/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/platform/files/common/files","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/node/pfs","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/map","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/state/electron-main/state","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/userDataProfile/electron-main/userDataProfile","vs/base/common/json","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/common/profiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/userDataSync/electron-main/userDataSyncProfilesStorageIpc","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ie=function(z){for(var e=[],v=0,t=z.length;v<t;v++)e[v]=te[z[v]];return e};define(te[120],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function v(D){return D?D.replace(/\$\((.*?)\)/g,(b,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=v;class t{constructor(b,u,m){this.id=b,this.definition=u,this.description=m,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(D,b){const u=["codicon","codicon-"+D];return b&&u.push("codicon-modifier-"+b),u}e.getClassNamesArray=k;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function u(y){if(y instanceof t)return["codicon","codicon-"+y.id];const E=b.exec(y.id);if(!E)return u(t.error);const[,h,d]=E,P=["codicon","codicon-"+h];return d&&P.push("codicon-modifier-"+d.substr(1)),P}D.asClassNameArray=u;function m(y){return u(y).join(" ")}D.asClassName=m;function I(y){return"."+u(y).join(".")}D.asCSSSelector=I})(R=e.CSSIcon||(e.CSSIcon={}))}),define(te[121],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function v(b,u){const m=Math.pow(10,u);return Math.round(b*m)/m}class t{constructor(u,m,I,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,I))|0,this.a=v(Math.max(Math.min(1,y),0),3)}static equals(u,m){return u.r===m.r&&u.g===m.g&&u.b===m.b&&u.a===m.a}}e.RGBA=t;class k{constructor(u,m,I,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=v(Math.max(Math.min(1,m),0),3),this.l=v(Math.max(Math.min(1,I),0),3),this.a=v(Math.max(Math.min(1,y),0),3)}static equals(u,m){return u.h===m.h&&u.s===m.s&&u.l===m.l&&u.a===m.a}static fromRGBA(u){const m=u.r/255,I=u.g/255,y=u.b/255,E=u.a,h=Math.max(m,I,y),d=Math.min(m,I,y);let P=0,w=0;const p=(d+h)/2,S=h-d;if(S>0){switch(w=Math.min(p<=.5?S/(2*p):S/(2-2*p),1),h){case m:P=(I-y)/S+(I<y?6:0);break;case I:P=(y-m)/S+2;break;case y:P=(m-I)/S+4;break}P*=60,P=Math.round(P)}return new k(P,w,p,E)}static _hue2rgb(u,m,I){return I<0&&(I+=1),I>1&&(I-=1),I<1/6?u+(m-u)*6*I:I<1/2?m:I<2/3?u+(m-u)*(2/3-I)*6:u}static toRGBA(u){const m=u.h/360,{s:I,l:y,a:E}=u;let h,d,P;if(I===0)h=d=P=y;else{const w=y<.5?y*(1+I):y+I-y*I,p=2*y-w;h=k._hue2rgb(p,w,m+1/3),d=k._hue2rgb(p,w,m),P=k._hue2rgb(p,w,m-1/3)}return new t(Math.round(h*255),Math.round(d*255),Math.round(P*255),E)}}e.HSLA=k;class R{constructor(u,m,I,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=v(Math.max(Math.min(1,m),0),3),this.v=v(Math.max(Math.min(1,I),0),3),this.a=v(Math.max(Math.min(1,y),0),3)}static equals(u,m){return u.h===m.h&&u.s===m.s&&u.v===m.v&&u.a===m.a}static fromRGBA(u){const m=u.r/255,I=u.g/255,y=u.b/255,E=Math.max(m,I,y),h=Math.min(m,I,y),d=E-h,P=E===0?0:d/E;let w;return d===0?w=0:E===m?w=((I-y)/d%6+6)%6:E===I?w=(y-m)/d+2:w=(m-I)/d+4,new R(Math.round(w*60),P,E,u.a)}static toRGBA(u){const{h:m,s:I,v:y,a:E}=u,h=y*I,d=h*(1-Math.abs(m/60%2-1)),P=y-h;let[w,p,S]=[0,0,0];return m<60?(w=h,p=d):m<120?(w=d,p=h):m<180?(p=h,S=d):m<240?(p=d,S=h):m<300?(w=d,S=h):m<=360&&(w=h,S=d),w=Math.round((w+P)*255),p=Math.round((p+P)*255),S=Math.round((S+P)*255),new t(w,p,S,E)}}e.HSVA=R;class D{static fromHex(u){return D.Format.CSS.parseHex(u)||D.red}static equals(u,m){return!u&&!m?!0:!u||!m?!1:u.equals(m)}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof t)this.rgba=u;else if(u instanceof k)this._hsla=u,this.rgba=k.toRGBA(u);else if(u instanceof R)this._hsva=u,this.rgba=R.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&t.equals(this.rgba,u.rgba)&&k.equals(this.hsla,u.hsla)&&R.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=D._relativeLuminanceForComponent(this.rgba.r),m=D._relativeLuminanceForComponent(this.rgba.g),I=D._relativeLuminanceForComponent(this.rgba.b),y=.2126*u+.7152*m+.0722*I;return v(y,4)}static _relativeLuminanceForComponent(u){const m=u/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(u){const m=this.getRelativeLuminance(),I=u.getRelativeLuminance();return m>I?(m+.05)/(I+.05):(I+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const m=this.getRelativeLuminance(),I=u.getRelativeLuminance();return m>I}isDarkerThan(u){const m=this.getRelativeLuminance(),I=u.getRelativeLuminance();return m<I}lighten(u){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:m,g:I,b:y,a:E}=this.rgba;return new D(new t(m,I,y,E*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const m=u.rgba,I=this.rgba.a,y=m.a,E=I+y*(1-I);if(E<1e-6)return D.transparent;const h=this.rgba.r*I/E+m.r*y*(1-I)/E,d=this.rgba.g*I/E+m.g*y*(1-I)/E,P=this.rgba.b*I/E+m.b*y*(1-I)/E;return new D(new t(h,d,P,E))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:m,g:I,b:y,a:E}=this.rgba;return new D(new t(u.rgba.r-E*(u.rgba.r-m),u.rgba.g-E*(u.rgba.g-I),u.rgba.b-E*(u.rgba.b-y),1))}flatten(...u){const m=u.reduceRight((I,y)=>D._flatten(y,I));return D._flatten(this,m)}static _flatten(u,m){const I=1-u.rgba.a;return new D(new t(I*m.rgba.r+u.rgba.a*u.rgba.r,I*m.rgba.g+u.rgba.a*u.rgba.g,I*m.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(u,m,I){if(u.isLighterThan(m))return u;I=I||.5;const y=u.getRelativeLuminance(),E=m.getRelativeLuminance();return I=I*(E-y)/E,u.lighten(I)}static getDarkerColor(u,m,I){if(u.isDarkerThan(m))return u;I=I||.5;const y=u.getRelativeLuminance(),E=m.getRelativeLuminance();return I=I*(y-E)/y,u.darken(I)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(b){let u;(function(m){let I;(function(y){function E(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:b.Format.CSS.formatRGBA(r)}y.formatRGB=E;function h(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}y.formatRGBA=h;function d(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:b.Format.CSS.formatHSLA(r)}y.formatHSL=d;function P(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}y.formatHSLA=P;function w(r){const o=r.toString(16);return o.length!==2?"0"+o:o}function p(r){return`#${w(r.rgba.r)}${w(r.rgba.g)}${w(r.rgba.b)}`}y.formatHex=p;function S(r,o=!1){return o&&r.rgba.a===1?b.Format.CSS.formatHex(r):`#${w(r.rgba.r)}${w(r.rgba.g)}${w(r.rgba.b)}${w(Math.round(r.rgba.a*255))}`}y.formatHexA=S;function f(r){return r.isOpaque()?b.Format.CSS.formatHex(r):b.Format.CSS.formatRGBA(r)}y.format=f;function g(r){const o=r.length;if(o===0||r.charCodeAt(0)!==35)return null;if(o===7){const i=16*l(r.charCodeAt(1))+l(r.charCodeAt(2)),n=16*l(r.charCodeAt(3))+l(r.charCodeAt(4)),s=16*l(r.charCodeAt(5))+l(r.charCodeAt(6));return new b(new t(i,n,s,1))}if(o===9){const i=16*l(r.charCodeAt(1))+l(r.charCodeAt(2)),n=16*l(r.charCodeAt(3))+l(r.charCodeAt(4)),s=16*l(r.charCodeAt(5))+l(r.charCodeAt(6)),c=16*l(r.charCodeAt(7))+l(r.charCodeAt(8));return new b(new t(i,n,s,c/255))}if(o===4){const i=l(r.charCodeAt(1)),n=l(r.charCodeAt(2)),s=l(r.charCodeAt(3));return new b(new t(16*i+i,16*n+n,16*s+s))}if(o===5){const i=l(r.charCodeAt(1)),n=l(r.charCodeAt(2)),s=l(r.charCodeAt(3)),c=l(r.charCodeAt(4));return new b(new t(16*i+i,16*n+n,16*s+s,(16*c+c)/255))}return null}y.parseHex=g;function l(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(I=m.CSS||(m.CSS={}))})(u=b.Format||(b.Format={}))}(D=e.Color||(e.Color={}))}),define(te[53],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(D){return(b,u,m)=>{let I=null,y=null;if(typeof m.value=="function"?(I="value",y=m.value):typeof m.get=="function"&&(I="get",y=m.get),!y)throw new Error("not supported");m[I]=D(y,u)}}e.createDecorator=v;function t(D,b,u){let m=null,I=null;if(typeof u.value=="function"?(m="value",I=u.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(m="get",I=u.get),!I)throw new Error("not supported");const y=`$memoize$${b}`;u[m]=function(...E){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,E)}),this[y]}}e.memoize=t;function k(D,b,u){return v((m,I)=>{const y=`$debounce$${I}`,E=`$debounce$result$${I}`;return function(...h){this[E]||(this[E]=u?u():void 0),clearTimeout(this[y]),b&&(this[E]=b(this[E],...h),h=[this[E]]),this[y]=setTimeout(()=>{m.apply(this,h),this[E]=u?u():void 0},D)}})}e.debounce=k;function R(D,b,u){return v((m,I)=>{const y=`$throttle$timer$${I}`,E=`$throttle$result$${I}`,h=`$throttle$lastRun$${I}`,d=`$throttle$pending$${I}`;return function(...P){if(this[E]||(this[E]=u?u():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),b&&(this[E]=b(this[E],...P)),this[d])return;const w=this[h]+D;w<=Date.now()?(this[h]=Date.now(),m.apply(this,[this[E]]),this[E]=u?u():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[h]=Date.now(),m.apply(this,[this[E]]),this[E]=u?u():void 0},w-Date.now()))}})}e.throttle=R}),define(te[17],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?f.isErrorNoTelemetry(r)?new f(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(o=>{o(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=v,e.errorHandler=new v;function t(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=t;function k(l){u(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=k;function R(l){u(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=R;function D(l){if(l instanceof Error){const{name:r,message:o}=l,i=l.stacktrace||l.stack;return{$isError:!0,name:r,message:o,stack:i,noTelemetry:f.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=D;const b="Canceled";function u(l){return l instanceof m?!0:l instanceof Error&&l.name===b&&l.message===b}e.isCancellationError=u;class m extends Error{constructor(){super(b),this.name=this.message}}e.CancellationError=m;function I(){const l=new Error(b);return l.name=l.message,l}e.canceled=I;function y(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=y;function E(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=E;function h(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function d(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}e.disposed=d;function P(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=P;class w extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=w;class p extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=p;class S extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=S;class f extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof f)return r;const o=new f;return o.message=r.message,o.stack=r.stack,o}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class g extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype);debugger}}e.BugIndicatingError=g}),define(te[24],ie([0,1,17]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(q,re=0){return q[q.length-(1+re)]}e.tail=t;function k(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=k;function R(q,re,ne=(ce,ge)=>ce===ge){if(q===re)return!0;if(!q||!re||q.length!==re.length)return!1;for(let ce=0,ge=q.length;ce<ge;ce++)if(!ne(q[ce],re[ce]))return!1;return!0}e.equals=R;function D(q,re){const ne=q.length-1;re<ne&&(q[re]=q[ne]),q.pop()}e.removeFastWithoutKeepingOrder=D;function b(q,re,ne){return u(q.length,ce=>ne(q[ce],re))}e.binarySearch=b;function u(q,re){let ne=0,ce=q-1;for(;ne<=ce;){const ge=(ne+ce)/2|0,De=re(ge);if(De<0)ne=ge+1;else if(De>0)ce=ge-1;else return ge}return-(ne+1)}e.binarySearch2=u;function m(q,re){let ne=0,ce=q.length;if(ce===0)return 0;for(;ne<ce;){const ge=Math.floor((ne+ce)/2);re(q[ge])?ce=ge:ne=ge+1}return ne}e.findFirstInSorted=m;function I(q,re,ne){if(q=q|0,q>=re.length)throw new TypeError("invalid index");const ce=re[Math.floor(re.length*Math.random())],ge=[],De=[],Ae=[];for(const ke of re){const Le=ne(ke,ce);Le<0?ge.push(ke):Le>0?De.push(ke):Ae.push(ke)}return q<ge.length?I(q,ge,ne):q<ge.length+Ae.length?Ae[0]:I(q-(ge.length+Ae.length),De,ne)}e.quickSelect=I;function y(q,re){const ne=[];let ce;for(const ge of q.slice(0).sort(re))!ce||re(ce[0],ge)!==0?(ce=[ge],ne.push(ce)):ce.push(ge);return ne}e.groupBy=y;function E(q,re,ne){const ce=[];function ge(ke,Le,qe){if(Le===0&&qe.length===0)return;const me=ce[ce.length-1];me&&me.start+me.deleteCount===ke?(me.deleteCount+=Le,me.toInsert.push(...qe)):ce.push({start:ke,deleteCount:Le,toInsert:qe})}let De=0,Ae=0;for(;;){if(De===q.length){ge(De,0,re.slice(Ae));break}if(Ae===re.length){ge(De,q.length-De,[]);break}const ke=q[De],Le=re[Ae],qe=ne(ke,Le);qe===0?(De+=1,Ae+=1):qe<0?(ge(De,1,[]),De+=1):qe>0&&(ge(De,0,[Le]),Ae+=1)}return ce}e.sortedDiff=E;function h(q,re,ne){const ce=E(q,re,ne),ge=[],De=[];for(const Ae of ce)ge.push(...q.slice(Ae.start,Ae.start+Ae.deleteCount)),De.push(...Ae.toInsert);return{removed:ge,added:De}}e.delta=h;function d(q,re,ne){if(ne===0)return[];const ce=q.slice(0,ne).sort(re);return w(q,re,ce,ne,q.length),ce}e.top=d;function P(q,re,ne,ce,ge){return ne===0?Promise.resolve([]):new Promise((De,Ae)=>{(async()=>{const ke=q.length,Le=q.slice(0,ne).sort(re);for(let qe=ne,me=Math.min(ne+ce,ke);qe<ke;qe=me,me=Math.min(me+ce,ke)){if(qe>ne&&await new Promise(we=>setTimeout(we)),ge&&ge.isCancellationRequested)throw new v.CancellationError;w(q,re,Le,qe,me)}return Le})().then(De,Ae)})}e.topAsync=P;function w(q,re,ne,ce,ge){for(const De=ne.length;ce<ge;ce++){const Ae=q[ce];if(re(Ae,ne[De-1])<0){ne.pop();const ke=m(ne,Le=>re(Ae,Le)<0);ne.splice(ke,0,Ae)}}}function p(q){return q.filter(re=>!!re)}e.coalesce=p;function S(q){let re=0;for(let ne=0;ne<q.length;ne++)q[ne]&&(q[re]=q[ne],re+=1);q.length=re}e.coalesceInPlace=S;function f(q,re,ne){q.splice(ne,0,q.splice(re,1)[0])}e.move=f;function g(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=g;function l(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=l;function r(q,re=ne=>ne){const ne=new Set;return q.filter(ce=>{const ge=re(ce);return ne.has(ge)?!1:(ne.add(ge),!0)})}e.distinct=r;function o(q){const re=new Set;return ne=>{const ce=q(ne);return re.has(ce)?!1:(re.add(ce),!0)}}e.uniqueFilter=o;function i(q,re){const ne=n(q,re);if(ne!==-1)return q[ne]}e.findLast=i;function n(q,re){for(let ne=q.length-1;ne>=0;ne--){const ce=q[ne];if(re(ce))return ne}return-1}e.lastIndex=n;function s(q,re){return q.length>0?q[0]:re}e.firstOrDefault=s;function c(q,re){return q.length>0?q[q.length-1]:re}e.lastOrDefault=c;function a(q,re,ne=(ce,ge)=>ce===ge){let ce=0;for(let ge=0,De=Math.min(q.length,re.length);ge<De&&ne(q[ge],re[ge]);ge++)ce++;return ce}e.commonPrefixLength=a;function C(q){return[].concat(...q)}e.flatten=C;function M(q,re){let ne=typeof re=="number"?q:0;typeof re=="number"?ne=q:(ne=0,re=q);const ce=[];if(ne<=re)for(let ge=ne;ge<re;ge++)ce.push(ge);else for(let ge=ne;ge>re;ge--)ce.push(ge);return ce}e.range=M;function T(q,re,ne){return q.reduce((ce,ge)=>(ce[re(ge)]=ne?ne(ge):ge,ce),Object.create(null))}e.index=T;function U(q,re){return q.push(re),()=>Q(q,re)}e.insert=U;function Q(q,re){const ne=q.indexOf(re);if(ne>-1)return q.splice(ne,1),re}e.remove=Q;function ae(q,re,ne){const ce=q.slice(0,re),ge=q.slice(re);return ce.concat(ne,ge)}e.arrayInsert=ae;function X(q,re){let ne;if(typeof re=="number"){let ce=re;ne=()=>{const ge=Math.sin(ce++)*179426549;return ge-Math.floor(ge)}}else ne=Math.random;for(let ce=q.length-1;ce>0;ce-=1){const ge=Math.floor(ne()*(ce+1)),De=q[ce];q[ce]=q[ge],q[ge]=De}}e.shuffle=X;function G(q,re){const ne=q.indexOf(re);ne>-1&&(q.splice(ne,1),q.unshift(re))}e.pushToStart=G;function Z(q,re){const ne=q.indexOf(re);ne>-1&&(q.splice(ne,1),q.push(re))}e.pushToEnd=Z;function se(q,re){for(const ne of re)q.push(ne)}e.pushMany=se;function he(q,re){return Array.isArray(q)?q.map(re):re(q)}e.mapArrayOrNot=he;function V(q){return Array.isArray(q)?q:[q]}e.asArray=V;function H(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=H;function W(q,re){for(const ne of q){const ce=re(ne);if(ce!==void 0)return ce}}e.mapFind=W;function A(q,re,ne){const ce=N(q,re),ge=q.length,De=ne.length;q.length=ge+De;for(let Ae=ge-1;Ae>=ce;Ae--)q[Ae+De]=q[Ae];for(let Ae=0;Ae<De;Ae++)q[Ae+ce]=ne[Ae]}e.insertInto=A;function F(q,re,ne,ce){const ge=N(q,re),De=q.splice(ge,ne);return A(q,ge,ce),De}e.splice=F;function N(q,re){return re<0?Math.max(re+q.length,0):Math.min(re,q.length)}var J;(function(q){function re(ge){return ge<0}q.isLessThan=re;function ne(ge){return ge>0}q.isGreaterThan=ne;function ce(ge){return ge===0}q.isNeitherLessOrGreaterThan=ce,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(J=e.CompareResult||(e.CompareResult={}));function B(q,re){return(ne,ce)=>re(q(ne),q(ce))}e.compareBy=B;function $(...q){return(re,ne)=>{for(const ce of q){const ge=ce(re,ne);if(!J.isNeitherLessOrGreaterThan(ge))return ge}return J.neitherLessOrGreaterThan}}e.tieBreakComparators=$;const L=(q,re)=>q-re;e.numberComparator=L;function O(q,re){if(q.length===0)return;let ne=q[0];for(let ce=1;ce<q.length;ce++){const ge=q[ce];re(ge,ne)>0&&(ne=ge)}return ne}e.findMaxBy=O;function _(q,re){if(q.length===0)return;let ne=q[0];for(let ce=1;ce<q.length;ce++){const ge=q[ce];re(ge,ne)>=0&&(ne=ge)}return ne}e.findLastMaxBy=_;function j(q,re){return O(q,(ne,ce)=>-re(ne,ce))}e.findMinBy=j;class Y{constructor(re){this.items=re,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(re){let ne=this.firstIdx;for(;ne<this.items.length&&re(this.items[ne]);)ne++;const ce=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,ce}takeFromEndWhile(re){let ne=this.lastIdx;for(;ne>=0&&re(this.items[ne]);)ne--;const ce=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const re=this.items[this.firstIdx];return this.firstIdx++,re}removeLast(){const re=this.items[this.lastIdx];return this.lastIdx--,re}takeCount(re){const ne=this.items.slice(this.firstIdx,this.firstIdx+re);return this.firstIdx+=re,ne}}e.ArrayQueue=Y;class oe{constructor(re){this.iterate=re}forEach(re){this.iterate(ne=>(re(ne),!0))}toArray(){const re=[];return this.iterate(ne=>(re.push(ne),!0)),re}filter(re){return new oe(ne=>this.iterate(ce=>re(ce)?ne(ce):!0))}map(re){return new oe(ne=>this.iterate(ce=>ne(re(ce))))}some(re){let ne=!1;return this.iterate(ce=>(ne=re(ce),!ne)),ne}findFirst(re){let ne;return this.iterate(ce=>re(ce)?(ne=ce,!1):!0),ne}findLast(re){let ne;return this.iterate(ce=>(re(ce)&&(ne=ce),!0)),ne}findLastMaxBy(re){let ne,ce=!0;return this.iterate(ge=>((ce||J.isGreaterThan(re(ge,ne)))&&(ce=!1,ne=ge),!0)),ne}}e.CallbackIterable=oe,oe.empty=new oe(q=>{})}),define(te[122],ie([0,1,17]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(u,m){if(!u)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=t;function k(u,m="Unreachable"){throw new Error(m)}e.assertNever=k;function R(u){if(!u)throw new v.BugIndicatingError("Assertion Failed")}e.assert=R;function D(u){if(!u()){debugger;u(),(0,v.onUnexpectedError)(new v.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function b(u,m){let I=0;for(;I<u.length-1;){const y=u[I],E=u[I+1];if(!m(y,E))return!1;I++}return!0}e.checkAdjacentItems=b}),define(te[49],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(t){const k=this;let R=!1,D;return function(){return R||(R=!0,D=t.apply(k,arguments)),D}}e.once=v}),define(te[57],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(t){function k(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function D(){return R}t.empty=D;function*b(o){yield o}t.single=b;function u(o){return o||R}t.from=u;function m(o){return!o||o[Symbol.iterator]().next().done===!0}t.isEmpty=m;function I(o){return o[Symbol.iterator]().next().value}t.first=I;function y(o,i){for(const n of o)if(i(n))return!0;return!1}t.some=y;function E(o,i){for(const n of o)if(i(n))return n}t.find=E;function*h(o,i){for(const n of o)i(n)&&(yield n)}t.filter=h;function*d(o,i){let n=0;for(const s of o)yield i(s,n++)}t.map=d;function*P(...o){for(const i of o)for(const n of i)yield n}t.concat=P;function*w(o){for(const i of o)for(const n of i)yield n}t.concatNested=w;function p(o,i,n){let s=n;for(const c of o)s=i(s,c);return s}t.reduce=p;function S(o,i){let n=0;for(const s of o)i(s,n++)}t.forEach=S;function*f(o,i,n=o.length){for(i<0&&(i+=o.length),n<0?n+=o.length:n>o.length&&(n=o.length);i<n;i++)yield o[i]}t.slice=f;function g(o,i=Number.POSITIVE_INFINITY){const n=[];if(i===0)return[n,o];const s=o[Symbol.iterator]();for(let c=0;c<i;c++){const a=s.next();if(a.done)return[n,t.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return s}}]}t.consume=g;function l(o){return g(o)[0]}t.collect=l;function r(o,i,n=(s,c)=>s===c){const s=o[Symbol.iterator](),c=i[Symbol.iterator]();for(;;){const a=s.next(),C=c.next();if(a.done!==C.done)return!1;if(a.done)return!0;if(!n(a.value,C.value))return!1}}t.equals=r})(v=e.Iterable||(e.Iterable={}))}),define(te[43],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var t;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(r){r.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(r,o=!1){let i=0;const n=r.length;let s="",c=0,a=16,C=0;function M(Z){let se=0,he=0;for(;se<Z;){const V=r.charCodeAt(i);if(V>=48&&V<=57)he=he*16+V-48;else if(V>=65&&V<=70)he=he*16+V-65+10;else if(V>=97&&V<=102)he=he*16+V-97+10;else break;i++,se++}return se<Z&&(he=-1),he}function T(Z){i=Z,s="",c=0,a=16,C=0}function U(){const Z=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&m(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&m(r.charCodeAt(i)))for(i++;i<r.length&&m(r.charCodeAt(i));)i++;else return C=3,r.substring(Z,i);let se=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&m(r.charCodeAt(i))){for(i++;i<r.length&&m(r.charCodeAt(i));)i++;se=i}else C=3;return r.substring(Z,se)}function Q(){let Z="",se=i;for(;;){if(i>=n){Z+=r.substring(se,i),C=2;break}const he=r.charCodeAt(i);if(he===34){Z+=r.substring(se,i),i++;break}if(he===92){if(Z+=r.substring(se,i),i++,i>=n){C=2;break}switch(r.charCodeAt(i++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:{const H=M(4);H>=0?Z+=String.fromCharCode(H):C=4;break}default:C=5}se=i;continue}if(he>=0&&he<=31)if(u(he)){Z+=r.substring(se,i),C=2;break}else C=6;i++}return Z}function ae(){if(s="",C=0,c=i,i>=n)return c=n,a=17;let Z=r.charCodeAt(i);if(b(Z)){do i++,s+=String.fromCharCode(Z),Z=r.charCodeAt(i);while(b(Z));return a=15}if(u(Z))return i++,s+=String.fromCharCode(Z),Z===13&&r.charCodeAt(i)===10&&(i++,s+=`
`),a=14;switch(Z){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,s=Q(),a=10;case 47:{const se=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<n&&!u(r.charCodeAt(i));)i++;return s=r.substring(se,i),a=12}if(r.charCodeAt(i+1)===42){i+=2;const he=n-1;let V=!1;for(;i<he;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,V=!0;break}i++}return V||(i++,C=1),s=r.substring(se,i),a=13}return s+=String.fromCharCode(Z),i++,a=16}case 45:if(s+=String.fromCharCode(Z),i++,i===n||!m(r.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=U(),a=11;default:for(;i<n&&X(Z);)i++,Z=r.charCodeAt(i);if(c!==i){switch(s=r.substring(c,i),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode(Z),i++,a=16}}function X(Z){if(b(Z)||u(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let Z;do Z=ae();while(Z>=12&&Z<=15);return Z}return{setPosition:T,getPosition:()=>i,scan:o?G:ae,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>C}}e.createScanner=D;function b(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function u(r){return r===10||r===13||r===8232||r===8233}function m(r){return r>=48&&r<=57}var I;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(I||(I={}));function y(r,o){const i=[],n=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function C(M,T,U,Q){c.value=M,c.offset=T,c.length=U,c.type=Q,c.colonOffset=void 0,s=c}try{f(r,{onObjectBegin:(M,T)=>{if(o<=M)throw n;s=void 0,a=o>M,i.push("")},onObjectProperty:(M,T,U)=>{if(o<T||(C(M,T,U,"property"),i[i.length-1]=M,o<=T+U))throw n},onObjectEnd:(M,T)=>{if(o<=M)throw n;s=void 0,i.pop()},onArrayBegin:(M,T)=>{if(o<=M)throw n;s=void 0,i.push(0)},onArrayEnd:(M,T)=>{if(o<=M)throw n;s=void 0,i.pop()},onLiteralValue:(M,T,U)=>{if(o<T||(C(M,T,U,l(M)),o<=T+U))throw n},onSeparator:(M,T,U)=>{if(o<=T)throw n;if(M===":"&&s&&s.type==="property")s.colonOffset=T,a=!1,s=void 0;else if(M===","){const Q=i[i.length-1];typeof Q=="number"?i[i.length-1]=Q+1:(a=!0,i[i.length-1]=""),s=void 0}}})}catch(M){if(M!==n)throw M}return{path:i,previousNode:s,isAtPropertyKey:a,matches:M=>{let T=0;for(let U=0;T<M.length&&U<i.length;U++)if(M[T]===i[U]||M[T]==="*")T++;else if(M[T]!=="**")return!1;return T===M.length}}}e.getLocation=y;function E(r,o=[],i=R.DEFAULT){let n=null,s=[];const c=[];function a(M){Array.isArray(s)?s.push(M):n!==null&&(s[n]=M)}return f(r,{onObjectBegin:()=>{const M={};a(M),c.push(s),s=M,n=null},onObjectProperty:M=>{n=M},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const M=[];a(M),c.push(s),s=M,n=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:a,onError:(M,T,U)=>{o.push({error:M,offset:T,length:U})}},i),s[0]}e.parse=E;function h(r,o=[],i=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(M){n.type==="property"&&(n.length=M-n.offset,n=n.parent)}function c(M){return n.children.push(M),M}f(r,{onObjectBegin:M=>{n=c({type:"object",offset:M,length:-1,parent:n,children:[]})},onObjectProperty:(M,T,U)=>{n=c({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:M,offset:T,length:U,parent:n})},onObjectEnd:(M,T)=>{n.length=M+T-n.offset,n=n.parent,s(M+T)},onArrayBegin:(M,T)=>{n=c({type:"array",offset:M,length:-1,parent:n,children:[]})},onArrayEnd:(M,T)=>{n.length=M+T-n.offset,n=n.parent,s(M+T)},onLiteralValue:(M,T,U)=>{c({type:l(M),offset:T,length:U,parent:n,value:M}),s(T+U)},onSeparator:(M,T,U)=>{n.type==="property"&&(M===":"?n.colonOffset=T:M===","&&s(T))},onError:(M,T,U)=>{o.push({error:M,offset:T,length:U})}},i);const C=n.children[0];return C&&delete C.parent,C}e.parseTree=h;function d(r,o){if(!r)return;let i=r;for(const n of o)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===n){i=c.children[1],s=!0;break}if(!s)return}else{const s=n;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=d;function P(r){if(!r.parent||!r.parent.children)return[];const o=P(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;o.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&o.push(i)}return o}e.getNodePath=P;function w(r){switch(r.type){case"array":return r.children.map(w);case"object":{const o=Object.create(null);for(const i of r.children){const n=i.children[1];n&&(o[i.children[0].value]=w(n))}return o}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=w;function p(r,o,i=!1){return o>=r.offset&&o<r.offset+r.length||i&&o===r.offset+r.length}e.contains=p;function S(r,o,i=!1){if(p(r,o,i)){const n=r.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=o;s++){const c=S(n[s],o,i);if(c)return c}return r}}e.findNodeAtOffset=S;function f(r,o,i=R.DEFAULT){const n=D(r,!1);function s(B){return B?()=>B(n.getTokenOffset(),n.getTokenLength()):()=>!0}function c(B){return B?$=>B($,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=s(o.onObjectBegin),C=c(o.onObjectProperty),M=s(o.onObjectEnd),T=s(o.onArrayBegin),U=s(o.onArrayEnd),Q=c(o.onLiteralValue),ae=c(o.onSeparator),X=s(o.onComment),G=c(o.onError),Z=i&&i.disallowComments,se=i&&i.allowTrailingComma;function he(){for(;;){const B=n.scan();switch(n.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:Z||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(B){case 12:case 13:Z?V(10):X();break;case 16:V(1);break;case 15:case 14:break;default:return B}}}function V(B,$=[],L=[]){if(G(B),$.length+L.length>0){let O=n.getToken();for(;O!==17;){if($.indexOf(O)!==-1){he();break}else if(L.indexOf(O)!==-1)break;O=he()}}}function H(B){const $=n.getTokenValue();return B?Q($):C($),he(),!0}function W(){switch(n.getToken()){case 11:{let B=0;try{B=JSON.parse(n.getTokenValue()),typeof B!="number"&&(V(2),B=0)}catch{V(2)}Q(B);break}case 7:Q(null);break;case 8:Q(!0);break;case 9:Q(!1);break;default:return!1}return he(),!0}function A(){return n.getToken()!==10?(V(3,[],[2,5]),!1):(H(!1),n.getToken()===6?(ae(":"),he(),J()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function F(){a(),he();let B=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(B||V(4,[],[]),ae(","),he(),n.getToken()===2&&se)break}else B&&V(6,[],[]);A()||V(4,[],[2,5]),B=!0}return M(),n.getToken()!==2?V(7,[2],[]):he(),!0}function N(){T(),he();let B=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(B||V(4,[],[]),ae(","),he(),n.getToken()===4&&se)break}else B&&V(6,[],[]);J()||V(4,[],[4,5]),B=!0}return U(),n.getToken()!==4?V(8,[4],[]):he(),!0}function J(){switch(n.getToken()){case 3:return N();case 1:return F();case 10:return H(!0);default:return W()}}return he(),n.getToken()===17?i.allowEmptyContent?!0:(V(4,[],[]),!1):J()?(n.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=f;function g(r,o){const i=D(r),n=[];let s,c=0,a;do switch(a=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:c!==a&&n.push(r.substring(c,a)),o!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,o)),c=i.getPosition();break}while(s!==17);return n.join("")}e.stripComments=g;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[123],ie([0,1,43]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(m,I,y){let E,h,d,P,w;if(I){for(P=I.offset,w=P+I.length,d=P;d>0&&!u(m,d-1);)d--;let a=w;for(;a<m.length&&!u(m,a);)a++;h=m.substring(d,a),E=D(h,y)}else h=m,E=0,d=0,P=0,w=m.length;const p=b(y,m);let S=!1,f=0,g;y.insertSpaces?g=R(" ",y.tabSize||4):g="	";const l=(0,v.createScanner)(h,!1);let r=!1;function o(){return p+R(g,E+f)}function i(){let a=l.scan();for(S=!1;a===15||a===14;)S=S||a===14,a=l.scan();return r=a===16||l.getTokenError()!==0,a}const n=[];function s(a,C,M){!r&&C<w&&M>P&&m.substring(C,M)!==a&&n.push({offset:C,length:M-C,content:a})}let c=i();if(c!==17){const a=l.getTokenOffset()+d,C=R(g,E);s(C,d,a)}for(;c!==17;){let a=l.getTokenOffset()+l.getTokenLength()+d,C=i(),M="";for(;!S&&(C===12||C===13);){const U=l.getTokenOffset()+d;s(" ",a,U),a=l.getTokenOffset()+l.getTokenLength()+d,M=C===12?o():"",C=i()}if(C===2)c!==1&&(f--,M=o());else if(C===4)c!==3&&(f--,M=o());else{switch(c){case 3:case 1:f++,M=o();break;case 5:case 12:M=o();break;case 13:S?M=o():M=" ";break;case 6:M=" ";break;case 10:if(C===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:C===12||C===13?M=" ":C!==5&&C!==17&&(r=!0);break;case 16:r=!0;break}S&&(C===12||C===13)&&(M=o())}const T=l.getTokenOffset()+d;s(M,a,T),c=C}return n}e.format=t;function k(m,I){const y=JSON.stringify(m,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?y.replace(/\r\n|\r|\n/g,I.eol):y}e.toFormattedString=k;function R(m,I){let y="";for(let E=0;E<I;E++)y+=m;return y}function D(m,I){let y=0,E=0;const h=I.tabSize||4;for(;y<m.length;){const d=m.charAt(y);if(d===" ")E++;else if(d==="	")E+=h;else break;y++}return Math.floor(E/h)}function b(m,I){for(let y=0;y<I.length;y++){const E=I.charAt(y);if(E==="\r")return y+1<I.length&&I.charAt(y+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=b;function u(m,I){return`\r
`.indexOf(m.charAt(I))!==-1}e.isEOL=u}),define(te[124],ie([0,1,43,123]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(m,I,y){return R(m,I,void 0,y)}e.removeProperty=k;function R(m,I,y,E,h){const d=I.slice(),P=[],w=(0,v.parseTree)(m,P);let p,S;for(;d.length>0&&(S=d.pop(),p=(0,v.findNodeAtLocation)(w,d),p===void 0&&y!==void 0);)typeof S=="string"?y={[S]:y}:y=[y];if(p)if(p.type==="object"&&typeof S=="string"&&Array.isArray(p.children)){const f=(0,v.findNodeAtLocation)(p,[S]);if(f!==void 0)if(y===void 0){if(!f.parent)throw new Error("Malformed AST");const g=p.children.indexOf(f.parent);let l,r=f.parent.offset+f.parent.length;if(g>0){const o=p.children[g-1];l=o.offset+o.length}else l=p.offset+1,p.children.length>1&&(r=p.children[1].offset);return D(m,{offset:l,length:r-l,content:""},E)}else return D(m,{offset:f.offset,length:f.length,content:JSON.stringify(y)},E);else{if(y===void 0)return[];const g=`${JSON.stringify(S)}: ${JSON.stringify(y)}`,l=h?h(p.children.map(o=>o.children[0].value)):p.children.length;let r;if(l>0){const o=p.children[l-1];r={offset:o.offset+o.length,length:0,content:","+g}}else p.children.length===0?r={offset:p.offset+1,length:0,content:g}:r={offset:p.offset+1,length:0,content:g+","};return D(m,r,E)}}else if(p.type==="array"&&typeof S=="number"&&Array.isArray(p.children))if(y!==void 0){const f=`${JSON.stringify(y)}`;let g;if(p.children.length===0||S===0)g={offset:p.offset+1,length:0,content:p.children.length===0?f:f+","};else{const l=S===-1||S>p.children.length?p.children.length:S,r=p.children[l-1];g={offset:r.offset+r.length,length:0,content:","+f}}return D(m,g,E)}else{const f=S,g=p.children[f];let l;if(p.children.length===1)l={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===f){const r=p.children[f-1],o=r.offset+r.length,i=p.offset+p.length;l={offset:o,length:i-2-o,content:""}}else l={offset:g.offset,length:p.children[f+1].offset-g.offset,content:""};return D(m,l,E)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${p.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return D(m,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(y)},E)}}e.setProperty=R;function D(m,I,y){let E=b(m,I),h=I.offset,d=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;h>0&&!(0,t.isEOL)(E,h-1);)h--;for(;d<E.length&&!(0,t.isEOL)(E,d);)d++}const P=(0,t.format)(E,{offset:h,length:d-h},y);for(let p=P.length-1;p>=0;p--){const S=P[p];E=b(E,S),h=Math.min(h,S.offset),d=Math.max(d,S.offset+S.length),d+=S.content.length-S.length}const w=m.length-(E.length-d)-h;return[{offset:h,length:w,content:E.substring(h,d)}]}e.withFormatting=D;function b(m,I){return m.substring(0,I.offset)+I.content+m.substring(I.offset+I.length)}e.applyEdit=b;function u(m,I){const y=I.slice(0).sort((h,d)=>{const P=h.offset-d.offset;return P===0?h.length-d.length:P});let E=m.length;for(let h=y.length-1;h>=0;h--){const d=y[h];if(d.offset+d.length<=E)m=b(m,d);else throw new Error("Overlapping edit");E=d.offset}return m}e.applyEdits=u}),define(te[125],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new v(()=>k(this.getValue()))}}e.Lazy=v}),define(te[2],ie([0,1,49,57]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function D(c){R=c}if(e.setDisposableTracker=D,k){const c="__is_disposable_tracked__";D(new class{trackDisposable(a){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[c]||console.log(C)},3e3)}setParent(a,C){if(a&&a!==S.None)try{a[c]=!0}catch{}}markAsDisposed(a){if(a&&a!==S.None)try{a[c]=!0}catch{}}markAsSingleton(a){}})}function b(c){return R?.trackDisposable(c),c}function u(c){R?.markAsDisposed(c)}function m(c,a){R?.setParent(c,a)}function I(c,a){if(!!R)for(const C of c)R.setParent(C,a)}function y(c){return R?.markAsSingleton(c),c}e.markAsSingleton=y;function E(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=E;function h(c){if(t.Iterable.is(c)){const a=[];for(const C of c)if(C)try{C.dispose()}catch(M){a.push(M)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=h;function d(c){for(const a of c)E(a)&&a.dispose();return[]}e.disposeIfDisposable=d;function P(...c){const a=w(()=>h(c));return I(c,a),a}e.combinedDisposable=P;function w(c){const a=b({dispose:(0,v.once)(()=>{u(a),c()})});return a}e.toDisposable=w;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{h(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return m(a,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new p,b(this),m(this._store,this)}dispose(){u(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=S,S.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&m(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,u(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&m(a,null),a}}e.MutableDisposable=f;class g{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=g;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(a){let C=a;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,u(this))},this}}e.SafeDisposable=l;class r{constructor(){this.references=new Map}acquire(a,...C){let M=this.references.get(a);M||(M={counter:0,object:this.createReferencedObject(a,...C)},this.references.set(a,M));const{object:T}=M,U=(0,v.once)(()=>{--M.counter===0&&(this.destroyReferencedObject(a,M.object),this.references.delete(a))});return M.counter++,{object:T,dispose:U}}}e.ReferenceCollection=r;class o{constructor(a){this.referenceCollection=a}async acquire(a,...C){const M=this.referenceCollection.acquire(a,...C);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}e.AsyncReferenceCollection=o;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function n(c){const a=new p;try{c(a)}finally{a.dispose()}}e.disposeOnReturn=n;class s{constructor(){this._store=new Map,this._isDisposed=!1,b(this)}dispose(){u(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{h(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,C,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(a)?.dispose(),this._store.set(a,C)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=s}),define(te[94],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(R){this.element=R,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class t{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let R=this._first;for(;R!==v.Undefined;){const D=R.next;R.prev=v.Undefined,R.next=v.Undefined,R=D}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const b=new v(R);if(this._first===v.Undefined)this._first=b,this._last=b;else if(D){const m=this._last;this._last=b,b.prev=m,m.next=b}else{const m=this._first;this._first=b,b.next=m,m.prev=b}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(b))}}shift(){if(this._first!==v.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==v.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==v.Undefined&&R.next!==v.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===v.Undefined&&R.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):R.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):R.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==v.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function z(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function D(u){R.push(u,Date.now())}function b(){const u=[];for(let m=0;m<R.length;m+=2)u.push({name:R[m],startTime:R[m+1]});return u}return{mark:D,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(k+D.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=v(t))}(),function(z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var t in v)(typeof exports=="object"?exports:z)[t]=v[t]}}(typeof self<"u"?self:this,function(){return function(z){var e={};function v(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return z[t].call(k.exports,k,k.exports,v),k.l=!0,k.exports}return v.m=z,v.c=e,v.d=function(t,k,R){v.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},v.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},v.t=function(t,k){if(1&k&&(t=v(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(v.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var D in t)v.d(R,D,function(b){return t[b]}.bind(null,D));return R},v.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return v.d(k,"a",k),k},v.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},v.p="",v(v.s=0)}([function(z,e,v){(function(t){var k;e=z.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],u=e.src=[],m=0,I=m++;u[I]="0|[1-9]\\d*";var y=m++;u[y]="[0-9]+";var E=m++;u[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=m++;u[h]="("+u[I]+")\\.("+u[I]+")\\.("+u[I]+")";var d=m++;u[d]="("+u[y]+")\\.("+u[y]+")\\.("+u[y]+")";var P=m++;u[P]="(?:"+u[I]+"|"+u[E]+")";var w=m++;u[w]="(?:"+u[y]+"|"+u[E]+")";var p=m++;u[p]="(?:-("+u[P]+"(?:\\."+u[P]+")*))";var S=m++;u[S]="(?:-?("+u[w]+"(?:\\."+u[w]+")*))";var f=m++;u[f]="[0-9A-Za-z-]+";var g=m++;u[g]="(?:\\+("+u[f]+"(?:\\."+u[f]+")*))";var l=m++,r="v?"+u[h]+u[p]+"?"+u[g]+"?";u[l]="^"+r+"$";var o="[v=\\s]*"+u[d]+u[S]+"?"+u[g]+"?",i=m++;u[i]="^"+o+"$";var n=m++;u[n]="((?:<|>)?=?)";var s=m++;u[s]=u[y]+"|x|X|\\*";var c=m++;u[c]=u[I]+"|x|X|\\*";var a=m++;u[a]="[v=\\s]*("+u[c]+")(?:\\.("+u[c]+")(?:\\.("+u[c]+")(?:"+u[p]+")?"+u[g]+"?)?)?";var C=m++;u[C]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[S]+")?"+u[g]+"?)?)?";var M=m++;u[M]="^"+u[n]+"\\s*"+u[a]+"$";var T=m++;u[T]="^"+u[n]+"\\s*"+u[C]+"$";var U=m++;u[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Q=m++;u[Q]="(?:~>?)";var ae=m++;u[ae]="(\\s*)"+u[Q]+"\\s+",b[ae]=new RegExp(u[ae],"g");var X=m++;u[X]="^"+u[Q]+u[a]+"$";var G=m++;u[G]="^"+u[Q]+u[C]+"$";var Z=m++;u[Z]="(?:\\^)";var se=m++;u[se]="(\\s*)"+u[Z]+"\\s+",b[se]=new RegExp(u[se],"g");var he=m++;u[he]="^"+u[Z]+u[a]+"$";var V=m++;u[V]="^"+u[Z]+u[C]+"$";var H=m++;u[H]="^"+u[n]+"\\s*("+o+")$|^$";var W=m++;u[W]="^"+u[n]+"\\s*("+r+")$|^$";var A=m++;u[A]="(\\s*)"+u[n]+"\\s*("+o+"|"+u[a]+")",b[A]=new RegExp(u[A],"g");var F=m++;u[F]="^\\s*("+u[a]+")\\s+-\\s+("+u[a]+")\\s*$";var N=m++;u[N]="^\\s*("+u[C]+")\\s+-\\s+("+u[C]+")\\s*$";var J=m++;u[J]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)k(B,u[B]),b[B]||(b[B]=new RegExp(u[B]));function $(x,le){if(x instanceof L)return x;if(typeof x!="string"||x.length>R||!(le?b[i]:b[l]).test(x))return null;try{return new L(x,le)}catch{return null}}function L(x,le){if(x instanceof L){if(x.loose===le)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(x,le);k("SemVer",x,le),this.loose=le;var fe=x.trim().match(le?b[i]:b[l]);if(!fe)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Ie=+Se;if(Ie>=0&&Ie<D)return Ie}return Se}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=$,e.valid=function(x,le){var fe=$(x,le);return fe?fe.version:null},e.clean=function(x,le){var fe=$(x.trim().replace(/^[=v]+/,""),le);return fe?fe.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(x){return k("SemVer.compare",this.version,this.loose,x),x instanceof L||(x=new L(x,this.loose)),this.compareMain(x)||this.comparePre(x)},L.prototype.compareMain=function(x){return x instanceof L||(x=new L(x,this.loose)),_(this.major,x.major)||_(this.minor,x.minor)||_(this.patch,x.patch)},L.prototype.comparePre=function(x){if(x instanceof L||(x=new L(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var le=0;do{var fe=this.prerelease[le],Se=x.prerelease[le];if(k("prerelease compare",le,fe,Se),fe===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(fe===void 0)return-1;if(fe!==Se)return _(fe,Se)}while(++le)},L.prototype.inc=function(x,le){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,le,fe,Se){typeof fe=="string"&&(Se=fe,fe=void 0);try{return new L(x,fe).inc(le,Se).version}catch{return null}},e.diff=function(x,le){if(q(x,le))return null;var fe=$(x),Se=$(le);if(fe.prerelease.length||Se.prerelease.length){for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Se[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Se[Ie])return Ie},e.compareIdentifiers=_;var O=/^[0-9]+$/;function _(x,le){var fe=O.test(x),Se=O.test(le);return fe&&Se&&(x=+x,le=+le),fe&&!Se?-1:Se&&!fe?1:x<le?-1:x>le?1:0}function j(x,le,fe){return new L(x,fe).compare(new L(le,fe))}function Y(x,le,fe){return j(x,le,fe)>0}function oe(x,le,fe){return j(x,le,fe)<0}function q(x,le,fe){return j(x,le,fe)===0}function re(x,le,fe){return j(x,le,fe)!==0}function ne(x,le,fe){return j(x,le,fe)>=0}function ce(x,le,fe){return j(x,le,fe)<=0}function ge(x,le,fe,Se){var Ie;switch(le){case"===":typeof x=="object"&&(x=x.version),typeof fe=="object"&&(fe=fe.version),Ie=x===fe;break;case"!==":typeof x=="object"&&(x=x.version),typeof fe=="object"&&(fe=fe.version),Ie=x!==fe;break;case"":case"=":case"==":Ie=q(x,fe,Se);break;case"!=":Ie=re(x,fe,Se);break;case">":Ie=Y(x,fe,Se);break;case">=":Ie=ne(x,fe,Se);break;case"<":Ie=oe(x,fe,Se);break;case"<=":Ie=ce(x,fe,Se);break;default:throw new TypeError("Invalid operator: "+le)}return Ie}function De(x,le){if(x instanceof De){if(x.loose===le)return x;x=x.value}if(!(this instanceof De))return new De(x,le);k("comparator",x,le),this.loose=le,this.parse(x),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(x,le){return _(le,x)},e.major=function(x,le){return new L(x,le).major},e.minor=function(x,le){return new L(x,le).minor},e.patch=function(x,le){return new L(x,le).patch},e.compare=j,e.compareLoose=function(x,le){return j(x,le,!0)},e.rcompare=function(x,le,fe){return j(le,x,fe)},e.sort=function(x,le){return x.sort(function(fe,Se){return e.compare(fe,Se,le)})},e.rsort=function(x,le){return x.sort(function(fe,Se){return e.rcompare(fe,Se,le)})},e.gt=Y,e.lt=oe,e.eq=q,e.neq=re,e.gte=ne,e.lte=ce,e.cmp=ge,e.Comparator=De;var Ae={};function ke(x,le){if(x instanceof ke)return x.loose===le?x:new ke(x.raw,le);if(x instanceof De)return new ke(x.value,le);if(!(this instanceof ke))return new ke(x,le);if(this.loose=le,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Le(x){return!x||x.toLowerCase()==="x"||x==="*"}function qe(x,le,fe,Se,Ie,Te,Oe,Ne,Be,ze,Ke,Ue,Ge){return((le=Le(fe)?"":Le(Se)?">="+fe+".0.0":Le(Ie)?">="+fe+"."+Se+".0":">="+le)+" "+(Ne=Le(Be)?"":Le(ze)?"<"+(+Be+1)+".0.0":Le(Ke)?"<"+Be+"."+(+ze+1)+".0":Ue?"<="+Be+"."+ze+"."+Ke+"-"+Ue:"<="+Ne)).trim()}function me(x,le){for(var fe=0;fe<x.length;fe++)if(!x[fe].test(le))return!1;if(le.prerelease.length){for(fe=0;fe<x.length;fe++)if(k(x[fe].semver),x[fe].semver!==Ae&&x[fe].semver.prerelease.length>0){var Se=x[fe].semver;if(Se.major===le.major&&Se.minor===le.minor&&Se.patch===le.patch)return!0}return!1}return!0}function we(x,le,fe){try{le=new ke(le,fe)}catch{return!1}return le.test(x)}function Ee(x,le,fe,Se){var Ie,Te,Oe,Ne,Be;switch(x=new L(x,Se),le=new ke(le,Se),fe){case">":Ie=Y,Te=ce,Oe=oe,Ne=">",Be=">=";break;case"<":Ie=oe,Te=ne,Oe=Y,Ne="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(x,le,Se))return!1;for(var ze=0;ze<le.set.length;++ze){var Ke=le.set[ze],Ue=null,Ge=null;if(Ke.forEach(function(K){K.semver===Ae&&(K=new De(">=0.0.0")),Ue=Ue||K,Ge=Ge||K,Ie(K.semver,Ue.semver,Se)?Ue=K:Oe(K.semver,Ge.semver,Se)&&(Ge=K)}),Ue.operator===Ne||Ue.operator===Be||(!Ge.operator||Ge.operator===Ne)&&Te(x,Ge.semver)||Ge.operator===Be&&Oe(x,Ge.semver))return!1}return!0}De.prototype.parse=function(x){var le=this.loose?b[H]:b[W],fe=x.match(le);if(!fe)throw new TypeError("Invalid comparator: "+x);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new L(fe[2],this.loose):this.semver=Ae},De.prototype.toString=function(){return this.value},De.prototype.test=function(x){return k("Comparator.test",x,this.loose),this.semver===Ae||(typeof x=="string"&&(x=new L(x,this.loose)),ge(x,this.operator,this.semver,this.loose))},De.prototype.intersects=function(x,le){if(!(x instanceof De))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new ke(x.value,le),we(this.value,fe,le);if(x.operator==="")return fe=new ke(this.value,le),we(x.semver,fe,le);var Se=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Te=this.semver.version===x.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Ne=ge(this.semver,"<",x.semver,le)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Be=ge(this.semver,">",x.semver,le)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return Se||Ie||Te&&Oe||Ne||Be},e.Range=ke,ke.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},ke.prototype.toString=function(){return this.range},ke.prototype.parseRange=function(x){var le=this.loose;x=x.trim(),k("range",x,le);var fe=le?b[N]:b[F];x=x.replace(fe,qe),k("hyphen replace",x),x=x.replace(b[A],"$1$2$3"),k("comparator trim",x,b[A]),x=(x=(x=x.replace(b[ae],"$1~")).replace(b[se],"$1^")).split(/\s+/).join(" ");var Se=le?b[H]:b[W],Ie=x.split(" ").map(function(Te){return function(Oe,Ne){return k("comp",Oe),Oe=function(Be,ze){return Be.trim().split(/\s+/).map(function(Ke){return function(Ue,Ge){k("caret",Ue,Ge);var K=Ge?b[V]:b[he];return Ue.replace(K,function(ue,de,pe,ye,Re){var _e;return k("caret",Ue,ue,de,pe,ye,Re),Le(de)?_e="":Le(pe)?_e=">="+de+".0.0 <"+(+de+1)+".0.0":Le(ye)?_e=de==="0"?">="+de+"."+pe+".0 <"+de+"."+(+pe+1)+".0":">="+de+"."+pe+".0 <"+(+de+1)+".0.0":Re?(k("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),_e=de==="0"?pe==="0"?">="+de+"."+pe+"."+ye+Re+" <"+de+"."+pe+"."+(+ye+1):">="+de+"."+pe+"."+ye+Re+" <"+de+"."+(+pe+1)+".0":">="+de+"."+pe+"."+ye+Re+" <"+(+de+1)+".0.0"):(k("no pr"),_e=de==="0"?pe==="0"?">="+de+"."+pe+"."+ye+" <"+de+"."+pe+"."+(+ye+1):">="+de+"."+pe+"."+ye+" <"+de+"."+(+pe+1)+".0":">="+de+"."+pe+"."+ye+" <"+(+de+1)+".0.0"),k("caret return",_e),_e})}(Ke,ze)}).join(" ")}(Oe,Ne),k("caret",Oe),Oe=function(Be,ze){return Be.trim().split(/\s+/).map(function(Ke){return function(Ue,Ge){var K=Ge?b[G]:b[X];return Ue.replace(K,function(ue,de,pe,ye,Re){var _e;return k("tilde",Ue,ue,de,pe,ye,Re),Le(de)?_e="":Le(pe)?_e=">="+de+".0.0 <"+(+de+1)+".0.0":Le(ye)?_e=">="+de+"."+pe+".0 <"+de+"."+(+pe+1)+".0":Re?(k("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),_e=">="+de+"."+pe+"."+ye+Re+" <"+de+"."+(+pe+1)+".0"):_e=">="+de+"."+pe+"."+ye+" <"+de+"."+(+pe+1)+".0",k("tilde return",_e),_e})}(Ke,ze)}).join(" ")}(Oe,Ne),k("tildes",Oe),Oe=function(Be,ze){return k("replaceXRanges",Be,ze),Be.split(/\s+/).map(function(Ke){return function(Ue,Ge){Ue=Ue.trim();var K=Ge?b[T]:b[M];return Ue.replace(K,function(ue,de,pe,ye,Re,_e){k("xRange",Ue,ue,de,pe,ye,Re,_e);var it=Le(pe),xe=it||Le(ye),je=xe||Le(Re);return de==="="&&je&&(de=""),it?ue=de===">"||de==="<"?"<0.0.0":"*":de&&je?(xe&&(ye=0),je&&(Re=0),de===">"?(de=">=",xe?(pe=+pe+1,ye=0,Re=0):je&&(ye=+ye+1,Re=0)):de==="<="&&(de="<",xe?pe=+pe+1:ye=+ye+1),ue=de+pe+"."+ye+"."+Re):xe?ue=">="+pe+".0.0 <"+(+pe+1)+".0.0":je&&(ue=">="+pe+"."+ye+".0 <"+pe+"."+(+ye+1)+".0"),k("xRange return",ue),ue})}(Ke,ze)}).join(" ")}(Oe,Ne),k("xrange",Oe),Oe=function(Be,ze){return k("replaceStars",Be,ze),Be.trim().replace(b[J],"")}(Oe,Ne),k("stars",Oe),Oe}(Te,le)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Te){return!!Te.match(Se)})),Ie=Ie.map(function(Te){return new De(Te,le)})},ke.prototype.intersects=function(x,le){if(!(x instanceof ke))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Se){return x.set.some(function(Ie){return Ie.every(function(Te){return Se.intersects(Te,le)})})})})},e.toComparators=function(x,le){return new ke(x,le).set.map(function(fe){return fe.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},ke.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new L(x,this.loose));for(var le=0;le<this.set.length;le++)if(me(this.set[le],x))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(x,le,fe){var Se=null,Ie=null;try{var Te=new ke(le,fe)}catch{return null}return x.forEach(function(Oe){Te.test(Oe)&&(Se&&Ie.compare(Oe)!==-1||(Ie=new L(Se=Oe,fe)))}),Se},e.minSatisfying=function(x,le,fe){var Se=null,Ie=null;try{var Te=new ke(le,fe)}catch{return null}return x.forEach(function(Oe){Te.test(Oe)&&(Se&&Ie.compare(Oe)!==1||(Ie=new L(Se=Oe,fe)))}),Se},e.validRange=function(x,le){try{return new ke(x,le).range||"*"}catch{return null}},e.ltr=function(x,le,fe){return Ee(x,le,"<",fe)},e.gtr=function(x,le,fe){return Ee(x,le,">",fe)},e.outside=Ee,e.prerelease=function(x,le){var fe=$(x,le);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(x,le,fe){return x=new ke(x,fe),le=new ke(le,fe),x.intersects(le)},e.coerce=function(x){if(x instanceof L)return x;if(typeof x!="string")return null;var le=x.match(b[U]);return le==null?null:$((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,v(1))},function(z,e){var v,t,k=z.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function b(w){if(v===setTimeout)return setTimeout(w,0);if((v===R||!v)&&setTimeout)return v=setTimeout,setTimeout(w,0);try{return v(w,0)}catch{try{return v.call(null,w,0)}catch{return v.call(this,w,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:R}catch{v=R}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var u,m=[],I=!1,y=-1;function E(){I&&u&&(I=!1,u.length?m=u.concat(m):y=-1,m.length&&h())}function h(){if(!I){var w=b(E);I=!0;for(var p=m.length;p;){for(u=m,m=[];++y<p;)u&&u[y].run();y=-1,p=m.length}u=null,I=!1,function(S){if(t===clearTimeout)return clearTimeout(S);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(S);try{t(S)}catch{try{return t.call(null,S)}catch{return t.call(this,S)}}}(w)}}function d(w,p){this.fun=w,this.array=p}function P(){}k.nextTick=function(w){var p=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)p[S-1]=arguments[S];m.push(new d(w,p)),m.length!==1||I||b(h)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=P,k.addListener=P,k.once=P,k.off=P,k.removeListener=P,k.removeAllListeners=P,k.emit=P,k.prependListener=P,k.prependOnceListener=P,k.listeners=function(w){return[]},k.binding=function(w){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(w){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(te[126],ie([0,1]),function(z,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(b,u,m){this.level=b,this.key=u,this.value=m,this.forward=[]}}const k=void 0;class R{constructor(b,u=2**16){this.comparator=b,this[v]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(u)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(b){return Boolean(R._search(this,b,this.comparator))}get(b){return R._search(this,b,this.comparator)?.value}set(b,u){return R._insert(this,b,u,this.comparator)&&(this._size+=1),this}delete(b){const u=R._delete(this,b,this.comparator);return u&&(this._size-=1),u}forEach(b,u){let m=this._header.forward[0];for(;m;)b.call(u,m.value,m.key,this),m=m.forward[0]}[(v=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this._header.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this._header.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this._header.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",u=this._header.forward[0];for(;u;)b+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return b}static _search(b,u,m){let I=b._header;for(let y=b._level-1;y>=0;y--)for(;I.forward[y]&&m(I.forward[y].key,u)<0;)I=I.forward[y];if(I=I.forward[0],I&&m(I.key,u)===0)return I}static _insert(b,u,m,I){const y=[];let E=b._header;for(let h=b._level-1;h>=0;h--){for(;E.forward[h]&&I(E.forward[h].key,u)<0;)E=E.forward[h];y[h]=E}if(E=E.forward[0],E&&I(E.key,u)===0)return E.value=m,!1;{const h=R._randomLevel(b);if(h>b._level){for(let d=b._level;d<h;d++)y[d]=b._header;b._level=h}E=new t(h,u,m);for(let d=0;d<h;d++)E.forward[d]=y[d].forward[d],y[d].forward[d]=E;return!0}}static _randomLevel(b,u=.5){let m=1;for(;Math.random()<u&&m<b._maxLevel;)m+=1;return m}static _delete(b,u,m){const I=[];let y=b._header;for(let E=b._level-1;E>=0;E--){for(;y.forward[E]&&m(y.forward[E].key,u)<0;)y=y.forward[E];I[E]=y}if(y=y.forward[0],!y||m(y.key,u)!==0)return!1;for(let E=0;E<b._level&&I[E].forward[E]===y;E++)I[E].forward[E]=y.forward[E];for(;b._level>0&&b._header.forward[b._level-1]===k;)b._level-=1;return!0}}e.SkipList=R}),define(te[58],ie([0,1,17,2]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(g){const l=g;return l?typeof l.read=="function":!1}e.isReadable=k;function R(g){const l=g;return l?[l.on,l.pause,l.resume,l.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=R;function D(g){const l=g;return l?R(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=D;function b(g,l){return new u(g,l)}e.newWriteableStream=b;class u{constructor(l,r){this.reducer=l,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l<"u"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(r=>r(l))}emitError(l){this.listeners.error.length===0?(0,v.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(r=>r(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,r){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(l,r){if(this.state.destroyed)return;let o;switch(l){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const i=o.indexOf(r);i>=0&&o.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(g,l){const r=[];let o;for(;(o=g.read())!==null;)r.push(o);return l(r)}e.consumeReadable=m;function I(g,l,r){const o=[];let i;for(;(i=g.read())!==null&&o.length<r;)o.push(i);return i===null&&o.length>0?l(o):{read:()=>{if(o.length>0)return o.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return g.read()}}}e.peekReadable=I;function y(g,l){return new Promise((r,o)=>{const i=[];E(g,{onData:n=>{l&&i.push(n)},onError:n=>{l?o(n):r(void 0)},onEnd:()=>{r(l?l(i):void 0)}})})}e.consumeStream=y;function E(g,l){let r=!1;return g.on("error",o=>{r||l.onError(o)}),g.on("end",()=>{r||l.onEnd()}),g.on("data",o=>{r||l.onData(o)}),(0,t.toDisposable)(()=>r=!0)}e.listenStream=E;function h(g,l){return new Promise((r,o)=>{const i=new t.DisposableStore,n=[],s=C=>{if(n.push(C),n.length>l)return i.dispose(),g.pause(),r({stream:g,buffer:n,ended:!1})},c=C=>o(C),a=()=>r({stream:g,buffer:n,ended:!0});i.add((0,t.toDisposable)(()=>g.removeListener("error",c))),g.on("error",c),i.add((0,t.toDisposable)(()=>g.removeListener("end",a))),g.on("end",a),i.add((0,t.toDisposable)(()=>g.removeListener("data",s))),g.on("data",s)})}e.peekStream=h;function d(g,l){const r=b(l);return r.end(g),r}e.toStream=d;function P(){const g=b(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=P;function w(g){let l=!1;return{read:()=>l?null:(l=!0,g)}}e.toReadable=w;function p(g,l,r){const o=b(r);return E(g,{onData:i=>o.write(l.data(i)),onError:i=>o.error(l.error?l.error(i):i),onEnd:()=>o.end()}),o}e.transform=p;function S(g,l,r){let o=!1;return{read:()=>{const i=l.read();return o?i:(o=!0,i!==null?r([g,i]):g)}}}e.prefixedReadable=S;function f(g,l,r){let o=!1;const i=b(r);return E(l,{onData:n=>o?i.write(n):(o=!0,i.write(r([g,n]))),onError:n=>i.error(n),onEnd:()=>{o||(o=!0,i.write(g)),i.end()}}),i}e.prefixedStream=f}),define(te[18],ie([0,1,58]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class D{static alloc(C){return t?new D(Buffer.allocUnsafe(C)):new D(new Uint8Array(C))}static wrap(C){return t&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new D(C)}static fromString(C,M){return!(M?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(C)):(k||(k=new TextEncoder),new D(k.encode(C)))}static fromByteArray(C){const M=D.alloc(C.length);for(let T=0,U=C.length;T<U;T++)M.buffer[T]=C[T];return M}static concat(C,M){if(typeof M>"u"){M=0;for(let Q=0,ae=C.length;Q<ae;Q++)M+=C[Q].byteLength}const T=D.alloc(M);let U=0;for(let Q=0,ae=C.length;Q<ae;Q++){const X=C[Q];T.set(X,U),U+=X.byteLength}return T}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=D.alloc(this.byteLength);return C.set(this),C}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(C,M){return new D(this.buffer.subarray(C,M))}set(C,M){if(C instanceof D)this.buffer.set(C.buffer,M);else if(C instanceof Uint8Array)this.buffer.set(C,M);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),M);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return m(this.buffer,C)}writeUInt32BE(C,M){I(this.buffer,C,M)}readUInt32LE(C){return y(this.buffer,C)}writeUInt32LE(C,M){E(this.buffer,C,M)}readUInt8(C){return h(this.buffer,C)}writeUInt8(C,M){d(this.buffer,C,M)}}e.VSBuffer=D;function b(a,C){return a[C+0]<<0>>>0|a[C+1]<<8>>>0}e.readUInt16LE=b;function u(a,C,M){a[M+0]=C&255,C=C>>>8,a[M+1]=C&255}e.writeUInt16LE=u;function m(a,C){return a[C]*2**24+a[C+1]*2**16+a[C+2]*2**8+a[C+3]}e.readUInt32BE=m;function I(a,C,M){a[M+3]=C,C=C>>>8,a[M+2]=C,C=C>>>8,a[M+1]=C,C=C>>>8,a[M]=C}e.writeUInt32BE=I;function y(a,C){return a[C+0]<<0>>>0|a[C+1]<<8>>>0|a[C+2]<<16>>>0|a[C+3]<<24>>>0}e.readUInt32LE=y;function E(a,C,M){a[M+0]=C&255,C=C>>>8,a[M+1]=C&255,C=C>>>8,a[M+2]=C&255,C=C>>>8,a[M+3]=C&255}e.writeUInt32LE=E;function h(a,C){return a[C]}e.readUInt8=h;function d(a,C,M){a[M]=C}e.writeUInt8=d;function P(a){return v.consumeReadable(a,C=>D.concat(C))}e.readableToBuffer=P;function w(a){return v.toReadable(a)}e.bufferToReadable=w;function p(a){return v.consumeStream(a,C=>D.concat(C))}e.streamToBuffer=p;async function S(a){return a.ended?D.concat(a.buffer):D.concat([...a.buffer,await p(a.stream)])}e.bufferedStreamToBuffer=S;function f(a){return v.toStream(a,C=>D.concat(C))}e.bufferToStream=f;function g(a){return v.transform(a,{data:C=>typeof C=="string"?D.fromString(C):D.wrap(C)},C=>D.concat(C))}e.streamToBufferReadableStream=g;function l(a){return v.newWriteableStream(C=>D.concat(C),a)}e.newWriteableBufferStream=l;function r(a,C){return v.prefixedReadable(a,C,M=>D.concat(M))}e.prefixedBufferReadable=r;function o(a,C){return v.prefixedStream(a,C,M=>D.concat(M))}e.prefixedBufferStream=o;function i(a){let C=0,M=0,T=0;const U=new Uint8Array(Math.floor(a.length/4*3)),Q=X=>{switch(M){case 3:U[T++]=C|X,M=0;break;case 2:U[T++]=C|X>>>2,C=X<<6,M=3;break;case 1:U[T++]=C|X>>>4,C=X<<4,M=2;break;default:C=X<<2,M=1}};for(let X=0;X<a.length;X++){const G=a.charCodeAt(X);if(G>=65&&G<=90)Q(G-65);else if(G>=97&&G<=122)Q(G-97+26);else if(G>=48&&G<=57)Q(G-48+52);else if(G===43||G===45)Q(62);else if(G===47||G===95)Q(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${a[X]}`)}}const ae=T;for(;M>0;)Q(0);return D.wrap(U).slice(0,ae)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},C=!0,M=!1){const T=M?s:n;let U="";const Q=a.byteLength%3;let ae=0;for(;ae<a.byteLength-Q;ae+=3){const X=a[ae+0],G=a[ae+1],Z=a[ae+2];U+=T[X>>>2],U+=T[(X<<4|G>>>4)&63],U+=T[(G<<2|Z>>>6)&63],U+=T[Z&63]}if(Q===1){const X=a[ae+0];U+=T[X>>>2],U+=T[X<<4&63],C&&(U+="==")}else if(Q===2){const X=a[ae+0],G=a[ae+1];U+=T[X>>>2],U+=T[(X<<4|G>>>4)&63],U+=T[G<<2&63],C&&(U+="=")}return U}e.encodeBase64=c}),define(te[12],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function v(o){return typeof o=="string"}e.isString=v;function t(o){return Array.isArray(o)&&o.every(i=>v(i))}e.isStringArray=t;function k(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=k;function R(o){const i=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof i}e.isTypedArray=R;function D(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=D;function b(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=b;function u(o){return o===!0||o===!1}e.isBoolean=u;function m(o){return typeof o>"u"}e.isUndefined=m;function I(o){return!y(o)}e.isDefined=I;function y(o){return m(o)||o===null}e.isUndefinedOrNull=y;function E(o,i){if(!o)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=E;function h(o){if(y(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=h;function d(...o){const i=[];for(let n=0;n<o.length;n++){const s=o[n];if(y(s))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(s)}return i}e.assertAllDefined=d;const P=Object.prototype.hasOwnProperty;function w(o){if(!k(o))return!1;for(const i in o)if(P.call(o,i))return!1;return!0}e.isEmptyObject=w;function p(o){return typeof o=="function"}e.isFunction=p;function S(...o){return o.length>0&&o.every(p)}e.areFunctions=S;function f(o,i){const n=Math.min(o.length,i.length);for(let s=0;s<n;s++)g(o[s],i[s])}e.validateConstraints=f;function g(o,i){if(v(i)){if(typeof o!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(p(i)){try{if(o instanceof i)return}catch{}if(!y(o)&&o.constructor===i||i.length===1&&i.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=g;function l(o){return o===null?void 0:o}e.withNullAsUndefined=l;function r(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=r}),define(te[50],ie([0,1,12]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const S=Array.isArray(p)?[]:{};return Object.keys(p).forEach(f=>{p[f]&&typeof p[f]=="object"?S[f]=t(p[f]):S[f]=p[f]}),S}e.deepClone=t;function k(p){if(!p||typeof p!="object")return p;const S=[p];for(;S.length>0;){const f=S.shift();Object.freeze(f);for(const g in f)if(R.call(f,g)){const l=f[g];typeof l=="object"&&!Object.isFrozen(l)&&!(0,v.isTypedArray)(l)&&S.push(l)}}return p}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function D(p,S){return b(p,S,new Set)}e.cloneAndChange=D;function b(p,S,f){if((0,v.isUndefinedOrNull)(p))return p;const g=S(p);if(typeof g<"u")return g;if(Array.isArray(p)){const l=[];for(const r of p)l.push(b(r,S,f));return l}if((0,v.isObject)(p)){if(f.has(p))throw new Error("Cannot clone recursive data-structure");f.add(p);const l={};for(const r in p)R.call(p,r)&&(l[r]=b(p[r],S,f));return f.delete(p),l}return p}function u(p,S,f=!0){return(0,v.isObject)(p)?((0,v.isObject)(S)&&Object.keys(S).forEach(g=>{g in p?f&&((0,v.isObject)(p[g])&&(0,v.isObject)(S[g])?u(p[g],S[g],f):p[g]=S[g]):p[g]=S[g]}),p):S}e.mixin=u;function m(p,S){if(p===S)return!0;if(p==null||S===null||S===void 0||typeof p!=typeof S||typeof p!="object"||Array.isArray(p)!==Array.isArray(S))return!1;let f,g;if(Array.isArray(p)){if(p.length!==S.length)return!1;for(f=0;f<p.length;f++)if(!m(p[f],S[f]))return!1}else{const l=[];for(g in p)l.push(g);l.sort();const r=[];for(g in S)r.push(g);if(r.sort(),!m(l,r))return!1;for(f=0;f<l.length;f++)if(!m(p[l[f]],S[l[f]]))return!1}return!0}e.equals=m;function I(p){const S=new Set;return JSON.stringify(p,(f,g)=>{if((0,v.isObject)(g)||Array.isArray(g)){if(S.has(g))return"[Circular]";S.add(g)}return g})}e.safeStringify=I;function y(p,S){const f=Object.create(null);return!p||!S||Object.keys(S).forEach(l=>{const r=p[l],o=S[l];m(r,o)||(f[l]=o)}),f}e.distinct=y;function E(p,S){const f=S.toLowerCase(),g=Object.keys(p).find(l=>l.toLowerCase()===f);return g?p[g]:p[S]}e.getCaseInsensitive=E;function h(p,S){const f=Object.create(null);for(const[g,l]of Object.entries(p))S(g,l)&&(f[g]=l);return f}e.filter=h;function d(p){let S=[],f=Object.getPrototypeOf(p);for(;Object.prototype!==f;)S=S.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return S}e.getAllPropertyNames=d;function P(p){const S=[];for(const f of d(p))typeof p[f]=="function"&&S.push(f);return S}e.getAllMethodNames=P;function w(p,S){const f=l=>function(){const r=Array.prototype.slice.call(arguments,0);return S(l,r)},g={};for(const l of p)g[l]=f(l);return g}e.createProxyObject=w}),define(te[29],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return v.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(b){for(let u=0;u<b.length;u++)b[u]=Math.floor(Math.random()*256);return b};const R=new Uint8Array(16),D=[];for(let b=0;b<256;b++)D.push(b.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let u=0,m="";return m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m+="-",m+=D[R[u++]],m+=D[R[u++]],m+="-",m+=D[R[u++]],m+=D[R[u++]],m+="-",m+=D[R[u++]],m+=D[R[u++]],m+="-",m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m}}()}),define(te[127],ie([0,1,76,40,49]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,b){if(await new Promise((I,y)=>{const E=t.createReadStream(D),h=v.createHash("sha1");E.pipe(h);const d=(0,k.once)((P,w)=>{E.removeAllListeners(),h.removeAllListeners(),P?y(P):I(w)});E.once("error",d),E.once("end",d),h.once("error",d),h.once("data",P=>d(void 0,P.toString("hex")))})!==b)throw new Error("Hash mismatch")}e.checksum=R}),define(te[128],ie([0,1,25]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(D){const b=D.replace(/\-/g,":").toLowerCase();return!t.has(b)}function R(){const D=(0,v.networkInterfaces)();for(const b in D){const u=D[b];if(u){for(const{mac:m}of u)if(k(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(te[95],ie([0,1,77]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(b,u,m,I=1){let y=!1;return new Promise(E=>{const h=setTimeout(()=>{if(!y)return y=!0,E(0)},m);k(b,u,I,d=>{if(!y)return y=!0,clearTimeout(h),E(d)})})}e.findFreePort=t;function k(b,u,m,I){if(u===0)return I(0);const y=new v.Socket;y.once("connect",()=>(D(y),k(b+m,u-1,m,I))),y.once("data",()=>{}),y.once("error",E=>(D(y),E.code!=="ECONNREFUSED"?k(b+m,u-1,m,I):I(b))),y.connect(b,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(b,u,m){let I=!1,y,E=1;const h=v.createServer({pauseOnConnect:!0});function d(P,w){I||(I=!0,h.removeAllListeners(),h.close(),y&&clearTimeout(y),w(P))}return new Promise(P=>{y=setTimeout(()=>{d(0,P)},m),h.on("listening",()=>{d(b,P)}),h.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&E<u?(b++,E++,h.listen(b,"127.0.0.1")):d(0,P)}),h.on("close",()=>{d(0,P)}),h.listen(b,"127.0.0.1")})}e.findFreePortFaster=R;function D(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(u){console.error(u)}}}),define(te[129],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(te[130],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(te[41],ie([0,1,15,17]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,b){const u=(m,...I)=>{this.validateEvent(D,m)&&b(m,...I)};return this.mapListenerToWrapper.set(b,u),v.ipcMain.on(D,u),this}once(D,b){return v.ipcMain.once(D,(u,...m)=>{this.validateEvent(D,u)&&b(u,...m)}),this}handle(D,b){return v.ipcMain.handle(D,(u,...m)=>this.validateEvent(D,u)?b(u,...m):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return v.ipcMain.removeHandler(D),this}removeListener(D,b){const u=this.mapListenerToWrapper.get(b);return u&&(v.ipcMain.removeListener(D,u),this.mapListenerToWrapper.delete(b)),this}validateEvent(D,b){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const u=b.senderFrame,m=u.url;if(!m)return!0;let I="unknown";try{I=new URL(m).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${m}'.`),!1}return I!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${I}'.`),!1):u.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${I}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(te[131],ie([0,1,15,41,12,129]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(u,m,I,y,E)=>{const h=b(u,y,I);h.popup({window:(0,k.withNullAsUndefined)(v.BrowserWindow.fromWebContents(u.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{h&&u.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=D;function b(u,m,I){const y=new v.Menu;return I.forEach(E=>{let h;E.type==="separator"?h=new v.MenuItem({type:E.type}):Array.isArray(E.submenu)?h=new v.MenuItem({submenu:b(u,m,E.submenu),label:E.label}):h=new v.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(d,P,w)=>u.sender.send(m,E.id,w)}),y.append(h)}),y}}),define(te[132],ie([11,10]),function(z,e){return z.create("vs/base/common/date",e)}),define(te[133],ie([0,1,132]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,D=R*7,b=R*30,u=R*365;function m(y,E,h){typeof y!="number"&&(y=y.getTime());const d=Math.round((new Date().getTime()-y)/1e3);if(d<-30)return(0,v.localize)(0,null,m(new Date().getTime()+d*1e3,!1));if(d<30)return(0,v.localize)(1,null);let P;return d<t?(P=d,E?P===1?h?(0,v.localize)(2,null,P):(0,v.localize)(3,null,P):h?(0,v.localize)(4,null,P):(0,v.localize)(5,null,P):P===1?h?(0,v.localize)(6,null,P):(0,v.localize)(7,null,P):h?(0,v.localize)(8,null,P):(0,v.localize)(9,null,P)):d<k?(P=Math.floor(d/t),E?P===1?h?(0,v.localize)(10,null,P):(0,v.localize)(11,null,P):h?(0,v.localize)(12,null,P):(0,v.localize)(13,null,P):P===1?h?(0,v.localize)(14,null,P):(0,v.localize)(15,null,P):h?(0,v.localize)(16,null,P):(0,v.localize)(17,null,P)):d<R?(P=Math.floor(d/k),E?P===1?h?(0,v.localize)(18,null,P):(0,v.localize)(19,null,P):h?(0,v.localize)(20,null,P):(0,v.localize)(21,null,P):P===1?h?(0,v.localize)(22,null,P):(0,v.localize)(23,null,P):h?(0,v.localize)(24,null,P):(0,v.localize)(25,null,P)):d<D?(P=Math.floor(d/R),E?P===1?(0,v.localize)(26,null,P):(0,v.localize)(27,null,P):P===1?(0,v.localize)(28,null,P):(0,v.localize)(29,null,P)):d<b?(P=Math.floor(d/D),E?P===1?h?(0,v.localize)(30,null,P):(0,v.localize)(31,null,P):h?(0,v.localize)(32,null,P):(0,v.localize)(33,null,P):P===1?h?(0,v.localize)(34,null,P):(0,v.localize)(35,null,P):h?(0,v.localize)(36,null,P):(0,v.localize)(37,null,P)):d<u?(P=Math.floor(d/b),E?P===1?h?(0,v.localize)(38,null,P):(0,v.localize)(39,null,P):h?(0,v.localize)(40,null,P):(0,v.localize)(41,null,P):P===1?h?(0,v.localize)(42,null,P):(0,v.localize)(43,null,P):h?(0,v.localize)(44,null,P):(0,v.localize)(45,null,P)):(P=Math.floor(d/u),E?P===1?h?(0,v.localize)(46,null,P):(0,v.localize)(47,null,P):h?(0,v.localize)(48,null,P):(0,v.localize)(49,null,P):P===1?h?(0,v.localize)(50,null,P):(0,v.localize)(51,null,P):h?(0,v.localize)(52,null,P):(0,v.localize)(53,null,P))}e.fromNow=m;function I(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(te[134],ie([11,10]),function(z,e){return z.create("vs/base/common/errorMessage",e)}),define(te[44],ie([0,1,24,12,134]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(y,E){return E&&(y.stack||y.stacktrace)?k.localize(0,null,b(y),D(y.stack)||D(y.stacktrace)):b(y)}function D(y){return Array.isArray(y)?y.join(`
`):y}function b(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?k.localize(1,null,y.message):y.message||k.localize(2,null)}function u(y=null,E=!1){if(!y)return k.localize(3,null);if(Array.isArray(y)){const h=v.coalesce(y),d=u(h[0],E);return h.length>1?k.localize(4,null,d,h.length):d}if(t.isString(y))return y;if(y.detail){const h=y.detail;if(h.error)return R(h.error,E);if(h.exception)return R(h.exception,E)}return y.stack?R(y,E):y.message?y.message:k.localize(5,null)}e.toErrorMessage=u;function m(y){const E=y;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=m;function I(y,E){let h;return typeof y=="string"?h=new Error(y):h=y,h.actions=E,h}e.createErrorWithActions=I}),define(te[135],ie([11,10]),function(z,e){return z.create("vs/base/common/jsonErrorMessages",e)}),define(te[136],ie([0,1,135]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,v.localize)(0,null);case 2:return(0,v.localize)(1,null);case 3:return(0,v.localize)(2,null);case 4:return(0,v.localize)(3,null);case 5:return(0,v.localize)(4,null);case 6:return(0,v.localize)(5,null);case 7:return(0,v.localize)(6,null);case 8:return(0,v.localize)(7,null);case 9:return(0,v.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(te[137],ie([11,10]),function(z,e){return z.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,137]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,R=!1,D=!1,b=!1,u=!1,m=!1,I=!1,y=!1,E=!1,h,d=e.LANGUAGE_DEFAULT,P,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?p=e.globals.vscode.process:typeof process<"u"&&(p=process);const S=typeof p?.versions?.electron=="string",f=S&&p?.type==="renderer";if(typeof navigator=="object"&&!f)w=navigator.userAgent,t=w.indexOf("Windows")>=0,k=w.indexOf("Macintosh")>=0,I=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=w.indexOf("Linux")>=0,E=w?.indexOf("Mobi")>=0,u=!0,h=v.getConfiguredDefaultLocale(v.localize(0,null))||e.LANGUAGE_DEFAULT,d=h;else if(typeof p=="object"){t=p.platform==="win32",k=p.platform==="darwin",R=p.platform==="linux",D=R&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,m=S,y=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const a=p.env.VSCODE_NLS_CONFIG;if(a)try{const C=JSON.parse(a),M=C.availableLanguages["*"];h=C.locale,d=M||e.LANGUAGE_DEFAULT,P=C._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var g;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function l(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let r=0;k?r=1:t?r=3:R&&(r=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=R,e.isLinuxSnap=D,e.isNative=b,e.isElectron=m,e.isWeb=u,e.isWebWorker=u&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isMobile=E,e.isCI=y,e.platform=r,e.userAgent=w,e.language=d;var o;(function(a){function C(){return e.language}a.value=C;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=M;function T(){return e.language==="en"}a.isDefault=T})(o=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=P,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,U=a.length;T<U;T++){const Q=a[T];if(Q.id===M.data.vscodeScheduleAsyncWork){a.splice(T,1),Q.callback();return}}});let C=0;return M=>{const T=++C;a.push({id:T,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return a=>setTimeout(a)})();var i;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||I?2:t?1:3;let n=!0,s=!1;function c(){if(!s){s=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,n=new Uint16Array(a.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[34],ie([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.process<"u"){const k=v.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(te[9],ie([0,1,34]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,D=122,b=46,u=47,m=92,I=58,y=63;class E extends Error{constructor(g,l,r){let o;typeof l=="string"&&l.indexOf("not ")===0?(o="must not be",l=l.replace(/^not /,"")):o="must be";const i=g.indexOf(".")!==-1?"property":"argument";let n=`The "${g}" ${i} ${o} of type ${l}`;n+=`. Received type ${typeof r}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function h(f,g){if(typeof f!="string")throw new E(g,"string",f)}function d(f){return f===u||f===m}function P(f){return f===u}function w(f){return f>=t&&f<=R||f>=k&&f<=D}function p(f,g,l,r){let o="",i=0,n=-1,s=0,c=0;for(let a=0;a<=f.length;++a){if(a<f.length)c=f.charCodeAt(a);else{if(r(c))break;c=u}if(r(c)){if(!(n===a-1||s===1))if(s===2){if(o.length<2||i!==2||o.charCodeAt(o.length-1)!==b||o.charCodeAt(o.length-2)!==b){if(o.length>2){const C=o.lastIndexOf(l);C===-1?(o="",i=0):(o=o.slice(0,C),i=o.length-1-o.lastIndexOf(l)),n=a,s=0;continue}else if(o.length!==0){o="",i=0,n=a,s=0;continue}}g&&(o+=o.length>0?`${l}..`:"..",i=2)}else o.length>0?o+=`${l}${f.slice(n+1,a)}`:o=f.slice(n+1,a),i=a-n-1;n=a,s=0}else c===b&&s!==-1?++s:s=-1}return o}function S(f,g){if(g===null||typeof g!="object")throw new E("pathObject","Object",g);const l=g.dir||g.root,r=g.base||`${g.name||""}${g.ext||""}`;return l?l===g.root?`${l}${r}`:`${l}${f}${r}`:r}e.win32={resolve(...f){let g="",l="",r=!1;for(let o=f.length-1;o>=-1;o--){let i;if(o>=0){if(i=f[o],h(i,"path"),i.length===0)continue}else g.length===0?i=v.cwd():(i=v.env[`=${g}`]||v.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==g.toLowerCase()&&i.charCodeAt(2)===m)&&(i=`${g}\\`));const n=i.length;let s=0,c="",a=!1;const C=i.charCodeAt(0);if(n===1)d(C)&&(s=1,a=!0);else if(d(C))if(a=!0,d(i.charCodeAt(1))){let M=2,T=M;for(;M<n&&!d(i.charCodeAt(M));)M++;if(M<n&&M!==T){const U=i.slice(T,M);for(T=M;M<n&&d(i.charCodeAt(M));)M++;if(M<n&&M!==T){for(T=M;M<n&&!d(i.charCodeAt(M));)M++;(M===n||M!==T)&&(c=`\\\\${U}\\${i.slice(T,M)}`,s=M)}}}else s=1;else w(C)&&i.charCodeAt(1)===I&&(c=i.slice(0,2),s=2,n>2&&d(i.charCodeAt(2))&&(a=!0,s=3));if(c.length>0)if(g.length>0){if(c.toLowerCase()!==g.toLowerCase())continue}else g=c;if(r){if(g.length>0)break}else if(l=`${i.slice(s)}\\${l}`,r=a,a&&g.length>0)break}return l=p(l,!r,"\\",d),r?`${g}\\${l}`:`${g}${l}`||"."},normalize(f){h(f,"path");const g=f.length;if(g===0)return".";let l=0,r,o=!1;const i=f.charCodeAt(0);if(g===1)return P(i)?"\\":f;if(d(i))if(o=!0,d(f.charCodeAt(1))){let s=2,c=s;for(;s<g&&!d(f.charCodeAt(s));)s++;if(s<g&&s!==c){const a=f.slice(c,s);for(c=s;s<g&&d(f.charCodeAt(s));)s++;if(s<g&&s!==c){for(c=s;s<g&&!d(f.charCodeAt(s));)s++;if(s===g)return`\\\\${a}\\${f.slice(c)}\\`;s!==c&&(r=`\\\\${a}\\${f.slice(c,s)}`,l=s)}}}else l=1;else w(i)&&f.charCodeAt(1)===I&&(r=f.slice(0,2),l=2,g>2&&d(f.charCodeAt(2))&&(o=!0,l=3));let n=l<g?p(f.slice(l),!o,"\\",d):"";return n.length===0&&!o&&(n="."),n.length>0&&d(f.charCodeAt(g-1))&&(n+="\\"),r===void 0?o?`\\${n}`:n:o?`${r}\\${n}`:`${r}${n}`},isAbsolute(f){h(f,"path");const g=f.length;if(g===0)return!1;const l=f.charCodeAt(0);return d(l)||g>2&&w(l)&&f.charCodeAt(1)===I&&d(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let g,l;for(let i=0;i<f.length;++i){const n=f[i];h(n,"path"),n.length>0&&(g===void 0?g=l=n:g+=`\\${n}`)}if(g===void 0)return".";let r=!0,o=0;if(typeof l=="string"&&d(l.charCodeAt(0))){++o;const i=l.length;i>1&&d(l.charCodeAt(1))&&(++o,i>2&&(d(l.charCodeAt(2))?++o:r=!1))}if(r){for(;o<g.length&&d(g.charCodeAt(o));)o++;o>=2&&(g=`\\${g.slice(o)}`)}return e.win32.normalize(g)},relative(f,g){if(h(f,"from"),h(g,"to"),f===g)return"";const l=e.win32.resolve(f),r=e.win32.resolve(g);if(l===r||(f=l.toLowerCase(),g=r.toLowerCase(),f===g))return"";let o=0;for(;o<f.length&&f.charCodeAt(o)===m;)o++;let i=f.length;for(;i-1>o&&f.charCodeAt(i-1)===m;)i--;const n=i-o;let s=0;for(;s<g.length&&g.charCodeAt(s)===m;)s++;let c=g.length;for(;c-1>s&&g.charCodeAt(c-1)===m;)c--;const a=c-s,C=n<a?n:a;let M=-1,T=0;for(;T<C;T++){const Q=f.charCodeAt(o+T);if(Q!==g.charCodeAt(s+T))break;Q===m&&(M=T)}if(T!==C){if(M===-1)return r}else{if(a>C){if(g.charCodeAt(s+T)===m)return r.slice(s+T+1);if(T===2)return r.slice(s+T)}n>C&&(f.charCodeAt(o+T)===m?M=T:T===2&&(M=3)),M===-1&&(M=0)}let U="";for(T=o+M+1;T<=i;++T)(T===i||f.charCodeAt(T)===m)&&(U+=U.length===0?"..":"\\..");return s+=M,U.length>0?`${U}${r.slice(s,c)}`:(r.charCodeAt(s)===m&&++s,r.slice(s,c))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const g=e.win32.resolve(f);if(g.length<=2)return f;if(g.charCodeAt(0)===m){if(g.charCodeAt(1)===m){const l=g.charCodeAt(2);if(l!==y&&l!==b)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(w(g.charCodeAt(0))&&g.charCodeAt(1)===I&&g.charCodeAt(2)===m)return`\\\\?\\${g}`;return f},dirname(f){h(f,"path");const g=f.length;if(g===0)return".";let l=-1,r=0;const o=f.charCodeAt(0);if(g===1)return d(o)?f:".";if(d(o)){if(l=r=1,d(f.charCodeAt(1))){let s=2,c=s;for(;s<g&&!d(f.charCodeAt(s));)s++;if(s<g&&s!==c){for(c=s;s<g&&d(f.charCodeAt(s));)s++;if(s<g&&s!==c){for(c=s;s<g&&!d(f.charCodeAt(s));)s++;if(s===g)return f;s!==c&&(l=r=s+1)}}}}else w(o)&&f.charCodeAt(1)===I&&(l=g>2&&d(f.charCodeAt(2))?3:2,r=l);let i=-1,n=!0;for(let s=g-1;s>=r;--s)if(d(f.charCodeAt(s))){if(!n){i=s;break}}else n=!1;if(i===-1){if(l===-1)return".";i=l}return f.slice(0,i)},basename(f,g){g!==void 0&&h(g,"ext"),h(f,"path");let l=0,r=-1,o=!0,i;if(f.length>=2&&w(f.charCodeAt(0))&&f.charCodeAt(1)===I&&(l=2),g!==void 0&&g.length>0&&g.length<=f.length){if(g===f)return"";let n=g.length-1,s=-1;for(i=f.length-1;i>=l;--i){const c=f.charCodeAt(i);if(d(c)){if(!o){l=i+1;break}}else s===-1&&(o=!1,s=i+1),n>=0&&(c===g.charCodeAt(n)?--n===-1&&(r=i):(n=-1,r=s))}return l===r?r=s:r===-1&&(r=f.length),f.slice(l,r)}for(i=f.length-1;i>=l;--i)if(d(f.charCodeAt(i))){if(!o){l=i+1;break}}else r===-1&&(o=!1,r=i+1);return r===-1?"":f.slice(l,r)},extname(f){h(f,"path");let g=0,l=-1,r=0,o=-1,i=!0,n=0;f.length>=2&&f.charCodeAt(1)===I&&w(f.charCodeAt(0))&&(g=r=2);for(let s=f.length-1;s>=g;--s){const c=f.charCodeAt(s);if(d(c)){if(!i){r=s+1;break}continue}o===-1&&(i=!1,o=s+1),c===b?l===-1?l=s:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||o===-1||n===0||n===1&&l===o-1&&l===r+1?"":f.slice(l,o)},format:S.bind(null,"\\"),parse(f){h(f,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return g;const l=f.length;let r=0,o=f.charCodeAt(0);if(l===1)return d(o)?(g.root=g.dir=f,g):(g.base=g.name=f,g);if(d(o)){if(r=1,d(f.charCodeAt(1))){let M=2,T=M;for(;M<l&&!d(f.charCodeAt(M));)M++;if(M<l&&M!==T){for(T=M;M<l&&d(f.charCodeAt(M));)M++;if(M<l&&M!==T){for(T=M;M<l&&!d(f.charCodeAt(M));)M++;M===l?r=M:M!==T&&(r=M+1)}}}}else if(w(o)&&f.charCodeAt(1)===I){if(l<=2)return g.root=g.dir=f,g;if(r=2,d(f.charCodeAt(2))){if(l===3)return g.root=g.dir=f,g;r=3}}r>0&&(g.root=f.slice(0,r));let i=-1,n=r,s=-1,c=!0,a=f.length-1,C=0;for(;a>=r;--a){if(o=f.charCodeAt(a),d(o)){if(!c){n=a+1;break}continue}s===-1&&(c=!1,s=a+1),o===b?i===-1?i=a:C!==1&&(C=1):i!==-1&&(C=-1)}return s!==-1&&(i===-1||C===0||C===1&&i===s-1&&i===n+1?g.base=g.name=f.slice(n,s):(g.name=f.slice(n,i),g.base=f.slice(n,s),g.ext=f.slice(i,s))),n>0&&n!==r?g.dir=f.slice(0,n-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let g="",l=!1;for(let r=f.length-1;r>=-1&&!l;r--){const o=r>=0?f[r]:v.cwd();h(o,"path"),o.length!==0&&(g=`${o}/${g}`,l=o.charCodeAt(0)===u)}return g=p(g,!l,"/",P),l?`/${g}`:g.length>0?g:"."},normalize(f){if(h(f,"path"),f.length===0)return".";const g=f.charCodeAt(0)===u,l=f.charCodeAt(f.length-1)===u;return f=p(f,!g,"/",P),f.length===0?g?"/":l?"./":".":(l&&(f+="/"),g?`/${f}`:f)},isAbsolute(f){return h(f,"path"),f.length>0&&f.charCodeAt(0)===u},join(...f){if(f.length===0)return".";let g;for(let l=0;l<f.length;++l){const r=f[l];h(r,"path"),r.length>0&&(g===void 0?g=r:g+=`/${r}`)}return g===void 0?".":e.posix.normalize(g)},relative(f,g){if(h(f,"from"),h(g,"to"),f===g||(f=e.posix.resolve(f),g=e.posix.resolve(g),f===g))return"";const l=1,r=f.length,o=r-l,i=1,n=g.length-i,s=o<n?o:n;let c=-1,a=0;for(;a<s;a++){const M=f.charCodeAt(l+a);if(M!==g.charCodeAt(i+a))break;M===u&&(c=a)}if(a===s)if(n>s){if(g.charCodeAt(i+a)===u)return g.slice(i+a+1);if(a===0)return g.slice(i+a)}else o>s&&(f.charCodeAt(l+a)===u?c=a:a===0&&(c=0));let C="";for(a=l+c+1;a<=r;++a)(a===r||f.charCodeAt(a)===u)&&(C+=C.length===0?"..":"/..");return`${C}${g.slice(i+c)}`},toNamespacedPath(f){return f},dirname(f){if(h(f,"path"),f.length===0)return".";const g=f.charCodeAt(0)===u;let l=-1,r=!0;for(let o=f.length-1;o>=1;--o)if(f.charCodeAt(o)===u){if(!r){l=o;break}}else r=!1;return l===-1?g?"/":".":g&&l===1?"//":f.slice(0,l)},basename(f,g){g!==void 0&&h(g,"ext"),h(f,"path");let l=0,r=-1,o=!0,i;if(g!==void 0&&g.length>0&&g.length<=f.length){if(g===f)return"";let n=g.length-1,s=-1;for(i=f.length-1;i>=0;--i){const c=f.charCodeAt(i);if(c===u){if(!o){l=i+1;break}}else s===-1&&(o=!1,s=i+1),n>=0&&(c===g.charCodeAt(n)?--n===-1&&(r=i):(n=-1,r=s))}return l===r?r=s:r===-1&&(r=f.length),f.slice(l,r)}for(i=f.length-1;i>=0;--i)if(f.charCodeAt(i)===u){if(!o){l=i+1;break}}else r===-1&&(o=!1,r=i+1);return r===-1?"":f.slice(l,r)},extname(f){h(f,"path");let g=-1,l=0,r=-1,o=!0,i=0;for(let n=f.length-1;n>=0;--n){const s=f.charCodeAt(n);if(s===u){if(!o){l=n+1;break}continue}r===-1&&(o=!1,r=n+1),s===b?g===-1?g=n:i!==1&&(i=1):g!==-1&&(i=-1)}return g===-1||r===-1||i===0||i===1&&g===r-1&&g===l+1?"":f.slice(g,r)},format:S.bind(null,"/"),parse(f){h(f,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return g;const l=f.charCodeAt(0)===u;let r;l?(g.root="/",r=1):r=0;let o=-1,i=0,n=-1,s=!0,c=f.length-1,a=0;for(;c>=r;--c){const C=f.charCodeAt(c);if(C===u){if(!s){i=c+1;break}continue}n===-1&&(s=!1,n=c+1),C===b?o===-1?o=c:a!==1&&(a=1):o!==-1&&(a=-1)}if(n!==-1){const C=i===0&&l?1:i;o===-1||a===0||a===1&&o===n-1&&o===i+1?g.base=g.name=f.slice(C,n):(g.name=f.slice(C,o),g.base=f.slice(C,n),g.ext=f.slice(o,n))}return i>0?g.dir=f.slice(0,i-1):l&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[78],ie([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(b,...u){const m=u.reduce((E,h)=>(E[h]=!0,E),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(E=>!m[E]).forEach(E=>{for(let h=0;h<I.length;h++)if(E.search(I[h])!==-1){delete b[E];break}})}e.sanitizeProcessEnvironment=R;function D(b){!b||(delete b.DEBUG,v.isMacintosh&&delete b.DYLD_LIBRARY_PATH,v.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(te[79],ie([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=v.globals.performance&&typeof v.globals.performance.now=="function";class k{static create(D=!0){return new k(D)}constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(te[3],ie([0,1,17,49,2,94,79]),function(z,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const b=!1,u=!1;var m;(function(c){c.None=()=>k.Disposable.None;function a(O){if(u){const{onListenerDidAdd:_}=O,j=d.create();let Y=0;O.onListenerDidAdd=()=>{++Y===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),_?.()}}}function C(O){return(_,j=null,Y)=>{let oe=!1,q;return q=O(re=>{if(!oe)return q?q.dispose():oe=!0,_.call(j,re)},null,Y),oe&&q.dispose(),q}}c.once=C;function M(O,_,j){return G((Y,oe=null,q)=>O(re=>Y.call(oe,_(re)),null,q),j)}c.map=M;function T(O,_,j){return G((Y,oe=null,q)=>O(re=>{_(re),Y.call(oe,re)},null,q),j)}c.forEach=T;function U(O,_,j){return G((Y,oe=null,q)=>O(re=>_(re)&&Y.call(oe,re),null,q),j)}c.filter=U;function Q(O){return O}c.signal=Q;function ae(...O){return(_,j=null,Y)=>(0,k.combinedDisposable)(...O.map(oe=>oe(q=>_.call(j,q),null,Y)))}c.any=ae;function X(O,_,j,Y){let oe=j;return M(O,q=>(oe=_(oe,q),oe),Y)}c.reduce=X;function G(O,_){let j;const Y={onFirstListenerAdd(){j=O(oe.fire,oe)},onLastListenerRemove(){j?.dispose()}};_||a(Y);const oe=new w(Y);return _?.add(oe),oe.event}function Z(O,_,j=100,Y=!1,oe,q){let re,ne,ce,ge=0;const De={leakWarningThreshold:oe,onFirstListenerAdd(){re=O(ke=>{ge++,ne=_(ne,ke),Y&&!ce&&(Ae.fire(ne),ne=void 0),clearTimeout(ce),ce=setTimeout(()=>{const Le=ne;ne=void 0,ce=void 0,(!Y||ge>1)&&Ae.fire(Le),ge=0},j)})},onLastListenerRemove(){re.dispose()}};q||a(De);const Ae=new w(De);return q?.add(Ae),Ae.event}c.debounce=Z;function se(O,_=(Y,oe)=>Y===oe,j){let Y=!0,oe;return U(O,q=>{const re=Y||!_(q,oe);return Y=!1,oe=q,re},j)}c.latch=se;function he(O,_,j){return[c.filter(O,_,j),c.filter(O,Y=>!_(Y),j)]}c.split=he;function V(O,_=!1,j=[]){let Y=j.slice(),oe=O(ne=>{Y?Y.push(ne):re.fire(ne)});const q=()=>{Y?.forEach(ne=>re.fire(ne)),Y=null},re=new w({onFirstListenerAdd(){oe||(oe=O(ne=>re.fire(ne)))},onFirstListenerDidAdd(){Y&&(_?setTimeout(q):q())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return re.event}c.buffer=V;class H{constructor(_){this.event=_,this.disposables=new k.DisposableStore}map(_){return new H(M(this.event,_,this.disposables))}forEach(_){return new H(T(this.event,_,this.disposables))}filter(_){return new H(U(this.event,_,this.disposables))}reduce(_,j){return new H(X(this.event,_,j,this.disposables))}latch(){return new H(se(this.event,void 0,this.disposables))}debounce(_,j=100,Y=!1,oe){return new H(Z(this.event,_,j,Y,oe,this.disposables))}on(_,j,Y){return this.event(_,j,Y)}once(_,j,Y){return C(this.event)(_,j,Y)}dispose(){this.disposables.dispose()}}function W(O){return new H(O)}c.chain=W;function A(O,_,j=Y=>Y){const Y=(...ne)=>re.fire(j(...ne)),oe=()=>O.on(_,Y),q=()=>O.removeListener(_,Y),re=new w({onFirstListenerAdd:oe,onLastListenerRemove:q});return re.event}c.fromNodeEventEmitter=A;function F(O,_,j=Y=>Y){const Y=(...ne)=>re.fire(j(...ne)),oe=()=>O.addEventListener(_,Y),q=()=>O.removeEventListener(_,Y),re=new w({onFirstListenerAdd:oe,onLastListenerRemove:q});return re.event}c.fromDOMEventEmitter=F;function N(O){return new Promise(_=>C(O)(_))}c.toPromise=N;function J(O,_){return _(void 0),O(j=>_(j))}c.runAndSubscribe=J;function B(O,_){let j=null;function Y(q){j?.dispose(),j=new k.DisposableStore,_(q,j)}Y(void 0);const oe=O(q=>Y(q));return(0,k.toDisposable)(()=>{oe.dispose(),j?.dispose()})}c.runAndSubscribeWithStore=B;class ${constructor(_,j){this.obs=_,this._counter=0,this._hasChanged=!1;const Y={onFirstListenerAdd:()=>{_.addObserver(this)},onLastListenerRemove:()=>{_.removeObserver(this)}};j||a(Y),this.emitter=new w(Y),j&&j.add(this.emitter)}beginUpdate(_){this._counter++}handleChange(_,j){this._hasChanged=!0}endUpdate(_){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,_){return new $(O,_).emitter.event}c.fromObservable=L})(m=e.Event||(e.Event={}));class I{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${I._idPool++}`,I.all.add(this)}start(a){this._stopWatch=new D.StopWatch(!0),this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=I,I.all=new Set,I._idPool=0;let y=-1;function E(c){const a=y;return y=c,{dispose(){y=a}}}e.setGlobalLeakWarningThreshold=E;class h{constructor(a,C=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=C,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,C){let M=y;if(typeof this.customThreshold=="number"&&(M=this.customThreshold),M<=0||C<M)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let U,Q=0;for(const[ae,X]of this._stacks)(!U||Q<X)&&(U=ae,Q=X);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${Q}):`),console.warn(U)}return()=>{const U=this._stacks.get(a.value)||0;this._stacks.set(a.value,U-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class P{constructor(a,C,M){this.callback=a,this.callbackThis=C,this.stack=M,this.subscription=new k.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class w{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=y>0?new h(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(b){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const C of a)C.subscription.isset()&&(C.subscription.unset(),C.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,C,M)=>{this._listeners||(this._listeners=new R.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let U,Q;this._leakageMon&&this._listeners.size>=30&&(Q=d.create(),U=this._leakageMon.check(Q,this._listeners.size+1)),b&&(Q=Q??d.create());const ae=new P(a,C,Q),X=this._listeners.push(ae);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,C);const G=ae.subscription.set(()=>{U?.(),this._disposed||(X(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return M instanceof k.DisposableStore?M.add(G):Array.isArray(M)&&M.push(G),G}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S);for(const C of this._listeners)this._deliveryQueue.push(this,C,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=w;class p{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(a,C,M){this._queue.push(new f(a,C,M))}clear(a){const C=new R.LinkedList;for(const M of this._queue)M.emitter!==a&&C.push(M);this._queue=C}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(C){(0,v.onUnexpectedError)(C)}}}}e.EventDeliveryQueue=p;class S extends p{clear(a){this._queue.clear()}}class f{constructor(a,C,M){this.emitter=a,this.listener=C,this.event=M}}class g extends w{async fireAsync(a,C,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,a]);for(;this._asyncDeliveryQueue.size>0&&!C.isCancellationRequested;){const[T,U]=this._asyncDeliveryQueue.shift(),Q=[],ae={...U,token:C,waitUntil:X=>{if(Object.isFrozen(Q))throw new Error("waitUntil can NOT be called asynchronous");M&&(X=M(X,T.callback)),Q.push(X)}};try{T.invoke(ae)}catch(X){(0,v.onUnexpectedError)(X);continue}Object.freeze(Q),await Promise.allSettled(Q).then(X=>{for(const G of X)G.status==="rejected"&&(0,v.onUnexpectedError)(G.reason)})}}}}e.AsyncEmitter=g;class l extends w{constructor(a){super(a),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=l;class r extends l{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=r;class o extends w{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){!this.hasListeners()||(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(C=>super.fire(C)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const C={event:a,listener:null};this.events.push(C),this.hasListeners&&this.hook(C);const M=()=>{this.hasListeners&&this.unhook(C);const T=this.events.indexOf(C);this.events.splice(T,1)};return(0,k.toDisposable)((0,t.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(C=>this.emitter.fire(C))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.buffers=[]}wrapEvent(a){return(C,M,T)=>a(U=>{const Q=this.buffers[this.buffers.length-1];Q?Q.push(()=>C.call(M,U)):C.call(M,U)},void 0,T)}bufferEvents(a){const C=[];this.buffers.push(C);const M=a();return this.buffers.pop(),C.forEach(T=>T()),M}}e.EventBufferer=n;class s{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=k.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(te[23],ie([0,1,3]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(b,u){const m=setTimeout(b.bind(u),0);return{dispose(){clearTimeout(m)}}});var k;(function(b){function u(m){return m===b.None||m===b.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}b.isCancellationToken=u,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=D}),define(te[138],ie([0,1,23]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(b){this.task=b,this.result=null}get(){if(this.result)return this.result;const b=new v.CancellationTokenSource,u=this.task(b.token);return this.result={promise:u,dispose:()=>{this.result=null,b.cancel(),b.dispose()}},this.result}}e.Cache=t;class k{constructor(b){this.fn=b,this.lastCache=void 0,this.lastArgKey=void 0}get(b){const u=JSON.stringify(b);return this.lastArgKey!==u&&(this.lastArgKey=u,this.lastCache=this.fn(b)),this.lastCache}}e.LRUCachedFunction=k;class R{get cachedValues(){return this._map}constructor(b){this.fn=b,this._map=new Map}get(b){if(this._map.has(b))return this._map.get(b);const u=this.fn(b);return this._map.set(b,u),u}}e.CachedFunction=R}),define(te[96],ie([0,1,3,2]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=D=>({onDidChange:v.Event.None,value:D});e.staticObservableValue=k;class R extends t.Disposable{get value(){return this._value}set value(b){b!==this._value&&(this._value=b,this.changeEmitter.fire(b))}constructor(b){super(),this._value=b,this.changeEmitter=this._register(new v.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=R}),define(te[26],ie([0,1,138,125]),function(z,e,v,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function b(K,...ue){return ue.length===0?K:K.replace(D,function(de,pe){const ye=parseInt(pe,10);return isNaN(ye)||ye<0||ye>=ue.length?de:ue[ye]})}e.format=b;const u=/{([^}]+)}/g;function m(K,ue){return K.replace(u,(de,pe)=>ue[pe]??de)}e.format2=m;function I(K){return K.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=I;function y(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function E(K,ue){let de=0;const pe=ue.charCodeAt(0);for(let ye=K.length-1;ye>=0;ye--)K.charCodeAt(ye)===pe&&de++;return de}e.count=E;function h(K,ue,de="\u2026"){return K.length<=ue?K:`${K.substr(0,ue)}${de}`}e.truncate=h;function d(K,ue=" "){const de=P(K,ue);return w(de,ue)}e.trim=d;function P(K,ue){if(!K||!ue)return K;const de=ue.length;if(de===0||K.length===0)return K;let pe=0;for(;K.indexOf(ue,pe)===pe;)pe=pe+de;return K.substring(pe)}e.ltrim=P;function w(K,ue){if(!K||!ue)return K;const de=ue.length,pe=K.length;if(de===0||pe===0)return K;let ye=pe,Re=-1;for(;Re=K.lastIndexOf(ue,ye-1),!(Re===-1||Re+de!==ye);){if(Re===0)return"";ye=Re}return K.substring(0,ye)}e.rtrim=w;function p(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function S(K){return K.replace(/\*/g,"")}e.stripWildcards=S;function f(K,ue,de={}){if(!K)throw new Error("Cannot create regex from empty string");ue||(K=y(K)),de.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let pe="";return de.global&&(pe+="g"),de.matchCase||(pe+="i"),de.multiline&&(pe+="m"),de.unicode&&(pe+="u"),new RegExp(K,pe)}e.createRegExp=f;function g(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function l(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function r(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=r;function o(K){return K.split(/\r\n|\r|\n/)}e.splitLines=o;function i(K){for(let ue=0,de=K.length;ue<de;ue++){const pe=K.charCodeAt(ue);if(pe!==32&&pe!==9)return ue}return-1}e.firstNonWhitespaceIndex=i;function n(K,ue=0,de=K.length){for(let pe=ue;pe<de;pe++){const ye=K.charCodeAt(pe);if(ye!==32&&ye!==9)return K.substring(ue,pe)}return K.substring(ue,de)}e.getLeadingWhitespace=n;function s(K,ue=K.length-1){for(let de=ue;de>=0;de--){const pe=K.charCodeAt(de);if(pe!==32&&pe!==9)return de}return-1}e.lastNonWhitespaceIndex=s;function c(K,ue,de){const pe=[];let ye=0;for(const Re of K.matchAll(ue)){if(pe.push(K.slice(ye,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ye=Re.index+Re[0].length,pe.push(de(Re[0],...Re.slice(1),Re.index,K,Re.groups))}return pe.push(K.slice(ye)),Promise.all(pe).then(Re=>Re.join(""))}e.replaceAsync=c;function a(K,ue){return K<ue?-1:K>ue?1:0}e.compare=a;function C(K,ue,de=0,pe=K.length,ye=0,Re=ue.length){for(;de<pe&&ye<Re;de++,ye++){const xe=K.charCodeAt(de),je=ue.charCodeAt(ye);if(xe<je)return-1;if(xe>je)return 1}const _e=pe-de,it=Re-ye;return _e<it?-1:_e>it?1:0}e.compareSubstring=C;function M(K,ue){return T(K,ue,0,K.length,0,ue.length)}e.compareIgnoreCase=M;function T(K,ue,de=0,pe=K.length,ye=0,Re=ue.length){for(;de<pe&&ye<Re;de++,ye++){let xe=K.charCodeAt(de),je=ue.charCodeAt(ye);if(xe===je)continue;if(xe>=128||je>=128)return C(K.toLowerCase(),ue.toLowerCase(),de,pe,ye,Re);Q(xe)&&(xe-=32),Q(je)&&(je-=32);const et=xe-je;if(et!==0)return et}const _e=pe-de,it=Re-ye;return _e<it?-1:_e>it?1:0}e.compareSubstringIgnoreCase=T;function U(K){return K>=48&&K<=57}e.isAsciiDigit=U;function Q(K){return K>=97&&K<=122}e.isLowerAsciiLetter=Q;function ae(K){return K>=65&&K<=90}e.isUpperAsciiLetter=ae;function X(K,ue){return K.length===ue.length&&T(K,ue)===0}e.equalsIgnoreCase=X;function G(K,ue){const de=ue.length;return ue.length>K.length?!1:T(K,ue,0,de)===0}e.startsWithIgnoreCase=G;function Z(K,ue){const de=Math.min(K.length,ue.length);let pe;for(pe=0;pe<de;pe++)if(K.charCodeAt(pe)!==ue.charCodeAt(pe))return pe;return de}e.commonPrefixLength=Z;function se(K,ue){const de=Math.min(K.length,ue.length);let pe;const ye=K.length-1,Re=ue.length-1;for(pe=0;pe<de;pe++)if(K.charCodeAt(ye-pe)!==ue.charCodeAt(Re-pe))return pe;return de}e.commonSuffixLength=se;function he(K){return 55296<=K&&K<=56319}e.isHighSurrogate=he;function V(K){return 56320<=K&&K<=57343}e.isLowSurrogate=V;function H(K,ue){return(K-55296<<10)+(ue-56320)+65536}e.computeCodePoint=H;function W(K,ue,de){const pe=K.charCodeAt(de);if(he(pe)&&de+1<ue){const ye=K.charCodeAt(de+1);if(V(ye))return H(pe,ye)}return pe}e.getNextCodePoint=W;function A(K,ue){const de=K.charCodeAt(ue-1);if(V(de)&&ue>1){const pe=K.charCodeAt(ue-2);if(he(pe))return H(pe,de)}return de}class F{get offset(){return this._offset}constructor(ue,de=0){this._str=ue,this._len=ue.length,this._offset=de}setOffset(ue){this._offset=ue}prevCodePoint(){const ue=A(this._str,this._offset);return this._offset-=ue>=65536?2:1,ue}nextCodePoint(){const ue=W(this._str,this._len,this._offset);return this._offset+=ue>=65536?2:1,ue}eol(){return this._offset>=this._len}}e.CodePointIterator=F;class N{get offset(){return this._iterator.offset}constructor(ue,de=0){this._iterator=new F(ue,de)}nextGraphemeLength(){const ue=Te.getInstance(),de=this._iterator,pe=de.offset;let ye=ue.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const Re=de.offset,_e=ue.getGraphemeBreakType(de.nextCodePoint());if(Se(ye,_e)){de.setOffset(Re);break}ye=_e}return de.offset-pe}prevGraphemeLength(){const ue=Te.getInstance(),de=this._iterator,pe=de.offset;let ye=ue.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const Re=de.offset,_e=ue.getGraphemeBreakType(de.prevCodePoint());if(Se(_e,ye)){de.setOffset(Re);break}ye=_e}return pe-de.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=N;function J(K,ue){return new N(K,ue).nextGraphemeLength()}e.nextCharLength=J;function B(K,ue){return new N(K,ue).prevGraphemeLength()}e.prevCharLength=B;function $(K,ue){ue>0&&V(K.charCodeAt(ue))&&ue--;const de=ue+J(K,ue);return[de-B(K,de),de]}e.getCharContainingOffset=$;function L(K){const ue=new N(K);let de=0;for(;!ue.eol();)de++,ue.nextGraphemeLength();return de}e.charCount=L;let O;function _(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(K){return O||(O=_()),O.test(K)}e.containsRTL=j;const Y=/^[\t\n\r\x20-\x7E]*$/;function oe(K){return Y.test(K)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=q;function re(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=re;function ne(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=ne;function ce(K,ue){if(K.length<ue)return K;const de=/\b/g;let pe=0;for(;de.test(K)&&!(K.length-de.lastIndex<ue);)pe=de.lastIndex,de.lastIndex+=1;return K.substring(pe).replace(/^\s/,"")}e.lcut=ce;const ge=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Ae=/\x1b\[0?m/g;function ke(K){return K&&(K=K.replace(ge,""),K=K.replace(De,""),K=K.replace(Ae,"")),K}e.removeAnsiEscapeCodes=ke,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function qe(K){return Le(K)?K.substr(1):K}e.stripUTF8BOM=qe;function me(K,ue){if(!K||!ue||K.length<ue.length)return!1;const de=ue.length,pe=K.toLowerCase();let ye=0,Re=-1;for(;ye<de;){const _e=pe.indexOf(ue[ye],Re+1);if(_e<0)return!1;Re=_e,ye++}return!0}e.fuzzyContains=me;function we(K,ue=!1){return K?(ue&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=we;function Ee(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ee;function x(K,ue=1){if(ue===0)return"";let de=-1;do de=K.indexOf(`
`,de+1),ue--;while(ue>0&&de>=0);return de===-1?K:(K[de-1]==="\r"&&de--,K.substr(0,de))}e.getNLines=x;function le(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}e.singleLetterHash=le;function fe(K){return Te.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=fe;function Se(K,ue){return K===0?ue!==5&&ue!==7:K===2&&ue===3?!1:K===4||K===2||K===3||ue===4||ue===2||ue===3?!0:!(K===8&&(ue===8||ue===9||ue===11||ue===12)||(K===11||K===9)&&(ue===9||ue===10)||(K===12||K===10)&&ue===10||ue===5||ue===13||ue===7||K===1||K===13&&ue===14||K===6&&ue===6)}var Ie;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Te{static getInstance(){return Te._INSTANCE||(Te._INSTANCE=new Te),Te._INSTANCE}constructor(){this._data=Oe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const de=this._data,pe=de.length/3;let ye=1;for(;ye<=pe;)if(ue<de[3*ye])ye=2*ye;else if(ue>de[3*ye+1])ye=2*ye+1;else return de[3*ye+2];return 0}}Te._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(K,ue){if(K===0)return 0;const de=Be(K,ue);if(de!==void 0)return de;const pe=new F(ue,K);return pe.prevCodePoint(),pe.offset}e.getLeftDeleteOffset=Ne;function Be(K,ue){const de=new F(ue,K);let pe=de.prevCodePoint();for(;ze(pe)||pe===65039||pe===8419;){if(de.offset===0)return;pe=de.prevCodePoint()}if(!ne(pe))return;let ye=de.offset;return ye>0&&de.prevCodePoint()===8205&&(ye=de.offset),ye}function ze(K){return 127995<=K&&K<=127999}var Ke;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ke||(Ke={})),e.noBreakWhitespace="\xA0";class Ue{static getInstance(ue){return Ue.cache.get(Array.from(ue))}static getLocales(){return Ue._locales.getValue()}constructor(ue){this.confusableDictionary=ue}isAmbiguous(ue){return this.confusableDictionary.has(ue)}getPrimaryConfusable(ue){return this.confusableDictionary.get(ue)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ue,k=Ue,Ue.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ue.cache=new v.LRUCachedFunction(K=>{function ue(je){const et=new Map;for(let nt=0;nt<je.length;nt+=2)et.set(je[nt],je[nt+1]);return et}function de(je,et){const nt=new Map(je);for(const[lt,gt]of et)nt.set(lt,gt);return nt}function pe(je,et){if(!je)return et;const nt=new Map;for(const[lt,gt]of je)et.has(lt)&&nt.set(lt,gt);return nt}const ye=k.ambiguousCharacterData.getValue();let Re=K.filter(je=>!je.startsWith("_")&&je in ye);Re.length===0&&(Re=["_default"]);let _e;for(const je of Re){const et=ue(ye[je]);_e=pe(_e,et)}const it=ue(ye._common),xe=de(it,_e);return new Ue(xe)}),Ue._locales=new t.Lazy(()=>Object.keys(Ue.ambiguousCharacterData.getValue()).filter(K=>!K.startsWith("_")));class Ge{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ge.getRawData())),this._data}static isInvisibleCharacter(ue){return Ge.getData().has(ue)}static get codePoints(){return Ge.getData()}}e.InvisibleCharacters=Ge,Ge._data=void 0}),define(te[30],ie([0,1,9,4,26,12]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(s){return s===47||s===92}e.isPathSeparator=D;function b(s){return s.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=b;function u(s){return s.indexOf("/")===-1&&(s=b(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=u;function m(s,c=v.posix.sep){if(!s)return"";const a=s.length,C=s.charCodeAt(0);if(D(C)){if(D(s.charCodeAt(1))&&!D(s.charCodeAt(2))){let T=3;const U=T;for(;T<a&&!D(s.charCodeAt(T));T++);if(U!==T&&!D(s.charCodeAt(T+1))){for(T+=1;T<a;T++)if(D(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,c)}}return c}else if(p(C)&&s.charCodeAt(1)===58)return D(s.charCodeAt(2))?s.slice(0,2)+c:s.slice(0,2);let M=s.indexOf("://");if(M!==-1){for(M+=3;M<a;M++)if(D(s.charCodeAt(M)))return s.slice(0,M+1)}return""}e.getRoot=m;function I(s){if(!t.isWindows||!s||s.length<5)return!1;let c=s.charCodeAt(0);if(c!==92||(c=s.charCodeAt(1),c!==92))return!1;let a=2;const C=a;for(;a<s.length&&(c=s.charCodeAt(a),c!==92);a++);return!(C===a||(c=s.charCodeAt(a+1),isNaN(c)||c===92))}e.isUNC=I;const y=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,c=t.isWindows){const a=c?y:E;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||c&&h.test(s)||s==="."||s===".."||c&&s[s.length-1]==="."||c&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function P(s,c,a){const C=s===c;return!a||C?C:!s||!c?!1:(0,k.equalsIgnoreCase)(s,c)}e.isEqual=P;function w(s,c,a,C=v.sep){if(s===c)return!0;if(!s||!c||c.length>s.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(s,c))return!1;if(c.length===s.length)return!0;let T=c.length;return c.charAt(c.length-1)===C&&T--,s.charAt(T)===C}return c.charAt(c.length-1)!==C&&(c+=C),s.indexOf(c)===0}e.isEqualOrParent=w;function p(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=p;function S(s,c){return t.isWindows&&s.endsWith(":")&&(s+=v.sep),(0,v.isAbsolute)(s)||(s=(0,v.join)(c,s)),s=(0,v.normalize)(s),t.isWindows?(s=(0,k.rtrim)(s,v.sep),s.endsWith(":")&&(s+=v.sep)):(s=(0,k.rtrim)(s,v.sep),s||(s=v.sep)),s}e.sanitizeFilePath=S;function f(s){const c=(0,v.normalize)(s);return t.isWindows?s.length>3?!1:g(c)&&(s.length===2||c.charCodeAt(2)===92):c===v.posix.sep}e.isRootOrDriveLetter=f;function g(s,c=t.isWindows){return c?p(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function l(s){return g(s)?s[0]:void 0}e.getDriveLetter=l;function r(s,c,a){return c.length>s.length?-1:s===c?0:(a&&(s=s.toLowerCase(),c=c.toLowerCase()),s.indexOf(c))}e.indexOfPath=r;function o(s){const c=s.split(":");let a,C,M;for(const T of c){const U=Number(T);(0,R.isNumber)(U)?C===void 0?C=U:M===void 0&&(M=U):a=a?[a,T].join(":"):T}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:C!==void 0?C:void 0,column:M!==void 0?M:C!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,c,a=8){let C="";for(let T=0;T<a;T++)C+=i.charAt(Math.floor(Math.random()*i.length));let M;return c?M=`${c}-${C}`:M=C,s?(0,v.join)(s,M):M}e.randomPath=n}),define(te[66],ie([0,1,26]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(p){return k(p,0)}e.hash=t;function k(p,S){switch(typeof p){case"object":return p===null?R(349,S):Array.isArray(p)?u(p,S):m(p,S);case"string":return b(p,S);case"boolean":return D(p,S);case"number":return R(p,S);case"undefined":return R(937,S);default:return R(617,S)}}e.doHash=k;function R(p,S){return(S<<5)-S+p|0}e.numberHash=R;function D(p,S){return R(p?433:863,S)}function b(p,S){S=R(149417,S);for(let f=0,g=p.length;f<g;f++)S=R(p.charCodeAt(f),S);return S}e.stringHash=b;function u(p,S){return S=R(104579,S),p.reduce((f,g)=>k(g,f),S)}function m(p,S){return S=R(181387,S),Object.keys(p).sort().reduce((f,g)=>(f=b(g,f),k(p[g],f)),S)}class I{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=k(S,this._value),this._value}}e.Hasher=I;var y;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function E(p,S,f=32){const g=f-S,l=~((1<<g)-1);return(p<<S|(l&p)>>>g)>>>0}function h(p,S=0,f=p.byteLength,g=0){for(let l=0;l<f;l++)p[S+l]=g}function d(p,S,f="0"){for(;p.length<S;)p=f+p;return p}function P(p,S=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(f=>f.toString(16).padStart(2,"0")).join(""):d((p>>>0).toString(16),S/4)}e.toHexString=P;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const f=S.length;if(f===0)return;const g=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,o,i;for(r!==0?(o=r,i=-1,r=0):(o=S.charCodeAt(0),i=0);;){let n=o;if(v.isHighSurrogate(o))if(i+1<f){const s=S.charCodeAt(i+1);v.isLowSurrogate(s)?(i++,n=v.computeCodePoint(o,s)):n=65533}else{r=o;break}else v.isLowSurrogate(o)&&(n=65533);if(l=this._push(g,l,n),i++,i<f)o=S.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(S,f,g){return g<128?S[f++]=g:g<2048?(S[f++]=192|(g&1984)>>>6,S[f++]=128|(g&63)>>>0):g<65536?(S[f++]=224|(g&61440)>>>12,S[f++]=128|(g&4032)>>>6,S[f++]=128|(g&63)>>>0):(S[f++]=240|(g&1835008)>>>18,S[f++]=128|(g&258048)>>>12,S[f++]=128|(g&4032)>>>6,S[f++]=128|(g&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),P(this._h0)+P(this._h1)+P(this._h2)+P(this._h3)+P(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=w._bigBlock32,f=this._buffDV;for(let a=0;a<64;a+=4)S.setUint32(a,f.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)S.setUint32(a,E(S.getUint32(a-12,!1)^S.getUint32(a-32,!1)^S.getUint32(a-56,!1)^S.getUint32(a-64,!1),1),!1);let g=this._h0,l=this._h1,r=this._h2,o=this._h3,i=this._h4,n,s,c;for(let a=0;a<80;a++)a<20?(n=l&r|~l&o,s=1518500249):a<40?(n=l^r^o,s=1859775393):a<60?(n=l&r|l&o|r&o,s=2400959708):(n=l^r^o,s=3395469782),c=E(g,5)+n+i+s+S.getUint32(a*4,!1)&4294967295,i=o,o=r,r=E(l,30),l=g,g=c;this._h0=this._h0+g&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(te[31],ie([0,1,24,26]),function(z,e,v,t){"use strict";var k,R,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(i,n,s){let c=i.get(n);return c===void 0&&(c=s,i.set(n,c)),c}e.getOrSet=b;function u(i){const n=[];return i.forEach((s,c)=>{n.push(`${c} => ${s}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=u;function m(i){const n=[];return i.forEach(s=>{n.push(s)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=m;class I{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),c=this._value.charCodeAt(this._pos);return s-c}value(){return this._value[this._pos]}}e.StringIterator=I;class y{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class E{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let s=n.length-1;s>=0;s--,this._valueLen--){const c=this._value.charCodeAt(s);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var h;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(h||(h={}));class d{constructor(n,s){this._ignorePathCasing=n,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class P{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(w||(w={}));class p{static forUris(n=()=>!1,s=()=>!1){return new p(new d(n,s))}static forPaths(n=!1){return new p(new E(void 0,!n))}static forStrings(){return new p(new I)}static forConfigKeys(){return new p(new y)}constructor(n){this._iter=n}clear(){this._root=void 0}fill(n,s){if(s){const c=s.slice(0);(0,v.shuffle)(c);for(const a of c)this.set(a,n)}else{const c=n.slice(0);(0,v.shuffle)(c);for(const a of c)this.set(a[0],a[1])}}set(n,s){const c=this._iter.reset(n);let a;this._root||(this._root=new P,this._root.segment=c.value());const C=[];for(a=this._root;;){const T=c.cmp(a.segment);if(T>0)a.left||(a.left=new P,a.left.segment=c.value()),C.push([-1,a]),a=a.left;else if(T<0)a.right||(a.right=new P,a.right.segment=c.value()),C.push([1,a]),a=a.right;else if(c.hasNext())c.next(),a.mid||(a.mid=new P,a.mid.segment=c.value()),C.push([0,a]),a=a.mid;else break}const M=a.value;a.value=s,a.key=n;for(let T=C.length-1;T>=0;T--){const U=C[T][1];U.updateHeight();const Q=U.balanceFactor();if(Q<-1||Q>1){const ae=C[T][0],X=C[T+1][0];if(ae===1&&X===1)C[T][1]=U.rotateLeft();else if(ae===-1&&X===-1)C[T][1]=U.rotateRight();else if(ae===1&&X===-1)U.right=C[T+1][1]=C[T+1][1].rotateRight(),C[T][1]=U.rotateLeft();else if(ae===-1&&X===1)U.left=C[T+1][1]=C[T+1][1].rotateLeft(),C[T][1]=U.rotateRight();else throw new Error;if(T>0)switch(C[T-1][0]){case-1:C[T-1][1].left=C[T][1];break;case 1:C[T-1][1].right=C[T][1];break;case 0:C[T-1][1].mid=C[T][1];break}else this._root=C[0][1]}}return M}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let c=this._root;for(;c;){const a=s.cmp(c.segment);if(a>0)c=c.left;else if(a<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else break}return c}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const c=this._iter.reset(n),a=[];let C=this._root;for(;C;){const M=c.cmp(C.segment);if(M>0)a.push([-1,C]),C=C.left;else if(M<0)a.push([1,C]),C=C.right;else if(c.hasNext())c.next(),a.push([0,C]),C=C.mid;else break}if(!!C){if(s?(C.left=void 0,C.mid=void 0,C.right=void 0,C.height=1):(C.key=void 0,C.value=void 0),!C.mid&&!C.value)if(C.left&&C.right){const M=this._min(C.right);if(M.key){const{key:T,value:U,segment:Q}=M;this._delete(M.key,!1),C.key=T,C.value=U,C.segment=Q}}else{const M=C.left??C.right;if(a.length>0){const[T,U]=a[a.length-1];switch(T){case-1:U.left=M;break;case 0:U.mid=M;break;case 1:U.right=M;break}}else this._root=M}for(let M=a.length-1;M>=0;M--){const T=a[M][1];T.updateHeight();const U=T.balanceFactor();if(U>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),a[M][1]=T.rotateLeft()):U<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),a[M][1]=T.rotateRight()),M>0)switch(a[M-1][0]){case-1:a[M-1][1].left=a[M][1];break;case 1:a[M-1][1].right=a[M][1];break;case 0:a[M-1][1].mid=a[M][1];break}else this._root=a[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const s=this._iter.reset(n);let c=this._root,a;for(;c;){const C=s.cmp(c.segment);if(C>0)c=c.left;else if(C<0)c=c.right;else if(s.hasNext())s.next(),a=c.value||a,c=c.mid;else break}return c&&c.value||a}findSuperstr(n){const s=this._iter.reset(n);let c=this._root;for(;c;){const a=s.cmp(c.segment);if(a>0)c=c.left;else if(a<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(n){for(const[s,c]of this)n(c,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const s=[];return this._dfsEntries(n,s),s[Symbol.iterator]()}_dfsEntries(n,s){!n||(n.left&&this._dfsEntries(n.left,s),n.value&&s.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,s),n.right&&this._dfsEntries(n.right,s))}_isBalanced(){const n=s=>{if(!s)return!0;const c=s.balanceFactor();return c<-1||c>1?!1:n(s.left)&&n(s.right)};return n(this._root)}}e.TernarySearchTree=p;class S{constructor(n,s){this.uri=n,this.value=s}}class f{constructor(n,s){this[k]="ResourceMap",n instanceof f?(this.map=new Map(n.map),this.toKey=s??f.defaultToKey):(this.map=new Map,this.toKey=n??f.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),new S(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[c,a]of this.map)n(a.value,a.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=f,f.defaultToKey=i=>i.toString();class g{constructor(n,s){this[R]="ResourceSet",!n||typeof n=="function"?this._map=new f(n):(this._map=new f(s),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,s){this._map.forEach((c,a)=>n.call(s,a,a,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=g;var l;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class r{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const c=this._map.get(n);if(!!c)return s!==0&&this.touch(c,s),c.value}set(n,s,c=0){let a=this._map.get(n);if(a)a.value=s,c!==0&&this.touch(a,c);else{switch(a={key:n,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(n,a),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const c=this._state;let a=this._head;for(;a;){if(s?n.bind(s)(a.value,a.key,this):n(a.value,a.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const n=this,s=this._state;let c=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const C={value:c.key,done:!1};return c=c.next,C}else return{value:void 0,done:!0}}};return a}values(){const n=this,s=this._state;let c=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const C={value:c.value,done:!1};return c=c.next,C}else return{value:void 0,done:!0}}};return a}entries(){const n=this,s=this._state;let c=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const C={value:[c.key,c.value],done:!1};return c=c.next,C}else return{value:void 0,done:!0}}};return a}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>n;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,c=n.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const c=n.next,a=n.previous;n===this._tail?(a.next=void 0,this._tail=a):(c.previous=a,a.next=c),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const c=n.next,a=n.previous;n===this._head?(c.previous=void 0,this._head=c):(c.previous=a,a.next=c),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,c)=>{n.push([c,s])}),n}fromJSON(n){this.clear();for(const[s,c]of n)this.set(s,c)}}e.LinkedMap=r;class o extends r{constructor(n,s=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(te[80],ie([0,1,31]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new v.LRUCache(1e4);function k(m){return u(m,"NFC",t)}e.normalizeNFC=k;const R=new v.LRUCache(1e4);function D(m){return u(m,"NFD",R)}e.normalizeNFD=D;const b=/[^\u0000-\u0080]/;function u(m,I,y){if(!m)return m;const E=y.get(m);if(E)return E;let h;return b.test(m)?h=m.normalize(I):h=m,y.set(m,h),h}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(I){return D(I).replace(m,"")}}()}),define(te[97],ie([0,1,26]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",D="warning",b="warn",u="info",m="ignore";function I(E){return E?v.equalsIgnoreCase(R,E)?k.Error:v.equalsIgnoreCase(D,E)||v.equalsIgnoreCase(b,E)?k.Warning:v.equalsIgnoreCase(u,E)?k.Info:k.Ignore:k.Ignore}k.fromValue=I;function y(E){switch(E){case k.Error:return R;case k.Warning:return D;case k.Info:return u;default:return m}}k.toString=y}(t||(t={})),e.default=t}),define(te[7],ie([0,1,9,4]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function b(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(i,n){return!i&&!n?"file":i}function m(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==y&&(n=y+n):n=y;break}return n}const I="",y="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(n){return n instanceof h?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,s,c,a,C,M=!1){typeof n=="object"?(this.scheme=n.scheme||I,this.authority=n.authority||I,this.path=n.path||I,this.query=n.query||I,this.fragment=n.fragment||I):(this.scheme=u(n,M),this.authority=s||I,this.path=m(this.scheme,c||I),this.query=a||I,this.fragment=C||I,b(this,M))}get fsPath(){return f(this,!1)}with(n){if(!n)return this;let{scheme:s,authority:c,path:a,query:C,fragment:M}=n;return s===void 0?s=this.scheme:s===null&&(s=I),c===void 0?c=this.authority:c===null&&(c=I),a===void 0?a=this.path:a===null&&(a=I),C===void 0?C=this.query:C===null&&(C=I),M===void 0?M=this.fragment:M===null&&(M=I),s===this.scheme&&c===this.authority&&a===this.path&&C===this.query&&M===this.fragment?this:new P(s,c,a,C,M)}static parse(n,s=!1){const c=E.exec(n);return c?new P(c[2]||I,o(c[4]||I),o(c[5]||I),o(c[7]||I),o(c[9]||I),s):new P(I,I,I,I,I)}static file(n){let s=I;if(t.isWindows&&(n=n.replace(/\\/g,y)),n[0]===y&&n[1]===y){const c=n.indexOf(y,2);c===-1?(s=n.substring(2),n=y):(s=n.substring(2,c),n=n.substring(c)||y)}return new P("file",s,n,I,I)}static from(n){const s=new P(n.scheme,n.authority,n.path,n.query,n.fragment);return b(s,!0),s}static joinPath(n,...s){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&n.scheme==="file"?c=h.file(v.win32.join(f(n,!0),...s)).path:c=v.posix.join(n.path,...s),n.with({path:c})}toString(n=!1){return g(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof h)return n;{const s=new P(n);return s._formatted=n.external,s._fsPath=n._sep===d?n.fsPath:null,s}}else return n}}e.URI=h;const d=t.isWindows?1:void 0;class P extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(n=!1){return n?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=d),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(i,n){let s,c=-1;for(let a=0;a<i.length;a++){const C=i.charCodeAt(a);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||n&&C===47)c!==-1&&(s+=encodeURIComponent(i.substring(c,a)),c=-1),s!==void 0&&(s+=i.charAt(a));else{s===void 0&&(s=i.substr(0,a));const M=w[C];M!==void 0?(c!==-1&&(s+=encodeURIComponent(i.substring(c,a)),c=-1),s+=M):c===-1&&(c=a)}}return c!==-1&&(s+=encodeURIComponent(i.substring(c))),s!==void 0?s:i}function S(i){let n;for(let s=0;s<i.length;s++){const c=i.charCodeAt(s);c===35||c===63?(n===void 0&&(n=i.substr(0,s)),n+=w[c]):n!==void 0&&(n+=i[s])}return n!==void 0?n:i}function f(i,n){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=f;function g(i,n){const s=n?S:p;let c="",{scheme:a,authority:C,path:M,query:T,fragment:U}=i;if(a&&(c+=a,c+=":"),(C||a==="file")&&(c+=y,c+=y),C){let Q=C.indexOf("@");if(Q!==-1){const ae=C.substr(0,Q);C=C.substr(Q+1),Q=ae.indexOf(":"),Q===-1?c+=s(ae,!1):(c+=s(ae.substr(0,Q),!1),c+=":",c+=s(ae.substr(Q+1),!1)),c+="@"}C=C.toLowerCase(),Q=C.indexOf(":"),Q===-1?c+=s(C,!1):(c+=s(C.substr(0,Q),!1),c+=C.substr(Q))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const Q=M.charCodeAt(1);Q>=65&&Q<=90&&(M=`/${String.fromCharCode(Q+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const Q=M.charCodeAt(0);Q>=65&&Q<=90&&(M=`${String.fromCharCode(Q+32)}:${M.substr(2)}`)}c+=s(M,!0)}return T&&(c+="?",c+=s(T,!1)),U&&(c+="#",c+=n?U:p(U,!1)),c}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(i){return i.match(r)?i.replace(r,n=>l(n)):i}}),define(te[139],ie([0,1,7]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(m){const I=m;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=t;function k(m){const I=[];let y;try{const E=JSON.parse(m.arguments),h=E[E.length-1];h&&h.__$stack&&(E.pop(),y=h.__$stack),I.push(...E)}catch{I.push("Unable to log remote console arguments",m.arguments)}return{args:I,stack:y}}e.parse=k;function R(m){if(typeof m!="string")return R(k(m).stack);const I=m;if(I){const y=D(I),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(E&&E.length===4)return{uri:v.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=R;function D(m){if(!m)return m;const I=m.indexOf(`
`);return I===-1?m:m.substring(0,I)}function b(m,I){const{args:y,stack:E}=k(m),h=typeof y[0]=="string"&&y.length===1;let d=D(E);d&&(d=`(${d.trim()})`);let P=[];if(typeof y[0]=="string"?d&&h?P=[`%c[${I}] %c${y[0]} %c${d}`,u("blue"),u(""),u("grey")]:P=[`%c[${I}] %c${y[0]}`,u("blue"),u(""),...y.slice(1)]:P=[`%c[${I}]%`,u("blue"),...y],d&&!h&&P.push(d),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,P)}e.log=b;function u(m){return`color: ${m}`}}),define(te[67],ie([0,1,18,26,7]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(m){return JSON.stringify(m,b)}e.stringify=R;function D(m){let I=JSON.parse(m);return I=u(I),I}e.parse=D;function b(m,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,t.regExpFlags)(I)}:I}function u(m,I=0){if(!m||I>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return k.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 14:return new Date(m.source)}if(m instanceof v.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let y=0;y<m.length;++y)m[y]=u(m[y],I+1);else for(const y in m)Object.hasOwnProperty.call(m,y)&&(m[y]=u(m[y],I+1))}return m}e.revive=u}),define(te[13],ie([0,1,4,7]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebook="vscode-notebook",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractive="vscode-interactive",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}setServerRootPath(m){this._remoteResourcesPath=`${m}/${k.vscodeRemoteResource}`}set(m,I,y){this._hosts[m]=I,this._ports[m]=y}setConnectionToken(m,I){this._connectionTokens[m]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(m){if(this._delegate)return this._delegate(m);const I=m.authority;let y=this._hosts[I];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const E=this._ports[I],h=this._connectionTokens[I];let d=`path=${encodeURIComponent(m.path)}`;return typeof h=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(h)}`),t.URI.from({scheme:v.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${y}:${E}`,path:this._remoteResourcesPath,query:d})}}e.RemoteAuthorities=new R;class D{asBrowserUri(m,I){const y=this.toUri(m,I);return y.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===k.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${k.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?y.with({scheme:k.vscodeFileResource,authority:y.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(m,I){const y=this.toUri(m,I);return y.scheme===k.vscodeFileResource?y.with({scheme:k.file,authority:y.authority!==D.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(m,I){return t.URI.isUri(m)?m:t.URI.parse(I.toUrl(m))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D;var b;(function(u){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(m.get("3"));const I="vscode-coi";function y(h){let d;typeof h=="string"?d=new URL(h).searchParams:h instanceof URL?d=h.searchParams:t.URI.isUri(h)&&(d=new URL(h.toString(!0)).searchParams);const P=d?.get(I);if(!!P)return m.get(P)}u.getHeadersFromQuery=y;function E(h,d,P){if(!globalThis.crossOriginIsolated)return;const w=d&&P?"3":P?"2":"1";h instanceof URLSearchParams?h.set(I,w):h[I]=w}u.addSearchParam=E})(b=e.COI||(e.COI={}))}),define(te[16],ie([0,1,30,13,9,4,26,7]),function(z,e,v,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function u(h){return(0,b.uriToFsPath)(h,!0)}e.originalFSPath=u;class m{constructor(d){this._ignorePathCasing=d}compare(d,P,w=!1){return d===P?0:(0,D.compare)(this.getComparisonKey(d,w),this.getComparisonKey(P,w))}isEqual(d,P,w=!1){return d===P?!0:!d||!P?!1:this.getComparisonKey(d,w)===this.getComparisonKey(P,w)}getComparisonKey(d,P=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:P?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,P,w=!1){if(d.scheme===P.scheme){if(d.scheme===t.Schemas.file)return v.isEqualOrParent(u(d),u(P),this._ignorePathCasing(d))&&d.query===P.query&&(w||d.fragment===P.fragment);if((0,e.isEqualAuthority)(d.authority,P.authority))return v.isEqualOrParent(d.path,P.path,this._ignorePathCasing(d),"/")&&d.query===P.query&&(w||d.fragment===P.fragment)}return!1}joinPath(d,...P){return b.URI.joinPath(d,...P)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let P;return d.scheme===t.Schemas.file?P=b.URI.file(k.dirname(u(d))).path:(P=k.posix.dirname(d.path),d.authority&&P.length&&P.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),P="/")),d.with({path:P})}normalizePath(d){if(!d.path.length)return d;let P;return d.scheme===t.Schemas.file?P=b.URI.file(k.normalize(u(d))).path:P=k.posix.normalize(d.path),d.with({path:P})}relativePath(d,P){if(d.scheme!==P.scheme||!(0,e.isEqualAuthority)(d.authority,P.authority))return;if(d.scheme===t.Schemas.file){const S=k.relative(u(d),u(P));return R.isWindows?v.toSlashes(S):S}let w=d.path||"/";const p=P.path||"/";if(this._ignorePathCasing(d)){let S=0;for(const f=Math.min(w.length,p.length);S<f&&!(w.charCodeAt(S)!==p.charCodeAt(S)&&w.charAt(S).toLowerCase()!==p.charAt(S).toLowerCase());S++);w=p.substr(0,S)+w.substr(S)}return k.posix.relative(w,p)}resolvePath(d,P){if(d.scheme===t.Schemas.file){const w=b.URI.file(k.resolve(u(d),P));return d.with({authority:w.authority,path:w.path})}return P=v.toPosixPath(P),d.with({path:k.posix.resolve(d.path,P)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,P){return d===P||d!==void 0&&P!==void 0&&(0,D.equalsIgnoreCase)(d,P)}hasTrailingPathSeparator(d,P=k.sep){if(d.scheme===t.Schemas.file){const w=u(d);return w.length>v.getRoot(w).length&&w[w.length-1]===P}else{const w=d.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,P=k.sep){return(0,e.hasTrailingPathSeparator)(d,P)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,P=k.sep){let w=!1;if(d.scheme===t.Schemas.file){const p=u(d);w=p!==void 0&&p.length===v.getRoot(p).length&&p[p.length-1]===P}else{P="/";const p=d.path;w=p.length===1&&p.charCodeAt(p.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(d,P)?d.with({path:d.path+"/"}):d}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(h=>h.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new m(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(h,d){const P=[];for(let w=0;w<h.length;w++){const p=d(h[w]);h.some((S,f)=>f===w?!1:(0,e.isEqualOrParent)(p,d(S)))||P.push(h[w])}return P}e.distinctParents=I;var y;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function d(P){const w=new Map;P.path.substring(P.path.indexOf(";")+1,P.path.lastIndexOf(";")).split(";").forEach(f=>{const[g,l]=f.split(":");g&&l&&w.set(g,l)});const S=P.path.substring(0,P.path.indexOf(";"));return S&&w.set(h.META_DATA_MIME,S),w}h.parseMetaData=d})(y=e.DataUri||(e.DataUri={}));function E(h,d,P){if(d){let w=h.path;return w&&w[0]!==k.posix.sep&&(w=k.posix.sep+w),h.with({scheme:P,authority:d,path:w})}return h.with({scheme:P})}e.toLocalResource=E}),define(te[8],ie([0,1,23,17,3,2,16,4]),function(z,e,v,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function u($){return!!$&&typeof $.then=="function"}e.isThenable=u;function m($){const L=new v.CancellationTokenSource,O=$(L.token),_=new Promise((j,Y)=>{const oe=L.token.onCancellationRequested(()=>{oe.dispose(),L.dispose(),Y(new t.CancellationError)});Promise.resolve(O).then(q=>{oe.dispose(),L.dispose(),j(q)},q=>{oe.dispose(),L.dispose(),Y(q)})});return new class{cancel(){L.cancel()}then(j,Y){return _.then(j,Y)}catch(j){return this.then(void 0,j)}finally(j){return _.finally(j)}}}e.createCancelablePromise=m;function I($,L,O){return new Promise((_,j)=>{const Y=L.onCancellationRequested(()=>{Y.dispose(),_(O)});$.then(_,j).finally(()=>Y.dispose())})}e.raceCancellation=I;function y($,L){return new Promise((O,_)=>{const j=L.onCancellationRequested(()=>{j.dispose(),_(new t.CancellationError)});$.then(O,_).finally(()=>j.dispose())})}e.raceCancellationError=y;async function E($){let L=-1;const O=$.map((j,Y)=>j.then(oe=>(L=Y,oe))),_=await Promise.race(O);return $.forEach((j,Y)=>{Y!==L&&j.cancel()}),_}e.raceCancellablePromises=E;function h($,L,O){let _;const j=setTimeout(()=>{_?.(void 0),O?.()},L);return Promise.race([$.finally(()=>clearTimeout(j)),new Promise(Y=>_=Y)])}e.raceTimeout=h;function d($){return new Promise((L,O)=>{const _=$();u(_)?_.then(L,O):L(_)})}e.asPromise=d;class P{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(O,O).then(_)})}return new Promise((O,_)=>{this.queuedPromise.then(O,_)})}return this.activePromise=L(),new Promise((O,_)=>{this.activePromise.then(j=>{this.activePromise=null,O(j)},j=>{this.activePromise=null,_(j)})})}}e.Throttler=P;class w{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=w;class p{constructor(){this.promiseMap=new Map}queue(L,O){const j=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===j&&this.promiseMap.delete(L)});return this.promiseMap.set(L,j),j}}e.SequencerByKey=p;const S=($,L)=>{let O=!0;const _=setTimeout(()=>{O=!1,L()},$);return{isTriggered:()=>O,dispose:()=>{clearTimeout(_),O=!1}}},f=$=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,$())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,Y)=>{this.doResolve=j,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}}));const _=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?f(_):S(O,_),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=g;class l{constructor(L){this.delayer=new g(L),this.throttler=new P}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class r{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class o extends r{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function i($,L){return L?new Promise((O,_)=>{const j=setTimeout(()=>{Y.dispose(),O()},$),Y=L.onCancellationRequested(()=>{clearTimeout(j),Y.dispose(),_(new t.CancellationError)})}):m(O=>i($,O))}e.timeout=i;function n($,L=0){const O=setTimeout($,L);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=n;function s($){const L=[];let O=0;const _=$.length;function j(){return O<_?$[O++]():null}function Y(oe){oe!=null&&L.push(oe);const q=j();return q?q.then(Y):Promise.resolve(L)}return Promise.resolve(null).then(Y)}e.sequence=s;function c($,L=_=>!!_,O=null){let _=0;const j=$.length,Y=()=>{if(_>=j)return Promise.resolve(O);const oe=$[_++];return Promise.resolve(oe()).then(re=>L(re)?Promise.resolve(re):Y())};return Y()}e.first=c;function a($,L=_=>!!_,O=null){if($.length===0)return Promise.resolve(O);let _=$.length;const j=()=>{_=-1;for(const Y of $)Y.cancel?.()};return new Promise((Y,oe)=>{for(const q of $)q.then(re=>{--_>=0&&L(re)?(j(),Y(re)):_===0&&Y(O)}).catch(re=>{--_>=0&&(j(),oe(re))})})}e.firstParallel=a;class C{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,_)=>{this.outstandingPromises.push({factory:L,c:O,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=C;class M extends C{constructor(){super(1)}}e.Queue=M;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new W;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=D.extUri){const _=O.getComparisonKey(L);let j=this.queues.get(_);return j||(j=new M,k.Event.once(j.onDrained)(()=>{j?.dispose(),this.queues.delete(_),this.onDidQueueDrain()}),this.queues.set(_,j)),j}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class U{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=U;class Q{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=Q;class ae{constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=ae;class X{constructor(L,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=X;class G extends ae{constructor(L,O){super(L,O),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=G;class Z extends R.Disposable{constructor(L,O){super(),this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ae(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=$=>{(0,b.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=($,L)=>{const O=requestIdleCallback($,typeof L=="number"?{timeout:L}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(O))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function he($,L,O){let _;for(let j=0;j<O;j++)try{return await $()}catch(Y){_=Y,await i(L)}throw _}e.retry=he;class V{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(L,O,_){return this._pending={taskId:L,cancel:()=>_?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,_;const j=new Promise((Y,oe)=>{O=Y,_=oe});this._next={run:L,promise:j,promiseResolve:O,promiseReject:_}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=V;class H{constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class W{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=W;var A;(function($){async function L(_){let j;const Y=await Promise.all(_.map(oe=>oe.then(q=>q,q=>{j||(j=q)})));if(typeof j<"u")throw j;return Y}$.settled=L;function O(_){return new Promise(async(j,Y)=>{try{await _(j,Y)}catch(oe){Y(oe)}})}$.withAsyncBody=O})(A=e.Promises||(e.Promises={}));var F;(function($){$[$.Initial=0]="Initial",$[$.DoneOK=1]="DoneOK",$[$.DoneError=2]="DoneError"})(F||(F={}));class N{static fromArray(L){return new N(O=>{O.emitMany(L)})}static fromPromise(L){return new N(async O=>{O.emitMany(await L)})}static fromPromises(L){return new N(async O=>{await Promise.all(L.map(async _=>O.emitOne(await _)))})}static merge(L){return new N(async O=>{await Promise.all(L.map(async _=>{for await(const j of _)O.emitOne(j)}))})}constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(L(O)),this.resolve()}catch(_){this.reject(_)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new N(async _=>{for await(const j of L)_.emitOne(O(j))})}map(L){return N.map(this,L)}static filter(L,O){return new N(async _=>{for await(const j of L)O(j)&&_.emitOne(j)})}filter(L){return N.filter(this,L)}static coalesce(L){return N.filter(L,O=>!!O)}coalesce(){return N.coalesce(this)}static async toPromise(L){const O=[];for await(const _ of L)O.push(_);return O}toPromise(){return N.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=N,N.EMPTY=N.fromArray([]);class J extends N{constructor(L,O){super(O),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=J;function B($){const L=new v.CancellationTokenSource,O=$(L.token);return new J(L,async _=>{const j=L.token.onCancellationRequested(()=>{j.dispose(),L.dispose(),_.reject(new t.CancellationError)});try{for await(const Y of O){if(L.token.isCancellationRequested)return;_.emitOne(Y)}j.dispose(),L.dispose()}catch(Y){j.dispose(),L.dispose(),_.reject(Y)}})}e.createCancelableAsyncIterable=B}),define(te[98],ie([0,1,24,8,30,31,9,4,26]),function(z,e,v,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",y="[^/\\\\]",E=/\//g;function h(W,A){switch(W){case 0:return"";case 1:return`${y}*?`;default:return`(?:${I}|${y}+${I}${A?`|${I}${y}+`:""})*?`}}function d(W,A){if(!W)return[];const F=[];let N=!1,J=!1,B="";for(const $ of W){switch($){case A:if(!N&&!J){F.push(B),B="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":J=!0;break;case"]":J=!1;break}B+=$}return B&&F.push(B),F}e.splitGlobAware=d;function P(W){if(!W)return"";let A="";const F=d(W,e.GLOB_SPLIT);if(F.every(N=>N===e.GLOBSTAR))A=".*";else{let N=!1;F.forEach((J,B)=>{if(J===e.GLOBSTAR){if(N)return;A+=h(2,B===F.length-1)}else{let $=!1,L="",O=!1,_="";for(const j of J){if(j!=="}"&&$){L+=j;continue}if(O&&(j!=="]"||!_)){let Y;j==="-"?Y=j:(j==="^"||j==="!")&&!_?Y="^":j===e.GLOB_SPLIT?Y="":Y=(0,u.escapeRegExpCharacters)(j),_+=Y;continue}switch(j){case"{":$=!0;continue;case"[":O=!0;continue;case"}":{A+=`(?:${d(L,",").map(q=>P(q)).join("|")})`,$=!1,L="";break}case"]":{A+="["+_+"]",O=!1,_="";break}case"?":A+=y;continue;case"*":A+=h(1);continue;default:A+=(0,u.escapeRegExpCharacters)(j)}}B<F.length-1&&(F[B+1]!==e.GLOBSTAR||B+2<F.length)&&(A+=I)}N=J===e.GLOBSTAR})}return A}const w=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new R.LRUCache(1e4),o=function(){return!1},i=function(){return null};function n(W,A){if(!W)return i;let F;typeof W!="string"?F=W.pattern:F=W,F=F.trim();const N=`${F}_${!!A.trimForExclusions}`;let J=r.get(N);if(J)return s(J,W);let B;return w.test(F)?J=a(F.substr(4),F):(B=p.exec(c(F,A)))?J=C(B[1],F):(A.trimForExclusions?f:S).test(F)?J=M(F,A):(B=g.exec(c(F,A)))?J=T(B[1].substr(1),F,!0):(B=l.exec(c(F,A)))?J=T(B[1],F,!1):J=U(F),r.set(N,J),s(J,W)}function s(W,A){if(typeof A=="string")return W;const F=function(N,J){return(0,k.isEqualOrParent)(N,A.base,!b.isLinux)?W(N.substr(A.base.length+1),J):null};return F.allBasenames=W.allBasenames,F.allPaths=W.allPaths,F.basenames=W.basenames,F.patterns=W.patterns,F}function c(W,A){return A.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function a(W,A){return function(F,N){return typeof F=="string"&&F.endsWith(W)?A:null}}function C(W,A){const F=`/${W}`,N=`\\${W}`,J=function($,L){return typeof $!="string"?null:L?L===W?A:null:$===W||$.endsWith(F)||$.endsWith(N)?A:null},B=[W];return J.basenames=B,J.patterns=[A],J.allBasenames=B,J}function M(W,A){const F=V(W.slice(1,-1).split(",").map(L=>n(L,A)).filter(L=>L!==i),W),N=F.length;if(!N)return i;if(N===1)return F[0];const J=function(L,O){for(let _=0,j=F.length;_<j;_++)if(F[_](L,O))return W;return null},B=F.find(L=>!!L.allBasenames);B&&(J.allBasenames=B.allBasenames);const $=F.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return $.length&&(J.allPaths=$),J}function T(W,A,F){const N=D.sep===D.posix.sep,J=N?W:W.replace(E,D.sep),B=D.sep+J,$=D.posix.sep+W;let L;return F?L=function(O,_){return typeof O=="string"&&(O===J||O.endsWith(B)||!N&&(O===W||O.endsWith($)))?A:null}:L=function(O,_){return typeof O=="string"&&(O===J||!N&&O===W)?A:null},L.allPaths=[(F?"*/":"./")+W],L}function U(W){try{const A=new RegExp(`^${P(W)}$`);return function(F){return A.lastIndex=0,typeof F=="string"&&A.test(F)?W:null}}catch{return i}}function Q(W,A,F){return!W||typeof A!="string"?!1:ae(W)(A,void 0,F)}e.match=Q;function ae(W,A={}){if(!W)return o;if(typeof W=="string"||X(W)){const F=n(W,A);if(F===i)return o;const N=function(J,B){return!!F(J,B)};return F.allBasenames&&(N.allBasenames=F.allBasenames),F.allPaths&&(N.allPaths=F.allPaths),N}return se(W,A)}e.parse=ae;function X(W){const A=W;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=X;function G(W){return W.allBasenames||[]}e.getBasenameTerms=G;function Z(W){return W.allPaths||[]}e.getPathTerms=Z;function se(W,A){const F=V(Object.getOwnPropertyNames(W).map(L=>he(L,W[L],A)).filter(L=>L!==i)),N=F.length;if(!N)return i;if(!F.some(L=>!!L.requiresSiblings)){if(N===1)return F[0];const L=function(j,Y){let oe;for(let q=0,re=F.length;q<re;q++){const ne=F[q](j,Y);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(oe||(oe=[]),oe.push(ne))}return oe?(async()=>{for(const q of oe){const re=await q;if(typeof re=="string")return re}return null})():null},O=F.find(j=>!!j.allBasenames);O&&(L.allBasenames=O.allBasenames);const _=F.reduce((j,Y)=>Y.allPaths?j.concat(Y.allPaths):j,[]);return _.length&&(L.allPaths=_),L}const J=function(L,O,_){let j,Y;for(let oe=0,q=F.length;oe<q;oe++){const re=F[oe];re.requiresSiblings&&_&&(O||(O=(0,D.basename)(L)),j||(j=O.substr(0,O.length-(0,D.extname)(L).length)));const ne=re(L,O,j,_);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(Y||(Y=[]),Y.push(ne))}return Y?(async()=>{for(const oe of Y){const q=await oe;if(typeof q=="string")return q}return null})():null},B=F.find(L=>!!L.allBasenames);B&&(J.allBasenames=B.allBasenames);const $=F.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return $.length&&(J.allPaths=$),J}function he(W,A,F){if(A===!1)return i;const N=n(W,F);if(N===i)return i;if(typeof A=="boolean")return N;if(A){const J=A.when;if(typeof J=="string"){const B=($,L,O,_)=>{if(!_||!N($,L))return null;const j=J.replace("$(basename)",O),Y=_(j);return(0,t.isThenable)(Y)?Y.then(oe=>oe?W:null):Y?W:null};return B.requiresSiblings=!0,B}}return N}function V(W,A){const F=W.filter(L=>!!L.basenames);if(F.length<2)return W;const N=F.reduce((L,O)=>{const _=O.basenames;return _?L.concat(_):L},[]);let J;if(A){J=[];for(let L=0,O=N.length;L<O;L++)J.push(A)}else J=F.reduce((L,O)=>{const _=O.patterns;return _?L.concat(_):L},[]);const B=function(L,O){if(typeof L!="string")return null;if(!O){let j;for(j=L.length;j>0;j--){const Y=L.charCodeAt(j-1);if(Y===47||Y===92)break}O=L.substr(j)}const _=N.indexOf(O);return _!==-1?J[_]:null};B.basenames=N,B.patterns=J,B.allBasenames=N;const $=W.filter(L=>!L.basenames);return $.push(B),$}function H(W,A){return(0,v.equals)(W,A,(F,N)=>typeof F=="string"&&typeof N=="string"?F===N:typeof F!="string"&&typeof N!="string"?F.base===N.base&&F.pattern===N.pattern:!1)}e.patternsEquals=H}),define(te[35],ie([0,1,24,30,9,4,16,26]),function(z,e,v,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function u(i,n){const{os:s,tildify:c,relative:a}=n;if(a){const T=m(i,a,s);if(typeof T=="string")return T}let C=i.fsPath;if(s===1&&!R.isWindows?C=C.replace(/\//g,"\\"):s!==1&&R.isWindows&&(C=C.replace(/\\/g,"/")),s!==1&&c?.userHome){const T=c.userHome.fsPath;let U;i.scheme!==c.userHome.scheme&&i.path.startsWith(k.posix.sep)?U=c.userHome.with({path:i.path}).fsPath:U=i.fsPath,C=E(U,T,s)}return(s===1?k.win32:k.posix).normalize(I(C,s===1))}e.getPathLabel=u;function m(i,n,s){const c=s===1?k.win32:k.posix,a=s===3?D.extUri:D.extUriIgnorePathCase,C=n.getWorkspace(),M=(0,v.firstOrDefault)(C.folders);if(!M)return;i.scheme!==M.uri.scheme&&i.path.startsWith(k.posix.sep)&&(i=M.uri.with({path:i.path}));const T=n.getWorkspaceFolder(i);if(!T)return;let U;if(a.isEqual(T.uri,i)?U="":U=a.relativePath(T.uri,i)??"",U&&(U=c.normalize(U)),C.folders.length>1&&!n.noPrefix){const Q=T.name?T.name:a.basenameOrAuthority(T.uri);U=U?`${Q} \u2022 ${U}`:Q}return U}function I(i,n=R.isWindows){return(0,t.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let y=Object.create(null);function E(i,n,s=R.OS){if(s===1||!i||!n)return i;let c=y.original===n?y.normalized:void 0;c||(c=n,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,b.rtrim)(c,k.posix.sep)}${k.posix.sep}`,y={original:n,normalized:c});let a=i;return R.isWindows&&(a=(0,t.toSlashes)(a)),(s===3?a.startsWith(c):(0,b.startsWithIgnoreCase)(a,c))?`~/${a.substr(c.length)}`:i}e.tildify=E;function h(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=h;const d="\u2026",P="\\\\",w="~";function p(i,n=k.sep){const s=new Array(i.length);let c=!1;for(let a=0;a<i.length;a++){const C=i[a];if(C===""){s[a]=`.${n}`;continue}if(!C){s[a]=C;continue}c=!0;let M="",T=C;T.indexOf(P)===0?(M=T.substr(0,T.indexOf(P)+P.length),T=T.substr(T.indexOf(P)+P.length)):T.indexOf(n)===0?(M=T.substr(0,T.indexOf(n)+n.length),T=T.substr(T.indexOf(n)+n.length)):T.indexOf(w)===0&&(M=T.substr(0,T.indexOf(w)+w.length),T=T.substr(T.indexOf(w)+w.length));const U=T.split(n);for(let Q=1;c&&Q<=U.length;Q++)for(let ae=U.length-Q;c&&ae>=0;ae--){c=!1;let X=U.slice(ae,ae+Q).join(n);for(let G=0;!c&&G<i.length;G++)if(G!==a&&i[G]&&i[G].indexOf(X)>-1){const Z=ae+Q===U.length,se=ae>0&&i[G].indexOf(n)>-1?n+X:X,he=i[G].endsWith(se);c=!Z||he}if(!c){let G="";(U[0].endsWith(":")||M!=="")&&(ae===1&&(ae=0,Q++,X=U[0]+n+X),ae>0&&(G=U[0]+n),G=M+G),ae>0&&(G=G+d+n),G=G+X,ae+Q<U.length&&(G=G+n+d),s[a]=G}}c&&(s[a]=C)}return s}e.shorten=p;var S;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(S||(S={}));function f(i,n=Object.create(null)){const s=[];let c=!1,a="";for(const C of i)if(C==="$"||c&&C==="{")a&&s.push({value:a,type:S.TEXT}),a="",c=!0;else if(C==="}"&&c){const M=n[a];if(typeof M=="string")M.length&&s.push({value:M,type:S.VARIABLE});else if(M){const T=s[s.length-1];(!T||T.type!==S.SEPARATOR)&&s.push({value:M.label,type:S.SEPARATOR})}a="",c=!1}else a+=C;return a&&!c&&s.push({value:a,type:S.TEXT}),s.filter((C,M)=>{if(C.type===S.SEPARATOR){const T=s[M-1],U=s[M+1];return[T,U].every(Q=>Q&&(Q.type===S.VARIABLE||Q.type===S.TEXT)&&Q.value.length>0)}return!0}).map(C=>C.value).join("")}e.template=f;function g(i,n){return R.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function l(i,n){return R.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,s=>s==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(i){const n=i.indexOf("/")!==-1?k.posix:k.win32,s=n.basename(i),c=n.dirname(i);return s.length?{name:s,parentPath:c}:{name:c,parentPath:""}}e.splitName=o}),define(te[140],ie([0,1,7]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(I){return I.toJSON()}class k{constructor(y){this._uriTransformer=y}transformIncoming(y){const E=this._uriTransformer.transformIncoming(y);return E===y?y:t(v.URI.from(E))}transformOutgoing(y){const E=this._uriTransformer.transformOutgoing(y);return E===y?y:t(v.URI.from(E))}transformOutgoingURI(y){const E=this._uriTransformer.transformOutgoing(y);return E===y?y:v.URI.from(E)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,y,E){if(!I||E>200)return null;if(typeof I=="object"){if(I instanceof v.URI)return y.transformOutgoing(I);for(const h in I)if(Object.hasOwnProperty.call(I,h)){const d=R(I[h],y,E+1);d!==null&&(I[h]=d)}}return null}function D(I,y){const E=R(I,y,0);return E===null?I:E}e.transformOutgoingURIs=D;function b(I,y,E,h){if(!I||h>200)return null;if(typeof I=="object"){if(I.$mid===1)return E?v.URI.revive(y.transformIncoming(I)):y.transformIncoming(I);for(const d in I)if(Object.hasOwnProperty.call(I,d)){const P=b(I[d],y,E,h+1);P!==null&&(I[d]=P)}}return null}function u(I,y){const E=b(I,y,!1,0);return E===null?I:E}e.transformIncomingURIs=u;function m(I,y){const E=b(I,y,!0,0);return E===null?I:E}e.transformAndReviveIncomingURIs=m}),define(te[81],ie([0,1,25,17,31,29,128]),function(z,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,y=0;const E=(0,v.networkInterfaces)();for(const h in E){const d=E[h];if(d)for(const{mac:P,internal:w}of d)w||(y+=1,this._isVirtualMachineMacAddress(P.toUpperCase())&&(I+=1))}this._value=y>0?I/y:0}return this._value}};let b;async function u(){return b||(b=(async()=>await m()||R.generateUuid())()),b}e.getMachineId=u;async function m(){try{const I=await new Promise((E,h)=>{z(["crypto"],E,h)}),y=(0,D.getMac)();return I.createHash("sha256").update(y,"utf8").digest("hex")}catch(I){t.onUnexpectedError(I);return}}}),define(te[21],ie([0,1,40,25,141,8,30,80,9,4,16,7]),function(z,e,v,t,k,R,D,b,u,m,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function h(se,he=E.UNLINK){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return he===E.UNLINK?P(se):d(se)}async function d(se){try{const he=(0,D.randomPath)((0,t.tmpdir)());try{await v.promises.rename(se,he)}catch(V){return V.code==="ENOENT"?void 0:P(se)}P(he).catch(V=>{})}catch(he){if(he.code!=="ENOENT")throw he}}async function P(se){return(0,k.promisify)(v.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function w(se){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function p(se,he){return g(await(he?S(se):(0,k.promisify)(v.readdir)(se)))}async function S(se){try{return await(0,k.promisify)(v.readdir)(se,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const he=[],V=await p(se);for(const H of V){let W=!1,A=!1,F=!1;try{const N=await e.Promises.lstat((0,u.join)(se,H));W=N.isFile(),A=N.isDirectory(),F=N.isSymbolicLink()}catch(N){console.warn("[node.js fs] unexpected error from lstat after readdir: ",N)}he.push({name:H,isFile:()=>W,isDirectory:()=>A,isSymbolicLink:()=>F})}return he}function f(se){return g(v.readdirSync(se))}e.readdirSync=f;function g(se){return se.map(he=>typeof he=="string"?m.isMacintosh?(0,b.normalizeNFC)(he):he:(he.name=m.isMacintosh?(0,b.normalizeNFC)(he.name):he.name,he))}async function l(se){const he=await p(se),V=[];for(const H of he)await o.existsDirectory((0,u.join)(se,H))&&V.push(H);return V}function r(se,he=1e3){return new Promise(V=>{let H=!1;const W=setInterval(()=>{H||(H=!0,v.access(se,A=>{H=!1,A&&(clearInterval(W),V(void 0))}))},he)})}e.whenDeleted=r;var o;(function(se){async function he(W){let A;try{if(A=await e.Promises.lstat(W),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(m.isWindows&&F.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(N){if(N.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw N}throw F}}se.stat=he;async function V(W){try{const{stat:A,symbolicLink:F}=await se.stat(W);return A.isFile()&&F?.dangling!==!0}catch{}return!1}se.existsFile=V;async function H(W){try{const{stat:A,symbolicLink:F}=await se.stat(W);return A.isDirectory()&&F?.dangling!==!0}catch{}return!1}se.existsDirectory=H})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function n(se,he,V){return i.queueFor(y.URI.file(se),I.extUriBiasedIgnorePathCase).queue(()=>{const H=M(V);return new Promise((W,A)=>a(se,he,H,F=>F?A(F):W()))})}let s=!0;function c(se){s=se}e.configureFlushOnWrite=c;function a(se,he,V,H){if(!s)return v.writeFile(se,he,{mode:V.mode,flag:V.flag},H);v.open(se,V.flag,V.mode,(W,A)=>{if(W)return H(W);v.writeFile(A,he,F=>{if(F)return v.close(A,()=>H(F));v.fdatasync(A,N=>(N&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",N),c(!1)),v.close(A,J=>H(J))))})})}function C(se,he,V){const H=M(V);if(!s)return v.writeFileSync(se,he,{mode:H.mode,flag:H.flag});const W=v.openSync(se,H.flag,H.mode);try{v.writeFileSync(W,he);try{v.fdatasyncSync(W)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),c(!1)}}finally{v.closeSync(W)}}e.writeFileSync=C;function M(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,he){if(se!==he)try{await e.Promises.rename(se,he)}catch(V){if(se.toLowerCase()!==he.toLowerCase()&&V.code==="EXDEV"||se.endsWith("."))await U(se,he,{preserveSymlinks:!1}),await h(se,E.MOVE);else throw V}}async function U(se,he,V){return ae(se,he,{root:{source:se,target:he},options:V,handledSourcePaths:new Set})}const Q=511;async function ae(se,he,V){if(V.handledSourcePaths.has(se))return;V.handledSourcePaths.add(se);const{stat:H,symbolicLink:W}=await o.stat(se);if(W){if(V.options.preserveSymlinks)try{return await Z(se,he,V)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(W.dangling)return}return H.isDirectory()?X(se,he,H.mode&Q,V):G(se,he,H.mode&Q)}async function X(se,he,V,H){await e.Promises.mkdir(he,{recursive:!0,mode:V});const W=await p(se);for(const A of W)await ae((0,u.join)(se,A),(0,u.join)(he,A),H)}async function G(se,he,V){await e.Promises.copyFile(se,he),await e.Promises.chmod(he,V)}async function Z(se,he,V){let H=await e.Promises.readlink(se);(0,D.isEqualOrParent)(H,V.root.source,!m.isLinux)&&(H=(0,u.join)(V.root.target,H.substr(V.root.source.length+1))),await e.Promises.symlink(H,he)}e.Promises=new class{get access(){return(0,k.promisify)(v.access)}get stat(){return(0,k.promisify)(v.stat)}get lstat(){return(0,k.promisify)(v.lstat)}get utimes(){return(0,k.promisify)(v.utimes)}get read(){return(se,he,V,H,W)=>new Promise((A,F)=>{v.read(se,he,V,H,W,(N,J,B)=>N?F(N):A({bytesRead:J,buffer:B}))})}get readFile(){return(0,k.promisify)(v.readFile)}get write(){return(se,he,V,H,W)=>new Promise((A,F)=>{v.write(se,he,V,H,W,(N,J,B)=>N?F(N):A({bytesWritten:J,buffer:B}))})}get appendFile(){return(0,k.promisify)(v.appendFile)}get fdatasync(){return(0,k.promisify)(v.fdatasync)}get truncate(){return(0,k.promisify)(v.truncate)}get rename(){return(0,k.promisify)(v.rename)}get copyFile(){return(0,k.promisify)(v.copyFile)}get open(){return(0,k.promisify)(v.open)}get close(){return(0,k.promisify)(v.close)}get symlink(){return(0,k.promisify)(v.symlink)}get readlink(){return(0,k.promisify)(v.readlink)}get chmod(){return(0,k.promisify)(v.chmod)}get mkdir(){return(0,k.promisify)(v.mkdir)}get unlink(){return(0,k.promisify)(v.unlink)}get rmdir(){return(0,k.promisify)(v.rmdir)}get realpath(){return(0,k.promisify)(v.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return l}get writeFile(){return n}get rm(){return h}get move(){return T}get copy(){return U}}}),define(te[99],ie([0,1,40,9,4,26,21]),function(z,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function b(E){if(k.isLinux)return E;const h=(0,t.dirname)(E);if(E===h)return E;const d=((0,t.basename)(E)||E).toLowerCase();try{const w=(0,D.readdirSync)(h).filter(p=>p.toLowerCase()===d);if(w.length===1){const p=b(h);if(p)return(0,t.join)(p,w[0])}else if(w.length>1){const p=w.indexOf(d);if(p>=0){const S=b(h);if(S)return(0,t.join)(S,w[p])}}}catch{}return null}e.realcaseSync=b;async function u(E){if(k.isLinux)return E;const h=(0,t.dirname)(E);if(E===h)return E;const d=((0,t.basename)(E)||E).toLowerCase();try{const w=(await D.Promises.readdir(h)).filter(p=>p.toLowerCase()===d);if(w.length===1){const p=await u(h);if(p)return(0,t.join)(p,w[0])}else if(w.length>1){const p=w.indexOf(d);if(p>=0){const S=await u(h);if(S)return(0,t.join)(S,w[p])}}}catch{}return null}e.realcase=u;async function m(E){try{return await D.Promises.realpath(E)}catch{const d=y(E);return await D.Promises.access(d,v.constants.R_OK),d}}e.realpath=m;function I(E){try{return v.realpathSync(E)}catch{const d=y(E);return v.accessSync(d,v.constants.R_OK),d}}e.realpathSync=I;function y(E){return(0,R.rtrim)((0,t.normalize)(E),t.sep)}}),define(te[142],ie([0,1,25,9,21]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var u;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(u||(u={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class y{constructor(l,r,o){this.exePath=l,this.displayName=r,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:g=!1}={}){return g?m===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:g=!1,findPreview:l=!1}={}){const r=E({useAlternateBitness:g});if(!r)return null;const o=t.join(r,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(o))return null;let i=-1,n=null;for(const a of await k.Promises.readdir(o)){let C=-1;if(l){const T=a.indexOf("-");if(T<0)continue;const U=a.substring(0,T);if(!R.test(U)||a.substring(T+1)!=="preview")continue;C=parseInt(U,10)}else{if(!R.test(a))continue;C=parseInt(a,10)}if(C<=i)continue;const M=t.join(o,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(M)||(n=M,i=C)}if(!n)return null;const s=r.includes("x86")?" (x86)":"",c=l?" Preview":"";return new y(n,`PowerShell${c}${s}`,!0)}async function d({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const l=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:o}=g?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(l))if(r.test(i)){const n=t.join(l,i,"pwsh.exe");return new y(n,o)}return null}function P(){const g=t.join(v.homedir(),".dotnet","tools","pwsh.exe");return new y(g,".NET Core PowerShell Global Tool")}function w(){const g=t.join(process.env.windir,m===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(g,"Windows PowerShell",!0)}async function*p(){let g=await h();g&&(yield g),g=await h({useAlternateBitness:!0}),g&&(yield g),g=await d(),g&&(yield g),g=P(),g&&(yield g),g=await h({findPreview:!0}),g&&(yield g),g=await d({findPreview:!0}),g&&(yield g),g=await h({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=w(),g&&(yield g)}async function*S(){for await(const g of p())await g.exists()&&(yield g)}e.enumeratePowerShellInstallations=S;async function f(){for await(const g of S())return g;return null}e.getFirstAvailablePowerShellInstallation=f}),define(te[82],ie([0,1,9,4,34,78,12,21]),function(z,e,v,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function u(y=k.env){return y.comspec||"cmd.exe"}e.getWindowsShell=u;function m(y){let E=[],h=!1;const d=function(P){if(h){E.push(P);return}(!y.send(P,p=>{if(p&&console.error(p),h=!1,E.length>0){const S=E.slice(0);E=[],S.forEach(f=>d(f))}})||t.isWindows)&&(h=!0)};return{send:d}}e.createQueuedSender=m;var I;(function(y){async function E(h,d,P){if(v.isAbsolute(h))return h;if(d===void 0&&(d=k.cwd()),v.dirname(h)!=="."||(P===void 0&&D.isString(k.env.PATH)&&(P=k.env.PATH.split(v.delimiter)),P===void 0||P.length===0))return v.join(d,h);async function p(S){if(await b.Promises.exists(S)){let f;try{f=await b.Promises.stat(S)}catch(g){g.message.startsWith("EACCES")&&(f=await b.Promises.lstat(S))}return f?!f.isDirectory():!1}return!1}for(const S of P){let f;if(v.isAbsolute(S)?f=v.join(S,h):f=v.join(d,S,h),await p(f))return f;let g=f+".com";if(await p(g)||(g=f+".exe",await p(g)))return g}return v.join(d,h)}y.findExecutable=E})(I=e.win32||(e.win32={}))}),define(te[100],ie([0,1,45,13]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(D){return new Promise((b,u)=>{let m;const I=new Map;function y(h,d,P,w,p){const S=I.get(d);if(h===D||S){const f={name:E(P),cmd:P,pid:h,ppid:d,load:w,mem:p};I.set(h,f),h===D&&(m=f),S&&(S.children||(S.children=[]),S.children.push(f),S.children.length>1&&(S.children=S.children.sort((g,l)=>g.pid-l.pid)))}}function E(h){const d=/--vscode-window-kind=shared-process/,P=/--vscode-window-kind=issue-reporter/,w=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,S=/--utility-sub-type=node.mojom.NodeService/,f=/--crashes-directory/,g=/\\pipe\\winpty-control/,l=/conhost\.exe/,r=/--type=([a-zA-Z-]+)/;if(f.exec(h))return"electron-crash-reporter";if(g.exec(h))return"winpty-process";if(l.exec(h))return"console-window-host (Windows internal process)";let o=r.exec(h);if(o&&o.length===2){if(o[1]==="renderer")return d.exec(h)?"shared-process":P.exec(h)?"issue-reporter":w.exec(h)?"process-explorer":"window";if(o[1]==="utility"){if(p.exec(h))return"utility-network-service";if(S.exec(h))return"extension-host"}return o[1]}const i=/[a-zA-Z-]+\.js/g;let n="";do o=i.exec(h),o&&(n+=o+" ");while(o);return n&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron_node ${n}`:h}if(process.platform==="win32"){const h=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,P)=>{z(["windows-process-tree"],d,P)}).then(d=>{d.getProcessList(D,P=>{if(!P){u(new Error(`Root process ${D} not found`));return}d.getProcessCpuUsage(P,w=>{const p=new Map;w.forEach(S=>{const f=h(S.commandLine||"");p.set(S.pid,{name:E(f),cmd:f,pid:S.pid,ppid:S.ppid,load:S.cpu||0,mem:S.memory||0})}),m=p.get(D),m?(p.forEach(S=>{const f=p.get(S.ppid);f&&(f.children||(f.children=[]),f.children.push(S))}),p.forEach(S=>{S.children&&(S.children=S.children.sort((f,g)=>f.pid-g.pid))}),b(m)):u(new Error(`Root process ${D} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let h=function(){let d=[m];const P=[];for(;d.length;){const p=d.shift();p&&(P.push(p.pid),p.children&&(d=d.concat(p.children)))}let w=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",z).fsPath);w+=" "+P.join(" "),(0,v.exec)(w,{},(p,S,f)=>{if(p||f)u(p||new Error(f.toString()));else{const g=S.toString().split(`
`);for(let l=0;l<P.length;l++){const r=I.get(P[l]);r.load=parseFloat(g[l])}if(!m){u(new Error(`Root process ${D} not found`));return}b(m)}})};(0,v.exec)("which ps",{},(d,P,w)=>{if(d||w)if(process.platform!=="linux")u(d||new Error(w.toString()));else{const p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",z).fsPath);(0,v.exec)(p,{},(S,f,g)=>{S||g?u(S||new Error(g.toString())):(R(f,y),h())})}else{const p=P.toString().trim(),S="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${p} ${S}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,g,l)=>{f||l&&!l.includes("screen size is bogus")?u(f||new Error(l.toString())):(R(g,y),process.platform==="linux"?h():m?b(m):u(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=k;function R(D,b){const u=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=D.toString().split(`
`);for(const I of m){const y=u.exec(I.trim());y&&y.length===6&&b(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(te[143],ie([0,1,25,4,142,82]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(h,d){return h===1?t.isWindows?y():R.getWindowsShell(d):m(h,d)}e.getSystemShell=D;function b(h,d){return h===1?t.isWindows?E(d):R.getWindowsShell(d):m(h,d)}e.getSystemShellSync=b;let u=null;function m(h,d){if(t.isLinux&&h===2||t.isMacintosh&&h===3)return"/bin/bash";if(!u){let P;if(t.isWindows)P="/bin/bash";else{if(P=d.SHELL,!P)try{P=(0,v.userInfo)().shell}catch{}P||(P="sh"),P==="/bin/false"&&(P="/bin/bash")}u=P}return u}let I=null;async function y(){return I||(I=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),I}function E(h){if(I)return I;const d=t.isWindows&&parseFloat((0,v.release)())>=10,P=h.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${h.windir}\\${P?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?w:R.getWindowsShell(h)}});var ve=this&&this.__decorate||function(z,e,v,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,v):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(z,e,v,t);else for(var b=z.length-1;b>=0;b--)(D=z[b])&&(R=(k<3?D(R):k>3?D(e,v,R):D(e,v))||R);return k>3&&R&&Object.defineProperty(e,v,R),R};define(te[46],ie([0,1,24,8,18,23,53,17,3,2,67,26,12]),function(z,e,v,t,k,R,D,b,u,m,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var h;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(h=e.RequestType||(e.RequestType={}));function d(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var P;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(P=e.ResponseType||(e.ResponseType={}));function w(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(p||(p={}));class S{constructor(A){this.buffer=A,this.pos=0}read(A){const F=this.buffer.slice(this.pos,this.pos+A);return this.pos+=F.byteLength,F}}class f{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var g;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(g||(g={}));function l(W){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(W,0),A}function r(W){return W.read(4).readUInt32BE(0)}function o(W){const A=k.VSBuffer.alloc(1);return A.writeUInt8(W,0),A}const i={Undefined:o(g.Undefined),String:o(g.String),Buffer:o(g.Buffer),VSBuffer:o(g.VSBuffer),Array:o(g.Array),Object:o(g.Object)},n=typeof Buffer<"u";function s(W,A){if(typeof A>"u")W.write(i.Undefined);else if(typeof A=="string"){const F=k.VSBuffer.fromString(A);W.write(i.String),W.write(l(F.byteLength)),W.write(F)}else if(n&&Buffer.isBuffer(A)){const F=k.VSBuffer.wrap(A);W.write(i.Buffer),W.write(l(F.byteLength)),W.write(F)}else if(A instanceof k.VSBuffer)W.write(i.VSBuffer),W.write(l(A.byteLength)),W.write(A);else if(Array.isArray(A)){W.write(i.Array),W.write(l(A.length));for(const F of A)s(W,F)}else{const F=k.VSBuffer.fromString(JSON.stringify(A));W.write(i.Object),W.write(l(F.byteLength)),W.write(F)}}function c(W){switch(W.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return W.read(r(W)).toString();case g.Buffer:return W.read(r(W)).buffer;case g.VSBuffer:return W.read(r(W));case g.Array:{const F=r(W),N=[];for(let J=0;J<F;J++)N.push(c(W));return N}case g.Object:return JSON.parse(W.read(r(W)).toString())}}class a{constructor(A,F,N=null,J=1e3){this.protocol=A,this.ctx=F,this.logger=N,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(A,F){this.channels.set(A,F),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const F=this.send([A.type]);this.logger?.logOutgoing(F,0,1,w(A.type));return}case 201:case 202:case 204:case 203:{const F=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(F,A.id,1,w(A.type),A.data);return}}}send(A,F=void 0){const N=new f;return s(N,A),s(N,F),this.sendBuffer(N.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const F=new S(A),N=c(F),J=c(F),B=N[0];switch(B){case 100:return this.logger?.logIncoming(A.byteLength,N[1],1,`${d(B)}: ${N[2]}.${N[3]}`,J),this.onPromise({type:B,id:N[1],channelName:N[2],name:N[3],arg:J});case 102:return this.logger?.logIncoming(A.byteLength,N[1],1,`${d(B)}: ${N[2]}.${N[3]}`,J),this.onEventListen({type:B,id:N[1],channelName:N[2],name:N[3],arg:J});case 101:return this.logger?.logIncoming(A.byteLength,N[1],1,`${d(B)}`),this.disposeActiveRequest({type:B,id:N[1]});case 103:return this.logger?.logIncoming(A.byteLength,N[1],1,`${d(B)}`),this.disposeActiveRequest({type:B,id:N[1]})}}onPromise(A){const F=this.channels.get(A.channelName);if(!F){this.collectPendingRequest(A);return}const N=new R.CancellationTokenSource;let J;try{J=F.call(this.ctx,A.name,A.arg,N.token)}catch(L){J=Promise.reject(L)}const B=A.id;J.then(L=>{this.sendResponse({id:B,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:B,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:B,data:L,type:203}),this.activeRequests.delete(A.id)});const $=(0,m.toDisposable)(()=>N.cancel());this.activeRequests.set(A.id,$)}onEventListen(A){const F=this.channels.get(A.channelName);if(!F){this.collectPendingRequest(A);return}const N=A.id,B=F.listen(this.ctx,A.name,A.arg)($=>this.sendResponse({id:N,data:$,type:204}));this.activeRequests.set(A.id,B)}disposeActiveRequest(A){const F=this.activeRequests.get(A.id);F&&(F.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let F=this.pendingRequests.get(A.channelName);F||(F=[],this.pendingRequests.set(A.channelName,F));const N=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);F.push({request:A,timeoutTimer:N})}flushPendingRequests(A){const F=this.pendingRequests.get(A);if(F){for(const N of F)switch(clearTimeout(N.timeoutTimer),N.request.type){case 100:this.onPromise(N.request);break;case 102:this.onEventListen(N.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var C;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(C=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(A,F=null){this.protocol=A,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(N=>this.onBuffer(N)),this.logger=F}getChannel(A){const F=this;return{call(N,J,B){return F.isDisposed?Promise.reject(new b.CancellationError):F.requestPromise(A,N,J,B)},listen(N,J){return F.isDisposed?u.Event.None:F.requestEvent(A,N,J)}}}requestPromise(A,F,N,J=R.CancellationToken.None){const B=this.lastRequestId++,L={id:B,type:100,channelName:A,name:F,arg:N};if(J.isCancellationRequested)return Promise.reject(new b.CancellationError);let O;return new Promise((j,Y)=>{if(J.isCancellationRequested)return Y(new b.CancellationError);const oe=()=>{const ce=ge=>{switch(ge.type){case 201:this.handlers.delete(B),j(ge.data);break;case 202:{this.handlers.delete(B);const De=new Error(ge.data.message);De.stack=ge.data.stack,De.name=ge.data.name,Y(De);break}case 203:this.handlers.delete(B),Y(ge.data);break}};this.handlers.set(B,ce),this.sendRequest(L)};let q=null;this.state===p.Idle?oe():(q=(0,t.createCancelablePromise)(ce=>this.whenInitialized()),q.then(()=>{q=null,oe()}));const re=()=>{q?(q.cancel(),q=null):this.sendRequest({id:B,type:101}),Y(new b.CancellationError)},ne=J.onCancellationRequested(re);O=(0,m.combinedDisposable)((0,m.toDisposable)(re),ne),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(A,F,N){const J=this.lastRequestId++,$={id:J,type:102,channelName:A,name:F,arg:N};let L=null;const O=new u.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(j=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest($)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:J,type:103}))}}),_=j=>O.fire(j.data);return this.handlers.set(J,_),O.event}sendRequest(A){switch(A.type){case 100:case 102:{const F=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(F,A.id,0,`${d(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const F=this.send([A.type,A.id]);this.logger?.logOutgoing(F,A.id,0,d(A.type));return}}}send(A,F=void 0){const N=new f;return s(N,A),s(N,F),this.sendBuffer(N.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const F=new S(A),N=c(F),J=c(F),B=N[0];switch(B){case 200:return this.logger?.logIncoming(A.byteLength,0,0,w(B)),this.onResponse({type:N[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,N[1],0,w(B),J),this.onResponse({type:N[0],id:N[1],data:J})}}onResponse(A){if(A.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([D.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class T{get connections(){const A=[];return this._connections.forEach(F=>A.push(F)),A}constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:F,onDidClientDisconnect:N})=>{u.Event.once(F.onMessage)(B=>{const $=new S(B),L=c($),O=new a(F,L),_=new M(F);this.channels.forEach((Y,oe)=>O.registerChannel(oe,Y));const j={channelServer:O,channelClient:_,ctx:L};this._connections.add(j),this._onDidAddConnection.fire(j),N(()=>{O.dispose(),_.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}getChannel(A,F){const N=this;return{call(J,B,$){let L;if((0,E.isFunction)(F)){const _=(0,v.getRandomElement)(N.connections.filter(F));L=_?Promise.resolve(_):u.Event.toPromise(u.Event.filter(N.onDidAddConnection,F))}else L=F.routeCall(N,J,B);const O=L.then(_=>_.channelClient.getChannel(A));return Q(O).call(J,B,$)},listen(J,B){if((0,E.isFunction)(F))return N.getMulticastEvent(A,F,J,B);const $=F.routeEvent(N,J,B).then(L=>L.channelClient.getChannel(A));return Q($).listen(J,B)}}}getMulticastEvent(A,F,N,J){const B=this;let $=new m.DisposableStore;const L=new u.Emitter({onFirstListenerAdd:()=>{$=new m.DisposableStore;const O=new u.EventMultiplexer,_=new Map,j=oe=>{const re=oe.channelClient.getChannel(A).listen(N,J),ne=O.add(re);_.set(oe,ne)},Y=oe=>{const q=_.get(oe);!q||(q.dispose(),_.delete(oe))};B.connections.filter(F).forEach(j),u.Event.filter(B.onDidAddConnection,F)(j,void 0,$),B.onDidRemoveConnection(Y,void 0,$),O.event(L.fire,L,$),$.add(O)},onLastListenerRemove:()=>{$.dispose()}});return L.event}registerChannel(A,F){this.channels.set(A,F),this._connections.forEach(N=>{N.channelServer.registerChannel(A,F)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class U{constructor(A,F,N=null){const J=new f;s(J,F),A.send(J.buffer),this.channelClient=new M(A,N),this.channelServer=new a(A,F,N)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,F){this.channelServer.registerChannel(A,F)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function Q(W){return{call(A,F,N){return W.then(J=>J.call(A,F,N))},listen(A,F){const N=new u.Relay;return W.then(J=>N.input=J.listen(A,F)),N.event}}}e.getDelayedChannel=Q;function ae(W){let A=!1;return{call(F,N,J){return A?W.call(F,N,J):(0,t.timeout)(0).then(()=>A=!0).then(()=>W.call(F,N,J))},listen(F,N){if(A)return W.listen(F,N);const J=new u.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>J.input=W.listen(F,N)),J.event}}}e.getNextTickChannel=ae;class X{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const F of A.connections)if(await Promise.resolve(this.fn(F.ctx)))return Promise.resolve(F);return await u.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=X;var G;(function(W){function A(B,$){const L=B,O=$&&$.disableMarshalling,_=new Map;for(const j in L)N(j)&&_.set(j,u.Event.buffer(L[j],!0));return new class{listen(j,Y,oe){const q=_.get(Y);if(q)return q;if(J(Y)){const re=L[Y];if(typeof re=="function")return re.call(L,oe)}throw new Error(`Event not found: ${Y}`)}call(j,Y,oe){const q=L[Y];if(typeof q=="function"){if(!O&&Array.isArray(oe))for(let re=0;re<oe.length;re++)oe[re]=(0,I.revive)(oe[re]);return q.apply(L,oe)}throw new Error(`Method not found: ${Y}`)}}}W.fromService=A;function F(B,$){const L=$&&$.disableMarshalling;return new Proxy({},{get(O,_){if(typeof _=="string")return $?.properties?.has(_)?$.properties.get(_):J(_)?function(j){return B.listen(_,j)}:N(_)?B.listen(_):async function(...j){let Y;$&&!(0,E.isUndefinedOrNull)($.context)?Y=[$.context,...j]:Y=j;const oe=await B.call(_,Y);return L?oe:(0,I.revive)(oe)};throw new Error(`Property not found: ${String(_)}`)}})}W.toService=F;function N(B){return B[0]==="o"&&B[1]==="n"&&y.isUpperAsciiLetter(B.charCodeAt(2))}function J(B){return/^onDynamic/.test(B)&&y.isUpperAsciiLetter(B.charCodeAt(9))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const A=W.toString();if(A!=="[object Object]")return A}return W}function he(W){return Array.isArray(W)?W.map(se):se(W)}function V(W,A,F,N,J,B,$){$=he($);const L=Z[J],O=L[N%L.length];let _=[`%c[${W}]%c[${String(A).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(N).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(B)?(_=_.concat($),_.push(")")):_.push($),console.log.apply(console,_)}e.logWithColors=V;class H{constructor(A,F){this._outgoingPrefix=A,this._incomingPrefix=F,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,F,N,J,B){this._totalOutgoing+=A,V(this._outgoingPrefix,this._totalOutgoing,A,F,N,J,B)}logIncoming(A,F,N,J,B){this._totalIncoming+=A,V(this._incomingPrefix,this._totalIncoming,A,F,N,J,B)}}e.IPCLogger=H}),define(te[144],ie([0,1,18,3,46]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(u){this.port=u,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",m=>v.VSBuffer.wrap(m.data)),u.start()}send(u){this.port.postMessage(u.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends k.IPCClient{constructor(u,m){const I=new R(u);super(I,m),this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=D}),define(te[101],ie([0,1,18,3,2,46]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var b;(function(n){n.enableDiagnostics=!1,n.records=[];const s=new WeakMap;let c=0;function a(M,T){if(!s.has(M)){const U=String(++c);s.set(M,U)}return s.get(M)}function C(M,T,U,Q){if(!n.enableDiagnostics)return;const ae=a(M,T);if(Q instanceof v.VSBuffer||Q instanceof Uint8Array||Q instanceof ArrayBuffer||ArrayBuffer.isView(Q)){const X=v.VSBuffer.alloc(Q.byteLength);X.set(Q),n.records.push({timestamp:Date.now(),id:ae,label:T,type:U,buff:X})}else n.records.push({timestamp:Date.now(),id:ae,label:T,type:U,data:Q})}n.traceSocketEvent=C})(b=e.SocketDiagnostics||(e.SocketDiagnostics={}));var u;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function I(){return m||(m=v.VSBuffer.alloc(0)),m}class y{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,c){if(s===0)return I();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const T=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=s),T}if(this._chunks[0].byteLength>s){const T=this._chunks[0].slice(0,s);return c&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),T}const a=v.VSBuffer.alloc(s);let C=0,M=0;for(;s>0;){const T=this._chunks[M];if(T.byteLength>s){const U=T.slice(0,s);a.set(U,C),C+=s,c&&(this._chunks[M]=T.slice(s),this._totalLength-=s),s-=s}else a.set(T,C),C+=T.byteLength,c?(this._chunks.shift(),this._totalLength-=T.byteLength):M++,s-=T.byteLength}return a}}e.ChunkStream=y;var E;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(E||(E={}));function h(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class P{constructor(s,c,a,C){this.type=s,this.id=c,this.ack=a,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends k.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:h(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,C=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new P(a,C,M,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=v.VSBuffer.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:h(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(c,s.data)}_bufferAdd(s,c){const a=this._totalLength===0;return this._data.push(s,c),this._totalLength+=s.byteLength+c.byteLength,a}_bufferTake(){const s=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,c){this._bufferAdd(s,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class S extends k.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new P(1,0,0,s))}}e.Protocol=S;class f extends R.IPCClient{static fromSocket(s,c){return new f(new S(s),c)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,c,a=null){super(s,c,a),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=f;class g{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=g;class l{constructor(s){this.data=s,this.next=null}}class r{constructor(){this._first=null,this._last=null}length(){let s=0,c=this._first;for(;c;)c=c.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let c=0,a=this._first;for(;a;)s[c++]=a.data,a=a.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const c=new l(s);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class o{static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let c=0;c<o._HISTORY_LENGTH;c++)this.lastRuns[c]=s-1e3*c;setInterval(()=>{for(let c=o._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),c=(1+o._HISTORY_LENGTH)*1e3;let a=0;for(let C=0;C<o._HISTORY_LENGTH;C++)s-this.lastRuns[C]<=c&&a++;return 1-a/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class i{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,c=null,a=o.getInstance()){this._onControlMessage=new g,this.onControlMessage=this._onControlMessage.event,this._onMessage=new g,this.onMessage=this._onMessage.event,this._onDidDispose=new g,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new g,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new g,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(C=>this._receiveMessage(C))),this._socketDisposables.push(this._socket.onClose(C=>this._onSocketClose.fire(C))),c&&this._socketReader.acceptChunk(c),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new P(5,0,0,I());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new P(7,0,0,I());this._socketWriter.write(s)}sendResume(){const s=new P(8,0,0,I());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,c){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new P(3,0,this._incomingAckId,I());this._socketWriter.write(s);const c=this._outgoingUnackMsg.toArray();for(let a=0,C=c.length;a<C;a++)this._socketWriter.write(c[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new P(6,0,0,I())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let a=0,C=c.length;a<C;a++)this._socketWriter.write(c[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new P(1,c,this._incomingAckId,s);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(s){const c=new P(2,0,0,s);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),c=Date.now()-s.writtenTime,a=Date.now()-this._socketReader.lastReadTime,C=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&a>=2e4&&C>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:a});return}const M=Math.max(2e4-c,2e4-a,2e4-C,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new P(3,0,this._incomingAckId,I());this._socketWriter.write(s)}_sendKeepAlive(){const s=new P(9,0,0,I());this._socketWriter.write(s)}}e.PersistentProtocol=i}),define(te[145],ie([0,1,41,18,3,2,46,130]),function(z,e,v,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function u(I,y){const E=k.Event.fromNodeEventEmitter(v.validatedIpcMain,y,(d,P)=>({event:d,message:P})),h=k.Event.filter(E,({event:d})=>d.sender.id===I);return k.Event.map(h,({message:d})=>d&&t.VSBuffer.wrap(d))}class m extends D.IPCServer{static getOnDidClientConnect(){const y=k.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:hello",({sender:E})=>E);return k.Event.map(y,E=>{const h=E.id;m.Clients.get(h)?.dispose();const P=new k.Emitter;m.Clients.set(h,(0,R.toDisposable)(()=>P.fire()));const w=u(h,"vscode:message"),p=k.Event.any(k.Event.signal(u(h,"vscode:disconnect")),P.event);return{protocol:new b.Protocol(E,w),onDidClientDisconnect:p}})}constructor(){super(m.getOnDidClientConnect())}}e.Server=m,m.Clients=new Map}),define(te[102],ie([0,1,41,3,29,144]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(m,I){super({addEventListener:(y,E)=>m.addListener(y,E),removeEventListener:(y,E)=>m.removeListener(y,E),postMessage:y=>m.postMessage(y),start:()=>m.start(),close:()=>m.close()},I)}}e.Client=D;async function b(u){if(u.isDestroyed()||u.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,k.generateUuid)();u.webContents.send("vscode:createMessageChannel",m);const I=t.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:createMessageChannelResult",(E,h)=>({nonce:h,port:E.ports[0]})),{port:y}=await t.Event.toPromise(t.Event.once(t.Event.filter(I,E=>E.nonce===m)));return y}e.connect=b}),define(te[146],ie([0,1,45,8,18,23,139,17,3,2,50,82,78,46]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends h.ChannelServer{constructor(p){super({send:S=>{try{process.send?.(S.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",S=>k.VSBuffer.wrap(Buffer.from(S,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=d;class P{constructor(p,S){this.modulePath=p,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new t.Delayer(f),this.child=null,this._client=null}getChannel(p){const S=this;return{call(f,g,l){return S.requestPromise(p,f,g,l)},listen(f,g){return S.requestEvent(p,f,g)}}}requestPromise(p,S,f,g=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(p),r=(0,t.createCancelablePromise)(n=>l.call(S,f,n)),o=g.onCancellationRequested(()=>r.cancel()),i=(0,m.toDisposable)(()=>r.cancel());return this.activeRequests.add(i),r.finally(()=>{o.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),r}requestEvent(p,S,f){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let g;const l=new u.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(p).listen(S,f)(l.fire,l),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,E.removeDangerousEnvVariables)(S.env),this.child=(0,v.fork)(this.modulePath,p,S);const f=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,D.isRemoteConsoleLog)(s)){(0,D.log)(s,`IPC Library: ${this.options.serverName}`);return}f.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const l=this.options.useQueue?(0,y.createQueuedSender)(this.child):this.child,r=s=>this.child&&this.child.connected&&l.send(s.buffer.toString("base64")),o=f.event,i={send:r,onMessage:o};this._client=new h.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,c)=>{process.removeListener("exit",n),this.activeRequests.forEach(a=>(0,m.dispose)(a)),this.activeRequests.clear(),s!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:c})})}return this._client}getCachedChannel(p){let S=this.channels.get(p);return S||(S=this.client.getChannel(p),this.channels.set(p,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=P}),define(te[83],ie([0,1,18,17,3,2,9,4,29,46,101]),function(z,e,v,t,k,R,D,b,u,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function y(){return{crypto:z.__$__nodeRequire("crypto"),zlib:z.__$__nodeRequire("zlib"),net:z.__$__nodeRequire("net"),os:z.__$__nodeRequire("os")}}class E{traceSocketEvent(a,C){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,C)}constructor(a,C=""){this._canWrite=!0,this.debugLabel=C,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,t.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener),this._closeListener=M=>{this.traceSocketEvent("close",{hadError:M}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(a){const C=M=>{this.traceSocketEvent("read",M),a(v.VSBuffer.wrap(M))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(a){const C=M=>{a({type:0,hadError:M,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(a){const C=()=>{a()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(a){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,t.onUnexpectedError)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,t.onUnexpectedError)(C)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=E;var h;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(h||(h={}));var d;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(d||(d={}));class P extends R.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,C){this.socket.traceSocketEvent(a,C)}constructor(a,C,M,T){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:M?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new w(this,C,M,T,this._onData,(U,Q)=>this._write(U,Q))),this._register(this._flowManager.onError(U=>{console.error(U),(0,t.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData(U=>this._acceptChunk(U))),this._register(this.socket.onClose(U=>this._onClose.fire(U)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,C){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let M=2;a.byteLength<126?M+=0:a.byteLength<2**16?M+=2:M+=8;const T=v.VSBuffer.alloc(M);if(C?T.writeUInt8(194,0):T.writeUInt8(130,0),a.byteLength<126)T.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){T.writeUInt8(126,1);let U=1;T.writeUInt8(a.byteLength>>>8&255,++U),T.writeUInt8(a.byteLength>>>0&255,++U)}else{T.writeUInt8(127,1);let U=1;T.writeUInt8(0,++U),T.writeUInt8(0,++U),T.writeUInt8(0,++U),T.writeUInt8(0,++U),T.writeUInt8(a.byteLength>>>24&255,++U),T.writeUInt8(a.byteLength>>>16&255,++U),T.writeUInt8(a.byteLength>>>8&255,++U),T.writeUInt8(a.byteLength>>>0&255,++U)}this.socket.write(v.VSBuffer.concat([T,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const C=this._incomingData.peek(this._state.readLen),M=C.readUInt8(0),T=(M&128)>>>7,U=(M&64)>>>6,Q=C.readUInt8(1),ae=(Q&128)>>>7,X=Q&127;this._state.state=2,this._state.readLen=2+(ae?4:0)+(X===126?2:0)+(X===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(U)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const C=this._incomingData.read(this._state.readLen),M=C.readUInt8(1),T=(M&128)>>>7;let U=M&127,Q=1;U===126?U=C.readUInt8(++Q)*2**8+C.readUInt8(++Q):U===127&&(U=C.readUInt8(++Q)*0+C.readUInt8(++Q)*0+C.readUInt8(++Q)*0+C.readUInt8(++Q)*0+C.readUInt8(++Q)*2**24+C.readUInt8(++Q)*2**16+C.readUInt8(++Q)*2**8+C.readUInt8(++Q));let ae=0;T&&(ae=C.readUInt8(++Q)*2**24+C.readUInt8(++Q)*2**16+C.readUInt8(++Q)*2**8+C.readUInt8(++Q)),this._state.state=3,this._state.readLen=U,this._state.mask=ae,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const C=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",C),f(C,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",C),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(C,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=P;class w extends R.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:v.VSBuffer.alloc(0)}constructor(a,C,M,T,U,Q){super(),this._tracer=a,this._onData=U,this._writeFn=Q,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,C?(this._zlibInflateStream=this._register(new p(this._tracer,T,M,{windowBits:15})),this._zlibDeflateStream=this._register(new S(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(ae=>this._onError.fire(ae))),this._register(this._zlibDeflateStream.onError(ae=>this._onError.fire(ae)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const C=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(C,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,C){return new Promise((M,T)=>{a.write(C),a.flush(U=>M(U))})}acceptFrame(a,C,M){this._readQueue.push({data:a,isCompressed:C,isLastFrameOfMessage:M}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const C=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(C)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,C,M){return new Promise((T,U)=>{a.write(C),M&&a.write(v.VSBuffer.fromByteArray([0,0,255,255])),a.flush(Q=>T(Q))})}}class p extends R.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?v.VSBuffer.concat(this._recordedInflateBytes):v.VSBuffer.alloc(0)}constructor(a,C,M,T){super(),this._tracer=a,this._recordInflateBytes=C,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=y().zlib.createInflateRaw(T),this._zlibInflate.on("error",U=>{this._tracer.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibInflate.on("data",U=>{this._tracer.traceSocketEvent("zlibInflateData",U),this._pendingInflateData.push(v.VSBuffer.wrap(U))}),M&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this._zlibInflate.write(M.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const C=v.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(C)})}}class S extends R.Disposable{constructor(a,C){super(),this._tracer=a,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=y().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",M=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibDeflate.on("data",M=>{this._tracer.traceSocketEvent("zlibDeflateData",M),this._pendingDeflateData.push(v.VSBuffer.wrap(M))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let C=v.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,C=C.slice(0,C.byteLength-4),a(C)})}}function f(c,a){if(a===0)return;const C=c.byteLength>>>2;for(let X=0;X<C;X++){const G=c.readUInt32BE(X*4);c.writeUInt32BE(G^a,X*4)}const M=C*4,T=c.byteLength-M,U=a>>>24&255,Q=a>>>16&255,ae=a>>>8&255;T>=1&&c.writeUInt8(c.readUInt8(M)^U,M),T>=2&&c.writeUInt8(c.readUInt8(M+1)^Q,M+1),T>=3&&c.writeUInt8(c.readUInt8(M+2)^ae,M+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const g={[2]:107,[1]:103};function l(){const c=(0,u.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):a=(0,D.join)(y().os.tmpdir(),`vscode-ipc-${c}.sock`),o(a),a}e.createRandomIPCHandle=l;function r(c,a,C){const M=y().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${C}-${a}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${C}-${a}.sock`):T=(0,D.join)(c,`${C}-${a}.sock`),o(T),T}e.createStaticIPCHandle=r;function o(c){const a=g[b.platform];typeof a=="number"&&c.length>=a&&console.warn(`WARNING: IPC handle "${c}" is longer than ${a} chars, try a shorter --user-data-dir`)}class i extends m.IPCServer{static toClientConnectionEvent(a){const C=k.Event.fromNodeEventEmitter(a,"connection");return k.Event.map(C,M=>({protocol:new I.Protocol(new E(M,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(M,"close"))}))}constructor(a){super(i.toClientConnectionEvent(a)),this.server=a}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function n(c){return new Promise((a,C)=>{const M=y().net.createServer();M.on("error",C),M.listen(c,()=>{M.removeListener("error",C),a(new i(M))})})}e.serve=n;function s(c,a){return new Promise((C,M)=>{const T=y().net.createConnection(c,()=>{T.removeListener("error",M),C(I.Client.fromSocket(new E(T,`ipc-client${a}`),a))});T.once("error",M)})}e.connect=s}),define(te[103],ie([0,1,8,3,2,12]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function b(y){const E=y;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var u;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(u=e.StorageState||(e.StorageState={}));class m extends k.Disposable{constructor(E,h=Object.create(null)){super(),this.database=E,this.options=h,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=u.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){E.changed?.forEach((h,d)=>this.accept(d,h)),E.deleted?.forEach(h=>this.accept(h,void 0))}accept(E,h){if(this.state===u.Closed)return;let d=!1;(0,R.isUndefinedOrNull)(h)?d=this.cache.delete(E):this.cache.get(E)!==h&&(this.cache.set(E,h),d=!0),d&&this._onDidChangeStorage.fire(E)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===u.None&&(this.state=u.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,h){const d=this.cache.get(E);return(0,R.isUndefinedOrNull)(d)?h:d}getBoolean(E,h){const d=this.get(E);return(0,R.isUndefinedOrNull)(d)?h:d==="true"}getNumber(E,h){const d=this.get(E);return(0,R.isUndefinedOrNull)(d)?h:parseInt(d,10)}async set(E,h){if(this.state===u.Closed)return;if((0,R.isUndefinedOrNull)(h))return this.delete(E);const d=String(h);if(this.cache.get(E)!==d)return this.cache.set(E,d),this.pendingInserts.set(E,d),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.doFlush()}async delete(E){if(!(this.state===u.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=u.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(E){if(!!this.hasPending)return this.doFlush(E)}async doFlush(E){return this.flushDelayer.trigger(()=>this.flushPending(),E)}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert?.forEach((h,d)=>this.items.set(d,h)),E.delete?.forEach(h=>this.items.delete(h))}async close(){}}e.InMemoryStorageDatabase=I}),define(te[147],ie([0,1,8,3,31,9,21]),function(z,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class b{get onDidChangeItemsExternal(){return t.Event.None}constructor(I,y=Object.create(null)){this.path=I,this.options=y,this.name=(0,R.basename)(this.path),this.logger=new u(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const I=await this.whenConnected,y=new Map;return(await this.all(I,"SELECT * FROM ItemTable")).forEach(h=>y.set(h.key,h.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${y.size} rows`),y}async updateItems(I){const y=await this.whenConnected;return this.doUpdateItems(y,I)}doUpdateItems(I,y){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${y.insert?(0,k.mapToString)(y.insert):"0"}), delete(${y.delete?(0,k.setToString)(y.delete):"0"})`),this.transaction(I,()=>{const E=y.insert,h=y.delete;if(E&&E.size>0){const d=[];d.push([]);let P=0;E.forEach((w,p)=>{let S=d[P];S.length>b.MAX_HOST_PARAMETERS&&(P++,S=[],d.push(S)),S.push(p,w)}),d.forEach(w=>{this.prepare(I,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,p=>p.run(w),()=>{const p=[];let S=0;return E.forEach((f,g)=>{p.push(g),S+=f.length}),`Keys: ${p.join(", ")} Length: ${S}`})})}if(h&&h.size){const d=[];d.push([]);let P=0;h.forEach(w=>{let p=d[P];p.length>b.MAX_HOST_PARAMETERS&&(P++,p=[],d.push(p)),p.push(w)}),d.forEach(w=>{this.prepare(I,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,p=>p.run(w),()=>{const p=[];return h.forEach(S=>{p.push(S)}),`Keys: ${p.join(", ")}`})})}})}async close(I){this.logger.trace(`[storage ${this.name}] close()`);const y=await this.whenConnected;return this.doClose(y,I)}doClose(I,y){return new Promise((E,h)=>{I.db.close(d=>(d&&this.handleSQLiteError(I,`[storage ${this.name}] close(): ${d}`),this.path===b.IN_MEMORY_PATH?E():!I.isErroneous&&!I.isInMemory?this.backup().then(E,P=>(this.logger.error(`[storage ${this.name}] backup(): ${P}`),E())):typeof y=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(P=>{const w=()=>this.doClose(P,void 0);return this.doUpdateItems(P,{insert:y()}).then(()=>w(),p=>(w(),Promise.reject(p)))})).then(E,h):h(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const I=this.toBackupPath(this.path);return D.Promises.copy(this.path,I,{preserveSymlinks:!1})}toBackupPath(I){return`${I}.backup`}async checkIntegrity(I){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${I})`);const y=await this.whenConnected,E=await this.get(y,I?"PRAGMA integrity_check":"PRAGMA quick_check"),h=I?E.integrity_check:E.quick_check;return y.isErroneous?`${h} (last error: ${y.lastError})`:y.isInMemory?`${h} (in-memory!)`:h}async connect(I,y=!0){this.logger.trace(`[storage ${this.name}] open(${I}, retryOnBusy: ${y})`);try{return await this.doConnect(I)}catch(E){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${E}`),E.code==="SQLITE_BUSY"&&y)return await(0,v.timeout)(b.BUSY_OPEN_TIMEOUT),this.connect(I,!1);try{await D.Promises.unlink(I);try{await D.Promises.rename(this.toBackupPath(I),I)}catch{}return await this.doConnect(I)}catch(h){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${h}`),this.doConnect(b.IN_MEMORY_PATH)}}}handleSQLiteError(I,y){I.isErroneous=!0,I.lastError=y,this.logger.error(y)}doConnect(I){return new Promise((y,E)=>{new Promise((h,d)=>{z(["@vscode/sqlite3"],h,d)}).then(h=>{const d={db:new(this.logger.isTracing?h.verbose().Database:h.Database)(I,P=>P?d.db&&P.code!=="SQLITE_CANTOPEN"?d.db.close(()=>E(P)):E(P):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(d),w=>d.db.close(()=>E(w)))),isInMemory:I===b.IN_MEMORY_PATH};d.db.on("error",P=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${P}`)),this.logger.isTracing&&d.db.on("trace",P=>this.logger.trace(`[storage ${this.name}] Trace (event): ${P}`))},E)})}exec(I,y){return new Promise((E,h)=>{I.db.exec(y,d=>d?(this.handleSQLiteError(I,`[storage ${this.name}] exec(): ${d}`),h(d)):E())})}get(I,y){return new Promise((E,h)=>{I.db.get(y,(d,P)=>d?(this.handleSQLiteError(I,`[storage ${this.name}] get(): ${d}`),h(d)):E(P))})}all(I,y){return new Promise((E,h)=>{I.db.all(y,(d,P)=>d?(this.handleSQLiteError(I,`[storage ${this.name}] all(): ${d}`),h(d)):E(P))})}transaction(I,y){return new Promise((E,h)=>{I.db.serialize(()=>{I.db.run("BEGIN TRANSACTION"),y(),I.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(I,`[storage ${this.name}] transaction(): ${d}`),h(d)):E())})})}prepare(I,y,E,h){const d=I.db.prepare(y),P=w=>{this.handleSQLiteError(I,`[storage ${this.name}] prepare(): ${w} (${y}). Details: ${h()}`)};d.on("error",P),E(d),d.finalize(w=>{w&&P(w),d.removeListener("error",P)})}}e.SQLiteStorageDatabase=b,b.IN_MEMORY_PATH=":memory:",b.BUSY_OPEN_TIMEOUT=2e3,b.MAX_HOST_PARAMETERS=256;class u{constructor(I){I&&typeof I.logTrace=="function"&&process.env[u.VSCODE_TRACE_STORAGE]&&(this.logTrace=I.logTrace),I&&typeof I.logError=="function"&&(this.logError=I.logError)}get isTracing(){return!!this.logTrace}trace(I){this.logTrace?.(I)}error(I){this.logError?.(I)}}u.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(te[148],ie([11,10]),function(z,e){return z.create("vs/code/electron-main/app",e)}),define(te[149],ie([11,10]),function(z,e){return z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[150],ie([11,10]),function(z,e){return z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[151],ie([11,10]),function(z,e){return z.create("vs/platform/environment/node/argv",e)}),define(te[152],ie([11,10]),function(z,e){return z.create("vs/platform/environment/node/argvHelper",e)}),define(te[153],ie([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[154],ie([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[155],ie([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[156],ie([11,10]),function(z,e){return z.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[157],ie([11,10]),function(z,e){return z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[158],ie([11,10]),function(z,e){return z.create("vs/platform/files/common/fileService",e)}),define(te[159],ie([11,10]),function(z,e){return z.create("vs/platform/files/common/files",e)}),define(te[160],ie([11,10]),function(z,e){return z.create("vs/platform/files/common/io",e)}),define(te[161],ie([11,10]),function(z,e){return z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[162],ie([11,10]),function(z,e){return z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[163],ie([11,10]),function(z,e){return z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[164],ie([11,10]),function(z,e){return z.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[165],ie([11,10]),function(z,e){return z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[166],ie([11,10]),function(z,e){return z.create("vs/platform/request/common/request",e)}),define(te[167],ie([11,10]),function(z,e){return z.create("vs/platform/shell/node/shellEnv",e)}),define(te[168],ie([11,10]),function(z,e){return z.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[169],ie([11,10]),function(z,e){return z.create("vs/platform/update/common/update.config.contribution",e)}),define(te[170],ie([11,10]),function(z,e){return z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[171],ie([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[172],ie([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[173],ie([11,10]),function(z,e){return z.create("vs/platform/workspace/common/workspace",e)}),define(te[174],ie([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[175],ie([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[176],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function v(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=v;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(te[177],ie([0,1,7]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function k(D){let b=[];try{Array.isArray(D.workspaces)&&(b=D.workspaces.map(u=>({workspace:{id:u.id,configPath:v.URI.parse(u.configURIPath)},remoteAuthority:u.remoteAuthority})))}catch{}return b}e.deserializeWorkspaceInfos=k;function R(D){let b=[];try{Array.isArray(D.folders)&&(b=D.folders.map(u=>({folderUri:v.URI.parse(u.folderUri),remoteAuthority:u.remoteAuthority})))}catch{}return b}e.deserializeFolderInfos=R}),define(te[178],ie([0,1,3,2]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(b,u,m){switch(u){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(b,u,m){switch(u){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(b){super(),this.channel=b}reload(b){this.channel.call("reload",[b])}get onReload(){return this.channel.listen("reload")}close(b){this.channel.call("close",[b])}get onClose(){return this.channel.listen("close")}attachSession(b,u,m){this.channel.call("attach",[b,u,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(b,u){this.channel.call("terminate",[b,u])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(b,u){return this.channel.call("openExtensionDevelopmentHostWindow",[b,u])}}e.ExtensionHostDebugChannelClient=R}),define(te[179],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class v{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>z(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=v}),define(te[180],ie([0,1,133,53,13,9,34,16,7]),function(z,e,v,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",z).fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const P=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",P)}return this.args.logsPath}get userDataSyncLogResource(){return u.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return u.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(u.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const P=D.env.VSCODE_PORTABLE;return P?u.URI.file((0,R.join)(P,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const P=this.args["builtin-extensions-dir"];return P?(0,R.resolve)(P):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const P=this.args["extensions-download-dir"];return P?(0,R.resolve)(P):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const P=this.args["extensions-dir"];if(P)return(0,R.resolve)(P);const w=D.env.VSCODE_EXTENSIONS;if(w)return w;const p=D.env.VSCODE_PORTABLE;return p?(0,R.join)(p,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const P=this.args.extensionDevelopmentPath;if(Array.isArray(P))return P.map(w=>/^[^:/?#]+?:\/\//.test(w)?u.URI.parse(w):u.URI.file((0,R.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(P=>P==="ui"||P==="workspace"||P==="web"?P:"workspace")}get extensionTestsLocationURI(){const P=this.args.extensionTestsPath;if(P)return/^[^:/?#]+?:\/\//.test(P)?u.URI.parse(P):u.URI.file((0,R.normalize)(P))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const P=this.args["disable-extension"];if(P){if(typeof P=="string")return[P];if(Array.isArray(P)&&P.length>0)return P}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return u.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const P=D.env.VSCODE_PORTABLE;return P?u.URI.file((0,R.join)(P,"policy.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(P){this.args.continueOn=P}get args(){return this._args}constructor(P,w,p){this._args=P,this.paths=w,this.productService=p,this.editSessionId=this.args.editSessionId}}ve([t.memoize],m.prototype,"appRoot",null),ve([t.memoize],m.prototype,"userHome",null),ve([t.memoize],m.prototype,"userDataPath",null),ve([t.memoize],m.prototype,"appSettingsHome",null),ve([t.memoize],m.prototype,"tmpDir",null),ve([t.memoize],m.prototype,"cacheHome",null),ve([t.memoize],m.prototype,"stateResource",null),ve([t.memoize],m.prototype,"userRoamingDataHome",null),ve([t.memoize],m.prototype,"userDataSyncHome",null),ve([t.memoize],m.prototype,"userDataSyncLogResource",null),ve([t.memoize],m.prototype,"editSessionsLogResource",null),ve([t.memoize],m.prototype,"sync",null),ve([t.memoize],m.prototype,"machineSettingsResource",null),ve([t.memoize],m.prototype,"workspaceStorageHome",null),ve([t.memoize],m.prototype,"localHistoryHome",null),ve([t.memoize],m.prototype,"keyboardLayoutResource",null),ve([t.memoize],m.prototype,"argvResource",null),ve([t.memoize],m.prototype,"isExtensionDevelopment",null),ve([t.memoize],m.prototype,"untitledWorkspacesHome",null),ve([t.memoize],m.prototype,"installSourcePath",null),ve([t.memoize],m.prototype,"builtinExtensionsPath",null),ve([t.memoize],m.prototype,"extensionsPath",null),ve([t.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ve([t.memoize],m.prototype,"extensionDevelopmentKind",null),ve([t.memoize],m.prototype,"extensionTestsLocationURI",null),ve([t.memoize],m.prototype,"debugExtensionHost",null),ve([t.memoize],m.prototype,"serviceMachineIdResource",null),ve([t.memoize],m.prototype,"telemetryLogResource",null),ve([t.memoize],m.prototype,"disableWorkspaceTrust",null),ve([t.memoize],m.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=m;function I(d,P){return h(d["inspect-extensions"],d["inspect-brk-extensions"],5870,P,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=I;function y(d,P){return h(d["inspect-search"],d["inspect-brk-search"],5876,P,d.extensionEnvironment)}e.parseSearchPort=y;function E(d,P){return h(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,P,d.extensionEnvironment)}e.parsePtyHostPort=E;function h(d,P,w,p,S,f){const l=Number(P||d)||(p?null:w),r=l?Boolean(!!P):!1;let o;if(f)try{o=JSON.parse(f)}catch{}return{port:l,break:r,debugId:S,env:o}}}),define(te[104],ie([0,1,277,4,151]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},category:{type:"string",cat:"e",description:(0,k.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function b(d,P,w=D){const p={},S=["_"],f=[];for(const o in P){const i=P[o];i.alias&&(p[o]=i.alias),i.type==="string"||i.type==="string[]"?(S.push(o),i.deprecates&&S.push(...i.deprecates)):i.type==="boolean"&&(f.push(o),i.deprecates&&f.push(...i.deprecates))}const g=v(d,{string:S,boolean:f,alias:p}),l={},r=g;l._=g._.map(o=>String(o)).filter(o=>o.length>0),delete r._;for(const o in P){const i=P[o];i.alias&&delete r[i.alias];let n=r[o];if(i.deprecates)for(const s of i.deprecates)r.hasOwnProperty(s)&&(n||(n=r[s],n&&w.onDeprecatedOption(s,i.deprecationMessage||(0,k.localize)(35,null,o))),delete r[s]);if(typeof n<"u"){if(i.type==="string[]"){if(Array.isArray(n)||(n=[n]),!i.allowEmptyValue){const s=n.filter(c=>c.length>0);s.length!==n.length&&(w.onEmptyValue(o),n=s.length>0?s:void 0)}}else i.type==="string"&&(Array.isArray(n)?(n=n.pop(),w.onMultipleValues(o,n)):!n&&!i.allowEmptyValue&&(w.onEmptyValue(o),n=void 0));l[o]=n,i.deprecationMessage&&w.onDeprecatedOption(o,i.deprecationMessage)}delete r[o]}for(const o in r)w.onUnknownOption(o);return l}e.parseArgs=b;function u(d,P){let w="";return P.args&&(Array.isArray(P.args)?w=` <${P.args.join("> <")}>`:w=` <${P.args}>`),P.alias?`-${P.alias} --${d}${w}`:`--${d}${w}`}function m(d,P){let w=0;const p=[];for(const l in d){const r=d[l],o=u(l,r);w=Math.max(w,o.length),p.push([o,r.description])}const S=w+2+1;if(P-S<25)return p.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);const f=P-S-1,g=[];for(const l of p){const r=l[0],o=y(l[1],f),i=I(S-r.length-2);g.push("  "+r+i+o[0]);for(let n=1;n<o.length;n++)g.push(I(S)+o[n])}return g}e.formatOptions=m;function I(d){return" ".repeat(d)}function y(d,P){const w=[];for(;d.length;){const p=d.length<P?d.length:d.lastIndexOf(" ",P),S=d.slice(0,p).trim();d=d.slice(p),w.push(S)}return w}function E(d,P,w,p,S){const f=process.stdout.isTTY&&process.stdout.columns||80,g=S?.noInputFiles!==!0?`[${(0,k.localize)(36,null)}...]`:"",l=[`${d} ${w}`];l.push(""),l.push(`${(0,k.localize)(37,null)}: ${P} [${(0,k.localize)(38,null)}]${g}`),l.push(""),S?.noPipe!==!0&&(t.isWindows?l.push((0,k.localize)(39,null,P)):l.push((0,k.localize)(40,null,P)),l.push(""));const r={};for(const o in p){const i=p[o];if(i.description&&i.cat){let n=r[i.cat];n||(r[i.cat]=n={}),n[o]=i}}for(const o in r){const i=o,n=r[i];n&&(l.push(R[i]),l.push(...m(n,f)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=E;function h(d,P){return`${d||(0,k.localize)(41,null)}
${P||(0,k.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=h}),define(te[181],ie([0,1,77,178,104]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(b,u){super(),this.windowsMainService=b,this.userDataProfilesMainService=u}call(b,u,m){return u==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1]):super.call(b,u,m)}async openExtensionDevelopmentHostWindow(b,u){const m=(0,k.parseArgs)(b,k.OPTIONS);m.debugRenderer=u;const I=m.extensionDevelopmentPath;if(!I)return{success:!1};const[y]=await this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:m,profile:await this.userDataProfilesMainService.checkAndCreateProfileFromCli(m)});if(!u)return{success:!0};const E=y.win;if(!E)return{success:!0};const h=E.webContents.debugger;let d=h.isAttached()?1/0:0;const P=(0,v.createServer)(w=>{d++===0&&h.attach();let p=!1;const S=l=>{p||w.write(JSON.stringify(l)+"\0")},f=(l,r,o,i)=>S({method:r,params:o,sessionId:i});E.on("close",()=>{h.removeListener("message",f),w.end(),p=!0}),h.addListener("message",f);let g=Buffer.alloc(0);w.on("data",l=>{g=Buffer.concat([g,l]);for(let r=g.indexOf(0);r!==-1;r=g.indexOf(0)){let o;try{const i=g.slice(0,r).toString("utf8");g=g.slice(r+1),o=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}h.sendCommand(o.method,o.params,o.sessionId).then(i=>S({id:o.id,sessionId:o.sessionId,result:i})).catch(i=>S({id:o.id,sessionId:o.sessionId,error:{code:0,message:i.message}}))}}),w.on("error",l=>{console.error("error on cdp pipe:",l)}),w.on("close",()=>{p=!0,--d===0&&h.detach()})});return await new Promise(w=>P.listen(0,w)),E.on("close",()=>P.close()),{rendererDebugPort:P.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(te[59],ie([0,1,278,152,104]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(E,h){const d={onUnknownOption:w=>{console.warn((0,t.localize)(0,null,w))},onMultipleValues:(w,p)=>{console.warn((0,t.localize)(1,null,w,p))},onEmptyValue:w=>{console.warn((0,t.localize)(2,null,w))},onDeprecatedOption:(w,p)=>{console.warn((0,t.localize)(3,null,w,p))}},P=(0,k.parseArgs)(E,k.OPTIONS,h?d:void 0);return P.goto&&P._.forEach(w=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,t.localize)(4,null))),P["max-memory"]&&v(parseInt(P["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),P}function b(E){const h=E.findIndex(d=>!/^-/.test(d));if(h>-1)return[...E.slice(0,h),...E.slice(h+1)]}function u(E){let[,...h]=E;process.env.VSCODE_DEV&&(h=b(h)||[]);const d=!y(process.env);return D(h,d)}e.parseMainProcessArgv=u;function m(E){const[,,...h]=E;return D(h,!0)}e.parseCLIProcessArgv=m;function I(E,...h){const d=E.indexOf("--");return d===-1?E.push(...h):E.splice(d,0,...h),E}e.addArg=I;function y(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=y}),function(){"use strict";function z(e,v,t){function k(D,b){const u=R(D,b),m=[u];return e.isAbsolute(u)||m.unshift(t),e.resolve(...m)}function R(D,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,b);const I=D["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(y,"AppData","Roaming")}break;case"darwin":m=e.join(v.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,b)}return{getUserDataPath:k}}if(typeof define=="function")define(te[182],ie([183,25,34]),function(e,v,t){return z(e,v,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),v=require("os");module.exports=z(e,v,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[184],ie([0,1,25,180,182]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(b,u){super(b,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,k.getUserDataPath)(b,u.nameShort)},u)}}e.NativeEnvironmentService=R}),define(te[185],ie([0,1,40,25,30]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(D){const b=(0,k.randomPath)((0,t.tmpdir)());try{return(0,v.writeFileSync)(b,""),D&&console.log(`Marker file for --wait created: ${b}`),b}catch(u){D&&console.error(`Failed to create marker file for --wait: ${u}`);return}}e.createWaitMarkerFileSync=R}),define(te[186],ie([0,1,12,154]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(D,b,u){try{R(D,b,u)}catch{}return D}e.localizeManifest=k;function R(D,b,u){const m=(I,y,E)=>{const h=I[y];if((0,v.isString)(h)){const d=h,P=d.length;if(P>1&&d[0]==="%"&&d[P-1]==="%"){const w=d.substr(1,P-2);let p=b[w];p===void 0&&u&&(p=u[w]);const S=typeof p=="string"?p:p.message;if(S!==void 0){const f=u?.[w],g=typeof f=="string"?f:f?.message;if(E&&(y==="title"||y==="category")&&g&&g!==S){const l={value:S,original:g};I[y]=l}else I[y]=S}else console.warn(`[${D.name}]: ${(0,t.localize)(0,null,w)}`)}}else if((0,v.isObject)(h))for(const d in h)h.hasOwnProperty(d)&&(d==="commands"?m(h,d,!0):m(h,d,E));else if(Array.isArray(h))for(let d=0;d<h.length;d++)m(h,d,E)};for(const I in D)D.hasOwnProperty(I)&&m(D,I)}}),define(te[187],ie([0,1,16,97,156,188]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function u(p){return p=p.trim(),p==="*"||D.test(p)}e.isValidVersionStr=u;function m(p){if(!u(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const S=p.match(D);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=m;function I(p){if(!p)return null;const S=p.majorBase,f=p.majorMustEqual,g=p.minorBase;let l=p.minorMustEqual;const r=p.patchBase;let o=p.patchMustEqual;p.hasCaret&&(S===0||(l=!1),o=!1);let i=0;if(p.preRelease){const n=b.exec(p.preRelease);if(n){const[,s,c,a]=n;i=Date.UTC(Number(s),Number(c)-1,Number(a))}}return{majorBase:S,majorMustEqual:f,minorBase:g,minorMustEqual:l,patchBase:r,patchMustEqual:o,isMinimum:p.hasGreaterEquals,notBefore:i}}e.normalizeVersion=I;function y(p,S,f){let g;typeof p=="string"?g=I(m(p)):g=p;let l;S instanceof Date?l=S.getTime():typeof S=="string"&&(l=new Date(S).getTime());let r;if(typeof f=="string"?r=I(m(f)):r=f,!g||!r)return!1;const o=g.majorBase,i=g.minorBase,n=g.patchBase;let s=r.majorBase,c=r.minorBase,a=r.patchBase;const C=r.notBefore;let M=r.majorMustEqual,T=r.minorMustEqual,U=r.patchMustEqual;return r.isMinimum?o>s?!0:o<s?!1:i>c?!0:i<c||l&&l<C?!1:n>=a:(o===1&&s===0&&(!M||!T||!U)&&(s=1,c=0,a=0,M=!0,T=!1,U=!1),o<s?!1:o>s?!M:i<c?!1:i>c?!T:n<a?!1:n>a?!U:!(l&&l<C))}e.isValidVersion=y;function E(p,S,f,g,l){const r=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return r.push([t.default.Error,k.localize(0,null)]),r;if(typeof g.name!="string")return r.push([t.default.Error,k.localize(1,null,"name")]),r;if(typeof g.version!="string")return r.push([t.default.Error,k.localize(2,null,"version")]),r;if(!g.engines)return r.push([t.default.Error,k.localize(3,null,"engines")]),r;if(typeof g.engines.vscode!="string")return r.push([t.default.Error,k.localize(4,null,"engines.vscode")]),r;if(typeof g.extensionDependencies<"u"&&!w(g.extensionDependencies))return r.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),r;if(typeof g.activationEvents<"u"){if(!w(g.activationEvents))return r.push([t.default.Error,k.localize(6,null,"activationEvents")]),r;if(typeof g.main>"u"&&typeof g.browser>"u")return r.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),r}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&r.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return r.push([t.default.Error,k.localize(9,null,"main")]),r;{const n=(0,v.joinPath)(f,g.main);(0,v.isEqualOrParent)(n,f)||r.push([t.default.Warning,k.localize(10,null,n.path,f.path)])}if(typeof g.activationEvents>"u")return r.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),r}if(typeof g.browser<"u"){if(typeof g.browser!="string")return r.push([t.default.Error,k.localize(12,null,"browser")]),r;{const n=(0,v.joinPath)(f,g.browser);(0,v.isEqualOrParent)(n,f)||r.push([t.default.Warning,k.localize(13,null,n.path,f.path)])}if(typeof g.activationEvents>"u")return r.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),r}if(!R.valid(g.version))return r.push([t.default.Error,k.localize(15,null)]),r;const o=[];if(!h(p,S,g,l,o))for(const n of o)r.push([t.default.Error,n]);return r}e.validateExtensionManifest=E;function h(p,S,f,g,l){return g||typeof f.main>"u"&&typeof f.browser>"u"?!0:P(p,S,f.engines.vscode,l)}e.isValidExtensionVersion=h;function d(p,S,f){return p==="*"||P(S,f,p)}e.isEngineValid=d;function P(p,S,f,g=[]){const l=I(m(f));if(!l)return g.push(k.localize(16,null,f)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return g.push(k.localize(17,null,f)),!1}else if(!l.majorMustEqual)return g.push(k.localize(18,null,f)),!1;return y(p,S,l)?!0:(g.push(k.localize(19,null,p,f)),!1)}function w(p){if(!Array.isArray(p))return!1;for(let S=0,f=p.length;S<f;S++)if(typeof p[S]!="string")return!1;return!0}}),define(te[189],ie([0,1,18,29]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,D,b){let u=b&&b.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const I=(await D.readFile(R.serviceMachineIdResource)).value.toString();u=(0,t.isUUID)(I)?I:null}catch{u=null}if(!u){u=(0,t.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,v.VSBuffer.fromString(u))}catch{}}return b?.store("storage.serviceMachineId",u,-1,1),u}e.getServiceMachineId=k}),define(te[68],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(k,R=[],D=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=v}),define(te[190],ie([0,1,68]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function R(b,u,m){u instanceof v.SyncDescriptor||(u=new v.SyncDescriptor(u,[],Boolean(m))),t.push([b,u])}e.registerSingleton=R;function D(){return t}e.getSingletonServiceDescriptors=D}),define(te[191],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(R,D){this.key=R,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=v;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const b=this.lookupOrInsertNode(R),u=this.lookupOrInsertNode(D);b.outgoing.set(u.key,u),u.incoming.set(b.key,b)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const b of this._nodes.values())b.outgoing.delete(D),b.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let b=this._nodes.get(D);return b||(b=new v(D,R),this._nodes.set(D,b)),b}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,b]of this._nodes)R.push(`${D}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const b=new Set([R]),u=this._findCycle(D,b);if(u)return u}}_findCycle(R,D){for(const[b,u]of R.outgoing){if(D.has(b))return[...D,b].join(" -> ");D.add(b);const m=this._findCycle(u,D);if(m)return m;D.delete(b)}}}e.Graph=t}),define(te[5],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function b(u){return u[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=b})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,b,u){b[v.DI_TARGET]===b?b[v.DI_DEPENDENCIES].push({id:D,index:u}):(b[v.DI_DEPENDENCIES]=[{id:D,index:u}],b[v.DI_TARGET]=b)}function k(D){if(v.serviceIds.has(D))return v.serviceIds.get(D);const b=function(u,m,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(b,u,I)};return b.toString=()=>D,v.serviceIds.set(D,b),b}e.createDecorator=k;function R(D){return D}e.refineServiceDecorator=R}),define(te[60],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService")}),define(te[19],ie([0,1,12,7,5]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationOverrides=R;function D(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var b;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function u(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=u;function m(p,S){const f=Object.create(null);for(const g in p)I(f,g,p[g],S);return f}e.toValuesTree=m;function I(p,S,f,g){const l=S.split("."),r=l.pop();let o=p;for(let i=0;i<l.length;i++){const n=l[i];let s=o[n];switch(typeof s){case"undefined":s=o[n]=Object.create(null);break;case"object":break;default:g(`Ignoring ${S} as ${l.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[r]=f}catch{g(`Ignoring ${S} as ${l.join(".")} is ${JSON.stringify(o)}`)}else g(`Ignoring ${S} as ${l.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=I;function y(p,S){const f=S.split(".");E(p,f)}e.removeFromValueTree=y;function E(p,S){const f=S.shift();if(S.length===0){delete p[f];return}if(Object.keys(p).indexOf(f)!==-1){const g=p[f];typeof g=="object"&&!Array.isArray(g)&&(E(g,S),Object.keys(g).length===0&&delete p[f])}}function h(p,S,f){function g(o,i){let n=o;for(const s of i){if(typeof n!="object"||n===null)return;n=n[s]}return n}const l=S.split("."),r=g(p,l);return typeof r>"u"?f:r}e.getConfigurationValue=h;function d(p,S,f){Object.keys(S).forEach(g=>{g!=="__proto__"&&(g in p?v.isObject(p[g])&&v.isObject(S[g])?d(p[g],S[g],f):f&&(p[g]=S[g]):p[g]=S[g])})}e.merge=d;function P(p,S,f){const g=p.inspect(S),l=p.inspect(f);return typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:g.defaultValue}e.getMigratedSettingValue=P;function w(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(te[69],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,v.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,v.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,b){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=b}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const b of Object.keys(this.secretVault[R]||{}))D.push({account:b,password:this.secretVault[R][b]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(te[84],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(D,b){return{}}async getSystemInfo(D,b){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,b){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=k}),define(te[105],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService")}),define(te[36],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(te[27],ie([0,1,53,9,83,36,184,5]),function(z,e,v,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,b.refineServiceDecorator)(R.IEnvironmentService);class u extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([v.memoize],u.prototype,"cachedLanguagesPath",null),ve([v.memoize],u.prototype,"backupHome",null),ve([v.memoize],u.prototype,"mainIPCHandle",null),ve([v.memoize],u.prototype,"mainLockfile",null),ve([v.memoize],u.prototype,"disableUpdates",null),ve([v.memoize],u.prototype,"disableKeytar",null),ve([v.memoize],u.prototype,"crossOriginIsolated",null),ve([v.memoize],u.prototype,"codeCachePath",null),ve([v.memoize],u.prototype,"useCodeCache",null),e.EnvironmentMainService=u}),define(te[192],ie([0,1,153,5]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(p,S){switch(p){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function b(p,S){return S==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function u(p,S,f){return b(S,f)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===f?!0:m(f).includes(p)}e.isTargetPlatformCompatible=u;function m(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function I(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=I;var y;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var E;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var h;(function(p){p.Install="install",p.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var d;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var P;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(P=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(S,f){super(S),this.code=f,this.name=f}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(te[193],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(te[194],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,v.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[106],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(te[195],ie([0,1,45,13,9,4,78,21,82,157,106]),function(z,e,v,t,k,R,D,b,u,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=m.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await P.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends E{openTerminal(g,l){return this.spawnTerminal(v,g,u.getWindowsShell(),l)}spawnTerminal(g,l,r,o){const i=l.windowsExec||h.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const n=k.basename(i).toLowerCase();if(n==="cmder"||n==="cmder.exe")return g.spawn(i,o?[o]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return i.indexOf(" ")>=0&&s.push('""'),s.push(i),(n==="wt"||n==="wt.exe")&&s.push("-d ."),new Promise((c,a)=>{const C=w(process),M=g.spawn(r,s,{cwd:o,env:C});M.on("error",a),M.on("exit",()=>c())})}runInTerminal(g,l,r,o,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:h.getDefaultTerminalWindows();return new Promise((s,c)=>{const a=`"${l} - ${y}"`,C=`""${r.join('" "')}" & pause"`,M=["/c","start",a,"/wait",n,"/c",C],T=Object.assign({},w(process),o);Object.keys(T).filter(ae=>T[ae]===null).forEach(ae=>delete T[ae]);const U={cwd:l,env:T,windowsVerbatimArguments:!0};v.spawn(h.CMD,M,U).on("error",ae=>{c(p(ae))}),s(void 0)})}static getDefaultTerminalWindows(){if(!h._DEFAULT_TERMINAL_WINDOWS){const g=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${g?"Sysnative":"System32"}\\cmd.exe`}return h._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=h,h.CMD="cmd.exe";class d extends E{openTerminal(g,l){return this.spawnTerminal(v,g,l)}runInTerminal(g,l,r,o,i){const n=i.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((s,c)=>{if(n===I.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const a=n===I.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,z).fsPath,"-t",g||y,"-w",l];for(const Q of r)M.push("-a"),M.push(Q);if(o){const Q=Object.assign({},w(process),o);for(const ae in Q){const X=Q[ae];X===null?(M.push("-u"),M.push(ae)):(M.push("-e"),M.push(`${ae}=${X}`))}}let T="";const U=v.spawn(d.OSASCRIPT,M);U.on("error",Q=>{c(p(Q))}),U.stderr.on("data",Q=>{T+=Q.toString()}),U.on("exit",Q=>{if(Q===0)s(void 0);else if(T){const ae=T.split(`
`,1);c(new Error(ae[0]))}else c(new Error(m.localize(1,null,a,Q)))})}else c(new Error(m.localize(2,null,n)))})}spawnTerminal(g,l,r){const o=l.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const s=["-a",o];r&&s.push(r);const c=w(process),a=g.spawn("/usr/bin/open",s,{cwd:r,env:c});a.on("error",n),a.on("exit",()=>i())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class P extends E{openTerminal(g,l){return this.spawnTerminal(v,g,l)}runInTerminal(g,l,r,o,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):P.getDefaultTerminalLinuxReady();return new Promise((s,c)=>{const a=[];n.then(C=>{C.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const M=`${S(r)}; echo; read -p "${P.WAIT_MESSAGE}" -n1;`;a.push(`''${M}''`);const T=Object.assign({},w(process),o);Object.keys(T).filter(X=>T[X]===null).forEach(X=>delete T[X]);const U={cwd:l,env:T};let Q="";const ae=v.spawn(C,a,U);ae.on("error",X=>{c(p(X))}),ae.stderr.on("data",X=>{Q+=X.toString()}),ae.on("exit",X=>{if(X===0)s(void 0);else if(Q){const G=Q.split(`
`,1);c(new Error(G[0]))}else c(new Error(m.localize(4,null,C,X)))})})})}static async getDefaultTerminalLinuxReady(){if(!P._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)P._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const g=await b.Promises.exists("/etc/debian_version");P._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{g?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return P._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(g,l,r){const o=l.linuxExec?Promise.resolve(l.linuxExec):P.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{o.then(s=>{const c=w(process),a=g.spawn(s,[],{cwd:r,env:c});a.on("error",n),a.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=P,P.WAIT_MESSAGE=m.localize(3,null);function w(f){const g={...f.env};return(0,D.sanitizeProcessEnvironment)(g),g}function p(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(m.localize(5,null,f.path)):f}function S(f){let g="";for(const l of f)l.indexOf(" ")>=0?g+='"'+l+'"':g+=l,g+=" ";return g}}),define(te[14],ie([0,1,31,9,26,12,7,159,5]),function(z,e,v,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,u.createDecorator)("fileService");function m(V){return V.create===!0}e.isFileOpenForWriteOptions=m;var I;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var y;(function(V){V[V.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var E;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=h;function d(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=d;function P(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=P;function w(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function p(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=p;function S(V){return h(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var f;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(H,W){super(H),this.code=W}}e.FileSystemProviderError=g;function l(V,H){const W=new g(V.toString(),H);return o(W,H),W}e.createFileSystemProviderError=l;function r(V){return V||l((0,b.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=r;function o(V,H){return V.name=H?`${H} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=o;function i(V){if(!V)return f.Unknown;if(V instanceof g)return V.code;const H=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!H)return f.Unknown;switch(H[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=i;function n(V){if(V instanceof T)return V.fileOperationResult;switch(i(V)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class c{constructor(H,W,A){this.resource=H,this.operation=W,this.target=A}isOperation(H){return this.operation===H}}e.FileOperationEvent=c;var a;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class C{constructor(H,W){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=H;const A=new Map;for(const F of H){const N=A.get(F.type);switch(N?N.push([F.resource,F]):A.set(F.type,[[F.resource,F]]),F.type){case 1:this.rawAdded.push(F.resource);break;case 0:this.rawUpdated.push(F.resource);break;case 2:this.rawDeleted.push(F.resource);break}}for(const[F,N]of A)switch(F){case 1:this.added=v.TernarySearchTree.forUris(()=>W),this.added.fill(N);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>W),this.updated.fill(N);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>W),this.deleted.fill(N);break}}contains(H,...W){return this.doContains(H,{includeChildren:!1},...W)}affects(H,...W){return this.doContains(H,{includeChildren:!0},...W)}doContains(H,W,...A){if(!H)return!1;const F=A.length>0;return!!((!F||A.includes(1))&&(this.added?.get(H)||W.includeChildren&&this.added?.findSuperstr(H))||(!F||A.includes(0))&&(this.updated?.get(H)||W.includeChildren&&this.updated?.findSuperstr(H))||(!F||A.includes(2))&&(this.deleted?.findSubstr(H)||W.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=C;function M(V,H,W){return!V||!H||V===H||H.length>V.length?!1:(H.charAt(H.length-1)!==t.sep&&(H+=t.sep),W?(0,k.startsWithIgnoreCase)(V,H):V.indexOf(H)===0)}e.isParent=M;class T extends Error{constructor(H,W,A){super(H),this.fileOperationResult=W,this.options=A}}e.FileOperationError=T;class U extends T{constructor(H,W,A){super(H,2,A),this.stat=W}}e.NotModifiedSinceFileOperationError=U;var Q;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ae;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function X(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=X;async function G(V,H){if(!H.hasProvider(D.URI.from({scheme:V.scheme})))return new Promise(W=>{const A=H.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===V.scheme&&F.added&&(A.dispose(),W())})})}e.whenProviderRegistered=G,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Z{static formatSize(H){return(0,R.isNumber)(H)||(H=0),H<Z.KB?(0,b.localize)(1,null,H.toFixed(0)):H<Z.MB?(0,b.localize)(2,null,(H/Z.KB).toFixed(2)):H<Z.GB?(0,b.localize)(3,null,(H/Z.MB).toFixed(2)):H<Z.TB?(0,b.localize)(4,null,(H/Z.GB).toFixed(2)):(0,b.localize)(5,null,(H/Z.TB).toFixed(2))}}e.ByteSize=Z,Z.KB=1024,Z.MB=Z.KB*Z.KB,Z.GB=Z.MB*Z.KB,Z.TB=Z.GB*Z.KB;var se;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function he(V){return{maxFileSize:V===0?300*Z.MB:16*Z.GB,maxHeapSize:V===0?700*Z.MB:2*700*Z.MB}}e.getPlatformLimits=he}),define(te[196],ie([0,1,18,44,17,3,2,58,7,29,14]),function(z,e,v,t,k,R,D,b,u,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class y extends D.Disposable{constructor(h,d){super(),this.channel=h,this.extraCapabilities=d,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,m.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(h){return this.channel.call("stat",[h])}readdir(h){return this.channel.call("readdir",[h])}async readFile(h,d){const{buffer:P}=await this.channel.call("readFile",[h,d]);return P}readFileStream(h,d,P){const w=(0,b.newWriteableStream)(S=>v.VSBuffer.concat(S.map(f=>v.VSBuffer.wrap(f))).buffer),p=this.channel.listen("readFileStream",[h,d])(S=>{if(S instanceof v.VSBuffer)w.write(S.buffer);else{if(S==="end")w.end();else{let f=S;f instanceof Error||(f=(0,I.createFileSystemProviderError)((0,t.toErrorMessage)(f),I.FileSystemProviderErrorCode.Unknown)),w.error(f),w.end()}p.dispose()}});return P.onCancellationRequested(()=>{w.error((0,k.canceled)()),w.end(),p.dispose()}),w}writeFile(h,d,P){return this.channel.call("writeFile",[h,v.VSBuffer.wrap(d),P])}open(h,d){return this.channel.call("open",[h,d])}close(h){return this.channel.call("close",[h])}async read(h,d,P,w,p){const[S,f]=await this.channel.call("read",[h,d,p]);return P.set(S.buffer.slice(0,f),w),f}write(h,d,P,w,p){return this.channel.call("write",[h,d,v.VSBuffer.wrap(P),w,p])}mkdir(h){return this.channel.call("mkdir",[h])}delete(h,d){return this.channel.call("delete",[h,d])}rename(h,d,P){return this.channel.call("rename",[h,d,P])}copy(h,d,P){return this.channel.call("copy",[h,d,P])}cloneFile(h,d){return this.channel.call("cloneFile",[h,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(h=>{if(Array.isArray(h)){const d=h;this._onDidChange.fire(d.map(P=>({resource:u.URI.revive(P.resource),type:P.type})))}else{const d=h;this._onDidWatchError.fire(d)}}))}watch(h,d){const P=(0,m.generateUuid)();return this.channel.call("watch",[this.sessionId,P,h,d]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,P]))}}e.DiskFileSystemProviderClient=y}),define(te[107],ie([0,1,18,17,160,14]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(I,y,E,h,d,P){let w;try{await b(I,y,E,h,d,P)}catch(p){w=p}finally{w&&d.errorTransformer&&(w=d.errorTransformer(w)),typeof w<"u"&&E.error(w),E.end()}}e.readFileIntoStream=D;async function b(I,y,E,h,d,P){u(P);const w=await I.open(y,{create:!1});try{u(P);let p=0,S=0,f=d&&typeof d.length=="number"?d.length:void 0,g=v.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),l=d&&typeof d.position=="number"?d.position:0,r=0;do S=await I.read(w,l,g.buffer,r,g.byteLength-r),l+=S,r+=S,p+=S,typeof f=="number"&&(f-=S),r===g.byteLength&&(await E.write(h(g)),g=v.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),r=0);while(S>0&&(typeof f!="number"||f>0)&&u(P)&&m(p,d));if(r>0){let o=r;typeof f=="number"&&(o=Math.min(r,f)),E.write(h(g.slice(0,o)))}}catch(p){throw(0,R.ensureFileSystemProviderError)(p)}finally{await I.close(w)}}function u(I){if(I.isCancellationRequested)throw(0,t.canceled)();return!0}function m(I,y){if(y?.limits){if(typeof y.limits.memory=="number"&&I>y.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&I>y.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[70],ie([0,1,98,2,9,4,7,14]),function(z,e,v,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function u(p){return p.recursive===!0}e.isRecursiveWatchRequest=u;class m extends t.Disposable{constructor(S,f,g,l){super(),this.onFileChanges=S,this.onLogMessage=f,this.verboseLogging=g,this.options=l,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const S=new t.DisposableStore;this.watcherDisposables.value=S,this.watcher=this.createWatcher(S),this.watcher.setVerboseLogging(this.verboseLogging),S.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),S.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),S.add(this.watcher.onDidError(f=>this.onError(f)))}onError(S){this.options.restartOnError?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${S}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${S}`):this.error(S)}restart(S){this.restartCounter++,this.init(),this.watch(S)}async watch(S){this.requests=S,await this.watcher?.watch(S)}async setVerboseLogging(S){this.verboseLogging=S,await this.watcher?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${S}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.MAX_RESTARTS=5;class I extends m{constructor(S,f,g){super(S,f,g,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class y extends m{constructor(S,f,g){super(S,f,g,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function E(p){return p.map(S=>({type:S.type,resource:D.URI.file(S.path)}))}e.toFileChanges=E;function h(p){const S=new w;for(const f of p)S.processEvent(f);return S.coalesce()}e.coalesceEvents=h;function d(p,S){return typeof S=="string"&&!S.startsWith(v.GLOBSTAR)&&!(0,k.isAbsolute)(S)?{base:p,pattern:S}:S}e.normalizeWatcherPattern=d;function P(p,S){const f=[];for(const g of S)f.push((0,v.parse)(d(p,g)));return f}e.parseWatcherPatterns=P;class w{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(S){return R.isLinux?S.path:S.path.toLowerCase()}processEvent(S){const f=this.mapPathToChange.get(this.toKey(S));let g=!1;if(f){const l=f.type,r=S.type;f.path!==S.path&&(S.type===2||S.type===1)?g=!0:l===1&&r===2?(this.mapPathToChange.delete(this.toKey(S)),this.coalesced.delete(f)):l===2&&r===1?f.type=0:l===1&&r===0||(f.type=r)}else g=!0;g&&(this.coalesced.add(S),this.mapPathToChange.set(this.toKey(S),S))}coalesce(){const S=[],f=[];return Array.from(this.coalesced).filter(g=>g.type!==2?(S.push(g),!1):!0).sort((g,l)=>g.path.length-l.path.length).filter(g=>f.some(l=>(0,b.isParent)(g.path,l,!R.isLinux))?!1:(f.push(g.path),!0)).concat(S)}}}),define(te[197],ie([0,1,40,8,23,30,2,80,9,4,99,21,70]),function(z,e,v,t,k,R,D,b,u,m,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends D.Disposable{constructor(w,p,S,f){super(),this.request=w,this.onDidFilesChange=p,this.onLogMessage=S,this.verboseLogging=f,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},g=>this.onDidFilesChange(g)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(h.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,E.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,E.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const w=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await y.Promises.stat(w);this._register(await this.doWatch(w,p.isDirectory()))}catch(w){w.code!=="ENOENT"?this.error(w):this.trace(w)}}async normalizePath(w){let p=w.path;try{p=await y.Promises.realpath(w.path),w.path===p&&(p=await(0,I.realcase)(w.path)??w.path),w.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${p})`)}catch{}return p}async doWatch(w,p){if(m.isMacintosh&&(0,R.isEqualOrParent)(w,"/Volumes/",!0))return this.error(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const S=new k.CancellationTokenSource(this.cts.token),f=new D.DisposableStore;try{const g=(0,u.basename)(w),l=(0,v.watch)(w);f.add((0,D.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${w}'`);const r=new Set;if(p)try{for(const i of await y.Promises.readdir(w))r.add(i)}catch(i){this.error(i)}const o=new Map;f.add((0,D.toDisposable)(()=>{for(const[,i]of o)i.dispose();o.clear()})),l.on("error",(i,n)=>{this.error(`Failed to watch ${w} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),l.on("change",(i,n)=>{if(S.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${n}`);let s="";if(n&&(s=n.toString(),m.isMacintosh&&(s=(0,b.normalizeNFC)(s))),!(!s||i!=="change"&&i!=="rename"))if(p)if(i==="rename"){o.get(s)?.dispose();const c=setTimeout(async()=>{if(o.delete(s),s===g&&!await y.Promises.exists(w)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,u.join)(w,s));if(S.token.isCancellationRequested)return;let C;a?r.has(s)?C=0:(C=1,r.add(s)):(r.delete(s),C=2),this.onFileChange({path:(0,u.join)(this.request.path,s),type:C})},h.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,D.toDisposable)(()=>clearTimeout(c)))}else{let c;r.has(s)?c=0:(c=1,r.add(s)),this.onFileChange({path:(0,u.join)(this.request.path,s),type:c})}else if(i==="rename"||s!==g){const c=setTimeout(async()=>{const a=await y.Promises.exists(w);S.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),f.add(await this.doWatch(w,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},h.FILE_DELETE_HANDLER_DELAY);f.clear(),f.add((0,D.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(g){await y.Promises.exists(w)&&!S.token.isCancellationRequested&&this.error(`Failed to watch ${w} for changes using fs.watch() (${g.toString()})`)}return(0,D.toDisposable)(()=>{S.dispose(!0),f.dispose()})}async onFileChange(w,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),!p&&this.excludes.some(S=>S(w.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${w.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(S=>S(w.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${w.path}`):this.fileChangesBuffer.push(w);try{await this.fileChangesDelayer.trigger(async()=>{const S=this.fileChangesBuffer;this.fileChangesBuffer=[];const f=(0,E.coalesceEvents)(S);if(f.length>0){if(this.verboseLogging)for(const l of f)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.throttledFileChangesWorker.work(f)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(w){if(m.isLinux)return y.Promises.exists(w);try{const p=(0,u.basename)(w);return(await y.Promises.readdir((0,u.dirname)(w))).some(f=>f===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(w){this.verboseLogging=w}error(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}warn(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}trace(w){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=h,h.FILE_DELETE_HANDLER_DELAY=100,h.FILE_CHANGES_HANDLER_DELAY=50;async function d(P,w,p,S,f=512){const g=await y.Promises.open(P,"r"),l=Buffer.allocUnsafe(f),r=new k.CancellationTokenSource(S);let o,i=!1;const n={path:P,excludes:[],recursive:!1},s=new h(n,c=>{(async()=>{for(const{type:a}of c)if(a===0){if(i)return;i=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:C}=await y.Promises.read(g,l,0,f,null);if(!C||r.token.isCancellationRequested)break;w(l.slice(0,C))}}catch(C){o=new Error(C),r.dispose(!0)}finally{i=!1}}})()});return await s.ready,p(),new Promise((c,a)=>{r.token.onCancellationRequested(async()=>{s.dispose();try{await y.Promises.close(g)}catch(C){o=new Error(C)}o?a(o):c()})})}e.watchFileContents=d}),define(te[198],ie([0,1,3,98,2,4,197]),function(z,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new v.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new v.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=v.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const I=this.normalizeRequests(m),y=I.filter(h=>{const d=this.watchers.get(h.path);return d?!(0,t.patternsEquals)(d.request.excludes,h.excludes)||!(0,t.patternsEquals)(d.request.includes,h.includes):!0}),E=Array.from(this.watchers.values()).filter(({request:h})=>!I.find(d=>d.path===h.path&&(0,t.patternsEquals)(d.excludes,h.excludes)&&(0,t.patternsEquals)(d.includes,h.includes))).map(({request:h})=>h.path);y.length&&this.trace(`Request to start watching: ${y.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),E.length&&this.trace(`Request to stop watching: ${E.join(",")}`);for(const h of E)this.stopWatching(h);for(const h of y)this.startWatching(h)}startWatching(m){const I=new D.NodeJSFileWatcherLibrary(m,E=>this._onDidChangeFile.fire(E),E=>this._onDidLogMessage.fire(E),this.verboseLogging),y={request:m,instance:I};this.watchers.set(m.path,y)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const I=this.watchers.get(m);I&&(this.watchers.delete(m),I.instance.dispose())}normalizeRequests(m){const I=new Map;for(const y of m){const E=R.isLinux?y.path:y.path.toLowerCase();I.set(E,y)}return Array.from(I.values())}async setVerboseLogging(m){this.verboseLogging=m;for(const[,I]of this.watchers)I.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,I){return I?`[File Watcher (node.js)] ${m} (path: ${I.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=b}),define(te[199],ie([0,1,70,198]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends v.AbstractNonRecursiveWatcherClient{constructor(D,b,u){super(D,b,u),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(te[200],ie([0,1,13,46,146,70]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(u,m,I){super(u,m,I),this.init()}createWatcher(u){const m=u.add(new k.Client(v.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(m.onDidProcessExit(({code:I,signal:y})=>this.onError(`terminated by itself with code ${I}, signal: ${y}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(te[85],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(const[R,D]of k)this.set(R,D)}set(k,R){const D=this._entries.get(k);return this._entries.set(k,R),D}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(te[201],ie([0,1,8,17,2,68,191,5,85,94]),function(z,e,v,t,k,R,D,b,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class y extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class E{constructor(w=new u.ServiceCollection,p=!1,S,f=I){this._services=w,this._strict=p,this._parent=S,this._enableTracing=f,this._activeInstantiations=new Set,this._services.set(b.IInstantiationService,this),this._globalGraph=f?S?._globalGraph??new D.Graph(g=>g):void 0}createChild(w){return new E(w,this._strict,this,this._enableTracing)}invokeFunction(w,...p){const S=d.traceInvocation(this._enableTracing,w);let f=!1;try{return w({get:l=>{if(f)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(l,S);if(!r)throw new Error(`[invokeFunction] unknown service '${l}'`);return r}},...p)}finally{f=!0,S.stop()}}createInstance(w,...p){let S,f;return w instanceof R.SyncDescriptor?(S=d.traceCreation(this._enableTracing,w.ctor),f=this._createInstance(w.ctor,w.staticArguments.concat(p),S)):(S=d.traceCreation(this._enableTracing,w),f=this._createInstance(w,p,S)),S.stop(),f}_createInstance(w,p=[],S){const f=b._util.getServiceDependencies(w).sort((r,o)=>r.index-o.index),g=[];for(const r of f){const o=this._getOrCreateServiceInstance(r.id,S);o||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${r.id}.`,!1),g.push(o)}const l=f.length>0?f[0].index:p.length;if(p.length!==l){console.trace(`[createInstance] First service dependency of ${w.name} at position ${l+1} conflicts with ${p.length} static arguments`);const r=l-p.length;r>0?p=p.concat(new Array(r)):p=p.slice(0,l)}return Reflect.construct(w,p.concat(g))}_setServiceInstance(w,p){if(this._services.get(w)instanceof R.SyncDescriptor)this._services.set(w,p);else if(this._parent)this._parent._setServiceInstance(w,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){const p=this._services.get(w);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):p}_getOrCreateServiceInstance(w,p){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(w));const S=this._getServiceInstanceOrDescriptor(w);return S instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,S,p.branch(w,!0)):(p.branch(w,!1),S)}_safeCreateAndCacheServiceInstance(w,p,S){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,p,S)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,p,S){const f=new D.Graph(r=>r.id.toString());let g=0;const l=[{id:w,desc:p,_trace:S}];for(;l.length;){const r=l.pop();if(f.lookupOrInsertNode(r),g++>1e3)throw new y(f);for(const o of b._util.getServiceDependencies(r.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(o.id);if(i||this._throwIfStrict(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(o.id)),i instanceof R.SyncDescriptor){const n={id:o.id,desc:i,_trace:r._trace.branch(o.id,!0)};f.insertEdge(r,n),l.push(n)}}}for(;;){const r=f.roots();if(r.length===0){if(!f.isEmpty())throw new y(f);break}for(const{data:o}of r){if(this._getServiceInstanceOrDescriptor(o.id)instanceof R.SyncDescriptor){const n=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,n)}f.removeNode(o)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,p,S=[],f,g){if(this._services.get(w)instanceof R.SyncDescriptor)return this._createServiceInstance(w,p,S,f,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,p,S,f,g);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(w,p,S=[],f,g){if(f){const l=new E(void 0,this._strict,this,this._enableTracing);l._globalGraphImplicitDependency=String(w);const r=new Map,o=new v.IdleValue(()=>{const i=l._createInstance(p,S,g);for(const[n,s]of r){const c=i[n];if(typeof c=="function")for(const a of s)c.apply(i,a)}return r.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!o.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let a=r.get(n);return a||(a=new m.LinkedList,r.set(n,a)),(M,T,U)=>{const Q=a.push([M,T,U]);return(0,k.toDisposable)(Q)}}if(n in i)return i[n];const s=o.value;let c=s[n];return typeof c!="function"||(c=c.bind(s),i[n]=c),c},set(i,n,s){return o.value[n]=s,!0}})}else return this._createInstance(p,S,g)}_throwIfStrict(w,p){if(p&&console.warn(w),this._strict)throw new Error(w)}}e.InstantiationService=E;var h;(function(P){P[P.Creation=0]="Creation",P[P.Invocation=1]="Invocation",P[P.Branch=2]="Branch"})(h||(h={}));class d{static traceInvocation(w,p){return w?new d(1,p.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d._None}static traceCreation(w,p){return w?new d(0,p.name):d._None}constructor(w,p){this.type=w,this.name=p,this._start=Date.now(),this._dep=[]}branch(w,p){const S=new d(2,w.toString());return this._dep.push([w,p,S]),S}stop(){const w=Date.now()-this._start;d._totals+=w;let p=!1;function S(g,l){const r=[],o=new Array(g+1).join("	");for(const[i,n,s]of l._dep)if(n&&s){p=!0,r.push(`${o}CREATES -> ${i}`);const c=S(g+1,s);c&&r.push(c)}else r.push(`${o}uses -> ${i}`);return r.join(`
`)}const f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(w>2||p)&&d.all.add(f.join(`
`))}}e.Trace=d,d.all=new Set,d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(te[6],ie([0,1,44,3,2,4,5]),function(z,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function b(){return new Date().toISOString()}var u;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(u=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=u.Info;function m(o,i,n){switch(i){case u.Trace:o.trace(n);break;case u.Debug:o.debug(n);break;case u.Info:o.info(n);break;case u.Warning:o.warn(n);break;case u.Error:o.error(n);break;case u.Critical:o.critical(n);break;default:throw new Error("Invalid log level")}}e.log=m;function I(o){let i="";for(let n=0;n<o.length;n++){let s=o[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}i+=(n>0?" ":"")+s}return i}e.format=I;class y extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class E extends y{constructor(i){super(),this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(u.Trace)&&this.log(u.Trace,I([i,...n]))}debug(i,...n){this.checkLogLevel(u.Debug)&&this.log(u.Debug,I([i,...n]))}info(i,...n){this.checkLogLevel(u.Info)&&this.log(u.Info,I([i,...n]))}warn(i,...n){this.checkLogLevel(u.Warning)&&this.log(u.Warning,I([i,...n]))}error(i,...n){if(this.checkLogLevel(u.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(u.Error,I(s))}else this.log(u.Error,I([i,...n]))}critical(i,...n){this.checkLogLevel(u.Critical)&&this.log(u.Critical,I([i,...n]))}flush(){}}e.AbstractMessageLogger=E;class h extends y{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i),this.useColors=!R.isWindows}trace(i,...n){this.getLevel()<=u.Trace&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,i,...n):console.log(`[main ${b()}]`,i,...n))}debug(i,...n){this.getLevel()<=u.Debug&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,i,...n):console.log(`[main ${b()}]`,i,...n))}info(i,...n){this.getLevel()<=u.Info&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,i,...n):console.log(`[main ${b()}]`,i,...n))}warn(i,...n){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,i,...n):console.warn(`[main ${b()}]`,i,...n))}error(i,...n){this.getLevel()<=u.Error&&(this.useColors?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,i,...n):console.error(`[main ${b()}]`,i,...n))}critical(i,...n){this.getLevel()<=u.Critical&&(this.useColors?console.error(`\x1B[90m[main ${b()}]\x1B[0m`,i,...n):console.error(`[main ${b()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class d extends y{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i)}trace(i,...n){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class P extends y{constructor(i,n=e.DEFAULT_LOG_LEVEL){super(),this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,v.toErrorMessage)(i,this.getLevel()<=u.Trace)}dispose(){}flush(){}}e.AdapterLogger=P;class w extends y{constructor(i){super(),this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const s of this.logServices)s.trace(i,...n)}debug(i,...n){for(const s of this.logServices)s.debug(i,...n)}info(i,...n){for(const s of this.logServices)s.info(i,...n)}warn(i,...n){for(const s of this.logServices)s.warn(i,...n)}error(i,...n){for(const s of this.logServices)s.error(i,...n)}critical(i,...n){for(const s of this.logServices)s.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=w;class p extends k.Disposable{constructor(i){super(),this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=p;class S extends k.Disposable{constructor(i,n){super(),this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,n?.always?u.Trace:this.logLevel,n),this.loggers.set(i.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class f{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return u.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=f;function g(o){if(o.verbose)return u.Trace;if(typeof o.logLevel=="string"){const i=l(o.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function l(o){switch(o){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}e.parseLogLevel=l;function r(o){switch(o){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}e.LogLevelToString=r});var ee=this&&this.__param||function(z,e){return function(v,t){e(v,t,z)}};define(te[202],ie([0,1,69,3,2,6,4,8]),function(z,e,v,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let u=class Et extends k.Disposable{constructor(I){super(),this.logService=I,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(I,y){this.logService.trace("Getting password from keytar:",I,y);let E;try{E=await this.withKeytar()}catch{return null}const h=await(0,b.retry)(()=>E.getPassword(I,y),50,3);if(!h)return this.logService.trace("Did not get a password from keytar for account:",y),h;let d,P;try{const w=JSON.parse(h);d=w.content,P=w.hasNextChunk}catch{}if(!d||!P)return this.logService.trace("Got password from keytar for account:",y),h;try{let w=1;for(;P;){const p=await(0,b.retry)(()=>E.getPassword(I,`${y}-${w}`),50,3),S=JSON.parse(p);d+=S.content,P=S.hasNextChunk,w++}return this.logService.trace(`Got ${w}-chunked password from keytar for account:`,y),d}catch(w){return this.logService.error(w),h}}async setPassword(I,y,E){this.logService.trace("Setting password using keytar:",I,y);let h;try{h=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}if(D.isWindows&&E.length>Et.MAX_PASSWORD_LENGTH){let d=0,P=0,w=!0;for(;w;){const p=E.substring(d,d+Et.PASSWORD_CHUNK_SIZE);d+=Et.PASSWORD_CHUNK_SIZE,w=E.length-d>0;const S={content:p,hasNextChunk:w};await(0,b.retry)(()=>h.setPassword(I,P?`${y}-${P}`:y,JSON.stringify(S)),50,3),P++}this.logService.trace(`Got${P?` ${P}-chunked`:""} password from keytar for account:`,y)}else await(0,b.retry)(()=>h.setPassword(I,y,E),50,3),this.logService.trace("Got password from keytar for account:",y);this._onDidChangePassword.fire({service:I,account:y})}async deletePassword(I,y){this.logService.trace("Deleting password using keytar:",I,y);let E;try{E=await this.withKeytar()}catch(p){throw this.surfaceKeytarLoadError?.(p),p}const h=await E.getPassword(I,y);if(!h)return this.logService.trace("Did not get a password to delete from keytar for account:",y),!1;let d,P;try{const p=JSON.parse(h);d=p.content,P=p.hasNextChunk}catch{}let w=0;if(d&&P)try{for(w++;P;){const p=`${y}-${w}`,S=await E.getPassword(I,p);await E.deletePassword(I,p),P=JSON.parse(S).hasNextChunk,w++}}catch(p){this.logService.error(p)}return await E.deletePassword(I,y)?(this._onDidChangePassword.fire({service:I,account:y}),this.logService.trace(`Deleted${w?` ${w}-chunked`:""} password from keytar for account:`,y),!0):(this.logService.trace(`Keytar failed to delete${w?` ${w}-chunked`:""} password for account:`,y),!1)}async findPassword(I){let y;try{y=await this.withKeytar()}catch{return null}return await y.findPassword(I)}async findCredentials(I){let y;try{y=await this.withKeytar()}catch{return[]}return await y.findCredentials(I)}clear(){return this._keytarCache instanceof v.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};u.MAX_PASSWORD_LENGTH=2500,u.PASSWORD_CHUNK_SIZE=u.MAX_PASSWORD_LENGTH-100,u=ve([ee(0,R.ILogService)],u),e.BaseCredentialsMainService=u}),define(te[203],ie([0,1,24,8,17,3,2,9,70,6]),function(z,e,v,t,k,R,D,b,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends D.Disposable{constructor(E,h){super(),this.logService=E,this.options=h,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(E,h){return h.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(E,h):this.watchNonRecursive(E,h)}watchUniversal(E,h){const d={path:this.toFilePath(E),excludes:h.excludes,includes:h.includes,recursive:h.recursive},P=(0,v.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{P(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(E=>(0,k.onUnexpectedError)(E))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(h=>this._onDidChangeFile.fire((0,u.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const E=this.options?.watcher?.recursive?.usePolling;if(E===!0)for(const h of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const h of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(h)&&E.includes(h.path)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(E,h){const d={path:this.toFilePath(E),excludes:h.excludes,includes:h.includes,recursive:!1},P=(0,v.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{P(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(E=>(0,k.onUnexpectedError)(E))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(E=>this._onDidChangeFile.fire((0,u.toFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(E){E.type==="error"&&this._onDidWatchError.fire(E.message),this.logService[E.type](E.message)}toFilePath(E){return(0,b.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(te[204],ie([0,1,24,8,18,23,3,66,57,2,31,13,71,16,58,158,14,107,6]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let f=class extends m.Disposable{constructor(l){super(),this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(l,r){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${l}`);const o=new m.DisposableStore;return this.provider.set(l,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:r}),o.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new w.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&o.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),o.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:l}))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:r}),this.provider.delete(l),(0,m.dispose)(o)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(o){r.push(o)}}),!this.provider.has(l)&&await t.Promises.settled(r)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,r){const o=this.provider.get(l.scheme);return!!(o&&o.capabilities&r)}listCapabilities(){return u.Iterable.map(this.provider,([l,r])=>({scheme:l,capabilities:r.capabilities}))}async withProvider(l){if(!(0,h.isAbsolutePath)(l))throw new w.FileOperationError((0,P.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const r=this.provider.get(l.scheme);if(!r){const o=new Error;throw o.name="ENOPRO",o.message=(0,P.localize)(1,null,l.toString()),o}return r}async withReadProvider(l){const r=await this.withProvider(l);if((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r)||(0,w.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const r=await this.withProvider(l);if((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,r){try{return await this.doResolveFile(l,r)}catch(o){throw(0,w.toFileSystemProviderErrorCode)(o)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,P.localize)(2,null,this.resourceForError(l)),1):(0,w.ensureFileSystemProviderError)(o)}}async doResolveFile(l,r){const o=await this.withProvider(l),i=this.isPathCaseSensitive(o),n=r?.resolveTo,s=r?.resolveSingleChildDescendants,c=r?.resolveMetadata,a=await o.stat(l);let C;return this.toFileStat(o,l,a,void 0,!!c,(M,T)=>(C||(C=I.TernarySearchTree.forUris(()=>!i),C.set(l,!0),n&&C.fill(!0,n)),C.get(M.resource)||C.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&s?T===1:!1))}async toFileStat(l,r,o,i,n,s){const{providerExtUri:c}=this.getExtUri(l),a={resource:r,name:c.basename(r),isFile:(o.type&w.FileType.File)!==0,isDirectory:(o.type&w.FileType.Directory)!==0,isSymbolicLink:(o.type&w.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&w.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,w.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(a.isDirectory&&s(a,i)){try{const C=await l.readdir(r),M=await t.Promises.settled(C.map(async([T,U])=>{try{const Q=c.joinPath(r,T),ae=n?await l.stat(Q):{type:U};return await this.toFileStat(l,Q,ae,C.length,n,s)}catch(Q){return this.logService.trace(Q),null}}));a.children=(0,v.coalesce)(M)}catch(C){this.logService.trace(C),a.children=[]}return a}return a}async resolveAll(l){return t.Promises.settled(l.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(l){const r=await this.withProvider(l),o=await r.stat(l);return this.toFileStat(r,l,o,void 0,!0,()=>!1)}async exists(l){const r=await this.withProvider(l);try{return!!await r.stat(l)}catch{return!1}}async canCreateFile(l,r){try{await this.doValidateCreateFile(l,r)}catch(o){return o}return!0}async doValidateCreateFile(l,r){if(!r?.overwrite&&await this.exists(l))throw new w.FileOperationError((0,P.localize)(3,null,this.resourceForError(l)),3,r)}async createFile(l,r=k.VSBuffer.fromString(""),o){await this.doValidateCreateFile(l,o);const i=await this.writeFile(l,r);return this._onDidRunOperation.fire(new w.FileOperationEvent(l,0,i)),i}async writeFile(l,r,o){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,l,o)||await this.mkdirp(i,n.dirname(l));let c;if((0,w.hasReadWriteCapability)(i)&&!(r instanceof k.VSBuffer))if((0,d.isReadableStream)(r)){const a=await(0,d.peekStream)(r,3);a.ended?c=k.VSBuffer.concat(a.buffer):c=a}else c=(0,d.peekReadable)(r,a=>k.VSBuffer.concat(a),3);else c=r;!(0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i)&&c instanceof k.VSBuffer?await this.doWriteUnbuffered(i,l,o,c):await this.doWriteBuffered(i,l,o,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this._onDidRunOperation.fire(new w.FileOperationEvent(l,4))}catch(s){throw new w.FileOperationError((0,P.localize)(4,null,this.resourceForError(l),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),o)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,r,o){if(!!o?.unlock&&!(l.capabilities&8192))throw new Error((0,P.localize)(5,null,this.resourceForError(r)));let n;try{n=await l.stat(r)}catch{return}if((n.type&w.FileType.Directory)!==0)throw new w.FileOperationError((0,P.localize)(6,null,this.resourceForError(r)),0,o);if(this.throwIfFileIsReadonly(r,n),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==w.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&o.mtime<n.mtime&&o.etag!==(0,w.etag)({mtime:o.mtime,size:n.size}))throw new w.FileOperationError((0,P.localize)(7,null),3,o);return n}async readFile(l,r,o){const i=await this.withReadProvider(l);return r?.atomic?this.doReadFileAtomic(i,l,r,o):this.doReadFile(i,l,r,o)}async doReadFileAtomic(l,r,o,i){return new Promise((n,s)=>{this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(l,r,o,i);n(c)}catch(c){s(c)}})})}async doReadFile(l,r,o,i){const n=await this.doReadFileStream(l,r,{...o,preferUnbuffered:!0},i);return{...n,value:await(0,k.streamToBuffer)(n.value)}}async readFileStream(l,r,o){const i=await this.withReadProvider(l);return this.doReadFileStream(i,l,r,o)}async doReadFileStream(l,r,o,i){const n=new R.CancellationTokenSource(i),s=this.validateReadFile(r,o).then(a=>a,a=>{throw n.cancel(),a});let c;try{return typeof o?.etag=="string"&&o.etag!==w.ETAG_DISABLED&&await s,o?.atomic&&(0,w.hasFileAtomicReadCapability)(l)||!((0,w.hasOpenReadWriteCloseCapability)(l)||(0,w.hasFileReadStreamCapability)(l))||(0,w.hasReadWriteCapability)(l)&&o?.preferUnbuffered?c=this.readFileUnbuffered(l,r,o):(0,w.hasFileReadStreamCapability)(l)?c=this.readFileStreamed(l,r,n.token,o):c=this.readFileBuffered(l,r,n.token,o),{...await s,value:c}}catch(a){c&&await(0,d.consumeStream)(c);const C=(0,P.localize)(8,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(a).toString());throw a instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(C,a.stat,o):new w.FileOperationError(C,(0,w.toFileOperationResult)(a),o)}}readFileStreamed(l,r,o,i=Object.create(null)){const n=l.readFileStream(r,i,o);return(0,d.transform)(n,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new w.FileOperationError((0,P.localize)(9,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),i)},s=>k.VSBuffer.concat(s))}readFileBuffered(l,r,o,i=Object.create(null)){const n=(0,k.newWriteableBufferStream)();return(0,p.readFileIntoStream)(l,r,n,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new w.FileOperationError((0,P.localize)(10,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),i)},o),n}readFileUnbuffered(l,r,o){const i=(0,d.newWriteableStream)(n=>k.VSBuffer.concat(n));return(async()=>{try{let n;o?.atomic&&(0,w.hasFileAtomicReadCapability)(l)?n=await l.readFile(r,{atomic:!0}):n=await l.readFile(r),typeof o?.position=="number"&&(n=n.slice(o.position)),typeof o?.length=="number"&&(n=n.slice(0,o.length)),this.validateReadFileLimits(r,n.byteLength,o),i.end(k.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(l,r){const o=await this.resolve(l,{resolveMetadata:!0});if(o.isDirectory)throw new w.FileOperationError((0,P.localize)(11,null,this.resourceForError(l)),0,r);if(typeof r?.etag=="string"&&r.etag!==w.ETAG_DISABLED&&r.etag===o.etag)throw new w.NotModifiedSinceFileOperationError((0,P.localize)(12,null),o,r);return this.validateReadFileLimits(l,o.size,r),o}validateReadFileLimits(l,r,o){if(o?.limits){let i;if(typeof o.limits.memory=="number"&&r>o.limits.memory&&(i=9),typeof o.limits.size=="number"&&r>o.limits.size&&(i=7),typeof i=="number")throw new w.FileOperationError((0,P.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,r,o){return this.doCanMoveCopy(l,r,"move",o)}async canCopy(l,r,o){return this.doCanMoveCopy(l,r,"copy",o)}async doCanMoveCopy(l,r,o,i){if(l.toString()!==r.toString())try{const n=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,l,s,r,o,i)}catch(n){return n}return!0}async move(l,r,o){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,l,n,r,"move",!!o),c=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,s==="move"?2:3,c)),c}async copy(l,r,o){const i=await this.withReadProvider(l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,l,n,r,"copy",!!o),c=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,s==="copy"?3:2,c)),c}async doMoveCopy(l,r,o,i,n,s){if(r.toString()===i.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(l,r,o,i,n,s);if(c&&!a&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(i)),n==="copy"){if(l===o&&(0,w.hasFileFolderCopyCapability)(l))await l.copy(r,i,{overwrite:s});else{const C=await this.resolve(r);C.isDirectory?await this.doCopyFolder(l,C,o,i):await this.doCopyFile(l,r,o,i)}return n}else return l===o?(await l.rename(r,i,{overwrite:s}),n):(await this.doMoveCopy(l,r,o,i,"copy",s),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(l,r,o,i){if((0,w.hasOpenReadWriteCloseCapability)(l)&&(0,w.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(l,r,o,i);if((0,w.hasOpenReadWriteCloseCapability)(l)&&(0,w.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(l,r,o,i);if((0,w.hasReadWriteCapability)(l)&&(0,w.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(l,r,o,i);if((0,w.hasReadWriteCapability)(l)&&(0,w.hasReadWriteCapability)(o))return this.doPipeUnbuffered(l,r,o,i)}async doCopyFolder(l,r,o,i){await o.mkdir(i),Array.isArray(r.children)&&await t.Promises.settled(r.children.map(async n=>{const s=this.getExtUri(o).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(l,await this.resolve(n.resource),o,s):this.doCopyFile(l,n.resource,o,s)}))}async doValidateMoveCopy(l,r,o,i,n,s){let c=!1;if(l===o){const{providerExtUri:C,isPathCaseSensitive:M}=this.getExtUri(l);if(M||(c=C.isEqual(r,i)),c&&n==="copy")throw new Error((0,P.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!c&&C.isEqualOrParent(i,r))throw new Error((0,P.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!c){if(!s)throw new w.FileOperationError((0,P.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(l===o){const{providerExtUri:C}=this.getExtUri(l);if(C.isEqualOrParent(r,i))throw new Error((0,P.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:c}}getExtUri(l){const r=this.isPathCaseSensitive(l);return{providerExtUri:r?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(r,l);const o=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,0,o)),o}async mkdirp(l,r){const o=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(r,i.dirname(r));)try{if(((await l.stat(r)).type&w.FileType.Directory)===0)throw new Error((0,P.localize)(18,null,this.resourceForError(r)));break}catch(n){if((0,w.toFileSystemProviderErrorCode)(n)!==w.FileSystemProviderErrorCode.FileNotFound)throw n;o.push(i.basename(r)),r=i.dirname(r)}for(let n=o.length-1;n>=0;n--){r=i.joinPath(r,o[n]);try{await l.mkdir(r)}catch(s){if((0,w.toFileSystemProviderErrorCode)(s)!==w.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(l,r){try{await this.doValidateDelete(l,r)}catch(o){return o}return!0}async doValidateDelete(l,r){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!r?.useTrash&&!(o.capabilities&4096))throw new Error((0,P.localize)(19,null,this.resourceForError(l)));let n;try{n=await o.stat(l)}catch{}if(n)this.throwIfFileIsReadonly(l,n);else throw new w.FileOperationError((0,P.localize)(20,null,this.resourceForError(l)),1);if(!!!r?.recursive){const c=await this.resolve(l);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,P.localize)(21,null,this.resourceForError(l)))}return o}async del(l,r){const o=await this.doValidateDelete(l,r),i=!!r?.useTrash,n=!!r?.recursive;await o.delete(l,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new w.FileOperationEvent(l,1))}async cloneFile(l,r){const o=await this.withProvider(l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(o===i&&this.getExtUri(o).providerExtUri.isEqual(l,r))return;if(o===i&&(0,w.hasFileCloneCapability)(o))return o.cloneFile(l,r);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(r));const n=this.writeQueue.queueFor(l,this.getExtUri(o).providerExtUri);return o===i&&(0,w.hasFileFolderCopyCapability)(o)?n.queue(()=>o.copy(l,r,{overwrite:!0})):n.queue(()=>this.doCopyFile(o,l,i,r))}watch(l,r={recursive:!1,excludes:[]}){const o=new m.DisposableStore;let i=!1,n=()=>{i=!0};return o.add((0,m.toDisposable)(()=>n())),(async()=>{try{const s=await this.doWatch(l,r);i?(0,m.dispose)(s):n=()=>(0,m.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(l,r){const o=await this.withProvider(l),i=(0,b.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(l),r]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:o.watch(l,r)},this.activeWatchers.set(i,n)),n.count+=1,(0,m.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,m.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,m.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,r,o,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{const n=await l.open(r,{create:!0,unlock:o?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,n,i):await this.doWriteReadableBufferedQueued(l,n,i)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await l.close(n)}})}async doWriteStreamBufferedQueued(l,r,o){let i=0,n;if((0,d.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=k.VSBuffer.concat(o.buffer);await this.doWriteBuffer(l,r,s,s.byteLength,i,0),i+=s.byteLength}if(o.ended)return;n=o.stream}else n=o;return new Promise((s,c)=>{(0,d.listenStream)(n,{onData:async a=>{n.pause();try{await this.doWriteBuffer(l,r,a,a.byteLength,i,0)}catch(C){return c(C)}i+=a.byteLength,setTimeout(()=>n.resume())},onError:a=>c(a),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(l,r,o){let i=0,n;for(;(n=o.read())!==null;)await this.doWriteBuffer(l,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(l,r,o,i,n,s){let c=0;for(;c<i;)c+=await l.write(r,n+c,o.buffer,s+c,i-c)}async doWriteUnbuffered(l,r,o,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,r,o,i))}async doWriteUnbufferedQueued(l,r,o,i){let n;i instanceof k.VSBuffer?n=i:(0,d.isReadableStream)(i)?n=await(0,k.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?n=await(0,k.bufferedStreamToBuffer)(i):n=(0,k.readableToBuffer)(i),await l.writeFile(r,n.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(l,r,o,i){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,r,o,i))}async doPipeBufferedQueued(l,r,o,i){let n,s;try{n=await l.open(r,{create:!1}),s=await o.open(i,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,C=0,M=0;do M=await l.read(n,a,c.buffer,C,c.byteLength-C),await this.doWriteBuffer(o,s,c,M,a,C),a+=M,C+=M,C===c.byteLength&&(C=0);while(M>0)}catch(c){throw(0,w.ensureFileSystemProviderError)(c)}finally{await t.Promises.settled([typeof n=="number"?l.close(n):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(l,r,o,i){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,r,o,i))}async doPipeUnbufferedQueued(l,r,o,i){return o.writeFile(i,await l.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,r,o,i){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,r,o,i))}async doPipeUnbufferedToBufferedQueued(l,r,o,i){const n=await o.open(i,{create:!0,unlock:!1});try{const s=await l.readFile(r);await this.doWriteBuffer(o,n,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await o.close(n)}}async doPipeBufferedToUnbuffered(l,r,o,i){const n=await(0,k.streamToBuffer)(this.readFileBuffered(l,r,R.CancellationToken.None));await this.doWriteUnbuffered(o,i,void 0,n)}throwIfFileSystemIsReadonly(l,r){if(l.capabilities&2048)throw new w.FileOperationError((0,P.localize)(22,null,this.resourceForError(r)),6);return l}throwIfFileIsReadonly(l,r){if((r.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,P.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===y.Schemas.file?l.fsPath:l.toString(!0)}};f=ve([ee(0,S.ILogService)],f),e.FileService=f}),define(te[86],ie([0,1,40,279,8,31,18,3,30,2,9,4,16,58,21,162,14,107,203,44,200,199]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p,S,f,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(v)}catch(o){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(o)}`)}})();class r extends S.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new R.ResourceMap(s=>E.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,y.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:s}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,E.joinPath)(i,c.name))).type:a=this.toType(c),s.push([c.name,a])}catch(a){this.logService.trace(a)}})),s}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let s;return n?.dangling?s=w.FileType.Unknown:i.isFile()?s=w.FileType.File:i.isDirectory()?s=w.FileType.Directory:s=w.FileType.Unknown,n&&(s|=w.FileType.SymbolicLink),s}async createResourceLock(i){const n=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const c=new k.Barrier;return this.resourceLocks.set(i,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,m.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),c.open()})}async readFile(i,n){let s;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),s=await this.createResourceLock(i));const c=this.toFilePath(i);return await d.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{s?.dispose()}}traceLock(i){r.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,n,s){const c=(0,h.newWriteableStream)(a=>D.VSBuffer.concat(a.map(C=>D.VSBuffer.wrap(C))).buffer);return(0,p.readFileIntoStream)(this,i,c,a=>a.buffer,{...n,bufferSize:256*1024},s),c}async writeFile(i,n,s){let c;try{const a=this.toFilePath(i);if(!s.create||!s.overwrite){if(await d.Promises.exists(a)){if(!s.overwrite)throw(0,w.createFileSystemProviderError)((0,P.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,w.createFileSystemProviderError)((0,P.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(c,0,n,0,n.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(i){r.canFlush=i}async open(i,n){const s=this.toFilePath(i);let c;(0,w.isFileOpenForWriteOptions)(n)&&(c=await this.createResourceLock(i));let a;try{if((0,w.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:M}=await d.SymlinkSupport.stat(s);M.mode&128||await d.Promises.chmod(s,M.mode|128)}catch(M){this.logService.trace(M)}let C;if((0,w.isFileOpenForWriteOptions)(n)){if(y.isWindows)try{await d.Promises.truncate(s,0),C="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}C||(C="w")}else C="r";a=await d.Promises.open(s,C)}catch(C){throw c?.dispose(),(0,w.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,C):this.toFileSystemProviderError(C)}if(this.mapHandleToPos.set(a,0),(0,w.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(a,i),c){const C=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${s})`),this.mapHandleToLock.set(a,c),C&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${s})`),C.dispose())}return a}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&r.canFlush)try{await d.Promises.fdatasync(i)}catch(s){r.configureFlushOnWrite(!1),this.logService.error(s)}return await d.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,s,c,a){const C=this.normalizePos(i,n);let M=null;try{M=(await d.Promises.read(i,s,c,a,C)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(i,C,M)}return M}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,s){const c=this.mapHandleToPos.get(i);typeof c=="number"&&(typeof n=="number"||(typeof s=="number"?this.mapHandleToPos.set(i,c+s):this.mapHandleToPos.delete(i)))}async write(i,n,s,c,a){return(0,k.retry)(()=>this.doWrite(i,n,s,c,a),100,3)}async doWrite(i,n,s,c,a){const C=this.normalizePos(i,n);let M=null;try{M=(await d.Promises.write(i,s,c,a,C)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),T)}finally{this.updatePos(i,C,M)}return M}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const s=this.toFilePath(i);n.recursive?await d.Promises.rm(s,d.RimRafMode.MOVE):await d.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(i,n,s){const c=this.toFilePath(i),a=this.toFilePath(n);if(c!==a)try{await this.validateTargetDeleted(i,n,"move",s.overwrite),await d.Promises.move(c,a)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,P.localize)(2,null,(0,I.basename)(c),(0,I.basename)((0,I.dirname)(a)),C.toString()))),this.toFileSystemProviderError(C)}}async copy(i,n,s){const c=this.toFilePath(i),a=this.toFilePath(n);if(c!==a)try{await this.validateTargetDeleted(i,n,"copy",s.overwrite),await d.Promises.copy(c,a,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,P.localize)(3,null,(0,I.basename)(c),(0,I.basename)((0,I.dirname)(a)),C.toString()))),this.toFileSystemProviderError(C)}}async validateTargetDeleted(i,n,s,c){const a=this.toFilePath(i),C=this.toFilePath(n);let M=!1;if(!!(this.capabilities&1024)||(M=(0,u.isEqual)(a,C,!0)),M&&s==="copy")throw(0,w.createFileSystemProviderError)((0,P.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!M&&await d.Promises.exists(C)){if(!c)throw(0,w.createFileSystemProviderError)((0,P.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,s){const c=this.toFilePath(i),a=this.toFilePath(n),C=!!(this.capabilities&1024);if((0,u.isEqual)(c,a,!C))return;const M=new m.DisposableStore;try{const[T,U]=await Promise.all([this.createResourceLock(i),this.createResourceLock(n)]);M.add(T),M.add(U),s&&await d.Promises.mkdir((0,I.dirname)(a),{recursive:!0}),await d.Promises.copyFile(c,a)}catch(T){if(T.code==="ENOENT"&&!s)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(T)}finally{M.dispose()}}createUniversalWatcher(i,n,s){return new g.UniversalWatcherClient(c=>i(c),c=>n(c),s)}createNonRecursiveWatcher(i,n,s){return new l.NodeJSWatcherClient(c=>i(c),c=>n(c),s)}toFileSystemProviderError(i){if(i instanceof w.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=w.FileSystemProviderErrorCode.NoPermissions;break;default:n=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let s=this.toFileSystemProviderError(n);if(i&&s.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await d.SymlinkSupport.stat(this.toFilePath(i));c.mode&128||(s=(0,w.createFileSystemProviderError)(n,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return s}}e.DiskFileSystemProvider=r,r.TRACE_LOG_RESOURCE_LOCKS=!1,r.canFlush=!0}),define(te[205],ie([0,1,3,86,2,18,58,23]),function(z,e,v,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class u extends k.Disposable{constructor(y,E){super(),this.provider=y,this.logService=E,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(y,E,h){const d=this.getUriTransformer(y);switch(E){case"stat":return this.stat(d,h[0]);case"readdir":return this.readdir(d,h[0]);case"open":return this.open(d,h[0],h[1]);case"close":return this.close(h[0]);case"read":return this.read(h[0],h[1],h[2]);case"readFile":return this.readFile(d,h[0],h[1]);case"write":return this.write(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.writeFile(d,h[0],h[1],h[2]);case"rename":return this.rename(d,h[0],h[1],h[2]);case"copy":return this.copy(d,h[0],h[1],h[2]);case"cloneFile":return this.cloneFile(d,h[0],h[1]);case"mkdir":return this.mkdir(d,h[0]);case"delete":return this.delete(d,h[0],h[1]);case"watch":return this.watch(d,h[0],h[1],h[2],h[3]);case"unwatch":return this.unwatch(h[0],h[1])}throw new Error(`IPC Command ${E} not found`)}listen(y,E,h){const d=this.getUriTransformer(y);switch(E){case"fileChange":return this.onFileChange(d,h[0]);case"readFileStream":return this.onReadFileStream(d,h[0],h[1])}throw new Error(`Unknown event ${E}`)}stat(y,E){const h=this.transformIncoming(y,E,!0);return this.provider.stat(h)}readdir(y,E){const h=this.transformIncoming(y,E);return this.provider.readdir(h)}async readFile(y,E,h){const d=this.transformIncoming(y,E,!0),P=await this.provider.readFile(d,h);return R.VSBuffer.wrap(P)}onReadFileStream(y,E,h){const d=this.transformIncoming(y,E,!0),P=new b.CancellationTokenSource,w=new v.Emitter({onLastListenerRemove:()=>{P.cancel()}}),p=this.provider.readFileStream(d,h,P.token);return(0,D.listenStream)(p,{onData:S=>w.fire(R.VSBuffer.wrap(S)),onError:S=>w.fire(S),onEnd:()=>{w.fire("end"),w.dispose(),P.dispose()}}),w.event}writeFile(y,E,h,d){const P=this.transformIncoming(y,E);return this.provider.writeFile(P,h.buffer,d)}open(y,E,h){const d=this.transformIncoming(y,E,!0);return this.provider.open(d,h)}close(y){return this.provider.close(y)}async read(y,E,h){const d=R.VSBuffer.alloc(h),P=0,w=await this.provider.read(y,E,d.buffer,P,h);return[d,w]}write(y,E,h,d,P){return this.provider.write(y,E,h.buffer,d,P)}mkdir(y,E){const h=this.transformIncoming(y,E);return this.provider.mkdir(h)}delete(y,E,h){const d=this.transformIncoming(y,E);return this.provider.delete(d,h)}rename(y,E,h,d){const P=this.transformIncoming(y,E),w=this.transformIncoming(y,h);return this.provider.rename(P,w,d)}copy(y,E,h,d){const P=this.transformIncoming(y,E),w=this.transformIncoming(y,h);return this.provider.copy(P,w,d)}cloneFile(y,E,h){const d=this.transformIncoming(y,E),P=this.transformIncoming(y,h);return this.provider.cloneFile(d,P)}onFileChange(y,E){const h=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(E,this.createSessionFileWatcher(y,h))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(E)),this.sessionToWatcher.delete(E)}});return h.event}async watch(y,E,h,d,P){const w=this.sessionToWatcher.get(E);if(w){const p=this.transformIncoming(y,d),S=w.watch(h,p,P);this.watchRequests.set(E+h,S)}}async unwatch(y,E){const h=y+E,d=this.watchRequests.get(h);d&&((0,k.dispose)(d),this.watchRequests.delete(h))}dispose(){super.dispose();for(const[,y]of this.watchRequests)y.dispose();this.watchRequests.clear();for(const[,y]of this.sessionToWatcher)y.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=u;class m extends k.Disposable{constructor(y,E,h,d){super(),this.uriTransformer=y,this.logService=h,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(E)}registerListeners(y){const E=this._register(new v.Emitter);this._register(E.event(h=>{y.fire(h.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(h=>E.fire(h))),this._register(this.fileWatcher.onDidWatchError(h=>y.fire(h)))}getRecursiveWatcherOptions(y){}getExtraExcludes(y){}watch(y,E,h){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(h.excludes=[...h.excludes,...d]),this.watcherRequests.set(y,this.fileWatcher.watch(E,h)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(y)),this.watcherRequests.delete(y)})}dispose(){super.dispose();for(const[,y]of this.watcherRequests)y.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=m}),define(te[206],ie([0,1,15,161,4,7,14,9,205,140]),function(z,e,v,t,k,R,D,b,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class I extends u.AbstractDiskFileSystemProviderChannel{constructor(h,d,P){super(h,d),this.environmentService=P}getUriTransformer(h){return m.DefaultURITransformer}transformIncoming(h,d){return R.URI.revive(d)}async delete(h,d,P){if(!P.useTrash)return super.delete(h,d,P);const w=this.transformIncoming(h,d),p=(0,b.normalize)(w.fsPath);try{await v.shell.trashItem(p)}catch{throw(0,D.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,b.basename)(p)):(0,t.localize)(1,null,(0,b.basename)(p)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(h,d){return new y(h,d,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=I;class y extends u.AbstractSessionFileWatcher{watch(h,d,P){if(P.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(h,d,P)}}}),define(te[108],ie([0,1,6]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,D){switch(D){case v.LogLevel.Trace:return R.trace;case v.LogLevel.Debug:return R.debug;case v.LogLevel.Info:return R.info;case v.LogLevel.Warning:return R.warn;case v.LogLevel.Error:return R.error;case v.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends v.AbstractLogger{constructor(D=v.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(b=>{this._logger?.setLevel(b)}))}set logger(D){this._logger=D;for(const{level:b,args:u}of this.buffer)t(D,b).apply(D,u);this.buffer=[]}_log(D,...b){this._logger?t(this._logger,D).apply(this._logger,b):this.getLevel()<=D&&this.buffer.push({level:D,args:b})}trace(D,...b){this._log(v.LogLevel.Trace,D,...b)}debug(D,...b){this._log(v.LogLevel.Debug,D,...b)}info(D,...b){this._log(v.LogLevel.Info,D,...b)}warn(D,...b){this._log(v.LogLevel.Warning,D,...b)}error(D,...b){this._log(v.LogLevel.Error,D,...b)}critical(D,...b){this._log(v.LogLevel.Critical,D,...b)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(te[207],ie([0,1,8,18,16,14,5,108,6]),function(z,e,v,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const m=5*R.ByteSize.MB;let I=class extends u.AbstractLogger{constructor(h,d,P,w,p){super(),this.resource=d,this.donotUseFormatters=w,this.fileService=p,this.backupIndex=1,this.setLevel(P),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=u.LogLevel.Trace&&this._log(u.LogLevel.Trace,(0,u.format)(arguments))}debug(){this.getLevel()<=u.LogLevel.Debug&&this._log(u.LogLevel.Debug,(0,u.format)(arguments))}info(){this.getLevel()<=u.LogLevel.Info&&this._log(u.LogLevel.Info,(0,u.format)(arguments))}warn(){this.getLevel()<=u.LogLevel.Warning&&this._log(u.LogLevel.Warning,(0,u.format)(arguments))}error(){if(this.getLevel()<=u.LogLevel.Error){const h=arguments[0];if(h instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=h.stack,this._log(u.LogLevel.Error,(0,u.format)(d))}else this._log(u.LogLevel.Error,(0,u.format)(arguments))}}critical(){this.getLevel()<=u.LogLevel.Critical&&this._log(u.LogLevel.Critical,(0,u.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(h){if(h.fileOperationResult!==3)throw h}}_log(h,d){this.queue.queue(async()=>{await this.initializePromise;let P=await this.loadContent();P.length>m&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(P)),P=""),this.donotUseFormatters?P+=d:P+=`${this.getCurrentTimestamp()} [${this.stringifyLogLevel(h)}] ${d}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(P))})}getCurrentTimestamp(){const h=w=>w<10?`0${w}`:w,d=w=>w<10?`00${w}`:w<100?`0${w}`:w,P=new Date;return`${P.getFullYear()}-${h(P.getMonth()+1)}-${h(P.getDate())} ${h(P.getHours())}:${h(P.getMinutes())}:${h(P.getSeconds())}.${d(P.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(h){switch(h){case u.LogLevel.Critical:return"critical";case u.LogLevel.Debug:return"debug";case u.LogLevel.Error:return"error";case u.LogLevel.Info:return"info";case u.LogLevel.Trace:return"trace";case u.LogLevel.Warning:return"warning"}return""}};I=ve([ee(4,R.IFileService)],I),e.FileLogger=I;let y=class extends u.AbstractLoggerService{constructor(h,d,P){super(h.getLevel(),h.onDidChangeLogLevel),this.instantiationService=d,this.fileService=P}doCreateLogger(h,d,P){const w=new b.BufferLogService(d);return(0,R.whenProviderRegistered)(h,this.fileService).then(()=>w.logger=this.instantiationService.createInstance(I,P?.name||(0,k.basename)(h),h,w.getLevel(),!!P?.donotUseFormatters)),w}};y=ve([ee(0,u.ILogService),ee(1,D.IInstantiationService),ee(2,R.IFileService)],y),e.FileLoggerService=y}),define(te[208],ie([0,1,3,7,6]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(E){this.service=E,this.onDidChangeLogLevel=v.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,h){switch(h){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${h}`)}async call(E,h,d){switch(h){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${h}`)}}e.LogLevelChannel=R;class D{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){D.setLevel(this.channel,E)}static setLevel(E,h){return E.call("setLevel",h)}}e.LogLevelChannelClient=D;class b{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,h){throw new Error(`Event not found: ${h}`)}async call(E,h,d){switch(h){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${h}`)}createLogger(E,h){this.loggers.set(E.toString(),this.loggerService.createLogger(E,h))}consoleLog(E,h){let d=console.log;switch(E){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...h)}log(E,h){const d=this.loggers.get(E.toString());if(!d)throw new Error("Create the logger before logging");for(const[P,w]of h)(0,k.log)(d,P,w)}}e.LoggerChannel=b;class u extends k.AbstractLoggerService{constructor(E,h,d){super(E,h),this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(E,h)=>{this.channel.call("consoleLog",[E,h])}})}doCreateLogger(E,h,d){return new m(this.channel,E,h,d)}}e.LoggerChannelClient=u;class m extends k.AbstractMessageLogger{constructor(E,h,d,P){super(P?.always),this.channel=E,this.file=h,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[h,P]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,h){const d=[[E,h]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(E){this.channel.call("log",[this.file,E])}}class I extends k.LogService{constructor(E,h){super(h),this.parent=E,this._register(E.onDidChangeLogLevel(d=>h.setLevel(d)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=I}),define(te[109],ie([0,1,14,6]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(b,u,m,I,y){try{const E=await new Promise((d,P)=>{z(["spdlog"],d,P)});E.setFlushOn(t.LogLevel.Trace);const h=await E.createAsyncRotatingLogger(b,u,m,I);return y?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(E){console.error(E)}return null}function R(b,u,m){switch(u){case t.LogLevel.Trace:b.trace(m);break;case t.LogLevel.Debug:b.debug(m);break;case t.LogLevel.Info:b.info(m);break;case t.LogLevel.Warning:b.warn(m);break;case t.LogLevel.Error:b.error(m);break;case t.LogLevel.Critical:b.critical(m);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(u,m,I,y,E){super(),this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(u,m,I,y),this._register(this.onDidChangeLogLevel(h=>{this._logger?.setLevel(h)}))}async _createSpdLogLogger(u,m,I,y){const E=I?6:1,h=30/E*v.ByteSize.MB,d=await k(u,m,h,E,y);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:P,message:w}of this.buffer)R(this._logger,P,w);this.buffer=[]}}log(u,m){this._logger?R(this._logger,u,m):this.getLevel()<=u&&this.buffer.push({level:u,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(te[209],ie([0,1,13,16,29,14,207,6,109]),function(z,e,v,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let m=class extends b.AbstractLoggerService{constructor(y,E){super(y.getLevel(),y.onDidChangeLogLevel),this.fileService=E}doCreateLogger(y,E,h){return y.scheme===v.Schemas.file?new u.SpdLogLogger(h?.name||(0,k.generateUuid)(),y.fsPath,!h?.donotRotate,!!h?.donotUseFormatters,E):new D.FileLogger(h?.name??(0,t.basename)(y),y,E,!!h?.donotUseFormatters,this.fileService)}};m=ve([ee(0,b.ILogService),ee(1,R.IFileService)],m),e.LoggerService=m}),define(te[210],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(D){return!v(D)&&!t(D)&&!k(D)}e.isMenubarMenuItemAction=R}),define(te[37],ie([0,1,3,57,2,5]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(m){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...m,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(m),t.Iterable.reduce(this.policies.entries(),(y,[E,h])=>({...y,[E]:h}),{})}getPolicyValue(m){return this.policies.get(m)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(m,[I,y])=>({...m,[I]:{definition:y,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=D;class b{constructor(){this.onDidChange=v.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(te[211],ie([0,1,8,3,57,12,14,6,37]),function(z,e,v,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function m(y,E){const h=[];for(const d of k.Iterable.concat(y.keys(),E.keys()))y.get(d)!==E.get(d)&&h.push(d);return h}let I=class extends u.AbstractPolicyService{constructor(E,h,d){super(),this.file=E,this.fileService=h,this.logService=d,this.throttledDelayer=this._register(new v.ThrottledDelayer(500));const P=t.Event.filter(h.onDidFilesChange,w=>w.affects(E));this._register(h.watch(E)),this._register(P(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(E){await this.refresh()}async read(){const E=new Map;try{const h=await this.fileService.readFile(this.file),d=JSON.parse(h.value.toString());if(!(0,R.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const P of Object.keys(d))this.policyDefinitions[P]&&E.set(P,d[P])}catch(h){h.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",h)}return E}async refresh(){const E=await this.read(),h=m(this.policies,E);this.policies=E,h.length>0&&this._onDidChange.fire(h)}};I=ve([ee(1,D.IFileService),ee(2,b.ILogService)],I),e.FilePolicyService=I}),define(te[212],ie([0,1,3,2,37]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(u){this.service=u,this.disposables=new t.DisposableStore}listen(u,m){switch(m){case"onDidChange":return v.Event.map(this.service.onDidChange,I=>I.reduce((y,E)=>({...y,[E]:this.service.getPolicyValue(E)??null}),{}),this.disposables)}throw new Error(`Event not found: ${m}`)}call(u,m,I){switch(m){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(I)}throw new Error(`Call not found: ${m}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends k.AbstractPolicyService{constructor(u,m){super(),this.channel=m;for(const I in u){const{definition:y,value:E}=u[I];this.policyDefinitions[I]=y,E!==void 0&&this.policies.set(I,E)}this.channel.listen("onDidChange")(I=>{for(const y in I){const E=I[y];E===null?this.policies.delete(y):this.policies.set(y,E)}this._onDidChange.fire(Object.keys(I))})}async initializePolicies(u){const m=await this.channel.call("registerPolicyDefinitions",u);for(const I in m)this.policies.set(I,m[I])}}e.PolicyChannelClient=D}),define(te[54],ie([0,1,13,4,34,16]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const b=t.globals.vscode.context.configuration();if(b)D=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof z?.__$__nodeRequire=="function"){const b=(0,R.dirname)(v.FileAccess.asFileUri("",z));if(D=z.__$__nodeRequire((0,R.joinPath)(b,"product.json").fsPath),k.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const u=z.__$__nodeRequire((0,R.joinPath)(b,"package.json").fsPath);Object.assign(D,{version:u.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(te[20],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[213],ie([0,1,76,6,20]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(b,u){this.productService=b,this.logService=u,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(b,u){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(u);if(!m)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",u),!1;const[,I,y]=m;let E=this.trustedExtensionUrlPublicKeys.get(b);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[b],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",b),!1;this.trustedExtensionUrlPublicKeys.set(b,[...E])}const h=Buffer.from(decodeURIComponent(y),"base64");if(h.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",u),!1;const d=h.slice(0,6),P=h.readUIntBE(0,6),w=Date.now()-P;if(w<0||w>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",u),!1;const p=h.slice(6),S=v.createVerify("SHA256");S.write(d),S.write(Buffer.from(I)),S.end();for(let f=0;f<E.length;f++){let g=E[f];if(g!==null){if(typeof g=="string")try{g=v.createPublicKey({key:Buffer.from(g,"base64"),format:"der",type:"spki"}),E[f]=g}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${f+1} for ${b}:`,l),E[f]=null;continue}if(S.verify(g,p))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",u),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",u),!1}};R=ve([ee(0,k.IProductService),ee(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(te[214],ie([0,1,9,5]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var k;(function(R){function D(b,u="noAbsolutePaths"){for(const m of b.nodes)m.callFrame&&m.callFrame.url&&((0,v.isAbsolute)(m.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(m.callFrame.url))&&(m.callFrame.url=(0,v.join)(u,(0,v.basename)(m.callFrame.url)));return b}R.rewriteAbsolutePaths=D})(k=e.Utils||(e.Utils={}))}),define(te[61],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(te[47],ie([0,1,122,12]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(D,b){v.ok(t.isString(D)),v.ok(t.isObject(b)),v.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,b)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new k}),define(te[215],ie([0,1,3,47]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,m){this.schemasById[k(u)]=m,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;t.Registry.add(e.Extensions.JSONContribution,D)}),define(te[62],ie([0,1,24,3,12,149,19,215,47]),function(z,e,v,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=u.Registry.as(b.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,o=!0){this.registerConfigurations([r],o)}registerConfigurations(r,o=!0){const i=this.doRegisterConfigurations(r,o);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(r){const o=this.doDeregisterConfigurations(r);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:r,remove:o}){const i=[];i.push(...this.doDeregisterConfigurations(o)),i.push(...this.doRegisterConfigurations(r,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,v.distinct)(i)})}registerDefaultConfigurations(r){const o=[],i=[];for(const{overrides:n,source:s}of r)for(const c in n)if(o.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.configurationDefaultsOverrides.get(c),C=a?.valuesSources??new Map;if(s)for(const Q of Object.keys(n[c]))C.set(Q,s);const M={...a?.value||{},...n[c]};this.configurationDefaultsOverrides.set(c,{source:s,value:M,valuesSources:C});const T=(0,D.getLanguageTagSettingPlainKey)(c),U={type:"object",default:M,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:k.isString(s)?void 0:s,defaultValueSource:s};i.push(...P(c)),this.configurationProperties[c]=U,this.defaultLanguageConfigurationOverridesNode.properties[c]=U}else{this.configurationDefaultsOverrides.set(c,{value:n[c],source:s});const a=this.configurationProperties[c];a&&(this.updatePropertyDefaultValue(c,a),this.updateSchema(c,a))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const o=[];for(const{overrides:i,source:n}of r)for(const s in i){const c=this.configurationDefaultsOverrides.get(s),a=k.isString(n)?n:n?.id,C=k.isString(c?.source)?c?.source:c?.source?.id;if(a===C)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const M=this.configurationProperties[s];M&&(this.updatePropertyDefaultValue(s,M),this.updateSchema(s,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const o of r)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,o){const i=[];return r.forEach(n=>{i.push(...this.validateAndRegisterProperties(n,o,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),i}doDeregisterConfigurations(r){const o=[],i=n=>{if(n.properties)for(const s in n.properties){o.push(s);const c=this.configurationProperties[s];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,n.properties[s])}n.allOf?.forEach(s=>i(s))};for(const n of r){i(n);const s=this.configurationContributors.indexOf(n);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(r,o=!0,i,n,s=3){s=k.isUndefinedOrNull(r.scope)?s:r.scope;const c=[],a=r.properties;if(a)for(const M in a){const T=a[M];if(o&&f(M,T)){delete a[M];continue}if(T.source=i,T.defaultDefaultValue=a[M].default,this.updatePropertyDefaultValue(M,T),e.OVERRIDE_PROPERTY_REGEX.test(M)?T.scope=void 0:(T.scope=k.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=k.isUndefinedOrNull(T.restricted)?!!n?.includes(M):T.restricted),a[M].hasOwnProperty("included")&&!a[M].included){this.excludedConfigurationProperties[M]=a[M],delete a[M];continue}else this.configurationProperties[M]=a[M],a[M].policy?.name&&this.policyConfigurations.set(a[M].policy.name,M);!a[M].deprecationMessage&&a[M].markdownDeprecationMessage&&(a[M].deprecationMessage=a[M].markdownDeprecationMessage),c.push(M)}const C=r.allOf;if(C)for(const M of C)c.push(...this.validateAndRegisterProperties(M,o,i,n,s));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const o=i=>{const n=i.properties;if(n)for(const c in n)this.updateSchema(c,n[c]);i.allOf?.forEach(o)};o(r)}updateSchema(r,o){switch(e.allSettings.properties[r]=o,o.scope){case 1:e.applicationSettings.properties[r]=o;break;case 2:e.machineSettings.properties[r]=o;break;case 6:e.machineOverridableSettings.properties[r]=o;break;case 3:e.windowSettings.properties[r]=o;break;case 4:e.resourceSettings.properties[r]=o;break;case 5:e.resourceSettings.properties[r]=o,this.resourceLanguageSettingsSchema.properties[r]=o;break}}removeFromSchema(r,o){switch(delete e.allSettings.properties[r],o.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const o=`[${r}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,i),e.allSettings.properties[o]=i,e.applicationSettings.properties[o]=i,e.machineSettings.properties[o]=i,e.machineOverridableSettings.properties[o]=i,e.windowSettings.properties[o]=i,e.resourceSettings.properties[o]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,o){const i=this.configurationDefaultsOverrides.get(r);let n=i?.value,s=i?.source;k.isUndefined(n)&&(n=o.defaultDefaultValue,s=void 0),k.isUndefined(n)&&(n=p(o.type)),o.default=n,o.defaultValueSource=s}}const h="\\[([^\\]]+)\\]",d=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function P(l){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let o=d.exec(l);for(;o?.length;){const i=o[1].trim();i&&r.push(i),o=d.exec(l)}}return(0,v.distinct)(r)}e.overrideIdentifiersFromKey=P;function w(l){return l.reduce((r,o)=>`${r}[${o}]`,"")}e.keyFromOverrideIdentifiers=w;function p(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const S=new E;u.Registry.add(e.Extensions.Configuration,S);function f(l,r){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?R.localize(7,null,l):S.getConfigurationProperties()[l]!==void 0?R.localize(8,null,l):r.policy?.name&&S.getPolicyConfigurations().get(r.policy?.name)!==void 0?R.localize(9,null,l,r.policy?.name,S.getPolicyConfigurations().get(r.policy?.name)):null:R.localize(6,null)}e.validateProperty=f;function g(){const l=[],r=S.getConfigurationProperties();for(const o of Object.keys(r))l.push([o,r[o].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=g}),define(te[110],ie([0,1,24,3,43,2,31,50,12,7,19,62,47]),function(z,e,v,t,k,R,D,b,u,m,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class h{constructor(r={},o=[],i=[],n){this._contents=r,this._keys=o,this._overrides=i,this.raw=n,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(o=>{if(o instanceof h)return o;const i=new d("");return i.parseRaw(o),i.configurationModel});this._rawConfiguration=r.reduce((o,i)=>i===o?i:o.merge(i),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,I.getConfigurationValue)(this.contents,r):this.contents}inspect(r,o){const i=this.rawConfiguration.getValue(r),n=o?this.rawConfiguration.getOverrideValue(r,o):void 0,s=o?this.rawConfiguration.override(o).getValue(r):i;return{value:i,override:n,merged:s}}getOverrideValue(r,o){const i=this.getContentsForOverrideIdentifer(o);return i?r?(0,I.getConfigurationValue)(i,r):i:void 0}getKeysForOverrideIdentifier(r){const o=[];for(const i of this.overrides)i.identifiers.includes(r)&&o.push(...i.keys);return v.distinct(o)}getAllOverrideIdentifiers(){const r=[];for(const o of this.overrides)r.push(...o.identifiers);return v.distinct(r)}override(r){let o=this.overrideConfigurations.get(r);return o||(o=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,o)),o}merge(...r){const o=b.deepClone(this.contents),i=b.deepClone(this.overrides),n=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const c of r)if(s.push(...c.raw?.length?c.raw:[c]),!c.isEmpty()){this.mergeContents(o,c.contents);for(const a of c.overrides){const[C]=i.filter(M=>v.equals(M.identifiers,a.identifiers));C?(this.mergeContents(C.contents,a.contents),C.keys.push(...a.keys),C.keys=v.distinct(C.keys)):i.push(b.deepClone(a))}for(const a of c.keys)n.indexOf(a)===-1&&n.push(a)}return new h(o,n,i,s.every(c=>c instanceof h)?void 0:s)}freeze(){return this.frozen=!0,this}clone(){return new h(b.deepClone(this.contents),[...this.keys],b.deepClone(this.overrides))}createOverrideConfigurationModel(r){const o=this.getContentsForOverrideIdentifer(r);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const i={};for(const n of v.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[n];const c=o[n];c&&(typeof s=="object"&&typeof c=="object"?(s=b.deepClone(s),this.mergeContents(s,c)):s=c),i[n]=s}return new h(i,this.keys,this.overrides)}mergeContents(r,o){for(const i of Object.keys(o)){if(i in r&&u.isObject(r[i])&&u.isObject(o[i])){this.mergeContents(r[i],o[i]);continue}r[i]=b.deepClone(o[i])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?b.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let o=null,i=null;const n=s=>{s&&(i?this.mergeContents(i,s):i=b.deepClone(s))};for(const s of this.overrides)v.equals(s.identifiers,[r])?o=s.contents:s.identifiers.includes(r)&&n(s.contents);return n(o),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,o){this.addKey(r),(0,I.addToValueTree)(this.contents,r,o,i=>{throw new Error(i)})}removeValue(r){this.removeKey(r)&&(0,I.removeFromValueTree)(this.contents,r)}addKey(r){let o=this.keys.length;for(let i=0;i<o;i++)r.indexOf(this.keys[i])===0&&(o=i);this.keys.splice(o,1,r)}removeKey(r){const o=this.keys.indexOf(r);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=h;class d{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,o){if(!u.isUndefinedOrNull(r)){const i=this.doParseContent(r);this.parseRaw(i,o)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,o){this._raw=r;const{contents:i,keys:n,overrides:s,restricted:c,hasExcludedProperties:a}=this.doParseRaw(r,o);this._configurationModel=new h(i,n,s,a?[r]:void 0),this._restrictedConfigurations=c||[]}doParseContent(r){let o={},i=null,n=[];const s=[],c=[];function a(M){Array.isArray(n)?n.push(M):i!==null&&(n[i]=M)}const C={onObjectBegin:()=>{const M={};a(M),s.push(n),n=M,i=null},onObjectProperty:M=>{i=M},onObjectEnd:()=>{n=s.pop()},onArrayBegin:()=>{const M=[];a(M),s.push(n),n=M,i=null},onArrayEnd:()=>{n=s.pop()},onLiteralValue:a,onError:(M,T,U)=>{c.push({error:M,offset:T,length:U})}};if(r)try{k.visit(r,C),o=n[0]||{}}catch(M){console.error(`Error while parsing settings file ${this._name}: ${M}`),this._parseErrors=[M]}return o}doParseRaw(r,o){const i=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),n=this.filter(r,i,!0,o);r=n.raw;const s=(0,I.toValuesTree)(r,C=>console.error(`Conflict in settings file ${this._name}: ${C}`)),c=Object.keys(r),a=this.toOverrides(r,C=>console.error(`Conflict in settings file ${this._name}: ${C}`));return{contents:s,keys:c,overrides:a,restricted:n.restricted,hasExcludedProperties:n.hasExcludedProperties}}filter(r,o,i,n){let s=!1;if(!n?.scopes&&!n?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:s};const c={},a=[];for(const C in r)if(y.OVERRIDE_PROPERTY_REGEX.test(C)&&i){const M=this.filter(r[C],o,!1,n);c[C]=M.raw,s=s||M.hasExcludedProperties,a.push(...M.restricted)}else{const M=o[C],T=M?typeof M.scope<"u"?M.scope:3:void 0;M?.restricted&&a.push(C),(T===void 0||n.scopes===void 0||n.scopes.includes(T))&&!(n.skipRestricted&&M?.restricted)?c[C]=r[C]:s=!0}return{raw:c,restricted:a,hasExcludedProperties:s}}toOverrides(r,o){const i=[];for(const n of Object.keys(r))if(y.OVERRIDE_PROPERTY_REGEX.test(n)){const s={};for(const c in r[n])s[c]=r[n][c];i.push({identifiers:(0,y.overrideIdentifiersFromKey)(n),keys:Object.keys(s),contents:(0,I.toValuesTree)(s,o)})}return i}}e.ConfigurationModelParser=d;class P extends R.Disposable{constructor(r,o,i,n){super(),this.userSettingsResource=r,this.scopes=o,this.fileService=n,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&i.isEqual(s.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class w{constructor(r,o,i,n,s=new h,c=new h,a=new D.ResourceMap,C=new h,M=new D.ResourceMap,T=!0){this._defaultConfiguration=r,this._policyConfiguration=o,this._applicationConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=c,this._folderConfigurations=a,this._memoryConfiguration=C,this._memoryConfigurationByResource=M,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(r,o,i){return this.getConsolidatedConfigurationModel(r,o,i).getValue(r)}updateValue(r,o,i={}){let n;i.resource?(n=this._memoryConfigurationByResource.get(i.resource),n||(n=new h,this._memoryConfigurationByResource.set(i.resource,n))):n=this._memoryConfiguration,o===void 0?n.removeValue(r):n.setValue(r,o),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,o,i){const n=this.getConsolidatedConfigurationModel(r,o,i),s=this.getFolderConfigurationModelForResource(o.resource,i),c=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,a=this._defaultConfiguration.inspect(r,o.overrideIdentifier),C=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(r),M=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(r),T=this.userConfiguration.freeze().inspect(r,o.overrideIdentifier),U=this.localUserConfiguration.freeze().inspect(r,o.overrideIdentifier),Q=this.remoteUserConfiguration.freeze().inspect(r,o.overrideIdentifier),ae=i?this._workspaceConfiguration.freeze().inspect(r,o.overrideIdentifier):void 0,X=s?s.freeze().inspect(r,o.overrideIdentifier):void 0,G=c.inspect(r,o.overrideIdentifier),Z=n.getValue(r),se=v.distinct(n.overrides.map(he=>he.identifiers).flat()).filter(he=>n.getOverrideValue(r,he)!==void 0);return{defaultValue:a?a.merged:void 0,policyValue:C?C.merged:void 0,applicationValue:M?M.merged:void 0,userValue:T?T.merged:void 0,userLocalValue:U?U.merged:void 0,userRemoteValue:Q?Q.merged:void 0,workspaceValue:ae?ae.merged:void 0,workspaceFolderValue:X?X.merged:void 0,memoryValue:G?G.merged:void 0,value:Z,default:a.value!==void 0||a.override!==void 0?{value:a.value,override:a.override}:void 0,policy:C?.value!==void 0?{value:C.value}:void 0,application:M?.value!==void 0||M?.override!==void 0?{value:M.value,override:M.override}:void 0,user:T.value!==void 0||T.override!==void 0?{value:T.value,override:T.override}:void 0,userLocal:U.value!==void 0||U.override!==void 0?{value:U.value,override:U.override}:void 0,userRemote:Q.value!==void 0||Q.override!==void 0?{value:Q.value,override:Q.override}:void 0,workspace:ae?.value!==void 0||ae?.override!==void 0?{value:ae.value,override:ae.override}:void 0,workspaceFolder:X?.value!==void 0||X?.override!==void 0?{value:X.value,override:X.override}:void 0,memory:G.value!==void 0||G.override!==void 0?{value:G.value,override:G.override}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(r){const o=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,o){this._folderConfigurations.set(r,o),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,o){const i=[];if(!o){const{added:n,updated:s,removed:c}=f(this._defaultConfiguration,r);o=[...n,...s,...c]}for(const n of o)for(const s of(0,y.overrideIdentifiersFromKey)(n)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(s),a=r.getKeysForOverrideIdentifier(s),C=[...a.filter(M=>c.indexOf(M)===-1),...c.filter(M=>a.indexOf(M)===-1),...c.filter(M=>!b.equals(this._defaultConfiguration.override(s).getValue(M),r.override(s).getValue(M)))];i.push([s,C])}return this.updateDefaultConfiguration(r),{keys:o,overrides:i}}compareAndUpdatePolicyConfiguration(r){const{added:o,updated:i,removed:n}=f(this._policyConfiguration,r),s=[...o,...i,...n];return s.length&&this.updatePolicyConfiguration(r),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:o,updated:i,removed:n,overrides:s}=f(this.applicationConfiguration,r),c=[...o,...i,...n];return c.length&&this.updateApplicationConfiguration(r),{keys:c,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:o,updated:i,removed:n,overrides:s}=f(this.localUserConfiguration,r),c=[...o,...i,...n];return c.length&&this.updateLocalUserConfiguration(r),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(r){const{added:o,updated:i,removed:n,overrides:s}=f(this.remoteUserConfiguration,r),c=[...o,...i,...n];return c.length&&this.updateRemoteUserConfiguration(r),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(r){const{added:o,updated:i,removed:n,overrides:s}=f(this.workspaceConfiguration,r),c=[...o,...i,...n];return c.length&&this.updateWorkspaceConfiguration(r),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(r,o){const i=this.folderConfigurations.get(r),{added:n,updated:s,removed:c,overrides:a}=f(i,o),C=[...n,...s,...c];return(C.length||!i)&&this.updateFolderConfiguration(r,o),{keys:C,overrides:a}}compareAndDeleteFolderConfiguration(r){const o=this.folderConfigurations.get(r);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:i,updated:n,removed:s,overrides:c}=f(o,void 0);return{keys:[...i,...n,...s],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,o,i){let n=this.getConsolidatedConfigurationModelForResource(o,i);return o.overrideIdentifier&&(n=n.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:r},o){let i=this.getWorkspaceConsolidatedConfiguration();if(o&&r){const n=o.getFolder(r);n&&(i=this.getFolderConsolidatedConfiguration(n.uri)||i);const s=this._memoryConfigurationByResource.get(r);s&&(i=i.merge(s))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let o=this._foldersConsolidatedConfigurations.get(r);if(!o){const i=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(r);n?(o=i.merge(n),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(r,o)):o=i}return o}getFolderConfigurationModelForResource(r,o){if(o&&r){const i=o.getFolder(r);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,o)=>{const{contents:i,overrides:n,keys:s}=this._folderConfigurations.get(o);return r.push([o,{contents:i,overrides:n,keys:s}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>r.add(o)),this.userConfiguration.freeze().keys.forEach(o=>r.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(i=>r.add(i))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>o.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>o.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(r).forEach(n=>o.add(n))),[...o.values()]}static parse(r){const o=this.parseConfigurationModel(r.defaults),i=this.parseConfigurationModel(r.policy),n=this.parseConfigurationModel(r.application),s=this.parseConfigurationModel(r.user),c=this.parseConfigurationModel(r.workspace),a=r.folders.reduce((C,M)=>(C.set(m.URI.revive(M[0]),this.parseConfigurationModel(M[1])),C),new D.ResourceMap);return new w(o,i,n,s,new h,c,a,new h,new D.ResourceMap,!1)}static parseConfigurationModel(r){return new h(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=w;function p(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const r=new Set,o=new Map;for(const n of l)n.keys.forEach(s=>r.add(s)),n.overrides.forEach(([s,c])=>{const a=(0,D.getOrSet)(o,s,new Set);c.forEach(C=>a.add(C))});const i=[];return o.forEach((n,s)=>i.push([s,[...n.values()]])),{keys:[...r.values()],overrides:i}}e.mergeChanges=p;class S{constructor(r,o,i,n){this.change=r,this.previous=o,this.currentConfiguraiton=i,this.currentWorkspace=n,this._previousConfiguration=void 0;const s=new Set;r.keys.forEach(a=>s.add(a)),r.overrides.forEach(([,a])=>a.forEach(C=>s.add(C))),this.affectedKeys=[...s.values()];const c=new h;this.affectedKeys.forEach(a=>c.setValue(a,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(o){const i=this.previousConfiguration?this.previousConfiguration.getValue(r,o,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(r,o,this.currentWorkspace);return!b.equals(i,n)}return!0}return!1}doesAffectedKeysTreeContains(r,o){let i=(0,I.toValuesTree)({[o]:!0},()=>{}),n;for(;typeof i=="object"&&(n=Object.keys(i)[0]);){if(r=r[n],!r)return!1;i=i[n]}return!0}}e.ConfigurationChangeEvent=S;function f(l,r){const{added:o,removed:i,updated:n}=g(r,l),s=[],c=l?.getAllOverrideIdentifiers()||[],a=r?.getAllOverrideIdentifiers()||[];if(r){const C=a.filter(M=>!c.includes(M));for(const M of C)s.push([M,r.getKeysForOverrideIdentifier(M)])}if(l){const C=c.filter(M=>!a.includes(M));for(const M of C)s.push([M,l.getKeysForOverrideIdentifier(M)])}if(r&&l){for(const C of c)if(a.includes(C)){const M=g({contents:l.getOverrideValue(void 0,C)||{},keys:l.getKeysForOverrideIdentifier(C)},{contents:r.getOverrideValue(void 0,C)||{},keys:r.getKeysForOverrideIdentifier(C)});s.push([C,[...M.added,...M.removed,...M.updated]])}}return{added:o,removed:i,updated:n,overrides:s}}function g(l,r){const o=l?r?l.keys.filter(s=>r.keys.indexOf(s)===-1):[...l.keys]:[],i=r?l?r.keys.filter(s=>l.keys.indexOf(s)===-1):[...r.keys]:[],n=[];if(l&&r){for(const s of r.keys)if(l.keys.indexOf(s)!==-1){const c=(0,I.getConfigurationValue)(r.contents,s),a=(0,I.getConfigurationValue)(l.contents,s);b.equals(c,a)||n.push(s)}}return{added:o,removed:i,updated:n}}}),define(te[216],ie([0,1,24,3,2,50,12,19,110,62,6,37,47]),function(z,e,v,t,k,R,D,b,u,m,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class h extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(E.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:S,defaultsOverrides:f})=>this.onDidUpdateConfiguration(S,f))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(S,f){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:S})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=h;class d extends u.ConfigurationModel{constructor(S={}){const f=E.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),g=Object.keys(f),l=Object.create(null),r=[];for(const o in f){const i=S[o],n=i!==void 0?i:f[o].default;(0,b.addToValueTree)(l,o,n,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(l))m.OVERRIDE_PROPERTY_REGEX.test(o)&&r.push({identifiers:(0,m.overrideIdentifiersFromKey)(o),keys:Object.keys(l[o]),contents:(0,b.toValuesTree)(l[o],i=>console.error(`Conflict in default settings file: ${i}`))});super(l,g,r)}}e.DefaultConfigurationModel=d;class P{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new u.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=P;let w=class extends k.Disposable{get configurationModel(){return this._configurationModel}constructor(S,f,g){super(),this.defaultConfiguration=S,this.policyService=f,this.logService=g,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new u.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(S=>this.onDidChangePolicies(S))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:S})=>this.update(await this.registerPolicyDefinitions(S),!0))),this._configurationModel}async registerPolicyDefinitions(S){const f={},g=[],l=E.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const r of S){const o=l[r];if(!o){g.push(r);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}g.push(r),f[o.policy.name]={type:o.type}}}return(0,D.isEmptyObject)(f)||await this.policyService.registerPolicyDefinitions(f),g}onDidChangePolicies(S){const f=E.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),g=(0,v.coalesce)(S.map(l=>f.get(l)));this.update(g,!0)}update(S,f){const g=E.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),l=[],r=this._configurationModel.isEmpty();for(const o of S){const i=g[o]?.policy?.name;if(i){const n=this.policyService.getPolicyValue(i);(r?n!==void 0:!(0,R.equals)(this._configurationModel.getValue(o),n))&&l.push([o,n])}else this._configurationModel.getValue(o)!==void 0&&l.push([o,void 0])}if(l.length){const o=this._configurationModel;this._configurationModel=new u.ConfigurationModel;for(const i of o.keys)this._configurationModel.setValue(i,o.getValue(i));for(const[i,n]of l)n===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,n);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};w=ve([ee(1,y.IPolicyService),ee(2,I.ILogService)],w),e.PolicyConfiguration=w}),define(te[217],ie([0,1,8,3,2,16,19,110,216,37]),function(z,e,v,t,k,R,D,b,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends k.Disposable{constructor(E,h,d,P){super(),this.settingsResource=E,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new u.DefaultConfiguration),this.policyConfiguration=d instanceof m.NullPolicyService?new u.NullPolicyConfiguration:this._register(new u.PolicyConfiguration(this.defaultConfiguration,d,P)),this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,h)),this.configuration=new b.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new b.ConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:w,properties:p})=>this.onDidDefaultConfigurationChange(w,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(w=>this.onDidPolicyConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[E,h,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new b.Configuration(E,h,new b.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(E,h){const d=typeof E=="string"?E:void 0,P=(0,D.isConfigurationOverrides)(E)?E:(0,D.isConfigurationOverrides)(h)?h:{};return this.configuration.getValue(d,P,void 0)}updateValue(E,h,d,P){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const h=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(d,h,2)}onDidDefaultConfigurationChange(E,h){const d=this.configuration.toData(),P=this.configuration.compareAndUpdateDefaultConfiguration(E,h);this.trigger(P,d,7)}onDidPolicyConfigurationChange(E){const h=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(E);this.trigger(d,h,7)}trigger(E,h,d){const P=new b.ConfigurationChangeEvent(E,{data:h},this.configuration);P.source=d,P.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(P)}getTargetConfiguration(E){switch(E){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(te[218],ie([0,1,17,5]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends v.ErrorNoTelemetry{static isTemporarilyNotAvailable(b){return b instanceof R&&b._code===k.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof R&&b._code===k.NoResolverFound}static isHandled(b){return b instanceof R&&b.isHandled}constructor(b,u=k.Unknown,m){super(b),this._message=b,this._code=u,this._detail=m,this.isHandled=u===k.NotAvailable&&m===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R}),define(te[63],ie([0,1,13]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(m){return m.scheme===v.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=t;function k(m){if(!m)return;const I=m.indexOf("+");return I<0?m:m.substr(0,I)}e.getRemoteName=k;function R(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(m){const{host:I,port:y}=u(m);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:y}}e.parseAuthorityWithPort=D;function b(m,I){let{host:y,port:E}=u(m);return typeof E>"u"&&(E=I),{host:y,port:E}}e.parseAuthorityWithOptionalPort=b;function u(m){const I=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const y=m.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const E=m.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:m,port:void 0}}}),define(te[111],ie([0,1,26,5,63]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=R;function D(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));var u;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(u=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,w){if(typeof P>"u"||P===null)return typeof w>"u"||w===null;if(typeof w>"u"||w===null)return!1;if(typeof P=="string"||typeof w=="string"){const p=typeof P=="string"?P:P.value,S=typeof w=="string"?w:w.value;return v.equalsIgnoreCase(p,S)}return P._lower===w._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=m;function I(d){return y(d)}e.isApplicationScopedExtension=I;function y(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function E(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function h(d,P){if(P){const w=`onResolveRemoteAuthority:${(0,k.getRemoteName)(P)}`;return d.activationEvents?.indexOf(w)!==-1}return!1}e.isResolverExtension=h,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[112],ie([0,1,26,192,111,4,7,17,34]),function(z,e,v,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(o,i){return o.uuid&&i.uuid?o.uuid===i.uuid:o.id===i.id?!0:(0,v.compareIgnoreCase)(o.id,i.id)===0}e.areSameExtensions=m;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const n=i.manifest?i.manifest.version:i.version,s=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,n,s)}static parse(i){const n=I.exec(i);return n&&n[1]&&n[2]?new y({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,s="undefined"){this.version=n,this.targetPlatform=s,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?m(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=y;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(o){const i=E.exec(o);return i&&i[1]?[P(i[1]),i[2]]:[P(o),void 0]}e.getIdAndVersion=h;function d(o,i){return`${o}.${i}`}e.getExtensionId=d;function P(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function w(o,i){return P(d(o,i))}e.getGalleryExtensionId=w;function p(o,i){const n=[],s=c=>{for(const a of n)if(a.some(C=>m(i(C),i(c))))return a;return null};for(const c of o){const a=s(c);a?a.push(c):n.push([c])}return n}e.groupByExtension=p;function S(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function f(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function g(o,i){const n=[],s=i.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const c=s.shift();if(c&&n.every(a=>!m(a.identifier,{id:c}))){const a=o.filter(C=>m(C.identifier,{id:c}));a.length===1&&(n.push(a[0]),s.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=g;async function l(o,i){if(!R.isLinux)return!1;let n;try{n=(await o.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await o.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(c))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=l;async function r(o,i){const n=await l(o,i),s=(0,t.getTargetPlatform)(n?"alpine":R.platform,u.arch);return i.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=r}),define(te[72],ie([0,1,8,18,2,31,7,112,14,5,6]),function(z,e,v,t,k,R,D,b,u,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let y=class extends k.Disposable{constructor(h,d){super(),this.fileService=h,this.logService=d,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(h){return this.withProfileExtensions(h)}addExtensionsToProfile(h,d){return this.withProfileExtensions(d,P=>(P=P.filter(w=>h.some(([p])=>!(0,b.areSameExtensions)(w.identifier,p.identifier))),P.push(...h.map(([w,p])=>({identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:p}))),P))}removeExtensionFromProfile(h,d){return this.withProfileExtensions(d,P=>P.filter(w=>!(0,b.areSameExtensions)(w.identifier,h)))}async withProfileExtensions(h,d){return this.getResourceAccessQueue(h).queue(async()=>{let P=[];try{const w=await this.fileService.readFile(h),p=JSON.parse(w.value.toString());for(const S of p){if(!S.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",S);continue}if(!S.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",S);continue}if(!S.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",S);continue}P.push({identifier:S.identifier,location:D.URI.revive(S.location),version:S.version,metadata:S.metadata})}}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}if(d){P=d(P);const w=P.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),metadata:p.metadata}));await this.fileService.writeFile(h,t.VSBuffer.fromString(JSON.stringify(w)))}return P})}getResourceAccessQueue(h){let d=this.resourcesAccessQueueMap.get(h);return d||(d=new v.Queue,this.resourcesAccessQueueMap.set(h,d)),d}};y=ve([ee(0,u.IFileService),ee(1,I.ILogService)],y),e.ExtensionsProfileScannerService=y}),define(te[219],ie([0,1,8,18,23,17,3,2,29,101,218,63]),function(z,e,v,t,k,R,D,b,u,m,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var h;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(h=e.ConnectionType||(e.ConnectionType={}));function d(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function P(B){const $=new k.CancellationTokenSource;return setTimeout(()=>$.cancel(),B),$.token}function w(B,$){if(B.isCancellationRequested||$.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return B.onCancellationRequested(()=>L.cancel()),$.onCancellationRequested(()=>L.cancel()),L.token}class p{get didTimeout(){return this._state==="timedout"}constructor($){this._state="pending",this._disposables=new b.DisposableStore,this.promise=new Promise((L,O)=>{this._resolvePromise=L,this._rejectPromise=O}),$.isCancellationRequested?this._timeout():this._disposables.add($.onCancellationRequested(()=>this._timeout()))}registerDisposable($){this._state==="pending"?this._disposables.add($):$.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const $=new Error("Time limit reached");return $.code="ETIMEDOUT",$.syscall="connect",$}resolve($){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise($))}reject($){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise($))}}function S(B,$){const L=new p($);return L.registerDisposable(B.onControlMessage(O=>{const _=JSON.parse(O.toString()),j=W(_);j?L.reject(j):L.resolve(_)})),L.promise}function f(B,$,L,O,_,j,Y,oe){const q=new p(oe);return $.connect(L,O,_,j,Y,(re,ne)=>{q.didTimeout?(re&&B.error(re),ne?.dispose()):re||!ne?q.reject(re):q.resolve(ne)}),q.promise}function g(B,$){const L=new p($);return B.then(O=>{L.didTimeout||L.resolve(O)},O=>{L.didTimeout||L.reject(O)}),L.promise}async function l(B,$,L,O){const _=N(B,$);B.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let j;try{j=await f(B.logService,B.socketFactory,B.host,B.port,(0,y.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${d($)}-${B.reconnectionToken}`,O)}catch(ne){throw B.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),B.logService.error(ne),ne}B.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let Y,oe;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(j,null),Y=B.reconnectionProtocol,oe=!1):(Y=new m.PersistentProtocol(j,null),oe=!0),B.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const q=await g(B.signService.createNewMessage((0,u.generateUuid)()),O),re={type:"auth",auth:B.connectionToken||"00000000000000000000",data:q.data};Y.sendControl(t.VSBuffer.fromString(JSON.stringify(re)));try{const ne=await S(Y,w(O,P(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const Ae=new Error("Unexpected handshake message");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}if(B.logService.trace(`${_} 4/6. received SignRequest control message.`),!await g(B.signService.validate(q,ne.signedData),O)){const Ae=new Error("Refused to connect to unsupported server");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}const ge=await g(B.signService.sign(ne.data),O),De={type:"connectionType",commit:B.commit,signedData:ge,desiredConnectionType:$};return L&&(De.args=L),B.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(t.VSBuffer.fromString(JSON.stringify(De))),{protocol:Y,ownsProtocol:oe}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(B.logService.error(`${_} the handshake timed out. Error:`),B.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${_} received error control message when negotiating connection. Error:`),B.logService.error(ne)),oe&&H(Y),ne}}async function r(B,$,L,O){const _=Date.now(),j=N(B,$),{protocol:Y,ownsProtocol:oe}=await l(B,$,L,O),q=new p(O);return q.registerDisposable(Y.onControlMessage(re=>{const ne=JSON.parse(re.toString()),ce=W(ne);ce?(B.logService.error(`${j} received error control message when negotiating connection. Error:`),B.logService.error(ce),oe&&H(Y),q.reject(ce)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${J(_)}!`),q.resolve({protocol:Y,firstMessage:ne}))})),q.promise}async function o(B,$){const{protocol:L}=await r(B,1,void 0,$);return{protocol:L}}async function i(B,$,L){const{protocol:O,firstMessage:_}=await r(B,2,$,L),j=_&&_.debugPort;return{protocol:O,debugPort:j}}async function n(B,$,L){const O=Date.now(),_=N(B,3),{protocol:j}=await l(B,3,$,L);return B.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${J(O)}!`),j}async function s(B,$,L){const{host:O,port:_,connectionToken:j}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:O,port:_,connectionToken:j,reconnectionToken:$,reconnectionProtocol:L,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function c(B,$,L){return C(B,async O=>{const{protocol:_}=await o(O,k.CancellationToken.None);return new he(B,$,L,O.reconnectionToken,_)})}e.connectRemoteAgentManagement=c;async function a(B,$){return C(B,async L=>{const{protocol:O,debugPort:_}=await i(L,$,k.CancellationToken.None);return new V(B,$,L.reconnectionToken,O,_)})}e.connectRemoteAgentExtensionHost=a;async function C(B,$){for(let O=1;;O++)try{const _=(0,u.generateUuid)(),j=await s(B,_,null);return await $(j)}catch(_){if(O<5)B.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(_);else throw B.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(_),se.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(_)),_}}async function M(B,$,L){const O=await s(B,(0,u.generateUuid)(),null);return await n(O,{host:$,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function T(B){return(0,v.createCancelablePromise)($=>new Promise((L,O)=>{const _=setTimeout(L,B*1e3);$.onCancellationRequested(()=>{clearTimeout(_),L()})}))}var U;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(U=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class Q{constructor($,L){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=Q;class ae{constructor($,L,O,_){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.durationSeconds=O,this.cancellableTimer=_,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=ae;class X{constructor($,L,O){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=X;class G{constructor($,L,O){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=4}}e.ConnectionGainEvent=G;class Z{constructor($,L,O,_){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.handled=_,this.type=3}}e.ReconnectionPermanentFailureEvent=Z;class se extends b.Disposable{static triggerPermanentFailure($,L,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=$,this._permanentFailureAttempt=L,this._permanentFailureHandled=O,this._instances.forEach(_=>_._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach($=>$._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach($=>$._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}constructor($,L,O,_,j){super(),this._connectionType=$,this._options=L,this.reconnectionToken=O,this.protocol=_,this._reconnectionFailureIsFatal=j,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new G(this.reconnectionToken,0,0)),this._register(_.onSocketClose(Y=>{const oe=F(this._connectionType,this.reconnectionToken,!0);Y?Y.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this._options.logService.error(Y.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this._options.logService.error(Y.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(_.onSocketTimeout(Y=>{const oe=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,b.toDisposable)(()=>{const Y=se._instances.indexOf(this);Y>=0&&se._instances.splice(Y,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const $=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${$} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const _=O<L.length?L[O]:L[L.length-1];try{if(_>0){const Y=T(_);this._onDidStateChange.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,Y)),this._options.logService.info(`${$} waiting for ${_} seconds before reconnecting...`);try{await Y}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${$} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${$} resolving connection...`);const j=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${$} connecting to ${j.host}:${j.port}...`),await this._reconnect(j,P(E)),this._options.logService.info(`${$} reconnected!`),this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${$} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${$} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(j)){this._options.logService.info(`${$} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this._options.logService.info(`${$} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((0,R.isCancellationError)(j)){this._options.logService.info(`${$} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if(j instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${$} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,I.RemoteAuthorityResolverError.isHandled(j));break}this._options.logService.error(`${$} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure($,L,O){this._reconnectionFailureIsFatal?se.triggerPermanentFailure($,L,O):this._gotoPermanentFailure($,L,O)}_gotoPermanentFailure($,L,O){this._onDidStateChange.fire(new Z(this.reconnectionToken,$,L,O)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class he extends se{constructor($,L,O,_,j){super(1,$,_,j,!0),this.client=this._register(new m.Client(j,{remoteAuthority:L,clientId:O},$.ipcLogger))}async _reconnect($,L){await o($,L)}}e.ManagementPersistentConnection=he;class V extends se{constructor($,L,O,_,j){super(2,$,O,_,!1),this._startArguments=L,this.debugPort=j}async _reconnect($,L){await i($,this._startArguments,L)}}e.ExtensionHostPersistentConnection=V;function H(B){try{B.acceptDisconnect();const $=B.getSocket();B.dispose(),$.dispose()}catch($){(0,R.onUnexpectedError)($)}}function W(B){if(B&&B.type==="error"){const $=new Error(`Connection error: ${B.reason}`);return $.code="VSCODE_CONNECTION_ERROR",$}return null}function A(B,$){for(;B.length<$;)B+=" ";return B}function F(B,$,L){return`[remote-connection][${A(d(B),13)}][${$.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function N(B,$){return`${F($,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function J(B){return`${Date.now()-B} ms`}}),define(te[220],ie([0,1,77,83]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,D,b,u,m){const I=E=>m(E,void 0),y=v.createConnection({host:k,port:R},()=>{y.removeListener("error",I);const E=Buffer.alloc(16);for(let w=0;w<16;w++)E[w]=Math.round(Math.random()*256);const h=E.toString("base64"),d=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${D}?${b}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`];y.write(d.join(`\r
`)+`\r
\r
`);const P=w=>{w.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",P),m(void 0,new t.NodeSocket(y,u)))};y.on("data",P)});y.setNoDelay(!0),y.once("error",I)}}}),define(te[221],ie([0,1,25,45,40,183]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function b(h=!1){return(D===void 0||h)&&(D=u()),D}e.hasWSLFeatureInstalled=b;async function u(){const h=m();if(h===void 0)return!1;if(h>=22e3){const d=y();if(d)return new Promise(P=>{t.execFile(d,["--status"],w=>P(!w))})}else{const d=E();if(d)try{if((await k.promises.stat(d)).isFile())return!0}catch{}}return!1}function m(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(v.release());if(h)return parseInt(h[3])}function I(h){const d=process.env.SystemRoot;if(d){const P=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(d,P?"Sysnative":"System32",h)}}function y(){return I("wsl.exe")}function E(){return I("lxss\\LxssManager.dll")}}),define(te[55],ie([0,1,18,166,62,5,47]),function(z,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function b(P){return P.res.statusCode&&P.res.statusCode>=200&&P.res.statusCode<300||P.res.statusCode===1223}e.isSuccess=b;function u(P){return P.res.statusCode===204}async function m(P){return u(P)?null:(await(0,v.streamToBuffer)(P.stream)).toString()}e.asText=m;async function I(P){if(!b(P))throw new Error("Server returned "+P.res.statusCode);return m(P)}e.asTextOrError=I;async function y(P){if(!b(P))throw new Error("Server returned "+P.res.statusCode);if(u(P))return null;const p=(await(0,v.streamToBuffer)(P.stream)).toString();try{return JSON.parse(p)}catch(S){throw S.message+=`:
`+p,S}}e.asJson=y;function E(P){d(P)}e.updateProxyConfigurationsScope=E;let h;function d(P){const w=D.Registry.as(k.Extensions.Configuration),p=h;h={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:P,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[h],remove:p?[p]:[]})}d(2)}),define(te[222],ie([0,1,18,23]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(b){this.service=b}listen(b,u){throw new Error("Invalid listen")}call(b,u,m,I=t.CancellationToken.None){switch(u){case"request":return this.service.request(m[0],I).then(async({res:y,stream:E})=>{const h=await(0,v.streamToBuffer)(E);return[{statusCode:y.statusCode,headers:y.headers},h]});case"resolveProxy":return this.service.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(b){this.channel=b}async request(b,u){const[m,I]=await this.channel.call("request",[b],u);return{res:m,stream:(0,v.bufferToStream)(I)}}async resolveProxy(b){return this.channel.call("resolveProxy",[b])}}e.RequestChannelClient=R}),define(te[223],ie([0,1,224,12]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(D,b){return D.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:D.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function R(D,b,u={}){const m=(0,v.parse)(D),I=u.proxyUrl||k(m,b);if(!I)return null;const y=(0,v.parse)(I);if(!/^https?:$/.test(y.protocol||""))return null;const E={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,t.isBoolean)(u.strictSSL)?u.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((h,d)=>{z(["http-proxy-agent"],h,d)}))(E):new(await new Promise((h,d)=>{z(["https-proxy-agent"],h,d)}))(E)}e.getProxyAgent=R}),define(te[113],ie([0,1,45,9,167,23,44,17,4,29,143,59,8]),function(z,e,v,t,k,R,D,b,u,m,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const h=1e4;let d;async function P(p,S,f){return S["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(f)&&!S["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(f)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=E.Promises.withAsyncBody(async(g,l)=>{const r=new R.CancellationTokenSource,o=setTimeout(()=>{r.dispose(!0),l(new Error((0,k.localize)(0,null)))},h);try{g(await w(p,r.token))}catch(i){!(0,b.isCancellationError)(i)&&!r.token.isCancellationRequested?l(new Error((0,k.localize)(1,null,(0,D.toErrorMessage)(i)))):g({})}finally{clearTimeout(o),r.dispose()}})),d)}e.getResolvedShellEnv=P;async function w(p,S){const f=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",f);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",g);const l=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",o);const i=await(0,I.getSystemShell)(u.OS,o);return p.trace("getUnixShellEnvironment#shell",i),new Promise((n,s)=>{if(S.isCancellationRequested)return s((0,b.canceled)());const c=(0,t.basename)(i);let a,C;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${M} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,C=["-Login","-Command"]):(a=`'${process.execPath}' ${M} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,c==="tcsh"?C=["-ic"]:C=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(C),a);const T=(0,v.spawn)(i,[...C,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});S.onCancellationRequested(()=>(T.kill(),s((0,b.canceled)()))),T.on("error",ae=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(ae)),s(ae)});const U=[];T.stdout.on("data",ae=>U.push(ae));const Q=[];T.stderr.on("data",ae=>Q.push(ae)),T.on("close",(ae,X)=>{const G=Buffer.concat(U).toString("utf8");p.trace("getUnixShellEnvironment#raw",G);const Z=Buffer.concat(Q).toString("utf8");if(Z.trim()&&p.trace("getUnixShellEnvironment#stderr",Z),ae||X)return s(new Error((0,k.localize)(2,null,ae,X)));const se=r.exec(G),he=se?se[1]:"{}";try{const V=JSON.parse(he);f?V.ELECTRON_RUN_AS_NODE=f:delete V.ELECTRON_RUN_AS_NODE,g?V.ELECTRON_NO_ATTACH_CONSOLE=g:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",V),n(V)}catch(V){p.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(V)),s(V)}})})}}),define(te[87],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[225],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>z(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),D=new R.validator;if(D){const b=String(v._nextId++);return this.validators.set(b,D),{id:b,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const D=this.validators.get(k.id);if(!D)return!1;this.validators.delete(k.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=v,v._nextId=1}),define(te[38],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(te[22],ie([0,1,15,41,8,3,2,4,34,12,5,6,38,27]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,I.createDecorator)("lifecycleMainService");var d;(function(p){p[p.QUIT=1]="QUIT",p[p.KILL=2]="KILL"})(d=e.ShutdownReason||(e.ShutdownReason={}));var P;(function(p){p[p.Starting=1]="Starting",p[p.Ready=2]="Ready",p[p.AfterWindowOpen=3]="AfterWindowOpen",p[p.Eventually=4]="Eventually"})(P=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let w=class Ct extends D.Disposable{get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(S,f,g){super(),this.logService=S,this.stateMainService=f,this.environmentMainService=g,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(Ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(Ct.QUIT_AND_RESTART_KEY)}registerListeners(){const S=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),b.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};v.app.addListener("before-quit",S);const f=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!b.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",f),v.app.once("will-quit",g=>{this.trace("Lifecycle#app.on(will-quit)"),g.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",S),v.app.removeListener("window-all-closed",f),v.app.quit()})})}fireOnWillShutdown(S){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const f=[];return this._onWillShutdown.fire({reason:S,join(g){f.push(g)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(f)}catch(g){this.logService.error(g)}try{await this.stateMainService.close()}catch(g){this.logService.error(g)}})(),this.pendingWillShutdownPromise}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===S)return;this.trace(`lifecycle (main): phase changed (value: ${S})`),this._phase=S;const f=this.phaseWhen.get(this._phase);f&&(f.open(),this.phaseWhen.delete(this._phase))}async when(S){if(S<=this._phase)return;let f=this.phaseWhen.get(S);f||(f=new k.Barrier,this.phaseWhen.set(S,f)),await f.wait()}registerWindow(S){const f=new D.DisposableStore;this.windowCounter++,f.add(S.onWillLoad(l=>this._onWillLoadWindow.fire({window:S,workspace:l.workspace,reason:l.reason})));const g=(0,m.assertIsDefined)(S.win);g.on("close",l=>{const r=S.id;if(this.windowToCloseRequest.has(r)){this.windowToCloseRequest.delete(r);return}this.trace(`Lifecycle#window.on('close') - window ID ${S.id}`),l.preventDefault(),this.unload(S,1).then(o=>{if(o){this.windowToCloseRequest.delete(r);return}this.windowToCloseRequest.add(r),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${r}`),this._onBeforeCloseWindow.fire(S),S.close()})}),g.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.windowCounter--,f.dispose(),this.windowCounter===0&&(!b.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(S,f){await this.unload(S,3)||S.reload(f)}unload(S,f){const g=this.mapWindowIdToPendingUnload.get(S.id);if(g)return g;const l=this.doUnload(S,f).finally(()=>{this.mapWindowIdToPendingUnload.delete(S.id)});return this.mapWindowIdToPendingUnload.set(S.id,l),l}async doUnload(S,f){if(!S.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${S.id}`);const g=this._quitRequested?2:f,l=await this.onBeforeUnloadWindowInRenderer(S,g);return l?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.handleWindowUnloadVeto(l)):(await this.onWillUnloadWindowInRenderer(S,g),!1)}handleWindowUnloadVeto(S){return S?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(S){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(S),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(S,f){return new Promise(g=>{const l=this.oneTimeListenerTokenGenerator++,r=`vscode:ok${l}`,o=`vscode:cancel${l}`;t.validatedIpcMain.once(r,()=>{g(!1)}),t.validatedIpcMain.once(o,()=>{g(!0)}),S.send("vscode:onBeforeUnload",{okChannel:r,cancelChannel:o,reason:f})})}onWillUnloadWindowInRenderer(S,f){return new Promise(g=>{const r=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(r,()=>g()),S.send("vscode:onWillUnload",{replyChannel:r,reason:f})})}quit(S){return this.trace(`Lifecycle#quit() - begin (willRestart: ${S})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(S&&this.stateMainService.setItem(Ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(f=>{this.pendingQuitPromiseResolve=f,this.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}trace(S){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(S):this.logService.trace(S)}async relaunch(S){this.trace("Lifecycle#relaunch()");const f=process.argv.slice(1);if(S?.addArgs&&f.push(...S.addArgs),S?.removeArgs)for(const r of S.removeArgs){const o=f.indexOf(r);o>=0&&f.splice(o,1)}const g=()=>{try{if(b.isWindows){const r=(0,u.cwd)();r!==process.cwd()&&process.chdir(r)}}catch(r){this.logService.error(r)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:f})};v.app.once("quit",g),await this.quit(!0)&&v.app.removeListener("quit",g)}async kill(S){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const f of v.BrowserWindow.getAllWindows())if(f&&!f.isDestroyed()){let g;f.webContents&&!f.webContents.isDestroyed()?g=new Promise(l=>f.once("closed",l)):g=Promise.resolve(),f.destroy(),await g}})()]),v.app.exit(S)}};w.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",w=ve([ee(0,y.ILogService),ee(1,E.IStateMainService),ee(2,h.IEnvironmentMainService)],w),e.LifecycleMainService=w}),define(te[226],ie([0,1,4,3,2,5,22]),function(z,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let b=class extends k.Disposable{constructor(I){super(),this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,I.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const I=await new Promise((y,E)=>{z(["native-keymap"],y,E)});this._keyboardLayoutData=u(I),v.isCI||I.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=u(I),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};b=ve([ee(0,D.ILifecycleMainService)],b),e.KeyboardLayoutMainService=b;function u(m){const I=m.getKeyMap(),y=m.getCurrentKeyboardLayout();return{keyboardMapping:I,keyboardLayoutInfo:y}}}),define(te[227],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,v.createDecorator)("stateService")}),define(te[228],ie([0,1,8,18,12,36,14,6]),function(z,e,v,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class u{constructor(y,E,h){this.storagePath=y,this.logService=E,this.fileService=h,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,E){const h=this.storage[y];return(0,k.isUndefinedOrNull)(h)?E:h}setItem(y,E){this.setItems([{key:y,data:E}])}setItems(y){let E=!1;for(const{key:h,data:d}of y)this.storage[h]!==d&&((0,k.isUndefinedOrNull)(d)?(0,k.isUndefined)(this.storage[h])||(this.storage[h]=void 0,E=!0):(this.storage[h]=d,E=!0));E&&this.save()}removeItem(y){(0,k.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(E){this.logService.error(E)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=u;let m=class{constructor(y,E,h){this.fileStorage=new u(y.stateResource,E,h)}async init(){await this.fileStorage.init()}getItem(y,E){return this.fileStorage.getItem(y,E)}};m=ve([ee(0,R.IEnvironmentService),ee(1,b.ILogService),ee(2,D.IFileService)],m),e.StateService=m}),define(te[229],ie([0,1,228]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends v.StateService{setItem(R,D){this.fileStorage.setItem(R,D)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(te[114],ie([0,1,4,34,7,29]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(m){if(v.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function b(m,I,y,E,h,d,P,w,p,S){const f=Object.create(null);f["common.machineId"]=P,f.sessionID=(0,R.generateUuid)()+Date.now(),f.commitHash=h,f.version=d,f["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,v.PlatformToString)(v.platform),f["common.nodePlatform"]=t.platform,f["common.nodeArch"]=E,f["common.product"]=S||"desktop",w&&(f["common.msftInternal"]=w);let g=0;const l=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),v.isLinuxSnap&&(f["common.snap"]="true");const r=D(y);r&&(f["common.platformDetail"]=r);try{const o=await m.readFile(k.URI.file(p));f["common.source"]=o.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=b;function u(m){const I=t.env.USERDNSDOMAIN;if(!I)return!1;const y=I.toLowerCase();return m.some(E=>y===E)}e.verifyMicrosoftInternalDomain=u}),define(te[32],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[230],ie([0,1,25,57,8,43,13,9,4,7,81,21,100,84,14,20,32]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function S(o,i){const n=`${o}::${i.join(":")}`,s=p.get(n);if(s)return s;const c=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,C=new Map,M=2e4;function T(Q,ae,X,G){const Z=ae.substring(Q.length+1);return k.Promises.withAsyncBody(async se=>{let he;try{he=await y.Promises.readdir(ae,{withFileTypes:!0})}catch{se();return}if(G.count>=M){G.count+=he.length,G.maxReached=!0,se();return}let V=he.length;if(V===0){se();return}let H=he;G.count+he.length>M&&(G.maxReached=!0,V=M-G.count,H=he.slice(0,V)),G.count+=he.length;for(const W of H)if(W.isDirectory()){if(X.includes(W.name)||await T(Q,(0,b.join)(ae,W.name),X,G),--V===0){se();return}}else{const A=W.name.lastIndexOf(".");if(A>=0){const F=W.name.substring(A+1);F&&a.set(F,(a.get(F)??0)+1)}for(const F of c)F.relativePathPattern?.test(Z)!==!1&&F.filePattern.test(W.name)&&C.set(F.tag,(C.get(F.tag)??0)+1);if(--V===0){se();return}}})}const U=k.Promises.withAsyncBody(async Q=>{const ae={count:0,maxReached:!1};await T(o,o,i,ae);const X=await l(o);Q({configFiles:f(C),fileTypes:f(a),fileCount:ae.count,maxFilesReached:ae.maxReached,launchConfigFiles:X})});return p.set(n,U),U}e.collectWorkspaceStats=S;function f(o){return[...t.Iterable.map(o.entries(),([i,n])=>({name:i,count:n}))].sort((i,n)=>n.count-i.count)}function g(){const o={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},i=v.cpus();return i&&i.length>0&&(o.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),o}e.getMachineInfo=g;async function l(o){try{const i=new Map,n=(0,b.join)(o,".vscode","launch.json"),s=await y.Promises.readFile(n),c=[],a=(0,R.parse)(s.toString(),c);if(c.length)return console.log(`Unable to parse ${n}`),[];if((0,R.getNodeType)(a)==="object"&&a.configurations)for(const C of a.configurations){const M=C.type;M&&(i.has(M)?i.set(M,i.get(M)+1):i.set(M,1))}return f(i)}catch{return[]}}e.collectLaunchConfigs=l;let r=class{constructor(i,n){this.telemetryService=i,this.productService=n}formatMachineInfo(i){const n=[];return n.push(`OS Version:       ${i.os}`),n.push(`CPUs:             ${i.cpus}`),n.push(`Memory (System):  ${i.memory}`),n.push(`VM:               ${i.vmHint}`),n.join(`
`)}formatEnvironment(i){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const s=v.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(v.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),u.isWindows||n.push(`Load (avg):       ${v.loadavg().map(c=>Math.round(c)).join(", ")}`),n.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${i.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(i,n){return Promise.all([(0,E.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async s=>{let[c,a]=s,C=this.formatProcessList(i,c);return n.forEach(M=>{if((0,h.isRemoteDiagnosticError)(M))C+=`
${M.errorMessage}`,a+=`
${M.errorMessage}`;else if(C+=`

Remote: ${M.hostName}`,M.processes&&(C+=`
${this.formatProcessList(i,M.processes)}`),M.workspaceMetadata){a+=`
|  Remote: ${M.hostName}`;for(const T of Object.keys(M.workspaceMetadata)){const U=M.workspaceMetadata[T];let Q=`${U.fileCount} files`;U.maxFilesReached&&(Q=`more than ${Q}`),a+=`|    Folder (${T}): ${Q}`,a+=this.formatWorkspaceStats(U)}}}),{processInfo:C,workspaceInfo:a}})}async getSystemInfo(i,n){const{memory:s,vmHint:c,os:a,cpus:C}=g(),M={os:a,memory:s,cpus:C,vmHint:c,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:n};return u.isWindows||(M.load=`${v.loadavg().map(T=>Math.round(T)).join(", ")}`),u.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(i,n){const s=[];return(0,E.listProcesses)(i.mainPID).then(async c=>(s.push(""),s.push(this.formatEnvironment(i)),s.push(""),s.push(this.formatProcessList(i,c)),i.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(i))),n.forEach(a=>{if((0,h.isRemoteDiagnosticError)(a))s.push(`
${a.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${a.hostName}`),s.push(this.formatMachineInfo(a.machineInfo)),a.processes&&s.push(this.formatProcessList(i,a.processes)),a.workspaceMetadata)for(const C of Object.keys(a.workspaceMetadata)){const M=a.workspaceMetadata[C];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),s.push(`Folder (${C}): ${T}`),s.push(this.formatWorkspaceStats(M))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(i){const n=[];let c=0;const a=(U,Q)=>{const ae=` ${U}(${Q})`;c+ae.length>60?(n.push(C),C="|                 ",c=C.length):c+=ae.length,C+=ae};let C="|      File types:";const M=10,T=i.fileTypes.length>M?M:i.fileTypes.length;for(let U=0;U<T;U++){const Q=i.fileTypes[U];a(Q.name,Q.count)}if(n.push(C),i.configFiles.length>=0&&(C="|      Conf files:",c=0,i.configFiles.forEach(U=>{a(U.name,U.count)}),n.push(C)),i.launchConfigFiles.length>0){let U="|      Launch Configs:";i.launchConfigFiles.forEach(Q=>{U+=Q.count>1?` ${Q.name}(${Q.count})`:` ${Q.name}`}),n.push(U)}return n.join(`
`)}expandGPUFeatures(i){const n=Math.max(...Object.keys(i).map(s=>s.length));return Object.keys(i).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${i[s]}`).join(`
                  `)}formatWorkspaceMetadata(i){const n=[],s=[];return i.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(n.push(`|  Window (${c.title})`),c.folderURIs.forEach(a=>{const C=m.URI.revive(a);if(C.scheme===D.Schemas.file){const M=C.fsPath;s.push(S(M,["node_modules",".git"]).then(T=>{let U=`${T.fileCount} files`;T.maxFilesReached&&(U=`more than ${U}`),n.push(`|    Folder (${(0,b.basename)(M)}): ${U}`),n.push(this.formatWorkspaceStats(T))}).catch(T=>{n.push(`|      Error: Unable to collect workspace stats for folder ${M} (${T.toString()})`)}))}else n.push(`|    Folder (${C.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(c=>n.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(i,n){const s=new Map;i.windows.forEach(a=>s.set(a.pid,a.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(i.mainPID,s,c,n,0),c.join(`
`)}formatProcessItem(i,n,s,c,a){const C=a===0;let M;C?M=c.pid===i?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(a)} ${c.name}`,c.name==="window"&&(M=`${M} (${n.get(c.pid)})`));const T=process.platform==="win32"?c.mem:v.totalmem()*(c.mem/100);s.push(`${c.load.toFixed(0).padStart(5," ")}	${(T/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(c.children)&&c.children.forEach(U=>this.formatProcessItem(i,n,s,U,a+1))}async getWorkspaceFileExtensions(i){const n=new Set;for(const{uri:s}of i.folders){const c=m.URI.revive(s);if(c.scheme!==D.Schemas.file)continue;const a=c.fsPath;try{(await S(a,["node_modules",".git"])).fileTypes.forEach(M=>n.add(M.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(i){for(const{uri:n}of i.folders){const s=m.URI.revive(n);if(s.scheme!==D.Schemas.file)continue;const c=s.fsPath;try{const a=await S(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),a.fileTypes.forEach(C=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:C.name,count:C.count})}),a.launchConfigFiles.forEach(C=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:C.name,count:C.count})}),a.configFiles.forEach(C=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:C.name,count:C.count})})}catch{}}}};r=ve([ee(0,w.ITelemetryService),ee(1,P.IProductService)],r),e.DiagnosticsService=r}),define(te[231],ie([0,1,8,2,6,21,25,9,32,214]),function(z,e,v,t,k,R,D,b,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;class I{constructor(h,d){this.node=h,this.callFrame=d,this.children=[],this.selfTime=-1,this.totalTime=-1}toString(){return`${this.callFrame.url}#${this.callFrame.functionName}@${this.callFrame.lineNumber}:${this.callFrame.columnNumber}`}static makeTotals(h){if(h.totalTime!==-1)return h.totalTime;let d=h.selfTime;for(const P of h.children)d+=I.makeTotals(P);return h.totalTime=d,d}}let y=class{constructor(h,d,P,w){this._window=h,this._sessionId=d,this._logService=P,this._telemetryService=w,this._profileAtOrAfter=0,this._session=new t.DisposableStore,this._isStarted=!1}async stop(){await this._isProfiling,this._logService.warn("[perf] STOPPING to monitor renderer",this._sessionId),this._session.clear();try{const h=this._window.webContents.debugger;await h.sendCommand("Profiler.disable"),h.detach()}catch{this._logService.error("[perf] FAILED to disable profiler",this._sessionId)}}receiveHeartbeat(){this._profileAtOrAfter=Date.now()+1e3}async start(){if(this._isStarted){this._logService.warn("[perf] already STARTED, ignoring request",this._sessionId);return}try{const d=this._window.webContents.debugger;d.attach(),await d.sendCommand("Profiler.enable")}catch{this._logService.error("[perf] FAILED to enable profiler",this._sessionId);return}this._logService.warn("[perf] started to EXPECT frequent heartbeat",this._sessionId),this._session.clear(),this._profileAtOrAfter=Date.now();const h=setInterval(()=>{Date.now()>=this._profileAtOrAfter&&(clearInterval(h),this._captureRendererProfile())},500);this._session.add((0,t.toDisposable)(()=>{this._isStarted=!1,clearInterval(h)}))}async _captureRendererProfile(){this._logService.warn("[perf] MISSED heartbeat, trying to profile renderer",this._sessionId);const h=(async()=>{const d=this._window.webContents.debugger;await d.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,v.timeout)(5e3);const P=await d.sendCommand("Profiler.stop");this._logService.warn("[perf] profiling DONE",this._sessionId),await this._store(P.profile),this._digest(P.profile)})();this._isProfiling=h.catch(d=>{this._logService.error("[perf] profiling the renderer FAILED",this._sessionId),this._logService.error(d)}).finally(()=>{this._isProfiling=void 0})}async _store(h){try{const d=(0,b.join)((0,D.tmpdir)(),`renderer-profile-${Date.now()}.cpuprofile`);await R.Promises.writeFile(d,JSON.stringify(h)),this._logService.info("[perf] stored profile to DISK",this._sessionId,d)}catch(d){this._logService.error("[perf] FAILED to write profile to disk",this._sessionId,d)}}_digest(h){if(!h.samples||!h.timeDeltas){this._logService.warn("[perf] INVALID profile: no samples or timeDeltas",this._sessionId);return}m.Utils.rewriteAbsolutePaths(h,"piiRemoved");const d=new Map;for(const f of h.nodes)d.set(f.id,new I(f,f.callFrame));for(const f of h.nodes)if(f.children){const g=d.get(f.id);for(const l of f.children){const r=d.get(l);g.children.push(r),r.parent=g}}let w=h.endTime-h.startTime-h.timeDeltas[0];for(let f=0;f<h.samples.length-1;f++){const g=h.samples[f],l=d.get(g);if(l){const r=h.timeDeltas[f+1];l.selfTime+=r,w-=r}}const p=d.get(h.samples[h.samples.length-1]);p&&(p.selfTime+=w),d.forEach(I.makeTotals);const S=Array.from(d.values()).sort((f,g)=>g.selfTime-f.selfTime);if(S[0].callFrame.functionName==="(idle)"){this._logService.warn("[perf] top stack is IDLE, ignoring this profile...",this._sessionId),this._telemetryService.publicLog2("prof.sample",{sessionId:this._sessionId,selfTime:0,totalTime:0,functionName:"(idle)",callstack:""});return}for(let f=0;f<S.length&&!(f>4);f++){const g=S[f],l=[];let r=g;for(;r;)l.push(r.toString()),r=r.parent;const o={sessionId:this._sessionId,selfTime:g.selfTime/1e3,totalTime:g.totalTime/1e3,functionName:g.callFrame.functionName,callstack:l.join(`
`)};this._telemetryService.publicLog2("prof.freeze.sample",o)}}};y=ve([ee(2,k.ILogService),ee(3,u.ITelemetryService)],y),e.WindowProfiler=y}),define(te[232],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:b,data:u}){return this.appenders.forEach(m=>m.log(b,u)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class t{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,b=>`Failed to log telemetry: ${console.warn(b)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(te[73],ie([0,1,50,96,12,19,114,32]),function(z,e,v,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class u{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(n,s){return Promise.resolve(void 0)}publicLog2(n,s){return this.publicLog(n,s)}publicLogError(n,s){return Promise.resolve(void 0)}publicLogError2(n,s){return this.publicLogError(n,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=u,e.NullTelemetryService=new u;class m{async publicLog(n,s,c){}async publicLogError(n,s,c){}}e.NullEndpointTelemetryService=m,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(i,n){return n.onDidChangeConfiguration(s=>{s.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(s.source),configurationKeys:p(s.sourceConfig)})})}e.configurationTelemetry=I;function y(i,n){return!(n.disableTelemetry||!i.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=y;function E(i){const n=i.getValue(b.TELEMETRY_SETTING_ID),s=i.getValue("telemetry.enableCrashReporter");if(i.getValue(b.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function h(i){const n={},s={},c={};w(i,c);for(let a in c){a=a.length>150?a.substr(a.length-149):a;const C=c[a];typeof C=="number"?s[a]=C:typeof C=="boolean"?s[a]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${C.length}`),n[a]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(n[a]=C)}return{properties:n,measurements:s}}e.validateTelemetryData=h;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function P(i){if(!i)return"none";for(const n of d)if(i.startsWith(`${n}+`))return n;return"other"}e.cleanRemoteAuthority=P;function w(i,n,s=0,c){if(!!i)for(const a of Object.getOwnPropertyNames(i)){const C=i[a],M=c?c+a:a;Array.isArray(C)?n[M]=(0,v.safeStringify)(C):C instanceof Date?n[M]=C.toISOString():(0,k.isObject)(C)?s<2?w(C,n,s+1,M+"."):n[M]=(0,v.safeStringify)(C):n[M]=C}}function p(i){if(!i)return[];const n=[];return S(n,"",i),n}function S(i,n,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(c=>S(i,n?`${n}.${c}`:c,s[c])):i.push(n)}function f(i,n){const s=i.msftInternalDomains||[],c=n.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(s)||c}e.isInternalTelemetry=f;function g(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=g;function l(i,n){let s=i;const c=[];for(const T of n)for(;;){const U=T.exec(i);if(!U)break;c.push([U.index,T.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let M=0;for(s="";;){const T=C.exec(i);if(!T)break;!a.test(T[0])&&c.every(([U,Q])=>T.index<U||T.index>=Q)&&(s+=i.substring(M,T.index)+"<REDACTED: user-file-path>",M=C.lastIndex)}return M<i.length&&(s+=i.substr(M)),s}function r(i){if(!i)return i;const n=i.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of s)if(c.regex.test(n))return`<REDACTED: ${c.label}>`;return i}function o(i,n){return(0,v.cloneAndChange)(i,s=>{if(typeof s=="string"){let c=s;c=l(c,n);for(const a of n)c=c.replace(a,"");return c=r(c),c}})}e.cleanData=o}),define(te[233],ie([0,1,189,73]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,D,b,u,m,I,y){const E={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`};if((0,t.supportsTelemetry)(D,b)&&(0,t.getTelemetryLevel)(u)===3){const h=await(0,v.getServiceMachineId)(b,m,I),{sessionId:d}=await y.getTelemetryInfo();E["X-Market-User-Id"]=h,E["VSCode-SessionId"]=d}return E}e.resolveMarketplaceHeaders=k}),define(te[234],ie([0,1,2,50,96,4,26,168,19,62,54,20,47,32,73]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let P=class{constructor(S,f,g){this._configurationService=f,this._productService=g,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=S.appenders,this._commonProperties=S.commonProperties||Promise.resolve({}),this._piiPaths=S.piiPaths||[],this._sendErrorTelemetry=!!S.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(S,f){this._experimentProperties[S]=f}_updateTelemetryLevel(){let S=(0,d.getTelemetryLevel)(this._configurationService);const f=this._productService.enabledTelemetryLevels;if(f){this._sendErrorTelemetry=this.sendErrorTelemetry?f.error:!1;const g=f.usage?3:f.error?2:0;S=Math.min(S,g)}this.telemetryLevel.value=S}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const S=await this._commonProperties,f=S.sessionID,g=S["common.machineId"],l=S["common.firstSessionDate"],r=S["common.msftInternal"];return{sessionId:f,machineId:g,firstSessionDate:l,msftInternal:r}}dispose(){this._disposables.dispose()}_log(S,f,g,l){return this.telemetryLevel.value<f?Promise.resolve(void 0):this._commonProperties.then(r=>{g=(0,t.mixin)(g,r),g=(0,t.mixin)(g,this._experimentProperties),g=(0,d.cleanData)(g,this._cleanupPatterns),this._appenders.forEach(o=>o.log(S,g))},r=>{console.error(r)})}publicLog(S,f,g){return this._log(S,3,f,g)}publicLog2(S,f,g){return this.publicLog(S,f,g)}publicLogError(S,f){return this._sendErrorTelemetry?this._log(S,2,f,!0):Promise.resolve(void 0)}publicLogError2(S,f){return this.publicLogError(S,f)}};P.IDLE_START_EVENT_NAME="UserIdleStart",P.IDLE_STOP_EVENT_NAME="UserIdleStop",P=ve([ee(1,u.IConfigurationService),ee(2,y.IProductService)],P),e.TelemetryService=P;function w(){const p=(0,b.localize)(0,null,I.default.nameLong),S=I.default.privacyStatementUrl?(0,b.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,b.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=R.isWeb?"":(0,b.localize)(3,null),g=(0,b.localize)(4,null),l=(0,b.localize)(5,null),r=(0,b.localize)(6,null),o=(0,b.localize)(7,null),i=`
|       | ${g} | ${l} | ${r} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,b.localize)(8,null);return`
${p} ${S} ${f}

&nbsp;

${o}
${i}

&nbsp;

${n}
`}E.Registry.as(m.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(9,null),properties:{[h.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,b.localize)(10,null),(0,b.localize)(11,null),(0,b.localize)(12,null),(0,b.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(m.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(14,null),properties:{[h.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,b.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,b.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,b.localize)(17,null,`\`#${h.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[235],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(v=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===v.HIGH_CONTRAST_DARK||R===v.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===v.DARK||R===v.HIGH_CONTRAST_DARK}e.isDark=k}),define(te[236],ie([0,1,120,3,2,5,47,235]),function(z,e,v,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var u;(function(w){function p(S){return S&&typeof S=="object"&&typeof S.id=="string"}w.isThemeColor=p})(u=e.ThemeColor||(e.ThemeColor={}));function m(w){return{id:w}}e.themeColorFromId=m;var I;(function(w){function p(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||u.isThemeColor(n.color))}w.isThemeIcon=p;const S=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function f(n){const s=S.exec(n);if(!s)return;const[,c]=s;return{id:c}}w.fromString=f;function g(n){return{id:n}}w.fromId=g;function l(n,s){let c=n.id;const a=c.lastIndexOf("~");return a!==-1&&(c=c.substring(0,a)),s&&(c=`${c}~${s}`),{id:c}}w.modify=l;function r(n){const s=n.id.lastIndexOf("~");if(s!==-1)return n.id.substring(s+1)}w.getModifier=r;function o(n,s){return n.id===s.id&&n.color?.id===s.color?.id}w.isEqual=o;function i(n,s){return{id:n.id,color:s?m(s):void 0}}w.asThemeIcon=i,w.asClassNameArray=v.CSSIcon.asClassNameArray,w.asClassName=v.CSSIcon.asClassName,w.asCSSSelector=v.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function y(w){switch(w){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case b.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,k.toDisposable)(()=>{const S=this.themingParticipants.indexOf(p);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const h=new E;D.Registry.add(e.Extensions.ThemingContribution,h);function d(w){return h.onColorThemeChange(w)}e.registerThemingParticipant=d;class P extends k.Disposable{constructor(p){super(),this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,S){let f=this.theme.getColor(p);return f&&S&&(f=S(f,this.theme)),f?f.toString():null}}e.Themable=P}),define(te[64],ie([0,1,15,3,2,4,19,5,38]),function(z,e,v,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const m="#FFFFFF",I="#1E1E1E",y="#000000",E="#FFFFFF",h="theme",d="themeBackground",P="windowSplash";e.IThemeMainService=(0,b.createDecorator)("themeMainService");let w=class extends k.Disposable{constructor(S,f){super(),this.stateMainService=S,this.configurationService=f,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,v.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&v.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:v.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const S=this.getColorScheme();if(S.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return S.dark?y:E;let f=this.stateMainService.getItem(d,null);if(!f)switch(this.stateMainService.getItem(h,"vs-dark").split(" ")[0]){case"vs":f=m;break;case"hc-black":f=y;break;case"hc-light":f=E;break;default:f=I}return R.isMacintosh&&f.toUpperCase()===I&&(f="#171717"),f}saveWindowSplash(S,f){this.stateMainService.setItems([{key:h,data:f.baseTheme},{key:d,data:f.colorInfo.background},{key:P,data:f}]),typeof S=="number"&&this.updateBackgroundColor(S,f)}updateBackgroundColor(S,f){for(const g of v.BrowserWindow.getAllWindows())if(g.id===S){g.setBackgroundColor(f.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(P)}};w=ve([ee(0,u.IStateMainService),ee(1,D.IConfigurationService)],w),e.ThemeMainService=w}),define(te[115],ie([0,1,3,4,5,6]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(P){P.Http="http",P.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var b;(function(P){P.ConstantPrivate="constantPrivate",P.Private="private",P.Public="public"})(b=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var u;(function(P){P[P.Notify=1]="Notify",P[P.OpenBrowser=2]="OpenBrowser",P[P.OpenPreview=3]="OpenPreview",P[P.Silent=4]="Silent",P[P.Ignore=5]="Ignore",P[P.OpenBrowserOnce=6]="OpenBrowserOnce"})(u=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(P){if(P.scheme!=="http"&&P.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(P.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(P){return e.LOCALHOST_ADDRESSES.indexOf(P)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(P){return e.ALL_INTERFACES_ADDRESSES.indexOf(P)>=0}e.isAllInterfaces=y;function E(P,w){return w?w!==1&&P<1024:!t.isWindows&&P<1024}e.isPortPrivileged=E;class h{constructor(w,p,S){this.remoteAddress=w,this.localAddress=p,this._dispose=S,this._onDispose=new v.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=h;let d=class{constructor(w){this.logService=w,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w){return this._tunnelProvider=w,w?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],p=Array.from(this._tunnels.values());for(const S of p){const f=Array.from(S.values());for(const g of f){const l=await g.value;l&&w.push(l)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:p}of w.values())await p.then(S=>S?.dispose());w.clear()}this._tunnels.clear()}setEnvironmentTunnel(w,p,S,f,g){this.addTunnelToMap(w,p,Promise.resolve({tunnelRemoteHost:w,tunnelRemotePort:p,localAddress:S,privacy:f,protocol:g,dispose:()=>Promise.resolve()}))}openTunnel(w,p,S,f,g=!1,l,r){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${S} on local port ${f}.`),!w)return;if(p||(p="localhost"),this._tunnelProvider&&this._factoryInProgress.has(S)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(w,p,S,f,g,l,r);return o?o.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(i);return(i.tunnelRemoteHost!==p||i.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const p=this._tunnels.get(w.tunnelRemoteHost);if(p){const S=p.get(w.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,S))}}}}async tryDisposeTunnel(w,p,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${p}.`);const f=S.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(p),f}}async closeTunnel(w,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${p} `);const S=this._tunnels.get(w);if(S&&S.has(p)){const f=S.get(p);f.refcount=0,await this.tryDisposeTunnel(w,p,f)}}addTunnelToMap(w,p,S){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(p,{refcount:1,value:S})}async removeEmptyTunnelFromMap(w,p){const S=this._tunnels.get(w);S&&(await S.get(p)||S.delete(p),S.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,p){const S=[w];I(w)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):y(w)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const f=S.map(g=>this._tunnels.get(g));for(const g of f){const l=g?.get(p);if(l)return l}}canTunnel(w){return!!m(w)}doIsPortPrivileged(w,p,S,f){if(p)return!1;if(S){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(g?.length===4){const l=parseInt(g[1]),r=parseInt(g[2]);if(l>10||l===10&&r>=14)return!1}}return w<1024}createWithProvider(w,p,S,f,g,l,r){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${S} on local port ${f}.`);const o=S;this._factoryInProgress.add(o);const i=f===void 0?S:f,n={elevationRequired:g?this.isPortPrivileged(i):!1},s={remoteAddress:{host:p,port:S},localAddressPort:f,privacy:l,public:l?l!==b.Private:void 0,protocol:r},c=w.forwardPort(s,n);return c?(this.addTunnelToMap(p,S,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),c}};d=ve([ee(0,R.ILogService)],d),e.AbstractTunnelService=d}),define(te[237],ie([0,1,77,25,95,220,8,2,19,6,20,219,115,87,4]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function P(g,l,r,o,i){let n;for(let s=3;s&&(n?.dispose(),n=await new w(g,l,r,o,i).waitForReady(),!(i&&k.BROWSER_RESTRICTED_PORTS[i]||!k.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));s--);return n}class w extends b.Disposable{constructor(l,r,o,i,n){super(),this.defaultTunnelHost=r,this.suggestedLocalPort=n,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=l,this._server=v.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(r=>{r()})}async waitForReady(){let l=await(0,k.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),r=null;return this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),r=this._server.address(),r||(l=0,this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),r=this._server.address()),this.tunnelLocalPort=r.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${r.port}`,this}async _onConnection(l){l.pause();const r=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,y.connectRemoteAgentTunnel)(this._options,r,this.tunnelRemotePort),i=o.getSocket().socket,n=o.readEntireBuffer();o.dispose(),n.byteLength>0&&l.write(n.buffer),l.on("end",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),i.end()}),l.on("close",()=>i.end()),l.on("error",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),i.destroy()}),i.on("end",()=>l.end()),i.on("close",()=>l.end()),i.on("error",()=>{l.destroy()}),l.pipe(i),i.pipe(l),l.localAddress&&this._socketsDispose.set(l.localAddress,()=>{l.end(),i.end()})}}let p=class extends E.AbstractTunnelService{constructor(l,r,o,i,n){super(r),this.socketFactory=l,this.signService=o,this.productService=i,this.configurationService=n}get defaultTunnelHost(){const l=this.configurationService.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}isPortPrivileged(l){return this.doIsPortPrivileged(l,d.isWindows,d.isMacintosh,t.release())}retainOrCreateTunnel(l,r,o,i,n,s,c){const a=this.getTunnelFromMap(r,o);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,r,o,i,n,s,c);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${o} on local port ${i}.`);const C={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:l,signService:this.signService,logService:this.logService,ipcLogger:null},M=P(C,this.defaultTunnelHost,r,o,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(r,o,M),M}}};p=ve([ee(1,m.ILogService),ee(2,h.ISignService),ee(3,I.IProductService),ee(4,u.IConfigurationService)],p),e.BaseTunnelService=p;let S=class extends p{constructor(l,r,o,i){super(R.nodeSocketFactory,l,r,o,i)}};S=ve([ee(0,m.ILogService),ee(1,h.ISignService),ee(2,I.IProductService),ee(3,u.IConfigurationService)],S),e.TunnelService=S;let f=class extends b.Disposable{constructor(l,r,o,i){super(),this.logService=l,this.productService=r,this.signService=o,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(l,r,o,i,n,s,c,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${i} on local port ${n}.`),!this._tunnelServices.has(l)){const C=new S(this.logService,this.signService,this.productService,this.configurationService);this._register(C),this._tunnelServices.set(l,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this._tunnelServices.delete(l))})}return this._tunnelServices.get(l).openTunnel(r,o,i,n,s,c,a)}};f=ve([ee(0,m.ILogService),ee(1,I.IProductService),ee(2,h.ISignService),ee(3,u.IConfigurationService)],f),e.SharedTunnelsService=f}),define(te[48],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(te[238],ie([0,1,4,169,62,47]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[239],ie([0,1,3,48]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(b){this.service=b}listen(b,u){switch(u){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${u}`)}call(b,u,m){switch(u){case"checkForUpdates":return this.service.checkForUpdates(m);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(m)}throw new Error(`Call not found: ${u}`)}}e.UpdateChannel=k;class R{get state(){return this._state}set state(b){this._state=b,this._onStateChange.fire(b)}constructor(b){this.channel=b,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(u=>this.state=u),this.channel.call("_getInitialState").then(u=>this.state=u)}checkForUpdates(b){return this.channel.call("checkForUpdates",b)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(b){return this.channel.call("_applySpecificUpdate",b)}}e.UpdateChannelClient=R}),define(te[88],ie([0,1,8,23,3,19,27,22,6,20,55,48]),function(z,e,v,t,k,R,D,b,u,m,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(d,P,w){return`${w.updateUrl}/api/update/${d}/${P}/${w.commit}`}e.createUpdateURL=E;let h=class{get state(){return this._state}setState(P){this.logService.info("update#setState",P.type),this._state=P,this._onStateChange.fire(P)}constructor(P,w,p,S,f,g){this.lifecycleMainService=P,this.configurationService=w,this.environmentMainService=p,this.requestService=S,this.logService=f,this.productService=g,this._state=y.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const P=this.getUpdateMode(),w=this.getProductQuality(P);if(!w){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(w),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(y.State.Idle(this.getUpdateType())),P==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}P==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(P){return P==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(P=60*60*1e3){return(0,v.timeout)(P).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(P){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(P)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(P){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(P=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${P}`),!P&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(P){}getUpdateType(){return 1}doQuitAndInstall(){}};h=ve([ee(0,b.ILifecycleMainService),ee(1,R.IConfigurationService),ee(2,D.IEnvironmentMainService),ee(3,I.IRequestService),ee(4,u.ILogService),ee(5,m.IProductService)],h),e.AbstractUpdateService=h}),define(te[240],ie([0,1,15,53,3,2,19,27,22,6,20,55,32,48,88]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let P=class extends d.AbstractUpdateService{get onRawError(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"error",(p,S)=>S)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(p,S,f)=>({url:S,version:f,productVersion:f}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(p,S,f,g)=>({releaseNotes:S,version:f,productVersion:f,date:g}))}constructor(p,S,f,g,l,r,o){super(p,S,g,l,r,o),this.telemetryService=f,this.disposables=new R.DisposableStore}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.logService.error("UpdateService error:",p);const f=(this.state.type==="checking for updates"?this.state.explicit:!0)?p:void 0;this.setState(h.State.Idle(1,f))}buildUpdateFeedUrl(p){let S;this.productService.darwinUniversalAssetId?S=this.productService.darwinUniversalAssetId:S=process.arch==="x64"?"darwin":"darwin-arm64";const f=(0,d.createUpdateURL)(S,p,this.productService);try{v.autoUpdater.setFeedURL({url:f})}catch(g){this.logService.error("Failed to set update feed URL",g);return}return f}doCheckForUpdates(p){this.setState(h.State.CheckingForUpdates(p)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(p){this.state.type==="checking for updates"&&this.setState(h.State.Downloading(p))}onUpdateDownloaded(p){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(h.State.Ready(p)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(h.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ve([t.memoize],P.prototype,"onRawError",null),ve([t.memoize],P.prototype,"onRawUpdateNotAvailable",null),ve([t.memoize],P.prototype,"onRawUpdateAvailable",null),ve([t.memoize],P.prototype,"onRawUpdateDownloaded",null),P=ve([ee(0,u.ILifecycleMainService),ee(1,D.IConfigurationService),ee(2,E.ITelemetryService),ee(3,b.IEnvironmentMainService),ee(4,y.IRequestService),ee(5,m.ILogService),ee(6,I.IProductService)],P),e.DarwinUpdateService=P}),define(te[241],ie([0,1,45,40,8,3,9,27,22,6,32,48]),function(z,e,v,t,k,R,D,b,u,m,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{get state(){return this._state}setState(P){this.logService.info("update#setState",P.type),this._state=P,this._onStateChange.fire(P)}constructor(P,w,p){if(this.lifecycleMainService=P,this.logService=p,this._state=y.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,w.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(y.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}scheduleCheckForUpdates(P=60*60*1e3){return(0,k.timeout)(P).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(P){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(P)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(P){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(P=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${P}`),!P&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(P){}};E=ve([ee(0,u.ILifecycleMainService),ee(1,b.IEnvironmentMainService),ee(2,m.ILogService)],E);let h=class extends E{constructor(P,w,p,S,f,g){super(p,S,f),this.snap=P,this.snapRevision=w,this.telemetryService=g;const l=(0,t.watch)(D.dirname(this.snap)),r=R.Event.fromNodeEventEmitter(l,"change",(s,c)=>c),o=R.Event.filter(r,s=>s==="current"),n=R.Event.debounce(o,(s,c)=>c,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{n.dispose(),l.close()})}doCheckForUpdates(){this.setState(y.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(P=>{P?this.setState(y.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(y.State.Idle(2)))},P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(y.State.Idle(2,P.message||P))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const P=await new Promise((p,S)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(f,g)=>f?S(f):p(g))),w=D.basename(P);return this.snapRevision!==w}isLatestVersion(){return this.isUpdateAvailable().then(void 0,P=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};h=ve([ee(2,u.ILifecycleMainService),ee(3,b.IEnvironmentMainService),ee(4,m.ILogService),ee(5,I.ITelemetryService)],h),e.SnapUpdateService=h}),define(te[51],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,v.createDecorator)("IUriIdentityService")}),define(te[242],ie([0,1,51,190,14,16,126,3,2]),function(z,e,v,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(E){this.uri=E,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let I=class{constructor(E){this._fileService=E,this._dispooables=new u.DisposableStore,this._limit=2**16;const h=new Map,d=P=>{let w=h.get(P.scheme);return w===void 0&&(w=E.hasProvider(P)&&!this._fileService.hasCapability(P,1024),h.set(P.scheme,w)),w};this._dispooables.add(b.Event.any(E.onDidChangeFileSystemProviderRegistrations,E.onDidChangeFileSystemProviderCapabilities)(P=>{h.delete(P.scheme)})),this.extUri=new R.ExtUri(d),this._canonicalUris=new D.SkipList((P,w)=>this.extUri.compare(P,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(E){this._fileService.hasProvider(E)&&(E=(0,R.normalizePath)(E));const h=this._canonicalUris.get(E);return h?h.touch().uri.with({fragment:E.fragment}):(this._canonicalUris.set(E,new m(E)),this._checkTrim(),E)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const E=[...this._canonicalUris.entries()].sort((d,P)=>d[1].touch<P[1].touch?1:d[1].touch>P[1].touch?-1:0);m._clock=0,this._canonicalUris.clear();const h=this._limit*.5;for(let d=0;d<h;d++)this._canonicalUris.set(E[d][0],E[d][1].touch())}};I=ve([ee(0,k.IFileService)],I),e.UriIdentityService=I,(0,t.registerSingleton)(v.IUriIdentityService,I,1)}),define(te[116],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(te[243],ie([0,1,7]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(b){this.handler=b}listen(b,u){throw new Error(`Event not found: ${u}`)}call(b,u,m){switch(u){case"handleURL":return this.handler.handleURL(v.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${u}`)}}e.URLHandlerChannel=t;class k{constructor(b){this.channel=b}handleURL(b,u){return this.channel.call("handleURL",[b.toJSON(),u])}}e.URLHandlerChannelClient=k;class R{constructor(b){this.next=b}async routeCall(b,u,m,I){if(u!=="handleURL")throw new Error(`Call not found: ${u}`);if(m){const y=v.URI.revive(m);if(y&&y.query){const E=/\bwindowId=(\d+)/.exec(y.query);if(E){const h=E[1],d=new RegExp(`window:${h}`),P=b.connections.find(w=>d.test(w.ctx));if(P)return P}}}return this.next.routeCall(b,u,m,I)}routeEvent(b,u){throw new Error(`Event not found: ${u}`)}}e.URLHandlerRouter=R}),define(te[244],ie([0,1,8,2,7,20]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(m,I){const y=[...this.handlers.values()];return(0,v.first)(y.map(E=>()=>E.handleURL(m,I)),void 0,!1).then(E=>E||!1)}registerHandler(m){return this.handlers.add(m),(0,t.toDisposable)(()=>this.handlers.delete(m))}}e.AbstractURLService=D;let b=class extends D{constructor(m){super(),this.productService=m}create(m){let{authority:I,path:y,query:E,fragment:h}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return I&&y&&y.indexOf("/")!==0&&(y=`/${y}`),k.URI.from({scheme:this.productService.urlProtocol,authority:I,path:y,query:E,fragment:h})}};b=ve([ee(0,R.IProductService)],b),e.NativeURLService=b}),define(te[245],ie([0,1,15,8,3,2,4,7]),function(z,e,v,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function u(I){try{return b.URI.parse(I)}catch{return null}}class m{constructor(y,E,h,d,P){if(this.urlService=E,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=y,D.isWindows){const S=d.isBuilt?[]:[`"${d.appRoot}"`];S.push("--open-url","--"),v.app.setAsDefaultProtocolClient(P.urlProtocol,process.execPath,S)}const w=k.Event.map(k.Event.fromNodeEventEmitter(v.app,"open-url",(S,f)=>({event:S,url:f})),({event:S,url:f})=>(S.preventDefault(),f));this.disposables.add(w(S=>{const f=u(S);!f||this.urlService.open(f,{originalUrl:S})})),h.getWindows().filter(S=>S.isReady).length>0?this.flush():k.Event.once(h.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const y=[];for(const E of this.uris)await this.urlService.open(E.uri,{originalUrl:E.url})||y.push(E);y.length!==0&&(this.uris=y,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=m}),define(te[246],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(te[247],ie([0,1,15,2,13,7]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const u=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(k.Schemas.vscodeWebview,u)}handleWebviewRequest(u,m){try{const I=R.URI.parse(u.url),y=D.validWebviewFilePaths.get(I.path);if(typeof y=="string"){const E=`vs/workbench/contrib/webview/browser/pre/${y}`,h=k.FileAccess.asFileUri(E,z);return m({path:decodeURIComponent(h.fsPath),headers:{...k.COI.getHeadersFromQuery(u.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(te[74],ie([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(I){return!!I.workspaceUri}e.isWorkspaceToOpen=t;function k(I){return!!I.folderUri}e.isFolderToOpen=k;function R(I){return!!I.fileUri}e.isFileToOpen=R;function D(I){const y=b(I),E=I.getValue("window.menuBarVisibility");return E==="default"||y==="native"&&E==="compact"||v.isMacintosh&&v.isNative?"classic":E}e.getMenuBarVisibility=D;function b(I){if(v.isWeb)return"custom";const y=I.getValue("window");if(y){if(v.isMacintosh&&y.nativeTabs===!0||v.isMacintosh&&y.nativeFullScreen===!1)return"native";const d=y.titleBarStyle;if(d==="native"||d==="custom")return d}return v.isLinux?"native":"custom"}e.getTitleBarStyle=b;function u(I){if(!v.isWindows||v.isWeb||b(I)==="native")return!1;const y=I.getValue("window.experimental.windowControlsOverlay.enabled");return typeof y=="boolean"?y:!1}e.useWindowControlsOverlay=u;function m(I=0){return Math.pow(1.2,I)}e.zoomLevelToZoomFactor=m}),define(te[117],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var v;(function(b){b[b.INITIAL=1]="INITIAL",b[b.LOAD=2]="LOAD",b[b.RELOAD=3]="RELOAD"})(v=e.LoadReason||(e.LoadReason={}));var t;(function(b){b[b.CLOSE=1]="CLOSE",b[b.QUIT=2]="QUIT",b[b.RELOAD=3]="RELOAD",b[b.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(b=1){return{width:1024,height:768,mode:b}};e.defaultWindowState=k;var R;(function(b){b[b.Maximized=0]="Maximized",b[b.Normal=1]="Normal",b[b.Minimized=2]="Minimized",b[b.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(b){b[b.UNRESPONSIVE=1]="UNRESPONSIVE",b[b.PROCESS_GONE=2]="PROCESS_GONE",b[b.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(te[33],ie([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,v.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(te[248],ie([0,1,15,23,3,66,2,29,69,105,6,20,33]),function(z,e,v,t,k,R,D,b,u,m,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var h;(function(P){P[P.Initial=1]="Initial",P[P.StoredCredentialsUsed=2]="StoredCredentialsUsed",P[P.LoginDialogShown=3]="LoginDialogShown"})(h||(h={}));let d=class extends D.Disposable{constructor(w,p,S,f,g){super(),this.logService=w,this.windowsMainService=p,this.credentialsService=S,this.encryptionMainService=f,this.productService=g,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=h.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const w=k.Event.fromNodeEventEmitter(v.app,"login",(p,S,f,g,l)=>({event:p,webContents:S,req:f,authInfo:g,callback:l}));this._register(w(this.onLogin,this))}async onLogin({event:w,authInfo:p,req:S,callback:f}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===h.LoginDialogShown&&S.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let g;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),g=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{g=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}f(g?.username,g?.password)}async resolveProxyCredentials(w){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(w);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(w){this.logService.trace("auth#doResolveProxyCredentials - enter",w);const p=String((0,R.hash)({scheme:w.scheme,host:w.host,port:w.port}));let S,f;try{const o=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p);if(o){const i=JSON.parse(await this.encryptionMainService.decrypt(o));S=i.username,f=i.password}}catch(o){this.logService.error(o)}if(this.state!==h.StoredCredentialsUsed&&typeof S=="string"&&typeof f=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=h.StoredCredentialsUsed,{username:S,password:f};const g=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!g){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${g.id} to handle proxy login`);const l={authInfo:w,username:this.sessionCredentials?.username??S,password:this.sessionCredentials?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,b.generateUuid)()}`};g.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,l),this.state=h.LoginDialogShown;const r=await new Promise(o=>{const i=async(n,s,c)=>{if(s===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${g.id}`),g.win?.webContents.off("ipc-message",i),c){const a={username:c.username,password:c.password};try{if(c.remember){const C=await this.encryptionMainService.encrypt(JSON.stringify(a));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p,C)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p)}catch(C){this.logService.error(C)}o({username:a.username,password:a.password})}else o(void 0)};g.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=r,r}};d=ve([ee(0,I.ILogService),ee(1,E.IWindowsMainService),ee(2,u.ICredentialsMainService),ee(3,m.IEncryptionMainService),ee(4,y.IProductService)],d),e.ProxyAuthHandler=d}),define(te[249],ie([0,1,69,6,36,20,33,202]),function(z,e,v,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let u=class extends b.BaseCredentialsMainService{constructor(I,y,E,h){super(I),this.environmentMainService=y,this.productService=E,this.windowsMainService=h,this.surfaceKeytarLoadError=d=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new v.InMemoryCredentialsProvider,this._keytarCache;const I=await new Promise((y,E)=>{z(["keytar"],y,E)});return await I.findCredentials("test-keytar-loads"),this._keytarCache=I,this._keytarCache}};u=ve([ee(0,t.ILogService),ee(1,k.INativeEnvironmentService),ee(2,R.IProductService),ee(3,D.IWindowsMainService)],u),e.CredentialsNativeMainService=u}),define(te[250],ie([0,1,17,2,3,6,22,79,45,280,8,13,50,4,34,15,33]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const p=P.UtilityProcess,S=typeof p<"u";let f=class Ut{constructor(o,i,n){this._logService=o,this._windowsMainService=n,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(s=>{this._shutdown=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(o){const i=this._extHosts.get(o);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(o){return this._getExtHost(o).onStdout}onDynamicStderr(o){return this._getExtHost(o).onStderr}onDynamicMessage(o){return this._getExtHost(o).onMessage}onDynamicError(o){return this._getExtHost(o).onError}onDynamicExit(o){return this._getExtHost(o).onExit}async canUseUtilityProcess(){return S}async createExtensionHost(o){if(this._shutdown)throw(0,v.canceled)();const i=String(++Ut._lastId);let n;if(o){if(!S)throw new Error("Cannot use UtilityProcess!");n=new l(i,this._logService,this._windowsMainService)}else n=new g(i,this._logService);return this._extHosts.set(i,n),n.onExit(({pid:s,code:c,signal:a})=>{this._logService.info(`Extension host with pid ${s} exited with code: ${c}, signal: ${a}.`),setTimeout(()=>{n.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(o,i){if(this._shutdown)throw(0,v.canceled)();return this._getExtHost(o).start(i)}async enableInspectPort(o){if(this._shutdown)throw(0,v.canceled)();const i=this._extHosts.get(o);return i?i.enableInspectPort():!1}async kill(o){if(this._shutdown)throw(0,v.canceled)();const i=this._extHosts.get(o);!i||i.kill()}async _killAllNow(){for(const[,o]of this._extHosts)o.kill()}async _waitForAllExit(o){const i=[];for(const[,n]of this._extHosts)i.push(n.waitForExit(o));return I.Promises.settled(i).then(()=>{})}};f._lastId=0,f=ve([ee(0,R.ILogService),ee(1,D.ILifecycleMainService),ee(2,w.IWindowsMainService)],f),e.ExtensionHostStarter=f;let g=class extends t.Disposable{constructor(o,i){super(),this.id=o,this._logService=i,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){h.isCI&&this._logService.info("Calling fork to start extension host...");const i=b.StopWatch.create(!1);this._process=(0,u.fork)(y.FileAccess.asFileUri("bootstrap-fork",z).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,E.mixin)({cwd:(0,d.cwd)()},o));const n=i.elapsed(),s=this._process.pid;this._logService.info(`Starting extension host with pid ${s} (fork() took ${n} ms).`);const c=new m.StringDecoder("utf-8");this._process.stdout?.on("data",C=>{const M=typeof C=="string"?C:c.write(C);this._onStdout.fire(M)});const a=new m.StringDecoder("utf-8");this._process.stderr?.on("data",C=>{const M=typeof C=="string"?C:a.write(C);this._onStderr.fire(M)}),this._process.on("message",C=>{this._onMessage.fire(C)}),this._process.on("error",C=>{this._onError.fire({error:(0,v.transformErrorForSerialization)(C)})}),this._process.on("exit",(C,M)=>{this._hasExited=!0,this._onExit.fire({pid:s,code:C,signal:M})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):h.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(o)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${o}ms.`),this._process.kill())}};g=ve([ee(1,R.ILogService)],g);let l=class extends t.Disposable{constructor(o,i,n){super(),this.id=o,this._logService=i,this._windowsMainService=n,this.onError=k.Event.None,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){const i=this._windowsMainService.getWindowById(o.responseWindowId);if(!i){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const n=i.win;if(!n||n.isDestroyed()||n.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,c=y.FileAccess.asFileUri("bootstrap-fork.js",z).fsPath,a=["--type=extensionHost","--skipWorkspaceStorageLock"],C=o.execArgv||[],M={...o.env},T=!0;for(const Z of Object.keys(M))M[Z]=String(M[Z]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new p(c,a,{serviceName:s,env:M,execArgv:C,allowLoadingUnsignedLibraries:T});const U=new m.StringDecoder("utf-8");this._process.stdout?.on("data",Z=>{const se=typeof Z=="string"?Z:U.write(Z);this._onStdout.fire(se)});const Q=new m.StringDecoder("utf-8");this._process.stderr?.on("data",Z=>{const se=typeof Z=="string"?Z:Q.write(Z);this._onStderr.fire(se)}),this._process.on("message",Z=>{this._onMessage.fire(Z)}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const ae=k.Event.fromNodeEventEmitter(this._process,"exit",(Z,se)=>se);this._register(ae(Z=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${Z}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:Z,signal:""})}));const{port1:X,port2:G}=new P.MessageChannelMain;this._process.postMessage("null",[G]),n.webContents.postMessage(o.responseChannel,o.responseNonce,[X])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):!1):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const i=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(o)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${o}ms, will kill it now.`),this._process.kill())}};l=ve([ee(1,R.ILogService),ee(2,w.IWindowsMainService)],l)}),define(te[251],ie([0,1,15,3,2,247,33]),function(z,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let b=class extends k.Disposable{constructor(m){super(),this.windowsMainService=m,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,I){let y;if(typeof m.windowId=="number"){const{windowId:E}=m,h=this.windowsMainService.getWindowById(E);if(!h?.win)throw new Error(`Invalid windowId: ${E}`);y=h.win.webContents}else{const{webContentsId:E}=m;if(y=v.webContents.fromId(E),!y)throw new Error(`Invalid webContentsId: ${E}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(I)}async findInFrame(m,I,y,E){const d=this.getFrameByName(m,I);if(typeof d.findInFrame=="function"){d.findInFrame(y,{findNext:E.findNext,forward:E.forward});const P=(w,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),d.removeListener("found-in-frame",P))};d.on("found-in-frame",P)}}async stopFindInFrame(m,I,y){const h=this.getFrameByName(m,I);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}getFrameByName(m,I){const y=this.windowsMainService.getWindowById(m.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${m}`);const E=y.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===I);if(!E)throw new Error(`Unknown frame: ${I}`);return E}};b=ve([ee(0,D.IWindowsMainService)],b),e.WebviewMainService=b}),define(te[252],ie([0,1,8,3,2]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:b,onDidFocusWindow:u,getActiveWindowId:m}){super(),this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(b,u))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>m()),(async()=>{try{const y=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:y}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(b){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=b}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(te[28],ie([0,1,173,9,31,16,7,5,13]),function(z,e,v,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function m(o){const i=o;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=m,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function I(o,i){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,t.basename)(o)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=o;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=I;function y(o){const i=o;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=y;function E(o){const i=o;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const n=o;if(n?.configPath)return{id:n.id,configPath:D.URI.revive(n.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=E;var h;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(h=e.WorkbenchState||(e.WorkbenchState={}));function d(o){const i=o;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=d;function P(o){const i=o;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=P;class w{constructor(i,n,s,c,a){this._id=i,this._transient=s,this._configuration=c,this._ignorePathCasing=a,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class p{constructor(i,n){this.raw=n,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,R.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function S(o){return new p({uri:o,index:0,name:(0,R.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,v.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(o,i){return R.extUriBiasedIgnorePathCase.isEqualOrParent(o,i.untitledWorkspacesHome)}e.isUntitledWorkspace=f;function g(o){let i;return D.URI.isUri(o)?i=o:i=o.configuration,i?.scheme===u.Schemas.tmp}e.isTemporaryWorkspace=g;function l(o,i){return!f(o,i)&&!g(o)}e.isSavedWorkspace=l;function r(o){return(typeof o=="string"?(0,t.extname)(o):(0,R.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(te[56],ie([0,1,15,8,66,35,2,80,4,12,21,150,5,6,28]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,E.createDecorator)("dialogMainService");let P=class{constructor(p){this.logService=p,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(p,S){return this.doPick({...p,pickFolders:!0,pickFiles:!0,title:(0,y.localize)(0,null)},S)}pickFolder(p,S){return this.doPick({...p,pickFolders:!0,title:(0,y.localize)(1,null)},S)}pickFile(p,S){return this.doPick({...p,pickFiles:!0,title:(0,y.localize)(2,null)},S)}pickWorkspace(p,S){const f=(0,y.localize)(3,null),g=(0,R.mnemonicButtonLabel)((0,y.localize)(4,null)),l=d.WORKSPACE_FILTER;return this.doPick({...p,pickFiles:!0,title:f,filters:l,buttonLabel:g},S)}async doPick(p,S){const f={title:p.title,buttonLabel:p.buttonLabel,filters:p.filters,defaultPath:p.defaultPath};(typeof p.pickFiles=="boolean"||typeof p.pickFolders=="boolean")&&(f.properties=void 0,p.pickFiles&&p.pickFolders&&(f.properties=["multiSelections","openDirectory","openFile","createDirectory"])),f.properties||(f.properties=["multiSelections",p.pickFolders?"openDirectory":"openFile","createDirectory"]),u.isMacintosh&&f.properties.push("treatPackageAsDirectory");const g=await this.showOpenDialog(f,(0,m.withNullAsUndefined)(S||v.BrowserWindow.getFocusedWindow()));if(g&&g.filePaths&&g.filePaths.length>0)return g.filePaths}getWindowDialogQueue(p){if(p){let S=this.windowDialogQueues.get(p.id);return S||(S=new t.Queue,this.windowDialogQueues.set(p.id,S)),S}else return this.noWindowDialogueQueue}showMessageBox(p,S){return this.getWindowDialogQueue(S).queue(async()=>S?v.dialog.showMessageBox(S,p):v.dialog.showMessageBox(p))}async showSaveDialog(p,S){const f=this.acquireFileDialogLock(p,S);if(!f)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(S).queue(async()=>{let g;return S?g=await v.dialog.showSaveDialog(S,p):g=await v.dialog.showSaveDialog(p),g.filePath=this.normalizePath(g.filePath),g})}finally{(0,D.dispose)(f)}}normalizePath(p){return p&&u.isMacintosh&&(p=(0,b.normalizeNFC)(p)),p}normalizePaths(p){return p.map(S=>this.normalizePath(S))}async showOpenDialog(p,S){p.defaultPath&&(await I.Promises.exists(p.defaultPath)||(p.defaultPath=void 0));const f=this.acquireFileDialogLock(p,S);if(!f)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(S).queue(async()=>{let g;return S?g=await v.dialog.showOpenDialog(S,p):g=await v.dialog.showOpenDialog(p),g.filePaths=this.normalizePaths(g.filePaths),g})}finally{(0,D.dispose)(f)}}acquireFileDialogLock(p,S){if(!S)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",p);let f=this.windowFileDialogLocks.get(S.id);f||(f=new Set,this.windowFileDialogLocks.set(S.id,f));const g=(0,k.hash)(p);if(!f.has(g))return this.logService.trace("[DialogMainService]: new file dialog lock created",p),f.add(g),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",p),f?.delete(g),f?.size===0&&this.windowFileDialogLocks.delete(S.id)})}};P=ve([ee(0,h.ILogService)],P),e.DialogMainService=P}),define(te[253],ie([0,1,3,2,67,28]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(u,m){super(),this.logService=u,this.storageMainService=m,this.onDidChangeApplicationStorageEmitter=this._register(new v.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(m.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(u,m){this._register(v.Event.debounce(u.onDidChangeStorage,(I,y)=>(I?I.push(y):I=[y],I),D.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&m.fire(this.serializeStorageChangeEvents(I,u))}))}serializeStorageChangeEvents(u,m){const I=new Map,y=new Set;return u.forEach(E=>{const h=m.get(E.key);typeof h=="string"?I.set(E.key,h):y.add(E.key)}),{changed:Array.from(I.entries()),deleted:Array.from(y.values())}}listen(u,m,I){switch(m){case"onDidChangeStorage":{const y=I.profile?(0,k.revive)(I.profile):void 0;if(!y)return this.onDidChangeApplicationStorageEmitter.event;let E=this.mapProfileToOnDidChangeProfileStorageEmitter.get(y.id);return E||(E=this._register(new v.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(y),E),this.mapProfileToOnDidChangeProfileStorageEmitter.set(y.id,E)),E.event}}throw new Error(`Event not found: ${m}`)}async call(u,m,I){const y=I.profile?(0,k.revive)(I.profile):void 0,E=(0,R.reviveIdentifier)(I.workspace),h=await this.withStorageInitialized(y,E);switch(m){case"getItems":return Array.from(h.items.entries());case"updateItems":{const d=I;if(d.insert)for(const[P,w]of d.insert)h.set(P,w);d.delete?.forEach(P=>h.delete(P));break}case"isUsed":{const d=I.payload;if(typeof d=="string")return this.storageMainService.isUsed(d)}default:throw new Error(`Call not found: ${m}`)}}async withStorageInitialized(u,m){let I;m?I=this.storageMainService.workspaceStorage(m):u?I=this.storageMainService.profileStorage(u):I=this.storageMainService.applicationStorage;try{await I.init()}catch(y){this.logService.error(`StorageIPC#init: Unable to init ${m?"workspace":u?"profile":"application"} storage due to ${y}`)}return I}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(te[39],ie([0,1,66,3,2,16,12,7,170,36,14,5,6,28,31,51,8,29,26]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function f(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&b.URI.isUri(n.location)&&b.URI.isUri(n.globalStorageHome)&&b.URI.isUri(n.settingsResource)&&b.URI.isUri(n.keybindingsResource)&&b.URI.isUri(n.tasksResource)&&b.URI.isUri(n.snippetsHome)&&((0,D.isUndefined)(n.extensionsResource)||b.URI.isUri(n.extensionsResource)))}e.isUserDataProfile=f,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,y.createDecorator)("IUserDataProfilesService");function g(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:b.URI.revive(i.location).with({scheme:n}),globalStorageHome:b.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:b.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:b.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:b.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:b.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:b.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=g,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function l(i,n,s,c){return{id:i,name:n,location:s,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,R.joinPath)(s,"globalStorage"),settingsResource:(0,R.joinPath)(s,"settings.json"),keybindingsResource:(0,R.joinPath)(s,"keybindings.json"),tasksResource:(0,R.joinPath)(s,"tasks.json"),snippetsHome:(0,R.joinPath)(s,"snippets"),extensionsResource:(0,R.joinPath)(s,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=l;let r=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,s,c,a){super(),this.environmentService=n,this.fileService=s,this.uriIdentityService=c,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(C=>l((0,R.basename)(C.location),C.name,C.location,{shortName:C.shortName,useDefaultFlags:C.useDefaultFlags})):[];let s;const c=new d.ResourceMap,a=l((0,v.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,u.localize)(0,null),this.environmentService.userRoamingDataHome);if(n.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),n.length){const C=this.getStoredProfileAssociations();if(C.workspaces)for(const[M,T]of Object.entries(C.workspaces)){const U=b.URI.parse(M),Q=b.URI.parse(T),ae=n.find(X=>this.uriIdentityService.extUri.isEqual(X.location,Q));ae&&c.set(U,ae)}if(C.emptyWindow){const M=b.URI.parse(C.emptyWindow);s=n.find(T=>this.uriIdentityService.extUri.isEqual(T.location,M))}}this._profilesObject={profiles:n,workspaces:c,emptyWindow:s}}return this._profilesObject}async createTransientProfile(n){const s="Temp",c=new RegExp(`${(0,S.escapeRegExpCharacters)(s)}\\s(\\d+)`);let a=0;for(const M of this.profiles){const T=c.exec(M.name),U=T?parseInt(T[1]):0;a=U>a?U:a}const C=`${s} ${a+1}`;return this.createProfile((0,v.hash)((0,p.generateUuid)()).toString(16),C,{transient:!0},n)}async createNamedProfile(n,s,c){return this.createProfile((0,v.hash)((0,p.generateUuid)()).toString(16),n,s,c)}async createProfile(n,s,c,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const C=await this.doCreateProfile(n,s,c);return a&&await this.setProfileForWorkspace(a,C),C}async doCreateProfile(n,s,c){let a=this.profileCreationPromises.get(s);return a||(a=(async()=>{try{const C=this.profiles.find(U=>U.name===s||U.id===n);if(C)return C;const M=l(n,s,(0,R.joinPath)(this.profilesHome,n),c);await this.fileService.createFolder(M.location);const T=[];return this._onWillCreateProfile.fire({profile:M,join(U){T.push(U)}}),await w.Promises.settled(T),this.updateProfiles([M],[],[]),M}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,a)),a}async updateProfile(n,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(a=>a.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);return c=l(c.id,s.name??c.name,c.location,{shortName:s.shortName??c.shortName,transient:s.transient??c.isTransient,useDefaultFlags:s.useDefaultFlags??c.useDefaultFlags}),this.updateProfiles([],[],[c]),c}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(a=>a.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:s,join(a){c.push(a)}});try{await Promise.allSettled(c)}catch(a){this.logService.error(a)}s.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(s.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(n,s=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let c=this.getProfileForWorkspace(n);return c||(c=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(n,c)),c}async setProfileForWorkspace(n,s){this.setProfileForWorkspaceSync(n,s)}setProfileForWorkspaceSync(n,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(a=>a.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(n,c)}unsetWorkspace(n,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(s=>s.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(n.map(s=>this.removeProfile(s)))}getProfileForWorkspace(n){const s=this.getWorkspace(n);return b.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(n){return(0,h.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,h.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}isProfileAssociatedToWorkspace(n){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,n.location)||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,n.location)||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location)))}updateProfiles(n,s,c){const a=[...this.profiles,...n],C=[];this.transientProfilesObject.profiles=[];for(let M of a)M.isDefault||s.some(T=>M.id===T.id)||(M=c.find(T=>M.id===T.id)??M,M.isTransient?this.transientProfilesObject.profiles.push(M):C.push({location:M.location,name:M.name,shortName:M.shortName,useDefaultFlags:M.useDefaultFlags}));this.saveStoredProfiles(C),this._profilesObject=void 0,this.triggerProfilesChanges(n,s,c)}triggerProfilesChanges(n,s,c){this._onDidChangeProfiles.fire({added:n,removed:s,updated:c,all:this.profiles})}updateWorkspaceAssociation(n,s,c){c=s?.isTransient?!0:c,c||this.updateWorkspaceAssociation(n,void 0,!0);const a=this.getWorkspace(n),C=c?this.transientProfilesObject:this.profilesObject;b.URI.isUri(a)?(C.workspaces.delete(a),s&&C.workspaces.set(a,s)):C.emptyWindow=s,c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[c,a]of this.profilesObject.workspaces.entries())n[c.toString()]=a.location.toString();const s=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:s}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};r.PROFILES_KEY="userDataProfiles",r.PROFILE_ASSOCIATIONS_KEY="profileAssociations",r=ve([ee(0,m.IEnvironmentService),ee(1,I.IFileService),ee(2,P.IUriIdentityService),ee(3,E.ILogService)],r),e.UserDataProfilesService=r;class o extends r{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=o}),define(te[89],ie([0,1,24,8,50,18,17,43,136,2,13,9,4,16,188,97,12,7,155,36,112,111,187,14,5,6,20,3,67,72,39,51,186]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p,S,f,g,l,r,o,i,n,s,c,a,C,M,T,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var Q;(function(V){function H(W,A){if(W===A)return!0;const F=Object.keys(W),N=new Set;for(const J of Object.keys(A))N.add(J);if(F.length!==N.size)return!1;for(const J of F){if(W[J]!==A[J])return!1;N.delete(J)}return N.size===0}V.equals=H})(Q=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let ae=class extends m.Disposable{constructor(H,W,A,F,N,J,B,$,L,O,_){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=W,this.extensionsControlLocation=A,this.cacheLocation=F,this.userDataProfilesService=N,this.extensionsProfileScannerService=J,this.fileService=B,this.logService=$,this.environmentService=L,this.productService=O,this.instantiationService=_,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Z,(0,h.joinPath)(this.cacheLocation,l.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Z,(0,h.joinPath)(this.cacheLocation,l.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(G,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,g.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(H,W,A){const[F,N]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(W)]),J=A?await this.scanExtensionsUnderDevelopment(H,[...F,...N]):[];return this.dedupExtensions(F,N,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const W=[];W.push(this.scanDefaultSystemExtensions(!!H.useCache,H.language)),W.push(this.scanDevSystemExtensions(H.language,!!H.checkControlFile));const[A,F]=await Promise.all(W);return this.applyScanOptions([...A,...F],0,H,!1)}async scanUserExtensions(H){this.logService.trace("Started scanning user extensions");const W=await this.createExtensionScannerInput(H.profileLocation??this.userExtensionsLocation,!!H.profileLocation,1,!H.includeUninstalled,H.language);let F=await(H.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(W);return F=await this.applyScanOptions(F,1,H,!0),this.logService.trace("Scanned user extensions:",F.length),F}async scanExtensionsUnderDevelopment(H,W){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const A=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(F=>F.scheme===I.Schemas.file).map(async F=>{const N=await this.createExtensionScannerInput(F,!1,1,!0,H.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(N)).map(B=>(B.type=W.find($=>(0,g.areSameExtensions)($.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,N)))}))).flat();return this.applyScanOptions(A,"development",H,!0)}return[]}async scanExistingExtension(H,W,A){const F=await this.createExtensionScannerInput(H,!1,W,!0,A.language),N=await this.extensionsScanner.scanExtension(F);return!N||!A.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(H,W,A){const F=await this.createExtensionScannerInput(H,!1,W,!0,A.language),N=await this.extensionsScanner.scanOneOrMultipleExtensions(F);return this.applyScanOptions(N,W,A,!0)}async scanMetadata(H){const W=(0,h.joinPath)(H,"package.json"),A=(await this.fileService.readFile(W)).value.toString();return JSON.parse(A).__metadata}async updateMetadata(H,W){const A=(0,h.joinPath)(H,"package.json"),F=(await this.fileService.readFile(A)).value.toString(),N=JSON.parse(F);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,N.__metadata={...N.__metadata,...W},await this.fileService.writeFile((0,h.joinPath)(H,"package.json"),R.VSBuffer.fromString(JSON.stringify(N,null,"	")))}async applyScanOptions(H,W,A,F){return A.includeAllVersions||(H=this.dedupExtensions(W===0?H:void 0,W===1?H:void 0,W==="development"?H:void 0,await this.getTargetPlatform(),F)),A.includeInvalid||(H=H.filter(N=>N.isValid)),H.sort((N,J)=>{const B=y.basename(N.location.fsPath),$=y.basename(J.location.fsPath);return B<$?-1:B>$?1:0})}dedupExtensions(H,W,A,F,N){const J=($,L,O)=>{if($.isValid&&!L.isValid)return!1;if($.isValid===L.isValid){if(N&&d.gt($.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${$.location.path} with version ${$.manifest.version}`),!1;if(d.eq($.manifest.version,L.manifest.version)){if($.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${$.location.path} with same version`),!1;if($.targetPlatform===F)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${$.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${$.location.path} with ${L.location.path}.`),!0},B=new Map;return H?.forEach($=>{const L=l.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);(!O||J(O,$,!1))&&B.set(L,$)}),W?.forEach($=>{const L=l.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);if(!O&&H&&$.type===0){this.logService.debug(`Skipping obsolete system extension ${$.location.path}.`);return}(!O||J(O,$,!1))&&B.set(L,$)}),A?.forEach($=>{const L=l.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);(!O||J(O,$,!0))&&B.set(L,$),B.set(L,$)}),[...B.values()]}async scanDefaultSystemExtensions(H,W){this.logService.trace("Started scanning system extensions");const A=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,W),N=await(H&&!A.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return this.logService.trace("Scanned system extensions:",N.length),N}async scanDevSystemExtensions(H,W){const A=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!A?.length)return[];this.logService.trace("Started scanning dev system extensions");const F=W?await this.getBuiltInExtensionControl():{},N=[],J=p.URI.file(y.normalize(y.join(I.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions")));for(const $ of A){const L=F[$.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":N.push((0,h.joinPath)(J,$.name));break;default:N.push(p.URI.file(L));break}}const B=await Promise.all(N.map(async $=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput($,!1,0,!0,H))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,v.coalesce)(B)}async getBuiltInExtensionControl(){try{const H=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(H.value.toString())}catch{return{}}}async createExtensionScannerInput(H,W,A,F,N,J=!0){const B=await this.getTranslations(N??E.language),$=await this.getMtime(H),L=W?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=L?await this.getMtime(L):void 0;return new X(H,$,L,O,W,A,F,J,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,N,B)}async getMtime(H){try{const W=await this.fileService.stat(H);if(typeof W.mtime=="number")return W.mtime}catch{}}};ae=ve([ee(4,M.IUserDataProfilesService),ee(5,C.IExtensionsProfileScannerService),ee(6,o.IFileService),ee(7,n.ILogService),ee(8,f.IEnvironmentService),ee(9,s.IProductService),ee(10,i.IInstantiationService)],ae),e.AbstractExtensionsScannerService=ae;class X{constructor(H,W,A,F,N,J,B,$,L,O,_,j,Y,oe){this.location=H,this.mtime=W,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=F,this.profile=N,this.type=J,this.excludeObsolete=B,this.validate=$,this.productVersion=L,this.productDate=O,this.productCommit=_,this.devMode=j,this.language=Y,this.translations=oe}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,W){return(0,h.isEqual)(H.location,W.location)&&H.mtime===W.mtime&&(0,h.isEqual)(H.applicationExtensionslocation,W.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&H.profile===W.profile&&H.type===W.type&&H.excludeObsolete===W.excludeObsolete&&H.validate===W.validate&&H.productVersion===W.productVersion&&H.productDate===W.productDate&&H.productCommit===W.productCommit&&H.devMode===W.devMode&&H.language===W.language&&Q.equals(H.translations,W.translations)}}let G=class extends m.Disposable{constructor(H,W,A,F,N){super(),this.obsoleteFile=H,this.extensionsProfileScannerService=W,this.uriIdentityService=A,this.fileService=F,this.logService=N}async scanExtensions(H){const W=H.profile?await this.scanExtensionsFromProfile(H):await this.scanExtensionsFromLocation(H);let A={};if(H.excludeObsolete&&H.type===1)try{const F=(await this.fileService.readFile(this.obsoleteFile)).value.toString();A=JSON.parse(F)}catch{}return(0,w.isEmptyObject)(A)?W:W.filter(F=>!A[g.ExtensionKey.create(F).toString()])}async scanExtensionsFromLocation(H){const W=await this.fileService.resolve(H.location);if(!W.children?.length)return[];const A=await Promise.all(W.children.map(async F=>{if(!F.isDirectory||H.type===1&&(0,h.basename)(F.resource).indexOf(".")===0)return null;const N=new X(F.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(N)}));return(0,v.coalesce)(A).sort((F,N)=>F.location.path<N.location.path?-1:1)}async scanExtensionsFromProfile(H){let W=await this.scanExtensionsFromProfileResource(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(H.location,H.applicationExtensionslocation)){W=W.filter(F=>!F.metadata?.isApplicationScoped);const A=await this.scanExtensionsFromProfileResource(H.applicationExtensionslocation,F=>!!F.metadata?.isApplicationScoped,H);W.push(...A)}return W}async scanExtensionsFromProfileResource(H,W,A){const F=await this.extensionsProfileScannerService.scanProfileExtensions(H);if(!F.length)return[];const N=await Promise.all(F.map(async J=>{if(W(J)){const B=new X(J.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(B,J.metadata)}return null}));return(0,v.coalesce)(N)}async scanOneOrMultipleExtensions(H){try{if(await this.fileService.exists((0,h.joinPath)(H.location,"package.json"))){const W=await this.scanExtension(H);return W?[W]:[]}else return await this.scanExtensions(H)}catch(W){return this.logService.error(`Error scanning extensions at ${H.location.path}:`,(0,D.getErrorMessage)(W)),[]}}async scanExtension(H,W){try{let A=await this.scanExtensionManifest(H.location);if(A){A.publisher||(A.publisher=l.UNDEFINED_PUBLISHER),W=W??A.__metadata,delete A.__metadata;const F=(0,g.getGalleryExtensionId)(A.publisher,A.name),N=W?.id?{id:F,uuid:W.id}:{id:F},J=W?.isSystem?0:H.type,B=J===0||!!W?.isBuiltin;A=await this.translateManifest(H.location,A,X.createNlsConfiguration(H));const $={type:J,identifier:N,manifest:A,location:H.location,isBuiltin:B,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return H.validate?this.validate($,H):$}}catch(A){H.type!==0&&this.logService.error(A)}return null}validate(H,W){let A=!0;const F=(0,r.validateExtensionManifest)(W.productVersion,W.productDate,W.location,H.manifest,H.isBuiltin);for(const[N,J]of F)N===P.default.Error&&(A=!1,this.logService.error(this.formatMessage(W.location,J)));return H.isValid=A,H.validations=F,H}async scanExtensionManifest(H){const W=(0,h.joinPath)(H,"package.json");let A;try{A=(await this.fileService.readFile(W)).value.toString()}catch(N){return(0,o.toFileOperationResult)(N)!==1&&this.logService.error(this.formatMessage(H,(0,S.localize)(0,null,W.path,N.message))),null}let F;try{F=JSON.parse(A)}catch{const J=[];(0,b.parse)(A,J);for(const B of J)this.logService.error(this.formatMessage(H,(0,S.localize)(1,null,W.path,B.offset,B.length,(0,u.getParseErrorMessage)(B.error))));return null}return(0,b.getNodeType)(F)!=="object"?(this.logService.error(this.formatMessage(H,(0,S.localize)(2,null,W.path))),null):F}async translateManifest(H,W,A){const F=await this.getLocalizedMessages(H,W,A);if(F)try{const N=[],J=await this.resolveOriginalMessageBundle(F.default,N);if(N.length>0)return N.forEach($=>{this.logService.error(this.formatMessage(H,(0,S.localize)(3,null,F.default?.path,(0,u.getParseErrorMessage)($.error))))}),W;if((0,b.getNodeType)(F)!=="object")return this.logService.error(this.formatMessage(H,(0,S.localize)(4,null,F.default?.path))),W;const B=F.values||Object.create(null);return(0,U.localizeManifest)(W,B,J)}catch{}return W}async getLocalizedMessages(H,W,A){const F=(0,h.joinPath)(H,"package.nls.json"),N=(L,O)=>{O.forEach(_=>{this.logService.error(this.formatMessage(H,(0,S.localize)(5,null,L?.path,(0,u.getParseErrorMessage)(_.error))))})},J=L=>{this.logService.error(this.formatMessage(H,(0,S.localize)(6,null,L?.path)))},B=`${W.publisher}.${W.name}`,$=A.translations[B];if($)try{const L=p.URI.file($),O=(await this.fileService.readFile(L)).value.toString(),_=[],j=(0,b.parse)(O,_);return _.length>0?(N(L,_),{values:void 0,default:F}):(0,b.getNodeType)(j)!=="object"?(J(L),{values:void 0,default:F}):{values:j.contents?j.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.fileService.exists(F))return;let O;try{O=await this.findMessageBundles(H,A)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const _=(await this.fileService.readFile(O.localized)).value.toString(),j=[],Y=(0,b.parse)(_,j);return j.length>0?(N(O.localized,j),{values:void 0,default:O.original}):(0,b.getNodeType)(Y)!=="object"?(J(O.localized),{values:void 0,default:O.original}):{values:Y,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(H,W){if(H)try{const A=(await this.fileService.readFile(H)).value.toString();return(0,b.parse)(A,W)}catch{}}findMessageBundles(H,W){return new Promise((A,F)=>{const N=J=>{const B=(0,h.joinPath)(H,`package.nls.${J}.json`);this.fileService.exists(B).then($=>{$&&A({localized:B,original:(0,h.joinPath)(H,"package.nls.json")});const L=J.lastIndexOf("-");L===-1?A({localized:(0,h.joinPath)(H,"package.nls.json"),original:null}):(J=J.substring(0,L),N(J))})};if(W.devMode||W.pseudo||!W.language)return A({localized:(0,h.joinPath)(H,"package.nls.json"),original:null});N(W.language)})}formatMessage(H,W){return`[${H.path}]: ${W}`}};G=ve([ee(1,C.IExtensionsProfileScannerService),ee(2,T.IUriIdentityService),ee(3,o.IFileService),ee(4,n.ILogService)],G);let Z=class extends G{constructor(H,W,A,F,N,J){super(W,A,F,N,J),this.cacheFile=H,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(H){const W=await this.readExtensionCache();if(this.input=H,W&&W.input&&X.equals(W.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),W.result.map(F=>(F.location=p.URI.revive(F.location),F));const A=await super.scanExtensions(H);return await this.writeExtensionCache({input:H,result:A}),A}async readExtensionCache(){try{const H=await this.fileService.readFile(this.cacheFile),W=JSON.parse(H.value.toString());return{result:W.result,input:(0,a.revive)(W.input)}}catch(H){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(H))}return null}async writeExtensionCache(H){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(H)))}catch(W){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(W))}}async validateCache(){if(!this.input)return;const H=await this.readExtensionCache();if(!H)return;const W=H.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(A,W))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(F){this.logService.error(F)}}};Z=ve([ee(2,C.IExtensionsProfileScannerService),ee(3,T.IUriIdentityService),ee(4,o.IFileService),ee(5,n.ILogService)],Z);function se(V,H){const W=(0,g.getExtensionId)(V.manifest.publisher,V.manifest.name);return{id:W,identifier:new l.ExtensionIdentifier(W),isBuiltin:V.type===0,isUserBuiltin:V.type===1&&V.isBuiltin,isUnderDevelopment:H,extensionLocation:V.location,uuid:V.identifier.uuid,targetPlatform:V.targetPlatform,...V.manifest}}e.toExtensionDescription=se;class he extends ae{constructor(H,W,A,F,N,J,B,$,L,O,_){super(H,W,(0,h.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,h.joinPath)(F,l.MANIFEST_CACHE_FOLDER),N,J,B,$,L,O,_),this.translationsPromise=(async()=>{if(E.translationsConfigFile)try{const j=await this.fileService.readFile(p.URI.file(E.translationsConfigFile));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}getTranslations(H){return this.translationsPromise}}e.NativeExtensionsScannerService=he}),define(te[254],ie([0,1,7,36,72,89,14,5,6,20,39]),function(z,e,v,t,k,R,D,b,u,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends R.NativeExtensionsScannerService{constructor(h,d,P,w,p,S,f){super(v.URI.file(p.builtinExtensionsPath),v.URI.file(p.extensionsPath),p.userHome,v.URI.file(p.userDataPath),h,d,P,w,p,S,f)}};y=ve([ee(0,I.IUserDataProfilesService),ee(1,k.IExtensionsProfileScannerService),ee(2,D.IFileService),ee(3,u.ILogService),ee(4,t.INativeEnvironmentService),ee(5,m.IProductService),ee(6,b.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(te[255],ie([0,1,15,41,2,31,13,9,4,7,29,36,6,39]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends k.Disposable{constructor(w,p,S){super(),this.environmentService=w,this.logService=S,this.validRoots=R.TernarySearchTree.forPaths(!u.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot(p.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(w.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:w}=v.session;w.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(p,S)=>this.handleResourceRequest(p,S)),w.protocol.interceptFileProtocol(D.Schemas.file,(p,S)=>this.handleFileRequest(p,S)),this._register((0,k.toDisposable)(()=>{w.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(w){const p=(0,b.normalize)(w);return this.validRoots.get(p)?k.Disposable.None:(this.validRoots.set(p,!0),(0,k.toDisposable)(()=>this.validRoots.delete(p)))}handleFileRequest(w,p){const S=m.URI.parse(w.url);return this.logService.error(`Refused to load resource ${S.fsPath} from ${D.Schemas.file}: protocol (original URL: ${w.url})`),p({error:-3})}handleResourceRequest(w,p){const S=this.requestToNormalizedFilePath(w);let f;return this.environmentService.crossOriginIsolated&&((0,b.basename)(S)==="workbench.html"||(0,b.basename)(S)==="workbench-dev.html"?f=D.COI.CoopAndCoep:f=D.COI.getHeadersFromQuery(w.url)),this.validRoots.findSubstr(S)?p({path:S,headers:f}):this.validExtensions.has((0,b.extname)(S).toLowerCase())?p({path:S}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${S} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),p({error:-3}))}requestToNormalizedFilePath(w){const p=m.URI.parse(w.url),S=D.FileAccess.asFileUri(p);return(0,b.normalize)(S.fsPath)}createIPCObjectUrl(){let w;const p=m.URI.from({scheme:"vscode",path:(0,I.generateUuid)()}),S=p.toString(),f=async()=>w;return t.validatedIpcMain.handle(S,f),this.logService.trace(`IPC Object URL: Registered new channel ${S}.`),{resource:p,update:g=>w=g,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${S}.`),t.validatedIpcMain.removeHandler(S)}}}};d=ve([ee(0,y.INativeEnvironmentService),ee(1,h.IUserDataProfilesService),ee(2,E.ILogService)],d),e.ProtocolMainService=d}),define(te[256],ie([0,1,15,41,8,3,2,13,12,102,27,22,6,54,61,64,44,39,37]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let f=class extends D.Disposable{constructor(l,r,o,i,n,s,c,a,C){super(),this.machineId=l,this.userEnv=r,this.environmentMainService=o,this.userDataProfilesService=i,this.lifecycleMainService=n,this.logService=s,this.policyService=c,this.themeMainService=a,this.protocolMainService=C,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(l,r)=>this.onWindowConnection(l,r)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(l,r)=>this.onWorkerConnection(l,r)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(l,r){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const o=await this.connect();if(l.sender.isDestroyed())return o.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",r,[o])}onWorkerConnection(l,r){this.logService.trace("SharedProcess: onWorkerConnection",r);const o=new D.DisposableStore,i=s=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${s}')`,r),o.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",r))},n=v.BrowserWindow.fromId(r.reply.windowId);if(!n||n.isDestroyed()||n.webContents.isDestroyed()||!r.reply.channel){i("unavailable");return}o.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===n)(()=>i("load"))),o.add(R.Event.fromNodeEventEmitter(n,"closed")(()=>i("closed"))),n.webContents.postMessage(r.reply.channel,r.reply.nonce,l.ports)}onWillShutdown(){const l=this.window;!l||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(l.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{l.close()}catch{}this.window=void 0},0))}send(l,...r){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${l}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(l,...r)}catch(o){this.logService.warn(`Error sending IPC message to channel '${l}' of shared process: ${(0,w.toErrorMessage)(o)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),l()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),l()}))})()),this._whenIpcReady}createWindow(){const l=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),l.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:h.default,policiesData:this.policyService.serialize()}),this.window.loadURL(b.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=l=>{this.logService.trace("SharedProcess#close prevented"),l.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(l,r)=>this._onDidError.fire({type:2,details:r})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(l,r,o)=>this._onDidError.fire({type:3,details:{reason:o,exitCode:r}})))}async connect(){await this.whenIpcReady;const l=(0,u.assertIsDefined)(this.window);return(0,m.connect)(l)}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const l=this.window;return l?!l.isDestroyed()&&!l.webContents.isDestroyed():!1}};f=ve([ee(2,I.IEnvironmentMainService),ee(3,p.IUserDataProfilesService),ee(4,y.ILifecycleMainService),ee(5,E.ILogService),ee(6,S.IPolicyService),ee(7,P.IThemeMainService),ee(8,d.IProtocolMainService)],f),e.SharedProcess=f}),define(te[90],ie([0,1,8,3,2,71,12,103,5,39]),function(z,e,v,t,k,R,D,b,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,u.createDecorator)("storageService");var I;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(S){S[S.APPLICATION=-1]="APPLICATION",S[S.PROFILE=0]="PROFILE",S[S.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var E;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(E=e.StorageTarget||(e.StorageTarget={}));function h(S){const f=S.get(e.TARGET_KEY);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.loadKeyTargets=h;class d extends k.Disposable{constructor(f={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super(),this.options=f,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,g){if(g===e.TARGET_KEY){switch(f){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:f})}else this._onDidChangeValue.fire({scope:f,key:g,target:this.getKeyTargets(f)[g]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,g,l){return this.getStorage(g)?.get(f,l)}getBoolean(f,g,l){return this.getStorage(g)?.getBoolean(f,l)}getNumber(f,g,l){return this.getStorage(g)?.getNumber(f,l)}store(f,g,l,r){if((0,D.isUndefinedOrNull)(g)){this.remove(f,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,l,r),this.getStorage(l)?.set(f,g)})}remove(f,g){this.withPausedEmitters(()=>{this.updateKeyTarget(f,g,void 0),this.getStorage(g)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,g){const l=[],r=this.getKeyTargets(f);for(const o of Object.keys(r))r[o]===g&&l.push(o);return l}updateKeyTarget(f,g,l){const r=this.getKeyTargets(g);typeof l=="number"?r[f]!==l&&(r[f]=l,this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(r))):typeof r[f]=="number"&&(delete r[f],this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(f){switch(f){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(f){const g=this.getStorage(f);return g?h(g):Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=I.NONE){this._onWillSaveState.fire({reason:f});const g=this.getStorage(-1),l=this.getStorage(0),r=this.getStorage(1);switch(f){case I.NONE:await v.Promises.settled([g?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await v.Promises.settled([g?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.getStorage(-1)?.items??new Map,g=this.getStorage(0)?.items??new Map,l=this.getStorage(1)?.items??new Map;return p(f,g,l,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(f,g){return this.emitWillSaveState(I.NONE),(0,m.isUserDataProfile)(f)?this.switchToProfile(f,g):this.switchToWorkspace(f,g)}canSwitchProfile(f,g){return!(f.id===g.id||P(g)&&P(f))}switchData(f,g,l,r){this.withPausedEmitters(()=>{if(r)for(const[o,i]of f)g.set(o,i);else{const o=new Set;for(const[i,n]of f)o.add(i),g.get(i)!==n&&this.emitDidChangeValue(l,i);for(const[i]of g.items)o.has(i)||this.emitDidChangeValue(l,i)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function P(S){return S.isDefault||!!S.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=P;class w extends d{constructor(){super(),this.applicationStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.profileStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.profileStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),this._register(this.applicationStorage.onDidChangeStorage(f=>this.emitDidChangeValue(-1,f)))}getStorage(f){switch(f){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(f){return!1}}e.InMemoryStorageService=w;async function p(S,f,g,l,r,o){const i=Q=>{try{return JSON.parse(Q)}catch{return Q}},n=new Map,s=new Map;S.forEach((Q,ae)=>{n.set(ae,Q),s.set(ae,i(Q))});const c=new Map,a=new Map;f.forEach((Q,ae)=>{c.set(ae,Q),a.set(ae,i(Q))});const C=new Map,M=new Map;g.forEach((Q,ae)=>{C.set(ae,Q),M.set(ae,i(Q))}),console.group(l!==r?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const T=[];if(n.forEach((Q,ae)=>{T.push({key:ae,value:Q})}),console.table(T),console.groupEnd(),console.log(s),l!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const Q=[];c.forEach((ae,X)=>{Q.push({key:X,value:ae})}),console.table(Q),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const U=[];C.forEach((Q,ae)=>{U.push({key:ae,value:Q})}),console.table(U),console.groupEnd(),console.log(M)}e.logStorage=p}),define(te[257],ie([0,1,24,8,3,2,9,79,7,21,103,147,6,90,32,28]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class w extends R.Disposable{get storage(){return this._storage}constructor(o,i){super(),this.logService=o,this.fileService=i,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=I.StorageState.None}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===I.StorageState.None)try{const o=await this.doCreate();this._storage.dispose(),this._storage=o,this._register(o.onDidChangeStorage(n=>this._onDidChangeStorage.fire({key:n}))),await this.doInit(o);const i=o.getBoolean(h.IS_NEW_KEY);i===void 0?o.set(h.IS_NEW_KEY,!0):i&&o.set(h.IS_NEW_KEY,!1)}catch(o){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${o}`)}finally{this.state=I.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===E.LogLevel.Trace?o=>this.logService.trace(o):void 0,logError:o=>this.logService.error(o)}}doInit(o){return o.init()}get items(){return this._storage.items}get(o,i){return this._storage.get(o,i)}set(o,i){return this._storage.set(o,i)}delete(o){return this._storage.delete(o)}async close(){const o=new b.StopWatch(!1);await this.doClose(),o.stop(),o.elapsed()>w.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(o),this._onDidCloseStorage.fire()}async logSlowClose(o){if(!!this.path)try{const i=(0,v.top)(Array.from(this._storage.items.entries()).map(([s,c])=>({key:s,length:c.length})),(s,c)=>c.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),n=(await this.fileService.stat(u.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${o.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=I.StorageState.Closed,await this._storage.close()}}w.LOG_SLOW_CLOSE_THRESHOLD=2e3;class p extends w{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,p.STORAGE_NAME)}constructor(o,i,n,s){super(n,s),this.profile=o,this.options=i}async doCreate(){return new I.Storage(new y.SQLiteStorageDatabase(this.path??y.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}p.STORAGE_NAME="state.vscdb";class S extends p{constructor(o,i,n,s){super(o,i,n,s)}}e.ProfileStorageMain=S;class f extends p{constructor(o,i,n,s){super(i.defaultProfile,o,n,s)}async doInit(o){await super.doInit(o),this.updateTelemetryState(o)}updateTelemetryState(o){o.get(d.firstSessionDateStorageKey,void 0)===void 0&&o.set(d.firstSessionDateStorageKey,new Date().toUTCString());const n=o.get(d.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();o.set(d.lastSessionDateStorageKey,typeof n>"u"?null:n),o.set(d.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=f;class g extends w{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,g.WORKSPACE_STORAGE_NAME)}constructor(o,i,n,s,c){super(n,c),this.workspace=o,this.options=i,this.environmentService=s}async doCreate(){const{storageFilePath:o,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new y.SQLiteStorageDatabase(o,{logging:this.createLoggingOptions()}),{hint:i?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:y.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const o=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,D.join)(o,g.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(o)?{storageFilePath:i,wasCreated:!1}:(await m.Promises.mkdir(o,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(o),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(o){let i;if((0,P.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,P.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const n=(0,D.join)(o,g.WORKSPACE_META_NAME);await m.Promises.exists(n)||await m.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json";class l extends w{get path(){}async doCreate(){return new I.Storage(new I.InMemoryStorageDatabase)}}e.InMemoryStorageMain=l}),define(te[258],ie([0,1,67,36,14,6,227,51,39]),function(z,e,v,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let m=class At extends u.UserDataProfilesService{constructor(y,E,h,d,P){super(h,d,E,P),this.stateService=y}getStoredProfiles(){return(0,v.revive)(this.stateService.getItem(At.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,v.revive)(this.stateService.getItem(At.PROFILE_ASSOCIATIONS_KEY,{}))}};m=ve([ee(0,D.IStateService),ee(1,b.IUriIdentityService),ee(2,t.IEnvironmentService),ee(3,k.IFileService),ee(4,R.ILogService)],m),e.UserDataProfilesService=m}),define(te[42],ie([0,1,7,36,14,5,6,38,51,39,258]),function(z,e,v,t,k,R,D,b,u,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(m.IUserDataProfilesService);let y=class dt extends I.UserDataProfilesService{constructor(h,d,P,w,p){super(h,d,P,w,p),this.stateMainService=h}setEnablement(h){super.setEnablement(h),this.enabled||(this.saveStoredProfiles([]),this.saveStoredProfileAssociations({}))}isEnabled(){return this.enabled}checkAndCreateProfileFromCli(h){if(!!this.isEnabled()){if(h.profile){const d=this.profiles.find(P=>P.name===h.profile);return d?Promise.resolve(d):this.createNamedProfile(h.profile)}if(h["profile-temp"])return this.createTransientProfile()}}saveStoredProfiles(h){h.length?this.stateMainService.setItem(dt.PROFILES_KEY,h):this.stateMainService.removeItem(dt.PROFILES_KEY)}saveStoredProfileAssociations(h){h.emptyWindow||h.workspaces?this.stateMainService.setItem(dt.PROFILE_ASSOCIATIONS_KEY,h):this.stateMainService.removeItem(dt.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const h="workspaceAndProfileInfo",d=this.stateMainService.getItem(h,void 0);if(d){this.stateMainService.removeItem(h);const P=d.reduce((w,{workspace:p,profile:S})=>(w[v.URI.revive(p).toString()]=v.URI.revive(S).toString(),w),{});this.stateMainService.setItem(dt.PROFILE_ASSOCIATIONS_KEY,{workspaces:P})}return super.getStoredProfileAssociations()}};y=ve([ee(0,b.IStateMainService),ee(1,u.IUriIdentityService),ee(2,t.IEnvironmentService),ee(3,k.IFileService),ee(4,D.ILogService)],y),e.UserDataProfilesMainService=y}),define(te[259],ie([0,1,2,16,72,89,14,6,39,42]),function(z,e,v,t,k,R,D,b,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let I=class extends v.Disposable{constructor(E,h,d,P,w){super(),this.userDataProfilesService=E,this.fileService=h,this.extensionsScannerService=d,this.extensionsProfileScannerService=P,E.isEnabled()?(this._register(E.onWillCreateProfile(p=>{E.profiles.length===1&&p.join(this.initialize())})),this._register(E.onDidChangeProfiles(p=>{E.profiles.length===1&&this.uninitialize()}))):this.uninitialize().then(null,p=>w.error(p))}async initialize(){const E=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(E)}catch{}const h=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(h.map(d=>[d,d.metadata]),E)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,u.EXTENSIONS_RESOURCE_NAME)}};I=ve([ee(0,m.IUserDataProfilesMainService),ee(1,D.IFileService),ee(2,R.IExtensionsScannerService),ee(3,k.IExtensionsProfileScannerService),ee(4,b.ILogService)],I),e.DefaultExtensionsProfileInitHandler=I}),define(te[260],ie([0,1,15,24,4,7,21,19,59,5,6,116,33,42]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,m.createDecorator)(e.ID);let d=class{constructor(w,p,S,f,g){this.logService=w,this.windowsMainService=p,this.urlService=S,this.configurationService=f,this.userDataProfilesMainService=g}async start(w,p){this.logService.trace("Received data from other instance: ",w,p),k.isMacintosh&&v.app.focus({steal:!0});const S=this.parseOpenUrl(w);if(S.length){let f=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const g=(0,t.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));g&&(f=g.ready())}f.then(()=>{for(const{uri:g,url:l}of S)this.urlService.open(g,{originalUrl:l})})}else return this.startOpenWindow(w,p)}parseOpenUrl(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,t.coalesce)(w._urls.map(p=>{try{return{uri:R.URI.parse(p),url:p}}catch{return null}})):[]}async startOpenWindow(w,p){const S=(0,u.isLaunchedFromCli)(p)?0:4;let f=[];const g=w.wait&&w.waitMarkerFilePath?R.URI.file(w.waitMarkerFilePath):void 0,l=w.remote||void 0,r=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(w),o={context:S,cli:w,userEnv:p,waitMarkerFileURI:g,remoteAuthority:l,profile:r};if(w.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,o);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let i=!1;if(w["new-window"]||w["unity-launch"]||r)i=!0;else if(w["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!k.isMacintosh}if(i)f=await this.windowsMainService.open({...o,forceNewWindow:!0,forceEmpty:!0});else{const n=this.windowsMainService.getLastActiveWindow();n?(this.windowsMainService.openExistingWindow(n,o),f=[n]):f=await this.windowsMainService.open({...o,forceEmpty:!0})}}else f=await this.windowsMainService.open({...o,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(g&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,D.whenDeleted)(g.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};d=ve([ee(0,I.ILogService),ee(1,E.IWindowsMainService),ee(2,y.IURLService),ee(3,b.IConfigurationService),ee(4,h.IUserDataProfilesMainService)],d),e.LaunchMainService=d}),define(te[91],ie([0,1,7,49,3,2,36,14,5,22,6,90,257,39,42,51]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,u.createDecorator)("storageMainService");let w=class extends R.Disposable{constructor(f,g,l,r,o,i){super(),this.logService=f,this.environmentService=g,this.userDataProfilesService=l,this.lifecycleMainService=r,this.fileService=o,this.uriIdentityService=i,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new k.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(f=>{f.window.profile&&this.profileStorage(f.window.profile).init(),f.workspace&&this.workspaceStorage(f.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(f=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=f.reason,f.join(this.applicationStorage.close());for(const[,g]of this.mapProfileToStorage)f.join(g.close());for(const[,g]of this.mapWorkspaceToStorage)f.join(g.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(f=>{f.join((async()=>{await this.fileService.exists(f.profile.globalStorageHome)||await this.fileService.createFolder(f.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(f=>{const g=this.mapProfileToStorage.get(f.profile.id);g&&f.join(g.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const f=new E.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,t.once)(f.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),f}profileStorage(f){if((0,y.isProfileUsingDefaultStorage)(f))return this.applicationStorage;let g=this.mapProfileToStorage.get(f.id);if(!g){this.logService.trace(`StorageMainService: creating profile storage (${f.name})`),g=this.createProfileStorage(f),this.mapProfileToStorage.set(f.id,g);const l=this._register(g.onDidChangeStorage(r=>this._onDidChangeProfileStorage.fire({...r,storage:g,profile:f})));(0,t.once)(g.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${f.name})`),this.mapProfileToStorage.delete(f.id),l.dispose()})}return g}createProfileStorage(f){return this.shutdownReason===2?new E.InMemoryStorageMain(this.logService,this.fileService):new E.ProfileStorageMain(f,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(f){let g=this.mapWorkspaceToStorage.get(f.id);return g||(this.logService.trace(`StorageMainService: creating workspace storage (${f.id})`),g=this.createWorkspaceStorage(f),this.mapWorkspaceToStorage.set(f.id,g),(0,t.once)(g.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${f.id})`),this.mapWorkspaceToStorage.delete(f.id)})),g}createWorkspaceStorage(f){return this.shutdownReason===2?new E.InMemoryStorageMain(this.logService,this.fileService):new E.WorkspaceStorageMain(f,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(f){const g=v.URI.file(f);for(const l of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(!!l.path&&this.uriIdentityService.extUri.isEqualOrParent(v.URI.file(l.path),g))return!0;return!1}};w=ve([ee(0,I.ILogService),ee(1,D.IEnvironmentService),ee(2,d.IUserDataProfilesMainService),ee(3,m.ILifecycleMainService),ee(4,b.IFileService),ee(5,P.IUriIdentityService)],w),e.StorageMainService=w,e.IApplicationStorageMainService=(0,u.createDecorator)("applicationStorageMainService");let p=class extends y.AbstractStorageService{constructor(f,g){super(),this.userDataProfilesService=f,this.storageMainService=g,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(f){if(f===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(f){if(f===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};p=ve([ee(0,h.IUserDataProfilesService),ee(1,e.IStorageMainService)],p),e.ApplicationStorageMainService=p}),define(te[261],ie([0,1,2,22,42]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends v.Disposable{constructor(b,u){super(),this.userDataProfilesService=u,this._register(b.onWillLoadWindow(m=>{m.reason===2&&this.unsetTransientProfileForWorkspace(m.window.openedWorkspace??"empty-window")})),this._register(b.onBeforeCloseWindow(m=>this.unsetTransientProfileForWorkspace(m.openedWorkspace??"empty-window")))}async unsetTransientProfileForWorkspace(b){this.userDataProfilesService.getOrSetProfileForWorkspace(b).isTransient&&(this.userDataProfilesService.unsetWorkspace(b,!0),await this.userDataProfilesService.cleanUpTransientProfiles())}};R=ve([ee(0,t.ILifecycleMainService),ee(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(te[262],ie([0,1,3,2,90]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends t.Disposable{constructor(b,u,m){super(),this.storageMainService=b,this.userDataProfilesService=u,this.logService=m;const I=this._register(new t.MutableDisposable);this._onDidChange=this._register(new v.Emitter({onFirstListenerAdd:()=>I.value=this.registerStorageChangeListeners(),onLastListenerRemove:()=>I.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const b=new t.DisposableStore;return b.add(v.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(u,m)=>(u?u.push(m.key):u=[m.key],u),100)(u=>this.onDidChangeApplicationStorage(u))),b.add(v.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(u,m)=>{u||(u=new Map);let I=u.get(m.profile.id);return I||u.set(m.profile.id,I={profile:m.profile,keys:[],storage:m.storage}),I.keys.push(m.key),u},100)(u=>this.onDidChangeProfileStorage(u))),b}onDidChangeApplicationStorage(b){const u=b.includes(k.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],m=[];if(b=b.filter(I=>I!==k.TARGET_KEY),b.length){const I=(0,k.loadKeyTargets)(this.storageMainService.applicationStorage.storage);m.push({profile:this.userDataProfilesService.defaultProfile,changes:b.map(y=>({key:y,scope:0,target:I[y]}))})}this.triggerEvents(u,m)}onDidChangeProfileStorage(b){const u=[],m=new Map;for(const[I,y]of b.entries()){y.keys.includes(k.TARGET_KEY)&&u.push(y.profile);const E=y.keys.filter(h=>h!==k.TARGET_KEY);if(E.length){const h=(0,k.loadKeyTargets)(y.storage.storage);m.set(I,{profile:y.profile,changes:E.map(d=>({key:d,scope:0,target:h[d]}))})}}this.triggerEvents(u,[...m.values()])}triggerEvents(b,u){(b.length||u.length)&&this._onDidChange.fire({valueChanges:u,targetChanges:b})}listen(b,u,m){switch(u){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${u}`)}async call(b,u){throw new Error(`Call not found: ${u}`)}}e.ProfileStorageChangesListenerChannel=R}),define(te[118],ie([0,1,16,7,28]),function(z,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(u,m,I){for(const E of u){const h=E.openedWorkspace;if((0,k.isWorkspaceIdentifier)(h)){const d=await I(h);if(d){if(d.folders.some(P=>v.extUriBiasedIgnorePathCase.isEqualOrParent(m,P.uri)))return E}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(m,h.configPath))return E}}const y=u.filter(E=>(0,k.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(m,E.openedWorkspace.uri));if(y.length)return y.sort((E,h)=>-(E.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(u,m){for(const I of u)if((0,k.isWorkspaceIdentifier)(I.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.configPath,m)||(0,k.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.uri,m))return I}e.findWindowOnWorkspaceOrFolder=D;function b(u,m){const I=y=>m.some(E=>v.extUriBiasedIgnorePathCase.isEqual(t.URI.file(E),t.URI.file(y)));for(const y of u)if(y.config?.extensionDevelopmentPath?.some(E=>I(E)))return y}e.findWindowOnExtensionDevelopmentPath=b}),define(te[263],ie([0,1,15,2,4,16,7,19,22,6,38,33,117,28]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class Tt extends t.Disposable{get state(){return this._state}constructor(g,l,r,o,i){super(),this.windowsMainService=g,this.stateMainService=l,this.lifecycleMainService=r,this.logService=o,this.configurationService=i,this._state=P(this.stateMainService.getItem(Tt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(g=>this.onBeforeCloseWindow(g)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(g=>{g.newCount-g.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(g=>this.onBeforeCloseWindow(g))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const g=new Set,l={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!l.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(l.lastActiveWindow=this.toWindowState(i),l.lastActiveWindow.uiState.mode===3&&g.add(l.lastActiveWindow.uiState.display))}const r=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);r&&(l.lastPluginDevelopmentHostWindow=this.toWindowState(r),l.lastPluginDevelopmentHostWindow.uiState.mode===3&&(g.has(l.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!r.win?.isSimpleFullScreen()&&(l.lastPluginDevelopmentHostWindow.uiState.mode=1):g.add(l.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(l.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.toWindowState(i);return n.uiState.mode===3&&(g.has(n.uiState.display)?k.isMacintosh&&n.windowId!==l.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):g.add(n.uiState.display)),n}));const o=p(l);this.stateMainService.setItem(Tt.windowsStateStorageKey,o),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",o)}onBeforeCloseWindow(g){if(this.lifecycleMainService.quitRequested)return;const l=this.toWindowState(g);g.isExtensionDevelopmentHost&&!g.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!g.isExtensionDevelopmentHost&&g.openedWorkspace&&this._state.openedWindows.forEach(r=>{const o=(0,h.isWorkspaceIdentifier)(g.openedWorkspace)&&r.workspace?.id===g.openedWorkspace.id,i=(0,h.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)&&r.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(r.folderUri,g.openedWorkspace.uri);(o||i)&&(r.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}toWindowState(g){return{windowId:g.id,workspace:(0,h.isWorkspaceIdentifier)(g.openedWorkspace)?g.openedWorkspace:void 0,folderUri:(0,h.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)?g.openedWorkspace.uri:void 0,backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.serializeWindowState()}}getNewWindowState(g){const l=this.doGetNewWindowState(g),r=this.configurationService.getValue("window");if(l.mode===3){let o;l.hasDefaultState?o=!!(r?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(r.newWindowDimensions)>=0):o=!!(this.lifecycleMainService.wasRestarted||r?.restoreFullscreen),o||(l.mode=1)}return l}doGetNewWindowState(g){const l=this.windowsMainService.getLastActiveWindow();if(!g.extensionTestsPath){if(!!g.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=g.workspace;if((0,h.isWorkspaceIdentifier)(c)){const C=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===c.id).map(M=>M.uiState);if(C.length)return C[0]}if((0,h.isSingleFolderWorkspaceIdentifier)(c)){const C=this.state.openedWindows.filter(M=>M.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(M.folderUri,c.uri)).map(M=>M.uiState);if(C.length)return C[0]}else if(g.backupPath){const C=this.state.openedWindows.filter(M=>M.backupPath===g.backupPath).map(M=>M.uiState);if(C.length)return C[0]}const a=this.lastClosedState||this.state.lastActiveWindow;if(!l&&a)return a.uiState}let r;const o=v.screen.getAllDisplays();if(o.length===1)r=o[0];else{if(k.isMacintosh){const c=v.screen.getCursorScreenPoint();r=v.screen.getDisplayNearestPoint(c)}!r&&l&&(r=v.screen.getDisplayMatching(l.getBounds())),r||(r=v.screen.getPrimaryDisplay()||o[0])}let i=(0,E.defaultWindowState)();i.x=Math.round(r.bounds.x+r.bounds.width/2-i.width/2),i.y=Math.round(r.bounds.y+r.bounds.height/2-i.height/2);const n=this.configurationService.getValue("window");let s=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,s=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,s=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&l){const c=l.serializeWindowState();c.mode===3?i.mode=3:i=c,s=i.mode!==3&&n.newWindowDimensions==="offset"}}return s&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(g){if(this.windowsMainService.getWindows().length===0)return g;g.x=typeof g.x=="number"?g.x:0,g.y=typeof g.y=="number"?g.y:0;const l=this.windowsMainService.getWindows().map(r=>r.getBounds());for(;l.some(r=>r.x===g.x||r.y===g.y);)g.x+=30,g.y+=30;return g}};d.windowsStateStorageKey="windowsState",d=ve([ee(0,y.IWindowsMainService),ee(1,I.IStateMainService),ee(2,u.ILifecycleMainService),ee(3,m.ILogService),ee(4,b.IConfigurationService)],d),e.WindowsStateHandler=d;function P(f){const g={openedWindows:[]},l=f||{openedWindows:[]};return l.lastActiveWindow&&(g.lastActiveWindow=w(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(g.lastPluginDevelopmentHostWindow=w(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(g.openedWindows=l.openedWindows.map(r=>w(r))),g}e.restoreWindowsState=P;function w(f){const g={uiState:f.uiState};return f.backupPath&&(g.backupPath=f.backupPath),f.remoteAuthority&&(g.remoteAuthority=f.remoteAuthority),f.folder&&(g.folderUri=D.URI.parse(f.folder)),f.workspaceIdentifier&&(g.workspace={id:f.workspaceIdentifier.id,configPath:D.URI.parse(f.workspaceIdentifier.configURIPath)}),g}function p(f){return{lastActiveWindow:f.lastActiveWindow&&S(f.lastActiveWindow),lastPluginDevelopmentHostWindow:f.lastPluginDevelopmentHostWindow&&S(f.lastPluginDevelopmentHostWindow),openedWindows:f.openedWindows.map(g=>S(g))}}e.getWindowsStateStoreData=p;function S(f){return{workspaceIdentifier:f.workspace&&{id:f.workspace.id,configURIPath:f.workspace.configPath.toString()},folder:f.folderUri&&f.folderUri.toString(),backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.uiState}}}),define(te[92],ie([0,1,30,43,124,35,13,9,4,16,7,5,63,28]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,y.createDecorator)("workspacesService");function d(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function P(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=P;function w(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=w;function p(M){return S(M)||f(M)}e.isStoredWorkspaceFolder=p;function S(M){const T=M;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function f(M){const T=M;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function g(M,T,U,Q,ae){if(M.scheme!==Q.scheme)return{name:U,uri:M.toString(!0)};let X=T?void 0:ae.relativePath(Q,M);if(X!==void 0)X.length===0?X=".":u.isWindows&&(X=l(X));else if(M.scheme===D.Schemas.file)X=M.fsPath,u.isWindows&&(X=l(X));else if(ae.isEqualAuthority(M.authority,Q.authority))X=M.path;else return{name:U,uri:M.toString(!0)};return{name:U,path:X}}e.getStoredWorkspaceFolder=g;function l(M){return M=(0,R.normalizeDriveLetter)(M),(0,v.isUNC)(M)||(M=(0,v.toSlashes)(M)),M}function r(M,T,U){const Q=[],ae=new Set,X=U.dirname(T);for(const G of M){let Z;if(S(G))G.path&&(Z=U.resolvePath(X,G.path));else if(f(G))try{Z=I.URI.parse(G.uri),Z.path[0]!==b.posix.sep&&(Z=Z.with({path:b.posix.sep+Z.path}))}catch(se){console.warn(se)}if(Z){const se=U.getComparisonKey(Z);if(!ae.has(se)){ae.add(se);const he=G.name||U.basenameOrAuthority(Z);Q.push(new h.WorkspaceFolder({uri:Z,name:he,index:Q.length},G))}}}return Q}e.toWorkspaceFolders=r;function o(M,T,U,Q,ae){const X=i(T,M),G=ae.dirname(T),Z=ae.dirname(Q),se=[];for(const W of X.folders){const A=S(W)?ae.resolvePath(G,W.path):I.URI.parse(W.uri);let F;U?F=!1:F=!S(W)||(0,b.isAbsolute)(W.path),se.push(g(A,F,W.name,Z,ae))}const he={insertSpaces:!1,tabSize:4,eol:u.isLinux||u.isMacintosh?`
`:`\r
`},V=k.setProperty(M,["folders"],se,he);let H=k.applyEdits(M,V);return(0,m.isEqualAuthority)(X.remoteAuthority,(0,E.getRemoteAuthority)(Q))&&(H=k.applyEdits(H,k.removeProperty(H,["remoteAuthority"],he))),H}e.rewriteWorkspaceFileForNewLocation=o;function i(M,T){const U=t.parse(T);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(Q=>p(Q));else throw new Error(`${M} looks like an invalid workspace file.`);return U}function n(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function s(M){return typeof M.folderUri=="string"}function c(M){return typeof M.fileUri=="string"}function a(M,T){const U={workspaces:[],files:[]};if(M){const Q=function(X,G){for(let Z=0;Z<X.length;Z++)try{G(X[Z],Z)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(X[Z])}: ${se.toString()}. Skip entry.`)}},ae=M;Array.isArray(ae.entries)&&Q(ae.entries,X=>{const G=X.label,Z=X.remoteAuthority;n(X)?U.workspaces.push({label:G,remoteAuthority:Z,workspace:{id:X.workspace.id,configPath:I.URI.parse(X.workspace.configPath)}}):s(X)?U.workspaces.push({label:G,remoteAuthority:Z,folderUri:I.URI.parse(X.folderUri)}):c(X)&&U.files.push({label:G,remoteAuthority:Z,fileUri:I.URI.parse(X.fileUri)})})}return U}e.restoreRecentlyOpened=a;function C(M){const T={entries:[]};for(const U of M.workspaces)P(U)?T.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):T.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of M.files)T.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return T}e.toStoreData=C}),define(te[93],ie([0,1,76,13,4,16]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(m){function I(){let y=m.scheme===t.Schemas.file?(0,R.originalFSPath)(m):m.toString();return k.isLinux||(y=y.toLowerCase()),(0,v.createHash)("md5").update(y).digest("hex")}return{id:I(),configPath:m}}e.getWorkspaceIdentifier=D;function b(m,I){function y(){if(m.scheme!==t.Schemas.file)return(0,v.createHash)("md5").update(m.toString()).digest("hex");if(!I)return;let h;return k.isLinux?h=I.ino:k.isMacintosh?h=I.birthtime.getTime():k.isWindows&&(typeof I.birthtimeMs=="number"?h=Math.floor(I.birthtimeMs):h=I.birthtime.getTime()),(0,v.createHash)("md5").update(m.fsPath).update(h?String(h):"").digest("hex")}const E=y();if(typeof E=="string")return{id:E,uri:m}}e.getSingleFolderWorkspaceIdentifier=b;function u(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=u}),define(te[264],ie([0,1,76,30,13,9,4,16,21,177,19,27,38,14,6,176,28,93]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let S=class Ot{constructor(g,l,r,o){this.environmentMainService=g,this.configurationService=l,this.logService=r,this.stateMainService=o,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=b.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,n)=>(0,t.isEqual)(i,n,!D.isLinux)}}async initialize(){const g=await this.initializeAndMigrateBackupWorkspacesMetadata();this.emptyWindows=await this.validateEmptyWorkspaces(g.emptyWindows),this.workspaces=await this.validateWorkspaces((0,m.deserializeWorkspaceInfos)(g)),this.folders=await this.validateFolders((0,m.deserializeFolderInfos)(g)),this.storeWorkspacesMetadata()}async initializeAndMigrateBackupWorkspacesMetadata(){let g=this.stateMainService.getItem(Ot.backupWorkspacesMetadataStorageKey);if(!g)try{const l=(0,R.join)(this.backupHome,"workspaces.json"),r=await u.Promises.readFile(l,"utf8");try{await u.Promises.unlink(l)}catch{}const o=JSON.parse(r);g={workspaces:Array.isArray(o.rootURIWorkspaces)?o.rootURIWorkspaces:[],folders:Array.isArray(o.folderWorkspaceInfos)?o.folderWorkspaceInfos:[],emptyWindows:Array.isArray(o.emptyWorkspaceInfos)?o.emptyWorkspaceInfos:[]}}catch(l){l.code!=="ENOENT"&&this.logService.error(`Backup: Could not migrate legacy backup workspaces metadata: ${l.toString()}`)}return g??{workspaces:[],folders:[],emptyWindows:[]}}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==h.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(g,l){this.workspaces.some(o=>g.workspace.id===o.workspace.id)||(this.workspaces.push(g),this.storeWorkspacesMetadata());const r=(0,R.join)(this.backupHome,g.workspace.id);return l?this.moveBackupFolder(r,l).then(()=>r):r}async moveBackupFolder(g,l){if(await u.Promises.exists(g)&&await this.convertToEmptyWindowBackup(g),await u.Promises.exists(l))try{await u.Promises.rename(l,g)}catch(r){this.logService.error(`Backup: Could not move backup folder to new location: ${r.toString()}`)}}registerFolderBackup(g){return this.folders.some(l=>this.backupUriComparer.isEqual(g.folderUri,l.folderUri))||(this.folders.push(g),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,this.getFolderHash(g))}registerEmptyWindowBackup(g){return this.emptyWindows.some(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,g.backupFolder))||(this.emptyWindows.push(g),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,g.backupFolder)}async validateWorkspaces(g){if(!Array.isArray(g))return[];const l=new Set,r=[];for(const o of g){const i=o.workspace;if(!(0,w.isWorkspaceIdentifier)(i))return[];if(!l.has(i.id)){l.add(i.id);const n=(0,R.join)(this.backupHome,i.id);await this.doHasBackups(n)?i.configPath.scheme!==k.Schemas.file||await u.Promises.exists(i.configPath.fsPath)?r.push(o):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return r}async validateFolders(g){if(!Array.isArray(g))return[];const l=[],r=new Set;for(const o of g){const i=o.folderUri,n=this.backupUriComparer.getComparisonKey(i);if(!r.has(n)){r.add(n);const s=(0,R.join)(this.backupHome,this.getFolderHash(o));await this.doHasBackups(s)?i.scheme!==k.Schemas.file||await u.Promises.exists(i.fsPath)?l.push(o):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return l}async validateEmptyWorkspaces(g){if(!Array.isArray(g))return[];const l=[],r=new Set;for(const o of g){const i=o.backupFolder;if(typeof i!="string")return[];if(!r.has(i)){r.add(i);const n=(0,R.join)(this.backupHome,i);await this.doHasBackups(n)?l.push(o):await this.deleteStaleBackup(n)}}return l}async deleteStaleBackup(g){try{await u.Promises.rm(g,u.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}prepareNewEmptyWindowBackup(){let g=(0,p.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,g.id));)g=(0,p.createEmptyWorkspaceIdentifier)();return{backupFolder:g.id}}async convertToEmptyWindowBackup(g){const l=this.prepareNewEmptyWindowBackup(),r=(0,R.join)(this.backupHome,l.backupFolder);try{await u.Promises.rename(g,r)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push(l),!0}async getDirtyWorkspaces(){const g=[];for(const l of this.workspaces)await this.hasBackups(l)&&g.push(l);for(const l of this.folders)await this.hasBackups(l)&&g.push(l);return g}hasBackups(g){let l;return(0,m.isEmptyWindowBackupInfo)(g)?l=(0,R.join)(this.backupHome,g.backupFolder):(0,P.isFolderBackupInfo)(g)?l=(0,R.join)(this.backupHome,this.getFolderHash(g)):l=(0,R.join)(this.backupHome,g.workspace.id),this.doHasBackups(l)}async doHasBackups(g){try{const l=await u.Promises.readdir(g);for(const r of l)try{if((await u.Promises.readdir((0,R.join)(g,r))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const g={workspaces:this.workspaces.map(({workspace:l,remoteAuthority:r})=>{const o={id:l.id,configURIPath:l.configPath.toString()};return r&&(o.remoteAuthority=r),o}),folders:this.folders.map(({folderUri:l,remoteAuthority:r})=>{const o={folderUri:l.toString()};return r&&(o.remoteAuthority=r),o}),emptyWindows:this.emptyWindows.map(({backupFolder:l,remoteAuthority:r})=>{const o={backupFolder:l};return r&&(o.remoteAuthority=r),o})};this.stateMainService.setItem(Ot.backupWorkspacesMetadataStorageKey,g)}getFolderHash(g){const l=g.folderUri;let r;return l.scheme===k.Schemas.file?r=D.isLinux?l.fsPath:l.fsPath.toLowerCase():r=l.toString().toLowerCase(),(0,v.createHash)("md5").update(r).digest("hex")}};S.backupWorkspacesMetadataStorageKey="backupWorkspaces",S=ve([ee(0,y.IEnvironmentMainService),ee(1,I.IConfigurationService),ee(2,d.ILogService),ee(3,E.IStateMainService)],S),e.BackupMainService=S}),define(te[52],ie([0,1,15,3,43,35,2,13,9,16,12,21,175,60,56,27,5,6,20,42,118,28,92,93]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p,S,f,g,l,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,w.createDecorator)("workspacesManagementMainService");let i=class extends D.Disposable{constructor(s,c,a,C,M,T){super(),this.environmentMainService=s,this.logService=c,this.userDataProfilesMainService=a,this.backupMainService=C,this.dialogMainService=M,this.productService=T,this._onDidDeleteUntitledWorkspace=this._register(new t.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new t.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const s=(await y.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(c=>(0,m.joinPath)(this.untitledWorkspacesHome,c,l.UNTITLED_WORKSPACE_NAME));for(const c of s){const a=(0,o.getWorkspaceIdentifier)(c),C=await this.resolveLocalWorkspace(c);C?this.untitledWorkspaces.push({workspace:a,remoteAuthority:C.remoteAuthority}):await this.deleteUntitledWorkspace(a)}}catch(s){s.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${s}).`)}}resolveLocalWorkspace(s){return this.doResolveLocalWorkspace(s,c=>y.Promises.readFile(c,"utf8"))}doResolveLocalWorkspace(s,c){if(!!this.isWorkspacePath(s)&&s.scheme===b.Schemas.file)try{const a=c(s.fsPath);return a instanceof Promise?a.then(C=>this.doResolveWorkspace(s,C),C=>{}):this.doResolveWorkspace(s,a)}catch{return}}isWorkspacePath(s){return(0,l.isUntitledWorkspace)(s,this.environmentMainService)||(0,l.hasWorkspaceFileExtension)(s)}doResolveWorkspace(s,c){try{const a=this.doParseStoredWorkspace(s,c),C=(0,o.getWorkspaceIdentifier)(s);return{id:C.id,configPath:C.configPath,folders:(0,r.toWorkspaceFolders)(a.folders,C.configPath,m.extUriBiasedIgnorePathCase),remoteAuthority:a.remoteAuthority,transient:a.transient}}catch(a){this.logService.warn(a.toString())}}doParseStoredWorkspace(s,c){const a=(0,k.parse)(c);if(a&&Array.isArray(a.folders))a.folders=a.folders.filter(C=>(0,r.isStoredWorkspaceFolder)(C));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return a}async createUntitledWorkspace(s,c){const{workspace:a,storedWorkspace:C}=this.newUntitledWorkspace(s,c),M=a.configPath.fsPath;return await y.Promises.mkdir((0,u.dirname)(M),{recursive:!0}),await y.Promises.writeFile(M,JSON.stringify(C,null,"	")),this.untitledWorkspaces.push({workspace:a,remoteAuthority:c}),a}newUntitledWorkspace(s=[],c){const a=(Date.now()+Math.round(Math.random()*1e3)).toString(),C=(0,m.joinPath)(this.untitledWorkspacesHome,a),M=(0,m.joinPath)(C,l.UNTITLED_WORKSPACE_NAME),T=[];for(const U of s)T.push((0,r.getStoredWorkspaceFolder)(U.uri,!0,U.name,C,m.extUriBiasedIgnorePathCase));return{workspace:(0,o.getWorkspaceIdentifier)(M),storedWorkspace:{folders:T,remoteAuthority:c}}}async getWorkspaceIdentifier(s){return(0,o.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,l.isUntitledWorkspace)(s.configPath,this.environmentMainService)}async deleteUntitledWorkspace(s){!this.isUntitledWorkspace(s)||(await this.doDeleteUntitledWorkspace(s),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(s),this._onDidDeleteUntitledWorkspace.fire(s))}async doDeleteUntitledWorkspace(s){const c=(0,m.originalFSPath)(s.configPath);try{await y.Promises.rm((0,u.dirname)(c));const a=(0,u.join)(this.environmentMainService.workspaceStorageHome.fsPath,s.id);await y.Promises.exists(a)&&await y.Promises.writeFile((0,u.join)(a,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(C=>C.workspace.id!==s.id)}catch(a){this.logService.warn(`Unable to delete untitled workspace ${c} (${a}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(s,c,a){if(!s||!s.win||!s.isReady||!await this.isValidTargetWorkspacePath(s,c,a))return;const M=await this.doEnterWorkspace(s,(0,o.getWorkspaceIdentifier)(a));if(!!M)return this._onDidEnterWorkspace.fire({window:s,workspace:M.workspace}),M}async isValidTargetWorkspacePath(s,c,a){if(!a)return!0;if((0,l.isWorkspaceIdentifier)(s.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,a))return!1;if((0,g.findWindowOnWorkspaceOrFolder)(c,a)){const C={title:this.productService.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(0,null))],message:(0,E.localize)(1,null,(0,m.basename)(a)),detail:(0,E.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(C,(0,I.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}async doEnterWorkspace(s,c){if(!s.config)return;s.focus();let a;return s.config.extensionDevelopmentPath||(s.config.backupPath?a=await this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:s.remoteAuthority},s.config.backupPath):a=this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:s.remoteAuthority})),(0,l.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=c,s.config.backupPath=a,{workspace:c,backupPath:a}}};i=ve([ee(0,P.IEnvironmentMainService),ee(1,p.ILogService),ee(2,f.IUserDataProfilesMainService),ee(3,h.IBackupMainService),ee(4,d.IDialogMainService),ee(5,S.IProductService)],i),e.WorkspacesManagementMainService=i}),define(te[119],ie([0,1,15,41,23,5,33,28,52,12,6]),function(z,e,v,t,k,R,D,b,u,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let y=class{constructor(h,d,P){this.windowsMainService=h,this.workspacesManagementMainService=d,this.logService=P}async getRemoteDiagnostics(h){const d=this.windowsMainService.getWindows();return(await Promise.all(d.map(async w=>{const p=w.remoteAuthority;if(!p)return;const S=`vscode:getDiagnosticInfoResponse${w.id}`,f={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?await this.getFolderURIs(w):void 0};return new Promise(g=>{w.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:S,args:f}),t.validatedIpcMain.once(S,(l,r)=>{r||g({hostName:p,errorMessage:`Unable to resolve connection to '${p}'.`}),g(r)}),setTimeout(()=>{g({hostName:p,errorMessage:`Connection to '${p}' could not be established`})},5e3)})}))).filter(w=>!!w)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const h=[];for(const d of v.BrowserWindow.getAllWindows()){const P=this.windowsMainService.getWindowById(d.id);P?h.push(await this.codeWindowToInfo(P)):h.push(this.browserWindowToInfo(d))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}async codeWindowToInfo(h){const d=await this.getFolderURIs(h),P=(0,m.assertIsDefined)(h.win);return this.browserWindowToInfo(P,d,h.remoteAuthority)}browserWindowToInfo(h,d=[],P){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:d,remoteAuthority:P}}async getFolderURIs(h){const d=[],P=h.openedWorkspace;if((0,b.isSingleFolderWorkspaceIdentifier)(P))d.push(P.uri);else if((0,b.isWorkspaceIdentifier)(P)){const w=await this.workspacesManagementMainService.resolveLocalWorkspace(P.configPath);w&&w.folders.forEach(S=>{d.push(S.uri)})}return d}};y=ve([ee(0,D.IWindowsMainService),ee(1,u.IWorkspacesManagementMainService),ee(2,I.ILogService)],y),e.DiagnosticsMainService=y}),define(te[65],ie([0,1,45,15,25,141,53,3,35,2,13,9,4,7,99,81,21,95,165,56,27,5,22,6,20,64,33,28,52,18,221,231,32]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p,S,f,g,l,r,o,i,n,s,c,a,C,M,T,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,l.createDecorator)("nativeHostMainService");let Q=class extends m.Disposable{constructor(X,G,Z,se,he,V,H,W,A,F){super(),this.sharedProcess=X,this.windowsMainService=G,this.dialogMainService=Z,this.lifecycleMainService=se,this.environmentMainService=he,this.logService=V,this.productService=H,this.themeMainService=W,this.workspacesManagementMainService=A,this.telemetryService=F,this.onDidOpenWindow=b.Event.map(this.windowsMainService.onDidOpenWindow,N=>N.id),this.onDidTriggerSystemContextMenu=b.Event.filter(b.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:N,x:J,y:B})=>({windowId:N.id,x:J,y:B})),({windowId:N})=>!!this.windowsMainService.getWindowById(N)),this.onDidMaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(N,J)=>J.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidUnmaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(N,J)=>J.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidBlurWindow=b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(N,J)=>J.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidFocusWindow=b.Event.any(b.Event.map(b.Event.filter(b.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),N=>!!N),N=>N.id),b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(N,J)=>J.id),N=>!!this.windowsMainService.getWindowById(N))),this.onDidResumeOS=b.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new b.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=b.Event.debounce(b.Event.any(b.Event.filter(b.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(N,J,B)=>B),N=>!(Array.isArray(N)&&N.length===1&&N[0]==="workArea")),b.Event.fromNodeEventEmitter(t.screen,"display-added"),b.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100),this._profilingSessions=new Map}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(G=>({id:G.id,workspace:G.openedWorkspace??(0,c.toWorkspaceIdentifier)(G.backupPath,G.isExtensionDevelopmentHost),title:G.win?.getTitle()??"",filename:G.getRepresentedFilename(),dirty:G.isDocumentEdited()}))}async getWindowCount(X){return this.windowsMainService.getWindowCount()}async getActiveWindowId(X){const G=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(G)return G.id}openWindow(X,G,Z){return Array.isArray(G)?this.doOpenWindow(X,G,Z):this.doOpenEmptyWindow(X,G)}async doOpenWindow(X,G,Z=Object.create(null)){G.length>0&&await this.windowsMainService.open({context:5,contextWindowId:X,urisToOpen:G,cli:this.environmentMainService.args,forceNewWindow:Z.forceNewWindow,forceReuseWindow:Z.forceReuseWindow,preferNewWindow:Z.preferNewWindow,diffMode:Z.diffMode,mergeMode:Z.mergeMode,addMode:Z.addMode,gotoLineMode:Z.gotoLineMode,noRecentEntry:Z.noRecentEntry,waitMarkerFileURI:Z.waitMarkerFileURI,remoteAuthority:Z.remoteAuthority||void 0})}async doOpenEmptyWindow(X,G){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:X},G)}async toggleFullScreen(X){this.windowById(X)?.toggleFullScreen()}async handleTitleDoubleClick(X){this.windowById(X)?.handleTitleDoubleClick()}async isMaximized(X){const G=this.windowById(X);return G?.win?G.win.isMaximized():!1}async maximizeWindow(X){const G=this.windowById(X);G?.win&&G.win.maximize()}async unmaximizeWindow(X){const G=this.windowById(X);G?.win&&G.win.unmaximize()}async minimizeWindow(X){const G=this.windowById(X);G?.win&&G.win.minimize()}async updateWindowControls(X,G){const Z=this.windowById(X);Z&&Z.updateWindowControls(G)}async focusWindow(X,G){G&&typeof G.windowId=="number"&&(X=G.windowId),this.windowById(X)?.focus({force:G?.force??!1})}async setMinimumSize(X,G,Z){const se=this.windowById(X);if(se?.win){const[he,V]=se.win.getSize(),[H,W]=se.win.getMinimumSize(),[A,F]=[G??H,Z??W],[N,J]=[Math.max(he,A),Math.max(V,F)];(H!==A||W!==F)&&se.win.setMinimumSize(A,F),(he!==N||V!==J)&&se.win.setSize(N,J)}}async saveWindowSplash(X,G){this.themeMainService.saveWindowSplash(X,G)}async installShellCommand(X){const{source:G,target:Z}=await this.getShellCommandLink();try{const{symbolicLink:se}=await w.SymlinkSupport.stat(G);if(se&&!se.dangling){const he=await(0,d.realpath)(G);if(Z===he)return}await w.Promises.unlink(G)}catch(se){if(se.code!=="ENOENT")throw se}try{await w.Promises.symlink(Z,G)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:he}=await this.showMessageBox(X,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(0,null,this.productService.nameShort),buttons:[(0,u.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,u.mnemonicButtonLabel)((0,S.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(he===0)try{const V=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Z}' '${G}'\\" with administrator privileges"`;await(0,R.promisify)(v.exec)(V)}catch{throw new Error((0,S.localize)(3,null,G))}}}async uninstallShellCommand(X){const{source:G}=await this.getShellCommandLink();try{await w.Promises.unlink(G)}catch(Z){switch(Z.code){case"EACCES":{const{response:se}=await this.showMessageBox(X,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(4,null,this.productService.nameShort),buttons:[(0,u.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,u.mnemonicButtonLabel)((0,S.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const he=`osascript -e "do shell script \\"rm '${G}'\\" with administrator privileges"`;await(0,R.promisify)(v.exec)(he)}catch{throw new Error((0,S.localize)(7,null,G))}break}case"ENOENT":break;default:throw Z}}}async getShellCommandLink(){const X=(0,y.resolve)(this.environmentMainService.appRoot,"bin","code"),G=`/usr/local/bin/${this.productService.applicationName}`;if(!await w.Promises.exists(X))throw new Error((0,S.localize)(8,null,X));return{source:G,target:X}}async showMessageBox(X,G){return this.dialogMainService.showMessageBox(G,this.toBrowserWindow(X))}async showSaveDialog(X,G){return this.dialogMainService.showSaveDialog(G,this.toBrowserWindow(X))}async showOpenDialog(X,G){return this.dialogMainService.showOpenDialog(G,this.toBrowserWindow(X))}toBrowserWindow(X){const G=this.windowById(X);if(G?.win)return G.win}async pickFileFolderAndOpen(X,G){const Z=await this.dialogMainService.pickFileFolder(G);Z&&await this.doOpenPicked(await Promise.all(Z.map(async se=>await w.SymlinkSupport.existsDirectory(se)?{folderUri:h.URI.file(se)}:{fileUri:h.URI.file(se)})),G,X)}async pickFolderAndOpen(X,G){const Z=await this.dialogMainService.pickFolder(G);Z&&await this.doOpenPicked(Z.map(se=>({folderUri:h.URI.file(se)})),G,X)}async pickFileAndOpen(X,G){const Z=await this.dialogMainService.pickFile(G);Z&&await this.doOpenPicked(Z.map(se=>({fileUri:h.URI.file(se)})),G,X)}async pickWorkspaceAndOpen(X,G){const Z=await this.dialogMainService.pickWorkspace(G);Z&&await this.doOpenPicked(Z.map(se=>({workspaceUri:h.URI.file(se)})),G,X)}async doOpenPicked(X,G,Z){await this.windowsMainService.open({context:3,contextWindowId:Z,cli:this.environmentMainService.args,urisToOpen:X,forceNewWindow:G.forceNewWindow})}async showItemInFolder(X,G){t.shell.showItemInFolder(G)}async setRepresentedFilename(X,G){this.windowById(X)?.setRepresentedFilename(G)}async setDocumentEdited(X,G){this.windowById(X)?.setDocumentEdited(G)}async openExternal(X,G){return E.isLinuxSnap?this.safeSnapOpenExternal(G):t.shell.openExternal(G),!0}safeSnapOpenExternal(X){const G=process.env.GDK_PIXBUF_MODULE_FILE,Z=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(X),process.env.GDK_PIXBUF_MODULE_FILE=G,process.env.GDK_PIXBUF_MODULEDIR=Z}moveItemToTrash(X,G){return t.shell.trashItem(G)}async isAdmin(){let X;return E.isWindows?X=(await new Promise((G,Z)=>{z(["native-is-elevated"],G,Z)}))():X=process.getuid()===0,X}async writeElevated(X,G,Z,se){const he=await new Promise((V,H)=>{z(["@vscode/sudo-prompt"],V,H)});return new Promise((V,H)=>{const W=[`"${this.cliPath}"`];se?.unlock&&W.push("--file-chmod"),W.push("--file-write",`"${G.fsPath}"`,`"${Z.fsPath}"`);const A={name:this.productService.nameLong.replace("-",""),icns:E.isMacintosh&&this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};he.exec(W.join(" "),A,(F,N,J)=>{N&&this.logService.trace(`[sudo-prompt] received stdout: ${N}`),J&&this.logService.trace(`[sudo-prompt] received stderr: ${J}`),F?H(F):V(void 0)})})}get cliPath(){return E.isWindows?this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):E.isLinux?this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,y.join)(this.environmentMainService.appRoot,"bin","code"):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return P.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return E.isWindows&&(0,M.hasWSLFeatureInstalled)()}async killProcess(X,G,Z){process.kill(G,Z)}async readClipboardText(X,G){return t.clipboard.readText(G)}async writeClipboardText(X,G,Z){return t.clipboard.writeText(G,Z)}async readClipboardFindText(X){return t.clipboard.readFindText()}async writeClipboardFindText(X,G){return t.clipboard.writeFindText(G)}async writeClipboardBuffer(X,G,Z,se){return t.clipboard.writeBuffer(G,Buffer.from(Z.buffer),se)}async readClipboardBuffer(X,G){return C.VSBuffer.wrap(t.clipboard.readBuffer(G))}async hasClipboard(X,G,Z){return t.clipboard.has(G,Z)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(X,G){this.windowById(X)?.updateTouchBar(G)}async notifyReady(X){this.windowById(X)?.setReady()}async relaunch(X,G){return this.lifecycleMainService.relaunch(G)}async reload(X,G){const Z=this.windowById(X);if(Z){if((0,c.isWorkspaceIdentifier)(Z.openedWorkspace)){const se=Z.openedWorkspace.configPath;if(se.scheme===I.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(se))?.transient)return this.openWindow(Z.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(Z,G?.disableExtensions!==void 0?{_:[],"disable-extensions":G.disableExtensions}:void 0)}}async closeWindow(X){this.closeWindowById(X,X)}async closeWindowById(X,G){const Z=this.windowById(G);if(Z?.win)return Z.win.close()}async quit(X){const G=this.windowsMainService.getLastActiveWindow();G?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&G.win?G.win.close():this.lifecycleMainService.quit()}async exit(X,G){await this.lifecycleMainService.kill(G)}async resolveProxy(X,G){const se=this.windowById(X)?.win?.webContents?.session;if(se)return se.resolveProxy(G)}findFreePort(X,G,Z,se,he=1){return(0,p.findFreePort)(G,Z,se,he)}async openDevTools(X,G){const Z=this.windowById(X);Z?.win&&Z.win.webContents.openDevTools(G)}async toggleDevTools(X){const G=this.windowById(X);G?.win&&G.win.webContents.toggleDevTools()}async sendInputEvent(X,G){const Z=this.windowById(X);Z?.win&&(G.type==="mouseDown"||G.type==="mouseUp")&&Z.win.webContents.sendInputEvent(G)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async startHeartbeat(X,G){const Z=this.windowById(X);if(!Z||!Z.win)return!1;if(!this._profilingSessions.has(Z.id)){const se=new T.WindowProfiler(Z.win,G,this.logService,this.telemetryService);this._profilingSessions.set(Z.id,se),se.start()}return!0}async sendHeartbeat(X,G){const Z=this.windowById(X);return!Z||!this._profilingSessions.has(Z.id)||this._profilingSessions.get(Z.id).receiveHeartbeat(),!1}async stopHeartbeat(X,G){const Z=this.windowById(X);return!Z||!this._profilingSessions.has(Z.id)||(this._profilingSessions.get(Z.id).stop(),this._profilingSessions.delete(Z.id)),!1}async windowsGetStringRegKey(X,G,Z,se){if(!E.isWindows)return;const he=await new Promise((V,H)=>{z(["@vscode/windows-registry"],V,H)});try{return he.GetStringRegKey(G,Z,se)}catch{return}}windowById(X){if(typeof X=="number")return this.windowsMainService.getWindowById(X)}};ve([D.memoize],Q.prototype,"cliPath",null),Q=ve([ee(1,s.IWindowsMainService),ee(2,f.IDialogMainService),ee(3,r.ILifecycleMainService),ee(4,g.IEnvironmentMainService),ee(5,o.ILogService),ee(6,i.IProductService),ee(7,n.IThemeMainService),ee(8,a.IWorkspacesManagementMainService),ee(9,U.ITelemetryService)],Q),e.NativeHostMainService=Q}),define(te[265],ie([0,1,15,41,25,35,2,13,4,100,163,84,119,56,27,5,6,65,54,20,61,74,30,12]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p,S,f,g,l,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,P.createDecorator)("issueMainService");let i=class Nt{constructor(s,c,a,C,M,T,U,Q,ae){this.userEnv=s,this.environmentMainService=c,this.logService=a,this.diagnosticsService=C,this.diagnosticsMainService=M,this.dialogMainService=T,this.nativeHostMainService=U,this.protocolMainService=Q,this.productService=ae,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[c,a]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),C=await this.diagnosticsService.getSystemInfo(c,a);this.safeSend(s,"vscode:issueSystemInfoResponse",C)}),t.validatedIpcMain.on("vscode:listProcesses",async s=>{const c=[];try{c.push({name:(0,I.localize)(0,null),rootProcess:await(0,m.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(C=>{(0,y.isRemoteDiagnosticError)(C)?c.push({name:C.hostName,rootProcess:C}):C.processes&&c.push({name:C.hostName,rootProcess:C.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(s,"vscode:listProcessesResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{const c={title:this.productService.nameLong,message:(0,I.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(c,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",a.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const c=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,I.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(s,c)=>{const{id:a,from:C,args:M}=c;let T;switch(C){case"issueReporter":T=this.issueReporterParentWindow;break;case"processExplorer":T=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${C}`)}T?.webContents.send("vscode:runAction",{id:a,from:C,args:M})}),t.validatedIpcMain.on("vscode:openExternal",(s,c)=>{this.nativeHostMainService.openExternal(void 0,c)}),t.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const c=await this.diagnosticsMainService.getMainDiagnostics();this.safeSend(s,"vscode:windowsInfoResponse",c.windows)})}safeSend(s,c,...a){s.sender.isDestroyed()||s.sender.send(c,...a)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const c=new D.DisposableStore,a=c.add(this.protocolMainService.createIPCObjectUrl()),C=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(C,a,{backgroundColor:s.styles.backgroundColor,title:(0,I.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:S.default}),this.issueReporterWindow.loadURL(b.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,c.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,c.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const c=new D.DisposableStore,a=c.add(this.protocolMainService.createIPCObjectUrl()),C=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(C,a,{backgroundColor:s.styles.backgroundColor,title:(0,I.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:S.default}),this.processExplorerWindow.loadURL(b.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,c.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,c.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,c,a,C){const M=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:a.title,backgroundColor:a.backgroundColor||Nt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,`--vscode-window-kind=${C}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,l.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop,experimentalDarkMode:!0});return M.setMenuBarVisibility(!1),M}async getSystemStatus(){const[s,c]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,c)}getWindowPosition(s,c,a){let C;const M=v.screen.getAllDisplays();if(M.length===1)C=M[0];else{if(u.isMacintosh){const Q=v.screen.getCursorScreenPoint();C=v.screen.getDisplayNearestPoint(Q)}!C&&s&&(C=v.screen.getDisplayMatching(s.getBounds())),C||(C=v.screen.getPrimaryDisplay()||M[0])}const T={width:c,height:a},U=C.bounds;return T.x=U.x+U.width/2-T.width/2,T.y=U.y+U.height/2-T.height/2,U.width>0&&U.height>0&&(T.x<U.x&&(T.x=U.x),T.y<U.y&&(T.y=U.y),T.x>U.x+U.width&&(T.x=U.x),T.y>U.y+U.height&&(T.y=U.y),T.width>U.width&&(T.width=U.width),T.height>U.height&&(T.height=U.height)),T}async getPerformanceInfo(){try{const[s,c]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,c)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}async stopTracing(){if(!this.environmentMainService.args.trace)return;const s=await v.contentTracing.stopRecording(`${(0,r.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,I.localize)(9,null),detail:(0,I.localize)(10,null,s),buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(11,null))],defaultId:0,noLink:!0},(0,o.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,s)}};i.DEFAULT_BACKGROUND_COLOR="#1E1E1E",i=ve([ee(1,d.IEnvironmentMainService),ee(2,w.ILogService),ee(3,y.IDiagnosticsService),ee(4,E.IDiagnosticsMainService),ee(5,h.IDialogMainService),ee(6,p.INativeHostMainService),ee(7,g.IProtocolMainService),ee(8,f.IProductService)],i),e.IssueMainService=i}),define(te[266],ie([0,1,23,19,27,22,6,65,20,55,32,48,88]),function(z,e,v,t,k,R,D,b,u,m,I,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let h=class extends E.AbstractUpdateService{constructor(P,w,p,S,f,g,l,r){super(P,w,S,f,g,r),this.telemetryService=p,this.nativeHostMainService=l}buildUpdateFeedUrl(P){return(0,E.createUpdateURL)(`linux-${process.arch}`,P,this.productService)}doCheckForUpdates(P){!this.url||(this.setState(y.State.CheckingForUpdates(P)),this.requestService.request({url:this.url},v.CancellationToken.None).then(m.asJson).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!P}),this.setState(y.State.Idle(1))):this.setState(y.State.AvailableForDownload(w))}).then(void 0,w=>{this.logService.error(w),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!P});const p=P?w.message||w:void 0;this.setState(y.State.Idle(1,p))}))}async doDownloadUpdate(P){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):P.update.url&&this.nativeHostMainService.openExternal(void 0,P.update.url),this.setState(y.State.Idle(1))}};h=ve([ee(0,R.ILifecycleMainService),ee(1,t.IConfigurationService),ee(2,I.ITelemetryService),ee(3,k.IEnvironmentMainService),ee(4,m.IRequestService),ee(5,D.ILogService),ee(6,b.INativeHostMainService),ee(7,u.IProductService)],h),e.LinuxUpdateService=h}),define(te[267],ie([0,1,45,40,25,8,23,53,9,7,127,21,19,27,14,22,6,65,20,55,32,48,88]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p,S,f,g,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function o(c,a=1e3){for(;!c();)await(0,R.timeout)(a)}let i;function n(){return typeof i>"u"&&(i=t.existsSync(u.join(u.dirname(process.execPath),"unins000.exe"))?0:1),i}let s=class extends r.AbstractUpdateService{get cachePath(){const a=u.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return y.Promises.mkdir(a,{recursive:!0}).then(()=>a)}constructor(a,C,M,T,U,Q,ae,X,G){super(a,C,T,U,Q,G),this.telemetryService=M,this.fileService=ae,this.nativeHostMainService=X}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(a){let C="win32";return process.arch!=="ia32"&&(C+=`-${process.arch}`),n()===1?C+="-archive":this.productService.target==="user"&&(C+="-user"),(0,r.createUpdateURL)(C,a,this.productService)}doCheckForUpdates(a){!this.url||(this.setState(l.State.CheckingForUpdates(a)),this.requestService.request({url:this.url},D.CancellationToken.None).then(f.asJson).then(C=>{const M=n();return!C||!C.url||!C.version||!C.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!a}),this.setState(l.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(l.State.AvailableForDownload(C)),Promise.resolve(null)):(this.setState(l.State.Downloading(C)),this.cleanup(C.version).then(()=>this.getUpdatePackagePath(C.version).then(T=>y.Promises.exists(T).then(U=>{if(U)return Promise.resolve(T);const Q=C.url,ae=C.hash,X=`${T}.tmp`;return this.requestService.request({url:Q},D.CancellationToken.None).then(G=>this.fileService.writeFile(m.URI.file(X),G.stream)).then(ae?()=>(0,I.checksum)(X,C.hash):()=>{}).then(()=>y.Promises.rename(X,T)).then(()=>T)})).then(T=>{const U=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},U&&C.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(C)):this.setState(l.State.Ready(C))})))}).then(void 0,C=>{this.logService.error(C),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!a});const M=a?C.message||C:void 0;this.setState(l.State.Idle(n(),M))}))}async doDownloadUpdate(a){a.update.url&&this.nativeHostMainService.openExternal(void 0,a.update.url),this.setState(l.State.Idle(n()))}async getUpdatePackagePath(a){const C=await this.cachePath;return u.join(C,`CodeSetup-${this.productService.quality}-${a}.exe`)}async cleanup(a=null){const C=a?Q=>!new RegExp(`${this.productService.quality}-${a}\\.exe$`).test(Q):()=>!0,M=await this.cachePath,U=(await y.Promises.readdir(M)).filter(C).map(async Q=>{try{await y.Promises.unlink(u.join(M,Q))}catch{}});await Promise.all(U)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const a=this.state.update;this.setState(l.State.Updating(a));const C=await this.cachePath;this.availableUpdate.updateFilePath=u.join(C,`CodeSetup-${this.productService.quality}-${a.version}.flag`),await y.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(n()))});const T=`${this.productService.win32MutexName}-ready`,U=await new Promise((Q,ae)=>{z(["windows-mutex"],Q,ae)});o(()=>U.isActive(T)).then(()=>this.setState(l.State.Ready(a)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}async _applySpecificUpdate(a){if(this.state.type!=="idle")return;const C=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!C};this.setState(l.State.Downloading(M)),this.availableUpdate={packagePath:a},C?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(M)):this.setState(l.State.Ready(M))}};ve([b.memoize],s.prototype,"cachePath",null),s=ve([ee(0,P.ILifecycleMainService),ee(1,E.IConfigurationService),ee(2,g.ITelemetryService),ee(3,h.IEnvironmentMainService),ee(4,f.IRequestService),ee(5,w.ILogService),ee(6,d.IFileService),ee(7,p.INativeHostMainService),ee(8,S.IProductService)],s),e.Win32UpdateService=s}),define(te[268],ie([0,1,15,8,23,44,3,35,2,13,9,71,4,7,171,60,19,56,27,59,14,22,6,20,61,233,91,32,236,64,74,33,28,52,117,121,37,38,54,42]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p,S,f,g,l,r,o,i,n,s,c,a,C,M,T,U,Q,ae,X,G,Z,se,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var V;(function(W){W[W.NONE=0]="NONE",W[W.NAVIGATING=1]="NAVIGATING",W[W.READY=2]="READY"})(V||(V={}));let H=class Ft extends u.Disposable{get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(A,F,N,J,B,$,L,O,_,j,Y,oe,q,re,ne,ce,ge,De,Ae){super(),this.logService=F,this.environmentMainService=N,this.policyService=J,this.userDataProfilesService=B,this.fileService=$,this.applicationStorageMainService=L,this.storageMainService=O,this.configurationService=_,this.themeMainService=j,this.workspacesManagementMainService=Y,this.backupMainService=oe,this.telemetryService=q,this.dialogMainService=re,this.lifecycleMainService=ne,this.productService=ce,this.protocolMainService=ge,this.windowsMainService=De,this.stateMainService=Ae,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[ke,Le]=this.restoreWindowState(A.state);this.windowState=ke,this.logService.trace("window#ctor: using window state",ke);const qe=this.windowState.mode===0||this.windowState.mode===3,me=this.configurationService.getValue("window");let we=!1;typeof me?.experimental?.useSandbox=="boolean"?we=me.experimental.useSandbox:we=typeof se.default.quality=="string"&&se.default.quality!=="stable";const Ee={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!qe,title:this.productService.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(me?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...we?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};E.isLinux?Ee.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):E.isWindows&&!this.environmentMainService.isBuilt&&(Ee.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),E.isMacintosh&&!this.useNativeFullScreen()&&(Ee.fullscreenable=!1),E.isMacintosh&&(Ee.acceptFirstMouse=!0,me?.clickThroughInactive===!1&&(Ee.acceptFirstMouse=!1));const x=E.isMacintosh&&me?.nativeTabs===!0;x&&(Ee.tabbingIdentifier=this.productService.nameShort);const le=(0,M.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(Ee.titleBarStyle="hidden",E.isMacintosh||(Ee.frame=!1),(0,M.useWindowControlsOverlay)(this.configurationService))){const fe=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Se=X.Color.fromHex(fe).isDarker()?"#FFFFFF":"#000000";Ee.titleBarOverlay={height:29,color:fe,symbolColor:Se},this.hasWindowControlOverlay=!0}if((0,y.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(Ee),(0,y.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,E.isMacintosh&&le&&this._win.setSheetOffset(22),le&&(E.isWindows&&(0,M.useWindowControlsOverlay)(this.configurationService)||E.isMacintosh)){const fe=this.stateMainService.getItem(Ft.windowControlHeightStateStorageKey);fe&&this.updateWindowControls({height:fe})}E.isWindows&&le&&this._win.hookWindowMessage(278,()=>{const[Se,Ie]=this._win.getPosition(),Te=v.screen.getCursorScreenPoint(),Oe=Te.x-Se,Ne=Te.y-Ie;return(()=>!(Oe>30&&Ne>=0&&Ne<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Oe,y:Ne})),0}),(E.isMacintosh||E.isWindows)&&Le&&(!x||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(fe=>typeof fe=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),qe&&((0,y.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,y.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setRepresentedFilename(A){E.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return E.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){E.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return E.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){E.isMacintosh&&A?.force&&v.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function F(){N.dispose(),J.dispose(),A()}const N=this.onDidClose(()=>F()),J=this.onWillLoad(()=>F())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(F,N)=>this.onWindowError(2,N)),this._win.webContents.on("did-fail-load",(F,N,J)=>this.onWindowError(3,{reason:J,exitCode:N})),this._win.webContents.on("will-prevent-unload",F=>{F.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",F=>{this._config&&(this._config.maximized=!0),v.app.emit("browser-window-maximize",F,this._win)}),this._win.on("unmaximize",F=>{this._config&&(this._config.maximized=!1),v.app.emit("browser-window-unmaximize",F,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(F=>this.onConfigurationUpdated(F))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(F=>this.onDidDeleteUntitledWorkspace(F)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(F,N)=>{const J=await this.getMarketplaceHeaders();N({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,J)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,n.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,F){switch(A){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:F?.reason,code:F?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const N=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,b.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,d.localize)(5,null):void 0},this._win);if(N.response!==1){const J=N.response===0;await this.destroyWindow(J,N.checkboxChecked)}}else if(A===2){let N;F?N=(0,d.localize)(7,null,F.reason,F.exitCode??"<unknown>"):N=(0,d.localize)(6,null);const J=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,d.localize)(8,null)),(0,b.mnemonicButtonLabel)((0,d.localize)(9,null))],message:N,detail:(0,d.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,d.localize)(11,null):void 0},this._win),B=J.response===0;await this.destroyWindow(B,J.checkboxChecked)}break}}async destroyWindow(A,F){const N=this._config?.workspace;if(F&&N)try{const J=this.storageMainService.workspaceStorage(N);await J.init(),J.delete("memento/workbench.parts.editor"),await J.close()}catch(J){this.logService.error(J)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let J,B;(0,U.isSingleFolderWorkspaceIdentifier)(N)?J={folderUri:N.uri}:(0,U.isWorkspaceIdentifier)(N)?J={workspaceUri:N.configPath}:B=!0;const[$]=await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:J?[J]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});$.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const F=this.getMenuBarVisibility();F!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=F,this.setMenuBarVisibility(F));let N=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const J=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.currentHttpProxy||J!==this.currentNoProxy)){this.currentHttpProxy=N,this.currentNoProxy=J;const B=N||"",$=J?`${J},<local>`:"<local>";this.logService.trace(`Setting proxy to '${B}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:B,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(A){E.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,F=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!F.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),F.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(A,F),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(m.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0));const N=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:F.isReload?3:N?2:1})}updateConfiguration(A,F){const N=(this._config??this.pendingLoadConfig)?.userEnv;if(N){const J=(0,f.isLaunchedFromCli)(N)&&!(0,f.isLaunchedFromCli)(A.userEnv),B=this.isExtensionDevelopmentHost;(J||B)&&(A.userEnv={...N,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),F.disableExtensions!==void 0&&(A["disable-extensions"]=F.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,y.mark)("code/willOpenNewWindow"),A.perfMarks=(0,y.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const F=Object.assign({},this._config);F.workspace=await this.validateWorkspaceBeforeReload(F),delete F.filesToOpenOrCreate,delete F.filesToDiff,delete F.filesToMerge,delete F.filesToWait,this.isExtensionDevelopmentHost&&A&&(F.verbose=A.verbose,F.debugId=A.debugId,F.extensionEnvironment=A.extensionEnvironment,F["inspect-extensions"]=A["inspect-extensions"],F["inspect-brk-extensions"]=A["inspect-brk-extensions"],F["extensions-dir"]=A["extensions-dir"]),F.isInitialStartup=!1,F.policiesData=this.policyService.serialize(),F.continueOn=this.environmentMainService.continueOn,F.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(F,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,U.isWorkspaceIdentifier)(A.workspace)){const F=A.workspace.configPath;if(F.scheme===m.Schemas.file&&!await this.fileService.exists(F))return}else if((0,U.isSingleFolderWorkspaceIdentifier)(A.workspace)){const F=A.workspace.uri;if(F.scheme===m.Schemas.file&&!await this.fileService.exists(F))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,ae.defaultWindowState)();if(this.isFullScreen){let N;try{N=v.screen.getDisplayMatching(this.getBounds())}catch{}const J=(0,ae.defaultWindowState)();return{mode:3,display:N?N.id:void 0,width:this.windowState.width||J.width,height:this.windowState.height||J.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let F;if(!E.isMacintosh&&this._win.isMaximized()?F=0:F=1,F===0?A.mode=0:A.mode=1,F===1||F===0){let N;F===1?N=this.getBounds():N=this._win.getNormalBounds(),A.x=N.x,A.y=N.y,A.width=N.width,A.height=N.height}return A}updateWindowControls(A){A.height&&this.stateMainService.setItem(Ft.windowControlHeightStateStorageKey,A.height),E.isWindows&&this.hasWindowControlOverlay?this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0}):E.isMacintosh&&A.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(A.height-15)/2})}restoreWindowState(A){(0,y.mark)("code/willRestoreCodeWindowState");let F=!1;if(A)try{const N=v.screen.getAllDisplays();F=N.length>1,A=this.validateWindowState(A,N)}catch(N){this.logService.warn(`Unexpected error validating window state: ${N}
${N.stack}`)}return(0,y.mark)("code/didRestoreCodeWindowState"),[A||(0,ae.defaultWindowState)(),F]}validateWindowState(A,F){if(this.logService.trace(`window#validateWindowState: validating window state on ${F.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(F.length===1){const B=this.getWorkingArea(F[0]);if(B){let $=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!B||(A.x<B.x&&(A.x=B.x),A.y<B.y&&(A.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),$(),A.width>B.width&&(A.width=B.width),A.height>B.height&&(A.height=B.height),A.x>B.x+B.width-128&&(A.x=B.x+B.width-A.width),A.y>B.y+B.height-128&&(A.y=B.y+B.height-A.height),$()}return A}if(A.display&&A.mode===3){const B=F.find($=>$.id===A.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,ae.defaultWindowState)(3);return $.x=B.bounds.x,$.y=B.bounds.y,$}}let N,J;try{N=v.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),J=this.getWorkingArea(N)}catch{}if(N&&J&&A.x+A.width>J.x&&A.y+A.height>J.y&&A.x<J.x+J.width&&A.y<J.y+J.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",J),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,F]=this._win.getPosition(),[N,J]=this._win.getSize();return{x:A,y:F,width:N,height:J}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return E.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(A)}doSetNativeFullScreen(A){E.isMacintosh&&(this.transientIsNativeFullScreen=A,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,M.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,F=!0){E.isMacintosh||(A==="toggle"&&F&&this.send("vscode:showInfoMessage",(0,d.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const F=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!F),this._win.autoHideMenuBar=F;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(E.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,F,...N){this.isReady?this.send(A,...N):this.ready().then(()=>{F.isCancellationRequested||this.send(A,...N)})}send(A,...F){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...F)}catch(N){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)(N)}`)}}}updateTouchBar(A){!E.isMacintosh||this.touchBarGroups.forEach((F,N)=>{const J=A[N];F.segments=this.createTouchBarGroupSegments(J)})}createTouchBar(){if(!!E.isMacintosh){for(let A=0;A<10;A++){const F=this.createTouchBarGroup();this.touchBarGroups.push(F)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const F=this.createTouchBarGroupSegments(A),N=new v.TouchBar.TouchBarSegmentedControl({segments:F,mode:"buttons",segmentStyle:"automatic",change:J=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:N.segments[J].id,from:"touchbar"})}});return N}createTouchBarGroupSegments(A=[]){return A.map(N=>{let J;N.icon&&!a.ThemeIcon.isThemeIcon(N.icon)&&N.icon?.dark?.scheme===m.Schemas.file&&(J=v.nativeImage.createFromPath(h.URI.revive(N.icon.dark).fsPath),J.isEmpty()&&(J=void 0));let B;return typeof N.title=="string"?B=N.title:B=N.title.value,{id:N.id,label:J?void 0:B,icon:J}})}dispose(){super.dispose(),this._win=null}};H.windowControlHeightStateStorageKey="windowControlHeight",H=ve([ee(1,r.ILogService),ee(2,S.IEnvironmentMainService),ee(3,G.IPolicyService),ee(4,he.IUserDataProfilesMainService),ee(5,g.IFileService),ee(6,s.IApplicationStorageMainService),ee(7,s.IStorageMainService),ee(8,w.IConfigurationService),ee(9,C.IThemeMainService),ee(10,Q.IWorkspacesManagementMainService),ee(11,P.IBackupMainService),ee(12,c.ITelemetryService),ee(13,p.IDialogMainService),ee(14,l.ILifecycleMainService),ee(15,o.IProductService),ee(16,i.IProtocolMainService),ee(17,T.IWindowsMainService),ee(18,Z.IStateMainService)],H),e.CodeWindow=H}),define(te[75],ie([0,1,15,24,8,3,35,2,13,4,16,7,21,174,5,22,6,91,92,28,52,31]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p,S,f,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let r=class rt extends b.Disposable{constructor(i,n,s,c){super(),this.logService=i,this.workspacesManagementMainService=n,this.lifecycleMainService=s,this.applicationStorageMainService=c,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],s=[];for(const a of i)if((0,S.isRecentWorkspace)(a))!this.workspacesManagementMainService.isUntitledWorkspace(a.workspace)&&!this.containsWorkspace(n,a.workspace)&&n.push(a);else if((0,S.isRecentFolder)(a))this.containsFolder(n,a.folderUri)||n.push(a);else{const C=this.containsFile(s,a.fileUri),M=a.fileUri.scheme===u.Schemas.file&&rt.COMMON_FILES_FILTER.indexOf((0,I.basename)(a.fileUri))>=0;!C&&!M&&(s.push(a),m.isWindows&&a.fileUri.scheme===u.Schemas.file&&v.app.addRecentDocument(a.fileUri.fsPath))}const c=await this.mergeEntriesFromStorage({workspaces:n,files:s});n=c.workspaces,s=c.files,n.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(n.length=rt.MAX_TOTAL_RECENT_ENTRIES),s.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(s.length=rt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:n,files:s}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(i){const n=C=>{const M=this.location(C);for(const T of i)if(I.extUriBiasedIgnorePathCase.isEqual(T,M))return!1;return!0},s=await this.getRecentlyOpened(),c=s.workspaces.filter(n),a=s.files.filter(n);(c.length!==s.workspaces.length||a.length!==s.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:c}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(i){const n=new l.ResourceMap(a=>I.extUriBiasedIgnorePathCase.getComparisonKey(a));if(i?.workspaces)for(const a of i.workspaces)n.set(this.location(a),a);const s=new l.ResourceMap(a=>I.extUriBiasedIgnorePathCase.getComparisonKey(a));if(i?.files)for(const a of i.files)s.set(this.location(a),a);const c=await this.getRecentlyOpenedFromStorage();for(const a of c.workspaces){const C=n.get(this.location(a));C?C.label=C.label??a.label:n.set(this.location(a),a)}for(const a of c.files){const C=s.get(this.location(a));C?C.label=C.label??a.label:s.set(this.location(a),a)}return{workspaces:[...n.values()],files:[...s.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let i;const n=this.applicationStorageMainService.get(rt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(s){this.logService.error("Unexpected error parsing opened paths list",s)}return(0,S.restoreRecentlyOpened)(i,this.logService)}async saveRecentlyOpened(i){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(rt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,S.toStoreData)(i)),-1,1)}location(i){return(0,S.isRecentFolder)(i)?i.folderUri:(0,S.isRecentFile)(i)?i.fileUri:i.workspace.configPath}containsWorkspace(i,n){return!!i.find(s=>(0,S.isRecentWorkspace)(s)&&s.workspace.id===n.id)}containsFolder(i,n){return!!i.find(s=>(0,S.isRecentFolder)(s)&&I.extUriBiasedIgnorePathCase.isEqual(s.folderUri,n))}containsFile(i,n){return!!i.find(s=>I.extUriBiasedIgnorePathCase.isEqual(s.fileUri,n))}async handleWindowsJumpList(){!m.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!m.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(0,null),description:(0,h.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const a of v.app.getJumpListSettings().removedItems){const C=a.args;if(C){const M=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);M&&n.push(y.URI.parse(M[2]))}}await this.removeRecentlyOpened(n);let s=!1;const c=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const C=(0,S.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:M,description:T}=this.getWindowsJumpListLabel(C,a.label);let U;return y.URI.isUri(C)?U=`--folder-uri "${C.toString()}"`:(s=!0,U=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:M.substr(0,255),description:T.substr(0,255),program:process.execPath,args:U,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&i.push({type:"custom",name:s?(0,h.localize)(2,null):(0,h.localize)(3,null),items:c})}i.push({type:"recent"});try{const n=v.app.setJumpList(i);n&&n!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.logService.warn("updateWindowsJumpList#setJumpList",n)}}getWindowsJumpListLabel(i,n){if(n)return{title:(0,D.splitName)(n).name,description:n};if(y.URI.isUri(i))return{title:(0,I.basename)(i),description:this.renderJumpListPathDescription(i)};if(this.workspacesManagementMainService.isUntitledWorkspace(i))return{title:(0,h.localize)(4,null),description:""};let s=(0,I.basename)(i.configPath);return s.endsWith(f.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-f.WORKSPACE_EXTENSION.length-1)),{title:(0,h.localize)(5,null,s),description:this.renderJumpListPathDescription(i.configPath)}}renderJumpListPathDescription(i){return i.scheme==="file"?(0,D.normalizeDriveLetter)(i.fsPath):i.toString()}async updateMacOSRecentDocuments(){if(!m.isMacintosh)return;v.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let s=0;for(let a=0;a<i.workspaces.length&&s<rt.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const C=this.location(i.workspaces[a]);if(C.scheme===u.Schemas.file){const M=(0,I.originalFSPath)(C);await E.Promises.exists(M)&&(n.push(M),s++)}}const c=[];for(let a=0;a<i.files.length&&s<rt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const C=this.location(i.files[a]);if(C.scheme===u.Schemas.file){const M=(0,I.originalFSPath)(C);if(rt.COMMON_FILES_FILTER.includes((0,I.basename)(C))||n.includes(M))continue;await E.Promises.exists(M)&&(c.push(M),s++)}}c.reverse().forEach(a=>v.app.addRecentDocument(a)),n.reverse().forEach(a=>v.app.addRecentDocument(a))}};r.MAX_TOTAL_RECENT_ENTRIES=500,r.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",r.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,r.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,r.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,r.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],r=ve([ee(0,w.ILogService),ee(1,g.IWorkspacesManagementMainService),ee(2,P.ILifecycleMainService),ee(3,p.IApplicationStorageMainService)],r),e.WorkspacesHistoryMainService=r}),define(te[269],ie([0,1,15,8,23,35,4,7,164,19,27,22,6,210,65,20,38,32,48,74,33,75]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p,S,f,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const r="menu";let o=class Wt{constructor(s,c,a,C,M,T,U,Q,ae,X,G){this.updateService=s,this.configurationService=c,this.windowsMainService=a,this.environmentMainService=C,this.telemetryService=M,this.workspacesHistoryMainService=T,this.stateMainService=U,this.lifecycleMainService=Q,this.logService=ae,this.nativeHostMainService=X,this.productService=G,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,f.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(Wt.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,U,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:U?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,U,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:U?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,U,Q)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,U,Q)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,U,Q)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const c=this.productService.requestFeatureUrl;c&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(c,"openUserVoiceUrl"));const a=this.productService.reportIssueUrl;a&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(a,"openReportIssues"));const C=this.productService.licenseUrl;C&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const T=C.indexOf("?")>0?"&":"?";this.openUrl(`${C}${T}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(C,"openLicenseUrl")});const M=this.productService.privacyStatementUrl;M&&C&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(M,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,c){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(Wt.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!D.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=v.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(D.isMacintosh?new v.Menu:null);return}const c=new v.Menu;let a;if(D.isMacintosh){const M=new v.Menu;a=new v.MenuItem({label:this.productService.nameShort,submenu:M}),this.setMacApplicationMenu(M),c.append(a)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const M=new v.Menu;M.append(new v.MenuItem({label:this.mnemonicLabel(u.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(M)}if(this.shouldDrawMenu("File")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(u.localize(1,null)),submenu:M});this.setMenuById(M,"File"),c.append(T)}if(this.shouldDrawMenu("Edit")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(u.localize(2,null)),submenu:M});this.setMenuById(M,"Edit"),c.append(T)}if(this.shouldDrawMenu("Selection")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(u.localize(3,null)),submenu:M});this.setMenuById(M,"Selection"),c.append(T)}if(this.shouldDrawMenu("View")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(u.localize(4,null)),submenu:M});this.setMenuById(M,"View"),c.append(T)}if(this.shouldDrawMenu("Go")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(u.localize(5,null)),submenu:M});this.setMenuById(M,"Go"),c.append(T)}if(this.shouldDrawMenu("Run")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(u.localize(6,null)),submenu:M});this.setMenuById(M,"Run"),c.append(T)}if(this.shouldDrawMenu("Terminal")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(u.localize(7,null)),submenu:M});this.setMenuById(M,"Terminal"),c.append(T)}let C;if(this.shouldDrawMenu("Window")){const M=new v.Menu;C=new v.MenuItem({label:this.mnemonicLabel(u.localize(8,null)),submenu:M,role:"window"}),this.setMacWindowMenu(M)}if(C&&c.append(C),this.shouldDrawMenu("Help")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(u.localize(9,null)),submenu:M,role:"help"});this.setMenuById(M,"Help"),c.append(T)}c.items&&c.items.length>0?v.Menu.setApplicationMenu(c):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const c=this.createMenuItem(u.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),a=this.getUpdateMenuItems();let C;if(this.shouldDrawMenu("Preferences")){const Z=new v.Menu;this.setMenuById(Z,"Preferences"),C=new v.MenuItem({label:this.mnemonicLabel(u.localize(11,null)),submenu:Z})}const M=new v.Menu,T=new v.MenuItem({label:u.localize(12,null),role:"services",submenu:M}),U=new v.MenuItem({label:u.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),Q=new v.MenuItem({label:u.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ae=new v.MenuItem({label:u.localize(15,null),role:"unhide"}),X=new v.MenuItem(this.likeAction("workbench.action.quit",{label:u.localize(16,null,this.productService.nameLong),click:async(Z,se,he)=>{const V=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||V?.isMinimized())&&await this.confirmBeforeQuit(he)&&this.nativeHostMainService.quit(void 0)}})),G=[c];G.push(...a),C&&G.push(i(),C),G.push(i(),T,i(),U,Q,ae,i(),X),G.forEach(Z=>s.append(Z))}async confirmBeforeQuit(s){if(this.windowsMainService.getWindowCount()===0)return!0;const c=this.configurationService.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.isKeyboardEvent(s)){const a={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(u.localize(17,null)),(0,R.mnemonicButtonLabel)(u.localize(18,null))],message:u.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:C}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,a);return C===0}return!0}shouldDrawMenu(s){if(!D.isMacintosh&&(0,f.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,c){c.forEach(a=>{if((0,h.isMenubarMenuItemSeparator)(a))s.append(i());else if((0,h.isMenubarMenuItemSubmenu)(a)){const C=new v.Menu,M=new v.MenuItem({label:this.mnemonicLabel(a.label),submenu:C});this.setMenu(C,a.submenu.items),s.append(M)}else(0,h.isMenubarMenuItemRecentAction)(a)?s.append(this.createOpenRecentMenuItem(a)):(0,h.isMenubarMenuItemAction)(a)&&(a.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[a.id]?s.append(new v.MenuItem(this.likeAction(a.id,{label:this.mnemonicLabel(a.label),click:this.fallbackMenuHandlers[a.id]}))):s.append(this.createMenuItem(a.label,a.id,!1,a.checked)):s.append(this.createMenuItem(a.label,a.id,a.enabled!==!1,!!a.checked)):s.append(this.createMenuItem(a.label,a.id,a.enabled!==!1,!!a.checked)))})}setMenuById(s,c){this.menubarMenus&&this.menubarMenus[c]&&this.setMenu(s,this.menubarMenus[c].items)}insertCheckForUpdatesItems(s){const c=this.getUpdateMenuItems();c.length&&(c.forEach(a=>s.append(a)),s.append(i()))}createOpenRecentMenuItem(s){const c=b.URI.revive(s.uri),a=s.id,C=a==="openRecentFile"?{fileUri:c}:a==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new v.MenuItem(this.likeAction(a,{label:s.label,click:async(M,T,U)=>{const Q=this.isOptionClick(U);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[C],forceNewWindow:Q,gotoLineMode:!1,remoteAuthority:s.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([c])}},!1))}isOptionClick(s){return!!(s&&(!D.isMacintosh&&(s.ctrlKey||s.shiftKey)||D.isMacintosh&&(s.metaKey||s.altKey)))}isKeyboardEvent(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}createRoleMenuItem(s,c,a){const C={label:this.mnemonicLabel(s),role:a,enabled:!0};return new v.MenuItem(this.withKeybinding(c,C))}setMacWindowMenu(s){const c=new v.MenuItem({label:u.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),a=new v.MenuItem({label:u.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),C=new v.MenuItem({label:u.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),M=this.createMenuItem(u.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(i()),T.push(this.createMenuItem(u.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(u.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(u.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(u.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(u.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,a,i(),M,...T,i(),C].forEach(U=>s.append(U))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(u.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:u.localize(30,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(u.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:u.localize(32,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(u.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:u.localize(34,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(u.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,c,a,C){const M=this.mnemonicLabel(s),T=typeof c=="function"?c:(G,Z,se)=>{const he=G?G.userSettingsLabel:null;let V=c;Array.isArray(c)&&(V=this.isOptionClick(se)?c[1]:c[0]),he&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:he}):this.runActionInRenderer({type:"commandId",commandId:V})},U=typeof a=="boolean"?a:this.windowsMainService.getWindowCount()>0,Q=typeof C=="boolean"?C:!1,ae={label:M,click:T,enabled:U};Q&&(ae.type="checkbox",ae.checked=Q);let X;return typeof c=="string"?X=c:Array.isArray(c)&&(X=c[0]),D.isMacintosh&&(X==="editor.action.clipboardCutAction"?ae.role="cut":X==="editor.action.clipboardCopyAction"?ae.role="copy":X==="editor.action.clipboardPasteAction"&&(ae.role="paste"),X==="undo"?ae.click=this.makeContextAwareClickHandler(T,{inDevTools:G=>G.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):X==="redo"?ae.click=this.makeContextAwareClickHandler(T,{inDevTools:G=>G.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):X==="editor.action.selectAll"&&(ae.click=this.makeContextAwareClickHandler(T,{inDevTools:G=>G.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(X,ae))}makeContextAwareClickHandler(s,c){return(a,C,M)=>{const T=v.BrowserWindow.getFocusedWindow();if(!T)return c.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return c.inDevTools(T.webContents.devToolsWebContents);s(a,C||T,M)}}runActionInRenderer(s){let c=v.BrowserWindow.getFocusedWindow();if(!c){const C=this.windowsMainService.getLastActiveWindow();C?.isMinimized()&&(c=C.win)}const a=c?this.windowsMainService.getWindowById(c.id):void 0;if(a){if(this.logService.trace("menubar#runActionInRenderer",s),D.isMacintosh&&!this.environmentMainService.isBuilt&&!a.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const C={id:s.commandId,from:"menu"};a.sendWhenReady("vscode:runAction",k.CancellationToken.None,C)}else{const C={userSettingsLabel:s.userSettingsLabel};a.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,C)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,c){const a=typeof s=="string"?this.keybindings[s]:void 0;if(a?.label){if(a.isNative!==!1)c.accelerator=a.label,c.userSettingsLabel=a.userSettingsLabel;else if(typeof c.label=="string"){const C=c.label.indexOf("[");C>=0?c.label=`${c.label.substr(0,C)} [${a.label}]`:c.label=`${c.label} [${a.label}]`}}else c.accelerator=void 0;return c}likeAction(s,c,a=!c.accelerator){a&&(c=this.withKeybinding(s,c));const C=c.click;return c.click=(M,T,U)=>{this.reportMenuActionTelemetry(s),C?.(M,T,U)},c}openUrl(s,c){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(c)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:r})}mnemonicLabel(s){return(0,R.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};o.lastKnownMenubarStorageKey="lastKnownMenubarData",o=ve([ee(0,S.IUpdateService),ee(1,m.IConfigurationService),ee(2,g.IWindowsMainService),ee(3,I.IEnvironmentMainService),ee(4,p.ITelemetryService),ee(5,l.IWorkspacesHistoryMainService),ee(6,w.IStateMainService),ee(7,y.ILifecycleMainService),ee(8,E.ILogService),ee(9,d.INativeHostMainService),ee(10,P.IProductService)],o),e.Menubar=o;function i(){return new v.MenuItem({type:"separator"})}}),define(te[270],ie([0,1,5,22,6,269]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let D=class{constructor(u,m,I){this.instantiationService=u,this.lifecycleMainService=m,this.logService=I,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(u,m){this.logService.trace("menubarService#updateMenubar",u),(await this.menubar).updateMenu(m,u)}};D=ve([ee(0,v.IInstantiationService),ee(1,t.ILifecycleMainService),ee(2,k.ILogService)],D),e.MenubarMainService=D}),define(te[271],ie([0,1,15,21,25,24,23,3,30,49,35,2,13,9,71,4,34,16,12,7,172,60,19,56,27,14,5,22,6,54,20,61,63,38,74,268,118,263,28,93,75,52,64,37,42]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p,S,f,g,l,r,o,i,n,s,c,a,C,M,T,U,Q,ae,X,G,Z,se,he,V,H,W,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N($){return(0,se.isWorkspaceIdentifier)($?.workspace)}function J($){return(0,se.isSingleFolderWorkspaceIdentifier)($?.workspace)}let B=class ft extends y.Disposable{constructor(L,O,_,j,Y,oe,q,re,ne,ce,ge,De,Ae,ke,Le,qe,me,we){super(),this.machineId=L,this.initialUserEnv=O,this.logService=_,this.stateMainService=j,this.policyService=Y,this.environmentMainService=oe,this.userDataProfilesMainService=q,this.lifecycleMainService=re,this.backupMainService=ne,this.configurationService=ce,this.workspacesHistoryMainService=ge,this.workspacesManagementMainService=De,this.instantiationService=Ae,this.dialogMainService=ke,this.fileService=Le,this.productService=qe,this.protocolMainService=me,this.themeMainService=we,this._onDidOpenWindow=this._register(new b.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new b.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new b.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new b.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new b.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new Z.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const O=new y.DisposableStore;if(O.add(b.Event.any(L.onDidClose,L.onDidDestroy)(()=>O.dispose())),L.config.extensionDevelopmentPath)for(const _ of L.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(_));L.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,O){const _=this.environmentMainService.args,j=O?.remoteAuthority||void 0,Y=!0,oe=O?.forceReuseWindow,q=!oe;return this.open({...L,cli:_,forceEmpty:Y,forceNewWindow:q,forceReuseWindow:oe,remoteAuthority:j})}openExistingWindow(L,O){L.focus(),this.handleWaitMarkerFile(O,[L])}async open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const O=[],_=[],j=[],Y=[],oe=[];let q,re=0;const ne=await this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ne);for(const ke of ne)J(ke)?L.addMode?O.push(ke):_.push(ke):N(ke)?j.push(ke):ke.fileUri?(q||(q={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ke.remoteAuthority}),q.filesToOpenOrCreate.push(ke)):ke.backupPath?oe.push({backupFolder:(0,h.basename)(ke.backupPath),remoteAuthority:ke.remoteAuthority}):re++;L.diffMode&&q&&q.filesToOpenOrCreate.length>=2&&(q.filesToDiff=q.filesToOpenOrCreate.slice(0,2),q.filesToOpenOrCreate=[]),L.mergeMode&&q&&q.filesToOpenOrCreate.length===4&&(q.filesToMerge=q.filesToOpenOrCreate.slice(0,4),q.filesToOpenOrCreate=[],q.filesToDiff=[]),q&&L.waitMarkerFileURI&&(q.filesToWait={paths:(0,R.coalesce)([...q.filesToDiff,q.filesToMerge[3],...q.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(Y.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),j.push(...Y),oe.push(...this.backupMainService.getEmptyWindowBackups())):oe.length=0;const{windows:ce,filesOpenedInWindow:ge}=await this.doOpen(L,j,_,oe,re,q,O);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${j.length}, foldersToOpen: ${_.length}, emptyToRestore: ${oe.length}, emptyToOpen: ${re})`),ce.length>1)if(ge)ge.focus();else{const ke=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Le=!0,qe=!0;if(ke){const me=ce.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Le=!1,qe=!1)}if(Le)for(let me=ce.length-1;me>=0;me--){const we=ce[me];if(!(we.openedWorkspace&&Y.some(Ee=>we.openedWorkspace&&Ee.workspace.id===we.openedWorkspace.id)||we.backupPath&&oe.some(Ee=>we.backupPath&&Ee.backupFolder===(0,h.basename)(we.backupPath)))){we.focus(),qe=!1;break}}qe&&ce[ce.length-1].focus()}const De=q&&q.filesToDiff.length>0,Ae=q&&q.filesToMerge.length>0;if(!ce.some(ke=>ke.isExtensionDevelopmentHost)&&!De&&!Ae&&!L.noRecentEntry){const ke=[];for(const Le of ne)N(Le)&&!Le.transient?ke.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):J(Le)?ke.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&ke.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ke)}return this.handleWaitMarkerFile(L,ce),ce}handleWaitMarkerFile(L,O){const _=L.waitMarkerFileURI;L.context===0&&_&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(_)}catch{}})()}async doOpen(L,O,_,j,Y,oe,q){const re=[];let ne;function ce(me,we){re.push(me),we&&(ne=me,oe=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:De}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&q.length>0){const me=q[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(me);we&&ce(this.doAddFoldersToExistingWindow(we,q.map(Ee=>Ee.workspace.uri)))}const Ae=_.length+O.length+j.length;if(oe&&Ae===0){const me=oe.filesToOpenOrCreate[0]||oe.filesToDiff[0]||oe.filesToMerge[3],we=this.getWindows().filter(x=>oe&&(0,p.isEqualAuthority)(x.remoteAuthority,oe.remoteAuthority));let Ee;me?.fileUri&&!De&&((L.context===4||L.context===0||L.context===1)&&(Ee=await(0,G.findWindowOnFile)(we,me.fileUri,async x=>x.configPath.scheme===E.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(x.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(we))),Ee?(0,se.isWorkspaceIdentifier)(Ee.openedWorkspace)?O.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?_.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(L,Ee,oe),!0):ce(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:oe,forceNewWindow:!0,remoteAuthority:oe.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,profile:L.profile}),!0)}const ke=(0,R.distinct)(O,me=>me.workspace.id);if(ke.length>0){const me=(0,R.coalesce)(ke.map(we=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.configPath)));if(me.length>0){const we=me[0],Ee=(0,p.isEqualAuthority)(oe?.remoteAuthority,we.remoteAuthority)?oe:void 0;ce(this.doOpenFilesInExistingWindow(L,we,Ee),!!Ee),ge=!0}for(const we of ke){if(me.some(le=>le.openedWorkspace&&le.openedWorkspace.id===we.workspace.id))continue;const Ee=we.remoteAuthority,x=(0,p.isEqualAuthority)(oe?.remoteAuthority,Ee)?oe:void 0;ce(this.doOpenFolderOrWorkspace(L,we,ge,x),!!x),ge=!0}}const Le=(0,R.distinct)(_,me=>p.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(Le.length>0){const me=(0,R.coalesce)(Le.map(we=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.uri)));if(me.length>0){const we=me[0],Ee=(0,p.isEqualAuthority)(oe?.remoteAuthority,we.remoteAuthority)?oe:void 0;ce(this.doOpenFilesInExistingWindow(L,we,Ee),!!Ee),ge=!0}for(const we of Le){if(me.some(le=>(0,se.isSingleFolderWorkspaceIdentifier)(le.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(le.openedWorkspace.uri,we.workspace.uri)))continue;const Ee=we.remoteAuthority,x=(0,p.isEqualAuthority)(oe?.remoteAuthority,Ee)?oe:void 0;ce(this.doOpenFolderOrWorkspace(L,we,ge,x),!!x),ge=!0}}const qe=(0,R.distinct)(j,me=>me.backupFolder);if(qe.length>0)for(const me of qe){const we=me.remoteAuthority,Ee=(0,p.isEqualAuthority)(oe?.remoteAuthority,we)?oe:void 0;ce(this.doOpenEmpty(L,!0,we,Ee,me),!!Ee),ge=!0}if(re.length===0||oe){oe&&!Y&&Y++;const me=oe?oe.remoteAuthority:L.remoteAuthority;for(let we=0;we<Y;we++)ce(this.doOpenEmpty(L,ge,me,oe),!!oe),ge=!0}return{windows:(0,R.distinct)(re),filesOpenedInWindow:ne}}doOpenFilesInExistingWindow(L,O,_){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),O.focus();const j={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",D.CancellationToken.None,j),O}doAddFoldersToExistingWindow(L,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),L.focus();const _={foldersToAdd:O};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,_),L}doOpenEmpty(L,O,_,j,Y){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!Y,remoteAuthority:_,filesToOpen:j,forceNewWindow:O});let oe;return!O&&typeof L.contextWindowId=="number"&&(oe=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:_,forceNewWindow:O,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:j,windowToUse:oe,emptyWindowBackupInfo:Y,profile:L.profile})}doOpenFolderOrWorkspace(L,O,_,j,Y){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:j}),!_&&!Y&&typeof L.contextWindowId=="number"&&(Y=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:j,windowToUse:Y,profile:L.profile})}async getPathsToOpen(L){let O,_=!1,j=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(O=await this.doExtractPathsFromAPI(L),_=!0):L.forceEmpty?O=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(O=await this.doExtractPathsFromCLI(L.cli),O.length===0&&O.push(Object.create(null)),_=!0):(O=await this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),j=!0),!L.addMode&&_){const Y=O.filter(oe=>J(oe));if(Y.length>1){const oe=Y[0].remoteAuthority;if(Y.every(q=>(0,p.isEqualAuthority)(q.remoteAuthority,oe))){const q=await this.workspacesManagementMainService.createUntitledWorkspace(Y.map(re=>({uri:re.workspace.uri})));O.push({workspace:q,remoteAuthority:oe}),O=O.filter(re=>!J(re))}}}if(L.initialStartup&&!j&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const Y=await this.doGetPathsFromLastSession();O.unshift(...Y.filter(oe=>N(oe)||J(oe)||oe.backupPath))}return O}async doExtractPathsFromAPI(L){const O={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},_=await Promise.all((0,R.coalesce)(L.urisToOpen||[]).map(async j=>{const Y=await this.resolveOpenable(j,O);if(Y)return Y.label=j.label,Y;const oe=this.resourceFromOpenable(j),q={title:this.productService.nameLong,type:"info",buttons:[(0,I.mnemonicButtonLabel)((0,g.localize)(0,null))],defaultId:0,message:oe.scheme===E.Schemas.file?(0,g.localize)(1,null):(0,g.localize)(2,null),detail:oe.scheme===E.Schemas.file?(0,g.localize)(3,null,(0,I.getPathLabel)(oe,{os:P.OS,tildify:this.environmentMainService})):(0,g.localize)(4,null,oe.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(q,(0,S.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(_)}async doExtractPathsFromCLI(L){const O=[],_={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},j=L["folder-uri"];if(j){const q=await Promise.all(j.map(re=>{const ne=this.cliArgToUri(re);if(!!ne)return this.resolveOpenable({folderUri:ne},_)}));O.push(...(0,R.coalesce)(q))}const Y=L["file-uri"];if(Y){const q=await Promise.all(Y.map(re=>{const ne=this.cliArgToUri(re);if(!!ne)return this.resolveOpenable((0,se.hasWorkspaceFileExtension)(re)?{workspaceUri:ne}:{fileUri:ne},_)}));O.push(...(0,R.coalesce)(q))}const oe=await Promise.all(L._.map(q=>_.remoteAuthority?this.doResolveRemotePath(q,_):this.doResolveFilePath(q,_)));return O.push(...(0,R.coalesce)(oe)),O}cliArgToUri(L){try{const O=f.URI.parse(L);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${L}, ${O.message}`)}}async doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];L!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const _=await Promise.all(O.map(async j=>{if(j.workspace){const Y=await this.resolveOpenable({workspaceUri:j.workspace.configPath},{remoteAuthority:j.remoteAuthority,rejectTransientWorkspaces:!0});if(N(Y))return Y}else if(j.folderUri){const Y=await this.resolveOpenable({folderUri:j.folderUri},{remoteAuthority:j.remoteAuthority});if(J(Y))return Y}else if(L!=="folders"&&j.backupPath)return{backupPath:j.backupPath,remoteAuthority:j.remoteAuthority}}));return(0,R.coalesce)(_)}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async resolveOpenable(L,O=Object.create(null)){const _=this.resourceFromOpenable(L);return _.scheme===E.Schemas.file?((0,ae.isFileToOpen)(L)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(_.fsPath,O)):this.doResolveRemoteOpenable(L,O)}doResolveRemoteOpenable(L,O){let _=this.resourceFromOpenable(L);const j=(0,U.getRemoteAuthority)(_)||O.remoteAuthority;if(_=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(_)),(0,ae.isFileToOpen)(L)){if(O.gotoLineMode){const{path:Y,line:oe,column:q}=(0,u.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:Y}),options:{selection:oe?{startLineNumber:oe,startColumn:q||1}:void 0},remoteAuthority:j}}return{fileUri:_,remoteAuthority:j}}else if((0,ae.isWorkspaceToOpen)(L))return{workspace:(0,he.getWorkspaceIdentifier)(_),remoteAuthority:j};return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:j}}resourceFromOpenable(L){return(0,ae.isWorkspaceToOpen)(L)?L.workspaceUri:(0,ae.isFolderToOpen)(L)?L.folderUri:L.fileUri}async doResolveFilePath(L,O){let _,j;O.gotoLineMode&&({path:L,line:_,column:j}=(0,u.parseLineAndColumnAware)(L)),L=(0,u.sanitizeFilePath)((0,h.normalize)(L),(0,w.cwd)());try{const Y=await t.Promises.stat(L);if(Y.isFile()){if(!O.forceOpenWorkspaceAsFile){const oe=await this.workspacesManagementMainService.resolveLocalWorkspace(f.URI.file(L));if(oe)return oe.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:oe.id,configPath:oe.configPath},type:n.FileType.File,exists:!0,remoteAuthority:oe.remoteAuthority,transient:oe.transient}}return{fileUri:f.URI.file(L),type:n.FileType.File,exists:!0,options:{selection:_?{startLineNumber:_,startColumn:j||1}:void 0}}}else{if(Y.isDirectory())return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(f.URI.file(L),Y),type:n.FileType.Directory,exists:!0};if(!P.isWindows&&L==="/dev/null")return{fileUri:f.URI.file(L),type:n.FileType.File,exists:!0}}}catch{const oe=f.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([oe]),O.ignoreFileNotFound)return{fileUri:oe,type:n.FileType.File,exists:!1}}}doResolveRemotePath(L,O){const _=L.charCodeAt(0),j=O.remoteAuthority;let Y,oe;O.gotoLineMode&&({path:L,line:Y,column:oe}=(0,u.parseLineAndColumnAware)(L)),_!==47&&((0,u.isWindowsDriveLetter)(_)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,u.toSlashes)(L)),L=`/${L}`);const q=f.URI.from({scheme:E.Schemas.vscodeRemote,authority:j,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return O.forceOpenWorkspaceAsFile?{fileUri:q,options:{selection:Y?{startLineNumber:Y,startColumn:oe||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,he.getWorkspaceIdentifier)(q),remoteAuthority:j};if(O.gotoLineMode||h.posix.basename(L).indexOf(".")!==-1)return{fileUri:q,options:{selection:Y?{startLineNumber:Y,startColumn:oe||1}:void 0},remoteAuthority:j}}return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(q),remoteAuthority:j}}shouldOpenNewWindow(L){const O=this.configurationService.getValue("window"),_=O?.openFoldersInNewWindow||"default",j=O?.openFilesInNewWindow||"off";let Y=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(_==="on"||_==="off")&&(Y=_==="on");let oe=!1;return L.forceNewWindow||L.forceReuseWindow?oe=!!L.forceNewWindow&&!L.forceReuseWindow:(P.isMacintosh?L.context===1&&(oe=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(oe=!0),!L.cli.extensionDevelopmentPath&&(j==="on"||j==="off")&&(oe=j==="on")),{openFolderInNewWindow:!!Y,openFilesInNewWindow:oe}}async openExtensionDevelopmentHostWindow(L,O){const _=(0,G.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(_)return this.lifecycleMainService.reload(_,O.cli),_.focus(),[_];let j=O.cli["folder-uri"]||[],Y=O.cli["file-uri"]||[],oe=O.cli._;if(!oe.length&&!j.length&&!Y.length&&!O.cli.extensionTestsPath){const ne=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ce=ne?.workspace??ne?.folderUri;ce&&(f.URI.isUri(ce)?ce.scheme===E.Schemas.file?oe=[ce.fsPath]:j=[ce.toString()]:ce.configPath.scheme===E.Schemas.file?oe=[(0,p.originalFSPath)(ce.configPath)]:Y=[ce.configPath.toString()])}let q=O.remoteAuthority;for(const ne of L)if(ne.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ce=f.URI.parse(ne),ge=(0,U.getRemoteAuthority)(ce);ge&&(q?(0,p.isEqualAuthority)(ge,q)||this.logService.error("more than one extension development path authority"):q=ge)}oe=oe.filter(ne=>{const ce=f.URI.file(ne);return(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:(0,p.isEqualAuthority)((0,U.getRemoteAuthority)(ce),q)}),j=j.filter(ne=>{const ce=this.cliArgToUri(ne);return ce&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,p.isEqualAuthority)((0,U.getRemoteAuthority)(ce),q):!1}),Y=Y.filter(ne=>{const ce=this.cliArgToUri(ne);return ce&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,p.isEqualAuthority)((0,U.getRemoteAuthority)(ce),q):!1}),O.cli._=oe,O.cli["folder-uri"]=j,O.cli["file-uri"]=Y;const re={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!oe.length&&!j.length&&!Y.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:q,profile:O.profile};return this.open(re)}openInBrowserWindow(L){const O=this.configurationService.getValue("window"),_={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,h.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:C.default,isInitialStartup:L.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};let j;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(j=L.windowToUse||this.getLastActiveWindow(),j&&j.focus()),j){const Y=j.config;!_.extensionDevelopmentPath&&Y?.extensionDevelopmentPath&&(_.extensionDevelopmentPath=Y.extensionDevelopmentPath,_.extensionDevelopmentKind=Y.extensionDevelopmentKind,_["enable-proposed-api"]=Y["enable-proposed-api"],_.verbose=Y.verbose,_["inspect-extensions"]=Y["inspect-extensions"],_["inspect-brk-extensions"]=Y["inspect-brk-extensions"],_.debugId=Y.debugId,_.extensionEnvironment=Y.extensionEnvironment,_["extensions-dir"]=Y["extensions-dir"],_["disable-extensions"]=Y["disable-extensions"])}else{const Y=this.windowsStateHandler.getNewWindowState(_);(0,d.mark)("code/willCreateCodeWindow");const oe=j=this.instantiationService.createInstance(X.CodeWindow,{state:Y,extensionDevelopmentPath:_.extensionDevelopmentPath,isExtensionTestHost:!!_.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(oe),ft.WINDOWS.push(oe),this._onDidOpenWindow.fire(oe),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(oe.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(oe)),(0,m.once)(oe.onDidClose)(()=>this.onWindowClosed(oe)),(0,m.once)(oe.onDidDestroy)(()=>this._onDidDestroyWindow.fire(oe)),oe.onDidTriggerSystemContextMenu(({x:re,y:ne})=>this._onDidTriggerSystemContextMenu.fire({window:oe,x:re,y:ne}));const q=(0,S.assertIsDefined)(oe.win?.webContents);q.removeAllListeners("devtools-reload-page"),q.on("devtools-reload-page",()=>this.lifecycleMainService.reload(oe)),this.lifecycleMainService.registerWindow(oe)}return _.windowId=j.id,j.isReady?this.lifecycleMainService.unload(j,4).then(Y=>{Y||this.doOpenInBrowserWindow(j,_,L)}):this.doOpenInBrowserWindow(j,_,L),j}doOpenInBrowserWindow(L,O,_){O.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,he.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),L.load(O)}resolveProfileForBrowserWindow(L){let O=L.profile;return O&&this.userDataProfilesMainService.setProfileForWorkspaceSync(L.workspace??"empty-window",O),O||(O=this.userDataProfilesMainService.getOrSetProfileForWorkspace(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile)),O}onWindowClosed(L){const O=ft.WINDOWS.indexOf(L);ft.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=v.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,p.isEqualAuthority)(O.remoteAuthority,L)))}doGetLastActiveWindow(L){const O=Math.max.apply(Math,L.map(_=>_.lastFocusTime));return L.find(_=>_.lastFocusTime===O)}sendToFocused(L,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...O)}sendToAll(L,O,_){for(const j of this.getWindows())_&&_.indexOf(j.id)>=0||j.sendWhenReady(L,D.CancellationToken.None,O)}getWindows(){return ft.WINDOWS}getWindowCount(){return ft.WINDOWS.length}getWindowById(L){const O=this.getWindows().filter(_=>_.id===L);return(0,R.firstOrDefault)(O)}getWindowByWebContents(L){const O=v.BrowserWindow.fromWebContents(L);if(!!O)return this.getWindowById(O.id)}};B.WINDOWS=[],B=ve([ee(2,a.ILogService),ee(3,Q.IStateMainService),ee(4,A.IPolicyService),ee(5,i.IEnvironmentMainService),ee(6,F.IUserDataProfilesMainService),ee(7,c.ILifecycleMainService),ee(8,l.IBackupMainService),ee(9,r.IConfigurationService),ee(10,V.IWorkspacesHistoryMainService),ee(11,H.IWorkspacesManagementMainService),ee(12,s.IInstantiationService),ee(13,o.IDialogMainService),ee(14,n.IFileService),ee(15,M.IProductService),ee(16,T.IProtocolMainService),ee(17,W.IThemeMainService)],B),e.WindowsMainService=B}),define(te[272],ie([0,1,60,33,75,52]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(u,m,I,y){this.workspacesManagementMainService=u,this.windowsMainService=m,this.workspacesHistoryMainService=I,this.backupMainService=y,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(u,m){const I=this.windowsMainService.getWindowById(u);if(I)return this.workspacesManagementMainService.enterWorkspace(I,this.windowsMainService.getWindows(),m)}createUntitledWorkspace(u,m,I){return this.workspacesManagementMainService.createUntitledWorkspace(m,I)}deleteUntitledWorkspace(u,m){return this.workspacesManagementMainService.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(u,m){return this.workspacesManagementMainService.getWorkspaceIdentifier(m)}getRecentlyOpened(u){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(u,m){return this.workspacesHistoryMainService.addRecentlyOpened(m)}removeRecentlyOpened(u,m){return this.workspacesHistoryMainService.removeRecentlyOpened(m)}clearRecentlyOpened(u){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=ve([ee(0,R.IWorkspacesManagementMainService),ee(1,t.IWindowsMainService),ee(2,k.IWorkspacesHistoryMainService),ee(3,v.IBackupMainService)],D),e.WorkspacesMainService=D}),define(te[273],ie([0,1,15,41,25,18,44,17,30,49,43,35,2,13,9,4,12,7,29,81,131,46,145,102,248,148,60,264,19,69,181,84,119,56,105,179,27,59,113,193,213,194,250,106,195,196,14,206,86,68,5,85,265,226,260,22,6,208,270,65,20,63,256,87,38,253,91,114,32,232,234,73,48,239,240,266,241,267,116,243,244,245,246,251,33,271,252,28,92,75,272,52,249,37,212,42,259,222,55,72,89,254,261,262,8]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p,S,f,g,l,r,o,i,n,s,c,a,C,M,T,U,Q,ae,X,G,Z,se,he,V,H,W,A,F,N,J,B,$,L,O,_,j,Y,oe,q,re,ne,ce,ge,De,Ae,ke,Le,qe,me,we,Ee,x,le,fe,Se,Ie,Te,Oe,Ne,Be,ze,Ke,Ue,Ge,K,ue,de,pe,ye,Re,_e,it,xe,je,et,nt,lt,gt,St,Bt,zt,$t,_t,qt,Ht,jt,Vt,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Pt=class extends E.Disposable{constructor(be,Pe,Me,Ce,Fe,$e,Ze,tt,We,Ve,Qe){super(),this.mainProcessNodeIpcServer=be,this.userEnv=Pe,this.mainInstantiationService=Me,this.logService=Ce,this.environmentMainService=Fe,this.lifecycleMainService=$e,this.configurationService=Ze,this.stateMainService=tt,this.fileService=We,this.productService=Ve,this.userDataProfilesMainService=Qe,this.configureSession(),this.registerListeners()}configureSession(){const be=We=>We?.startsWith(`${h.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((We,Ve,Qe,Je)=>be(Je.requestingUrl)?Qe(Pe.has(Ve)):Qe(!1)),v.session.defaultSession.setPermissionCheckHandler((We,Ve,Qe,Je)=>be(Je.requestingUrl)?Pe.has(Ve):!1);const Me=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,"devtools"]),Ce=We=>{for(let Ve=We;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},Fe=We=>We.resourceType==="xhr"||Ce(We.frame),$e=We=>{const Ve=We.frame;if(!Ve||!this.windowsMainService)return!1;const Qe=v.BrowserWindow.getAllWindows();for(const Je of Qe)if(Ve.processId===Je.webContents.mainFrame.processId)return!0;return!1},Ze=(We,Ve)=>{if(We.path!=="/index.html")return!0;const Qe=Ve.frame;if(!Qe||!this.windowsMainService)return!1;for(const Je of this.windowsMainService.getWindows())if(Je.win&&Qe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};v.session.defaultSession.webRequest.onBeforeRequest((We,Ve)=>{const Qe=p.URI.parse(We.url);return Qe.scheme===h.Schemas.vscodeWebview&&!Ze(Qe,We)?(this.logService.error("Blocked vscode-webview request",We.url),Ve({cancel:!0})):Qe.scheme===h.Schemas.vscodeFileResource&&!$e(We)?(this.logService.error("Blocked vscode-file request",We.url),Ve({cancel:!0})):Qe.path.endsWith(".svg")&&!Me.has(Qe.scheme)?Ve({cancel:!Fe(We)}):Ve({cancel:!1})}),v.session.defaultSession.webRequest.onHeadersReceived((We,Ve)=>{const Qe=We.responseHeaders,Je=Qe["content-type"]||Qe["Content-Type"];if(Je&&Array.isArray(Je)){const ot=p.URI.parse(We.url);if(ot.path.endsWith(".svg")&&Me.has(ot.scheme))return Qe["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Qe});if(!ot.path.endsWith(h.Schemas.vscodeRemoteResource)&&Je.some(ct=>ct.toLowerCase().includes("image/svg")))return Ve({cancel:!Fe(We)})}return Ve({cancel:!1})});const tt=v.session.defaultSession;typeof tt.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&tt.setCodeCachePath((0,d.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,b.setUnexpectedErrorHandler)(Me=>this.onUnexpectedError(Me)),process.on("uncaughtException",Me=>(0,b.onUnexpectedError)(Me)),process.on("unhandledRejection",Me=>(0,b.onUnexpectedError)(Me)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,g.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(Me,Ce)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ce)}),v.app.on("activate",async(Me,Ce)=>{this.logService.trace("app#activate"),Ce||await this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(Me,Ce)=>{Ce.on("will-navigate",Fe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),Ce.setWindowOpenHandler(({url:Fe})=>(this.nativeHostMainService?.openExternal(void 0,Fe),{action:"deny"}))});let be=[],Pe;v.app.on("open-file",(Me,Ce)=>{this.logService.trace("app#open-file: ",Ce),Me.preventDefault(),be.push((0,_e.hasWorkspaceFileExtension)(Ce)?{workspaceUri:p.URI.file(Ce)}:{fileUri:p.URI.file(Ce)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:be,gotoLineMode:!1,preferNewWindow:!0}),be=[],Pe=void 0},100)}),v.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Me=>{const Ce=this.windowsMainService?.getWindowByWebContents(Me.sender);let Fe,$e;return Ce?.config?(Fe=Ce.config,$e={...process.env,...Ce.config.userEnv}):(Fe=this.environmentMainService.args,$e=process.env),this.resolveShellEnvironment(Fe,$e,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Me,Ce,Fe)=>{const $e=this.validateNlsPath([Ce]);if(!$e||typeof Fe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile($e,R.VSBuffer.fromString(Fe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Me,...Ce)=>{const Fe=this.validateNlsPath(Ce);if(!Fe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Fe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Me=>Me.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Me=>Me.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Me=>Me.sender.reload())}validateNlsPath(be){let Pe;for(const Me of be)typeof Me=="string"&&(typeof Pe!="string"?Pe=Me:Pe=(0,d.join)(Pe,Me));if(!(typeof Pe!="string"||!(0,d.isAbsolute)(Pe)||!(0,u.isEqualOrParent)(Pe,this.environmentMainService.cachedLanguagesPath,!P.isLinux)))return p.URI.file(Pe)}onUnexpectedError(be){if(be){const Pe={message:`[uncaught exception in main]: ${be.message}`,stack:be.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${be}`),be.stack&&this.logService.error(be.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const be=this.productService.win32AppUserModelId;P.isWindows&&be&&v.app.setAppUserModelId(be);try{P.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(We){this.logService.error(We)}const Pe=new r.Server;this.lifecycleMainService.onWillShutdown(We=>{We.reason===2&&Pe.dispose()}),this.logService.trace("Resolving machine identifier...");const Me=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Me}`);const{sharedProcess:Ce,sharedProcessReady:Fe,sharedProcessClient:$e}=this.setupSharedProcess(Me),Ze=await this.initServices(Me,Ce,Fe);this.setUpHandlers(Ze),Ze.invokeFunction(We=>this.initChannels(We,Pe,$e)),await Ze.invokeFunction(We=>this.openFirstWindow(We,Pe)),Ze.invokeFunction(We=>this.afterWindowOpen(We,Ce)),this._register(new It.RunOnceScheduler(()=>{this._register((0,It.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setUpHandlers(be){this._register(be.createInstance(i.ProxyAuthHandler)),this._register(be.createInstance(Bt.DefaultExtensionsProfileInitHandler)),this._register(be.createInstance(jt.UserDataTransientProfilesHandler))}async resolveMachineId(){let be=this.stateMainService.getItem(x.machineIdKey);return(!be||P.isMacintosh&&be==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(be=await(0,f.getMachineId)(),this.stateMainService.setItem(x.machineIdKey,be)),be}setupSharedProcess(be){const Pe=this._register(this.mainInstantiationService.createInstance(ke.SharedProcess,be,this.userEnv)),Me=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Fe=await Pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new o.Client(Fe,"main")})(),Ce=(async()=>(await Pe.whenReady(),Me))();return{sharedProcess:Pe,sharedProcessReady:Ce,sharedProcessClient:Me}}async initServices(be,Pe,Me){const Ce=new _.ServiceCollection;switch(process.platform){case"win32":Ce.set(Ie.IUpdateService,new L.SyncDescriptor(ze.Win32UpdateService));break;case"linux":P.isLinuxSnap?Ce.set(Ie.IUpdateService,new L.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ce.set(Ie.IUpdateService,new L.SyncDescriptor(Ne.LinuxUpdateService));break;case"darwin":Ce.set(Ie.IUpdateService,new L.SyncDescriptor(Oe.DarwinUpdateService));break}Ce.set(pe.IWindowsMainService,new L.SyncDescriptor(ye.WindowsMainService,[be,this.userEnv],!1));const Fe=new Q.DialogMainService(this.logService);Ce.set(Q.IDialogMainService,Fe),Ce.set(oe.ILaunchMainService,new L.SyncDescriptor(oe.LaunchMainService,void 0,!1)),Ce.set(U.IDiagnosticsMainService,new L.SyncDescriptor(U.DiagnosticsMainService,void 0,!1)),Ce.set(T.IDiagnosticsService,l.ProxyChannel.toService((0,l.getDelayedChannel)(Me.then(tt=>tt.getChannel("diagnostics"))))),Ce.set(j.IIssueMainService,new L.SyncDescriptor(j.IssueMainService,[this.userEnv])),Ce.set(ae.IEncryptionMainService,new L.SyncDescriptor(X.EncryptionMainService,[be])),Ce.set(Y.IKeyboardLayoutMainService,new L.SyncDescriptor(Y.KeyboardLayoutMainService)),Ce.set(ge.INativeHostMainService,new L.SyncDescriptor(ge.NativeHostMainService,[Pe],!1)),Ce.set(C.ICredentialsMainService,new L.SyncDescriptor(nt.CredentialsNativeMainService)),Ce.set(ue.IWebviewManagerService,new L.SyncDescriptor(de.WebviewMainService)),Ce.set(ce.IMenubarMainService,new L.SyncDescriptor(ce.MenubarMainService)),Ce.set(he.IExtensionUrlTrustService,new L.SyncDescriptor(V.ExtensionUrlTrustService)),Ce.set(H.IExtensionHostStarter,new L.SyncDescriptor(W.ExtensionHostStarter)),Ce.set(we.IStorageMainService,new L.SyncDescriptor(we.StorageMainService)),Ce.set(we.IApplicationStorageMainService,new L.SyncDescriptor(we.ApplicationStorageMainService)),P.isWindows?Ce.set(A.IExternalTerminalMainService,new L.SyncDescriptor(F.WindowsExternalTerminalService)):P.isMacintosh?Ce.set(A.IExternalTerminalMainService,new L.SyncDescriptor(F.MacExternalTerminalService)):P.isLinux&&Ce.set(A.IExternalTerminalMainService,new L.SyncDescriptor(F.LinuxExternalTerminalService));const $e=new c.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateMainService);Ce.set(s.IBackupMainService,$e);const Ze=new et.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,$e,Fe,this.productService);if(Ce.set(et.IWorkspacesManagementMainService,Ze),Ce.set(it.IWorkspacesService,new L.SyncDescriptor(je.WorkspacesMainService,void 0,!1)),Ce.set(xe.IWorkspacesHistoryMainService,new L.SyncDescriptor(xe.WorkspacesHistoryMainService,void 0,!1)),Ce.set(Ke.IURLService,new L.SyncDescriptor(Ge.NativeURLService,void 0,!1)),(0,Se.supportsTelemetry)(this.productService,this.environmentMainService)){const tt=(0,Se.isInternalTelemetry)(this.productService,this.configurationService),We=(0,l.getDelayedChannel)(Me.then(ct=>ct.getChannel("telemetryAppender"))),Ve=new le.TelemetryAppenderClient(We),Qe=(0,Ee.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,be,tt,this.environmentMainService.installSourcePath),Je=(0,Se.getPiiPathsFromEnvironment)(this.environmentMainService),ot={appenders:[Ve],commonProperties:Qe,piiPaths:Je,sendErrorTelemetry:!0};Ce.set(x.ITelemetryService,new L.SyncDescriptor(fe.TelemetryService,[ot],!1))}else Ce.set(x.ITelemetryService,Se.NullTelemetryService);return Ce.set(_t.IExtensionsProfileScannerService,new L.SyncDescriptor(_t.ExtensionsProfileScannerService,void 0,!0)),Ce.set(qt.IExtensionsScannerService,new L.SyncDescriptor(Ht.ExtensionsScannerService,void 0,!0)),await It.Promises.settled([$e.initialize(),Ze.initialize()]),this.mainInstantiationService.createChild(Ce)}initChannels(be,Pe,Me){const Ce=l.ProxyChannel.fromService(be.get(oe.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Ce);const Fe=l.ProxyChannel.fromService(be.get(U.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Fe);const $e=new gt.PolicyChannel(be.get(lt.IPolicyService));Pe.registerChannel("policy",$e),Me.then(Ye=>Ye.registerChannel("policy",$e));const Ze=this.fileService.getProvider(h.Schemas.file);(0,w.assertType)(Ze instanceof $.DiskFileSystemProvider);const tt=new B.DiskFileSystemProviderChannel(Ze,this.logService,this.environmentMainService);Pe.registerChannel(N.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt),Me.then(Ye=>Ye.registerChannel(N.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt));const We=l.ProxyChannel.fromService(be.get(St.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",We),Me.then(Ye=>Ye.registerChannel("userDataProfiles",We));const Ve=new zt.RequestChannel(be.get($t.IRequestService));Me.then(Ye=>Ye.registerChannel("request",Ve));const Qe=new Te.UpdateChannel(be.get(Ie.IUpdateService));Pe.registerChannel("update",Qe);const Je=l.ProxyChannel.fromService(be.get(j.IIssueMainService));Pe.registerChannel("issue",Je);const ot=l.ProxyChannel.fromService(be.get(ae.IEncryptionMainService));Pe.registerChannel("encryption",ot);const ct=l.ProxyChannel.fromService(be.get(C.ICredentialsMainService));Pe.registerChannel("credentials",ct);const kt=l.ProxyChannel.fromService(be.get(Le.ISignService));Pe.registerChannel("sign",kt);const Xe=l.ProxyChannel.fromService(be.get(Y.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",Xe),this.nativeHostMainService=be.get(ge.INativeHostMainService);const mt=l.ProxyChannel.fromService(this.nativeHostMainService);Pe.registerChannel("nativeHost",mt),Me.then(Ye=>Ye.registerChannel("nativeHost",mt));const pt=l.ProxyChannel.fromService(be.get(it.IWorkspacesService));Pe.registerChannel("workspaces",pt);const yt=l.ProxyChannel.fromService(be.get(ce.IMenubarMainService));Pe.registerChannel("menubar",yt);const Mt=l.ProxyChannel.fromService(be.get(Ke.IURLService));Pe.registerChannel("url",Mt);const Dt=l.ProxyChannel.fromService(be.get(he.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",Dt);const wt=l.ProxyChannel.fromService(be.get(ue.IWebviewManagerService));Pe.registerChannel("webview",wt);const ut=this._register(new me.StorageDatabaseChannel(this.logService,be.get(we.IStorageMainService)));Pe.registerChannel("storage",ut),Me.then(Ye=>Ye.registerChannel("storage",ut));const bt=this._register(new Vt.ProfileStorageChangesListenerChannel(be.get(we.IStorageMainService),be.get(St.IUserDataProfilesMainService),this.logService));Me.then(Ye=>Ye.registerChannel("profileStorageListener",bt));const vt=l.ProxyChannel.fromService(be.get(A.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",vt);const He=new ne.LogLevelChannel(be.get(re.ILogService));Pe.registerChannel("logLevel",He),Me.then(Ye=>Ye.registerChannel("logLevel",He));const st=new ne.LoggerChannel(be.get(re.ILoggerService));Pe.registerChannel("logger",st),Me.then(Ye=>Ye.registerChannel("logger",st));const ht=new M.ElectronExtensionHostDebugBroadcastChannel(be.get(pe.IWindowsMainService),be.get(St.IUserDataProfilesMainService));Pe.registerChannel("extensionhostdebugservice",ht);const at=l.ProxyChannel.fromService(be.get(H.IExtensionHostStarter));Pe.registerChannel(H.ipcExtensionHostStarterChannelName,at)}async openFirstWindow(be,Pe){const Me=this.windowsMainService=be.get(pe.IWindowsMainService),Ce=be.get(Ke.IURLService),Fe=be.get(ge.INativeHostMainService);this.lifecycleMainService.phase=2;const $e=[],Ze=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(He=>{try{return{uri:p.URI.parse(He),url:He}}catch{return}}).filter(He=>{if(!He||this.shouldBlockURI(He.uri))return!1;const st=this.getWindowOpenableFromProtocolLink(He.uri);return st?($e.push(st),!1):!0}),tt=this,We=this.environmentMainService,Ve=this.productService,Qe=this.logService;Ce.registerHandler({async handleURL(He,st){if(Qe.trace("app#handleURL: ",He.toString(!0),st),He.scheme===Ve.urlProtocol&&He.path==="workspace"&&(He=He.with({authority:"file",path:p.URI.parse(He.query).path,query:""})),tt.shouldBlockURI(He))return!0;let ht=!1;const at=new URLSearchParams(He.query);at.get("windowId")==="_blank"&&(at.delete("windowId"),He=He.with({query:at.toString()}),ht=!0),ht||=P.isMacintosh&&Me.getWindowCount()===0;const Ye=at.get("continueOn");Ye!==null&&(We.continueOn=Ye??void 0,at.delete("continueOn"),He=He.with({query:at.toString()}));const Rt=tt.getWindowOpenableFromProtocolLink(He);if(Qe.trace("app#handleURL: windowOpenableFromProtocolLink = ",Rt),Rt){const[Lt]=await Me.open({context:5,cli:{...We.args},urisToOpen:[Rt],forceNewWindow:ht,gotoLineMode:!0});return Lt.focus(),!0}if(ht){const[Lt]=await Me.open({context:5,cli:{...We.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ae.getRemoteAuthority)(He)});return await Lt.ready(),Ce.open(He,st)}return!1}});const Je=this._register(new Re.ActiveWindowManager({onDidOpenWindow:Fe.onDidOpenWindow,onDidFocusWindow:Fe.onDidFocusWindow,getActiveWindowId:()=>Fe.getActiveWindowId(-1)})),ot=new l.StaticRouter(He=>Je.getActiveClientId().then(st=>He===st)),ct=new Ue.URLHandlerRouter(ot),kt=Pe.getChannel("urlHandler",ct);Ce.registerHandler(new Ue.URLHandlerChannelClient(kt)),this._register(new K.ElectronURLListener(Ze,Ce,Me,this.environmentMainService,this.productService));const Xe=this.environmentMainService.args,mt=global.macOpenFiles,pt=(0,Z.isLaunchedFromCli)(process.env)?0:4,yt=Xe._.length,Mt=!!Xe["folder-uri"],Dt=!!Xe["file-uri"],wt=Xe["skip-add-to-recently-opened"]===!0,ut=Xe.wait&&Xe.waitMarkerFilePath?p.URI.file(Xe.waitMarkerFilePath):void 0,bt=Xe.remote||void 0;if($e.length>0)return Me.open({context:pt,cli:Xe,urisToOpen:$e,gotoLineMode:!0,initialStartup:!0});const vt=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(this.environmentMainService.args);if(!yt&&!Mt&&!Dt){if(Xe["new-window"]||vt)return Me.open({context:pt,cli:Xe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:bt,profile:vt});if(mt.length)return Me.open({context:1,cli:Xe,urisToOpen:mt.map(He=>(0,_e.hasWorkspaceFileExtension)(He)?{workspaceUri:p.URI.file(He)}:{fileUri:p.URI.file(He)}),noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0})}return Me.open({context:pt,cli:Xe,forceNewWindow:Xe["new-window"]||!yt&&Xe["unity-launch"],diffMode:Xe.diff,mergeMode:Xe.merge,noRecentEntry:wt,waitMarkerFileURI:ut,gotoLineMode:Xe.goto,initialStartup:!0,remoteAuthority:bt,profile:vt})}shouldBlockURI(be){return!!(be.authority===h.Schemas.file&&P.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,y.mnemonicButtonLabel)((0,n.localize)(0,null)),(0,y.mnemonicButtonLabel)((0,n.localize)(1,null))],defaultId:0,cancelId:1,message:(0,n.localize)(2,null,(0,y.getPathLabel)(be,{os:P.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,n.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(be){if(!!be.path){if(be.authority===h.Schemas.file){const Pe=p.URI.file(be.fsPath);return(0,_e.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(be.authority===h.Schemas.vscodeRemote){const Pe=be.path.indexOf(d.posix.sep,1);if(Pe!==-1){const Me=be.path.substring(1,Pe),Ce=be.path.substring(Pe),Fe=p.URI.from({scheme:h.Schemas.vscodeRemote,authority:Me,path:Ce,query:be.query,fragment:be.fragment});return(0,_e.hasWorkspaceFileExtension)(Ce)?{workspaceUri:Fe}:/:[\d]+$/.test(Ce)?{fileUri:Fe}:{folderUri:Fe}}}}}afterWindowOpen(be,Pe){const Me=be.get(x.ITelemetryService),Ce=be.get(Ie.IUpdateService);this.lifecycleMainService.phase=3,this.handleSharedProcessErrors(Me,Pe),this.installMutex(),v.protocol.registerHttpProtocol(h.Schemas.vscodeRemoteResource,(Fe,$e)=>{$e({url:Fe.url.replace(/^vscode-remote-resource:/,"http:"),method:Fe.method})}),(Ce instanceof ze.Win32UpdateService||Ce instanceof Ne.LinuxUpdateService||Ce instanceof Oe.DarwinUpdateService)&&Ce.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const be=this.productService.win32MutexName;if(P.isWindows&&be)try{const Pe=await new Promise((Ce,Fe)=>{z(["windows-mutex"],Ce,Fe)}),Me=new Pe.Mutex(be);(0,m.once)(this.lifecycleMainService.onWillShutdown)(()=>Me.release())}catch(Pe){this.logService.error(Pe)}}handleSharedProcessErrors(be,Pe){let Me=!1;(0,m.once)(this.lifecycleMainService.onWillShutdown)(()=>Me=!0),this._register(Pe.onDidError(({type:Ce,details:Fe})=>{let $e;switch(Ce){case 1:$e="SharedProcess: detected unresponsive window";break;case 2:$e=`SharedProcess: renderer process gone (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:$e=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,b.onUnexpectedError)(new Error($e)),be.publicLog2("sharedprocesserror",{type:Ce,reason:Fe?.reason,code:Fe?.exitCode,visible:Pe.isVisible(),shuttingdown:Me})}))}async resolveShellEnvironment(be,Pe,Me){try{return await(0,se.getResolvedShellEnv)(this.logService,be,Pe)}catch(Ce){const Fe=(0,D.toErrorMessage)(Ce);Me?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Fe):this.logService.error(Fe)}return{}}async updateCrashReporterEnablement(){try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Me=JSON.parse((0,I.stripComments)(Pe)),Fe=(0,Se.getTelemetryLevel)(this.configurationService)>=1;if(Me["enable-crash-reporter"]===void 0){const $e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Fe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,S.generateUuid)()}"`,"}"],Ze=Pe.substring(0,Pe.length-2).concat(`,
`,$e.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Ze))}else{const $e=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Fe},`);$e!==Pe&&await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString($e))}}catch(be){this.logService.error(be)}}};Pt=ve([ee(2,O.IInstantiationService),ee(3,re.ILogService),ee(4,G.IEnvironmentMainService),ee(5,q.ILifecycleMainService),ee(6,a.IConfigurationService),ee(7,qe.IStateMainService),ee(8,J.IFileService),ee(9,De.IProductService),ee(10,St.IUserDataProfilesMainService)],Pt),e.CodeApplication=Pt}),define(te[274],ie([0,1,37,8,281,2]),function(z,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends v.AbstractPolicyService{constructor(u){super(),this.productName=u,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(u){await this.throttler.queue(()=>new Promise((m,I)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,u,y=>{for(const E in y){const h=y[E];h===void 0?this.policies.delete(E):this.policies.set(E,h)}this._onDidChange.fire(Object.keys(y)),m()})}catch(y){I(y)}}))}}e.NativePolicyService=D}),define(te[275],ie([0,1,224,8,18,17,2,12,19,36,113,6,223,282]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends D.Disposable{constructor(w,p,S){super(),this.environmentService=p,this.logService=S,this.configure(w.getValue()),this._register(w.onDidChangeConfiguration(()=>this.configure(w.getValue()),this))}configure(w){this.proxyUrl=w.http&&w.http.proxy,this.strictSSL=!!(w.http&&w.http.proxyStrictSSL),this.authorization=w.http&&w.http.proxyAuthorization}async request(w,p){this.logService.trace("RequestService#request (node) - begin",w.url);const{proxyUrl:S,strictSSL:f}=this;let g;try{g=await(0,I.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",o))}const l={...process.env,...g},r=w.agent?w.agent:await(0,E.getProxyAgent)(w.url||"",l,{proxyUrl:S,strictSSL:f});w.agent=r,w.strictSSL=f,this.authorization&&(w.headers={...w.headers||{},"Proxy-Authorization":this.authorization});try{const o=await this._request(w,p);return this.logService.trace("RequestService#request (node) - success",w.url),o}catch(o){throw this.logService.trace("RequestService#request (node) - error",w.url,o),o}}async getNodeRequest(w){return((0,v.parse)(w.url).protocol==="https:"?await new Promise((f,g)=>{z(["https"],f,g)}):await new Promise((f,g)=>{z(["http"],f,g)})).request}_request(w,p){return t.Promises.withAsyncBody(async(S,f)=>{const g=(0,v.parse)(w.url),l=w.getRawRequest?w.getRawRequest(w):await this.getNodeRequest(w),r={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,b.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(r.auth=w.user+":"+w.password);const o=l(r,i=>{const n=(0,b.isNumber)(w.followRedirects)?w.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...w,url:i.headers.location,followRedirects:n-1},p).then(S,f);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,h.createGunzip)())),S({res:i,stream:(0,k.streamToBufferReadableStream)(s)})}});o.on("error",f),w.timeout&&o.setTimeout(w.timeout),w.data&&typeof w.data=="string"&&o.write(w.data),o.end(),p.onCancellationRequested(()=>{o.abort(),f(new R.CancellationError)})})}async resolveProxy(w){}};d=ve([ee(0,u.IConfigurationService),ee(1,m.INativeEnvironmentService),ee(2,y.ILogService)],d),e.RequestService=d}),define(te[276],ie([0,1,15,275]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(D){return v.net.request}class R extends t.RequestService{request(b,u){return super.request({...b||{},getRawRequest:k},u)}}e.RequestMainService=R}),define(te[283],ie([0,1,15,40,7,24,8,44,17,30,49,35,13,9,71,4,34,26,21,46,83,273,10,19,217,230,27,59,185,14,204,86,68,201,85,22,108,6,209,109,54,20,61,255,115,237,55,276,87,225,38,229,73,64,42,37,274,211,2,51,242,39,238]),function(z,e,v,t,k,R,D,b,u,m,I,y,E,h,d,P,w,p,S,f,g,l,r,o,i,n,s,c,a,C,M,T,U,Q,ae,X,G,Z,se,he,V,H,W,A,F,N,J,B,$,L,O,_,j,Y,oe,q,re,ne,ce,ge,De,Ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ke{main(){try{this.startup()}catch(me){console.error(me.message),v.app.exit(1)}}async startup(){(0,u.setUnexpectedErrorHandler)(Te=>console.error(Te));const[me,we,Ee,x,le,fe,Se,Ie]=this.createServices();try{try{await this.initServices(Ee,Ie,x,le,Se)}catch(Te){throw this.handleStartupDataDirError(Ee,Se.nameLong,Te),Te}await me.invokeFunction(async Te=>{const Oe=Te.get(Z.ILogService),Ne=Te.get(X.ILifecycleMainService),Be=Te.get(C.IFileService),ze=await this.claimInstance(Oe,Ee,Ne,me,Se,!0);return S.Promises.writeFile(Ee.mainLockfile,String(process.pid)).catch(Ke=>{Oe.warn(`Error writing main lockfile: ${Ke.stack}`)}),fe.logger=new he.SpdLogLogger("main",(0,h.join)(Ee.logsPath,"main.log"),!0,!1,fe.getLevel()),(0,I.once)(Ne.onWillShutdown)(Ke=>{Be.dispose(),x.dispose(),Ke.join(S.Promises.unlink(Ee.mainLockfile).catch(()=>{}))}),me.createInstance(l.CodeApplication,ze,we).startup()})}catch(Te){me.invokeFunction(this.quit,Te)}}createServices(){const me=new ae.ServiceCollection,we=new ce.DisposableStore;process.once("exit",()=>we.dispose());const Ee={_serviceBrand:void 0,...V.default};me.set(H.IProductService,Ee);const x=new s.EnvironmentMainService(this.resolveArgs(),Ee),le=this.patchEnvironment(x);me.set(s.IEnvironmentMainService,x);const fe=new G.BufferLogService,Se=we.add(new Z.MultiplexLogService([new Z.ConsoleMainLogger((0,Z.getLogLevel)(x)),fe]));me.set(Z.ILogService,Se);const Ie=new M.FileService(Se);me.set(C.IFileService,Ie);const Te=new T.DiskFileSystemProvider(Se);Ie.registerProvider(E.Schemas.file,Te);const Oe=new De.UriIdentityService(Ie);me.set(ge.IUriIdentityService,Oe),me.set(Z.ILoggerService,new se.LoggerService(Se,Ie));const Ne=new _.StateMainService(x,Se,Ie);me.set(O.IStateMainService,Ne);const Be=new oe.UserDataProfilesMainService(Ne,Oe,x,Ie,Se);me.set(oe.IUserDataProfilesMainService,Be);const ze=P.isWindows&&Ee.win32RegValueName?we.add(new re.NativePolicyService(Ee.win32RegValueName)):x.policyFile?we.add(new ne.FilePolicyService(x.policyFile,Ie,Se)):new q.NullPolicyService;me.set(q.IPolicyService,ze);const Ke=new i.ConfigurationService(Be.defaultProfile.settingsResource,Ie,ze,Se);return me.set(o.IConfigurationService,Ke),me.set(X.ILifecycleMainService,new U.SyncDescriptor(X.LifecycleMainService,void 0,!1)),me.set(J.IRequestService,new U.SyncDescriptor(B.RequestMainService,void 0,!0)),me.set(Y.IThemeMainService,new U.SyncDescriptor(Y.ThemeMainService)),me.set($.ISignService,new U.SyncDescriptor(L.SignService,void 0,!1)),me.set(F.ITunnelService,new U.SyncDescriptor(N.TunnelService)),me.set(W.IProtocolMainService,new A.ProtocolMainService(x,Be,Se)),[new Q.InstantiationService(me,!0),le,x,Ke,Ne,fe,Ee,Be]}patchEnvironment(me){const we={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ee=>{const x=process.env[Ee];typeof x=="string"&&(we[Ee]=x)}),Object.assign(process.env,we),we}async initServices(me,we,Ee,x,le){await D.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsPath,we.defaultProfile.globalStorageHome.fsPath,me.workspaceStorageHome.fsPath,me.localHistoryHome.fsPath,me.backupHome].map(fe=>fe?S.Promises.mkdir(fe,{recursive:!0}):void 0)),x.init(),Ee.initialize()]),we.setEnablement(le.quality!=="stable"||Ee.getValue(Ae.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(me,we,Ee,x,le,fe){let Se;try{(0,d.mark)("code/willStartMainServer"),Se=await(0,g.serve)(we.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,I.once)(Ee.onWillShutdown)(()=>Se.dispose())}catch(Ie){if(Ie.code!=="EADDRINUSE")throw this.handleStartupDataDirError(we,le.nameLong,Ie),Ie;let Te;try{Te=await(0,g.connect)(we.mainIPCHandle,"main")}catch(ze){if(!fe||P.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.showStartupWarningDialog((0,r.localize)(0,null,le.nameShort),(0,r.localize)(1,null),le.nameLong),ze;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(Ke){throw me.warn("Could not delete obsolete instance handle",Ke),Ke}return this.claimInstance(me,we,Ee,x,le,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const ze="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw me.error(ze),Te.dispose(),new Error(ze)}let Oe;!we.args.wait&&!we.args.status&&(Oe=setTimeout(()=>{this.showStartupWarningDialog((0,r.localize)(2,null,le.nameShort),(0,r.localize)(3,null),le.nameLong)},1e4));const Ne=f.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),Be=f.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return x.invokeFunction(async()=>{const ze=new n.DiagnosticsService(j.NullTelemetryService,le),Ke=await Be.getMainDiagnostics(),Ue=await Be.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ge=await ze.getDiagnostics(Ke,Ue);throw console.log(Ge),new u.ExpectedError});throw P.isWindows&&await this.windowsAllowSetForegroundWindow(Ne,me),me.trace("Sending env to running instance..."),await Ne.start(we.args,process.env),Te.dispose(),Oe&&clearTimeout(Oe),new u.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw me.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new u.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Se}handleStartupDataDirError(me,we,Ee){if(Ee.code==="EACCES"||Ee.code==="EPERM"){const x=(0,R.coalesce)([me.userDataPath,me.extensionsPath,g.XDG_RUNTIME_DIR]).map(le=>(0,y.getPathLabel)(k.URI.file(le),{os:P.OS,tildify:me}));this.showStartupWarningDialog((0,r.localize)(4,null),(0,r.localize)(5,null,(0,b.toErrorMessage)(Ee),x.join(`
`)),we)}}showStartupWarningDialog(me,we,Ee){v.dialog.showMessageBoxSync({title:Ee,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,r.localize)(6,null))],message:me,detail:we,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(me,we){if(P.isWindows){const Ee=await me.getMainProcessId();we.trace("Sending some foreground love to the running instance:",Ee);try{(await new Promise((x,le)=>{z(["windows-foreground-love"],x,le)})).allowSetForegroundWindow(Ee)}catch(x){we.error(x)}}}quit(me,we){const Ee=me.get(Z.ILogService),x=me.get(X.ILifecycleMainService);let le=0;we&&(we.isExpected?we.message&&Ee.trace(we.message):(le=1,we.stack?Ee.error(we.stack):Ee.error(`Startup error: ${we.toString()}`))),x.kill(le)}resolveArgs(){const me=this.validatePaths((0,c.parseMainProcessArgv)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const we=(0,a.createWaitMarkerFileSync)(me.verbose);we&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",we),me.waitMarkerFilePath=we)}return me}validatePaths(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const we=this.doValidatePaths(me._,me.goto);me._=we}return me}doValidatePaths(me,we){const Ee=(0,w.cwd)(),x=me.map(Se=>{let Ie=String(Se),Te;we&&(Te=(0,m.parseLineAndColumnAware)(Ie),Ie=Te.path),Ie&&(Ie=this.preparePath(Ee,Ie));const Oe=(0,m.sanitizeFilePath)(Ie,Ee),Ne=(0,h.basename)(Oe);return Ne&&!(0,m.isValidBasename)(Ne)?null:we&&Te?(Te.path=Oe,this.toPath(Te)):Oe}),le=P.isWindows||P.isMacintosh,fe=(0,R.distinct)(x,Se=>Se&&le?Se.toLowerCase():Se||"");return(0,R.coalesce)(fe)}preparePath(me,we){return P.isWindows&&(we=(0,p.rtrim)(we,'"')),we=(0,p.trim)((0,p.trim)(we," "),"	"),P.isWindows&&(we=(0,h.resolve)(me,we),we=(0,p.rtrim)(we,".")),we}toPath(me){const we=[me.path];return typeof me.line=="number"&&we.push(String(me.line)),typeof me.column=="number"&&we.push(String(me.column)),we.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a8108049ab61b970f2ec1839dfb753054e07395e/core/vs/code/electron-main/main.js.map
