/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/base/common/types","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/errors","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/base/common/map","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(B){for(var i=[],D=0,R=B.length;D<R;D++)i[D]=Q[B[D]];return i};define(Q[49],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function D(L){return(p,l,f)=>{let I=null,P=null;if(typeof f.value=="function"?(I="value",P=f.value):typeof f.get=="function"&&(I="get",P=f.get),!P)throw new Error("not supported");f[I]=L(P,l)}}i.createDecorator=D;function R(L,p,l){let f=null,I=null;if(typeof l.value=="function"?(f="value",I=l.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(f="get",I=l.get),!I)throw new Error("not supported");const P=`$memoize$${p}`;l[f]=function(...h){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,h)}),this[P]}}i.memoize=R;function b(L,p,l){return D((f,I)=>{const P=`$debounce$${I}`,h=`$debounce$result$${I}`;return function(...S){this[h]||(this[h]=l?l():void 0),clearTimeout(this[P]),p&&(this[h]=p(this[h],...S),S=[this[h]]),this[P]=setTimeout(()=>{f.apply(this,S),this[h]=l?l():void 0},L)}})}i.debounce=b;function k(L,p,l){return D((f,I)=>{const P=`$throttle$timer$${I}`,h=`$throttle$result$${I}`,S=`$throttle$lastRun$${I}`,g=`$throttle$pending$${I}`;return function(...E){if(this[h]||(this[h]=l?l():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),p&&(this[h]=p(this[h],...E)),this[g])return;const v=this[S]+L;v<=Date.now()?(this[S]=Date.now(),f.apply(this,[this[h]]),this[h]=l?l():void 0):(this[g]=!0,this[P]=setTimeout(()=>{this[g]=!1,this[S]=Date.now(),f.apply(this,[this[h]]),this[h]=l?l():void 0},v-Date.now()))}})}i.throttle=k}),define(Q[68],Z([0,1,11]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.checkAdjacentItems=i.assertFn=i.assert=i.assertNever=i.ok=void 0;function R(l,f){if(!l)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}i.ok=R;function b(l,f="Unreachable"){throw new Error(f)}i.assertNever=b;function k(l){if(!l)throw new D.BugIndicatingError("Assertion Failed")}i.assert=k;function L(l){if(!l()){debugger;l(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}i.assertFn=L;function p(l,f){let I=0;for(;I<l.length-1;){const P=l[I],h=l[I+1];if(!f(P,h))return!1;I++}return!0}i.checkAdjacentItems=p}),define(Q[50],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var D;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(D=i.ScanError||(i.ScanError={}));var R;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(R=i.SyntaxKind||(i.SyntaxKind={}));var b;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(b=i.ParseErrorCode||(i.ParseErrorCode={}));var k;(function(e){e.DEFAULT={allowTrailingComma:!0}})(k=i.ParseOptions||(i.ParseOptions={}));function L(e,r=!1){let t=0;const n=e.length;let o="",d=0,y=16,w=0;function C(se){let fe=0,le=0;for(;fe<se;){const ie=e.charCodeAt(t);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;t++,fe++}return fe<se&&(le=-1),le}function z(se){t=se,o="",d=0,y=16,w=0}function _(){const se=t;if(e.charCodeAt(t)===48)t++;else for(t++;t<e.length&&f(e.charCodeAt(t));)t++;if(t<e.length&&e.charCodeAt(t)===46)if(t++,t<e.length&&f(e.charCodeAt(t)))for(t++;t<e.length&&f(e.charCodeAt(t));)t++;else return w=3,e.substring(se,t);let fe=t;if(t<e.length&&(e.charCodeAt(t)===69||e.charCodeAt(t)===101))if(t++,(t<e.length&&e.charCodeAt(t)===43||e.charCodeAt(t)===45)&&t++,t<e.length&&f(e.charCodeAt(t))){for(t++;t<e.length&&f(e.charCodeAt(t));)t++;fe=t}else w=3;return e.substring(se,fe)}function X(){let se="",fe=t;for(;;){if(t>=n){se+=e.substring(fe,t),w=2;break}const le=e.charCodeAt(t);if(le===34){se+=e.substring(fe,t),t++;break}if(le===92){if(se+=e.substring(fe,t),t++,t>=n){w=2;break}switch(e.charCodeAt(t++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const V=C(4);V>=0?se+=String.fromCharCode(V):w=4;break}default:w=5}fe=t;continue}if(le>=0&&le<=31)if(l(le)){se+=e.substring(fe,t),w=2;break}else w=6;t++}return se}function H(){if(o="",w=0,d=t,t>=n)return d=n,y=17;let se=e.charCodeAt(t);if(p(se)){do t++,o+=String.fromCharCode(se),se=e.charCodeAt(t);while(p(se));return y=15}if(l(se))return t++,o+=String.fromCharCode(se),se===13&&e.charCodeAt(t)===10&&(t++,o+=`
`),y=14;switch(se){case 123:return t++,y=1;case 125:return t++,y=2;case 91:return t++,y=3;case 93:return t++,y=4;case 58:return t++,y=6;case 44:return t++,y=5;case 34:return t++,o=X(),y=10;case 47:{const fe=t-1;if(e.charCodeAt(t+1)===47){for(t+=2;t<n&&!l(e.charCodeAt(t));)t++;return o=e.substring(fe,t),y=12}if(e.charCodeAt(t+1)===42){t+=2;const le=n-1;let ie=!1;for(;t<le;){if(e.charCodeAt(t)===42&&e.charCodeAt(t+1)===47){t+=2,ie=!0;break}t++}return ie||(t++,w=1),o=e.substring(fe,t),y=13}return o+=String.fromCharCode(se),t++,y=16}case 45:if(o+=String.fromCharCode(se),t++,t===n||!f(e.charCodeAt(t)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),y=11;default:for(;t<n&&ne(se);)t++,se=e.charCodeAt(t);if(d!==t){switch(o=e.substring(d,t),o){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return o+=String.fromCharCode(se),t++,y=16}}function ne(se){if(p(se)||l(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let se;do se=H();while(se>=12&&se<=15);return se}return{setPosition:z,getPosition:()=>t,scan:r?re:H,getToken:()=>y,getTokenValue:()=>o,getTokenOffset:()=>d,getTokenLength:()=>t-d,getTokenError:()=>w}}i.createScanner=L;function p(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function l(e){return e===10||e===13||e===8232||e===8233}function f(e){return e>=48&&e<=57}var I;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(I||(I={}));function P(e,r){const t=[],n=new Object;let o;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function w(C,z,_,X){d.value=C,d.offset=z,d.length=_,d.type=X,d.colonOffset=void 0,o=d}try{m(e,{onObjectBegin:(C,z)=>{if(r<=C)throw n;o=void 0,y=r>C,t.push("")},onObjectProperty:(C,z,_)=>{if(r<z||(w(C,z,_,"property"),t[t.length-1]=C,r<=z+_))throw n},onObjectEnd:(C,z)=>{if(r<=C)throw n;o=void 0,t.pop()},onArrayBegin:(C,z)=>{if(r<=C)throw n;o=void 0,t.push(0)},onArrayEnd:(C,z)=>{if(r<=C)throw n;o=void 0,t.pop()},onLiteralValue:(C,z,_)=>{if(r<z||(w(C,z,_,s(C)),r<=z+_))throw n},onSeparator:(C,z,_)=>{if(r<=z)throw n;if(C===":"&&o&&o.type==="property")o.colonOffset=z,y=!1,o=void 0;else if(C===","){const X=t[t.length-1];typeof X=="number"?t[t.length-1]=X+1:(y=!0,t[t.length-1]=""),o=void 0}}})}catch(C){if(C!==n)throw C}return{path:t,previousNode:o,isAtPropertyKey:y,matches:C=>{let z=0;for(let _=0;z<C.length&&_<t.length;_++)if(C[z]===t[_]||C[z]==="*")z++;else if(C[z]!=="**")return!1;return z===C.length}}}i.getLocation=P;function h(e,r=[],t=k.DEFAULT){let n=null,o=[];const d=[];function y(C){Array.isArray(o)?o.push(C):n!==null&&(o[n]=C)}return m(e,{onObjectBegin:()=>{const C={};y(C),d.push(o),o=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{o=d.pop()},onArrayBegin:()=>{const C=[];y(C),d.push(o),o=C,n=null},onArrayEnd:()=>{o=d.pop()},onLiteralValue:y,onError:(C,z,_)=>{r.push({error:C,offset:z,length:_})}},t),o[0]}i.parse=h;function S(e,r=[],t=k.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(C){n.type==="property"&&(n.length=C-n.offset,n=n.parent)}function d(C){return n.children.push(C),C}m(e,{onObjectBegin:C=>{n=d({type:"object",offset:C,length:-1,parent:n,children:[]})},onObjectProperty:(C,z,_)=>{n=d({type:"property",offset:z,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:C,offset:z,length:_,parent:n})},onObjectEnd:(C,z)=>{n.length=C+z-n.offset,n=n.parent,o(C+z)},onArrayBegin:(C,z)=>{n=d({type:"array",offset:C,length:-1,parent:n,children:[]})},onArrayEnd:(C,z)=>{n.length=C+z-n.offset,n=n.parent,o(C+z)},onLiteralValue:(C,z,_)=>{d({type:s(C),offset:z,length:_,parent:n,value:C}),o(z+_)},onSeparator:(C,z,_)=>{n.type==="property"&&(C===":"?n.colonOffset=z:C===","&&o(z))},onError:(C,z,_)=>{r.push({error:C,offset:z,length:_})}},t);const w=n.children[0];return w&&delete w.parent,w}i.parseTree=S;function g(e,r){if(!e)return;let t=e;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const d of t.children)if(Array.isArray(d.children)&&d.children[0].value===n){t=d.children[1],o=!0;break}if(!o)return}else{const o=n;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}i.findNodeAtLocation=g;function E(e){if(!e.parent||!e.parent.children)return[];const r=E(e.parent);if(e.parent.type==="property"){const t=e.parent.children[0].value;r.push(t)}else if(e.parent.type==="array"){const t=e.parent.children.indexOf(e);t!==-1&&r.push(t)}return r}i.getNodePath=E;function v(e){switch(e.type){case"array":return e.children.map(v);case"object":{const r=Object.create(null);for(const t of e.children){const n=t.children[1];n&&(r[t.children[0].value]=v(n))}return r}case"null":case"string":case"number":case"boolean":return e.value;default:return}}i.getNodeValue=v;function a(e,r,t=!1){return r>=e.offset&&r<e.offset+e.length||t&&r===e.offset+e.length}i.contains=a;function u(e,r,t=!1){if(a(e,r,t)){const n=e.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const d=u(n[o],r,t);if(d)return d}return e}}i.findNodeAtOffset=u;function m(e,r,t=k.DEFAULT){const n=L(e,!1);function o(A){return A?()=>A(n.getTokenOffset(),n.getTokenLength()):()=>!0}function d(A){return A?U=>A(U,n.getTokenOffset(),n.getTokenLength()):()=>!0}const y=o(r.onObjectBegin),w=d(r.onObjectProperty),C=o(r.onObjectEnd),z=o(r.onArrayBegin),_=o(r.onArrayEnd),X=d(r.onLiteralValue),H=d(r.onSeparator),ne=o(r.onComment),re=d(r.onError),se=t&&t.disallowComments,fe=t&&t.allowTrailingComma;function le(){for(;;){const A=n.scan();switch(n.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:se||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(A){case 12:case 13:se?ie(10):ne();break;case 16:ie(1);break;case 15:case 14:break;default:return A}}}function ie(A,U=[],T=[]){if(re(A),U.length+T.length>0){let O=n.getToken();for(;O!==17;){if(U.indexOf(O)!==-1){le();break}else if(T.indexOf(O)!==-1)break;O=le()}}}function V(A){const U=n.getTokenValue();return A?X(U):w(U),le(),!0}function N(){switch(n.getToken()){case 11:{let A=0;try{A=JSON.parse(n.getTokenValue()),typeof A!="number"&&(ie(2),A=0)}catch{ie(2)}X(A);break}case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return le(),!0}function F(){return n.getToken()!==10?(ie(3,[],[2,5]),!1):(V(!1),n.getToken()===6?(H(":"),le(),Y()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function j(){y(),le();let A=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(A||ie(4,[],[]),H(","),le(),n.getToken()===2&&fe)break}else A&&ie(6,[],[]);F()||ie(4,[],[2,5]),A=!0}return C(),n.getToken()!==2?ie(7,[2],[]):le(),!0}function $(){z(),le();let A=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(A||ie(4,[],[]),H(","),le(),n.getToken()===4&&fe)break}else A&&ie(6,[],[]);Y()||ie(4,[],[4,5]),A=!0}return _(),n.getToken()!==4?ie(8,[4],[]):le(),!0}function Y(){switch(n.getToken()){case 3:return $();case 1:return j();case 10:return V(!0);default:return N()}}return le(),n.getToken()===17?t.allowEmptyContent?!0:(ie(4,[],[]),!1):Y()?(n.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}i.visit=m;function c(e,r){const t=L(e),n=[];let o,d=0,y;do switch(y=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:d!==y&&n.push(e.substring(d,y)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),d=t.getPosition();break}while(o!==17);return n.join("")}i.stripComments=c;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=s}),function(){function B(b){const k=[];typeof b=="number"&&k.push("code/timeOrigin",b);function L(l){k.push(l,Date.now())}function p(){const l=[];for(let f=0;f<k.length;f+=2)l.push({name:k[f],startTime:k[f+1]});return l}return{mark:L,getMarks:p}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?B():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const L of performance.getEntriesByType("mark"))k.push({name:L.name,startTime:Math.round(b+L.startTime)});return k}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return B(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),B()}function D(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=i()),b.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=D(R))}(),function(B,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var D=i();for(var R in D)(typeof exports=="object"?exports:B)[R]=D[R]}}(typeof self<"u"?self:this,function(){return function(B){var i={};function D(R){if(i[R])return i[R].exports;var b=i[R]={i:R,l:!1,exports:{}};return B[R].call(b.exports,b,b.exports,D),b.l=!0,b.exports}return D.m=B,D.c=i,D.d=function(R,b,k){D.o(R,b)||Object.defineProperty(R,b,{enumerable:!0,get:k})},D.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},D.t=function(R,b){if(1&b&&(R=D(R)),8&b||4&b&&typeof R=="object"&&R&&R.__esModule)return R;var k=Object.create(null);if(D.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:R}),2&b&&typeof R!="string")for(var L in R)D.d(k,L,function(p){return R[p]}.bind(null,L));return k},D.n=function(R){var b=R&&R.__esModule?function(){return R.default}:function(){return R};return D.d(b,"a",b),b},D.o=function(R,b){return Object.prototype.hasOwnProperty.call(R,b)},D.p="",D(D.s=0)}([function(B,i,D){(function(R){var b;i=B.exports=T,b=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var k=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,p=i.re=[],l=i.src=[],f=0,I=f++;l[I]="0|[1-9]\\d*";var P=f++;l[P]="[0-9]+";var h=f++;l[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=f++;l[S]="("+l[I]+")\\.("+l[I]+")\\.("+l[I]+")";var g=f++;l[g]="("+l[P]+")\\.("+l[P]+")\\.("+l[P]+")";var E=f++;l[E]="(?:"+l[I]+"|"+l[h]+")";var v=f++;l[v]="(?:"+l[P]+"|"+l[h]+")";var a=f++;l[a]="(?:-("+l[E]+"(?:\\."+l[E]+")*))";var u=f++;l[u]="(?:-?("+l[v]+"(?:\\."+l[v]+")*))";var m=f++;l[m]="[0-9A-Za-z-]+";var c=f++;l[c]="(?:\\+("+l[m]+"(?:\\."+l[m]+")*))";var s=f++,e="v?"+l[S]+l[a]+"?"+l[c]+"?";l[s]="^"+e+"$";var r="[v=\\s]*"+l[g]+l[u]+"?"+l[c]+"?",t=f++;l[t]="^"+r+"$";var n=f++;l[n]="((?:<|>)?=?)";var o=f++;l[o]=l[P]+"|x|X|\\*";var d=f++;l[d]=l[I]+"|x|X|\\*";var y=f++;l[y]="[v=\\s]*("+l[d]+")(?:\\.("+l[d]+")(?:\\.("+l[d]+")(?:"+l[a]+")?"+l[c]+"?)?)?";var w=f++;l[w]="[v=\\s]*("+l[o]+")(?:\\.("+l[o]+")(?:\\.("+l[o]+")(?:"+l[u]+")?"+l[c]+"?)?)?";var C=f++;l[C]="^"+l[n]+"\\s*"+l[y]+"$";var z=f++;l[z]="^"+l[n]+"\\s*"+l[w]+"$";var _=f++;l[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var X=f++;l[X]="(?:~>?)";var H=f++;l[H]="(\\s*)"+l[X]+"\\s+",p[H]=new RegExp(l[H],"g");var ne=f++;l[ne]="^"+l[X]+l[y]+"$";var re=f++;l[re]="^"+l[X]+l[w]+"$";var se=f++;l[se]="(?:\\^)";var fe=f++;l[fe]="(\\s*)"+l[se]+"\\s+",p[fe]=new RegExp(l[fe],"g");var le=f++;l[le]="^"+l[se]+l[y]+"$";var ie=f++;l[ie]="^"+l[se]+l[w]+"$";var V=f++;l[V]="^"+l[n]+"\\s*("+r+")$|^$";var N=f++;l[N]="^"+l[n]+"\\s*("+e+")$|^$";var F=f++;l[F]="(\\s*)"+l[n]+"\\s*("+r+"|"+l[y]+")",p[F]=new RegExp(l[F],"g");var j=f++;l[j]="^\\s*("+l[y]+")\\s+-\\s+("+l[y]+")\\s*$";var $=f++;l[$]="^\\s*("+l[w]+")\\s+-\\s+("+l[w]+")\\s*$";var Y=f++;l[Y]="(<|>)?=?\\s*\\*";for(var A=0;A<35;A++)b(A,l[A]),p[A]||(p[A]=new RegExp(l[A]));function U(x,G){if(x instanceof T)return x;if(typeof x!="string"||x.length>k||!(G?p[t]:p[s]).test(x))return null;try{return new T(x,G)}catch{return null}}function T(x,G){if(x instanceof T){if(x.loose===G)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof T))return new T(x,G);b("SemVer",x,G),this.loose=G;var J=x.trim().match(G?p[t]:p[s]);if(!J)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var me=+ue;if(me>=0&&me<L)return me}return ue}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}i.parse=U,i.valid=function(x,G){var J=U(x,G);return J?J.version:null},i.clean=function(x,G){var J=U(x.trim().replace(/^[=v]+/,""),G);return J?J.version:null},i.SemVer=T,T.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},T.prototype.toString=function(){return this.version},T.prototype.compare=function(x){return b("SemVer.compare",this.version,this.loose,x),x instanceof T||(x=new T(x,this.loose)),this.compareMain(x)||this.comparePre(x)},T.prototype.compareMain=function(x){return x instanceof T||(x=new T(x,this.loose)),M(this.major,x.major)||M(this.minor,x.minor)||M(this.patch,x.patch)},T.prototype.comparePre=function(x){if(x instanceof T||(x=new T(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var G=0;do{var J=this.prerelease[G],ue=x.prerelease[G];if(b("prerelease compare",G,J,ue),J===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if(J===void 0)return-1;if(J!==ue)return M(J,ue)}while(++G)},T.prototype.inc=function(x,G){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},i.inc=function(x,G,J,ue){typeof J=="string"&&(ue=J,J=void 0);try{return new T(x,J).inc(G,ue).version}catch{return null}},i.diff=function(x,G){if(ae(x,G))return null;var J=U(x),ue=U(G);if(J.prerelease.length||ue.prerelease.length){for(var me in J)if((me==="major"||me==="minor"||me==="patch")&&J[me]!==ue[me])return"pre"+me;return"prerelease"}for(var me in J)if((me==="major"||me==="minor"||me==="patch")&&J[me]!==ue[me])return me},i.compareIdentifiers=M;var O=/^[0-9]+$/;function M(x,G){var J=O.test(x),ue=O.test(G);return J&&ue&&(x=+x,G=+G),J&&!ue?-1:ue&&!J?1:x<G?-1:x>G?1:0}function W(x,G,J){return new T(x,J).compare(new T(G,J))}function q(x,G,J){return W(x,G,J)>0}function K(x,G,J){return W(x,G,J)<0}function ae(x,G,J){return W(x,G,J)===0}function ce(x,G,J){return W(x,G,J)!==0}function pe(x,G,J){return W(x,G,J)>=0}function Se(x,G,J){return W(x,G,J)<=0}function te(x,G,J,ue){var me;switch(G){case"===":typeof x=="object"&&(x=x.version),typeof J=="object"&&(J=J.version),me=x===J;break;case"!==":typeof x=="object"&&(x=x.version),typeof J=="object"&&(J=J.version),me=x!==J;break;case"":case"=":case"==":me=ae(x,J,ue);break;case"!=":me=ce(x,J,ue);break;case">":me=q(x,J,ue);break;case">=":me=pe(x,J,ue);break;case"<":me=K(x,J,ue);break;case"<=":me=Se(x,J,ue);break;default:throw new TypeError("Invalid operator: "+G)}return me}function oe(x,G){if(x instanceof oe){if(x.loose===G)return x;x=x.value}if(!(this instanceof oe))return new oe(x,G);b("comparator",x,G),this.loose=G,this.parse(x),this.semver===de?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}i.rcompareIdentifiers=function(x,G){return M(G,x)},i.major=function(x,G){return new T(x,G).major},i.minor=function(x,G){return new T(x,G).minor},i.patch=function(x,G){return new T(x,G).patch},i.compare=W,i.compareLoose=function(x,G){return W(x,G,!0)},i.rcompare=function(x,G,J){return W(G,x,J)},i.sort=function(x,G){return x.sort(function(J,ue){return i.compare(J,ue,G)})},i.rsort=function(x,G){return x.sort(function(J,ue){return i.rcompare(J,ue,G)})},i.gt=q,i.lt=K,i.eq=ae,i.neq=ce,i.gte=pe,i.lte=Se,i.cmp=te,i.Comparator=oe;var de={};function he(x,G){if(x instanceof he)return x.loose===G?x:new he(x.raw,G);if(x instanceof oe)return new he(x.value,G);if(!(this instanceof he))return new he(x,G);if(this.loose=G,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function ve(x){return!x||x.toLowerCase()==="x"||x==="*"}function ke(x,G,J,ue,me,De,we,Le,be,Ce,Me,Re,Te){return((G=ve(J)?"":ve(ue)?">="+J+".0.0":ve(me)?">="+J+"."+ue+".0":">="+G)+" "+(Le=ve(be)?"":ve(Ce)?"<"+(+be+1)+".0.0":ve(Me)?"<"+be+"."+(+Ce+1)+".0":Re?"<="+be+"."+Ce+"."+Me+"-"+Re:"<="+Le)).trim()}function Fe(x,G){for(var J=0;J<x.length;J++)if(!x[J].test(G))return!1;if(G.prerelease.length){for(J=0;J<x.length;J++)if(b(x[J].semver),x[J].semver!==de&&x[J].semver.prerelease.length>0){var ue=x[J].semver;if(ue.major===G.major&&ue.minor===G.minor&&ue.patch===G.patch)return!0}return!1}return!0}function Ue(x,G,J){try{G=new he(G,J)}catch{return!1}return G.test(x)}function xe(x,G,J,ue){var me,De,we,Le,be;switch(x=new T(x,ue),G=new he(G,ue),J){case">":me=q,De=Se,we=K,Le=">",be=">=";break;case"<":me=K,De=pe,we=q,Le="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(x,G,ue))return!1;for(var Ce=0;Ce<G.set.length;++Ce){var Me=G.set[Ce],Re=null,Te=null;if(Me.forEach(function(Ae){Ae.semver===de&&(Ae=new oe(">=0.0.0")),Re=Re||Ae,Te=Te||Ae,me(Ae.semver,Re.semver,ue)?Re=Ae:we(Ae.semver,Te.semver,ue)&&(Te=Ae)}),Re.operator===Le||Re.operator===be||(!Te.operator||Te.operator===Le)&&De(x,Te.semver)||Te.operator===be&&we(x,Te.semver))return!1}return!0}oe.prototype.parse=function(x){var G=this.loose?p[V]:p[N],J=x.match(G);if(!J)throw new TypeError("Invalid comparator: "+x);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new T(J[2],this.loose):this.semver=de},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(x){return b("Comparator.test",x,this.loose),this.semver===de||(typeof x=="string"&&(x=new T(x,this.loose)),te(x,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(x,G){if(!(x instanceof oe))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new he(x.value,G),Ue(this.value,J,G);if(x.operator==="")return J=new he(this.value,G),Ue(x.semver,J,G);var ue=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),De=this.semver.version===x.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Le=te(this.semver,"<",x.semver,G)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),be=te(this.semver,">",x.semver,G)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ue||me||De&&we||Le||be},i.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(x){var G=this.loose;x=x.trim(),b("range",x,G);var J=G?p[$]:p[j];x=x.replace(J,ke),b("hyphen replace",x),x=x.replace(p[F],"$1$2$3"),b("comparator trim",x,p[F]),x=(x=(x=x.replace(p[H],"$1~")).replace(p[fe],"$1^")).split(/\s+/).join(" ");var ue=G?p[V]:p[N],me=x.split(" ").map(function(De){return function(we,Le){return b("comp",we),we=function(be,Ce){return be.trim().split(/\s+/).map(function(Me){return function(Re,Te){b("caret",Re,Te);var Ae=Te?p[ie]:p[le];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var Oe;return b("caret",Re,Ne,ye,Ee,Pe,Ie),ve(ye)?Oe="":ve(Ee)?Oe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ve(Pe)?Oe=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":Ie?(b("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Oe=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+Ie+" <"+(+ye+1)+".0.0"):(b("no pr"),Oe=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+" <"+(+ye+1)+".0.0"),b("caret return",Oe),Oe})}(Me,Ce)}).join(" ")}(we,Le),b("caret",we),we=function(be,Ce){return be.trim().split(/\s+/).map(function(Me){return function(Re,Te){var Ae=Te?p[re]:p[ne];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var Oe;return b("tilde",Re,Ne,ye,Ee,Pe,Ie),ve(ye)?Oe="":ve(Ee)?Oe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ve(Pe)?Oe=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":Ie?(b("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Oe=">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0"):Oe=">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0",b("tilde return",Oe),Oe})}(Me,Ce)}).join(" ")}(we,Le),b("tildes",we),we=function(be,Ce){return b("replaceXRanges",be,Ce),be.split(/\s+/).map(function(Me){return function(Re,Te){Re=Re.trim();var Ae=Te?p[z]:p[C];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie,Oe){b("xRange",Re,Ne,ye,Ee,Pe,Ie,Oe);var Ve=ve(Ee),ze=Ve||ve(Pe),je=ze||ve(Ie);return ye==="="&&je&&(ye=""),Ve?Ne=ye===">"||ye==="<"?"<0.0.0":"*":ye&&je?(ze&&(Pe=0),je&&(Ie=0),ye===">"?(ye=">=",ze?(Ee=+Ee+1,Pe=0,Ie=0):je&&(Pe=+Pe+1,Ie=0)):ye==="<="&&(ye="<",ze?Ee=+Ee+1:Pe=+Pe+1),Ne=ye+Ee+"."+Pe+"."+Ie):ze?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":je&&(Ne=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),b("xRange return",Ne),Ne})}(Me,Ce)}).join(" ")}(we,Le),b("xrange",we),we=function(be,Ce){return b("replaceStars",be,Ce),be.trim().replace(p[Y],"")}(we,Le),b("stars",we),we}(De,G)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(De){return!!De.match(ue)})),me=me.map(function(De){return new oe(De,G)})},he.prototype.intersects=function(x,G){if(!(x instanceof he))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(ue){return x.set.some(function(me){return me.every(function(De){return ue.intersects(De,G)})})})})},i.toComparators=function(x,G){return new he(x,G).set.map(function(J){return J.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},he.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new T(x,this.loose));for(var G=0;G<this.set.length;G++)if(Fe(this.set[G],x))return!0;return!1},i.satisfies=Ue,i.maxSatisfying=function(x,G,J){var ue=null,me=null;try{var De=new he(G,J)}catch{return null}return x.forEach(function(we){De.test(we)&&(ue&&me.compare(we)!==-1||(me=new T(ue=we,J)))}),ue},i.minSatisfying=function(x,G,J){var ue=null,me=null;try{var De=new he(G,J)}catch{return null}return x.forEach(function(we){De.test(we)&&(ue&&me.compare(we)!==1||(me=new T(ue=we,J)))}),ue},i.validRange=function(x,G){try{return new he(x,G).range||"*"}catch{return null}},i.ltr=function(x,G,J){return xe(x,G,"<",J)},i.gtr=function(x,G,J){return xe(x,G,">",J)},i.outside=xe,i.prerelease=function(x,G){var J=U(x,G);return J&&J.prerelease.length?J.prerelease:null},i.intersects=function(x,G,J){return x=new he(x,J),G=new he(G,J),x.intersects(G)},i.coerce=function(x){if(x instanceof T)return x;if(typeof x!="string")return null;var G=x.match(p[_]);return G==null?null:U((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,D(1))},function(B,i){var D,R,b=B.exports={};function k(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function p(v){if(D===setTimeout)return setTimeout(v,0);if((D===k||!D)&&setTimeout)return D=setTimeout,setTimeout(v,0);try{return D(v,0)}catch{try{return D.call(null,v,0)}catch{return D.call(this,v,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:k}catch{D=k}try{R=typeof clearTimeout=="function"?clearTimeout:L}catch{R=L}})();var l,f=[],I=!1,P=-1;function h(){I&&l&&(I=!1,l.length?f=l.concat(f):P=-1,f.length&&S())}function S(){if(!I){var v=p(h);I=!0;for(var a=f.length;a;){for(l=f,f=[];++P<a;)l&&l[P].run();P=-1,a=f.length}l=null,I=!1,function(u){if(R===clearTimeout)return clearTimeout(u);if((R===L||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(u);try{R(u)}catch{try{return R.call(null,u)}catch{return R.call(this,u)}}}(v)}}function g(v,a){this.fun=v,this.array=a}function E(){}b.nextTick=function(v){var a=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)a[u-1]=arguments[u];f.push(new g(v,a)),f.length!==1||I||p(S)},g.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=E,b.addListener=E,b.once=E,b.off=E,b.removeListener=E,b.removeAllListeners=E,b.emit=E,b.prependListener=E,b.prependOnceListener=E,b.listeners=function(v){return[]},b.binding=function(v){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(v){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Q[69],Z([0,1]),function(B,i){"use strict";var D;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class R{constructor(p,l,f){this.level=p,this.key=l,this.value=f,this.forward=[]}}const b=void 0;class k{constructor(p,l=2**16){this.comparator=p,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new R(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new R(this._maxLevel,b,b)}has(p){return Boolean(k._search(this,p,this.comparator))}get(p){return k._search(this,p,this.comparator)?.value}set(p,l){return k._insert(this,p,l,this.comparator)&&(this._size+=1),this}delete(p){const l=k._delete(this,p,this.comparator);return l&&(this._size-=1),l}forEach(p,l){let f=this._header.forward[0];for(;f;)p.call(l,f.value,f.key,this),f=f.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let p=this._header.forward[0];for(;p;)yield[p.key,p.value],p=p.forward[0]}*keys(){let p=this._header.forward[0];for(;p;)yield p.key,p=p.forward[0]}*values(){let p=this._header.forward[0];for(;p;)yield p.value,p=p.forward[0]}toString(){let p="[SkipList]:",l=this._header.forward[0];for(;l;)p+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return p}static _search(p,l,f){let I=p._header;for(let P=p._level-1;P>=0;P--)for(;I.forward[P]&&f(I.forward[P].key,l)<0;)I=I.forward[P];if(I=I.forward[0],I&&f(I.key,l)===0)return I}static _insert(p,l,f,I){const P=[];let h=p._header;for(let S=p._level-1;S>=0;S--){for(;h.forward[S]&&I(h.forward[S].key,l)<0;)h=h.forward[S];P[S]=h}if(h=h.forward[0],h&&I(h.key,l)===0)return h.value=f,!1;{const S=k._randomLevel(p);if(S>p._level){for(let g=p._level;g<S;g++)P[g]=p._header;p._level=S}h=new R(S,l,f);for(let g=0;g<S;g++)h.forward[g]=P[g].forward[g],P[g].forward[g]=h;return!0}}static _randomLevel(p,l=.5){let f=1;for(;Math.random()<l&&f<p._maxLevel;)f+=1;return f}static _delete(p,l,f){const I=[];let P=p._header;for(let h=p._level-1;h>=0;h--){for(;P.forward[h]&&f(P.forward[h].key,l)<0;)P=P.forward[h];I[h]=P}if(P=P.forward[0],!P||f(P.key,l)!==0)return!1;for(let h=0;h<p._level&&I[h].forward[h]===P;h++)I[h].forward[h]=P.forward[h];for(;p._level>0&&p._header.forward[p._level-1]===b;)p._level-=1;return!0}}i.SkipList=k}),define(Q[43],Z([0,1,11,2]),function(B,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=i.isReadable=void 0;function b(c){const s=c;return s?typeof s.read=="function":!1}i.isReadable=b;function k(c){const s=c;return s?[s.on,s.pause,s.resume,s.destroy].every(e=>typeof e=="function"):!1}i.isReadableStream=k;function L(c){const s=c;return s?k(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}i.isReadableBufferedStream=L;function p(c,s){return new l(c,s)}i.newWriteableStream=p;class l{constructor(s,e){this.reducer=s,this.options=e,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s<"u"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(e=>e(s))}emitError(s){this.listeners.error.length===0?(0,D.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(e=>e(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,e){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(e),this.resume();break;case"end":this.listeners.end.push(e),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(e),this.state.flowing&&this.flowErrors();break}}removeListener(s,e){if(this.state.destroyed)return;let r;switch(s){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const t=r.indexOf(e);t>=0&&r.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const e=[...this.pendingWritePromises];this.pendingWritePromises.length=0,e.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(c,s){const e=[];let r;for(;(r=c.read())!==null;)e.push(r);return s(e)}i.consumeReadable=f;function I(c,s,e){const r=[];let t;for(;(t=c.read())!==null&&r.length<e;)r.push(t);return t===null&&r.length>0?s(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return c.read()}}}i.peekReadable=I;function P(c,s){return new Promise((e,r)=>{const t=[];h(c,{onData:n=>{s&&t.push(n)},onError:n=>{s?r(n):e(void 0)},onEnd:()=>{e(s?s(t):void 0)}})})}i.consumeStream=P;function h(c,s){let e=!1;return c.on("error",r=>{e||s.onError(r)}),c.on("end",()=>{e||s.onEnd()}),c.on("data",r=>{e||s.onData(r)}),(0,R.toDisposable)(()=>e=!0)}i.listenStream=h;function S(c,s){return new Promise((e,r)=>{const t=new R.DisposableStore,n=[],o=w=>{if(n.push(w),n.length>s)return t.dispose(),c.pause(),e({stream:c,buffer:n,ended:!1})},d=w=>r(w),y=()=>e({stream:c,buffer:n,ended:!0});t.add((0,R.toDisposable)(()=>c.removeListener("error",d))),c.on("error",d),t.add((0,R.toDisposable)(()=>c.removeListener("end",y))),c.on("end",y),t.add((0,R.toDisposable)(()=>c.removeListener("data",o))),c.on("data",o)})}i.peekStream=S;function g(c,s){const e=p(s);return e.end(c),e}i.toStream=g;function E(){const c=p(()=>{throw new Error("not supported")});return c.end(),c}i.emptyStream=E;function v(c){let s=!1;return{read:()=>s?null:(s=!0,c)}}i.toReadable=v;function a(c,s,e){const r=p(e);return h(c,{onData:t=>r.write(s.data(t)),onError:t=>r.error(s.error?s.error(t):t),onEnd:()=>r.end()}),r}i.transform=a;function u(c,s,e){let r=!1;return{read:()=>{const t=s.read();return r?t:(r=!0,t!==null?e([c,t]):c)}}}i.prefixedReadable=u;function m(c,s,e){let r=!1;const t=p(e);return h(s,{onData:n=>r?t.write(n):(r=!0,t.write(e([c,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(c)),t.end()}}),t}i.prefixedStream=m}),define(Q[15],Z([0,1,43]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.encodeBase64=i.decodeBase64=i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const R=typeof Buffer<"u";let b,k;class L{static alloc(w){return R?new L(Buffer.allocUnsafe(w)):new L(new Uint8Array(w))}static wrap(w){return R&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new L(w)}static fromString(w,C){return!(C?.dontUseNodeBuffer||!1)&&R?new L(Buffer.from(w)):(b||(b=new TextEncoder),new L(b.encode(w)))}static fromByteArray(w){const C=L.alloc(w.length);for(let z=0,_=w.length;z<_;z++)C.buffer[z]=w[z];return C}static concat(w,C){if(typeof C>"u"){C=0;for(let X=0,H=w.length;X<H;X++)C+=w[X].byteLength}const z=L.alloc(C);let _=0;for(let X=0,H=w.length;X<H;X++){const ne=w[X];z.set(ne,_),_+=ne.byteLength}return z}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=L.alloc(this.byteLength);return w.set(this),w}toString(){return R?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(w,C){return new L(this.buffer.subarray(w,C))}set(w,C){if(w instanceof L)this.buffer.set(w.buffer,C);else if(w instanceof Uint8Array)this.buffer.set(w,C);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),C);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return f(this.buffer,w)}writeUInt32BE(w,C){I(this.buffer,w,C)}readUInt32LE(w){return P(this.buffer,w)}writeUInt32LE(w,C){h(this.buffer,w,C)}readUInt8(w){return S(this.buffer,w)}writeUInt8(w,C){g(this.buffer,w,C)}}i.VSBuffer=L;function p(y,w){return y[w+0]<<0>>>0|y[w+1]<<8>>>0}i.readUInt16LE=p;function l(y,w,C){y[C+0]=w&255,w=w>>>8,y[C+1]=w&255}i.writeUInt16LE=l;function f(y,w){return y[w]*2**24+y[w+1]*2**16+y[w+2]*2**8+y[w+3]}i.readUInt32BE=f;function I(y,w,C){y[C+3]=w,w=w>>>8,y[C+2]=w,w=w>>>8,y[C+1]=w,w=w>>>8,y[C]=w}i.writeUInt32BE=I;function P(y,w){return y[w+0]<<0>>>0|y[w+1]<<8>>>0|y[w+2]<<16>>>0|y[w+3]<<24>>>0}i.readUInt32LE=P;function h(y,w,C){y[C+0]=w&255,w=w>>>8,y[C+1]=w&255,w=w>>>8,y[C+2]=w&255,w=w>>>8,y[C+3]=w&255}i.writeUInt32LE=h;function S(y,w){return y[w]}i.readUInt8=S;function g(y,w,C){y[C]=w}i.writeUInt8=g;function E(y){return D.consumeReadable(y,w=>L.concat(w))}i.readableToBuffer=E;function v(y){return D.toReadable(y)}i.bufferToReadable=v;function a(y){return D.consumeStream(y,w=>L.concat(w))}i.streamToBuffer=a;async function u(y){return y.ended?L.concat(y.buffer):L.concat([...y.buffer,await a(y.stream)])}i.bufferedStreamToBuffer=u;function m(y){return D.toStream(y,w=>L.concat(w))}i.bufferToStream=m;function c(y){return D.transform(y,{data:w=>typeof w=="string"?L.fromString(w):L.wrap(w)},w=>L.concat(w))}i.streamToBufferReadableStream=c;function s(y){return D.newWriteableStream(w=>L.concat(w),y)}i.newWriteableBufferStream=s;function e(y,w){return D.prefixedReadable(y,w,C=>L.concat(C))}i.prefixedBufferReadable=e;function r(y,w){return D.prefixedStream(y,w,C=>L.concat(C))}i.prefixedBufferStream=r;function t(y){let w=0,C=0,z=0;const _=new Uint8Array(Math.floor(y.length/4*3)),X=ne=>{switch(C){case 3:_[z++]=w|ne,C=0;break;case 2:_[z++]=w|ne>>>2,w=ne<<6,C=3;break;case 1:_[z++]=w|ne>>>4,w=ne<<4,C=2;break;default:w=ne<<2,C=1}};for(let ne=0;ne<y.length;ne++){const re=y.charCodeAt(ne);if(re>=65&&re<=90)X(re-65);else if(re>=97&&re<=122)X(re-97+26);else if(re>=48&&re<=57)X(re-48+52);else if(re===43||re===45)X(62);else if(re===47||re===95)X(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${y[ne]}`)}}const H=z;for(;C>0;)X(0);return L.wrap(_).slice(0,H)}i.decodeBase64=t;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:y},w=!0,C=!1){const z=C?o:n;let _="";const X=y.byteLength%3;let H=0;for(;H<y.byteLength-X;H+=3){const ne=y[H+0],re=y[H+1],se=y[H+2];_+=z[ne>>>2],_+=z[(ne<<4|re>>>4)&63],_+=z[(re<<2|se>>>6)&63],_+=z[se&63]}if(X===1){const ne=y[H+0];_+=z[ne>>>2],_+=z[ne<<4&63],w&&(_+="==")}else if(X===2){const ne=y[H+0],re=y[H+1];_+=z[ne>>>2],_+=z[(ne<<4|re>>>4)&63],_+=z[re<<2&63],w&&(_+="=")}return _}i.encodeBase64=d}),define(Q[26],Z([0,1,5]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createProxyObject=i.getAllMethodNames=i.getAllPropertyNames=i.filter=i.getCaseInsensitive=i.distinct=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function R(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const u=Array.isArray(a)?[]:{};return Object.keys(a).forEach(m=>{a[m]&&typeof a[m]=="object"?u[m]=R(a[m]):u[m]=a[m]}),u}i.deepClone=R;function b(a){if(!a||typeof a!="object")return a;const u=[a];for(;u.length>0;){const m=u.shift();Object.freeze(m);for(const c in m)if(k.call(m,c)){const s=m[c];typeof s=="object"&&!Object.isFrozen(s)&&!(0,D.isTypedArray)(s)&&u.push(s)}}return a}i.deepFreeze=b;const k=Object.prototype.hasOwnProperty;function L(a,u){return p(a,u,new Set)}i.cloneAndChange=L;function p(a,u,m){if((0,D.isUndefinedOrNull)(a))return a;const c=u(a);if(typeof c<"u")return c;if(Array.isArray(a)){const s=[];for(const e of a)s.push(p(e,u,m));return s}if((0,D.isObject)(a)){if(m.has(a))throw new Error("Cannot clone recursive data-structure");m.add(a);const s={};for(const e in a)k.call(a,e)&&(s[e]=p(a[e],u,m));return m.delete(a),s}return a}function l(a,u,m=!0){return(0,D.isObject)(a)?((0,D.isObject)(u)&&Object.keys(u).forEach(c=>{c in a?m&&((0,D.isObject)(a[c])&&(0,D.isObject)(u[c])?l(a[c],u[c],m):a[c]=u[c]):a[c]=u[c]}),a):u}i.mixin=l;function f(a,u){if(a===u)return!0;if(a==null||u===null||u===void 0||typeof a!=typeof u||typeof a!="object"||Array.isArray(a)!==Array.isArray(u))return!1;let m,c;if(Array.isArray(a)){if(a.length!==u.length)return!1;for(m=0;m<a.length;m++)if(!f(a[m],u[m]))return!1}else{const s=[];for(c in a)s.push(c);s.sort();const e=[];for(c in u)e.push(c);if(e.sort(),!f(s,e))return!1;for(m=0;m<s.length;m++)if(!f(a[s[m]],u[s[m]]))return!1}return!0}i.equals=f;function I(a){const u=new Set;return JSON.stringify(a,(m,c)=>{if((0,D.isObject)(c)||Array.isArray(c)){if(u.has(c))return"[Circular]";u.add(c)}return c})}i.safeStringify=I;function P(a,u){const m=Object.create(null);return!a||!u||Object.keys(u).forEach(s=>{const e=a[s],r=u[s];f(e,r)||(m[s]=r)}),m}i.distinct=P;function h(a,u){const m=u.toLowerCase(),c=Object.keys(a).find(s=>s.toLowerCase()===m);return c?a[c]:a[u]}i.getCaseInsensitive=h;function S(a,u){const m=Object.create(null);for(const[c,s]of Object.entries(a))u(c,s)&&(m[c]=s);return m}i.filter=S;function g(a){let u=[],m=Object.getPrototypeOf(a);for(;Object.prototype!==m;)u=u.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return u}i.getAllPropertyNames=g;function E(a){const u=[];for(const m of g(a))typeof a[m]=="function"&&u.push(m);return u}i.getAllMethodNames=E;function v(a,u){const m=s=>function(){const e=Array.prototype.slice.call(arguments,0);return u(s,e)},c={};for(const s of a)c[s]=m(s);return c}i.createProxyObject=v}),define(Q[30],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(b){return D.test(b)}i.isUUID=R,i.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(p){for(let l=0;l<p.length;l++)p[l]=Math.floor(Math.random()*256);return p};const k=new Uint8Array(16),L=[];for(let p=0;p<256;p++)L.push(p.toString(16).padStart(2,"0"));return function(){b(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let l=0,f="";return f+=L[k[l++]],f+=L[k[l++]],f+=L[k[l++]],f+=L[k[l++]],f+="-",f+=L[k[l++]],f+=L[k[l++]],f+="-",f+=L[k[l++]],f+=L[k[l++]],f+="-",f+=L[k[l++]],f+=L[k[l++]],f+="-",f+=L[k[l++]],f+=L[k[l++]],f+=L[k[l++]],f+=L[k[l++]],f+=L[k[l++]],f+=L[k[l++]],f}}()}),define(Q[70],Z([6,7]),function(B,i){return B.create("vs/base/common/date",i)}),define(Q[71],Z([0,1,70]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const R=60,b=R*60,k=b*24,L=k*7,p=k*30,l=k*365;function f(P,h,S){typeof P!="number"&&(P=P.getTime());const g=Math.round((new Date().getTime()-P)/1e3);if(g<-30)return(0,D.localize)(0,null,f(new Date().getTime()+g*1e3,!1));if(g<30)return(0,D.localize)(1,null);let E;return g<R?(E=g,h?E===1?S?(0,D.localize)(2,null,E):(0,D.localize)(3,null,E):S?(0,D.localize)(4,null,E):(0,D.localize)(5,null,E):E===1?S?(0,D.localize)(6,null,E):(0,D.localize)(7,null,E):S?(0,D.localize)(8,null,E):(0,D.localize)(9,null,E)):g<b?(E=Math.floor(g/R),h?E===1?S?(0,D.localize)(10,null,E):(0,D.localize)(11,null,E):S?(0,D.localize)(12,null,E):(0,D.localize)(13,null,E):E===1?S?(0,D.localize)(14,null,E):(0,D.localize)(15,null,E):S?(0,D.localize)(16,null,E):(0,D.localize)(17,null,E)):g<k?(E=Math.floor(g/b),h?E===1?S?(0,D.localize)(18,null,E):(0,D.localize)(19,null,E):S?(0,D.localize)(20,null,E):(0,D.localize)(21,null,E):E===1?S?(0,D.localize)(22,null,E):(0,D.localize)(23,null,E):S?(0,D.localize)(24,null,E):(0,D.localize)(25,null,E)):g<L?(E=Math.floor(g/k),h?E===1?(0,D.localize)(26,null,E):(0,D.localize)(27,null,E):E===1?(0,D.localize)(28,null,E):(0,D.localize)(29,null,E)):g<p?(E=Math.floor(g/L),h?E===1?S?(0,D.localize)(30,null,E):(0,D.localize)(31,null,E):S?(0,D.localize)(32,null,E):(0,D.localize)(33,null,E):E===1?S?(0,D.localize)(34,null,E):(0,D.localize)(35,null,E):S?(0,D.localize)(36,null,E):(0,D.localize)(37,null,E)):g<l?(E=Math.floor(g/p),h?E===1?S?(0,D.localize)(38,null,E):(0,D.localize)(39,null,E):S?(0,D.localize)(40,null,E):(0,D.localize)(41,null,E):E===1?S?(0,D.localize)(42,null,E):(0,D.localize)(43,null,E):S?(0,D.localize)(44,null,E):(0,D.localize)(45,null,E)):(E=Math.floor(g/l),h?E===1?S?(0,D.localize)(46,null,E):(0,D.localize)(47,null,E):S?(0,D.localize)(48,null,E):(0,D.localize)(49,null,E):E===1?S?(0,D.localize)(50,null,E):(0,D.localize)(51,null,E):S?(0,D.localize)(52,null,E):(0,D.localize)(53,null,E))}i.fromNow=f;function I(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=I}),define(Q[72],Z([6,7]),function(B,i){return B.create("vs/base/common/errorMessage",i)}),define(Q[31],Z([0,1,19,5,72]),function(B,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createErrorWithActions=i.isErrorWithActions=i.toErrorMessage=void 0;function k(P,h){return h&&(P.stack||P.stacktrace)?b.localize(0,null,p(P),L(P.stack)||L(P.stacktrace)):p(P)}function L(P){return Array.isArray(P)?P.join(`
`):P}function p(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?b.localize(1,null,P.message):P.message||b.localize(2,null)}function l(P=null,h=!1){if(!P)return b.localize(3,null);if(Array.isArray(P)){const S=D.coalesce(P),g=l(S[0],h);return S.length>1?b.localize(4,null,g,S.length):g}if(R.isString(P))return P;if(P.detail){const S=P.detail;if(S.error)return k(S.error,h);if(S.exception)return k(S.exception,h)}return P.stack?k(P,h):P.message?P.message:b.localize(5,null)}i.toErrorMessage=l;function f(P){const h=P;return h instanceof Error&&Array.isArray(h.actions)}i.isErrorWithActions=f;function I(P,h){let S;return typeof P=="string"?S=new Error(P):S=P,S.actions=h,S}i.createErrorWithActions=I}),define(Q[73],Z([6,7]),function(B,i){return B.create("vs/base/common/jsonErrorMessages",i)}),define(Q[74],Z([0,1,73]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getParseErrorMessage=void 0;function R(b){switch(b){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}i.getParseErrorMessage=R}),define(Q[51],Z([0,1,12]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.removeDangerousEnvVariables=i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var R;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(R=i.Source||(i.Source={}));var b;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(b=i.TerminateResponseCode||(i.TerminateResponseCode={}));function k(p,...l){const f=l.reduce((h,S)=>(h[S]=!0,h),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(h=>!f[h]).forEach(h=>{for(let S=0;S<I.length;S++)if(h.search(I[S])!==-1){delete p[h];break}})}i.sanitizeProcessEnvironment=k;function L(p){!p||(delete p.DEBUG,D.isMacintosh&&delete p.DYLD_LIBRARY_PATH,D.isLinux&&delete p.LD_PRELOAD)}i.removeDangerousEnvVariables=L}),define(Q[52],Z([0,1,4,2]),function(B,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MutableObservableValue=i.staticObservableValue=void 0;const b=L=>({onDidChange:D.Event.None,value:L});i.staticObservableValue=b;class k extends R.Disposable{get value(){return this._value}set value(p){p!==this._value&&(this._value=p,this.changeEmitter.fire(p))}constructor(p){super(),this._value=p,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}}i.MutableObservableValue=k}),define(Q[53],Z([0,1,27]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.Hasher=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function R(a){return b(a,0)}i.hash=R;function b(a,u){switch(typeof a){case"object":return a===null?k(349,u):Array.isArray(a)?l(a,u):f(a,u);case"string":return p(a,u);case"boolean":return L(a,u);case"number":return k(a,u);case"undefined":return k(937,u);default:return k(617,u)}}i.doHash=b;function k(a,u){return(u<<5)-u+a|0}i.numberHash=k;function L(a,u){return k(a?433:863,u)}function p(a,u){u=k(149417,u);for(let m=0,c=a.length;m<c;m++)u=k(a.charCodeAt(m),u);return u}i.stringHash=p;function l(a,u){return u=k(104579,u),a.reduce((m,c)=>b(c,m),u)}function f(a,u){return u=k(181387,u),Object.keys(a).sort().reduce((m,c)=>(m=p(c,m),b(a[c],m)),u)}class I{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=b(u,this._value),this._value}}i.Hasher=I;var P;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function h(a,u,m=32){const c=m-u,s=~((1<<c)-1);return(a<<u|(s&a)>>>c)>>>0}function S(a,u=0,m=a.byteLength,c=0){for(let s=0;s<m;s++)a[u+s]=c}function g(a,u,m="0"){for(;a.length<u;)a=m+a;return a}function E(a,u=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(m=>m.toString(16).padStart(2,"0")).join(""):g((a>>>0).toString(16),u/4)}i.toHexString=E;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const m=u.length;if(m===0)return;const c=this._buff;let s=this._buffLen,e=this._leftoverHighSurrogate,r,t;for(e!==0?(r=e,t=-1,e=0):(r=u.charCodeAt(0),t=0);;){let n=r;if(D.isHighSurrogate(r))if(t+1<m){const o=u.charCodeAt(t+1);D.isLowSurrogate(o)?(t++,n=D.computeCodePoint(r,o)):n=65533}else{e=r;break}else D.isLowSurrogate(r)&&(n=65533);if(s=this._push(c,s,n),t++,t<m)r=u.charCodeAt(t);else break}this._buffLen=s,this._leftoverHighSurrogate=e}_push(u,m,c){return c<128?u[m++]=c:c<2048?(u[m++]=192|(c&1984)>>>6,u[m++]=128|(c&63)>>>0):c<65536?(u[m++]=224|(c&61440)>>>12,u[m++]=128|(c&4032)>>>6,u[m++]=128|(c&63)>>>0):(u[m++]=240|(c&1835008)>>>18,u[m++]=128|(c&258048)>>>12,u[m++]=128|(c&4032)>>>6,u[m++]=128|(c&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=v._bigBlock32,m=this._buffDV;for(let y=0;y<64;y+=4)u.setUint32(y,m.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)u.setUint32(y,h(u.getUint32(y-12,!1)^u.getUint32(y-32,!1)^u.getUint32(y-56,!1)^u.getUint32(y-64,!1),1),!1);let c=this._h0,s=this._h1,e=this._h2,r=this._h3,t=this._h4,n,o,d;for(let y=0;y<80;y++)y<20?(n=s&e|~s&r,o=1518500249):y<40?(n=s^e^r,o=1859775393):y<60?(n=s&e|s&r|e&r,o=2400959708):(n=s^e^r,o=3395469782),d=h(c,5)+n+t+o+u.getUint32(y*4,!1)&4294967295,t=r,r=e,e=h(s,30),s=c,c=d;this._h0=this._h0+c&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+e&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+t&4294967295}}i.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[54],Z([0,1,27]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0});var R;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(R||(R={})),function(b){const k="error",L="warning",p="warn",l="info",f="ignore";function I(h){return h?D.equalsIgnoreCase(k,h)?b.Error:D.equalsIgnoreCase(L,h)||D.equalsIgnoreCase(p,h)?b.Warning:D.equalsIgnoreCase(l,h)?b.Info:b.Ignore:b.Ignore}b.fromValue=I;function P(h){switch(h){case b.Error:return k;case b.Warning:return L;case b.Info:return l;default:return f}}b.toString=P}(R||(R={})),i.default=R}),define(Q[75],Z([0,1,10]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function R(f){const I=f;return I&&typeof I.type=="string"&&typeof I.severity=="string"}i.isRemoteConsoleLog=R;function b(f){const I=[];let P;try{const h=JSON.parse(f.arguments),S=h[h.length-1];S&&S.__$stack&&(h.pop(),P=S.__$stack),I.push(...h)}catch{I.push("Unable to log remote console arguments",f.arguments)}return{args:I,stack:P}}i.parse=b;function k(f){if(typeof f!="string")return k(b(f).stack);const I=f;if(I){const P=L(I),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(h&&h.length===4)return{uri:D.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}i.getFirstFrame=k;function L(f){if(!f)return f;const I=f.indexOf(`
`);return I===-1?f:f.substring(0,I)}function p(f,I){const{args:P,stack:h}=b(f),S=typeof P[0]=="string"&&P.length===1;let g=L(h);g&&(g=`(${g.trim()})`);let E=[];if(typeof P[0]=="string"?g&&S?E=[`%c[${I}] %c${P[0]} %c${g}`,l("blue"),l(""),l("grey")]:E=[`%c[${I}] %c${P[0]}`,l("blue"),l(""),...P.slice(1)]:E=[`%c[${I}]%`,l("blue"),...P],g&&!S&&E.push(g),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,E)}i.log=p;function l(f){return`color: ${f}`}}),define(Q[44],Z([0,1,15,27,10]),function(B,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.parse=i.stringify=void 0;function k(f){return JSON.stringify(f,p)}i.stringify=k;function L(f){let I=JSON.parse(f);return I=l(I),I}i.parse=L;function p(f,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,R.regExpFlags)(I)}:I}function l(f,I=0){if(!f||I>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return b.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 14:return new Date(f.source)}if(f instanceof D.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let P=0;P<f.length;++P)f[P]=l(f[P],I+1);else for(const P in f)Object.hasOwnProperty.call(f,P)&&(f[P]=l(f[P],I+1))}return f}i.revive=l}),define(Q[76],Z([0,1,38,14,20]),function(B,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,L=/^Microsoft.PowerShell_.*/,p=/^Microsoft.PowerShellPreview_.*/;var l;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(l||(l={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class P{constructor(s,e,r){this.exePath=s,this.displayName=e,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:c=!1}={}){return c?f===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:c=!1,findPreview:s=!1}={}){const e=h({useAlternateBitness:c});if(!e)return null;const r=R.join(e,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const y of await b.Promises.readdir(r)){let w=-1;if(s){const z=y.indexOf("-");if(z<0)continue;const _=y.substring(0,z);if(!k.test(_)||y.substring(z+1)!=="preview")continue;w=parseInt(_,10)}else{if(!k.test(y))continue;w=parseInt(y,10)}if(w<=t)continue;const C=R.join(r,y,"pwsh.exe");!await b.SymlinkSupport.existsFile(C)||(n=C,t=w)}if(!n)return null;const o=e.includes("x86")?" (x86)":"",d=s?" Preview":"";return new P(n,`PowerShell${d}${o}`,!0)}async function g({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const s=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:r}=c?{pwshMsixDirRegex:p,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const t of await b.Promises.readdir(s))if(e.test(t)){const n=R.join(s,t,"pwsh.exe");return new P(n,r)}return null}function E(){const c=R.join(D.homedir(),".dotnet","tools","pwsh.exe");return new P(c,".NET Core PowerShell Global Tool")}function v(){const c=R.join(process.env.windir,f===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(c,"Windows PowerShell",!0)}async function*a(){let c=await S();c&&(yield c),c=await S({useAlternateBitness:!0}),c&&(yield c),c=await g(),c&&(yield c),c=E(),c&&(yield c),c=await S({findPreview:!0}),c&&(yield c),c=await g({findPreview:!0}),c&&(yield c),c=await S({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=v(),c&&(yield c)}async function*u(){for await(const c of a())await c.exists()&&(yield c)}i.enumeratePowerShellInstallations=u;async function m(){for await(const c of u())return c;return null}i.getFirstAvailablePowerShellInstallation=m}),define(Q[55],Z([0,1,14,12,32,51,5,20]),function(B,i,D,R,b,k,L,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.getWindowsShell=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function l(P=b.env){return P.comspec||"cmd.exe"}i.getWindowsShell=l;function f(P){let h=[],S=!1;const g=function(E){if(S){h.push(E);return}(!P.send(E,a=>{if(a&&console.error(a),S=!1,h.length>0){const u=h.slice(0);h=[],u.forEach(m=>g(m))}})||R.isWindows)&&(S=!0)};return{send:g}}i.createQueuedSender=f;var I;(function(P){async function h(S,g,E){if(D.isAbsolute(S))return S;if(g===void 0&&(g=b.cwd()),D.dirname(S)!=="."||(E===void 0&&L.isString(b.env.PATH)&&(E=b.env.PATH.split(D.delimiter)),E===void 0||E.length===0))return D.join(g,S);async function a(u){if(await p.Promises.exists(u)){let m;try{m=await p.Promises.stat(u)}catch(c){c.message.startsWith("EACCES")&&(m=await p.Promises.lstat(u))}return m?!m.isDirectory():!1}return!1}for(const u of E){let m;if(D.isAbsolute(u)?m=D.join(u,S):m=D.join(g,u,S),await a(m))return m;let c=m+".com";if(await a(c)||(c=m+".exe",await a(c)))return c}return D.join(g,S)}P.findExecutable=h})(I=i.win32||(i.win32={}))}),define(Q[77],Z([0,1,38,12,76,55]),function(B,i,D,R,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function L(S,g){return S===1?R.isWindows?P():k.getWindowsShell(g):f(S,g)}i.getSystemShell=L;function p(S,g){return S===1?R.isWindows?h(g):k.getWindowsShell(g):f(S,g)}i.getSystemShellSync=p;let l=null;function f(S,g){if(R.isLinux&&S===2||R.isMacintosh&&S===3)return"/bin/bash";if(!l){let E;if(R.isWindows)E="/bin/bash";else{if(E=g.SHELL,!E)try{E=(0,D.userInfo)().shell}catch{}E||(E="sh"),E==="/bin/false"&&(E="/bin/bash")}l=E}return l}let I=null;async function P(){return I||(I=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),I}function h(S){if(I)return I;const g=R.isWindows&&parseFloat((0,D.release)())>=10,E=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${S.windir}\\${E?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return g?v:k.getWindowsShell(S)}});var ge=this&&this.__decorate||function(B,i,D,R){var b=arguments.length,k=b<3?i:R===null?R=Object.getOwnPropertyDescriptor(i,D):R,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(B,i,D,R);else for(var p=B.length-1;p>=0;p--)(L=B[p])&&(k=(b<3?L(k):b>3?L(i,D,k):L(i,D))||k);return b>3&&k&&Object.defineProperty(i,D,k),k};define(Q[56],Z([0,1,19,3,15,24,49,11,4,2,44,27,5]),function(B,i,D,R,b,k,L,p,l,f,I,P,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var S;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(S=i.RequestType||(i.RequestType={}));function g(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(E=i.ResponseType||(i.ResponseType={}));function v(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(a||(a={}));class u{constructor(F){this.buffer=F,this.pos=0}read(F){const j=this.buffer.slice(this.pos,this.pos+F);return this.pos+=j.byteLength,j}}class m{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var c;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(c||(c={}));function s(N){const F=b.VSBuffer.alloc(4);return F.writeUInt32BE(N,0),F}function e(N){return N.read(4).readUInt32BE(0)}function r(N){const F=b.VSBuffer.alloc(1);return F.writeUInt8(N,0),F}const t={Undefined:r(c.Undefined),String:r(c.String),Buffer:r(c.Buffer),VSBuffer:r(c.VSBuffer),Array:r(c.Array),Object:r(c.Object)},n=typeof Buffer<"u";function o(N,F){if(typeof F>"u")N.write(t.Undefined);else if(typeof F=="string"){const j=b.VSBuffer.fromString(F);N.write(t.String),N.write(s(j.byteLength)),N.write(j)}else if(n&&Buffer.isBuffer(F)){const j=b.VSBuffer.wrap(F);N.write(t.Buffer),N.write(s(j.byteLength)),N.write(j)}else if(F instanceof b.VSBuffer)N.write(t.VSBuffer),N.write(s(F.byteLength)),N.write(F);else if(Array.isArray(F)){N.write(t.Array),N.write(s(F.length));for(const j of F)o(N,j)}else{const j=b.VSBuffer.fromString(JSON.stringify(F));N.write(t.Object),N.write(s(j.byteLength)),N.write(j)}}function d(N){switch(N.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return N.read(e(N)).toString();case c.Buffer:return N.read(e(N)).buffer;case c.VSBuffer:return N.read(e(N));case c.Array:{const j=e(N),$=[];for(let Y=0;Y<j;Y++)$.push(d(N));return $}case c.Object:return JSON.parse(N.read(e(N)).toString())}}class y{constructor(F,j,$=null,Y=1e3){this.protocol=F,this.ctx=j,this.logger=$,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(A=>this.onRawMessage(A)),this.sendResponse({type:200})}registerChannel(F,j){this.channels.set(F,j),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const j=this.send([F.type]);this.logger?.logOutgoing(j,0,1,v(F.type));return}case 201:case 202:case 204:case 203:{const j=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(j,F.id,1,v(F.type),F.data);return}}}send(F,j=void 0){const $=new m;return o($,F),o($,j),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const j=new u(F),$=d(j),Y=d(j),A=$[0];switch(A){case 100:return this.logger?.logIncoming(F.byteLength,$[1],1,`${g(A)}: ${$[2]}.${$[3]}`,Y),this.onPromise({type:A,id:$[1],channelName:$[2],name:$[3],arg:Y});case 102:return this.logger?.logIncoming(F.byteLength,$[1],1,`${g(A)}: ${$[2]}.${$[3]}`,Y),this.onEventListen({type:A,id:$[1],channelName:$[2],name:$[3],arg:Y});case 101:return this.logger?.logIncoming(F.byteLength,$[1],1,`${g(A)}`),this.disposeActiveRequest({type:A,id:$[1]});case 103:return this.logger?.logIncoming(F.byteLength,$[1],1,`${g(A)}`),this.disposeActiveRequest({type:A,id:$[1]})}}onPromise(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const $=new k.CancellationTokenSource;let Y;try{Y=j.call(this.ctx,F.name,F.arg,$.token)}catch(T){Y=Promise.reject(T)}const A=F.id;Y.then(T=>{this.sendResponse({id:A,data:T,type:201}),this.activeRequests.delete(F.id)},T=>{T instanceof Error?this.sendResponse({id:A,data:{message:T.message,name:T.name,stack:T.stack?T.stack.split?T.stack.split(`
`):T.stack:void 0},type:202}):this.sendResponse({id:A,data:T,type:203}),this.activeRequests.delete(F.id)});const U=(0,f.toDisposable)(()=>$.cancel());this.activeRequests.set(F.id,U)}onEventListen(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const $=F.id,A=j.listen(this.ctx,F.name,F.arg)(U=>this.sendResponse({id:$,data:U,type:204}));this.activeRequests.set(F.id,A)}disposeActiveRequest(F){const j=this.activeRequests.get(F.id);j&&(j.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let j=this.pendingRequests.get(F.channelName);j||(j=[],this.pendingRequests.set(F.channelName,j));const $=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:F,timeoutTimer:$})}flushPendingRequests(F){const j=this.pendingRequests.get(F);if(j){for(const $ of j)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}i.ChannelServer=y;var w;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(w=i.RequestInitiator||(i.RequestInitiator={}));class C{constructor(F,j=null){this.protocol=F,this.isDisposed=!1,this.state=a.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=j}getChannel(F){const j=this;return{call($,Y,A){return j.isDisposed?Promise.reject(new p.CancellationError):j.requestPromise(F,$,Y,A)},listen($,Y){return j.isDisposed?l.Event.None:j.requestEvent(F,$,Y)}}}requestPromise(F,j,$,Y=k.CancellationToken.None){const A=this.lastRequestId++,T={id:A,type:100,channelName:F,name:j,arg:$};if(Y.isCancellationRequested)return Promise.reject(new p.CancellationError);let O;return new Promise((W,q)=>{if(Y.isCancellationRequested)return q(new p.CancellationError);const K=()=>{const Se=te=>{switch(te.type){case 201:this.handlers.delete(A),W(te.data);break;case 202:{this.handlers.delete(A);const oe=new Error(te.data.message);oe.stack=te.data.stack,oe.name=te.data.name,q(oe);break}case 203:this.handlers.delete(A),q(te.data);break}};this.handlers.set(A,Se),this.sendRequest(T)};let ae=null;this.state===a.Idle?K():(ae=(0,R.createCancelablePromise)(Se=>this.whenInitialized()),ae.then(()=>{ae=null,K()}));const ce=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:A,type:101}),q(new p.CancellationError)},pe=Y.onCancellationRequested(ce);O=(0,f.combinedDisposable)((0,f.toDisposable)(ce),pe),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(F,j,$){const Y=this.lastRequestId++,U={id:Y,type:102,channelName:F,name:j,arg:$};let T=null;const O=new l.Emitter({onFirstListenerAdd:()=>{T=(0,R.createCancelablePromise)(W=>this.whenInitialized()),T.then(()=>{T=null,this.activeRequests.add(O),this.sendRequest(U)})},onLastListenerRemove:()=>{T?(T.cancel(),T=null):(this.activeRequests.delete(O),this.sendRequest({id:Y,type:103}))}}),M=W=>O.fire(W.data);return this.handlers.set(Y,M),O.event}sendRequest(F){switch(F.type){case 100:case 102:{const j=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(j,F.id,0,`${g(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const j=this.send([F.type,F.id]);this.logger?.logOutgoing(j,F.id,0,g(F.type));return}}}send(F,j=void 0){const $=new m;return o($,F),o($,j),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const j=new u(F),$=d(j),Y=d(j),A=$[0];switch(A){case 200:return this.logger?.logIncoming(F.byteLength,0,0,v(A)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(F.byteLength,$[1],0,v(A),Y),this.onResponse({type:$[0],id:$[1],data:Y})}}onResponse(F){if(F.type===200){this.state=a.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ge([L.memoize],C.prototype,"onDidInitializePromise",null),i.ChannelClient=C;class z{get connections(){const F=[];return this._connections.forEach(j=>F.push(j)),F}constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:j,onDidClientDisconnect:$})=>{l.Event.once(j.onMessage)(A=>{const U=new u(A),T=d(U),O=new y(j,T),M=new C(j);this.channels.forEach((q,K)=>O.registerChannel(K,q));const W={channelServer:O,channelClient:M,ctx:T};this._connections.add(W),this._onDidAddConnection.fire(W),$(()=>{O.dispose(),M.dispose(),this._connections.delete(W),this._onDidRemoveConnection.fire(W)})})})}getChannel(F,j){const $=this;return{call(Y,A,U){let T;if((0,h.isFunction)(j)){const M=(0,D.getRandomElement)($.connections.filter(j));T=M?Promise.resolve(M):l.Event.toPromise(l.Event.filter($.onDidAddConnection,j))}else T=j.routeCall($,Y,A);const O=T.then(M=>M.channelClient.getChannel(F));return X(O).call(Y,A,U)},listen(Y,A){if((0,h.isFunction)(j))return $.getMulticastEvent(F,j,Y,A);const U=j.routeEvent($,Y,A).then(T=>T.channelClient.getChannel(F));return X(U).listen(Y,A)}}}getMulticastEvent(F,j,$,Y){const A=this;let U=new f.DisposableStore;const T=new l.Emitter({onFirstListenerAdd:()=>{U=new f.DisposableStore;const O=new l.EventMultiplexer,M=new Map,W=K=>{const ce=K.channelClient.getChannel(F).listen($,Y),pe=O.add(ce);M.set(K,pe)},q=K=>{const ae=M.get(K);!ae||(ae.dispose(),M.delete(K))};A.connections.filter(j).forEach(W),l.Event.filter(A.onDidAddConnection,j)(W,void 0,U),A.onDidRemoveConnection(q,void 0,U),O.event(T.fire,T,U),U.add(O)},onLastListenerRemove:()=>{U.dispose()}});return T.event}registerChannel(F,j){this.channels.set(F,j),this._connections.forEach($=>{$.channelServer.registerChannel(F,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=z;class _{constructor(F,j,$=null){const Y=new m;o(Y,j),F.send(Y.buffer),this.channelClient=new C(F,$),this.channelServer=new y(F,j,$)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,j){this.channelServer.registerChannel(F,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=_;function X(N){return{call(F,j,$){return N.then(Y=>Y.call(F,j,$))},listen(F,j){const $=new l.Relay;return N.then(Y=>$.input=Y.listen(F,j)),$.event}}}i.getDelayedChannel=X;function H(N){let F=!1;return{call(j,$,Y){return F?N.call(j,$,Y):(0,R.timeout)(0).then(()=>F=!0).then(()=>N.call(j,$,Y))},listen(j,$){if(F)return N.listen(j,$);const Y=new l.Relay;return(0,R.timeout)(0).then(()=>F=!0).then(()=>Y.input=N.listen(j,$)),Y.event}}}i.getNextTickChannel=H;class ne{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const j of F.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await l.Event.toPromise(F.onDidAddConnection),await this.route(F)}}i.StaticRouter=ne;var re;(function(N){function F(A,U){const T=A,O=U&&U.disableMarshalling,M=new Map;for(const W in T)$(W)&&M.set(W,l.Event.buffer(T[W],!0));return new class{listen(W,q,K){const ae=M.get(q);if(ae)return ae;if(Y(q)){const ce=T[q];if(typeof ce=="function")return ce.call(T,K)}throw new Error(`Event not found: ${q}`)}call(W,q,K){const ae=T[q];if(typeof ae=="function"){if(!O&&Array.isArray(K))for(let ce=0;ce<K.length;ce++)K[ce]=(0,I.revive)(K[ce]);return ae.apply(T,K)}throw new Error(`Method not found: ${q}`)}}}N.fromService=F;function j(A,U){const T=U&&U.disableMarshalling;return new Proxy({},{get(O,M){if(typeof M=="string")return U?.properties?.has(M)?U.properties.get(M):Y(M)?function(W){return A.listen(M,W)}:$(M)?A.listen(M):async function(...W){let q;U&&!(0,h.isUndefinedOrNull)(U.context)?q=[U.context,...W]:q=W;const K=await A.call(M,q);return T?K:(0,I.revive)(K)};throw new Error(`Property not found: ${String(M)}`)}})}N.toService=j;function $(A){return A[0]==="o"&&A[1]==="n"&&P.isUpperAsciiLetter(A.charCodeAt(2))}function Y(A){return/^onDynamic/.test(A)&&P.isUpperAsciiLetter(A.charCodeAt(9))}})(re=i.ProxyChannel||(i.ProxyChannel={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){const F=N.toString();if(F!=="[object Object]")return F}return N}function le(N){return Array.isArray(N)?N.map(fe):fe(N)}function ie(N,F,j,$,Y,A,U){U=le(U);const T=se[Y],O=T[$%T.length];let M=[`%c[${N}]%c[${String(F).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String($).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(A)?(M=M.concat(U),M.push(")")):M.push(U),console.log.apply(console,M)}i.logWithColors=ie;class V{constructor(F,j){this._outgoingPrefix=F,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,j,$,Y,A){this._totalOutgoing+=F,ie(this._outgoingPrefix,this._totalOutgoing,F,j,$,Y,A)}logIncoming(F,j,$,Y,A){this._totalIncoming+=F,ie(this._incomingPrefix,this._totalIncoming,F,j,$,Y,A)}}i.IPCLogger=V}),define(Q[78],Z([0,1,57,3,15,24,75,11,4,2,26,55,51,56]),function(B,i,D,R,b,k,L,p,l,f,I,P,h,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class g extends S.ChannelServer{constructor(a){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",u=>b.VSBuffer.wrap(Buffer.from(u,"base64")))},a),process.once("disconnect",()=>this.dispose())}}i.Server=g;class E{constructor(a,u){this.modulePath=a,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new R.Delayer(m),this.child=null,this._client=null}getChannel(a){const u=this;return{call(m,c,s){return u.requestPromise(a,m,c,s)},listen(m,c){return u.requestEvent(a,m,c)}}}requestPromise(a,u,m,c=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(p.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(a),e=(0,R.createCancelablePromise)(n=>s.call(u,m,n)),r=c.onCancellationRequested(()=>e.cancel()),t=(0,f.toDisposable)(()=>e.cancel());return this.activeRequests.add(t),e.finally(()=>{r.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(a,u,m){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let c;const s=new l.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(a).listen(u,m)(s.fire,s),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const a=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,h.removeDangerousEnvVariables)(u.env),this.child=(0,D.fork)(this.modulePath,a,u);const m=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,L.isRemoteConsoleLog)(o)){(0,L.log)(o,`IPC Library: ${this.options.serverName}`);return}m.fire(b.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,e=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),r=m.event,t={send:e,onMessage:r};this._client=new S.ChannelClient(t);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,d)=>{process.removeListener("exit",n),this.activeRequests.forEach(y=>(0,f.dispose)(y)),this.activeRequests.clear(),o!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+d),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:d})})}return this._client}getCachedChannel(a){let u=this.channels.get(a);return u||(u=this.client.getChannel(a),this.channels.set(a,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=E}),define(Q[79],Z([0,1,3,4,2,5]),function(B,i,D,R,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.StorageState=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var L;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=i.StorageHint||(i.StorageHint={}));function p(P){const h=P;return h?.changed instanceof Map||h?.deleted instanceof Set}i.isStorageItemsChangeEvent=p;var l;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(l=i.StorageState||(i.StorageState={}));class f extends b.Disposable{constructor(h,S=Object.create(null)){super(),this.database=h,this.options=S,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((S,g)=>this.accept(g,S)),h.deleted?.forEach(S=>this.accept(S,void 0))}accept(h,S){if(this.state===l.Closed)return;let g=!1;(0,k.isUndefinedOrNull)(S)?g=this.cache.delete(h):this.cache.get(h)!==S&&(this.cache.set(h,S),g=!0),g&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,S){const g=this.cache.get(h);return(0,k.isUndefinedOrNull)(g)?S:g}getBoolean(h,S){const g=this.get(h);return(0,k.isUndefinedOrNull)(g)?S:g==="true"}getNumber(h,S){const g=this.get(h);return(0,k.isUndefinedOrNull)(g)?S:parseInt(g,10)}async set(h,S){if(this.state===l.Closed)return;if((0,k.isUndefinedOrNull)(S))return this.delete(h);const g=String(S);if(this.cache.get(h)!==g)return this.cache.set(h,g),this.pendingInserts.set(h,g),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async delete(h){if(!(this.state===l.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(!!this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert?.forEach((S,g)=>this.items.set(g,S)),h.delete?.forEach(S=>this.items.delete(S))}async close(){}}i.InMemoryStorageDatabase=I}),define(Q[80],Z([6,7]),function(B,i){return B.create("vs/base/node/zip",i)}),define(Q[81],Z([6,7]),function(B,i){return B.create("vs/platform/configuration/common/configurationRegistry",i)}),define(Q[82],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(Q[83],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(Q[84],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagementCLI",i)}),define(Q[85],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionNls",i)}),define(Q[86],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionsScannerService",i)}),define(Q[87],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(Q[88],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(Q[89],Z([6,7]),function(B,i){return B.create("vs/platform/extensions/common/extensionValidator",i)}),define(Q[90],Z([6,7]),function(B,i){return B.create("vs/platform/files/common/fileService",i)}),define(Q[91],Z([6,7]),function(B,i){return B.create("vs/platform/files/common/io",i)}),define(Q[92],Z([6,7]),function(B,i){return B.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(Q[93],Z([6,7]),function(B,i){return B.create("vs/platform/languagePacks/common/languagePacks",i)}),define(Q[94],Z([6,7]),function(B,i){return B.create("vs/platform/request/common/request",i)}),define(Q[95],Z([6,7]),function(B,i){return B.create("vs/platform/shell/node/shellEnv",i)}),define(Q[96],Z([6,7]),function(B,i){return B.create("vs/platform/telemetry/common/telemetryService",i)}),define(Q[97],Z([6,7]),function(B,i){return B.create("vs/platform/userDataProfile/common/userDataProfile",i)}),define(Q[98],Z([6,7]),function(B,i){return B.create("vs/platform/workspace/common/workspace",i)}),define(Q[99],Z([0,1,71,49,17,14,32,18,10]),function(B,i,D,R,b,k,L,p,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class f{get appRoot(){return(0,k.dirname)(b.FileAccess.asFileUri("",B).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,p.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,p.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const E=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",E)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return l.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,p.joinPath)(l.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,p.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,p.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,p.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=L.env.VSCODE_PORTABLE;return E?l.URI.file((0,k.join)(E,"argv.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,k.resolve)(E):(0,k.normalize)((0,k.join)(b.FileAccess.asFileUri("",B).fsPath,"..","extensions"))}get extensionsDownloadPath(){const E=this.args["extensions-download-dir"];return E?(0,k.resolve)(E):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,k.resolve)(E);const v=L.env.VSCODE_EXTENSIONS;if(v)return v;const a=L.env.VSCODE_PORTABLE;return a?(0,k.join)(a,"extensions"):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(v=>/^[^:/?#]+?:\/\//.test(v)?l.URI.parse(v):l.URI.file((0,k.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?l.URI.parse(E):l.URI.file((0,k.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,p.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return l.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const E=L.env.VSCODE_PORTABLE;return E?l.URI.file((0,k.join)(E,"policy.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(E){this.args.continueOn=E}get args(){return this._args}constructor(E,v,a){this._args=E,this.paths=v,this.productService=a,this.editSessionId=this.args.editSessionId}}ge([R.memoize],f.prototype,"appRoot",null),ge([R.memoize],f.prototype,"userHome",null),ge([R.memoize],f.prototype,"userDataPath",null),ge([R.memoize],f.prototype,"appSettingsHome",null),ge([R.memoize],f.prototype,"tmpDir",null),ge([R.memoize],f.prototype,"cacheHome",null),ge([R.memoize],f.prototype,"stateResource",null),ge([R.memoize],f.prototype,"userRoamingDataHome",null),ge([R.memoize],f.prototype,"userDataSyncHome",null),ge([R.memoize],f.prototype,"userDataSyncLogResource",null),ge([R.memoize],f.prototype,"editSessionsLogResource",null),ge([R.memoize],f.prototype,"sync",null),ge([R.memoize],f.prototype,"machineSettingsResource",null),ge([R.memoize],f.prototype,"workspaceStorageHome",null),ge([R.memoize],f.prototype,"localHistoryHome",null),ge([R.memoize],f.prototype,"keyboardLayoutResource",null),ge([R.memoize],f.prototype,"argvResource",null),ge([R.memoize],f.prototype,"isExtensionDevelopment",null),ge([R.memoize],f.prototype,"untitledWorkspacesHome",null),ge([R.memoize],f.prototype,"installSourcePath",null),ge([R.memoize],f.prototype,"builtinExtensionsPath",null),ge([R.memoize],f.prototype,"extensionsPath",null),ge([R.memoize],f.prototype,"extensionDevelopmentLocationURI",null),ge([R.memoize],f.prototype,"extensionDevelopmentKind",null),ge([R.memoize],f.prototype,"extensionTestsLocationURI",null),ge([R.memoize],f.prototype,"debugExtensionHost",null),ge([R.memoize],f.prototype,"serviceMachineIdResource",null),ge([R.memoize],f.prototype,"telemetryLogResource",null),ge([R.memoize],f.prototype,"disableWorkspaceTrust",null),ge([R.memoize],f.prototype,"policyFile",null),i.AbstractNativeEnvironmentService=f;function I(g,E){return S(g["inspect-extensions"],g["inspect-brk-extensions"],5870,E,g.debugId,g.extensionEnvironment)}i.parseExtensionHostPort=I;function P(g,E){return S(g["inspect-search"],g["inspect-brk-search"],5876,E,g.extensionEnvironment)}i.parseSearchPort=P;function h(g,E){return S(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,E,g.extensionEnvironment)}i.parsePtyHostPort=h;function S(g,E,v,a,u,m){const s=Number(E||g)||(a?null:v),e=s?Boolean(!!E):!1;let r;if(m)try{r=JSON.parse(m)}catch{}return{port:s,break:e,debugId:u,env:r}}}),function(){"use strict";function B(i,D,R){function b(L,p){const l=k(L,p),f=[l];return i.isAbsolute(l)||f.unshift(R),i.resolve(...f)}function k(L,p){process.env.VSCODE_DEV&&(p="code-oss-dev");const l=process.env.VSCODE_PORTABLE;if(l)return i.join(l,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return i.join(f,p);const I=L["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=i.join(P,"AppData","Roaming")}break;case"darwin":f=i.join(D.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||i.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(f,p)}return{getUserDataPath:b}}if(typeof define=="function")define(Q[100],Z([149,38,32]),function(i,D,R){return B(i,D,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("path"),D=require("os");module.exports=B(i,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[101],Z([0,1,38,99,100]),function(B,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class k extends R.AbstractNativeEnvironmentService{constructor(p,l){super(p,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,b.getUserDataPath)(p,l.nameShort)},l)}}i.NativeEnvironmentService=k}),define(Q[102],Z([0,1,5,85]),function(B,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;function b(L,p,l){try{k(L,p,l)}catch{}return L}i.localizeManifest=b;function k(L,p,l){const f=(I,P,h)=>{const S=I[P];if((0,D.isString)(S)){const g=S,E=g.length;if(E>1&&g[0]==="%"&&g[E-1]==="%"){const v=g.substr(1,E-2);let a=p[v];a===void 0&&l&&(a=l[v]);const u=typeof a=="string"?a:a.message;if(u!==void 0){const m=l?.[v],c=typeof m=="string"?m:m?.message;if(h&&(P==="title"||P==="category")&&c&&c!==u){const s={value:u,original:c};I[P]=s}else I[P]=u}else console.warn(`[${L.name}]: ${(0,R.localize)(0,null,v)}`)}}else if((0,D.isObject)(S))for(const g in S)S.hasOwnProperty(g)&&(g==="commands"?f(S,g,!0):f(S,g,h));else if(Array.isArray(S))for(let g=0;g<S.length;g++)f(S,g,h)};for(const I in L)L.hasOwnProperty(I)&&f(L,I)}}),define(Q[45],Z([0,1,18,54,89,39]),function(B,i,D,R,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.validateExtensionManifest=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function l(a){return a=a.trim(),a==="*"||L.test(a)}i.isValidVersionStr=l;function f(a){if(!l(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=a.match(L);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}i.parseVersion=f;function I(a){if(!a)return null;const u=a.majorBase,m=a.majorMustEqual,c=a.minorBase;let s=a.minorMustEqual;const e=a.patchBase;let r=a.patchMustEqual;a.hasCaret&&(u===0||(s=!1),r=!1);let t=0;if(a.preRelease){const n=p.exec(a.preRelease);if(n){const[,o,d,y]=n;t=Date.UTC(Number(o),Number(d)-1,Number(y))}}return{majorBase:u,majorMustEqual:m,minorBase:c,minorMustEqual:s,patchBase:e,patchMustEqual:r,isMinimum:a.hasGreaterEquals,notBefore:t}}i.normalizeVersion=I;function P(a,u,m){let c;typeof a=="string"?c=I(f(a)):c=a;let s;u instanceof Date?s=u.getTime():typeof u=="string"&&(s=new Date(u).getTime());let e;if(typeof m=="string"?e=I(f(m)):e=m,!c||!e)return!1;const r=c.majorBase,t=c.minorBase,n=c.patchBase;let o=e.majorBase,d=e.minorBase,y=e.patchBase;const w=e.notBefore;let C=e.majorMustEqual,z=e.minorMustEqual,_=e.patchMustEqual;return e.isMinimum?r>o?!0:r<o?!1:t>d?!0:t<d||s&&s<w?!1:n>=y:(r===1&&o===0&&(!C||!z||!_)&&(o=1,d=0,y=0,C=!0,z=!1,_=!1),r<o?!1:r>o?!C:t<d?!1:t>d?!z:n<y?!1:n>y?!_:!(s&&s<w))}i.isValidVersion=P;function h(a,u,m,c,s){const e=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return e.push([R.default.Error,b.localize(0,null)]),e;if(typeof c.name!="string")return e.push([R.default.Error,b.localize(1,null,"name")]),e;if(typeof c.version!="string")return e.push([R.default.Error,b.localize(2,null,"version")]),e;if(!c.engines)return e.push([R.default.Error,b.localize(3,null,"engines")]),e;if(typeof c.engines.vscode!="string")return e.push([R.default.Error,b.localize(4,null,"engines.vscode")]),e;if(typeof c.extensionDependencies<"u"&&!v(c.extensionDependencies))return e.push([R.default.Error,b.localize(5,null,"extensionDependencies")]),e;if(typeof c.activationEvents<"u"){if(!v(c.activationEvents))return e.push([R.default.Error,b.localize(6,null,"activationEvents")]),e;if(typeof c.main>"u"&&typeof c.browser>"u")return e.push([R.default.Error,b.localize(7,null,"activationEvents","main")]),e}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&e.push([R.default.Warning,b.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return e.push([R.default.Error,b.localize(9,null,"main")]),e;{const n=(0,D.joinPath)(m,c.main);(0,D.isEqualOrParent)(n,m)||e.push([R.default.Warning,b.localize(10,null,n.path,m.path)])}if(typeof c.activationEvents>"u")return e.push([R.default.Error,b.localize(11,null,"activationEvents","main")]),e}if(typeof c.browser<"u"){if(typeof c.browser!="string")return e.push([R.default.Error,b.localize(12,null,"browser")]),e;{const n=(0,D.joinPath)(m,c.browser);(0,D.isEqualOrParent)(n,m)||e.push([R.default.Warning,b.localize(13,null,n.path,m.path)])}if(typeof c.activationEvents>"u")return e.push([R.default.Error,b.localize(14,null,"activationEvents","browser")]),e}if(!k.valid(c.version))return e.push([R.default.Error,b.localize(15,null)]),e;const r=[];if(!S(a,u,c,s,r))for(const n of r)e.push([R.default.Error,n]);return e}i.validateExtensionManifest=h;function S(a,u,m,c,s){return c||typeof m.main>"u"&&typeof m.browser>"u"?!0:E(a,u,m.engines.vscode,s)}i.isValidExtensionVersion=S;function g(a,u,m){return a==="*"||E(u,m,a)}i.isEngineValid=g;function E(a,u,m,c=[]){const s=I(f(m));if(!s)return c.push(b.localize(16,null,m)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return c.push(b.localize(17,null,m)),!1}else if(!s.majorMustEqual)return c.push(b.localize(18,null,m)),!1;return P(a,u,s)?!0:(c.push(b.localize(19,null,a,m)),!1)}function v(a){if(!Array.isArray(a))return!1;for(let u=0,m=a.length;u<m;u++)if(typeof a[u]!="string")return!1;return!0}}),define(Q[103],Z([0,1,15,30]),function(B,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function b(k,L,p){let l=p&&p.get("storage.serviceMachineId",-1)||null;if(l)return l;try{const I=(await L.readFile(k.serviceMachineIdResource)).value.toString();l=(0,R.isUUID)(I)?I:null}catch{l=null}if(!l){l=(0,R.generateUuid)();try{await L.writeFile(k.serviceMachineIdResource,D.VSBuffer.fromString(l))}catch{}}return p?.store("storage.serviceMachineId",l,-1,1),l}i.getServiceMachineId=b}),define(Q[46],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class D{constructor(b,k=[],L=!1){this.ctor=b,this.staticArguments=k,this.supportsDelayedInstantiation=L}}i.SyncDescriptor=D}),define(Q[104],Z([0,1,46]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=i.InstantiationType=void 0;const R=[];var b;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(b=i.InstantiationType||(i.InstantiationType={}));function k(p,l,f){l instanceof D.SyncDescriptor||(l=new D.SyncDescriptor(l,[],Boolean(f))),R.push([p,l])}i.registerSingleton=k;function L(){return R}i.getSingletonServiceDescriptors=L}),define(Q[105],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class D{constructor(k,L){this.key=k,this.data=L,this.incoming=new Map,this.outgoing=new Map}}i.Node=D;class R{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(const L of this._nodes.values())L.outgoing.size===0&&k.push(L);return k}insertEdge(k,L){const p=this.lookupOrInsertNode(k),l=this.lookupOrInsertNode(L);p.outgoing.set(l.key,l),l.incoming.set(p.key,p)}removeNode(k){const L=this._hashFn(k);this._nodes.delete(L);for(const p of this._nodes.values())p.outgoing.delete(L),p.incoming.delete(L)}lookupOrInsertNode(k){const L=this._hashFn(k);let p=this._nodes.get(L);return p||(p=new D(L,k),this._nodes.set(L,p)),p}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){const k=[];for(const[L,p]of this._nodes)k.push(`${L}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,L]of this._nodes){const p=new Set([k]),l=this._findCycle(L,p);if(l)return l}}_findCycle(k,L){for(const[p,l]of k.outgoing){if(L.has(p))return[...L,p].join(" -> ");L.add(p);const f=this._findCycle(l,L);if(f)return f;L.delete(p)}}}i.Graph=R}),define(Q[21],Z([0,1,5,10,8]),function(B,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getLanguageTagSettingPlainKey=i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,b.createDecorator)("configurationService");function k(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof R.URI)}i.isConfigurationOverrides=k;function L(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof R.URI)}i.isConfigurationUpdateOverrides=L;var p;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(p=i.ConfigurationTarget||(i.ConfigurationTarget={}));function l(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}i.ConfigurationTargetToString=l;function f(a,u){const m=Object.create(null);for(const c in a)I(m,c,a[c],u);return m}i.toValuesTree=f;function I(a,u,m,c){const s=u.split("."),e=s.pop();let r=a;for(let t=0;t<s.length;t++){const n=s[t];let o=r[n];switch(typeof o){case"undefined":o=r[n]=Object.create(null);break;case"object":break;default:c(`Ignoring ${u} as ${s.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[e]=m}catch{c(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(r)}`)}else c(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(r)}`)}i.addToValueTree=I;function P(a,u){const m=u.split(".");h(a,m)}i.removeFromValueTree=P;function h(a,u){const m=u.shift();if(u.length===0){delete a[m];return}if(Object.keys(a).indexOf(m)!==-1){const c=a[m];typeof c=="object"&&!Array.isArray(c)&&(h(c,u),Object.keys(c).length===0&&delete a[m])}}function S(a,u,m){function c(r,t){let n=r;for(const o of t){if(typeof n!="object"||n===null)return;n=n[o]}return n}const s=u.split("."),e=c(a,s);return typeof e>"u"?m:e}i.getConfigurationValue=S;function g(a,u,m){Object.keys(u).forEach(c=>{c!=="__proto__"&&(c in a?D.isObject(a[c])&&D.isObject(u[c])?g(a[c],u[c],m):m&&(a[c]=u[c]):a[c]=u[c])})}i.merge=g;function E(a,u,m){const c=a.inspect(u),s=a.inspect(m);return typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:c.defaultValue}i.getMigratedSettingValue=E;function v(a){return a.replace(/[\[\]]/g,"")}i.getLanguageTagSettingPlainKey=v}),define(Q[58],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Q[16],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,D.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,D.refineServiceDecorator)(i.IEnvironmentService)}),define(Q[22],Z([0,1,83,8]),function(B,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";function b(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=b;function k(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=k;function L(a,u){switch(a){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=L;function p(a,u){return u==="web"&&!a.includes("web")}i.isNotWebExtensionInWebTargetPlatform=p;function l(a,u,m){return p(u,m)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===m?!0:f(m).includes(a)}i.isTargetPlatformCompatible=l;function f(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=f;function I(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}i.isIExtensionIdentifier=I;var P;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(P=i.SortBy||(i.SortBy={}));var h;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(h=i.SortOrder||(i.SortOrder={}));var S;(function(a){a.Install="install",a.Uninstall="uninstall"})(S=i.StatisticType||(i.StatisticType={}));var g;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(g=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var E;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal"})(E=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class v extends Error{constructor(u,m){super(u),this.code=m,this.name=m}}i.ExtensionManagementError=v,i.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),i.ExtensionsLabel=(0,D.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.PreferencesLabel=(0,D.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"}}),define(Q[59],Z([0,1,15,11,91,13]),function(B,i,D,R,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function L(I,P,h,S,g,E){let v;try{await p(I,P,h,S,g,E)}catch(a){v=a}finally{v&&g.errorTransformer&&(v=g.errorTransformer(v)),typeof v<"u"&&h.error(v),h.end()}}i.readFileIntoStream=L;async function p(I,P,h,S,g,E){l(E);const v=await I.open(P,{create:!1});try{l(E);let a=0,u=0,m=g&&typeof g.length=="number"?g.length:void 0,c=D.VSBuffer.alloc(Math.min(g.bufferSize,typeof m=="number"?m:g.bufferSize)),s=g&&typeof g.position=="number"?g.position:0,e=0;do u=await I.read(v,s,c.buffer,e,c.byteLength-e),s+=u,e+=u,a+=u,typeof m=="number"&&(m-=u),e===c.byteLength&&(await h.write(S(c)),c=D.VSBuffer.alloc(Math.min(g.bufferSize,typeof m=="number"?m:g.bufferSize)),e=0);while(u>0&&(typeof m!="number"||m>0)&&l(E)&&f(a,g));if(e>0){let r=e;typeof m=="number"&&(r=Math.min(e,m)),h.write(S(c.slice(0,r)))}}catch(a){throw(0,k.ensureFileSystemProviderError)(a)}finally{await I.close(v)}}function l(I){if(I.isCancellationRequested)throw(0,R.canceled)();return!0}function f(I,P){if(P?.limits){if(typeof P.limits.memory=="number"&&I>P.limits.memory)throw(0,k.createFileSystemProviderError)((0,b.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&I>P.limits.size)throw(0,k.createFileSystemProviderError)((0,b.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[106],Z([0,1,4,150,2,12,151]),function(B,i,D,R,b,k,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcher=void 0;class p extends b.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(f){const I=this.normalizeRequests(f),P=I.filter(S=>{const g=this.watchers.get(S.path);return g?!(0,R.patternsEquals)(g.request.excludes,S.excludes)||!(0,R.patternsEquals)(g.request.includes,S.includes):!0}),h=Array.from(this.watchers.values()).filter(({request:S})=>!I.find(g=>g.path===S.path&&(0,R.patternsEquals)(g.excludes,S.excludes)&&(0,R.patternsEquals)(g.includes,S.includes))).map(({request:S})=>S.path);P.length&&this.trace(`Request to start watching: ${P.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"})`).join(",")}`),h.length&&this.trace(`Request to stop watching: ${h.join(",")}`);for(const S of h)this.stopWatching(S);for(const S of P)this.startWatching(S)}startWatching(f){const I=new L.NodeJSFileWatcherLibrary(f,h=>this._onDidChangeFile.fire(h),h=>this._onDidLogMessage.fire(h),this.verboseLogging),P={request:f,instance:I};this.watchers.set(f.path,P)}async stop(){for(const[f]of this.watchers)this.stopWatching(f);this.watchers.clear()}stopWatching(f){const I=this.watchers.get(f);I&&(this.watchers.delete(f),I.instance.dispose())}normalizeRequests(f){const I=new Map;for(const P of f){const h=k.isLinux?P.path:P.path.toLowerCase();I.set(h,P)}return Array.from(I.values())}async setVerboseLogging(f){this.verboseLogging=f;for(const[,I]of this.watchers)I.instance.setVerboseLogging(f)}trace(f){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(f)})}toMessage(f,I){return I?`[File Watcher (node.js)] ${f} (path: ${I.request.path})`:`[File Watcher (node.js)] ${f}`}}i.NodeJSWatcher=p}),define(Q[107],Z([0,1,60,106]),function(B,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcherClient=void 0;class b extends D.AbstractNonRecursiveWatcherClient{constructor(L,p,l){super(L,p,l),this.init()}createWatcher(){return new R.NodeJSWatcher}}i.NodeJSWatcherClient=b}),define(Q[108],Z([0,1,17,56,78,60]),function(B,i,D,R,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UniversalWatcherClient=void 0;class L extends k.AbstractUniversalWatcherClient{constructor(l,f,I){super(l,f,I),this.init()}createWatcher(l){const f=l.add(new b.Client(D.FileAccess.asFileUri("bootstrap-fork",B).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(f.onDidProcessExit(({code:I,signal:P})=>this.onError(`terminated by itself with code ${I}, signal: ${P}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(f.getChannel("watcher")))}}i.UniversalWatcherClient=L}),define(Q[61],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class D{constructor(...b){this._entries=new Map;for(const[k,L]of b)this.set(k,L)}set(b,k){const L=this._entries.get(b);return this._entries.set(b,k),L}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}i.ServiceCollection=D}),define(Q[109],Z([0,1,3,11,2,46,105,8,61,152]),function(B,i,D,R,b,k,L,p,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Trace=i.InstantiationService=void 0;const I=!1;class P extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class h{constructor(v=new l.ServiceCollection,a=!1,u,m=I){this._services=v,this._strict=a,this._parent=u,this._enableTracing=m,this._activeInstantiations=new Set,this._services.set(p.IInstantiationService,this),this._globalGraph=m?u?._globalGraph??new L.Graph(c=>c):void 0}createChild(v){return new h(v,this._strict,this,this._enableTracing)}invokeFunction(v,...a){const u=g.traceInvocation(this._enableTracing,v);let m=!1;try{return v({get:s=>{if(m)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const e=this._getOrCreateServiceInstance(s,u);if(!e)throw new Error(`[invokeFunction] unknown service '${s}'`);return e}},...a)}finally{m=!0,u.stop()}}createInstance(v,...a){let u,m;return v instanceof k.SyncDescriptor?(u=g.traceCreation(this._enableTracing,v.ctor),m=this._createInstance(v.ctor,v.staticArguments.concat(a),u)):(u=g.traceCreation(this._enableTracing,v),m=this._createInstance(v,a,u)),u.stop(),m}_createInstance(v,a=[],u){const m=p._util.getServiceDependencies(v).sort((e,r)=>e.index-r.index),c=[];for(const e of m){const r=this._getOrCreateServiceInstance(e.id,u);r||this._throwIfStrict(`[createInstance] ${v.name} depends on UNKNOWN service ${e.id}.`,!1),c.push(r)}const s=m.length>0?m[0].index:a.length;if(a.length!==s){console.trace(`[createInstance] First service dependency of ${v.name} at position ${s+1} conflicts with ${a.length} static arguments`);const e=s-a.length;e>0?a=a.concat(new Array(e)):a=a.slice(0,s)}return Reflect.construct(v,a.concat(c))}_setServiceInstance(v,a){if(this._services.get(v)instanceof k.SyncDescriptor)this._services.set(v,a);else if(this._parent)this._parent._setServiceInstance(v,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(v){const a=this._services.get(v);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(v):a}_getOrCreateServiceInstance(v,a){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(v));const u=this._getServiceInstanceOrDescriptor(v);return u instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(v,u,a.branch(v,!0)):(a.branch(v,!1),u)}_safeCreateAndCacheServiceInstance(v,a,u){if(this._activeInstantiations.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this._activeInstantiations.add(v);try{return this._createAndCacheServiceInstance(v,a,u)}finally{this._activeInstantiations.delete(v)}}_createAndCacheServiceInstance(v,a,u){const m=new L.Graph(e=>e.id.toString());let c=0;const s=[{id:v,desc:a,_trace:u}];for(;s.length;){const e=s.pop();if(m.lookupOrInsertNode(e),c++>1e3)throw new P(m);for(const r of p._util.getServiceDependencies(e.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(r.id);if(t||this._throwIfStrict(`[createInstance] ${v} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(e.id),String(r.id)),t instanceof k.SyncDescriptor){const n={id:r.id,desc:t,_trace:e._trace.branch(r.id,!0)};m.insertEdge(e,n),s.push(n)}}}for(;;){const e=m.roots();if(e.length===0){if(!m.isEmpty())throw new P(m);break}for(const{data:r}of e){if(this._getServiceInstanceOrDescriptor(r.id)instanceof k.SyncDescriptor){const n=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,n)}m.removeNode(r)}}return this._getServiceInstanceOrDescriptor(v)}_createServiceInstanceWithOwner(v,a,u=[],m,c){if(this._services.get(v)instanceof k.SyncDescriptor)return this._createServiceInstance(v,a,u,m,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(v,a,u,m,c);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(v,a,u=[],m,c){if(m){const s=new h(void 0,this._strict,this,this._enableTracing);s._globalGraphImplicitDependency=String(v);const e=new Map,r=new D.IdleValue(()=>{const t=s._createInstance(a,u,c);for(const[n,o]of e){const d=t[n];if(typeof d=="function")for(const y of o)d.apply(t,y)}return e.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let y=e.get(n);return y||(y=new f.LinkedList,e.set(n,y)),(C,z,_)=>{const X=y.push([C,z,_]);return(0,b.toDisposable)(X)}}if(n in t)return t[n];const o=r.value;let d=o[n];return typeof d!="function"||(d=d.bind(o),t[n]=d),d},set(t,n,o){return r.value[n]=o,!0}})}else return this._createInstance(a,u,c)}_throwIfStrict(v,a){if(a&&console.warn(v),this._strict)throw new Error(v)}}i.InstantiationService=h;var S;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(S||(S={}));class g{static traceInvocation(v,a){return v?new g(1,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(v,a){return v?new g(0,a.name):g._None}constructor(v,a){this.type=v,this.name=a,this._start=Date.now(),this._dep=[]}branch(v,a){const u=new g(2,v.toString());return this._dep.push([v,a,u]),u}stop(){const v=Date.now()-this._start;g._totals+=v;let a=!1;function u(c,s){const e=[],r=new Array(c+1).join("	");for(const[t,n,o]of s._dep)if(n&&o){a=!0,e.push(`${r}CREATES -> ${t}`);const d=u(c+1,o);d&&e.push(d)}else e.push(`${r}uses -> ${t}`);return e.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(v>2||a)&&g.all.add(m.join(`
`))}}i.Trace=g,g.all=new Set,g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0});var ee=this&&this.__param||function(B,i){return function(D,R){i(D,R,B)}};define(Q[62],Z([0,1,24,2,12,93,22,8]),function(B,i,D,R,b,k,L,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LanguagePackBaseService=i.ILanguagePackService=void 0,i.ILanguagePackService=(0,p.createDecorator)("languagePackService");let l=class extends R.Disposable{constructor(I){super(),this.extensionGalleryService=I}async getAvailableLanguages(){const I=new D.CancellationTokenSource;setTimeout(()=>I.cancel(),1e3);let P;try{P=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const S=P.firstPage.filter(g=>g.properties.localizedLanguages?.length&&g.tags.some(E=>E.startsWith("lp-"))).map(g=>{const E=g.properties.localizedLanguages?.[0],v=this.getLocale(g);return{...this.createQuickPickItem(v,E,g),extensionId:g.identifier.id,galleryExtension:g}});return S.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),S}getLocale(I){return I.tags.find(P=>P.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(I,P,h){const S=P??I;let g;if(S!==I&&(g=`(${I})`),I.toLowerCase()===b.language.toLowerCase()&&(g??="",g+=(0,k.localize)(0,null)),h?.installCount){g??="";const E=h.installCount;let v;E>1e6?v=`${Math.floor(E/1e5)/10}M`:E>1e3?v=`${Math.floor(E/1e3)}K`:v=String(E),g+=` $(cloud-download) ${v}`}return{id:I,label:S,description:g}}};l=ge([ee(0,L.IExtensionGalleryService)],l),i.LanguagePackBaseService=l}),define(Q[9],Z([0,1,31,4,2,12,8]),function(B,i,D,R,b,k,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,L.createDecorator)("logService"),i.ILoggerService=(0,L.createDecorator)("loggerService");function p(){return new Date().toISOString()}var l;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(l=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=l.Info;function f(r,t,n){switch(t){case l.Trace:r.trace(n);break;case l.Debug:r.debug(n);break;case l.Info:r.info(n);break;case l.Warning:r.warn(n);break;case l.Error:r.error(n);break;case l.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}i.log=f;function I(r){let t="";for(let n=0;n<r.length;n++){let o=r[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(n>0?" ":"")+o}return t}i.format=I;class P extends b.Disposable{constructor(){super(...arguments),this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=P;class h extends P{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(l.Trace)&&this.log(l.Trace,I([t,...n]))}debug(t,...n){this.checkLogLevel(l.Debug)&&this.log(l.Debug,I([t,...n]))}info(t,...n){this.checkLogLevel(l.Info)&&this.log(l.Info,I([t,...n]))}warn(t,...n){this.checkLogLevel(l.Warning)&&this.log(l.Warning,I([t,...n]))}error(t,...n){if(this.checkLogLevel(l.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(l.Error,I(o))}else this.log(l.Error,I([t,...n]))}critical(t,...n){this.checkLogLevel(l.Critical)&&this.log(l.Critical,I([t,...n]))}flush(){}}i.AbstractMessageLogger=h;class S extends P{constructor(t=i.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!k.isWindows}trace(t,...n){this.getLevel()<=l.Trace&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,t,...n):console.log(`[main ${p()}]`,t,...n))}debug(t,...n){this.getLevel()<=l.Debug&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,t,...n):console.log(`[main ${p()}]`,t,...n))}info(t,...n){this.getLevel()<=l.Info&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,t,...n):console.log(`[main ${p()}]`,t,...n))}warn(t,...n){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,t,...n):console.warn(`[main ${p()}]`,t,...n))}error(t,...n){this.getLevel()<=l.Error&&(this.useColors?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,t,...n):console.error(`[main ${p()}]`,t,...n))}critical(t,...n){this.getLevel()<=l.Critical&&(this.useColors?console.error(`\x1B[90m[main ${p()}]\x1B[0m`,t,...n):console.error(`[main ${p()}]`,t,...n))}dispose(){}flush(){}}i.ConsoleMainLogger=S;class g extends P{constructor(t=i.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...n){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}i.ConsoleLogger=g;class E extends P{constructor(t,n=i.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=l.Trace)}dispose(){}flush(){}}i.AdapterLogger=E;class v extends P{constructor(t){super(),this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const o of this.logServices)o.trace(t,...n)}debug(t,...n){for(const o of this.logServices)o.debug(t,...n)}info(t,...n){for(const o of this.logServices)o.info(t,...n)}warn(t,...n){for(const o of this.logServices)o.warn(t,...n)}error(t,...n){for(const o of this.logServices)o.error(t,...n)}critical(t,...n){for(const o of this.logServices)o.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}i.MultiplexLogService=v;class a extends b.Disposable{constructor(t){super(),this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}i.LogService=a;class u extends b.Disposable{constructor(t,n){super(),this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,n){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,n?.always?l.Trace:this.logLevel,n),this.loggers.set(t.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=u;class m{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(t){}getLevel(){return l.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}i.NullLogService=m;function c(r){if(r.verbose)return l.Trace;if(typeof r.logLevel=="string"){const t=s(r.logLevel.toLowerCase());if(t!==void 0)return t}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=c;function s(r){switch(r){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}i.parseLogLevel=s;function e(r){switch(r){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}i.LogLevelToString=e}),define(Q[110],Z([0,1,19,3,11,4,2,14,60,9]),function(B,i,D,R,b,k,L,p,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class I extends L.Disposable{constructor(h,S){super(),this.logService=h,this.options=S,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new R.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(h,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(h,S):this.watchNonRecursive(h,S)}watchUniversal(h,S){const g={path:this.toFilePath(h),excludes:S.excludes,includes:S.includes,recursive:S.recursive},E=(0,D.insert)(this.universalPathsToWatch,g);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(h=>(0,b.onUnexpectedError)(h))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,l.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)})));const h=this.options?.watcher?.recursive?.usePolling;if(h===!0)for(const S of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const S of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(S)&&h.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(h,S){const g={path:this.toFilePath(h),excludes:S.excludes,includes:S.includes,recursive:!1},E=(0,D.insert)(this.nonRecursivePathsToWatch,g);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(h=>(0,b.onUnexpectedError)(h))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(h=>this._onDidChangeFile.fire((0,l.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(h){h.type==="error"&&this._onDidWatchError.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,p.normalize)(h.fsPath)}}i.AbstractDiskFileSystemProvider=I}),define(Q[111],Z([0,1,19,3,15,24,4,53,63,2,36,17,112,18,43,90,13,59,9]),function(B,i,D,R,b,k,L,p,l,f,I,P,h,S,g,E,v,a,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let m=class extends f.Disposable{constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(s,e){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${s}`);const r=new f.DisposableStore;return this.provider.set(s,e),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:e}),r.add(e.onDidChangeFile(t=>this._onDidFilesChange.fire(new v.FileChangesEvent(t,!this.isPathCaseSensitive(e))))),typeof e.onDidWatchError=="function"&&r.add(e.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),r.add(e.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:e,scheme:s}))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:e}),this.provider.delete(s),(0,f.dispose)(r)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const e=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(r){e.push(r)}}),!this.provider.has(s)&&await R.Promises.settled(e)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,e){const r=this.provider.get(s.scheme);return!!(r&&r.capabilities&e)}listCapabilities(){return l.Iterable.map(this.provider,([s,e])=>({scheme:s,capabilities:e.capabilities}))}async withProvider(s){if(!(0,S.isAbsolutePath)(s))throw new v.FileOperationError((0,E.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const e=this.provider.get(s.scheme);if(!e){const r=new Error;throw r.name="ENOPRO",r.message=(0,E.localize)(1,null,s.toString()),r}return e}async withReadProvider(s){const e=await this.withProvider(s);if((0,v.hasOpenReadWriteCloseCapability)(e)||(0,v.hasReadWriteCapability)(e)||(0,v.hasFileReadStreamCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const e=await this.withProvider(s);if((0,v.hasOpenReadWriteCloseCapability)(e)||(0,v.hasReadWriteCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,e){try{return await this.doResolveFile(s,e)}catch(r){throw(0,v.toFileSystemProviderErrorCode)(r)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,E.localize)(2,null,this.resourceForError(s)),1):(0,v.ensureFileSystemProviderError)(r)}}async doResolveFile(s,e){const r=await this.withProvider(s),t=this.isPathCaseSensitive(r),n=e?.resolveTo,o=e?.resolveSingleChildDescendants,d=e?.resolveMetadata,y=await r.stat(s);let w;return this.toFileStat(r,s,y,void 0,!!d,(C,z)=>(w||(w=I.TernarySearchTree.forUris(()=>!t),w.set(s,!0),n&&w.fill(!0,n)),w.get(C.resource)||w.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&o?z===1:!1))}async toFileStat(s,e,r,t,n,o){const{providerExtUri:d}=this.getExtUri(s),y={resource:e,name:d.basename(e),isFile:(r.type&v.FileType.File)!==0,isDirectory:(r.type&v.FileType.Directory)!==0,isSymbolicLink:(r.type&v.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&v.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,v.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(y.isDirectory&&o(y,t)){try{const w=await s.readdir(e),C=await R.Promises.settled(w.map(async([z,_])=>{try{const X=d.joinPath(e,z),H=n?await s.stat(X):{type:_};return await this.toFileStat(s,X,H,w.length,n,o)}catch(X){return this.logService.trace(X),null}}));y.children=(0,D.coalesce)(C)}catch(w){this.logService.trace(w),y.children=[]}return y}return y}async resolveAll(s){return R.Promises.settled(s.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(s){const e=await this.withProvider(s),r=await e.stat(s);return this.toFileStat(e,s,r,void 0,!0,()=>!1)}async exists(s){const e=await this.withProvider(s);try{return!!await e.stat(s)}catch{return!1}}async canCreateFile(s,e){try{await this.doValidateCreateFile(s,e)}catch(r){return r}return!0}async doValidateCreateFile(s,e){if(!e?.overwrite&&await this.exists(s))throw new v.FileOperationError((0,E.localize)(3,null,this.resourceForError(s)),3,e)}async createFile(s,e=b.VSBuffer.fromString(""),r){await this.doValidateCreateFile(s,r);const t=await this.writeFile(s,e);return this._onDidRunOperation.fire(new v.FileOperationEvent(s,0,t)),t}async writeFile(s,e,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(t);try{await this.validateWriteFile(t,s,r)||await this.mkdirp(t,n.dirname(s));let d;if((0,v.hasReadWriteCapability)(t)&&!(e instanceof b.VSBuffer))if((0,g.isReadableStream)(e)){const y=await(0,g.peekStream)(e,3);y.ended?d=b.VSBuffer.concat(y.buffer):d=y}else d=(0,g.peekReadable)(e,y=>b.VSBuffer.concat(y),3);else d=e;!(0,v.hasOpenReadWriteCloseCapability)(t)||(0,v.hasReadWriteCapability)(t)&&d instanceof b.VSBuffer?await this.doWriteUnbuffered(t,s,r,d):await this.doWriteBuffered(t,s,r,d instanceof b.VSBuffer?(0,b.bufferToReadable)(d):d),this._onDidRunOperation.fire(new v.FileOperationEvent(s,4))}catch(o){throw new v.FileOperationError((0,E.localize)(4,null,this.resourceForError(s),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),r)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,e,r){if(!!r?.unlock&&!(s.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(e)));let n;try{n=await s.stat(e)}catch{return}if((n.type&v.FileType.Directory)!==0)throw new v.FileOperationError((0,E.localize)(6,null,this.resourceForError(e)),0,r);if(this.throwIfFileIsReadonly(e,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==v.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,v.etag)({mtime:r.mtime,size:n.size}))throw new v.FileOperationError((0,E.localize)(7,null),3,r);return n}async readFile(s,e,r){const t=await this.withReadProvider(s);return e?.atomic?this.doReadFileAtomic(t,s,e,r):this.doReadFile(t,s,e,r)}async doReadFileAtomic(s,e,r,t){return new Promise((n,o)=>{this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{try{const d=await this.doReadFile(s,e,r,t);n(d)}catch(d){o(d)}})})}async doReadFile(s,e,r,t){const n=await this.doReadFileStream(s,e,{...r,preferUnbuffered:!0},t);return{...n,value:await(0,b.streamToBuffer)(n.value)}}async readFileStream(s,e,r){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,e,r)}async doReadFileStream(s,e,r,t){const n=new k.CancellationTokenSource(t),o=this.validateReadFile(e,r).then(y=>y,y=>{throw n.cancel(),y});let d;try{return typeof r?.etag=="string"&&r.etag!==v.ETAG_DISABLED&&await o,r?.atomic&&(0,v.hasFileAtomicReadCapability)(s)||!((0,v.hasOpenReadWriteCloseCapability)(s)||(0,v.hasFileReadStreamCapability)(s))||(0,v.hasReadWriteCapability)(s)&&r?.preferUnbuffered?d=this.readFileUnbuffered(s,e,r):(0,v.hasFileReadStreamCapability)(s)?d=this.readFileStreamed(s,e,n.token,r):d=this.readFileBuffered(s,e,n.token,r),{...await o,value:d}}catch(y){d&&await(0,g.consumeStream)(d);const w=(0,E.localize)(8,null,this.resourceForError(e),(0,v.ensureFileSystemProviderError)(y).toString());throw y instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(w,y.stat,r):new v.FileOperationError(w,(0,v.toFileOperationResult)(y),r)}}readFileStreamed(s,e,r,t=Object.create(null)){const n=s.readFileStream(e,t,r);return(0,g.transform)(n,{data:o=>o instanceof b.VSBuffer?o:b.VSBuffer.wrap(o),error:o=>new v.FileOperationError((0,E.localize)(9,null,this.resourceForError(e),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),t)},o=>b.VSBuffer.concat(o))}readFileBuffered(s,e,r,t=Object.create(null)){const n=(0,b.newWriteableBufferStream)();return(0,a.readFileIntoStream)(s,e,n,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new v.FileOperationError((0,E.localize)(10,null,this.resourceForError(e),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),t)},r),n}readFileUnbuffered(s,e,r){const t=(0,g.newWriteableStream)(n=>b.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,v.hasFileAtomicReadCapability)(s)?n=await s.readFile(e,{atomic:!0}):n=await s.readFile(e),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(e,n.byteLength,r),t.end(b.VSBuffer.wrap(n))}catch(n){t.error(n),t.end()}})(),t}async validateReadFile(s,e){const r=await this.resolve(s,{resolveMetadata:!0});if(r.isDirectory)throw new v.FileOperationError((0,E.localize)(11,null,this.resourceForError(s)),0,e);if(typeof e?.etag=="string"&&e.etag!==v.ETAG_DISABLED&&e.etag===r.etag)throw new v.NotModifiedSinceFileOperationError((0,E.localize)(12,null),r,e);return this.validateReadFileLimits(s,r.size,e),r}validateReadFileLimits(s,e,r){if(r?.limits){let t;if(typeof r.limits.memory=="number"&&e>r.limits.memory&&(t=9),typeof r.limits.size=="number"&&e>r.limits.size&&(t=7),typeof t=="number")throw new v.FileOperationError((0,E.localize)(13,null,this.resourceForError(s)),t)}}async canMove(s,e,r){return this.doCanMoveCopy(s,e,"move",r)}async canCopy(s,e,r){return this.doCanMoveCopy(s,e,"copy",r)}async doCanMoveCopy(s,e,r,t){if(s.toString()!==e.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);await this.doValidateMoveCopy(n,s,o,e,r,t)}catch(n){return n}return!0}async move(s,e,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,n,e,"move",!!r),d=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(s,o==="move"?2:3,d)),d}async copy(s,e,r){const t=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,n,e,"copy",!!r),d=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(s,o==="copy"?3:2,d)),d}async doMoveCopy(s,e,r,t,n,o){if(e.toString()===t.toString())return n;const{exists:d,isSameResourceWithDifferentPathCase:y}=await this.doValidateMoveCopy(s,e,r,t,n,o);if(d&&!y&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(t)),n==="copy"){if(s===r&&(0,v.hasFileFolderCopyCapability)(s))await s.copy(e,t,{overwrite:o});else{const w=await this.resolve(e);w.isDirectory?await this.doCopyFolder(s,w,r,t):await this.doCopyFile(s,e,r,t)}return n}else return s===r?(await s.rename(e,t,{overwrite:o}),n):(await this.doMoveCopy(s,e,r,t,"copy",o),await this.del(e,{recursive:!0}),"copy")}async doCopyFile(s,e,r,t){if((0,v.hasOpenReadWriteCloseCapability)(s)&&(0,v.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(s,e,r,t);if((0,v.hasOpenReadWriteCloseCapability)(s)&&(0,v.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(s,e,r,t);if((0,v.hasReadWriteCapability)(s)&&(0,v.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(s,e,r,t);if((0,v.hasReadWriteCapability)(s)&&(0,v.hasReadWriteCapability)(r))return this.doPipeUnbuffered(s,e,r,t)}async doCopyFolder(s,e,r,t){await r.mkdir(t),Array.isArray(e.children)&&await R.Promises.settled(e.children.map(async n=>{const o=this.getExtUri(r).providerExtUri.joinPath(t,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),r,o):this.doCopyFile(s,n.resource,r,o)}))}async doValidateMoveCopy(s,e,r,t,n,o){let d=!1;if(s===r){const{providerExtUri:w,isPathCaseSensitive:C}=this.getExtUri(s);if(C||(d=w.isEqual(e,t)),d&&n==="copy")throw new Error((0,E.localize)(14,null,this.resourceForError(e),this.resourceForError(t)));if(!d&&w.isEqualOrParent(t,e))throw new Error((0,E.localize)(15,null,this.resourceForError(e),this.resourceForError(t)))}const y=await this.exists(t);if(y&&!d){if(!o)throw new v.FileOperationError((0,E.localize)(16,null,this.resourceForError(e),this.resourceForError(t)),4);if(s===r){const{providerExtUri:w}=this.getExtUri(s);if(w.isEqualOrParent(e,t))throw new Error((0,E.localize)(17,null,this.resourceForError(e),this.resourceForError(t)))}}return{exists:y,isSameResourceWithDifferentPathCase:d}}getExtUri(s){const e=this.isPathCaseSensitive(s);return{providerExtUri:e?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:e}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(e,s);const r=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(s,0,r)),r}async mkdirp(s,e){const r=[],{providerExtUri:t}=this.getExtUri(s);for(;!t.isEqual(e,t.dirname(e));)try{if(((await s.stat(e)).type&v.FileType.Directory)===0)throw new Error((0,E.localize)(18,null,this.resourceForError(e)));break}catch(n){if((0,v.toFileSystemProviderErrorCode)(n)!==v.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(t.basename(e)),e=t.dirname(e)}for(let n=r.length-1;n>=0;n--){e=t.joinPath(e,r[n]);try{await s.mkdir(e)}catch(o){if((0,v.toFileSystemProviderErrorCode)(o)!==v.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,e){try{await this.doValidateDelete(s,e)}catch(r){return r}return!0}async doValidateDelete(s,e){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!e?.useTrash&&!(r.capabilities&4096))throw new Error((0,E.localize)(19,null,this.resourceForError(s)));let n;try{n=await r.stat(s)}catch{}if(n)this.throwIfFileIsReadonly(s,n);else throw new v.FileOperationError((0,E.localize)(20,null,this.resourceForError(s)),1);if(!!!e?.recursive){const d=await this.resolve(s);if(d.isDirectory&&Array.isArray(d.children)&&d.children.length>0)throw new Error((0,E.localize)(21,null,this.resourceForError(s)))}return r}async del(s,e){const r=await this.doValidateDelete(s,e),t=!!e?.useTrash,n=!!e?.recursive;await r.delete(s,{recursive:n,useTrash:t}),this._onDidRunOperation.fire(new v.FileOperationEvent(s,1))}async cloneFile(s,e){const r=await this.withProvider(s),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);if(r===t&&this.getExtUri(r).providerExtUri.isEqual(s,e))return;if(r===t&&(0,v.hasFileCloneCapability)(r))return r.cloneFile(s,e);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(e));const n=this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri);return r===t&&(0,v.hasFileFolderCopyCapability)(r)?n.queue(()=>r.copy(s,e,{overwrite:!0})):n.queue(()=>this.doCopyFile(r,s,t,e))}watch(s,e={recursive:!1,excludes:[]}){const r=new f.DisposableStore;let t=!1,n=()=>{t=!0};return r.add((0,f.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(s,e);t?(0,f.dispose)(o):n=()=>(0,f.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(s,e){const r=await this.withProvider(s),t=(0,p.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(s),e]);let n=this.activeWatchers.get(t);return n||(n={count:0,disposable:r.watch(s,e)},this.activeWatchers.set(t,n)),n.count+=1,(0,f.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,f.dispose)(n.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,f.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,e,r,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{const n=await s.open(e,{create:!0,unlock:r?.unlock??!1});try{(0,g.isReadableStream)(t)||(0,g.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(s,n,t):await this.doWriteReadableBufferedQueued(s,n,t)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await s.close(n)}})}async doWriteStreamBufferedQueued(s,e,r){let t=0,n;if((0,g.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=b.VSBuffer.concat(r.buffer);await this.doWriteBuffer(s,e,o,o.byteLength,t,0),t+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,d)=>{(0,g.listenStream)(n,{onData:async y=>{n.pause();try{await this.doWriteBuffer(s,e,y,y.byteLength,t,0)}catch(w){return d(w)}t+=y.byteLength,setTimeout(()=>n.resume())},onError:y=>d(y),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,e,r){let t=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(s,e,n,n.byteLength,t,0),t+=n.byteLength}async doWriteBuffer(s,e,r,t,n,o){let d=0;for(;d<t;)d+=await s.write(e,n+d,r.buffer,o+d,t-d)}async doWriteUnbuffered(s,e,r,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,e,r,t))}async doWriteUnbufferedQueued(s,e,r,t){let n;t instanceof b.VSBuffer?n=t:(0,g.isReadableStream)(t)?n=await(0,b.streamToBuffer)(t):(0,g.isReadableBufferedStream)(t)?n=await(0,b.bufferedStreamToBuffer)(t):n=(0,b.readableToBuffer)(t),await s.writeFile(e,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(s,e,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,e,r,t))}async doPipeBufferedQueued(s,e,r,t){let n,o;try{n=await s.open(e,{create:!1}),o=await r.open(t,{create:!0,unlock:!1});const d=b.VSBuffer.alloc(this.BUFFER_SIZE);let y=0,w=0,C=0;do C=await s.read(n,y,d.buffer,w,d.byteLength-w),await this.doWriteBuffer(r,o,d,C,y,w),y+=C,w+=C,w===d.byteLength&&(w=0);while(C>0)}catch(d){throw(0,v.ensureFileSystemProviderError)(d)}finally{await R.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,e,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,e,r,t))}async doPipeUnbufferedQueued(s,e,r,t){return r.writeFile(t,await s.readFile(e),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,e,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,e,r,t))}async doPipeUnbufferedToBufferedQueued(s,e,r,t){const n=await r.open(t,{create:!0,unlock:!1});try{const o=await s.readFile(e);await this.doWriteBuffer(r,n,b.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(s,e,r,t){const n=await(0,b.streamToBuffer)(this.readFileBuffered(s,e,k.CancellationToken.None));await this.doWriteUnbuffered(r,t,void 0,n)}throwIfFileSystemIsReadonly(s,e){if(s.capabilities&2048)throw new v.FileOperationError((0,E.localize)(22,null,this.resourceForError(e)),6);return s}throwIfFileIsReadonly(s,e){if((e.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,E.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===P.Schemas.file?s.fsPath:s.toString(!0)}};m=ge([ee(0,u.ILogService)],m),i.FileService=m}),define(Q[113],Z([0,1,114,153,3,36,15,4,154,2,14,12,18,43,20,92,13,59,110,31,108,107]),function(B,i,D,R,b,k,L,p,l,f,I,P,h,S,g,E,v,a,u,m,c,s){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(r)}`)}})();class e extends u.AbstractDiskFileSystemProvider{constructor(t,n){super(t,n),this.onDidChangeCapabilities=p.Event.None,this.resourceLocks=new k.ResourceMap(o=>h.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:n,symbolicLink:o}=await g.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(t){try{const n=await g.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async d=>{try{let y;d.isSymbolicLink()?y=(await this.stat((0,h.joinPath)(t,d.name))).type:y=this.toType(d),o.push([d.name,y])}catch(y){this.logService.trace(y)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(t,n){let o;return n?.dangling?o=v.FileType.Unknown:t.isFile()?o=v.FileType.File:t.isDirectory()?o=v.FileType.Directory:o=v.FileType.Unknown,n&&(o|=v.FileType.SymbolicLink),o}async createResourceLock(t){const n=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const d=new b.Barrier;return this.resourceLocks.set(t,d),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,f.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(t)===d&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),d.open()})}async readFile(t,n){let o;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const d=this.toFilePath(t);return await g.Promises.readFile(d)}catch(d){throw this.toFileSystemProviderError(d)}finally{o?.dispose()}}traceLock(t){e.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,n,o){const d=(0,S.newWriteableStream)(y=>L.VSBuffer.concat(y.map(w=>L.VSBuffer.wrap(w))).buffer);return(0,a.readFileIntoStream)(this,t,d,y=>y.buffer,{...n,bufferSize:256*1024},o),d}async writeFile(t,n,o){let d;try{const y=this.toFilePath(t);if(!o.create||!o.overwrite){if(await g.Promises.exists(y)){if(!o.overwrite)throw(0,v.createFileSystemProviderError)((0,E.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,v.createFileSystemProviderError)((0,E.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}d=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(d,0,n,0,n.byteLength)}catch(y){throw await this.toFileSystemProviderWriteError(t,y)}finally{typeof d=="number"&&await this.close(d)}}static configureFlushOnWrite(t){e.canFlush=t}async open(t,n){const o=this.toFilePath(t);let d;(0,v.isFileOpenForWriteOptions)(n)&&(d=await this.createResourceLock(t));let y;try{if((0,v.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:C}=await g.SymlinkSupport.stat(o);C.mode&128||await g.Promises.chmod(o,C.mode|128)}catch(C){this.logService.trace(C)}let w;if((0,v.isFileOpenForWriteOptions)(n)){if(P.isWindows)try{await g.Promises.truncate(o,0),w="r+"}catch(C){C.code!=="ENOENT"&&this.logService.trace(C)}w||(w="w")}else w="r";y=await g.Promises.open(o,w)}catch(w){throw d?.dispose(),(0,v.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(t,w):this.toFileSystemProviderError(w)}if(this.mapHandleToPos.set(y,0),(0,v.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(y,t),d){const w=this.mapHandleToLock.get(y);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${y} (${o})`),this.mapHandleToLock.set(y,d),w&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${y} (${o})`),w.dispose())}return y}async close(t){const n=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&e.canFlush)try{await g.Promises.fdatasync(t)}catch(o){e.configureFlushOnWrite(!1),this.logService.error(o)}return await g.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(t)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,o,d,y){const w=this.normalizePos(t,n);let C=null;try{C=(await g.Promises.read(t,o,d,y,w)).bytesRead}catch(z){throw this.toFileSystemProviderError(z)}finally{this.updatePos(t,w,C)}return C}normalizePos(t,n){return n===this.mapHandleToPos.get(t)?null:n}updatePos(t,n,o){const d=this.mapHandleToPos.get(t);typeof d=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,d+o):this.mapHandleToPos.delete(t)))}async write(t,n,o,d,y){return(0,b.retry)(()=>this.doWrite(t,n,o,d,y),100,3)}async doWrite(t,n,o,d,y){const w=this.normalizePos(t,n);let C=null;try{C=(await g.Promises.write(t,o,d,y,w)).bytesWritten}catch(z){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),z)}finally{this.updatePos(t,w,C)}return C}async mkdir(t){try{await g.Promises.mkdir(this.toFilePath(t))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(t,n){try{const o=this.toFilePath(t);n.recursive?await g.Promises.rm(o,g.RimRafMode.MOVE):await g.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,n,o){const d=this.toFilePath(t),y=this.toFilePath(n);if(d!==y)try{await this.validateTargetDeleted(t,n,"move",o.overwrite),await g.Promises.move(d,y)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,E.localize)(2,null,(0,I.basename)(d),(0,I.basename)((0,I.dirname)(y)),w.toString()))),this.toFileSystemProviderError(w)}}async copy(t,n,o){const d=this.toFilePath(t),y=this.toFilePath(n);if(d!==y)try{await this.validateTargetDeleted(t,n,"copy",o.overwrite),await g.Promises.copy(d,y,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,E.localize)(3,null,(0,I.basename)(d),(0,I.basename)((0,I.dirname)(y)),w.toString()))),this.toFileSystemProviderError(w)}}async validateTargetDeleted(t,n,o,d){const y=this.toFilePath(t),w=this.toFilePath(n);let C=!1;if(!!(this.capabilities&1024)||(C=(0,l.isEqual)(y,w,!0)),C&&o==="copy")throw(0,v.createFileSystemProviderError)((0,E.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(!C&&await g.Promises.exists(w)){if(!d)throw(0,v.createFileSystemProviderError)((0,E.localize)(5,null),v.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(t,n){return this.doCloneFile(t,n,!1)}async doCloneFile(t,n,o){const d=this.toFilePath(t),y=this.toFilePath(n),w=!!(this.capabilities&1024);if((0,l.isEqual)(d,y,!w))return;const C=new f.DisposableStore;try{const[z,_]=await Promise.all([this.createResourceLock(t),this.createResourceLock(n)]);C.add(z),C.add(_),o&&await g.Promises.mkdir((0,I.dirname)(y),{recursive:!0}),await g.Promises.copyFile(d,y)}catch(z){if(z.code==="ENOENT"&&!o)return this.doCloneFile(t,n,!0);throw this.toFileSystemProviderError(z)}finally{C.dispose()}}createUniversalWatcher(t,n,o){return new c.UniversalWatcherClient(d=>t(d),d=>n(d),o)}createNonRecursiveWatcher(t,n,o){return new s.NodeJSWatcherClient(d=>t(d),d=>n(d),o)}toFileSystemProviderError(t){if(t instanceof v.FileSystemProviderError)return t;let n;switch(t.code){case"ENOENT":n=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=v.FileSystemProviderErrorCode.NoPermissions;break;default:n=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(t,n)}async toFileSystemProviderWriteError(t,n){let o=this.toFileSystemProviderError(n);if(t&&o.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await g.SymlinkSupport.stat(this.toFilePath(t));d.mode&128||(o=(0,v.createFileSystemProviderError)(n,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.logService.trace(d)}return o}}i.DiskFileSystemProvider=e,e.TRACE_LOG_RESOURCE_LOCKS=!1,e.canFlush=!0}),define(Q[115],Z([0,1,13,9]),function(B,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function b(p,l,f,I,P){try{const h=await new Promise((g,E)=>{B(["spdlog"],g,E)});h.setFlushOn(R.LogLevel.Trace);const S=await h.createAsyncRotatingLogger(p,l,f,I);return P?S.clearFormatters():S.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),S}catch(h){console.error(h)}return null}function k(p,l,f){switch(l){case R.LogLevel.Trace:p.trace(f);break;case R.LogLevel.Debug:p.debug(f);break;case R.LogLevel.Info:p.info(f);break;case R.LogLevel.Warning:p.warn(f);break;case R.LogLevel.Error:p.error(f);break;case R.LogLevel.Critical:p.critical(f);break;default:throw new Error("Invalid log level")}}class L extends R.AbstractMessageLogger{constructor(l,f,I,P,h){super(),this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(l,f,I,P),this._register(this.onDidChangeLogLevel(S=>{this._logger?.setLevel(S)}))}async _createSpdLogLogger(l,f,I,P){const h=I?6:1,S=30/h*D.ByteSize.MB,g=await b(l,f,S,h,P);if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:E,message:v}of this.buffer)k(this._logger,E,v);this.buffer=[]}}log(l,f){this._logger?k(this._logger,l,f):this.getLevel()<=l&&this.buffer.push({level:l,message:f})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=L}),define(Q[37],Z([0,1,4,63,2,8]),function(B,i,D,R,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NullPolicyService=i.AbstractPolicyService=i.IPolicyService=void 0,i.IPolicyService=(0,k.createDecorator)("policy");class L extends b.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(f){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...f,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(f),R.Iterable.reduce(this.policies.entries(),(P,[h,S])=>({...P,[h]:S}),{})}getPolicyValue(f){return this.policies.get(f)}serialize(){return R.Iterable.reduce(Object.entries(this.policyDefinitions),(f,[I,P])=>({...f,[I]:{definition:P,value:this.policies.get(I)}}),{})}}i.AbstractPolicyService=L;class p{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}i.NullPolicyService=p}),define(Q[116],Z([0,1,3,4,63,5,13,9,37]),function(B,i,D,R,b,k,L,p,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FilePolicyService=void 0;function f(P,h){const S=[];for(const g of b.Iterable.concat(P.keys(),h.keys()))P.get(g)!==h.get(g)&&S.push(g);return S}let I=class extends l.AbstractPolicyService{constructor(h,S,g){super(),this.file=h,this.fileService=S,this.logService=g,this.throttledDelayer=this._register(new D.ThrottledDelayer(500));const E=R.Event.filter(S.onDidFilesChange,v=>v.affects(h));this._register(S.watch(h)),this._register(E(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(h){await this.refresh()}async read(){const h=new Map;try{const S=await this.fileService.readFile(this.file),g=JSON.parse(S.value.toString());if(!(0,k.isObject)(g))throw new Error("Policy file isn't a JSON object");for(const E of Object.keys(g))this.policyDefinitions[E]&&h.set(E,g[E])}catch(S){S.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",S)}return h}async refresh(){const h=await this.read(),S=f(this.policies,h);this.policies=h,S.length>0&&this._onDidChange.fire(S)}};I=ge([ee(1,L.IFileService),ee(2,p.ILogService)],I),i.FilePolicyService=I}),define(Q[28],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,D.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(Q[33],Z([0,1,68,5]),function(B,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class b{constructor(){this.data=new Map}add(L,p){D.ok(R.isString(L)),D.ok(R.isObject(p)),D.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,p)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}i.Registry=new b}),define(Q[117],Z([0,1,4,33]),function(B,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function b(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class k{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,f){this.schemasById[b(l)]=f,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new k;R.Registry.add(i.Extensions.JSONContribution,L)}),define(Q[40],Z([0,1,19,4,5,81,21,117,33]),function(B,i,D,R,b,k,L,p,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var f;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(f=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var I;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=l.Registry.as(p.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},P.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(e,r=!0){this.registerConfigurations([e],r)}registerConfigurations(e,r=!0){const t=this.doRegisterConfigurations(e,r);P.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(e){const r=this.doDeregisterConfigurations(e);P.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:e,remove:r}){const t=[];t.push(...this.doDeregisterConfigurations(r)),t.push(...this.doRegisterConfigurations(e,!1)),P.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(e){const r=[],t=[];for(const{overrides:n,source:o}of e)for(const d in n)if(r.push(d),i.OVERRIDE_PROPERTY_REGEX.test(d)){const y=this.configurationDefaultsOverrides.get(d),w=y?.valuesSources??new Map;if(o)for(const X of Object.keys(n[d]))w.set(X,o);const C={...y?.value||{},...n[d]};this.configurationDefaultsOverrides.set(d,{source:o,value:C,valuesSources:w});const z=(0,L.getLanguageTagSettingPlainKey)(d),_={type:"object",default:C,description:k.localize(1,null,z),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:C,source:b.isString(o)?void 0:o,defaultValueSource:o};t.push(...E(d)),this.configurationProperties[d]=_,this.defaultLanguageConfigurationOverridesNode.properties[d]=_}else{this.configurationDefaultsOverrides.set(d,{value:n[d],source:o});const y=this.configurationProperties[d];y&&(this.updatePropertyDefaultValue(d,y),this.updateSchema(d,y))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(e){const r=[];for(const{overrides:t,source:n}of e)for(const o in t){const d=this.configurationDefaultsOverrides.get(o),y=b.isString(n)?n:n?.id,w=b.isString(d?.source)?d?.source:d?.source?.id;if(y===w)if(r.push(o),this.configurationDefaultsOverrides.delete(o),i.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const C=this.configurationProperties[o];C&&(this.updatePropertyDefaultValue(o,C),this.updateSchema(o,C))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const r of e)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(e,r){const t=[];return e.forEach(n=>{t.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),t}doDeregisterConfigurations(e){const r=[],t=n=>{if(n.properties)for(const o in n.properties){r.push(o);const d=this.configurationProperties[o];d?.policy?.name&&this.policyConfigurations.delete(d.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>t(o))};for(const n of e){t(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(e,r=!0,t,n,o=3){o=b.isUndefinedOrNull(e.scope)?o:e.scope;const d=[],y=e.properties;if(y)for(const C in y){const z=y[C];if(r&&m(C,z)){delete y[C];continue}if(z.source=t,z.defaultDefaultValue=y[C].default,this.updatePropertyDefaultValue(C,z),i.OVERRIDE_PROPERTY_REGEX.test(C)?z.scope=void 0:(z.scope=b.isUndefinedOrNull(z.scope)?o:z.scope,z.restricted=b.isUndefinedOrNull(z.restricted)?!!n?.includes(C):z.restricted),y[C].hasOwnProperty("included")&&!y[C].included){this.excludedConfigurationProperties[C]=y[C],delete y[C];continue}else this.configurationProperties[C]=y[C],y[C].policy?.name&&this.policyConfigurations.set(y[C].policy.name,C);!y[C].deprecationMessage&&y[C].markdownDeprecationMessage&&(y[C].deprecationMessage=y[C].markdownDeprecationMessage),d.push(C)}const w=e.allOf;if(w)for(const C of w)d.push(...this.validateAndRegisterProperties(C,r,t,n,o));return d}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(e){const r=t=>{const n=t.properties;if(n)for(const d in n)this.updateSchema(d,n[d]);t.allOf?.forEach(r)};r(e)}updateSchema(e,r){switch(i.allSettings.properties[e]=r,r.scope){case 1:i.applicationSettings.properties[e]=r;break;case 2:i.machineSettings.properties[e]=r;break;case 6:i.machineOverridableSettings.properties[e]=r;break;case 3:i.windowSettings.properties[e]=r;break;case 4:i.resourceSettings.properties[e]=r;break;case 5:i.resourceSettings.properties[e]=r,this.resourceLanguageSettingsSchema.properties[e]=r;break}}removeFromSchema(e,r){switch(delete i.allSettings.properties[e],r.scope){case 1:delete i.applicationSettings.properties[e];break;case 2:delete i.machineSettings.properties[e];break;case 6:delete i.machineOverridableSettings.properties[e];break;case 3:delete i.windowSettings.properties[e];break;case 4:case 5:delete i.resourceSettings.properties[e],delete this.resourceLanguageSettingsSchema.properties[e];break}}updateOverridePropertyPatternKey(){for(const e of this.overrideIdentifiers.values()){const r=`[${e}]`,t={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,t),i.allSettings.properties[r]=t,i.applicationSettings.properties[r]=t,i.machineSettings.properties[r]=t,i.machineOverridableSettings.properties[r]=t,i.windowSettings.properties[r]=t,i.resourceSettings.properties[r]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const e={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(e,r){const t=this.configurationDefaultsOverrides.get(e);let n=t?.value,o=t?.source;b.isUndefined(n)&&(n=r.defaultDefaultValue,o=void 0),b.isUndefined(n)&&(n=a(r.type)),r.default=n,r.defaultValueSource=o}}const S="\\[([^\\]]+)\\]",g=new RegExp(S,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function E(s){const e=[];if(i.OVERRIDE_PROPERTY_REGEX.test(s)){let r=g.exec(s);for(;r?.length;){const t=r[1].trim();t&&e.push(t),r=g.exec(s)}}return(0,D.distinct)(e)}i.overrideIdentifiersFromKey=E;function v(s){return s.reduce((e,r)=>`${e}[${r}]`,"")}i.keyFromOverrideIdentifiers=v;function a(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=a;const u=new h;l.Registry.add(i.Extensions.Configuration,u);function m(s,e){return s.trim()?i.OVERRIDE_PROPERTY_REGEX.test(s)?k.localize(7,null,s):u.getConfigurationProperties()[s]!==void 0?k.localize(8,null,s):e.policy?.name&&u.getPolicyConfigurations().get(e.policy?.name)!==void 0?k.localize(9,null,s,e.policy?.name,u.getPolicyConfigurations().get(e.policy?.name)):null:k.localize(6,null)}i.validateProperty=m;function c(){const s=[],e=u.getConfigurationProperties();for(const r of Object.keys(e))s.push([r,e[r].scope]);return s.push(["launch",4]),s.push(["task",4]),s}i.getScopes=c}),define(Q[64],Z([0,1,19,4,50,2,36,26,5,10,21,40,33]),function(B,i,D,R,b,k,L,p,l,f,I,P,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.ConfigurationModel=void 0;class S{constructor(e={},r=[],t=[],n){this._contents=e,this._keys=r,this._overrides=t,this.raw=n,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const e=this.raw.map(r=>{if(r instanceof S)return r;const t=new g("");return t.parseRaw(r),t.configurationModel});this._rawConfiguration=e.reduce((r,t)=>t===r?t:r.merge(t),e[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(e){return e?(0,I.getConfigurationValue)(this.contents,e):this.contents}inspect(e,r){const t=this.rawConfiguration.getValue(e),n=r?this.rawConfiguration.getOverrideValue(e,r):void 0,o=r?this.rawConfiguration.override(r).getValue(e):t;return{value:t,override:n,merged:o}}getOverrideValue(e,r){const t=this.getContentsForOverrideIdentifer(r);return t?e?(0,I.getConfigurationValue)(t,e):t:void 0}getKeysForOverrideIdentifier(e){const r=[];for(const t of this.overrides)t.identifiers.includes(e)&&r.push(...t.keys);return D.distinct(r)}getAllOverrideIdentifiers(){const e=[];for(const r of this.overrides)e.push(...r.identifiers);return D.distinct(e)}override(e){let r=this.overrideConfigurations.get(e);return r||(r=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,r)),r}merge(...e){const r=p.deepClone(this.contents),t=p.deepClone(this.overrides),n=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const d of e)if(o.push(...d.raw?.length?d.raw:[d]),!d.isEmpty()){this.mergeContents(r,d.contents);for(const y of d.overrides){const[w]=t.filter(C=>D.equals(C.identifiers,y.identifiers));w?(this.mergeContents(w.contents,y.contents),w.keys.push(...y.keys),w.keys=D.distinct(w.keys)):t.push(p.deepClone(y))}for(const y of d.keys)n.indexOf(y)===-1&&n.push(y)}return new S(r,n,t,o.every(d=>d instanceof S)?void 0:o)}freeze(){return this.frozen=!0,this}clone(){return new S(p.deepClone(this.contents),[...this.keys],p.deepClone(this.overrides))}createOverrideConfigurationModel(e){const r=this.getContentsForOverrideIdentifer(e);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const t={};for(const n of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let o=this.contents[n];const d=r[n];d&&(typeof o=="object"&&typeof d=="object"?(o=p.deepClone(o),this.mergeContents(o,d)):o=d),t[n]=o}return new S(t,this.keys,this.overrides)}mergeContents(e,r){for(const t of Object.keys(r)){if(t in e&&l.isObject(e[t])&&l.isObject(r[t])){this.mergeContents(e[t],r[t]);continue}e[t]=p.deepClone(r[t])}}checkAndFreeze(e){return this.frozen&&!Object.isFrozen(e)?p.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let r=null,t=null;const n=o=>{o&&(t?this.mergeContents(t,o):t=p.deepClone(o))};for(const o of this.overrides)D.equals(o.identifiers,[e])?r=o.contents:o.identifiers.includes(e)&&n(o.contents);return n(r),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,r){this.addKey(e),(0,I.addToValueTree)(this.contents,e,r,t=>{throw new Error(t)})}removeValue(e){this.removeKey(e)&&(0,I.removeFromValueTree)(this.contents,e)}addKey(e){let r=this.keys.length;for(let t=0;t<r;t++)e.indexOf(this.keys[t])===0&&(r=t);this.keys.splice(r,1,e)}removeKey(e){const r=this.keys.indexOf(e);return r!==-1?(this.keys.splice(r,1),!0):!1}}i.ConfigurationModel=S;class g{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,r){if(!l.isUndefinedOrNull(e)){const t=this.doParseContent(e);this.parseRaw(t,r)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,r){this._raw=e;const{contents:t,keys:n,overrides:o,restricted:d,hasExcludedProperties:y}=this.doParseRaw(e,r);this._configurationModel=new S(t,n,o,y?[e]:void 0),this._restrictedConfigurations=d||[]}doParseContent(e){let r={},t=null,n=[];const o=[],d=[];function y(C){Array.isArray(n)?n.push(C):t!==null&&(n[t]=C)}const w={onObjectBegin:()=>{const C={};y(C),o.push(n),n=C,t=null},onObjectProperty:C=>{t=C},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const C=[];y(C),o.push(n),n=C,t=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:y,onError:(C,z,_)=>{d.push({error:C,offset:z,length:_})}};if(e)try{b.visit(e,w),r=n[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return r}doParseRaw(e,r){const t=h.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),n=this.filter(e,t,!0,r);e=n.raw;const o=(0,I.toValuesTree)(e,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),d=Object.keys(e),y=this.toOverrides(e,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:o,keys:d,overrides:y,restricted:n.restricted,hasExcludedProperties:n.hasExcludedProperties}}filter(e,r,t,n){let o=!1;if(!n?.scopes&&!n?.skipRestricted)return{raw:e,restricted:[],hasExcludedProperties:o};const d={},y=[];for(const w in e)if(P.OVERRIDE_PROPERTY_REGEX.test(w)&&t){const C=this.filter(e[w],r,!1,n);d[w]=C.raw,o=o||C.hasExcludedProperties,y.push(...C.restricted)}else{const C=r[w],z=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&y.push(w),(z===void 0||n.scopes===void 0||n.scopes.includes(z))&&!(n.skipRestricted&&C?.restricted)?d[w]=e[w]:o=!0}return{raw:d,restricted:y,hasExcludedProperties:o}}toOverrides(e,r){const t=[];for(const n of Object.keys(e))if(P.OVERRIDE_PROPERTY_REGEX.test(n)){const o={};for(const d in e[n])o[d]=e[n][d];t.push({identifiers:(0,P.overrideIdentifiersFromKey)(n),keys:Object.keys(o),contents:(0,I.toValuesTree)(o,r)})}return t}}i.ConfigurationModelParser=g;class E extends k.Disposable{constructor(e,r,t,n){super(),this.userSettingsResource=e,this.scopes=r,this.fileService=n,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.any(R.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),R.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,e)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=E;class v{constructor(e,r,t,n,o=new S,d=new S,y=new L.ResourceMap,w=new S,C=new L.ResourceMap,z=!0){this._defaultConfiguration=e,this._policyConfiguration=r,this._applicationConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=d,this._folderConfigurations=y,this._memoryConfiguration=w,this._memoryConfigurationByResource=C,this._freeze=z,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(e,r,t){return this.getConsolidatedConfigurationModel(e,r,t).getValue(e)}updateValue(e,r,t={}){let n;t.resource?(n=this._memoryConfigurationByResource.get(t.resource),n||(n=new S,this._memoryConfigurationByResource.set(t.resource,n))):n=this._memoryConfiguration,r===void 0?n.removeValue(e):n.setValue(e,r),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,r,t){const n=this.getConsolidatedConfigurationModel(e,r,t),o=this.getFolderConfigurationModelForResource(r.resource,t),d=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,y=this._defaultConfiguration.inspect(e,r.overrideIdentifier),w=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(e),C=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(e),z=this.userConfiguration.freeze().inspect(e,r.overrideIdentifier),_=this.localUserConfiguration.freeze().inspect(e,r.overrideIdentifier),X=this.remoteUserConfiguration.freeze().inspect(e,r.overrideIdentifier),H=t?this._workspaceConfiguration.freeze().inspect(e,r.overrideIdentifier):void 0,ne=o?o.freeze().inspect(e,r.overrideIdentifier):void 0,re=d.inspect(e,r.overrideIdentifier),se=n.getValue(e),fe=D.distinct(n.overrides.map(le=>le.identifiers).flat()).filter(le=>n.getOverrideValue(e,le)!==void 0);return{defaultValue:y?y.merged:void 0,policyValue:w?w.merged:void 0,applicationValue:C?C.merged:void 0,userValue:z?z.merged:void 0,userLocalValue:_?_.merged:void 0,userRemoteValue:X?X.merged:void 0,workspaceValue:H?H.merged:void 0,workspaceFolderValue:ne?ne.merged:void 0,memoryValue:re?re.merged:void 0,value:se,default:y.value!==void 0||y.override!==void 0?{value:y.value,override:y.override}:void 0,policy:w?.value!==void 0?{value:w.value}:void 0,application:C?.value!==void 0||C?.override!==void 0?{value:C.value,override:C.override}:void 0,user:z.value!==void 0||z.override!==void 0?{value:z.value,override:z.override}:void 0,userLocal:_.value!==void 0||_.override!==void 0?{value:_.value,override:_.override}:void 0,userRemote:X.value!==void 0||X.override!==void 0?{value:X.value,override:X.override}:void 0,workspace:H?.value!==void 0||H?.override!==void 0?{value:H.value,override:H.override}:void 0,workspaceFolder:ne?.value!==void 0||ne?.override!==void 0?{value:ne.value,override:ne.override}:void 0,memory:re.value!==void 0||re.override!==void 0?{value:re.value,override:re.override}:void 0,overrideIdentifiers:fe.length?fe:void 0}}keys(e){const r=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(e){this._policyConfiguration=e}updateApplicationConfiguration(e){this._applicationConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,r){this._folderConfigurations.set(e,r),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,r){const t=[];if(!r){const{added:n,updated:o,removed:d}=m(this._defaultConfiguration,e);r=[...n,...o,...d]}for(const n of r)for(const o of(0,P.overrideIdentifiersFromKey)(n)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(o),y=e.getKeysForOverrideIdentifier(o),w=[...y.filter(C=>d.indexOf(C)===-1),...d.filter(C=>y.indexOf(C)===-1),...d.filter(C=>!p.equals(this._defaultConfiguration.override(o).getValue(C),e.override(o).getValue(C)))];t.push([o,w])}return this.updateDefaultConfiguration(e),{keys:r,overrides:t}}compareAndUpdatePolicyConfiguration(e){const{added:r,updated:t,removed:n}=m(this._policyConfiguration,e),o=[...r,...t,...n];return o.length&&this.updatePolicyConfiguration(e),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(e){const{added:r,updated:t,removed:n,overrides:o}=m(this.applicationConfiguration,e),d=[...r,...t,...n];return d.length&&this.updateApplicationConfiguration(e),{keys:d,overrides:o}}compareAndUpdateLocalUserConfiguration(e){const{added:r,updated:t,removed:n,overrides:o}=m(this.localUserConfiguration,e),d=[...r,...t,...n];return d.length&&this.updateLocalUserConfiguration(e),{keys:d,overrides:o}}compareAndUpdateRemoteUserConfiguration(e){const{added:r,updated:t,removed:n,overrides:o}=m(this.remoteUserConfiguration,e),d=[...r,...t,...n];return d.length&&this.updateRemoteUserConfiguration(e),{keys:d,overrides:o}}compareAndUpdateWorkspaceConfiguration(e){const{added:r,updated:t,removed:n,overrides:o}=m(this.workspaceConfiguration,e),d=[...r,...t,...n];return d.length&&this.updateWorkspaceConfiguration(e),{keys:d,overrides:o}}compareAndUpdateFolderConfiguration(e,r){const t=this.folderConfigurations.get(e),{added:n,updated:o,removed:d,overrides:y}=m(t,r),w=[...n,...o,...d];return(w.length||!t)&&this.updateFolderConfiguration(e,r),{keys:w,overrides:y}}compareAndDeleteFolderConfiguration(e){const r=this.folderConfigurations.get(e);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:t,updated:n,removed:o,overrides:d}=m(r,void 0);return{keys:[...t,...n,...o],overrides:d}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(e,r,t){let n=this.getConsolidatedConfigurationModelForResource(r,t);return r.overrideIdentifier&&(n=n.override(r.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(e)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:e},r){let t=this.getWorkspaceConsolidatedConfiguration();if(r&&e){const n=r.getFolder(e);n&&(t=this.getFolderConsolidatedConfiguration(n.uri)||t);const o=this._memoryConfigurationByResource.get(e);o&&(t=t.merge(o))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let r=this._foldersConsolidatedConfigurations.get(e);if(!r){const t=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(e);n?(r=t.merge(n),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(e,r)):r=t}return r}getFolderConfigurationModelForResource(e,r){if(r&&e){const t=r.getFolder(e);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,r)=>{const{contents:t,overrides:n,keys:o}=this._folderConfigurations.get(r);return e.push([r,{contents:t,overrides:n,keys:o}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>e.add(r)),this.userConfiguration.freeze().keys.forEach(r=>e.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(t=>e.add(t))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>r.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>r.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>r.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(e).forEach(n=>r.add(n))),[...r.values()]}static parse(e){const r=this.parseConfigurationModel(e.defaults),t=this.parseConfigurationModel(e.policy),n=this.parseConfigurationModel(e.application),o=this.parseConfigurationModel(e.user),d=this.parseConfigurationModel(e.workspace),y=e.folders.reduce((w,C)=>(w.set(f.URI.revive(C[0]),this.parseConfigurationModel(C[1])),w),new L.ResourceMap);return new v(r,t,n,o,new S,d,y,new S,new L.ResourceMap,!1)}static parseConfigurationModel(e){return new S(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=v;function a(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,r=new Map;for(const n of s)n.keys.forEach(o=>e.add(o)),n.overrides.forEach(([o,d])=>{const y=(0,L.getOrSet)(r,o,new Set);d.forEach(w=>y.add(w))});const t=[];return r.forEach((n,o)=>t.push([o,[...n.values()]])),{keys:[...e.values()],overrides:t}}i.mergeChanges=a;class u{constructor(e,r,t,n){this.change=e,this.previous=r,this.currentConfiguraiton=t,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;e.keys.forEach(y=>o.add(y)),e.overrides.forEach(([,y])=>y.forEach(w=>o.add(w))),this.affectedKeys=[...o.values()];const d=new S;this.affectedKeys.forEach(y=>d.setValue(y,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(r){const t=this.previousConfiguration?this.previousConfiguration.getValue(e,r,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(e,r,this.currentWorkspace);return!p.equals(t,n)}return!0}return!1}doesAffectedKeysTreeContains(e,r){let t=(0,I.toValuesTree)({[r]:!0},()=>{}),n;for(;typeof t=="object"&&(n=Object.keys(t)[0]);){if(e=e[n],!e)return!1;t=t[n]}return!0}}i.ConfigurationChangeEvent=u;function m(s,e){const{added:r,removed:t,updated:n}=c(e,s),o=[],d=s?.getAllOverrideIdentifiers()||[],y=e?.getAllOverrideIdentifiers()||[];if(e){const w=y.filter(C=>!d.includes(C));for(const C of w)o.push([C,e.getKeysForOverrideIdentifier(C)])}if(s){const w=d.filter(C=>!y.includes(C));for(const C of w)o.push([C,s.getKeysForOverrideIdentifier(C)])}if(e&&s){for(const w of d)if(y.includes(w)){const C=c({contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)},{contents:e.getOverrideValue(void 0,w)||{},keys:e.getKeysForOverrideIdentifier(w)});o.push([w,[...C.added,...C.removed,...C.updated]])}}return{added:r,removed:t,updated:n,overrides:o}}function c(s,e){const r=s?e?s.keys.filter(o=>e.keys.indexOf(o)===-1):[...s.keys]:[],t=e?s?e.keys.filter(o=>s.keys.indexOf(o)===-1):[...e.keys]:[],n=[];if(s&&e){for(const o of e.keys)if(s.keys.indexOf(o)!==-1){const d=(0,I.getConfigurationValue)(e.contents,o),y=(0,I.getConfigurationValue)(s.contents,o);p.equals(d,y)||n.push(o)}}return{added:r,removed:t,updated:n}}}),define(Q[118],Z([0,1,19,4,2,26,5,21,64,40,9,37,33]),function(B,i,D,R,b,k,L,p,l,f,I,P,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PolicyConfiguration=i.NullPolicyConfiguration=i.DefaultConfigurationModel=i.DefaultConfiguration=void 0;class S extends b.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new g(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(h.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:m})=>this.onDidUpdateConfiguration(u,m))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(u,m){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:u})}getConfigurationDefaultOverrides(){return{}}}i.DefaultConfiguration=S;class g extends l.ConfigurationModel{constructor(u={}){const m=h.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(m),s=Object.create(null),e=[];for(const r in m){const t=u[r],n=t!==void 0?t:m[r].default;(0,p.addToValueTree)(s,r,n,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(s))f.OVERRIDE_PROPERTY_REGEX.test(r)&&e.push({identifiers:(0,f.overrideIdentifiersFromKey)(r),keys:Object.keys(s[r]),contents:(0,p.toValuesTree)(s[r],t=>console.error(`Conflict in default settings file: ${t}`))});super(s,c,e)}}i.DefaultConfigurationModel=g;class E{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new l.ConfigurationModel}async initialize(){return this.configurationModel}}i.NullPolicyConfiguration=E;let v=class extends b.Disposable{get configurationModel(){return this._configurationModel}constructor(u,m,c){super(),this.defaultConfiguration=u,this.policyService=m,this.logService=c,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new l.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(u=>this.onDidChangePolicies(u))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:u})=>this.update(await this.registerPolicyDefinitions(u),!0))),this._configurationModel}async registerPolicyDefinitions(u){const m={},c=[],s=h.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const e of u){const r=s[e];if(!r){c.push(e);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}c.push(e),m[r.policy.name]={type:r.type}}}return(0,L.isEmptyObject)(m)||await this.policyService.registerPolicyDefinitions(m),c}onDidChangePolicies(u){const m=h.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),c=(0,D.coalesce)(u.map(s=>m.get(s)));this.update(c,!0)}update(u,m){const c=h.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),s=[],e=this._configurationModel.isEmpty();for(const r of u){const t=c[r]?.policy?.name;if(t){const n=this.policyService.getPolicyValue(t);(e?n!==void 0:!(0,k.equals)(this._configurationModel.getValue(r),n))&&s.push([r,n])}else this._configurationModel.getValue(r)!==void 0&&s.push([r,void 0])}if(s.length){const r=this._configurationModel;this._configurationModel=new l.ConfigurationModel;for(const t of r.keys)this._configurationModel.setValue(t,r.getValue(t));for(const[t,n]of s)n===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,n);m&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};v=ge([ee(1,P.IPolicyService),ee(2,I.ILogService)],v),i.PolicyConfiguration=v}),define(Q[119],Z([0,1,3,4,2,18,21,64,118,37]),function(B,i,D,R,b,k,L,p,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class I extends b.Disposable{constructor(h,S,g,E){super(),this.settingsResource=h,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new l.DefaultConfiguration),this.policyConfiguration=g instanceof f.NullPolicyService?new l.NullPolicyConfiguration:this._register(new l.PolicyConfiguration(this.defaultConfiguration,g,E)),this.userConfiguration=this._register(new p.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,S)),this.configuration=new p.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new p.ConfigurationModel,new p.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:v,properties:a})=>this.onDidDefaultConfigurationChange(v,a))),this._register(this.policyConfiguration.onDidChangeConfiguration(v=>this.onDidPolicyConfigurationChange(v))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[h,S,g]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new p.Configuration(h,S,new p.ConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(h,S){const g=typeof h=="string"?h:void 0,E=(0,L.isConfigurationOverrides)(h)?h:(0,L.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(g,E,void 0)}updateValue(h,S,g,E){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const S=this.configuration.toData(),g=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(g,S,2)}onDidDefaultConfigurationChange(h,S){const g=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(h,S);this.trigger(E,g,7)}onDidPolicyConfigurationChange(h){const S=this.configuration.toData(),g=this.configuration.compareAndUpdatePolicyConfiguration(h);this.trigger(g,S,7)}trigger(h,S,g){const E=new p.ConfigurationChangeEvent(h,{data:S},this.configuration);E.source=g,E.sourceConfig=this.getTargetConfiguration(g),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(h){switch(h){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=I}),define(Q[120],Z([0,1,17]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parseAuthorityWithOptionalPort=i.parseAuthorityWithPort=i.getRemoteServerRootPath=i.getRemoteName=i.getRemoteAuthority=void 0;function R(f){return f.scheme===D.Schemas.vscodeRemote?f.authority:void 0}i.getRemoteAuthority=R;function b(f){if(!f)return;const I=f.indexOf("+");return I<0?f:f.substr(0,I)}i.getRemoteName=b;function k(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}i.getRemoteServerRootPath=k;function L(f){const{host:I,port:P}=l(f);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:P}}i.parseAuthorityWithPort=L;function p(f,I){let{host:P,port:h}=l(f);return typeof h>"u"&&(h=I),{host:P,port:h}}i.parseAuthorityWithOptionalPort=p;function l(f){const I=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const P=f.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const h=f.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:f,port:void 0}}}),define(Q[34],Z([0,1,27,8,120]),function(B,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.isApplicationScopedExtension=i.ExtensionIdentifier=i.TargetPlatform=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.UNDEFINED_PUBLISHER=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.UNDEFINED_PUBLISHER="undefined_publisher",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}i.getWorkspaceSupportTypeMessage=k;function L(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}i.isIExtensionIdentifier=L,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var p;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(p=i.ExtensionType||(i.ExtensionType={}));var l;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(l=i.TargetPlatform||(i.TargetPlatform={}));class f{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,v){if(typeof E>"u"||E===null)return typeof v>"u"||v===null;if(typeof v>"u"||v===null)return!1;if(typeof E=="string"||typeof v=="string"){const a=typeof E=="string"?E:E.value,u=typeof v=="string"?v:v.value;return D.equalsIgnoreCase(a,u)}return E._lower===v._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}i.ExtensionIdentifier=f;function I(g){return P(g)}i.isApplicationScopedExtension=I;function P(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}i.isLanguagePackExtension=P;function h(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=h;function S(g,E){if(E){const v=`onResolveRemoteAuthority:${(0,b.getRemoteName)(E)}`;return g.activationEvents?.indexOf(v)!==-1}return!1}i.isResolverExtension=S,i.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[23],Z([0,1,27,22,34,12,10,11,32]),function(B,i,D,R,b,k,L,p,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeTargetPlatform=i.isAlpineLinux=i.getExtensionDependencies=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.getIdAndVersion=i.ExtensionKey=i.areSameExtensions=void 0;function f(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,D.compareIgnoreCase)(r.id,t.id)===0}i.areSameExtensions=f;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class P{static create(t){const n=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new P(t.identifier,n,o)}static parse(t){const n=I.exec(t);return n&&n[1]&&n[2]?new P({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof P?f(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}i.ExtensionKey=P;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(r){const t=h.exec(r);return t&&t[1]?[E(t[1]),t[2]]:[E(r),void 0]}i.getIdAndVersion=S;function g(r,t){return`${r}.${t}`}i.getExtensionId=g;function E(r){return r.toLocaleLowerCase()}i.adoptToGalleryExtensionId=E;function v(r,t){return E(g(r,t))}i.getGalleryExtensionId=v;function a(r,t){const n=[],o=d=>{for(const y of n)if(y.some(w=>f(t(w),t(d))))return y;return null};for(const d of r){const y=o(d);y?y.push(d):n.push([d])}return n}i.groupByExtension=a;function u(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=u;function m(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}i.getGalleryExtensionTelemetryData=m,i.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function c(r,t){const n=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const d=o.shift();if(d&&n.every(y=>!f(y.identifier,{id:d}))){const y=r.filter(w=>f(w.identifier,{id:d}));y.length===1&&(n.push(y[0]),o.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}i.getExtensionDependencies=c;async function s(r,t){if(!k.isLinux)return!1;let n;try{n=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){t.debug("Error while getting the os-release file.",(0,p.getErrorMessage)(d))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}i.isAlpineLinux=s;async function e(r,t){const n=await s(r,t),o=(0,R.getTargetPlatform)(n?"alpine":k.platform,l.arch);return t.debug("ComputeTargetPlatform:",o),o}i.computeTargetPlatform=e}),define(Q[121],Z([0,1,24,11,17,18,39,10,84,22,23,34]),function(B,i,D,R,b,k,L,p,l,f,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLI=void 0;const h=v=>(0,l.localize)(0,null,v),S=(0,l.localize)(1,null,"ms-dotnettools.csharp");function g(v,a){return a?`${v.publisher}.${v.name}@${v.version}`:`${v.publisher}.${v.name}`}let E=class{constructor(a,u){this.extensionManagementService=a,this.extensionGalleryService=u}get location(){}async listExtensions(a,u,m,c=console){let s=await this.extensionManagementService.getInstalled(1,m);const e=P.EXTENSION_CATEGORIES.map(t=>t.toLowerCase());if(u&&u!==""){if(e.indexOf(u.toLowerCase())<0){c.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}s=s.filter(t=>t.manifest.categories?t.manifest.categories.map(o=>o.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){c.log("Possible Categories: "),e.forEach(t=>{c.log(t)});return}this.location&&c.log((0,l.localize)(2,null,this.location)),s=s.sort((t,n)=>t.identifier.id.localeCompare(n.identifier.id));let r;for(const t of s)r!==t.identifier.id&&(r=t.identifier.id,c.log(g(t.manifest,a)))}async installExtensions(a,u,m,c,s=console){const e=[],r=[];a.length&&s.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const t=await this.extensionManagementService.getInstalled(1,m.profileLocation),n=(w,C)=>{const z=t.find(_=>(0,I.areSameExtensions)(_.identifier,{id:w}));if(z){if(!c&&(!C||C==="prerelease"&&z.preRelease))return s.log((0,l.localize)(5,null,w,z.manifest.version,w)),!1;if(C&&z.manifest.version===C)return s.log((0,l.localize)(6,null,`${w}@${C}`)),!1}return!0},o=(w,C,z)=>{y.push({id:w,version:C!=="prerelease"?C:void 0,installOptions:{...m,isBuiltin:z,installPreReleaseVersion:C==="prerelease"||m.installPreReleaseVersion}})},d=[],y=[];for(const w of a)if(w instanceof p.URI)d.push(w);else{const[C,z]=(0,I.getIdAndVersion)(w);n(C,z)&&o(C,z,!1)}for(const w of u){const[C,z]=(0,I.getIdAndVersion)(w);n(C,z)&&o(C,z,!0)}if(d.length&&await Promise.all(d.map(async w=>{try{const C=await this.installVSIX(w,{...m,isBuiltin:!1},c,s);C&&r.push(C)}catch(C){s.error(C.message||C.stack||C),e.push(w.toString())}})),y.length){const w=await this.getGalleryExtensions(y);await Promise.all(y.map(async C=>{const z=w.get(C.id.toLowerCase());if(z)try{const _=await this.installFromGallery(C,z,t,c,s);_&&r.push(_)}catch(_){s.error(_.message||_.stack||_),e.push(C.id)}else s.error(`${h(C.version?`${C.id}@${C.version}`:C.id)}
${S}`),e.push(C.id)}))}if(e.length)throw new Error((0,l.localize)(7,null,e.join(", ")))}async installVSIX(a,u,m,c){const s=await this.extensionManagementService.getManifest(a);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,m,u.profileLocation,c))try{return await this.extensionManagementService.install(a,u),c.log((0,l.localize)(8,null,(0,k.basename)(a))),s}catch(r){if((0,R.isCancellationError)(r))return c.log((0,l.localize)(9,null,(0,k.basename)(a))),null;throw r}return null}async getGalleryExtensions(a){const u=new Map,m=a.some(s=>s.installOptions.installPreReleaseVersion),c=await this.extensionGalleryService.getExtensions(a.map(s=>({...s,preRelease:m})),D.CancellationToken.None);for(const s of c)u.set(s.identifier.id.toLowerCase(),s);return u}async installFromGallery({id:a,version:u,installOptions:m},c,s,e,r){const t=await this.extensionGalleryService.getManifest(c,D.CancellationToken.None);if(t&&!this.validateExtensionKind(t,r))return null;const n=s.find(o=>(0,I.areSameExtensions)(o.identifier,c.identifier));if(n){if(c.version===n.manifest.version)return r.log((0,l.localize)(10,null,u?`${a}@${u}`:a)),null;r.log((0,l.localize)(11,null,a,c.version))}try{m.isBuiltin?r.log(u?(0,l.localize)(12,null,a,u):(0,l.localize)(13,null,a)):r.log(u?(0,l.localize)(14,null,a,u):(0,l.localize)(15,null,a));const o=await this.extensionManagementService.installFromGallery(c,{...m,installGivenVersion:!!u});return r.log((0,l.localize)(16,null,a,o.manifest.version)),t}catch(o){if((0,R.isCancellationError)(o))return r.log((0,l.localize)(17,null,a)),null;throw o}}validateExtensionKind(a,u){return!0}async validateVSIX(a,u,m,c){const s={id:(0,I.getGalleryExtensionId)(a.publisher,a.name)},r=(await this.extensionManagementService.getInstalled(1,m)).find(t=>(0,I.areSameExtensions)(s,t.identifier)&&(0,L.gt)(t.manifest.version,a.version));return r&&!u?(c.log((0,l.localize)(18,null,r.identifier.id,r.manifest.version,a.version)),!1):this.validateExtensionKind(a,c)}async uninstallExtensions(a,u,m,c=console){const s=async r=>{if(r instanceof p.URI){const t=await this.extensionManagementService.getManifest(r);return g(t)}return r},e=[];for(const r of a){const t=await s(r),o=(await this.extensionManagementService.getInstalled(void 0,m)).filter(d=>(0,I.areSameExtensions)(d.identifier,{id:t}));if(!o.length)throw new Error(`${this.notInstalled(t)}
${S}`);if(o.some(d=>d.type===0)){c.log((0,l.localize)(19,null,t));return}if(!u&&o.some(d=>d.isBuiltin)){c.log((0,l.localize)(20,null,t));return}c.log((0,l.localize)(21,null,t));for(const d of o)await this.extensionManagementService.uninstall(d,{profileLocation:m}),e.push(d);this.location?c.log((0,l.localize)(22,null,t,this.location)):c.log((0,l.localize)(23,null,t))}}async locateExtension(a,u=console){const m=await this.extensionManagementService.getInstalled();a.forEach(c=>{m.forEach(s=>{if(s.identifier.id===c&&s.location.scheme===b.Schemas.file){u.log(s.location.fsPath);return}})})}notInstalled(a){return this.location?(0,l.localize)(24,null,a,this.location):(0,l.localize)(25,null,a)}};E=ge([ee(0,f.IExtensionManagementService),ee(1,f.IExtensionGalleryService)],E),i.ExtensionManagementCLI=E}),define(Q[41],Z([0,1,3,15,2,36,10,23,13,8,9]),function(B,i,D,R,b,k,L,p,l,f,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsProfileScannerService=i.IExtensionsProfileScannerService=void 0,i.IExtensionsProfileScannerService=(0,f.createDecorator)("IExtensionsProfileScannerService");let P=class extends b.Disposable{constructor(S,g){super(),this.fileService=S,this.logService=g,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(S){return this.withProfileExtensions(S)}addExtensionsToProfile(S,g){return this.withProfileExtensions(g,E=>(E=E.filter(v=>S.some(([a])=>!(0,p.areSameExtensions)(v.identifier,a.identifier))),E.push(...S.map(([v,a])=>({identifier:v.identifier,version:v.manifest.version,location:v.location,metadata:a}))),E))}removeExtensionFromProfile(S,g){return this.withProfileExtensions(g,E=>E.filter(v=>!(0,p.areSameExtensions)(v.identifier,S)))}async withProfileExtensions(S,g){return this.getResourceAccessQueue(S).queue(async()=>{let E=[];try{const v=await this.fileService.readFile(S),a=JSON.parse(v.value.toString());for(const u of a){if(!u.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",u);continue}if(!u.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",u);continue}if(!u.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",u);continue}E.push({identifier:u.identifier,location:L.URI.revive(u.location),version:u.version,metadata:u.metadata})}}catch(v){v.fileOperationResult!==1&&this.logService.error(v)}if(g){E=g(E);const v=E.map(a=>({identifier:a.identifier,version:a.version,location:a.location.toJSON(),metadata:a.metadata}));await this.fileService.writeFile(S,R.VSBuffer.fromString(JSON.stringify(v)))}return E})}getResourceAccessQueue(S){let g=this.resourcesAccessQueueMap.get(S);return g||(g=new D.Queue,this.resourcesAccessQueueMap.set(S,g)),g}};P=ge([ee(0,l.IFileService),ee(1,I.ILogService)],P),i.ExtensionsProfileScannerService=P}),define(Q[122],Z([0,1,3,11,2,12,18,39,10,30,20,16,22,23,13,9]),function(B,i,D,R,b,k,L,p,l,f,I,P,h,S,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;let v=class extends b.Disposable{constructor(u,m,c,s){super(),this.fileService=m,this.extensionGalleryService=c,this.logService=s,this.extensionsDownloadDir=l.URI.file(u.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(u,m){await this.cleanUpPromise;const c=this.getName(u),s=(0,L.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(s)){const e=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,f.generateUuid)()}`);await this.fileService.exists(e)||await this.extensionGalleryService.download(u,e,m);try{await this.rename(e,s,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(e)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",u.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,e.path),r}}return s}async delete(u){await this.cleanUpPromise,await this.fileService.del(u)}async rename(u,m,c){try{await I.Promises.rename(u.fsPath,m.fsPath)}catch(s){if(k.isWindows&&s&&s.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${u} to ${m} with 'EPERM' error. Trying again...`),this.rename(u,m,c);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const u=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(u.children){const m=[],c=[];for(const r of u.children){const t=S.ExtensionKey.parse(r.name);t&&c.push([t,r])}const s=(0,S.groupByExtension)(c,([r])=>r),e=[];for(const r of s)r.sort((t,n)=>p.rcompare(t[0].version,n[0].version)),m.push(...r.slice(1).map(t=>t[1].resource)),e.push(r[0][1]);e.sort((r,t)=>r.mtime-t.mtime),m.push(...e.slice(0,Math.max(0,e.length-this.cache)).map(r=>r.resource)),await D.Promises.settled(m.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(u){this.logService.error(u)}}getName(u){return this.cache?S.ExtensionKey.create(u).toString().toLowerCase():(0,f.generateUuid)()}};v=ge([ee(0,P.INativeEnvironmentService),ee(1,g.IFileService),ee(2,h.IExtensionGalleryService),ee(3,E.ILogService)],v),i.ExtensionsDownloader=v}),define(Q[123],Z([0,1,2,14,20,34]),function(B,i,D,R,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class L extends D.Disposable{constructor(l,f){super(),this.environmentService=l,this.extensionsManifestCache=(0,R.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(f.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(f.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(l){l.some(f=>!!f.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=L}),define(Q[124],Z([0,1,155,19,3,2,17,14,20,16,22,23,9,62,12,10]),function(B,i,D,R,b,k,L,p,l,f,I,P,h,S,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeLanguagePackService=void 0;let v=class extends S.LanguagePackBaseService{constructor(c,s,e,r){super(e),this.extensionManagementService=c,this.logService=r,this.cache=this._register(new a(s,r)),this.extensionManagementService.registerParticipant({postInstall:async t=>this.postInstallExtension(t),postUninstall:async t=>this.postUninstallExtension(t)})}async getTranslationsUri(c){const e=(await this.cache.getLanguagePacks())[g.locale];if(!e){this.logService.warn(`No language pack found for ${g.locale}`);return}const r=e.translations[c];return r?E.URI.file(r):void 0}async getInstalledLanguages(){const c=await this.cache.getLanguagePacks(),s=Object.keys(c).map(e=>{const r=c[e];return{...this.createQuickPickItem(e,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return s.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),s.sort((e,r)=>e.label.localeCompare(r.label)),s}async postInstallExtension(c){c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",c.identifier.id),await this.update())}async postUninstallExtension(c){const s=await this.cache.getLanguagePacks();Object.keys(s).some(e=>s[e]&&s[e].extensions.some(r=>(0,P.areSameExtensions)(r.extensionIdentifier,c.identifier)))&&(this.logService.info("Removing language packs from the extension",c.identifier.id),await this.update())}async update(){const[c,s]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),e=await this.cache.update(s);return!(0,R.equals)(Object.keys(c),Object.keys(e))}};v=ge([ee(0,I.IExtensionManagementService),ee(1,f.INativeEnvironmentService),ee(2,I.IExtensionGalleryService),ee(3,h.ILogService)],v),i.NativeLanguagePackService=v;let a=class extends k.Disposable{constructor(c,s){super(),this.logService=s,this.languagePacks={},this.languagePacksFilePath=(0,p.join)(c.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(c){return this.withLanguagePacks(s=>{Object.keys(s).forEach(e=>delete s[e]),this.createLanguagePacksFromExtensions(s,...c)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(c,...s){for(const e of s)e&&e.manifest&&e.manifest.contributes&&e.manifest.contributes.localizations&&e.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(c,e);Object.keys(c).forEach(e=>this.updateHash(c[e]))}createLanguagePacksFromExtension(c,s){const e=s.identifier,r=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const t of r)if(s.location.scheme===L.Schemas.file&&u(t)){let n=c[t.languageId];n||(n={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},c[t.languageId]=n);const o=n.extensions.filter(d=>(0,P.areSameExtensions)(d.extensionIdentifier,e))[0];o?o.version=s.manifest.version:n.extensions.push({extensionIdentifier:e,version:s.manifest.version});for(const d of t.translations)n.translations[d.id]=(0,p.join)(s.location.fsPath,d.path)}}updateHash(c){if(c){const s=(0,D.createHash)("md5");for(const e of c.extensions)s.update(e.extensionIdentifier.uuid||e.extensionIdentifier.id).update(e.version);c.hash=s.digest("hex")}}withLanguagePacks(c=()=>null){return this.languagePacksFileLimiter.queue(()=>{let s=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,e=>e.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(e)).then(e=>{try{return JSON.parse(e)}catch{return{}}}).then(e=>(s=c(e),e)).then(e=>{for(const t of Object.keys(e))e[t]||delete e[t];this.languagePacks=e,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),l.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>s,e=>this.logService.error(e))})}};a=ge([ee(0,f.INativeEnvironmentService),ee(1,h.ILogService)],a);function u(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const c of m.translations)if(typeof c.id!="string"||typeof c.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(Q[47],Z([0,1,15,94,40,8,33]),function(B,i,D,R,b,k,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asTextOrError=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,k.createDecorator)("requestService");function p(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}i.isSuccess=p;function l(E){return E.res.statusCode===204}async function f(E){return l(E)?null:(await(0,D.streamToBuffer)(E.stream)).toString()}i.asText=f;async function I(E){if(!p(E))throw new Error("Server returned "+E.res.statusCode);return f(E)}i.asTextOrError=I;async function P(E){if(!p(E))throw new Error("Server returned "+E.res.statusCode);if(l(E))return null;const a=(await(0,D.streamToBuffer)(E.stream)).toString();try{return JSON.parse(a)}catch(u){throw u.message+=`:
`+a,u}}i.asJson=P;function h(E){g(E)}i.updateProxyConfigurationsScope=h;let S;function g(E){const v=L.Registry.as(b.Extensions.Configuration),a=S;S={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},v.updateConfigurations({add:[S],remove:a?[a]:[]})}g(2)}),define(Q[125],Z([0,1,24,17,13,47]),function(B,i,D,R,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let L=class{constructor(l,f){this.requestService=l,this.fileService=f}async download(l,f,I=D.CancellationToken.None){if(l.scheme===R.Schemas.file||l.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(l,f);return}const P={type:"GET",url:l.toString(!0)},h=await this.requestService.request(P,I);if(h.res.statusCode===200)await this.fileService.writeFile(f,h.stream);else{const S=await(0,k.asTextOrError)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${S}`)}}};L=ge([ee(0,k.IRequestService),ee(1,b.IFileService)],L),i.DownloadService=L}),define(Q[126],Z([0,1,127,5]),function(B,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function b(L,p){return L.protocol==="http:"?p.HTTP_PROXY||p.http_proxy||null:L.protocol==="https:"&&(p.HTTPS_PROXY||p.https_proxy||p.HTTP_PROXY||p.http_proxy)||null}async function k(L,p,l={}){const f=(0,D.parse)(L),I=l.proxyUrl||b(f,p);if(!I)return null;const P=(0,D.parse)(I);if(!/^https?:$/.test(P.protocol||""))return null;const h={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,R.isBoolean)(l.strictSSL)?l.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((S,g)=>{B(["http-proxy-agent"],S,g)}))(h):new(await new Promise((S,g)=>{B(["https-proxy-agent"],S,g)}))(h)}i.getProxyAgent=k}),define(Q[128],Z([0,1,57,14,95,24,31,11,12,30,77,156,3]),function(B,i,D,R,b,k,L,p,l,f,I,P,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const S=1e4;let g;async function E(a,u,m){return u["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(m)&&!u["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(m)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=h.Promises.withAsyncBody(async(c,s)=>{const e=new k.CancellationTokenSource,r=setTimeout(()=>{e.dispose(!0),s(new Error((0,b.localize)(0,null)))},S);try{c(await v(a,e.token))}catch(t){!(0,p.isCancellationError)(t)&&!e.token.isCancellationRequested?s(new Error((0,b.localize)(1,null,(0,L.toErrorMessage)(t)))):c({})}finally{clearTimeout(r),e.dispose()}})),g)}i.getResolvedShellEnv=E;async function v(a,u){const m=process.env.ELECTRON_RUN_AS_NODE;a.trace("getUnixShellEnvironment#runAsNode",m);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;a.trace("getUnixShellEnvironment#noAttach",c);const s=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};a.trace("getUnixShellEnvironment#env",r);const t=await(0,I.getSystemShell)(l.OS,r);return a.trace("getUnixShellEnvironment#shell",t),new Promise((n,o)=>{if(u.isCancellationRequested)return o((0,p.canceled)());const d=(0,R.basename)(t);let y,w;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(d)?(y=`& '${process.execPath}' ${C} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,w=["-Login","-Command"]):(y=`'${process.execPath}' ${C} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,d==="tcsh"?w=["-ic"]:w=["-ilc"]),a.trace("getUnixShellEnvironment#spawn",JSON.stringify(w),y);const z=(0,D.spawn)(t,[...w,y],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});u.onCancellationRequested(()=>(z.kill(),o((0,p.canceled)()))),z.on("error",H=>{a.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(H)),o(H)});const _=[];z.stdout.on("data",H=>_.push(H));const X=[];z.stderr.on("data",H=>X.push(H)),z.on("close",(H,ne)=>{const re=Buffer.concat(_).toString("utf8");a.trace("getUnixShellEnvironment#raw",re);const se=Buffer.concat(X).toString("utf8");if(se.trim()&&a.trace("getUnixShellEnvironment#stderr",se),H||ne)return o(new Error((0,b.localize)(2,null,H,ne)));const fe=e.exec(re),le=fe?fe[1]:"{}";try{const ie=JSON.parse(le);m?ie.ELECTRON_RUN_AS_NODE=m:delete ie.ELECTRON_RUN_AS_NODE,c?ie.ELECTRON_NO_ATTACH_CONSOLE=c:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.XDG_RUNTIME_DIR,a.trace("getUnixShellEnvironment#result",ie),n(ie)}catch(ie){a.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(ie)),o(ie)}})})}}),define(Q[65],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IStateService=void 0,i.IStateService=(0,D.createDecorator)("stateService")}),define(Q[129],Z([0,1,3,15,5,16,13,9]),function(B,i,D,R,b,k,L,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StateService=i.FileStorage=void 0;class l{constructor(P,h,S){this.storagePath=P,this.logService=h,this.fileService=S,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new D.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(P){P.fileOperationResult!==1&&this.logService.error(P)}}getItem(P,h){const S=this.storage[P];return(0,b.isUndefinedOrNull)(S)?h:S}setItem(P,h){this.setItems([{key:P,data:h}])}setItems(P){let h=!1;for(const{key:S,data:g}of P)this.storage[S]!==g&&((0,b.isUndefinedOrNull)(g)?(0,b.isUndefined)(this.storage[S])||(this.storage[S]=void 0,h=!0):(this.storage[S]=g,h=!0));h&&this.save()}removeItem(P){(0,b.isUndefined)(this.storage[P])||(this.storage[P]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const P=JSON.stringify(this.storage,null,4);if(P!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,R.VSBuffer.fromString(P)),this.lastSavedStorageContents=P}catch(h){this.logService.error(h)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}i.FileStorage=l;let f=class{constructor(P,h,S){this.fileStorage=new l(P.stateResource,h,S)}async init(){await this.fileStorage.init()}getItem(P,h){return this.fileStorage.getItem(P,h)}};f=ge([ee(0,k.IEnvironmentService),ee(1,p.ILogService),ee(2,L.IFileService)],f),i.StateService=f}),define(Q[66],Z([0,1,12,32,10,30]),function(B,i,D,R,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function L(f){if(D.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function p(f,I,P,h,S,g,E,v,a,u){const m=Object.create(null);m["common.machineId"]=E,m.sessionID=(0,k.generateUuid)()+Date.now(),m.commitHash=S,m.version=g,m["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,D.PlatformToString)(D.platform),m["common.nodePlatform"]=R.platform,m["common.nodeArch"]=h,m["common.product"]=u||"desktop",v&&(m["common.msftInternal"]=v);let c=0;const s=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),D.isLinuxSnap&&(m["common.snap"]="true");const e=L(P);e&&(m["common.platformDetail"]=e);try{const r=await f.readFile(b.URI.file(a));m["common.source"]=r.value.toString().slice(0,30)}catch{}return m}i.resolveCommonProperties=p;function l(f){const I=R.env.USERDNSDOMAIN;if(!I)return!1;const P=I.toLowerCase();return f.some(h=>P===h)}i.verifyMicrosoftInternalDomain=l}),define(Q[35],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,D.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(R=i.TelemetryLevel||(i.TelemetryLevel={}));var b;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(b=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(Q[42],Z([0,1,26,52,5,21,66,35]),function(B,i,D,R,b,k,L,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.cleanData=i.getPiiPathsFromEnvironment=i.isInternalTelemetry=i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class l{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,R.staticObservableValue)(0)}publicLog(n,o){return Promise.resolve(void 0)}publicLog2(n,o){return this.publicLog(n,o)}publicLogError(n,o){return Promise.resolve(void 0)}publicLogError2(n,o){return this.publicLogError(n,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=l,i.NullTelemetryService=new l;class f{async publicLog(n,o,d){}async publicLogError(n,o,d){}}i.NullEndpointTelemetryService=f,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(t,n){return n.onDidChangeConfiguration(o=>{o.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(o.source),configurationKeys:a(o.sourceConfig)})})}i.configurationTelemetry=I;function P(t,n){return!(n.disableTelemetry||!t.enableTelemetry||n.extensionTestsLocationURI)}i.supportsTelemetry=P;function h(t){const n=t.getValue(p.TELEMETRY_SETTING_ID),o=t.getValue("telemetry.enableCrashReporter");if(t.getValue(p.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=h;function S(t){const n={},o={},d={};v(t,d);for(let y in d){y=y.length>150?y.substr(y.length-149):y;const w=d[y];typeof w=="number"?o[y]=w:typeof w=="boolean"?o[y]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${y} has been trimmed to 8192, the original length is ${w.length}`),n[y]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(n[y]=w)}return{properties:n,measurements:o}}i.validateTelemetryData=S;const g=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function E(t){if(!t)return"none";for(const n of g)if(t.startsWith(`${n}+`))return n;return"other"}i.cleanRemoteAuthority=E;function v(t,n,o=0,d){if(!!t)for(const y of Object.getOwnPropertyNames(t)){const w=t[y],C=d?d+y:y;Array.isArray(w)?n[C]=(0,D.safeStringify)(w):w instanceof Date?n[C]=w.toISOString():(0,b.isObject)(w)?o<2?v(w,n,o+1,C+"."):n[C]=(0,D.safeStringify)(w):n[C]=w}}function a(t){if(!t)return[];const n=[];return u(n,"",t),n}function u(t,n,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(d=>u(t,n?`${n}.${d}`:d,o[d])):t.push(n)}function m(t,n){const o=t.msftInternalDomains||[],d=n.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(o)||d}i.isInternalTelemetry=m;function c(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}i.getPiiPathsFromEnvironment=c;function s(t,n){let o=t;const d=[];for(const z of n)for(;;){const _=z.exec(t);if(!_)break;d.push([_.index,z.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let C=0;for(o="";;){const z=w.exec(t);if(!z)break;!y.test(z[0])&&d.every(([_,X])=>z.index<_||z.index>=X)&&(o+=t.substring(C,z.index)+"<REDACTED: user-file-path>",C=w.lastIndex)}return C<t.length&&(o+=t.substr(C)),o}function e(t){if(!t)return t;const n=t.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of o)if(d.regex.test(n))return`<REDACTED: ${d.label}>`;return t}function r(t,n){return(0,D.cloneAndChange)(t,o=>{if(typeof o=="string"){let d=o;d=s(d,n);for(const y of n)d=d.replace(y,"");return d=e(d),d}})}i.cleanData=r}),define(Q[130],Z([0,1,103,42]),function(B,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=void 0;async function b(k,L,p,l,f,I,P){const h={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${L.nameShort})`};if((0,R.supportsTelemetry)(L,p)&&(0,R.getTelemetryLevel)(l)===3){const S=await(0,D.getServiceMachineId)(p,f,I),{sessionId:g}=await P.getTelemetryInfo();h["X-Market-User-Id"]=S,h["VSCode-SessionId"]=g}return h}i.resolveMarketplaceHeaders=b}),define(Q[131],Z([0,1,11,26,42]),function(B,i,D,R,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractOneDataSystemAppender=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function L(l,f,I){const P=await new Promise((v,a)=>{B(["@microsoft/1ds-core-js"],v,a)}),h=await new Promise((v,a)=>{B(["@microsoft/1ds-post-js"],v,a)}),S=new P.AppInsightsCore,g=new h.PostChannel,E={instrumentationKey:l,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(I){E.extensionConfig={};const v={alwaysUseXhrOverride:!0,httpXHROverride:I};E.extensionConfig[g.identifier]=v}return S.initialize(E,[]),S.addTelemetryInitializer(v=>{f&&(v.ext=v.ext??{},v.ext.utc=v.ext.utc??{},v.ext.utc.flags=8462029)}),S}class p{constructor(f,I,P,h,S){this._isInternalTelemetry=f,this._eventPrefix=I,this._defaultData=P,this._xhrOverride=S,this.endPointUrl=k,this._defaultData||(this._defaultData={}),typeof h=="function"?this._aiCoreOrKey=h():this._aiCoreOrKey=h,this._asyncAiCore=null}_withAIClient(f){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){f(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=L(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(I=>{f(I)},I=>{(0,D.onUnexpectedError)(I),console.error(I)})}}log(f,I){if(!this._aiCoreOrKey)return;I=(0,R.mixin)(I,this._defaultData),I=(0,b.validateTelemetryData)(I);const P=this._eventPrefix+"/"+f;try{this._withAIClient(h=>{h.pluginVersionString=I?.properties.version??"Unknown",h.track({name:P,baseData:{name:P,properties:I?.properties,measurements:I?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(f=>{this._withAIClient(I=>{I.unload(!0,()=>{this._aiCoreOrKey=void 0,f(void 0)})})}):Promise.resolve(void 0)}}i.AbstractOneDataSystemAppender=p}),define(Q[132],Z([0,1,2,26,52,12,27,96,21,40,133,28,33,35,42]),function(B,i,D,R,b,k,L,p,l,f,I,P,h,S,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let E=class{constructor(u,m,c){this._configurationService=m,this._productService=c,this._experimentProperties={},this.telemetryLevel=new b.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(u,m){this._experimentProperties[u]=m}_updateTelemetryLevel(){let u=(0,g.getTelemetryLevel)(this._configurationService);const m=this._productService.enabledTelemetryLevels;if(m){this._sendErrorTelemetry=this.sendErrorTelemetry?m.error:!1;const c=m.usage?3:m.error?2:0;u=Math.min(u,c)}this.telemetryLevel.value=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const u=await this._commonProperties,m=u.sessionID,c=u["common.machineId"],s=u["common.firstSessionDate"],e=u["common.msftInternal"];return{sessionId:m,machineId:c,firstSessionDate:s,msftInternal:e}}dispose(){this._disposables.dispose()}_log(u,m,c,s){return this.telemetryLevel.value<m?Promise.resolve(void 0):this._commonProperties.then(e=>{c=(0,R.mixin)(c,e),c=(0,R.mixin)(c,this._experimentProperties),c=(0,g.cleanData)(c,this._cleanupPatterns),this._appenders.forEach(r=>r.log(u,c))},e=>{console.error(e)})}publicLog(u,m,c){return this._log(u,3,m,c)}publicLog2(u,m,c){return this.publicLog(u,m,c)}publicLogError(u,m){return this._sendErrorTelemetry?this._log(u,2,m,!0):Promise.resolve(void 0)}publicLogError2(u,m){return this.publicLogError(u,m)}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=ge([ee(1,l.IConfigurationService),ee(2,P.IProductService)],E),i.TelemetryService=E;function v(){const a=(0,p.localize)(0,null,I.default.nameLong),u=I.default.privacyStatementUrl?(0,p.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,p.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=k.isWeb?"":(0,p.localize)(3,null),c=(0,p.localize)(4,null),s=(0,p.localize)(5,null),e=(0,p.localize)(6,null),r=(0,p.localize)(7,null),t=`
|       | ${c} | ${s} | ${e} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,p.localize)(8,null);return`
${a} ${u} ${m}

&nbsp;

${r}
${t}

&nbsp;

${n}
`}h.Registry.as(f.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,p.localize)(10,null),(0,p.localize)(11,null),(0,p.localize)(12,null),(0,p.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),h.Registry.as(f.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,p.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,p.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,p.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[134],Z([0,1,157,131]),function(B,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.OneDataSystemAppender=void 0;class b extends R.AbstractOneDataSystemAppender{constructor(L,p,l,f){const I={sendPOST:(P,h)=>{const S={method:"POST",headers:{...P.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(P.data)}};try{const g=D.request(P.urlString,S,E=>{E.on("data",function(v){h(E.statusCode??200,E.headers,v.toString())}),E.on("error",function(v){h(0,{})})});g.write(P.data),g.end()}catch{h(0,{})}}};super(L,p,l,f,I)}}i.OneDataSystemAppender=b}),define(Q[135],Z([0,1,14,20]),function(B,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function b(k,L){const p=Object.create(null),l=(I,P)=>{const h=JSON.parse(I);p[P]=h};if(L){const I=[],P=await R.Promises.readdir(L);for(const S of P)try{(await R.Promises.stat((0,D.join)(L,S))).isDirectory()&&I.push(S)}catch{}const h=[];for(const S of I)(await R.Promises.readdir((0,D.join)(L,S))).filter(E=>E==="telemetry.json").length===1&&h.push(S);for(const S of h){const g=(await R.Promises.readFile((0,D.join)(L,S,"telemetry.json"))).toString();l(g,S)}}let f=(await R.Promises.readFile((0,D.join)(k,"telemetry-core.json"))).toString();return l(f,"vscode-core"),f=(await R.Promises.readFile((0,D.join)(k,"telemetry-extensions.json"))).toString(),l(f,"vscode-extensions"),JSON.stringify(p,null,4)}i.buildTelemetryMessage=b}),define(Q[29],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(Q[136],Z([0,1,4,2,10,16,23,13,9,29]),function(B,i,D,R,b,k,L,p,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let I=class extends R.Disposable{constructor(h,S,g,E,v){super(),this.extensionsManagementService=h,this.logService=E,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(u=>{this.installedExtensions=u.map(m=>m.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(u=>this.onInstallExtension(u))),this._register(h.onDidInstallExtensions(u=>this.onDidInstallExtensions(u))),this._register(h.onDidUninstallExtension(u=>this.onDidUninstallExtension(u)));const a=b.URI.file(g.extensionsPath);this._register(S.watch(a)),this._register(D.Event.filter(S.onDidFilesChange,u=>u.rawChanges.some(m=>this.doesChangeAffects(m,a)))(()=>this.onDidChange()))}doesChangeAffects(h,S){return h.type!==1&&h.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h.resource),S)?!1:this.uriIdentityService.extUri.isEqual(h.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(h.resource).startsWith(".")}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const S of h)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(S=>!(0,L.areSameExtensions)(S,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,L.areSameExtensions)(S,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(),S=h.filter(E=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,L.areSameExtensions)(v,E.identifier))?!1:E.installedTimestamp&&E.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",E.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",E.identifier.id),!1)),g=this.installedExtensions.filter(E=>this.installingExtensions.some(v=>(0,L.areSameExtensions)(v,E))?!1:h.every(v=>!(0,L.areSameExtensions)(v.identifier,E))?(this.logService.info("Detected extension removed from another source",E.id),!0):!1);this.installedExtensions=h.map(E=>E.identifier),(S.length||g.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:g})}}};I=ge([ee(1,p.IFileService),ee(2,k.INativeEnvironmentService),ee(3,l.ILogService),ee(4,f.IUriIdentityService)],I),i.ExtensionsWatcher=I}),define(Q[137],Z([0,1,29,104,13,18,69,4,2]),function(B,i,D,R,b,k,L,p,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class f{constructor(h){this.uri=h,this.time=f._clock++}touch(){return this.time=f._clock++,this}}f._clock=0;let I=class{constructor(h){this._fileService=h,this._dispooables=new l.DisposableStore,this._limit=2**16;const S=new Map,g=E=>{let v=S.get(E.scheme);return v===void 0&&(v=h.hasProvider(E)&&!this._fileService.hasCapability(E,1024),S.set(E.scheme,v)),v};this._dispooables.add(p.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(E=>{S.delete(E.scheme)})),this.extUri=new k.ExtUri(g),this._canonicalUris=new L.SkipList((E,v)=>this.extUri.compare(E,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,k.normalizePath)(h));const S=this._canonicalUris.get(h);return S?S.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new f(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((g,E)=>g[1].touch<E[1].touch?1:g[1].touch>E[1].touch?-1:0);f._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let g=0;g<S;g++)this._canonicalUris.set(h[g][0],h[g][1].touch())}};I=ge([ee(0,b.IFileService)],I),i.UriIdentityService=I,(0,R.registerSingleton)(D.IUriIdentityService,I,1)}),define(Q[138],Z([0,1,98,14,36,18,10,8,17]),function(B,i,D,R,b,k,L,p,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.hasWorkspaceFileExtension=i.isSavedWorkspace=i.isTemporaryWorkspace=i.isUntitledWorkspace=i.UNTITLED_WORKSPACE_NAME=i.WORKSPACE_FILTER=i.WORKSPACE_SUFFIX=i.WORKSPACE_EXTENSION=i.toWorkspaceFolder=i.WorkspaceFolder=i.Workspace=i.isWorkspaceFolder=i.isWorkspace=i.WorkbenchState=i.reviveIdentifier=i.isWorkspaceIdentifier=i.toWorkspaceIdentifier=i.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=i.isSingleFolderWorkspaceIdentifier=i.IWorkspaceContextService=void 0,i.IWorkspaceContextService=(0,p.createDecorator)("contextService");function f(r){const t=r;return typeof t?.id=="string"&&L.URI.isUri(t.uri)}i.isSingleFolderWorkspaceIdentifier=f,i.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function I(r,t){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,R.basename)(r)}:t?i.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=r;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}i.toWorkspaceIdentifier=I;function P(r){const t=r;return typeof t?.id=="string"&&L.URI.isUri(t.configPath)}i.isWorkspaceIdentifier=P;function h(r){const t=r;if(t?.uri)return{id:t.id,uri:L.URI.revive(t.uri)};const n=r;if(n?.configPath)return{id:n.id,configPath:L.URI.revive(n.configPath)};if(r?.id)return{id:r.id}}i.reviveIdentifier=h;var S;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(S=i.WorkbenchState||(i.WorkbenchState={}));function g(r){const t=r;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}i.isWorkspace=g;function E(r){const t=r;return!!(t&&typeof t=="object"&&L.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}i.isWorkspaceFolder=E;class v{constructor(t,n,o,d,y){this._id=t,this._transient=o,this._configuration=d,this._ignorePathCasing=y,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}i.Workspace=v;class a{constructor(t,n){this.raw=n,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,k.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}i.WorkspaceFolder=a;function u(r){return new a({uri:r,index:0,name:(0,k.basenameOrAuthority)(r)},{uri:r.toString()})}i.toWorkspaceFolder=u,i.WORKSPACE_EXTENSION="code-workspace",i.WORKSPACE_SUFFIX=`.${i.WORKSPACE_EXTENSION}`,i.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[i.WORKSPACE_EXTENSION]}],i.UNTITLED_WORKSPACE_NAME="workspace.json";function m(r,t){return k.extUriBiasedIgnorePathCase.isEqualOrParent(r,t.untitledWorkspacesHome)}i.isUntitledWorkspace=m;function c(r){let t;return L.URI.isUri(r)?t=r:t=r.configuration,t?.scheme===l.Schemas.tmp}i.isTemporaryWorkspace=c;function s(r,t){return!m(r,t)&&!c(r)}i.isSavedWorkspace=s;function e(r){return(typeof r=="string"?(0,R.extname)(r):(0,k.extname)(r))===i.WORKSPACE_SUFFIX}i.hasWorkspaceFileExtension=e}),define(Q[25],Z([0,1,53,4,2,18,5,10,97,16,13,8,9,138,36,29,3,30,27]),function(B,i,D,R,b,k,L,p,l,f,I,P,h,S,g,E,v,a,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryUserDataProfilesService=i.UserDataProfilesService=i.toUserDataProfile=i.EXTENSIONS_RESOURCE_NAME=i.reviveProfile=i.IUserDataProfilesService=i.PROFILES_ENABLEMENT_CONFIG=i.isUserDataProfile=void 0;function m(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&p.URI.isUri(n.location)&&p.URI.isUri(n.globalStorageHome)&&p.URI.isUri(n.settingsResource)&&p.URI.isUri(n.keybindingsResource)&&p.URI.isUri(n.tasksResource)&&p.URI.isUri(n.snippetsHome)&&((0,L.isUndefined)(n.extensionsResource)||p.URI.isUri(n.extensionsResource)))}i.isUserDataProfile=m,i.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",i.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function c(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:p.URI.revive(t.location).with({scheme:n}),globalStorageHome:p.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:p.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:p.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:p.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:p.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:p.URI.revive(t.extensionsResource)?.with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}i.reviveProfile=c,i.EXTENSIONS_RESOURCE_NAME="extensions.json";function s(t,n,o,d){return{id:t,name:n,location:o,isDefault:!1,shortName:d?.shortName,globalStorageHome:(0,k.joinPath)(o,"globalStorage"),settingsResource:(0,k.joinPath)(o,"settings.json"),keybindingsResource:(0,k.joinPath)(o,"keybindings.json"),tasksResource:(0,k.joinPath)(o,"tasks.json"),snippetsHome:(0,k.joinPath)(o,"snippets"),extensionsResource:(0,k.joinPath)(o,i.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:d?.useDefaultFlags,isTransient:d?.transient}}i.toUserDataProfile=s;let e=class extends b.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,o,d,y){super(),this.environmentService=n,this.fileService=o,this.uriIdentityService=d,this.logService=y,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new R.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new R.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new R.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new R.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new g.ResourceMap},this.profilesHome=(0,k.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(w=>s((0,k.basename)(w.location),w.name,w.location,{shortName:w.shortName,useDefaultFlags:w.useDefaultFlags})):[];let o;const d=new g.ResourceMap,y=s((0,D.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,l.localize)(0,null),this.environmentService.userRoamingDataHome);if(n.unshift({...y,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0||this.transientProfilesObject.profiles.length>0?y.extensionsResource:void 0}),n.length){const w=this.getStoredProfileAssociations();if(w.workspaces)for(const[C,z]of Object.entries(w.workspaces)){const _=p.URI.parse(C),X=p.URI.parse(z),H=n.find(ne=>this.uriIdentityService.extUri.isEqual(ne.location,X));H&&d.set(_,H)}if(w.emptyWindow){const C=p.URI.parse(w.emptyWindow);o=n.find(z=>this.uriIdentityService.extUri.isEqual(z.location,C))}}this._profilesObject={profiles:n,workspaces:d,emptyWindow:o}}return this._profilesObject}async createTransientProfile(n){const o="Temp",d=new RegExp(`${(0,u.escapeRegExpCharacters)(o)}\\s(\\d+)`);let y=0;for(const C of this.profiles){const z=d.exec(C.name),_=z?parseInt(z[1]):0;y=_>y?_:y}const w=`${o} ${y+1}`;return this.createProfile((0,D.hash)((0,a.generateUuid)()).toString(16),w,{transient:!0},n)}async createNamedProfile(n,o,d){return this.createProfile((0,D.hash)((0,a.generateUuid)()).toString(16),n,o,d)}async createProfile(n,o,d,y){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);const w=await this.doCreateProfile(n,o,d);return y&&await this.setProfileForWorkspace(y,w),w}async doCreateProfile(n,o,d){let y=this.profileCreationPromises.get(o);return y||(y=(async()=>{try{const w=this.profiles.find(_=>_.name===o||_.id===n);if(w)return w;const C=s(n,o,(0,k.joinPath)(this.profilesHome,n),d);await this.fileService.createFolder(C.location);const z=[];return this._onWillCreateProfile.fire({profile:C,join(_){z.push(_)}}),await v.Promises.settled(z),this.updateProfiles([C],[],[]),C}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,y)),y}async updateProfile(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);let d=this.profiles.find(y=>y.id===n.id);if(!d)throw new Error(`Profile '${n.name}' does not exist`);return d=s(d.id,o.name??d.name,d.location,{shortName:o.shortName??d.shortName,transient:o.transient??d.isTransient,useDefaultFlags:o.useDefaultFlags??d.useDefaultFlags}),this.updateProfiles([],[],[d]),d}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(y=>y.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const d=[];this._onWillRemoveProfile.fire({profile:o,join(y){d.push(y)}});try{await Promise.allSettled(d)}catch(y){this.logService.error(y)}o.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const y of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(y)?.id&&this.profilesObject.workspaces.delete(y);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(o.location,{recursive:!0})}catch(y){this.logService.error(y)}}getOrSetProfileForWorkspace(n,o=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let d=this.getProfileForWorkspace(n);return d||(d=o,this.profiles.length>1&&this.setProfileForWorkspaceSync(n,d)),d}async setProfileForWorkspace(n,o){this.setProfileForWorkspaceSync(n,o)}setProfileForWorkspaceSync(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);const d=this.profiles.find(y=>y.id===o.id);if(!d)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(n,d)}unsetWorkspace(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(d=>!this.uriIdentityService.extUri.isEqual(d.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.getWorkspace(n);return p.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(n){return(0,S.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,S.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}isProfileAssociatedToWorkspace(n){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,n.location)||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,n.location)||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location)))}updateProfiles(n,o,d){const y=[...this.profiles,...n],w=[];this.transientProfilesObject.profiles=[];for(let C of y)C.isDefault||o.some(z=>C.id===z.id)||(C=d.find(z=>C.id===z.id)??C,C.isTransient?this.transientProfilesObject.profiles.push(C):w.push({location:C.location,name:C.name,shortName:C.shortName,useDefaultFlags:C.useDefaultFlags}));this.saveStoredProfiles(w),this._profilesObject=void 0,this.triggerProfilesChanges(n,o,d)}triggerProfilesChanges(n,o,d){this._onDidChangeProfiles.fire({added:n,removed:o,updated:d,all:this.profiles})}updateWorkspaceAssociation(n,o,d){d=o?.isTransient?!0:d,d||this.updateWorkspaceAssociation(n,void 0,!0);const y=this.getWorkspace(n),w=d?this.transientProfilesObject:this.profilesObject;p.URI.isUri(y)?(w.workspaces.delete(y),o&&w.workspaces.set(y,o)):w.emptyWindow=o,d||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[d,y]of this.profilesObject.workspaces.entries())n[d.toString()]=y.location.toString();const o=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:o}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};e.PROFILES_KEY="userDataProfiles",e.PROFILE_ASSOCIATIONS_KEY="profileAssociations",e=ge([ee(0,f.IEnvironmentService),ee(1,I.IFileService),ee(2,E.IUriIdentityService),ee(3,h.ILogService)],e),i.UserDataProfilesService=e;class r extends e{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}i.InMemoryUserDataProfilesService=r}),define(Q[139],Z([0,1,19,3,24,11,4,2,12,10,82,22,23,34,9,28,35,25]),function(B,i,D,R,b,k,L,p,l,f,I,P,h,S,g,E,v,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let u=class extends p.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(t,n,o,d,y){super(),this.galleryService=t,this.telemetryService=n,this.logService=o,this.productService=d,this.userDataProfilesService=y,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this.participants=[],this._register((0,p.toDisposable)(()=>{this.installingExtensions.forEach(({task:w})=>w.cancel()),this.uninstallingExtensions.forEach(w=>w.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const n=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,P.isTargetPlatformCompatible)(o,t.allTargetPlatforms,n))}async installFromGallery(t,n={}){try{if(!this.galleryService.isEnabled())throw new P.ExtensionManagementError(I.localize(0,null),P.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(t,!!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,n)}catch(o){throw s(this.telemetryService,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(t),error:o}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(o),c(o)}}async uninstall(t,n={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,n)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(I.localize(1,null));const n=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:n,compatible:!0},b.CancellationToken.None);if(!o)throw new Error(I.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,n,o){const d=X=>`${h.ExtensionKey.create(X).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!f.URI.isUri(n)){const X=this.installingExtensions.get(d(n));if(X){this.logService.info("Extensions is already requested to install",n.identifier.id);const{local:H}=await X.task.waitUntilTaskIsFinished();return H}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const y=[],w=[],C=[],z=this.createInstallExtensionTask(t,n,o);f.URI.isUri(n)||this.installingExtensions.set(d(n),{task:z,waitingTasks:[]}),this._onInstallExtension.fire({identifier:z.identifier,source:n,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",z.identifier.id),y.push({task:z,manifest:t});let _=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",z.identifier.id);else try{const H=await this.getAllDepsAndPackExtensions(z.identifier,t,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),ne=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:re,manifest:se}of H){_=_||!!se.extensionDependencies?.some(ie=>(0,h.areSameExtensions)({id:ie},z.identifier));const fe=d(re),le=this.installingExtensions.get(fe);if(le){if(this.canWaitForTask(z,le.task)){this.logService.info("Waiting for already requested installing extension",re.identifier.id,z.identifier.id),le.waitingTasks.push(z);const ie=le.task.identifier;w.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,V=>V.some(N=>(0,h.areSameExtensions)(N.identifier,ie)))).then(V=>{if(!V.find(F=>(0,h.areSameExtensions)(F.identifier,ie))?.local)throw new Error(`Extension ${ie.id} is not installed`)}))}}else if(!ne.some(({identifier:ie})=>(0,h.areSameExtensions)(ie,re.identifier))){const ie=this.createInstallExtensionTask(se,re,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(fe,{task:ie,waitingTasks:[z]}),this._onInstallExtension.fire({identifier:ie.identifier,source:re,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",ie.identifier.id,z.identifier.id),y.push({task:ie,manifest:se})}}}catch(H){if(f.URI.isUri(z.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",z.identifier.id,H.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",z.identifier.id,H.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",z.identifier.id),H}const X=y.reduce((H,{task:ne,manifest:re})=>(H.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:re}),H),new Map);for(;X.size;){let H;const ne=[...X.values()].filter(({manifest:re})=>!re.extensionDependencies?.some(se=>X.has(se.toLowerCase())));ne.length?H=X.size===1?ne:ne.filter(({task:re})=>!(re===z&&!_)):(this.logService.info("Found extensions with circular dependencies",ne.map(({task:re})=>re.identifier.id)),H=[...X.values()]),await this.joinAllSettled(H.map(async({task:re})=>{const se=new Date().getTime();try{const{local:fe}=await re.run();if(await this.joinAllSettled(this.participants.map(le=>le.postInstall(fe,re.source,o,b.CancellationToken.None))),!f.URI.isUri(re.source)){const le=re.operation===3,ie=le?void 0:(new Date().getTime()-re.source.lastUpdated)/1e3;if(s(this.telemetryService,le?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(re.source),duration:new Date().getTime()-se,durationSinceUpdate:ie}),l.isWeb&&re.operation!==3)try{await this.galleryService.reportStatistic(fe.manifest.publisher,fe.manifest.name,fe.manifest.version,"install")}catch{}}C.push({local:fe,identifier:re.identifier,operation:re.operation,source:re.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:fe.isApplicationScoped})}catch(fe){throw f.URI.isUri(re.source)||s(this.telemetryService,re.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(re.source),duration:new Date().getTime()-se,error:fe}),this.logService.error("Error while installing the extension:",re.identifier.id),fe}finally{X.delete(re.identifier.id.toLowerCase())}}))}return w.length&&await this.joinAllSettled(w),C.forEach(({identifier:H})=>this.logService.info("Extension installed successfully:",H.id)),this._onDidInstallExtensions.fire(C),C.filter(({identifier:H})=>(0,h.areSameExtensions)(H,z.identifier))[0].local}catch(X){if(y.forEach(({task:H})=>H.cancel()),C.length)try{const H=await Promise.allSettled(C.map(({local:ne})=>this.createUninstallExtensionTask(ne,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let ne=0;ne<H.length;ne++){const re=H[ne],{identifier:se}=C[ne];re.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",se.id):this.logService.warn("Rollback: Error while uninstalling extension",se.id,(0,k.getErrorMessage)(re.reason))}}catch(H){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(H),C.map(({identifier:ne})=>ne.id))}throw this._onDidInstallExtensions.fire(y.map(({task:H})=>({identifier:H.identifier,operation:2,source:H.source,context:o.context,profileLocation:o.profileLocation}))),X}finally{for(const[X,{task:H,waitingTasks:ne}]of this.installingExtensions.entries()){const re=ne.indexOf(z);re!==-1&&ne.splice(re,1),ne.length===0&&(H===z||re!==-1)&&this.installingExtensions.delete(X)}}}canWaitForTask(t,n){for(const[,{task:o,waitingTasks:d}]of this.installingExtensions.entries())if(o===t&&(d.includes(n)||d.some(y=>this.canWaitForTask(y,n)))||o===n&&d[0]&&!this.canWaitForTask(t,d[0]))return!1;return!0}async joinAllSettled(t){const n=[],o=[],d=await Promise.allSettled(t);for(const y of d)y.status==="fulfilled"?n.push(y.value):o.push(y.reason);if(o.length)throw m(o);return n}async getAllDepsAndPackExtensions(t,n,o,d,y){if(!this.galleryService.isEnabled())return[];const w=await this.getInstalled(void 0,y),C=[t],z=[],_=async(X,H)=>{const ne=H.extensionDependencies||[],re=[...ne];if(H.extensionPack){const se=o?w.find(fe=>(0,h.areSameExtensions)(fe.identifier,X)):void 0;for(const fe of H.extensionPack)se&&se.manifest.extensionPack&&se.manifest.extensionPack.some(le=>(0,h.areSameExtensions)({id:le},{id:fe}))||re.every(le=>!(0,h.areSameExtensions)({id:le},{id:fe}))&&re.push(fe)}if(re.length){const se=[...C,...z.map(le=>le.gallery.identifier)],fe=re.filter(le=>se.every(ie=>!(0,h.areSameExtensions)(ie,{id:le})));if(fe.length){const le=await this.galleryService.getExtensions(fe.map(ie=>({id:ie,preRelease:d})),b.CancellationToken.None);for(const ie of le){if(se.find(F=>(0,h.areSameExtensions)(F,ie.identifier)))continue;const V=ne.some(F=>(0,h.areSameExtensions)({id:F},ie.identifier));let N;try{N=await this.checkAndGetCompatibleVersion(ie,!1,d)}catch(F){if(F instanceof P.ExtensionManagementError&&F.code===P.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!V){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}else throw F}z.push({gallery:N.extension,manifest:N.manifest}),await _(N.extension.identifier,N.manifest)}}}};return await _(t,n),z}async checkAndGetCompatibleVersion(t,n,o){if((await this.getExtensionsControlManifest()).malicious.some(C=>(0,h.areSameExtensions)(t.identifier,C)))throw new P.ExtensionManagementError(I.localize(3,null,t.identifier.id),P.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const C=await this.getTargetPlatform();throw new P.ExtensionManagementError(I.localize(4,null,t.identifier.id,this.productService.nameLong,(0,P.TargetPlatformToString)(C)),P.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const y=await this.getCompatibleVersion(t,n,o);if(y){if(o&&!n&&t.hasPreReleaseVersion&&!y.properties.isPreReleaseVersion)throw new P.ExtensionManagementError(I.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),P.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],b.CancellationToken.None))[0]?new P.ExtensionManagementError(I.localize(6,null,t.identifier.id),P.ExtensionManagementErrorCode.ReleaseVersionNotFound):new P.ExtensionManagementError(I.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),P.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",y.identifier.id);const w=await this.galleryService.getManifest(y,b.CancellationToken.None);if(w===null)throw new P.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,P.ExtensionManagementErrorCode.Invalid);if(w.version!==y.version)throw new P.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,P.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:w}}async getCompatibleVersion(t,n,o){const d=await this.getTargetPlatform();let y=null;return!n&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(y=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:d,compatible:!0},b.CancellationToken.None))[0]||null),!y&&await this.galleryService.isExtensionCompatible(t,o,d)&&(y=t),y||(n?y=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:d,compatible:!0},b.CancellationToken.None))[0]||null:y=await this.galleryService.getCompatibleExtension(t,o,d)),y}async uninstallExtension(t,n){const o=_=>`${_.id.toLowerCase()}${n.versionOnly?`-${t.manifest.version}`:""}${n.profileLocation?`@${n.profileLocation.toString()}`:""}`,d=this.uninstallingExtensions.get(o(t.identifier));if(d)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),d.waitUntilTaskIsFinished();const y=(_,X)=>{const H=this.createUninstallExtensionTask(_,X);return this.uninstallingExtensions.set(o(H.extension.identifier),H),n.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,n.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this._onUninstallExtension.fire({identifier:_.identifier,profileLocation:n.profileLocation,applicationScoped:_.isApplicationScoped}),H},w=(_,X)=>{X?n.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,n.profileLocation.toString(),X.message):this.logService.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,X.message):n.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,n.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)(_),error:X}),this._onDidUninstallExtension.fire({identifier:_.identifier,version:_.manifest.version,error:X?.code,profileLocation:n.profileLocation,applicationScoped:_.isApplicationScoped})},C=[],z=[];try{C.push(y(t,n));const _=await this.getInstalled(1,n.profileLocation);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const X=this.getAllPackExtensionsToUninstall(t,_);for(const H of X)this.uninstallingExtensions.has(o(H.identifier))?this.logService.info("Extensions is already requested to uninstall",H.identifier.id):C.push(y(H,n))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(C.map(X=>X.extension),_,t),await this.joinAllSettled(C.map(async X=>{try{if(await X.run(),await this.joinAllSettled(this.participants.map(H=>H.postUninstall(X.extension,n,b.CancellationToken.None))),X.extension.identifier.uuid)try{await this.galleryService.reportStatistic(X.extension.manifest.publisher,X.extension.manifest.name,X.extension.manifest.version,"uninstall")}catch{}w(X.extension)}catch(H){const ne=H instanceof P.ExtensionManagementError?H:new P.ExtensionManagementError((0,k.getErrorMessage)(H),P.ExtensionManagementErrorCode.Internal);throw w(X.extension,ne),ne}finally{z.push(X)}}))}catch(_){const X=_ instanceof P.ExtensionManagementError?_:new P.ExtensionManagementError((0,k.getErrorMessage)(_),P.ExtensionManagementErrorCode.Internal);for(const H of C){try{H.cancel()}catch{}z.includes(H)||w(H.extension,X)}throw X}finally{for(const _ of C)this.uninstallingExtensions.delete(o(_.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}checkForDependents(t,n,o){for(const d of t){const y=this.getDependents(d,n);if(y.length){const w=y.filter(C=>!t.some(z=>(0,h.areSameExtensions)(z.identifier,C.identifier)));if(w.length)throw new Error(this.getDependentsErrorMessage(d,w,o))}}}getDependentsErrorMessage(t,n,o){return o===t?n.length===1?I.localize(8,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?I.localize(9,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):I.localize(10,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?I.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?I.localize(12,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):I.localize(13,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(t,n,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const d=t.manifest.extensionPack?t.manifest.extensionPack:[];if(d.length){const y=n.filter(C=>!C.isBuiltin&&d.some(z=>(0,h.areSameExtensions)({id:z},C.identifier))),w=[];for(const C of y)w.push(...this.getAllPackExtensionsToUninstall(C,n,o));return[...y,...w]}return[]}getDependents(t,n){return n.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(d=>(0,h.areSameExtensions)({id:d},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,n,o){return o.profileLocation&&(0,S.isApplicationScopedExtension)(t)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,n,o)}createUninstallExtensionTask(t,n){return n.profileLocation&&t.isApplicationScoped&&(n={...n,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,n)}};u=ge([ee(0,P.IExtensionGalleryService),ee(1,v.ITelemetryService),ee(2,g.ILogService),ee(3,E.IProductService),ee(4,a.IUserDataProfilesService)],u),i.AbstractExtensionManagementService=u;function m(r){const t=Array.isArray(r)?r:[r];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((n,o)=>new Error(`${n.message}${n.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}i.joinErrors=m;function c(r){if(r instanceof P.ExtensionManagementError)return r;const t=new P.ExtensionManagementError(r.message,P.ExtensionManagementErrorCode.Internal);return t.stack=r.stack,t}function s(r,t,{extensionData:n,duration:o,error:d,durationSinceUpdate:y}){const w=d?d instanceof P.ExtensionManagementError?d.code:P.ExtensionManagementErrorCode.Internal:void 0;r.publicLog(t,{...n,success:!d,duration:o,errorcode:w,durationSinceUpdate:y})}i.reportTelemetry=s;class e{constructor(){this.barrier=new R.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(t=>new Promise((n,o)=>{const d=t.onCancellationRequested(()=>{d.dispose(),o(new k.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=e}),define(Q[48],Z([0,1,19,3,26,15,11,50,74,2,17,14,12,18,39,54,5,10,86,16,23,34,45,13,8,9,28,4,44,41,25,29,102]),function(B,i,D,R,b,k,L,p,l,f,I,P,h,S,g,E,v,a,u,m,c,s,e,r,t,n,o,d,y,w,C,z,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeExtensionsScannerService=i.toExtensionDescription=i.AbstractExtensionsScannerService=i.IExtensionsScannerService=i.Translations=void 0;var X;(function(ie){function V(N,F){if(N===F)return!0;const j=Object.keys(N),$=new Set;for(const Y of Object.keys(F))$.add(Y);if(j.length!==$.size)return!1;for(const Y of j){if(N[Y]!==F[Y])return!1;$.delete(Y)}return $.size===0}ie.equals=V})(X=i.Translations||(i.Translations={})),i.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let H=class extends f.Disposable{constructor(V,N,F,j,$,Y,A,U,T,O,M){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=N,this.extensionsControlLocation=F,this.cacheLocation=j,this.userDataProfilesService=$,this.extensionsProfileScannerService=Y,this.fileService=A,this.logService=U,this.environmentService=T,this.productService=O,this.instantiationService=M,this._onDidChangeCache=this._register(new d.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,S.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(se,(0,S.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(se,(0,S.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(re,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,c.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(V,N,F){const[j,$]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(N)]),Y=F?await this.scanExtensionsUnderDevelopment(V,[...j,...$]):[];return this.dedupExtensions(j,$,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const N=[];N.push(this.scanDefaultSystemExtensions(!!V.useCache,V.language)),N.push(this.scanDevSystemExtensions(V.language,!!V.checkControlFile));const[F,j]=await Promise.all(N);return this.applyScanOptions([...F,...j],0,V,!1)}async scanUserExtensions(V){this.logService.trace("Started scanning user extensions");const N=await this.createExtensionScannerInput(V.profileLocation??this.userExtensionsLocation,!!V.profileLocation,1,!V.includeUninstalled,V.language);let j=await(V.useCache&&!N.devMode&&N.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(N);return j=await this.applyScanOptions(j,1,V,!0),this.logService.trace("Scanned user extensions:",j.length),j}async scanExtensionsUnderDevelopment(V,N){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const F=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(j=>j.scheme===I.Schemas.file).map(async j=>{const $=await this.createExtensionScannerInput(j,!1,1,!0,V.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions($)).map(A=>(A.type=N.find(U=>(0,c.areSameExtensions)(U.identifier,A.identifier))?.type??A.type,this.extensionsScanner.validate(A,$)))}))).flat();return this.applyScanOptions(F,"development",V,!0)}return[]}async scanExistingExtension(V,N,F){const j=await this.createExtensionScannerInput(V,!1,N,!0,F.language),$=await this.extensionsScanner.scanExtension(j);return!$||!F.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(V,N,F){const j=await this.createExtensionScannerInput(V,!1,N,!0,F.language),$=await this.extensionsScanner.scanOneOrMultipleExtensions(j);return this.applyScanOptions($,N,F,!0)}async scanMetadata(V){const N=(0,S.joinPath)(V,"package.json"),F=(await this.fileService.readFile(N)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(V,N){const F=(0,S.joinPath)(V,"package.json"),j=(await this.fileService.readFile(F)).value.toString(),$=JSON.parse(j);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,$.__metadata={...$.__metadata,...N},await this.fileService.writeFile((0,S.joinPath)(V,"package.json"),k.VSBuffer.fromString(JSON.stringify($,null,"	")))}async applyScanOptions(V,N,F,j){return F.includeAllVersions||(V=this.dedupExtensions(N===0?V:void 0,N===1?V:void 0,N==="development"?V:void 0,await this.getTargetPlatform(),j)),F.includeInvalid||(V=V.filter($=>$.isValid)),V.sort(($,Y)=>{const A=P.basename($.location.fsPath),U=P.basename(Y.location.fsPath);return A<U?-1:A>U?1:0})}dedupExtensions(V,N,F,j,$){const Y=(U,T,O)=>{if(U.isValid&&!T.isValid)return!1;if(U.isValid===T.isValid){if($&&g.gt(U.manifest.version,T.manifest.version))return this.logService.debug(`Skipping extension ${T.location.path} with lower version ${T.manifest.version} in favour of ${U.location.path} with version ${U.manifest.version}`),!1;if(g.eq(U.manifest.version,T.manifest.version)){if(U.type===0)return this.logService.debug(`Skipping extension ${T.location.path} in favour of system extension ${U.location.path} with same version`),!1;if(U.targetPlatform===j)return this.logService.debug(`Skipping extension ${T.location.path} from different target platform ${T.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${U.location.path} with ${T.location.path}.`):this.logService.debug(`Overwriting user extension ${U.location.path} with ${T.location.path}.`),!0},A=new Map;return V?.forEach(U=>{const T=s.ExtensionIdentifier.toKey(U.identifier.id),O=A.get(T);(!O||Y(O,U,!1))&&A.set(T,U)}),N?.forEach(U=>{const T=s.ExtensionIdentifier.toKey(U.identifier.id),O=A.get(T);if(!O&&V&&U.type===0){this.logService.debug(`Skipping obsolete system extension ${U.location.path}.`);return}(!O||Y(O,U,!1))&&A.set(T,U)}),F?.forEach(U=>{const T=s.ExtensionIdentifier.toKey(U.identifier.id),O=A.get(T);(!O||Y(O,U,!0))&&A.set(T,U),A.set(T,U)}),[...A.values()]}async scanDefaultSystemExtensions(V,N){this.logService.trace("Started scanning system extensions");const F=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,N),$=await(V&&!F.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return this.logService.trace("Scanned system extensions:",$.length),$}async scanDevSystemExtensions(V,N){const F=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!F?.length)return[];this.logService.trace("Started scanning dev system extensions");const j=N?await this.getBuiltInExtensionControl():{},$=[],Y=a.URI.file(P.normalize(P.join(I.FileAccess.asFileUri("",B).fsPath,"..",".build","builtInExtensions")));for(const U of F){const T=j[U.name]||"marketplace";switch(T){case"disabled":break;case"marketplace":$.push((0,S.joinPath)(Y,U.name));break;default:$.push(a.URI.file(T));break}}const A=await Promise.all($.map(async U=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(U,!1,0,!0,V))));return this.logService.trace("Scanned dev system extensions:",A.length),(0,D.coalesce)(A)}async getBuiltInExtensionControl(){try{const V=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(V.value.toString())}catch{return{}}}async createExtensionScannerInput(V,N,F,j,$,Y=!0){const A=await this.getTranslations($??h.language),U=await this.getMtime(V),T=N?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=T?await this.getMtime(T):void 0;return new ne(V,U,T,O,N,F,j,Y,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,$,A)}async getMtime(V){try{const N=await this.fileService.stat(V);if(typeof N.mtime=="number")return N.mtime}catch{}}};H=ge([ee(4,C.IUserDataProfilesService),ee(5,w.IExtensionsProfileScannerService),ee(6,r.IFileService),ee(7,n.ILogService),ee(8,m.IEnvironmentService),ee(9,o.IProductService),ee(10,t.IInstantiationService)],H),i.AbstractExtensionsScannerService=H;class ne{constructor(V,N,F,j,$,Y,A,U,T,O,M,W,q,K){this.location=V,this.mtime=N,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=j,this.profile=$,this.type=Y,this.excludeObsolete=A,this.validate=U,this.productVersion=T,this.productDate=O,this.productCommit=M,this.devMode=W,this.language=q,this.translations=K}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,N){return(0,S.isEqual)(V.location,N.location)&&V.mtime===N.mtime&&(0,S.isEqual)(V.applicationExtensionslocation,N.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&V.profile===N.profile&&V.type===N.type&&V.excludeObsolete===N.excludeObsolete&&V.validate===N.validate&&V.productVersion===N.productVersion&&V.productDate===N.productDate&&V.productCommit===N.productCommit&&V.devMode===N.devMode&&V.language===N.language&&X.equals(V.translations,N.translations)}}let re=class extends f.Disposable{constructor(V,N,F,j,$){super(),this.obsoleteFile=V,this.extensionsProfileScannerService=N,this.uriIdentityService=F,this.fileService=j,this.logService=$}async scanExtensions(V){const N=V.profile?await this.scanExtensionsFromProfile(V):await this.scanExtensionsFromLocation(V);let F={};if(V.excludeObsolete&&V.type===1)try{const j=(await this.fileService.readFile(this.obsoleteFile)).value.toString();F=JSON.parse(j)}catch{}return(0,v.isEmptyObject)(F)?N:N.filter(j=>!F[c.ExtensionKey.create(j).toString()])}async scanExtensionsFromLocation(V){const N=await this.fileService.resolve(V.location);if(!N.children?.length)return[];const F=await Promise.all(N.children.map(async j=>{if(!j.isDirectory||V.type===1&&(0,S.basename)(j.resource).indexOf(".")===0)return null;const $=new ne(j.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension($)}));return(0,D.coalesce)(F).sort((j,$)=>j.location.path<$.location.path?-1:1)}async scanExtensionsFromProfile(V){let N=await this.scanExtensionsFromProfileResource(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(V.location,V.applicationExtensionslocation)){N=N.filter(j=>!j.metadata?.isApplicationScoped);const F=await this.scanExtensionsFromProfileResource(V.applicationExtensionslocation,j=>!!j.metadata?.isApplicationScoped,V);N.push(...F)}return N}async scanExtensionsFromProfileResource(V,N,F){const j=await this.extensionsProfileScannerService.scanProfileExtensions(V);if(!j.length)return[];const $=await Promise.all(j.map(async Y=>{if(N(Y)){const A=new ne(Y.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(A,Y.metadata)}return null}));return(0,D.coalesce)($)}async scanOneOrMultipleExtensions(V){try{if(await this.fileService.exists((0,S.joinPath)(V.location,"package.json"))){const N=await this.scanExtension(V);return N?[N]:[]}else return await this.scanExtensions(V)}catch(N){return this.logService.error(`Error scanning extensions at ${V.location.path}:`,(0,L.getErrorMessage)(N)),[]}}async scanExtension(V,N){try{let F=await this.scanExtensionManifest(V.location);if(F){F.publisher||(F.publisher=s.UNDEFINED_PUBLISHER),N=N??F.__metadata,delete F.__metadata;const j=(0,c.getGalleryExtensionId)(F.publisher,F.name),$=N?.id?{id:j,uuid:N.id}:{id:j},Y=N?.isSystem?0:V.type,A=Y===0||!!N?.isBuiltin;F=await this.translateManifest(V.location,F,ne.createNlsConfiguration(V));const U={type:Y,identifier:$,manifest:F,location:V.location,isBuiltin:A,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return V.validate?this.validate(U,V):U}}catch(F){V.type!==0&&this.logService.error(F)}return null}validate(V,N){let F=!0;const j=(0,e.validateExtensionManifest)(N.productVersion,N.productDate,N.location,V.manifest,V.isBuiltin);for(const[$,Y]of j)$===E.default.Error&&(F=!1,this.logService.error(this.formatMessage(N.location,Y)));return V.isValid=F,V.validations=j,V}async scanExtensionManifest(V){const N=(0,S.joinPath)(V,"package.json");let F;try{F=(await this.fileService.readFile(N)).value.toString()}catch($){return(0,r.toFileOperationResult)($)!==1&&this.logService.error(this.formatMessage(V,(0,u.localize)(0,null,N.path,$.message))),null}let j;try{j=JSON.parse(F)}catch{const Y=[];(0,p.parse)(F,Y);for(const A of Y)this.logService.error(this.formatMessage(V,(0,u.localize)(1,null,N.path,A.offset,A.length,(0,l.getParseErrorMessage)(A.error))));return null}return(0,p.getNodeType)(j)!=="object"?(this.logService.error(this.formatMessage(V,(0,u.localize)(2,null,N.path))),null):j}async translateManifest(V,N,F){const j=await this.getLocalizedMessages(V,N,F);if(j)try{const $=[],Y=await this.resolveOriginalMessageBundle(j.default,$);if($.length>0)return $.forEach(U=>{this.logService.error(this.formatMessage(V,(0,u.localize)(3,null,j.default?.path,(0,l.getParseErrorMessage)(U.error))))}),N;if((0,p.getNodeType)(j)!=="object")return this.logService.error(this.formatMessage(V,(0,u.localize)(4,null,j.default?.path))),N;const A=j.values||Object.create(null);return(0,_.localizeManifest)(N,A,Y)}catch{}return N}async getLocalizedMessages(V,N,F){const j=(0,S.joinPath)(V,"package.nls.json"),$=(T,O)=>{O.forEach(M=>{this.logService.error(this.formatMessage(V,(0,u.localize)(5,null,T?.path,(0,l.getParseErrorMessage)(M.error))))})},Y=T=>{this.logService.error(this.formatMessage(V,(0,u.localize)(6,null,T?.path)))},A=`${N.publisher}.${N.name}`,U=F.translations[A];if(U)try{const T=a.URI.file(U),O=(await this.fileService.readFile(T)).value.toString(),M=[],W=(0,p.parse)(O,M);return M.length>0?($(T,M),{values:void 0,default:j}):(0,p.getNodeType)(W)!=="object"?(Y(T),{values:void 0,default:j}):{values:W.contents?W.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.fileService.exists(j))return;let O;try{O=await this.findMessageBundles(V,F)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const M=(await this.fileService.readFile(O.localized)).value.toString(),W=[],q=(0,p.parse)(M,W);return W.length>0?($(O.localized,W),{values:void 0,default:O.original}):(0,p.getNodeType)(q)!=="object"?(Y(O.localized),{values:void 0,default:O.original}):{values:q,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(V,N){if(V)try{const F=(await this.fileService.readFile(V)).value.toString();return(0,p.parse)(F,N)}catch{}}findMessageBundles(V,N){return new Promise((F,j)=>{const $=Y=>{const A=(0,S.joinPath)(V,`package.nls.${Y}.json`);this.fileService.exists(A).then(U=>{U&&F({localized:A,original:(0,S.joinPath)(V,"package.nls.json")});const T=Y.lastIndexOf("-");T===-1?F({localized:(0,S.joinPath)(V,"package.nls.json"),original:null}):(Y=Y.substring(0,T),$(Y))})};if(N.devMode||N.pseudo||!N.language)return F({localized:(0,S.joinPath)(V,"package.nls.json"),original:null});$(N.language)})}formatMessage(V,N){return`[${V.path}]: ${N}`}};re=ge([ee(1,w.IExtensionsProfileScannerService),ee(2,z.IUriIdentityService),ee(3,r.IFileService),ee(4,n.ILogService)],re);let se=class extends re{constructor(V,N,F,j,$,Y){super(N,F,j,$,Y),this.cacheFile=V,this.cacheValidatorThrottler=this._register(new R.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new d.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(V){const N=await this.readExtensionCache();if(this.input=V,N&&N.input&&ne.equals(N.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),N.result.map(j=>(j.location=a.URI.revive(j.location),j));const F=await super.scanExtensions(V);return await this.writeExtensionCache({input:V,result:F}),F}async readExtensionCache(){try{const V=await this.fileService.readFile(this.cacheFile),N=JSON.parse(V.value.toString());return{result:N.result,input:(0,y.revive)(N.input)}}catch(V){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(V))}return null}async writeExtensionCache(V){try{await this.fileService.writeFile(this.cacheFile,k.VSBuffer.fromString(JSON.stringify(V)))}catch(N){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(N))}}async validateCache(){if(!this.input)return;const V=await this.readExtensionCache();if(!V)return;const N=V.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!b.equals(F,N))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(j){this.logService.error(j)}}};se=ge([ee(2,w.IExtensionsProfileScannerService),ee(3,z.IUriIdentityService),ee(4,r.IFileService),ee(5,n.ILogService)],se);function fe(ie,V){const N=(0,c.getExtensionId)(ie.manifest.publisher,ie.manifest.name);return{id:N,identifier:new s.ExtensionIdentifier(N),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:V,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}i.toExtensionDescription=fe;class le extends H{constructor(V,N,F,j,$,Y,A,U,T,O,M){super(V,N,(0,S.joinPath)(F,".vscode-oss-dev","extensions","control.json"),(0,S.joinPath)(j,s.MANIFEST_CACHE_FOLDER),$,Y,A,U,T,O,M),this.translationsPromise=(async()=>{if(h.translationsConfigFile)try{const W=await this.fileService.readFile(a.URI.file(h.translationsConfigFile));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}getTranslations(V){return this.translationsPromise}}i.NativeExtensionsScannerService=le}),define(Q[140],Z([0,1,57,3,31,4,2,17,14,20,9,25]),function(B,i,D,R,b,k,L,p,l,f,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let h=class extends L.Disposable{constructor(g,E){super(),this.userDataProfilesService=g,this.logService=E,this.processesLimiter=new R.Limiter(5)}async postUninstall(g){const E=this.parseScript(g,"uninstall");return E&&(this.logService.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(E.script,"uninstall",E.args,!0,g).then(()=>this.logService.info(g.identifier.id,g.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(g.identifier.id,g.manifest.version,`Failed to run post uninstall script: ${v}`)))),f.Promises.rm(this.getExtensionStoragePath(g)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(g,E){const v=`vscode:${E}`;if(g.location.scheme===p.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[v]=="string"){const a=g.manifest.scripts[v].split(" ");return a.length<2||a[0]!=="node"||!a[1]?(this.logService.warn(g.identifier.id,g.manifest.version,`${v} should be a node script`),null):{script:(0,l.join)(g.location.fsPath,a[1]),args:a.slice(2)||[]}}return null}runLifecycleHook(g,E,v,a,u){return new Promise((m,c)=>{const s=this.start(g,E,v,u);let e;const r=t=>{e&&(clearTimeout(e),e=null),t?c(t):m(void 0)};s.on("error",t=>{r((0,b.toErrorMessage)(t)||"Unknown")}),s.on("exit",(t,n)=>{r(t?`post-${E} process exited with code ${t}`:void 0)}),a&&(e=setTimeout(()=>{e=null,s.kill(),c("timed out")},5e3))})}start(g,E,v,a){const u={silent:!0,execArgv:void 0},m=(0,D.fork)(g,[`--type=extension-post-${E}`,...v],u);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const c=k.Event.fromNodeEventEmitter(m.stdout,"data"),s=k.Event.fromNodeEventEmitter(m.stderr,"data");c(t=>this.logService.info(a.identifier.id,a.manifest.version,`post-${E}`,t)),s(t=>this.logService.error(a.identifier.id,a.manifest.version,`post-${E}`,t));const e=k.Event.any(k.Event.map(c,t=>({data:`%c${t}`,format:[""]})),k.Event.map(s,t=>({data:`%c${t}`,format:["color: red"]})));return k.Event.debounce(e,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(a.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),m}getExtensionStoragePath(g){return(0,l.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};h=ge([ee(0,P.IUserDataProfilesService),ee(1,I.ILogService)],h),i.ExtensionsLifecycle=h}),define(Q[141],Z([0,1,10,16,41,48,13,8,9,28,25]),function(B,i,D,R,b,k,L,p,l,f,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScannerService=void 0;let P=class extends k.NativeExtensionsScannerService{constructor(S,g,E,v,a,u,m){super(D.URI.file(a.builtinExtensionsPath),D.URI.file(a.extensionsPath),a.userHome,D.URI.file(a.userDataPath),S,g,E,v,a,u,m)}};P=ge([ee(0,I.IUserDataProfilesService),ee(1,b.IExtensionsProfileScannerService),ee(2,L.IFileService),ee(3,l.ILogService),ee(4,R.INativeEnvironmentService),ee(5,f.IProductService),ee(6,p.IInstantiationService)],P),i.ExtensionsScannerService=P}),define(Q[142],Z([0,1,3,4,2,112,5,79,8,25]),function(B,i,D,R,b,k,L,p,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.isProfileUsingDefaultStorage=i.AbstractStorageService=i.loadKeyTargets=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.TARGET_KEY=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker",i.TARGET_KEY="__$__targetStorageMarker",i.IStorageService=(0,l.createDecorator)("storageService");var I;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(I=i.WillSaveStateReason||(i.WillSaveStateReason={}));var P;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(P=i.StorageScope||(i.StorageScope={}));var h;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(h=i.StorageTarget||(i.StorageTarget={}));function S(u){const m=u.get(i.TARGET_KEY);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}i.loadKeyTargets=S;class g extends b.Disposable{constructor(m={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super(),this.options=m,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,c){if(c===i.TARGET_KEY){switch(m){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:m})}else this._onDidChangeValue.fire({scope:m,key:c,target:this.getKeyTargets(m)[c]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,c,s){return this.getStorage(c)?.get(m,s)}getBoolean(m,c,s){return this.getStorage(c)?.getBoolean(m,s)}getNumber(m,c,s){return this.getStorage(c)?.getNumber(m,s)}store(m,c,s,e){if((0,L.isUndefinedOrNull)(c)){this.remove(m,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,s,e),this.getStorage(s)?.set(m,c)})}remove(m,c){this.withPausedEmitters(()=>{this.updateKeyTarget(m,c,void 0),this.getStorage(c)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,c){const s=[],e=this.getKeyTargets(m);for(const r of Object.keys(e))e[r]===c&&s.push(r);return s}updateKeyTarget(m,c,s){const e=this.getKeyTargets(c);typeof s=="number"?e[m]!==s&&(e[m]=s,this.getStorage(c)?.set(i.TARGET_KEY,JSON.stringify(e))):typeof e[m]=="number"&&(delete e[m],this.getStorage(c)?.set(i.TARGET_KEY,JSON.stringify(e)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(m){switch(m){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(m){const c=this.getStorage(m);return c?S(c):Object.create(null)}isNew(m){return this.getBoolean(i.IS_NEW_KEY,m)===!0}async flush(m=I.NONE){this._onWillSaveState.fire({reason:m});const c=this.getStorage(-1),s=this.getStorage(0),e=this.getStorage(1);switch(m){case I.NONE:await D.Promises.settled([c?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),e?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await D.Promises.settled([c?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),e?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.getStorage(-1)?.items??new Map,c=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return a(m,c,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(m,c){return this.emitWillSaveState(I.NONE),(0,f.isUserDataProfile)(m)?this.switchToProfile(m,c):this.switchToWorkspace(m,c)}canSwitchProfile(m,c){return!(m.id===c.id||E(c)&&E(m))}switchData(m,c,s,e){this.withPausedEmitters(()=>{if(e)for(const[r,t]of m)c.set(r,t);else{const r=new Set;for(const[t,n]of m)r.add(t),c.get(t)!==n&&this.emitDidChangeValue(s,t);for(const[t]of c.items)r.has(t)||this.emitDidChangeValue(s,t)}})}}i.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;function E(u){return u.isDefault||!!u.useDefaultFlags?.uiState}i.isProfileUsingDefaultStorage=E;class v extends g{constructor(){super(),this.applicationStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.profileStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.profileStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),this._register(this.applicationStorage.onDidChangeStorage(m=>this.emitDidChangeValue(-1,m)))}getStorage(m){switch(m){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(m){return!1}}i.InMemoryStorageService=v;async function a(u,m,c,s,e,r){const t=X=>{try{return JSON.parse(X)}catch{return X}},n=new Map,o=new Map;u.forEach((X,H)=>{n.set(H,X),o.set(H,t(X))});const d=new Map,y=new Map;m.forEach((X,H)=>{d.set(H,X),y.set(H,t(X))});const w=new Map,C=new Map;c.forEach((X,H)=>{w.set(H,X),C.set(H,t(X))}),console.group(s!==e?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const z=[];if(n.forEach((X,H)=>{z.push({key:H,value:X})}),console.table(z),console.groupEnd(),console.log(o),s!==e){console.group(`Storage: Profile (path: ${e}, profile specific)`);const X=[];d.forEach((H,ne)=>{X.push({key:ne,value:H})}),console.table(X),console.groupEnd(),console.log(y)}console.group(`Storage: Workspace (path: ${r})`);const _=[];w.forEach((X,H)=>{_.push({key:H,value:X})}),console.table(_),console.groupEnd(),console.log(C)}i.logStorage=a}),define(Q[143],Z([0,1,19,24,11,12,32,5,10,21,16,22,23,45,13,9,28,47,130,142,35]),function(B,i,D,R,b,k,L,p,l,f,I,P,h,S,g,E,v,a,u,m,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const s=k.isWeb?"web":(0,P.getTargetPlatform)(k.platform,L.arch);var e;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(e||(e={}));function r(...T){return String(T.reduce((O,M)=>O|M,0))}var t;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class w{constructor(O=y){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(O,M=this.state.pageSize){return new w({...this.state,pageNumber:O,pageSize:M})}withFilter(O,...M){const W=[...this.state.criteria,...M.length?M.map(q=>({filterType:O,value:q})):[{filterType:O}]];return new w({...this.state,criteria:W})}withSortBy(O){return new w({...this.state,sortBy:O})}withSortOrder(O){return new w({...this.state,sortOrder:O})}withFlags(...O){return new w({...this.state,flags:O.reduce((M,W)=>M|W,0)})}withAssetTypes(...O){return new w({...this.state,assetTypes:O})}withSource(O){return new w({...this.state,source:O})}get raw(){const{criteria:O,pageNumber:M,pageSize:W,sortBy:q,sortOrder:K,flags:ae,assetTypes:ce}=this.state;return{filters:[{criteria:O,pageNumber:M,pageSize:W,sortBy:q,sortOrder:K}],assetTypes:ce,flags:ae}}get searchText(){const O=this.state.criteria.filter(M=>M.filterType===t.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function C(T,O){const M=(T||[]).filter(W=>W.statisticName===O)[0];return M?M.value:0}function z(T){const O="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(W=>W.assetType.indexOf(O)===0).reduce((W,q)=>{const K=H(T,q.assetType);return K&&W.push([q.assetType.substring(O.length),K]),W},[])}function _(T){if(T.properties){const O=T.properties.filter(q=>q.key===n.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=O.filter(q=>M.test(q.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return H(T,n.Repository)}function X(T){return{uri:`${T.fallbackAssetUri}/${n.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${n.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function H(T,O){return T.files.filter(W=>W.assetType===O)[0]?{uri:`${T.assetUri}/${O}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${O}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function ne(T,O){const M=T.properties?T.properties.filter(q=>q.key===O):[],W=M.length>0&&M[0].value;return W?W.split(",").map(q=>(0,h.adoptToGalleryExtensionId)(q)):[]}function re(T){const O=T.properties?T.properties.filter(M=>M.key===o.Engine):[];return O.length>0&&O[0].value||""}function se(T){const O=T.properties?T.properties.filter(M=>M.key===o.PreRelease):[];return O.length>0&&O[0].value==="true"}function fe(T){const O=T.properties?T.properties.filter(W=>W.key===o.LocalizedLanguages):[],M=O.length>0&&O[0].value||"";return M?M.split(","):[]}function le(T){return T.properties?.find(O=>O.key===o.SponsorLink)?.value}function ie(T){return T.indexOf("preview")!==-1}function V(T){return T.targetPlatform?(0,P.toTargetPlatform)(T.targetPlatform):"undefined"}function N(T){const O=(0,D.distinct)(T.versions.map(V)),M=!!T.tags?.includes(P.WEB_EXTENSION_TAG),W=O.indexOf("web");return M?W===-1&&O.push("web"):W!==-1&&O.splice(W,1),O}function F(T,O){const M=(0,P.getFallbackTargetPlarforms)(O);for(let W=0;W<T.length;W++){const q=T[W];if(q.version===T[W-1]?.version){let K=W;const ae=V(q);if(ae===O)for(;K>0&&T[K-1].version===q.version;)K--;else if(M.includes(ae))for(;K>0&&T[K-1].version===q.version&&V(T[K-1])!==O;)K--;K!==W&&(T.splice(W,1),T.splice(K,0,q))}}return T}i.sortExtensionVersions=F;function j(T,O,M){T.telemetryData={index:O,querySource:M}}function $(T,O,M){const W=T.versions[0],q={manifest:H(O,n.Manifest),readme:H(O,n.Details),changelog:H(O,n.Changelog),license:H(O,n.License),repository:_(O),download:X(O),icon:H(O,n.Icon),coreTranslations:z(O)};return{identifier:{id:(0,h.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:O.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:le(W),description:T.shortDescription||"",installCount:C(T.statistics,"install"),rating:C(T.statistics,"averagerating"),ratingCount:C(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:M,assets:q,properties:{dependencies:ne(O,o.Dependency),extensionPack:ne(O,o.ExtensionPack),engine:re(O),localizedLanguages:fe(O),targetPlatform:V(O),isPreReleaseVersion:se(O)},hasPreReleaseVersion:se(W),hasReleaseVersion:!0,preview:ie(T.flags)}}let Y=class{constructor(O,M,W,q,K,ae,ce,pe){this.requestService=M,this.logService=W,this.environmentService=q,this.telemetryService=K,this.fileService=ae,this.productService=ce,this.configurationService=pe;const Se=ce.extensionsGallery;this.extensionsGalleryUrl=Se?.serviceUrl,this.extensionsGallerySearchUrl=Se?.searchUrl,this.extensionsControlUrl=Se?.controlUrl,this.commonHeadersPromise=(0,u.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,O,this.telemetryService)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,M,W){const q=R.CancellationToken.isCancellationToken(M)?{}:M,K=R.CancellationToken.isCancellationToken(M)?M:W,ae=[],ce=[],pe=[],Se=[];let te=!0;for(const he of O){he.uuid?ce.push(he.uuid):ae.push(he.id);const ve=!!(he.version||he.preRelease);pe.push({id:he.id,uuid:he.uuid,includePreRelease:ve}),he.version&&Se.push({id:he.id,uuid:he.uuid,version:he.version}),te=te&&!!he.hasPreRelease&&!ve}if(!ce.length&&!ae.length)return[];let oe=new w().withPage(1,O.length);ce.length&&(oe=oe.withFilter(t.ExtensionId,...ce)),ae.length&&(oe=oe.withFilter(t.ExtensionName,...ae)),(q.queryAllVersions||te)&&(oe=oe.withFlags(oe.flags,e.IncludeVersions)),q.source&&(oe=oe.withSource(q.source));const{extensions:de}=await this.queryGalleryExtensions(oe,{targetPlatform:q.targetPlatform??s,includePreRelease:pe,versions:Se,compatible:!!q.compatible},K);return q.source&&de.forEach((he,ve)=>j(he,ve,q.source)),de}async getCompatibleExtension(O,M,W){if((0,P.isNotWebExtensionInWebTargetPlatform)(O.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(O,M,W))return O;const q=new w().withFlags(e.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,O.identifier.uuid),{extensions:K}=await this.queryGalleryExtensions(q,{targetPlatform:W,compatible:!0,includePreRelease:M},R.CancellationToken.None);return K[0]||null}async isExtensionCompatible(O,M,W){if(!(0,P.isTargetPlatformCompatible)(O.properties.targetPlatform,O.allTargetPlatforms,W)||!M&&O.properties.isPreReleaseVersion)return!1;let q=O.properties.engine;if(!q){const K=await this.getManifest(O,R.CancellationToken.None);if(!K)throw new Error("Manifest was not found");q=K.engines.vscode}return(0,S.isEngineValid)(q,this.productService.version,this.productService.date)}async isValidVersion(O,M,W,q,K){if(!(0,P.isTargetPlatformCompatible)(V(O),q,K)||M!=="any"&&se(O)!==(M==="prerelease"))return!1;if(W)try{const ae=await this.getEngine(O);if(!(0,S.isEngineValid)(ae,this.productService.version,this.productService.date))return!1}catch(ae){return this.logService.error(`Error while getting the engine for the version ${O.version}.`,(0,b.getErrorMessage)(ae)),!1}return!0}async query(O,M){let W=O.text||"";const q=O.pageSize??50;let K=new w().withPage(1,q);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,oe,de)=>(K=K.withFilter(t.Category,de||oe),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,oe,de)=>(K=K.withFilter(t.Tag,de||oe),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(t.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),K=K.withFilter(t.SearchText,W)),K=K.withSortBy(0)):O.ids?K=K.withFilter(t.ExtensionId,...O.ids):O.names?K=K.withFilter(t.ExtensionName,...O.names):K=K.withSortBy(4),typeof O.sortBy=="number"&&(K=K.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(K=K.withSortOrder(O.sortOrder)),O.source&&(K=K.withSource(O.source));const ae=async(te,oe)=>{const{extensions:de,total:he}=await this.queryGalleryExtensions(te,{targetPlatform:s,compatible:!1,includePreRelease:!!O.includePreRelease},oe);return de.forEach((ve,ke)=>j(ve,(te.pageNumber-1)*te.pageSize+ke,O.source)),{extensions:de,total:he}},{extensions:ce,total:pe}=await ae(K,M),Se=async(te,oe)=>{if(oe.isCancellationRequested)throw new b.CancellationError;const{extensions:de}=await ae(K.withPage(te+1),oe);return de};return{firstPage:ce,total:pe,pageSize:K.pageSize,getPage:Se}}async queryGalleryExtensions(O,M,W){const q=O.flags;!!(O.flags&e.IncludeLatestVersionOnly)&&!!(O.flags&e.IncludeVersions)&&(O=O.withFlags(O.flags&~e.IncludeVersions,e.IncludeLatestVersionOnly)),!(O.flags&e.IncludeLatestVersionOnly)&&!(O.flags&e.IncludeVersions)&&(O=O.withFlags(O.flags,e.IncludeLatestVersionOnly)),M.versions?.length&&(O=O.withFlags(O.flags&~e.IncludeLatestVersionOnly,e.IncludeVersions)),O=O.withFlags(O.flags,e.IncludeAssetUri,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeStatistics,e.IncludeVersionProperties);const{galleryExtensions:K,total:ae}=await this.queryRawGalleryExtensions(O,W);if(!(O.flags&e.IncludeLatestVersionOnly)){const te=[];for(const oe of K){const de=await this.toGalleryExtensionWithCriteria(oe,M);de&&te.push(de)}return{extensions:te,total:ae}}const pe=[],Se=new Map;for(let te=0;te<K.length;te++){const oe=K[te],de={id:(0,h.getGalleryExtensionId)(oe.publisher.publisherName,oe.extensionName),uuid:oe.extensionId},he=(0,p.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(ke=>(0,h.areSameExtensions)(ke,de))?.includePreRelease;if(M.compatible&&(0,P.isNotWebExtensionInWebTargetPlatform)(N(oe),M.targetPlatform))continue;const ve=await this.toGalleryExtensionWithCriteria(oe,M);!ve||ve.properties.isPreReleaseVersion&&(!he||!ve.hasReleaseVersion)||!ve.properties.isPreReleaseVersion&&ve.properties.targetPlatform!==M.targetPlatform&&ve.hasPreReleaseVersion?Se.set(oe.extensionId,te):pe.push([te,ve])}if(Se.size){const te=new Date().getTime(),oe=new w().withFlags(q&~e.IncludeLatestVersionOnly,e.IncludeVersions).withPage(1,Se.size).withFilter(t.ExtensionId,...Se.keys()),{extensions:de}=await this.queryGalleryExtensions(oe,M,W);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-te,count:Se.size});for(const he of de){const ve=Se.get(he.identifier.uuid);pe.push([ve,he])}}return{extensions:pe.sort((te,oe)=>te[0]-oe[0]).map(([,te])=>te),total:ae}}async toGalleryExtensionWithCriteria(O,M){const W={id:(0,h.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},q=M.versions?.find(pe=>(0,h.areSameExtensions)(pe,W))?.version,K=(0,p.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(pe=>(0,h.areSameExtensions)(pe,W))?.includePreRelease,ae=N(O),ce=F(O.versions,M.targetPlatform);if(M.compatible&&(0,P.isNotWebExtensionInWebTargetPlatform)(ae,M.targetPlatform))return null;for(let pe=0;pe<ce.length;pe++){const Se=ce[pe];if(!(q&&Se.version!==q)){if(await this.isValidVersion(Se,K?"any":"release",M.compatible,ae,M.targetPlatform))return $(O,Se,ae);if(q&&Se.version===q)return null}}return q||M.compatible?null:$(O,O.versions[0],ae)}async queryRawGalleryExtensions(O,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,e.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,r(e.Unpublished));const W=await this.commonHeadersPromise,q=JSON.stringify(O.raw),K={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},ae=new Date().getTime();let ce,pe,Se=0;try{if(ce=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&O.criteria.some(oe=>oe.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:q,headers:K},M),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:Se};const te=await(0,a.asJson)(ce);if(te){const oe=te.results[0],de=oe.extensions,he=oe.resultMetadata&&oe.resultMetadata.filter(ve=>ve.metadataType==="ResultCount")[0];return Se=he&&he.metadataItems.filter(ve=>ve.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:Se}}return{galleryExtensions:[],total:Se}}catch(te){throw pe=te,te}finally{this.telemetryService.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(q.length),duration:new Date().getTime()-ae,success:!!ce&&(0,a.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:pe?(0,b.isCancellationError)(pe)?"canceled":(0,b.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Se)})}}async reportStatistic(O,M,W,q){if(!this.isEnabled())return;const K=k.isWeb?this.api(`/itemName/${O}.${M}/version/${W}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${O}/extensions/${M}/${W}/stats?statType=${q}`),ae=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:K,headers:pe},R.CancellationToken.None)}catch{}}async download(O,M,W){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const q=(0,h.getGalleryExtensionTelemetryData)(O),K=new Date().getTime(),ae=te=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...q,duration:te}),ce=W===2?"install":W===3?"update":"",pe=ce?{uri:`${O.assets.download.uri}${l.URI.parse(O.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${O.assets.download.fallbackUri}${l.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:O.assets.download,Se=await this.getAsset(pe);await this.fileService.writeFile(M,Se.stream),ae(new Date().getTime()-K)}async getReadme(O,M){if(O.assets.readme){const W=await this.getAsset(O.assets.readme,{},M);return await(0,a.asTextOrError)(W)||""}return""}async getManifest(O,M){if(O.assets.manifest){const W=await this.getAsset(O.assets.manifest,{},M),q=await(0,a.asTextOrError)(W);return q?JSON.parse(q):null}return null}async getManifestFromRawExtensionVersion(O,M){const W=H(O,n.Manifest);if(!W)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},K=await this.getAsset(W,{headers:q});return await(0,a.asJson)(K)}async getCoreTranslation(O,M){const W=O.assets.coreTranslations.filter(q=>q[0]===M.toUpperCase())[0];if(W){const q=await this.getAsset(W[1]),K=await(0,a.asTextOrError)(q);return K?JSON.parse(K):null}return null}async getChangelog(O,M){if(O.assets.changelog){const W=await this.getAsset(O.assets.changelog,{},M);return await(0,a.asTextOrError)(W)||""}return""}async getAllCompatibleVersions(O,M,W){let q=new w().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);O.identifier.uuid?q=q.withFilter(t.ExtensionId,O.identifier.uuid):q=q.withFilter(t.ExtensionName,O.identifier.id);const{galleryExtensions:K}=await this.queryRawGalleryExtensions(q,R.CancellationToken.None);if(!K.length)return[];const ae=N(K[0]);if((0,P.isNotWebExtensionInWebTargetPlatform)(ae,W))return[];const ce=[];await Promise.all(K[0].versions.map(async te=>{try{await this.isValidVersion(te,M?"any":"release",!0,ae,W)&&ce.push(te)}catch{}}));const pe=[],Se=new Set;for(const te of F(ce,W))Se.has(te.version)||(Se.add(te.version),pe.push({version:te.version,date:te.lastUpdated,isPreReleaseVersion:se(te)}));return pe}async getAsset(O,M={},W=R.CancellationToken.None){const q=await this.commonHeadersPromise,K={type:"GET"},ae={...q,...M.headers||{}};M={...M,...K,headers:ae};const ce=O.uri,pe=O.fallbackUri,Se={...M,url:ce};try{const te=await this.requestService.request(Se,W);if(te.res.statusCode===200)return te;const oe=await(0,a.asTextOrError)(te);throw new Error(`Expected 200, got back ${te.res.statusCode} instead.

${oe}`)}catch(te){if((0,b.isCancellationError)(te))throw te;const oe=(0,b.getErrorMessage)(te);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:oe});const de={...M,url:pe};return this.requestService.request(de,W)}}async getEngine(O){let M=re(O);if(!M){const W=await this.getManifestFromRawExtensionVersion(O,R.CancellationToken.None);if(!W)throw new Error("Manifest was not found");M=W.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,a.asJson)(O),W=[],q={};if(M){for(const K of M.malicious)W.push({id:K});if(M.migrateToPreRelease)for(const[K,ae]of Object.entries(M.migrateToPreRelease))(!ae.engine||(0,S.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(q[K.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[K,ae]of Object.entries(M.deprecated))ae&&(q[K.toLowerCase()]=(0,p.isBoolean)(ae)?{}:ae)}return{malicious:W,deprecated:q}}};Y=ge([ee(1,a.IRequestService),ee(2,E.ILogService),ee(3,I.IEnvironmentService),ee(4,c.ITelemetryService),ee(5,g.IFileService),ee(6,v.IProductService),ee(7,f.IConfigurationService)],Y);let A=class extends Y{constructor(O,M,W,q,K,ae,ce,pe){super(O,M,W,q,K,ae,ce,pe)}};A=ge([ee(0,m.IStorageService),ee(1,a.IRequestService),ee(2,E.ILogService),ee(3,I.IEnvironmentService),ee(4,c.ITelemetryService),ee(5,g.IFileService),ee(6,v.IProductService),ee(7,f.IConfigurationService)],A),i.ExtensionGalleryService=A;let U=class extends Y{constructor(O,M,W,q,K,ae,ce){super(void 0,O,M,W,q,K,ae,ce)}};U=ge([ee(0,a.IRequestService),ee(1,E.ILogService),ee(2,I.IEnvironmentService),ee(3,c.ITelemetryService),ee(4,g.IFileService),ee(5,v.IProductService),ee(6,f.IConfigurationService)],U),i.ExtensionGalleryServiceWithNoStorageService=U}),define(Q[144],Z([0,1,44,16,13,9,65,29,25]),function(B,i,D,R,b,k,L,p,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UserDataProfilesService=void 0;let f=class We extends l.UserDataProfilesService{constructor(P,h,S,g,E){super(S,g,h,E),this.stateService=P}getStoredProfiles(){return(0,D.revive)(this.stateService.getItem(We.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,D.revive)(this.stateService.getItem(We.PROFILE_ASSOCIATIONS_KEY,{}))}};f=ge([ee(0,L.IStateService),ee(1,p.IUriIdentityService),ee(2,R.IEnvironmentService),ee(3,b.IFileService),ee(4,k.ILogService)],f),i.UserDataProfilesService=f}),define(Q[145],Z([0,1,37,3,158,2]),function(B,i,D,R,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativePolicyService=void 0;class L extends D.AbstractPolicyService{constructor(l){super(),this.productName=l,this.throttler=new R.Throttler,this.watcher=this._register(new k.MutableDisposable)}async initializePolicies(l){await this.throttler.queue(()=>new Promise((f,I)=>{try{this.watcher.value=(0,b.createWatcher)(this.productName,l,P=>{for(const h in P){const S=P[h];S===void 0?this.policies.delete(h):this.policies.set(h,S)}this._onDidChange.fire(Object.keys(P)),f()})}catch(P){I(P)}}))}}i.NativePolicyService=L}),define(Q[67],Z([0,1,114,3,14,5,20,80,159,160]),function(B,i,D,R,b,k,L,p,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class I extends Error{constructor(e,r){let t=r.message;switch(e){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=e,this.cause=r}}i.ExtractError=I;function P(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(r=>e&r).reduce((r,t)=>r+t,e&61440)}function h(s){if(s instanceof I)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new I(e,s)}function S(s,e,r,t,n,o){const d=b.dirname(e),y=b.join(t,d);if(!y.startsWith(t))return Promise.reject(new Error(p.localize(0,null,e)));const w=b.join(t,e);let C;return o.onCancellationRequested(()=>{C?.destroy()}),Promise.resolve(L.Promises.mkdir(y,{recursive:!0})).then(()=>new Promise((z,_)=>{if(!o.isCancellationRequested)try{C=(0,D.createWriteStream)(w,{mode:r}),C.once("close",()=>z()),C.once("error",_),s.once("error",_),s.pipe(C)}catch(X){_(X)}}))}function g(s,e,r,t){let n=(0,R.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{n.cancel(),s.close()}),new Promise((d,y)=>{const w=new R.Sequencer,C=z=>{z.isCancellationRequested||(o++,s.readEntry())};s.once("error",y),s.once("close",()=>n.then(()=>{t.isCancellationRequested||s.entryCount===o?d():y(new I("Incomplete",new Error(p.localize(1,null,o,s.entryCount))))},y)),s.readEntry(),s.on("entry",z=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(z.fileName)){C(t);return}const _=z.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(_)){const ne=b.join(e,_);n=(0,R.createCancelablePromise)(re=>L.Promises.mkdir(ne,{recursive:!0}).then(()=>C(re)).then(void 0,y));return}const X=v(s,z),H=P(z);n=(0,R.createCancelablePromise)(ne=>w.queue(()=>X.then(re=>S(re,_,H,e,r,ne).then(()=>C(ne)))).then(null,y))})})}function E(s,e=!1){return new Promise((r,t)=>{(0,l.open)(s,e?{lazyEntries:!0}:void 0,(n,o)=>{n?t(h(n)):r((0,k.assertIsDefined)(o))})})}function v(s,e){return new Promise((r,t)=>{s.openReadStream(e,(n,o)=>{n?t(h(n)):r((0,k.assertIsDefined)(o))})})}function a(s,e){return new Promise((r,t)=>{const n=new f.ZipFile;e.forEach(d=>{d.contents?n.addBuffer(typeof d.contents=="string"?Buffer.from(d.contents,"utf8"):d.contents,d.path):d.localPath&&n.addFile(d.localPath,d.path)}),n.end();const o=(0,D.createWriteStream)(s);n.outputStream.pipe(o),n.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>r(s))})}i.zip=a;function u(s,e,r={},t){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=E(s,!0);return r.overwrite&&(o=o.then(d=>L.Promises.rm(e).then(()=>d))),o.then(d=>g(d,e,{sourcePathRegex:n},t))}i.extract=u;function m(s,e){return E(s).then(r=>new Promise((t,n)=>{r.on("entry",o=>{o.fileName===e&&v(r,o).then(d=>t(d),d=>n(d))}),r.once("close",()=>n(new Error(p.localize(2,null,e))))}))}function c(s,e){return m(s,e).then(r=>new Promise((t,n)=>{const o=[];r.once("error",n),r.on("data",d=>o.push(d)),r.on("end",()=>t(Buffer.concat(o)))}))}i.buffer=c}),define(Q[146],Z([0,1,67,88]),function(B,i,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function b(k){return(0,D.buffer)(k,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}i.getManifest=b}),define(Q[147],Z([0,1,3,31,11,2,17,14,12,18,39,5,10,30,20,67,87,58,16,139,22,23,41,48,122,140,146,123,136,34,45,13,8,9,28,35,29,25]),function(B,i,D,R,b,k,L,p,l,f,I,P,h,S,g,E,v,a,u,m,c,s,e,r,t,n,o,d,y,w,C,z,_,X,H,ne,re,se){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=i.INativeServerExtensionManagementService=void 0,i.INativeServerExtensionManagementService=(0,_.refineServiceDecorator)(c.IExtensionManagementService);let fe=class extends m.AbstractExtensionManagementService{constructor(A,U,T,O,M,W,q,K,ae,ce,pe,Se){super(A,U,T,ce,Se),this.extensionsScannerService=M,this.extensionsProfileScannerService=W,this.downloadService=q,this.fileService=ae,this.installGalleryExtensionsTasks=new Map;const te=this._register(K.createInstance(n.ExtensionsLifecycle));this.extensionsScanner=this._register(K.createInstance(le,de=>te.postUninstall(de))),this.manifestCache=this._register(new d.ExtensionsManifestCache(O,this)),this.extensionsDownloader=this._register(K.createInstance(t.ExtensionsDownloader));const oe=this._register(new y.ExtensionsWatcher(this,ae,O,T,pe));this._register(oe.onDidChangeExtensionsByAnotherSource(({added:de,removed:he})=>{de.length&&this._onDidInstallExtensions.fire(de.map(ve=>({identifier:ve.identifier,operation:1,local:ve}))),he.forEach(ve=>this._onDidUninstallExtension.fire({identifier:ve}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(A){this.logService.trace("ExtensionManagementService#zip",A.identifier.id);const U=await this.collectFiles(A),T=await(0,E.zip)((0,f.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,S.generateUuid)()).fsPath,U);return h.URI.file(T)}async unzip(A){return this.logService.trace("ExtensionManagementService#unzip",A.toString()),(await this.install(A)).identifier}async getManifest(A){const{location:U,cleanup:T}=await this.downloadVsix(A),O=p.resolve(U.fsPath);try{return await(0,o.getManifest)(O)}finally{await T()}}getInstalled(A,U){return this.extensionsScanner.scanExtensions(A??null,U)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(A,U={}){this.logService.trace("ExtensionManagementService#install",A.toString());const{location:T,cleanup:O}=await this.downloadVsix(A);try{const M=await(0,o.getManifest)(p.resolve(T.fsPath));if(M.engines&&M.engines.vscode&&!(0,C.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(v.localize(0,null,(0,s.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return await this.installExtension(M,T,U)}finally{await O()}}getMetadata(A){return this.extensionsScannerService.scanMetadata(A.location)}async updateMetadata(A,U){this.logService.trace("ExtensionManagementService#updateMetadata",A.identifier.id);const T={...U};return U.isPreReleaseVersion&&(T.preRelease=!0),A=await this.extensionsScanner.updateMetadata(A,T),this.manifestCache.invalidate(),A}async updateExtensionScope(A,U){return this.logService.trace("ExtensionManagementService#updateExtensionScope",A.identifier.id),A=await this.extensionsScanner.updateMetadata(A,{isMachineScoped:U}),this.manifestCache.invalidate(),A}removeUninstalledExtensions(A){return this.extensionsScanner.cleanUp(A)}async downloadVsix(A){if(A.scheme===L.Schemas.file)return{location:A,async cleanup(){}};this.logService.trace("Downloading extension from",A.toString());const U=(0,f.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,S.generateUuid)());return await this.downloadService.download(A,U),this.logService.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.fileService.del(U)}catch(O){this.logService.error(O)}}}}doCreateInstallExtensionTask(A,U,T){let O;if(h.URI.isUri(U))O=new N(A,U,T,this.galleryService,this.extensionsScanner,this.logService);else{const M=s.ExtensionKey.create(U).toString();O=this.installGalleryExtensionsTasks.get(M),O||(this.installGalleryExtensionsTasks.set(M,O=new V(A,U,T,this.extensionsDownloader,this.extensionsScanner,this.logService)),O.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(M)))}return T.profileLocation?new F(O,T.profileLocation,this.extensionsProfileScannerService):O}doCreateUninstallExtensionTask(A,U){return U.profileLocation?new $(A,U.profileLocation,this.extensionsProfileScannerService):new j(A,U,this.extensionsScanner)}async collectFiles(A){const U=async O=>{let M=await g.Promises.readdir(O);M=M.map(K=>p.join(O,K));const W=await Promise.all(M.map(K=>g.Promises.stat(K)));let q=Promise.resolve([]);return W.forEach((K,ae)=>{const ce=M[ae];K.isFile()&&(q=q.then(pe=>[...pe,ce])),K.isDirectory()&&(q=q.then(pe=>U(ce).then(Se=>[...pe,...Se])))}),q};return(await U(A.location.fsPath)).map(O=>({path:`extension/${p.relative(A.location.fsPath,O)}`,localPath:O}))}};fe=ge([ee(0,c.IExtensionGalleryService),ee(1,ne.ITelemetryService),ee(2,X.ILogService),ee(3,u.INativeEnvironmentService),ee(4,r.IExtensionsScannerService),ee(5,e.IExtensionsProfileScannerService),ee(6,a.IDownloadService),ee(7,_.IInstantiationService),ee(8,z.IFileService),ee(9,H.IProductService),ee(10,re.IUriIdentityService),ee(11,se.IUserDataProfilesService)],fe),i.ExtensionManagementService=fe;let le=class extends k.Disposable{constructor(A,U,T,O){super(),this.beforeRemovingExtension=A,this.fileService=U,this.extensionsScannerService=T,this.logService=O,this.uninstalledPath=(0,f.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(A){await this.removeUninstalledExtensions(),A&&await this.removeOutdatedExtensions()}async scanExtensions(A,U){const T={includeInvalid:!0,profileLocation:U};let O=[];return A===null||A===0?O.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},T,!1)):A===1&&O.push(...await this.extensionsScannerService.scanUserExtensions(T)),O=A!==null?O.filter(M=>M.type===A):O,Promise.all(O.map(M=>this.toLocalExtension(M)))}async scanUserExtensions(A){const U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!A,includeInvalid:!0});return Promise.all(U.map(T=>this.toLocalExtension(T)))}async extractUserExtension(A,U,T,O){const M=A.toString(),W=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,S.generateUuid)()}`),q=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,M);try{await g.Promises.rm(q)}catch{throw new c.ExtensionManagementError(v.localize(1,null,q,A.id),c.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(A,U,W,O),await this.extensionsScannerService.updateMetadata(h.URI.file(W),T);try{await this.rename(A,W,q,Date.now()+2*60*1e3),this.logService.info("Renamed to",q)}catch(K){try{await g.Promises.rm(W)}catch{}if(K.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(K)}. Deleted from extracted location`,W),K}return this.scanLocalExtension(h.URI.file(q),1)}async updateMetadata(A,U){return await this.extensionsScannerService.updateMetadata(A.location,U),this.scanLocalExtension(A.location,A.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...A){const U=A.map(T=>s.ExtensionKey.create(T));await this.withUninstalledExtensions(T=>{U.forEach(O=>T[O.toString()]=!0)})}async setInstalled(A){await this.withUninstalledExtensions(O=>delete O[A.toString()]);const T=(await this.scanUserExtensions(!0)).find(O=>s.ExtensionKey.create(O).equals(A))||null;return T?this.updateMetadata(T,{installedTimestamp:Date.now()}):null}async removeExtension(A,U){this.logService.trace(`Deleting ${U} extension from disk`,A.identifier.id,A.location.fsPath),await g.Promises.rm(A.location.fsPath),this.logService.info("Deleted from disk",A.identifier.id,A.location.fsPath)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.withUninstalledExtensions(U=>delete U[s.ExtensionKey.create(A).toString()])}async withUninstalledExtensions(A){return this.uninstalledFileLimiter.queue(async()=>{let U;try{U=await g.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let T={};if(U)try{T=JSON.parse(U)}catch{}return A&&(A(T),Object.keys(T).length?await g.Promises.writeFile(this.uninstalledPath,JSON.stringify(T)):await g.Promises.rm(this.uninstalledPath)),T})}async extractAtLocation(A,U,T,O){this.logService.trace(`Started extracting the extension from ${U} to ${T}`);try{await g.Promises.rm(T)}catch(M){throw new c.ExtensionManagementError(this.joinErrors(M).message,c.ExtensionManagementErrorCode.Delete)}try{await(0,E.extract)(U,T,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${T}:`,A.id)}catch(M){try{await g.Promises.rm(T)}catch{}let W=c.ExtensionManagementErrorCode.Extract;throw M instanceof E.ExtractError&&(M.type==="CorruptZip"?W=c.ExtensionManagementErrorCode.CorruptZip:M.type==="Incomplete"&&(W=c.ExtensionManagementErrorCode.IncompleteZip)),new c.ExtensionManagementError(M.message,W)}}async rename(A,U,T,O){try{await g.Promises.rename(U,T)}catch(M){if(l.isWindows&&M&&M.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${U} to ${T} with 'EPERM' error. Trying again...`,A.id),this.rename(A,U,T,O);throw new c.ExtensionManagementError(M.message||v.localize(2,null,U,T),M.code||c.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(A,U){const T=await this.extensionsScannerService.scanExistingExtension(A,U,{includeInvalid:!0});if(T)return this.toLocalExtension(T);throw new Error(v.localize(3,null,A.path))}async toLocalExtension(A){const U=await this.fileService.resolve(A.location);let T,O;return U.children&&(T=U.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,O=U.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:A.identifier,type:A.type,isBuiltin:A.isBuiltin||!!A.metadata?.isBuiltin,location:A.location,manifest:A.manifest,targetPlatform:A.targetPlatform,validations:A.validations,isValid:A.isValid,readmeUrl:T,changelogUrl:O,publisherDisplayName:A.metadata?.publisherDisplayName||null,publisherId:A.metadata?.publisherId||null,isApplicationScoped:!!A.metadata?.isApplicationScoped,isMachineScoped:!!A.metadata?.isMachineScoped,isPreReleaseVersion:!!A.metadata?.isPreReleaseVersion,preRelease:!!A.metadata?.preRelease,installedTimestamp:A.metadata?.installedTimestamp,updated:!!A.metadata?.updated}}async removeUninstalledExtensions(){const A=await this.getUninstalledExtensions(),U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),T=new Set;for(const W of U)A[s.ExtensionKey.create(W).toString()]||T.add(W.identifier.id.toLowerCase());const O=(0,s.groupByExtension)(U,W=>W.identifier);await D.Promises.settled(O.map(async W=>{const q=W.sort((K,ae)=>I.rcompare(K.manifest.version,ae.manifest.version))[0];T.has(q.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(q))}));const M=U.filter(W=>A[s.ExtensionKey.create(W).toString()]);await D.Promises.settled(M.map(W=>this.removeUninstalledExtension(W)))}async removeOutdatedExtensions(){const A=await this.extensionsScannerService.scanSystemExtensions({}),U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),T=[],O=await this.extensionsScannerService.getTargetPlatform(),M=(0,s.groupByExtension)(U,W=>W.identifier);for(const W of M)if(W.length>1&&T.push(...W.sort((q,K)=>{const ae=I.rcompare(q.manifest.version,K.manifest.version);return ae!==0?ae:q.targetPlatform===O?-1:1}).slice(1)),W[0].type===0){const q=A.find(K=>(0,s.areSameExtensions)(K.identifier,W[0].identifier));(!q||I.gte(q.manifest.version,W[0].manifest.version))&&T.push(W[0])}await D.Promises.settled(T.map(W=>this.removeExtension(W,"outdated")))}joinErrors(A){const U=Array.isArray(A)?A:[A];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((T,O)=>new Error(`${T.message}${T.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}};le=ge([ee(1,z.IFileService),ee(2,r.IExtensionsScannerService),ee(3,X.ILogService)],le);class ie extends m.AbstractExtensionTask{get operation(){return(0,P.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(A,U,T,O,M){super(),this.identifier=A,this.source=U,this.options=T,this.extensionsScanner=O,this.logService=M,this._operation=2}async installExtension(A,U){try{const T=await this.unsetUninstalledAndGetLocal(A.key);if(T)return this.extensionsScanner.updateMetadata(T,A.metadata)}catch{throw l.isMacintosh?new c.ExtensionManagementError(v.localize(4,null),c.ExtensionManagementErrorCode.Internal):new c.ExtensionManagementError(v.localize(5,null),c.ExtensionManagementErrorCode.Internal)}return this.extract(A,U)}async unsetUninstalledAndGetLocal(A){if(!await this.isUninstalled(A))return null;this.logService.trace("Removing the extension from uninstalled list:",A.id);const T=await this.extensionsScanner.setInstalled(A);return this.logService.info("Removed the extension from uninstalled list:",A.id),T}async isUninstalled(A){return!!(await this.extensionsScanner.getUninstalledExtensions())[A.toString()]}async extract({zipPath:A,key:U,metadata:T},O){const M=await this.extensionsScanner.extractUserExtension(U,A,T,O);return this.logService.info("Extracting completed.",U.id),M}}class V extends ie{constructor(A,U,T,O,M,W){super(U.identifier,U,T,M,W),this.manifest=A,this.gallery=U,this.extensionsDownloader=O}async doRun(A){const T=(await this.extensionsScanner.scanExtensions(null,void 0)).find(W=>(0,s.areSameExtensions)(W.identifier,this.gallery.identifier));T&&(this._operation=3);const O={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,w.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||T?.isMachineScoped,isBuiltin:this.options.isBuiltin||T?.isBuiltin,isSystem:T?.type===0?!0:void 0,updated:!!T,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,P.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:T?.preRelease)};if(T?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(T,O),metadata:O};const M=await this.downloadExtension(this.gallery,this._operation);try{const W=await this.installExtension({zipPath:M,key:s.ExtensionKey.create(this.gallery),metadata:O},A);return T&&!this.options.profileLocation&&(T.targetPlatform!==W.targetPlatform||I.neq(T.manifest.version,W.manifest.version))&&await this.extensionsScanner.setUninstalled(T),{local:W,metadata:O}}catch(W){throw await this.deleteDownloadedVSIX(M),W}}async deleteDownloadedVSIX(A){try{await this.extensionsDownloader.delete(h.URI.file(A))}catch(U){this.logService.warn("Error while deleting the downloaded vsix",A.toString(),(0,b.getErrorMessage)(U))}}async downloadExtension(A,U){let T;try{this.logService.trace("Started downloading extension:",A.identifier.id),T=(await this.extensionsDownloader.downloadExtension(A,U)).fsPath,this.logService.info("Downloaded extension:",A.identifier.id,T)}catch(O){throw new c.ExtensionManagementError((0,m.joinErrors)(O).message,c.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(T),T}catch(O){throw await this.deleteDownloadedVSIX(T),new c.ExtensionManagementError((0,m.joinErrors)(O).message,c.ExtensionManagementErrorCode.Invalid)}}}class N extends ie{constructor(A,U,T,O,M,W){super({id:(0,s.getGalleryExtensionId)(A.publisher,A.name)},U,T,M,W),this.manifest=A,this.location=U,this.galleryService=O}async doRun(A){const U=new s.ExtensionKey(this.identifier,this.manifest.version),O=(await this.extensionsScanner.scanExtensions(1,void 0)).find(q=>(0,s.areSameExtensions)(this.identifier,q.identifier)),M=await this.getMetadata(this.identifier.id,this.manifest.version,A);if(M.isApplicationScoped=(0,w.isApplicationScopedExtension)(this.manifest),M.isMachineScoped=this.options.isMachineScoped||O?.isMachineScoped,M.isBuiltin=this.options.isBuiltin||O?.isBuiltin,M.installedTimestamp=Date.now(),O)if(this._operation=3,U.equals(new s.ExtensionKey(O.identifier,O.manifest.version)))try{await this.extensionsScanner.removeExtension(O,"existing")}catch{throw new Error(v.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&I.gt(O.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(O);else{const q=await this.unsetUninstalledAndGetLocal(U);if(q)try{await this.extensionsScanner.removeExtension(q,"existing")}catch{throw new Error(v.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:p.resolve(this.location.fsPath),key:U,metadata:M},A),metadata:M}}async getMetadata(A,U,T){try{let[O]=await this.galleryService.getExtensions([{id:A,version:U}],T);if(O||([O]=await this.galleryService.getExtensions([{id:A}],T)),O)return{id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class F{constructor(A,U,T){this.task=A,this.profileLocation=U,this.extensionsProfileScannerService=T,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const A=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[A.local,A.metadata]],this.profileLocation),A}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class j extends m.AbstractExtensionTask{constructor(A,U,T){super(),this.extension=A,this.options=U,this.extensionsScanner=T}async doRun(A){const U=[],T=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const O=s.ExtensionKey.create(this.extension);U.push(...T.filter(M=>O.equals(s.ExtensionKey.create(M))))}else U.push(...T.filter(O=>(0,s.areSameExtensions)(O.identifier,this.extension.identifier)));if(!U.length)throw new Error(v.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...U),this.options.remove)for(const O of U)try{A.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(O)}catch(M){throw new Error(v.localize(9,null,(0,R.toErrorMessage)(M)))}}}class $ extends m.AbstractExtensionTask{constructor(A,U,T){super(),this.extension=A,this.profileLocation=U,this.extensionsProfileScannerService=T}async doRun(A){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(Q[148],Z([0,1,127,3,15,11,2,5,21,16,128,9,126,161]),function(B,i,D,R,b,k,L,p,l,f,I,P,h,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let g=class extends L.Disposable{constructor(v,a,u){super(),this.environmentService=a,this.logService=u,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,a){this.logService.trace("RequestService#request (node) - begin",v.url);const{proxyUrl:u,strictSSL:m}=this;let c;try{c=await(0,I.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const s={...process.env,...c},e=v.agent?v.agent:await(0,h.getProxyAgent)(v.url||"",s,{proxyUrl:u,strictSSL:m});v.agent=e,v.strictSSL=m,this.authorization&&(v.headers={...v.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(v,a);return this.logService.trace("RequestService#request (node) - success",v.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",v.url,r),r}}async getNodeRequest(v){return((0,D.parse)(v.url).protocol==="https:"?await new Promise((m,c)=>{B(["https"],m,c)}):await new Promise((m,c)=>{B(["http"],m,c)})).request}_request(v,a){return R.Promises.withAsyncBody(async(u,m)=>{const c=(0,D.parse)(v.url),s=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),e={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:(0,p.isBoolean)(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(e.auth=v.user+":"+v.password);const r=s(e,t=>{const n=(0,p.isNumber)(v.followRedirects)?v.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)this._request({...v,url:t.headers.location,followRedirects:n-1},a).then(u,m);else{let o=t;t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,S.createGunzip)())),u({res:t,stream:(0,b.streamToBufferReadableStream)(o)})}});r.on("error",m),v.timeout&&r.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&r.write(v.data),r.end(),a.onCancellationRequested(()=>{r.abort(),m(new k.CancellationError)})})}async resolveProxy(v){}};g=ge([ee(0,l.IConfigurationService),ee(1,f.INativeEnvironmentService),ee(2,P.ILogService)],g),i.RequestService=g}),define(Q[162],Z([0,1,38,3,15,31,11,2,17,14,12,32,10,20,21,119,58,125,16,101,143,22,121,41,48,147,141,13,111,113,46,109,61,62,124,9,115,116,37,145,133,28,47,148,65,129,66,35,132,42,134,135,29,137,25,144]),function(B,i,D,R,b,k,L,p,l,f,I,P,h,S,g,E,v,a,u,m,c,s,e,r,t,n,o,d,y,w,C,z,_,X,H,ne,re,se,fe,le,ie,V,N,F,j,$,Y,A,U,T,O,M,W,q,K,ae){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class ce extends p.Disposable{constructor(te){super(),this.argv=te,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[te,oe]=await this.initServices();return te.invokeFunction(async de=>{const he=de.get(ne.ILogService),ve=de.get(d.IFileService),ke=de.get(u.INativeEnvironmentService),Fe=de.get(K.IUserDataProfilesService);he.info("CLI main",this.argv),this.registerErrorHandler(he),await this.doRun(ke,ve,Fe,te),await Promise.all(oe.map(Ue=>{(0,R.raceTimeout)(Ue.flush(),1e3)}))})}async initServices(){const te=new _.ServiceCollection,oe={_serviceBrand:void 0,...ie.default};te.set(V.IProductService,oe);const de=new m.NativeEnvironmentService(this.argv,oe);te.set(u.INativeEnvironmentService,de),await Promise.all([de.appSettingsHome.fsPath,de.extensionsPath].map(we=>we?S.Promises.mkdir(we,{recursive:!0}):void 0));const he=(0,ne.getLogLevel)(de),ve=[];ve.push(new re.SpdLogLogger("cli",(0,f.join)(de.logsPath,"cli.log"),!0,!1,he)),he===ne.LogLevel.Trace&&ve.push(new ne.ConsoleLogger(he));const ke=this._register(new ne.MultiplexLogService(ve));te.set(ne.ILogService,ke);const Fe=this._register(new y.FileService(ke));te.set(d.IFileService,Fe);const Ue=this._register(new w.DiskFileSystemProvider(ke));Fe.registerProvider(l.Schemas.file,Ue);const xe=new $.StateService(de,ke,Fe);te.set(j.IStateService,xe);const x=new q.UriIdentityService(Fe);te.set(W.IUriIdentityService,x);const G=new ae.UserDataProfilesService(xe,x,de,Fe,ke);te.set(K.IUserDataProfilesService,G);const J=I.isWindows&&oe.win32RegValueName?this._register(new le.NativePolicyService(oe.win32RegValueName)):de.policyFile?this._register(new se.FilePolicyService(de.policyFile,Fe,ke)):new fe.NullPolicyService;te.set(fe.IPolicyService,J);const ue=this._register(new E.ConfigurationService(G.defaultProfile.settingsResource,Fe,J,ke));te.set(g.IConfigurationService,ue),await Promise.all([xe.init(),ue.initialize()]),G.setEnablement(oe.quality!=="stable"||ue.getValue(K.PROFILES_ENABLEMENT_CONFIG)),te.set(W.IUriIdentityService,new q.UriIdentityService(Fe)),te.set(N.IRequestService,new C.SyncDescriptor(F.RequestService,void 0,!0)),te.set(v.IDownloadService,new C.SyncDescriptor(a.DownloadService,void 0,!0)),te.set(r.IExtensionsProfileScannerService,new C.SyncDescriptor(r.ExtensionsProfileScannerService,void 0,!0)),te.set(t.IExtensionsScannerService,new C.SyncDescriptor(o.ExtensionsScannerService,void 0,!0)),te.set(n.INativeServerExtensionManagementService,new C.SyncDescriptor(n.ExtensionManagementService,void 0,!0)),te.set(s.IExtensionGalleryService,new C.SyncDescriptor(c.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),te.set(X.ILanguagePackService,new C.SyncDescriptor(H.NativeLanguagePackService,void 0,!1));const me=[],De=(0,T.isInternalTelemetry)(oe,ue);if((0,T.supportsTelemetry)(oe,de)){oe.aiConfig&&oe.aiConfig.ariaKey&&me.push(new O.OneDataSystemAppender(De,"monacoworkbench",null,oe.aiConfig.ariaKey));const{installSourcePath:we}=de,Le={appenders:me,sendErrorTelemetry:!1,commonProperties:(async()=>{let be;try{const Ce=await S.Promises.readFile(de.stateResource.fsPath);be=JSON.parse(Ce.toString())[A.machineIdKey]}catch(Ce){Ce.code!=="ENOENT"&&ke.error(Ce)}return(0,Y.resolveCommonProperties)(Fe,(0,D.release)(),(0,D.hostname)(),process.arch,oe.commit,oe.version,be,De,we)})(),piiPaths:(0,T.getPiiPathsFromEnvironment)(de)};te.set(A.ITelemetryService,new C.SyncDescriptor(U.TelemetryService,[Le],!1))}else te.set(A.ITelemetryService,T.NullTelemetryService);return[new z.InstantiationService(te),me]}registerErrorHandler(te){(0,L.setUnexpectedErrorHandler)(oe=>{const de=(0,k.toErrorMessage)(oe,!0);!de||te.error(`[uncaught exception in CLI]: ${de}`)}),process.on("uncaughtException",oe=>(0,L.onUnexpectedError)(oe)),process.on("unhandledRejection",oe=>(0,L.onUnexpectedError)(oe))}async doRun(te,oe,de,he){const ve=te.args.profile?de.profiles.find(ke=>ke.name===te.args.profile)?.extensionsResource:de.defaultProfile.extensionsResource;if(this.argv["install-source"])return this.setInstallSource(te,oe,this.argv["install-source"]);if(this.argv["list-extensions"])return he.createInstance(e.ExtensionManagementCLI).listExtensions(!!this.argv["show-versions"],this.argv.category,ve);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const ke={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:ve};return he.createInstance(e.ExtensionManagementCLI).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],ke,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return he.createInstance(e.ExtensionManagementCLI).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,ve);if(this.argv["locate-extension"])return he.createInstance(e.ExtensionManagementCLI).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(te.appRoot,te.extensionsPath))}}asExtensionIdOrVSIX(te){return te.map(oe=>/\.vsix$/i.test(oe)?h.URI.file((0,f.isAbsolute)(oe)?oe:(0,f.join)((0,P.cwd)(),oe)):oe)}async setInstallSource(te,oe,de){await oe.writeFile(h.URI.file(te.installSourcePath),b.VSBuffer.fromString(de.slice(0,30)))}}async function pe(Se){const te=new ce(Se);try{await te.run()}finally{te.dispose()}}i.main=pe})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a8108049ab61b970f2ec1839dfb753054e07395e/core/vs/code/node/cliProcessMain.js.map
