/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/platform","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","fs","vs/editor/common/languages","vs/platform/configuration/common/configuration","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/hash","vs/base/common/normalization","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/observableValue","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(J){for(var e=[],l=0,t=J.length;l<t;l++)e[l]=Ce[J[l]];return e};define(Ce[76],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function l(y){return y?y.replace(/\$\((.*?)\)/g,(D,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=l;class t{constructor(D,w,k){this.id=D,this.definition=w,this.description=k,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function I(y,D){const w=["codicon","codicon-"+y];return D&&w.push("codicon-modifier-"+D),w}e.getClassNamesArray=I;var P;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function w(C){if(C instanceof t)return["codicon","codicon-"+C.id];const E=D.exec(C.id);if(!E)return w(t.error);const[,T,S]=E,p=["codicon","codicon-"+T];return S&&p.push("codicon-modifier-"+S.substr(1)),p}y.asClassNameArray=w;function k(C){return w(C).join(" ")}y.asClassName=k;function L(C){return"."+w(C).join(".")}y.asCSSSelector=L})(P=e.CSSIcon||(e.CSSIcon={}))}),define(Ce[77],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function l(y,D){const w=Object.create(null);for(const k of y){const L=D(k);let C=w[L];C||(C=w[L]=[]),C.push(k)}return w}e.groupBy=l;function t(y,D){const w=[],k=[];for(const L of y)D.has(L)||w.push(L);for(const L of D)y.has(L)||k.push(L);return{removed:w,added:k}}e.diffSets=t;function I(y,D){const w=[],k=[];for(const[L,C]of y)D.has(L)||w.push(C);for(const[L,C]of D)y.has(L)||k.push(C);return{removed:w,added:k}}e.diffMaps=I;class P{constructor(){this.map=new Map}add(D,w){let k=this.map.get(D);k||(k=new Set,this.map.set(D,k)),k.add(w)}delete(D,w){const k=this.map.get(D);!k||(k.delete(w),k.size===0&&this.map.delete(D))}forEach(D,w){const k=this.map.get(D);!k||k.forEach(w)}}e.SetMap=P}),define(Ce[59],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function l(y){return(D,w,k)=>{let L=null,C=null;if(typeof k.value=="function"?(L="value",C=k.value):typeof k.get=="function"&&(L="get",C=k.get),!C)throw new Error("not supported");k[L]=y(C,w)}}e.createDecorator=l;function t(y,D,w){let k=null,L=null;if(typeof w.value=="function"?(k="value",L=w.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(k="get",L=w.get),!L)throw new Error("not supported");const C=`$memoize$${D}`;w[k]=function(...E){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,E)}),this[C]}}e.memoize=t;function I(y,D,w){return l((k,L)=>{const C=`$debounce$${L}`,E=`$debounce$result$${L}`;return function(...T){this[E]||(this[E]=w?w():void 0),clearTimeout(this[C]),D&&(this[E]=D(this[E],...T),T=[this[E]]),this[C]=setTimeout(()=>{k.apply(this,T),this[E]=w?w():void 0},y)}})}e.debounce=I;function P(y,D,w){return l((k,L)=>{const C=`$throttle$timer$${L}`,E=`$throttle$result$${L}`,T=`$throttle$lastRun$${L}`,S=`$throttle$pending$${L}`;return function(...p){if(this[E]||(this[E]=w?w():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),D&&(this[E]=D(this[E],...p)),this[S])return;const b=this[T]+y;b<=Date.now()?(this[T]=Date.now(),k.apply(this,[this[E]]),this[E]=w?w():void 0):(this[S]=!0,this[C]=setTimeout(()=>{this[S]=!1,this[T]=Date.now(),k.apply(this,[this[E]]),this[E]=w?w():void 0},b-Date.now()))}})}e.throttle=P}),define(Ce[11],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class l{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?h.isErrorNoTelemetry(i)?new h(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(u=>{u(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=l,e.errorHandler=new l;function t(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=t;function I(g){w(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=I;function P(g){w(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=P;function y(g){if(g instanceof Error){const{name:i,message:u}=g,r=g.stacktrace||g.stack;return{$isError:!0,name:i,message:u,stack:r,noTelemetry:h.isErrorNoTelemetry(g)}}return g}e.transformErrorForSerialization=y;const D="Canceled";function w(g){return g instanceof k?!0:g instanceof Error&&g.name===D&&g.message===D}e.isCancellationError=w;class k extends Error{constructor(){super(D),this.name=this.message}}e.CancellationError=k;function L(){const g=new Error(D);return g.name=g.message,g}e.canceled=L;function C(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=C;function E(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=E;function T(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=T;function S(g){const i=new Error(`${g} has been disposed`);return i.name="DISPOSED",i}e.disposed=S;function p(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=p;class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=b;class f extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=f;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class h extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof h)return i;const u=new h;return u.message=i.message,u.stack=i.stack,u}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=h;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype);debugger}}e.BugIndicatingError=c}),define(Ce[17],De([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(oe,le=0){return oe[oe.length-(1+le)]}e.tail=t;function I(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=I;function P(oe,le,ge=(Z,ae)=>Z===ae){if(oe===le)return!0;if(!oe||!le||oe.length!==le.length)return!1;for(let Z=0,ae=oe.length;Z<ae;Z++)if(!ge(oe[Z],le[Z]))return!1;return!0}e.equals=P;function y(oe,le){const ge=oe.length-1;le<ge&&(oe[le]=oe[ge]),oe.pop()}e.removeFastWithoutKeepingOrder=y;function D(oe,le,ge){return w(oe.length,Z=>ge(oe[Z],le))}e.binarySearch=D;function w(oe,le){let ge=0,Z=oe-1;for(;ge<=Z;){const ae=(ge+Z)/2|0,ne=le(ae);if(ne<0)ge=ae+1;else if(ne>0)Z=ae-1;else return ae}return-(ge+1)}e.binarySearch2=w;function k(oe,le){let ge=0,Z=oe.length;if(Z===0)return 0;for(;ge<Z;){const ae=Math.floor((ge+Z)/2);le(oe[ae])?Z=ae:ge=ae+1}return ge}e.findFirstInSorted=k;function L(oe,le,ge){if(oe=oe|0,oe>=le.length)throw new TypeError("invalid index");const Z=le[Math.floor(le.length*Math.random())],ae=[],ne=[],ie=[];for(const O of le){const j=ge(O,Z);j<0?ae.push(O):j>0?ne.push(O):ie.push(O)}return oe<ae.length?L(oe,ae,ge):oe<ae.length+ie.length?ie[0]:L(oe-(ae.length+ie.length),ne,ge)}e.quickSelect=L;function C(oe,le){const ge=[];let Z;for(const ae of oe.slice(0).sort(le))!Z||le(Z[0],ae)!==0?(Z=[ae],ge.push(Z)):Z.push(ae);return ge}e.groupBy=C;function E(oe,le,ge){const Z=[];function ae(O,j,G){if(j===0&&G.length===0)return;const X=Z[Z.length-1];X&&X.start+X.deleteCount===O?(X.deleteCount+=j,X.toInsert.push(...G)):Z.push({start:O,deleteCount:j,toInsert:G})}let ne=0,ie=0;for(;;){if(ne===oe.length){ae(ne,0,le.slice(ie));break}if(ie===le.length){ae(ne,oe.length-ne,[]);break}const O=oe[ne],j=le[ie],G=ge(O,j);G===0?(ne+=1,ie+=1):G<0?(ae(ne,1,[]),ne+=1):G>0&&(ae(ne,0,[j]),ie+=1)}return Z}e.sortedDiff=E;function T(oe,le,ge){const Z=E(oe,le,ge),ae=[],ne=[];for(const ie of Z)ae.push(...oe.slice(ie.start,ie.start+ie.deleteCount)),ne.push(...ie.toInsert);return{removed:ae,added:ne}}e.delta=T;function S(oe,le,ge){if(ge===0)return[];const Z=oe.slice(0,ge).sort(le);return b(oe,le,Z,ge,oe.length),Z}e.top=S;function p(oe,le,ge,Z,ae){return ge===0?Promise.resolve([]):new Promise((ne,ie)=>{(async()=>{const O=oe.length,j=oe.slice(0,ge).sort(le);for(let G=ge,X=Math.min(ge+Z,O);G<O;G=X,X=Math.min(X+Z,O)){if(G>ge&&await new Promise(pe=>setTimeout(pe)),ae&&ae.isCancellationRequested)throw new l.CancellationError;b(oe,le,j,G,X)}return j})().then(ne,ie)})}e.topAsync=p;function b(oe,le,ge,Z,ae){for(const ne=ge.length;Z<ae;Z++){const ie=oe[Z];if(le(ie,ge[ne-1])<0){ge.pop();const O=k(ge,j=>le(ie,j)<0);ge.splice(O,0,ie)}}}function f(oe){return oe.filter(le=>!!le)}e.coalesce=f;function v(oe){let le=0;for(let ge=0;ge<oe.length;ge++)oe[ge]&&(oe[le]=oe[ge],le+=1);oe.length=le}e.coalesceInPlace=v;function h(oe,le,ge){oe.splice(ge,0,oe.splice(le,1)[0])}e.move=h;function c(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=c;function g(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=g;function i(oe,le=ge=>ge){const ge=new Set;return oe.filter(Z=>{const ae=le(Z);return ge.has(ae)?!1:(ge.add(ae),!0)})}e.distinct=i;function u(oe){const le=new Set;return ge=>{const Z=oe(ge);return le.has(Z)?!1:(le.add(Z),!0)}}e.uniqueFilter=u;function r(oe,le){const ge=n(oe,le);if(ge!==-1)return oe[ge]}e.findLast=r;function n(oe,le){for(let ge=oe.length-1;ge>=0;ge--){const Z=oe[ge];if(le(Z))return ge}return-1}e.lastIndex=n;function o(oe,le){return oe.length>0?oe[0]:le}e.firstOrDefault=o;function d(oe,le){return oe.length>0?oe[oe.length-1]:le}e.lastOrDefault=d;function s(oe,le,ge=(Z,ae)=>Z===ae){let Z=0;for(let ae=0,ne=Math.min(oe.length,le.length);ae<ne&&ge(oe[ae],le[ae]);ae++)Z++;return Z}e.commonPrefixLength=s;function a(oe){return[].concat(...oe)}e.flatten=a;function m(oe,le){let ge=typeof le=="number"?oe:0;typeof le=="number"?ge=oe:(ge=0,le=oe);const Z=[];if(ge<=le)for(let ae=ge;ae<le;ae++)Z.push(ae);else for(let ae=ge;ae>le;ae--)Z.push(ae);return Z}e.range=m;function _(oe,le,ge){return oe.reduce((Z,ae)=>(Z[le(ae)]=ge?ge(ae):ae,Z),Object.create(null))}e.index=_;function R(oe,le){return oe.push(le),()=>M(oe,le)}e.insert=R;function M(oe,le){const ge=oe.indexOf(le);if(ge>-1)return oe.splice(ge,1),le}e.remove=M;function U(oe,le,ge){const Z=oe.slice(0,le),ae=oe.slice(le);return Z.concat(ge,ae)}e.arrayInsert=U;function A(oe,le){let ge;if(typeof le=="number"){let Z=le;ge=()=>{const ae=Math.sin(Z++)*179426549;return ae-Math.floor(ae)}}else ge=Math.random;for(let Z=oe.length-1;Z>0;Z-=1){const ae=Math.floor(ge()*(Z+1)),ne=oe[Z];oe[Z]=oe[ae],oe[ae]=ne}}e.shuffle=A;function z(oe,le){const ge=oe.indexOf(le);ge>-1&&(oe.splice(ge,1),oe.unshift(le))}e.pushToStart=z;function $(oe,le){const ge=oe.indexOf(le);ge>-1&&(oe.splice(ge,1),oe.push(le))}e.pushToEnd=$;function N(oe,le){for(const ge of le)oe.push(ge)}e.pushMany=N;function V(oe,le){return Array.isArray(oe)?oe.map(le):le(oe)}e.mapArrayOrNot=V;function B(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=B;function F(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=F;function x(oe,le){for(const ge of oe){const Z=le(ge);if(Z!==void 0)return Z}}e.mapFind=x;function H(oe,le,ge){const Z=K(oe,le),ae=oe.length,ne=ge.length;oe.length=ae+ne;for(let ie=ae-1;ie>=Z;ie--)oe[ie+ne]=oe[ie];for(let ie=0;ie<ne;ie++)oe[ie+Z]=ge[ie]}e.insertInto=H;function Q(oe,le,ge,Z){const ae=K(oe,le),ne=oe.splice(ae,ge);return H(oe,ae,Z),ne}e.splice=Q;function K(oe,le){return le<0?Math.max(le+oe.length,0):Math.min(le,oe.length)}var de;(function(oe){function le(ae){return ae<0}oe.isLessThan=le;function ge(ae){return ae>0}oe.isGreaterThan=ge;function Z(ae){return ae===0}oe.isNeitherLessOrGreaterThan=Z,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(de=e.CompareResult||(e.CompareResult={}));function ee(oe,le){return(ge,Z)=>le(oe(ge),oe(Z))}e.compareBy=ee;function he(...oe){return(le,ge)=>{for(const Z of oe){const ae=Z(le,ge);if(!de.isNeitherLessOrGreaterThan(ae))return ae}return de.neitherLessOrGreaterThan}}e.tieBreakComparators=he;const Y=(oe,le)=>oe-le;e.numberComparator=Y;function me(oe,le){if(oe.length===0)return;let ge=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,ge)>0&&(ge=ae)}return ge}e.findMaxBy=me;function be(oe,le){if(oe.length===0)return;let ge=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,ge)>=0&&(ge=ae)}return ge}e.findLastMaxBy=be;function ke(oe,le){return me(oe,(ge,Z)=>-le(ge,Z))}e.findMinBy=ke;class Re{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let ge=this.firstIdx;for(;ge<this.items.length&&le(this.items[ge]);)ge++;const Z=ge===this.firstIdx?null:this.items.slice(this.firstIdx,ge);return this.firstIdx=ge,Z}takeFromEndWhile(le){let ge=this.lastIdx;for(;ge>=0&&le(this.items[ge]);)ge--;const Z=ge===this.lastIdx?null:this.items.slice(ge+1,this.lastIdx+1);return this.lastIdx=ge,Z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const le=this.items[this.firstIdx];return this.firstIdx++,le}removeLast(){const le=this.items[this.lastIdx];return this.lastIdx--,le}takeCount(le){const ge=this.items.slice(this.firstIdx,this.firstIdx+le);return this.firstIdx+=le,ge}}e.ArrayQueue=Re;class ze{constructor(le){this.iterate=le}forEach(le){this.iterate(ge=>(le(ge),!0))}toArray(){const le=[];return this.iterate(ge=>(le.push(ge),!0)),le}filter(le){return new ze(ge=>this.iterate(Z=>le(Z)?ge(Z):!0))}map(le){return new ze(ge=>this.iterate(Z=>ge(le(Z))))}some(le){let ge=!1;return this.iterate(Z=>(ge=le(Z),!ge)),ge}findFirst(le){let ge;return this.iterate(Z=>le(Z)?(ge=Z,!1):!0),ge}findLast(le){let ge;return this.iterate(Z=>(le(Z)&&(ge=Z),!0)),ge}findLastMaxBy(le){let ge,Z=!0;return this.iterate(ae=>((Z||de.isGreaterThan(le(ae,ge)))&&(Z=!1,ge=ae),!0)),ge}}e.CallbackIterable=ze,ze.empty=new ze(oe=>{})}),define(Ce[48],De([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(w,k){if(!w)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=t;function I(w,k="Unreachable"){throw new Error(k)}e.assertNever=I;function P(w){if(!w)throw new l.BugIndicatingError("Assertion Failed")}e.assert=P;function y(w){if(!w()){debugger;w(),(0,l.onUnexpectedError)(new l.BugIndicatingError("Assertion Failed"))}}e.assertFn=y;function D(w,k){let L=0;for(;L<w.length-1;){const C=w[L],E=w[L+1];if(!k(C,E))return!1;L++}return!0}e.checkAdjacentItems=D}),define(Ce[60],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function l(t){const I=this;let P=!1,y;return function(){return P||(P=!0,y=t.apply(I,arguments)),y}}e.once=l}),define(Ce[96],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class l{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=l,e.defaultGenerator=new l("id#")}),define(Ce[61],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var l;(function(t){function I(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}t.is=I;const P=Object.freeze([]);function y(){return P}t.empty=y;function*D(u){yield u}t.single=D;function w(u){return u||P}t.from=w;function k(u){return!u||u[Symbol.iterator]().next().done===!0}t.isEmpty=k;function L(u){return u[Symbol.iterator]().next().value}t.first=L;function C(u,r){for(const n of u)if(r(n))return!0;return!1}t.some=C;function E(u,r){for(const n of u)if(r(n))return n}t.find=E;function*T(u,r){for(const n of u)r(n)&&(yield n)}t.filter=T;function*S(u,r){let n=0;for(const o of u)yield r(o,n++)}t.map=S;function*p(...u){for(const r of u)for(const n of r)yield n}t.concat=p;function*b(u){for(const r of u)for(const n of r)yield n}t.concatNested=b;function f(u,r,n){let o=n;for(const d of u)o=r(o,d);return o}t.reduce=f;function v(u,r){let n=0;for(const o of u)r(o,n++)}t.forEach=v;function*h(u,r,n=u.length){for(r<0&&(r+=u.length),n<0?n+=u.length:n>u.length&&(n=u.length);r<n;r++)yield u[r]}t.slice=h;function c(u,r=Number.POSITIVE_INFINITY){const n=[];if(r===0)return[n,u];const o=u[Symbol.iterator]();for(let d=0;d<r;d++){const s=o.next();if(s.done)return[n,t.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return o}}]}t.consume=c;function g(u){return c(u)[0]}t.collect=g;function i(u,r,n=(o,d)=>o===d){const o=u[Symbol.iterator](),d=r[Symbol.iterator]();for(;;){const s=o.next(),a=d.next();if(s.done!==a.done)return!1;if(s.done)return!0;if(!n(s.value,a.value))return!1}}t.equals=i})(l=e.Iterable||(e.Iterable={}))}),define(Ce[143],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var l;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(l=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(i){i.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function y(i,u=!1){let r=0;const n=i.length;let o="",d=0,s=16,a=0;function m($){let N=0,V=0;for(;N<$;){const B=i.charCodeAt(r);if(B>=48&&B<=57)V=V*16+B-48;else if(B>=65&&B<=70)V=V*16+B-65+10;else if(B>=97&&B<=102)V=V*16+B-97+10;else break;r++,N++}return N<$&&(V=-1),V}function _($){r=$,o="",d=0,s=16,a=0}function R(){const $=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&k(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&k(i.charCodeAt(r)))for(r++;r<i.length&&k(i.charCodeAt(r));)r++;else return a=3,i.substring($,r);let N=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&k(i.charCodeAt(r))){for(r++;r<i.length&&k(i.charCodeAt(r));)r++;N=r}else a=3;return i.substring($,N)}function M(){let $="",N=r;for(;;){if(r>=n){$+=i.substring(N,r),a=2;break}const V=i.charCodeAt(r);if(V===34){$+=i.substring(N,r),r++;break}if(V===92){if($+=i.substring(N,r),r++,r>=n){a=2;break}switch(i.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const F=m(4);F>=0?$+=String.fromCharCode(F):a=4;break}default:a=5}N=r;continue}if(V>=0&&V<=31)if(w(V)){$+=i.substring(N,r),a=2;break}else a=6;r++}return $}function U(){if(o="",a=0,d=r,r>=n)return d=n,s=17;let $=i.charCodeAt(r);if(D($)){do r++,o+=String.fromCharCode($),$=i.charCodeAt(r);while(D($));return s=15}if(w($))return r++,o+=String.fromCharCode($),$===13&&i.charCodeAt(r)===10&&(r++,o+=`
`),s=14;switch($){case 123:return r++,s=1;case 125:return r++,s=2;case 91:return r++,s=3;case 93:return r++,s=4;case 58:return r++,s=6;case 44:return r++,s=5;case 34:return r++,o=M(),s=10;case 47:{const N=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<n&&!w(i.charCodeAt(r));)r++;return o=i.substring(N,r),s=12}if(i.charCodeAt(r+1)===42){r+=2;const V=n-1;let B=!1;for(;r<V;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,B=!0;break}r++}return B||(r++,a=1),o=i.substring(N,r),s=13}return o+=String.fromCharCode($),r++,s=16}case 45:if(o+=String.fromCharCode($),r++,r===n||!k(i.charCodeAt(r)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=R(),s=11;default:for(;r<n&&A($);)r++,$=i.charCodeAt(r);if(d!==r){switch(o=i.substring(d,r),o){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return o+=String.fromCharCode($),r++,s=16}}function A($){if(D($)||w($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let $;do $=U();while($>=12&&$<=15);return $}return{setPosition:_,getPosition:()=>r,scan:u?z:U,getToken:()=>s,getTokenValue:()=>o,getTokenOffset:()=>d,getTokenLength:()=>r-d,getTokenError:()=>a}}e.createScanner=y;function D(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function w(i){return i===10||i===13||i===8232||i===8233}function k(i){return i>=48&&i<=57}var L;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(L||(L={}));function C(i,u){const r=[],n=new Object;let o;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function a(m,_,R,M){d.value=m,d.offset=_,d.length=R,d.type=M,d.colonOffset=void 0,o=d}try{h(i,{onObjectBegin:(m,_)=>{if(u<=m)throw n;o=void 0,s=u>m,r.push("")},onObjectProperty:(m,_,R)=>{if(u<_||(a(m,_,R,"property"),r[r.length-1]=m,u<=_+R))throw n},onObjectEnd:(m,_)=>{if(u<=m)throw n;o=void 0,r.pop()},onArrayBegin:(m,_)=>{if(u<=m)throw n;o=void 0,r.push(0)},onArrayEnd:(m,_)=>{if(u<=m)throw n;o=void 0,r.pop()},onLiteralValue:(m,_,R)=>{if(u<_||(a(m,_,R,g(m)),u<=_+R))throw n},onSeparator:(m,_,R)=>{if(u<=_)throw n;if(m===":"&&o&&o.type==="property")o.colonOffset=_,s=!1,o=void 0;else if(m===","){const M=r[r.length-1];typeof M=="number"?r[r.length-1]=M+1:(s=!0,r[r.length-1]=""),o=void 0}}})}catch(m){if(m!==n)throw m}return{path:r,previousNode:o,isAtPropertyKey:s,matches:m=>{let _=0;for(let R=0;_<m.length&&R<r.length;R++)if(m[_]===r[R]||m[_]==="*")_++;else if(m[_]!=="**")return!1;return _===m.length}}}e.getLocation=C;function E(i,u=[],r=P.DEFAULT){let n=null,o=[];const d=[];function s(m){Array.isArray(o)?o.push(m):n!==null&&(o[n]=m)}return h(i,{onObjectBegin:()=>{const m={};s(m),d.push(o),o=m,n=null},onObjectProperty:m=>{n=m},onObjectEnd:()=>{o=d.pop()},onArrayBegin:()=>{const m=[];s(m),d.push(o),o=m,n=null},onArrayEnd:()=>{o=d.pop()},onLiteralValue:s,onError:(m,_,R)=>{u.push({error:m,offset:_,length:R})}},r),o[0]}e.parse=E;function T(i,u=[],r=P.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(m){n.type==="property"&&(n.length=m-n.offset,n=n.parent)}function d(m){return n.children.push(m),m}h(i,{onObjectBegin:m=>{n=d({type:"object",offset:m,length:-1,parent:n,children:[]})},onObjectProperty:(m,_,R)=>{n=d({type:"property",offset:_,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:m,offset:_,length:R,parent:n})},onObjectEnd:(m,_)=>{n.length=m+_-n.offset,n=n.parent,o(m+_)},onArrayBegin:(m,_)=>{n=d({type:"array",offset:m,length:-1,parent:n,children:[]})},onArrayEnd:(m,_)=>{n.length=m+_-n.offset,n=n.parent,o(m+_)},onLiteralValue:(m,_,R)=>{d({type:g(m),offset:_,length:R,parent:n,value:m}),o(_+R)},onSeparator:(m,_,R)=>{n.type==="property"&&(m===":"?n.colonOffset=_:m===","&&o(_))},onError:(m,_,R)=>{u.push({error:m,offset:_,length:R})}},r);const a=n.children[0];return a&&delete a.parent,a}e.parseTree=T;function S(i,u){if(!i)return;let r=i;for(const n of u)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const d of r.children)if(Array.isArray(d.children)&&d.children[0].value===n){r=d.children[1],o=!0;break}if(!o)return}else{const o=n;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=S;function p(i){if(!i.parent||!i.parent.children)return[];const u=p(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;u.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&u.push(r)}return u}e.getNodePath=p;function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const u=Object.create(null);for(const r of i.children){const n=r.children[1];n&&(u[r.children[0].value]=b(n))}return u}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=b;function f(i,u,r=!1){return u>=i.offset&&u<i.offset+i.length||r&&u===i.offset+i.length}e.contains=f;function v(i,u,r=!1){if(f(i,u,r)){const n=i.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=u;o++){const d=v(n[o],u,r);if(d)return d}return i}}e.findNodeAtOffset=v;function h(i,u,r=P.DEFAULT){const n=y(i,!1);function o(ee){return ee?()=>ee(n.getTokenOffset(),n.getTokenLength()):()=>!0}function d(ee){return ee?he=>ee(he,n.getTokenOffset(),n.getTokenLength()):()=>!0}const s=o(u.onObjectBegin),a=d(u.onObjectProperty),m=o(u.onObjectEnd),_=o(u.onArrayBegin),R=o(u.onArrayEnd),M=d(u.onLiteralValue),U=d(u.onSeparator),A=o(u.onComment),z=d(u.onError),$=r&&r.disallowComments,N=r&&r.allowTrailingComma;function V(){for(;;){const ee=n.scan();switch(n.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:$||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ee){case 12:case 13:$?B(10):A();break;case 16:B(1);break;case 15:case 14:break;default:return ee}}}function B(ee,he=[],Y=[]){if(z(ee),he.length+Y.length>0){let me=n.getToken();for(;me!==17;){if(he.indexOf(me)!==-1){V();break}else if(Y.indexOf(me)!==-1)break;me=V()}}}function F(ee){const he=n.getTokenValue();return ee?M(he):a(he),V(),!0}function x(){switch(n.getToken()){case 11:{let ee=0;try{ee=JSON.parse(n.getTokenValue()),typeof ee!="number"&&(B(2),ee=0)}catch{B(2)}M(ee);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return V(),!0}function H(){return n.getToken()!==10?(B(3,[],[2,5]),!1):(F(!1),n.getToken()===6?(U(":"),V(),de()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Q(){s(),V();let ee=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ee||B(4,[],[]),U(","),V(),n.getToken()===2&&N)break}else ee&&B(6,[],[]);H()||B(4,[],[2,5]),ee=!0}return m(),n.getToken()!==2?B(7,[2],[]):V(),!0}function K(){_(),V();let ee=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ee||B(4,[],[]),U(","),V(),n.getToken()===4&&N)break}else ee&&B(6,[],[]);de()||B(4,[],[4,5]),ee=!0}return R(),n.getToken()!==4?B(8,[4],[]):V(),!0}function de(){switch(n.getToken()){case 3:return K();case 1:return Q();case 10:return F(!0);default:return x()}}return V(),n.getToken()===17?r.allowEmptyContent?!0:(B(4,[],[]),!1):de()?(n.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=h;function c(i,u){const r=y(i),n=[];let o,d=0,s;do switch(s=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:d!==s&&n.push(i.substring(d,s)),u!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,u)),d=r.getPosition();break}while(o!==17);return n.join("")}e.stripComments=c;function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(Ce[78],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class l{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new l(()=>I(this.getValue()))}}e.Lazy=l}),define(Ce[6],De([1,0,60,61]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let P=null;function y(d){P=d}if(e.setDisposableTracker=y,I){const d="__is_disposable_tracked__";y(new class{trackDisposable(s){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[d]||console.log(a)},3e3)}setParent(s,a){if(s&&s!==v.None)try{s[d]=!0}catch{}}markAsDisposed(s){if(s&&s!==v.None)try{s[d]=!0}catch{}}markAsSingleton(s){}})}function D(d){return P?.trackDisposable(d),d}function w(d){P?.markAsDisposed(d)}function k(d,s){P?.setParent(d,s)}function L(d,s){if(!!P)for(const a of d)P.setParent(a,s)}function C(d){return P?.markAsSingleton(d),d}e.markAsSingleton=C;function E(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=E;function T(d){if(t.Iterable.is(d)){const s=[];for(const a of d)if(a)try{a.dispose()}catch(m){s.push(m)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(d)?[]:d}else if(d)return d.dispose(),d}e.dispose=T;function S(d){for(const s of d)E(s)&&s.dispose();return[]}e.disposeIfDisposable=S;function p(...d){const s=b(()=>T(d));return L(d,s),s}e.combinedDisposable=p;function b(d){const s=D({dispose:(0,l.once)(()=>{w(s),d()})});return s}e.toDisposable=b;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{T(this._toDispose)}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return k(s,this),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new f,D(this),k(this._store,this)}dispose(){w(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&k(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&k(s,null),s}}e.MutableDisposable=h;class c{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(s){let a=s;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,w(this))},this}}e.SafeDisposable=g;class i{constructor(){this.references=new Map}acquire(s,...a){let m=this.references.get(s);m||(m={counter:0,object:this.createReferencedObject(s,...a)},this.references.set(s,m));const{object:_}=m,R=(0,l.once)(()=>{--m.counter===0&&(this.destroyReferencedObject(s,m.object),this.references.delete(s))});return m.counter++,{object:_,dispose:R}}}e.ReferenceCollection=i;class u{constructor(s){this.referenceCollection=s}async acquire(s,...a){const m=this.referenceCollection.acquire(s,...a);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(_){throw m.dispose(),_}}}e.AsyncReferenceCollection=u;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r;function n(d){const s=new f;try{d(s)}finally{s.dispose()}}e.disposeOnReturn=n;class o{constructor(){this._store=new Map,this._isDisposed=!1,D(this)}dispose(){w(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{T(this._store.values())}finally{this._store.clear()}}has(s){return this._store.has(s)}get(s){return this._store.get(s)}set(s,a,m=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),m||this._store.get(s)?.dispose(),this._store.set(s,a)}deleteAndDispose(s){this._store.get(s)?.dispose(),this._store.delete(s)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=o}),define(Ce[62],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class l{constructor(P){this.element=P,this.next=l.Undefined,this.prev=l.Undefined}}l.Undefined=new l(void 0);class t{constructor(){this._first=l.Undefined,this._last=l.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===l.Undefined}clear(){let P=this._first;for(;P!==l.Undefined;){const y=P.next;P.prev=l.Undefined,P.next=l.Undefined,P=y}this._first=l.Undefined,this._last=l.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,y){const D=new l(P);if(this._first===l.Undefined)this._first=D,this._last=D;else if(y){const k=this._last;this._last=D,D.prev=k,k.next=D}else{const k=this._first;this._first=D,D.next=k,k.prev=D}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(D))}}shift(){if(this._first!==l.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==l.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==l.Undefined&&P.next!==l.Undefined){const y=P.prev;y.next=P.next,P.next.prev=y}else P.prev===l.Undefined&&P.next===l.Undefined?(this._first=l.Undefined,this._last=l.Undefined):P.next===l.Undefined?(this._last=this._last.prev,this._last.next=l.Undefined):P.prev===l.Undefined&&(this._first=this._first.next,this._first.prev=l.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==l.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),function(J,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[144],De([0]),e):(J=typeof globalThis<"u"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(oe,le){for(var ge=0;ge<le.length;ge++){var Z=le[ge];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(oe,Z.key,Z)}}function l(oe,le,ge){return le&&e(oe.prototype,le),ge&&e(oe,ge),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function t(oe,le){if(!!oe){if(typeof oe=="string")return I(oe,le);var ge=Object.prototype.toString.call(oe).slice(8,-1);if(ge==="Object"&&oe.constructor&&(ge=oe.constructor.name),ge==="Map"||ge==="Set")return Array.from(oe);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return I(oe,le)}}function I(oe,le){(le==null||le>oe.length)&&(le=oe.length);for(var ge=0,Z=new Array(le);ge<le;ge++)Z[ge]=oe[ge];return Z}function P(oe,le){var ge=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(ge)return(ge=ge.call(oe)).next.bind(ge);if(Array.isArray(oe)||(ge=t(oe))||le&&oe&&typeof oe.length=="number"){ge&&(oe=ge);var Z=0;return function(){return Z>=oe.length?{done:!0}:{done:!1,value:oe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=y();function D(oe){J.defaults=oe}var w=/[&<>"']/,k=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(le){return E[le]};function S(oe,le){if(le){if(w.test(oe))return oe.replace(k,T)}else if(L.test(oe))return oe.replace(C,T);return oe}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function b(oe){return oe.replace(p,function(le,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var f=/(^|[^\[])\^/g;function v(oe,le){oe=typeof oe=="string"?oe:oe.source,le=le||"";var ge={replace:function(ae,ne){return ne=ne.source||ne,ne=ne.replace(f,"$1"),oe=oe.replace(ae,ne),ge},getRegex:function(){return new RegExp(oe,le)}};return ge}var h=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(oe,le,ge){if(oe){var Z;try{Z=decodeURIComponent(b(ge)).replace(h,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}le&&!c.test(ge)&&(ge=o(le,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var i={},u=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(oe,le){i[" "+oe]||(u.test(oe)?i[" "+oe]=oe+"/":i[" "+oe]=m(oe,"/",!0)),oe=i[" "+oe];var ge=oe.indexOf(":")===-1;return le.substring(0,2)==="//"?ge?le:oe.replace(r,"$1")+le:le.charAt(0)==="/"?ge?le:oe.replace(n,"$1")+le:oe+le}var d={exec:function(){}};function s(oe){for(var le=1,ge,Z;le<arguments.length;le++){ge=arguments[le];for(Z in ge)Object.prototype.hasOwnProperty.call(ge,Z)&&(oe[Z]=ge[Z])}return oe}function a(oe,le){var ge=oe.replace(/\|/g,function(ne,ie,O){for(var j=!1,G=ie;--G>=0&&O[G]==="\\";)j=!j;return j?"|":" |"}),Z=ge.split(/ \|/),ae=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>le)Z.splice(le);else for(;Z.length<le;)Z.push("");for(;ae<Z.length;ae++)Z[ae]=Z[ae].trim().replace(/\\\|/g,"|");return Z}function m(oe,le,ge){var Z=oe.length;if(Z===0)return"";for(var ae=0;ae<Z;){var ne=oe.charAt(Z-ae-1);if(ne===le&&!ge)ae++;else if(ne!==le&&ge)ae++;else break}return oe.slice(0,Z-ae)}function _(oe,le){if(oe.indexOf(le[1])===-1)return-1;for(var ge=oe.length,Z=0,ae=0;ae<ge;ae++)if(oe[ae]==="\\")ae++;else if(oe[ae]===le[0])Z++;else if(oe[ae]===le[1]&&(Z--,Z<0))return ae;return-1}function R(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(oe,le){if(le<1)return"";for(var ge="";le>1;)le&1&&(ge+=oe),le>>=1,oe+=oe;return ge+oe}function U(oe,le,ge,Z){var ae=le.href,ne=le.title?S(le.title):null,ie=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){Z.state.inLink=!0;var O={type:"link",raw:ge,href:ae,title:ne,text:ie,tokens:Z.inlineTokens(ie)};return Z.state.inLink=!1,O}return{type:"image",raw:ge,href:ae,title:ne,text:S(ie)}}function A(oe,le){var ge=oe.match(/^(\s+)(?:```)/);if(ge===null)return le;var Z=ge[1];return le.split(`
`).map(function(ae){var ne=ae.match(/^\s+/);if(ne===null)return ae;var ie=ne[0];return ie.length>=Z.length?ae.slice(Z.length):ae}).join(`
`)}var z=function(){function oe(ge){this.options=ge||J.defaults}var le=oe.prototype;return le.space=function(Z){var ae=this.rules.block.newline.exec(Z);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},le.code=function(Z){var ae=this.rules.block.code.exec(Z);if(ae){var ne=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:m(ne,`
`)}}},le.fences=function(Z){var ae=this.rules.block.fences.exec(Z);if(ae){var ne=ae[0],ie=A(ne,ae[3]||"");return{type:"code",raw:ne,lang:ae[2]?ae[2].trim():ae[2],text:ie}}},le.heading=function(Z){var ae=this.rules.block.heading.exec(Z);if(ae){var ne=ae[2].trim();if(/#$/.test(ne)){var ie=m(ne,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(ne=ie.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:ne,tokens:this.lexer.inline(ne)}}},le.hr=function(Z){var ae=this.rules.block.hr.exec(Z);if(ae)return{type:"hr",raw:ae[0]}},le.blockquote=function(Z){var ae=this.rules.block.blockquote.exec(Z);if(ae){var ne=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},le.list=function(Z){var ae=this.rules.block.list.exec(Z);if(ae){var ne,ie,O,j,G,X,pe,we,ce,Ie,ye,We,qe=ae[1].trim(),Ze=qe.length>1,Ye={type:"list",raw:"",ordered:Ze,start:Ze?+qe.slice(0,-1):"",loose:!1,items:[]};qe=Ze?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=Ze?qe:"[*+-]");for(var Ne=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(We=!1,!(!(ae=Ne.exec(Z))||this.rules.block.hr.test(Z)));){if(ne=ae[0],Z=Z.substring(ne.length),we=ae[2].split(`
`,1)[0],ce=Z.split(`
`,1)[0],this.options.pedantic?(j=2,ye=we.trimLeft()):(j=ae[2].search(/[^ ]/),j=j>4?1:j,ye=we.slice(j),j+=ae[1].length),X=!1,!we&&/^ *$/.test(ce)&&(ne+=ce+`
`,Z=Z.substring(ce.length+1),We=!0),!We)for(var at=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),re=new RegExp("^ {0,"+Math.min(3,j-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),se=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:```|~~~)"),Ee=new RegExp("^ {0,"+Math.min(3,j-1)+"}#");Z&&(Ie=Z.split(`
`,1)[0],we=Ie,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(se.test(we)||Ee.test(we)||at.test(we)||re.test(Z)));){if(we.search(/[^ ]/)>=j||!we.trim())ye+=`
`+we.slice(j);else if(!X)ye+=`
`+we;else break;!X&&!we.trim()&&(X=!0),ne+=Ie+`
`,Z=Z.substring(Ie.length+1)}Ye.loose||(pe?Ye.loose=!0:/\n *\n *$/.test(ne)&&(pe=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(ye),ie&&(O=ie[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ne,task:!!ie,checked:O,loose:!1,text:ye}),Ye.raw+=ne}Ye.items[Ye.items.length-1].raw=ne.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var Ve=Ye.items.length;for(G=0;G<Ve;G++){this.lexer.state.top=!1,Ye.items[G].tokens=this.lexer.blockTokens(Ye.items[G].text,[]);var fe=Ye.items[G].tokens.filter(function(Le){return Le.type==="space"}),Ae=fe.every(function(Le){for(var Me=Le.raw.split(""),Ke=0,Je=P(Me),st;!(st=Je()).done;){var ot=st.value;if(ot===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Ye.loose&&fe.length&&Ae&&(Ye.loose=!0,Ye.items[G].loose=!0)}return Ye}},le.html=function(Z){var ae=this.rules.block.html.exec(Z);if(ae){var ne={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var ie=this.options.sanitizer?this.options.sanitizer(ae[0]):S(ae[0]);ne.type="paragraph",ne.text=ie,ne.tokens=this.lexer.inline(ie)}return ne}},le.def=function(Z){var ae=this.rules.block.def.exec(Z);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var ne=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:ae[0],href:ae[2],title:ae[3]}}},le.table=function(Z){var ae=this.rules.block.table.exec(Z);if(ae){var ne={type:"table",header:a(ae[1]).map(function(pe){return{text:pe}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=ae[0];var ie=ne.align.length,O,j,G,X;for(O=0;O<ie;O++)/^ *-+: *$/.test(ne.align[O])?ne.align[O]="right":/^ *:-+: *$/.test(ne.align[O])?ne.align[O]="center":/^ *:-+ *$/.test(ne.align[O])?ne.align[O]="left":ne.align[O]=null;for(ie=ne.rows.length,O=0;O<ie;O++)ne.rows[O]=a(ne.rows[O],ne.header.length).map(function(pe){return{text:pe}});for(ie=ne.header.length,j=0;j<ie;j++)ne.header[j].tokens=this.lexer.inline(ne.header[j].text);for(ie=ne.rows.length,j=0;j<ie;j++)for(X=ne.rows[j],G=0;G<X.length;G++)X[G].tokens=this.lexer.inline(X[G].text);return ne}}},le.lheading=function(Z){var ae=this.rules.block.lheading.exec(Z);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},le.paragraph=function(Z){var ae=this.rules.block.paragraph.exec(Z);if(ae){var ne=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:ne,tokens:this.lexer.inline(ne)}}},le.text=function(Z){var ae=this.rules.block.text.exec(Z);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},le.escape=function(Z){var ae=this.rules.inline.escape.exec(Z);if(ae)return{type:"escape",raw:ae[0],text:S(ae[1])}},le.tag=function(Z){var ae=this.rules.inline.tag.exec(Z);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):S(ae[0]):ae[0]}},le.link=function(Z){var ae=this.rules.inline.link.exec(Z);if(ae){var ne=ae[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var ie=m(ne.slice(0,-1),"\\");if((ne.length-ie.length)%2===0)return}else{var O=_(ae[2],"()");if(O>-1){var j=ae[0].indexOf("!")===0?5:4,G=j+ae[1].length+O;ae[2]=ae[2].substring(0,O),ae[0]=ae[0].substring(0,G).trim(),ae[3]=""}}var X=ae[2],pe="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);we&&(X=we[1],pe=we[3])}else pe=ae[3]?ae[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(ne)?X=X.slice(1):X=X.slice(1,-1)),U(ae,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:pe&&pe.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},le.reflink=function(Z,ae){var ne;if((ne=this.rules.inline.reflink.exec(Z))||(ne=this.rules.inline.nolink.exec(Z))){var ie=(ne[2]||ne[1]).replace(/\s+/g," ");if(ie=ae[ie.toLowerCase()],!ie||!ie.href){var O=ne[0].charAt(0);return{type:"text",raw:O,text:O}}return U(ne,ie,ne[0],this.lexer)}},le.emStrong=function(Z,ae,ne){ne===void 0&&(ne="");var ie=this.rules.inline.emStrong.lDelim.exec(Z);if(!!ie&&!(ie[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var O=ie[1]||ie[2]||"";if(!O||O&&(ne===""||this.rules.inline.punctuation.exec(ne))){var j=ie[0].length-1,G,X,pe=j,we=0,ce=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,ae=ae.slice(-1*Z.length+j);(ie=ce.exec(ae))!=null;)if(G=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!G){if(X=G.length,ie[3]||ie[4]){pe+=X;continue}else if((ie[5]||ie[6])&&j%3&&!((j+X)%3)){we+=X;continue}if(pe-=X,!(pe>0)){if(X=Math.min(X,X+pe+we),Math.min(j,X)%2){var Ie=Z.slice(1,j+ie.index+X);return{type:"em",raw:Z.slice(0,j+ie.index+X+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}var ye=Z.slice(2,j+ie.index+X-1);return{type:"strong",raw:Z.slice(0,j+ie.index+X+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},le.codespan=function(Z){var ae=this.rules.inline.code.exec(Z);if(ae){var ne=ae[2].replace(/\n/g," "),ie=/[^ ]/.test(ne),O=/^ /.test(ne)&&/ $/.test(ne);return ie&&O&&(ne=ne.substring(1,ne.length-1)),ne=S(ne,!0),{type:"codespan",raw:ae[0],text:ne}}},le.br=function(Z){var ae=this.rules.inline.br.exec(Z);if(ae)return{type:"br",raw:ae[0]}},le.del=function(Z){var ae=this.rules.inline.del.exec(Z);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},le.autolink=function(Z,ae){var ne=this.rules.inline.autolink.exec(Z);if(ne){var ie,O;return ne[2]==="@"?(ie=S(this.options.mangle?ae(ne[1]):ne[1]),O="mailto:"+ie):(ie=S(ne[1]),O=ie),{type:"link",raw:ne[0],text:ie,href:O,tokens:[{type:"text",raw:ie,text:ie}]}}},le.url=function(Z,ae){var ne;if(ne=this.rules.inline.url.exec(Z)){var ie,O;if(ne[2]==="@")ie=S(this.options.mangle?ae(ne[0]):ne[0]),O="mailto:"+ie;else{var j;do j=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(j!==ne[0]);ie=S(ne[0]),ne[1]==="www."?O="http://"+ie:O=ie}return{type:"link",raw:ne[0],text:ie,href:O,tokens:[{type:"text",raw:ie,text:ie}]}}},le.inlineText=function(Z,ae){var ne=this.rules.inline.text.exec(Z);if(ne){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):S(ne[0]):ne[0]:ie=S(this.options.smartypants?ae(ne[0]):ne[0]),{type:"text",raw:ne[0],text:ie}}},oe}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=v($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=v(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=v($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=v($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=v($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=v($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=s({},$),$.gfm=s({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=v($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=v($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=s({},$.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:v($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=v(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=v($._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=v(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=v(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=v(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=v(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=v(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=v(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=v(N.reflink).replace("label",N._label).replace("ref",$._label).getRegex(),N.nolink=v(N.nolink).replace("ref",$._label).getRegex(),N.reflinkSearch=v(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=s({},N),N.pedantic=s({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=s({},N.normal,{escape:v(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=v(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=s({},N.gfm,{br:v(N.br).replace("{2,}","*").getRegex(),text:v(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function V(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(oe){var le="",ge,Z,ae=oe.length;for(ge=0;ge<ae;ge++)Z=oe.charCodeAt(ge),Math.random()>.5&&(Z="x"+Z.toString(16)),le+="&#"+Z+";";return le}var F=function(){function oe(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||J.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:$.normal,inline:N.normal};this.options.pedantic?(Z.block=$.pedantic,Z.inline=N.pedantic):this.options.gfm&&(Z.block=$.gfm,this.options.breaks?Z.inline=N.breaks:Z.inline=N.gfm),this.tokenizer.rules=Z}oe.lex=function(Z,ae){var ne=new oe(ae);return ne.lex(Z)},oe.lexInline=function(Z,ae){var ne=new oe(ae);return ne.inlineTokens(Z)};var le=oe.prototype;return le.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},le.blockTokens=function(Z,ae){var ne=this;ae===void 0&&(ae=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(pe,we,ce){return we+"    ".repeat(ce.length)});for(var ie,O,j,G;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(pe){return(ie=pe.call({lexer:ne},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.space(Z)){Z=Z.substring(ie.raw.length),ie.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(ie);continue}if(ie=this.tokenizer.code(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=O.text):ae.push(ie);continue}if(ie=this.tokenizer.fences(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.heading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.hr(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.blockquote(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.list(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.html(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.def(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=O.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.lheading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(j=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var pe=1/0,we=Z.slice(1),ce=void 0;ne.options.extensions.startBlock.forEach(function(Ie){ce=Ie.call({lexer:this},we),typeof ce=="number"&&ce>=0&&(pe=Math.min(pe,ce))}),pe<1/0&&pe>=0&&(j=Z.substring(0,pe+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(j))){O=ae[ae.length-1],G&&O.type==="paragraph"?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):ae.push(ie),G=j.length!==Z.length,Z=Z.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&O.type==="text"?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):ae.push(ie);continue}if(Z){var X="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,ae},le.inline=function(Z,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:Z,tokens:ae}),ae},le.inlineTokens=function(Z,ae){var ne=this;ae===void 0&&(ae=[]);var ie,O,j,G=Z,X,pe,we;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)ce.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,X.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(pe||(we=""),pe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(ie=ye.call({lexer:ne},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.tag(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&ie.type==="text"&&O.type==="text"?(O.raw+=ie.raw,O.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.link(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&ie.type==="text"&&O.type==="text"?(O.raw+=ie.raw,O.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.emStrong(Z,G,we)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.codespan(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.br(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.del(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.autolink(Z,B)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(Z,B))){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(j=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,We=Z.slice(1),qe=void 0;ne.options.extensions.startInline.forEach(function(Ze){qe=Ze.call({lexer:this},We),typeof qe=="number"&&qe>=0&&(ye=Math.min(ye,qe))}),ye<1/0&&ye>=0&&(j=Z.substring(0,ye+1))}(),ie=this.tokenizer.inlineText(j,V)){Z=Z.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(we=ie.raw.slice(-1)),pe=!0,O=ae[ae.length-1],O&&O.type==="text"?(O.raw+=ie.raw,O.text+=ie.text):ae.push(ie);continue}if(Z){var Ie="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return ae},l(oe,null,[{key:"rules",get:function(){return{block:$,inline:N}}}]),oe}(),x=function(){function oe(ge){this.options=ge||J.defaults}var le=oe.prototype;return le.code=function(Z,ae,ne){var ie=(ae||"").match(/\S*/)[0];if(this.options.highlight){var O=this.options.highlight(Z,ie);O!=null&&O!==Z&&(ne=!0,Z=O)}return Z=Z.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+S(ie,!0)+'">'+(ne?Z:S(Z,!0))+`</code></pre>
`:"<pre><code>"+(ne?Z:S(Z,!0))+`</code></pre>
`},le.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},le.html=function(Z){return Z},le.heading=function(Z,ae,ne,ie){if(this.options.headerIds){var O=this.options.headerPrefix+ie.slug(ne);return"<h"+ae+' id="'+O+'">'+Z+"</h"+ae+`>
`}return"<h"+ae+">"+Z+"</h"+ae+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(Z,ae,ne){var ie=ae?"ol":"ul",O=ae&&ne!==1?' start="'+ne+'"':"";return"<"+ie+O+`>
`+Z+"</"+ie+`>
`},le.listitem=function(Z){return"<li>"+Z+`</li>
`},le.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(Z){return"<p>"+Z+`</p>
`},le.table=function(Z,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ae+`</table>
`},le.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},le.tablecell=function(Z,ae){var ne=ae.header?"th":"td",ie=ae.align?"<"+ne+' align="'+ae.align+'">':"<"+ne+">";return ie+Z+("</"+ne+`>
`)},le.strong=function(Z){return"<strong>"+Z+"</strong>"},le.em=function(Z){return"<em>"+Z+"</em>"},le.codespan=function(Z){return"<code>"+Z+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(Z){return"<del>"+Z+"</del>"},le.link=function(Z,ae,ne){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var ie='<a href="'+S(Z)+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=">"+ne+"</a>",ie},le.image=function(Z,ae,ne){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var ie='<img src="'+Z+'" alt="'+ne+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=this.options.xhtml?"/>":">",ie},le.text=function(Z){return Z},oe}(),H=function(){function oe(){}var le=oe.prototype;return le.strong=function(Z){return Z},le.em=function(Z){return Z},le.codespan=function(Z){return Z},le.del=function(Z){return Z},le.html=function(Z){return Z},le.text=function(Z){return Z},le.link=function(Z,ae,ne){return""+ne},le.image=function(Z,ae,ne){return""+ne},le.br=function(){return""},oe}(),Q=function(){function oe(){this.seen={}}var le=oe.prototype;return le.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(Z,ae){var ne=Z,ie=0;if(this.seen.hasOwnProperty(ne)){ie=this.seen[Z];do ie++,ne=Z+"-"+ie;while(this.seen.hasOwnProperty(ne))}return ae||(this.seen[Z]=ie,this.seen[ne]=0),ne},le.slug=function(Z,ae){ae===void 0&&(ae={});var ne=this.serialize(Z);return this.getNextSafeSlug(ne,ae.dryrun)},oe}(),K=function(){function oe(ge){this.options=ge||J.defaults,this.options.renderer=this.options.renderer||new x,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new H,this.slugger=new Q}oe.parse=function(Z,ae){var ne=new oe(ae);return ne.parse(Z)},oe.parseInline=function(Z,ae){var ne=new oe(ae);return ne.parseInline(Z)};var le=oe.prototype;return le.parse=function(Z,ae){ae===void 0&&(ae=!0);var ne="",ie,O,j,G,X,pe,we,ce,Ie,ye,We,qe,Ze,Ye,Ne,at,re,se,Ee,Ve=Z.length;for(ie=0;ie<Ve;ie++){if(ye=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ee=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ee!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ne+=Ee||"";continue}switch(ye.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,b(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ce="",we="",G=ye.header.length,O=0;O<G;O++)we+=this.renderer.tablecell(this.parseInline(ye.header[O].tokens),{header:!0,align:ye.align[O]});for(ce+=this.renderer.tablerow(we),Ie="",G=ye.rows.length,O=0;O<G;O++){for(pe=ye.rows[O],we="",X=pe.length,j=0;j<X;j++)we+=this.renderer.tablecell(this.parseInline(pe[j].tokens),{header:!1,align:ye.align[j]});Ie+=this.renderer.tablerow(we)}ne+=this.renderer.table(ce,Ie);continue}case"blockquote":{Ie=this.parse(ye.tokens),ne+=this.renderer.blockquote(Ie);continue}case"list":{for(We=ye.ordered,qe=ye.start,Ze=ye.loose,G=ye.items.length,Ie="",O=0;O<G;O++)Ne=ye.items[O],at=Ne.checked,re=Ne.task,Ye="",Ne.task&&(se=this.renderer.checkbox(at),Ze?Ne.tokens.length>0&&Ne.tokens[0].type==="paragraph"?(Ne.tokens[0].text=se+" "+Ne.tokens[0].text,Ne.tokens[0].tokens&&Ne.tokens[0].tokens.length>0&&Ne.tokens[0].tokens[0].type==="text"&&(Ne.tokens[0].tokens[0].text=se+" "+Ne.tokens[0].tokens[0].text)):Ne.tokens.unshift({type:"text",text:se}):Ye+=se),Ye+=this.parse(Ne.tokens,Ze),Ie+=this.renderer.listitem(Ye,re,at);ne+=this.renderer.list(Ie,We,qe);continue}case"html":{ne+=this.renderer.html(ye.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(Ie=ye.tokens?this.parseInline(ye.tokens):ye.text;ie+1<Ve&&Z[ie+1].type==="text";)ye=Z[++ie],Ie+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ne+=ae?this.renderer.paragraph(Ie):Ie;continue}default:{var fe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(fe);return}else throw new Error(fe)}}}return ne},le.parseInline=function(Z,ae){ae=ae||this.renderer;var ne="",ie,O,j,G=Z.length;for(ie=0;ie<G;ie++){if(O=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[O.type]&&(j=this.options.extensions.renderers[O.type].call({parser:this},O),j!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(O.type))){ne+=j||"";continue}switch(O.type){case"escape":{ne+=ae.text(O.text);break}case"html":{ne+=ae.html(O.text);break}case"link":{ne+=ae.link(O.href,O.title,this.parseInline(O.tokens,ae));break}case"image":{ne+=ae.image(O.href,O.title,O.text);break}case"strong":{ne+=ae.strong(this.parseInline(O.tokens,ae));break}case"em":{ne+=ae.em(this.parseInline(O.tokens,ae));break}case"codespan":{ne+=ae.codespan(O.text);break}case"br":{ne+=ae.br();break}case"del":{ne+=ae.del(this.parseInline(O.tokens,ae));break}case"text":{ne+=ae.text(O.text);break}default:{var X='Token with "'+O.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return ne},oe}();function de(oe,le,ge){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof le=="function"&&(ge=le,le=null),le=s({},de.defaults,le||{}),R(le),ge){var Z=le.highlight,ae;try{ae=F.lex(oe,le)}catch(G){return ge(G)}var ne=function(X){var pe;if(!X)try{le.walkTokens&&de.walkTokens(ae,le.walkTokens),pe=K.parse(ae,le)}catch(we){X=we}return le.highlight=Z,X?ge(X):ge(null,pe)};if(!Z||Z.length<3||(delete le.highlight,!ae.length))return ne();var ie=0;de.walkTokens(ae,function(G){G.type==="code"&&(ie++,setTimeout(function(){Z(G.text,G.lang,function(X,pe){if(X)return ne(X);pe!=null&&pe!==G.text&&(G.text=pe,G.escaped=!0),ie--,ie===0&&ne()})},0))}),ie===0&&ne();return}function O(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+S(G.message+"",!0)+"</pre>";throw G}try{var j=F.lex(oe,le);if(le.walkTokens){if(le.async)return Promise.all(de.walkTokens(j,le.walkTokens)).then(function(){return K.parse(j,le)}).catch(O);de.walkTokens(j,le.walkTokens)}return K.parse(j,le)}catch(G){O(G)}}de.options=de.setOptions=function(oe){return s(de.defaults,oe),D(de.defaults),de},de.getDefaults=y,de.defaults=J.defaults,de.use=function(){for(var oe=arguments.length,le=new Array(oe),ge=0;ge<oe;ge++)le[ge]=arguments[ge];var Z=s.apply(void 0,[{}].concat(le)),ae=de.defaults.extensions||{renderers:{},childTokens:{}},ne;le.forEach(function(ie){if(ie.extensions&&(ne=!0,ie.extensions.forEach(function(j){if(!j.name)throw new Error("extension name required");if(j.renderer){var G=ae.renderers?ae.renderers[j.name]:null;G?ae.renderers[j.name]=function(){for(var X=arguments.length,pe=new Array(X),we=0;we<X;we++)pe[we]=arguments[we];var ce=j.renderer.apply(this,pe);return ce===!1&&(ce=G.apply(this,pe)),ce}:ae.renderers[j.name]=j.renderer}if(j.tokenizer){if(!j.level||j.level!=="block"&&j.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[j.level]?ae[j.level].unshift(j.tokenizer):ae[j.level]=[j.tokenizer],j.start&&(j.level==="block"?ae.startBlock?ae.startBlock.push(j.start):ae.startBlock=[j.start]:j.level==="inline"&&(ae.startInline?ae.startInline.push(j.start):ae.startInline=[j.start]))}j.childTokens&&(ae.childTokens[j.name]=j.childTokens)})),ie.renderer&&function(){var j=de.defaults.renderer||new x,G=function(we){var ce=j[we];j[we]=function(){for(var Ie=arguments.length,ye=new Array(Ie),We=0;We<Ie;We++)ye[We]=arguments[We];var qe=ie.renderer[we].apply(j,ye);return qe===!1&&(qe=ce.apply(j,ye)),qe}};for(var X in ie.renderer)G(X);Z.renderer=j}(),ie.tokenizer&&function(){var j=de.defaults.tokenizer||new z,G=function(we){var ce=j[we];j[we]=function(){for(var Ie=arguments.length,ye=new Array(Ie),We=0;We<Ie;We++)ye[We]=arguments[We];var qe=ie.tokenizer[we].apply(j,ye);return qe===!1&&(qe=ce.apply(j,ye)),qe}};for(var X in ie.tokenizer)G(X);Z.tokenizer=j}(),ie.walkTokens){var O=de.defaults.walkTokens;Z.walkTokens=function(j){var G=[];return G.push(ie.walkTokens.call(this,j)),O&&(G=G.concat(O.call(this,j))),G}}ne&&(Z.extensions=ae),de.setOptions(Z)})},de.walkTokens=function(oe,le){for(var ge=[],Z=function(){var O=ne.value;switch(ge=ge.concat(le.call(de,O)),O.type){case"table":{for(var j=P(O.header),G;!(G=j()).done;){var X=G.value;ge=ge.concat(de.walkTokens(X.tokens,le))}for(var pe=P(O.rows),we;!(we=pe()).done;)for(var ce=we.value,Ie=P(ce),ye;!(ye=Ie()).done;){var We=ye.value;ge=ge.concat(de.walkTokens(We.tokens,le))}break}case"list":{ge=ge.concat(de.walkTokens(O.items,le));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[O.type]?de.defaults.extensions.childTokens[O.type].forEach(function(qe){ge=ge.concat(de.walkTokens(O[qe],le))}):O.tokens&&(ge=ge.concat(de.walkTokens(O.tokens,le)))}},ae=P(oe),ne;!(ne=ae()).done;)Z();return ge},de.parseInline=function(oe,le){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");le=s({},de.defaults,le||{}),R(le);try{var ge=F.lexInline(oe,le);return le.walkTokens&&de.walkTokens(ge,le.walkTokens),K.parseInline(ge,le)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+S(Z.message+"",!0)+"</pre>";throw Z}},de.Parser=K,de.parser=K.parse,de.Renderer=x,de.TextRenderer=H,de.Lexer=F,de.lexer=F.lex,de.Tokenizer=z,de.Slugger=Q,de.parse=de;var ee=de.options,he=de.setOptions,Y=de.use,me=de.walkTokens,be=de.parseInline,ke=de,Re=K.parse,ze=F.lex;J.Lexer=F,J.Parser=K,J.Renderer=x,J.Slugger=Q,J.TextRenderer=H,J.Tokenizer=z,J.getDefaults=y,J.lexer=ze,J.marked=de,J.options=ee,J.parse=ke,J.parseInline=be,J.parser=Re,J.setOptions=he,J.use=Y,J.walkTokens=me,Object.defineProperty(J,"__esModule",{value:!0})}),define(Ce[97],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function l(D,w,k){return Math.min(Math.max(D,w),k)}e.clamp=l;function t(D,w){return(w+D%w)%w}e.rot=t;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class P{constructor(){this._n=1,this._val=0}update(w){return this._val=this._val+(w-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class y{constructor(w){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(w),this._values.fill(0,0,w)}update(w){const k=this._values[this._index];return this._values[this._index]=w,this._index=(this._index+1)%this._values.length,this._sum-=k,this._sum+=w,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),function(){function J(I){const P=[];typeof I=="number"&&P.push("code/timeOrigin",I);function y(w){P.push(w,Date.now())}function D(){const w=[];for(let k=0;k<P.length;k+=2)w.push({name:P[k],startTime:P[k+1]});return w}return{mark:y,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const y of performance.getEntriesByType("mark"))P.push({name:y.name,startTime:Math.round(I+y.startTime)});return P}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function l(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=l(t))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var l=e();for(var t in l)(typeof exports=="object"?exports:J)[t]=l[t]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function l(t){if(e[t])return e[t].exports;var I=e[t]={i:t,l:!1,exports:{}};return J[t].call(I.exports,I,I.exports,l),I.l=!0,I.exports}return l.m=J,l.c=e,l.d=function(t,I,P){l.o(t,I)||Object.defineProperty(t,I,{enumerable:!0,get:P})},l.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},l.t=function(t,I){if(1&I&&(t=l(t)),8&I||4&I&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(l.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&I&&typeof t!="string")for(var y in t)l.d(P,y,function(D){return t[D]}.bind(null,y));return P},l.n=function(t){var I=t&&t.__esModule?function(){return t.default}:function(){return t};return l.d(I,"a",I),I},l.o=function(t,I){return Object.prototype.hasOwnProperty.call(t,I)},l.p="",l(l.s=0)}([function(J,e,l){(function(t){var I;e=J.exports=Y,I=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,y=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],w=e.src=[],k=0,L=k++;w[L]="0|[1-9]\\d*";var C=k++;w[C]="[0-9]+";var E=k++;w[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=k++;w[T]="("+w[L]+")\\.("+w[L]+")\\.("+w[L]+")";var S=k++;w[S]="("+w[C]+")\\.("+w[C]+")\\.("+w[C]+")";var p=k++;w[p]="(?:"+w[L]+"|"+w[E]+")";var b=k++;w[b]="(?:"+w[C]+"|"+w[E]+")";var f=k++;w[f]="(?:-("+w[p]+"(?:\\."+w[p]+")*))";var v=k++;w[v]="(?:-?("+w[b]+"(?:\\."+w[b]+")*))";var h=k++;w[h]="[0-9A-Za-z-]+";var c=k++;w[c]="(?:\\+("+w[h]+"(?:\\."+w[h]+")*))";var g=k++,i="v?"+w[T]+w[f]+"?"+w[c]+"?";w[g]="^"+i+"$";var u="[v=\\s]*"+w[S]+w[v]+"?"+w[c]+"?",r=k++;w[r]="^"+u+"$";var n=k++;w[n]="((?:<|>)?=?)";var o=k++;w[o]=w[C]+"|x|X|\\*";var d=k++;w[d]=w[L]+"|x|X|\\*";var s=k++;w[s]="[v=\\s]*("+w[d]+")(?:\\.("+w[d]+")(?:\\.("+w[d]+")(?:"+w[f]+")?"+w[c]+"?)?)?";var a=k++;w[a]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[v]+")?"+w[c]+"?)?)?";var m=k++;w[m]="^"+w[n]+"\\s*"+w[s]+"$";var _=k++;w[_]="^"+w[n]+"\\s*"+w[a]+"$";var R=k++;w[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=k++;w[M]="(?:~>?)";var U=k++;w[U]="(\\s*)"+w[M]+"\\s+",D[U]=new RegExp(w[U],"g");var A=k++;w[A]="^"+w[M]+w[s]+"$";var z=k++;w[z]="^"+w[M]+w[a]+"$";var $=k++;w[$]="(?:\\^)";var N=k++;w[N]="(\\s*)"+w[$]+"\\s+",D[N]=new RegExp(w[N],"g");var V=k++;w[V]="^"+w[$]+w[s]+"$";var B=k++;w[B]="^"+w[$]+w[a]+"$";var F=k++;w[F]="^"+w[n]+"\\s*("+u+")$|^$";var x=k++;w[x]="^"+w[n]+"\\s*("+i+")$|^$";var H=k++;w[H]="(\\s*)"+w[n]+"\\s*("+u+"|"+w[s]+")",D[H]=new RegExp(w[H],"g");var Q=k++;w[Q]="^\\s*("+w[s]+")\\s+-\\s+("+w[s]+")\\s*$";var K=k++;w[K]="^\\s*("+w[a]+")\\s+-\\s+("+w[a]+")\\s*$";var de=k++;w[de]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)I(ee,w[ee]),D[ee]||(D[ee]=new RegExp(w[ee]));function he(ce,Ie){if(ce instanceof Y)return ce;if(typeof ce!="string"||ce.length>P||!(Ie?D[r]:D[g]).test(ce))return null;try{return new Y(ce,Ie)}catch{return null}}function Y(ce,Ie){if(ce instanceof Y){if(ce.loose===Ie)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof Y))return new Y(ce,Ie);I("SemVer",ce,Ie),this.loose=Ie;var ye=ce.trim().match(Ie?D[r]:D[g]);if(!ye)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>y||this.major<0)throw new TypeError("Invalid major version");if(this.minor>y||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>y||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var qe=+We;if(qe>=0&&qe<y)return qe}return We}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=he,e.valid=function(ce,Ie){var ye=he(ce,Ie);return ye?ye.version:null},e.clean=function(ce,Ie){var ye=he(ce.trim().replace(/^[=v]+/,""),Ie);return ye?ye.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(ce){return I("SemVer.compare",this.version,this.loose,ce),ce instanceof Y||(ce=new Y(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},Y.prototype.compareMain=function(ce){return ce instanceof Y||(ce=new Y(ce,this.loose)),be(this.major,ce.major)||be(this.minor,ce.minor)||be(this.patch,ce.patch)},Y.prototype.comparePre=function(ce){if(ce instanceof Y||(ce=new Y(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var Ie=0;do{var ye=this.prerelease[Ie],We=ce.prerelease[Ie];if(I("prerelease compare",Ie,ye,We),ye===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(ye===void 0)return-1;if(ye!==We)return be(ye,We)}while(++Ie)},Y.prototype.inc=function(ce,Ie){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ie);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ie);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ie),this.inc("pre",Ie);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ie),this.inc("pre",Ie);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Ie&&(this.prerelease[0]===Ie?isNaN(this.prerelease[1])&&(this.prerelease=[Ie,0]):this.prerelease=[Ie,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,Ie,ye,We){typeof ye=="string"&&(We=ye,ye=void 0);try{return new Y(ce,ye).inc(Ie,We).version}catch{return null}},e.diff=function(ce,Ie){if(oe(ce,Ie))return null;var ye=he(ce),We=he(Ie);if(ye.prerelease.length||We.prerelease.length){for(var qe in ye)if((qe==="major"||qe==="minor"||qe==="patch")&&ye[qe]!==We[qe])return"pre"+qe;return"prerelease"}for(var qe in ye)if((qe==="major"||qe==="minor"||qe==="patch")&&ye[qe]!==We[qe])return qe},e.compareIdentifiers=be;var me=/^[0-9]+$/;function be(ce,Ie){var ye=me.test(ce),We=me.test(Ie);return ye&&We&&(ce=+ce,Ie=+Ie),ye&&!We?-1:We&&!ye?1:ce<Ie?-1:ce>Ie?1:0}function ke(ce,Ie,ye){return new Y(ce,ye).compare(new Y(Ie,ye))}function Re(ce,Ie,ye){return ke(ce,Ie,ye)>0}function ze(ce,Ie,ye){return ke(ce,Ie,ye)<0}function oe(ce,Ie,ye){return ke(ce,Ie,ye)===0}function le(ce,Ie,ye){return ke(ce,Ie,ye)!==0}function ge(ce,Ie,ye){return ke(ce,Ie,ye)>=0}function Z(ce,Ie,ye){return ke(ce,Ie,ye)<=0}function ae(ce,Ie,ye,We){var qe;switch(Ie){case"===":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),qe=ce===ye;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),qe=ce!==ye;break;case"":case"=":case"==":qe=oe(ce,ye,We);break;case"!=":qe=le(ce,ye,We);break;case">":qe=Re(ce,ye,We);break;case">=":qe=ge(ce,ye,We);break;case"<":qe=ze(ce,ye,We);break;case"<=":qe=Z(ce,ye,We);break;default:throw new TypeError("Invalid operator: "+Ie)}return qe}function ne(ce,Ie){if(ce instanceof ne){if(ce.loose===Ie)return ce;ce=ce.value}if(!(this instanceof ne))return new ne(ce,Ie);I("comparator",ce,Ie),this.loose=Ie,this.parse(ce),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(ce,Ie){return be(Ie,ce)},e.major=function(ce,Ie){return new Y(ce,Ie).major},e.minor=function(ce,Ie){return new Y(ce,Ie).minor},e.patch=function(ce,Ie){return new Y(ce,Ie).patch},e.compare=ke,e.compareLoose=function(ce,Ie){return ke(ce,Ie,!0)},e.rcompare=function(ce,Ie,ye){return ke(Ie,ce,ye)},e.sort=function(ce,Ie){return ce.sort(function(ye,We){return e.compare(ye,We,Ie)})},e.rsort=function(ce,Ie){return ce.sort(function(ye,We){return e.rcompare(ye,We,Ie)})},e.gt=Re,e.lt=ze,e.eq=oe,e.neq=le,e.gte=ge,e.lte=Z,e.cmp=ae,e.Comparator=ne;var ie={};function O(ce,Ie){if(ce instanceof O)return ce.loose===Ie?ce:new O(ce.raw,Ie);if(ce instanceof ne)return new O(ce.value,Ie);if(!(this instanceof O))return new O(ce,Ie);if(this.loose=Ie,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function j(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function G(ce,Ie,ye,We,qe,Ze,Ye,Ne,at,re,se,Ee,Ve){return((Ie=j(ye)?"":j(We)?">="+ye+".0.0":j(qe)?">="+ye+"."+We+".0":">="+Ie)+" "+(Ne=j(at)?"":j(re)?"<"+(+at+1)+".0.0":j(se)?"<"+at+"."+(+re+1)+".0":Ee?"<="+at+"."+re+"."+se+"-"+Ee:"<="+Ne)).trim()}function X(ce,Ie){for(var ye=0;ye<ce.length;ye++)if(!ce[ye].test(Ie))return!1;if(Ie.prerelease.length){for(ye=0;ye<ce.length;ye++)if(I(ce[ye].semver),ce[ye].semver!==ie&&ce[ye].semver.prerelease.length>0){var We=ce[ye].semver;if(We.major===Ie.major&&We.minor===Ie.minor&&We.patch===Ie.patch)return!0}return!1}return!0}function pe(ce,Ie,ye){try{Ie=new O(Ie,ye)}catch{return!1}return Ie.test(ce)}function we(ce,Ie,ye,We){var qe,Ze,Ye,Ne,at;switch(ce=new Y(ce,We),Ie=new O(Ie,We),ye){case">":qe=Re,Ze=Z,Ye=ze,Ne=">",at=">=";break;case"<":qe=ze,Ze=ge,Ye=Re,Ne="<",at="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(ce,Ie,We))return!1;for(var re=0;re<Ie.set.length;++re){var se=Ie.set[re],Ee=null,Ve=null;if(se.forEach(function(fe){fe.semver===ie&&(fe=new ne(">=0.0.0")),Ee=Ee||fe,Ve=Ve||fe,qe(fe.semver,Ee.semver,We)?Ee=fe:Ye(fe.semver,Ve.semver,We)&&(Ve=fe)}),Ee.operator===Ne||Ee.operator===at||(!Ve.operator||Ve.operator===Ne)&&Ze(ce,Ve.semver)||Ve.operator===at&&Ye(ce,Ve.semver))return!1}return!0}ne.prototype.parse=function(ce){var Ie=this.loose?D[F]:D[x],ye=ce.match(Ie);if(!ye)throw new TypeError("Invalid comparator: "+ce);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new Y(ye[2],this.loose):this.semver=ie},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(ce){return I("Comparator.test",ce,this.loose),this.semver===ie||(typeof ce=="string"&&(ce=new Y(ce,this.loose)),ae(ce,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(ce,Ie){if(!(ce instanceof ne))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new O(ce.value,Ie),pe(this.value,ye,Ie);if(ce.operator==="")return ye=new O(this.value,Ie),pe(ce.semver,ye,Ie);var We=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ze=this.semver.version===ce.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Ne=ae(this.semver,"<",ce.semver,Ie)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),at=ae(this.semver,">",ce.semver,Ie)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return We||qe||Ze&&Ye||Ne||at},e.Range=O,O.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},O.prototype.toString=function(){return this.range},O.prototype.parseRange=function(ce){var Ie=this.loose;ce=ce.trim(),I("range",ce,Ie);var ye=Ie?D[K]:D[Q];ce=ce.replace(ye,G),I("hyphen replace",ce),ce=ce.replace(D[H],"$1$2$3"),I("comparator trim",ce,D[H]),ce=(ce=(ce=ce.replace(D[U],"$1~")).replace(D[N],"$1^")).split(/\s+/).join(" ");var We=Ie?D[F]:D[x],qe=ce.split(" ").map(function(Ze){return function(Ye,Ne){return I("comp",Ye),Ye=function(at,re){return at.trim().split(/\s+/).map(function(se){return function(Ee,Ve){I("caret",Ee,Ve);var fe=Ve?D[B]:D[V];return Ee.replace(fe,function(Ae,Le,Me,Ke,Je){var st;return I("caret",Ee,Ae,Le,Me,Ke,Je),j(Le)?st="":j(Me)?st=">="+Le+".0.0 <"+(+Le+1)+".0.0":j(Ke)?st=Le==="0"?">="+Le+"."+Me+".0 <"+Le+"."+(+Me+1)+".0":">="+Le+"."+Me+".0 <"+(+Le+1)+".0.0":Je?(I("replaceCaret pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),st=Le==="0"?Me==="0"?">="+Le+"."+Me+"."+Ke+Je+" <"+Le+"."+Me+"."+(+Ke+1):">="+Le+"."+Me+"."+Ke+Je+" <"+Le+"."+(+Me+1)+".0":">="+Le+"."+Me+"."+Ke+Je+" <"+(+Le+1)+".0.0"):(I("no pr"),st=Le==="0"?Me==="0"?">="+Le+"."+Me+"."+Ke+" <"+Le+"."+Me+"."+(+Ke+1):">="+Le+"."+Me+"."+Ke+" <"+Le+"."+(+Me+1)+".0":">="+Le+"."+Me+"."+Ke+" <"+(+Le+1)+".0.0"),I("caret return",st),st})}(se,re)}).join(" ")}(Ye,Ne),I("caret",Ye),Ye=function(at,re){return at.trim().split(/\s+/).map(function(se){return function(Ee,Ve){var fe=Ve?D[z]:D[A];return Ee.replace(fe,function(Ae,Le,Me,Ke,Je){var st;return I("tilde",Ee,Ae,Le,Me,Ke,Je),j(Le)?st="":j(Me)?st=">="+Le+".0.0 <"+(+Le+1)+".0.0":j(Ke)?st=">="+Le+"."+Me+".0 <"+Le+"."+(+Me+1)+".0":Je?(I("replaceTilde pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),st=">="+Le+"."+Me+"."+Ke+Je+" <"+Le+"."+(+Me+1)+".0"):st=">="+Le+"."+Me+"."+Ke+" <"+Le+"."+(+Me+1)+".0",I("tilde return",st),st})}(se,re)}).join(" ")}(Ye,Ne),I("tildes",Ye),Ye=function(at,re){return I("replaceXRanges",at,re),at.split(/\s+/).map(function(se){return function(Ee,Ve){Ee=Ee.trim();var fe=Ve?D[_]:D[m];return Ee.replace(fe,function(Ae,Le,Me,Ke,Je,st){I("xRange",Ee,Ae,Le,Me,Ke,Je,st);var ot=j(Me),it=ot||j(Ke),lt=it||j(Je);return Le==="="&&lt&&(Le=""),ot?Ae=Le===">"||Le==="<"?"<0.0.0":"*":Le&&lt?(it&&(Ke=0),lt&&(Je=0),Le===">"?(Le=">=",it?(Me=+Me+1,Ke=0,Je=0):lt&&(Ke=+Ke+1,Je=0)):Le==="<="&&(Le="<",it?Me=+Me+1:Ke=+Ke+1),Ae=Le+Me+"."+Ke+"."+Je):it?Ae=">="+Me+".0.0 <"+(+Me+1)+".0.0":lt&&(Ae=">="+Me+"."+Ke+".0 <"+Me+"."+(+Ke+1)+".0"),I("xRange return",Ae),Ae})}(se,re)}).join(" ")}(Ye,Ne),I("xrange",Ye),Ye=function(at,re){return I("replaceStars",at,re),at.trim().replace(D[de],"")}(Ye,Ne),I("stars",Ye),Ye}(Ze,Ie)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(Ze){return!!Ze.match(We)})),qe=qe.map(function(Ze){return new ne(Ze,Ie)})},O.prototype.intersects=function(ce,Ie){if(!(ce instanceof O))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(We){return ce.set.some(function(qe){return qe.every(function(Ze){return We.intersects(Ze,Ie)})})})})},e.toComparators=function(ce,Ie){return new O(ce,Ie).set.map(function(ye){return ye.map(function(We){return We.value}).join(" ").trim().split(" ")})},O.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new Y(ce,this.loose));for(var Ie=0;Ie<this.set.length;Ie++)if(X(this.set[Ie],ce))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(ce,Ie,ye){var We=null,qe=null;try{var Ze=new O(Ie,ye)}catch{return null}return ce.forEach(function(Ye){Ze.test(Ye)&&(We&&qe.compare(Ye)!==-1||(qe=new Y(We=Ye,ye)))}),We},e.minSatisfying=function(ce,Ie,ye){var We=null,qe=null;try{var Ze=new O(Ie,ye)}catch{return null}return ce.forEach(function(Ye){Ze.test(Ye)&&(We&&qe.compare(Ye)!==1||(qe=new Y(We=Ye,ye)))}),We},e.validRange=function(ce,Ie){try{return new O(ce,Ie).range||"*"}catch{return null}},e.ltr=function(ce,Ie,ye){return we(ce,Ie,"<",ye)},e.gtr=function(ce,Ie,ye){return we(ce,Ie,">",ye)},e.outside=we,e.prerelease=function(ce,Ie){var ye=he(ce,Ie);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ce,Ie,ye){return ce=new O(ce,ye),Ie=new O(Ie,ye),ce.intersects(Ie)},e.coerce=function(ce){if(ce instanceof Y)return ce;if(typeof ce!="string")return null;var Ie=ce.match(D[R]);return Ie==null?null:he((Ie[1]||"0")+"."+(Ie[2]||"0")+"."+(Ie[3]||"0"))}}).call(this,l(1))},function(J,e){var l,t,I=J.exports={};function P(){throw new Error("setTimeout has not been defined")}function y(){throw new Error("clearTimeout has not been defined")}function D(b){if(l===setTimeout)return setTimeout(b,0);if((l===P||!l)&&setTimeout)return l=setTimeout,setTimeout(b,0);try{return l(b,0)}catch{try{return l.call(null,b,0)}catch{return l.call(this,b,0)}}}(function(){try{l=typeof setTimeout=="function"?setTimeout:P}catch{l=P}try{t=typeof clearTimeout=="function"?clearTimeout:y}catch{t=y}})();var w,k=[],L=!1,C=-1;function E(){L&&w&&(L=!1,w.length?k=w.concat(k):C=-1,k.length&&T())}function T(){if(!L){var b=D(E);L=!0;for(var f=k.length;f;){for(w=k,k=[];++C<f;)w&&w[C].run();C=-1,f=k.length}w=null,L=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===y||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(b)}}function S(b,f){this.fun=b,this.array=f}function p(){}I.nextTick=function(b){var f=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)f[v-1]=arguments[v];k.push(new S(b,f)),k.length!==1||L||D(T)},S.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=p,I.addListener=p,I.once=p,I.off=p,I.removeListener=p,I.removeAllListeners=p,I.emit=p,I.prependListener=p,I.prependOnceListener=p,I.listeners=function(b){return[]},I.binding=function(b){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(b){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Ce[98],De([1,0,11,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(c){const g=c;return g?typeof g.read=="function":!1}e.isReadable=I;function P(c){const g=c;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=P;function y(c){const g=c;return g?P(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=y;function D(c,g){return new w(c,g)}e.newWriteableStream=D;class w{constructor(g,i){this.reducer=g,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g<"u"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(i=>i(g))}emitError(g){this.listeners.error.length===0?(0,l.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(i=>i(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,i){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(g,i){if(this.state.destroyed)return;let u;switch(g){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const r=u.indexOf(i);r>=0&&u.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function k(c,g){const i=[];let u;for(;(u=c.read())!==null;)i.push(u);return g(i)}e.consumeReadable=k;function L(c,g,i){const u=[];let r;for(;(r=c.read())!==null&&u.length<i;)u.push(r);return r===null&&u.length>0?g(u):{read:()=>{if(u.length>0)return u.shift();if(typeof r<"u"){const n=r;return r=void 0,n}return c.read()}}}e.peekReadable=L;function C(c,g){return new Promise((i,u)=>{const r=[];E(c,{onData:n=>{g&&r.push(n)},onError:n=>{g?u(n):i(void 0)},onEnd:()=>{i(g?g(r):void 0)}})})}e.consumeStream=C;function E(c,g){let i=!1;return c.on("error",u=>{i||g.onError(u)}),c.on("end",()=>{i||g.onEnd()}),c.on("data",u=>{i||g.onData(u)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=E;function T(c,g){return new Promise((i,u)=>{const r=new t.DisposableStore,n=[],o=a=>{if(n.push(a),n.length>g)return r.dispose(),c.pause(),i({stream:c,buffer:n,ended:!1})},d=a=>u(a),s=()=>i({stream:c,buffer:n,ended:!0});r.add((0,t.toDisposable)(()=>c.removeListener("error",d))),c.on("error",d),r.add((0,t.toDisposable)(()=>c.removeListener("end",s))),c.on("end",s),r.add((0,t.toDisposable)(()=>c.removeListener("data",o))),c.on("data",o)})}e.peekStream=T;function S(c,g){const i=D(g);return i.end(c),i}e.toStream=S;function p(){const c=D(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=p;function b(c){let g=!1;return{read:()=>g?null:(g=!0,c)}}e.toReadable=b;function f(c,g,i){const u=D(i);return E(c,{onData:r=>u.write(g.data(r)),onError:r=>u.error(g.error?g.error(r):r),onEnd:()=>u.end()}),u}e.transform=f;function v(c,g,i){let u=!1;return{read:()=>{const r=g.read();return u?r:(u=!0,r!==null?i([c,r]):c)}}}e.prefixedReadable=v;function h(c,g,i){let u=!1;const r=D(i);return E(g,{onData:n=>u?r.write(n):(u=!0,r.write(i([c,n]))),onError:n=>r.error(n),onEnd:()=>{u||(u=!0,r.write(c)),r.end()}}),r}e.prefixedStream=h}),define(Ce[23],De([1,0,98]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let I,P;class y{static alloc(a){return t?new y(Buffer.allocUnsafe(a)):new y(new Uint8Array(a))}static wrap(a){return t&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new y(a)}static fromString(a,m){return!(m?.dontUseNodeBuffer||!1)&&t?new y(Buffer.from(a)):(I||(I=new TextEncoder),new y(I.encode(a)))}static fromByteArray(a){const m=y.alloc(a.length);for(let _=0,R=a.length;_<R;_++)m.buffer[_]=a[_];return m}static concat(a,m){if(typeof m>"u"){m=0;for(let M=0,U=a.length;M<U;M++)m+=a[M].byteLength}const _=y.alloc(m);let R=0;for(let M=0,U=a.length;M<U;M++){const A=a[M];_.set(A,R),R+=A.byteLength}return _}constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}clone(){const a=y.alloc(this.byteLength);return a.set(this),a}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(a,m){return new y(this.buffer.subarray(a,m))}set(a,m){if(a instanceof y)this.buffer.set(a.buffer,m);else if(a instanceof Uint8Array)this.buffer.set(a,m);else if(a instanceof ArrayBuffer)this.buffer.set(new Uint8Array(a),m);else if(ArrayBuffer.isView(a))this.buffer.set(new Uint8Array(a.buffer,a.byteOffset,a.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(a){return k(this.buffer,a)}writeUInt32BE(a,m){L(this.buffer,a,m)}readUInt32LE(a){return C(this.buffer,a)}writeUInt32LE(a,m){E(this.buffer,a,m)}readUInt8(a){return T(this.buffer,a)}writeUInt8(a,m){S(this.buffer,a,m)}}e.VSBuffer=y;function D(s,a){return s[a+0]<<0>>>0|s[a+1]<<8>>>0}e.readUInt16LE=D;function w(s,a,m){s[m+0]=a&255,a=a>>>8,s[m+1]=a&255}e.writeUInt16LE=w;function k(s,a){return s[a]*2**24+s[a+1]*2**16+s[a+2]*2**8+s[a+3]}e.readUInt32BE=k;function L(s,a,m){s[m+3]=a,a=a>>>8,s[m+2]=a,a=a>>>8,s[m+1]=a,a=a>>>8,s[m]=a}e.writeUInt32BE=L;function C(s,a){return s[a+0]<<0>>>0|s[a+1]<<8>>>0|s[a+2]<<16>>>0|s[a+3]<<24>>>0}e.readUInt32LE=C;function E(s,a,m){s[m+0]=a&255,a=a>>>8,s[m+1]=a&255,a=a>>>8,s[m+2]=a&255,a=a>>>8,s[m+3]=a&255}e.writeUInt32LE=E;function T(s,a){return s[a]}e.readUInt8=T;function S(s,a,m){s[m]=a}e.writeUInt8=S;function p(s){return l.consumeReadable(s,a=>y.concat(a))}e.readableToBuffer=p;function b(s){return l.toReadable(s)}e.bufferToReadable=b;function f(s){return l.consumeStream(s,a=>y.concat(a))}e.streamToBuffer=f;async function v(s){return s.ended?y.concat(s.buffer):y.concat([...s.buffer,await f(s.stream)])}e.bufferedStreamToBuffer=v;function h(s){return l.toStream(s,a=>y.concat(a))}e.bufferToStream=h;function c(s){return l.transform(s,{data:a=>typeof a=="string"?y.fromString(a):y.wrap(a)},a=>y.concat(a))}e.streamToBufferReadableStream=c;function g(s){return l.newWriteableStream(a=>y.concat(a),s)}e.newWriteableBufferStream=g;function i(s,a){return l.prefixedReadable(s,a,m=>y.concat(m))}e.prefixedBufferReadable=i;function u(s,a){return l.prefixedStream(s,a,m=>y.concat(m))}e.prefixedBufferStream=u;function r(s){let a=0,m=0,_=0;const R=new Uint8Array(Math.floor(s.length/4*3)),M=A=>{switch(m){case 3:R[_++]=a|A,m=0;break;case 2:R[_++]=a|A>>>2,a=A<<6,m=3;break;case 1:R[_++]=a|A>>>4,a=A<<4,m=2;break;default:a=A<<2,m=1}};for(let A=0;A<s.length;A++){const z=s.charCodeAt(A);if(z>=65&&z<=90)M(z-65);else if(z>=97&&z<=122)M(z-97+26);else if(z>=48&&z<=57)M(z-48+52);else if(z===43||z===45)M(62);else if(z===47||z===95)M(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${s[A]}`)}}const U=_;for(;m>0;)M(0);return y.wrap(R).slice(0,U)}e.decodeBase64=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:s},a=!0,m=!1){const _=m?o:n;let R="";const M=s.byteLength%3;let U=0;for(;U<s.byteLength-M;U+=3){const A=s[U+0],z=s[U+1],$=s[U+2];R+=_[A>>>2],R+=_[(A<<4|z>>>4)&63],R+=_[(z<<2|$>>>6)&63],R+=_[$&63]}if(M===1){const A=s[U+0];R+=_[A>>>2],R+=_[A<<4&63],a&&(R+="==")}else if(M===2){const A=s[U+0],z=s[U+1];R+=_[A>>>2],R+=_[(A<<4|z>>>4)&63],R+=_[z<<2&63],a&&(R+="=")}return R}e.encodeBase64=d}),define(Ce[13],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function l(u){return typeof u=="string"}e.isString=l;function t(u){return Array.isArray(u)&&u.every(r=>l(r))}e.isStringArray=t;function I(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=I;function P(u){const r=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof r}e.isTypedArray=P;function y(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=y;function D(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=D;function w(u){return u===!0||u===!1}e.isBoolean=w;function k(u){return typeof u>"u"}e.isUndefined=k;function L(u){return!C(u)}e.isDefined=L;function C(u){return k(u)||u===null}e.isUndefinedOrNull=C;function E(u,r){if(!u)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=E;function T(u){if(C(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=T;function S(...u){const r=[];for(let n=0;n<u.length;n++){const o=u[n];if(C(o))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);r.push(o)}return r}e.assertAllDefined=S;const p=Object.prototype.hasOwnProperty;function b(u){if(!I(u))return!1;for(const r in u)if(p.call(u,r))return!1;return!0}e.isEmptyObject=b;function f(u){return typeof u=="function"}e.isFunction=f;function v(...u){return u.length>0&&u.every(f)}e.areFunctions=v;function h(u,r){const n=Math.min(u.length,r.length);for(let o=0;o<n;o++)c(u[o],r[o])}e.validateConstraints=h;function c(u,r){if(l(r)){if(typeof u!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(f(r)){try{if(u instanceof r)return}catch{}if(!C(u)&&u.constructor===r||r.length===1&&r.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function g(u){return u===null?void 0:u}e.withNullAsUndefined=g;function i(u){return typeof u>"u"?null:u}e.withUndefinedAsNull=i}),define(Ce[24],De([1,0,13]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const v=Array.isArray(f)?[]:{};return Object.keys(f).forEach(h=>{f[h]&&typeof f[h]=="object"?v[h]=t(f[h]):v[h]=f[h]}),v}e.deepClone=t;function I(f){if(!f||typeof f!="object")return f;const v=[f];for(;v.length>0;){const h=v.shift();Object.freeze(h);for(const c in h)if(P.call(h,c)){const g=h[c];typeof g=="object"&&!Object.isFrozen(g)&&!(0,l.isTypedArray)(g)&&v.push(g)}}return f}e.deepFreeze=I;const P=Object.prototype.hasOwnProperty;function y(f,v){return D(f,v,new Set)}e.cloneAndChange=y;function D(f,v,h){if((0,l.isUndefinedOrNull)(f))return f;const c=v(f);if(typeof c<"u")return c;if(Array.isArray(f)){const g=[];for(const i of f)g.push(D(i,v,h));return g}if((0,l.isObject)(f)){if(h.has(f))throw new Error("Cannot clone recursive data-structure");h.add(f);const g={};for(const i in f)P.call(f,i)&&(g[i]=D(f[i],v,h));return h.delete(f),g}return f}function w(f,v,h=!0){return(0,l.isObject)(f)?((0,l.isObject)(v)&&Object.keys(v).forEach(c=>{c in f?h&&((0,l.isObject)(f[c])&&(0,l.isObject)(v[c])?w(f[c],v[c],h):f[c]=v[c]):f[c]=v[c]}),f):v}e.mixin=w;function k(f,v){if(f===v)return!0;if(f==null||v===null||v===void 0||typeof f!=typeof v||typeof f!="object"||Array.isArray(f)!==Array.isArray(v))return!1;let h,c;if(Array.isArray(f)){if(f.length!==v.length)return!1;for(h=0;h<f.length;h++)if(!k(f[h],v[h]))return!1}else{const g=[];for(c in f)g.push(c);g.sort();const i=[];for(c in v)i.push(c);if(i.sort(),!k(g,i))return!1;for(h=0;h<g.length;h++)if(!k(f[g[h]],v[g[h]]))return!1}return!0}e.equals=k;function L(f){const v=new Set;return JSON.stringify(f,(h,c)=>{if((0,l.isObject)(c)||Array.isArray(c)){if(v.has(c))return"[Circular]";v.add(c)}return c})}e.safeStringify=L;function C(f,v){const h=Object.create(null);return!f||!v||Object.keys(v).forEach(g=>{const i=f[g],u=v[g];k(i,u)||(h[g]=u)}),h}e.distinct=C;function E(f,v){const h=v.toLowerCase(),c=Object.keys(f).find(g=>g.toLowerCase()===h);return c?f[c]:f[v]}e.getCaseInsensitive=E;function T(f,v){const h=Object.create(null);for(const[c,g]of Object.entries(f))v(c,g)&&(h[c]=g);return h}e.filter=T;function S(f){let v=[],h=Object.getPrototypeOf(f);for(;Object.prototype!==h;)v=v.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return v}e.getAllPropertyNames=S;function p(f){const v=[];for(const h of S(f))typeof f[h]=="function"&&v.push(h);return v}e.getAllMethodNames=p;function b(f,v){const h=g=>function(){const i=Array.prototype.slice.call(arguments,0);return v(g,i)},c={};for(const g of f)c[g]=h(g);return c}e.createProxyObject=b}),define(Ce[99],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var l;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(l=e.Constants||(e.Constants={}));function t(P){return P<0?0:P>255?255:P|0}e.toUint8=t;function I(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=I}),define(Ce[31],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(I){return l.test(I)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(D){for(let w=0;w<D.length;w++)D[w]=Math.floor(Math.random()*256);return D};const P=new Uint8Array(16),y=[];for(let D=0;D<256;D++)y.push(D.toString(16).padStart(2,"0"));return function(){I(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let w=0,k="";return k+=y[P[w++]],k+=y[P[w++]],k+=y[P[w++]],k+=y[P[w++]],k+="-",k+=y[P[w++]],k+=y[P[w++]],k+="-",k+=y[P[w++]],k+=y[P[w++]],k+="-",k+=y[P[w++]],k+=y[P[w++]],k+="-",k+=y[P[w++]],k+=y[P[w++]],k+=y[P[w++]],k+=y[P[w++]],k+=y[P[w++]],k+=y[P[w++]],k}}()}),define(Ce[100],De([1,0,99]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(D){const w=(0,l.toUint8)(D);this._defaultValue=w,this._asciiMap=t._createAsciiMap(w),this._map=new Map}static _createAsciiMap(D){const w=new Uint8Array(256);for(let k=0;k<256;k++)w[k]=D;return w}set(D,w){const k=(0,l.toUint8)(w);D>=0&&D<256?this._asciiMap[D]=k:this._map.set(D,k)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=t;var I;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(I||(I={}));class P{constructor(){this._actual=new t(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=P}),define(Ce[49],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class l{constructor(I,P){this.lineNumber=I,this.column=P}with(I=this.lineNumber,P=this.column){return I===this.lineNumber&&P===this.column?this:new l(I,P)}delta(I=0,P=0){return this.with(this.lineNumber+I,this.column+P)}equals(I){return l.equals(this,I)}static equals(I,P){return!I&&!P?!0:!!I&&!!P&&I.lineNumber===P.lineNumber&&I.column===P.column}isBefore(I){return l.isBefore(this,I)}static isBefore(I,P){return I.lineNumber<P.lineNumber?!0:P.lineNumber<I.lineNumber?!1:I.column<P.column}isBeforeOrEqual(I){return l.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,P){return I.lineNumber<P.lineNumber?!0:P.lineNumber<I.lineNumber?!1:I.column<=P.column}static compare(I,P){const y=I.lineNumber|0,D=P.lineNumber|0;if(y===D){const w=I.column|0,k=P.column|0;return w-k}return y-D}clone(){return new l(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new l(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=l}),define(Ce[35],De([1,0,49]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,y,D,w){P>D||P===D&&y>w?(this.startLineNumber=D,this.startColumn=w,this.endLineNumber=P,this.endColumn=y):(this.startLineNumber=P,this.startColumn=y,this.endLineNumber=D,this.endColumn=w)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<P.startColumn||y.lineNumber===P.endLineNumber&&y.column>P.endColumn)}static strictContainsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<=P.startColumn||y.lineNumber===P.endLineNumber&&y.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<=P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,y){let D,w,k,L;return y.startLineNumber<P.startLineNumber?(D=y.startLineNumber,w=y.startColumn):y.startLineNumber===P.startLineNumber?(D=y.startLineNumber,w=Math.min(y.startColumn,P.startColumn)):(D=P.startLineNumber,w=P.startColumn),y.endLineNumber>P.endLineNumber?(k=y.endLineNumber,L=y.endColumn):y.endLineNumber===P.endLineNumber?(k=y.endLineNumber,L=Math.max(y.endColumn,P.endColumn)):(k=P.endLineNumber,L=P.endColumn),new t(D,w,k,L)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,y){let D=P.startLineNumber,w=P.startColumn,k=P.endLineNumber,L=P.endColumn;const C=y.startLineNumber,E=y.startColumn,T=y.endLineNumber,S=y.endColumn;return D<C?(D=C,w=E):D===C&&(w=Math.max(w,E)),k>T?(k=T,L=S):k===T&&(L=Math.min(L,S)),D>k||D===k&&w>L?null:new t(D,w,k,L)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,y){return!!P&&!!y&&P.startLineNumber===y.startLineNumber&&P.startColumn===y.startColumn&&P.endLineNumber===y.endLineNumber&&P.endColumn===y.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new l.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new l.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,y){return new t(this.startLineNumber,this.startColumn,P,y)}setStartPosition(P,y){return new t(P,y,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(P){return new t(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,y=P){return new t(P.lineNumber,P.column,y.lineNumber,y.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<P.startColumn)}static areIntersecting(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<=y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,y){if(P&&y){const k=P.startLineNumber|0,L=y.startLineNumber|0;if(k===L){const C=P.startColumn|0,E=y.startColumn|0;if(C===E){const T=P.endLineNumber|0,S=y.endLineNumber|0;if(T===S){const p=P.endColumn|0,b=y.endColumn|0;return p-b}return T-S}return C-E}return k-L}return(P?1:0)-(y?1:0)}static compareRangesUsingEnds(P,y){return P.endLineNumber===y.endLineNumber?P.endColumn===y.endColumn?P.startLineNumber===y.startLineNumber?P.startColumn-y.startColumn:P.startLineNumber-y.startLineNumber:P.endColumn-y.endColumn:P.endLineNumber-y.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(Ce[145],De([1,0,49,35]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class P extends t.Range{constructor(D,w,k,L){super(D,w,k,L),this.selectionStartLineNumber=D,this.selectionStartColumn=w,this.positionLineNumber=k,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return P.selectionsEqual(this,D)}static selectionsEqual(D,w){return D.selectionStartLineNumber===w.selectionStartLineNumber&&D.selectionStartColumn===w.selectionStartColumn&&D.positionLineNumber===w.positionLineNumber&&D.positionColumn===w.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,w){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,D,w):new P(D,w,this.startLineNumber,this.startColumn)}getPosition(){return new l.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new l.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(D,w){return this.getDirection()===0?new P(D,w,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,D,w)}static fromPositions(D,w=D){return new P(D.lineNumber,D.column,w.lineNumber,w.column)}static fromRange(D,w){return w===0?new P(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):new P(D.endLineNumber,D.endColumn,D.startLineNumber,D.startColumn)}static liftSelection(D){return new P(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,w){if(D&&!w||!D&&w)return!1;if(!D&&!w)return!0;if(D.length!==w.length)return!1;for(let k=0,L=D.length;k<L;k++)if(!this.selectionsEqual(D[k],w[k]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,w,k,L,C){return C===0?new P(D,w,k,L):new P(k,L,D,w)}}e.Selection=P}),define(Ce[146],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[147],De([1,0,100]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends l.CharacterClassifier{constructor(D){super(0);for(let w=0,k=D.length;w<k;w++)this.set(D.charCodeAt(w),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function P(y){const D={};return w=>(D.hasOwnProperty(w)||(D[w]=y(w)),D[w])}e.getMapForWordSeparators=P(y=>new I(y))}),define(Ce[101],De([1,0,61,6,62]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(C=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)C.indexOf(T)>=0||(E+="\\"+T);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=P();function y(C){let E=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)E=C;else{let T="g";C.ignoreCase&&(T+="i"),C.multiline&&(T+="m"),C.unicode&&(T+="u"),E=new RegExp(C.source,T)}return E.lastIndex=0,E}e.ensureValidWordDefinition=y;const D=new I.LinkedList;D.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function w(C){const E=D.unshift(C);return(0,t.toDisposable)(E)}e.setDefaultGetWordAtTextConfig=w;function k(C,E,T,S,p){if(p||(p=l.Iterable.first(D)),T.length>p.maxLen){let c=C-p.maxLen/2;return c<0?c=0:S+=c,T=T.substring(c,C+p.maxLen/2),k(C,E,T,S,p)}const b=Date.now(),f=C-1-S;let v=-1,h=null;for(let c=1;!(Date.now()-b>=p.timeBudget);c++){const g=f-p.windowSize*c;E.lastIndex=Math.max(0,g);const i=L(E,T,f,v);if(!i&&h||(h=i,g<=0))break;v=g}if(h){const c={word:h[0],startColumn:S+1+h.index,endColumn:S+1+h.index+h[0].length};return E.lastIndex=0,c}return null}e.getWordAtText=k;function L(C,E,T,S){let p;for(;p=C.exec(E);){const b=p.index||0;if(b<=T&&C.lastIndex>=T)return p;if(S>0&&b>S)return null}return null}}),define(Ce[148],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var l;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(l=e.IndentAction||(e.IndentAction={}));class t{constructor(D){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=D.open,this.close=D.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(D.notIn))for(let w=0,k=D.notIn.length;w<k;w++)switch(D.notIn[w]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(D){switch(D){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(D,w){if(D.getTokenCount()===0)return!0;const k=D.findTokenIndexAtOffset(w-2),L=D.getStandardTokenType(k);return this.isOK(L)}_findNeutralCharacterInRange(D,w){for(let k=D;k<=w;k++){const L=String.fromCharCode(k);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class I{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of D)P(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),P(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),P(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),P(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&P(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.AutoClosingPairs=I;function P(y,D,w){y.has(D)?y.get(D).push(w):y.set(D,[w])}}),define(Ce[149],De([1,0,100]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(S,p,b){const f=new Uint8Array(S*p);for(let v=0,h=S*p;v<h;v++)f[v]=b;this._data=f,this.rows=S,this.cols=p}get(S,p){return this._data[S*this.cols+p]}set(S,p,b){this._data[S*this.cols+p]=b}}e.Uint8Matrix=I;class P{constructor(S){let p=0,b=0;for(let v=0,h=S.length;v<h;v++){const[c,g,i]=S[v];g>p&&(p=g),c>b&&(b=c),i>b&&(b=i)}p++,b++;const f=new I(b,p,0);for(let v=0,h=S.length;v<h;v++){const[c,g,i]=S[v];f.set(c,g,i)}this._states=f,this._maxCharCode=p}nextState(S,p){return p<0||p>=this._maxCharCode?0:this._states.get(S,p)}}e.StateMachine=P;let y=null;function D(){return y===null&&(y=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var w;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(w||(w={}));let k=null;function L(){if(k===null){k=new l.CharacterClassifier(0);const T=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<T.length;p++)k.set(T.charCodeAt(p),1);const S=".,;:";for(let p=0;p<S.length;p++)k.set(S.charCodeAt(p),2)}return k}class C{static _createLink(S,p,b,f,v){let h=v-1;do{const c=p.charCodeAt(h);if(S.get(c)!==2)break;h--}while(h>f);if(f>0){const c=p.charCodeAt(f-1),g=p.charCodeAt(h);(c===40&&g===41||c===91&&g===93||c===123&&g===125)&&h--}return{range:{startLineNumber:b,startColumn:f+1,endLineNumber:b,endColumn:h+2},url:p.substring(f,h+1)}}static computeLinks(S,p=D()){const b=L(),f=[];for(let v=1,h=S.getLineCount();v<=h;v++){const c=S.getLineContent(v),g=c.length;let i=0,u=0,r=0,n=1,o=!1,d=!1,s=!1,a=!1;for(;i<g;){let m=!1;const _=c.charCodeAt(i);if(n===13){let R;switch(_){case 40:o=!0,R=0;break;case 41:R=o?0:1;break;case 91:s=!0,d=!0,R=0;break;case 93:s=!1,R=d?0:1;break;case 123:a=!0,R=0;break;case 125:R=a?0:1;break;case 39:R=r===39?1:0;break;case 34:R=r===34?1:0;break;case 96:R=r===96?1:0;break;case 42:R=r===42?1:0;break;case 124:R=r===124?1:0;break;case 32:R=s?0:1;break;default:R=b.get(_)}R===1&&(f.push(C._createLink(b,c,v,u,i)),m=!0)}else if(n===12){let R;_===91?(d=!0,R=0):R=b.get(_),R===1?m=!0:n=13}else n=p.nextState(n,_),n===0&&(m=!0);m&&(n=1,o=!1,d=!1,a=!1,u=i+1,r=_),i++}n===13&&f.push(C._createLink(b,c,v,u,g))}return f}}e.LinkComputer=C;function E(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:C.computeLinks(T)}e.computeLinks=E}),define(Ce[102],De([1,0,24]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var y;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(y=e.EndOfLinePreference||(e.EndOfLinePreference={}));var D;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(D=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var w;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(w=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),this.indentSize=c.tabSize|0,this.insertSpaces=Boolean(c.insertSpaces),this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=Boolean(c.trimAutoWhitespace),this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,l.equals)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class L{constructor(c,g){this._findMatchBrand=void 0,this.range=c,this.matches=g}}e.FindMatch=L;var C;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function E(h){return h&&typeof h.read=="function"}e.isITextSnapshot=E;var T;(function(h){h[h.Left=0]="Left",h[h.Right=1]="Right",h[h.None=2]="None",h[h.LeftOfInjectedText=3]="LeftOfInjectedText",h[h.RightOfInjectedText=4]="RightOfInjectedText"})(T=e.PositionAffinity||(e.PositionAffinity={}));var S;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(S=e.ModelConstants||(e.ModelConstants={}));class p{constructor(c,g,i,u,r,n){this.identifier=c,this.range=g,this.text=i,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=r,this._isTracked=n}}e.ValidAnnotatedEditOperation=p;class b{constructor(c,g,i){this.regex=c,this.wordSeparators=g,this.simpleSearch=i}}e.SearchData=b;class f{constructor(c,g,i){this.reverseEdits=c,this.changes=g,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=f;function v(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}e.shouldSynchronizeModel=v}),define(Ce[150],De([1,0,17,99]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(w){this.values=w,this.prefixSum=new Uint32Array(w.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(w,k){w=(0,t.toUint32)(w);const L=this.values,C=this.prefixSum,E=k.length;return E===0?!1:(this.values=new Uint32Array(L.length+E),this.values.set(L.subarray(0,w),0),this.values.set(L.subarray(w),w+E),this.values.set(k,w),w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(w,k){return w=(0,t.toUint32)(w),k=(0,t.toUint32)(k),this.values[w]===k?!1:(this.values[w]=k,w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),!0)}removeValues(w,k){w=(0,t.toUint32)(w),k=(0,t.toUint32)(k);const L=this.values,C=this.prefixSum;if(w>=L.length)return!1;const E=L.length-w;return k>=E&&(k=E),k===0?!1:(this.values=new Uint32Array(L.length-k),this.values.set(L.subarray(0,w),0),this.values.set(L.subarray(w+k),w),this.prefixSum=new Uint32Array(this.values.length),w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(w){return w<0?0:(w=(0,t.toUint32)(w),this._getPrefixSum(w))}_getPrefixSum(w){if(w<=this.prefixSumValidIndex[0])return this.prefixSum[w];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),w>=this.values.length&&(w=this.values.length-1);for(let L=k;L<=w;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],w),this.prefixSum[w]}getIndexOf(w){w=Math.floor(w),this.getTotalSum();let k=0,L=this.values.length-1,C=0,E=0,T=0;for(;k<=L;)if(C=k+(L-k)/2|0,E=this.prefixSum[C],T=E-this.values[C],w<T)L=C-1;else if(w>=E)k=C+1;else break;return new y(C,w-T)}}e.PrefixSumComputer=I;class P{constructor(w){this._values=w,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(w){return this._ensureValid(),w===0?0:this._prefixSum[w-1]}getIndexOf(w){this._ensureValid();const k=this._indexBySum[w],L=k>0?this._prefixSum[k-1]:0;return new y(k,w-L)}removeValues(w,k){this._values.splice(w,k),this._invalidate(w)}insertValues(w,k){this._values=(0,l.arrayInsert)(this._values,w,k),this._invalidate(w)}_invalidate(w){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,w-1)}_ensureValid(){if(!this._isValid){for(let w=this._validEndIndex+1,k=this._values.length;w<k;w++){const L=this._values[w],C=w>0?this._prefixSum[w-1]:0;this._prefixSum[w]=C+L;for(let E=0;E<L;E++)this._indexBySum[C+E]=w}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(w,k){this._values[w]!==k&&(this._values[w]=k,this._invalidate(w))}}e.ConstantTimePrefixSumComputer=P;class y{constructor(w,k){this.index=w,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=w,this.remainder=k}}e.PrefixSumIndexOfResult=y}),define(Ce[151],De([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(Ce[152],De([1,0,151]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,P=I*24,y=P*7,D=P*30,w=P*365;function k(C,E,T){typeof C!="number"&&(C=C.getTime());const S=Math.round((new Date().getTime()-C)/1e3);if(S<-30)return(0,l.localize)(0,null,k(new Date().getTime()+S*1e3,!1));if(S<30)return(0,l.localize)(1,null);let p;return S<t?(p=S,E?p===1?T?(0,l.localize)(2,null,p):(0,l.localize)(3,null,p):T?(0,l.localize)(4,null,p):(0,l.localize)(5,null,p):p===1?T?(0,l.localize)(6,null,p):(0,l.localize)(7,null,p):T?(0,l.localize)(8,null,p):(0,l.localize)(9,null,p)):S<I?(p=Math.floor(S/t),E?p===1?T?(0,l.localize)(10,null,p):(0,l.localize)(11,null,p):T?(0,l.localize)(12,null,p):(0,l.localize)(13,null,p):p===1?T?(0,l.localize)(14,null,p):(0,l.localize)(15,null,p):T?(0,l.localize)(16,null,p):(0,l.localize)(17,null,p)):S<P?(p=Math.floor(S/I),E?p===1?T?(0,l.localize)(18,null,p):(0,l.localize)(19,null,p):T?(0,l.localize)(20,null,p):(0,l.localize)(21,null,p):p===1?T?(0,l.localize)(22,null,p):(0,l.localize)(23,null,p):T?(0,l.localize)(24,null,p):(0,l.localize)(25,null,p)):S<y?(p=Math.floor(S/P),E?p===1?(0,l.localize)(26,null,p):(0,l.localize)(27,null,p):p===1?(0,l.localize)(28,null,p):(0,l.localize)(29,null,p)):S<D?(p=Math.floor(S/y),E?p===1?T?(0,l.localize)(30,null,p):(0,l.localize)(31,null,p):T?(0,l.localize)(32,null,p):(0,l.localize)(33,null,p):p===1?T?(0,l.localize)(34,null,p):(0,l.localize)(35,null,p):T?(0,l.localize)(36,null,p):(0,l.localize)(37,null,p)):S<w?(p=Math.floor(S/D),E?p===1?T?(0,l.localize)(38,null,p):(0,l.localize)(39,null,p):T?(0,l.localize)(40,null,p):(0,l.localize)(41,null,p):p===1?T?(0,l.localize)(42,null,p):(0,l.localize)(43,null,p):T?(0,l.localize)(44,null,p):(0,l.localize)(45,null,p)):(p=Math.floor(S/w),E?p===1?T?(0,l.localize)(46,null,p):(0,l.localize)(47,null,p):T?(0,l.localize)(48,null,p):(0,l.localize)(49,null,p):p===1?T?(0,l.localize)(50,null,p):(0,l.localize)(51,null,p):T?(0,l.localize)(52,null,p):(0,l.localize)(53,null,p))}e.fromNow=k;function L(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(Ce[153],De([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(Ce[50],De([1,0,17,13,153]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(C,E){return E&&(C.stack||C.stacktrace)?I.localize(0,null,D(C),y(C.stack)||y(C.stacktrace)):D(C)}function y(C){return Array.isArray(C)?C.join(`
`):C}function D(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?I.localize(1,null,C.message):C.message||I.localize(2,null)}function w(C=null,E=!1){if(!C)return I.localize(3,null);if(Array.isArray(C)){const T=l.coalesce(C),S=w(T[0],E);return T.length>1?I.localize(4,null,S,T.length):S}if(t.isString(C))return C;if(C.detail){const T=C.detail;if(T.error)return P(T.error,E);if(T.exception)return P(T.exception,E)}return C.stack?P(C,E):C.message?C.message:I.localize(5,null)}e.toErrorMessage=w;function k(C){const E=C;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=k;function L(C,E){let T;return typeof C=="string"?T=new Error(C):T=C,T.actions=E,T}e.createErrorWithActions=L}),define(Ce[154],De([19,20]),function(J,e){return J.create("vs/base/common/platform",e)}),define(Ce[10],De([1,0,154]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,I=!1,P=!1,y=!1,D=!1,w=!1,k=!1,L=!1,C=!1,E=!1,T,S=e.LANGUAGE_DEFAULT,p,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?f=e.globals.vscode.process:typeof process<"u"&&(f=process);const v=typeof f?.versions?.electron=="string",h=v&&f?.type==="renderer";if(typeof navigator=="object"&&!h)b=navigator.userAgent,t=b.indexOf("Windows")>=0,I=b.indexOf("Macintosh")>=0,L=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=b.indexOf("Linux")>=0,E=b?.indexOf("Mobi")>=0,w=!0,T=l.getConfiguredDefaultLocale(l.localize(0,null))||e.LANGUAGE_DEFAULT,S=T;else if(typeof f=="object"){t=f.platform==="win32",I=f.platform==="darwin",P=f.platform==="linux",y=P&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,k=v,C=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,T=e.LANGUAGE_DEFAULT,S=e.LANGUAGE_DEFAULT;const s=f.env.VSCODE_NLS_CONFIG;if(s)try{const a=JSON.parse(s),m=a.availableLanguages["*"];T=a.locale,S=m||e.LANGUAGE_DEFAULT,p=a._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var c;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(c=e.Platform||(e.Platform={}));function g(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let i=0;I?i=1:t?i=3:P&&(i=2),e.isWindows=t,e.isMacintosh=I,e.isLinux=P,e.isLinuxSnap=y,e.isNative=D,e.isElectron=k,e.isWeb=w,e.isWebWorker=w&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=E,e.isCI=C,e.platform=i,e.userAgent=b,e.language=S;var u;(function(s){function a(){return e.language}s.value=a;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=m;function _(){return e.language==="en"}s.isDefault=_})(u=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let _=0,R=s.length;_<R;_++){const M=s[_];if(M.id===m.data.vscodeScheduleAsyncWork){s.splice(_,1),M.callback();return}}});let a=0;return m=>{const _=++a;s.push({id:_,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:_},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||L?2:t?1:3;let n=!0,o=!1;function d(){if(!o){o=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,n=new Uint16Array(s.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=d,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Ce[36],De([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof l.globals.vscode<"u"&&typeof l.globals.vscode.process<"u"){const I=l.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return l.isWindows?"win32":l.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Ce[9],De([1,0,36]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,P=90,y=122,D=46,w=47,k=92,L=58,C=63;class E extends Error{constructor(c,g,i){let u;typeof g=="string"&&g.indexOf("not ")===0?(u="must not be",g=g.replace(/^not /,"")):u="must be";const r=c.indexOf(".")!==-1?"property":"argument";let n=`The "${c}" ${r} ${u} of type ${g}`;n+=`. Received type ${typeof i}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function T(h,c){if(typeof h!="string")throw new E(c,"string",h)}function S(h){return h===w||h===k}function p(h){return h===w}function b(h){return h>=t&&h<=P||h>=I&&h<=y}function f(h,c,g,i){let u="",r=0,n=-1,o=0,d=0;for(let s=0;s<=h.length;++s){if(s<h.length)d=h.charCodeAt(s);else{if(i(d))break;d=w}if(i(d)){if(!(n===s-1||o===1))if(o===2){if(u.length<2||r!==2||u.charCodeAt(u.length-1)!==D||u.charCodeAt(u.length-2)!==D){if(u.length>2){const a=u.lastIndexOf(g);a===-1?(u="",r=0):(u=u.slice(0,a),r=u.length-1-u.lastIndexOf(g)),n=s,o=0;continue}else if(u.length!==0){u="",r=0,n=s,o=0;continue}}c&&(u+=u.length>0?`${g}..`:"..",r=2)}else u.length>0?u+=`${g}${h.slice(n+1,s)}`:u=h.slice(n+1,s),r=s-n-1;n=s,o=0}else d===D&&o!==-1?++o:o=-1}return u}function v(h,c){if(c===null||typeof c!="object")throw new E("pathObject","Object",c);const g=c.dir||c.root,i=c.base||`${c.name||""}${c.ext||""}`;return g?g===c.root?`${g}${i}`:`${g}${h}${i}`:i}e.win32={resolve(...h){let c="",g="",i=!1;for(let u=h.length-1;u>=-1;u--){let r;if(u>=0){if(r=h[u],T(r,"path"),r.length===0)continue}else c.length===0?r=l.cwd():(r=l.env[`=${c}`]||l.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==c.toLowerCase()&&r.charCodeAt(2)===k)&&(r=`${c}\\`));const n=r.length;let o=0,d="",s=!1;const a=r.charCodeAt(0);if(n===1)S(a)&&(o=1,s=!0);else if(S(a))if(s=!0,S(r.charCodeAt(1))){let m=2,_=m;for(;m<n&&!S(r.charCodeAt(m));)m++;if(m<n&&m!==_){const R=r.slice(_,m);for(_=m;m<n&&S(r.charCodeAt(m));)m++;if(m<n&&m!==_){for(_=m;m<n&&!S(r.charCodeAt(m));)m++;(m===n||m!==_)&&(d=`\\\\${R}\\${r.slice(_,m)}`,o=m)}}}else o=1;else b(a)&&r.charCodeAt(1)===L&&(d=r.slice(0,2),o=2,n>2&&S(r.charCodeAt(2))&&(s=!0,o=3));if(d.length>0)if(c.length>0){if(d.toLowerCase()!==c.toLowerCase())continue}else c=d;if(i){if(c.length>0)break}else if(g=`${r.slice(o)}\\${g}`,i=s,s&&c.length>0)break}return g=f(g,!i,"\\",S),i?`${c}\\${g}`:`${c}${g}`||"."},normalize(h){T(h,"path");const c=h.length;if(c===0)return".";let g=0,i,u=!1;const r=h.charCodeAt(0);if(c===1)return p(r)?"\\":h;if(S(r))if(u=!0,S(h.charCodeAt(1))){let o=2,d=o;for(;o<c&&!S(h.charCodeAt(o));)o++;if(o<c&&o!==d){const s=h.slice(d,o);for(d=o;o<c&&S(h.charCodeAt(o));)o++;if(o<c&&o!==d){for(d=o;o<c&&!S(h.charCodeAt(o));)o++;if(o===c)return`\\\\${s}\\${h.slice(d)}\\`;o!==d&&(i=`\\\\${s}\\${h.slice(d,o)}`,g=o)}}}else g=1;else b(r)&&h.charCodeAt(1)===L&&(i=h.slice(0,2),g=2,c>2&&S(h.charCodeAt(2))&&(u=!0,g=3));let n=g<c?f(h.slice(g),!u,"\\",S):"";return n.length===0&&!u&&(n="."),n.length>0&&S(h.charCodeAt(c-1))&&(n+="\\"),i===void 0?u?`\\${n}`:n:u?`${i}\\${n}`:`${i}${n}`},isAbsolute(h){T(h,"path");const c=h.length;if(c===0)return!1;const g=h.charCodeAt(0);return S(g)||c>2&&b(g)&&h.charCodeAt(1)===L&&S(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let c,g;for(let r=0;r<h.length;++r){const n=h[r];T(n,"path"),n.length>0&&(c===void 0?c=g=n:c+=`\\${n}`)}if(c===void 0)return".";let i=!0,u=0;if(typeof g=="string"&&S(g.charCodeAt(0))){++u;const r=g.length;r>1&&S(g.charCodeAt(1))&&(++u,r>2&&(S(g.charCodeAt(2))?++u:i=!1))}if(i){for(;u<c.length&&S(c.charCodeAt(u));)u++;u>=2&&(c=`\\${c.slice(u)}`)}return e.win32.normalize(c)},relative(h,c){if(T(h,"from"),T(c,"to"),h===c)return"";const g=e.win32.resolve(h),i=e.win32.resolve(c);if(g===i||(h=g.toLowerCase(),c=i.toLowerCase(),h===c))return"";let u=0;for(;u<h.length&&h.charCodeAt(u)===k;)u++;let r=h.length;for(;r-1>u&&h.charCodeAt(r-1)===k;)r--;const n=r-u;let o=0;for(;o<c.length&&c.charCodeAt(o)===k;)o++;let d=c.length;for(;d-1>o&&c.charCodeAt(d-1)===k;)d--;const s=d-o,a=n<s?n:s;let m=-1,_=0;for(;_<a;_++){const M=h.charCodeAt(u+_);if(M!==c.charCodeAt(o+_))break;M===k&&(m=_)}if(_!==a){if(m===-1)return i}else{if(s>a){if(c.charCodeAt(o+_)===k)return i.slice(o+_+1);if(_===2)return i.slice(o+_)}n>a&&(h.charCodeAt(u+_)===k?m=_:_===2&&(m=3)),m===-1&&(m=0)}let R="";for(_=u+m+1;_<=r;++_)(_===r||h.charCodeAt(_)===k)&&(R+=R.length===0?"..":"\\..");return o+=m,R.length>0?`${R}${i.slice(o,d)}`:(i.charCodeAt(o)===k&&++o,i.slice(o,d))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const c=e.win32.resolve(h);if(c.length<=2)return h;if(c.charCodeAt(0)===k){if(c.charCodeAt(1)===k){const g=c.charCodeAt(2);if(g!==C&&g!==D)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(b(c.charCodeAt(0))&&c.charCodeAt(1)===L&&c.charCodeAt(2)===k)return`\\\\?\\${c}`;return h},dirname(h){T(h,"path");const c=h.length;if(c===0)return".";let g=-1,i=0;const u=h.charCodeAt(0);if(c===1)return S(u)?h:".";if(S(u)){if(g=i=1,S(h.charCodeAt(1))){let o=2,d=o;for(;o<c&&!S(h.charCodeAt(o));)o++;if(o<c&&o!==d){for(d=o;o<c&&S(h.charCodeAt(o));)o++;if(o<c&&o!==d){for(d=o;o<c&&!S(h.charCodeAt(o));)o++;if(o===c)return h;o!==d&&(g=i=o+1)}}}}else b(u)&&h.charCodeAt(1)===L&&(g=c>2&&S(h.charCodeAt(2))?3:2,i=g);let r=-1,n=!0;for(let o=c-1;o>=i;--o)if(S(h.charCodeAt(o))){if(!n){r=o;break}}else n=!1;if(r===-1){if(g===-1)return".";r=g}return h.slice(0,r)},basename(h,c){c!==void 0&&T(c,"ext"),T(h,"path");let g=0,i=-1,u=!0,r;if(h.length>=2&&b(h.charCodeAt(0))&&h.charCodeAt(1)===L&&(g=2),c!==void 0&&c.length>0&&c.length<=h.length){if(c===h)return"";let n=c.length-1,o=-1;for(r=h.length-1;r>=g;--r){const d=h.charCodeAt(r);if(S(d)){if(!u){g=r+1;break}}else o===-1&&(u=!1,o=r+1),n>=0&&(d===c.charCodeAt(n)?--n===-1&&(i=r):(n=-1,i=o))}return g===i?i=o:i===-1&&(i=h.length),h.slice(g,i)}for(r=h.length-1;r>=g;--r)if(S(h.charCodeAt(r))){if(!u){g=r+1;break}}else i===-1&&(u=!1,i=r+1);return i===-1?"":h.slice(g,i)},extname(h){T(h,"path");let c=0,g=-1,i=0,u=-1,r=!0,n=0;h.length>=2&&h.charCodeAt(1)===L&&b(h.charCodeAt(0))&&(c=i=2);for(let o=h.length-1;o>=c;--o){const d=h.charCodeAt(o);if(S(d)){if(!r){i=o+1;break}continue}u===-1&&(r=!1,u=o+1),d===D?g===-1?g=o:n!==1&&(n=1):g!==-1&&(n=-1)}return g===-1||u===-1||n===0||n===1&&g===u-1&&g===i+1?"":h.slice(g,u)},format:v.bind(null,"\\"),parse(h){T(h,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return c;const g=h.length;let i=0,u=h.charCodeAt(0);if(g===1)return S(u)?(c.root=c.dir=h,c):(c.base=c.name=h,c);if(S(u)){if(i=1,S(h.charCodeAt(1))){let m=2,_=m;for(;m<g&&!S(h.charCodeAt(m));)m++;if(m<g&&m!==_){for(_=m;m<g&&S(h.charCodeAt(m));)m++;if(m<g&&m!==_){for(_=m;m<g&&!S(h.charCodeAt(m));)m++;m===g?i=m:m!==_&&(i=m+1)}}}}else if(b(u)&&h.charCodeAt(1)===L){if(g<=2)return c.root=c.dir=h,c;if(i=2,S(h.charCodeAt(2))){if(g===3)return c.root=c.dir=h,c;i=3}}i>0&&(c.root=h.slice(0,i));let r=-1,n=i,o=-1,d=!0,s=h.length-1,a=0;for(;s>=i;--s){if(u=h.charCodeAt(s),S(u)){if(!d){n=s+1;break}continue}o===-1&&(d=!1,o=s+1),u===D?r===-1?r=s:a!==1&&(a=1):r!==-1&&(a=-1)}return o!==-1&&(r===-1||a===0||a===1&&r===o-1&&r===n+1?c.base=c.name=h.slice(n,o):(c.name=h.slice(n,r),c.base=h.slice(n,o),c.ext=h.slice(r,o))),n>0&&n!==i?c.dir=h.slice(0,n-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let c="",g=!1;for(let i=h.length-1;i>=-1&&!g;i--){const u=i>=0?h[i]:l.cwd();T(u,"path"),u.length!==0&&(c=`${u}/${c}`,g=u.charCodeAt(0)===w)}return c=f(c,!g,"/",p),g?`/${c}`:c.length>0?c:"."},normalize(h){if(T(h,"path"),h.length===0)return".";const c=h.charCodeAt(0)===w,g=h.charCodeAt(h.length-1)===w;return h=f(h,!c,"/",p),h.length===0?c?"/":g?"./":".":(g&&(h+="/"),c?`/${h}`:h)},isAbsolute(h){return T(h,"path"),h.length>0&&h.charCodeAt(0)===w},join(...h){if(h.length===0)return".";let c;for(let g=0;g<h.length;++g){const i=h[g];T(i,"path"),i.length>0&&(c===void 0?c=i:c+=`/${i}`)}return c===void 0?".":e.posix.normalize(c)},relative(h,c){if(T(h,"from"),T(c,"to"),h===c||(h=e.posix.resolve(h),c=e.posix.resolve(c),h===c))return"";const g=1,i=h.length,u=i-g,r=1,n=c.length-r,o=u<n?u:n;let d=-1,s=0;for(;s<o;s++){const m=h.charCodeAt(g+s);if(m!==c.charCodeAt(r+s))break;m===w&&(d=s)}if(s===o)if(n>o){if(c.charCodeAt(r+s)===w)return c.slice(r+s+1);if(s===0)return c.slice(r+s)}else u>o&&(h.charCodeAt(g+s)===w?d=s:s===0&&(d=0));let a="";for(s=g+d+1;s<=i;++s)(s===i||h.charCodeAt(s)===w)&&(a+=a.length===0?"..":"/..");return`${a}${c.slice(r+d)}`},toNamespacedPath(h){return h},dirname(h){if(T(h,"path"),h.length===0)return".";const c=h.charCodeAt(0)===w;let g=-1,i=!0;for(let u=h.length-1;u>=1;--u)if(h.charCodeAt(u)===w){if(!i){g=u;break}}else i=!1;return g===-1?c?"/":".":c&&g===1?"//":h.slice(0,g)},basename(h,c){c!==void 0&&T(c,"ext"),T(h,"path");let g=0,i=-1,u=!0,r;if(c!==void 0&&c.length>0&&c.length<=h.length){if(c===h)return"";let n=c.length-1,o=-1;for(r=h.length-1;r>=0;--r){const d=h.charCodeAt(r);if(d===w){if(!u){g=r+1;break}}else o===-1&&(u=!1,o=r+1),n>=0&&(d===c.charCodeAt(n)?--n===-1&&(i=r):(n=-1,i=o))}return g===i?i=o:i===-1&&(i=h.length),h.slice(g,i)}for(r=h.length-1;r>=0;--r)if(h.charCodeAt(r)===w){if(!u){g=r+1;break}}else i===-1&&(u=!1,i=r+1);return i===-1?"":h.slice(g,i)},extname(h){T(h,"path");let c=-1,g=0,i=-1,u=!0,r=0;for(let n=h.length-1;n>=0;--n){const o=h.charCodeAt(n);if(o===w){if(!u){g=n+1;break}continue}i===-1&&(u=!1,i=n+1),o===D?c===-1?c=n:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||i===-1||r===0||r===1&&c===i-1&&c===g+1?"":h.slice(c,i)},format:v.bind(null,"/"),parse(h){T(h,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return c;const g=h.charCodeAt(0)===w;let i;g?(c.root="/",i=1):i=0;let u=-1,r=0,n=-1,o=!0,d=h.length-1,s=0;for(;d>=i;--d){const a=h.charCodeAt(d);if(a===w){if(!o){r=d+1;break}continue}n===-1&&(o=!1,n=d+1),a===D?u===-1?u=d:s!==1&&(s=1):u!==-1&&(s=-1)}if(n!==-1){const a=r===0&&g?1:r;u===-1||s===0||s===1&&u===n-1&&u===r+1?c.base=c.name=h.slice(a,n):(c.name=h.slice(a,u),c.base=h.slice(a,n),c.ext=h.slice(u,n))}return r>0?c.dir=h.slice(0,r-1):g&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=l.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=l.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=l.platform==="win32"?e.win32.join:e.posix.join,e.resolve=l.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=l.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=l.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=l.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=l.platform==="win32"?e.win32.extname:e.posix.extname,e.format=l.platform==="win32"?e.win32.format:e.posix.format,e.parse=l.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=l.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=l.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=l.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Ce[103],De([1,0,9]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(L){const C=(0,l.extname)(L),E=t[C.toLowerCase()];return E!==void 0?E:y(L)}e.getMediaOrTextMime=P;function y(L){const C=(0,l.extname)(L);return I[C.toLowerCase()]}e.getMediaMime=y;function D(L){for(const C in I)if(I[C]===L)return C}e.getExtensionForMimeType=D;const w=/^(.+)\/(.+?)(;.+)?$/;function k(L,C){const E=w.exec(L);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:C?void 0:L}e.normalizeMimeType=k}),define(Ce[104],De([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var I;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(D,...w){const k=w.reduce((E,T)=>(E[T]=!0,E),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(E=>!k[E]).forEach(E=>{for(let T=0;T<L.length;T++)if(E.search(L[T])!==-1){delete D[E];break}})}e.sanitizeProcessEnvironment=P;function y(D){!D||(delete D.DEBUG,l.isMacintosh&&delete D.DYLD_LIBRARY_PATH,l.isLinux&&delete D.LD_PRELOAD)}e.removeDangerousEnvVariables=y}),define(Ce[51],De([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=l.globals.performance&&typeof l.globals.performance.now=="function";class I{static create(y=!0){return new I(y)}constructor(y){this._highResolution=t&&y,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?l.globals.performance.now():Date.now()}}e.StopWatch=I}),define(Ce[4],De([1,0,11,60,6,62,51]),function(J,e,l,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const D=!1,w=!1;var k;(function(d){d.None=()=>I.Disposable.None;function s(me){if(w){const{onListenerDidAdd:be}=me,ke=S.create();let Re=0;me.onListenerDidAdd=()=>{++Re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ke.print()),be?.()}}}function a(me){return(be,ke=null,Re)=>{let ze=!1,oe;return oe=me(le=>{if(!ze)return oe?oe.dispose():ze=!0,be.call(ke,le)},null,Re),ze&&oe.dispose(),oe}}d.once=a;function m(me,be,ke){return z((Re,ze=null,oe)=>me(le=>Re.call(ze,be(le)),null,oe),ke)}d.map=m;function _(me,be,ke){return z((Re,ze=null,oe)=>me(le=>{be(le),Re.call(ze,le)},null,oe),ke)}d.forEach=_;function R(me,be,ke){return z((Re,ze=null,oe)=>me(le=>be(le)&&Re.call(ze,le),null,oe),ke)}d.filter=R;function M(me){return me}d.signal=M;function U(...me){return(be,ke=null,Re)=>(0,I.combinedDisposable)(...me.map(ze=>ze(oe=>be.call(ke,oe),null,Re)))}d.any=U;function A(me,be,ke,Re){let ze=ke;return m(me,oe=>(ze=be(ze,oe),ze),Re)}d.reduce=A;function z(me,be){let ke;const Re={onFirstListenerAdd(){ke=me(ze.fire,ze)},onLastListenerRemove(){ke?.dispose()}};be||s(Re);const ze=new b(Re);return be?.add(ze),ze.event}function $(me,be,ke=100,Re=!1,ze,oe){let le,ge,Z,ae=0;const ne={leakWarningThreshold:ze,onFirstListenerAdd(){le=me(O=>{ae++,ge=be(ge,O),Re&&!Z&&(ie.fire(ge),ge=void 0),clearTimeout(Z),Z=setTimeout(()=>{const j=ge;ge=void 0,Z=void 0,(!Re||ae>1)&&ie.fire(j),ae=0},ke)})},onLastListenerRemove(){le.dispose()}};oe||s(ne);const ie=new b(ne);return oe?.add(ie),ie.event}d.debounce=$;function N(me,be=(Re,ze)=>Re===ze,ke){let Re=!0,ze;return R(me,oe=>{const le=Re||!be(oe,ze);return Re=!1,ze=oe,le},ke)}d.latch=N;function V(me,be,ke){return[d.filter(me,be,ke),d.filter(me,Re=>!be(Re),ke)]}d.split=V;function B(me,be=!1,ke=[]){let Re=ke.slice(),ze=me(ge=>{Re?Re.push(ge):le.fire(ge)});const oe=()=>{Re?.forEach(ge=>le.fire(ge)),Re=null},le=new b({onFirstListenerAdd(){ze||(ze=me(ge=>le.fire(ge)))},onFirstListenerDidAdd(){Re&&(be?setTimeout(oe):oe())},onLastListenerRemove(){ze&&ze.dispose(),ze=null}});return le.event}d.buffer=B;class F{constructor(be){this.event=be,this.disposables=new I.DisposableStore}map(be){return new F(m(this.event,be,this.disposables))}forEach(be){return new F(_(this.event,be,this.disposables))}filter(be){return new F(R(this.event,be,this.disposables))}reduce(be,ke){return new F(A(this.event,be,ke,this.disposables))}latch(){return new F(N(this.event,void 0,this.disposables))}debounce(be,ke=100,Re=!1,ze){return new F($(this.event,be,ke,Re,ze,this.disposables))}on(be,ke,Re){return this.event(be,ke,Re)}once(be,ke,Re){return a(this.event)(be,ke,Re)}dispose(){this.disposables.dispose()}}function x(me){return new F(me)}d.chain=x;function H(me,be,ke=Re=>Re){const Re=(...ge)=>le.fire(ke(...ge)),ze=()=>me.on(be,Re),oe=()=>me.removeListener(be,Re),le=new b({onFirstListenerAdd:ze,onLastListenerRemove:oe});return le.event}d.fromNodeEventEmitter=H;function Q(me,be,ke=Re=>Re){const Re=(...ge)=>le.fire(ke(...ge)),ze=()=>me.addEventListener(be,Re),oe=()=>me.removeEventListener(be,Re),le=new b({onFirstListenerAdd:ze,onLastListenerRemove:oe});return le.event}d.fromDOMEventEmitter=Q;function K(me){return new Promise(be=>a(me)(be))}d.toPromise=K;function de(me,be){return be(void 0),me(ke=>be(ke))}d.runAndSubscribe=de;function ee(me,be){let ke=null;function Re(oe){ke?.dispose(),ke=new I.DisposableStore,be(oe,ke)}Re(void 0);const ze=me(oe=>Re(oe));return(0,I.toDisposable)(()=>{ze.dispose(),ke?.dispose()})}d.runAndSubscribeWithStore=ee;class he{constructor(be,ke){this.obs=be,this._counter=0,this._hasChanged=!1;const Re={onFirstListenerAdd:()=>{be.addObserver(this)},onLastListenerRemove:()=>{be.removeObserver(this)}};ke||s(Re),this.emitter=new b(Re),ke&&ke.add(this.emitter)}beginUpdate(be){this._counter++}handleChange(be,ke){this._hasChanged=!0}endUpdate(be){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Y(me,be){return new he(me,be).emitter.event}d.fromObservable=Y})(k=e.Event||(e.Event={}));class L{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${L._idPool++}`,L.all.add(this)}start(s){this._stopWatch=new y.StopWatch(!0),this.listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=L,L.all=new Set,L._idPool=0;let C=-1;function E(d){const s=C;return C=d,{dispose(){C=s}}}e.setGlobalLeakWarningThreshold=E;class T{constructor(s,a=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s,a){let m=C;if(typeof this.customThreshold=="number"&&(m=this.customThreshold),m<=0||a<m)return;this._stacks||(this._stacks=new Map);const _=this._stacks.get(s.value)||0;if(this._stacks.set(s.value,_+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let R,M=0;for(const[U,A]of this._stacks)(!R||M<A)&&(R=U,M=A);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${M}):`),console.warn(R)}return()=>{const R=this._stacks.get(s.value)||0;this._stacks.set(s.value,R-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(s,a,m){this.callback=s,this.callbackThis=a,this.stack=m,this.subscription=new I.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class b{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=C>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new L(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(D){const s=Array.from(this._listeners);queueMicrotask(()=>{for(const a of s)a.subscription.isset()&&(a.subscription.unset(),a.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(s,a,m)=>{this._listeners||(this._listeners=new P.LinkedList);const _=this._listeners.isEmpty();_&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let R,M;this._leakageMon&&this._listeners.size>=30&&(M=S.create(),R=this._leakageMon.check(M,this._listeners.size+1)),D&&(M=M??S.create());const U=new p(s,a,M),A=this._listeners.push(U);_&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,a);const z=U.subscription.set(()=>{R?.(),this._disposed||(A(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return m instanceof I.DisposableStore?m.add(z):Array.isArray(m)&&m.push(z),z}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const a of this._listeners)this._deliveryQueue.push(this,a,s);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=b;class f{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(s,a,m){this._queue.push(new h(s,a,m))}clear(s){const a=new P.LinkedList;for(const m of this._queue)m.emitter!==s&&a.push(m);this._queue=a}deliver(){for(;this._queue.size>0;){const s=this._queue.shift();try{s.listener.invoke(s.event)}catch(a){(0,l.onUnexpectedError)(a)}}}}e.EventDeliveryQueue=f;class v extends f{clear(s){this._queue.clear()}}class h{constructor(s,a,m){this.emitter=s,this.listener=a,this.event=m}}class c extends b{async fireAsync(s,a,m){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const _ of this._listeners)this._asyncDeliveryQueue.push([_,s]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[_,R]=this._asyncDeliveryQueue.shift(),M=[],U={...R,token:a,waitUntil:A=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");m&&(A=m(A,_.callback)),M.push(A)}};try{_.invoke(U)}catch(A){(0,l.onUnexpectedError)(A);continue}Object.freeze(M),await Promise.allSettled(M).then(A=>{for(const z of A)z.status==="rejected"&&(0,l.onUnexpectedError)(z.reason)})}}}}e.AsyncEmitter=c;class g extends b{constructor(s){super(s),this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=g;class i extends g{constructor(s){super(s),this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=i;class u extends b{constructor(s){super(s),this._queuedEvents=[],this._mergeFn=s?.merge}fire(s){!this.hasListeners()||(this._queuedEvents.push(s),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(a=>super.fire(a)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=u;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const a={event:s,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const m=()=>{this.hasListeners&&this.unhook(a);const _=this.events.indexOf(a);this.events.splice(_,1)};return(0,I.toDisposable)((0,t.once)(m))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(a=>this.emitter.fire(a))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class n{constructor(){this.buffers=[]}wrapEvent(s){return(a,m,_)=>s(R=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>a.call(m,R)):a.call(m,R)},void 0,_)}bufferEvents(s){const a=[];this.buffers.push(a);const m=s();return this.buffers.pop(),a.forEach(_=>_()),m}}e.EventBufferer=n;class o{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=I.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(Ce[21],De([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(D,w){const k=setTimeout(D.bind(w),0);return{dispose(){clearTimeout(k)}}});var I;(function(D){function w(k){return k===D.None||k===D.Cancelled||k instanceof P?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}D.isCancellationToken=w,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:l.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new l.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=I.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=y}),define(Ce[155],De([1,0,21]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new l.CancellationTokenSource,w=this.task(D.token);return this.result={promise:w,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=t;class I{constructor(D){this.fn=D,this.lastCache=void 0,this.lastArgKey=void 0}get(D){const w=JSON.stringify(D);return this.lastArgKey!==w&&(this.lastArgKey=w,this.lastCache=this.fn(D)),this.lastCache}}e.LRUCachedFunction=I;class P{get cachedValues(){return this._map}constructor(D){this.fn=D,this._map=new Map}get(D){if(this._map.has(D))return this._map.get(D);const w=this.fn(D);return this._map.set(D,w),w}}e.CachedFunction=P}),define(Ce[156],De([1,0,4,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const I=y=>({onDidChange:l.Event.None,value:y});e.staticObservableValue=I;class P extends t.Disposable{get value(){return this._value}set value(D){D!==this._value&&(this._value=D,this.changeEmitter.fire(D))}constructor(D){super(),this._value=D,this.changeEmitter=this._register(new l.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=P}),define(Ce[8],De([1,0,155,78]),function(J,e,l,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(fe){return!fe||typeof fe!="string"?!0:fe.trim().length===0}e.isFalsyOrWhitespace=P;const y=/{(\d+)}/g;function D(fe,...Ae){return Ae.length===0?fe:fe.replace(y,function(Le,Me){const Ke=parseInt(Me,10);return isNaN(Ke)||Ke<0||Ke>=Ae.length?Le:Ae[Ke]})}e.format=D;const w=/{([^}]+)}/g;function k(fe,Ae){return fe.replace(w,(Le,Me)=>Ae[Me]??Le)}e.format2=k;function L(fe){return fe.replace(/[<>&]/g,function(Ae){switch(Ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ae}})}e.escape=L;function C(fe){return fe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function E(fe,Ae){let Le=0;const Me=Ae.charCodeAt(0);for(let Ke=fe.length-1;Ke>=0;Ke--)fe.charCodeAt(Ke)===Me&&Le++;return Le}e.count=E;function T(fe,Ae,Le="\u2026"){return fe.length<=Ae?fe:`${fe.substr(0,Ae)}${Le}`}e.truncate=T;function S(fe,Ae=" "){const Le=p(fe,Ae);return b(Le,Ae)}e.trim=S;function p(fe,Ae){if(!fe||!Ae)return fe;const Le=Ae.length;if(Le===0||fe.length===0)return fe;let Me=0;for(;fe.indexOf(Ae,Me)===Me;)Me=Me+Le;return fe.substring(Me)}e.ltrim=p;function b(fe,Ae){if(!fe||!Ae)return fe;const Le=Ae.length,Me=fe.length;if(Le===0||Me===0)return fe;let Ke=Me,Je=-1;for(;Je=fe.lastIndexOf(Ae,Ke-1),!(Je===-1||Je+Le!==Ke);){if(Je===0)return"";Ke=Je}return fe.substring(0,Ke)}e.rtrim=b;function f(fe){return fe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function v(fe){return fe.replace(/\*/g,"")}e.stripWildcards=v;function h(fe,Ae,Le={}){if(!fe)throw new Error("Cannot create regex from empty string");Ae||(fe=C(fe)),Le.wholeWord&&(/\B/.test(fe.charAt(0))||(fe="\\b"+fe),/\B/.test(fe.charAt(fe.length-1))||(fe=fe+"\\b"));let Me="";return Le.global&&(Me+="g"),Le.matchCase||(Me+="i"),Le.multiline&&(Me+="m"),Le.unicode&&(Me+="u"),new RegExp(fe,Me)}e.createRegExp=h;function c(fe){return fe.source==="^"||fe.source==="^$"||fe.source==="$"||fe.source==="^\\s*$"?!1:!!(fe.exec("")&&fe.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function g(fe){return!!fe.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function i(fe){return(fe.global?"g":"")+(fe.ignoreCase?"i":"")+(fe.multiline?"m":"")+(fe.unicode?"u":"")}e.regExpFlags=i;function u(fe){return fe.split(/\r\n|\r|\n/)}e.splitLines=u;function r(fe){for(let Ae=0,Le=fe.length;Ae<Le;Ae++){const Me=fe.charCodeAt(Ae);if(Me!==32&&Me!==9)return Ae}return-1}e.firstNonWhitespaceIndex=r;function n(fe,Ae=0,Le=fe.length){for(let Me=Ae;Me<Le;Me++){const Ke=fe.charCodeAt(Me);if(Ke!==32&&Ke!==9)return fe.substring(Ae,Me)}return fe.substring(Ae,Le)}e.getLeadingWhitespace=n;function o(fe,Ae=fe.length-1){for(let Le=Ae;Le>=0;Le--){const Me=fe.charCodeAt(Le);if(Me!==32&&Me!==9)return Le}return-1}e.lastNonWhitespaceIndex=o;function d(fe,Ae,Le){const Me=[];let Ke=0;for(const Je of fe.matchAll(Ae)){if(Me.push(fe.slice(Ke,Je.index)),Je.index===void 0)throw new Error("match.index should be defined");Ke=Je.index+Je[0].length,Me.push(Le(Je[0],...Je.slice(1),Je.index,fe,Je.groups))}return Me.push(fe.slice(Ke)),Promise.all(Me).then(Je=>Je.join(""))}e.replaceAsync=d;function s(fe,Ae){return fe<Ae?-1:fe>Ae?1:0}e.compare=s;function a(fe,Ae,Le=0,Me=fe.length,Ke=0,Je=Ae.length){for(;Le<Me&&Ke<Je;Le++,Ke++){const it=fe.charCodeAt(Le),lt=Ae.charCodeAt(Ke);if(it<lt)return-1;if(it>lt)return 1}const st=Me-Le,ot=Je-Ke;return st<ot?-1:st>ot?1:0}e.compareSubstring=a;function m(fe,Ae){return _(fe,Ae,0,fe.length,0,Ae.length)}e.compareIgnoreCase=m;function _(fe,Ae,Le=0,Me=fe.length,Ke=0,Je=Ae.length){for(;Le<Me&&Ke<Je;Le++,Ke++){let it=fe.charCodeAt(Le),lt=Ae.charCodeAt(Ke);if(it===lt)continue;if(it>=128||lt>=128)return a(fe.toLowerCase(),Ae.toLowerCase(),Le,Me,Ke,Je);M(it)&&(it-=32),M(lt)&&(lt-=32);const vt=it-lt;if(vt!==0)return vt}const st=Me-Le,ot=Je-Ke;return st<ot?-1:st>ot?1:0}e.compareSubstringIgnoreCase=_;function R(fe){return fe>=48&&fe<=57}e.isAsciiDigit=R;function M(fe){return fe>=97&&fe<=122}e.isLowerAsciiLetter=M;function U(fe){return fe>=65&&fe<=90}e.isUpperAsciiLetter=U;function A(fe,Ae){return fe.length===Ae.length&&_(fe,Ae)===0}e.equalsIgnoreCase=A;function z(fe,Ae){const Le=Ae.length;return Ae.length>fe.length?!1:_(fe,Ae,0,Le)===0}e.startsWithIgnoreCase=z;function $(fe,Ae){const Le=Math.min(fe.length,Ae.length);let Me;for(Me=0;Me<Le;Me++)if(fe.charCodeAt(Me)!==Ae.charCodeAt(Me))return Me;return Le}e.commonPrefixLength=$;function N(fe,Ae){const Le=Math.min(fe.length,Ae.length);let Me;const Ke=fe.length-1,Je=Ae.length-1;for(Me=0;Me<Le;Me++)if(fe.charCodeAt(Ke-Me)!==Ae.charCodeAt(Je-Me))return Me;return Le}e.commonSuffixLength=N;function V(fe){return 55296<=fe&&fe<=56319}e.isHighSurrogate=V;function B(fe){return 56320<=fe&&fe<=57343}e.isLowSurrogate=B;function F(fe,Ae){return(fe-55296<<10)+(Ae-56320)+65536}e.computeCodePoint=F;function x(fe,Ae,Le){const Me=fe.charCodeAt(Le);if(V(Me)&&Le+1<Ae){const Ke=fe.charCodeAt(Le+1);if(B(Ke))return F(Me,Ke)}return Me}e.getNextCodePoint=x;function H(fe,Ae){const Le=fe.charCodeAt(Ae-1);if(B(Le)&&Ae>1){const Me=fe.charCodeAt(Ae-2);if(V(Me))return F(Me,Le)}return Le}class Q{get offset(){return this._offset}constructor(Ae,Le=0){this._str=Ae,this._len=Ae.length,this._offset=Le}setOffset(Ae){this._offset=Ae}prevCodePoint(){const Ae=H(this._str,this._offset);return this._offset-=Ae>=65536?2:1,Ae}nextCodePoint(){const Ae=x(this._str,this._len,this._offset);return this._offset+=Ae>=65536?2:1,Ae}eol(){return this._offset>=this._len}}e.CodePointIterator=Q;class K{get offset(){return this._iterator.offset}constructor(Ae,Le=0){this._iterator=new Q(Ae,Le)}nextGraphemeLength(){const Ae=Ze.getInstance(),Le=this._iterator,Me=Le.offset;let Ke=Ae.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const Je=Le.offset,st=Ae.getGraphemeBreakType(Le.nextCodePoint());if(We(Ke,st)){Le.setOffset(Je);break}Ke=st}return Le.offset-Me}prevGraphemeLength(){const Ae=Ze.getInstance(),Le=this._iterator,Me=Le.offset;let Ke=Ae.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const Je=Le.offset,st=Ae.getGraphemeBreakType(Le.prevCodePoint());if(We(st,Ke)){Le.setOffset(Je);break}Ke=st}return Me-Le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function de(fe,Ae){return new K(fe,Ae).nextGraphemeLength()}e.nextCharLength=de;function ee(fe,Ae){return new K(fe,Ae).prevGraphemeLength()}e.prevCharLength=ee;function he(fe,Ae){Ae>0&&B(fe.charCodeAt(Ae))&&Ae--;const Le=Ae+de(fe,Ae);return[Le-ee(fe,Le),Le]}e.getCharContainingOffset=he;function Y(fe){const Ae=new K(fe);let Le=0;for(;!Ae.eol();)Le++,Ae.nextGraphemeLength();return Le}e.charCount=Y;let me;function be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ke(fe){return me||(me=be()),me.test(fe)}e.containsRTL=ke;const Re=/^[\t\n\r\x20-\x7E]*$/;function ze(fe){return Re.test(fe)}e.isBasicASCII=ze,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(fe){return e.UNUSUAL_LINE_TERMINATORS.test(fe)}e.containsUnusualLineTerminators=oe;function le(fe){return fe>=11904&&fe<=55215||fe>=63744&&fe<=64255||fe>=65281&&fe<=65374}e.isFullWidthCharacter=le;function ge(fe){return fe>=127462&&fe<=127487||fe===8986||fe===8987||fe===9200||fe===9203||fe>=9728&&fe<=10175||fe===11088||fe===11093||fe>=127744&&fe<=128591||fe>=128640&&fe<=128764||fe>=128992&&fe<=129008||fe>=129280&&fe<=129535||fe>=129648&&fe<=129782}e.isEmojiImprecise=ge;function Z(fe,Ae){if(fe.length<Ae)return fe;const Le=/\b/g;let Me=0;for(;Le.test(fe)&&!(fe.length-Le.lastIndex<Ae);)Me=Le.lastIndex,Le.lastIndex+=1;return fe.substring(Me).replace(/^\s/,"")}e.lcut=Z;const ae=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function O(fe){return fe&&(fe=fe.replace(ae,""),fe=fe.replace(ne,""),fe=fe.replace(ie,"")),fe}e.removeAnsiEscapeCodes=O,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function j(fe){return!!(fe&&fe.length>0&&fe.charCodeAt(0)===65279)}e.startsWithUTF8BOM=j;function G(fe){return j(fe)?fe.substr(1):fe}e.stripUTF8BOM=G;function X(fe,Ae){if(!fe||!Ae||fe.length<Ae.length)return!1;const Le=Ae.length,Me=fe.toLowerCase();let Ke=0,Je=-1;for(;Ke<Le;){const st=Me.indexOf(Ae[Ke],Je+1);if(st<0)return!1;Je=st,Ke++}return!0}e.fuzzyContains=X;function pe(fe,Ae=!1){return fe?(Ae&&(fe=fe.replace(/\\./g,"")),fe.toLowerCase()!==fe):!1}e.containsUppercaseCharacter=pe;function we(fe){return fe.charAt(0).toUpperCase()+fe.slice(1)}e.uppercaseFirstLetter=we;function ce(fe,Ae=1){if(Ae===0)return"";let Le=-1;do Le=fe.indexOf(`
`,Le+1),Ae--;while(Ae>0&&Le>=0);return Le===-1?fe:(fe[Le-1]==="\r"&&Le--,fe.substr(0,Le))}e.getNLines=ce;function Ie(fe){return fe=fe%(2*26),fe<26?String.fromCharCode(97+fe):String.fromCharCode(65+fe-26)}e.singleLetterHash=Ie;function ye(fe){return Ze.getInstance().getGraphemeBreakType(fe)}e.getGraphemeBreakType=ye;function We(fe,Ae){return fe===0?Ae!==5&&Ae!==7:fe===2&&Ae===3?!1:fe===4||fe===2||fe===3||Ae===4||Ae===2||Ae===3?!0:!(fe===8&&(Ae===8||Ae===9||Ae===11||Ae===12)||(fe===11||fe===9)&&(Ae===9||Ae===10)||(fe===12||fe===10)&&Ae===10||Ae===5||Ae===13||Ae===7||fe===1||fe===13&&Ae===14||fe===6&&Ae===6)}var qe;(function(fe){fe[fe.Other=0]="Other",fe[fe.Prepend=1]="Prepend",fe[fe.CR=2]="CR",fe[fe.LF=3]="LF",fe[fe.Control=4]="Control",fe[fe.Extend=5]="Extend",fe[fe.Regional_Indicator=6]="Regional_Indicator",fe[fe.SpacingMark=7]="SpacingMark",fe[fe.L=8]="L",fe[fe.V=9]="V",fe[fe.T=10]="T",fe[fe.LV=11]="LV",fe[fe.LVT=12]="LVT",fe[fe.ZWJ=13]="ZWJ",fe[fe.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ze{static getInstance(){return Ze._INSTANCE||(Ze._INSTANCE=new Ze),Ze._INSTANCE}constructor(){this._data=Ye()}getGraphemeBreakType(Ae){if(Ae<32)return Ae===10?3:Ae===13?2:4;if(Ae<127)return 0;const Le=this._data,Me=Le.length/3;let Ke=1;for(;Ke<=Me;)if(Ae<Le[3*Ke])Ke=2*Ke;else if(Ae>Le[3*Ke+1])Ke=2*Ke+1;else return Le[3*Ke+2];return 0}}Ze._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(fe,Ae){if(fe===0)return 0;const Le=at(fe,Ae);if(Le!==void 0)return Le;const Me=new Q(Ae,fe);return Me.prevCodePoint(),Me.offset}e.getLeftDeleteOffset=Ne;function at(fe,Ae){const Le=new Q(Ae,fe);let Me=Le.prevCodePoint();for(;re(Me)||Me===65039||Me===8419;){if(Le.offset===0)return;Me=Le.prevCodePoint()}if(!ge(Me))return;let Ke=Le.offset;return Ke>0&&Le.prevCodePoint()===8205&&(Ke=Le.offset),Ke}function re(fe){return 127995<=fe&&fe<=127999}var se;(function(fe){fe[fe.zwj=8205]="zwj",fe[fe.emojiVariantSelector=65039]="emojiVariantSelector",fe[fe.enclosingKeyCap=8419]="enclosingKeyCap"})(se||(se={})),e.noBreakWhitespace="\xA0";class Ee{static getInstance(Ae){return Ee.cache.get(Array.from(Ae))}static getLocales(){return Ee._locales.getValue()}constructor(Ae){this.confusableDictionary=Ae}isAmbiguous(Ae){return this.confusableDictionary.has(Ae)}getPrimaryConfusable(Ae){return this.confusableDictionary.get(Ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ee,I=Ee,Ee.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ee.cache=new l.LRUCachedFunction(fe=>{function Ae(lt){const vt=new Map;for(let wt=0;wt<lt.length;wt+=2)vt.set(lt[wt],lt[wt+1]);return vt}function Le(lt,vt){const wt=new Map(lt);for(const[ft,St]of vt)wt.set(ft,St);return wt}function Me(lt,vt){if(!lt)return vt;const wt=new Map;for(const[ft,St]of lt)vt.has(ft)&&wt.set(ft,St);return wt}const Ke=I.ambiguousCharacterData.getValue();let Je=fe.filter(lt=>!lt.startsWith("_")&&lt in Ke);Je.length===0&&(Je=["_default"]);let st;for(const lt of Je){const vt=Ae(Ke[lt]);st=Me(st,vt)}const ot=Ae(Ke._common),it=Le(ot,st);return new Ee(it)}),Ee._locales=new t.Lazy(()=>Object.keys(Ee.ambiguousCharacterData.getValue()).filter(fe=>!fe.startsWith("_")));class Ve{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ve.getRawData())),this._data}static isInvisibleCharacter(Ae){return Ve.getData().has(Ae)}static get codePoints(){return Ve.getData()}}e.InvisibleCharacters=Ve,Ve._data=void 0}),define(Ce[32],De([1,0,9,10,8,13]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(o){return o===47||o===92}e.isPathSeparator=y;function D(o){return o.replace(/[\\/]/g,l.posix.sep)}e.toSlashes=D;function w(o){return o.indexOf("/")===-1&&(o=D(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=w;function k(o,d=l.posix.sep){if(!o)return"";const s=o.length,a=o.charCodeAt(0);if(y(a)){if(y(o.charCodeAt(1))&&!y(o.charCodeAt(2))){let _=3;const R=_;for(;_<s&&!y(o.charCodeAt(_));_++);if(R!==_&&!y(o.charCodeAt(_+1))){for(_+=1;_<s;_++)if(y(o.charCodeAt(_)))return o.slice(0,_+1).replace(/[\\/]/g,d)}}return d}else if(f(a)&&o.charCodeAt(1)===58)return y(o.charCodeAt(2))?o.slice(0,2)+d:o.slice(0,2);let m=o.indexOf("://");if(m!==-1){for(m+=3;m<s;m++)if(y(o.charCodeAt(m)))return o.slice(0,m+1)}return""}e.getRoot=k;function L(o){if(!t.isWindows||!o||o.length<5)return!1;let d=o.charCodeAt(0);if(d!==92||(d=o.charCodeAt(1),d!==92))return!1;let s=2;const a=s;for(;s<o.length&&(d=o.charCodeAt(s),d!==92);s++);return!(a===s||(d=o.charCodeAt(s+1),isNaN(d)||d===92))}e.isUNC=L;const C=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(o,d=t.isWindows){const s=d?C:E;return!(!o||o.length===0||/^\s+$/.test(o)||(s.lastIndex=0,s.test(o))||d&&T.test(o)||o==="."||o===".."||d&&o[o.length-1]==="."||d&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=S;function p(o,d,s){const a=o===d;return!s||a?a:!o||!d?!1:(0,I.equalsIgnoreCase)(o,d)}e.isEqual=p;function b(o,d,s,a=l.sep){if(o===d)return!0;if(!o||!d||d.length>o.length)return!1;if(s){if(!(0,I.startsWithIgnoreCase)(o,d))return!1;if(d.length===o.length)return!0;let _=d.length;return d.charAt(d.length-1)===a&&_--,o.charAt(_)===a}return d.charAt(d.length-1)!==a&&(d+=a),o.indexOf(d)===0}e.isEqualOrParent=b;function f(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=f;function v(o,d){return t.isWindows&&o.endsWith(":")&&(o+=l.sep),(0,l.isAbsolute)(o)||(o=(0,l.join)(d,o)),o=(0,l.normalize)(o),t.isWindows?(o=(0,I.rtrim)(o,l.sep),o.endsWith(":")&&(o+=l.sep)):(o=(0,I.rtrim)(o,l.sep),o||(o=l.sep)),o}e.sanitizeFilePath=v;function h(o){const d=(0,l.normalize)(o);return t.isWindows?o.length>3?!1:c(d)&&(o.length===2||d.charCodeAt(2)===92):d===l.posix.sep}e.isRootOrDriveLetter=h;function c(o,d=t.isWindows){return d?f(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function g(o){return c(o)?o[0]:void 0}e.getDriveLetter=g;function i(o,d,s){return d.length>o.length?-1:o===d?0:(s&&(o=o.toLowerCase(),d=d.toLowerCase()),o.indexOf(d))}e.indexOfPath=i;function u(o){const d=o.split(":");let s,a,m;for(const _ of d){const R=Number(_);(0,P.isNumber)(R)?a===void 0?a=R:m===void 0&&(m=R):s=s?[s,_].join(":"):_}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:a!==void 0?a:void 0,column:m!==void 0?m:a!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,d,s=8){let a="";for(let _=0;_<s;_++)a+=r.charAt(Math.floor(Math.random()*r.length));let m;return d?m=`${d}-${a}`:m=a,o?(0,l.join)(o,m):m}e.randomPath=n}),define(Ce[79],De([1,0,8]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(f){return I(f,0)}e.hash=t;function I(f,v){switch(typeof f){case"object":return f===null?P(349,v):Array.isArray(f)?w(f,v):k(f,v);case"string":return D(f,v);case"boolean":return y(f,v);case"number":return P(f,v);case"undefined":return P(937,v);default:return P(617,v)}}e.doHash=I;function P(f,v){return(v<<5)-v+f|0}e.numberHash=P;function y(f,v){return P(f?433:863,v)}function D(f,v){v=P(149417,v);for(let h=0,c=f.length;h<c;h++)v=P(f.charCodeAt(h),v);return v}e.stringHash=D;function w(f,v){return v=P(104579,v),f.reduce((h,c)=>I(c,h),v)}function k(f,v){return v=P(181387,v),Object.keys(f).sort().reduce((h,c)=>(h=D(c,h),I(f[c],h)),v)}class L{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=I(v,this._value),this._value}}e.Hasher=L;var C;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function E(f,v,h=32){const c=h-v,g=~((1<<c)-1);return(f<<v|(g&f)>>>c)>>>0}function T(f,v=0,h=f.byteLength,c=0){for(let g=0;g<h;g++)f[v+g]=c}function S(f,v,h="0"){for(;f.length<v;)f=h+f;return f}function p(f,v=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(h=>h.toString(16).padStart(2,"0")).join(""):S((f>>>0).toString(16),v/4)}e.toHexString=p;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const h=v.length;if(h===0)return;const c=this._buff;let g=this._buffLen,i=this._leftoverHighSurrogate,u,r;for(i!==0?(u=i,r=-1,i=0):(u=v.charCodeAt(0),r=0);;){let n=u;if(l.isHighSurrogate(u))if(r+1<h){const o=v.charCodeAt(r+1);l.isLowSurrogate(o)?(r++,n=l.computeCodePoint(u,o)):n=65533}else{i=u;break}else l.isLowSurrogate(u)&&(n=65533);if(g=this._push(c,g,n),r++,r<h)u=v.charCodeAt(r);else break}this._buffLen=g,this._leftoverHighSurrogate=i}_push(v,h,c){return c<128?v[h++]=c:c<2048?(v[h++]=192|(c&1984)>>>6,v[h++]=128|(c&63)>>>0):c<65536?(v[h++]=224|(c&61440)>>>12,v[h++]=128|(c&4032)>>>6,v[h++]=128|(c&63)>>>0):(v[h++]=240|(c&1835008)>>>18,v[h++]=128|(c&258048)>>>12,v[h++]=128|(c&4032)>>>6,v[h++]=128|(c&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=b._bigBlock32,h=this._buffDV;for(let s=0;s<64;s+=4)v.setUint32(s,h.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)v.setUint32(s,E(v.getUint32(s-12,!1)^v.getUint32(s-32,!1)^v.getUint32(s-56,!1)^v.getUint32(s-64,!1),1),!1);let c=this._h0,g=this._h1,i=this._h2,u=this._h3,r=this._h4,n,o,d;for(let s=0;s<80;s++)s<20?(n=g&i|~g&u,o=1518500249):s<40?(n=g^i^u,o=1859775393):s<60?(n=g&i|g&u|i&u,o=2400959708):(n=g^i^u,o=3395469782),d=E(c,5)+n+r+o+v.getUint32(s*4,!1)&4294967295,r=u,u=i,i=E(g,30),g=c,c=d;this._h0=this._h0+c&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Ce[26],De([1,0,17,8]),function(J,e,l,t){"use strict";var I,P,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(r,n,o){let d=r.get(n);return d===void 0&&(d=o,r.set(n,d)),d}e.getOrSet=D;function w(r){const n=[];return r.forEach((o,d)=>{n.push(`${d} => ${o}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=w;function k(r){const n=[];return r.forEach(o=>{n.push(o)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=k;class L{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),d=this._value.charCodeAt(this._pos);return o-d}value(){return this._value[this._pos]}}e.StringIterator=L;class C{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class E{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let o=n.length-1;o>=0;o--,this._valueLen--){const d=this._value.charCodeAt(o);if(!(d===47||this._splitOnBackslash&&d===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var T;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(T||(T={}));class S{constructor(n,o){this._ignorePathCasing=n,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(b||(b={}));class f{static forUris(n=()=>!1,o=()=>!1){return new f(new S(n,o))}static forPaths(n=!1){return new f(new E(void 0,!n))}static forStrings(){return new f(new L)}static forConfigKeys(){return new f(new C)}constructor(n){this._iter=n}clear(){this._root=void 0}fill(n,o){if(o){const d=o.slice(0);(0,l.shuffle)(d);for(const s of d)this.set(s,n)}else{const d=n.slice(0);(0,l.shuffle)(d);for(const s of d)this.set(s[0],s[1])}}set(n,o){const d=this._iter.reset(n);let s;this._root||(this._root=new p,this._root.segment=d.value());const a=[];for(s=this._root;;){const _=d.cmp(s.segment);if(_>0)s.left||(s.left=new p,s.left.segment=d.value()),a.push([-1,s]),s=s.left;else if(_<0)s.right||(s.right=new p,s.right.segment=d.value()),a.push([1,s]),s=s.right;else if(d.hasNext())d.next(),s.mid||(s.mid=new p,s.mid.segment=d.value()),a.push([0,s]),s=s.mid;else break}const m=s.value;s.value=o,s.key=n;for(let _=a.length-1;_>=0;_--){const R=a[_][1];R.updateHeight();const M=R.balanceFactor();if(M<-1||M>1){const U=a[_][0],A=a[_+1][0];if(U===1&&A===1)a[_][1]=R.rotateLeft();else if(U===-1&&A===-1)a[_][1]=R.rotateRight();else if(U===1&&A===-1)R.right=a[_+1][1]=a[_+1][1].rotateRight(),a[_][1]=R.rotateLeft();else if(U===-1&&A===1)R.left=a[_+1][1]=a[_+1][1].rotateLeft(),a[_][1]=R.rotateRight();else throw new Error;if(_>0)switch(a[_-1][0]){case-1:a[_-1][1].left=a[_][1];break;case 1:a[_-1][1].right=a[_][1];break;case 0:a[_-1][1].mid=a[_][1];break}else this._root=a[0][1]}}return m}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let d=this._root;for(;d;){const s=o.cmp(d.segment);if(s>0)d=d.left;else if(s<0)d=d.right;else if(o.hasNext())o.next(),d=d.mid;else break}return d}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const d=this._iter.reset(n),s=[];let a=this._root;for(;a;){const m=d.cmp(a.segment);if(m>0)s.push([-1,a]),a=a.left;else if(m<0)s.push([1,a]),a=a.right;else if(d.hasNext())d.next(),s.push([0,a]),a=a.mid;else break}if(!!a){if(o?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const m=this._min(a.right);if(m.key){const{key:_,value:R,segment:M}=m;this._delete(m.key,!1),a.key=_,a.value=R,a.segment=M}}else{const m=a.left??a.right;if(s.length>0){const[_,R]=s[s.length-1];switch(_){case-1:R.left=m;break;case 0:R.mid=m;break;case 1:R.right=m;break}}else this._root=m}for(let m=s.length-1;m>=0;m--){const _=s[m][1];_.updateHeight();const R=_.balanceFactor();if(R>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),s[m][1]=_.rotateLeft()):R<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),s[m][1]=_.rotateRight()),m>0)switch(s[m-1][0]){case-1:s[m-1][1].left=s[m][1];break;case 1:s[m-1][1].right=s[m][1];break;case 0:s[m-1][1].mid=s[m][1];break}else this._root=s[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let d=this._root,s;for(;d;){const a=o.cmp(d.segment);if(a>0)d=d.left;else if(a<0)d=d.right;else if(o.hasNext())o.next(),s=d.value||s,d=d.mid;else break}return d&&d.value||s}findSuperstr(n){const o=this._iter.reset(n);let d=this._root;for(;d;){const s=o.cmp(d.segment);if(s>0)d=d.left;else if(s<0)d=d.right;else if(o.hasNext())o.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(n){for(const[o,d]of this)n(d,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const o=[];return this._dfsEntries(n,o),o[Symbol.iterator]()}_dfsEntries(n,o){!n||(n.left&&this._dfsEntries(n.left,o),n.value&&o.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,o),n.right&&this._dfsEntries(n.right,o))}_isBalanced(){const n=o=>{if(!o)return!0;const d=o.balanceFactor();return d<-1||d>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=f;class v{constructor(n,o){this.uri=n,this.value=o}}class h{constructor(n,o){this[I]="ResourceMap",n instanceof h?(this.map=new Map(n.map),this.toKey=o??h.defaultToKey):(this.map=new Map,this.toKey=n??h.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new v(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[d,s]of this.map)n(s.value,s.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=h,h.defaultToKey=r=>r.toString();class c{constructor(n,o){this[P]="ResourceSet",!n||typeof n=="function"?this._map=new h(n):(this._map=new h(o),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,o){this._map.forEach((d,s)=>n.call(o,s,s,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=c;var g;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(g=e.Touch||(e.Touch={}));class i{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const d=this._map.get(n);if(!!d)return o!==0&&this.touch(d,o),d.value}set(n,o,d=0){let s=this._map.get(n);if(s)s.value=o,d!==0&&this.touch(s,d);else{switch(s={key:n,value:o,next:void 0,previous:void 0},d){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(n,s),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const d=this._state;let s=this._head;for(;s;){if(o?n.bind(o)(s.value,s.key,this):n(s.value,s.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const n=this,o=this._state;let d=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const a={value:d.key,done:!1};return d=d.next,a}else return{value:void 0,done:!0}}};return s}values(){const n=this,o=this._state;let d=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const a={value:d.value,done:!1};return d=d.next,a}else return{value:void 0,done:!0}}};return s}entries(){const n=this,o=this._state;let d=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const a={value:[d.key,d.value],done:!1};return d=d.next,a}else return{value:void 0,done:!0}}};return s}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,d=this.size;for(;o&&d>n;)this._map.delete(o.key),o=o.next,d--;this._head=o,this._size=d,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,d=n.previous;if(!o||!d)throw new Error("Invalid list");o.previous=d,d.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const d=n.next,s=n.previous;n===this._tail?(s.next=void 0,this._tail=s):(d.previous=s,s.next=d),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const d=n.next,s=n.previous;n===this._head?(d.previous=void 0,this._head=d):(d.previous=s,s.next=d),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,d)=>{n.push([d,o])}),n}fromJSON(n){this.clear();for(const[o,d]of n)this.set(o,d)}}e.LinkedMap=i;class u extends i{constructor(n,o=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u}),define(Ce[105],De([1,0,26,8]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...ne){return function(ie,O){for(let j=0,G=ne.length;j<G;j++){const X=ne[j](ie,O);if(X)return X}return null}}e.or=I,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(ne,ie,O){if(!O||O.length<ie.length)return null;let j;return ne?j=t.startsWithIgnoreCase(O,ie):j=O.indexOf(ie)===0,j?ie.length>0?[{start:0,end:ie.length}]:[]:null}function y(ne,ie){const O=ie.toLowerCase().indexOf(ne.toLowerCase());return O===-1?null:[{start:O,end:O+ne.length}]}e.matchesContiguousSubString=y;function D(ne,ie){return w(ne.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=D;function w(ne,ie,O,j){if(O===ne.length)return[];if(j===ie.length)return null;if(ne[O]===ie[j]){let G=null;return(G=w(ne,ie,O+1,j+1))?f({start:j,end:j+1},G):null}return w(ne,ie,O,j+1)}function k(ne){return 97<=ne&&ne<=122}function L(ne){return 65<=ne&&ne<=90}e.isUpper=L;function C(ne){return 48<=ne&&ne<=57}function E(ne){return ne===32||ne===9||ne===10||ne===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>T.add(ne.charCodeAt(0)));function S(ne){return E(ne)||T.has(ne)}function p(ne,ie){return ne===ie||S(ne)&&S(ie)}function b(ne){return k(ne)||L(ne)||C(ne)}function f(ne,ie){return ie.length===0?ie=[ne]:ne.end===ie[0].start?ie[0].start=ne.start:ie.unshift(ne),ie}function v(ne,ie){for(let O=ie;O<ne.length;O++){const j=ne.charCodeAt(O);if(L(j)||C(j)||O>0&&!b(ne.charCodeAt(O-1)))return O}return ne.length}function h(ne,ie,O,j){if(O===ne.length)return[];if(j===ie.length)return null;if(ne[O]!==ie[j].toLowerCase())return null;{let G=null,X=j+1;for(G=h(ne,ie,O+1,j+1);!G&&(X=v(ie,X))<ie.length;)G=h(ne,ie,O+1,X),X++;return G===null?null:f({start:j,end:j+1},G)}}function c(ne){let ie=0,O=0,j=0,G=0,X=0;for(let ye=0;ye<ne.length;ye++)X=ne.charCodeAt(ye),L(X)&&ie++,k(X)&&O++,b(X)&&j++,C(X)&&G++;const pe=ie/ne.length,we=O/ne.length,ce=j/ne.length,Ie=G/ne.length;return{upperPercent:pe,lowerPercent:we,alphaPercent:ce,numericPercent:Ie}}function g(ne){const{upperPercent:ie,lowerPercent:O}=ne;return O===0&&ie>.6}function i(ne){const{upperPercent:ie,lowerPercent:O,alphaPercent:j,numericPercent:G}=ne;return O>.2&&ie<.8&&j>.6&&G<.2}function u(ne){let ie=0,O=0,j=0,G=0;for(let X=0;X<ne.length;X++)j=ne.charCodeAt(X),L(j)&&ie++,k(j)&&O++,E(j)&&G++;return(ie===0||O===0)&&G===0?ne.length<=30:ie<=5}function r(ne,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!u(ne)||ie.length>60)return null;const O=c(ie);if(!i(O)){if(!g(O))return null;ie=ie.toLowerCase()}let j=null,G=0;for(ne=ne.toLowerCase();G<ie.length&&(j=h(ne,ie,0,G))===null;)G=v(ie,G+1);return j}e.matchesCamelCase=r;function n(ne,ie,O=!1){if(!ie||ie.length===0)return null;let j=null,G=0;for(ne=ne.toLowerCase(),ie=ie.toLowerCase();G<ie.length&&(j=o(ne,ie,0,G,O))===null;)G=d(ie,G+1);return j}e.matchesWords=n;function o(ne,ie,O,j,G){if(O===ne.length)return[];if(j===ie.length)return null;if(p(ne.charCodeAt(O),ie.charCodeAt(j))){let X=null,pe=j+1;if(X=o(ne,ie,O+1,j+1,G),!G)for(;!X&&(pe=d(ie,pe))<ie.length;)X=o(ne,ie,O+1,pe,G),pe++;return X?ne.charCodeAt(O)!==ie.charCodeAt(j)?X:f({start:j,end:j+1},X):null}else return null}function d(ne,ie){for(let O=ie;O<ne.length;O++)if(S(ne.charCodeAt(O))||O>0&&S(ne.charCodeAt(O-1)))return O;return ne.length}const s=I(e.matchesPrefix,r,y),a=I(e.matchesPrefix,r,D),m=new l.LRUCache(1e4);function _(ne,ie,O=!1){if(typeof ne!="string"||typeof ie!="string")return null;let j=m.get(ne);j||(j=new RegExp(t.convertSimple2RegExpPattern(ne),"i"),m.set(ne,j));const G=j.exec(ie);return G?[{start:G.index,end:G.index+G[0].length}]:O?a(ne,ie):s(ne,ie)}e.matchesFuzzy=_;function R(ne,ie){const O=Re(ne,ne.toLowerCase(),0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return O?U(O):null}e.matchesFuzzy2=R;function M(ne,ie,O,j,G,X){const pe=Math.min(13,ne.length);for(;O<pe;O++){const we=Re(ne,ie,O,j,G,X,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(we)return we}return[0,X]}e.anyScore=M;function U(ne){if(typeof ne>"u")return[];const ie=[],O=ne[1];for(let j=ne.length-1;j>1;j--){const G=ne[j]+O,X=ie[ie.length-1];X&&X.end===G?X.end=G+1:ie.push({start:G,end:G+1})}return ie}e.createMatches=U;const A=128;function z(){const ne=[],ie=[];for(let O=0;O<=A;O++)ie[O]=0;for(let O=0;O<=A;O++)ne.push(ie.slice(0));return ne}function $(ne){const ie=[];for(let O=0;O<=ne;O++)ie[O]=0;return ie}const N=$(2*A),V=$(2*A),B=z(),F=z(),x=z(),H=!1;function Q(ne,ie,O,j,G){function X(we,ce,Ie=" "){for(;we.length<ce;)we=Ie+we;return we}let pe=` |   |${j.split("").map(we=>X(we,3)).join("|")}
`;for(let we=0;we<=O;we++)we===0?pe+=" |":pe+=`${ie[we-1]}|`,pe+=ne[we].slice(0,G+1).map(ce=>X(ce.toString(),3)).join("|")+`
`;return pe}function K(ne,ie,O,j){ne=ne.substr(ie),O=O.substr(j),console.log(Q(F,ne,ne.length,O,O.length)),console.log(Q(x,ne,ne.length,O,O.length)),console.log(Q(B,ne,ne.length,O,O.length))}function de(ne,ie){if(ie<0||ie>=ne.length)return!1;const O=ne.codePointAt(ie);switch(O){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(O)}}function ee(ne,ie){if(ie<0||ie>=ne.length)return!1;switch(ne.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function he(ne,ie,O){return ie[ne]!==O[ne]}function Y(ne,ie,O,j,G,X,pe=!1){for(;ie<O&&G<X;)ne[ie]===j[G]&&(pe&&(N[ie]=G),ie+=1),G+=1;return ie===O}e.isPatternInWord=Y;var me;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(me||(me={}));var be;(function(ne){ne.Default=[-100,0];function ie(O){return!O||O.length===2&&O[0]===-100&&O[1]===0}ne.isDefault=ie})(be=e.FuzzyScore||(e.FuzzyScore={}));class ke{constructor(ie,O){this.firstMatchCanBeWeak=ie,this.boostFullMatch=O}}e.FuzzyScoreOptions=ke,ke.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Re(ne,ie,O,j,G,X,pe=ke.default){const we=ne.length>A?A:ne.length,ce=j.length>A?A:j.length;if(O>=we||X>=ce||we-O>ce-X||!Y(ie,O,we,G,X,ce,!0))return;ze(we,ce,O,X,ie,G);let Ie=1,ye=1,We=O,qe=X;const Ze=[!1];for(Ie=1,We=O;We<we;Ie++,We++){const se=N[We],Ee=V[We],Ve=We+1<we?V[We+1]:ce;for(ye=se-X+1,qe=se;qe<Ve;ye++,qe++){let fe=Number.MIN_SAFE_INTEGER,Ae=!1;qe<=Ee&&(fe=oe(ne,ie,We,O,j,G,qe,ce,X,B[Ie-1][ye-1]===0,Ze));let Le=0;fe!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Le=fe+F[Ie-1][ye-1]);const Me=qe>se,Ke=Me?F[Ie][ye-1]+(B[Ie][ye-1]>0?-5:0):0,Je=qe>se+1&&B[Ie][ye-1]>0,st=Je?F[Ie][ye-2]+(B[Ie][ye-2]>0?-5:0):0;if(Je&&(!Me||st>=Ke)&&(!Ae||st>=Le))F[Ie][ye]=st,x[Ie][ye]=3,B[Ie][ye]=0;else if(Me&&(!Ae||Ke>=Le))F[Ie][ye]=Ke,x[Ie][ye]=2,B[Ie][ye]=0;else if(Ae)F[Ie][ye]=Le,x[Ie][ye]=1,B[Ie][ye]=B[Ie-1][ye-1]+1;else throw new Error("not possible")}}if(H&&K(ne,O,j,X),!Ze[0]&&!pe.firstMatchCanBeWeak)return;Ie--,ye--;const Ye=[F[Ie][ye],X];let Ne=0,at=0;for(;Ie>=1;){let se=ye;do{const Ee=x[Ie][se];if(Ee===3)se=se-2;else if(Ee===2)se=se-1;else break}while(se>=1);Ne>1&&ie[O+Ie-1]===G[X+ye-1]&&!he(se+X-1,j,G)&&Ne+1>B[Ie][se]&&(se=ye),se===ye?Ne++:Ne=1,at||(at=se),Ie--,ye=se-1,Ye.push(ye)}ce===we&&pe.boostFullMatch&&(Ye[0]+=2);const re=at-we;return Ye[0]-=re,Ye}e.fuzzyScore=Re;function ze(ne,ie,O,j,G,X){let pe=ne-1,we=ie-1;for(;pe>=O&&we>=j;)G[pe]===X[we]&&(V[pe]=we,pe--),we--}function oe(ne,ie,O,j,G,X,pe,we,ce,Ie,ye){if(ie[O]!==X[pe])return Number.MIN_SAFE_INTEGER;let We=1,qe=!1;return pe===O-j?We=ne[O]===G[pe]?7:5:he(pe,G,X)&&(pe===0||!he(pe-1,G,X))?(We=ne[O]===G[pe]?7:5,qe=!0):de(X,pe)&&(pe===0||!de(X,pe-1))?We=5:(de(X,pe-1)||ee(X,pe-1))&&(We=5,qe=!0),We>1&&O===j&&(ye[0]=!0),qe||(qe=he(pe,G,X)||de(X,pe-1)||ee(X,pe-1)),O===j?pe>ce&&(We-=qe?3:5):Ie?We+=qe?2:0:We+=qe?0:1,pe+1===we&&(We-=qe?3:5),We}function le(ne,ie,O,j,G,X,pe){return Z(ne,ie,O,j,G,X,!0,pe)}e.fuzzyScoreGracefulAggressive=le;function ge(ne,ie,O,j,G,X,pe){return Z(ne,ie,O,j,G,X,!1,pe)}e.fuzzyScoreGraceful=ge;function Z(ne,ie,O,j,G,X,pe,we){let ce=Re(ne,ie,O,j,G,X,we);if(ce&&!pe)return ce;if(ne.length>=3){const Ie=Math.min(7,ne.length-1);for(let ye=O+1;ye<Ie;ye++){const We=ae(ne,ye);if(We){const qe=Re(We,We.toLowerCase(),O,j,G,X,we);qe&&(qe[0]-=3,(!ce||qe[0]>ce[0])&&(ce=qe))}}}return ce}function ae(ne,ie){if(ie+1>=ne.length)return;const O=ne[ie],j=ne[ie+1];if(O!==j)return ne.slice(0,ie)+j+O+ne.slice(ie+2)}}),define(Ce[157],De([1,0,76,105,8]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(l.CSSIcon.iconNameCharacter),D=new RegExp(`(\\\\)?${P.source}`,"g");function w(b){return b.replace(D,(f,v)=>v?f:`\\${f}`)}e.escapeIcons=w;const k=new RegExp(`\\\\${P.source}`,"g");function L(b){return b.replace(k,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=L;const C=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function E(b){return b.indexOf(e.iconStartMarker)===-1?b:b.replace(C,(f,v,h,c)=>h?f:v||c||"")}e.stripIcons=E;function T(b){const f=b.indexOf(e.iconStartMarker);return f===-1?{text:b}:S(b,f)}e.parseLabelWithIcons=T;function S(b,f){const v=[];let h="";function c(s){if(s){h+=s;for(const a of s)v.push(u)}}let g=-1,i="",u=0,r,n,o=f;const d=b.length;for(c(b.substr(0,f));o<d;)r=b[o],n=b[o+1],r===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(g=o,c(i),i=e.iconStartMarker,o++):r===")"&&g!==-1?(u+=o-g+1,g=-1,i=""):g!==-1?y.test(r)?i+=r:(c(i),g=-1,i=""):c(r),o++;return c(i),{text:h,iconOffsets:v}}function p(b,f,v=!1){const{text:h,iconOffsets:c}=f;if(!c||c.length===0)return(0,t.matchesFuzzy)(b,h,v);const g=(0,I.ltrim)(h," "),i=h.length-g.length,u=(0,t.matchesFuzzy)(b,g,v);if(u)for(const r of u){const n=c[r.start+i]+i;r.start+=n,r.end+=n}return u}e.matchesFuzzyIconAware=p}),define(Ce[80],De([1,0,26]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new l.LRUCache(1e4);function I(k){return w(k,"NFC",t)}e.normalizeNFC=I;const P=new l.LRUCache(1e4);function y(k){return w(k,"NFD",P)}e.normalizeNFD=y;const D=/[^\u0000-\u0080]/;function w(k,L,C){if(!k)return k;const E=C.get(k);if(E)return E;let T;return D.test(k)?T=k.normalize(L):T=k,C.set(k,T),T}e.removeAccents=function(){const k=/[\u0300-\u036f]/g;return function(L){return y(L).replace(k,"")}}()}),define(Ce[42],De([1,0,8]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const P="error",y="warning",D="warn",w="info",k="ignore";function L(E){return E?l.equalsIgnoreCase(P,E)?I.Error:l.equalsIgnoreCase(y,E)||l.equalsIgnoreCase(D,E)?I.Warning:l.equalsIgnoreCase(w,E)?I.Info:I.Ignore:I.Ignore}I.fromValue=L;function C(E){switch(E){case I.Error:return P;case I.Warning:return y;case I.Info:return w;default:return k}}I.toString=C}(t||(t={})),e.default=t}),define(Ce[2],De([1,0,9,10]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,P=/^\//,y=/^\/\//;function D(r,n){if(!r.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!I.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!P.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(r,n){return!r&&!n?"file":r}function k(r,n){switch(r){case"https":case"http":case"file":n?n[0]!==C&&(n=C+n):n=C;break}return n}const L="",C="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{static isUri(n){return n instanceof T?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,d,s,a,m=!1){typeof n=="object"?(this.scheme=n.scheme||L,this.authority=n.authority||L,this.path=n.path||L,this.query=n.query||L,this.fragment=n.fragment||L):(this.scheme=w(n,m),this.authority=o||L,this.path=k(this.scheme,d||L),this.query=s||L,this.fragment=a||L,D(this,m))}get fsPath(){return h(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:d,path:s,query:a,fragment:m}=n;return o===void 0?o=this.scheme:o===null&&(o=L),d===void 0?d=this.authority:d===null&&(d=L),s===void 0?s=this.path:s===null&&(s=L),a===void 0?a=this.query:a===null&&(a=L),m===void 0?m=this.fragment:m===null&&(m=L),o===this.scheme&&d===this.authority&&s===this.path&&a===this.query&&m===this.fragment?this:new p(o,d,s,a,m)}static parse(n,o=!1){const d=E.exec(n);return d?new p(d[2]||L,u(d[4]||L),u(d[5]||L),u(d[7]||L),u(d[9]||L),o):new p(L,L,L,L,L)}static file(n){let o=L;if(t.isWindows&&(n=n.replace(/\\/g,C)),n[0]===C&&n[1]===C){const d=n.indexOf(C,2);d===-1?(o=n.substring(2),n=C):(o=n.substring(2,d),n=n.substring(d)||C)}return new p("file",o,n,L,L)}static from(n){const o=new p(n.scheme,n.authority,n.path,n.query,n.fragment);return D(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return t.isWindows&&n.scheme==="file"?d=T.file(l.win32.join(h(n,!0),...o)).path:d=l.posix.join(n.path,...o),n.with({path:d})}toString(n=!1){return c(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof T)return n;{const o=new p(n);return o._formatted=n.external,o._fsPath=n._sep===S?n.fsPath:null,o}}else return n}}e.URI=T;const S=t.isWindows?1:void 0;class p extends T{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(n=!1){return n?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=S),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(r,n){let o,d=-1;for(let s=0;s<r.length;s++){const a=r.charCodeAt(s);if(a>=97&&a<=122||a>=65&&a<=90||a>=48&&a<=57||a===45||a===46||a===95||a===126||n&&a===47)d!==-1&&(o+=encodeURIComponent(r.substring(d,s)),d=-1),o!==void 0&&(o+=r.charAt(s));else{o===void 0&&(o=r.substr(0,s));const m=b[a];m!==void 0?(d!==-1&&(o+=encodeURIComponent(r.substring(d,s)),d=-1),o+=m):d===-1&&(d=s)}}return d!==-1&&(o+=encodeURIComponent(r.substring(d))),o!==void 0?o:r}function v(r){let n;for(let o=0;o<r.length;o++){const d=r.charCodeAt(o);d===35||d===63?(n===void 0&&(n=r.substr(0,o)),n+=b[d]):n!==void 0&&(n+=r[o])}return n!==void 0?n:r}function h(r,n){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?n?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=h;function c(r,n){const o=n?v:f;let d="",{scheme:s,authority:a,path:m,query:_,fragment:R}=r;if(s&&(d+=s,d+=":"),(a||s==="file")&&(d+=C,d+=C),a){let M=a.indexOf("@");if(M!==-1){const U=a.substr(0,M);a=a.substr(M+1),M=U.indexOf(":"),M===-1?d+=o(U,!1):(d+=o(U.substr(0,M),!1),d+=":",d+=o(U.substr(M+1),!1)),d+="@"}a=a.toLowerCase(),M=a.indexOf(":"),M===-1?d+=o(a,!1):(d+=o(a.substr(0,M),!1),d+=a.substr(M))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const M=m.charCodeAt(1);M>=65&&M<=90&&(m=`/${String.fromCharCode(M+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const M=m.charCodeAt(0);M>=65&&M<=90&&(m=`${String.fromCharCode(M+32)}:${m.substr(2)}`)}d+=o(m,!0)}return _&&(d+="?",d+=o(_,!1)),R&&(d+="#",d+=n?R:f(R,!1)),d}function g(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+g(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(r){return r.match(i)?r.replace(i,n=>g(n)):r}}),define(Ce[81],De([1,0,23,8,2]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(k){return JSON.stringify(k,D)}e.stringify=P;function y(k){let L=JSON.parse(k);return L=w(L),L}e.parse=y;function D(k,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,t.regExpFlags)(L)}:L}function w(k,L=0){if(!k||L>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return I.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 14:return new Date(k.source)}if(k instanceof l.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=w(k[C],L+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=w(k[C],L+1))}return k}e.revive=w}),define(Ce[14],De([1,0,10,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(k){this._preferredWebSchema=k}setDelegate(k){this._delegate=k}setServerRootPath(k){this._remoteResourcesPath=`${k}/${I.vscodeRemoteResource}`}set(k,L,C){this._hosts[k]=L,this._ports[k]=C}setConnectionToken(k,L){this._connectionTokens[k]=L}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(k){if(this._delegate)return this._delegate(k);const L=k.authority;let C=this._hosts[L];C&&C.indexOf(":")!==-1&&C.indexOf("[")===-1&&(C=`[${C}]`);const E=this._ports[L],T=this._connectionTokens[L];let S=`path=${encodeURIComponent(k.path)}`;return typeof T=="string"&&(S+=`&${e.connectionTokenQueryName}=${encodeURIComponent(T)}`),t.URI.from({scheme:l.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${C}:${E}`,path:this._remoteResourcesPath,query:S})}}e.RemoteAuthorities=new P;class y{asBrowserUri(k,L){const C=this.toUri(k,L);return C.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===I.file&&(l.isNative||l.isWebWorker&&l.globals.origin===`${I.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?C.with({scheme:I.vscodeFileResource,authority:C.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(k,L){const C=this.toUri(k,L);return C.scheme===I.vscodeFileResource?C.with({scheme:I.file,authority:C.authority!==y.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(k,L){return t.URI.isUri(k)?k:t.URI.parse(L.toUrl(k))}}y.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new y;var D;(function(w){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(k.get("3"));const L="vscode-coi";function C(T){let S;typeof T=="string"?S=new URL(T).searchParams:T instanceof URL?S=T.searchParams:t.URI.isUri(T)&&(S=new URL(T.toString(!0)).searchParams);const p=S?.get(L);if(!!p)return k.get(p)}w.getHeadersFromQuery=C;function E(T,S,p){if(!globalThis.crossOriginIsolated)return;const b=S&&p?"3":p?"2":"1";T instanceof URLSearchParams?T.set(L,b):T[L]=b}w.addSearchParam=E})(D=e.COI||(e.COI={}))}),define(Ce[22],De([1,0,32,14,9,10,8,2]),function(J,e,l,t,I,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(T){return(0,D.uriToFsPath)(T,!0)}e.originalFSPath=w;class k{constructor(S){this._ignorePathCasing=S}compare(S,p,b=!1){return S===p?0:(0,y.compare)(this.getComparisonKey(S,b),this.getComparisonKey(p,b))}isEqual(S,p,b=!1){return S===p?!0:!S||!p?!1:this.getComparisonKey(S,b)===this.getComparisonKey(p,b)}getComparisonKey(S,p=!1){return S.with({path:this._ignorePathCasing(S)?S.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(S){return this._ignorePathCasing(S)}isEqualOrParent(S,p,b=!1){if(S.scheme===p.scheme){if(S.scheme===t.Schemas.file)return l.isEqualOrParent(w(S),w(p),this._ignorePathCasing(S))&&S.query===p.query&&(b||S.fragment===p.fragment);if((0,e.isEqualAuthority)(S.authority,p.authority))return l.isEqualOrParent(S.path,p.path,this._ignorePathCasing(S),"/")&&S.query===p.query&&(b||S.fragment===p.fragment)}return!1}joinPath(S,...p){return D.URI.joinPath(S,...p)}basenameOrAuthority(S){return(0,e.basename)(S)||S.authority}basename(S){return I.posix.basename(S.path)}extname(S){return I.posix.extname(S.path)}dirname(S){if(S.path.length===0)return S;let p;return S.scheme===t.Schemas.file?p=D.URI.file(I.dirname(w(S))).path:(p=I.posix.dirname(S.path),S.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),p="/")),S.with({path:p})}normalizePath(S){if(!S.path.length)return S;let p;return S.scheme===t.Schemas.file?p=D.URI.file(I.normalize(w(S))).path:p=I.posix.normalize(S.path),S.with({path:p})}relativePath(S,p){if(S.scheme!==p.scheme||!(0,e.isEqualAuthority)(S.authority,p.authority))return;if(S.scheme===t.Schemas.file){const v=I.relative(w(S),w(p));return P.isWindows?l.toSlashes(v):v}let b=S.path||"/";const f=p.path||"/";if(this._ignorePathCasing(S)){let v=0;for(const h=Math.min(b.length,f.length);v<h&&!(b.charCodeAt(v)!==f.charCodeAt(v)&&b.charAt(v).toLowerCase()!==f.charAt(v).toLowerCase());v++);b=f.substr(0,v)+b.substr(v)}return I.posix.relative(b,f)}resolvePath(S,p){if(S.scheme===t.Schemas.file){const b=D.URI.file(I.resolve(w(S),p));return S.with({authority:b.authority,path:b.path})}return p=l.toPosixPath(p),S.with({path:I.posix.resolve(S.path,p)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,p){return S===p||S!==void 0&&p!==void 0&&(0,y.equalsIgnoreCase)(S,p)}hasTrailingPathSeparator(S,p=I.sep){if(S.scheme===t.Schemas.file){const b=w(S);return b.length>l.getRoot(b).length&&b[b.length-1]===p}else{const b=S.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,p=I.sep){return(0,e.hasTrailingPathSeparator)(S,p)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,p=I.sep){let b=!1;if(S.scheme===t.Schemas.file){const f=w(S);b=f!==void 0&&f.length===l.getRoot(f).length&&f[f.length-1]===p}else{p="/";const f=S.path;b=f.length===1&&f.charCodeAt(f.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(S,p)?S.with({path:S.path+"/"}):S}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(T=>T.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new k(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(T,S){const p=[];for(let b=0;b<T.length;b++){const f=S(T[b]);T.some((v,h)=>h===b?!1:(0,e.isEqualOrParent)(f,S(v)))||p.push(T[b])}return p}e.distinctParents=L;var C;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function S(p){const b=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(h=>{const[c,g]=h.split(":");c&&g&&b.set(c,g)});const v=p.path.substring(0,p.path.indexOf(";"));return v&&b.set(T.META_DATA_MIME,v),b}T.parseMetaData=S})(C=e.DataUri||(e.DataUri={}));function E(T,S,p){if(S){let b=T.path;return b&&b[0]!==I.posix.sep&&(b=I.posix.sep+b),T.with({scheme:p,authority:S,path:b})}return T.with({scheme:p})}e.toLocalResource=E}),define(Ce[18],De([1,0,21,11,4,6,22,10]),function(J,e,l,t,I,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(he){return!!he&&typeof he.then=="function"}e.isThenable=w;function k(he){const Y=new l.CancellationTokenSource,me=he(Y.token),be=new Promise((ke,Re)=>{const ze=Y.token.onCancellationRequested(()=>{ze.dispose(),Y.dispose(),Re(new t.CancellationError)});Promise.resolve(me).then(oe=>{ze.dispose(),Y.dispose(),ke(oe)},oe=>{ze.dispose(),Y.dispose(),Re(oe)})});return new class{cancel(){Y.cancel()}then(ke,Re){return be.then(ke,Re)}catch(ke){return this.then(void 0,ke)}finally(ke){return be.finally(ke)}}}e.createCancelablePromise=k;function L(he,Y,me){return new Promise((be,ke)=>{const Re=Y.onCancellationRequested(()=>{Re.dispose(),be(me)});he.then(be,ke).finally(()=>Re.dispose())})}e.raceCancellation=L;function C(he,Y){return new Promise((me,be)=>{const ke=Y.onCancellationRequested(()=>{ke.dispose(),be(new t.CancellationError)});he.then(me,be).finally(()=>ke.dispose())})}e.raceCancellationError=C;async function E(he){let Y=-1;const me=he.map((ke,Re)=>ke.then(ze=>(Y=Re,ze))),be=await Promise.race(me);return he.forEach((ke,Re)=>{Re!==Y&&ke.cancel()}),be}e.raceCancellablePromises=E;function T(he,Y,me){let be;const ke=setTimeout(()=>{be?.(void 0),me?.()},Y);return Promise.race([he.finally(()=>clearTimeout(ke)),new Promise(Re=>be=Re)])}e.raceTimeout=T;function S(he){return new Promise((Y,me)=>{const be=he();w(be)?be.then(Y,me):Y(be)})}e.asPromise=S;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const me=()=>{this.queuedPromise=null;const be=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,be};this.queuedPromise=new Promise(be=>{this.activePromise.then(me,me).then(be)})}return new Promise((me,be)=>{this.queuedPromise.then(me,be)})}return this.activePromise=Y(),new Promise((me,be)=>{this.activePromise.then(ke=>{this.activePromise=null,me(ke)},ke=>{this.activePromise=null,be(ke)})})}}e.Throttler=p;class b{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=b;class f{constructor(){this.promiseMap=new Map}queue(Y,me){const ke=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.promiseMap.get(Y)===ke&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,ke),ke}}e.SequencerByKey=f;const v=(he,Y)=>{let me=!0;const be=setTimeout(()=>{me=!1,Y()},he);return{isTriggered:()=>me,dispose:()=>{clearTimeout(be),me=!1}}},h=he=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,he())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,me=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ke,Re)=>{this.doResolve=ke,this.doReject=Re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ke=this.task;return this.task=null,ke()}}));const be=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=me===e.MicrotaskDelay?h(be):v(me,be),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class g{constructor(Y){this.delayer=new c(Y),this.throttler=new p}trigger(Y,me){return this.delayer.trigger(()=>this.throttler.queue(Y),me)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=g;class i{constructor(){this._isOpen=!1,this._promise=new Promise((Y,me)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class u extends i{constructor(Y){super(),this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function r(he,Y){return Y?new Promise((me,be)=>{const ke=setTimeout(()=>{Re.dispose(),me()},he),Re=Y.onCancellationRequested(()=>{clearTimeout(ke),Re.dispose(),be(new t.CancellationError)})}):k(me=>r(he,me))}e.timeout=r;function n(he,Y=0){const me=setTimeout(he,Y);return(0,P.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=n;function o(he){const Y=[];let me=0;const be=he.length;function ke(){return me<be?he[me++]():null}function Re(ze){ze!=null&&Y.push(ze);const oe=ke();return oe?oe.then(Re):Promise.resolve(Y)}return Promise.resolve(null).then(Re)}e.sequence=o;function d(he,Y=be=>!!be,me=null){let be=0;const ke=he.length,Re=()=>{if(be>=ke)return Promise.resolve(me);const ze=he[be++];return Promise.resolve(ze()).then(le=>Y(le)?Promise.resolve(le):Re())};return Re()}e.first=d;function s(he,Y=be=>!!be,me=null){if(he.length===0)return Promise.resolve(me);let be=he.length;const ke=()=>{be=-1;for(const Re of he)Re.cancel?.()};return new Promise((Re,ze)=>{for(const oe of he)oe.then(le=>{--be>=0&&Y(le)?(ke(),Re(le)):be===0&&Re(me)}).catch(le=>{--be>=0&&(ke(),ze(le))})})}e.firstParallel=s;class a{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new I.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Y){return this._size++,new Promise((me,be)=>{this.outstandingPromises.push({factory:Y,c:me,e:be}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const me=Y.factory();me.then(Y.c,Y.e),me.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=a;class m extends a{constructor(){super(1)}}e.Queue=m;class _{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new x;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,me=y.extUri){const be=me.getComparisonKey(Y);let ke=this.queues.get(be);return ke||(ke=new m,I.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.queues.delete(be),this.onDidQueueDrain()}),this.queues.set(be,ke)),ke}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=_;class R{constructor(Y,me){this._token=-1,typeof Y=="function"&&typeof me=="number"&&this.setIfNotSet(Y,me)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,me){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},me)}setIfNotSet(Y,me){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},me))}}e.TimeoutTimer=R;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,me){this.cancel(),this._token=setInterval(()=>{Y()},me)}}e.IntervalTimer=M;class U{constructor(Y,me){this.timeoutToken=-1,this.runner=Y,this.timeout=me,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class A{constructor(Y,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=me,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=A;class z extends U{constructor(Y,me){super(Y,me),this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner?.(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class $ extends P.Disposable{constructor(Y,me){super(),this.options=Y,this.handler=me,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=he=>{(0,D.setTimeout0)(()=>{if(Y)return;const me=Date.now()+15;he(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(he,Y)=>{const me=requestIdleCallback(he,typeof Y=="number"?{timeout:Y}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(me))}}}}();class N{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(me){this._error=me}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=N;async function V(he,Y,me){let be;for(let ke=0;ke<me;ke++)try{return await he()}catch(Re){be=Re,await r(Y)}throw be}e.retry=V;class B{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Y,me,be){return this._pending={taskId:Y,cancel:()=>be?.(),promise:me},me.then(()=>this.donePending(Y),()=>this.donePending(Y)),me}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let me,be;const ke=new Promise((Re,ze)=>{me=Re,be=ze});this._next={run:Y,promise:ke,promiseResolve:me,promiseReject:be}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=B;class F{constructor(Y,me=()=>Date.now()){this.interval=Y,this.nowFn=me,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=F;class x{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,me)=>{this.completeCallback=Y,this.errorCallback=me})}complete(Y){return new Promise(me=>{this.completeCallback(Y),this.resolved=!0,me()})}error(Y){return new Promise(me=>{this.errorCallback(Y),this.rejected=!0,me()})}cancel(){new Promise(Y=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=x;var H;(function(he){async function Y(be){let ke;const Re=await Promise.all(be.map(ze=>ze.then(oe=>oe,oe=>{ke||(ke=oe)})));if(typeof ke<"u")throw ke;return Re}he.settled=Y;function me(be){return new Promise(async(ke,Re)=>{try{await be(ke,Re)}catch(ze){Re(ze)}})}he.withAsyncBody=me})(H=e.Promises||(e.Promises={}));var Q;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(Q||(Q={}));class K{static fromArray(Y){return new K(me=>{me.emitMany(Y)})}static fromPromise(Y){return new K(async me=>{me.emitMany(await Y)})}static fromPromises(Y){return new K(async me=>{await Promise.all(Y.map(async be=>me.emitOne(await be)))})}static merge(Y){return new K(async me=>{await Promise.all(Y.map(async be=>{for await(const ke of be)me.emitOne(ke)}))})}constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const me={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(Y(me)),this.resolve()}catch(be){this.reject(be)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,me){return new K(async be=>{for await(const ke of Y)be.emitOne(me(ke))})}map(Y){return K.map(this,Y)}static filter(Y,me){return new K(async be=>{for await(const ke of Y)me(ke)&&be.emitOne(ke)})}filter(Y){return K.filter(this,Y)}static coalesce(Y){return K.filter(Y,me=>!!me)}coalesce(){return K.coalesce(this)}static async toPromise(Y){const me=[];for await(const be of Y)me.push(be);return me}toPromise(){return K.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=K,K.EMPTY=K.fromArray([]);class de extends K{constructor(Y,me){super(me),this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=de;function ee(he){const Y=new l.CancellationTokenSource,me=he(Y.token);return new de(Y,async be=>{const ke=Y.token.onCancellationRequested(()=>{ke.dispose(),Y.dispose(),be.reject(new t.CancellationError)});try{for await(const Re of me){if(Y.token.isCancellationRequested)return;be.emitOne(Re)}ke.dispose(),Y.dispose()}catch(Re){ke.dispose(),Y.dispose(),be.reject(Re)}})}e.createCancelableAsyncIterable=ee}),define(Ce[106],De([1,0,18,9]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new l.IdleValue(()=>{const m=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:m,collatorIsNumeric:m.resolvedOptions().numeric}}),P=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(m,_,R=!1){const M=m||"",U=_||"",A=I.value.collator.compare(M,U);return I.value.collatorIsNumeric&&A===0&&M!==U?M<U?-1:1:A}e.compareFileNames=D;function w(m,_){const R=P.value.collator;return m=m||"",_=_||"",g(R,m,_)}e.compareFileNamesDefault=w;function k(m,_){const R=P.value.collator;return m=m||"",_=_||"",n(m,_)||g(R,m,_)}e.compareFileNamesUpper=k;function L(m,_){const R=P.value.collator;return m=m||"",_=_||"",r(m,_)||g(R,m,_)}e.compareFileNamesLower=L;function C(m,_){return m=m||"",_=_||"",m===_?0:m<_?-1:1}e.compareFileNamesUnicode=C;function E(m,_,R=!1){R||(m=m&&m.toLowerCase(),_=_&&_.toLowerCase());const[M,U]=h(m),[A,z]=h(_);return M!==A?M<A?-1:1:U===z?0:U<z?-1:1}e.noIntlCompareFileNames=E;function T(m,_){const[R,M]=h(m),[U,A]=h(_);let z=I.value.collator.compare(M,A);if(z===0){if(I.value.collatorIsNumeric&&M!==A)return M<A?-1:1;if(z=I.value.collator.compare(R,U),I.value.collatorIsNumeric&&z===0&&R!==U)return R<U?-1:1}return z}e.compareFileExtensions=T;function S(m,_){m=m||"",_=_||"";const R=c(m),M=c(_),U=P.value.collator,A=y.value.collator;return g(A,R,M)||g(U,m,_)}e.compareFileExtensionsDefault=S;function p(m,_){m=m||"",_=_||"";const R=c(m),M=c(_),U=P.value.collator,A=y.value.collator;return g(A,R,M)||n(m,_)||g(U,m,_)}e.compareFileExtensionsUpper=p;function b(m,_){m=m||"",_=_||"";const R=c(m),M=c(_),U=P.value.collator,A=y.value.collator;return g(A,R,M)||r(m,_)||g(U,m,_)}e.compareFileExtensionsLower=b;function f(m,_){m=m||"",_=_||"";const R=c(m).toLowerCase(),M=c(_).toLowerCase();return R!==M?R<M?-1:1:m!==_?m<_?-1:1:0}e.compareFileExtensionsUnicode=f;const v=/^(.*?)(\.([^.]*))?$/;function h(m,_=!1){const R=m?v.exec(m):[];let M=[R&&R[1]||"",R&&R[3]||""];return _&&(!M[0]&&M[1]||M[0]&&M[0].charAt(0)===".")&&(M=[M[0]+"."+M[1],""]),M}function c(m){const _=m?v.exec(m):[];return _&&_[1]&&_[1].charAt(0)!=="."&&_[3]||""}function g(m,_,R){const M=m.compare(_,R);return M!==0?M:_.length!==R.length?_.length<R.length?-1:1:0}function i(m){const _=m.charAt(0);return _.toLocaleUpperCase()!==_}function u(m){const _=m.charAt(0);return _.toLocaleLowerCase()!==_}function r(m,_){return i(m)&&u(_)?-1:u(m)&&i(_)?1:0}function n(m,_){return u(m)&&i(_)?-1:i(m)&&u(_)?1:0}function o(m,_,R=!1){return R||(m=m&&m.toLowerCase(),_=_&&_.toLowerCase()),m===_?0:m<_?-1:1}function d(m,_,R=!1){const M=m.split(t.sep),U=_.split(t.sep),A=M.length-1,z=U.length-1;let $,N;for(let V=0;;V++){if($=A===V,N=z===V,$&&N)return D(M[V],U[V],R);if($)return-1;if(N)return 1;const B=o(M[V],U[V],R);if(B!==0)return B}}e.comparePaths=d;function s(m,_,R){const M=m.toLowerCase(),U=_.toLowerCase(),A=a(m,_,R);if(A)return A;const z=M.endsWith(R),$=U.endsWith(R);if(z!==$)return z?-1:1;const N=D(M,U);return N!==0?N:M.localeCompare(U)}e.compareAnything=s;function a(m,_,R){const M=m.toLowerCase(),U=_.toLowerCase(),A=M.startsWith(R),z=U.startsWith(R);if(A!==z)return A?-1:1;if(A&&z){if(M.length<U.length)return-1;if(M.length>U.length)return 1}return 0}e.compareByPrefix=a}),define(Ce[107],De([1,0,106,105,79,9,10,8]),function(J,e,l,t,I,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const w=0,k=[w,[]];function L(B,F,x,H){if(!B||!F)return k;const Q=B.length,K=F.length;if(Q<K)return k;const de=B.toLowerCase();return C(F,x,K,B,de,Q,H)}e.scoreFuzzy=L;function C(B,F,x,H,Q,K,de){const ee=[],he=[];for(let ke=0;ke<x;ke++){const Re=ke*K,ze=Re-K,oe=ke>0,le=B[ke],ge=F[ke];for(let Z=0;Z<K;Z++){const ae=Z>0,ne=Re+Z,ie=ne-1,O=ze+Z-1,j=ae?ee[ie]:0,G=oe&&ae?ee[O]:0,X=oe&&ae?he[O]:0;let pe;!G&&oe?pe=0:pe=E(le,ge,H,Q,Z,X),pe&&G+pe>=j&&(de||oe||Q.startsWith(F,Z))?(he[ne]=X+1,ee[ne]=G+pe):(he[ne]=w,ee[ne]=j)}}const Y=[];let me=x-1,be=K-1;for(;me>=0&&be>=0;){const ke=me*K+be;he[ke]===w||(Y.push(be),me--),be--}return[ee[x*K-1],Y.reverse()]}function E(B,F,x,H,Q,K){let de=0;if(!T(F,H[Q]))return de;if(de+=1,K>0&&(de+=K*5),B===x[Q]&&(de+=1),Q===0)de+=8;else{const ee=S(x.charCodeAt(Q-1));ee?de+=ee:(0,t.isUpper)(x.charCodeAt(Q))&&K===0&&(de+=2)}return de}function T(B,F){return B===F?!0:B==="/"||B==="\\"?F==="/"||F==="\\":!1}function S(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function b(B,F,x=0,H=0){const Q=F;return Q.values&&Q.values.length>1?f(B,Q.values,x,H):v(B,F,x,H)}e.scoreFuzzy2=b;function f(B,F,x,H){let Q=0;const K=[];for(const de of F){const[ee,he]=v(B,de,x,H);if(typeof ee!="number")return p;Q+=ee,K.push(...he)}return[Q,a(K)]}function v(B,F,x,H){const Q=(0,t.fuzzyScore)(F.original,F.originalLowercase,x,B,B.toLowerCase(),H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,t.createMatches)(Q)]:p}const h=Object.freeze({score:0}),c=1<<18,g=1<<17,i=1<<16;function u(B,F,x,H){const Q=H.values?H.values:[H];return(0,I.hash)({[H.normalized]:{values:Q.map(de=>({value:de.normalized,expectContiguousMatch:de.expectContiguousMatch})),label:B,description:F,allowNonContiguousMatches:x}})}function r(B,F,x,H,Q){if(!B||!F.normalized)return h;const K=H.getItemLabel(B);if(!K)return h;const de=H.getItemDescription(B),ee=u(K,de,x,F),he=Q[ee];if(he)return he;const Y=n(K,de,H.getItemPath(B),F,x);return Q[ee]=Y,Y}e.scoreItemFuzzy=r;function n(B,F,x,H,Q){const K=!x||!H.containsPathSeparator;return x&&(y.isLinux?H.pathNormalized===x:(0,D.equalsIgnoreCase)(H.pathNormalized,x))?{score:c,labelMatch:[{start:0,end:B.length}],descriptionMatch:F?[{start:0,end:F.length}]:void 0}:H.values&&H.values.length>1?o(B,F,x,H.values,K,Q):d(B,F,x,H,K,Q)}function o(B,F,x,H,Q,K){let de=0;const ee=[],he=[];for(const Y of H){const{score:me,labelMatch:be,descriptionMatch:ke}=d(B,F,x,Y,Q,K);if(me===w)return h;de+=me,be&&ee.push(...be),ke&&he.push(...ke)}return{score:de,labelMatch:a(ee),descriptionMatch:a(he)}}function d(B,F,x,H,Q,K){if(Q||!F){const[de,ee]=L(B,H.normalized,H.normalizedLowercase,K&&!H.expectContiguousMatch);if(de){const he=(0,t.matchesPrefix)(H.normalized,B);let Y;return he?(Y=g,Y+=Math.round(H.normalized.length/B.length*100)):Y=i,{score:Y+de,labelMatch:he||s(ee)}}}if(F){let de=F;x&&(de=`${F}${P.sep}`);const ee=de.length,he=`${de}${B}`,[Y,me]=L(he,H.normalized,H.normalizedLowercase,K&&!H.expectContiguousMatch);if(Y){const be=s(me),ke=[],Re=[];return be.forEach(ze=>{ze.start<ee&&ze.end>ee?(ke.push({start:0,end:ze.end-ee}),Re.push({start:ze.start,end:ee})):ze.start>=ee?ke.push({start:ze.start-ee,end:ze.end-ee}):Re.push(ze)}),{score:Y,labelMatch:ke,descriptionMatch:Re}}}return h}function s(B){const F=[];if(!B)return F;let x;for(const H of B)x&&x.end===H?x.end+=1:(x={start:H,end:H+1},F.push(x));return F}function a(B){const F=B.sort((Q,K)=>Q.start-K.start),x=[];let H;for(const Q of F)!H||!m(H,Q)?(H=Q,x.push(Q)):(H.start=Math.min(H.start,Q.start),H.end=Math.max(H.end,Q.end));return x}function m(B,F){return!(B.end<F.start||F.end<B.start)}function _(B,F,x,H,Q,K){const de=r(B,x,H,Q,K),ee=r(F,x,H,Q,K),he=de.score,Y=ee.score;if((he===c||Y===c)&&he!==Y)return he===c?-1:1;if(he>i||Y>i){if(he!==Y)return he>Y?-1:1;if(he<g&&Y<g){const le=M(de.labelMatch,ee.labelMatch);if(le!==0)return le}const ze=Q.getItemLabel(B)||"",oe=Q.getItemLabel(F)||"";if(ze.length!==oe.length)return ze.length-oe.length}if(he!==Y)return he>Y?-1:1;const me=Array.isArray(de.labelMatch)&&de.labelMatch.length>0,be=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0;if(me&&!be)return-1;if(be&&!me)return 1;const ke=R(B,de,Q),Re=R(F,ee,Q);return ke&&Re&&ke!==Re?Re>ke?-1:1:U(B,F,x,Q)}e.compareItemsByFuzzyScore=_;function R(B,F,x){let H=-1,Q=-1;if(F.descriptionMatch&&F.descriptionMatch.length?H=F.descriptionMatch[0].start:F.labelMatch&&F.labelMatch.length&&(H=F.labelMatch[0].start),F.labelMatch&&F.labelMatch.length){if(Q=F.labelMatch[F.labelMatch.length-1].end,F.descriptionMatch&&F.descriptionMatch.length){const K=x.getItemDescription(B);K&&(Q+=K.length)}}else F.descriptionMatch&&F.descriptionMatch.length&&(Q=F.descriptionMatch[F.descriptionMatch.length-1].end);return Q-H}function M(B,F){if(!B&&!F||(!B||!B.length)&&(!F||!F.length))return 0;if(!F||!F.length)return-1;if(!B||!B.length)return 1;const x=B[0].start,Q=B[B.length-1].end-x,K=F[0].start,ee=F[F.length-1].end-K;return Q===ee?0:ee<Q?1:-1}function U(B,F,x,H){const Q=H.getItemLabel(B)||"",K=H.getItemLabel(F)||"",de=H.getItemDescription(B),ee=H.getItemDescription(F),he=Q.length+(de?de.length:0),Y=K.length+(ee?ee.length:0);if(he!==Y)return he-Y;const me=H.getItemPath(B),be=H.getItemPath(F);return me&&be&&me.length!==be.length?me.length-be.length:Q!==K?(0,l.compareAnything)(Q,K,x.normalized):de&&ee&&de!==ee?(0,l.compareAnything)(de,ee,x.normalized):me&&be&&me!==be?(0,l.compareAnything)(me,be,x.normalized):0}function A(B){return B.startsWith('"')&&B.endsWith('"')}const z=" ";function $(B){typeof B!="string"&&(B="");const F=B.toLowerCase(),{pathNormalized:x,normalized:H,normalizedLowercase:Q}=N(B),K=x.indexOf(P.sep)>=0,de=A(B);let ee;const he=B.split(z);if(he.length>1)for(const Y of he){const me=A(Y),{pathNormalized:be,normalized:ke,normalizedLowercase:Re}=N(Y);ke&&(ee||(ee=[]),ee.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:be,normalized:ke,normalizedLowercase:Re,expectContiguousMatch:me}))}return{original:B,originalLowercase:F,pathNormalized:x,normalized:H,normalizedLowercase:Q,values:ee,containsPathSeparator:K,expectContiguousMatch:de}}e.prepareQuery=$;function N(B){let F;y.isWindows?F=B.replace(/\//g,P.sep):F=B.replace(/\\/g,P.sep);const x=(0,D.stripWildcards)(F).replace(/\s|"/g,"");return{pathNormalized:F,normalized:x,normalizedLowercase:x.toLowerCase()}}function V(B){return Array.isArray(B)?$(B.map(F=>F.original).join(z)):$(B.original)}e.pieceToQuery=V}),define(Ce[37],De([1,0,17,18,32,26,9,10,8]),function(J,e,l,t,I,P,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",C="[^/\\\\]",E=/\//g;function T(x,H){switch(x){case 0:return"";case 1:return`${C}*?`;default:return`(?:${L}|${C}+${L}${H?`|${L}${C}+`:""})*?`}}function S(x,H){if(!x)return[];const Q=[];let K=!1,de=!1,ee="";for(const he of x){switch(he){case H:if(!K&&!de){Q.push(ee),ee="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":de=!0;break;case"]":de=!1;break}ee+=he}return ee&&Q.push(ee),Q}e.splitGlobAware=S;function p(x){if(!x)return"";let H="";const Q=S(x,e.GLOB_SPLIT);if(Q.every(K=>K===e.GLOBSTAR))H=".*";else{let K=!1;Q.forEach((de,ee)=>{if(de===e.GLOBSTAR){if(K)return;H+=T(2,ee===Q.length-1)}else{let he=!1,Y="",me=!1,be="";for(const ke of de){if(ke!=="}"&&he){Y+=ke;continue}if(me&&(ke!=="]"||!be)){let Re;ke==="-"?Re=ke:(ke==="^"||ke==="!")&&!be?Re="^":ke===e.GLOB_SPLIT?Re="":Re=(0,w.escapeRegExpCharacters)(ke),be+=Re;continue}switch(ke){case"{":he=!0;continue;case"[":me=!0;continue;case"}":{H+=`(?:${S(Y,",").map(oe=>p(oe)).join("|")})`,he=!1,Y="";break}case"]":{H+="["+be+"]",me=!1,be="";break}case"?":H+=C;continue;case"*":H+=T(1);continue;default:H+=(0,w.escapeRegExpCharacters)(ke)}}ee<Q.length-1&&(Q[ee+1]!==e.GLOBSTAR||ee+2<Q.length)&&(H+=L)}K=de===e.GLOBSTAR})}return H}const b=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new P.LRUCache(1e4),u=function(){return!1},r=function(){return null};function n(x,H){if(!x)return r;let Q;typeof x!="string"?Q=x.pattern:Q=x,Q=Q.trim();const K=`${Q}_${!!H.trimForExclusions}`;let de=i.get(K);if(de)return o(de,x);let ee;return b.test(Q)?de=s(Q.substr(4),Q):(ee=f.exec(d(Q,H)))?de=a(ee[1],Q):(H.trimForExclusions?h:v).test(Q)?de=m(Q,H):(ee=c.exec(d(Q,H)))?de=_(ee[1].substr(1),Q,!0):(ee=g.exec(d(Q,H)))?de=_(ee[1],Q,!1):de=R(Q),i.set(K,de),o(de,x)}function o(x,H){if(typeof H=="string")return x;const Q=function(K,de){return(0,I.isEqualOrParent)(K,H.base,!D.isLinux)?x(K.substr(H.base.length+1),de):null};return Q.allBasenames=x.allBasenames,Q.allPaths=x.allPaths,Q.basenames=x.basenames,Q.patterns=x.patterns,Q}function d(x,H){return H.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function s(x,H){return function(Q,K){return typeof Q=="string"&&Q.endsWith(x)?H:null}}function a(x,H){const Q=`/${x}`,K=`\\${x}`,de=function(he,Y){return typeof he!="string"?null:Y?Y===x?H:null:he===x||he.endsWith(Q)||he.endsWith(K)?H:null},ee=[x];return de.basenames=ee,de.patterns=[H],de.allBasenames=ee,de}function m(x,H){const Q=B(x.slice(1,-1).split(",").map(Y=>n(Y,H)).filter(Y=>Y!==r),x),K=Q.length;if(!K)return r;if(K===1)return Q[0];const de=function(Y,me){for(let be=0,ke=Q.length;be<ke;be++)if(Q[be](Y,me))return x;return null},ee=Q.find(Y=>!!Y.allBasenames);ee&&(de.allBasenames=ee.allBasenames);const he=Q.reduce((Y,me)=>me.allPaths?Y.concat(me.allPaths):Y,[]);return he.length&&(de.allPaths=he),de}function _(x,H,Q){const K=y.sep===y.posix.sep,de=K?x:x.replace(E,y.sep),ee=y.sep+de,he=y.posix.sep+x;let Y;return Q?Y=function(me,be){return typeof me=="string"&&(me===de||me.endsWith(ee)||!K&&(me===x||me.endsWith(he)))?H:null}:Y=function(me,be){return typeof me=="string"&&(me===de||!K&&me===x)?H:null},Y.allPaths=[(Q?"*/":"./")+x],Y}function R(x){try{const H=new RegExp(`^${p(x)}$`);return function(Q){return H.lastIndex=0,typeof Q=="string"&&H.test(Q)?x:null}}catch{return r}}function M(x,H,Q){return!x||typeof H!="string"?!1:U(x)(H,void 0,Q)}e.match=M;function U(x,H={}){if(!x)return u;if(typeof x=="string"||A(x)){const Q=n(x,H);if(Q===r)return u;const K=function(de,ee){return!!Q(de,ee)};return Q.allBasenames&&(K.allBasenames=Q.allBasenames),Q.allPaths&&(K.allPaths=Q.allPaths),K}return N(x,H)}e.parse=U;function A(x){const H=x;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.isRelativePattern=A;function z(x){return x.allBasenames||[]}e.getBasenameTerms=z;function $(x){return x.allPaths||[]}e.getPathTerms=$;function N(x,H){const Q=B(Object.getOwnPropertyNames(x).map(Y=>V(Y,x[Y],H)).filter(Y=>Y!==r)),K=Q.length;if(!K)return r;if(!Q.some(Y=>!!Y.requiresSiblings)){if(K===1)return Q[0];const Y=function(ke,Re){let ze;for(let oe=0,le=Q.length;oe<le;oe++){const ge=Q[oe](ke,Re);if(typeof ge=="string")return ge;(0,t.isThenable)(ge)&&(ze||(ze=[]),ze.push(ge))}return ze?(async()=>{for(const oe of ze){const le=await oe;if(typeof le=="string")return le}return null})():null},me=Q.find(ke=>!!ke.allBasenames);me&&(Y.allBasenames=me.allBasenames);const be=Q.reduce((ke,Re)=>Re.allPaths?ke.concat(Re.allPaths):ke,[]);return be.length&&(Y.allPaths=be),Y}const de=function(Y,me,be){let ke,Re;for(let ze=0,oe=Q.length;ze<oe;ze++){const le=Q[ze];le.requiresSiblings&&be&&(me||(me=(0,y.basename)(Y)),ke||(ke=me.substr(0,me.length-(0,y.extname)(Y).length)));const ge=le(Y,me,ke,be);if(typeof ge=="string")return ge;(0,t.isThenable)(ge)&&(Re||(Re=[]),Re.push(ge))}return Re?(async()=>{for(const ze of Re){const oe=await ze;if(typeof oe=="string")return oe}return null})():null},ee=Q.find(Y=>!!Y.allBasenames);ee&&(de.allBasenames=ee.allBasenames);const he=Q.reduce((Y,me)=>me.allPaths?Y.concat(me.allPaths):Y,[]);return he.length&&(de.allPaths=he),de}function V(x,H,Q){if(H===!1)return r;const K=n(x,Q);if(K===r)return r;if(typeof H=="boolean")return K;if(H){const de=H.when;if(typeof de=="string"){const ee=(he,Y,me,be)=>{if(!be||!K(he,Y))return null;const ke=de.replace("$(basename)",me),Re=be(ke);return(0,t.isThenable)(Re)?Re.then(ze=>ze?x:null):Re?x:null};return ee.requiresSiblings=!0,ee}}return K}function B(x,H){const Q=x.filter(Y=>!!Y.basenames);if(Q.length<2)return x;const K=Q.reduce((Y,me)=>{const be=me.basenames;return be?Y.concat(be):Y},[]);let de;if(H){de=[];for(let Y=0,me=K.length;Y<me;Y++)de.push(H)}else de=Q.reduce((Y,me)=>{const be=me.patterns;return be?Y.concat(be):Y},[]);const ee=function(Y,me){if(typeof Y!="string")return null;if(!me){let ke;for(ke=Y.length;ke>0;ke--){const Re=Y.charCodeAt(ke-1);if(Re===47||Re===92)break}me=Y.substr(ke)}const be=K.indexOf(me);return be!==-1?de[be]:null};ee.basenames=K,ee.patterns=de,ee.allBasenames=K;const he=x.filter(Y=>!Y.basenames);return he.push(ee),he}function F(x,H){return(0,l.equals)(x,H,(Q,K)=>typeof Q=="string"&&typeof K=="string"?Q===K:typeof Q!="string"&&typeof K!="string"?Q.base===K.base&&Q.pattern===K.pattern:!1)}e.patternsEquals=F}),define(Ce[108],De([1,0,11,157,22,8,2]),function(J,e,l,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(b){b[b.Paragraph=0]="Paragraph",b[b.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class w{constructor(f="",v=!1){if(this.value=f,typeof this.value!="string")throw(0,l.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(f,v=0){return this.value+=E(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(h,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,v){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(f,v,h){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(f),")"),h&&(this.value+=` "${this._escape(this._escape(h,'"'),")")}"`),this.value+=")",this}_escape(f,v){const h=new RegExp((0,P.escapeRegExpCharacters)(v),"g");return f.replace(h,(c,g)=>f.charAt(g-1)!=="\\"?`\\${c}`:c)}}e.MarkdownString=w;function k(b){return L(b)?!b.value:Array.isArray(b)?b.every(k):!0}e.isEmptyMarkdownString=k;function L(b){return b instanceof w?!0:b&&typeof b=="object"?typeof b.value=="string"&&(typeof b.isTrusted=="boolean"||b.isTrusted===void 0)&&(typeof b.supportThemeIcons=="boolean"||b.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function C(b,f){return b===f?!0:!b||!f?!1:b.value===f.value&&b.isTrusted===f.isTrusted&&b.supportThemeIcons===f.supportThemeIcons&&b.supportHtml===f.supportHtml&&(b.baseUri===f.baseUri||!!b.baseUri&&!!f.baseUri&&(0,I.isEqual)(y.URI.from(b.baseUri),y.URI.from(f.baseUri)))}e.markdownStringEqual=C;function E(b){return b.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function T(b){return b.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function S(b){return b&&b.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=S;function p(b){const f=[],v=b.split("|").map(c=>c.trim());b=v[0];const h=v[1];if(h){const c=/height=(\d+)/.exec(h),g=/width=(\d+)/.exec(h),i=c?c[1]:"",u=g?g[1]:"",r=isFinite(parseInt(u)),n=isFinite(parseInt(i));r&&f.push(`width="${u}"`),n&&f.push(`height="${i}"`)}return{href:b,dimensions:f}}e.parseHrefAndDimensions=p}),define(Ce[109],De([1,0,17,32,9,10,22,8]),function(J,e,l,t,I,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(r,n){const{os:o,tildify:d,relative:s}=n;if(s){const _=k(r,s,o);if(typeof _=="string")return _}let a=r.fsPath;if(o===1&&!P.isWindows?a=a.replace(/\//g,"\\"):o!==1&&P.isWindows&&(a=a.replace(/\\/g,"/")),o!==1&&d?.userHome){const _=d.userHome.fsPath;let R;r.scheme!==d.userHome.scheme&&r.path.startsWith(I.posix.sep)?R=d.userHome.with({path:r.path}).fsPath:R=r.fsPath,a=E(R,_,o)}return(o===1?I.win32:I.posix).normalize(L(a,o===1))}e.getPathLabel=w;function k(r,n,o){const d=o===1?I.win32:I.posix,s=o===3?y.extUri:y.extUriIgnorePathCase,a=n.getWorkspace(),m=(0,l.firstOrDefault)(a.folders);if(!m)return;r.scheme!==m.uri.scheme&&r.path.startsWith(I.posix.sep)&&(r=m.uri.with({path:r.path}));const _=n.getWorkspaceFolder(r);if(!_)return;let R;if(s.isEqual(_.uri,r)?R="":R=s.relativePath(_.uri,r)??"",R&&(R=d.normalize(R)),a.folders.length>1&&!n.noPrefix){const M=_.name?_.name:s.basenameOrAuthority(_.uri);R=R?`${M} \u2022 ${R}`:M}return R}function L(r,n=P.isWindows){return(0,t.hasDriveLetter)(r,n)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=L;let C=Object.create(null);function E(r,n,o=P.OS){if(o===1||!r||!n)return r;let d=C.original===n?C.normalized:void 0;d||(d=n,P.isWindows&&(d=(0,t.toSlashes)(d)),d=`${(0,D.rtrim)(d,I.posix.sep)}${I.posix.sep}`,C={original:n,normalized:d});let s=r;return P.isWindows&&(s=(0,t.toSlashes)(s)),(o===3?s.startsWith(d):(0,D.startsWithIgnoreCase)(s,d))?`~/${s.substr(d.length)}`:r}e.tildify=E;function T(r,n){return r.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=T;const S="\u2026",p="\\\\",b="~";function f(r,n=I.sep){const o=new Array(r.length);let d=!1;for(let s=0;s<r.length;s++){const a=r[s];if(a===""){o[s]=`.${n}`;continue}if(!a){o[s]=a;continue}d=!0;let m="",_=a;_.indexOf(p)===0?(m=_.substr(0,_.indexOf(p)+p.length),_=_.substr(_.indexOf(p)+p.length)):_.indexOf(n)===0?(m=_.substr(0,_.indexOf(n)+n.length),_=_.substr(_.indexOf(n)+n.length)):_.indexOf(b)===0&&(m=_.substr(0,_.indexOf(b)+b.length),_=_.substr(_.indexOf(b)+b.length));const R=_.split(n);for(let M=1;d&&M<=R.length;M++)for(let U=R.length-M;d&&U>=0;U--){d=!1;let A=R.slice(U,U+M).join(n);for(let z=0;!d&&z<r.length;z++)if(z!==s&&r[z]&&r[z].indexOf(A)>-1){const $=U+M===R.length,N=U>0&&r[z].indexOf(n)>-1?n+A:A,V=r[z].endsWith(N);d=!$||V}if(!d){let z="";(R[0].endsWith(":")||m!=="")&&(U===1&&(U=0,M++,A=R[0]+n+A),U>0&&(z=R[0]+n),z=m+z),U>0&&(z=z+S+n),z=z+A,U+M<R.length&&(z=z+n+S),o[s]=z}}d&&(o[s]=a)}return o}e.shorten=f;var v;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function h(r,n=Object.create(null)){const o=[];let d=!1,s="";for(const a of r)if(a==="$"||d&&a==="{")s&&o.push({value:s,type:v.TEXT}),s="",d=!0;else if(a==="}"&&d){const m=n[s];if(typeof m=="string")m.length&&o.push({value:m,type:v.VARIABLE});else if(m){const _=o[o.length-1];(!_||_.type!==v.SEPARATOR)&&o.push({value:m.label,type:v.SEPARATOR})}s="",d=!1}else s+=a;return s&&!d&&o.push({value:s,type:v.TEXT}),o.filter((a,m)=>{if(a.type===v.SEPARATOR){const _=o[m-1],R=o[m+1];return[_,R].every(M=>M&&(M.type===v.VARIABLE||M.type===v.TEXT)&&M.value.length>0)}return!0}).map(a=>a.value).join("")}e.template=h;function c(r,n){return P.isMacintosh||n?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):r.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function g(r,n){return P.isMacintosh||n?r.replace(/\(&&\w\)|&&/g,""):P.isWindows?r.replace(/&&|&/g,o=>o==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=g;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function u(r){const n=r.indexOf("/")!==-1?I.posix:I.win32,o=n.basename(r),d=n.dirname(r);return o.length?{name:o,parentPath:d}:{name:d,parentPath:""}}e.splitName=u}),define(Ce[110],De([1,0,2]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(L){return L.toJSON()}class I{constructor(C){this._uriTransformer=C}transformIncoming(C){const E=this._uriTransformer.transformIncoming(C);return E===C?C:t(l.URI.from(E))}transformOutgoing(C){const E=this._uriTransformer.transformOutgoing(C);return E===C?C:t(l.URI.from(E))}transformOutgoingURI(C){const E=this._uriTransformer.transformOutgoing(C);return E===C?C:l.URI.from(E)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function P(L,C,E){if(!L||E>200)return null;if(typeof L=="object"){if(L instanceof l.URI)return C.transformOutgoing(L);for(const T in L)if(Object.hasOwnProperty.call(L,T)){const S=P(L[T],C,E+1);S!==null&&(L[T]=S)}}return null}function y(L,C){const E=P(L,C,0);return E===null?L:E}e.transformOutgoingURIs=y;function D(L,C,E,T){if(!L||T>200)return null;if(typeof L=="object"){if(L.$mid===1)return E?l.URI.revive(C.transformIncoming(L)):C.transformIncoming(L);for(const S in L)if(Object.hasOwnProperty.call(L,S)){const p=D(L[S],C,E,T+1);p!==null&&(L[S]=p)}}return null}function w(L,C){const E=D(L,C,!1,0);return E===null?L:E}e.transformIncomingURIs=w;function k(L,C){const E=D(L,C,!0,0);return E===null?L:E}e.transformAndReviveIncomingURIs=k}),define(Ce[29],De([1,0,63,82,305,18,32,80,9,10,22,2]),function(J,e,l,t,I,P,y,D,w,k,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function T(N,V=E.UNLINK){if((0,y.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return V===E.UNLINK?p(N):S(N)}async function S(N){try{const V=(0,y.randomPath)((0,t.tmpdir)());try{await l.promises.rename(N,V)}catch(B){return B.code==="ENOENT"?void 0:p(N)}p(V).catch(B=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function p(N){return(0,I.promisify)(l.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function b(N){if((0,y.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");l.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function f(N,V){return c(await(V?v(N):(0,I.promisify)(l.readdir)(N)))}async function v(N){try{return await(0,I.promisify)(l.readdir)(N,{withFileTypes:!0})}catch(F){console.warn("[node.js fs] readdir with filetypes failed with error: ",F)}const V=[],B=await f(N);for(const F of B){let x=!1,H=!1,Q=!1;try{const K=await e.Promises.lstat((0,w.join)(N,F));x=K.isFile(),H=K.isDirectory(),Q=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}V.push({name:F,isFile:()=>x,isDirectory:()=>H,isSymbolicLink:()=>Q})}return V}function h(N){return c(l.readdirSync(N))}e.readdirSync=h;function c(N){return N.map(V=>typeof V=="string"?k.isMacintosh?(0,D.normalizeNFC)(V):V:(V.name=k.isMacintosh?(0,D.normalizeNFC)(V.name):V.name,V))}async function g(N){const V=await f(N),B=[];for(const F of V)await u.existsDirectory((0,w.join)(N,F))&&B.push(F);return B}function i(N,V=1e3){return new Promise(B=>{let F=!1;const x=setInterval(()=>{F||(F=!0,l.access(N,H=>{F=!1,H&&(clearInterval(x),B(void 0))}))},V)})}e.whenDeleted=i;var u;(function(N){async function V(x){let H;try{if(H=await e.Promises.lstat(x),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(k.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw K}throw Q}}N.stat=V;async function B(x){try{const{stat:H,symbolicLink:Q}=await N.stat(x);return H.isFile()&&Q?.dangling!==!0}catch{}return!1}N.existsFile=B;async function F(x){try{const{stat:H,symbolicLink:Q}=await N.stat(x);return H.isDirectory()&&Q?.dangling!==!0}catch{}return!1}N.existsDirectory=F})(u=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new P.ResourceQueue;function n(N,V,B){return r.queueFor(C.URI.file(N),L.extUriBiasedIgnorePathCase).queue(()=>{const F=m(B);return new Promise((x,H)=>s(N,V,F,Q=>Q?H(Q):x()))})}let o=!0;function d(N){o=N}e.configureFlushOnWrite=d;function s(N,V,B,F){if(!o)return l.writeFile(N,V,{mode:B.mode,flag:B.flag},F);l.open(N,B.flag,B.mode,(x,H)=>{if(x)return F(x);l.writeFile(H,V,Q=>{if(Q)return l.close(H,()=>F(Q));l.fdatasync(H,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),d(!1)),l.close(H,de=>F(de))))})})}function a(N,V,B){const F=m(B);if(!o)return l.writeFileSync(N,V,{mode:F.mode,flag:F.flag});const x=l.openSync(N,F.flag,F.mode);try{l.writeFileSync(x,V);try{l.fdatasyncSync(x)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),d(!1)}}finally{l.closeSync(x)}}e.writeFileSync=a;function m(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function _(N,V){if(N!==V)try{await e.Promises.rename(N,V)}catch(B){if(N.toLowerCase()!==V.toLowerCase()&&B.code==="EXDEV"||N.endsWith("."))await R(N,V,{preserveSymlinks:!1}),await T(N,E.MOVE);else throw B}}async function R(N,V,B){return U(N,V,{root:{source:N,target:V},options:B,handledSourcePaths:new Set})}const M=511;async function U(N,V,B){if(B.handledSourcePaths.has(N))return;B.handledSourcePaths.add(N);const{stat:F,symbolicLink:x}=await u.stat(N);if(x){if(B.options.preserveSymlinks)try{return await $(N,V,B)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(x.dangling)return}return F.isDirectory()?A(N,V,F.mode&M,B):z(N,V,F.mode&M)}async function A(N,V,B,F){await e.Promises.mkdir(V,{recursive:!0,mode:B});const x=await f(N);for(const H of x)await U((0,w.join)(N,H),(0,w.join)(V,H),F)}async function z(N,V,B){await e.Promises.copyFile(N,V),await e.Promises.chmod(V,B)}async function $(N,V,B){let F=await e.Promises.readlink(N);(0,y.isEqualOrParent)(F,B.root.source,!k.isLinux)&&(F=(0,w.join)(B.root.target,F.substr(B.root.source.length+1))),await e.Promises.symlink(F,V)}e.Promises=new class{get access(){return(0,I.promisify)(l.access)}get stat(){return(0,I.promisify)(l.stat)}get lstat(){return(0,I.promisify)(l.lstat)}get utimes(){return(0,I.promisify)(l.utimes)}get read(){return(N,V,B,F,x)=>new Promise((H,Q)=>{l.read(N,V,B,F,x,(K,de,ee)=>K?Q(K):H({bytesRead:de,buffer:ee}))})}get readFile(){return(0,I.promisify)(l.readFile)}get write(){return(N,V,B,F,x)=>new Promise((H,Q)=>{l.write(N,V,B,F,x,(K,de,ee)=>K?Q(K):H({bytesWritten:de,buffer:ee}))})}get appendFile(){return(0,I.promisify)(l.appendFile)}get fdatasync(){return(0,I.promisify)(l.fdatasync)}get truncate(){return(0,I.promisify)(l.truncate)}get rename(){return(0,I.promisify)(l.rename)}get copyFile(){return(0,I.promisify)(l.copyFile)}get open(){return(0,I.promisify)(l.open)}get close(){return(0,I.promisify)(l.close)}get symlink(){return(0,I.promisify)(l.symlink)}get readlink(){return(0,I.promisify)(l.readlink)}get chmod(){return(0,I.promisify)(l.chmod)}get mkdir(){return(0,I.promisify)(l.mkdir)}get unlink(){return(0,I.promisify)(l.unlink)}get rmdir(){return(0,I.promisify)(l.rmdir)}get realpath(){return(0,I.promisify)(l.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return g}get writeFile(){return n}get rm(){return T}get move(){return _}get copy(){return R}}}),define(Ce[111],De([1,0,63,9,10,8,29]),function(J,e,l,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(E){if(I.isLinux)return E;const T=(0,t.dirname)(E);if(E===T)return E;const S=((0,t.basename)(E)||E).toLowerCase();try{const b=(0,y.readdirSync)(T).filter(f=>f.toLowerCase()===S);if(b.length===1){const f=D(T);if(f)return(0,t.join)(f,b[0])}else if(b.length>1){const f=b.indexOf(S);if(f>=0){const v=D(T);if(v)return(0,t.join)(v,b[f])}}}catch{}return null}e.realcaseSync=D;async function w(E){if(I.isLinux)return E;const T=(0,t.dirname)(E);if(E===T)return E;const S=((0,t.basename)(E)||E).toLowerCase();try{const b=(await y.Promises.readdir(T)).filter(f=>f.toLowerCase()===S);if(b.length===1){const f=await w(T);if(f)return(0,t.join)(f,b[0])}else if(b.length>1){const f=b.indexOf(S);if(f>=0){const v=await w(T);if(v)return(0,t.join)(v,b[f])}}}catch{}return null}e.realcase=w;async function k(E){try{return await y.Promises.realpath(E)}catch{const S=C(E);return await y.Promises.access(S,l.constants.R_OK),S}}e.realpath=k;function L(E){try{return l.realpathSync(E)}catch{const S=C(E);return l.accessSync(S,l.constants.R_OK),S}}e.realpathSync=L;function C(E){return(0,P.rtrim)((0,t.normalize)(E),t.sep)}}),define(Ce[112],De([1,0,9,10,36,104,13,29]),function(J,e,l,t,I,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function w(C=I.env){return C.comspec||"cmd.exe"}e.getWindowsShell=w;function k(C){let E=[],T=!1;const S=function(p){if(T){E.push(p);return}(!C.send(p,f=>{if(f&&console.error(f),T=!1,E.length>0){const v=E.slice(0);E=[],v.forEach(h=>S(h))}})||t.isWindows)&&(T=!0)};return{send:S}}e.createQueuedSender=k;var L;(function(C){async function E(T,S,p){if(l.isAbsolute(T))return T;if(S===void 0&&(S=I.cwd()),l.dirname(T)!=="."||(p===void 0&&y.isString(I.env.PATH)&&(p=I.env.PATH.split(l.delimiter)),p===void 0||p.length===0))return l.join(S,T);async function f(v){if(await D.Promises.exists(v)){let h;try{h=await D.Promises.stat(v)}catch(c){c.message.startsWith("EACCES")&&(h=await D.Promises.lstat(v))}return h?!h.isDirectory():!1}return!1}for(const v of p){let h;if(l.isAbsolute(v)?h=l.join(v,T):h=l.join(S,v,T),await f(h))return h;let c=h+".com";if(await f(c)||(c=h+".exe",await f(c)))return c}return l.join(S,T)}C.findExecutable=E})(L=e.win32||(e.win32={}))});var je=this&&this.__decorate||function(J,e,l,t){var I=arguments.length,P=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,l):t,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(J,e,l,t);else for(var D=J.length-1;D>=0;D--)(y=J[D])&&(P=(I<3?y(P):I>3?y(e,l,P):y(e,l))||P);return I>3&&P&&Object.defineProperty(e,l,P),P};define(Ce[113],De([1,0,17,18,23,21,59,11,4,6,81,8,13]),function(J,e,l,t,I,P,y,D,w,k,L,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var T;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(T=e.RequestType||(e.RequestType={}));function S(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function b(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(f||(f={}));class v{constructor(H){this.buffer=H,this.pos=0}read(H){const Q=this.buffer.slice(this.pos,this.pos+H);return this.pos+=Q.byteLength,Q}}class h{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(H){this.buffers.push(H)}}var c;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(c||(c={}));function g(x){const H=I.VSBuffer.alloc(4);return H.writeUInt32BE(x,0),H}function i(x){return x.read(4).readUInt32BE(0)}function u(x){const H=I.VSBuffer.alloc(1);return H.writeUInt8(x,0),H}const r={Undefined:u(c.Undefined),String:u(c.String),Buffer:u(c.Buffer),VSBuffer:u(c.VSBuffer),Array:u(c.Array),Object:u(c.Object)},n=typeof Buffer<"u";function o(x,H){if(typeof H>"u")x.write(r.Undefined);else if(typeof H=="string"){const Q=I.VSBuffer.fromString(H);x.write(r.String),x.write(g(Q.byteLength)),x.write(Q)}else if(n&&Buffer.isBuffer(H)){const Q=I.VSBuffer.wrap(H);x.write(r.Buffer),x.write(g(Q.byteLength)),x.write(Q)}else if(H instanceof I.VSBuffer)x.write(r.VSBuffer),x.write(g(H.byteLength)),x.write(H);else if(Array.isArray(H)){x.write(r.Array),x.write(g(H.length));for(const Q of H)o(x,Q)}else{const Q=I.VSBuffer.fromString(JSON.stringify(H));x.write(r.Object),x.write(g(Q.byteLength)),x.write(Q)}}function d(x){switch(x.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return x.read(i(x)).toString();case c.Buffer:return x.read(i(x)).buffer;case c.VSBuffer:return x.read(i(x));case c.Array:{const Q=i(x),K=[];for(let de=0;de<Q;de++)K.push(d(x));return K}case c.Object:return JSON.parse(x.read(i(x)).toString())}}class s{constructor(H,Q,K=null,de=1e3){this.protocol=H,this.ctx=Q,this.logger=K,this.timeoutDelay=de,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:200})}registerChannel(H,Q){this.channels.set(H,Q),setTimeout(()=>this.flushPendingRequests(H),0)}sendResponse(H){switch(H.type){case 200:{const Q=this.send([H.type]);this.logger?.logOutgoing(Q,0,1,b(H.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([H.type,H.id],H.data);this.logger?.logOutgoing(Q,H.id,1,b(H.type),H.data);return}}}send(H,Q=void 0){const K=new h;return o(K,H),o(K,Q),this.sendBuffer(K.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onRawMessage(H){const Q=new v(H),K=d(Q),de=d(Q),ee=K[0];switch(ee){case 100:return this.logger?.logIncoming(H.byteLength,K[1],1,`${S(ee)}: ${K[2]}.${K[3]}`,de),this.onPromise({type:ee,id:K[1],channelName:K[2],name:K[3],arg:de});case 102:return this.logger?.logIncoming(H.byteLength,K[1],1,`${S(ee)}: ${K[2]}.${K[3]}`,de),this.onEventListen({type:ee,id:K[1],channelName:K[2],name:K[3],arg:de});case 101:return this.logger?.logIncoming(H.byteLength,K[1],1,`${S(ee)}`),this.disposeActiveRequest({type:ee,id:K[1]});case 103:return this.logger?.logIncoming(H.byteLength,K[1],1,`${S(ee)}`),this.disposeActiveRequest({type:ee,id:K[1]})}}onPromise(H){const Q=this.channels.get(H.channelName);if(!Q){this.collectPendingRequest(H);return}const K=new P.CancellationTokenSource;let de;try{de=Q.call(this.ctx,H.name,H.arg,K.token)}catch(Y){de=Promise.reject(Y)}const ee=H.id;de.then(Y=>{this.sendResponse({id:ee,data:Y,type:201}),this.activeRequests.delete(H.id)},Y=>{Y instanceof Error?this.sendResponse({id:ee,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:ee,data:Y,type:203}),this.activeRequests.delete(H.id)});const he=(0,k.toDisposable)(()=>K.cancel());this.activeRequests.set(H.id,he)}onEventListen(H){const Q=this.channels.get(H.channelName);if(!Q){this.collectPendingRequest(H);return}const K=H.id,ee=Q.listen(this.ctx,H.name,H.arg)(he=>this.sendResponse({id:K,data:he,type:204}));this.activeRequests.set(H.id,ee)}disposeActiveRequest(H){const Q=this.activeRequests.get(H.id);Q&&(Q.dispose(),this.activeRequests.delete(H.id))}collectPendingRequest(H){let Q=this.pendingRequests.get(H.channelName);Q||(Q=[],this.pendingRequests.set(H.channelName,Q));const K=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.sendResponse({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:H,timeoutTimer:K})}flushPendingRequests(H){const Q=this.pendingRequests.get(H);if(Q){for(const K of Q)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete(H)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,k.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=s;var a;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));class m{constructor(H,Q=null){this.protocol=H,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=Q}getChannel(H){const Q=this;return{call(K,de,ee){return Q.isDisposed?Promise.reject(new D.CancellationError):Q.requestPromise(H,K,de,ee)},listen(K,de){return Q.isDisposed?w.Event.None:Q.requestEvent(H,K,de)}}}requestPromise(H,Q,K,de=P.CancellationToken.None){const ee=this.lastRequestId++,Y={id:ee,type:100,channelName:H,name:Q,arg:K};if(de.isCancellationRequested)return Promise.reject(new D.CancellationError);let me;return new Promise((ke,Re)=>{if(de.isCancellationRequested)return Re(new D.CancellationError);const ze=()=>{const Z=ae=>{switch(ae.type){case 201:this.handlers.delete(ee),ke(ae.data);break;case 202:{this.handlers.delete(ee);const ne=new Error(ae.data.message);ne.stack=ae.data.stack,ne.name=ae.data.name,Re(ne);break}case 203:this.handlers.delete(ee),Re(ae.data);break}};this.handlers.set(ee,Z),this.sendRequest(Y)};let oe=null;this.state===f.Idle?ze():(oe=(0,t.createCancelablePromise)(Z=>this.whenInitialized()),oe.then(()=>{oe=null,ze()}));const le=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:ee,type:101}),Re(new D.CancellationError)},ge=de.onCancellationRequested(le);me=(0,k.combinedDisposable)((0,k.toDisposable)(le),ge),this.activeRequests.add(me)}).finally(()=>{this.activeRequests.delete(me)})}requestEvent(H,Q,K){const de=this.lastRequestId++,he={id:de,type:102,channelName:H,name:Q,arg:K};let Y=null;const me=new w.Emitter({onFirstListenerAdd:()=>{Y=(0,t.createCancelablePromise)(ke=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(me),this.sendRequest(he)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(me),this.sendRequest({id:de,type:103}))}}),be=ke=>me.fire(ke.data);return this.handlers.set(de,be),me.event}sendRequest(H){switch(H.type){case 100:case 102:{const Q=this.send([H.type,H.id,H.channelName,H.name],H.arg);this.logger?.logOutgoing(Q,H.id,0,`${S(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const Q=this.send([H.type,H.id]);this.logger?.logOutgoing(Q,H.id,0,S(H.type));return}}}send(H,Q=void 0){const K=new h;return o(K,H),o(K,Q),this.sendBuffer(K.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onBuffer(H){const Q=new v(H),K=d(Q),de=d(Q),ee=K[0];switch(ee){case 200:return this.logger?.logIncoming(H.byteLength,0,0,b(ee)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(H.byteLength,K[1],0,b(ee),de),this.onResponse({type:K[0],id:K[1],data:de})}}onResponse(H){if(H.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(H.id)?.(H)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,k.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}je([y.memoize],m.prototype,"onDidInitializePromise",null),e.ChannelClient=m;class _{get connections(){const H=[];return this._connections.forEach(Q=>H.push(Q)),H}constructor(H){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,H(({protocol:Q,onDidClientDisconnect:K})=>{w.Event.once(Q.onMessage)(ee=>{const he=new v(ee),Y=d(he),me=new s(Q,Y),be=new m(Q);this.channels.forEach((Re,ze)=>me.registerChannel(ze,Re));const ke={channelServer:me,channelClient:be,ctx:Y};this._connections.add(ke),this._onDidAddConnection.fire(ke),K(()=>{me.dispose(),be.dispose(),this._connections.delete(ke),this._onDidRemoveConnection.fire(ke)})})})}getChannel(H,Q){const K=this;return{call(de,ee,he){let Y;if((0,E.isFunction)(Q)){const be=(0,l.getRandomElement)(K.connections.filter(Q));Y=be?Promise.resolve(be):w.Event.toPromise(w.Event.filter(K.onDidAddConnection,Q))}else Y=Q.routeCall(K,de,ee);const me=Y.then(be=>be.channelClient.getChannel(H));return M(me).call(de,ee,he)},listen(de,ee){if((0,E.isFunction)(Q))return K.getMulticastEvent(H,Q,de,ee);const he=Q.routeEvent(K,de,ee).then(Y=>Y.channelClient.getChannel(H));return M(he).listen(de,ee)}}}getMulticastEvent(H,Q,K,de){const ee=this;let he=new k.DisposableStore;const Y=new w.Emitter({onFirstListenerAdd:()=>{he=new k.DisposableStore;const me=new w.EventMultiplexer,be=new Map,ke=ze=>{const le=ze.channelClient.getChannel(H).listen(K,de),ge=me.add(le);be.set(ze,ge)},Re=ze=>{const oe=be.get(ze);!oe||(oe.dispose(),be.delete(ze))};ee.connections.filter(Q).forEach(ke),w.Event.filter(ee.onDidAddConnection,Q)(ke,void 0,he),ee.onDidRemoveConnection(Re,void 0,he),me.event(Y.fire,Y,he),he.add(me)},onLastListenerRemove:()=>{he.dispose()}});return Y.event}registerChannel(H,Q){this.channels.set(H,Q),this._connections.forEach(K=>{K.channelServer.registerChannel(H,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class R{constructor(H,Q,K=null){const de=new h;o(de,Q),H.send(de.buffer),this.channelClient=new m(H,K),this.channelServer=new s(H,Q,K)}getChannel(H){return this.channelClient.getChannel(H)}registerChannel(H,Q){this.channelServer.registerChannel(H,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function M(x){return{call(H,Q,K){return x.then(de=>de.call(H,Q,K))},listen(H,Q){const K=new w.Relay;return x.then(de=>K.input=de.listen(H,Q)),K.event}}}e.getDelayedChannel=M;function U(x){let H=!1;return{call(Q,K,de){return H?x.call(Q,K,de):(0,t.timeout)(0).then(()=>H=!0).then(()=>x.call(Q,K,de))},listen(Q,K){if(H)return x.listen(Q,K);const de=new w.Relay;return(0,t.timeout)(0).then(()=>H=!0).then(()=>de.input=x.listen(Q,K)),de.event}}}e.getNextTickChannel=U;class A{constructor(H){this.fn=H}routeCall(H){return this.route(H)}routeEvent(H){return this.route(H)}async route(H){for(const Q of H.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await w.Event.toPromise(H.onDidAddConnection),await this.route(H)}}e.StaticRouter=A;var z;(function(x){function H(ee,he){const Y=ee,me=he&&he.disableMarshalling,be=new Map;for(const ke in Y)K(ke)&&be.set(ke,w.Event.buffer(Y[ke],!0));return new class{listen(ke,Re,ze){const oe=be.get(Re);if(oe)return oe;if(de(Re)){const le=Y[Re];if(typeof le=="function")return le.call(Y,ze)}throw new Error(`Event not found: ${Re}`)}call(ke,Re,ze){const oe=Y[Re];if(typeof oe=="function"){if(!me&&Array.isArray(ze))for(let le=0;le<ze.length;le++)ze[le]=(0,L.revive)(ze[le]);return oe.apply(Y,ze)}throw new Error(`Method not found: ${Re}`)}}}x.fromService=H;function Q(ee,he){const Y=he&&he.disableMarshalling;return new Proxy({},{get(me,be){if(typeof be=="string")return he?.properties?.has(be)?he.properties.get(be):de(be)?function(ke){return ee.listen(be,ke)}:K(be)?ee.listen(be):async function(...ke){let Re;he&&!(0,E.isUndefinedOrNull)(he.context)?Re=[he.context,...ke]:Re=ke;const ze=await ee.call(be,Re);return Y?ze:(0,L.revive)(ze)};throw new Error(`Property not found: ${String(be)}`)}})}x.toService=Q;function K(ee){return ee[0]==="o"&&ee[1]==="n"&&C.isUpperAsciiLetter(ee.charCodeAt(2))}function de(ee){return/^onDynamic/.test(ee)&&C.isUpperAsciiLetter(ee.charCodeAt(9))}})(z=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const H=x.toString();if(H!=="[object Object]")return H}return x}function V(x){return Array.isArray(x)?x.map(N):N(x)}function B(x,H,Q,K,de,ee,he){he=V(he);const Y=$[de],me=Y[K%Y.length];let be=[`%c[${x}]%c[${String(H).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${me}`];/\($/.test(ee)?(be=be.concat(he),be.push(")")):be.push(he),console.log.apply(console,be)}e.logWithColors=B;class F{constructor(H,Q){this._outgoingPrefix=H,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(H,Q,K,de,ee){this._totalOutgoing+=H,B(this._outgoingPrefix,this._totalOutgoing,H,Q,K,de,ee)}logIncoming(H,Q,K,de,ee){this._totalIncoming+=H,B(this._incomingPrefix,this._totalIncoming,H,Q,K,de,ee)}}e.IPCLogger=F}),define(Ce[114],De([1,0,23,4,6,113]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var y;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(y=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var D;(function(n){n.enableDiagnostics=!1,n.records=[];const o=new WeakMap;let d=0;function s(m,_){if(!o.has(m)){const R=String(++d);o.set(m,R)}return o.get(m)}function a(m,_,R,M){if(!n.enableDiagnostics)return;const U=s(m,_);if(M instanceof l.VSBuffer||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const A=l.VSBuffer.alloc(M.byteLength);A.set(M),n.records.push({timestamp:Date.now(),id:U,label:_,type:R,buff:A})}else n.records.push({timestamp:Date.now(),id:U,label:_,type:R,data:M})}n.traceSocketEvent=a})(D=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let k=null;function L(){return k||(k=l.VSBuffer.alloc(0)),k}class C{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,d){if(o===0)return L();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const _=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=o),_}if(this._chunks[0].byteLength>o){const _=this._chunks[0].slice(0,o);return d&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),_}const s=l.VSBuffer.alloc(o);let a=0,m=0;for(;o>0;){const _=this._chunks[m];if(_.byteLength>o){const R=_.slice(0,o);s.set(R,a),a+=o,d&&(this._chunks[m]=_.slice(o),this._totalLength-=o),o-=o}else s.set(_,a),a+=_.byteLength,d?(this._chunks.shift(),this._totalLength-=_.byteLength):m++,o-=_.byteLength}return s}}e.ChunkStream=C;var E;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(E||(E={}));function T(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(S=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(o,d,s,a){this.type=o,this.id=d,this.ack=s,this.data=a,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends I.Disposable{constructor(o){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const s=this._state.messageType,a=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",d),this._onMessage.fire(new p(s,a,m,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=l.VSBuffer.alloc(13);d.writeUInt8(o.type,0),d.writeUInt32BE(o.id,1),d.writeUInt32BE(o.ack,5),d.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:T(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(d,o.data)}_bufferAdd(o,d){const s=this._totalLength===0;return this._data.push(o,d),this._totalLength+=o.byteLength+d.byteLength,s}_bufferTake(){const o=l.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,d){this._bufferAdd(o,d)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class v extends I.Disposable{constructor(o){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===1&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new p(1,0,0,o))}}e.Protocol=v;class h extends P.IPCClient{static fromSocket(o,d){return new h(new v(o),d)}get onDidDispose(){return this.protocol.onDidDispose}constructor(o,d,s=null){super(o,d,s),this.protocol=o}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=h;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class g{constructor(o){this.data=o,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let o=0,d=this._first;for(;d;)d=d.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let d=0,s=this._first;for(;s;)o[d++]=s.data,s=s.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const d=new g(o);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class u{static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}constructor(){this.lastRuns=[];const o=Date.now();for(let d=0;d<u._HISTORY_LENGTH;d++)this.lastRuns[d]=o-1e3*d;setInterval(()=>{for(let d=u._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}load(){const o=Date.now(),d=(1+u._HISTORY_LENGTH)*1e3;let s=0;for(let a=0;a<u._HISTORY_LENGTH;a++)o-this.lastRuns[a]<=d&&s++;return 1-s/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class r{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(o,d=null,s=u.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=s,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),d&&this._socketReader.acceptChunk(d),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new p(5,0,0,L());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new p(7,0,0,L());this._socketWriter.write(o)}sendResume(){const o=new p(8,0,0,L());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,d){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(s=>this._onSocketClose.fire(s))),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new p(3,0,this._incomingAckId,L());this._socketWriter.write(o);const d=this._outgoingUnackMsg.toArray();for(let s=0,a=d.length;s<a;s++)this._socketWriter.write(d[s]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new p(6,0,0,L())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const d=this._outgoingUnackMsg.toArray();for(let s=0,a=d.length;s<a;s++)this._socketWriter.write(d[s]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const s=new p(1,d,this._incomingAckId,o);this._outgoingUnackMsg.push(s),this._isReconnecting||(this._socketWriter.write(s),this._recvAckCheck())}sendControl(o){const d=new p(2,0,0,o);this._socketWriter.write(d)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),d=Date.now()-o.writtenTime,s=Date.now()-this._socketReader.lastReadTime,a=Date.now()-this._lastSocketTimeoutTime;if(d>=2e4&&s>=2e4&&a>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:s});return}const m=Math.max(2e4-d,2e4-s,2e4-a,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},m)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new p(3,0,this._incomingAckId,L());this._socketWriter.write(o)}_sendKeepAlive(){const o=new p(9,0,0,L());this._socketWriter.write(o)}}e.PersistentProtocol=r}),define(Ce[115],De([1,0,23,11,4,6,9,10,31,113,114]),function(J,e,l,t,I,P,y,D,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function C(){return{crypto:J.__$__nodeRequire("crypto"),zlib:J.__$__nodeRequire("zlib"),net:J.__$__nodeRequire("net"),os:J.__$__nodeRequire("os")}}class E{traceSocketEvent(s,a){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,a)}constructor(s,a=""){this._canWrite=!0,this.debugLabel=a,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=m=>{if(this.traceSocketEvent("error",{code:m?.code,message:m?.message}),m){if(m.code==="EPIPE")return;(0,t.onUnexpectedError)(m)}},this.socket.on("error",this._errorListener),this._closeListener=m=>{this.traceSocketEvent("close",{hadError:m}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(s){const a=m=>{this.traceSocketEvent("read",m),s(l.VSBuffer.wrap(m))};return this.socket.on("data",a),{dispose:()=>this.socket.off("data",a)}}onClose(s){const a=m=>{s({type:0,hadError:m,error:void 0})};return this.socket.on("close",a),{dispose:()=>this.socket.off("close",a)}}onEnd(s){const a=()=>{s()};return this.socket.on("end",a),{dispose:()=>this.socket.off("end",a)}}write(s){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,a=>{if(a){if(a.code==="EPIPE")return;(0,t.onUnexpectedError)(a)}})}catch(a){if(a.code==="EPIPE")return;(0,t.onUnexpectedError)(a)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,a)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const m=()=>{this.socket.off("close",m),this.socket.off("end",m),this.socket.off("error",m),this.socket.off("timeout",m),this.socket.off("drain",m),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",m),this.socket.on("end",m),this.socket.on("error",m),this.socket.on("timeout",m),this.socket.on("drain",m)})}}e.NodeSocket=E;var T;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(T||(T={}));var S;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(S||(S={}));class p extends P.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(s,a){this.socket.traceSocketEvent(s,a)}constructor(s,a,m,_){super(),this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:a,inflateBytesLength:m?.byteLength||0,recordInflateBytes:_}),this._flowManager=this._register(new b(this,a,m,_,this._onData,(R,M)=>this._write(R,M))),this._register(this._flowManager.onError(R=>{console.error(R),(0,t.onUnexpectedError)(R),this._onClose.fire({type:0,hadError:!0,error:R})})),this._incomingData=new L.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(R=>this._onClose.fire(R)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this._onData.event(s)}onClose(s){return this._onClose.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this._flowManager.writeMessage(s)}_write(s,a){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let m=2;s.byteLength<126?m+=0:s.byteLength<2**16?m+=2:m+=8;const _=l.VSBuffer.alloc(m);if(a?_.writeUInt8(194,0):_.writeUInt8(130,0),s.byteLength<126)_.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){_.writeUInt8(126,1);let R=1;_.writeUInt8(s.byteLength>>>8&255,++R),_.writeUInt8(s.byteLength>>>0&255,++R)}else{_.writeUInt8(127,1);let R=1;_.writeUInt8(0,++R),_.writeUInt8(0,++R),_.writeUInt8(0,++R),_.writeUInt8(0,++R),_.writeUInt8(s.byteLength>>>24&255,++R),_.writeUInt8(s.byteLength>>>16&255,++R),_.writeUInt8(s.byteLength>>>8&255,++R),_.writeUInt8(s.byteLength>>>0&255,++R)}this.socket.write(l.VSBuffer.concat([_,s]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(s){if(s.byteLength!==0){for(this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const a=this._incomingData.peek(this._state.readLen),m=a.readUInt8(0),_=(m&128)>>>7,R=(m&64)>>>6,M=a.readUInt8(1),U=(M&128)>>>7,A=M&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(A===126?2:0)+(A===127?8:0),this._state.fin=_,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(R)),this._state.firstFrameOfMessage=Boolean(_),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const a=this._incomingData.read(this._state.readLen),m=a.readUInt8(1),_=(m&128)>>>7;let R=m&127,M=1;R===126?R=a.readUInt8(++M)*2**8+a.readUInt8(++M):R===127&&(R=a.readUInt8(++M)*0+a.readUInt8(++M)*0+a.readUInt8(++M)*0+a.readUInt8(++M)*0+a.readUInt8(++M)*2**24+a.readUInt8(++M)*2**16+a.readUInt8(++M)*2**8+a.readUInt8(++M));let U=0;_&&(U=a.readUInt8(++M)*2**24+a.readUInt8(++M)*2**16+a.readUInt8(++M)*2**8+a.readUInt8(++M)),this._state.state=3,this._state.readLen=R,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const a=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",a),h(a,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",a),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(a,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class b extends P.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:l.VSBuffer.alloc(0)}constructor(s,a,m,_,R,M){super(),this._tracer=s,this._onData=R,this._writeFn=M,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,a?(this._zlibInflateStream=this._register(new f(this._tracer,_,m,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(s){this._writeQueue.push(s),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const s=this._writeQueue.shift();if(this._zlibDeflateStream){const a=await this._deflateMessage(this._zlibDeflateStream,s);this._writeFn(a,!0)}else this._writeFn(s,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(s,a){return new Promise((m,_)=>{s.write(a),s.flush(R=>m(R))})}acceptFrame(s,a,m){this._readQueue.push({data:s,isCompressed:a,isLastFrameOfMessage:m}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const s=this._readQueue.shift();if(this._zlibInflateStream&&s.isCompressed){const a=await this._inflateFrame(this._zlibInflateStream,s.data,s.isLastFrameOfMessage);this._onData.fire(a)}else this._onData.fire(s.data)}this._isProcessingReadQueue=!1}}_inflateFrame(s,a,m){return new Promise((_,R)=>{s.write(a),m&&s.write(l.VSBuffer.fromByteArray([0,0,255,255])),s.flush(M=>_(M))})}}class f extends P.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?l.VSBuffer.concat(this._recordedInflateBytes):l.VSBuffer.alloc(0)}constructor(s,a,m,_){super(),this._tracer=s,this._recordInflateBytes=a,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=C().zlib.createInflateRaw(_),this._zlibInflate.on("error",R=>{this._tracer.traceSocketEvent("zlibInflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibInflate.on("data",R=>{this._tracer.traceSocketEvent("zlibInflateData",R),this._pendingInflateData.push(l.VSBuffer.wrap(R))}),m&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",m.buffer),this._zlibInflate.write(m.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(s){this._recordInflateBytes&&this._recordedInflateBytes.push(s.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",s),this._zlibInflate.write(s.buffer)}flush(s){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const a=l.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,s(a)})}}class v extends P.Disposable{constructor(s,a){super(),this._tracer=s,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=C().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",m=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:m?.message,code:m?.code}),this._onError.fire(m)}),this._zlibDeflate.on("data",m=>{this._tracer.traceSocketEvent("zlibDeflateData",m),this._pendingDeflateData.push(l.VSBuffer.wrap(m))})}write(s){this._tracer.traceSocketEvent("zlibDeflateWrite",s.buffer),this._zlibDeflate.write(s.buffer)}flush(s){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let a=l.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,a=a.slice(0,a.byteLength-4),s(a)})}}function h(d,s){if(s===0)return;const a=d.byteLength>>>2;for(let A=0;A<a;A++){const z=d.readUInt32BE(A*4);d.writeUInt32BE(z^s,A*4)}const m=a*4,_=d.byteLength-m,R=s>>>24&255,M=s>>>16&255,U=s>>>8&255;_>=1&&d.writeUInt8(d.readUInt8(m)^R,m),_>=2&&d.writeUInt8(d.readUInt8(m+1)^M,m+1),_>=3&&d.writeUInt8(d.readUInt8(m+2)^U,m+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const c={[2]:107,[1]:103};function g(){const d=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):s=(0,y.join)(C().os.tmpdir(),`vscode-ipc-${d}.sock`),u(s),s}e.createRandomIPCHandle=g;function i(d,s,a){const m=C().crypto.createHash("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${m}-${a}-${s}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${m.substr(0,8)}-${a}-${s}.sock`):_=(0,y.join)(d,`${a}-${s}.sock`),u(_),_}e.createStaticIPCHandle=i;function u(d){const s=c[D.platform];typeof s=="number"&&d.length>=s&&console.warn(`WARNING: IPC handle "${d}" is longer than ${s} chars, try a shorter --user-data-dir`)}class r extends k.IPCServer{static toClientConnectionEvent(s){const a=I.Event.fromNodeEventEmitter(s,"connection");return I.Event.map(a,m=>({protocol:new L.Protocol(new E(m,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(m,"close"))}))}constructor(s){super(r.toClientConnectionEvent(s)),this.server=s}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function n(d){return new Promise((s,a)=>{const m=C().net.createServer();m.on("error",a),m.listen(d,()=>{m.removeListener("error",a),s(new r(m))})})}e.serve=n;function o(d,s){return new Promise((a,m)=>{const _=C().net.createConnection(d,()=>{_.removeListener("error",m),a(L.Client.fromSocket(new E(_,`ipc-client${s}`),s))});_.once("error",m)})}e.connect=o}),define(Ce[158],De([1,0,37,9]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(P,y,D,w,k,L){if(Array.isArray(P)){let C=0;for(const E of P){const T=I(E,y,D,w,k,L);if(T===10)return T;T>C&&(C=T)}return C}else{if(typeof P=="string")return w?P==="*"?5:P===D?10:0:0;if(P){const{language:C,pattern:E,scheme:T,hasAccessToAllModels:S,notebookType:p}=P;if(!w&&!S)return 0;p&&k&&(y=k);let b=0;if(T)if(T===y.scheme)b=10;else if(T==="*")b=5;else return 0;if(C)if(C===D)b=10;else if(C==="*")b=Math.max(b,5);else return 0;if(p)if(p===L)b=10;else if(p==="*"&&L!==void 0)b=Math.max(b,5);else return 0;if(E){let f;if(typeof E=="string"?f=E:f={...E,base:(0,t.normalize)(E.base)},f===y.fsPath||(0,l.match)(f,y.fsPath))b=10;else return 0}return b}else return 0}}e.score=I}),define(Ce[159],De([1,0,8,49,150]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(D,w,k,L){this._uri=D,this._lines=w,this._eol=k,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const w=D.changes;for(const k of w)this._acceptDeleteRange(k.range),this._acceptInsertText(new t.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,w=this._lines.length,k=new Uint32Array(w);for(let L=0;L<w;L++)k[L]=this._lines[L].length+D;this._lineStarts=new I.PrefixSumComputer(k)}}_setLineText(D,w){this._lines[D]=w,this._lineStarts&&this._lineStarts.setValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,w){if(w.length===0)return;const k=(0,l.splitLines)(w);if(k.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+k[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}k[k.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+k[0]);const L=new Uint32Array(k.length-1);for(let C=1;C<k.length;C++)this._lines.splice(D.lineNumber+C-1,0,k[C]),L[C-1]=k[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,L)}}e.MirrorTextModel=P}),define(Ce[160],De([1,0,8,147,49,35,102]),function(J,e,l,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class w{constructor(v,h,c,g){this.searchString=v,this.isRegex=h,this.matchCase=c,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=k(this.searchString):v=this.searchString.indexOf(`
`)>=0;let h=null;try{h=l.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!h)return null;let c=!this.isRegex&&!v;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new y.SearchData(h,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=w;function k(f){if(!f||f.length===0)return!1;for(let v=0,h=f.length;v<h;v++){const c=f.charCodeAt(v);if(c===10)return!0;if(c===92){if(v++,v>=h)break;const g=f.charCodeAt(v);if(g===110||g===114||g===87)return!0}}return!1}e.isMultilineRegexSource=k;function L(f,v,h){if(!h)return new y.FindMatch(f,null);const c=[];for(let g=0,i=v.length;g<i;g++)c[g]=v[g];return new y.FindMatch(f,c)}e.createFindMatch=L;class C{constructor(v){const h=[];let c=0;for(let g=0,i=v.length;g<i;g++)v.charCodeAt(g)===10&&(h[c++]=g);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(v){const h=this._lineFeedsOffsets;let c=0,g=h.length-1;if(g===-1||v<=h[0])return 0;for(;c<g;){const i=c+((g-c)/2>>0);h[i]>=v?g=i-1:h[i+1]>=v?(c=i,g=i):c=i+1}return c+1}}class E{static findMatches(v,h,c,g,i){const u=h.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(v,c,new b(u.wordSeparators,u.regex),g,i):this._doFindMatchesLineByLine(v,c,u,g,i):[]}static _getMultilineMatchRange(v,h,c,g,i,u){let r,n=0;g?(n=g.findLineFeedCountBeforeOffset(i),r=h+i+n):r=h+i;let o;if(g){const m=g.findLineFeedCountBeforeOffset(i+u.length)-n;o=r+u.length+m}else o=r+u.length;const d=v.getPositionAt(r),s=v.getPositionAt(o);return new P.Range(d.lineNumber,d.column,s.lineNumber,s.column)}static _doFindMatchesMultiline(v,h,c,g,i){const u=v.getOffsetAt(h.getStartPosition()),r=v.getValueInRange(h,1),n=v.getEOL()===`\r
`?new C(r):null,o=[];let d=0,s;for(c.reset(0);s=c.next(r);)if(o[d++]=L(this._getMultilineMatchRange(v,u,r,n,s.index,s[0]),s,g),d>=i)return o;return o}static _doFindMatchesLineByLine(v,h,c,g,i){const u=[];let r=0;if(h.startLineNumber===h.endLineNumber){const o=v.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return r=this._findMatchesInLine(c,o,h.startLineNumber,h.startColumn-1,r,u,g,i),u}const n=v.getLineContent(h.startLineNumber).substring(h.startColumn-1);r=this._findMatchesInLine(c,n,h.startLineNumber,h.startColumn-1,r,u,g,i);for(let o=h.startLineNumber+1;o<h.endLineNumber&&r<i;o++)r=this._findMatchesInLine(c,v.getLineContent(o),o,0,r,u,g,i);if(r<i){const o=v.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);r=this._findMatchesInLine(c,o,h.endLineNumber,0,r,u,g,i)}return u}static _findMatchesInLine(v,h,c,g,i,u,r,n){const o=v.wordSeparators;if(!r&&v.simpleSearch){const a=v.simpleSearch,m=a.length,_=h.length;let R=-m;for(;(R=h.indexOf(a,R+m))!==-1;)if((!o||p(o,h,_,R,m))&&(u[i++]=new y.FindMatch(new P.Range(c,R+1+g,c,R+1+m+g),null),i>=n))return i;return i}const d=new b(v.wordSeparators,v.regex);let s;d.reset(0);do if(s=d.next(h),s&&(u[i++]=L(new P.Range(c,s.index+1+g,c,s.index+1+s[0].length+g),s,r),i>=n))return i;while(s);return i}static findNextMatch(v,h,c,g){const i=h.parseSearchRequest();if(!i)return null;const u=new b(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(v,c,u,g):this._doFindNextMatchLineByLine(v,c,u,g)}static _doFindNextMatchMultiline(v,h,c,g){const i=new I.Position(h.lineNumber,1),u=v.getOffsetAt(i),r=v.getLineCount(),n=v.getValueInRange(new P.Range(i.lineNumber,i.column,r,v.getLineMaxColumn(r)),1),o=v.getEOL()===`\r
`?new C(n):null;c.reset(h.column-1);const d=c.next(n);return d?L(this._getMultilineMatchRange(v,u,n,o,d.index,d[0]),d,g):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(v,new I.Position(1,1),c,g):null}static _doFindNextMatchLineByLine(v,h,c,g){const i=v.getLineCount(),u=h.lineNumber,r=v.getLineContent(u),n=this._findFirstMatchInLine(c,r,u,h.column,g);if(n)return n;for(let o=1;o<=i;o++){const d=(u+o-1)%i,s=v.getLineContent(d+1),a=this._findFirstMatchInLine(c,s,d+1,1,g);if(a)return a}return null}static _findFirstMatchInLine(v,h,c,g,i){v.reset(g-1);const u=v.next(h);return u?L(new P.Range(c,u.index+1,c,u.index+1+u[0].length),u,i):null}static findPreviousMatch(v,h,c,g){const i=h.parseSearchRequest();if(!i)return null;const u=new b(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(v,c,u,g):this._doFindPreviousMatchLineByLine(v,c,u,g)}static _doFindPreviousMatchMultiline(v,h,c,g){const i=this._doFindMatchesMultiline(v,new P.Range(1,1,h.lineNumber,h.column),c,g,10*D);if(i.length>0)return i[i.length-1];const u=v.getLineCount();return h.lineNumber!==u||h.column!==v.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(v,new I.Position(u,v.getLineMaxColumn(u)),c,g):null}static _doFindPreviousMatchLineByLine(v,h,c,g){const i=v.getLineCount(),u=h.lineNumber,r=v.getLineContent(u).substring(0,h.column-1),n=this._findLastMatchInLine(c,r,u,g);if(n)return n;for(let o=1;o<=i;o++){const d=(i+u-o-1)%i,s=v.getLineContent(d+1),a=this._findLastMatchInLine(c,s,d+1,g);if(a)return a}return null}static _findLastMatchInLine(v,h,c,g){let i=null,u;for(v.reset(0);u=v.next(h);)i=L(new P.Range(c,u.index+1,c,u.index+1+u[0].length),u,g);return i}}e.TextModelSearch=E;function T(f,v,h,c,g){if(c===0)return!0;const i=v.charCodeAt(c-1);if(f.get(i)!==0||i===13||i===10)return!0;if(g>0){const u=v.charCodeAt(c);if(f.get(u)!==0)return!0}return!1}function S(f,v,h,c,g){if(c+g===h)return!0;const i=v.charCodeAt(c+g);if(f.get(i)!==0||i===13||i===10)return!0;if(g>0){const u=v.charCodeAt(c+g-1);if(f.get(u)!==0)return!0}return!1}function p(f,v,h,c,g){return T(f,v,h,c,g)&&S(f,v,h,c,g)}e.isValidMatch=p;class b{constructor(v,h){this._wordSeparators=v,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const h=v.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(c=this._searchRegex.exec(v),!c))return null;const g=c.index,i=c[0].length;if(g===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){l.getNextCodePoint(v,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=g,this._prevMatchLength=i,!this._wordSeparators||p(this._wordSeparators,v,h,g,i))return c}while(c);return null}}e.Searcher=b}),define(Ce[116],De([1,0,23,10]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(I||(I={}));function P(C){for(let E=0,T=C.length;E<T;E+=4){const S=C[E+0],p=C[E+1],b=C[E+2],f=C[E+3];C[E+0]=f,C[E+1]=b,C[E+2]=p,C[E+3]=S}}function y(C){const E=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return t.isLittleEndian()||P(E),l.VSBuffer.wrap(E)}function D(C){const E=C.buffer;if(t.isLittleEndian()||P(E),E.byteOffset%4===0)return new Uint32Array(E.buffer,E.byteOffset,E.length/4);{const T=new Uint8Array(E.byteLength);return T.set(E),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function w(C){const E=new Uint32Array(k(C));let T=0;if(E[T++]=C.id,C.type==="full")E[T++]=1,E[T++]=C.data.length,E.set(C.data,T),T+=C.data.length;else{E[T++]=2,E[T++]=C.deltas.length;for(const S of C.deltas)E[T++]=S.start,E[T++]=S.deleteCount,S.data?(E[T++]=S.data.length,E.set(S.data,T),T+=S.data.length):E[T++]=0}return y(E)}e.encodeSemanticTokensDto=w;function k(C){let E=0;if(E+=1+1,C.type==="full")E+=1+C.data.length;else{E+=1,E+=(1+1+1)*C.deltas.length;for(const T of C.deltas)T.data&&(E+=T.data.length)}return E}function L(C){const E=D(C);let T=0;const S=E[T++];if(E[T++]===1){const v=E[T++],h=E.subarray(T,T+v);return T+=v,{id:S,type:"full",data:h}}const b=E[T++],f=[];for(let v=0;v<b;v++){const h=E[T++],c=E[T++],g=E[T++];let i;g>0&&(i=E.subarray(T,T+g),T+=g),f[v]={start:h,deleteCount:c,data:i}}return{id:S,type:"delta",deltas:f}}e.decodeSemanticTokensDto=L}),define(Ce[161],De([1,0,4,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new l.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,w){return this._map.set(D,w),this.fire([D]),(0,t.toDisposable)(()=>{this._map.get(D)===w&&(this._map.delete(D),this.fire([D]))})}registerFactory(D,w){this._factories.get(D)?.dispose();const k=new P(this,D,w);return this._factories.set(D,k),(0,t.toDisposable)(()=>{const L=this._factories.get(D);!L||L!==k||(this._factories.delete(D),L.dispose())})}async getOrCreate(D){const w=this.get(D);if(w)return w;const k=this._factories.get(D);return!k||k.isResolved?null:(await k.resolve(),this.get(D))}get(D){return this._map.get(D)||null}isResolved(D){if(this.get(D))return!0;const k=this._factories.get(D);return!!(!k||k.isResolved)}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=I;class P extends t.Disposable{get isResolved(){return this._isResolved}constructor(D,w,k){super(),this._registry=D,this._languageId=w,this._factory=k,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const D=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,D&&!this._isDisposed&&this._register(this._registry.register(this._languageId,D))}}}),define(Ce[64],De([1,0,76,2,35,161]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class y{constructor(m,_,R){this._tokenBrand=void 0,this.offset=m,this.type=_,this.language=R}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=y;class D{constructor(m,_){this._tokenizationResultBrand=void 0,this.tokens=m,this.endState=_}}e.TokenizationResult=D;class w{constructor(m,_){this._encodedTokenizationResultBrand=void 0,this.tokens=m,this.endState=_}}e.EncodedTokenizationResult=w;var k;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(k=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(a){const m=new Map;m.set(0,l.Codicon.symbolMethod),m.set(1,l.Codicon.symbolFunction),m.set(2,l.Codicon.symbolConstructor),m.set(3,l.Codicon.symbolField),m.set(4,l.Codicon.symbolVariable),m.set(5,l.Codicon.symbolClass),m.set(6,l.Codicon.symbolStruct),m.set(7,l.Codicon.symbolInterface),m.set(8,l.Codicon.symbolModule),m.set(9,l.Codicon.symbolProperty),m.set(10,l.Codicon.symbolEvent),m.set(11,l.Codicon.symbolOperator),m.set(12,l.Codicon.symbolUnit),m.set(13,l.Codicon.symbolValue),m.set(15,l.Codicon.symbolEnum),m.set(14,l.Codicon.symbolConstant),m.set(15,l.Codicon.symbolEnum),m.set(16,l.Codicon.symbolEnumMember),m.set(17,l.Codicon.symbolKeyword),m.set(27,l.Codicon.symbolSnippet),m.set(18,l.Codicon.symbolText),m.set(19,l.Codicon.symbolColor),m.set(20,l.Codicon.symbolFile),m.set(21,l.Codicon.symbolReference),m.set(22,l.Codicon.symbolCustomColor),m.set(23,l.Codicon.symbolFolder),m.set(24,l.Codicon.symbolTypeParameter),m.set(25,l.Codicon.account),m.set(26,l.Codicon.issues);function _(U){let A=m.get(U);return A||(console.info("No codicon found for CompletionItemKind "+U),A=l.Codicon.symbolProperty),A}a.toIcon=_;const R=new Map;R.set("method",0),R.set("function",1),R.set("constructor",2),R.set("field",3),R.set("variable",4),R.set("class",5),R.set("struct",6),R.set("interface",7),R.set("module",8),R.set("property",9),R.set("event",10),R.set("operator",11),R.set("unit",12),R.set("value",13),R.set("constant",14),R.set("enum",15),R.set("enum-member",16),R.set("enumMember",16),R.set("keyword",17),R.set("snippet",27),R.set("text",18),R.set("color",19),R.set("file",20),R.set("reference",21),R.set("customcolor",22),R.set("folder",23),R.set("type-parameter",24),R.set("typeParameter",24),R.set("account",25),R.set("issue",26);function M(U,A){let z=R.get(U);return typeof z>"u"&&!A&&(z=9),z}a.fromString=M})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var C;(function(a){a[a.Deprecated=1]="Deprecated"})(C=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var p;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(p=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var b;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(b=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(a){return a&&t.URI.isUri(a.uri)&&I.Range.isIRange(a.range)&&(I.Range.isIRange(a.originSelectionRange)||I.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=v;var h;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(h=e.SymbolKind||(e.SymbolKind={}));var c;(function(a){a[a.Deprecated=1]="Deprecated"})(c=e.SymbolTag||(e.SymbolTag={}));var g;(function(a){const m=new Map;m.set(0,l.Codicon.symbolFile),m.set(1,l.Codicon.symbolModule),m.set(2,l.Codicon.symbolNamespace),m.set(3,l.Codicon.symbolPackage),m.set(4,l.Codicon.symbolClass),m.set(5,l.Codicon.symbolMethod),m.set(6,l.Codicon.symbolProperty),m.set(7,l.Codicon.symbolField),m.set(8,l.Codicon.symbolConstructor),m.set(9,l.Codicon.symbolEnum),m.set(10,l.Codicon.symbolInterface),m.set(11,l.Codicon.symbolFunction),m.set(12,l.Codicon.symbolVariable),m.set(13,l.Codicon.symbolConstant),m.set(14,l.Codicon.symbolString),m.set(15,l.Codicon.symbolNumber),m.set(16,l.Codicon.symbolBoolean),m.set(17,l.Codicon.symbolArray),m.set(18,l.Codicon.symbolObject),m.set(19,l.Codicon.symbolKey),m.set(20,l.Codicon.symbolNull),m.set(21,l.Codicon.symbolEnumMember),m.set(22,l.Codicon.symbolStruct),m.set(23,l.Codicon.symbolEvent),m.set(24,l.Codicon.symbolOperator),m.set(25,l.Codicon.symbolTypeParameter);function _(R){let M=m.get(R);return M||(console.info("No codicon found for SymbolKind "+R),M=l.Codicon.symbolProperty),M}a.toIcon=_})(g=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(m){this.value=m}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var u;(function(a){function m(_){return!_||typeof _!="object"?!1:typeof _.id=="string"&&typeof _.title=="string"}a.is=m})(u=e.Command||(e.Command={}));var r;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var n;(function(a){a[a.Unresolved=0]="Unresolved",a[a.Resolved=1]="Resolved"})(n=e.CommentThreadState||(e.CommentThreadState={}));var o;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(o=e.CommentMode||(e.CommentMode={}));var d;(function(a){a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(d=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var s;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(s=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ce[162],De([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(Ce[117],De([1,0,162,10,101,17,24,146]),function(J,e,l,t,I,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var w;(function(re){re[re.None=0]="None",re[re.Keep=1]="Keep",re[re.Brackets=2]="Brackets",re[re.Advanced=3]="Advanced",re[re.Full=4]="Full"})(w=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=k;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class C{constructor(se,Ee,Ve,fe){this.id=se,this.name=Ee,this.defaultValue=Ve,this.schema=fe}applyUpdate(se,Ee){return T(se,Ee)}compute(se,Ee,Ve){return Ve}}class E{constructor(se,Ee){this.newValue=se,this.didChange=Ee}}e.ApplyUpdateResult=E;function T(re,se){if(typeof re!="object"||typeof se!="object"||!re||!se)return new E(se,re!==se);if(Array.isArray(re)||Array.isArray(se)){const Ve=Array.isArray(re)&&Array.isArray(se)&&P.equals(re,se);return new E(se,!Ve)}let Ee=!1;for(const Ve in se)if(se.hasOwnProperty(Ve)){const fe=T(re[Ve],se[Ve]);fe.didChange&&(re[Ve]=fe.newValue,Ee=!0)}return new E(re,Ee)}class S{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ee){return T(se,Ee)}validate(se){return this.defaultValue}}class p{constructor(se,Ee,Ve,fe){this.id=se,this.name=Ee,this.defaultValue=Ve,this.schema=fe}applyUpdate(se,Ee){return T(se,Ee)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ee,Ve){return Ve}}function b(re,se){return typeof re>"u"?se:re==="false"?!1:Boolean(re)}e.boolean=b;class f extends p{constructor(se,Ee,Ve,fe=void 0){typeof fe<"u"&&(fe.type="boolean",fe.default=Ve),super(se,Ee,Ve,fe)}validate(se){return b(se,this.defaultValue)}}function v(re,se,Ee,Ve){if(typeof re>"u")return se;let fe=parseInt(re,10);return isNaN(fe)?se:(fe=Math.max(Ee,fe),fe=Math.min(Ve,fe),fe|0)}e.clampedInt=v;class h extends p{static clampedInt(se,Ee,Ve,fe){return v(se,Ee,Ve,fe)}constructor(se,Ee,Ve,fe,Ae,Le=void 0){typeof Le<"u"&&(Le.type="integer",Le.default=Ve,Le.minimum=fe,Le.maximum=Ae),super(se,Ee,Ve,Le),this.minimum=fe,this.maximum=Ae}validate(se){return h.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class c extends p{static clamp(se,Ee,Ve){return se<Ee?Ee:se>Ve?Ve:se}static float(se,Ee){if(typeof se=="number")return se;if(typeof se>"u")return Ee;const Ve=parseFloat(se);return isNaN(Ve)?Ee:Ve}constructor(se,Ee,Ve,fe,Ae){typeof Ae<"u"&&(Ae.type="number",Ae.default=Ve),super(se,Ee,Ve,Ae),this.validationFn=fe}validate(se){return this.validationFn(c.float(se,this.defaultValue))}}class g extends p{static string(se,Ee){return typeof se!="string"?Ee:se}constructor(se,Ee,Ve,fe=void 0){typeof fe<"u"&&(fe.type="string",fe.default=Ve),super(se,Ee,Ve,fe)}validate(se){return g.string(se,this.defaultValue)}}function i(re,se,Ee){return typeof re!="string"||Ee.indexOf(re)===-1?se:re}e.stringSet=i;class u extends p{constructor(se,Ee,Ve,fe,Ae=void 0){typeof Ae<"u"&&(Ae.type="string",Ae.enum=fe,Ae.default=Ve),super(se,Ee,Ve,Ae),this._allowedValues=fe}validate(se){return i(se,this.defaultValue,this._allowedValues)}}class r extends C{constructor(se,Ee,Ve,fe,Ae,Le,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.enum=Ae,Me.default=fe),super(se,Ee,Ve,Me),this._allowedValues=Ae,this._convert=Le}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function n(re){switch(re){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ee,Ve){return Ve===0?se.accessibilitySupport:Ve}}class d extends C{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:l.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertSpace:b(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:b(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(re){re[re.Hidden=0]="Hidden",re[re.Blink=1]="Blink",re[re.Smooth=2]="Smooth",re[re.Phase=3]="Phase",re[re.Expand=4]="Expand",re[re.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function a(re){switch(re){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(re){re[re.Line=1]="Line",re[re.Block=2]="Block",re[re.Underline=3]="Underline",re[re.LineThin=4]="LineThin",re[re.BlockOutline=5]="BlockOutline",re[re.UnderlineThin=6]="UnderlineThin"})(m=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function _(re){switch(re){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=_;function R(re){switch(re){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class M extends S{constructor(){super(130)}compute(se,Ee,Ve){const fe=["monaco-editor"];return Ee.get(34)&&fe.push(Ee.get(34)),se.extraEditorClassName&&fe.push(se.extraEditorClassName),Ee.get(67)==="default"?fe.push("mouse-default"):Ee.get(67)==="copy"&&fe.push("mouse-copy"),Ee.get(101)&&fe.push("showUnused"),Ee.get(128)&&fe.push("showDeprecated"),fe.join(" ")}}class U extends f{constructor(){super(33,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(se,Ee,Ve){return Ve&&se.emptySelectionClipboard}}class A extends C{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:l.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:l.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{cursorMoveOnType:b(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":i(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":i(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:b(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:b(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:b(Ee.loop,this.defaultValue.loop)}}}class z extends C{constructor(){super(46,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?z.OFF:se==="true"?z.ON:se:Boolean(se)?z.ON:z.OFF}}e.EditorFontLigatures=z,z.OFF='"liga" off, "calt" off',z.ON='"liga" on, "calt" on';class $ extends S{constructor(){super(45)}compute(se,Ee,Ve){return se.fontInfo}}class N extends p{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(22,null)})}validate(se){const Ee=c.float(se,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(Ee,6,100)}compute(se,Ee,Ve){return se.fontInfo.fontSize}}class V extends C{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:l.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(h.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}V.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],V.MINIMUM_VALUE=1,V.MAXIMUM_VALUE=1e3;class B extends C{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[l.localize(25,null),l.localize(26,null),l.localize(27,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(29,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(30,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:l.localize(31,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:l.localize(32,null),...Ee},"editor.gotoLocation.multipleReferences":{description:l.localize(33,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:Ve,description:l.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:Ve,description:l.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:Ve,description:l.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:Ve,description:l.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:Ve,description:l.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{multiple:i(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??i(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??i(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??i(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??i(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??i(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class F extends C{constructor(){const se={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:l.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:l.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:l.localize(41,null)},"editor.hover.above":{type:"boolean",default:se.above,description:l.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),delay:h.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:b(Ee.sticky,this.defaultValue.sticky),above:b(Ee.above,this.defaultValue.above)}}}var x;(function(re){re[re.None=0]="None",re[re.Text=1]="Text",re[re.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class H extends S{constructor(){super(133)}compute(se,Ee,Ve){return H.computeLayout(Ee,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const Ee=se.height/se.lineHeight,Ve=se.scrollBeyondLastLine?Ee-1:0,fe=(se.viewLineCount+Ve)/(se.pixelRatio*se.height),Ae=Math.floor(se.viewLineCount/fe);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:Ve,desiredRatio:fe,minimapLineCount:Ae}}static _computeMinimapLayout(se,Ee){const Ve=se.outerWidth,fe=se.outerHeight,Ae=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ae*fe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:fe};const Le=Ee.stableMinimapLayoutInput,Me=Le&&se.outerHeight===Le.outerHeight&&se.lineHeight===Le.lineHeight&&se.typicalHalfwidthCharacterWidth===Le.typicalHalfwidthCharacterWidth&&se.pixelRatio===Le.pixelRatio&&se.scrollBeyondLastLine===Le.scrollBeyondLastLine&&se.minimap.enabled===Le.minimap.enabled&&se.minimap.side===Le.minimap.side&&se.minimap.size===Le.minimap.size&&se.minimap.showSlider===Le.minimap.showSlider&&se.minimap.renderCharacters===Le.minimap.renderCharacters&&se.minimap.maxColumn===Le.minimap.maxColumn&&se.minimap.scale===Le.minimap.scale&&se.verticalScrollbarWidth===Le.verticalScrollbarWidth&&se.isViewportWrapping===Le.isViewportWrapping,Ke=se.lineHeight,Je=se.typicalHalfwidthCharacterWidth,st=se.scrollBeyondLastLine,ot=se.minimap.renderCharacters;let it=Ae>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const lt=se.minimap.maxColumn,vt=se.minimap.size,wt=se.minimap.side,ft=se.verticalScrollbarWidth,St=se.viewLineCount,Ft=se.remainingWidth,Mt=se.isViewportWrapping,Qe=ot?2:3;let zt=Math.floor(Ae*fe);const Ot=zt/Ae;let Pt=!1,gt=!1,kt=Qe*it,Pe=it/Ae,Oe=1;if(vt==="fill"||vt==="fit"){const{typicalViewportLineCount:rt,extraLinesBeyondLastLine:pt,desiredRatio:Et,minimapLineCount:Tt}=H.computeContainedMinimapLineCount({viewLineCount:St,scrollBeyondLastLine:st,height:fe,lineHeight:Ke,pixelRatio:Ae});if(St/Tt>1)Pt=!0,gt=!0,it=1,kt=1,Pe=it/Ae;else{let _t=!1,bt=it+1;if(vt==="fit"){const Ct=Math.ceil((St+pt)*kt);Mt&&Me&&Ft<=Ee.stableFitRemainingWidth?(_t=!0,bt=Ee.stableFitMaxMinimapScale):_t=Ct>zt}if(vt==="fill"||_t){Pt=!0;const Ct=it;kt=Math.min(Ke*Ae,Math.max(1,Math.floor(1/Et))),Mt&&Me&&Ft<=Ee.stableFitRemainingWidth&&(bt=Ee.stableFitMaxMinimapScale),it=Math.min(bt,Math.max(1,Math.floor(kt/Qe))),it>Ct&&(Oe=Math.min(2,it/Ct)),Pe=it/Ae/Oe,zt=Math.ceil(Math.max(rt,St+pt)*kt),Mt?(Ee.stableMinimapLayoutInput=se,Ee.stableFitRemainingWidth=Ft,Ee.stableFitMaxMinimapScale=it):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const _e=Math.floor(lt*Pe),te=Math.min(_e,Math.max(0,Math.floor((Ft-ft-2)*Pe/(Je+Pe)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(Ae*te);const xe=Fe/Ae;Fe=Math.floor(Fe*Oe);const nt=ot?1:2,Ge=wt==="left"?0:Ve-te-ft;return{renderMinimap:nt,minimapLeft:Ge,minimapWidth:te,minimapHeightIsEditorHeight:Pt,minimapIsSampling:gt,minimapScale:it,minimapLineHeight:kt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:zt,minimapCanvasOuterWidth:xe,minimapCanvasOuterHeight:Ot}}static computeLayout(se,Ee){const Ve=Ee.outerWidth|0,fe=Ee.outerHeight|0,Ae=Ee.lineHeight|0,Le=Ee.lineNumbersDigitCount|0,Me=Ee.typicalHalfwidthCharacterWidth,Ke=Ee.maxDigitWidth,Je=Ee.pixelRatio,st=Ee.viewLineCount,ot=se.get(125),it=ot==="inherit"?se.get(124):ot,lt=it==="inherit"?se.get(120):it,vt=se.get(123),wt=se.get(2),ft=Ee.isDominatedByLongLines,St=se.get(51),Ft=se.get(61).renderType!==0,Mt=se.get(62),Qe=se.get(95),zt=se.get(66),Ot=se.get(93),Pt=Ot.verticalScrollbarSize,gt=Ot.verticalHasArrows,kt=Ot.arrowSize,Pe=Ot.horizontalScrollbarSize,Oe=se.get(59),_e=se.get(38),te=se.get(100)!=="never";let Fe;if(typeof Oe=="string"&&/^\d+(\.\d+)?ch$/.test(Oe)){const $t=parseFloat(Oe.substr(0,Oe.length-2));Fe=h.clampedInt($t*Me,0,0,1e3)}else Fe=h.clampedInt(Oe,0,0,1e3);_e&&te&&(Fe+=16);let xe=0;if(Ft){const $t=Math.max(Le,Mt);xe=Math.round($t*Ke)}let nt=0;St&&(nt=Ae);let Ge=0,rt=Ge+nt,pt=rt+xe,Et=pt+Fe;const Tt=Ve-nt-xe-Fe;let It=!1,_t=!1,bt=-1;wt!==2&&(it==="inherit"&&ft?(It=!0,_t=!0):lt==="on"||lt==="bounded"?_t=!0:lt==="wordWrapColumn"&&(bt=vt));const Ct=H._computeMinimapLayout({outerWidth:Ve,outerHeight:fe,lineHeight:Ae,typicalHalfwidthCharacterWidth:Me,pixelRatio:Je,scrollBeyondLastLine:Qe,minimap:zt,verticalScrollbarWidth:Pt,viewLineCount:st,remainingWidth:Tt,isViewportWrapping:_t},Ee.memory||new L);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(Ge+=Ct.minimapWidth,rt+=Ct.minimapWidth,pt+=Ct.minimapWidth,Et+=Ct.minimapWidth);const en=Tt-Ct.minimapWidth,yt=Math.max(1,Math.floor((en-Pt-2)/Me)),qt=gt?kt:0;return _t&&(bt=Math.max(1,yt),lt==="bounded"&&(bt=Math.min(bt,vt))),{width:Ve,height:fe,glyphMarginLeft:Ge,glyphMarginWidth:nt,lineNumbersLeft:rt,lineNumbersWidth:xe,decorationsLeft:pt,decorationsWidth:Fe,contentLeft:Et,contentWidth:en,minimap:Ct,viewportColumn:yt,isWordWrapMinified:It,isViewportWrapping:_t,wrappingColumn:bt,verticalScrollbarWidth:Pt,horizontalScrollbarHeight:Pe,overviewRuler:{top:qt,width:Pt,height:fe-2*qt,right:0}}}}e.EditorLayoutInfoComputer=H;class Q extends C{constructor(){const se={enabled:!0};super(58,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:l.localize(43,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:b(se.enabled,this.defaultValue.enabled)}}}class K extends C{constructor(){const se={enabled:!1,maxLineCount:5};super(105,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:l.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:l.localize(45,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),maxLineCount:h.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class de extends C{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:l.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(47,null),l.localize(48,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(49,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:l.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:l.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:l.localize(53,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:i(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:h.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:b(Ee.padding,this.defaultValue.padding)}}}class ee extends c{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>c.clamp(se,0,150),{markdownDescription:l.localize(54,null)})}compute(se,Ee,Ve){return se.fontInfo.lineHeight}}class he extends C{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:l.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:l.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(57,null),l.localize(58,null),l.localize(59,null)],default:se.size,description:l.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:l.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:l.localize(62,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:l.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:l.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),autohide:b(Ee.autohide,this.defaultValue.autohide),size:i(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(Ee.side,this.defaultValue.side,["right","left"]),showSlider:i(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:b(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:h.clampedInt(Ee.scale,1,1,3),maxColumn:h.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(re){return re==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class me extends C{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(67,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{top:h.clampedInt(Ee.top,0,0,1e3),bottom:h.clampedInt(Ee.bottom,0,0,1e3)}}}class be extends C{constructor(){const se={enabled:!0,cycle:!1};super(77,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:l.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:l.localize(69,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),cycle:b(Ee.cycle,this.defaultValue.cycle)}}}class ke extends S{constructor(){super(131)}compute(se,Ee,Ve){return se.pixelRatio}}class Re extends C{constructor(){const se={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(70,null),l.localize(71,null),l.localize(72,null)]}];super(80,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:se.strings,description:l.localize(73,null)},comments:{anyOf:Ee,default:se.comments,description:l.localize(74,null)},other:{anyOf:Ee,default:se.other,description:l.localize(75,null)}},default:se,markdownDescription:l.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const Je=se?"on":"off";return{comments:Je,strings:Je,other:Je}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ee,comments:Ve,strings:fe}=se,Ae=["on","inline","off"];let Le,Me,Ke;return typeof Ee=="boolean"?Le=Ee?"on":"off":Le=i(Ee,this.defaultValue.other,Ae),typeof Ve=="boolean"?Me=Ve?"on":"off":Me=i(Ve,this.defaultValue.comments,Ae),typeof fe=="boolean"?Ke=fe?"on":"off":Ke=i(fe,this.defaultValue.strings,Ae),{other:Le,comments:Me,strings:Ke}}}var ze;(function(re){re[re.Off=0]="Off",re[re.On=1]="On",re[re.Relative=2]="Relative",re[re.Interval=3]="Interval",re[re.Custom=4]="Custom"})(ze=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends C{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(77,null),l.localize(78,null),l.localize(79,null),l.localize(80,null)],default:"on",description:l.localize(81,null)})}validate(se){let Ee=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ee=4,Ve=se):se==="interval"?Ee=3:se==="relative"?Ee=2:se==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Ve}}}function le(re){const se=re.get(88);return se==="editable"?re.get(82):se!=="on"}e.filterValidationDecorations=le;class ge extends C{constructor(){const se=[],Ee={type:"number",description:l.localize(82,null)};super(92,"rulers",se,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:l.localize(83,null),format:"color-hex"}}}]},default:se,description:l.localize(84,null)})}validate(se){if(Array.isArray(se)){const Ee=[];for(const Ve of se)if(typeof Ve=="number")Ee.push({column:h.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const fe=Ve;Ee.push({column:h.clampedInt(fe.column,0,0,1e4),color:fe.color})}return Ee.sort((Ve,fe)=>Ve.column-fe.column),Ee}return this.defaultValue}}function Z(re,se){if(typeof re!="string")return se;switch(re){case"hidden":return 2;case"visible":return 3;default:return 1}}class ae extends C{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(85,null),l.localize(86,null),l.localize(87,null)],default:"auto",description:l.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(89,null),l.localize(90,null),l.localize(91,null)],default:"auto",description:l.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:l.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:l.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:l.localize(95,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se,Ve=h.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),fe=h.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:h.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Z(Ee.vertical,this.defaultValue.vertical),horizontal:Z(Ee.horizontal,this.defaultValue.horizontal),useShadows:b(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:b(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:b(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:b(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:b(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:h.clampedInt(Ee.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:fe,verticalSliderSize:h.clampedInt(Ee.verticalSliderSize,fe,0,1e3),scrollByPage:b(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ne extends C{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:l.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:l.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:l.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:l.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:l.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:l.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:l.localize(102,null)}})}applyUpdate(se,Ee){let Ve=!1;Ee.allowedCharacters&&se&&(y.equals(se.allowedCharacters,Ee.allowedCharacters)||(se={...se,allowedCharacters:Ee.allowedCharacters},Ve=!0)),Ee.allowedLocales&&se&&(y.equals(se.allowedLocales,Ee.allowedLocales)||(se={...se,allowedLocales:Ee.allowedLocales},Ve=!0));const fe=super.applyUpdate(se,Ee);return Ve?new E(fe.newValue,!0):fe}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{nonBasicASCII:G(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:b(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:b(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:G(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:G(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(se.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(se,Ee){if(typeof se!="object"||!se)return Ee;const Ve={};for(const[fe,Ae]of Object.entries(se))Ae===!0&&(Ve[fe]=!0);return Ve}}class ie extends C{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:l.localize(103,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),mode:i(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class O extends C{constructor(){const se={enabled:D.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:D.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:l.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:l.localize(105,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:b(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class j extends C{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(106,null),l.localize(107,null),l.localize(108,null)],default:se.bracketPairs,description:l.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(110,null),l.localize(111,null),l.localize(112,null)],default:se.bracketPairsHorizontal,description:l.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:l.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:l.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(116,null),l.localize(117,null),l.localize(118,null)],default:se.highlightActiveIndentation,description:l.localize(119,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{bracketPairs:G(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:G(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:b(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:b(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:G(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function G(re,se,Ee){const Ve=Ee.indexOf(re);return Ve===-1?se:Ee[Ve]}class X extends C{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(120,null),l.localize(121,null)],default:se.insertMode,description:l.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:l.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:l.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:l.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:l.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:l.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:l.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:l.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:l.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertMode:i(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:b(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:b(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:b(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:b(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:b(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:b(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:b(Ee.preview,this.defaultValue.preview),previewMode:i(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:b(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:b(Ee.showMethods,this.defaultValue.showMethods),showFunctions:b(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:b(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:b(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:b(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:b(Ee.showFields,this.defaultValue.showFields),showVariables:b(Ee.showVariables,this.defaultValue.showVariables),showClasses:b(Ee.showClasses,this.defaultValue.showClasses),showStructs:b(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:b(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:b(Ee.showModules,this.defaultValue.showModules),showProperties:b(Ee.showProperties,this.defaultValue.showProperties),showEvents:b(Ee.showEvents,this.defaultValue.showEvents),showOperators:b(Ee.showOperators,this.defaultValue.showOperators),showUnits:b(Ee.showUnits,this.defaultValue.showUnits),showValues:b(Ee.showValues,this.defaultValue.showValues),showConstants:b(Ee.showConstants,this.defaultValue.showConstants),showEnums:b(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:b(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:b(Ee.showKeywords,this.defaultValue.showKeywords),showWords:b(Ee.showWords,this.defaultValue.showWords),showColors:b(Ee.showColors,this.defaultValue.showColors),showFiles:b(Ee.showFiles,this.defaultValue.showFiles),showReferences:b(Ee.showReferences,this.defaultValue.showReferences),showFolders:b(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:b(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:b(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:b(Ee.showUsers,this.defaultValue.showUsers),showIssues:b(Ee.showIssues,this.defaultValue.showIssues)}}}class pe extends C{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(163,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:b(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class we extends S{constructor(){super(132)}compute(se,Ee,Ve){return Ee.get(82)?!0:se.tabFocusMode}}var ce;(function(re){re[re.None=0]="None",re[re.Same=1]="Same",re[re.Indent=2]="Indent",re[re.DeepIndent=3]="DeepIndent"})(ce=e.WrappingIndent||(e.WrappingIndent={}));function Ie(re){switch(re){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ye extends S{constructor(){super(134)}compute(se,Ee,Ve){const fe=Ee.get(133);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:fe.isWordWrapMinified,isViewportWrapping:fe.isViewportWrapping,wrappingColumn:fe.wrappingColumn}}}class We extends C{constructor(){const se={enabled:!0};super(32,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:l.localize(164,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:b(se.enabled,this.defaultValue.enabled)}}}const qe="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",Ye="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Ze:t.isLinux?Ye:qe,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(re){return e.editorOptionsRegistry[re.id]=re,re}var at;(function(re){re[re.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",re[re.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",re[re.accessibilitySupport=2]="accessibilitySupport",re[re.accessibilityPageSize=3]="accessibilityPageSize",re[re.ariaLabel=4]="ariaLabel",re[re.autoClosingBrackets=5]="autoClosingBrackets",re[re.autoClosingDelete=6]="autoClosingDelete",re[re.autoClosingOvertype=7]="autoClosingOvertype",re[re.autoClosingQuotes=8]="autoClosingQuotes",re[re.autoIndent=9]="autoIndent",re[re.automaticLayout=10]="automaticLayout",re[re.autoSurround=11]="autoSurround",re[re.bracketPairColorization=12]="bracketPairColorization",re[re.guides=13]="guides",re[re.codeLens=14]="codeLens",re[re.codeLensFontFamily=15]="codeLensFontFamily",re[re.codeLensFontSize=16]="codeLensFontSize",re[re.colorDecorators=17]="colorDecorators",re[re.columnSelection=18]="columnSelection",re[re.comments=19]="comments",re[re.contextmenu=20]="contextmenu",re[re.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",re[re.cursorBlinking=22]="cursorBlinking",re[re.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",re[re.cursorStyle=24]="cursorStyle",re[re.cursorSurroundingLines=25]="cursorSurroundingLines",re[re.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",re[re.cursorWidth=27]="cursorWidth",re[re.disableLayerHinting=28]="disableLayerHinting",re[re.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",re[re.domReadOnly=30]="domReadOnly",re[re.dragAndDrop=31]="dragAndDrop",re[re.dropIntoEditor=32]="dropIntoEditor",re[re.emptySelectionClipboard=33]="emptySelectionClipboard",re[re.extraEditorClassName=34]="extraEditorClassName",re[re.fastScrollSensitivity=35]="fastScrollSensitivity",re[re.find=36]="find",re[re.fixedOverflowWidgets=37]="fixedOverflowWidgets",re[re.folding=38]="folding",re[re.foldingStrategy=39]="foldingStrategy",re[re.foldingHighlight=40]="foldingHighlight",re[re.foldingImportsByDefault=41]="foldingImportsByDefault",re[re.foldingMaximumRegions=42]="foldingMaximumRegions",re[re.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",re[re.fontFamily=44]="fontFamily",re[re.fontInfo=45]="fontInfo",re[re.fontLigatures=46]="fontLigatures",re[re.fontSize=47]="fontSize",re[re.fontWeight=48]="fontWeight",re[re.formatOnPaste=49]="formatOnPaste",re[re.formatOnType=50]="formatOnType",re[re.glyphMargin=51]="glyphMargin",re[re.gotoLocation=52]="gotoLocation",re[re.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",re[re.hover=54]="hover",re[re.inDiffEditor=55]="inDiffEditor",re[re.inlineSuggest=56]="inlineSuggest",re[re.letterSpacing=57]="letterSpacing",re[re.lightbulb=58]="lightbulb",re[re.lineDecorationsWidth=59]="lineDecorationsWidth",re[re.lineHeight=60]="lineHeight",re[re.lineNumbers=61]="lineNumbers",re[re.lineNumbersMinChars=62]="lineNumbersMinChars",re[re.linkedEditing=63]="linkedEditing",re[re.links=64]="links",re[re.matchBrackets=65]="matchBrackets",re[re.minimap=66]="minimap",re[re.mouseStyle=67]="mouseStyle",re[re.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",re[re.mouseWheelZoom=69]="mouseWheelZoom",re[re.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",re[re.multiCursorModifier=71]="multiCursorModifier",re[re.multiCursorPaste=72]="multiCursorPaste",re[re.occurrencesHighlight=73]="occurrencesHighlight",re[re.overviewRulerBorder=74]="overviewRulerBorder",re[re.overviewRulerLanes=75]="overviewRulerLanes",re[re.padding=76]="padding",re[re.parameterHints=77]="parameterHints",re[re.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",re[re.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",re[re.quickSuggestions=80]="quickSuggestions",re[re.quickSuggestionsDelay=81]="quickSuggestionsDelay",re[re.readOnly=82]="readOnly",re[re.renameOnType=83]="renameOnType",re[re.renderControlCharacters=84]="renderControlCharacters",re[re.renderFinalNewline=85]="renderFinalNewline",re[re.renderLineHighlight=86]="renderLineHighlight",re[re.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",re[re.renderValidationDecorations=88]="renderValidationDecorations",re[re.renderWhitespace=89]="renderWhitespace",re[re.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",re[re.roundedSelection=91]="roundedSelection",re[re.rulers=92]="rulers",re[re.scrollbar=93]="scrollbar",re[re.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",re[re.scrollBeyondLastLine=95]="scrollBeyondLastLine",re[re.scrollPredominantAxis=96]="scrollPredominantAxis",re[re.selectionClipboard=97]="selectionClipboard",re[re.selectionHighlight=98]="selectionHighlight",re[re.selectOnLineNumbers=99]="selectOnLineNumbers",re[re.showFoldingControls=100]="showFoldingControls",re[re.showUnused=101]="showUnused",re[re.snippetSuggestions=102]="snippetSuggestions",re[re.smartSelect=103]="smartSelect",re[re.smoothScrolling=104]="smoothScrolling",re[re.stickyScroll=105]="stickyScroll",re[re.stickyTabStops=106]="stickyTabStops",re[re.stopRenderingLineAfter=107]="stopRenderingLineAfter",re[re.suggest=108]="suggest",re[re.suggestFontSize=109]="suggestFontSize",re[re.suggestLineHeight=110]="suggestLineHeight",re[re.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",re[re.suggestSelection=112]="suggestSelection",re[re.tabCompletion=113]="tabCompletion",re[re.tabIndex=114]="tabIndex",re[re.unicodeHighlighting=115]="unicodeHighlighting",re[re.unusualLineTerminators=116]="unusualLineTerminators",re[re.useShadowDOM=117]="useShadowDOM",re[re.useTabStops=118]="useTabStops",re[re.wordSeparators=119]="wordSeparators",re[re.wordWrap=120]="wordWrap",re[re.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",re[re.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",re[re.wordWrapColumn=123]="wordWrapColumn",re[re.wordWrapOverride1=124]="wordWrapOverride1",re[re.wordWrapOverride2=125]="wordWrapOverride2",re[re.wrappingIndent=126]="wrappingIndent",re[re.wrappingStrategy=127]="wrappingStrategy",re[re.showDeprecated=128]="showDeprecated",re[re.inlayHints=129]="inlayHints",re[re.editorClassName=130]="editorClassName",re[re.pixelRatio=131]="pixelRatio",re[re.tabFocusMode=132]="tabFocusMode",re[re.layoutInfo=133]="layoutInfo",re[re.wrappingInfo=134]="wrappingInfo"})(at=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(165,null)})),acceptSuggestionOnEnter:Ne(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(166,null),""],markdownDescription:l.localize(167,null)})),accessibilitySupport:Ne(new o),accessibilityPageSize:Ne(new h(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(168,null),tags:["accessibility"]})),ariaLabel:Ne(new g(4,"ariaLabel",l.localize(169,null))),autoClosingBrackets:Ne(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(170,null),l.localize(171,null),""],description:l.localize(172,null)})),autoClosingDelete:Ne(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(173,null),""],description:l.localize(174,null)})),autoClosingOvertype:Ne(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(175,null),""],description:l.localize(176,null)})),autoClosingQuotes:Ne(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(177,null),l.localize(178,null),""],description:l.localize(179,null)})),autoIndent:Ne(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],n,{enumDescriptions:[l.localize(180,null),l.localize(181,null),l.localize(182,null),l.localize(183,null),l.localize(184,null)],description:l.localize(185,null)})),automaticLayout:Ne(new f(10,"automaticLayout",!1)),autoSurround:Ne(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(186,null),l.localize(187,null),l.localize(188,null),""],description:l.localize(189,null)})),bracketPairColorization:Ne(new O),bracketPairGuides:Ne(new j),stickyTabStops:Ne(new f(106,"stickyTabStops",!1,{description:l.localize(190,null)})),codeLens:Ne(new f(14,"codeLens",!0,{description:l.localize(191,null)})),codeLensFontFamily:Ne(new g(15,"codeLensFontFamily","",{description:l.localize(192,null)})),codeLensFontSize:Ne(new h(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(193,null)})),colorDecorators:Ne(new f(17,"colorDecorators",!0,{description:l.localize(194,null)})),columnSelection:Ne(new f(18,"columnSelection",!1,{description:l.localize(195,null)})),comments:Ne(new d),contextmenu:Ne(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new f(21,"copyWithSyntaxHighlighting",!0,{description:l.localize(196,null)})),cursorBlinking:Ne(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],a,{description:l.localize(197,null)})),cursorSmoothCaretAnimation:Ne(new f(23,"cursorSmoothCaretAnimation",!1,{description:l.localize(198,null)})),cursorStyle:Ne(new r(24,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:l.localize(199,null)})),cursorSurroundingLines:Ne(new h(25,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(200,null)})),cursorSurroundingLinesStyle:Ne(new u(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(201,null),l.localize(202,null)],description:l.localize(203,null)})),cursorWidth:Ne(new h(27,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(204,null)})),disableLayerHinting:Ne(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new f(30,"domReadOnly",!1)),dragAndDrop:Ne(new f(31,"dragAndDrop",!0,{description:l.localize(205,null)})),emptySelectionClipboard:Ne(new U),dropIntoEditor:Ne(new We),stickyScroll:Ne(new K),extraEditorClassName:Ne(new g(34,"extraEditorClassName","")),fastScrollSensitivity:Ne(new c(35,"fastScrollSensitivity",5,re=>re<=0?5:re,{markdownDescription:l.localize(206,null)})),find:Ne(new A),fixedOverflowWidgets:Ne(new f(37,"fixedOverflowWidgets",!1)),folding:Ne(new f(38,"folding",!0,{description:l.localize(207,null)})),foldingStrategy:Ne(new u(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(208,null),l.localize(209,null)],description:l.localize(210,null)})),foldingHighlight:Ne(new f(40,"foldingHighlight",!0,{description:l.localize(211,null)})),foldingImportsByDefault:Ne(new f(41,"foldingImportsByDefault",!1,{description:l.localize(212,null)})),foldingMaximumRegions:Ne(new h(42,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(213,null)})),unfoldOnClickAfterEndOfLine:Ne(new f(43,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(214,null)})),fontFamily:Ne(new g(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(215,null)})),fontInfo:Ne(new $),fontLigatures2:Ne(new z),fontSize:Ne(new N),fontWeight:Ne(new V),formatOnPaste:Ne(new f(49,"formatOnPaste",!1,{description:l.localize(216,null)})),formatOnType:Ne(new f(50,"formatOnType",!1,{description:l.localize(217,null)})),glyphMargin:Ne(new f(51,"glyphMargin",!0,{description:l.localize(218,null)})),gotoLocation:Ne(new B),hideCursorInOverviewRuler:Ne(new f(53,"hideCursorInOverviewRuler",!1,{description:l.localize(219,null)})),hover:Ne(new F),inDiffEditor:Ne(new f(55,"inDiffEditor",!1)),letterSpacing:Ne(new c(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,re=>c.clamp(re,-5,20),{description:l.localize(220,null)})),lightbulb:Ne(new Q),lineDecorationsWidth:Ne(new p(59,"lineDecorationsWidth",10)),lineHeight:Ne(new ee),lineNumbers:Ne(new oe),lineNumbersMinChars:Ne(new h(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new f(63,"linkedEditing",!1,{description:l.localize(221,null)})),links:Ne(new f(64,"links",!0,{description:l.localize(222,null)})),matchBrackets:Ne(new u(65,"matchBrackets","always",["always","near","never"],{description:l.localize(223,null)})),minimap:Ne(new he),mouseStyle:Ne(new u(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new c(68,"mouseWheelScrollSensitivity",1,re=>re===0?1:re,{markdownDescription:l.localize(224,null)})),mouseWheelZoom:Ne(new f(69,"mouseWheelZoom",!1,{markdownDescription:l.localize(225,null)})),multiCursorMergeOverlapping:Ne(new f(70,"multiCursorMergeOverlapping",!0,{description:l.localize(226,null)})),multiCursorModifier:Ne(new r(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[l.localize(227,null),l.localize(228,null)],markdownDescription:l.localize(229,null)})),multiCursorPaste:Ne(new u(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(230,null),l.localize(231,null)],markdownDescription:l.localize(232,null)})),occurrencesHighlight:Ne(new f(73,"occurrencesHighlight",!0,{description:l.localize(233,null)})),overviewRulerBorder:Ne(new f(74,"overviewRulerBorder",!0,{description:l.localize(234,null)})),overviewRulerLanes:Ne(new h(75,"overviewRulerLanes",3,0,3)),padding:Ne(new me),parameterHints:Ne(new be),peekWidgetDefaultFocus:Ne(new u(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(235,null),l.localize(236,null)],description:l.localize(237,null)})),definitionLinkOpensInPeek:Ne(new f(79,"definitionLinkOpensInPeek",!1,{description:l.localize(238,null)})),quickSuggestions:Ne(new Re),quickSuggestionsDelay:Ne(new h(81,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(239,null)})),readOnly:Ne(new f(82,"readOnly",!1)),renameOnType:Ne(new f(83,"renameOnType",!1,{description:l.localize(240,null),markdownDeprecationMessage:l.localize(241,null)})),renderControlCharacters:Ne(new f(84,"renderControlCharacters",!0,{description:l.localize(242,null),restricted:!0})),renderFinalNewline:Ne(new f(85,"renderFinalNewline",!0,{description:l.localize(243,null)})),renderLineHighlight:Ne(new u(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(244,null)],description:l.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Ne(new f(87,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(246,null)})),renderValidationDecorations:Ne(new u(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new u(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(247,null),l.localize(248,null),l.localize(249,null),""],description:l.localize(250,null)})),revealHorizontalRightPadding:Ne(new h(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new f(91,"roundedSelection",!0,{description:l.localize(251,null)})),rulers:Ne(new ge),scrollbar:Ne(new ae),scrollBeyondLastColumn:Ne(new h(94,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(252,null)})),scrollBeyondLastLine:Ne(new f(95,"scrollBeyondLastLine",!0,{description:l.localize(253,null)})),scrollPredominantAxis:Ne(new f(96,"scrollPredominantAxis",!0,{description:l.localize(254,null)})),selectionClipboard:Ne(new f(97,"selectionClipboard",!0,{description:l.localize(255,null),included:t.isLinux})),selectionHighlight:Ne(new f(98,"selectionHighlight",!0,{description:l.localize(256,null)})),selectOnLineNumbers:Ne(new f(99,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new u(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(257,null),l.localize(258,null),l.localize(259,null)],description:l.localize(260,null)})),showUnused:Ne(new f(101,"showUnused",!0,{description:l.localize(261,null)})),showDeprecated:Ne(new f(128,"showDeprecated",!0,{description:l.localize(262,null)})),inlayHints:Ne(new de),snippetSuggestions:Ne(new u(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(263,null),l.localize(264,null),l.localize(265,null),l.localize(266,null)],description:l.localize(267,null)})),smartSelect:Ne(new pe),smoothScrolling:Ne(new f(104,"smoothScrolling",!1,{description:l.localize(268,null)})),stopRenderingLineAfter:Ne(new h(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new X),inlineSuggest:Ne(new ie),suggestFontSize:Ne(new h(109,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new h(110,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new f(111,"suggestOnTriggerCharacters",!0,{description:l.localize(271,null)})),suggestSelection:Ne(new u(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(272,null),l.localize(273,null),l.localize(274,null)],description:l.localize(275,null)})),tabCompletion:Ne(new u(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(276,null),l.localize(277,null),l.localize(278,null)],description:l.localize(279,null)})),tabIndex:Ne(new h(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new ne),unusualLineTerminators:Ne(new u(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(280,null),l.localize(281,null),l.localize(282,null)],description:l.localize(283,null)})),useShadowDOM:Ne(new f(117,"useShadowDOM",!0)),useTabStops:Ne(new f(118,"useTabStops",!0,{description:l.localize(284,null)})),wordSeparators:Ne(new g(119,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:l.localize(285,null)})),wordWrap:Ne(new u(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(286,null),l.localize(287,null),l.localize(288,null),l.localize(289,null)],description:l.localize(290,null)})),wordWrapBreakAfterCharacters:Ne(new g(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new g(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new h(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(291,null)})),wordWrapOverride1:Ne(new u(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new u(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ne(new r(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ie,{enumDescriptions:[l.localize(292,null),l.localize(293,null),l.localize(294,null),l.localize(295,null)],description:l.localize(296,null)})),wrappingStrategy:Ne(new u(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[l.localize(297,null),l.localize(298,null)],description:l.localize(299,null)})),editorClassName:Ne(new M),pixelRatio:Ne(new ke),tabFocusMode:Ne(new we),layoutInfo:Ne(new H),wrappingInfo:Ne(new ye)}}),define(Ce[163],De([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[164],De([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[165],De([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[166],De([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ce[167],De([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(Ce[168],De([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(Ce[169],De([19,20]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(Ce[170],De([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[171],De([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[172],De([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[173],De([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[174],De([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[175],De([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[176],De([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[177],De([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ce[178],De([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Ce[179],De([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(Ce[180],De([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[181],De([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[182],De([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ce[183],De([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[184],De([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[185],De([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[186],De([19,20]),function(J,e){return J.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[187],De([19,20]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[188],De([1,0,22,42,165,306]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function w(f){return f=f.trim(),f==="*"||y.test(f)}e.isValidVersionStr=w;function k(f){if(!w(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=f.match(y);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=k;function L(f){if(!f)return null;const v=f.majorBase,h=f.majorMustEqual,c=f.minorBase;let g=f.minorMustEqual;const i=f.patchBase;let u=f.patchMustEqual;f.hasCaret&&(v===0||(g=!1),u=!1);let r=0;if(f.preRelease){const n=D.exec(f.preRelease);if(n){const[,o,d,s]=n;r=Date.UTC(Number(o),Number(d)-1,Number(s))}}return{majorBase:v,majorMustEqual:h,minorBase:c,minorMustEqual:g,patchBase:i,patchMustEqual:u,isMinimum:f.hasGreaterEquals,notBefore:r}}e.normalizeVersion=L;function C(f,v,h){let c;typeof f=="string"?c=L(k(f)):c=f;let g;v instanceof Date?g=v.getTime():typeof v=="string"&&(g=new Date(v).getTime());let i;if(typeof h=="string"?i=L(k(h)):i=h,!c||!i)return!1;const u=c.majorBase,r=c.minorBase,n=c.patchBase;let o=i.majorBase,d=i.minorBase,s=i.patchBase;const a=i.notBefore;let m=i.majorMustEqual,_=i.minorMustEqual,R=i.patchMustEqual;return i.isMinimum?u>o?!0:u<o?!1:r>d?!0:r<d||g&&g<a?!1:n>=s:(u===1&&o===0&&(!m||!_||!R)&&(o=1,d=0,s=0,m=!0,_=!1,R=!1),u<o?!1:u>o?!m:r<d?!1:r>d?!_:n<s?!1:n>s?!R:!(g&&g<a))}e.isValidVersion=C;function E(f,v,h,c,g){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([t.default.Error,I.localize(0,null)]),i;if(typeof c.name!="string")return i.push([t.default.Error,I.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([t.default.Error,I.localize(2,null,"version")]),i;if(!c.engines)return i.push([t.default.Error,I.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([t.default.Error,I.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!b(c.extensionDependencies))return i.push([t.default.Error,I.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!b(c.activationEvents))return i.push([t.default.Error,I.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([t.default.Error,I.localize(7,null,"activationEvents","main")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([t.default.Warning,I.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([t.default.Error,I.localize(9,null,"main")]),i;{const n=(0,l.joinPath)(h,c.main);(0,l.isEqualOrParent)(n,h)||i.push([t.default.Warning,I.localize(10,null,n.path,h.path)])}if(typeof c.activationEvents>"u")return i.push([t.default.Error,I.localize(11,null,"activationEvents","main")]),i}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([t.default.Error,I.localize(12,null,"browser")]),i;{const n=(0,l.joinPath)(h,c.browser);(0,l.isEqualOrParent)(n,h)||i.push([t.default.Warning,I.localize(13,null,n.path,h.path)])}if(typeof c.activationEvents>"u")return i.push([t.default.Error,I.localize(14,null,"activationEvents","browser")]),i}if(!P.valid(c.version))return i.push([t.default.Error,I.localize(15,null)]),i;const u=[];if(!T(f,v,c,g,u))for(const n of u)i.push([t.default.Error,n]);return i}e.validateExtensionManifest=E;function T(f,v,h,c,g){return c||typeof h.main>"u"&&typeof h.browser>"u"?!0:p(f,v,h.engines.vscode,g)}e.isValidExtensionVersion=T;function S(f,v,h){return f==="*"||p(v,h,f)}e.isEngineValid=S;function p(f,v,h,c=[]){const g=L(k(h));if(!g)return c.push(I.localize(16,null,h)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return c.push(I.localize(17,null,h)),!1}else if(!g.majorMustEqual)return c.push(I.localize(18,null,h)),!1;return C(f,v,g)?!0:(c.push(I.localize(19,null,f,h)),!1)}function b(f){if(!Array.isArray(f))return!1;for(let v=0,h=f.length;v<h;v++)if(typeof f[v]!="string")return!1;return!0}}),define(Ce[118],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class l{constructor(I,P=[],y=!1){this.ctor=I,this.staticArguments=P,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=l}),define(Ce[83],De([1,0,118]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var I;(function(D){D[D.Eager=0]="Eager",D[D.Delayed=1]="Delayed"})(I=e.InstantiationType||(e.InstantiationType={}));function P(D,w,k){w instanceof l.SyncDescriptor||(w=new l.SyncDescriptor(w,[],Boolean(k))),t.push([D,w])}e.registerSingleton=P;function y(){return t}e.getSingletonServiceDescriptors=y}),define(Ce[189],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class l{constructor(P,y){this.key=P,this.data=y,this.incoming=new Map,this.outgoing=new Map}}e.Node=l;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const y of this._nodes.values())y.outgoing.size===0&&P.push(y);return P}insertEdge(P,y){const D=this.lookupOrInsertNode(P),w=this.lookupOrInsertNode(y);D.outgoing.set(w.key,w),w.incoming.set(D.key,D)}removeNode(P){const y=this._hashFn(P);this._nodes.delete(y);for(const D of this._nodes.values())D.outgoing.delete(y),D.incoming.delete(y)}lookupOrInsertNode(P){const y=this._hashFn(P);let D=this._nodes.get(y);return D||(D=new l(y,P),this._nodes.set(y,D)),D}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[y,D]of this._nodes)P.push(`${y}
	(-> incoming)[${[...D.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...D.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,y]of this._nodes){const D=new Set([P]),w=this._findCycle(y,D);if(w)return w}}_findCycle(P,y){for(const[D,w]of P.outgoing){if(y.has(D))return[...y,D].join(" -> ");y.add(D);const k=this._findCycle(w,y);if(k)return k;y.delete(D)}}}e.Graph=t}),define(Ce[3],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var l;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function D(w){return w[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=D})(l=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(y,D,w){D[l.DI_TARGET]===D?D[l.DI_DEPENDENCIES].push({id:y,index:w}):(D[l.DI_DEPENDENCIES]=[{id:y,index:w}],D[l.DI_TARGET]=D)}function I(y){if(l.serviceIds.has(y))return l.serviceIds.get(y);const D=function(w,k,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(D,w,L)};return D.toString=()=>y,l.serviceIds.set(y,D),D}e.createDecorator=I;function P(y){return y}e.refineServiceDecorator=P}),define(Ce[65],De([1,0,13,2,3]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function P(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationOverrides=P;function y(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=y;var D;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function k(f,v){const h=Object.create(null);for(const c in f)L(h,c,f[c],v);return h}e.toValuesTree=k;function L(f,v,h,c){const g=v.split("."),i=g.pop();let u=f;for(let r=0;r<g.length;r++){const n=g[r];let o=u[n];switch(typeof o){case"undefined":o=u[n]=Object.create(null);break;case"object":break;default:c(`Ignoring ${v} as ${g.slice(0,r+1).join(".")} is ${JSON.stringify(o)}`);return}u=o}if(typeof u=="object"&&u!==null)try{u[i]=h}catch{c(`Ignoring ${v} as ${g.join(".")} is ${JSON.stringify(u)}`)}else c(`Ignoring ${v} as ${g.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=L;function C(f,v){const h=v.split(".");E(f,h)}e.removeFromValueTree=C;function E(f,v){const h=v.shift();if(v.length===0){delete f[h];return}if(Object.keys(f).indexOf(h)!==-1){const c=f[h];typeof c=="object"&&!Array.isArray(c)&&(E(c,v),Object.keys(c).length===0&&delete f[h])}}function T(f,v,h){function c(u,r){let n=u;for(const o of r){if(typeof n!="object"||n===null)return;n=n[o]}return n}const g=v.split("."),i=c(f,g);return typeof i>"u"?h:i}e.getConfigurationValue=T;function S(f,v,h){Object.keys(v).forEach(c=>{c!=="__proto__"&&(c in f?l.isObject(f[c])&&l.isObject(v[c])?S(f[c],v[c],h):h&&(f[c]=v[c]):f[c]=v[c])})}e.merge=S;function p(f,v,h){const c=f.inspect(v),g=f.inspect(h);return typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:c.defaultValue}e.getMigratedSettingValue=p;function b(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(Ce[52],De([1,0,10,8,3]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",l.isMacintosh),P.set("isLinux",l.isLinux),P.set("isWindows",l.isWindows),P.set("isWeb",l.isWeb),P.set("isMacNative",l.isMacintosh&&!l.isWeb),P.set("isEdge",l.isEdge),P.set("isFirefox",l.isFirefox),P.set("isChrome",l.isChrome),P.set("isSafari",l.isSafari);const y=Object.prototype.hasOwnProperty;var D;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return C.INSTANCE}static true(){return E.INSTANCE}static has(A){return T.create(A)}static equals(A,z){return S.create(A,z)}static notEquals(A,z){return f.create(A,z)}static regex(A,z){return r.create(A,z)}static in(A,z){return p.create(A,z)}static notIn(A,z){return b.create(A,z)}static not(A){return v.create(A)}static and(...A){return d.create(A,null)}static or(...A){return s.create(A,null,!0)}static greater(A,z){return c.create(A,z)}static greaterEquals(A,z){return g.create(A,z)}static smaller(A,z){return i.create(A,z)}static smallerEquals(A,z){return u.create(A,z)}static deserialize(A,z=!1){if(!!A)return this._deserializeOrExpression(A,z)}static _deserializeOrExpression(A,z){const $=A.split("||");return s.create($.map(N=>this._deserializeAndExpression(N,z)),null,!0)}static _deserializeAndExpression(A,z){const $=A.split("&&");return d.create($.map(N=>this._deserializeOne(N,z)),null)}static _deserializeOne(A,z){if(A=A.trim(),A.indexOf("!=")>=0){const $=A.split("!=");return f.create($[0].trim(),this._deserializeValue($[1],z))}if(A.indexOf("==")>=0){const $=A.split("==");return S.create($[0].trim(),this._deserializeValue($[1],z))}if(A.indexOf("=~")>=0){const $=A.split("=~");return r.create($[0].trim(),this._deserializeRegexValue($[1],z))}if(A.indexOf(" not in ")>=0){const $=A.split(" not in ");return b.create($[0].trim(),this._deserializeValue($[1],z))}if(A.indexOf(" in ")>=0){const $=A.split(" in ");return p.create($[0].trim(),this._deserializeValue($[1],z))}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const $=A.split(">=");return g.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const $=A.split(">");return c.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const $=A.split("<=");return u.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const $=A.split("<");return i.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(A)?v.create(A.substr(1).trim()):T.create(A)}static _deserializeValue(A,z){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;const $=/^'([^']*)'$/.exec(A);return $?$[1].trim():A}static _deserializeRegexValue(A,z){if((0,t.isFalsyOrWhitespace)(A)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=A.indexOf("/"),N=A.lastIndexOf("/");if($===N||$<0){if(z)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}const V=A.slice($+1,N),B=A[N+1]==="i"?"i":"";try{return new RegExp(V,B)}catch(F){if(z)throw new Error(`bad regexp-value '${A}', parse error: ${F}`);return console.warn(`bad regexp-value '${A}', parse error: ${F}`),null}}}e.ContextKeyExpr=w;function k(U,A){const z=U?U.substituteConstants():void 0,$=A?A.substituteConstants():void 0;return!z&&!$?!0:!z||!$?!1:z.equals($)}e.expressionsAreEqualWithConstantSubstitution=k;function L(U,A){return U.cmp(A)}class C{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class E{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class T{static create(A,z=null){const $=P.get(A);return typeof $=="boolean"?$?E.INSTANCE:C.INSTANCE:new T(A,z)}constructor(A,z){this.key=A,this.negated=z,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:m(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?E.INSTANCE:C.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class S{static create(A,z,$=null){if(typeof z=="boolean")return z?T.create(A,$):v.create(A,$);const N=P.get(A);return typeof N=="boolean"?z===(N?"true":"false")?E.INSTANCE:C.INSTANCE:new S(A,z,$)}constructor(A,z,$){this.key=A,this.value=z,this.negated=$,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:_(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const z=A?"true":"false";return this.value===z?E.INSTANCE:C.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=S;class p{static create(A,z){return new p(A,z)}constructor(A,z){this.key=A,this.valueKey=z,this.type=10,this.negated=null}cmp(A){return A.type!==this.type?this.type-A.type:_(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const z=A.getValue(this.valueKey),$=A.getValue(this.key);return Array.isArray(z)?z.includes($):typeof $=="string"&&typeof z=="object"&&z!==null?y.call(z,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=p;class b{static create(A,z){return new b(A,z)}constructor(A,z){this.key=A,this.valueKey=z,this.type=11,this._negated=p.create(A,z)}cmp(A){return A.type!==this.type?this.type-A.type:this._negated.cmp(A._negated)}equals(A){return A.type===this.type?this._negated.equals(A._negated):!1}substituteConstants(){return this}evaluate(A){return!this._negated.evaluate(A)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(A){return A.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=b;class f{static create(A,z,$=null){if(typeof z=="boolean")return z?v.create(A,$):T.create(A,$);const N=P.get(A);return typeof N=="boolean"?z===(N?"true":"false")?C.INSTANCE:E.INSTANCE:new f(A,z,$)}constructor(A,z,$){this.key=A,this.value=z,this.negated=$,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:_(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const z=A?"true":"false";return this.value===z?C.INSTANCE:E.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=f;class v{static create(A,z=null){const $=P.get(A);return typeof $=="boolean"?$?C.INSTANCE:E.INSTANCE:new v(A,z)}constructor(A,z){this.key=A,this.negated=z,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:m(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?C.INSTANCE:E.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function h(U,A){if(typeof U=="string"){const z=parseFloat(U);isNaN(z)||(U=z)}return typeof U=="string"||typeof U=="number"?A(U):C.INSTANCE}class c{static create(A,z,$=null){return h(z,N=>new c(A,N,$))}constructor(A,z,$){this.key=A,this.value=z,this.negated=$,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:_(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class g{static create(A,z,$=null){return h(z,N=>new g(A,N,$))}constructor(A,z,$){this.key=A,this.value=z,this.negated=$,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:_(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=g;class i{static create(A,z,$=null){return h(z,N=>new i(A,N,$))}constructor(A,z,$){this.key=A,this.value=z,this.negated=$,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:_(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class u{static create(A,z,$=null){return h(z,N=>new u(A,N,$))}constructor(A,z,$){this.key=A,this.value=z,this.negated=$,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:_(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class r{static create(A,z){return new r(A,z)}constructor(A,z){this.key=A,this.regexp=z,this.type=7,this.negated=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const z=this.regexp?this.regexp.source:"",$=A.regexp?A.regexp.source:"";return z<$?-1:z>$?1:0}equals(A){if(A.type===this.type){const z=this.regexp?this.regexp.source:"",$=A.regexp?A.regexp.source:"";return this.key===A.key&&z===$}return!1}substituteConstants(){return this}evaluate(A){const z=A.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class n{static create(A){return new n(A)}constructor(A){this._actual=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(A){return new n(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function o(U){let A=null;for(let z=0,$=U.length;z<$;z++){const N=U[z].substituteConstants();if(U[z]!==N&&A===null){A=[];for(let V=0;V<z;V++)A[V]=U[V]}A!==null&&(A[z]=N)}return A===null?U:A}class d{static create(A,z){return d._normalizeArr(A,z)}constructor(A,z){this.expr=A,this.negated=z,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let z=0,$=this.expr.length;z<$;z++){const N=L(this.expr[z],A.expr[z]);if(N!==0)return N}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let z=0,$=this.expr.length;z<$;z++)if(!this.expr[z].equals(A.expr[z]))return!1;return!0}return!1}substituteConstants(){const A=o(this.expr);return A===this.expr?this:d.create(A,this.negated)}evaluate(A){for(let z=0,$=this.expr.length;z<$;z++)if(!this.expr[z].evaluate(A))return!1;return!0}static _normalizeArr(A,z){const $=[];let N=!1;for(const V of A)if(!!V){if(V.type===1){N=!0;continue}if(V.type===0)return C.INSTANCE;if(V.type===6){$.push(...V.expr);continue}$.push(V)}if($.length===0&&N)return E.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(L);for(let V=1;V<$.length;V++)$[V-1].equals($[V])&&($.splice(V,1),V--);if($.length===1)return $[0];for(;$.length>1;){const V=$[$.length-1];if(V.type!==9)break;$.pop();const B=$.pop(),F=$.length===0,x=s.create(V.expr.map(H=>d.create([H,B],null)),null,F);x&&($.push(x),$.sort(L))}return $.length===1?$[0]:new d($,z)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const z of this.expr)A.push(...z.keys());return A}map(A){return new d(this.expr.map(z=>z.map(A)),null)}negate(){if(!this.negated){const A=[];for(const z of this.expr)A.push(z.negate());this.negated=s.create(A,this,!0)}return this.negated}}class s{static create(A,z,$){return s._normalizeArr(A,z,$)}constructor(A,z){this.expr=A,this.negated=z,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let z=0,$=this.expr.length;z<$;z++){const N=L(this.expr[z],A.expr[z]);if(N!==0)return N}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let z=0,$=this.expr.length;z<$;z++)if(!this.expr[z].equals(A.expr[z]))return!1;return!0}return!1}substituteConstants(){const A=o(this.expr);return A===this.expr?this:s.create(A,this.negated,!1)}evaluate(A){for(let z=0,$=this.expr.length;z<$;z++)if(this.expr[z].evaluate(A))return!0;return!1}static _normalizeArr(A,z,$){let N=[],V=!1;if(A){for(let B=0,F=A.length;B<F;B++){const x=A[B];if(!!x){if(x.type===0){V=!0;continue}if(x.type===1)return E.INSTANCE;if(x.type===9){N=N.concat(x.expr);continue}N.push(x)}}if(N.length===0&&V)return C.INSTANCE;N.sort(L)}if(N.length!==0){if(N.length===1)return N[0];for(let B=1;B<N.length;B++)N[B-1].equals(N[B])&&(N.splice(B,1),B--);if(N.length===1)return N[0];if($){for(let B=0;B<N.length;B++)for(let F=B+1;F<N.length;F++)R(N[B],N[F])&&(N.splice(F,1),F--);if(N.length===1)return N[0]}return new s(N,z)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const z of this.expr)A.push(...z.keys());return A}map(A){return new s(this.expr.map(z=>z.map(A)),null)}negate(){if(!this.negated){const A=[];for(const z of this.expr)A.push(z.negate());for(;A.length>1;){const z=A.shift(),$=A.shift(),N=[];for(const B of M(z))for(const F of M($))N.push(d.create([B,F],null));const V=A.length===0;A.unshift(s.create(N,null,V))}this.negated=A[0]}return this.negated}}class a extends T{static all(){return a._info.values()}constructor(A,z,$){super(A,null),this._defaultValue=z,typeof $=="object"?a._info.push({...$,key:A}):$!==!0&&a._info.push({key:A,description:$,type:z!=null?typeof z:void 0})}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return S.create(this.key,A)}notEqualsTo(A){return f.create(this.key,A)}}e.RawContextKey=a,a._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(U,A){return U<A?-1:U>A?1:0}function _(U,A,z,$){return U<z?-1:U>z?1:A<$?-1:A>$?1:0}function R(U,A){if(A.type===6&&U.type!==9&&U.type!==6){for(const N of A.expr)if(U.equals(N))return!0}const z=U.negate(),$=M(z).concat(M(A));$.sort(L);for(let N=0;N<$.length;N++){const B=$[N].negate();for(let F=N+1;F<$.length;F++){const x=$[F];if(B.equals(x))return!0}}return!1}e.implies=R;function M(U){return U.type===9?U.expr:[U]}}),define(Ce[190],De([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,l.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,l.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[119],De([1,0,164,3]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function I(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function P(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function y(f,v){switch(f){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function D(f,v){return v==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function w(f,v,h){return D(v,h)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===h?!0:k(h).includes(f)}e.isTargetPlatformCompatible=w;function k(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function L(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=L;var C;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var E;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var T;(function(f){f.Install="install",f.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var S;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var p;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(v,h){super(v),this.code=h,this.name=h}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,l.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,l.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ce[191],De([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,l.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,l.createDecorator)("externalTerminal")}),define(Ce[192],De([1,0,44,14,9,10,104,29,112,166,191]),function(J,e,l,t,I,P,y,D,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const C=k.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends E{openTerminal(c,g){return this.spawnTerminal(l,c,w.getWindowsShell(),g)}spawnTerminal(c,g,i,u){const r=g.windowsExec||T.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const n=I.basename(r).toLowerCase();if(n==="cmder"||n==="cmder.exe")return c.spawn(r,u?[u]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return r.indexOf(" ")>=0&&o.push('""'),o.push(r),(n==="wt"||n==="wt.exe")&&o.push("-d ."),new Promise((d,s)=>{const a=b(process),m=c.spawn(i,o,{cwd:u,env:a});m.on("error",s),m.on("exit",()=>d())})}runInTerminal(c,g,i,u,r){const n="windowsExec"in r&&r.windowsExec?r.windowsExec:T.getDefaultTerminalWindows();return new Promise((o,d)=>{const s=`"${g} - ${C}"`,a=`""${i.join('" "')}" & pause"`,m=["/c","start",s,"/wait",n,"/c",a],_=Object.assign({},b(process),u);Object.keys(_).filter(U=>_[U]===null).forEach(U=>delete _[U]);const R={cwd:g,env:_,windowsVerbatimArguments:!0};l.spawn(T.CMD,m,R).on("error",U=>{d(f(U))}),o(void 0)})}static getDefaultTerminalWindows(){if(!T._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return T._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=T,T.CMD="cmd.exe";class S extends E{openTerminal(c,g){return this.spawnTerminal(l,c,g)}runInTerminal(c,g,i,u,r){const n=r.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((o,d)=>{if(n===L.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const s=n===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",m=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${s}.scpt`,J).fsPath,"-t",c||C,"-w",g];for(const M of i)m.push("-a"),m.push(M);if(u){const M=Object.assign({},b(process),u);for(const U in M){const A=M[U];A===null?(m.push("-u"),m.push(U)):(m.push("-e"),m.push(`${U}=${A}`))}}let _="";const R=l.spawn(S.OSASCRIPT,m);R.on("error",M=>{d(f(M))}),R.stderr.on("data",M=>{_+=M.toString()}),R.on("exit",M=>{if(M===0)o(void 0);else if(_){const U=_.split(`
`,1);d(new Error(U[0]))}else d(new Error(k.localize(1,null,s,M)))})}else d(new Error(k.localize(2,null,n)))})}spawnTerminal(c,g,i){const u=g.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,n)=>{const o=["-a",u];i&&o.push(i);const d=b(process),s=c.spawn("/usr/bin/open",o,{cwd:i,env:d});s.on("error",n),s.on("exit",()=>r())})}}e.MacExternalTerminalService=S,S.OSASCRIPT="/usr/bin/osascript";class p extends E{openTerminal(c,g){return this.spawnTerminal(l,c,g)}runInTerminal(c,g,i,u,r){const n=r.linuxExec?Promise.resolve(r.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((o,d)=>{const s=[];n.then(a=>{a.indexOf("gnome-terminal")>=0?s.push("-x"):s.push("-e"),s.push("bash"),s.push("-c");const m=`${v(i)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;s.push(`''${m}''`);const _=Object.assign({},b(process),u);Object.keys(_).filter(A=>_[A]===null).forEach(A=>delete _[A]);const R={cwd:g,env:_};let M="";const U=l.spawn(a,s,R);U.on("error",A=>{d(f(A))}),U.stderr.on("data",A=>{M+=A.toString()}),U.on("exit",A=>{if(A===0)o(void 0);else if(M){const z=M.split(`
`,1);d(new Error(z[0]))}else d(new Error(k.localize(4,null,a,A)))})})})}static async getDefaultTerminalLinuxReady(){if(!p._DEFAULT_TERMINAL_LINUX_READY)if(!P.isLinux)p._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const c=await D.Promises.exists("/etc/debian_version");p._DEFAULT_TERMINAL_LINUX_READY=new Promise(g=>{c?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(c,g,i){const u=g.linuxExec?Promise.resolve(g.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((r,n)=>{u.then(o=>{const d=b(process),s=c.spawn(o,[],{cwd:i,env:d});s.on("error",n),s.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=p,p.WAIT_MESSAGE=k.localize(3,null);function b(h){const c={...h.env};return(0,y.sanitizeProcessEnvironment)(c),c}function f(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(k.localize(5,null,h.path)):h}function v(h){let c="";for(const g of h)g.indexOf(" ")>=0?c+='"'+g+'"':c+=g,c+=" ";return c}}),define(Ce[38],De([1,0,26,9,8,13,2,167,3]),function(J,e,l,t,I,P,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function k(B){return B.create===!0}e.isFileOpenForWriteOptions=k;var L;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var C;(function(B){B[B.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var E;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function T(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=T;function S(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=S;function p(B){return!!(B.capabilities&32768)}e.hasFileCloneCapability=p;function b(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function f(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=f;function v(B){return T(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var h;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(h=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(F,x){super(F),this.code=x}}e.FileSystemProviderError=c;function g(B,F){const x=new c(B.toString(),F);return u(x,F),x}e.createFileSystemProviderError=g;function i(B){return B||g((0,D.localize)(0,null),h.Unknown)}e.ensureFileSystemProviderError=i;function u(B,F){return B.name=F?`${F} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=u;function r(B){if(!B)return h.Unknown;if(B instanceof c)return B.code;const F=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!F)return h.Unknown;switch(F[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileExceedsMemoryLimit:return h.FileExceedsMemoryLimit;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}e.toFileSystemProviderErrorCode=r;function n(B){if(B instanceof _)return B.fileOperationResult;switch(r(B)){case h.FileNotFound:return 1;case h.FileIsADirectory:return 0;case h.FileNotADirectory:return 10;case h.FileWriteLocked:return 5;case h.NoPermissions:return 6;case h.FileExists:return 4;case h.FileExceedsMemoryLimit:return 9;case h.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var o;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class d{constructor(F,x,H){this.resource=F,this.operation=x,this.target=H}isOperation(F){return this.operation===F}}e.FileOperationEvent=d;var s;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class a{constructor(F,x){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=F;const H=new Map;for(const Q of F){const K=H.get(Q.type);switch(K?K.push([Q.resource,Q]):H.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,K]of H)switch(Q){case 1:this.added=l.TernarySearchTree.forUris(()=>x),this.added.fill(K);break;case 0:this.updated=l.TernarySearchTree.forUris(()=>x),this.updated.fill(K);break;case 2:this.deleted=l.TernarySearchTree.forUris(()=>x),this.deleted.fill(K);break}}contains(F,...x){return this.doContains(F,{includeChildren:!1},...x)}affects(F,...x){return this.doContains(F,{includeChildren:!0},...x)}doContains(F,x,...H){if(!F)return!1;const Q=H.length>0;return!!((!Q||H.includes(1))&&(this.added?.get(F)||x.includeChildren&&this.added?.findSuperstr(F))||(!Q||H.includes(0))&&(this.updated?.get(F)||x.includeChildren&&this.updated?.findSuperstr(F))||(!Q||H.includes(2))&&(this.deleted?.findSubstr(F)||x.includeChildren&&this.deleted?.findSuperstr(F)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=a;function m(B,F,x){return!B||!F||B===F||F.length>B.length?!1:(F.charAt(F.length-1)!==t.sep&&(F+=t.sep),x?(0,I.startsWithIgnoreCase)(B,F):B.indexOf(F)===0)}e.isParent=m;class _ extends Error{constructor(F,x,H){super(F),this.fileOperationResult=x,this.options=H}}e.FileOperationError=_;class R extends _{constructor(F,x,H){super(F,2,H),this.stat=x}}e.NotModifiedSinceFileOperationError=R;var M;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function A(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=A;async function z(B,F){if(!F.hasProvider(y.URI.from({scheme:B.scheme})))return new Promise(x=>{const H=F.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===B.scheme&&Q.added&&(H.dispose(),x())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(F){return(0,P.isNumber)(F)||(F=0),F<$.KB?(0,D.localize)(1,null,F.toFixed(0)):F<$.MB?(0,D.localize)(2,null,(F/$.KB).toFixed(2)):F<$.GB?(0,D.localize)(3,null,(F/$.MB).toFixed(2)):F<$.TB?(0,D.localize)(4,null,(F/$.GB).toFixed(2)):(0,D.localize)(5,null,(F/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var N;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(N=e.Arch||(e.Arch={}));function V(B){return{maxFileSize:B===0?300*$.MB:16*$.GB,maxHeapSize:B===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=V}),define(Ce[84],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class l{constructor(...I){this._entries=new Map;for(const[P,y]of I)this.set(P,y)}set(I,P){const y=this._entries.get(I);return this._entries.set(I,P),y}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=l}),define(Ce[193],De([1,0,18,11,6,118,189,3,84,62]),function(J,e,l,t,I,P,y,D,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class C extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class E{constructor(b=new w.ServiceCollection,f=!1,v,h=L){this._services=b,this._strict=f,this._parent=v,this._enableTracing=h,this._activeInstantiations=new Set,this._services.set(D.IInstantiationService,this),this._globalGraph=h?v?._globalGraph??new y.Graph(c=>c):void 0}createChild(b){return new E(b,this._strict,this,this._enableTracing)}invokeFunction(b,...f){const v=S.traceInvocation(this._enableTracing,b);let h=!1;try{return b({get:g=>{if(h)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(g,v);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...f)}finally{h=!0,v.stop()}}createInstance(b,...f){let v,h;return b instanceof P.SyncDescriptor?(v=S.traceCreation(this._enableTracing,b.ctor),h=this._createInstance(b.ctor,b.staticArguments.concat(f),v)):(v=S.traceCreation(this._enableTracing,b),h=this._createInstance(b,f,v)),v.stop(),h}_createInstance(b,f=[],v){const h=D._util.getServiceDependencies(b).sort((i,u)=>i.index-u.index),c=[];for(const i of h){const u=this._getOrCreateServiceInstance(i.id,v);u||this._throwIfStrict(`[createInstance] ${b.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(u)}const g=h.length>0?h[0].index:f.length;if(f.length!==g){console.trace(`[createInstance] First service dependency of ${b.name} at position ${g+1} conflicts with ${f.length} static arguments`);const i=g-f.length;i>0?f=f.concat(new Array(i)):f=f.slice(0,g)}return Reflect.construct(b,f.concat(c))}_setServiceInstance(b,f){if(this._services.get(b)instanceof P.SyncDescriptor)this._services.set(b,f);else if(this._parent)this._parent._setServiceInstance(b,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(b){const f=this._services.get(b);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(b):f}_getOrCreateServiceInstance(b,f){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(b));const v=this._getServiceInstanceOrDescriptor(b);return v instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(b,v,f.branch(b,!0)):(f.branch(b,!1),v)}_safeCreateAndCacheServiceInstance(b,f,v){if(this._activeInstantiations.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this._activeInstantiations.add(b);try{return this._createAndCacheServiceInstance(b,f,v)}finally{this._activeInstantiations.delete(b)}}_createAndCacheServiceInstance(b,f,v){const h=new y.Graph(i=>i.id.toString());let c=0;const g=[{id:b,desc:f,_trace:v}];for(;g.length;){const i=g.pop();if(h.lookupOrInsertNode(i),c++>1e3)throw new C(h);for(const u of D._util.getServiceDependencies(i.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(u.id);if(r||this._throwIfStrict(`[createInstance] ${b} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(u.id)),r instanceof P.SyncDescriptor){const n={id:u.id,desc:r,_trace:i._trace.branch(u.id,!0)};h.insertEdge(i,n),g.push(n)}}}for(;;){const i=h.roots();if(i.length===0){if(!h.isEmpty())throw new C(h);break}for(const{data:u}of i){if(this._getServiceInstanceOrDescriptor(u.id)instanceof P.SyncDescriptor){const n=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,n)}h.removeNode(u)}}return this._getServiceInstanceOrDescriptor(b)}_createServiceInstanceWithOwner(b,f,v=[],h,c){if(this._services.get(b)instanceof P.SyncDescriptor)return this._createServiceInstance(b,f,v,h,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(b,f,v,h,c);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(b,f,v=[],h,c){if(h){const g=new E(void 0,this._strict,this,this._enableTracing);g._globalGraphImplicitDependency=String(b);const i=new Map,u=new l.IdleValue(()=>{const r=g._createInstance(f,v,c);for(const[n,o]of i){const d=r[n];if(typeof d=="function")for(const s of o)d.apply(r,s)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,n){if(!u.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let s=i.get(n);return s||(s=new k.LinkedList,i.set(n,s)),(m,_,R)=>{const M=s.push([m,_,R]);return(0,I.toDisposable)(M)}}if(n in r)return r[n];const o=u.value;let d=o[n];return typeof d!="function"||(d=d.bind(o),r[n]=d),d},set(r,n,o){return u.value[n]=o,!0}})}else return this._createInstance(f,v,c)}_throwIfStrict(b,f){if(f&&console.warn(b),this._strict)throw new Error(b)}}e.InstantiationService=E;var T;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(T||(T={}));class S{static traceInvocation(b,f){return b?new S(1,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S._None}static traceCreation(b,f){return b?new S(0,f.name):S._None}constructor(b,f){this.type=b,this.name=f,this._start=Date.now(),this._dep=[]}branch(b,f){const v=new S(2,b.toString());return this._dep.push([b,f,v]),v}stop(){const b=Date.now()-this._start;S._totals+=b;let f=!1;function v(c,g){const i=[],u=new Array(c+1).join("	");for(const[r,n,o]of g._dep)if(n&&o){f=!0,i.push(`${u}CREATES -> ${r}`);const d=v(c+1,o);d&&i.push(d)}else i.push(`${u}uses -> ${r}`);return i.join(`
`)}const h=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(b>2||f)&&S.all.add(h.join(`
`))}}e.Trace=S,S.all=new Set,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(Ce[12],De([1,0,50,4,6,10,3]),function(J,e,l,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function D(){return new Date().toISOString()}var w;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function k(u,r,n){switch(r){case w.Trace:u.trace(n);break;case w.Debug:u.debug(n);break;case w.Info:u.info(n);break;case w.Warning:u.warn(n);break;case w.Error:u.error(n);break;case w.Critical:u.critical(n);break;default:throw new Error("Invalid log level")}}e.log=k;function L(u){let r="";for(let n=0;n<u.length;n++){let o=u[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}r+=(n>0?" ":"")+o}return r}e.format=L;class C extends I.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class E extends C{constructor(r){super(),this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...n){this.checkLogLevel(w.Trace)&&this.log(w.Trace,L([r,...n]))}debug(r,...n){this.checkLogLevel(w.Debug)&&this.log(w.Debug,L([r,...n]))}info(r,...n){this.checkLogLevel(w.Info)&&this.log(w.Info,L([r,...n]))}warn(r,...n){this.checkLogLevel(w.Warning)&&this.log(w.Warning,L([r,...n]))}error(r,...n){if(this.checkLogLevel(w.Error))if(r instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=r.stack,this.log(w.Error,L(o))}else this.log(w.Error,L([r,...n]))}critical(r,...n){this.checkLogLevel(w.Critical)&&this.log(w.Critical,L([r,...n]))}flush(){}}e.AbstractMessageLogger=E;class T extends C{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r),this.useColors=!P.isWindows}trace(r,...n){this.getLevel()<=w.Trace&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,r,...n):console.log(`[main ${D()}]`,r,...n))}debug(r,...n){this.getLevel()<=w.Debug&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,r,...n):console.log(`[main ${D()}]`,r,...n))}info(r,...n){this.getLevel()<=w.Info&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,r,...n):console.log(`[main ${D()}]`,r,...n))}warn(r,...n){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,r,...n):console.warn(`[main ${D()}]`,r,...n))}error(r,...n){this.getLevel()<=w.Error&&(this.useColors?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,r,...n):console.error(`[main ${D()}]`,r,...n))}critical(r,...n){this.getLevel()<=w.Critical&&(this.useColors?console.error(`\x1B[90m[main ${D()}]\x1B[0m`,r,...n):console.error(`[main ${D()}]`,r,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class S extends C{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r)}trace(r,...n){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",r,...n)}debug(r,...n){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...n)}info(r,...n){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",r,...n)}warn(r,...n){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",r,...n)}error(r,...n){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",r,...n)}critical(r,...n){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...n)}dispose(){}flush(){}}e.ConsoleLogger=S;class p extends C{constructor(r,n=e.DEFAULT_LOG_LEVEL){super(),this.adapter=r,this.setLevel(n)}trace(r,...n){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(r),...n])}debug(r,...n){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(r),...n])}info(r,...n){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(r),...n])}warn(r,...n){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(r),...n])}error(r,...n){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(r),...n])}critical(r,...n){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(r),...n])}extractMessage(r){return typeof r=="string"?r:(0,l.toErrorMessage)(r,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class b extends C{constructor(r){super(),this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const n of this.logServices)n.setLevel(r);super.setLevel(r)}trace(r,...n){for(const o of this.logServices)o.trace(r,...n)}debug(r,...n){for(const o of this.logServices)o.debug(r,...n)}info(r,...n){for(const o of this.logServices)o.info(r,...n)}warn(r,...n){for(const o of this.logServices)o.warn(r,...n)}error(r,...n){for(const o of this.logServices)o.error(r,...n)}critical(r,...n){for(const o of this.logServices)o.critical(r,...n)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=b;class f extends I.Disposable{constructor(r){super(),this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...n){this.logger.trace(r,...n)}debug(r,...n){this.logger.debug(r,...n)}info(r,...n){this.logger.info(r,...n)}warn(r,...n){this.logger.warn(r,...n)}error(r,...n){this.logger.error(r,...n)}critical(r,...n){this.logger.critical(r,...n)}flush(){this.logger.flush()}}e.LogService=f;class v extends I.Disposable{constructor(r,n){super(),this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(o))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,n){let o=this.loggers.get(r.toString());return o||(o=this.doCreateLogger(r,n?.always?w.Trace:this.logLevel,n),this.loggers.set(r.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class h{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(r){}getLevel(){return w.Info}trace(r,...n){}debug(r,...n){}info(r,...n){}warn(r,...n){}error(r,...n){}critical(r,...n){}dispose(){}flush(){}}e.NullLogService=h;function c(u){if(u.verbose)return w.Trace;if(typeof u.logLevel=="string"){const r=g(u.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function g(u){switch(u){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=g;function i(u){switch(u){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=i}),define(Ce[194],De([1,0,38,12]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function I(D,w,k,L,C){try{const E=await new Promise((S,p)=>{J(["spdlog"],S,p)});E.setFlushOn(t.LogLevel.Trace);const T=await E.createAsyncRotatingLogger(D,w,k,L);return C?T.clearFormatters():T.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),T}catch(E){console.error(E)}return null}function P(D,w,k){switch(w){case t.LogLevel.Trace:D.trace(k);break;case t.LogLevel.Debug:D.debug(k);break;case t.LogLevel.Info:D.info(k);break;case t.LogLevel.Warning:D.warn(k);break;case t.LogLevel.Error:D.error(k);break;case t.LogLevel.Critical:D.critical(k);break;default:throw new Error("Invalid log level")}}class y extends t.AbstractMessageLogger{constructor(w,k,L,C,E){super(),this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(w,k,L,C),this._register(this.onDidChangeLogLevel(T=>{this._logger?.setLevel(T)}))}async _createSpdLogLogger(w,k,L,C){const E=L?6:1,T=30/E*l.ByteSize.MB,S=await I(w,k,T,E,C);if(S){this._logger=S,this._logger.setLevel(this.getLevel());for(const{level:p,message:b}of this.buffer)P(this._logger,p,b);this.buffer=[]}}log(w,k){this._logger?P(this._logger,w,k):this.getLevel()<=w&&this.buffer.push({level:w,message:k})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(Ce[120],De([1,0,42,168,3]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var y;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(w){function k(S,p){return p-S}w.compare=k;const L=Object.create(null);L[w.Error]=(0,t.localize)(0,null),L[w.Warning]=(0,t.localize)(1,null),L[w.Info]=(0,t.localize)(2,null);function C(S){return L[S]||""}w.toString=C;function E(S){switch(S){case l.default.Error:return w.Error;case l.default.Warning:return w.Warning;case l.default.Info:return w.Info;case l.default.Ignore:return w.Hint}}w.fromSeverity=E;function T(S){switch(S){case w.Error:return l.default.Error;case w.Warning:return l.default.Warning;case w.Info:return l.default.Info;case w.Hint:return l.default.Ignore}}w.toSeverity=T}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(w){const k="";function L(E){return C(E,!0)}w.makeKey=L;function C(E,T){const S=[k];return E.source?S.push(E.source.replace("\xA6","\\\xA6")):S.push(k),E.code?typeof E.code=="string"?S.push(E.code.replace("\xA6","\\\xA6")):S.push(E.code.value.replace("\xA6","\\\xA6")):S.push(k),E.severity!==void 0&&E.severity!==null?S.push(y.toString(E.severity)):S.push(k),E.message&&T?S.push(E.message.replace("\xA6","\\\xA6")):S.push(k),E.startLineNumber!==void 0&&E.startLineNumber!==null?S.push(E.startLineNumber.toString()):S.push(k),E.startColumn!==void 0&&E.startColumn!==null?S.push(E.startColumn.toString()):S.push(k),E.endLineNumber!==void 0&&E.endLineNumber!==null?S.push(E.endLineNumber.toString()):S.push(k),E.endColumn!==void 0&&E.endColumn!==null?S.push(E.endColumn.toString()):S.push(k),S.push(k),S.join("\xA6")}w.makeKeyOptionalMessage=C})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(Ce[195],De([1,0,4,42,3]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var P;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new w,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=D;class w{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=w}),define(Ce[121],De([1,0,6,8,2,3]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return l.Disposable.None},registerValidator(){return l.Disposable.None},registerExternalUriResolver(){return l.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return l.Disposable.None},async open(){return!1},async resolveExternalUri(L){return{resolved:L,dispose(){}}}});function y(L,C){return I.URI.isUri(L)?(0,t.equalsIgnoreCase)(L.scheme,C):(0,t.startsWithIgnoreCase)(L,C+":")}e.matchesScheme=y;function D(L,...C){return C.some(E=>y(L,E))}e.matchesSomeScheme=D;function w(L,C){return L.with({fragment:`${C.startLineNumber},${C.startColumn}${C.endLineNumber?`-${C.endLineNumber}${C.endColumn?`,${C.endColumn}`:""}`:""}`})}e.withSelection=w;function k(L){let C;const E=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(L.fragment);return E&&(C={startLineNumber:parseInt(E[1]),startColumn:E[2]?parseInt(E[2]):1,endLineNumber:E[4]?parseInt(E[4]):void 0,endColumn:E[4]?E[5]?parseInt(E[5]):1:void 0},L=L.with({fragment:""})),{selection:C,uri:L}}e.extractSelection=k}),define(Ce[196],De([1,0,14,10,36,22]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const D=t.globals.vscode.context.configuration();if(D)y=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const D=(0,P.dirname)(l.FileAccess.asFileUri("",J));if(y=J.__$__nodeRequire((0,P.joinPath)(D,"product.json").fsPath),I.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`,serverDataFolderName:y.serverDataFolderName?`${y.serverDataFolderName}-dev`:void 0}),!y.version){const w=J.__$__nodeRequire((0,P.joinPath)(D,"package.json").fsPath);Object.assign(y,{version:w.version})}}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=y}),define(Ce[197],De([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,l.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var He=this&&this.__param||function(J,e){return function(l,t){e(l,t,J)}};define(Ce[122],De([1,0,18,21,6,3]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var y;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{get value(){return this._value}constructor(C){this.callback=C}report(C){this._value=C,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let w=class extends I.Disposable{constructor(C,E){super(),this.deferred=new l.DeferredPromise,E.withProgress(C,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};w=je([He(1,e.IProgressService)],w),e.UnmanagedProgress=w;class k extends I.Disposable{constructor(C){super(),this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(C){this.stop();const E=++this.currentOperationId,T=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{E===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:E,token:T.token,stop:()=>this.doStop(E),isCurrent:()=>this.currentOperationId===E}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(Ce[43],De([1,0,48,13]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(y,D){l.ok(t.isString(y)),l.ok(t.isObject(D)),l.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,D)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new I}),define(Ce[123],De([1,0,4,43]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class P{constructor(){this._onDidChangeSchema=new l.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,k){this.schemasById[I(w)]=k,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new P;t.Registry.add(e.Extensions.JSONContribution,y)}),define(Ce[124],De([1,0,17,4,13,163,65,123,43]),function(J,e,l,t,I,P,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=w.Registry.as(D.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,u=!0){this.registerConfigurations([i],u)}registerConfigurations(i,u=!0){const r=this.doRegisterConfigurations(i,u);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(i){const u=this.doDeregisterConfigurations(i);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:i,remove:u}){const r=[];r.push(...this.doDeregisterConfigurations(u)),r.push(...this.doRegisterConfigurations(i,!1)),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,l.distinct)(r)})}registerDefaultConfigurations(i){const u=[],r=[];for(const{overrides:n,source:o}of i)for(const d in n)if(u.push(d),e.OVERRIDE_PROPERTY_REGEX.test(d)){const s=this.configurationDefaultsOverrides.get(d),a=s?.valuesSources??new Map;if(o)for(const M of Object.keys(n[d]))a.set(M,o);const m={...s?.value||{},...n[d]};this.configurationDefaultsOverrides.set(d,{source:o,value:m,valuesSources:a});const _=(0,y.getLanguageTagSettingPlainKey)(d),R={type:"object",default:m,description:P.localize(1,null,_),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:I.isString(o)?void 0:o,defaultValueSource:o};r.push(...p(d)),this.configurationProperties[d]=R,this.defaultLanguageConfigurationOverridesNode.properties[d]=R}else{this.configurationDefaultsOverrides.set(d,{value:n[d],source:o});const s=this.configurationProperties[d];s&&(this.updatePropertyDefaultValue(d,s),this.updateSchema(d,s))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const u=[];for(const{overrides:r,source:n}of i)for(const o in r){const d=this.configurationDefaultsOverrides.get(o),s=I.isString(n)?n:n?.id,a=I.isString(d?.source)?d?.source:d?.source?.id;if(s===a)if(u.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const m=this.configurationProperties[o];m&&(this.updatePropertyDefaultValue(o,m),this.updateSchema(o,m))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const u of i)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,u){const r=[];return i.forEach(n=>{r.push(...this.validateAndRegisterProperties(n,u,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),r}doDeregisterConfigurations(i){const u=[],r=n=>{if(n.properties)for(const o in n.properties){u.push(o);const d=this.configurationProperties[o];d?.policy?.name&&this.policyConfigurations.delete(d.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>r(o))};for(const n of i){r(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return u}validateAndRegisterProperties(i,u=!0,r,n,o=3){o=I.isUndefinedOrNull(i.scope)?o:i.scope;const d=[],s=i.properties;if(s)for(const m in s){const _=s[m];if(u&&h(m,_)){delete s[m];continue}if(_.source=r,_.defaultDefaultValue=s[m].default,this.updatePropertyDefaultValue(m,_),e.OVERRIDE_PROPERTY_REGEX.test(m)?_.scope=void 0:(_.scope=I.isUndefinedOrNull(_.scope)?o:_.scope,_.restricted=I.isUndefinedOrNull(_.restricted)?!!n?.includes(m):_.restricted),s[m].hasOwnProperty("included")&&!s[m].included){this.excludedConfigurationProperties[m]=s[m],delete s[m];continue}else this.configurationProperties[m]=s[m],s[m].policy?.name&&this.policyConfigurations.set(s[m].policy.name,m);!s[m].deprecationMessage&&s[m].markdownDeprecationMessage&&(s[m].deprecationMessage=s[m].markdownDeprecationMessage),d.push(m)}const a=i.allOf;if(a)for(const m of a)d.push(...this.validateAndRegisterProperties(m,u,r,n,o));return d}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const u=r=>{const n=r.properties;if(n)for(const d in n)this.updateSchema(d,n[d]);r.allOf?.forEach(u)};u(i)}updateSchema(i,u){switch(e.allSettings.properties[i]=u,u.scope){case 1:e.applicationSettings.properties[i]=u;break;case 2:e.machineSettings.properties[i]=u;break;case 6:e.machineOverridableSettings.properties[i]=u;break;case 3:e.windowSettings.properties[i]=u;break;case 4:e.resourceSettings.properties[i]=u;break;case 5:e.resourceSettings.properties[i]=u,this.resourceLanguageSettingsSchema.properties[i]=u;break}}removeFromSchema(i,u){switch(delete e.allSettings.properties[i],u.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const u=`[${i}]`,r={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,r),e.allSettings.properties[u]=r,e.applicationSettings.properties[u]=r,e.machineSettings.properties[u]=r,e.machineOverridableSettings.properties[u]=r,e.windowSettings.properties[u]=r,e.resourceSettings.properties[u]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,u){const r=this.configurationDefaultsOverrides.get(i);let n=r?.value,o=r?.source;I.isUndefined(n)&&(n=u.defaultDefaultValue,o=void 0),I.isUndefined(n)&&(n=f(u.type)),u.default=n,u.defaultValueSource=o}}const T="\\[([^\\]]+)\\]",S=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(g){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let u=S.exec(g);for(;u?.length;){const r=u[1].trim();r&&i.push(r),u=S.exec(g)}}return(0,l.distinct)(i)}e.overrideIdentifiersFromKey=p;function b(g){return g.reduce((i,u)=>`${i}[${u}]`,"")}e.keyFromOverrideIdentifiers=b;function f(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const v=new E;w.Registry.add(e.Extensions.Configuration,v);function h(g,i){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?P.localize(7,null,g):v.getConfigurationProperties()[g]!==void 0?P.localize(8,null,g):i.policy?.name&&v.getPolicyConfigurations().get(i.policy?.name)!==void 0?P.localize(9,null,g,i.policy?.name,v.getPolicyConfigurations().get(i.policy?.name)):null:P.localize(6,null)}e.validateProperty=h;function c(){const g=[],i=v.getConfigurationProperties();for(const u of Object.keys(i))g.push([u,i[u].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=c}),define(Ce[198],De([1,0,17,4,143,6,26,24,13,2,65,124,43]),function(J,e,l,t,I,P,y,D,w,k,L,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class T{constructor(i={},u=[],r=[],n){this._contents=i,this._keys=u,this._overrides=r,this.raw=n,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(u=>{if(u instanceof T)return u;const r=new S("");return r.parseRaw(u),r.configurationModel});this._rawConfiguration=i.reduce((u,r)=>r===u?r:u.merge(r),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,L.getConfigurationValue)(this.contents,i):this.contents}inspect(i,u){const r=this.rawConfiguration.getValue(i),n=u?this.rawConfiguration.getOverrideValue(i,u):void 0,o=u?this.rawConfiguration.override(u).getValue(i):r;return{value:r,override:n,merged:o}}getOverrideValue(i,u){const r=this.getContentsForOverrideIdentifer(u);return r?i?(0,L.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const u=[];for(const r of this.overrides)r.identifiers.includes(i)&&u.push(...r.keys);return l.distinct(u)}getAllOverrideIdentifiers(){const i=[];for(const u of this.overrides)i.push(...u.identifiers);return l.distinct(i)}override(i){let u=this.overrideConfigurations.get(i);return u||(u=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,u)),u}merge(...i){const u=D.deepClone(this.contents),r=D.deepClone(this.overrides),n=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const d of i)if(o.push(...d.raw?.length?d.raw:[d]),!d.isEmpty()){this.mergeContents(u,d.contents);for(const s of d.overrides){const[a]=r.filter(m=>l.equals(m.identifiers,s.identifiers));a?(this.mergeContents(a.contents,s.contents),a.keys.push(...s.keys),a.keys=l.distinct(a.keys)):r.push(D.deepClone(s))}for(const s of d.keys)n.indexOf(s)===-1&&n.push(s)}return new T(u,n,r,o.every(d=>d instanceof T)?void 0:o)}freeze(){return this.frozen=!0,this}clone(){return new T(D.deepClone(this.contents),[...this.keys],D.deepClone(this.overrides))}createOverrideConfigurationModel(i){const u=this.getContentsForOverrideIdentifer(i);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const r={};for(const n of l.distinct([...Object.keys(this.contents),...Object.keys(u)])){let o=this.contents[n];const d=u[n];d&&(typeof o=="object"&&typeof d=="object"?(o=D.deepClone(o),this.mergeContents(o,d)):o=d),r[n]=o}return new T(r,this.keys,this.overrides)}mergeContents(i,u){for(const r of Object.keys(u)){if(r in i&&w.isObject(i[r])&&w.isObject(u[r])){this.mergeContents(i[r],u[r]);continue}i[r]=D.deepClone(u[r])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?D.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let u=null,r=null;const n=o=>{o&&(r?this.mergeContents(r,o):r=D.deepClone(o))};for(const o of this.overrides)l.equals(o.identifiers,[i])?u=o.contents:o.identifiers.includes(i)&&n(o.contents);return n(u),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,u){this.addKey(i),(0,L.addToValueTree)(this.contents,i,u,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,L.removeFromValueTree)(this.contents,i)}addKey(i){let u=this.keys.length;for(let r=0;r<u;r++)i.indexOf(this.keys[r])===0&&(u=r);this.keys.splice(u,1,i)}removeKey(i){const u=this.keys.indexOf(i);return u!==-1?(this.keys.splice(u,1),!0):!1}}e.ConfigurationModel=T;class S{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,u){if(!w.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,u)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,u){this._raw=i;const{contents:r,keys:n,overrides:o,restricted:d,hasExcludedProperties:s}=this.doParseRaw(i,u);this._configurationModel=new T(r,n,o,s?[i]:void 0),this._restrictedConfigurations=d||[]}doParseContent(i){let u={},r=null,n=[];const o=[],d=[];function s(m){Array.isArray(n)?n.push(m):r!==null&&(n[r]=m)}const a={onObjectBegin:()=>{const m={};s(m),o.push(n),n=m,r=null},onObjectProperty:m=>{r=m},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const m=[];s(m),o.push(n),n=m,r=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:s,onError:(m,_,R)=>{d.push({error:m,offset:_,length:R})}};if(i)try{I.visit(i,a),u=n[0]||{}}catch(m){console.error(`Error while parsing settings file ${this._name}: ${m}`),this._parseErrors=[m]}return u}doParseRaw(i,u){const r=E.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),n=this.filter(i,r,!0,u);i=n.raw;const o=(0,L.toValuesTree)(i,a=>console.error(`Conflict in settings file ${this._name}: ${a}`)),d=Object.keys(i),s=this.toOverrides(i,a=>console.error(`Conflict in settings file ${this._name}: ${a}`));return{contents:o,keys:d,overrides:s,restricted:n.restricted,hasExcludedProperties:n.hasExcludedProperties}}filter(i,u,r,n){let o=!1;if(!n?.scopes&&!n?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:o};const d={},s=[];for(const a in i)if(C.OVERRIDE_PROPERTY_REGEX.test(a)&&r){const m=this.filter(i[a],u,!1,n);d[a]=m.raw,o=o||m.hasExcludedProperties,s.push(...m.restricted)}else{const m=u[a],_=m?typeof m.scope<"u"?m.scope:3:void 0;m?.restricted&&s.push(a),(_===void 0||n.scopes===void 0||n.scopes.includes(_))&&!(n.skipRestricted&&m?.restricted)?d[a]=i[a]:o=!0}return{raw:d,restricted:s,hasExcludedProperties:o}}toOverrides(i,u){const r=[];for(const n of Object.keys(i))if(C.OVERRIDE_PROPERTY_REGEX.test(n)){const o={};for(const d in i[n])o[d]=i[n][d];r.push({identifiers:(0,C.overrideIdentifiersFromKey)(n),keys:Object.keys(o),contents:(0,L.toValuesTree)(o,u)})}return r}}e.ConfigurationModelParser=S;class p extends P.Disposable{constructor(i,u,r,n){super(),this.userSettingsResource=i,this.scopes=u,this.fileService=n,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&r.isEqual(o.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class b{constructor(i,u,r,n,o=new T,d=new T,s=new y.ResourceMap,a=new T,m=new y.ResourceMap,_=!0){this._defaultConfiguration=i,this._policyConfiguration=u,this._applicationConfiguration=r,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=d,this._folderConfigurations=s,this._memoryConfiguration=a,this._memoryConfigurationByResource=m,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(i,u,r){return this.getConsolidatedConfigurationModel(i,u,r).getValue(i)}updateValue(i,u,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new T,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,u===void 0?n.removeValue(i):n.setValue(i,u),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,u,r){const n=this.getConsolidatedConfigurationModel(i,u,r),o=this.getFolderConfigurationModelForResource(u.resource,r),d=u.resource?this._memoryConfigurationByResource.get(u.resource)||this._memoryConfiguration:this._memoryConfiguration,s=this._defaultConfiguration.inspect(i,u.overrideIdentifier),a=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(i),m=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(i),_=this.userConfiguration.freeze().inspect(i,u.overrideIdentifier),R=this.localUserConfiguration.freeze().inspect(i,u.overrideIdentifier),M=this.remoteUserConfiguration.freeze().inspect(i,u.overrideIdentifier),U=r?this._workspaceConfiguration.freeze().inspect(i,u.overrideIdentifier):void 0,A=o?o.freeze().inspect(i,u.overrideIdentifier):void 0,z=d.inspect(i,u.overrideIdentifier),$=n.getValue(i),N=l.distinct(n.overrides.map(V=>V.identifiers).flat()).filter(V=>n.getOverrideValue(i,V)!==void 0);return{defaultValue:s?s.merged:void 0,policyValue:a?a.merged:void 0,applicationValue:m?m.merged:void 0,userValue:_?_.merged:void 0,userLocalValue:R?R.merged:void 0,userRemoteValue:M?M.merged:void 0,workspaceValue:U?U.merged:void 0,workspaceFolderValue:A?A.merged:void 0,memoryValue:z?z.merged:void 0,value:$,default:s.value!==void 0||s.override!==void 0?{value:s.value,override:s.override}:void 0,policy:a?.value!==void 0?{value:a.value}:void 0,application:m?.value!==void 0||m?.override!==void 0?{value:m.value,override:m.override}:void 0,user:_.value!==void 0||_.override!==void 0?{value:_.value,override:_.override}:void 0,userLocal:R.value!==void 0||R.override!==void 0?{value:R.value,override:R.override}:void 0,userRemote:M.value!==void 0||M.override!==void 0?{value:M.value,override:M.override}:void 0,workspace:U?.value!==void 0||U?.override!==void 0?{value:U.value,override:U.override}:void 0,workspaceFolder:A?.value!==void 0||A?.override!==void 0?{value:A.value,override:A.override}:void 0,memory:z.value!==void 0||z.override!==void 0?{value:z.value,override:z.override}:void 0,overrideIdentifiers:N.length?N:void 0}}keys(i){const u=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:u?u.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,u){this._folderConfigurations.set(i,u),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,u){const r=[];if(!u){const{added:n,updated:o,removed:d}=h(this._defaultConfiguration,i);u=[...n,...o,...d]}for(const n of u)for(const o of(0,C.overrideIdentifiersFromKey)(n)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(o),s=i.getKeysForOverrideIdentifier(o),a=[...s.filter(m=>d.indexOf(m)===-1),...d.filter(m=>s.indexOf(m)===-1),...d.filter(m=>!D.equals(this._defaultConfiguration.override(o).getValue(m),i.override(o).getValue(m)))];r.push([o,a])}return this.updateDefaultConfiguration(i),{keys:u,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:u,updated:r,removed:n}=h(this._policyConfiguration,i),o=[...u,...r,...n];return o.length&&this.updatePolicyConfiguration(i),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:u,updated:r,removed:n,overrides:o}=h(this.applicationConfiguration,i),d=[...u,...r,...n];return d.length&&this.updateApplicationConfiguration(i),{keys:d,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:u,updated:r,removed:n,overrides:o}=h(this.localUserConfiguration,i),d=[...u,...r,...n];return d.length&&this.updateLocalUserConfiguration(i),{keys:d,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:u,updated:r,removed:n,overrides:o}=h(this.remoteUserConfiguration,i),d=[...u,...r,...n];return d.length&&this.updateRemoteUserConfiguration(i),{keys:d,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:u,updated:r,removed:n,overrides:o}=h(this.workspaceConfiguration,i),d=[...u,...r,...n];return d.length&&this.updateWorkspaceConfiguration(i),{keys:d,overrides:o}}compareAndUpdateFolderConfiguration(i,u){const r=this.folderConfigurations.get(i),{added:n,updated:o,removed:d,overrides:s}=h(r,u),a=[...n,...o,...d];return(a.length||!r)&&this.updateFolderConfiguration(i,u),{keys:a,overrides:s}}compareAndDeleteFolderConfiguration(i){const u=this.folderConfigurations.get(i);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:n,removed:o,overrides:d}=h(u,void 0);return{keys:[...r,...n,...o],overrides:d}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,u,r){let n=this.getConsolidatedConfigurationModelForResource(u,r);return u.overrideIdentifier&&(n=n.override(u.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:i},u){let r=this.getWorkspaceConsolidatedConfiguration();if(u&&i){const n=u.getFolder(i);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const o=this._memoryConfigurationByResource.get(i);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let u=this._foldersConsolidatedConfigurations.get(i);if(!u){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(i);n?(u=r.merge(n),this._freeze&&(u=u.freeze()),this._foldersConsolidatedConfigurations.set(i,u)):u=r}return u}getFolderConfigurationModelForResource(i,u){if(u&&i){const r=u.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,u)=>{const{contents:r,overrides:n,keys:o}=this._folderConfigurations.get(u);return i.push([u,{contents:r,overrides:n,keys:o}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(u=>i.add(u)),this.userConfiguration.freeze().keys.forEach(u=>i.add(u)),this._workspaceConfiguration.freeze().keys.forEach(u=>i.add(u)),this._folderConfigurations.forEach(u=>u.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>i.add(u)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>i.add(u)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>i.add(u)),this._folderConfigurations.forEach(u=>u.freeze().getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const u=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>u.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>u.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>u.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(n=>u.add(n))),[...u.values()]}static parse(i){const u=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.policy),n=this.parseConfigurationModel(i.application),o=this.parseConfigurationModel(i.user),d=this.parseConfigurationModel(i.workspace),s=i.folders.reduce((a,m)=>(a.set(k.URI.revive(m[0]),this.parseConfigurationModel(m[1])),a),new y.ResourceMap);return new b(u,r,n,o,new T,d,s,new T,new y.ResourceMap,!1)}static parseConfigurationModel(i){return new T(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=b;function f(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const i=new Set,u=new Map;for(const n of g)n.keys.forEach(o=>i.add(o)),n.overrides.forEach(([o,d])=>{const s=(0,y.getOrSet)(u,o,new Set);d.forEach(a=>s.add(a))});const r=[];return u.forEach((n,o)=>r.push([o,[...n.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=f;class v{constructor(i,u,r,n){this.change=i,this.previous=u,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;i.keys.forEach(s=>o.add(s)),i.overrides.forEach(([,s])=>s.forEach(a=>o.add(a))),this.affectedKeys=[...o.values()];const d=new T;this.affectedKeys.forEach(s=>d.setValue(s,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,u){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(u){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,u,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(i,u,this.currentWorkspace);return!D.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(i,u){let r=(0,L.toValuesTree)({[u]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(i=i[n],!i)return!1;r=r[n]}return!0}}e.ConfigurationChangeEvent=v;function h(g,i){const{added:u,removed:r,updated:n}=c(i,g),o=[],d=g?.getAllOverrideIdentifiers()||[],s=i?.getAllOverrideIdentifiers()||[];if(i){const a=s.filter(m=>!d.includes(m));for(const m of a)o.push([m,i.getKeysForOverrideIdentifier(m)])}if(g){const a=d.filter(m=>!s.includes(m));for(const m of a)o.push([m,g.getKeysForOverrideIdentifier(m)])}if(i&&g){for(const a of d)if(s.includes(a)){const m=c({contents:g.getOverrideValue(void 0,a)||{},keys:g.getKeysForOverrideIdentifier(a)},{contents:i.getOverrideValue(void 0,a)||{},keys:i.getKeysForOverrideIdentifier(a)});o.push([a,[...m.added,...m.removed,...m.updated]])}}return{added:u,removed:r,updated:n,overrides:o}}function c(g,i){const u=g?i?g.keys.filter(o=>i.keys.indexOf(o)===-1):[...g.keys]:[],r=i?g?i.keys.filter(o=>g.keys.indexOf(o)===-1):[...i.keys]:[],n=[];if(g&&i){for(const o of i.keys)if(g.keys.indexOf(o)!==-1){const d=(0,L.getConfigurationValue)(i.contents,o),s=(0,L.getConfigurationValue)(g.contents,o);D.equals(d,s)||n.push(o)}}return{added:u,removed:r,updated:n}}}),define(Ce[125],De([1,0,11,3]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var I;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends l.ErrorNoTelemetry{static isTemporarilyNotAvailable(D){return D instanceof P&&D._code===I.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof P&&D._code===I.NoResolverFound}static isHandled(D){return D instanceof P&&D.isHandled}constructor(D,w=I.Unknown,k){super(D),this._message=D,this._code=w,this._detail=k,this.isHandled=w===I.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}}e.RemoteAuthorityResolverError=P}),define(Ce[85],De([1,0,14]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(k){return k.scheme===l.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=t;function I(k){if(!k)return;const L=k.indexOf("+");return L<0?k:k.substr(0,L)}e.getRemoteName=I;function P(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=P;function y(k){const{host:L,port:C}=w(k);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:C}}e.parseAuthorityWithPort=y;function D(k,L){let{host:C,port:E}=w(k);return typeof E>"u"&&(E=L),{host:C,port:E}}e.parseAuthorityWithOptionalPort=D;function w(k){const L=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const C=k.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const E=k.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:k,port:void 0}}}),define(Ce[27],De([1,0,8,3,85]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}e.getWorkspaceSupportTypeMessage=P;function y(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(!S.uuid||typeof S.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));var w;(function(S){S.WIN32_X64="win32-x64",S.WIN32_IA32="win32-ia32",S.WIN32_ARM64="win32-arm64",S.LINUX_X64="linux-x64",S.LINUX_ARM64="linux-arm64",S.LINUX_ARMHF="linux-armhf",S.ALPINE_X64="alpine-x64",S.ALPINE_ARM64="alpine-arm64",S.DARWIN_X64="darwin-x64",S.DARWIN_ARM64="darwin-arm64",S.WEB="web",S.UNIVERSAL="universal",S.UNKNOWN="unknown",S.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,b){if(typeof p>"u"||p===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof p=="string"||typeof b=="string"){const f=typeof p=="string"?p:p.value,v=typeof b=="string"?b:b.value;return l.equalsIgnoreCase(f,v)}return p._lower===b._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=k;function L(S){return C(S)}e.isApplicationScopedExtension=L;function C(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function E(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function T(S,p){if(p){const b=`onResolveRemoteAuthority:${(0,I.getRemoteName)(p)}`;return S.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[199],De([1,0,8,119,27,10,2,11,36]),function(J,e,l,t,I,P,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(u,r){return u.uuid&&r.uuid?u.uuid===r.uuid:u.id===r.id?!0:(0,l.compareIgnoreCase)(u.id,r.id)===0}e.areSameExtensions=k;const L=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class C{static create(r){const n=r.manifest?r.manifest.version:r.version,o=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new C(r.identifier,n,o)}static parse(r){const n=L.exec(r);return n&&n[1]&&n[2]?new C({id:n[1]},n[2],n[4]||void 0):null}constructor(r,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof C?k(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=C;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(u){const r=E.exec(u);return r&&r[1]?[p(r[1]),r[2]]:[p(u),void 0]}e.getIdAndVersion=T;function S(u,r){return`${u}.${r}`}e.getExtensionId=S;function p(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=p;function b(u,r){return p(S(u,r))}e.getGalleryExtensionId=b;function f(u,r){const n=[],o=d=>{for(const s of n)if(s.some(a=>k(r(a),r(d))))return s;return null};for(const d of u){const s=o(d);s?s.push(d):n.push([d])}return n}e.groupByExtension=f;function v(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function h(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=h,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function c(u,r){const n=[],o=r.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const d=o.shift();if(d&&n.every(s=>!k(s.identifier,{id:d}))){const s=u.filter(a=>k(a.identifier,{id:d}));s.length===1&&(n.push(s[0]),o.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=c;async function g(u,r){if(!P.isLinux)return!1;let n;try{n=(await u.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await u.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){r.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(d))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=g;async function i(u,r){const n=await g(u,r),o=(0,t.getTargetPlatform)(n?"alpine":P.platform,w.arch);return r.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=i}),define(Ce[200],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class l{constructor(){this.validators=new Map}vsda(){return new Promise((I,P)=>J(["vsda"],I,P))}async createNewMessage(I){try{const P=await this.vsda(),y=new P.validator;if(y){const D=String(l._nextId++);return this.validators.set(D,y),{id:D,data:y.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,P){if(!I.id)return!0;const y=this.validators.get(I.id);if(!y)return!1;this.validators.delete(I.id);try{return y.validate(P)==="ok"}catch{return!1}}async sign(I){try{const P=await this.vsda(),y=new P.signer;if(y)return y.sign(I)}catch{}return I}}e.SignService=l,l._nextId=1}),define(Ce[201],De([1,0,10,36,2,31]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function y(k){if(l.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function D(k,L,C,E,T,S,p,b,f,v){const h=Object.create(null);h["common.machineId"]=p,h.sessionID=(0,P.generateUuid)()+Date.now(),h.commitHash=T,h.version=S,h["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,l.PlatformToString)(l.platform),h["common.nodePlatform"]=t.platform,h["common.nodeArch"]=E,h["common.product"]=v||"desktop",b&&(h["common.msftInternal"]=b);let c=0;const g=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),l.isLinuxSnap&&(h["common.snap"]="true");const i=y(C);i&&(h["common.platformDetail"]=i);try{const u=await k.readFile(I.URI.file(f));h["common.source"]=u.value.toString().slice(0,30)}catch{}return h}e.resolveCommonProperties=D;function w(k){const L=t.env.USERDNSDOMAIN;if(!L)return!1;const C=L.toLowerCase();return k.some(E=>C===E)}e.verifyMicrosoftInternalDomain=w}),define(Ce[202],De([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,l.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,l.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var I;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(I=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ce[203],De([1,0,24,156,13,65,201,202]),function(J,e,l,t,I,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class w{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(n,o){return Promise.resolve(void 0)}publicLog2(n,o){return this.publicLog(n,o)}publicLogError(n,o){return Promise.resolve(void 0)}publicLogError2(n,o){return this.publicLogError(n,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=w,e.NullTelemetryService=new w;class k{async publicLog(n,o,d){}async publicLogError(n,o,d){}}e.NullEndpointTelemetryService=k,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function L(r,n){return n.onDidChangeConfiguration(o=>{o.source!==7&&r.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(o.source),configurationKeys:f(o.sourceConfig)})})}e.configurationTelemetry=L;function C(r,n){return!(n.disableTelemetry||!r.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=C;function E(r){const n=r.getValue(D.TELEMETRY_SETTING_ID),o=r.getValue("telemetry.enableCrashReporter");if(r.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function T(r){const n={},o={},d={};b(r,d);for(let s in d){s=s.length>150?s.substr(s.length-149):s;const a=d[s];typeof a=="number"?o[s]=a:typeof a=="boolean"?o[s]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${a.length}`),n[s]=a.substring(0,8191)):typeof a<"u"&&a!==null&&(n[s]=a)}return{properties:n,measurements:o}}e.validateTelemetryData=T;const S=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function p(r){if(!r)return"none";for(const n of S)if(r.startsWith(`${n}+`))return n;return"other"}e.cleanRemoteAuthority=p;function b(r,n,o=0,d){if(!!r)for(const s of Object.getOwnPropertyNames(r)){const a=r[s],m=d?d+s:s;Array.isArray(a)?n[m]=(0,l.safeStringify)(a):a instanceof Date?n[m]=a.toISOString():(0,I.isObject)(a)?o<2?b(a,n,o+1,m+"."):n[m]=(0,l.safeStringify)(a):n[m]=a}}function f(r){if(!r)return[];const n=[];return v(n,"",r),n}function v(r,n,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(d=>v(r,n?`${n}.${d}`:d,o[d])):r.push(n)}function h(r,n){const o=r.msftInternalDomains||[],d=n.getValue("telemetry.internalTesting");return(0,y.verifyMicrosoftInternalDomain)(o)||d}e.isInternalTelemetry=h;function c(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}e.getPiiPathsFromEnvironment=c;function g(r,n){let o=r;const d=[];for(const _ of n)for(;;){const R=_.exec(r);if(!R)break;d.push([R.index,_.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(o="";;){const _=a.exec(r);if(!_)break;!s.test(_[0])&&d.every(([R,M])=>_.index<R||_.index>=M)&&(o+=r.substring(m,_.index)+"<REDACTED: user-file-path>",m=a.lastIndex)}return m<r.length&&(o+=r.substr(m)),o}function i(r){if(!r)return r;const n=r.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of o)if(d.regex.test(n))return`<REDACTED: ${d.label}>`;return r}function u(r,n){return(0,l.cloneAndChange)(r,o=>{if(typeof o=="string"){let d=o;d=g(d,n);for(const s of n)d=d.replace(s,"");return d=i(d),d}})}e.cleanData=u}),define(Ce[204],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class l{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,P,y=5){const D=P(w=>{const k=typeof w=="string"?w:w.data;let L=this._terminalBufferMap.get(I);if(L){L.data.push(k);return}const C=setTimeout(()=>this.flushBuffer(I),y);L={data:[k],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(I),D.dispose()}},this._terminalBufferMap.set(I,L)});return D}stopBuffering(I){this._terminalBufferMap.get(I)?.dispose()}flushBuffer(I){const P=this._terminalBufferMap.get(I);P&&(this._terminalBufferMap.delete(I),this._callback(I,P.data.join("")))}}e.TerminalDataBufferer=l}),define(Ce[205],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var l;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(l=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===l.HIGH_CONTRAST_DARK||P===l.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function I(P){return P===l.DARK||P===l.HIGH_CONTRAST_DARK}e.isDark=I}),define(Ce[86],De([1,0,76,4,6,3,43,205]),function(J,e,l,t,I,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var w;(function(b){function f(v){return v&&typeof v=="object"&&typeof v.id=="string"}b.isThemeColor=f})(w=e.ThemeColor||(e.ThemeColor={}));function k(b){return{id:b}}e.themeColorFromId=k;var L;(function(b){function f(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||w.isThemeColor(n.color))}b.isThemeIcon=f;const v=new RegExp(`^\\$\\((${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?)\\)$`);function h(n){const o=v.exec(n);if(!o)return;const[,d]=o;return{id:d}}b.fromString=h;function c(n){return{id:n}}b.fromId=c;function g(n,o){let d=n.id;const s=d.lastIndexOf("~");return s!==-1&&(d=d.substring(0,s)),o&&(d=`${d}~${o}`),{id:d}}b.modify=g;function i(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}b.getModifier=i;function u(n,o){return n.id===o.id&&n.color?.id===o.color?.id}b.isEqual=u;function r(n,o){return{id:n.id,color:o?k(o):void 0}}b.asThemeIcon=r,b.asClassNameArray=l.CSSIcon.asClassNameArray,b.asClassName=l.CSSIcon.asClassName,b.asCSSSelector=l.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=l.Codicon.file,e.FolderThemeIcon=l.Codicon.folder;function C(b){switch(b){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case D.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(f){return this.themingParticipants.push(f),this.onThemingParticipantAddedEmitter.fire(f),(0,I.toDisposable)(()=>{const v=this.themingParticipants.indexOf(f);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const T=new E;y.Registry.add(e.Extensions.ThemingContribution,T);function S(b){return T.onColorThemeChange(b)}e.registerThemingParticipant=S;class p extends I.Disposable{constructor(f){super(),this.themeService=f,this.theme=f.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(f){this.theme=f,this.updateStyles()}updateStyles(){}getColor(f,v){let h=this.theme.getColor(f);return h&&v&&(h=v(h,this.theme)),h?h.toString():null}}e.Themable=p}),define(Ce[126],De([1,0,4,10,3,12]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var y;(function(p){p.Http="http",p.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var D;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(D=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=C;function E(p,b){return b?b!==1&&p<1024:!t.isWindows&&p<1024}e.isPortPrivileged=E;class T{constructor(b,f,v){this.remoteAddress=b,this.localAddress=f,this._dispose=v,this._onDispose=new l.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=T;let S=class{constructor(b){this.logService=b,this._onTunnelOpened=new l.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new l.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new l.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(b){return this._tunnelProvider=b,b?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const b=[],f=Array.from(this._tunnels.values());for(const v of f){const h=Array.from(v.values());for(const c of h){const g=await c.value;g&&b.push(g)}}return b}async dispose(){for(const b of this._tunnels.values()){for(const{value:f}of b.values())await f.then(v=>v?.dispose());b.clear()}this._tunnels.clear()}setEnvironmentTunnel(b,f,v,h,c){this.addTunnelToMap(b,f,Promise.resolve({tunnelRemoteHost:b,tunnelRemotePort:f,localAddress:v,privacy:h,protocol:c,dispose:()=>Promise.resolve()}))}openTunnel(b,f,v,h,c=!1,g,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${v} on local port ${h}.`),!b)return;if(f||(f="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(b,f,v,h,c,g,i);return u?u.then(r=>{if(!r){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(r);return(r.tunnelRemoteHost!==f||r.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const f=this._tunnels.get(b.tunnelRemoteHost);if(f){const v=f.get(b.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(b.tunnelRemoteHost,b.tunnelRemotePort,v))}}}}async tryDisposeTunnel(b,f,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${f}.`);const h=v.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(b)&&this._tunnels.get(b).delete(f),h}}async closeTunnel(b,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${f} `);const v=this._tunnels.get(b);if(v&&v.has(f)){const h=v.get(f);h.refcount=0,await this.tryDisposeTunnel(b,f,h)}}addTunnelToMap(b,f,v){this._tunnels.has(b)||this._tunnels.set(b,new Map),this._tunnels.get(b).set(f,{refcount:1,value:v})}async removeEmptyTunnelFromMap(b,f){const v=this._tunnels.get(b);v&&(await v.get(f)||v.delete(f),v.size===0&&this._tunnels.delete(b))}getTunnelFromMap(b,f){const v=[b];L(b)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):C(b)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const h=v.map(c=>this._tunnels.get(c));for(const c of h){const g=c?.get(f);if(g)return g}}canTunnel(b){return!!k(b)}doIsPortPrivileged(b,f,v,h){if(f)return!1;if(v){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(c?.length===4){const g=parseInt(c[1]),i=parseInt(c[2]);if(g>10||g===10&&i>=14)return!1}}return b<1024}createWithProvider(b,f,v,h,c,g,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${v} on local port ${h}.`);const u=v;this._factoryInProgress.add(u);const r=h===void 0?v:h,n={elevationRequired:c?this.isPortPrivileged(r):!1},o={remoteAddress:{host:f,port:v},localAddressPort:h,privacy:g,public:g?g!==D.Private:void 0,protocol:i},d=b.forwardPort(o,n);return d?(this.addTunnelToMap(f,v,d),d.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),d}};S=je([He(0,P.ILogService)],S),e.AbstractTunnelService=S}),define(Ce[206],De([1,0,14]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(w){return w.scheme!==l.Schemas.file&&w.scheme!==l.Schemas.vscodeRemote}e.isVirtualResource=t;function I(w){if(w.folders.length)return w.folders.every(k=>t(k.uri))?w.folders[0].uri:void 0;if(w.configuration&&t(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=I;function P(w){return I(w)?.scheme}e.getVirtualWorkspaceScheme=P;function y(w){return I(w)?.authority}e.getVirtualWorkspaceAuthority=y;function D(w){return I(w)!==void 0}e.isVirtualWorkspace=D}),define(Ce[45],De([1,0,169,9,26,22,2,3,14]),function(J,e,l,t,I,P,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function k(u){const r=u;return typeof r?.id=="string"&&y.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function L(u,r){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,t.basename)(u)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=u;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=L;function C(u){const r=u;return typeof r?.id=="string"&&y.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=C;function E(u){const r=u;if(r?.uri)return{id:r.id,uri:y.URI.revive(r.uri)};const n=u;if(n?.configPath)return{id:n.id,configPath:y.URI.revive(n.configPath)};if(u?.id)return{id:u.id}}e.reviveIdentifier=E;var T;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function S(u){const r=u;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=S;function p(u){const r=u;return!!(r&&typeof r=="object"&&y.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=p;class b{constructor(r,n,o,d,s){this._id=r,this._transient=o,this._configuration=d,this._ignorePathCasing=s,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class f{constructor(r,n){this.raw=n,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,P.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function v(u){return new f({uri:u,index:0,name:(0,P.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,l.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function h(u,r){return P.extUriBiasedIgnorePathCase.isEqualOrParent(u,r.untitledWorkspacesHome)}e.isUntitledWorkspace=h;function c(u){let r;return y.URI.isUri(u)?r=u:r=u.configuration,r?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=c;function g(u,r){return!h(u,r)&&!c(u)}e.isSavedWorkspace=g;function i(u){return(typeof u=="string"?(0,t.extname)(u):(0,P.extname)(u))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(Ce[87],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class l{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const P=this._idPool++;return this._data.set(P,I),this.logDebugInfo(),P}get(I,P){return this._data.has(I)?this._data.get(I)[P]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!l.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=l,l.enableDebugLogging=!1}),define(Ce[46],De([1,0,14,22,3]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(l.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(D=>{const w=this._providerInfo.get(D.scheme);return!(w===void 0||w&1024)})}$acceptProviderInfos(D,w){w===null?this._providerInfo.delete(D.scheme):this._providerInfo.set(D.scheme,w)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[25],De([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,l.createDecorator)("IExtHostInitDataService")}),define(Ce[207],De([1,0,18]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(y,D,w){this._deferredPromises=new Map,this._id=y,this._shared=D,this._storage=w,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new l.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of k.values())L.complete()}catch(L){for(const C of k.values())C.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(y,D){let w=this._value[y];return typeof w>"u"&&(w=D),w}update(y,D){this._value[y]=D;const w=this._deferredPromises.get(y);if(w!==void 0)return w.p;const k=new l.DeferredPromise;return this._deferredPromises.set(y,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class I extends t{setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}constructor(y,D){super(y.identifier.value,!0,D),this._extension=y}}e.ExtensionGlobalMemento=I}),define(Ce[208],De([1,0,4,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class I{constructor(y){this._notebooksAndEditors=y,this._onDidSaveNotebookDocument=new l.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new l.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(y,D,w,k){const C=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptModelChanged(D.value,w,k);this._onDidChangeNotebookDocument.fire(C)}$acceptDirtyStateChanged(y,D){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptDirty(D)}$acceptModelSaved(y){const D=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}}e.ExtHostNotebookDocuments=I}),define(Ce[16],De([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,l.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,l):I?I.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[209],De([1,0,27,4]),function(J,e,l,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(D,w){I.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=l.ExtensionIdentifier.toKey(D.identifier),tt(this,I,w,"f"),Be(this,I,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(D){return Be(this,I,"f").get(this._id,D)}store(D,w){return Be(this,I,"f").store(this._id,D,w)}delete(D){return Be(this,I,"f").delete(this._id,D)}}e.ExtensionSecrets=P,I=new WeakMap}),define(Ce[53],De([1,0,3,126,4,16]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(w){function k(C){return{remoteAddress:C.remoteAddress,localAddress:C.localAddress,public:!!C.public,privacy:C.privacy??(C.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:C.protocol}}w.fromApiTunnel=k;function L(C){return{remoteAddress:{host:C.tunnelRemoteHost,port:C.tunnelRemotePort},localAddress:C.localAddress,public:C.privacy!==t.TunnelPrivacyId.ConstantPrivate&&C.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:C.privacy,protocol:C.protocol}}w.fromServiceTunnel=L})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,l.createDecorator)("IExtHostTunnelService");let D=class{constructor(k){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,L){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,L){return{dispose:()=>{}}}async $providePortAttributes(k,L,C,E,T){return[]}async $forwardPort(k,L){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=je([He(0,P.IExtHostRpcService)],D),e.ExtHostTunnelService=D}),define(Ce[54],De([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,l.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=t}),define(Ce[210],De([1,0,23]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(w){let k=this.buffers.indexOf(w);return k<0&&(k=this.buffers.length,this.buffers.push(w)),k}}function I(D,w){if(w.serializeBuffersForPostMessage){const k=new t,L=(T,S)=>{if(S instanceof ArrayBuffer){const p=k.add(S);return{$$vscode_array_buffer_reference$$:!0,index:p}}else if(ArrayBuffer.isView(S)){const p=P(S);if(p){const b=k.add(S.buffer);return{$$vscode_array_buffer_reference$$:!0,index:b,view:{type:p,byteLength:S.byteLength,byteOffset:S.byteOffset}}}}return S},C=JSON.stringify(D,L),E=k.buffers.map(T=>{const S=new Uint8Array(T);return l.VSBuffer.wrap(S)});return{message:C,buffers:E}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=I;function P(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(D,w){const k=w.map(E=>{const T=new ArrayBuffer(E.byteLength);return new Uint8Array(T).set(E.buffer),T}),L=w.length?(E,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const S=T,{index:p}=S,b=k[p];if(S.view)switch(S.view.type){case 1:return new Int8Array(b,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return T}:void 0;return{message:JSON.parse(D,L),arrayBuffers:k}}e.deserializeWebviewMessage=y}),define(Ce[211],De([1,0,110]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:y=>y.scheme==="vscode-remote"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="file"?{scheme:"vscode-local",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoing:y=>y.scheme==="file"?{scheme:"vscode-remote",authority:P,path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="vscode-local"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoingScheme:y=>y==="file"?"vscode-remote":y==="vscode-local"?"file":y}}function I(P){return new l.URITransformer(t(P))}e.createURITransformer=I}),define(Ce[127],De([1,0,179,13,2,6,3,43,38,14]),function(J,e,l,t,I,P,y,D,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var L;(function(x){x[x.PROGRAMMATIC=1]="PROGRAMMATIC",x[x.USER=2]="USER",x[x.EDIT=3]="EDIT",x[x.NAVIGATION=4]="NAVIGATION",x[x.JUMP=5]="JUMP"})(L=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var C;(function(x){x[x.IDENTICAL=1]="IDENTICAL",x[x.SIMILAR=2]="SIMILAR",x[x.DIFFERENT=3]="DIFFERENT"})(C=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(x){const H=x;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}e.isEditorPaneWithSelection=E;function T(x,H,Q){for(const K of Q.visibleEditorPanes)if(K.group.id===H&&x.matches(K.input))return K.getViewState()}e.findViewStateForEditor=T;function S(x){if(o(x))return!1;const H=x;return I.URI.isUri(H?.resource)}e.isResourceEditorInput=S;function p(x){if(o(x))return!1;const H=x;return H?.original!==void 0&&H.modified!==void 0}e.isResourceDiffEditorInput=p;function b(x){if(o(x)||p(x))return!1;const H=x;return H?.primary!==void 0&&H.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function f(x){if(o(x))return!1;const H=x;return H?H.resource===void 0||H.resource.scheme===k.Schemas.untitled||H.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=f;const v=/Untitled-\d+/;function h(x){return x.scheme===k.Schemas.untitled&&x.path.length>1&&!v.test(x.path)}e.isUntitledWithAssociatedResource=h;function c(x){if(o(x))return!1;const H=x;return I.URI.isUri(H?.base?.resource)&&I.URI.isUri(H?.input1?.resource)&&I.URI.isUri(H?.input2?.resource)&&I.URI.isUri(H?.result?.resource)}e.isResourceMergeEditorInput=c;var g;(function(x){x[x.SHORT=0]="SHORT",x[x.MEDIUM=1]="MEDIUM",x[x.LONG=2]="LONG"})(g=e.Verbosity||(e.Verbosity={}));var i;(function(x){x[x.EXPLICIT=1]="EXPLICIT",x[x.AUTO=2]="AUTO",x[x.FOCUS_CHANGE=3]="FOCUS_CHANGE",x[x.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i=e.SaveReason||(e.SaveReason={}));class u{constructor(){this.mapIdToSaveSource=new Map}registerSource(H,Q){let K=this.mapIdToSaveSource.get(H);return K||(K={source:H,label:Q},this.mapIdToSaveSource.set(H,K)),K.source}getSourceLabel(H){return this.mapIdToSaveSource.get(H)?.label??H}}e.SaveSourceRegistry=new u;var r;(function(x){x[x.None=0]="None",x[x.Readonly=2]="Readonly",x[x.Untitled=4]="Untitled",x[x.Singleton=8]="Singleton",x[x.RequiresTrust=16]="RequiresTrust",x[x.CanSplitInGroup=32]="CanSplitInGroup",x[x.ForceDescription=64]="ForceDescription",x[x.CanDropIntoEditor=128]="CanDropIntoEditor",x[x.MultipleEditors=256]="MultipleEditors"})(r=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends P.Disposable{}e.AbstractEditorInput=n;function o(x){return x instanceof n}e.isEditorInput=o;function d(x){const H=x;return I.URI.isUri(H?.preferredResource)}function s(x){const H=x;return o(H?.primary)&&o(H?.secondary)}e.isSideBySideEditorInput=s;function a(x){const H=x;return o(H?.modified)&&o(H?.original)}e.isDiffEditorInput=a;function m(x){return o(x?.editor)}e.isEditorInputWithOptions=m;function _(x){const H=x;return m(x)&&H?.group!==void 0}e.isEditorInputWithOptionsAndGroup=_;function R(x){const H=x;return typeof H?.groupId=="number"&&o(H.editor)}e.isEditorIdentifier=R;var M;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.REPLACE=1]="REPLACE",x[x.MOVE=2]="MOVE",x[x.UNPIN=3]="UNPIN"})(M=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(x){x[x.GROUP_ACTIVE=0]="GROUP_ACTIVE",x[x.GROUP_INDEX=1]="GROUP_INDEX",x[x.GROUP_LOCKED=2]="GROUP_LOCKED",x[x.EDITOR_OPEN=3]="EDITOR_OPEN",x[x.EDITOR_CLOSE=4]="EDITOR_CLOSE",x[x.EDITOR_MOVE=5]="EDITOR_MOVE",x[x.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",x[x.EDITOR_LABEL=7]="EDITOR_LABEL",x[x.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",x[x.EDITOR_PIN=9]="EDITOR_PIN",x[x.EDITOR_STICKY=10]="EDITOR_STICKY",x[x.EDITOR_DIRTY=11]="EDITOR_DIRTY",x[x.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var A;(function(x){x[x.PRIMARY=1]="PRIMARY",x[x.SECONDARY=2]="SECONDARY",x[x.BOTH=3]="BOTH",x[x.ANY=4]="ANY"})(A=e.SideBySideEditor||(e.SideBySideEditor={}));class z{getOriginalUri(H,Q){if(!H)return;if(c(H))return e.EditorResourceAccessor.getOriginalUri(H.result,Q);if(Q?.supportSideBySide){const{primary:de,secondary:ee}=this.getSideEditors(H);if(de&&ee){if(Q?.supportSideBySide===A.BOTH)return{primary:this.getOriginalUri(de,{filterByScheme:Q.filterByScheme}),secondary:this.getOriginalUri(ee,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===A.ANY)return this.getOriginalUri(de,{filterByScheme:Q.filterByScheme})??this.getOriginalUri(ee,{filterByScheme:Q.filterByScheme});H=Q.supportSideBySide===A.PRIMARY?de:ee}}if(p(H)||b(H)||c(H))return;const K=d(H)?H.preferredResource:H.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}getSideEditors(H){return s(H)||b(H)?{primary:H.primary,secondary:H.secondary}:a(H)||p(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,Q){if(!H)return;if(c(H))return e.EditorResourceAccessor.getCanonicalUri(H.result,Q);if(Q?.supportSideBySide){const{primary:de,secondary:ee}=this.getSideEditors(H);if(de&&ee){if(Q?.supportSideBySide===A.BOTH)return{primary:this.getCanonicalUri(de,{filterByScheme:Q.filterByScheme}),secondary:this.getCanonicalUri(ee,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===A.ANY)return this.getCanonicalUri(de,{filterByScheme:Q.filterByScheme})??this.getCanonicalUri(ee,{filterByScheme:Q.filterByScheme});H=Q.supportSideBySide===A.PRIMARY?de:ee}}if(p(H)||b(H)||c(H))return;const K=H.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}filterUri(H,Q){if(Array.isArray(Q)){if(Q.some(K=>H.scheme===K))return H}else if(Q===H.scheme)return H}}e.EditorResourceAccessor=new z;var $;(function(x){x[x.LEFT=0]="LEFT",x[x.RIGHT=1]="RIGHT"})($=e.CloseDirection||(e.CloseDirection={}));class N{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(H){const Q=this.instantiationService=H.get(y.IInstantiationService);for(const[K,de]of this.editorSerializerConstructors)this.createEditorSerializer(K,de,Q);this.editorSerializerConstructors.clear()}createEditorSerializer(H,Q,K){const de=K.createInstance(Q);this.editorSerializerInstances.set(H,de)}registerFileEditorFactory(H){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=H}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(H,Q){if(this.editorSerializerConstructors.has(H)||this.editorSerializerInstances.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.instantiationService?this.createEditorSerializer(H,Q,this.instantiationService):this.editorSerializerConstructors.set(H,Q),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(H),this.editorSerializerInstances.delete(H)})}getEditorSerializer(H){return this.editorSerializerInstances.get(typeof H=="string"?H:H.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new N);async function V(x,H){return!x||!x.length?[]:await Promise.all(x.map(async Q=>{const K=I.URI.revive(Q.fileUri);if(!K||!await H.canHandleResource(K))return;let ee=Q.exists,he=Q.type;if(typeof ee!="boolean"||typeof he!="number")try{he=(await H.stat(K)).isDirectory?w.FileType.Directory:w.FileType.Unknown,ee=!0}catch{ee=!1}if(!ee&&Q.openOnlyIfExists||he===w.FileType.Directory)return;const Y={...Q.options,pinned:!0};return ee?{resource:K,options:Y}:{resource:K,options:Y,forceUntitled:!0}}))}e.pathsToEditors=V;var B;(function(x){x[x.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",x[x.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}));function F(x){const H=x;if(!H)return!1;const Q=H;if(Q.modified)return F(Q.modified);const K=H;return!!(K.contributionsState&&K.viewState&&Array.isArray(K.cursorState))}e.isTextEditorViewState=F}),define(Ce[88],De([1,0,14,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function I(D,w){return D.scheme===l.Schemas.http||D.scheme===l.Schemas.https?D:(w&&w.authority&&w.isRemote&&D.scheme===l.Schemas.file&&(D=t.URI.from({scheme:l.Schemas.vscodeRemote,authority:w.authority,path:D.path})),t.URI.from({scheme:l.Schemas.https,authority:`${D.scheme}+${P(D.authority)}.${e.webviewRootResourceAuthority}`,path:D.path,fragment:D.fragment,query:D.query}))}e.asWebviewUri=I;function P(D){return D.replace(/./g,w=>{const k=w.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?w:"-"+k.toString(16).padStart(4,"0")})}function y(D){return D.replace(/-([0-9a-f]{4})/g,(w,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=y}),define(Ce[212],De([1,0,4,6,88]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(D,w,k){this._proxy=D,this._editors=w,this._remoteInfo=k,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(w.onDidChangeVisibleTextEditors(()=>{const L=w.getVisibleTextEditors();for(const C of this._insets.values())L.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,w,k,L,C){let E;for(const h of this._editors.getVisibleTextEditors(!0))if(h.value===D){E=h;break}if(!E)throw new Error("not a visible editor");const T=this,S=this._handlePool++,p=new l.Emitter,b=new l.Emitter,f=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(h){return(0,I.asWebviewUri)(h,T._remoteInfo)}get cspSource(){return I.webviewGenericCspSource}set options(h){this._options=h,T._proxy.$setOptions(S,h)}get options(){return this._options}set html(h){this._html=h,T._proxy.$setHtml(S,h)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(h){return T._proxy.$postMessage(S,h)}},v=new class{constructor(){this.editor=D,this.line=w,this.height=k,this.webview=f,this.onDidDispose=b.event}dispose(){T._insets.has(S)&&(T._insets.delete(S),T._proxy.$disposeEditorInset(S),b.fire(),b.dispose(),p.dispose())}};return this._proxy.$createEditorInset(S,E.id,E.value.document.uri,w+1,k,L||{},C.identifier,C.extensionLocation),this._insets.set(S,{editor:D,inset:v,onDidReceiveMessage:p}),v}$onDidDispose(D){const w=this._insets.get(D);w&&w.inset.dispose()}$onDidReceiveMessage(D,w){this._insets.get(D)?.onDidReceiveMessage.fire(w)}}e.ExtHostEditorInsets=P}),define(Ce[128],De([1,0,4,18,180]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new l.Emitter,this._onExit=new l.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,w,k,L){const C={command:D};if(w&&Object.keys(w).length>0&&(C.arguments=w),this.internalSend("request",C),typeof L=="number"){const E=setTimeout(()=>{clearTimeout(E);const T=this.pendingRequests.get(C.seq);if(T){this.pendingRequests.delete(C.seq);const S={type:"response",seq:0,request_seq:C.seq,success:!1,command:D,message:(0,I.localize)(0,null,L,D)};T(S)}},L)}return k&&this.pendingRequests.set(C.seq,k),C.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,w){return D.type!=="event"||w.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,t.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback?.(D);break;case"request":this.requestCallback?.(D);break;case"response":{const w=D,k=this.pendingRequests.get(w.request_seq);k&&(this.pendingRequests.delete(w.request_seq),k(w));break}}}}internalSend(D,w){w.type=D,w.seq=this.sequence++,this.sendMessage(w)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((w,k)=>D.set(k,w)),await(0,t.timeout)(500),D.forEach((w,k)=>{w({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(Ce[213],De([1,0,181,52,3]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:l.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:l.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:l.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:l.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:l.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:l.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:l.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:l.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:l.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:l.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:l.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:l.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:l.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:l.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:l.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:l.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:l.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:l.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:l.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:l.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:l.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:l.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:l.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:l.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:l.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:l.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:l.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:l.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:l.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:l.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:l.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:l.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:l.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:l.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:l.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:l.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:l.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:l.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:l.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:l.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:l.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:l.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:l.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:l.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:l.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:l.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:l.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:l.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:l.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:l.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:l.localize(50,null)});const P=E=>l.localize(51,null,E);e.debuggerDisabledMessage=P,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:l.localize(52,null)};var y;(function(E){E[E.Inactive=0]="Inactive",E[E.Initializing=1]="Initializing",E[E.Stopped=2]="Stopped",E[E.Running=3]="Running"})(y=e.State||(e.State={}));function D(E){switch(E){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=D;var w;(function(E){E[E.Valid=0]="Valid",E[E.Unreadable=1]="Unreadable",E[E.Error=2]="Error"})(w=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(E){E[E.Initial=1]="Initial",E[E.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(E){E.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,I.createDecorator)(e.DEBUG_SERVICE_ID);var C;(function(E){E[E.CONDITION=0]="CONDITION",E[E.HIT_COUNT=1]="HIT_COUNT",E[E.LOG_MESSAGE=2]="LOG_MESSAGE"})(C=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[214],De([1,0,8,2,9,24,14]),function(J,e,l,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function w(r,n,o){return r.replace(D,function(d,s){return n&&s.length>0&&s[0]!=="_"?d:o&&o.hasOwnProperty(s)?o[s]:d})}e.formatPII=w;function k(r){const n={};for(const o of Object.keys(r))o.startsWith("!")||(n[o]=r[o]);return n}e.filterExceptionsFromTelemetry=k;function L(r){return r.configuration.request==="attach"&&!C(r)&&(!r.parentSession||L(r.parentSession))}e.isSessionAttach=L;function C(r){let n=r.configuration.type;if(!!n)return n==="vslsShare"&&(n=r.configuration.adapterProxy.configuration.type),(0,l.equalsIgnoreCase)(n,"extensionhost")||(0,l.equalsIgnoreCase)(n,"pwa-extensionhost")?r:r.parentSession?C(r.parentSession):void 0}e.getExtensionHostDebugSession=C;function E(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=E;function T(r,n,o){let d,s=0;const a=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let m=null;for(;m=a.exec(r);){const _=m.index+1,R=_+m[0].length;if(_<=n&&R>=o){d=m[0],s=_;break}}if(d){const _=/\w+/g;let R=null;for(;(R=_.exec(d))&&!(R.index+1+s+R[0].length>=o););R&&(d=d.substring(0,_.lastIndex))}return d?{start:s,end:s+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const S=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(r){return!!(r&&r.match(S))}e.isUri=p;function b(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(p(r.path))return t.URI.parse(r.path);if((0,I.isAbsolute)(r.path))return t.URI.file(r.path)}return r.path}function f(r){if(typeof r.path=="object"){const n=t.URI.revive(r.path);if(n)return n.scheme===y.Schemas.file?n.fsPath:n.toString()}return r.path}function v(r,n){const o=n?b:f,d=(0,P.deepClone)(r);return c(d,(s,a)=>{s&&a&&(a.path=o(a))}),d}e.convertToDAPaths=v;function h(r,n){const o=n?b:f,d=(0,P.deepClone)(r);return c(d,(s,a)=>{!s&&a&&(a.path=o(a))}),d}e.convertToVSCPaths=h;function c(r,n){switch(r.type){case"event":{const o=r;switch(o.event){case"output":n(!1,o.body.source);break;case"loadedSource":n(!1,o.body.source);break;case"breakpoint":n(!1,o.body.breakpoint.source);break;default:break}break}case"request":{const o=r;switch(o.command){case"setBreakpoints":n(!0,o.arguments.source);break;case"breakpointLocations":n(!0,o.arguments.source);break;case"source":n(!0,o.arguments.source);break;case"gotoTargets":n(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(d=>n(!1,d));break;default:break}break}case"response":{const o=r;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(d=>n(!1,d.source));break;case"loadedSources":o.body.sources.forEach(d=>n(!1,d));break;case"scopes":o.body.scopes.forEach(d=>n(!1,d.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(d=>n(!1,d.source));break;case"setBreakpoints":o.body.breakpoints.forEach(d=>n(!1,d.source));break;case"disassemble":o.body?.instructions.forEach(s=>n(!1,s.location));break;default:break}break}}}function g(r){return r.filter(n=>!n.presentation?.hidden).sort((n,o)=>n.presentation?o.presentation?n.presentation.group?o.presentation.group?n.presentation.group!==o.presentation.group?n.presentation.group.localeCompare(o.presentation.group):i(n.presentation.order,o.presentation.order):-1:o.presentation.group?1:i(n.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=g;function i(r,n){return typeof r!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:r-n}async function u(r,n){const o=r.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(o!=="none"&&(await n.saveAll(),o==="allEditorsInActiveGroup")){const d=n.activeEditorPane;d&&d.input.resource?.scheme===y.Schemas.untitled&&await n.save({editor:d.input,groupId:d.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(Ce[215],De([1,0,44,216,24,9,10,8,29,182,128]),function(J,e,l,t,I,P,y,D,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class C extends L.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(f,v){this.outputStream=v,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,f.on("data",h=>this.handleData(h))}sendMessage(f){if(this.outputStream){const v=JSON.stringify(f);this.outputStream.write(`Content-Length: ${Buffer.byteLength(v,"utf8")}${C.TWO_CRLF}${v}`,"utf8")}}handleData(f){for(this.rawData=Buffer.concat([this.rawData,f]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const v=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,v.length>0)try{this.acceptMessage(JSON.parse(v))}catch(h){this._onError.fire(new Error((h.message||h)+`
`+v))}continue}}else{const v=this.rawData.indexOf(C.TWO_CRLF);if(v!==-1){const c=this.rawData.toString("utf8",0,v).split(C.HEADER_LINESEPARATOR);for(const g of c){const i=g.split(C.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(v+C.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=C,C.TWO_CRLF=`\r
\r
`,C.HEADER_LINESEPARATOR=/\r?\n/,C.HEADER_FIELDSEPARATOR=/: */;class E extends C{startSession(){return new Promise((f,v)=>{let h=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),f(),h=!0}),this.socket.on("close",()=>{h?this._onError.fire(new Error("connection closed")):v(new Error("connection closed"))}),this.socket.on("error",c=>{h?this._onError.fire(c):v(c)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class T extends E{constructor(f){super(),this.adapterServer=f}createConnection(f){return t.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",f)}}e.SocketDebugAdapter=T;class S extends E{constructor(f){super(),this.adapterServer=f}createConnection(f){return t.createConnection(this.adapterServer.path,f)}}e.NamedPipeDebugAdapter=S;class p extends C{constructor(f,v){super(),this.adapterExecutable=f,this.debugType=v}async startSession(){const f=this.adapterExecutable.command,v=this.adapterExecutable.args,h=this.adapterExecutable.options||{};try{if(f)if(P.isAbsolute(f)){if(!await w.Promises.exists(f))throw new Error(k.localize(0,null,f))}else f.indexOf("/")<0&&f.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let c=process.env;if(h.env&&Object.keys(h.env).length>0&&(c=I.mixin(I.deepClone(process.env),h.env)),f==="node")if(Array.isArray(v)&&v.length>0){const g=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:c,execArgv:g?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};h.cwd&&(i.cwd=h.cwd);const u=l.fork(v[0],v.slice(1),i);if(!u.pid)throw new Error(k.localize(2,null,v[0]));this.serverProcess=u}else throw new Error(k.localize(3,null));else{const g={env:c};h.cwd&&(g.cwd=h.cwd),this.serverProcess=l.spawn(f,v,g)}this.serverProcess.on("error",g=>{this._onError.fire(g)}),this.serverProcess.on("exit",(g,i)=>{this._onExit.fire(g)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",g=>{this._onError.fire(g)}),this.serverProcess.stdin.on("error",g=>{this._onError.fire(g)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(c){this._onError.fire(c)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),y.isWindows?new Promise((f,v)=>{const h=l.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(c,g,i){if(c)return v(c)});h.on("exit",f),h.on("error",v)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(f,v){if(!f)return;const h=Object.create(null);f.runtime&&(f.runtime.indexOf("./")===0?h.runtime=P.join(v,f.runtime):h.runtime=f.runtime),f.runtimeArgs&&(h.runtimeArgs=f.runtimeArgs),f.program&&(P.isAbsolute(f.program)?h.program=f.program:h.program=P.join(v,f.program)),f.args&&(h.args=f.args);const c=f;return c.win&&(h.win=p.extract(c.win,v)),c.winx86&&(h.winx86=p.extract(c.winx86,v)),c.windows&&(h.windows=p.extract(c.windows,v)),c.osx&&(h.osx=p.extract(c.osx,v)),c.linux&&(h.linux=p.extract(c.linux,v)),h}static platformAdapterExecutable(f,v){let h=Object.create(null);v=v.toLowerCase();for(const n of f)if(n.contributes){const o=n.contributes.debuggers;o&&o.length>0&&o.filter(d=>typeof d.type=="string"&&D.equalsIgnoreCase(d.type,v)).forEach(d=>{const s=p.extract(d,n.extensionLocation.fsPath);h=I.mixin(h,s,n.isBuiltin)})}let c;y.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?c=h.winx86||h.win||h.windows:y.isWindows?c=h.win||h.windows:y.isMacintosh?c=h.osx:y.isLinux&&(c=h.linux),c=c||h;const g=c.program||h.program,i=c.args||h.args,u=c.runtime||h.runtime,r=c.runtimeArgs||h.runtimeArgs;if(u)return{type:"executable",command:u,args:(r||[]).concat(typeof g=="string"?[g]:[]).concat(i||[])};if(g)return{type:"executable",command:g,args:i||[]}}}e.ExecutableDebugAdapter=p}),define(Ce[217],De([1,0,44,32,10]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(k,L){return new Promise((C,E)=>{let T="";const S=l.spawn(k,L);S.pid&&S.stdout.on("data",p=>{T+=p.toString()}),S.on("error",p=>{E(p)}),S.on("close",p=>{C(T)})})}async function y(k){if(k)if(I.isWindows){const L=await new Promise((C,E)=>{J(["windows-process-tree"],C,E)});return new Promise(C=>{L.getProcessTree(k,E=>{C(!!E&&E.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(k)]).then(L=>{const C=L.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=y;var D;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(D||(D={}));function w(k,L,C,E,T){k=k.trim().toLowerCase();let S;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?S=1:k.indexOf("cmd.exe")>=0?S=0:k.indexOf("bash")>=0?S=2:I.isWindows?S=0:S=2;let p,b=" ";switch(S){case 1:if(p=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),E){const f=(0,t.getDriveLetter)(E);f&&(b+=`${f}:; `),b+=`cd ${p(E)}; `}if(T)for(const f in T){const v=T[f];v===null?b+=`Remove-Item env:${f}; `:b+=`\${env:${f}}='${v}'; `}if(L.length>0){const f=L.shift(),v=C?f:p(f);b+=v[0]==="'"?`& ${v} `:`${v} `;for(const h of L)b+=h==="<"||h===">"||C?h:p(h),b+=" "}break;case 0:if(p=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(v=>f.includes(v))||f.length===0?`"${f}"`:f),E){const f=(0,t.getDriveLetter)(E);f&&(b+=`${f}: && `),b+=`cd ${p(E)} && `}if(T){b+='cmd /C "';for(const f in T){let v=T[f];v===null?b+=`set "${f}=" && `:(v=v.replace(/[&^|<>]/g,h=>`^${h}`),b+=`set "${f}=${v}" && `)}}for(const f of L)b+=f==="<"||f===">"||C?f:p(f),b+=" ";T&&(b+='"');break;case 2:{p=v=>(v=v.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),v.length===0?'""':v);const f=v=>/[^\w@%\/+=,.:^-]/.test(v)?`'${v.replace(/'/g,"'\\''")}'`:v;if(E&&(b+=`cd ${p(E)} ; `),T){b+="/usr/bin/env";for(const v in T){const h=T[v];h===null?b+=` -u ${f(v)}`:b+=` ${f(`${v}=${h}`)}`}b+=" "}for(const v of L)b+=v==="<"||v===">"||C?v:p(v),b+=" ";break}}return b}e.prepareCommand=w}),define(Ce[89],De([1,0,23,37,61,103,14,9,10,52]),function(J,e,l,t,I,P,y,D,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var L;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.latex,P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.latex,P.Mimes.markdown,"application/json",P.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(V){V[V.Running=1]="Running",V[V.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var E;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(E=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(V){V[V.WithHardKernelDependency=0]="WithHardKernelDependency",V[V.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",V[V.Pure=2]="Pure",V[V.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var S;(function(V){V.Always="always",V.Never="never",V.Optional="optional"})(S=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(V){V[V.ModelChange=1]="ModelChange",V[V.Move=2]="Move",V[V.ChangeCellLanguage=5]="ChangeCellLanguage",V[V.Initialize=6]="Initialize",V[V.ChangeCellMetadata=7]="ChangeCellMetadata",V[V.Output=8]="Output",V[V.OutputItem=9]="OutputItem",V[V.ChangeCellContent=10]="ChangeCellContent",V[V.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",V[V.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",V[V.ChangeCellMime=13]="ChangeCellMime",V[V.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var b;(function(V){V[V.Handle=0]="Handle",V[V.Index=1]="Index"})(b=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(V){V[V.Replace=1]="Replace",V[V.Output=2]="Output",V[V.Metadata=3]="Metadata",V[V.CellLanguage=4]="CellLanguage",V[V.DocumentMetadata=5]="DocumentMetadata",V[V.Move=6]="Move",V[V.OutputItems=7]="OutputItems",V[V.PartialMetadata=8]="PartialMetadata",V[V.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var v;(function(V){V.scheme=y.Schemas.vscodeNotebookCell;const B=["W","X","Y","Z","a","b","c","d","e","f"],F=new RegExp(`^[${B.join("")}]+`),x=7;function H(Y,me){const be=me.toString(x),Re=`${be.length<B.length?B[be.length-1]:"z"}${be}s${(0,l.encodeBase64)(l.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:V.scheme,fragment:Re})}V.generate=H;function Q(Y){if(Y.scheme!==V.scheme)return;const me=Y.fragment.indexOf("s");if(me<0)return;const be=parseInt(Y.fragment.substring(0,me).replace(F,""),x),ke=(0,l.decodeBase64)(Y.fragment.substring(me+1)).toString();if(!isNaN(be))return{handle:be,notebook:Y.with({scheme:ke,fragment:null})}}V.parse=Q;function K(Y,me){return Y.with({scheme:y.Schemas.vscodeNotebookCellOutput,fragment:`op${me??""},${Y.scheme!==y.Schemas.file?Y.scheme:""}`})}V.generateCellOutputUri=K;function de(Y){if(Y.scheme!==y.Schemas.vscodeNotebookCellOutput)return;const me=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!me)return;const be=me[1]&&me[1]!==""?me[1]:void 0,ke=me[2];return{outputId:be,notebook:Y.with({scheme:ke||y.Schemas.file,fragment:null})}}V.parseCellOutputUri=de;function ee(Y,me,be){return V.generate(Y,me).with({scheme:be})}V.generateCellPropertyUri=ee;function he(Y,me){if(Y.scheme===me)return V.parse(Y.with({scheme:V.scheme}))}V.parseCellPropertyUri=he})(v=e.CellUri||(e.CellUri={}));const h=V=>w.isWindows?V.replace(/\//g,"\\"):V;class c{constructor(B=[],F=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=F,this.order=[...new Set(B)].map(x=>({pattern:x,matches:t.parse(h(x))}))}sort(B){const F=new Map(I.Iterable.map(B,H=>[H,h(H)]));let x=[];for(const{matches:H}of this.order)for(const[Q,K]of F)if(H(K)){x.push(Q),F.delete(Q);break}return F.size&&(x=x.concat([...F.keys()].sort((H,Q)=>this.defaultOrder.indexOf(H)-this.defaultOrder.indexOf(Q)))),x}prioritize(B,F){const x=this.findIndex(B);if(x===-1){this.order.unshift({pattern:B,matches:t.parse(h(B))});return}const H=new Set(F.map(K=>this.findIndex(K,x)));H.delete(-1);const Q=Array.from(H).sort();this.order.splice(x+1,0,...Q.map(K=>this.order[K]));for(let K=Q.length-1;K>=0;K--)this.order.splice(Q[K],1)}toArray(){return this.order.map(B=>B.pattern)}findIndex(B,F=this.order.length){const x=h(B);for(let H=0;H<F;H++)if(this.order[H].matches(x))return H;return-1}}e.MimeTypeDisplayOrder=c;function g(V,B,F,x=(H,Q)=>H===Q){const H=[];function Q(ee,he,Y){if(he===0&&Y.length===0)return;const me=H[H.length-1];me&&me.start+me.deleteCount===ee?(me.deleteCount+=he,me.toInsert.push(...Y)):H.push({start:ee,deleteCount:he,toInsert:Y})}let K=0,de=0;for(;;){if(K===V.length){Q(K,0,B.slice(de));break}if(de===B.length){Q(K,V.length-K,[]);break}const ee=V[K],he=B[de];if(x(ee,he)){K+=1,de+=1;continue}F(he)?(Q(K,1,[]),K+=1):(Q(K,0,[he]),de+=1)}return H}e.diff=g,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(V){V.default="default",V.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(V){const B=V;return!!((typeof B.include=="string"||t.isRelativePattern(B.include))&&(typeof B.exclude=="string"||t.isRelativePattern(B.exclude)))}e.isDocumentExcludePattern=u;function r(V,B,F){if(Array.isArray(V.viewType)&&V.viewType.indexOf(B)>=0||V.viewType===B)return!0;if(V.filenamePattern){const x=u(V.filenamePattern)?V.filenamePattern.include:V.filenamePattern,H=u(V.filenamePattern)?V.filenamePattern.exclude:void 0;if(t.match(x,(0,D.basename)(F.fsPath).toLowerCase()))return!(H&&t.match(H,(0,D.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var n;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(n=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(B){return`${o._prefix}${B}`}static parse(B){if(B.startsWith(o._prefix))return B.substring(o._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o._prefix="notebook/";function d(V){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(V)}e.isTextStreamMime=d;const s=new TextDecoder;function a(V){const B=[];let F=!1;for(const x of V)(B.length===0||F)&&(B.push(x),F=!0);return M(B),N(l.VSBuffer.concat(B.map(x=>l.VSBuffer.wrap(x))))}e.compressOutputItemStreams=a;const m=`${String.fromCharCode(27)}[A`,_=m.split("").map(V=>V.charCodeAt(0)),R=10;function M(V){V.forEach((B,F)=>{if(F===0||B.length<m.length)return;const x=V[F-1],H=B.subarray(0,m.length);if(H[0]===_[0]&&H[1]===_[1]&&H[2]===_[2]){const Q=x.lastIndexOf(R);if(Q===-1)return;V[F-1]=x.subarray(0,Q),V[F]=B.subarray(m.length)}})}function U(V){let B=V;do V=B,B=V.replace(/[^\n]\x08/gm,"");while(B.length<V.length);return V}function A(V){for(V=V.replace(/\r+\n/gm,`
`);V.search(/\r[^$]/g)>-1;){const B=V.match(/^(.*)\r+/m)[1];let F=V.match(/\r+(.*)$/m)[1];F=F+B.slice(F.length,B.length),V=V.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,F)}return V}const z="\b".charCodeAt(0),$="\r".charCodeAt(0);function N(V){return!V.buffer.includes(z)&&!V.buffer.includes($)?V:l.VSBuffer.fromString(A(U(s.decode(V.buffer))))}}),define(Ce[218],De([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,l.createDecorator)("INotebookExecutionService")}),define(Ce[219],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function l(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=l;function t(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=t;function I(y){return Array.from(y.entries()).map(D=>[D[0],l(D[1].map)])}e.serializeEnvironmentVariableCollections=I;function P(y){return new Map(y.map(D=>[D[0],{map:t(D[1])}]))}e.deserializeEnvironmentVariableCollections=P}),define(Ce[55],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(P){P.Delimiter="\0"})(l=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{static fromExtHostTestItem(y,D,w=y.parent){if(y._isRoot)return new I([D]);const k=[y.id];for(let L=w;L&&L.id!==D;L=L.parent)k.push(L.id);return k.push(D),new I(k.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const D=y.indexOf("\0");return D===-1?y:y.slice(0,D)}static fromString(y){return new I(y.split("\0"))}static join(y,D){return new I([...y.path,D])}static joinToString(y,D){return y.toString()+"\0"+D}static parentId(y){const D=y.lastIndexOf("\0");return D===-1?void 0:y.slice(0,D)}static compare(y,D){return y===D?0:D.startsWith(y+"\0")?2:y.startsWith(D+"\0")?3:1}constructor(y,D=y.length){if(this.path=y,this.viewEnd=D,y.length===0||D<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let y=1;y<=this.viewEnd;y++)yield new I(this.path,y)}*idsToRoot(){for(let y=this.viewEnd;y>0;y--)yield new I(this.path,y)}compare(y){if(typeof y=="string")return I.compare(this.toString(),y);for(let D=0;D<y.viewEnd&&D<this.viewEnd;D++)if(y.path[D]!==this.path[D])return 1;return y.viewEnd>this.viewEnd?2:y.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let y=1;y<this.viewEnd;y++)this.stringifed+="\0",this.stringifed+=this.path[y]}return this.stringifed}}e.TestId=I}),define(Ce[66],De([1,0,2,35,55]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var P;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(P=e.TestResultState||(e.TestResultState={}));var y;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(y=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(s){s.serialize=a=>({range:a.range.toJSON(),uri:a.uri.toJSON()}),s.deserialize=a=>({range:t.Range.lift(a.range),uri:l.URI.revive(a.uri)})})(D=e.IRichLocation||(e.IRichLocation={}));var w;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(w=e.TestMessageType||(e.TestMessageType={}));var k;(function(s){s.serialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&D.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&D.deserialize(a.location)})})(k=e.ITestErrorMessage||(e.ITestErrorMessage={}));const L=(s,a)=>`${a?"s":"e"}${s}`;e.getMarkId=L;var C;(function(s){s.serialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&D.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&D.deserialize(a.location)})})(C=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(s){s.serialize=a=>a.type===0?k.serialize(a):C.serialize(a),s.deserialize=a=>a.type===0?k.deserialize(a):C.deserialize(a)})(E=e.ITestMessage||(e.ITestMessage={}));var T;(function(s){s.serializeWithoutMessages=a=>({state:a.state,duration:a.duration,messages:[]}),s.serialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(E.serialize)}),s.deserialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(E.deserialize)})})(T=e.ITestTaskState||(e.ITestTaskState={}));const S="\0",p=(s,a)=>s+S+a;e.namespaceTestTag=p;const b=s=>{const a=s.indexOf(S);return{ctrlId:s.slice(0,a),tagId:s.slice(a+1)}};e.denamespaceTestTag=b;var f;(function(s){s.serialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?.toJSON(),range:a.range?.toJSON()||null,description:a.description,error:a.error,sortText:a.sortText}),s.deserialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?l.URI.revive(a.uri):void 0,range:a.range?t.Range.lift(a.range):null,description:a.description,error:a.error,sortText:a.sortText})})(f=e.ITestItem||(e.ITestItem={}));var v;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var h;(function(s){s.serialize=a=>({expand:a.expand,item:f.serialize(a.item)}),s.deserialize=a=>({controllerId:I.TestId.root(a.item.extId),expand:a.expand,item:f.deserialize(a.item)})})(h=e.InternalTestItem||(e.InternalTestItem={}));var c;(function(s){s.serialize=a=>{let m;return a.item&&(m={},a.item.label!==void 0&&(m.label=a.item.label),a.item.tags!==void 0&&(m.tags=a.item.tags),a.item.busy!==void 0&&(m.busy=a.item.busy),a.item.uri!==void 0&&(m.uri=a.item.uri?.toJSON()),a.item.range!==void 0&&(m.range=a.item.range?.toJSON()),a.item.description!==void 0&&(m.description=a.item.description),a.item.error!==void 0&&(m.error=a.item.error),a.item.sortText!==void 0&&(m.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:m}},s.deserialize=a=>{let m;return a.item&&(m={},a.item.label!==void 0&&(m.label=a.item.label),a.item.tags!==void 0&&(m.tags=a.item.tags),a.item.busy!==void 0&&(m.busy=a.item.busy),a.item.range!==void 0&&(m.range=a.item.range?t.Range.lift(a.item.range):null),a.item.description!==void 0&&(m.description=a.item.description),a.item.error!==void 0&&(m.error=a.item.error),a.item.sortText!==void 0&&(m.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:m}}})(c=e.ITestItemUpdate||(e.ITestItemUpdate={}));const g=(s,a)=>{a.expand!==void 0&&(s.expand=a.expand),a.item!==void 0&&(s.item=s.item?Object.assign(s.item,a.item):a.item)};e.applyTestItemUpdate=g;var i;(function(s){s.serializeWithoutMessages=a=>({...h.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(T.serializeWithoutMessages),retired:a.retired}),s.serialize=a=>({...h.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(T.serialize),retired:a.retired}),s.deserialize=a=>({...h.deserialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(T.deserialize),retired:!0})})(i=e.TestResultItem||(e.TestResultItem={}));var u;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(u=e.DetailType||(e.DetailType={}));var r;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.DocumentSynced=2]="DocumentSynced",s[s.Remove=3]="Remove",s[s.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",s[s.Retire=5]="Retire",s[s.AddTag=6]="AddTag",s[s.RemoveTag=7]="RemoveTag"})(r=e.TestDiffOpType||(e.TestDiffOpType={}));var n;(function(s){s.deserialize=a=>a.op===0?{op:a.op,item:h.deserialize(a.item)}:a.op===1?{op:a.op,item:c.deserialize(a.item)}:a.op===2?{op:a.op,uri:l.URI.revive(a.uri),docv:a.docv}:a,s.serialize=a=>a.op===0?{op:a.op,item:h.serialize(a.item)}:a.op===1?{op:a.op,item:c.serialize(a.item)}:a})(n=e.TestsDiffOp||(e.TestsDiffOp={}));class o{add(a){}update(a){}remove(a,m){}complete(){}}e.IncrementalChangeCollector=o;class d{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const m=this.createChangeCollector();for(const _ of a)switch(_.op){case 0:{const R=h.deserialize(_.item),M=I.TestId.parentId(R.item.extId)?.toString();if(M){if(this.items.has(M)){const U=this.items.get(M);U.children.add(R.item.extId);const A=this.createItem(R,U);this.items.set(R.item.extId,A),m.add(A)}}else{const U=this.createItem(R);this.roots.add(U),this.items.set(R.item.extId,U),m.add(U)}R.expand===2&&this.busyControllerCount++;break}case 1:{const R=c.deserialize(_.item),M=this.items.get(R.extId);if(!M)break;R.expand!==void 0&&(M.expand===2&&this.busyControllerCount--,R.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(M,R),m.update(M);break}case 3:{const R=this.items.get(_.itemId);if(!R)break;const M=I.TestId.parentId(R.item.extId)?.toString();M?this.items.get(M).children.delete(R.item.extId):this.roots.delete(R);const U=[[_.itemId]];for(;U.length;)for(const A of U.pop()){const z=this.items.get(A);z&&(U.push(z.children),this.items.delete(A),m.remove(z,z!==R),z.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(_.itemId);break;case 4:this.updatePendingRoots(_.amount);break;case 6:this._tags.set(_.tag.id,_.tag);break;case 7:this._tags.delete(_.id);break}m.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new o}}e.AbstractIncrementalTestCollection=d}),define(Ce[90],De([1,0,18,4,6,48,66,55]),function(J,e,l,t,I,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var w;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(w=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(f,v)=>f===v,L={range:(f,v)=>f===v?!0:!f||!v?!1:f.equalsRange(v),busy:k,label:k,description:k,error:k,tags:(f,v)=>!(f.length!==v.length||f.some(h=>!v.includes(h)))},C=(f,v)=>{let h;for(const[c,g]of Object.entries(L))g(f[c],v[c])||(h?h[c]=v[c]:h={[c]:v[c]});return h};class E extends I.Disposable{get root(){return this.options.root}constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new l.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(v){this._resolveHandler=v;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){switch(v.op){case 2:{for(const h of this.diff)if(h.op===2&&h.uri===v.uri){h.docv=v.docv;return}break}case 1:{const h=this.diff[this.diff.length-1];if(h){if(h.op===1&&h.item.extId===v.item.extId){(0,y.applyTestItemUpdate)(h.item,v.item);return}if(h.op===0&&h.item.item.extId===v.item.extId){(0,y.applyTestItemUpdate)(h.item,v.item);return}}break}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,h){const c=this.tree.get(v);if(!!c){if((c.expandLevels===void 0||h>c.expandLevels)&&(c.expandLevels=h),c.expand===1){const g=this.resolveChildren(c);return g.isOpen()?this.expandChildren(c,h-1):g.wait().then(()=>this.expandChildren(c,h-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,h-1)):this.expandChildren(c,h-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,h){switch(h.op){case 3:this.removeItem(D.TestId.joinToString(v.fullId,h.id));break;case 0:this.upsertItem(h.item,v);break;case 5:for(const c of h.ops)this.onTestItemEvent(v,c);break;case 1:this.diffTagRefs(h.new,h.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:h.update}});break;case 6:this.documentSynced(v.actual.uri);break;default:(0,P.assertNever)(h)}}documentSynced(v){v&&this.pushDiff({op:2,uri:v,docv:this.options.getDocumentVersion(v)})}upsertItem(v,h){const c=D.TestId.fromExtHostTestItem(v,this.root.id,h?.actual),g=this.options.getApiFor(v);g.parent&&g.parent!==h?.actual&&this.options.getChildren(g.parent).delete(v.id);let i=this.tree.get(c.toString());if(!i){i={fullId:c,actual:v,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(i.fullId.toString(),i),this.setItemParent(v,h),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:i.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,i,h);return}if(i.actual===v){this.connectItem(v,i,h);return}const u=this.options.getChildren(i.actual),r=i.actual,n=C(this.options.toITestItem(r),this.options.toITestItem(v));this.options.getApiFor(r).listener=void 0,i.actual=v,i.expand=0,n&&(n.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,r.tags,c.toString()),delete n.tags),this.onTestItemEvent(i,{op:4,update:n})),this.connectItemAndChildren(v,i,h);for(const[o,d]of u)this.options.getChildren(v).get(d.id)||this.removeItem(D.TestId.joinToString(c,d.id));this.documentSynced(i.actual.uri)}diffTagRefs(v,h,c){const g=new Set(h.map(i=>i.id));for(const i of v)g.delete(i.id)||this.incrementTagRefs(i);this.pushDiff({op:1,item:{extId:c,item:{tags:v.map(i=>(0,y.namespaceTestTag)(this.options.controllerId,i.id))}}}),g.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const h=this.tags.get(v.id);h?h.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,y.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const h=this.tags.get(v);h&&!--h.refCount&&(this.tags.delete(v),this.pushDiff({op:7,id:(0,y.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,h){this.options.getApiFor(v).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(v,h,c){this.setItemParent(v,c);const g=this.options.getApiFor(v);g.parent=c?.actual,g.listener=i=>this.onTestItemEvent(h,i),this.updateExpandability(h)}connectItemAndChildren(v,h,c){this.connectItem(v,h,c);for(const[g,i]of this.options.getChildren(v))this.upsertItem(i,h)}updateExpandability(v){let h;this._resolveHandler?v.resolveBarrier?h=v.resolveBarrier.isOpen()?3:2:h=v.actual.canResolveChildren?1:0:h=0,h!==v.expand&&(v.expand=h,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:h}}),h===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,h){if(h<0)return;const c=[];for(const[g,i]of this.options.getChildren(v.actual)){const u=this.expand(D.TestId.joinToString(v.fullId,i.id),h);(0,l.isThenable)(u)&&c.push(u)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const i=new l.Barrier;return i.open(),i}v.expand=2,this.pushExpandStateUpdate(v);const h=v.resolveBarrier=new l.Barrier,c=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,i)};let g;try{g=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(i){c(i)}return(0,l.isThenable)(g)?g.catch(c).then(()=>{h.open(),this.updateExpandability(v)}):(h.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const h=this.tree.get(v);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const c=[h];for(;c.length;){const g=c.pop();if(!!g){this.options.getApiFor(g.actual).listener=void 0;for(const i of g.actual.tags)this.decrementTagRefs(i.id);this.tree.delete(g.fullId.toString());for(const[i,u]of this.options.getChildren(g.actual))c.push(this.tree.get(D.TestId.joinToString(g.fullId,u.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=E;class T extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=T;class S extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=S;class p extends Error{constructor(v,h,c){super(`TestItem with ID "${v}" is from controller "${h}" and cannot be added as a child of an item from controller "${c}".`)}}e.MixedTestItemController=p;const b=(f,v,h)=>{let c=new Map;return{get size(){return c.size},forEach(g,i){for(const u of c.values())g.call(i,u,this)},[Symbol.iterator](){return c.entries()},replace(g){const i=new Map,u=new Set(c.keys()),r={op:5,ops:[]};for(const n of g){if(!(n instanceof h))throw new S(n.id);const o=v(n).controllerId;if(o!==f.controllerId)throw new p(n.id,o,f.controllerId);if(i.has(n.id))throw new T(n.id);i.set(n.id,n),u.delete(n.id),r.ops.push({op:0,item:n})}for(const n of u.keys())r.ops.push({op:3,id:n});f.listener?.(r),c=i},add(g){if(!(g instanceof h))throw new S(g.id);c.set(g.id,g),f.listener?.({op:0,item:g})},delete(g){c.delete(g)&&f.listener?.({op:3,id:g})},get(g){return c.get(g)},toJSON(){return Array.from(c.values())}}};e.createTestItemChildren=b}),define(Ce[129],De([1,0,90]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,I=(y,D)=>{const w={controllerId:D};return t.set(y,w),w};e.createPrivateApiFor=I;const P=y=>{const D=t.get(y);if(!D)throw new l.InvalidTestItemError(y?.id||"<unknown>");return D};e.getPrivateApiFor=P}),define(Ce[220],De([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,l.createDecorator)("configurationResolverService");var t;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class I extends Error{constructor(y,D){super(D),this.variable=y}}e.VariableError=I}),define(Ce[221],De([1,0,9,36,13,24,10,109,185,220,8]),function(J,e,l,t,I,P,y,D,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(T,S,p,b){this._contributedVariables=new Map,this._context=T,this._labelService=S,this._userHomePromise=p,b&&(this._envVariablesPromise=b.then(f=>this.prepareEnv(f)))}prepareEnv(T){if(y.isWindows){const S=Object.create(null);return Object.keys(T).forEach(p=>{S[p.toLowerCase()]=T[p]}),S}return T}resolveWithEnvironment(T,S,p){return this.recursiveResolve({env:this.prepareEnv(T),userHome:void 0},S?S.uri:void 0,p)}async resolveAsync(T,S){const p={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(p,T?T.uri:void 0,S)}async resolveAnyBase(T,S,p,b){const f=P.deepClone(S);y.isWindows&&f.windows?Object.keys(f.windows).forEach(h=>f[h]=f.windows[h]):y.isMacintosh&&f.osx?Object.keys(f.osx).forEach(h=>f[h]=f.osx[h]):y.isLinux&&f.linux&&Object.keys(f.linux).forEach(h=>f[h]=f.linux[h]),delete f.windows,delete f.osx,delete f.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,T?T.uri:void 0,f,p,b)}async resolveAnyAsync(T,S,p){return this.resolveAnyBase(T,S,p)}async resolveAnyMap(T,S,p){const b=new Map;return{newConfig:await this.resolveAnyBase(T,S,p,b),resolvedVariables:b}}resolveWithInteractionReplace(T,S,p,b){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,S,p,b){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,S){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,S)}async recursiveResolve(T,S,p,b,f){if(I.isString(p))return this.resolveString(T,S,p,b,f);if(Array.isArray(p))return Promise.all(p.map(v=>this.recursiveResolve(T,S,v,b,f)));if(I.isObject(p)){const v=Object.create(null),h=await Promise.all(Object.keys(p).map(async c=>[await this.resolveString(T,S,c,b,f),await this.recursiveResolve(T,S,p[c],b,f)]));for(const[c,g]of h)v[c]=g;return v}return p}resolveString(T,S,p,b,f){return(0,L.replaceAsync)(p,C.VARIABLE_REGEXP,async(v,h)=>{if(h.includes(C.VARIABLE_LHS))return v;let c=await this.evaluateSingleVariable(T,v,h,S,b);return f?.set(h,c),c!==v&&I.isString(c)&&c.match(C.VARIABLE_REGEXP)&&(c=await this.resolveString(T,S,c,b,f)),c})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}async evaluateSingleVariable(T,S,p,b,f){let v;const h=p.split(":");h.length>1&&(p=h[0],v=h[1]);const c=u=>{const r=this._context.getFilePath();if(r)return r;throw new k.VariableError(u,(0,w.localize)(0,null,S))},g=u=>{const r=c(u);if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new k.VariableError(u,(0,w.localize)(1,null,S,l.basename(r)))},i=u=>{if(v){const r=this._context.getFolderUri(v);if(r)return r;throw new k.VariableError(u,(0,w.localize)(2,null,S,v))}if(b)return b;throw this._context.getWorkspaceFolderCount()>1?new k.VariableError(u,(0,w.localize)(3,null,S)):new k.VariableError(u,(0,w.localize)(4,null,S))};switch(p){case"env":if(v){if(T.env){const u=T.env[y.isWindows?v.toLowerCase():v];if(I.isString(u))return u}return""}throw new k.VariableError(k.VariableKind.Env,(0,w.localize)(5,null,S));case"config":if(v){const u=this._context.getConfigurationValue(b,v);if(I.isUndefinedOrNull(u))throw new k.VariableError(k.VariableKind.Config,(0,w.localize)(6,null,S,v));if(I.isObject(u))throw new k.VariableError(k.VariableKind.Config,(0,w.localize)(7,null,S,v));return u}throw new k.VariableError(k.VariableKind.Config,(0,w.localize)(8,null,S));case"command":return this.resolveFromMap(k.VariableKind.Command,S,v,f,"command");case"input":return this.resolveFromMap(k.VariableKind.Input,S,v,f,"input");case"extensionInstallFolder":if(v){const u=await this._context.getExtension(v);if(!u)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,S,v));return this.fsPath(u.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,S));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(i(k.VariableKind.WorkspaceFolder)));case"cwd":return b||v?(0,D.normalizeDriveLetter)(this.fsPath(i(k.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return l.basename(this.fsPath(i(k.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(T.userHome)return T.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,w.localize)(11,null,S))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new k.VariableError(k.VariableKind.LineNumber,(0,w.localize)(12,null,S))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new k.VariableError(k.VariableKind.SelectedText,(0,w.localize)(13,null,S))}case"file":return c(k.VariableKind.File);case"fileWorkspaceFolder":return g(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return b||v?l.relative(this.fsPath(i(k.VariableKind.RelativeFile)),c(k.VariableKind.RelativeFile)):c(k.VariableKind.RelativeFile);case"relativeFileDirname":{const u=l.dirname(c(k.VariableKind.RelativeFileDirname));if(b||v){const r=l.relative(this.fsPath(i(k.VariableKind.RelativeFileDirname)),u);return r.length===0?".":r}return u}case"fileDirname":return l.dirname(c(k.VariableKind.FileDirname));case"fileExtname":return l.extname(c(k.VariableKind.FileExtname));case"fileBasename":return l.basename(c(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=l.basename(c(k.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-l.extname(u).length)}case"fileDirnameBasename":return l.basename(l.dirname(c(k.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||S}case"execInstallFolder":{const u=this._context.getAppRoot();return u||S}case"pathSeparator":return l.sep;default:try{const u=v?`${p}:${v}`:p;return this.resolveFromMap(k.VariableKind.Unknown,S,u,f,void 0)}catch{return S}}}}resolveFromMap(T,S,p,b,f){if(p&&b){const v=f===void 0?b[p]:b[f+":"+p];if(typeof v=="string")return v;throw new k.VariableError(T,(0,w.localize)(14,null,S))}return S}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[130],De([1,0,3,127]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,l.createDecorator)("editorGroupsService");var I;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var P;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var D;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EVEN=1]="EVEN",S[S.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var w;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(w=e.MergeGroupMode||(e.MergeGroupMode={}));function k(S){const p=S;return(0,t.isEditorInput)(p?.editor)&&(0,t.isEditorInput)(p?.replacement)}e.isEditorReplacement=k;var L;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(C=e.OpenEditorContext||(e.OpenEditorContext={}));function E(S){const p=S;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=E;function T(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(Ce[222],De([1,0,3,130]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,l.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(P){const y=P;return typeof P=="number"||(0,t.isEditorGroup)(y)}e.isPreferredGroup=I}),define(Ce[223],De([1,0,3,190]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,l.refineServiceDecorator)(t.IEnvironmentService)}),define(Ce[224],De([1,0,27,4,9]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(C){this.removedDueToLooping=C}}e.DeltaExtensionsResult=P;class y{constructor(C){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=C,this._initialize()}_initialize(){this._extensionDescriptions.sort(w),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const C of this._extensionDescriptions){if(this._extensionsMap.has(l.ExtensionIdentifier.toKey(C.identifier))){console.error("Extension `"+C.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(l.ExtensionIdentifier.toKey(C.identifier),C),this._extensionsArr.push(C),Array.isArray(C.activationEvents))for(let E of C.activationEvents)E==="onUri"&&(E=`onUri:${l.ExtensionIdentifier.toKey(C.identifier)}`),this._activationMap.has(E)||this._activationMap.set(E,[]),this._activationMap.get(E).push(C)}}set(C){this._extensionDescriptions=C,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(C,E){this._extensionDescriptions=k(this._extensionDescriptions,E),this._extensionDescriptions=this._extensionDescriptions.concat(C);const T=y._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=k(this._extensionDescriptions,T.map(S=>S.identifier)),this._initialize(),this._onDidChange.fire(void 0),new P(T)}static _findLoopingExtensions(C){const E=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,v){this.addNode(f),this.addNode(v),this._arcs.has(f)?this._arcs.get(f).push(v):this._arcs.set(f,[v])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,v){const h=E.getArcs(f);for(let c=0;c<h.length;c++)if(!v.has(h[c]))return!1;return!0}getNodes(){return this._nodesArr}},T=new Map;for(const f of C){const v=l.ExtensionIdentifier.toKey(f.identifier);if(T.set(v,f),f.extensionDependencies)for(const h of f.extensionDependencies){const c=l.ExtensionIdentifier.toKey(h);E.addArc(v,c)}}const S=new Set;E.getNodes().filter(f=>E.getArcs(f).length===0).forEach(f=>S.add(f));const p=E.getNodes().filter(f=>!S.has(f));let b;do{b=!1;for(let f=0;f<p.length;f++){const v=p[f];E.hasOnlyGoodArcs(v,S)&&(p.splice(f,1),f--,S.add(v),b=!0)}}while(b);return p.map(f=>T.get(f))}containsActivationEvent(C){return this._activationMap.has(C)}containsExtension(C){return this._extensionsMap.has(l.ExtensionIdentifier.toKey(C))}getExtensionDescriptionsForActivationEvent(C){const E=this._activationMap.get(C);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(C){const E=this._extensionsMap.get(l.ExtensionIdentifier.toKey(C));return E||void 0}getExtensionDescriptionByUUID(C){for(const E of this._extensionsArr)if(E.uuid===C)return E}getExtensionDescriptionByIdOrUUID(C,E){return this.getExtensionDescription(C)??(E?this.getExtensionDescriptionByUUID(E):void 0)}}e.ExtensionDescriptionRegistry=y;var D;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(D||(D={}));function w(L,C){const E=L.isBuiltin?0:L.isUnderDevelopment?2:1,T=C.isBuiltin?0:C.isUnderDevelopment?2:1;if(E!==T)return E-T;const S=I.posix.basename(L.extensionLocation.path),p=I.posix.basename(C.extensionLocation.path);return S<p?-1:S>p?1:0}function k(L,C){const E=new Set;return C.forEach(T=>E.add(l.ExtensionIdentifier.toKey(T))),L.filter(T=>!E.has(l.ExtensionIdentifier.toKey(T.identifier)))}}),define(Ce[225],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var l;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(l=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(C){this.pipeName=C,this.type=1}serialize(C){C[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class I{constructor(){this.type=2}serialize(C){C[I.ENV_KEY]="1"}}e.SocketExtHostConnection=I,I.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(C){C[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function y(L){delete L[t.ENV_KEY],delete L[I.ENV_KEY],delete L[P.ENV_KEY]}function D(L,C){y(C),L.serialize(C)}e.writeExtHostConnection=D;function w(L){if(L[t.ENV_KEY])return k(L,new t(L[t.ENV_KEY]));if(L[I.ENV_KEY])return k(L,new I);if(L[P.ENV_KEY])return k(L,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=w;function k(L,C){return y(L),C}}),define(Ce[91],De([1,0,23]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var I;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function y(k){const L=l.VSBuffer.alloc(1);switch(k){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=y;function D(k,L){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=D;var w;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(w=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[131],De([1,0,3,4,12,25,91,85,203,24,2]),function(J,e,l,t,I,P,y,D,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let C=class{constructor(p,b){this.initData=p,this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryLoggers=new Map,console.log(this.initData.environment.extensionTelemetryLogResource),this._outputLogger=b.createLogger(L.URI.revive(this.initData.environment.extensionTelemetryLogResource)),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(p,b){const f=this.getTelemetryDetails(),v=new E(b,p,this._outputLogger,this.getBuiltInCommonProperties(p),{isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled});return this._telemetryLoggers.set(p.identifier.value,v),v.apiTelemetryLogger}$initializeTelemetryLevel(p,b){this._level=p,this._productConfig=b||{usage:!0,error:!0}}getBuiltInCommonProperties(p){const b={};switch(b["common.extname"]=p.name,b["common.extversion"]=p.version,b["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,b["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,b["common.vscodeversion"]=this.initData.version,b["common.isnewappinstall"]=T(this.initData.telemetryInfo.firstSessionDate),b["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case y.UIKind.Web:b["common.uikind"]="web";break;case y.UIKind.Desktop:b["common.uikind"]="desktop";break;default:b["common.uikind"]="unknown"}return b["common.remotename"]=(0,D.getRemoteName)((0,w.cleanRemoteAuthority)(this.initData.remote.authority)),b}$onDidChangeTelemetryLevel(p){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=p;const b=this.getTelemetryDetails();this._telemetryLoggers.forEach(f=>{f.updateTelemetryEnablements(b.isUsageEnabled,b.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}};C=je([He(0,P.IExtHostInitDataService),He(1,I.ILoggerService)],C),e.ExtHostTelemetry=C;class E{constructor(p,b,f,v,h){this._extension=b,this._logger=f,this._commonProperties=v,this._onDidChangeEnableStates=new t.Emitter,this._appender=p,this._telemetryEnablements={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(p,b){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:p,isErrorsEnabled:b},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(p){return this._appender.ignoreBuiltInCommonProperties||(p=(0,k.mixin)(p,this._commonProperties)),this._appender.additionalCommonProperties&&(p=(0,k.mixin)(p,this._appender.additionalCommonProperties)),p=(0,w.cleanData)(p,[]),p}logEvent(p,b){p=this._extension.identifier.value+"/"+p,b=this.mixInCommonPropsAndCleanData(b||{}),this._appender.logEvent(p,b),this._logger.trace(p,b)}logUsage(p,b){!this._telemetryEnablements.isUsageEnabled||this.logEvent(p,b)}logError(p,b){!this._telemetryEnablements.isErrorsEnabled||(typeof p=="string"?this.logEvent(p,b):this._appender.logException(p,b))}get apiTelemetryLogger(){if(!this._apiObject){const p=this,b={logUsage:p.logUsage,get isUsageEnabled(){return p._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return p._telemetryEnablements.isErrorsEnabled},logError:p.logError,dispose:p.dispose,onDidChangeEnableStates:p._onDidChangeEnableStates.event};this._apiObject=Object.freeze(b)}return this._apiObject}dispose(){this._appender?.flush&&this._appender.flush()}}e.ExtHostTelemetryLogger=E;function T(S){const p=Date.now()-new Date(S).getTime();return isNaN(p)?!1:p<1e3*60*60*24}e.isNewAppInstall=T,e.IExtHostTelemetry=(0,l.createDecorator)("IExtHostTelemetry")}),define(Ce[28],De([1,0,4,2,3,27,199]),function(J,e,l,t,I,P,y){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");class w{constructor(d){this.affinity=d,this.kind=1}equals(d){return this.kind===d.kind&&this.affinity===d.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=w;class k{constructor(){this.kind=2,this.affinity=0}equals(d){return this.kind===d.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=k;class L{constructor(){this.kind=3,this.affinity=0}equals(d){return this.kind===d.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class C{constructor(d){this.dependency=d}}e.MissingExtensionDependency=C;var E;(function(o){o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(o){if(o===null)return"None";switch(o){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class S{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(d,s){const a=[],m=[],_=[],R=[],M=f(this._allExtensions),U=f(d),A=(V,B)=>V.extensionLocation.toString()===B.extensionLocation.toString()||V.isBuiltin===B.isBuiltin||V.isUserBuiltin===B.isUserBuiltin||V.isUnderDevelopment===B.isUnderDevelopment;for(const V of this._allExtensions){const B=U.get(P.ExtensionIdentifier.toKey(V.identifier));if(!B){a.push(V.identifier),M.delete(P.ExtensionIdentifier.toKey(V.identifier));continue}if(!A(V,B)){a.push(V.identifier),M.delete(P.ExtensionIdentifier.toKey(V.identifier));continue}}for(const V of d){const B=M.get(P.ExtensionIdentifier.toKey(V.identifier));if(!B){m.push(V);continue}if(!A(B,V)){a.push(B.identifier),M.delete(P.ExtensionIdentifier.toKey(B.identifier));continue}}const z=b(this._myExtensions),$=b(s);for(const V of this._myExtensions)$.has(P.ExtensionIdentifier.toKey(V))||_.push(V);for(const V of s)z.has(P.ExtensionIdentifier.toKey(V))||R.push(V);const N={toRemove:a,toAdd:m,myToRemove:_,myToAdd:R};return this.delta(N),N}delta(d){const{toRemove:s,toAdd:a,myToRemove:m,myToAdd:_}=d,R=b(s),M=b(m);for(let U=0;U<this._allExtensions.length;U++)R.has(P.ExtensionIdentifier.toKey(this._allExtensions[U].identifier))&&(this._allExtensions.splice(U,1),U--);for(let U=0;U<this._myExtensions.length;U++)M.has(P.ExtensionIdentifier.toKey(this._myExtensions[U]))&&(this._myExtensions.splice(U,1),U--);for(const U of a)this._allExtensions.push(U);for(const U of _)this._myExtensions.push(U)}containsExtension(d){for(const s of this._myExtensions)if(P.ExtensionIdentifier.equals(s,d))return!0;return!1}}e.ExtensionHostExtensions=S;class p{constructor(d){if(this[D]="ExtensionIdentifierSet",this._map=new Map,this._toKey=P.ExtensionIdentifier.toKey,d)for(const s of d)this.add(s)}get size(){return this._map.size}add(d){return this._map.set(this._toKey(d),d),this}clear(){this._map.clear()}delete(d){return this._map.delete(this._toKey(d))}has(d){return this._map.has(this._toKey(d))}forEach(d,s){this._map.forEach(a=>d.call(s,a,a,this))}*entries(){for(const[d,s]of this._map)yield[s,s]}keys(){return this._map.values()}values(){return this._map.values()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=p;function b(o){const d=new Set;for(const s of o)d.add(P.ExtensionIdentifier.toKey(s));return d}e.extensionIdentifiersArrayToSet=b;function f(o){const d=new Map;for(const s of o)d.set(P.ExtensionIdentifier.toKey(s.identifier),s);return d}function v(o,d){return o.enabledApiProposals?o.enabledApiProposals.includes(d):!1}e.isProposedApiEnabled=v;function h(o,d){if(!v(o,d))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=h;class c{constructor(d,s,a,m){this.codeLoadingTime=d,this.activateCallTime=s,this.activateResolvedTime=a,this.activationReason=m}}e.ActivationTimes=c;class g{constructor(d,s){this.description=d,this.value=s}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost";var i;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function u(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function r(o,d){return{identifier:new P.ExtensionIdentifier((0,y.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!d,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,browserNlsBundleUris:o.browserNlsBundleUris}}e.toExtensionDescription=r;class n{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(d,s){return Promise.resolve(0)}getInspectPorts(d,s){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(d,s){return Promise.resolve()}}e.NullExtensionService=n}),define(Ce[226],De([1,0,11,27,28,12,18]),function(J,e,l,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class D{constructor(b,f,v,h){this.startup=b,this.codeLoadingTime=f,this.activateCallTime=v,this.activateResolvedTime=h}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class w{constructor(b){this._startup=b,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(b,f){return b===-1||f===-1?-1:f-b}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=w;class k{constructor(b,f,v,h,c,g){this.activationFailed=b,this.activationFailedError=f,this.activationTimes=v,this.module=h,this.exports=c,this.subscriptions=g}}e.ActivatedExtension=k;class L extends k{constructor(b){super(!1,null,b,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class C extends k{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class E extends k{constructor(b){super(!0,b,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=E;let T=class{constructor(b,f,v,h,c){this._logService=c,this._registry=b,this._resolvedExtensionsSet=new Set,f.forEach(g=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(g))),this._externalExtensionsMap=new Map,v.forEach(g=>this._externalExtensionsMap.set(t.ExtensionIdentifier.toKey(g),g)),this._host=h,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[b,f]of this._operations)f.dispose()}isActivated(b){const f=this._operations.get(t.ExtensionIdentifier.toKey(b));return Boolean(f&&f.value)}getActivatedExtension(b){const f=this._operations.get(t.ExtensionIdentifier.toKey(b));if(!f||!f.value)throw new Error(`Extension '${b.value}' is not known or not activated`);return f.value}async activateByEvent(b,f){if(this._alreadyActivatedEvents[b])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(b);await this._activateExtensions(v.map(h=>({id:h.identifier,reason:{startup:f,extensionId:h.identifier,activationEvent:b}}))),this._alreadyActivatedEvents[b]=!0}activateById(b,f){const v=this._registry.getExtensionDescription(b);if(!v)throw new Error(`Extension '${b}' is not known`);return this._activateExtensions([{id:v.identifier,reason:f}])}async _activateExtensions(b){const f=b.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(f.map(v=>v.wait()))}_handleActivationRequest(b){if(this._operations.has(t.ExtensionIdentifier.toKey(b.id)))return this._operations.get(t.ExtensionIdentifier.toKey(b.id));if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(b.id)))return this._createAndSaveOperation(b,null,[],null);const f=this._registry.getExtensionDescription(b.id);if(!f){const c=new Error(`Cannot activate unknown extension '${b.id.value}'`),g=this._createAndSaveOperation(b,null,[],new E(c));return this._host.onExtensionActivationError(b.id,c,new I.MissingExtensionDependency(b.id.value)),g}const v=[],h=typeof f.extensionDependencies>"u"?[]:f.extensionDependencies;for(const c of h){if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(c)))continue;const g=this._operations.get(t.ExtensionIdentifier.toKey(c));if(g){v.push(g);continue}if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(c))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(t.ExtensionIdentifier.toKey(c)),reason:b.reason}));continue}const i=this._registry.getExtensionDescription(c);if(i){if(!i.main&&!i.browser)continue;v.push(this._handleActivationRequest({id:i.identifier,reason:b.reason}));continue}const u=f.displayName||f.identifier.value,r=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${c}'`),n=this._createAndSaveOperation(b,f.displayName,[],new E(r));return this._host.onExtensionActivationError(f.identifier,r,new I.MissingExtensionDependency(c)),n}return this._createAndSaveOperation(b,f.displayName,v,null)}_createAndSaveOperation(b,f,v,h){const c=new S(b.id,f,b.reason,v,h,this._host,this._logService);return this._operations.set(t.ExtensionIdentifier.toKey(b.id),c),c}};T=je([He(4,P.ILogService)],T),e.ExtensionsActivator=T;let S=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(b,f,v,h,c,g,i){this._id=b,this._displayName=f,this._reason=v,this._deps=h,this._value=c,this._host=g,this._logService=i,this._barrier=new y.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let b=0;b<this._deps.length;b++){const f=this._deps[b];if(f.value&&!f.value.activationFailed){this._deps.splice(b,1),b--;continue}if(f.value&&f.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);v.detail=f.value.activationFailedError,this._value=new E(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(b=>b.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(b){const f=new Error;if(b&&b.name&&(f.name=b.name),b&&b.message?f.message=`Activating extension '${this._id.value}' failed: ${b.message}.`:f.message=`Activating extension '${this._id.value}' failed: ${b}.`,b&&b.stack&&(f.stack=b.stack),this._value=new E(f),this._isDisposed&&l.isCancellationError(b))return;this._host.onExtensionActivationError(this._id,f,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(b)}}};S=je([He(6,P.ILogService)],S)}),define(Ce[227],De([1,0,12,25,28]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends l.LogService{constructor(D,w){super(D.createLogger(w.logFile,{name:I.ExtensionHostLogFileName}))}};P=je([He(0,l.ILoggerService),He(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,l):I?I.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[7],De([1,0,17,11,108,26,103,8,13,2,31,38,125,89,28]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S){"use strict";var p,b,f,v,h,c,g,i,u,r,n,o,d,s,a,m,_,R,M,U,A,z,$;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function N(q){return Object.assign(q,{apply:function(){const ue=arguments.length===1?[]:arguments[1];return Reflect.construct(q,ue,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(q,[]);{const[ue,...Te]=arguments;return Reflect.construct(q,Te,ue.constructor)}}})}let V=c=class{static from(...W){let ue=W;return new c(function(){if(ue){for(const Te of ue)Te&&typeof Te.dispose=="function"&&Te.dispose();ue=void 0}})}constructor(W){p.set(this,void 0),tt(this,p,W,"f")}dispose(){typeof Be(this,p,"f")=="function"&&(Be(this,p,"f").call(this),tt(this,p,void 0,"f"))}};p=new WeakMap,V=c=je([N],V),e.Disposable=V;let B=g=class{static Min(...W){if(W.length===0)throw new TypeError;let ue=W[0];for(let Te=1;Te<W.length;Te++){const Xe=W[Te];Xe.isBefore(ue)&&(ue=Xe)}return ue}static Max(...W){if(W.length===0)throw new TypeError;let ue=W[0];for(let Te=1;Te<W.length;Te++){const Xe=W[Te];Xe.isAfter(ue)&&(ue=Xe)}return ue}static isPosition(W){if(!W)return!1;if(W instanceof g)return!0;const{line:ue,character:Te}=W;return typeof ue=="number"&&typeof Te=="number"}static of(W){if(W instanceof g)return W;if(this.isPosition(W))return new g(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(W,ue){if(W<0)throw(0,t.illegalArgument)("line must be non-negative");if(ue<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=W,this._character=ue}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,ue=0){if(W===null||ue===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,ue=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&ue===0?this:new g(this.line+Te,this.character+ue)}with(W,ue=this.character){if(W===null||ue===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,ue=typeof W.character=="number"?W.character:this.character),Te===this.line&&ue===this.character?this:new g(Te,ue)}toJSON(){return{line:this.line,character:this.character}}};B=g=je([N],B),e.Position=B;let F=i=class{static isRange(W){return W instanceof i?!0:W?B.isPosition(W.start)&&B.isPosition(W.end):!1}static of(W){if(W instanceof i)return W;if(this.isRange(W))return new i(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(W,ue,Te,Xe){let et,ut;if(typeof W=="number"&&typeof ue=="number"&&typeof Te=="number"&&typeof Xe=="number"?(et=new B(W,ue),ut=new B(Te,Xe)):B.isPosition(W)&&B.isPosition(ue)&&(et=B.of(W),ut=B.of(ue)),!et||!ut)throw new Error("Invalid arguments");et.isBefore(ut)?(this._start=et,this._end=ut):(this._start=ut,this._end=et)}contains(W){return i.isRange(W)?this.contains(W.start)&&this.contains(W.end):B.isPosition(W)?!(B.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const ue=B.Max(W.start,this._start),Te=B.Min(W.end,this._end);if(!ue.isAfter(Te))return new i(ue,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ue=B.Min(W.start,this._start),Te=B.Max(W.end,this.end);return new i(ue,Te)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,ue=this.end){if(W===null||ue===null)throw(0,t.illegalArgument)();let Te;return W?B.isPosition(W)?Te=W:(Te=W.start||this.start,ue=W.end||this.end):Te=this.start,Te.isEqual(this._start)&&ue.isEqual(this.end)?this:new i(Te,ue)}toJSON(){return[this.start,this.end]}};F=i=je([N],F),e.Range=F;let x=u=class extends F{static isSelection(W){return W instanceof u?!0:W?F.isRange(W)&&B.isPosition(W.anchor)&&B.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(W,ue,Te,Xe){let et,ut;if(typeof W=="number"&&typeof ue=="number"&&typeof Te=="number"&&typeof Xe=="number"?(et=new B(W,ue),ut=new B(Te,Xe)):B.isPosition(W)&&B.isPosition(ue)&&(et=B.of(W),ut=B.of(ue)),!et||!ut)throw new Error("Invalid arguments");super(et,ut),this._anchor=et,this._active=ut}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=u=je([N],x),e.Selection=x;class H{constructor(W,ue,Te){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(ue),this.connectionToken=Te}}e.ResolvedAuthority=H;class Q extends Error{static NotAvailable(W,ue){return new Q(W,E.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable(W){return new Q(W,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ue=E.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=ue,this._detail=Te,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Q.prototype)}}e.RemoteAuthorityResolverError=Q;var K;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var de;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(de=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ee=r=class{static isTextEdit(W){return W instanceof r?!0:W?F.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ue){return new r(W,ue)}static insert(W,ue){return r.replace(new F(W,W),ue)}static delete(W){return r.replace(W,"")}static setEndOfLine(W){const ue=new r(new F(new B(0,0),new B(0,0)),"");return ue.newEol=W,ue}get range(){return this._range}set range(W){if(W&&!F.isRange(W))throw(0,t.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,t.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,t.illegalArgument)("newEol");this._newEol=W}constructor(W,ue){this._range=W,this._newText=ue}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ee=r=je([N],ee),e.TextEdit=ee;let he=n=class{static isNotebookCellEdit(W){return W instanceof n?!0:W?Vt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ue){return new n(W,ue)}static insertCells(W,ue){return new n(new Vt(W,W),ue)}static deleteCells(W){return new n(W,[])}static updateCellMetadata(W,ue){const Te=new n(new Vt(W,W),[]);return Te.newCellMetadata=ue,Te}static updateNotebookMetadata(W){const ue=new n(new Vt(0,0),[]);return ue.newNotebookMetadata=W,ue}constructor(W,ue){this.range=W,this.newCells=ue}};he=n=je([N],he),e.NotebookEdit=he;class Y{static isSnippetTextEdit(W){return W instanceof Y?!0:W?F.isRange(W.range)&&ke.isSnippetString(W.snippet):!1}static replace(W,ue){return new Y(W,ue)}static insert(W,ue){return Y.replace(new F(W,W),ue)}constructor(W,ue){this.range=W,this.snippet=ue}}e.SnippetTextEdit=Y;var me;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace",q[q.Snippet=6]="Snippet"})(me=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,ue,Te,Xe){this._edits.push({_type:1,from:W,to:ue,options:Te,metadata:Xe})}createFile(W,ue,Te){this._edits.push({_type:1,from:void 0,to:W,options:ue,metadata:Te})}deleteFile(W,ue,Te){this._edits.push({_type:1,from:W,to:void 0,options:ue,metadata:Te})}replaceNotebookMetadata(W,ue,Te){this._edits.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:ue},notebookMetadata:ue})}replaceNotebookCells(W,ue,Te,Xe){const et=ue.start,ut=ue.end;(et!==ut||Te.length>0)&&this._edits.push({_type:5,uri:W,index:et,count:ut-et,cells:Te,metadata:Xe})}replaceNotebookCellMetadata(W,ue,Te,Xe){this._edits.push({_type:3,metadata:Xe,uri:W,edit:{editType:8,index:ue,metadata:Te}})}replace(W,ue,Te,Xe){this._edits.push({_type:2,uri:W,edit:new ee(ue,Te),metadata:Xe})}insert(W,ue,Te,Xe){this.replace(W,new F(ue,ue),Te,Xe)}delete(W,ue,Te){this.replace(W,ue,"",Te)}has(W){return this._edits.some(ue=>ue._type===2&&ue.uri.toString()===W.toString())}set(W,ue){if(ue)for(const Te of ue){if(!Te)continue;let Xe,et;Array.isArray(Te)?(Xe=Te[0],et=Te[1]):Xe=Te,he.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.replaceNotebookCellMetadata(W,Xe.range.start,Xe.newCellMetadata,et):Xe.newNotebookMetadata?this.replaceNotebookMetadata(W,Xe.newNotebookMetadata,et):this.replaceNotebookCells(W,Xe.range,Xe.newCells,et):Y.isSnippetTextEdit(Xe)?this._edits.push({_type:6,uri:W,range:Xe.range,edit:Xe.snippet,metadata:et}):this._edits.push({_type:2,uri:W,edit:Xe,metadata:et})}else{for(let Te=0;Te<this._edits.length;Te++){const Xe=this._edits[Te];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===W.toString()&&(this._edits[Te]=void 0);break}}(0,l.coalesceInPlace)(this._edits)}}get(W){const ue=[];for(const Te of this._edits)Te._type===2&&Te.uri.toString()===W.toString()&&ue.push(Te.edit);return ue}entries(){const W=new P.ResourceMap;for(const ue of this._edits)if(ue._type===2){let Te=W.get(ue.uri);Te||(Te=[ue.uri,[]],W.set(ue.uri,Te)),Te[1].push(ue.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=je([N],be),e.WorkspaceEdit=be;let ke=o=class{static isSnippetString(W){return W instanceof o?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this._tabstop=1,this.value=W||""}appendText(W){return this.value+=o._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ue=this._tabstop++){if(typeof W=="function"){const Te=new o;Te._tabstop=this._tabstop,W(Te),this._tabstop=Te._tabstop,W=Te.value}else W=o._escape(W);return this.value+="${",this.value+=ue,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ue=this._tabstop++){const Te=W.map(Xe=>Xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,ue){if(typeof ue=="function"){const Te=new o;Te._tabstop=this._tabstop,ue(Te),this._tabstop=Te._tabstop,ue=Te.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};ke=o=je([N],ke),e.SnippetString=ke;var Re;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(Re=e.DiagnosticTag||(e.DiagnosticTag={}));var ze;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(ze=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=d=class{static isLocation(W){return W instanceof d?!0:W?F.isRange(W.range)&&k.URI.isUri(W.uri):!1}constructor(W,ue){if(this.uri=W,ue)if(F.isRange(ue))this.range=F.of(ue);else if(B.isPosition(ue))this.range=new F(ue,ue);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};oe=d=je([N],oe),e.Location=oe;let le=class{static is(W){return W?typeof W.message=="string"&&W.location&&F.isRange(W.location.range)&&k.URI.isUri(W.location.uri):!1}constructor(W,ue){this.location=W,this.message=ue}static isEqual(W,ue){return W===ue?!0:!W||!ue?!1:W.message===ue.message&&W.location.range.isEqual(ue.location.range)&&W.location.uri.toString()===ue.location.uri.toString()}};le=je([N],le),e.DiagnosticRelatedInformation=le;let ge=class{constructor(W,ue,Te=ze.Error){if(!F.isRange(W))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=W,this.message=ue,this.severity=Te}toJSON(){return{severity:ze[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ue){return W===ue?!0:!W||!ue?!1:W.message===ue.message&&W.severity===ue.severity&&W.code===ue.code&&W.severity===ue.severity&&W.source===ue.source&&W.range.isEqual(ue.range)&&(0,l.equals)(W.tags,ue.tags)&&(0,l.equals)(W.relatedInformation,ue.relatedInformation,le.isEqual)}};ge=je([N],ge),e.Diagnostic=ge;let Z=class{constructor(W,ue){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ue}};Z=je([N],Z),e.Hover=Z;var ae;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ne=class{constructor(W,ue=ae.Text){this.range=W,this.kind=ue}toJSON(){return{range:this.range,kind:ae[this.kind]}}};ne=je([N],ne),e.DocumentHighlight=ne;var ie;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(ie=e.SymbolKind||(e.SymbolKind={}));var O;(function(q){q[q.Deprecated=1]="Deprecated"})(O=e.SymbolTag||(e.SymbolTag={}));let j=s=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ue,Te,Xe,et){this.name=W,this.kind=ue,this.containerName=et,typeof Te=="string"&&(this.containerName=Te),Xe instanceof oe?this.location=Xe:Te instanceof F&&(this.location=new oe(Xe,Te)),s.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};j=s=je([N],j),e.SymbolInformation=j;let G=a=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(a.validate)}constructor(W,ue,Te,Xe,et){this.name=W,this.detail=ue,this.kind=Te,this.range=Xe,this.selectionRange=et,this.children=[],a.validate(this)}};G=a=je([N],G),e.DocumentSymbol=G;var X;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(W,ue){this.title=W,this.kind=ue}};pe=je([N],pe),e.CodeAction=pe;let we=m=class{constructor(W){this.value=W}append(W){return new m(this.value?this.value+m.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+m.sep)}};we.sep=".",we=m=je([N],we),e.CodeActionKind=we,we.Empty=new we(""),we.QuickFix=we.Empty.append("quickfix"),we.Refactor=we.Empty.append("refactor"),we.RefactorExtract=we.Refactor.append("extract"),we.RefactorInline=we.Refactor.append("inline"),we.RefactorMove=we.Refactor.append("move"),we.RefactorRewrite=we.Refactor.append("rewrite"),we.Source=we.Empty.append("source"),we.SourceOrganizeImports=we.Source.append("organizeImports"),we.SourceFixAll=we.Source.append("fixAll");let ce=class{constructor(W,ue){if(this.range=W,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ce=je([N],ce),e.SelectionRange=ce;class Ie{constructor(W,ue,Te,Xe,et,ut){this.kind=W,this.name=ue,this.detail=Te,this.uri=Xe,this.range=et,this.selectionRange=ut}}e.CallHierarchyItem=Ie;class ye{constructor(W,ue){this.fromRanges=ue,this.from=W}}e.CallHierarchyIncomingCall=ye;class We{constructor(W,ue){this.fromRanges=ue,this.to=W}}e.CallHierarchyOutgoingCall=We;var qe;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ze=class{constructor(W,ue){this.range=W,this.command=ue}get isResolved(){return!!this.command}};Ze=je([N],Ze),e.CodeLens=Ze;let Ye=_=class{static isMarkdownString(W){return W instanceof _?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ue=!1){b.set(this,void 0),tt(this,b,new I.MarkdownString(W,{supportThemeIcons:ue}),"f")}get value(){return Be(this,b,"f").value}set value(W){Be(this,b,"f").value=W}get isTrusted(){return Be(this,b,"f").isTrusted}set isTrusted(W){Be(this,b,"f").isTrusted=W}get supportThemeIcons(){return Be(this,b,"f").supportThemeIcons}set supportThemeIcons(W){Be(this,b,"f").supportThemeIcons=W}get supportHtml(){return Be(this,b,"f").supportHtml}set supportHtml(W){Be(this,b,"f").supportHtml=W}get baseUri(){return Be(this,b,"f").baseUri}set baseUri(W){Be(this,b,"f").baseUri=W}appendText(W){return Be(this,b,"f").appendText(W),this}appendMarkdown(W){return Be(this,b,"f").appendMarkdown(W),this}appendCodeblock(W,ue){return Be(this,b,"f").appendCodeblock(ue??"",W),this}};b=new WeakMap,Ye=_=je([N],Ye),e.MarkdownString=Ye;let Ne=class{constructor(W,ue){this.label=W,this.documentation=ue}};Ne=je([N],Ne),e.ParameterInformation=Ne;let at=class{constructor(W,ue){this.label=W,this.documentation=ue,this.parameters=[]}};at=je([N],at),e.SignatureInformation=at;let re=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};re=je([N],re),e.SignatureHelp=re;var se;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(se=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ee;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Ee=e.InlayHintKind||(e.InlayHintKind={}));let Ve=class{constructor(W){this.value=W}};Ve=je([N],Ve),e.InlayHintLabelPart=Ve;let fe=class{constructor(W,ue,Te){this.position=W,this.label=ue,this.kind=Te}};fe=je([N],fe),e.InlayHint=fe;var Ae;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(Le=e.CompletionItemKind||(e.CompletionItemKind={}));var Me;(function(q){q[q.Deprecated=1]="Deprecated"})(Me=e.CompletionItemTag||(e.CompletionItemTag={}));let Ke=class{constructor(W,ue){this.label=W,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&Le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ke=je([N],Ke),e.CompletionItem=Ke;let Je=class{constructor(W=[],ue=!1){this.items=W,this.isIncomplete=ue}};Je=je([N],Je),e.CompletionList=Je;let st=class{constructor(W,ue,Te){this.insertText=W,this.range=ue,this.command=Te}};st=je([N],st),e.InlineSuggestion=st;let ot=class{constructor(W){this.commands=void 0,this.items=W}};ot=je([N],ot),e.InlineSuggestionList=ot;let it=class{constructor(W,ue,Te){this.insertText=W,this.range=ue,this.command=Te}};it=je([N],it),e.InlineSuggestionNew=it;let lt=class{constructor(W,ue){this.items=W,this.commands=ue}};lt=je([N],lt),e.InlineSuggestionsNew=lt;var vt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(vt=e.ViewColumn||(e.ViewColumn={}));var wt;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(wt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var St;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(St=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Mt;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(Qe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var zt;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(zt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function W(ue){switch(ue){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=W}(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ot=class{constructor(W,ue){if(ue&&!k.URI.isUri(ue))throw(0,t.illegalArgument)("target");if(!F.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.target=ue}};Ot=je([N],Ot),e.DocumentLink=Ot;let Pt=class{constructor(W,ue,Te,Xe){this.red=W,this.green=ue,this.blue=Te,this.alpha=Xe}};Pt=je([N],Pt),e.Color=Pt;let gt=class{constructor(W,ue){if(ue&&!(ue instanceof Pt))throw(0,t.illegalArgument)("color");if(!F.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.color=ue}};gt=je([N],gt),e.ColorInformation=gt;let kt=class{constructor(W){if(!W||typeof W!="string")throw(0,t.illegalArgument)("label");this.label=W}};kt=je([N],kt),e.ColorPresentation=kt;var Pe;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Pe=e.ColorFormat||(e.ColorFormat={}));var Oe;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(Oe=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var _e;(function(q){q[q.Unknown=0]="Unknown",q[q.Shutdown=1]="Shutdown",q[q.Process=2]="Process",q[q.User=3]="User",q[q.Extension=4]="Extension"})(_e=e.TerminalExitReason||(e.TerminalExitReason={}));class te{constructor(W,ue,Te){if(this.startIndex=W,this.length=ue,this.tooltip=Te,typeof W!="number"||W<0)throw(0,t.illegalArgument)("startIndex");if(typeof ue!="number"||ue<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=te;var Fe;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(Fe=e.TerminalLocation||(e.TerminalLocation={}));class xe{constructor(W){if(this.options=W,typeof W!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=xe;var nt;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(nt=e.TaskRevealKind||(e.TaskRevealKind={}));var Ge;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(Ge=e.TaskPanelKind||(e.TaskPanelKind={}));let rt=R=class{static from(W){switch(W){case"clean":return R.Clean;case"build":return R.Build;case"rebuild":return R.Rebuild;case"test":return R.Test;default:return}}constructor(W,ue){if(this.label=ue,typeof W!="string"||typeof ue!="string")throw(0,t.illegalArgument)("name");this._id=W}get id(){return this._id}};rt.Clean=new R("clean","Clean"),rt.Build=new R("build","Build"),rt.Rebuild=new R("rebuild","Rebuild"),rt.Test=new R("test","Test"),rt=R=je([N],rt),e.TaskGroup=rt;function pt(q){let W="";for(let ue=0;ue<q.length;ue++)W+=q[ue].replace(/,/g,",,")+",";return W}let Et=class{constructor(W,ue,Te){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=W,ue!==void 0&&(Array.isArray(ue)?(this._args=ue,this._options=Te):this._options=ue)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const ue of this._args)W.push(ue);return pt(W)}};Et=je([N],Et),e.ProcessExecution=Et;let Tt=class{constructor(W,ue,Te){if(this._args=[],Array.isArray(ue)){if(!W)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W,this._args=ue,this._options=Te}else{if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W,this._options=ue}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ue of this._args)W.push(typeof ue=="string"?ue:ue.value);return pt(W)}};Tt=je([N],Tt),e.ShellExecution=Tt;var It;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(It=e.ShellQuoting||(e.ShellQuoting={}));var _t;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(_t=e.TaskScope||(e.TaskScope={}));class bt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=bt;let Ct=M=class{constructor(W,ue,Te,Xe,et,ut){this.__deprecated=!1,this._definition=this.definition=W;let ht;typeof ue=="string"?(this._name=this.name=ue,this._source=this.source=Te,this.execution=Xe,ht=et,this.__deprecated=!0):ue===_t.Global||ue===_t.Workspace?(this.target=ue,this._name=this.name=Te,this._source=this.source=Xe,this.execution=et,ht=ut):(this.target=ue,this._name=this.name=Te,this._source=this.source=Xe,this.execution=et,ht=ut),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Et?this._definition={type:M.ProcessType,id:this._execution.computeId()}:this._execution instanceof Tt?this._definition={type:M.ShellType,id:this._execution.computeId()}:this._execution instanceof bt?this._definition={type:M.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:M.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const ue=this._definition.type;(M.EmptyType===ue||M.ProcessType===ue||M.ShellType===ue||M.ExtensionCallbackType===ue)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};Ct.ExtensionCallbackType="customExecution",Ct.ProcessType="process",Ct.ShellType="shell",Ct.EmptyType="$empty",Ct=M=je([N],Ct),e.Task=Ct;var en;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(en=e.ProgressLocation||(e.ProgressLocation={}));var yt;(function(q){function W(ue){const Te=ue;return(0,w.isNumber)(Te.value)?Te.tooltip&&!(0,w.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}q.isViewBadge=W})(yt=e.ViewBadge||(e.ViewBadge={}));let qt=U=class{static isTreeItem(W,ue){if(W instanceof U)return!0;const Te=W;if(Te.label!==void 0&&!(0,w.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,w.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,w.isString)(Te.iconPath)&&!k.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,w.isString)(Te.iconPath.id))){const Xe=Te.iconPath;if(!Xe||!(0,w.isString)(Xe.light)&&!k.URI.isUri(Xe.light)&&!(0,w.isString)(Xe.dark)&&!k.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,w.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!k.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,w.isString)(Te.tooltip)&&!(Te.tooltip instanceof Ye))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<$t.None&&Te.collapsibleState>$t.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,w.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,S.checkProposedApiEnabled)(ue,"treeItemCheckbox");const Xe=(0,w.isNumber)(Te.checkboxState)?Te.checkboxState:(0,w.isObject)(Te.checkboxState)&&(0,w.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,et=!(0,w.isNumber)(Te.checkboxState)&&(0,w.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==tn.Checked&&Xe!==tn.Unchecked||et!==void 0&&!(0,w.isString)(et))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(W,ue=$t.None){this.collapsibleState=ue,k.URI.isUri(W)?this.resourceUri=W:this.label=W}};qt=U=je([N],qt),e.TreeItem=qt;var $t;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})($t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var tn;(function(q){q[q.Unchecked=0]="Unchecked",q[q.Checked=1]="Checked"})(tn=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let un=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,ue){this.value=W,this.id=ue??(0,L.generateUuid)()}};un=je([N],un),e.DataTransferItem=un;let At=class{constructor(W){f.set(this,new Map);for(const[ue,Te]of W??[]){const Xe=Be(this,f,"f").get(ue);Xe?Xe.push(Te):Be(this,f,"f").set(ue,[Te])}}get(W){return Be(this,f,"f").get(W)?.[0]}set(W,ue){Be(this,f,"f").set(W,[ue])}forEach(W,ue){for(const[Te,Xe]of Be(this,f,"f"))for(const et of Xe)W.call(ue,et,Te,this)}*[(f=new WeakMap,Symbol.iterator)](){for(const[W,ue]of Be(this,f,"f"))for(const Te of ue)yield[W,Te]}};At=je([N],At),e.DataTransfer=At;let nn=class{constructor(W){this.insertText=W}};nn=je([N],nn),e.DocumentDropEdit=nn;let dn=class{constructor(W){this.insertText=W}};dn=je([N],dn),e.DocumentPasteEdit=dn;let Ut=class{constructor(W,ue){this.id=W,this.color=ue}};Ut=je([N],Ut),e.ThemeIcon=Ut,Ut.File=new Ut("file"),Ut.Folder=new Ut("folder");let Jt=class{constructor(W){this.id=W}};Jt=je([N],Jt),e.ThemeColor=Jt;var dt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(dt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let hn=class{get base(){return this._base}set base(W){this._base=W,this._baseUri=k.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}constructor(W,ue){if(typeof W!="string"&&(!W||!k.URI.isUri(W)&&!k.URI.isUri(W.uri)))throw(0,t.illegalArgument)("base");if(typeof ue!="string")throw(0,t.illegalArgument)("pattern");typeof W=="string"?this.baseUri=k.URI.file(W):k.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ue}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};hn=je([N],hn),e.RelativePattern=hn;let Nt=class{constructor(W,ue,Te,Xe){this.enabled=typeof W=="boolean"?W:!0,typeof ue=="string"&&(this.condition=ue),typeof Te=="string"&&(this.hitCondition=Te),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};Nt=je([N],Nt),e.Breakpoint=Nt;let Gt=class extends Nt{constructor(W,ue,Te,Xe,et){if(super(ue,Te,Xe,et),W===null)throw(0,t.illegalArgument)("location");this.location=W}};Gt=je([N],Gt),e.SourceBreakpoint=Gt;let rn=class extends Nt{constructor(W,ue,Te,Xe,et){super(ue,Te,Xe,et),this.functionName=W}};rn=je([N],rn),e.FunctionBreakpoint=rn;let fn=class extends Nt{constructor(W,ue,Te,Xe,et,ut,ht){if(super(Xe,et,ut,ht),!ue)throw(0,t.illegalArgument)("dataId");this.label=W,this.dataId=ue,this.canPersist=Te}};fn=je([N],fn),e.DataBreakpoint=fn;let sn=class{constructor(W,ue,Te){this.command=W,this.args=ue||[],this.options=Te}};sn=je([N],sn),e.DebugAdapterExecutable=sn;let mn=class{constructor(W,ue){this.port=W,this.host=ue}};mn=je([N],mn),e.DebugAdapterServer=mn;let on=class{constructor(W){this.path=W}};on=je([N],on),e.DebugAdapterNamedPipeServer=on;let Zt=class{constructor(W){this.implementation=W}};Zt=je([N],Zt),e.DebugAdapterInlineImplementation=Zt;let gn=class{constructor(W,ue){this.range=W,this.expression=ue}};gn=je([N],gn),e.EvaluatableExpression=gn;var pn;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(pn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var vn;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(vn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let bn=class{constructor(W,ue){this.range=W,this.text=ue}};bn=je([N],bn),e.InlineValueText=bn;let wn=class{constructor(W,ue,Te=!0){this.range=W,this.variableName=ue,this.caseSensitiveLookup=Te}};wn=je([N],wn),e.InlineValueVariableLookup=wn;let Kt=class{constructor(W,ue){this.range=W,this.expression=ue}};Kt=je([N],Kt),e.InlineValueEvaluatableExpression=Kt;let En=class{constructor(W,ue){this.frameId=W,this.stoppedLocation=ue}};En=je([N],En),e.InlineValueContext=En;var Fn;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Fn=e.FileChangeType||(e.FileChangeType={}));let Sn=A=class extends Error{static FileExists(W){return new A(W,C.FileSystemProviderErrorCode.FileExists,A.FileExists)}static FileNotFound(W){return new A(W,C.FileSystemProviderErrorCode.FileNotFound,A.FileNotFound)}static FileNotADirectory(W){return new A(W,C.FileSystemProviderErrorCode.FileNotADirectory,A.FileNotADirectory)}static FileIsADirectory(W){return new A(W,C.FileSystemProviderErrorCode.FileIsADirectory,A.FileIsADirectory)}static NoPermissions(W){return new A(W,C.FileSystemProviderErrorCode.NoPermissions,A.NoPermissions)}static Unavailable(W){return new A(W,C.FileSystemProviderErrorCode.Unavailable,A.Unavailable)}constructor(W,ue=C.FileSystemProviderErrorCode.Unknown,Te){super(k.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,C.markAsFileSystemProviderError)(this,ue),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Sn=A=je([N],Sn),e.FileSystemError=Sn;let _n=class{constructor(W,ue,Te){this.start=W,this.end=ue,this.kind=Te}};_n=je([N],_n),e.FoldingRange=_n;var yn;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(yn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Tn;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(Tn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Pn;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(Pn=e.CommentMode||(e.CommentMode={}));var $e;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})($e=e.CommentThreadState||(e.CommentThreadState={}));class xt{constructor(W,ue=[]){this.tokenTypes=W,this.tokenModifiers=ue}}e.SemanticTokensLegend=xt;function An(q){return typeof q>"u"||(0,w.isStringArray)(q)}class mt{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let ue=0,Te=W.tokenTypes.length;ue<Te;ue++)this._tokenTypeStrToInt.set(W.tokenTypes[ue],ue);for(let ue=0,Te=W.tokenModifiers.length;ue<Te;ue++)this._tokenModifierStrToInt.set(W.tokenModifiers[ue],ue)}}push(W,ue,Te,Xe,et){if(typeof W=="number"&&typeof ue=="number"&&typeof Te=="number"&&typeof Xe=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this._pushEncoded(W,ue,Te,Xe,et);if(F.isRange(W)&&typeof ue=="string"&&An(Te))return this._push(W,ue,Te);throw(0,t.illegalArgument)()}_push(W,ue,Te){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ue))throw new Error("`tokenType` is not in the provided legend");const Xe=W.start.line,et=W.start.character,ut=W.end.character-W.start.character,ht=this._tokenTypeStrToInt.get(ue);let Lt=0;if(Te)for(const Wt of Te){if(!this._tokenModifierStrToInt.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const Ht=this._tokenModifierStrToInt.get(Wt);Lt|=1<<Ht>>>0}this._pushEncoded(Xe,et,ut,ht,Lt)}_pushEncoded(W,ue,Te,Xe,et){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&ue<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Lt=this._data.length/5|0;let Wt=0,Ht=0;for(let jt=0;jt<Lt;jt++){let Qt=this._data[5*jt],In=this._data[5*jt+1];Qt===0?(Qt=Wt,In+=Ht):Qt+=Wt,this._data[5*jt]=Qt,this._data[5*jt+1]=In,Wt=Qt,Ht=In}}let ut=W,ht=ue;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Te,this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=et,this._prevLine=W,this._prevChar=ue}static _sortAndDeltaEncode(W){const ue=[],Te=W.length/5|0;for(let ht=0;ht<Te;ht++)ue[ht]=ht;ue.sort((ht,Lt)=>{const Wt=W[5*ht],Ht=W[5*Lt];if(Wt===Ht){const jt=W[5*ht+1],Qt=W[5*Lt+1];return jt-Qt}return Wt-Ht});const Xe=new Uint32Array(W.length);let et=0,ut=0;for(let ht=0;ht<Te;ht++){const Lt=5*ue[ht],Wt=W[Lt+0],Ht=W[Lt+1],jt=W[Lt+2],Qt=W[Lt+3],In=W[Lt+4],Jn=Wt-et,Di=Jn===0?Ht-ut:Ht,kn=5*ht;Xe[kn+0]=Jn,Xe[kn+1]=Di,Xe[kn+2]=jt,Xe[kn+3]=Qt,Xe[kn+4]=In,et=Wt,ut=Ht}return Xe}build(W){return this._dataIsSortedAndDeltaEncoded?new Cn(new Uint32Array(this._data),W):new Cn(mt._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=mt;class Cn{constructor(W,ue){this.resultId=ue,this.data=W}}e.SemanticTokens=Cn;class Mn{constructor(W,ue,Te){this.start=W,this.deleteCount=ue,this.data=Te}}e.SemanticTokensEdit=Mn;class Rn{constructor(W,ue){this.resultId=ue,this.edits=W}}e.SemanticTokensEdits=Rn;var Un;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Un=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new Ut("arrow-left")},Xt=je([N],Xt),e.QuickInputButtons=Xt;var Bn;(function(q){q[q.Separator=-1]="Separator",q[q.Default=0]="Default"})(Bn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var zn;(function(q){q[q.Info=1]="Info",q[q.Warning=2]="Warning",q[q.Error=3]="Error"})(zn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Wn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Wn=e.ExtensionKind||(e.ExtensionKind={}));class Ln{static validate(W){if(W.badge){let ue=(0,D.nextCharLength)(W.badge,0);if(ue<W.badge.length&&(ue+=(0,D.nextCharLength)(W.badge,ue)),W.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ue,Te){this.badge=W,this.tooltip=ue,this.color=Te}}e.FileDecoration=Ln;let Dn=class{constructor(W){this.kind=W}};Dn=je([N],Dn),e.ColorTheme=Dn;var $n;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast",q[q.HighContrastLight=4]="HighContrastLight"})($n=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{static isNotebookRange(W){return W instanceof Vt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(W,ue){if(W<0)throw(0,t.illegalArgument)("start must be positive");if(ue<0)throw(0,t.illegalArgument)("end must be positive");W<=ue?(this._start=W,this._end=ue):(this._start=ue,this._end=W)}with(W){let ue=this._start,Te=this._end;return W.start!==void 0&&(ue=W.start),W.end!==void 0&&(Te=W.end),ue===this._start&&Te===this._end?this:new Vt(ue,Te)}}e.NotebookRange=Vt;class an{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ue=>an.isNotebookCellData(ue))}static isNotebookCellData(W){return!0}constructor(W,ue,Te,Xe,et,ut,ht){this.kind=W,this.value=ue,this.languageId=Te,this.mime=Xe,this.outputs=et??[],this.metadata=ut,this.executionSummary=ht,an.validate(this)}}e.NotebookCellData=an;class Hn{constructor(W){this.cells=W}}e.NotebookData=Hn;class Bt{static isNotebookCellOutputItem(W){return W instanceof Bt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ue={name:W.name,message:W.message,stack:W.stack};return Bt.json(ue,"application/vnd.code.notebook.error")}static stdout(W){return Bt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Bt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ue="application/octet-stream"){return new Bt(W,ue)}static text(W,ue=y.Mimes.text){const Te=Be(Bt,v,"f",h).encode(String(W));return new Bt(Te,ue)}static json(W,ue="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return Bt.text(Te,ue)}constructor(W,ue){this.data=W,this.mime=ue;const Te=(0,y.normalizeMimeType)(ue,!0);if(!Te)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=Bt,v=Bt,h={value:new TextEncoder};class ve{static isNotebookCellOutput(W){return W instanceof ve?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ue=!1){const Te=new Set,Xe=new Set;for(let et=0;et<W.length;et++){const ut=W[et],ht=(0,y.normalizeMimeType)(ut.mime);if(!Te.has(ht)||(0,T.isTextStreamMime)(ht)){Te.add(ht);continue}Xe.add(et),ue&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Xe.size===0?W:W.filter((et,ut)=>!Xe.has(ut))}constructor(W,ue,Te){this.items=ve.ensureUniqueMimeTypes(W,!0),typeof ue=="string"?(this.id=ue,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=ue??Te)}}e.NotebookCellOutput=ve;var Se;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(Se=e.NotebookCellKind||(e.NotebookCellKind={}));var Ue;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(Ue=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ct;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ct=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Dt;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Dt=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Rt{constructor(W,ue){this.text=W,this.alignment=ue}}e.NotebookCellStatusBarItem=Rt;var ni;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(ni=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var ii;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred",q[q.Hidden=-1]="Hidden"})(ii=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ri{constructor(W,ue=[]){this.uri=W,this.provides=(0,l.asArray)(ue)}}e.NotebookRendererScript=ri;let xn=class{constructor(W,ue){this.label=W,this.timestamp=ue}};xn=je([N],xn),e.TimelineItem=xn;var si;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(si=e.ExtensionMode||(e.ExtensionMode={}));var oi;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ai;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(ai=e.StandardTokenType||(e.StandardTokenType={}));class ci{constructor(W,ue){this.ranges=W,this.wordPattern=ue}}e.LinkedEditingRanges=ci;class li{constructor(W,ue){this._port=W,this._autoForwardAction=ue}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=li;var ui;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(ui=e.TestResultState||(e.TestResultState={}));var di;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(di=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Vn=class{constructor(W=void 0,ue=void 0,Te=void 0){this.include=W,this.exclude=ue,this.profile=Te}};Vn=je([N],Vn),e.TestRunRequest=Vn;let jn=z=class{static diff(W,ue,Te){const Xe=new z(W);return Xe.expectedOutput=ue,Xe.actualOutput=Te,Xe}constructor(W){this.message=W}};jn=z=je([N],jn),e.TestMessage=jn;let qn=class{constructor(W){this.id=W}};qn=je([N],qn),e.TestTag=qn;let cn=class{constructor(W,ue){this.covered=W,this.total=ue}};cn=je([N],cn),e.CoveredCount=cn;let Gn=$=class{static fromDetails(W,ue){const Te=new cn(0,0),Xe=new cn(0,0),et=new cn(0,0);for(const ht of ue)if("branches"in ht){Te.total+=1,Te.covered+=ht.executionCount>0?1:0;for(const Lt of ht.branches)Xe.total+=1,Xe.covered+=Lt.executionCount>0?1:0}else et.total+=1,et.covered+=ht.executionCount>0?1:0;const ut=new $(W,Te,Xe.total>0?Xe:void 0,et.total>0?et:void 0);return ut.detailedCoverage=ue,ut}constructor(W,ue,Te,Xe){this.uri=W,this.statementCoverage=ue,this.branchCoverage=Te,this.functionCoverage=Xe}};Gn=$=je([N],Gn),e.FileCoverage=Gn;let Kn=class{constructor(W,ue,Te=[]){this.executionCount=W,this.location=ue,this.branches=Te}};Kn=je([N],Kn),e.StatementCoverage=Kn;let Xn=class{constructor(W,ue){this.executionCount=W,this.location=ue}};Xn=je([N],Xn),e.BranchCoverage=Xn;let Qn=class{constructor(W,ue){this.executionCount=W,this.location=ue}};Qn=je([N],Qn),e.FunctionCoverage=Qn;var hi;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fi;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(fi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mi;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(mi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gi{constructor(W,ue,Te,Xe,et,ut){this.kind=W,this.name=ue,this.detail=Te,this.uri=Xe,this.range=et,this.selectionRange=ut}}e.TypeHierarchyItem=gi;class pi{constructor(W){this.uri=W}}e.TextTabInput=pi;class vi{constructor(W,ue){this.original=W,this.modified=ue}}e.TextDiffTabInput=vi;class bi{constructor(W,ue,Te,Xe){this.base=W,this.input1=ue,this.input2=Te,this.result=Xe}}e.TextMergeTabInput=bi;class wi{constructor(W,ue){this.uri=W,this.viewType=ue}}e.CustomEditorTabInput=wi;class Ei{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Ei;class Si{constructor(W,ue){this.uri=W,this.notebookType=ue}}e.NotebookEditorTabInput=Si;class _i{constructor(W,ue,Te){this.original=W,this.modified=ue,this.notebookType=Te}}e.NotebookDiffEditorTabInput=_i;class yi{constructor(){}}e.TerminalEditorTabInput=yi;class Ci{constructor(W,ue){this.uri=W,this.inputBoxUri=ue}}e.InteractiveWindowInput=Ci}),define(Ce[132],De([1,0,48,14,8,159,101,7,17]),function(J,e,l,t,I,P,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function L(S,p){p?k.set(S,p):k.delete(S)}e.setWordDefinitionFor=L;function C(S){return k.get(S)}e.getWordDefinitionFor=C;class E extends P.MirrorTextModel{constructor(p,b,f,v,h,c,g,i){super(b,f,v,h),this._proxy=p,this._languageId=c,this._isDirty=g,this.notebook=i,this._isDisposed=!1}dispose(){(0,l.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(p){return(0,w.equals)(this._lines,p)}get document(){if(!this._document){const p=this;this._document={get uri(){return p._uri},get fileName(){return p._uri.fsPath},get isUntitled(){return p._uri.scheme===t.Schemas.untitled},get languageId(){return p._languageId},get version(){return p._versionId},get isClosed(){return p._isDisposed},get isDirty(){return p._isDirty},save(){return p._save()},getText(b){return b?p._getTextInRange(b):p.getText()},get eol(){return p._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return p._lines.length},lineAt(b){return p._lineAt(b)},offsetAt(b){return p._offsetAt(b)},positionAt(b){return p._positionAt(b)},validateRange(b){return p._validateRange(b)},validatePosition(b){return p._validatePosition(b)},getWordRangeAtPosition(b,f){return p._getWordRangeAtPosition(b,f)}}}return Object.freeze(this._document)}_acceptLanguageId(p){(0,l.ok)(!this._isDisposed),this._languageId=p}_acceptIsDirty(p){(0,l.ok)(!this._isDisposed),this._isDirty=p}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(p){const b=this._validateRange(p);if(b.isEmpty)return"";if(b.isSingleLine)return this._lines[b.start.line].substring(b.start.character,b.end.character);const f=this._eol,v=b.start.line,h=b.end.line,c=[];c.push(this._lines[v].substring(b.start.character));for(let g=v+1;g<h;g++)c.push(this._lines[g]);return c.push(this._lines[h].substring(0,b.end.character)),c.join(f)}_lineAt(p){let b;if(p instanceof D.Position?b=p.line:typeof p=="number"&&(b=p),typeof b!="number"||b<0||b>=this._lines.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new T(b,this._lines[b],b===this._lines.length-1)}_offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.line-1)+p.character}_positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(p),f=this._lines[b.index].length;return new D.Position(b.index,Math.min(b.remainder,f))}_validateRange(p){if(!(p instanceof D.Range))throw new Error("Invalid argument");const b=this._validatePosition(p.start),f=this._validatePosition(p.end);return b===p.start&&f===p.end?p:new D.Range(b.line,b.character,f.line,f.character)}_validatePosition(p){if(!(p instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return p.with(0,0);let{line:b,character:f}=p,v=!1;if(b<0)b=0,f=0,v=!0;else if(b>=this._lines.length)b=this._lines.length-1,f=this._lines[b].length,v=!0;else{const h=this._lines[b].length;f<0?(f=0,v=!0):f>h&&(f=h,v=!0)}return v?new D.Position(b,f):p}_getWordRangeAtPosition(p,b){const f=this._validatePosition(p);if(!b)b=C(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const v=(0,y.getWordAtText)(f.character+1,(0,y.ensureValidWordDefinition)(b),this._lines[f.line],0);if(v)return new D.Range(f.line,v.startColumn-1,f.line,v.endColumn-1)}}e.ExtHostDocumentData=E;class T{constructor(p,b,f){this._line=p,this._text=b,this._isLastLine=f}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(Ce[228],De([1,0,7,16,4]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(D){this._actual=new l.ColorTheme(l.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let w;switch(D){case"light":w=l.ColorThemeKind.Light;break;case"hcDark":w=l.ColorThemeKind.HighContrast;break;case"hcLight":w=l.ColorThemeKind.HighContrastLight;break;default:w=l.ColorThemeKind.Dark}this._actual=new l.ColorTheme(w),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=je([He(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(Ce[15],De([1,0,17,23,108,26,144,81,24,13,2,35,64,120,129,127,89,55,66,222,7,60]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f,v,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(Pe){function Oe(te){const{selectionStartLineNumber:Fe,selectionStartColumn:xe,positionLineNumber:nt,positionColumn:Ge}=te,rt=new c.Position(Fe-1,xe-1),pt=new c.Position(nt-1,Ge-1);return new c.Selection(rt,pt)}Pe.to=Oe;function _e(te){const{anchor:Fe,active:xe}=te;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:xe.line+1,positionColumn:xe.character+1}}Pe.from=_e})(i=e.Selection||(e.Selection={}));var u;(function(Pe){function Oe(te){if(!te)return;const{start:Fe,end:xe}=te;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:xe.line+1,endColumn:xe.character+1}}Pe.from=Oe;function _e(te){if(!te)return;const{startLineNumber:Fe,startColumn:xe,endLineNumber:nt,endColumn:Ge}=te;return new c.Range(Fe-1,xe-1,nt-1,Ge-1)}Pe.to=_e})(u=e.Range||(e.Range={}));var r;(function(Pe){function Oe(_e){switch(_e){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}Pe.to=Oe})(r=e.TokenType||(e.TokenType={}));var n;(function(Pe){function Oe(te){return new c.Position(te.lineNumber-1,te.column-1)}Pe.to=Oe;function _e(te){return{lineNumber:te.line+1,column:te.character+1}}Pe.from=_e})(n=e.Position||(e.Position={}));var o;(function(Pe){function Oe(Fe,xe){return(0,l.coalesce)((0,l.asArray)(Fe).map(nt=>_e(nt,xe)))}Pe.from=Oe;function _e(Fe,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:te(Fe.scheme,xe),pattern:Ee.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function te(Fe,xe){return xe&&typeof Fe=="string"?xe.transformOutgoingScheme(Fe):Fe}})(o=e.DocumentSelector||(e.DocumentSelector={}));var d;(function(Pe){function Oe(te){switch(te){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}Pe.from=Oe;function _e(te){switch(te){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}Pe.to=_e})(d=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(Pe){function Oe(te){let Fe;return te.code&&((0,k.isString)(te.code)||(0,k.isNumber)(te.code)?Fe=String(te.code):Fe={value:String(te.code.value),target:te.code.target}),{...u.from(te.range),message:te.message,source:te.source,code:Fe,severity:m.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(a.from),tags:Array.isArray(te.tags)?(0,l.coalesce)(te.tags.map(d.from)):void 0}}Pe.from=Oe;function _e(te){const Fe=new c.Diagnostic(u.to(te),te.message,m.to(te.severity));return Fe.source=te.source,Fe.code=(0,k.isString)(te.code)?te.code:te.code?.value,Fe.relatedInformation=te.relatedInformation&&te.relatedInformation.map(a.to),Fe.tags=te.tags&&(0,l.coalesce)(te.tags.map(d.to)),Fe}Pe.to=_e})(s=e.Diagnostic||(e.Diagnostic={}));var a;(function(Pe){function Oe(te){return{...u.from(te.location.range),message:te.message,resource:te.location.uri}}Pe.from=Oe;function _e(te){return new c.DiagnosticRelatedInformation(new c.Location(te.resource,u.to(te)),te.message)}Pe.to=_e})(a=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var m;(function(Pe){function Oe(te){switch(te){case c.DiagnosticSeverity.Error:return T.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return T.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return T.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return T.MarkerSeverity.Hint}return T.MarkerSeverity.Error}Pe.from=Oe;function _e(te){switch(te){case T.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case T.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case T.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case T.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}Pe.to=_e})(m=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var _;(function(Pe){function Oe(te){return typeof te=="number"&&te>=c.ViewColumn.One?te-1:te===c.ViewColumn.Beside?h.SIDE_GROUP:h.ACTIVE_GROUP}Pe.from=Oe;function _e(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=_e})(_=e.ViewColumn||(e.ViewColumn={}));function R(Pe){return typeof Pe.range<"u"}function M(Pe){return Pe.length===0?!0:!!R(Pe[0])}e.isDecorationOptionsArr=M;var U;(function(Pe){function Oe(Ge){return Ge.map(Pe.from)}Pe.fromMany=Oe;function _e(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function te(Ge){let rt;if(_e(Ge)){const{language:It,value:_t}=Ge;rt={value:"```"+It+`
`+_t+"\n```\n"}}else c.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const pt=Object.create(null);rt.uris=pt;const Et=It=>{try{let _t=L.URI.parse(It,!0);_t=_t.with({query:Fe(_t.query,pt)}),pt[It]=_t}catch{}return""},Tt=new y.marked.Renderer;return Tt.link=Et,Tt.image=It=>typeof It=="string"?Et(I.parseHrefAndDimensions(It).href):"",(0,y.marked)(rt.value,{renderer:Tt}),rt}Pe.from=te;function Fe(Ge,rt){if(!Ge)return Ge;let pt;try{pt=(0,D.parse)(Ge)}catch{}if(!pt)return Ge;let Et=!1;return pt=(0,w.cloneAndChange)(pt,Tt=>{if(L.URI.isUri(Tt)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[It]=Tt,Et=!0,It}else return}),Et?JSON.stringify(pt):Ge}function xe(Ge){const rt=new c.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt.supportHtml=Ge.supportHtml,rt.baseUri=Ge.baseUri?L.URI.from(Ge.baseUri):void 0,rt}Pe.to=xe;function nt(Ge){if(!!Ge)return typeof Ge=="string"?Ge:Pe.from(Ge)}Pe.fromStrict=nt})(U=e.MarkdownString||(e.MarkdownString={}));function A(Pe){return M(Pe)?Pe.map(Oe=>({range:u.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?U.fromMany(Oe.hoverMessage):Oe.hoverMessage?U.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Pe.map(Oe=>({range:u.from(Oe)}))}e.fromRangeOrRangeWithMessage=A;function z(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?L.URI.file(Pe):Pe}e.pathOrURIToURI=z;var $;(function(Pe){function Oe(_e){return typeof _e>"u"?_e:{contentText:_e.contentText,contentIconPath:_e.contentIconPath?z(_e.contentIconPath):void 0,border:_e.border,borderColor:_e.borderColor,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,color:_e.color,backgroundColor:_e.backgroundColor,margin:_e.margin,width:_e.width,height:_e.height}}Pe.from=Oe})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(Pe){function Oe(_e){return typeof _e>"u"?_e:{backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?z(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?$.from(_e.before):void 0,after:_e.after?$.from(_e.after):void 0}}Pe.from=Oe})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(Pe){function Oe(_e){if(typeof _e>"u")return _e;switch(_e){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Oe})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(Pe){function Oe(_e){return{isWholeLine:_e.isWholeLine,rangeBehavior:_e.rangeBehavior?V.from(_e.rangeBehavior):void 0,overviewRulerLane:_e.overviewRulerLane,light:_e.light?N.from(_e.light):void 0,dark:_e.dark?N.from(_e.dark):void 0,backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?z(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?$.from(_e.before):void 0,after:_e.after?$.from(_e.after):void 0}}Pe.from=Oe})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var F;(function(Pe){function Oe(te){return{text:te.newText,eol:te.newEol&&Ye.from(te.newEol),range:u.from(te.range)}}Pe.from=Oe;function _e(te){const Fe=new c.TextEdit(u.to(te.range),te.text);return Fe.newEol=typeof te.eol>"u"?void 0:Ye.to(te.eol),Fe}Pe.to=_e})(F=e.TextEdit||(e.TextEdit={}));var x;(function(Pe){function Oe(te,Fe){const xe={edits:[]};if(te instanceof c.WorkspaceEdit){const nt=new P.ResourceSet;for(const Ge of te._allEntries())Ge._type===1&&L.URI.isUri(Ge.to)&&Ge.from===void 0&&nt.add(Ge.to);for(const Ge of te._allEntries())Ge._type===1?xe.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contentsBase64:Ge.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ge.options.contents))},metadata:Ge.metadata}):Ge._type===2?xe.edits.push({resource:Ge.uri,textEdit:F.from(Ge.edit),versionId:nt.has(Ge.uri)?void 0:Fe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?xe.edits.push({resource:Ge.uri,textEdit:{range:u.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:nt.has(Ge.uri)?void 0:Fe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?xe.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&xe.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Je.from)}})}return xe}Pe.from=Oe;function _e(te){const Fe=new c.WorkspaceEdit;for(const xe of te.edits)xe.textEdit?Fe.replace(L.URI.revive(xe.resource),u.to(xe.textEdit.range),xe.textEdit.text):Fe.renameFile(L.URI.revive(xe.oldResource),L.URI.revive(xe.newResource),xe.options);return Fe}Pe.to=_e})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(Pe){const Oe=Object.create(null);Oe[c.SymbolKind.File]=0,Oe[c.SymbolKind.Module]=1,Oe[c.SymbolKind.Namespace]=2,Oe[c.SymbolKind.Package]=3,Oe[c.SymbolKind.Class]=4,Oe[c.SymbolKind.Method]=5,Oe[c.SymbolKind.Property]=6,Oe[c.SymbolKind.Field]=7,Oe[c.SymbolKind.Constructor]=8,Oe[c.SymbolKind.Enum]=9,Oe[c.SymbolKind.Interface]=10,Oe[c.SymbolKind.Function]=11,Oe[c.SymbolKind.Variable]=12,Oe[c.SymbolKind.Constant]=13,Oe[c.SymbolKind.String]=14,Oe[c.SymbolKind.Number]=15,Oe[c.SymbolKind.Boolean]=16,Oe[c.SymbolKind.Array]=17,Oe[c.SymbolKind.Object]=18,Oe[c.SymbolKind.Key]=19,Oe[c.SymbolKind.Null]=20,Oe[c.SymbolKind.EnumMember]=21,Oe[c.SymbolKind.Struct]=22,Oe[c.SymbolKind.Event]=23,Oe[c.SymbolKind.Operator]=24,Oe[c.SymbolKind.TypeParameter]=25;function _e(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Pe.from=_e;function te(Fe){for(const xe in Oe)if(Oe[xe]===Fe)return Number(xe);return c.SymbolKind.Property}Pe.to=te})(H=e.SymbolKind||(e.SymbolKind={}));var Q;(function(Pe){function Oe(te){switch(te){case c.SymbolTag.Deprecated:return 1}}Pe.from=Oe;function _e(te){switch(te){case 1:return c.SymbolTag.Deprecated}}Pe.to=_e})(Q=e.SymbolTag||(e.SymbolTag={}));var K;(function(Pe){function Oe(te){return{name:te.name,kind:H.from(te.kind),tags:te.tags&&te.tags.map(Q.from),containerName:te.containerName,location:me.from(te.location)}}Pe.from=Oe;function _e(te){const Fe=new c.SymbolInformation(te.name,H.to(te.kind),te.containerName,me.to(te.location));return Fe.tags=te.tags&&te.tags.map(Q.to),Fe}Pe.to=_e})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var de;(function(Pe){function Oe(te){const Fe={name:te.name||"!!MISSING: name!!",detail:te.detail,range:u.from(te.range),selectionRange:u.from(te.selectionRange),kind:H.from(te.kind),tags:te.tags?.map(Q.from)??[]};return te.children&&(Fe.children=te.children.map(Oe)),Fe}Pe.from=Oe;function _e(te){const Fe=new c.DocumentSymbol(te.name,te.detail,H.to(te.kind),u.to(te.range),u.to(te.selectionRange));return(0,l.isNonEmptyArray)(te.tags)&&(Fe.tags=te.tags.map(Q.to)),te.children&&(Fe.children=te.children.map(_e)),Fe}Pe.to=_e})(de=e.DocumentSymbol||(e.DocumentSymbol={}));var ee;(function(Pe){function Oe(te){const Fe=new c.CallHierarchyItem(H.to(te.kind),te.name,te.detail||"",L.URI.revive(te.uri),u.to(te.range),u.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Pe.to=Oe;function _e(te,Fe,xe){if(Fe=Fe??te._sessionId,xe=xe??te._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,name:te.name,detail:te.detail,kind:H.from(te.kind),uri:te.uri,range:u.from(te.range),selectionRange:u.from(te.selectionRange),tags:te.tags?.map(Q.from)}}Pe.from=_e})(ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var he;(function(Pe){function Oe(_e){return new c.CallHierarchyIncomingCall(ee.to(_e.from),_e.fromRanges.map(te=>u.to(te)))}Pe.to=Oe})(he=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Y;(function(Pe){function Oe(_e){return new c.CallHierarchyOutgoingCall(ee.to(_e.to),_e.fromRanges.map(te=>u.to(te)))}Pe.to=Oe})(Y=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var me;(function(Pe){function Oe(te){return{range:te.range&&u.from(te.range),uri:te.uri}}Pe.from=Oe;function _e(te){return new c.Location(L.URI.revive(te.uri),u.to(te.range))}Pe.to=_e})(me=e.location||(e.location={}));var be;(function(Pe){function Oe(te){const Fe=te,xe=te;return{originSelectionRange:Fe.originSelectionRange?u.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:xe.uri,range:u.from(Fe.targetRange?Fe.targetRange:xe.range),targetSelectionRange:Fe.targetSelectionRange?u.from(Fe.targetSelectionRange):void 0}}Pe.from=Oe;function _e(te){return{targetUri:L.URI.revive(te.uri),targetRange:u.to(te.range),targetSelectionRange:te.targetSelectionRange?u.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?u.to(te.originSelectionRange):void 0}}Pe.to=_e})(be=e.DefinitionLink||(e.DefinitionLink={}));var ke;(function(Pe){function Oe(te){return{range:u.from(te.range),contents:U.fromMany(te.contents)}}Pe.from=Oe;function _e(te){return new c.Hover(te.contents.map(U.to),u.to(te.range))}Pe.to=_e})(ke=e.Hover||(e.Hover={}));var Re;(function(Pe){function Oe(te){return{range:u.from(te.range),expression:te.expression}}Pe.from=Oe;function _e(te){return new c.EvaluatableExpression(u.to(te.range),te.expression)}Pe.to=_e})(Re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ze;(function(Pe){function Oe(te){if(te instanceof c.InlineValueText)return{type:"text",range:u.from(te.range),text:te.text};if(te instanceof c.InlineValueVariableLookup)return{type:"variable",range:u.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Oe;function _e(te){switch(te.type){case"text":return{range:u.to(te.range),text:te.text};case"variable":return{range:u.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:u.to(te.range),expression:te.expression}}}Pe.to=_e})(ze=e.InlineValue||(e.InlineValue={}));var oe;(function(Pe){function Oe(te){return{frameId:te.frameId,stoppedLocation:u.from(te.stoppedLocation)}}Pe.from=Oe;function _e(te){return new c.InlineValueContext(te.frameId,u.to(te.stoppedLocation))}Pe.to=_e})(oe=e.InlineValueContext||(e.InlineValueContext={}));var le;(function(Pe){function Oe(te){return{range:u.from(te.range),kind:te.kind}}Pe.from=Oe;function _e(te){return new c.DocumentHighlight(u.to(te.range),te.kind)}Pe.to=_e})(le=e.DocumentHighlight||(e.DocumentHighlight={}));var ge;(function(Pe){function Oe(_e){switch(_e){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}Pe.to=Oe})(ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(Pe){function Oe(_e){return{triggerKind:ge.to(_e.triggerKind),triggerCharacter:_e.triggerCharacter}}Pe.to=Oe})(Z=e.CompletionContext||(e.CompletionContext={}));var ae;(function(Pe){function Oe(te){switch(te){case c.CompletionItemTag.Deprecated:return 1}}Pe.from=Oe;function _e(te){switch(te){case 1:return c.CompletionItemTag.Deprecated}}Pe.to=_e})(ae=e.CompletionItemTag||(e.CompletionItemTag={}));var ne;(function(Pe){const Oe=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function _e(xe){return Oe.get(xe)??9}Pe.from=_e;const te=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Fe(xe){return te.get(xe)??c.CompletionItemKind.Property}Pe.to=Fe})(ne=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(Pe){function Oe(_e,te){const Fe=new c.CompletionItem(_e.label);return Fe.insertText=_e.insertText,Fe.kind=ne.to(_e.kind),Fe.tags=_e.tags?.map(ae.to),Fe.detail=_e.detail,Fe.documentation=I.isMarkdownString(_e.documentation)?U.to(_e.documentation):_e.documentation,Fe.sortText=_e.sortText,Fe.filterText=_e.filterText,Fe.preselect=_e.preselect,Fe.commitCharacters=_e.commitCharacters,C.Range.isIRange(_e.range)?Fe.range=u.to(_e.range):typeof _e.range=="object"&&(Fe.range={inserting:u.to(_e.range.insert),replacing:u.to(_e.range.replace)}),Fe.keepWhitespace=typeof _e.insertTextRules>"u"?!1:Boolean(_e.insertTextRules&1),typeof _e.insertTextRules<"u"&&_e.insertTextRules&4?Fe.insertText=new c.SnippetString(_e.insertText):(Fe.insertText=_e.insertText,Fe.textEdit=Fe.range instanceof c.Range?new c.TextEdit(Fe.range,Fe.insertText):void 0),_e.additionalTextEdits&&_e.additionalTextEdits.length>0&&(Fe.additionalTextEdits=_e.additionalTextEdits.map(xe=>F.to(xe))),Fe.command=te&&_e.command?te.fromInternal(_e.command):void 0,Fe}Pe.to=Oe})(ie=e.CompletionItem||(e.CompletionItem={}));var O;(function(Pe){function Oe(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:U.fromStrict(te.documentation)}}Pe.from=Oe;function _e(te){return{label:te.label,documentation:I.isMarkdownString(te.documentation)?U.to(te.documentation):te.documentation}}Pe.to=_e})(O=e.ParameterInformation||(e.ParameterInformation={}));var j;(function(Pe){function Oe(te){return{label:te.label,documentation:U.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(O.from):[],activeParameter:te.activeParameter}}Pe.from=Oe;function _e(te){return{label:te.label,documentation:I.isMarkdownString(te.documentation)?U.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(O.to):[],activeParameter:te.activeParameter}}Pe.to=_e})(j=e.SignatureInformation||(e.SignatureInformation={}));var G;(function(Pe){function Oe(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(j.from):[]}}Pe.from=Oe;function _e(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(j.to):[]}}Pe.to=_e})(G=e.SignatureHelp||(e.SignatureHelp={}));var X;(function(Pe){function Oe(_e,te){const Fe=new c.InlayHint(n.to(te.position),typeof te.label=="string"?te.label:te.label.map(pe.to.bind(void 0,_e)),te.kind&&we.to(te.kind));return Fe.textEdits=te.textEdits&&te.textEdits.map(F.to),Fe.tooltip=I.isMarkdownString(te.tooltip)?U.to(te.tooltip):te.tooltip,Fe.paddingLeft=te.paddingLeft,Fe.paddingRight=te.paddingRight,Fe}Pe.to=Oe})(X=e.InlayHint||(e.InlayHint={}));var pe;(function(Pe){function Oe(_e,te){const Fe=new c.InlayHintLabelPart(te.label);return Fe.tooltip=I.isMarkdownString(te.tooltip)?U.to(te.tooltip):te.tooltip,E.Command.is(te.command)&&(Fe.command=_e.fromInternal(te.command)),te.location&&(Fe.location=me.to(te.location)),Fe}Pe.to=Oe})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var we;(function(Pe){function Oe(te){return te}Pe.from=Oe;function _e(te){return te}Pe.to=_e})(we=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(Pe){function Oe(te){return{range:u.from(te.range),url:te.target,tooltip:te.tooltip}}Pe.from=Oe;function _e(te){let Fe;if(te.url)try{Fe=typeof te.url=="string"?L.URI.parse(te.url,!0):L.URI.revive(te.url)}catch{}return new c.DocumentLink(u.to(te.range),Fe)}Pe.to=_e})(ce=e.DocumentLink||(e.DocumentLink={}));var Ie;(function(Pe){function Oe(te){const Fe=new c.ColorPresentation(te.label);return te.textEdit&&(Fe.textEdit=F.to(te.textEdit)),te.additionalTextEdits&&(Fe.additionalTextEdits=te.additionalTextEdits.map(xe=>F.to(xe))),Fe}Pe.to=Oe;function _e(te){return{label:te.label,textEdit:te.textEdit?F.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Fe=>F.from(Fe)):void 0}}Pe.from=_e})(Ie=e.ColorPresentation||(e.ColorPresentation={}));var ye;(function(Pe){function Oe(te){return new c.Color(te[0],te[1],te[2],te[3])}Pe.to=Oe;function _e(te){return[te.red,te.green,te.blue,te.alpha]}Pe.from=_e})(ye=e.Color||(e.Color={}));var We;(function(Pe){function Oe(te){return{range:u.from(te.range)}}Pe.from=Oe;function _e(te){return new c.SelectionRange(u.to(te.range))}Pe.to=_e})(We=e.SelectionRange||(e.SelectionRange={}));var qe;(function(Pe){function Oe(_e){switch(_e){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}Pe.to=Oe})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ze;(function(Pe){function Oe(te){switch(te){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Oe;function _e(te){switch(te){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}Pe.to=_e})(Ze=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ye;(function(Pe){function Oe(te){if(te===c.EndOfLine.CRLF)return 1;if(te===c.EndOfLine.LF)return 0}Pe.from=Oe;function _e(te){if(te===1)return c.EndOfLine.CRLF;if(te===0)return c.EndOfLine.LF}Pe.to=_e})(Ye=e.EndOfLine||(e.EndOfLine={}));var Ne;(function(Pe){function Oe(_e){if(typeof _e=="object")return _e.viewId;switch(_e){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Oe})(Ne=e.ProgressLocation||(e.ProgressLocation={}));var at;(function(Pe){function Oe(_e){const te={start:_e.start+1,end:_e.end+1};return _e.kind&&(te.kind=re.from(_e.kind)),te}Pe.from=Oe})(at=e.FoldingRange||(e.FoldingRange={}));var re;(function(Pe){function Oe(_e){if(_e)switch(_e){case c.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}Pe.from=Oe})(re=e.FoldingRangeKind||(e.FoldingRangeKind={}));var se;(function(Pe){function Oe(_e){if(_e)return{pinned:typeof _e.preview=="boolean"?!_e.preview:void 0,inactive:_e.background,preserveFocus:_e.preserveFocus,selection:typeof _e.selection=="object"?u.from(_e.selection):void 0,override:typeof _e.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Pe.from=Oe})(se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ee;(function(Pe){function Oe(xe){return xe instanceof c.RelativePattern?xe.toJSON():typeof xe=="string"?xe:_e(xe)||te(xe)?new c.RelativePattern(xe.baseUri??xe.base,xe.pattern).toJSON():xe}Pe.from=Oe;function _e(xe){const nt=xe;return nt?L.URI.isUri(nt.baseUri)&&typeof nt.pattern=="string":!1}function te(xe){const nt=xe;return nt?typeof nt.base=="string"&&typeof nt.pattern=="string":!1}function Fe(xe){return typeof xe=="string"?xe:new c.RelativePattern(L.URI.revive(xe.baseUri),xe.pattern)}Pe.to=Fe})(Ee=e.GlobPattern||(e.GlobPattern={}));var Ve;(function(Pe){function Oe(_e){if(_e){if(Array.isArray(_e))return _e.map(Oe);if(typeof _e=="string")return _e;{const te=_e;return{language:te.language,scheme:te.scheme,pattern:Ee.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Pe.from=Oe})(Ve=e.LanguageSelector||(e.LanguageSelector={}));var fe;(function(Pe){function Oe(te){return{start:te.start,end:te.end}}Pe.from=Oe;function _e(te){return new c.NotebookRange(te.start,te.end)}Pe.to=_e})(fe=e.NotebookRange||(e.NotebookRange={}));var Ae;(function(Pe){function Oe(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Pe.to=Oe;function _e(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Pe.from=_e})(Ae=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Le;(function(Pe){function Oe(_e){if(_e===b.NotebookCellExecutionState.Unconfirmed)return c.NotebookCellExecutionState.Pending;if(_e===b.NotebookCellExecutionState.Pending)return;if(_e===b.NotebookCellExecutionState.Executing)return c.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${_e}`)}Pe.to=Oe})(Le=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Me;(function(Pe){function Oe(te){switch(te){case c.NotebookCellKind.Markup:return b.CellKind.Markup;case c.NotebookCellKind.Code:default:return b.CellKind.Code}}Pe.from=Oe;function _e(te){switch(te){case b.CellKind.Markup:return c.NotebookCellKind.Markup;case b.CellKind.Code:default:return c.NotebookCellKind.Code}}Pe.to=_e})(Me=e.NotebookCellKind||(e.NotebookCellKind={}));var Ke;(function(Pe){function Oe(te){const Fe={metadata:te.metadata??Object.create(null),cells:[]};for(const xe of te.cells)c.NotebookCellData.validate(xe),Fe.cells.push(Je.from(xe));return Fe}Pe.from=Oe;function _e(te){const Fe=new c.NotebookData(te.cells.map(Je.to));return(0,k.isEmptyObject)(te.metadata)||(Fe.metadata=te.metadata),Fe}Pe.to=_e})(Ke=e.NotebookData||(e.NotebookData={}));var Je;(function(Pe){function Oe(te){return{cellKind:Me.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Ae.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(ot.from):[]}}Pe.from=Oe;function _e(te){return new c.NotebookCellData(Me.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(ot.to):void 0,te.metadata,te.internalMetadata?Ae.to(te.internalMetadata):void 0)}Pe.to=_e})(Je=e.NotebookCellData||(e.NotebookCellData={}));var st;(function(Pe){function Oe(te){return{mime:te.mime,valueBytes:t.VSBuffer.wrap(te.data)}}Pe.from=Oe;function _e(te){return new c.NotebookCellOutputItem(te.valueBytes.buffer,te.mime)}Pe.to=_e})(st=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ot;(function(Pe){function Oe(te){return{outputId:te.id,items:te.items.map(st.from),metadata:te.metadata}}Pe.from=Oe;function _e(te){const Fe=te.items.map(st.to);return new c.NotebookCellOutput(Fe,te.outputId,te.metadata)}Pe.to=_e})(ot=e.NotebookCellOutput||(e.NotebookCellOutput={}));var it;(function(Pe){function Oe(Fe){return te(Fe)?{include:(0,k.withNullAsUndefined)(Ee.from(Fe.include)),exclude:(0,k.withNullAsUndefined)(Ee.from(Fe.exclude))}:(0,k.withNullAsUndefined)(Ee.from(Fe))}Pe.from=Oe;function _e(Fe){return te(Fe)?{include:Ee.to(Fe.include),exclude:Ee.to(Fe.exclude)}:Ee.to(Fe)}Pe.to=_e;function te(Fe){const xe=Fe;return xe?!(0,k.isUndefinedOrNull)(xe.include)&&!(0,k.isUndefinedOrNull)(xe.exclude):!1}})(it=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var lt;(function(Pe){function Oe(_e,te,Fe){const xe=typeof _e.command=="string"?{title:"",command:_e.command}:_e.command;return{alignment:_e.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(xe,Fe),text:_e.text,tooltip:_e.tooltip,accessibilityInformation:_e.accessibilityInformation,priority:_e.priority}}Pe.from=Oe})(lt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var vt;(function(Pe){function Oe(_e){return{transientOutputs:_e?.transientOutputs??!1,transientCellMetadata:_e?.transientCellMetadata??{},transientDocumentMetadata:_e?.transientDocumentMetadata??{},cellContentMetadata:_e?.cellContentMetadata??{}}}Pe.from=Oe})(vt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var wt;(function(Pe){function Oe(te){return{uri:te.uri,provides:te.provides}}Pe.from=Oe;function _e(te){return new c.NotebookRendererScript(L.URI.revive(te.uri),te.provides)}Pe.to=_e})(wt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(Pe){function Oe(te){return{message:U.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,location:te.location&&{range:u.from(te.location.range),uri:te.location.uri}}}Pe.from=Oe;function _e(te){const Fe=new c.TestMessage(typeof te.message=="string"?te.message:U.to(te.message));return Fe.actualOutput=te.actual,Fe.expectedOutput=te.expected,Fe.location=te.location?me.to(te.location):void 0,Fe}Pe.to=_e})(ft=e.TestMessage||(e.TestMessage={}));var St;(function(Pe){Pe.namespace=v.namespaceTestTag,Pe.denamespace=v.denamespaceTestTag})(St=e.TestTag||(e.TestTag={}));var Ft;(function(Pe){function Oe(te){const Fe=(0,S.getPrivateApiFor)(te).controllerId;return{extId:f.TestId.fromExtHostTestItem(te,Fe).toString(),label:te.label,uri:L.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(xe=>St.namespace(Fe,xe.id)),range:C.Range.lift(u.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&U.fromStrict(te.error)||null}}Pe.from=Oe;function _e(te){return{parent:void 0,error:void 0,id:f.TestId.fromString(te.extId).localId,label:te.label,uri:L.URI.revive(te.uri),tags:(te.tags||[]).map(Fe=>{const{tagId:xe}=St.denamespace(Fe);return new c.TestTag(xe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Pe.toPlain=_e})(Ft=e.TestItem||(e.TestItem={})),function(Pe){function Oe(te){return{id:te.id}}Pe.from=Oe;function _e(te){return new c.TestTag(te.id)}Pe.to=_e}(St=e.TestTag||(e.TestTag={}));var Mt;(function(Pe){const Oe=(te,Fe)=>{const xe=[];for(const[Ge,rt]of Fe)f.TestId.compare(rt.item.extId,Ge)===2&&(Fe.delete(Ge),xe.push(rt));const nt={...Ft.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(rt=>rt.type===0).map(ft.to)})),children:xe.map(Ge=>Oe(Ge,Fe))};for(const Ge of nt.children)Ge.parent=nt;return nt};function _e(te){const Fe=[],xe=new Map;for(const nt of te.items){xe.set(nt.item.extId,nt);const Ge=f.TestId.root(nt.item.extId);te.request.targets.some(rt=>rt.controllerId===Ge&&rt.testIds.includes(nt.item.extId))&&Fe.push(nt)}return{completedAt:te.completedAt,results:Fe.map(nt=>Oe(nt,xe))}}Pe.to=_e})(Mt=e.TestResults||(e.TestResults={}));var Qe;(function(Pe){function Oe(xe){return{covered:xe.covered,total:xe.covered}}function _e(xe){return"line"in xe?n.from(xe):u.from(xe)}function te(xe){return"branches"in xe?{count:xe.executionCount,location:_e(xe.location),type:1,branches:xe.branches.length?xe.branches.map(nt=>({count:nt.executionCount,location:nt.location&&_e(nt.location)})):void 0}:{type:0,count:xe.executionCount,location:_e(xe.location)}}Pe.fromDetailed=te;function Fe(xe){return{uri:xe.uri,statement:Oe(xe.statementCoverage),branch:xe.branchCoverage&&Oe(xe.branchCoverage),function:xe.functionCoverage&&Oe(xe.functionCoverage),details:xe.detailedCoverage?.map(te)}}Pe.fromFile=Fe})(Qe=e.TestCoverage||(e.TestCoverage={}));var zt;(function(Pe){function Oe(_e){switch(_e){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}Pe.to=Oe})(zt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ot;(function(Pe){function Oe(te){const Fe=new c.TypeHierarchyItem(H.to(te.kind),te.name,te.detail||"",L.URI.revive(te.uri),u.to(te.range),u.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Pe.to=Oe;function _e(te,Fe,xe){if(Fe=Fe??te._sessionId,xe=xe??te._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,kind:H.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:u.from(te.range),selectionRange:u.from(te.selectionRange),tags:te.tags?.map(Q.from)}}Pe.from=_e})(Ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Pt;(function(Pe){function Oe(_e){if(!!_e)return{value:_e.value,tooltip:_e.tooltip}}Pe.from=Oe})(Pt=e.ViewBadge||(e.ViewBadge={}));var gt;(function(Pe){function Oe(_e,te){const Fe=_e.fileData;return Fe?new class extends c.DataTransferItem{asFile(){return{name:Fe.name,uri:L.URI.revive(Fe.uri),data:(0,g.once)(()=>te())}}}("",_e.id):new c.DataTransferItem(_e.asString)}Pe.toDataTransferItem=Oe})(gt=e.DataTransferItem||(e.DataTransferItem={}));var kt;(function(Pe){function Oe(te,Fe){const xe=te.items.map(([nt,Ge])=>[nt,gt.toDataTransferItem(Ge,()=>Fe(Ge.id))]);return new c.DataTransfer(xe)}Pe.toDataTransfer=Oe;async function _e(te){const Fe={items:[]},xe=[];return te.forEach((nt,Ge)=>{xe.push((async()=>{const rt=await nt.asString(),pt=nt.asFile();Fe.items.push([Ge,{id:nt.id,asString:rt,fileData:pt?{name:pt.name,uri:pt.uri}:void 0}])})())}),await Promise.all(xe),Fe}Pe.toDataTransferDTO=_e})(kt=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[229],De([1,0,2,11,7,15,62]),function(J,e,l,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(k,L,C,E={timeout:1500,errors:3}){this._logService=k,this._documents=L,this._mainThreadBulkEdits=C,this._thresholds=E,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(L,C,E)=>{const S={dispose:this._callbacks.push([L,C,k])};return Array.isArray(E)&&E.push(S),S}}async $participateInSave(k,L){const C=l.URI.revive(k);let E=!1;const T=setTimeout(()=>E=!0,this._thresholds.timeout),S=[];try{for(const p of[...this._callbacks]){if(E)break;const b=this._documents.getDocument(C),f=await this._deliverEventAsyncAndBlameBadListeners(p,{document:b,reason:P.TextDocumentSaveReason.to(L)});S.push(f)}}finally{clearTimeout(T)}return S}_deliverEventAsyncAndBlameBadListeners([k,L,C],E){const T=this._badListeners.get(k);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,k,L,E).then(()=>!0,S=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const p=this._badListeners.get(k);this._badListeners.set(k,p?p+1:1),typeof p=="number"&&p>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,L,C,E){const T=[],S=Date.now(),{document:p,reason:b}=E,{version:f}=p,v=Object.freeze({document:p,reason:b,waitUntil(h){if(Object.isFrozen(T))throw(0,t.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(h))}});try{L.apply(C,[v])}catch(h){return Promise.reject(h)}return Object.freeze(T),new Promise((h,c)=>{const g=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(g),h(i)}).catch(i=>{clearTimeout(g),c(i)})}).then(h=>{const c={edits:[]};for(const g of h)if(Array.isArray(g)&&g.every(i=>i instanceof I.TextEdit))for(const{newText:i,newEol:u,range:r}of g)c.edits.push({resource:p.uri,versionId:void 0,textEdit:{range:r&&P.Range.from(r),text:i,eol:u&&P.EndOfLine.from(u)}});if(c.edits.length!==0)return f===p.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(Ce[230],De([1,0,14,2,15,7,89]),function(J,e,l,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(C,E,T,S){this.start=C,this.deletedCount=E,this.deletedItems=T,this.items=S}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class w{static asModelAddData(C,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,E,T){this.notebook=C,this._extHostDocument=E,this._cellData=T,this.handle=T.handle,this.uri=t.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(I.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const C=this,E=this._extHostDocument.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:I.NotebookCellKind.to(this._cellData.cellKind),document:E.document,get mime(){return C._mime},set mime(S){C._mime=S},get outputs(){return C._outputs.slice(0)},get metadata(){return C._metadata},get executionSummary(){return C._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(C){this._outputs=C.map(I.NotebookCellOutput.to)}setOutputItems(C,E,T){const S=T.map(I.NotebookCellOutputItem.to),p=this._outputs.find(b=>b.id===C);if(p&&(E||(p.items.length=0),p.items.push(...S),p.items.length>1&&p.items.every(b=>y.isTextStreamMime(b.mime)))){const b=new Map,f=[];p.items.forEach(v=>{let h;b.has(v.mime)?h=b.get(v.mime):(h=[],b.set(v.mime,h),f.push(v.mime)),h.push(v.data)}),p.items.length=0,f.forEach(v=>{const h=y.compressOutputItemStreams(b.get(v));p.items.push({mime:v,data:h.buffer})})}}setMetadata(C){this._metadata=Object.freeze(C)}setInternalMetadata(C){this._internalMetadata=C,this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.ExtHostCell=w;class k{constructor(C,E,T,S,p){this._proxy=C,this._textDocumentsAndEditors=E,this._textDocuments=T,this.uri=S,this.handle=k._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=p.viewType,this._metadata=Object.freeze(p.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,p.cells]],!0,void 0),this._versionId=p.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const C=this,E={get uri(){return C.uri},get version(){return C._versionId},get notebookType(){return C._notebookType},get isDirty(){return C._isDirty},get isUntitled(){return C.uri.scheme===l.Schemas.untitled},get isClosed(){return C._disposed},get metadata(){return C._metadata},get cellCount(){return C._cells.length},cellAt(T){return T=C._validateIndex(T),C._cells[T].apiCell},getCells(T){return(T?C._getCells(T):C._cells).map(p=>p.apiCell)},save(){return C._save()}};this._notebook=Object.freeze(E)}return this._notebook}acceptDocumentPropertiesChanged(C){C.metadata&&(this._metadata=Object.freeze({...this._metadata,...C.metadata}))}acceptDirty(C){this._isDirty=C}acceptModelChanged(C,E,T){this._versionId=C.versionId,this._isDirty=E,this.acceptDocumentPropertiesChanged({metadata:T});const S={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},p=[];for(const f of C.rawEvents)f.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1,S.contentChanges):f.kind===y.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx,S.contentChanges):f.kind===y.NotebookCellsChangeType.Output?(this._setCellOutputs(f.index,f.outputs),p.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===y.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems),p.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===y.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(f.index,f.language),p.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document})):f.kind===y.NotebookCellsChangeType.ChangeCellContent?p.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document}):f.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===y.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(f.index,f.metadata),p.push({cell:this._cells[f.index].apiCell,metadata:this._cells[f.index].apiCell.metadata})):f.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(f.index,f.internalMetadata),p.push({cell:this._cells[f.index].apiCell,executionSummary:this._cells[f.index].apiCell.executionSummary}));const b=new Map;for(let f=0;f<p.length;f++){const v=p[f],h=b.get(v.cell);if(h===void 0){const c=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});b.set(v.cell,c-1)}else S.cellChanges[h]={...S.cellChanges[h],...v}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}_validateIndex(C){return C=C|0,C<0?0:C>=this._cells.length?this._cells.length-1:C}_validateRange(C){let E=C.start|0,T=C.end|0;return E<0&&(E=0),T>this._cells.length&&(T=this._cells.length),C.with({start:E,end:T})}_getCells(C){C=this._validateRange(C);const E=[];for(let T=C.start;T<C.end;T++)E.push(this._cells[T]);return E}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(C,E,T){if(this._disposed)return;const S=[],p=[],b=[];if(C.reverse().forEach(f=>{const h=f[2].map(i=>{const u=new w(this,this._textDocumentsAndEditors,i);return E||p.push(w.asModelAddData(this.apiNotebook,i)),u}),c=new D(f[0],f[1],[],h),g=this._cells.splice(f[0],f[1],...h);for(const i of g)b.push(i.uri),c.deletedItems.push(i.apiCell);S.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:b}),T)for(const f of S)T.push(f.asApiEvent())}_moveCell(C,E,T){const S=this._cells.splice(C,1);this._cells.splice(E,0,...S);const p=[new D(C,1,S.map(b=>b.apiCell),[]),new D(E,0,[],S)];for(const b of p)T.push(b.asApiEvent())}_setCellOutputs(C,E){this._cells[C].setOutputs(E)}_setCellOutputItems(C,E,T,S){this._cells[C].setOutputItems(E,T,S)}_changeCellLanguage(C,E){const T=this._cells[C];T.apiCell.document.languageId!==E&&this._textDocuments.$acceptModelLanguageChanged(T.uri,E)}_changeCellMime(C,E){const T=this._cells[C];T.apiCell.mime=E}_changeCellMetadata(C,E){this._cells[C].setMetadata(E)}_changeCellInternalMetadata(C,E){this._cells[C].setInternalMetadata(E)}getCellFromApiCell(C){return this._cells.find(E=>E.apiCell===C)}getCellFromIndex(C){return this._cells[C]}getCell(C){return this._cells.find(E=>E.handle===C)}getCellIndex(C){return this._cells.indexOf(C)}}e.ExtHostNotebookDocument=k,k._handlePool=0}),define(Ce[133],De([1,0,11,15,7]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(D,w,k,L,C,E){this.id=D,this._proxy=w,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=C,this._visibleRanges=L,this._viewColumn=E}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get notebook(){return D.notebookData.apiNotebook},get selection(){return D._selections[0]},set selection(w){this.selections=[w]},get selections(){return D._selections},set selections(w){if(!Array.isArray(w)||!w.every(I.NotebookRange.isNotebookRange))throw(0,l.illegalArgument)("selections");D._selections=w,D._trySetSelections(w)},get visibleRanges(){return D._visibleRanges},revealRange(w,k){D._proxy.$tryRevealRange(D.id,t.NotebookRange.from(w),k??I.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(t.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(Ce[231],De([1,0,4,12,15]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(D,w){this._logService=D,this._notebooksAndEditors=w,this._onDidChangeNotebookEditorSelection=new l.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new l.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(D,w){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,w);const k=this._notebooksAndEditors.getEditorById(D);w.visibleRanges&&k._acceptVisibleRanges(w.visibleRanges.ranges.map(I.NotebookRange.to)),w.selections&&k._acceptSelections(w.selections.selections.map(I.NotebookRange.to)),w.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),w.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const w in D)this._notebooksAndEditors.getEditorById(w)._acceptViewColumn(I.ViewColumn.to(D[w]))}};P=je([He(0,t.ILogService)],P),e.ExtHostNotebookEditors=P}),define(Ce[232],De([1,0,15,122,172,21,59,11]),function(J,e,l,t,I,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class w{constructor(E){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=E}async withProgress(E,T,S){const p=this._handles++,{title:b,location:f,cancellable:v}=T,h={label:(0,I.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this._proxy.$startProgress(p,{location:l.ProgressLocation.from(f),title:b,source:h,cancellable:v},E.isUnderDevelopment?void 0:E.identifier.value).catch(D.onUnexpectedExternalError),this._withProgress(p,S,!!v)}_withProgress(E,T,S){let p;S&&(p=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(E,p));const b=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),p?.dispose()};let f;try{f=T(new L(this._proxy,E),S&&p?p.token:P.CancellationToken.None)}catch(v){throw b(E),v}return f.then(v=>b(E),v=>b(E)),f}$acceptProgressCanceled(E){const T=this._mapHandleToCancellationSource.get(E);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(E))}}e.ExtHostProgress=w;function k(C,E){return C.message=E.message,typeof E.increment=="number"&&(typeof C.increment=="number"?C.increment+=E.increment:C.increment=E.increment),C}class L extends t.Progress{constructor(E,T){super(S=>this.throttledReport(S)),this._proxy=E,this._handle=T}throttledReport(E){this._proxy.$progressReport(this._handle,E)}}je([(0,y.throttle)(100,(C,E)=>k(C,E),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(Ce[134],De([1,0,35,129,55,90,66,15,2]),function(J,e,l,t,I,P,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(h,c,g,i)=>{let u=c;return{enumerable:!0,configurable:!1,get(){return u},set(r){if(!g(u,r)){const n=u;u=r,h.listener?.(i(r,n))}}}},L=(h,c)=>h===c,C={range:(h,c)=>h===c?!0:!h||!c?!1:h.isEqual(c),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(h,c)=>!(h.length!==c.length||h.some(g=>!c.find(i=>g.id===i.id)))},E=h=>c=>({op:4,update:h(c)}),T=(h,c)=>({range:(()=>{let g;const i=E(u=>({range:l.Range.lift(D.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return g},set(u){h.listener?.({op:6}),C.range(g,u)||(g=u,h.listener?.(i(u)))}}})(),label:k(h,c,C.label,E(g=>({label:g}))),description:k(h,void 0,C.description,E(g=>({description:g}))),sortText:k(h,void 0,C.sortText,E(g=>({sortText:g}))),canResolveChildren:k(h,!1,C.canResolveChildren,g=>({op:2,state:g})),busy:k(h,!1,C.busy,E(g=>({busy:g}))),error:k(h,void 0,C.error,E(g=>({error:D.MarkdownString.fromStrict(g)||null}))),tags:k(h,[],C.tags,(g,i)=>({op:1,new:g.map(D.TestTag.from),old:i.map(D.TestTag.from)}))}),S=h=>{const c=I.TestId.fromString(h.extId),g=new b(c.controllerId,c.localId,h.label,w.URI.revive(h.uri)||void 0);return g.range=D.Range.to(h.range||void 0),g.description=h.description||void 0,g.sortText=h.sortText||void 0,g.tags=h.tags.map(i=>D.TestTag.to({id:(0,y.denamespaceTestTag)(i).tagId})),g},p=h=>{let c;for(const g of h.tests){const i=S(g.item);(0,t.getPrivateApiFor)(i).parent=c,c=i}return c};e.toItemFromContext=p;class b{constructor(c,g,i,u){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const r=(0,t.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof f?void 0:r.parent}},children:{value:(0,P.createTestItemChildren)(r,t.getPrivateApiFor,b),enumerable:!0,writable:!1},...T(r,i)})}}e.TestItemImpl=b;class f extends b{constructor(c,g){super(c,c,g,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class v extends P.TestItemCollection{constructor(c,g,i){super({controllerId:c,getDocumentVersion:u=>u&&i.getDocument(u)?.version,getApiFor:t.getPrivateApiFor,getChildren:u=>u.children,root:new f(c,g),toITestItem:D.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(Ce[135],De([1,0,48,11,96,15,7]),function(J,e,l,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(E,T,S){const p=D._Keys.nextId();E.$registerTextEditorDecorationType(T.identifier,p,P.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:p,dispose(){E.$removeTextEditorDecorationType(p)}})}}e.TextEditorDecorationType=D,D._Keys=new I.IdGenerator("TextEditorDecorationType");class w{constructor(E,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=E,this._documentVersionId=E.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(E,T){this._throwIfFinalized();let S=null;if(E instanceof y.Position)S=new y.Range(E,E);else if(E instanceof y.Range)S=E;else throw new Error("Unrecognized location");this._pushEdit(S,T,!1)}insert(E,T){this._throwIfFinalized(),this._pushEdit(new y.Range(E,E),T,!0)}delete(E){this._throwIfFinalized();let T=null;if(E instanceof y.Range)T=E;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(E,T,S){const p=this._document.validateRange(E);this._collectedEdits.push({range:p,text:T,forceMoveMarkers:S})}setEndOfLine(E){if(this._throwIfFinalized(),E!==y.EndOfLine.LF&&E!==y.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=E}}e.TextEditorEdit=w;class k{constructor(E,T,S,p){this._proxy=E,this._id=T,this._accept(S),this._logService=p;const b=this;this.value={get tabSize(){return b._tabSize},set tabSize(f){b._setTabSize(f)},get insertSpaces(){return b._insertSpaces},set insertSpaces(f){b._setInsertSpaces(f)},get cursorStyle(){return b._cursorStyle},set cursorStyle(f){b._setCursorStyle(f)},get lineNumbers(){return b._lineNumbers},set lineNumbers(f){b._setLineNumbers(f)}}}_accept(E){this._tabSize=E.tabSize,this._insertSpaces=E.insertSpaces,this._cursorStyle=E.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(E.lineNumbers)}_validateTabSize(E){if(E==="auto")return"auto";if(typeof E=="number"){const T=Math.floor(E);return T>0?T:null}if(typeof E=="string"){const T=parseInt(E,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(E){const T=this._validateTabSize(E);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(E){return E==="auto"?"auto":E==="false"?!1:Boolean(E)}_setInsertSpaces(E){const T=this._validateInsertSpaces(E);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(E){this._cursorStyle!==E&&(this._cursorStyle=E,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:E})))}_setLineNumbers(E){this._lineNumbers!==E&&(this._lineNumbers=E,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(E)})))}assign(E){const T={};let S=!1;if(typeof E.tabSize<"u"){const p=this._validateTabSize(E.tabSize);p==="auto"?(S=!0,T.tabSize=p):typeof p=="number"&&this._tabSize!==p&&(this._tabSize=p,S=!0,T.tabSize=p)}if(typeof E.insertSpaces<"u"){const p=this._validateInsertSpaces(E.insertSpaces);p==="auto"?(S=!0,T.insertSpaces=p):this._insertSpaces!==p&&(this._insertSpaces=p,S=!0,T.insertSpaces=p)}typeof E.cursorStyle<"u"&&this._cursorStyle!==E.cursorStyle&&(this._cursorStyle=E.cursorStyle,S=!0,T.cursorStyle=E.cursorStyle),typeof E.lineNumbers<"u"&&this._lineNumbers!==E.lineNumbers&&(this._lineNumbers=E.lineNumbers,S=!0,T.lineNumbers=P.TextEditorLineNumbersStyle.from(E.lineNumbers)),S&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(E,T){T.catch(S=>{this._logService.warn(`ExtHostTextEditorOptions '${E}' failed:'`),this._logService.warn(S)})}}e.ExtHostTextEditorOptions=k;class L{constructor(E,T,S,p,b,f,v,h){this.id=E,this._proxy=T,this._logService=S,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=b,this._options=new k(this._proxy,this.id,f,S),this._visibleRanges=v,this._viewColumn=h;const c=this;this.value=Object.freeze({get document(){return p.getValue()},set document(g){throw(0,t.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(g){if(!(g instanceof y.Selection))throw(0,t.illegalArgument)("selection");c._selections=[g],c._trySetSelection()},get selections(){return c._selections},set selections(g){if(!Array.isArray(g)||g.some(i=>!(i instanceof y.Selection)))throw(0,t.illegalArgument)("selections");c._selections=g,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(g){throw(0,t.readonly)("visibleRanges")},get options(){return c._options.value},set options(g){c._disposed||c._options.assign(g)},get viewColumn(){return c._viewColumn},set viewColumn(g){throw(0,t.readonly)("viewColumn")},edit(g,i={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new w(p.getValue(),i);return g(u),c._applyEdit(u)},insertSnippet(g,i,u={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=c._selections.map(n=>P.Range.from(n));else if(i instanceof y.Position){const{lineNumber:n,column:o}=P.Position.from(i);r=[{startLineNumber:n,startColumn:o,endLineNumber:n,endColumn:o}]}else if(i instanceof y.Range)r=[P.Range.from(i)];else{r=[];for(const n of i)if(n instanceof y.Range)r.push(P.Range.from(n));else{const{lineNumber:o,column:d}=P.Position.from(n);r.push({startLineNumber:o,startColumn:d,endLineNumber:o,endColumn:d})}}return T.$tryInsertSnippet(E,p.getValue().version,g.value,r,u)},setDecorations(g,i){const u=i.length===0;u&&!c._hasDecorationsForKey.has(g.key)||(u?c._hasDecorationsForKey.delete(g.key):c._hasDecorationsForKey.add(g.key),c._runOnProxy(()=>{if(P.isDecorationOptionsArr(i))return T.$trySetDecorations(E,g.key,P.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let n=0,o=i.length;n<o;n++){const d=i[n];r[4*n]=d.start.line+1,r[4*n+1]=d.start.character+1,r[4*n+2]=d.end.line+1,r[4*n+3]=d.end.character+1}return T.$trySetDecorationsFast(E,g.key,r)}}))},revealRange(g,i){c._runOnProxy(()=>T.$tryRevealRange(E,P.Range.from(g),i||y.TextEditorRevealType.Default))},show(g){T.$tryShowEditor(E,P.ViewColumn.from(g))},hide(){T.$tryHideEditor(E)}})}dispose(){(0,l.ok)(!this._disposed),this._disposed=!0}_acceptOptions(E){(0,l.ok)(!this._disposed),this._options._accept(E)}_acceptVisibleRanges(E){(0,l.ok)(!this._disposed),this._visibleRanges=E}_acceptViewColumn(E){(0,l.ok)(!this._disposed),this._viewColumn=E}_acceptSelections(E){(0,l.ok)(!this._disposed),this._selections=E}async _trySetSelection(){const E=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,E)),this.value}_applyEdit(E){const T=E.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const S=T.edits.map(b=>b.range);S.sort((b,f)=>b.end.line===f.end.line?b.end.character===f.end.character?b.start.line===f.start.line?b.start.character-f.start.character:b.start.line-f.start.line:b.end.character-f.end.character:b.end.line-f.end.line);for(let b=0,f=S.length-1;b<f;b++){const v=S[b].end;if(S[b+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=T.edits.map(b=>({range:P.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,p,{setEndOfLine:typeof T.setEndOfLine=="number"?P.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(E){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):E().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=L}),define(Ce[233],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[234],De([1,0,186,11,42,119,123,43,27,233,197]),function(J,e,l,t,I,P,y,D,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const C=D.Registry.as(y.Extensions.JSONContribution);class E{constructor(c,g,i){this._messageHandler=c,this._extension=g,this._extensionPointId=i}_msg(c,g){this._messageHandler({type:c,message:g,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(c){this._msg(I.default.Error,c)}warn(c){this._msg(I.default.Warning,c)}info(c){this._msg(I.default.Info,c)}}e.ExtensionMessageCollector=E;class T{static _toSet(c){const g=new Set;for(let i=0,u=c.length;i<u;i++)g.add(w.ExtensionIdentifier.toKey(c[i].description.identifier));return g}static compute(c,g){if(!c||!c.length)return new T(g,[]);if(!g||!g.length)return new T([],c);const i=this._toSet(c),u=this._toSet(g),r=g.filter(o=>!i.has(w.ExtensionIdentifier.toKey(o.description.identifier))),n=c.filter(o=>!u.has(w.ExtensionIdentifier.toKey(o.description.identifier)));return new T(r,n)}constructor(c,g){this.added=c,this.removed=g}}e.ExtensionPointUserDelta=T;class S{constructor(c,g){this.name=c,this.defaultExtensionKind=g,this._handler=null,this._users=null,this._delta=null}setHandler(c){if(this._handler!==null)throw new Error("Handler already set!");this._handler=c,this._handle()}acceptUsers(c){this._delta=T.compute(this._users,c),this._users=c,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(c){(0,t.onUnexpectedError)(c)}}}e.ExtensionPoint=S;const p={type:"string",enum:["ui","workspace"],enumDescriptions:[l.localize(0,null),l.localize(1,null)]},b="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:l.localize(2,null),properties:{vscode:{type:"string",description:l.localize(3,null),default:"^1.22.0"}}},publisher:{description:l.localize(4,null),type:"string"},displayName:{description:l.localize(5,null),type:"string"},categories:{description:l.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:w.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:l.localize(7,null)}]}},galleryBanner:{type:"object",description:l.localize(8,null),properties:{color:{description:l.localize(9,null),type:"string"},theme:{description:l.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:l.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:l.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:l.localize(13,null)},enabledApiProposals:{markdownDescription:l.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},activationEvents:{description:l.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:l.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:l.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:l.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:l.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:l.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:l.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:l.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:l.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:l.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:l.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:l.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:l.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:l.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:l.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:l.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:l.localize(31,null)},{label:"onUri",body:"onUri",description:l.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:l.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:l.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:l.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:l.localize(36,null)},{label:"onRenderer",description:l.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:l.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:l.localize(39,null)},{label:"*",description:l.localize(40,null),body:"*"}]}},badges:{type:"array",description:l.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:l.localize(42,null)},href:{type:"string",description:l.localize(43,null)},description:{type:"string",description:l.localize(44,null)}}}},markdown:{type:"string",description:l.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:l.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:l.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:l.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:l.localize(49,null),type:"array",items:p,default:["workspace"],defaultSnippets:[{body:["ui"],description:l.localize(50,null)},{body:["workspace"],description:l.localize(51,null)},{body:["ui","workspace"],description:l.localize(52,null)},{body:["workspace","ui"],description:l.localize(53,null)},{body:[],description:l.localize(54,null)}]},capabilities:{description:l.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:l.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:l.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(58,null),l.localize(59,null),l.localize(60,null)]},description:{type:"string",markdownDescription:l.localize(61,null)}}},untrustedWorkspaces:{description:l.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:l.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(64,null),l.localize(65,null),l.localize(66,null)]},restrictedConfigurations:{description:l.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:l.localize(68,null)}}}}},sponsor:{description:l.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:l.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:l.localize(71,null),type:"string"},"vscode:uninstall":{description:l.localize(72,null),type:"string"}}},icon:{type:"string",description:l.localize(73,null)},l10n:{type:"string",description:l.localize(74,null)}}};class f{constructor(){this._extensionPoints=new Map}registerExtensionPoint(c){if(this._extensionPoints.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const g=new S(c.extensionPoint,c.defaultExtensionKind);return this._extensionPoints.set(c.extensionPoint,g),e.schema.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,C.registerSchema(b,e.schema),g}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=f;const v={ExtensionsRegistry:"ExtensionsRegistry"};D.Registry.add(v.ExtensionsRegistry,new f),e.ExtensionsRegistry=D.Registry.as(v.ExtensionsRegistry),C.registerSchema(b,e.schema),C.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:l.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ce[235],De([1,0,183,13,24,234,52,4]),function(J,e,l,t,I,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const w={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:l.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:l.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:l.localize(2,null),default:""}}};var k;(function(E){function T(S,p,b){if(!S)return;const f=t.isString(S.type)?S.type:void 0;if(!f||f.length===0){b.error(l.localize(3,null));return}const v=[];if(Array.isArray(S.required))for(const h of S.required)t.isString(h)&&v.push(h);return{extensionId:p.value,taskType:f,required:v,properties:S.properties?I.deepClone(S.properties):{},when:S.when?y.ContextKeyExpr.deserialize(S.when):void 0}}E.from=T})(k||(k={}));const L=P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:l.localize(4,null),type:"array",items:w}});class C{constructor(){this._onDefinitionsChanged=new D.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,S)=>{L.setHandler((p,b)=>{this._schema=void 0;try{for(const f of b.removed){const v=f.value;for(const h of v)this.taskTypes&&h.type&&this.taskTypes[h.type]&&delete this.taskTypes[h.type]}for(const f of b.added){const v=f.value;for(const h of v){const c=k.from(h,f.description.identifier,f.collector);c&&(this.taskTypes[c.taskType]=c)}}(b.removed.length>0||b.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const S of this.all()){const p={type:"object",additionalProperties:!1};S.required.length>0&&(p.required=S.required.slice(0)),S.properties!==void 0?p.properties=I.deepClone(S.properties):p.properties=Object.create(null),p.properties.type={type:"string",enum:[S.taskType]},T.push(p)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistryImpl=C,e.TaskDefinitionRegistry=new C}),define(Ce[236],De([1,0,184,13,22,24,52,235]),function(J,e,l,t,I,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new y.RawContextKey("taskRunning",!1,l.localize(0,null)),e.TASKS_CATEGORY={value:l.localize(1,null),original:"Tasks"};var w;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(w=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function V(B){if(!B)return N.Strong;switch(B.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=V}(w=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var L;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(N){function V(B){switch(B.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=V}(L=e.RevealKind||(e.RevealKind={}));var C;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(C=e.RevealProblemKind||(e.RevealProblemKind={})),function(N){function V(B){switch(B.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=V}(C=e.RevealProblemKind||(e.RevealProblemKind={}));var E;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(E=e.PanelKind||(e.PanelKind={})),function(N){function V(B){switch(B.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=V}(E=e.PanelKind||(e.PanelKind={}));var T;(function(N){N.defaults={echo:!0,reveal:L.Always,revealProblems:C.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var S;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(S=e.RuntimeType||(e.RuntimeType={})),function(N){function V(F){switch(F.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=V;function B(F){switch(F){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=B}(S=e.RuntimeType||(e.RuntimeType={}));var p;(function(N){function V(B){return t.isString(B)?B:B.value}N.value=V})(p=e.CommandString||(e.CommandString={}));var b;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function V(F){return F===N.Clean._id||F===N.Build._id||F===N.Rebuild._id||F===N.Test._id}N.is=V;function B(F){if(F!==void 0)return t.isString(F)?V(F)?{_id:F,isDefault:!1}:void 0:F}N.from=B})(b=e.TaskGroup||(e.TaskGroup={}));var f;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var v;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function V(B){switch(B){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=V})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var h;(function(N){N.parallel="parallel",N.sequence="sequence"})(h=e.DependsOrder||(e.DependsOrder={}));var c;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(c=e.RunOnOptions||(e.RunOnOptions={}));var g;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(g=e.RunOptions||(e.RunOptions={}));class i{constructor(V,B,F,x,H,Q){this._label="",this._id=V,B&&(this._label=B),F&&(this.type=F),this.runOptions=x,this.configurationProperties=H,this._source=Q}getDefinition(V){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const V={folder:this.getFolderId(),id:this._id};return JSON.stringify(V)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(V,B=!1){if(V===void 0)return!1;if(t.isString(V))return V===this._label||V===this.configurationProperties.identifier||B&&V===this._id;const F=this.getDefinition(!0);return F!==void 0&&F._key===V._key}getQualifiedLabel(){const V=this.getWorkspaceFolder();return V?`${this._label} (${V.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(V){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),V&&(this._taskLoadMessages=this._taskLoadMessages.concat(V))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=i;class u extends i{constructor(V,B,F,x,H,Q,K,de){super(V,F,void 0,K,de,B),this.command={},this._source=B,this.hasDefinedMatchers=Q,H&&(this.command=H)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(V=!1){if(V&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case S.Shell:B="shell";break;case S.Process:B="process";break;case S.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(V){return V instanceof u}getMapKey(){const V=this._source.config.workspaceFolder;return V?`${V.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const V=this.getFolderId();if(!V)return;let B=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(B+=this._source.kind);const F={type:e.CUSTOMIZED_TASK_TYPE,folder:V,id:B};return JSON.stringify(F)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(V){return new u(V._id,V._source,V._label,V.type,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.CustomTask=u;class r extends i{constructor(V,B,F,x,H,Q,K){super(V,F,x,Q,K,B),this._source=B,this.configures=H}static is(V){return V instanceof r}fromObject(V){return V}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const V=this.getFolderId();if(!V)return;let B=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(B+=this._source.kind);const F={type:e.CUSTOMIZED_TASK_TYPE,folder:V,id:B};return JSON.stringify(F)}}e.ConfiguringTask=r;class n extends i{constructor(V,B,F,x,H,Q,K,de,ee){super(V,F,x,de,ee,B),this.defines=H,this.hasDefinedMatchers=K,this.command=Q,this.icon=ee.icon,this.hide=ee.hide}clone(){return new n(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(V){return V instanceof n}getMapKey(){const V=this._source.workspaceFolder;return V?`${this._source.scope.toString()}|${V.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const V={type:"contributed",scope:this._source.scope,id:this._id};return V.folder=this.getFolderId(),JSON.stringify(V)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(V){return new n(V._id,V._source,V._label,V.type,V.defines,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.ContributedTask=n;class o extends i{constructor(V,B,F,x,H,Q){super(V,F,x,H,Q,B),this._source=B}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(V){return V instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(V){return new o(V._id,V._source,V._label,V.type,V.runOptions,V.configurationProperties)}}e.InMemoryTask=o;var d;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(d=e.ExecutionEngine||(e.ExecutionEngine={})),function(N){N._default=N.Terminal}(d=e.ExecutionEngine||(e.ExecutionEngine={}));var s;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(s=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class a{constructor(V){this._order=new Map;for(let B=0;B<V.length;B++)this._order.set(V[B].uri.toString(),B)}compare(V,B){const F=V.getWorkspaceFolder(),x=B.getWorkspaceFolder();if(F&&x){let H=this._order.get(F.uri.toString());H=H===void 0?0:H+1;let Q=this._order.get(x.uri.toString());return Q=Q===void 0?0:Q+1,H===Q?V._label.localeCompare(B._label):H-Q}else return!F&&x?-1:F&&!x?1:0}}e.TaskSorter=a;var m;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(m=e.TaskEventKind||(e.TaskEventKind={}));var _;(function(N){N.SingleRun="singleRun",N.Background="background"})(_=e.TaskRunType||(e.TaskRunType={}));var R;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(R=e.TaskRunSource||(e.TaskRunSource={}));var M;(function(N){function V(B,F,x,H,Q){if(F){const K={kind:B,taskId:F._id,taskName:F.configurationProperties.name,runType:F.configurationProperties.isBackground?"background":"singleRun",group:F.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:F};return B==="start"?(K.terminalId=x,K.resolvedVariables=H):B==="processStarted"?K.processId=x:B==="processEnded"&&(K.exitCode=x),Object.freeze(K)}else return Object.freeze({kind:"changed"})}N.create=V})(M=e.TaskEvent||(e.TaskEvent={}));var U;(function(N){function V(F){const x=Object.keys(F).sort();let H="";for(const Q of x){let K=F[Q];K instanceof Object?K=V(K):typeof K=="string"&&(K=K.replace(/,/g,",,")),H+=Q+","+K+","}return H}function B(F){const H={_key:V(F),type:F.taskType};return Object.assign(H,F),H}N.create=B})(U=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var A;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(A=e.TaskSettingId||(e.TaskSettingId={}));var z;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(z=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var $;(function(N){function V(B,F){const x=D.TaskDefinitionRegistry.get(B.type);if(x===void 0){const de=P.deepClone(B);return delete de._key,U.create(de)}const H=Object.create(null);H.type=x.taskType;const Q=new Set;x.required.forEach(de=>Q.add(de));const K=x.properties;for(const de of Object.keys(K)){const ee=B[de];if(ee!=null)H[de]=ee;else if(Q.has(de)){const he=K[de];if(he.default!==void 0)H[de]=P.deepClone(he.default);else switch(he.type){case"boolean":H[de]=!1;break;case"number":case"integer":H[de]=0;break;case"string":H[de]="";break;default:F.error(l.localize(2,null,JSON.stringify(B,void 0,0),de));return}}}return U.create(H)}N.createTaskIdentifier=V})($=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[237],De([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,D)=>{this._actualOk=y,this._actualErr=D,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,l.onUnexpectedError)(y))}then(y,D){return this._ensureActual().then(y,D)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=t;class I extends t{constructor(){super(),this._hasErr=!0,this._err=new l.CancellationError}}e.CanceledLazyPromise=I}),define(Ce[56],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class l{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++l.count}}e.ProxyIdentifier=l,l.count=0;const t=[];function I(D){const w=new l(D);return t[w.nid]=w,w}e.createProxyIdentifier=I;function P(D){return t[D].sid}e.getStringIdentifierForProxy=P;class y{constructor(w){this.value=w}}e.SerializableObjectWithBuffers=y}),define(Ce[5],De([1,0,56]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(I=e.TabInputKind||(e.TabInputKind={}));var P;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(P=e.TabModelOperationKind||(e.TabModelOperationKind={}));var y;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var w;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(w=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class C{static mixin(b){return b._id=C._n++,b}}e.IdObject=C,C._n=0;var E;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.command="m",p.kindModifier="n"})(E=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var T;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(T=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,l.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,l.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,l.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,l.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,l.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,l.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,l.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,l.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,l.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,l.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,l.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,l.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,l.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,l.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,l.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,l.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,l.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,l.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,l.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,l.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,l.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,l.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,l.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,l.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,l.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,l.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,l.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,l.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,l.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,l.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,l.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,l.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,l.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,l.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,l.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,l.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,l.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,l.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,l.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,l.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,l.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,l.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,l.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,l.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,l.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,l.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,l.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,l.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,l.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,l.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,l.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,l.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,l.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,l.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,l.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,l.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,l.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,l.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,l.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,l.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,l.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,l.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,l.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,l.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,l.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,l.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,l.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,l.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,l.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,l.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,l.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,l.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,l.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,l.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,l.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,l.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,l.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,l.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,l.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,l.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,l.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,l.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,l.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,l.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,l.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,l.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,l.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,l.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,l.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,l.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,l.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,l.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,l.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,l.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,l.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,l.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,l.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,l.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,l.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,l.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,l.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,l.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,l.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,l.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,l.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,l.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,l.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,l.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,l.createProxyIdentifier)("ExtHostLocalization")}}),define(Ce[67],De([1,0,3,12,5,16]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,l.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(w,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=w.getProxy(I.MainContext.MainThreadTelemetry)}report(w,k,L){const C=this.getUsageKey(w,k);this._reportedUsages.has(C)||(this._reportedUsages.add(C),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${w}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:w}))}getUsageKey(w,k){return`${w}-${k.identifier.value}`}};y=je([He(0,P.IExtHostRpcService),He(1,t.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(D,w,k){}})}),define(Ce[238],De([1,0,4,5,7,27]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(w){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new l.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=w.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(w){return this._providers=w,Promise.resolve()}async getSession(w,k,L,C={}){const E=P.ExtensionIdentifier.toKey(w.identifier),T=this._inFlightRequests.get(E)||[],S=[...L].sort().join(" ");let p=T.find(b=>b.providerId===k&&b.scopes===S);if(p)return p.result;{const b=this._getSession(w,E,k,L,C);p={providerId:k,scopes:S,result:b},T.push(p),this._inFlightRequests.set(E,T);try{await b}finally{const f=T.findIndex(v=>v.providerId===k&&v.scopes===S);f>-1&&(T.splice(f),this._inFlightRequests.set(E,T))}return b}}async _getSession(w,k,L,C,E={}){await this._proxy.$ensureProvider(L);const T=w.displayName||w.name;return this._proxy.$getSession(L,C,k,T,E)}async removeSession(w,k){const L=this._authenticationProviders.get(w);return L?L.provider.removeSession(k):this._proxy.$removeSession(w,k)}registerAuthenticationProvider(w,k,L,C){if(this._authenticationProviders.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this._authenticationProviders.set(w,{label:k,provider:L,options:C??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===w)||this._providers.push({id:w,label:k});const E=L.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(w,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(w,k,C?.supportsMultipleAccounts??!1),new I.Disposable(()=>{E.dispose(),this._authenticationProviders.delete(w);const T=this._providers.findIndex(S=>S.id===w);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(w)})}$createSession(w,k){const L=this._authenticationProviders.get(w);if(L)return Promise.resolve(L.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,k){const L=this._authenticationProviders.get(w);if(L)return Promise.resolve(L.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,k){const L=this._authenticationProviders.get(w);if(L)return Promise.resolve(L.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,k){return this._onDidChangeSessions.fire({provider:{id:w,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(Ce[239],De([1,0,5,16,15]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(D,w){this._proxy=D.getProxy(l.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:k=>w.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(D,w,k){const L=I.WorkspaceEdit.from(D,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(L,void 0,k?.isRefactoring??!1)}};P=je([He(0,t.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(Ce[240],De([1,0,5]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const y=P.getProxy(l.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(D){return y.$writeText(D)}})}}e.ExtHostClipboard=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,l):I?I.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[39],De([1,0,13,7,15,24,5,17,12,81,35,49,2,6,3,16,134,23,56,50]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f,v,h){"use strict";var c,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{constructor(s,a){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,g.set(this,void 0),tt(this,c,s.getProxy(y.MainContext.MainThreadCommands),"f"),this._logService=a,tt(this,g,s.getProxy(y.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,m=>{const _=this._apiCommands.get(m);return _?.result===n.Void?_:void 0},a),this._argumentProcessors=[{processArgument(m){return(0,k.revive)(m)}},{processArgument(m){return(0,P.cloneAndChange)(m,function(_){if(L.Range.isIRange(_))return I.Range.to(_);if(C.Position.isIPosition(_))return I.Position.to(_);if(L.Range.isIRange(_.range)&&E.URI.isUri(_.uri))return I.location.to(_);if(_ instanceof f.VSBuffer)return _.buffer.buffer;if(!Array.isArray(_))return _})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const a=this.registerCommand(!1,s.id,async(...m)=>{const _=s.args.map((M,U)=>{if(!M.validate(m[U]))throw new Error(`Invalid argument '${M.name}' when running '${s.id}', received: ${m[U]}`);return M.convert(m[U])}),R=await this.executeCommand(s.internalId,..._);return s.result.convert(R,m,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new t.Disposable(()=>{a.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,a,m,_,R,M){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:m,thisArg:_,description:R,extension:M}),s&&Be(this,c,"f").$registerCommand(a),new t.Disposable(()=>{this._commands.delete(a)&&s&&Be(this,c,"f").$unregisterCommand(a)})}executeCommand(s,...a){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,a,!0)}async _doExecuteCommand(s,a,m){if(this._commands.has(s))return Be(this,c,"f").$fireCommandActivationEvent(s),this._executeContributedCommand(s,a,!1);{let _=!1;const R=(0,P.cloneAndChange)(a,function(M){if(M instanceof t.Position)return I.Position.from(M);if(M instanceof t.Range)return I.Range.from(M);if(M instanceof t.Location)return I.location.from(M);if(t.NotebookRange.isNotebookRange(M))return I.NotebookRange.from(M);if(M instanceof ArrayBuffer)return _=!0,f.VSBuffer.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return _=!0,f.VSBuffer.wrap(M);if(M instanceof f.VSBuffer)return _=!0,M;if(!Array.isArray(M))return M});try{const M=await Be(this,c,"f").$executeCommand(s,_?new v.SerializableObjectWithBuffers(R):R,m);return(0,k.revive)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this._doExecuteCommand(s,a,!1);throw M}}}async _executeContributedCommand(s,a,m){const _=this._commands.get(s);if(!_)throw new Error("Unknown command");this._reportTelemetry(_,s);const{callback:R,thisArg:M,description:U}=_;if(U)for(let A=0;A<U.args.length;A++)try{(0,l.validateConstraint)(a[A],U.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${U.args[A].name}' - ${U.args[A].description}`)}try{return await R.apply(M,a)}catch(A){if(s===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...a);z&&(s=z.command)}throw this._logService.error(A,s,_.extension?.identifier),m?new class extends Error{constructor(){super((0,h.toErrorMessage)(A)),this.id=s,this.source=_.extension?.displayName??_.extension?.name}}:A}}_reportTelemetry(s,a){!s.extension||s.extension.isBuiltin||Be(this,g,"f").$publicLog2("Extension:ActionExecuted",{extensionId:s.extension.identifier.value,id:a})}$executeContributedCommand(s,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(a=a.map(m=>this._argumentProcessors.reduce((_,R)=>R.processArgument(_),m)),this._executeContributedCommand(s,a,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),Be(this,c,"f").$getCommands().then(a=>(s&&(a=a.filter(m=>m[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(const[a,m]of this._commands){const{description:_}=m;_&&(s[a]=_)}return Promise.resolve(s)}};c=new WeakMap,g=new WeakMap,i=je([He(0,p.IExtHostRpcService),He(1,w.ILogService)],i),e.ExtHostCommands=i,e.IExtHostCommands=(0,S.createDecorator)("IExtHostCommands");class u{constructor(s,a,m){this._commands=s,this._lookupApiCommand=a,this._logService=m,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,a){if(!s)return;const m={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return m;const _=this._lookupApiCommand(s.command);if(_)m.id=_.internalId,m.arguments=_.args.map((R,M)=>R.convert(s.arguments&&s.arguments[M]));else if((0,D.isNonEmptyArray)(s.arguments)){const R=++this._cachIdPool;this._cache.set(R,s),a.add((0,T.toDisposable)(()=>{this._cache.delete(R),this._logService.trace("CommandsConverter#DISPOSE",R)})),m.$ident=R,m.id=this.delegatingCommandId,m.arguments=[R],this._logService.trace("CommandsConverter#CREATE",s.command,R)}return m}fromInternal(s){return typeof s.$ident=="number"?this._cache.get(s.$ident):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const a=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=u;class r{constructor(s,a,m,_){this.name=s,this.description=a,this.validate=m,this.convert=_}optional(){return new r(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,a){return new r(s??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",d=>E.URI.isUri(d),d=>d),r.Position=new r("position","A position in a text document",d=>t.Position.isPosition(d),I.Position.from),r.Range=new r("range","A range in a text document",d=>t.Range.isRange(d),I.Range.from),r.Selection=new r("selection","A selection in a text document",d=>t.Selection.isSelection(d),I.Selection.from),r.Number=new r("number","",d=>typeof d=="number",d=>d),r.String=new r("string","",d=>typeof d=="string",d=>d),r.CallHierarchyItem=new r("item","A call hierarchy item",d=>d instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",d=>d instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",d=>d instanceof b.TestItemImpl,I.TestItem.from);class n{constructor(s,a){this.description=s,this.convert=a}}e.ApiCommandResult=n,n.Void=new n("no result",d=>d);class o{constructor(s,a,m,_,R){this.id=s,this.internalId=a,this.description=m,this.args=_,this.result=R}}e.ApiCommand=o}),define(Ce[241],De([1,0,2,15,7,64,39,17,116,121,14]),function(J,e,l,t,I,P,y,D,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(t.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(p,b)=>{if((0,D.isFalsyOrEmpty)(p))return;class f extends I.SymbolInformation{static to(h){const c=new f(h.name,t.SymbolKind.to(h.kind),h.containerName||"",new I.Location(b[0],t.Range.to(h.range)));return c.detail=h.detail,c.range=c.location.range,c.selectionRange=t.Range.to(h.selectionRange),c.children=h.children?h.children.map(f.to):[],c}}return p.map(f.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",p=>!0,p=>p)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",p=>!0,p=>p)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",p=>typeof p=="string",p=>p),new y.ApiCommandArgument("options","Formatting options",p=>!0,p=>p)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(t.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(t.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",p=>Array.isArray(p)&&p.every(b=>I.Position.isPosition(b)),p=>p.map(t.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",p=>p.map(b=>{let f;for(const v of b.reverse())f=new I.SelectionRange(t.Range.to(v),f);return f}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",p=>p.map(t.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",p=>p.map(t.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",p=>p.map(t.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",p=>p.map(t.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",p=>{if(!!p)return{range:t.Range.to(p.range),placeholder:p.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",p=>{if(!!p){if(p.rejectReason)throw new Error(p.rejectReason);return t.WorkspaceEdit.to(p)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",p=>p.map(t.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",p=>{if(!!p)return new I.SemanticTokensLegend(p.tokenTypes,p.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",p=>{if(!p)return;const b=(0,w.decodeSemanticTokensDto)(p);if(b.type==="full")return new I.SemanticTokens(b.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",p=>{if(!!p)return new I.SemanticTokensLegend(p.tokenTypes,p.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",p=>{if(!p)return;const b=(0,w.decodeSemanticTokensDto)(p);if(b.type==="full")return new I.SemanticTokens(b.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(p,b,f)=>{if(!p)return new I.CompletionList([]);const v=p.suggestions.map(h=>t.CompletionItem.to(h,f));return new I.CompletionList(v,p.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",p=>{if(p)return t.SignatureHelp.to(p)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(p,b,f)=>T(v=>new I.CodeLens(t.Range.to(v.range),v.command&&f.fromInternal(v.command)))(p))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",p=>I.Range.isRange(p),p=>I.Selection.isSelection(p)?t.Selection.from(p):t.Range.from(p)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(p,b,f)=>T(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(v.command)}else{const h=new I.CodeAction(v.title,v.kind?new I.CodeActionKind(v.kind):void 0);return v.edit&&(h.edit=t.WorkspaceEdit.to(v.edit)),v.command&&(h.command=f.fromInternal(v.command)),h.isPreferred=v.isPreferred,h}})(p))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",p=>p?p.map(b=>new I.ColorInformation(t.Range.to(b.range),t.Color.to(b.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",p=>p instanceof I.Color,t.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",p=>!0,p=>({uri:p.uri,range:t.Range.from(p.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",p=>p?p.map(t.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(p,b,f)=>p.map(t.InlayHint.to.bind(void 0,f)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(p=>({viewType:p.viewType,displayName:p.displayName,options:{transientOutputs:p.options.transientOutputs,transientCellMetadata:p.options.transientCellMetadata,transientDocumentMetadata:p.options.transientDocumentMetadata},filenamePattern:p.filenamePattern.map(b=>t.NotebookExclusiveDocumentPattern.to(b))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",p=>p.map(t.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",p=>l.URI.isUri(p)||typeof p=="string"&&(0,k.matchesSomeScheme)(p,L.Schemas.http,L.Schemas.https),p=>p),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",p=>p===void 0||typeof p=="number"||typeof p=="object",p=>p&&(typeof p=="number"?[t.ViewColumn.from(p),void 0]:[t.ViewColumn.from(p.viewColumn),t.TextEditorOpenOptions.from(p)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",p=>p===void 0||typeof p=="number"||typeof p=="object",p=>p&&(typeof p=="number"?[t.ViewColumn.from(p),void 0]:[t.ViewColumn.from(p.viewColumn),t.TextEditorOpenOptions.from(p)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",p=>p===void 0||typeof p=="object",p=>p&&[t.ViewColumn.from(p.viewColumn),t.TextEditorOpenOptions.from(p)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",p=>p.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",p=>p.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",p=>p.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void),new y.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[y.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],y.ApiCommandResult.Void)];class E{static register(b){C.forEach(b.registerApiCommand,b)}}e.ExtHostApiCommands=E;function T(p){return b=>{if(Array.isArray(b))return b.map(p)}}function S(p){if(!Array.isArray(p))return;const b=[];for(const f of p)P.isLocationLink(f)?b.push(t.DefinitionLink.to(f)):b.push(t.location.to(f));return b}}),define(Ce[242],De([1,0,18,59,4,6,2,64,27,15,7,28,5]),function(J,e,l,t,I,P,y,D,w,k,L,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(S,p,b){const f=S.getProxy(E.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,p.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const s=this._commentControllers.get(d.handle);return s?s.value:d}else if(d&&d.$mid===7){const s=this._commentControllers.get(d.commentControlHandle);if(!s)return d;const a=s.getCommentThread(d.commentThreadHandle);return a?a.value:d}else if(d&&d.$mid===8){const s=this._commentControllers.get(d.thread.commentControlHandle);if(!s)return d;const a=s.getCommentThread(d.thread.commentThreadHandle);return a?{thread:a.value,text:d.text}:d}else if(d&&d.$mid===9){const s=this._commentControllers.get(d.thread.commentControlHandle);if(!s)return d;const a=s.getCommentThread(d.thread.commentThreadHandle);if(!a)return d;const m=d.commentUniqueId,_=a.getCommentByUniqueId(m);return _||d}else if(d&&d.$mid===10){const s=this._commentControllers.get(d.thread.commentControlHandle);if(!s)return d;const a=s.getCommentThread(d.thread.commentThreadHandle);if(!a)return d;const m=d.text,_=d.commentUniqueId,R=a.getCommentByUniqueId(_);return R?(typeof R.body=="string"?R.body=m:R.body.value=m,R):d}return d}})}createCommentController(d,s,a){const m=v.handlePool++,_=new c(d,m,s,a);this._commentControllers.set(_.handle,_);const R=this._commentControllersByExtension.get(w.ExtensionIdentifier.toKey(d.identifier))||[];return R.push(_),this._commentControllersByExtension.set(w.ExtensionIdentifier.toKey(d.identifier),R),_.value}$createCommentThreadTemplate(d,s,a){const m=this._commentControllers.get(d);!m||m.$createCommentThreadTemplate(s,a)}async $updateCommentThreadTemplate(d,s,a){const m=this._commentControllers.get(d);!m||m.$updateCommentThreadTemplate(s,a)}$deleteCommentThread(d,s){this._commentControllers.get(d)?.$deleteCommentThread(s)}$provideCommentingRanges(d,s,a){const m=this._commentControllers.get(d);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const _=b.getDocument(y.URI.revive(s));return(0,l.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(_,a)).then(R=>R?R.map(M=>k.Range.from(M)):void 0)}$toggleReaction(d,s,a,m,_){const R=this._commentControllers.get(d);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,l.asPromise)(()=>{const M=R.getCommentThread(s);if(M){const U=M.getCommentByUniqueId(m.uniqueIdInThread);if(R!==void 0&&U&&R.reactionHandler)return R.reactionHandler(U,u(_))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class h{set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){d.isEqual(this._range)||(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get state(){return(0,C.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(d){(0,C.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=d,this.modifications.state=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(d,s,a,m,_,R,M,U){this._commentControllerHandle=s,this._id=a,this._uri=m,this._range=_,this._comments=R,this.extensionDescription=M,this._isTemplate=U,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${d}.${this.handle}`),f.$createCommentThread(s,this.handle,this._id,this._uri,k.Range.from(this._range),M.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{f.$deleteCommentThread(s,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(z){A.range=z},get comments(){return A.comments},set comments(z){A.comments=z},get collapsibleState(){return A.collapsibleState},set collapsibleState(z){A.collapsibleState=z},get canReply(){return A.canReply},set canReply(z){A.canReply=z},get contextValue(){return A.contextValue},set contextValue(z){A.contextValue=z},get label(){return A.label},set label(z){A.label=z},get state(){return A.state},set state(z){A.state=z},dispose:()=>{A.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const d=a=>Object.prototype.hasOwnProperty.call(this.modifications,a),s={};d("range")&&(s.range=k.Range.from(this._range)),d("label")&&(s.label=this.label),d("contextValue")&&(s.contextValue=this.contextValue??null),d("comments")&&(s.comments=this._comments.map(a=>g(this,a,this._commentsMap))),d("collapsibleState")&&(s.collapseState=r(this._collapseState)),d("canReply")&&(s.canReply=this.canReply),d("state")&&(s.state=n(this._state)),d("isTemplate")&&(s.isTemplate=this._isTemplate),this.modifications={},f.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,s)}getCommentByUniqueId(d){for(const s of this._commentsMap){const a=s[0],m=s[1];if(d===m)return a}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose())}}h._handlePool=0,je([(0,t.debounce)(100)],h.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(d){this._commentingRangeProvider=d,f.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,f.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(d,s,a,m){this._extension=d,this._handle=s,this._id=a,this._label=m,this._threads=new Map,f.$registerCommentController(this.handle,a,m);const _=this;this.value=Object.freeze({id:_.id,label:_.label,get options(){return _.options},set options(R){_.options=R},get commentingRangeProvider(){return _.commentingRangeProvider},set commentingRangeProvider(R){_.commentingRangeProvider=R},get reactionHandler(){return _.reactionHandler},set reactionHandler(R){_.reactionHandler=R},createCommentThread(R,M,U){return _.createCommentThread(R,M,U).value},dispose:()=>{_.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(d,s,a,m){if(typeof d=="string"){const _=new h(this.id,this.handle,d,s,a,m,this._extension,!1);return this._threads.set(_.handle,_),_}else{const _=new h(this.id,this.handle,void 0,d,s,a,this._extension,!1);return this._threads.set(_.handle,_),_}}$createCommentThreadTemplate(d,s){const a=new h(this.id,this.handle,void 0,y.URI.revive(d),k.Range.to(s),[],this._extension,!0);return a.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(a.handle,a),a}$updateCommentThreadTemplate(d,s){const a=this._threads.get(d);a&&(a.range=k.Range.to(s))}$deleteCommentThread(d){this._threads.get(d)?.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._localDisposables.forEach(d=>d.dispose())}}function g(o,d,s){let a=s.get(d);a||(a=++o.commentHandle,s.set(d,a));const m=d.author&&d.author.iconPath?d.author.iconPath.toString():void 0;return{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:a,body:typeof d.body=="string"?d.body:k.MarkdownString.from(d.body),userName:d.author.name,userIconPath:m,label:d.label,commentReactions:d.reactions?d.reactions.map(_=>i(_)):void 0,timestamp:d.timestamp?.toJSON()}}function i(o){return{label:o.label,iconPath:o.iconPath?k.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function u(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?y.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function r(o){if(o!==void 0)switch(o){case L.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}function n(o){if(o!==void 0)switch(o){case L.CommentThreadState.Unresolved:return D.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return D.CommentThreadState.Resolved}return D.CommentThreadState.Unresolved}return new v}e.createExtHostComments=T}),define(Ce[243],De([1,0,24,5,25,16]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let y=class{constructor(L,C){this._mainThreadConsole=L.getProxy(t.MainContext.MainThreadConsole),this._includeStack=C.consoleForward.includeStack,this._logNative=C.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(L,C){const E=this,T=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){E._handleConsoleCall(L,C,T,arguments)}})}_handleConsoleCall(L,C,E,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:C,arguments:w(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(L,E,T)}};y=je([He(0,P.IExtHostRpcService),He(1,I.IExtHostInitDataService)],y),e.AbstractExtHostConsoleForwarder=y;const D=1e5;function w(k,L){const C=[];if(k.length)for(let E=0;E<k.length;E++){let T=k[E];if(typeof T>"u")T="undefined";else if(T instanceof Error){const S=T;S.stack?T=S.stack:T=S.toString()}C.push(T)}if(L){const E=new Error().stack;E&&C.push({__$stack:E.split(`
`).slice(3).join(`
`)})}try{const E=(0,l.safeStringify)(C);return E.length>D?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}),define(Ce[136],De([1,0,2,5,7,3,16,12,17,8,9]),function(J,e,l,t,I,P,y,D,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class On{constructor(T,S){this._logService=S,this._provider=new Map,this._proxy=T.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,S){const p=On._handlePool++;this._provider.set(p,{provider:T,extensionId:S}),this._proxy.$registerDecorationProvider(p,S.value);const b=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(f=>{if(!f){this._proxy.$onDidChange(p,null);return}const v=(0,w.asArray)(f);if(v.length<=On._maxEventSize){this._proxy.$onDidChange(p,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",S.value,v.length);const h=v.map(i=>({uri:i,rank:(0,k.count)(i.path,"/")})),c=(0,w.groupBy)(h,(i,u)=>i.rank-u.rank||(0,k.compare)(i.uri.path,u.uri.path)),g=[];e:for(const i of c){let u;for(const r of i){const n=(0,L.dirname)(r.uri.path);if(u!==n&&(u=n,g.push(r.uri)>=On._maxEventSize))break e}}this._proxy.$onDidChange(p,g)});return new I.Disposable(()=>{b?.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(T,S,p){if(!this._provider.has(T))return Object.create(null);const b=Object.create(null),{provider:f,extensionId:v}=this._provider.get(T);return await Promise.all(S.map(async h=>{try{const{uri:c,id:g}=h,i=await Promise.resolve(f.provideFileDecoration(l.URI.revive(c),p));if(!i)return;try{I.FileDecoration.validate(i),b[g]=[i.propagate,i.tooltip,i.badge,i.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${v.value}': ${u}`)}}catch(c){this._logService.error(c)}})),b}};C._handlePool=0,C._maxEventSize=250,C=je([He(0,y.IExtHostRpcService),He(1,D.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,l):I?I.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[244],De([1,0,170,120,2,5,7,15,4,12,26,46]),function(J,e,l,t,I,P,y,D,w,k,L,C){"use strict";var E,T,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class p{constructor(v,h,c,g,i,u){this._name=v,this._owner=h,this._maxDiagnosticsPerFile=c,E.set(this,void 0),T.set(this,void 0),S.set(this,void 0),this._isDisposed=!1,tt(this,S,new L.ResourceMap(r=>g.getComparisonKey(r)),"f"),tt(this,E,i,"f"),tt(this,T,u,"f")}dispose(){this._isDisposed||(Be(this,T,"f").fire([...Be(this,S,"f").keys()]),Be(this,E,"f")?.$clear(this._owner),Be(this,S,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,h){if(!v){this.clear();return}this._checkDisposed();let c=[];if(I.URI.isUri(v)){if(!h){this.delete(v);return}Be(this,S,"f").set(v,h.slice()),c=[v]}else if(Array.isArray(v)){c=[];let i;v=[...v].sort(p._compareIndexedTuplesByUri);for(const u of v){const[r,n]=u;if((!i||r.toString()!==i.toString())&&(i&&Be(this,S,"f").get(i).length===0&&Be(this,S,"f").delete(i),i=r,c.push(r),Be(this,S,"f").set(r,[])),n)Be(this,S,"f").get(r)?.push(...n);else{const o=Be(this,S,"f").get(r);o&&(o.length=0)}}}if(Be(this,T,"f").fire(c),!Be(this,E,"f"))return;const g=[];for(const i of c){let u=[];const r=Be(this,S,"f").get(i);if(r)if(r.length>this._maxDiagnosticsPerFile){u=[];const n=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const d of r)if(d.severity===n[o]&&u.push(D.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;u.push({severity:t.MarkerSeverity.Info,message:(0,l.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=r.map(n=>D.Diagnostic.from(n));g.push([i,u])}Be(this,E,"f").$changeMany(this._owner,g)}delete(v){this._checkDisposed(),Be(this,T,"f").fire([v]),Be(this,S,"f").delete(v),Be(this,E,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Be(this,T,"f").fire([...Be(this,S,"f").keys()]),Be(this,S,"f").clear(),Be(this,E,"f")?.$clear(this._owner)}forEach(v,h){this._checkDisposed();for(const[c,g]of this)v.call(h,c,g,this)}*[(E=new WeakMap,T=new WeakMap,S=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Be(this,S,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const h=Be(this,S,"f").get(v);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Be(this,S,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,h){return v[0].toString()<h[0].toString()?-1:v[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=p;let b=class ln{static _mapper(v){const h=new L.ResourceMap;for(const c of v)h.set(c,c);return{uris:Object.freeze(Array.from(h.values()))}}constructor(v,h,c){this._logService=h,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new w.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=w.Event.map(this._onDidChangeDiagnostics.event,ln._mapper),this._proxy=v.getProxy(P.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(v,h){const{_collections:c,_proxy:g,_onDidChangeDiagnostics:i,_logService:u,_fileSystemInfoService:r}=this,n=new class{$changeMany(s,a){g.$changeMany(s,a),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,s,a.length===0?"CLEARING":a)}$clear(s){g.$clear(s),u.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,s)}dispose(){g.dispose()}};let o;if(!h)h="_generated_diagnostic_collection_name_#"+ln._idPool++,o=h;else if(!c.has(h))o=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do o=h+ln._idPool++;while(c.has(o))}return new class extends p{constructor(){super(h,o,ln._maxDiagnosticsPerFile,r.extUri,n,i),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const h=new Map,c=[];for(const g of this._collections.values())g.forEach((i,u)=>{let r=h.get(i.toString());typeof r>"u"&&(r=c.length,h.set(i.toString(),r),c.push([i,[]])),c[r][1]=c[r][1].concat(...u)});return c}}_getDiagnostics(v){let h=[];for(const c of this._collections.values())c.has(v)&&(h=h.concat(c.get(v)));return h}$acceptMarkersChange(v){if(!this._mirrorCollection){const h="_generated_mirror",c=new p(h,h,ln._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(h,c),this._mirrorCollection=c}for(const[h,c]of v)this._mirrorCollection.set(I.URI.revive(h),c.map(D.Diagnostic.to))}};b._idPool=0,b._maxDiagnosticsPerFile=1e3,b=je([He(1,k.ILogService),He(2,C.IExtHostFileSystemInfo)],b),e.ExtHostDiagnostics=b}),define(Ce[245],De([1,0,2,5]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(y){this._proxy=y.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(D=>D?D.map(w=>l.URI.revive(w)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(D=>D?l.URI.revive(D):void 0)}}e.ExtHostDialogs=I}),define(Ce[246],De([1,0,11,2,7,5,14,21,8]),function(J,e,l,t,I,P,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(C,E,T){this._documentsAndEditors=E,this._logService=T,this._documentContentProviders=new Map,this._proxy=C.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,E){if(Object.keys(y.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const T=k._handlePool++;this._documentContentProviders.set(T,E),this._proxy.$registerTextContentProvider(T,C);let S;return typeof E.onDidChange=="function"&&(S=E.onDidChange(p=>{if(p.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(p)&&this.$provideTextDocumentContent(T,p).then(b=>{if(!b&&typeof b!="string")return;const f=this._documentsAndEditors.getDocument(p);if(!f)return;const v=(0,w.splitLines)(b);if(!f.equalLines(v))return this._proxy.$onVirtualDocumentChange(p,b)},l.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(C,E){const T=this._documentContentProviders.get(C);return T?Promise.resolve(T.provideTextDocumentContent(t.URI.revive(E),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${E.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(Ce[247],De([1,0,4,6,2,5,132,15,13,24,7]),function(J,e,l,t,I,P,y,D,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class C{constructor(T,S){this._onDidAddDocument=new l.Emitter,this._onDidRemoveDocument=new l.Emitter,this._onDidChangeDocument=new l.Emitter,this._onDidSaveDocument=new l.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=S,this._documentsAndEditors.onDidRemoveDocuments(p=>{for(const b of p)this._onDidRemoveDocument.fire(b.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(p=>{for(const b of p)this._onDidAddDocument.fire(b.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const S=this._documentsAndEditors.getDocument(T);if(S)return S}getDocument(T){const S=this.getDocumentData(T);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return S.document}ensureDocumentData(T){const S=this._documentsAndEditors.getDocument(T);if(S)return Promise.resolve(S);let p=this._documentLoader.get(T.toString());return p||(p=this._proxy.$tryOpenDocument(T).then(b=>{this._documentLoader.delete(T.toString());const f=I.URI.revive(b);return(0,w.assertIsDefined)(this._documentsAndEditors.getDocument(f))},b=>(this._documentLoader.delete(T.toString()),Promise.reject(b))),this._documentLoader.set(T.toString(),p)),p}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(S=>I.URI.revive(S))}$acceptModelLanguageChanged(T,S){const p=I.URI.revive(T),b=this._documentsAndEditors.getDocument(p);if(!b)throw new Error("unknown document");this._onDidRemoveDocument.fire(b.document),b._acceptLanguageId(S),this._onDidAddDocument.fire(b.document)}$acceptModelSaved(T){const S=I.URI.revive(T),p=this._documentsAndEditors.getDocument(S);if(!p)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(p.document)}$acceptDirtyStateChanged(T,S){const p=I.URI.revive(T),b=this._documentsAndEditors.getDocument(p);if(!b)throw new Error("unknown document");b._acceptIsDirty(S),this._onDidChangeDocument.fire({document:b.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,S,p){const b=I.URI.revive(T),f=this._documentsAndEditors.getDocument(b);if(!f)throw new Error("unknown document");f._acceptIsDirty(p),f.onEvents(S);let v;S.isUndoing?v=L.TextDocumentChangeReason.Undo:S.isRedoing&&(v=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:f.document,contentChanges:S.changes.map(h=>({range:D.Range.to(h.range),rangeOffset:h.rangeOffset,rangeLength:h.rangeLength,text:h.text})),reason:v}))}setWordDefinitionFor(T,S){(0,y.setWordDefinitionFor)(T,S)}}e.ExtHostDocuments=C}),define(Ce[57],De([1,0,48,4,6,2,3,5,132,16,135,15,12,26,14,61,78]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let v=class{constructor(c,g){this._extHostRpc=c,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const g=[],i=[],u=[];if(c.removedDocuments)for(const r of c.removedDocuments){const n=P.URI.revive(r),o=this._documents.get(n);o?.unref()&&(this._documents.delete(n),g.push(o.value))}if(c.addedDocuments)for(const r of c.addedDocuments){const n=P.URI.revive(r.uri);let o=this._documents.get(n);if(o&&n.scheme!==S.Schemas.vscodeNotebookCell&&n.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);o||(o=new f(new w.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),n,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(n,o),i.push(o.value)),o.ref()}if(c.removedEditors)for(const r of c.removedEditors){const n=this._editors.get(r);this._editors.delete(r),n&&u.push(n)}if(c.addedEditors)for(const r of c.addedEditors){const n=P.URI.revive(r.documentUri);l.ok(this._documents.has(n),`document '${n}' does not exist`),l.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const o=this._documents.get(n).value,d=new L.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new b.Lazy(()=>o.document),r.selections.map(C.Selection.to),r.options,r.visibleRanges.map(s=>C.Range.to(s)),typeof r.editorPosition=="number"?C.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,d)}c.newActiveEditor!==void 0&&(l.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,I.dispose)(g),(0,I.dispose)(u),c.removedDocuments&&this._onDidRemoveDocuments.fire(g),c.addedDocuments&&this._onDidAddDocuments.fire(i),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return p.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return c?g:g?.value}allEditors(){return[...this._editors.values()]}};v=je([He(0,k.IExtHostRpcService),He(1,E.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[58],De([1,0,15,5,2,4,3,7,16,13,77]),function(J,e,l,t,I,P,y,D,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");class C{constructor(b,f,v){this._activeTabIdGetter=v,this._parentGroup=f,this.acceptDtoUpdate(b)}get apiObject(){if(!this._apiObject){const b=this,f={get isActive(){return b._dto.id===b._activeTabIdGetter()},get label(){return b._dto.label},get input(){return b._input},get isDirty(){return b._dto.isDirty},get isPinned(){return b._dto.isPinned},get isPreview(){return b._dto.isPreview},get group(){return b._parentGroup.apiObject}};this._apiObject=Object.freeze(f)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(b){this._dto=b,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new D.TextTabInput(I.URI.revive(this._dto.input.uri));case 2:return new D.TextDiffTabInput(I.URI.revive(this._dto.input.original),I.URI.revive(this._dto.input.modified));case 3:return new D.TextMergeTabInput(I.URI.revive(this._dto.input.base),I.URI.revive(this._dto.input.input1),I.URI.revive(this._dto.input.input2),I.URI.revive(this._dto.input.result));case 6:return new D.CustomEditorTabInput(I.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new D.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new D.NotebookEditorTabInput(I.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new D.NotebookDiffEditorTabInput(I.URI.revive(this._dto.input.original),I.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new D.TerminalEditorTabInput;case 9:return new D.InteractiveWindowInput(I.URI.revive(this._dto.input.uri),I.URI.revive(this._dto.input.inputBoxUri));default:return}}}class E{constructor(b,f){this._tabs=[],this._activeTabId="",this._dto=b,this._activeGroupIdGetter=f;for(const v of b.tabs)v.isActive&&(this._activeTabId=v.id),this._tabs.push(new C(v,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const b=this,f={get isActive(){return b._dto.groupId===b._activeGroupIdGetter()},get viewColumn(){return l.ViewColumn.to(b._dto.viewColumn)},get activeTab(){return b._tabs.find(v=>v.tabId===b._activeTabId)?.apiObject},get tabs(){return Object.freeze(b._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(f)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(b){this._dto=b}acceptTabOperation(b){if(b.kind===0){const v=new C(b.tabDto,this,()=>this.activeTabId());return this._tabs.splice(b.index,0,v),b.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(b.kind===1){const v=this._tabs.splice(b.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${b.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(b.kind===3){if(b.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(b.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${b.oldIndex} which does not exist`);return this._tabs.splice(b.index,0,v),v}const f=this._tabs.find(v=>v.tabId===b.tabDto.id);if(!f)throw new Error("INVALID tab");return b.tabDto.isActive?this._activeTabId=b.tabDto.id:this._activeTabId===b.tabDto.id&&!b.tabDto.isActive&&(this._activeTabId=""),f.acceptDtoUpdate(b.tabDto),f}activeTabId(){return this._activeTabId}}let T=class{constructor(b){this._onDidChangeTabs=new P.Emitter,this._onDidChangeTabGroups=new P.Emitter,this._extHostTabGroups=[],this._proxy=b.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const b=this,f={onDidChangeTabGroups:b._onDidChangeTabGroups.event,onDidChangeTabs:b._onDidChangeTabs.event,get all(){return Object.freeze(b._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=b._activeGroupId;return(0,k.assertIsDefined)(b._extHostTabGroups.find(c=>c.groupId===v)?.apiObject)},close:async(v,h)=>{const c=Array.isArray(v)?v:[v];return c.length?S(c[0])?this._closeGroups(c,h):this._closeTabs(c,h):!0}};this._apiObject=Object.freeze(f)}return this._apiObject}$acceptEditorTabModel(b){const f=new Set(this._extHostTabGroups.map(r=>r.groupId)),v=new Set(b.map(r=>r.groupId)),h=(0,L.diffSets)(f,v),c=this._extHostTabGroups.filter(r=>h.removed.includes(r.groupId)).map(r=>r.apiObject),g=[],i=[];this._extHostTabGroups=b.map(r=>{const n=new E(r,()=>this._activeGroupId);return h.added.includes(n.groupId)?g.push(n.apiObject):i.push(n.apiObject),n});const u=(0,k.assertIsDefined)(b.find(r=>r.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:g,closed:c,changed:i}))}$acceptTabGroupUpdate(b){const f=this._extHostTabGroups.find(v=>v.groupId===b.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(b),b.isActive&&(this._activeGroupId=b.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(b){const f=this._extHostTabGroups.find(h=>h.groupId===b.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const v=f.acceptTabOperation(b);switch(b.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(b){for(const f of this._extHostTabGroups)for(const v of f.tabs)if(v.apiObject===b)return v}_findExtHostTabGroupFromApi(b){return this._extHostTabGroups.find(f=>f.apiObject===b)}async _closeTabs(b,f){const v=[];for(const h of b){const c=this._findExtHostTabFromApi(h);if(!c)throw new Error("Tab close: Invalid tab not found!");v.push(c.tabId)}return this._proxy.$closeTab(v,f)}async _closeGroups(b,f){const v=[];for(const h of b){const c=this._findExtHostTabGroupFromApi(h);if(!c)throw new Error("Group close: Invalid group not found!");v.push(c.groupId)}return this._proxy.$closeGroup(v,f)}};T=je([He(0,w.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function S(p){return p.tabs!==void 0}}),define(Ce[248],De([1,0,2,5,6,7,15,149,8,23,28]),function(J,e,l,t,I,P,y,D,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class C{constructor(){this._schemes=[]}add(S){this._stateMachine=void 0,this._schemes.push(S)}delete(S){const p=this._schemes.indexOf(S);p>=0&&(this._schemes.splice(p,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const S=this._schemes.sort(),p=[];let b,f,v=14,h=14;for(const c of S){let g=b?(0,w.commonPrefixLength)(b,c):0;for(g===0?f=1:f=h;g<c.length;g++)g+1===c.length?(v=h,h=9):h+=1,p.push([f,c.toUpperCase().charCodeAt(g),h]),p.push([f,c.toLowerCase().charCodeAt(g),h]),f=h;b=c,h=v}p.push([9,58,10]),p.push([10,47,12]),this._stateMachine=new D.StateMachine(p)}}provideDocumentLinks(S){this._initStateMachine();const p=[],b=D.LinkComputer.computeLinks({getLineContent(f){return S.lineAt(f-1).text},getLineCount(){return S.lineCount}},this._stateMachine);for(const f of b){const v=y.DocumentLink.to(f);v.target&&p.push(v)}return p}}class E{constructor(S,p){this._extHostLanguageFeatures=p,this._linkProvider=new C,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=S.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(S,p,b,f={}){if(this._registeredSchemes.has(p))throw new Error(`a provider for the scheme '${p}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(S,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(p),this._registeredSchemes.add(p),this._fsProvider.set(v,b);let h=2;f.isCaseSensitive&&(h+=1024),f.isReadonly&&(h+=2048),typeof b.copy=="function"&&(h+=8),typeof b.open=="function"&&typeof b.close=="function"&&typeof b.read=="function"&&typeof b.write=="function"&&((0,L.checkProposedApiEnabled)(S,"fsChunks"),h+=4),this._proxy.$registerFileSystemProvider(v,p,h).catch(g=>{console.error(`FAILED to register filesystem provider of ${S.identifier.value}-extension for the scheme ${p}`),console.error(g)});const c=b.onDidChangeFile(g=>{const i=[];for(const u of g){const{uri:r,type:n}=u;if(r.scheme!==p)continue;let o;switch(n){case P.FileChangeType.Changed:o=0;break;case P.FileChangeType.Created:o=1;break;case P.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:r,type:o})}this._proxy.$onFileSystemChange(v,i)});return(0,I.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(p),this._registeredSchemes.delete(p),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(S){const{type:p,ctime:b,mtime:f,size:v,permissions:h}=S;return{type:p,ctime:b,mtime:f,size:v,permissions:h}}$stat(S,p){return Promise.resolve(this._getFsProvider(S).stat(l.URI.revive(p))).then(b=>E._asIStat(b))}$readdir(S,p){return Promise.resolve(this._getFsProvider(S).readDirectory(l.URI.revive(p)))}$readFile(S,p){return Promise.resolve(this._getFsProvider(S).readFile(l.URI.revive(p))).then(b=>k.VSBuffer.wrap(b))}$writeFile(S,p,b,f){return Promise.resolve(this._getFsProvider(S).writeFile(l.URI.revive(p),b.buffer,f))}$delete(S,p,b){return Promise.resolve(this._getFsProvider(S).delete(l.URI.revive(p),b))}$rename(S,p,b,f){return Promise.resolve(this._getFsProvider(S).rename(l.URI.revive(p),l.URI.revive(b),f))}$copy(S,p,b,f){const v=this._getFsProvider(S);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(l.URI.revive(p),l.URI.revive(b),f))}$mkdir(S,p){return Promise.resolve(this._getFsProvider(S).createDirectory(l.URI.revive(p)))}$watch(S,p,b,f){const v=this._getFsProvider(S).watch(l.URI.revive(b),f);this._watches.set(p,v)}$unwatch(S,p){const b=this._watches.get(p);b&&(b.dispose(),this._watches.delete(p))}$open(S,p,b){const f=this._getFsProvider(S);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(l.URI.revive(p),b))}$close(S,p){const b=this._getFsProvider(S);if(!b.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(b.close(p))}$read(S,p,b,f){const v=this._getFsProvider(S);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const h=k.VSBuffer.alloc(f);return Promise.resolve(v.read(p,b,h.buffer,0,f)).then(c=>h.slice(0,c))}$write(S,p,b,f){const v=this._getFsProvider(S);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(p,b,f.buffer,0,f.byteLength))}_getFsProvider(S){const p=this._fsProvider.get(S);if(!p){const b=new Error;throw b.name="ENOPRO",b.message="no provider",b}return p}}e.ExtHostFileSystem=E}),define(Ce[68],De([1,0,5,38,7,23,3,16,46,6]),function(J,e,l,t,I,P,y,D,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Yt{constructor(E,T){this._fileSystemProvider=new Map,this._proxy=E.getProxy(l.MainContext.MainThreadFileSystem);const S=this;this.value=Object.freeze({async stat(p){try{const b=S._fileSystemProvider.get(p.scheme);if(!b)return await S._proxy.$stat(p);await S._proxy.$ensureActivation(p.scheme);const f=await b.stat(p);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(b){Yt._handleError(b)}},async readDirectory(p){try{const b=S._fileSystemProvider.get(p.scheme);return b?(await S._proxy.$ensureActivation(p.scheme),(await b.readDirectory(p)).slice()):await S._proxy.$readdir(p)}catch(b){return Yt._handleError(b)}},async createDirectory(p){try{return await S._proxy.$mkdir(p)}catch(b){return Yt._handleError(b)}},async readFile(p){try{const b=S._fileSystemProvider.get(p.scheme);return b?(await S._proxy.$ensureActivation(p.scheme),(await b.readFile(p)).slice()):(await S._proxy.$readFile(p)).buffer}catch(b){return Yt._handleError(b)}},async writeFile(p,b){try{return await S._proxy.$writeFile(p,P.VSBuffer.wrap(b))}catch(f){return Yt._handleError(f)}},async delete(p,b){try{const f=S._fileSystemProvider.get(p.scheme);return f?(await S._proxy.$ensureActivation(p.scheme),await f.delete(p,{recursive:!1,...b})):await S._proxy.$delete(p,{recursive:!1,useTrash:!1,...b})}catch(f){return Yt._handleError(f)}},async rename(p,b,f){try{return await S._proxy.$rename(p,b,{overwrite:!1,...f})}catch(v){return Yt._handleError(v)}},async copy(p,b,f){try{return await S._proxy.$copy(p,b,{overwrite:!1,...f})}catch(v){return Yt._handleError(v)}},isWritableFileSystem(p){const b=T.getCapabilities(p);if(typeof b=="number")return!(b&2048)}})}static _handleError(E){if(E instanceof I.FileSystemError)throw E;if(!(E instanceof Error))throw new I.FileSystemError(String(E));if(E.name==="ENOPRO")throw I.FileSystemError.Unavailable(E.message);switch(E.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(E.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(E.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(E.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(E.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(E.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(E.message);default:throw new I.FileSystemError(E.message,E.name)}}addFileSystemProvider(E,T){return this._fileSystemProvider.set(E,T),(0,k.toDisposable)(()=>this._fileSystemProvider.delete(E))}};L=je([He(0,D.IExtHostRpcService),He(1,w.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[249],De([1,0,4,37,2,5,15,7]),function(J,e,l,t,I,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class w{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(C,E,T,S,p,b,f,v){this._onDidCreate=new l.Emitter,this._onDidChange=new l.Emitter,this._onDidDelete=new l.Emitter;const h=this.ensureWatching(C,T,p);this._config=0,b&&(this._config+=1),f&&(this._config+=2),v&&(this._config+=4);const c=(0,t.parse)(p),g=typeof p=="string",i=S(u=>{if(!b)for(const r of u.created){const n=I.URI.revive(r);c(n.fsPath)&&(!g||E.getWorkspaceFolder(n))&&this._onDidCreate.fire(n)}if(!f)for(const r of u.changed){const n=I.URI.revive(r);c(n.fsPath)&&(!g||E.getWorkspaceFolder(n))&&this._onDidChange.fire(n)}if(!v)for(const r of u.deleted){const n=I.URI.revive(r);c(n.fsPath)&&(!g||E.getWorkspaceFolder(n))&&this._onDidDelete.fire(n)}});this._disposable=D.Disposable.from(h,this._onDidCreate,this._onDidChange,this._onDidDelete,i)}ensureWatching(C,E,T){const S=D.Disposable.from();if(typeof T=="string")return S;const p=C.getProxy(P.MainContext.MainThreadFileSystem);let b=!1;(T.pattern.includes(t.GLOBSTAR)||T.pattern.includes(t.GLOB_SPLIT))&&(b=!0);const f=Math.random();return p.$watch(E.identifier.value,f,T.baseUri,{recursive:b,excludes:[]}),D.Disposable.from({dispose:()=>p.$unwatch(f)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(C,E,T){this._mainContext=C,this._logService=E,this._extHostDocumentsAndEditors=T,this._onFileSystemEvent=new l.Emitter,this._onDidRenameFile=new l.Emitter,this._onDidCreateFile=new l.Emitter,this._onDidDeleteFile=new l.Emitter,this._onWillRenameFile=new l.AsyncEmitter,this._onWillCreateFile=new l.AsyncEmitter,this._onWillDeleteFile=new l.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,E,T,S,p,b){return new w(this._mainContext,C,E,this._onFileSystemEvent.event,y.GlobPattern.from(T),S,p,b)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,E){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:E.map(T=>({oldUri:I.URI.revive(T.source),newUri:I.URI.revive(T.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:E.map(T=>I.URI.revive(T.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:E.map(T=>I.URI.revive(T.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,E){return(T,S,p)=>{const b=function(v){T.call(S,v)};return b.extension=C,E.event(b,void 0,p)}}async $onWillRunFileOperation(C,E,T,S){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:E.map(p=>({oldUri:I.URI.revive(p.source),newUri:I.URI.revive(p.target)}))},T,S);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:E.map(p=>I.URI.revive(p.target))},T,S);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:E.map(p=>I.URI.revive(p.target))},T,S)}}async _fireWillEvent(C,E,T,S){const p=new Set,b=[];if(await C.fireAsync(E,S,async(v,h)=>{const c=Date.now(),g=await Promise.resolve(v);g instanceof D.WorkspaceEdit&&(b.push([h.extension,g]),p.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-c>T&&this._logService.warn("SLOW file-participant",h.extension.identifier)}),S.isCancellationRequested||b.length===0)return;const f={edits:[]};for(const[,v]of b){const{edits:h}=y.WorkspaceEdit.from(v,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});f.edits=f.edits.concat(h)}return{edit:f,extensionNames:Array.from(p)}}}e.ExtHostFileSystemEventService=k}),define(Ce[250],De([1,0,2,39]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(y,D,w,k,L){this._extHostNotebooks=D,this._textDocumentsAndEditors=w,this._commands=k;const C=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new t.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new t.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new t.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new t.ApiCommandResult("Notebook and input URI",E=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",E.notebookEditorId),E.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(E.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:l.URI.revive(E.notebookUri),inputUri:l.URI.revive(E.inputUri),notebookEditor:T.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",E.notebookUri,E.inputUri),{notebookUri:l.URI.revive(E.notebookUri),inputUri:l.URI.revive(E.inputUri)}}));this._commands.registerApiCommand(C)}$willAddInteractiveDocument(y,D,w,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:D,lines:[""],languageId:w,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(l.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=I}),define(Ce[251],De([1,0,6,5]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(y){this._handlePool=0,this._proxy=y.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,y),(0,l.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=I}),define(Ce[252],De([1,0,2,24,15,7,64,5,8,35,17,13,145,21,6,116,96,87,51,11,18,28]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f,v,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class i{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentSymbols(O,j){const G=this._documents.getDocument(O),X=await this._provider.provideDocumentSymbols(G,j);if(!(0,L.isFalsyOrEmpty)(X))return X[0]instanceof P.DocumentSymbol?X.map(I.DocumentSymbol.from):i._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((X,pe)=>{let we=X.location.range.start.compareTo(pe.location.range.start);return we===0&&(we=pe.location.range.end.compareTo(X.location.range.end)),we});const j=[],G=[];for(const X of O){const pe={name:X.name||"!!MISSING: name!!",kind:I.SymbolKind.from(X.kind),tags:X.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:I.Range.from(X.location.range),selectionRange:I.Range.from(X.location.range),children:[]};for(;;){if(G.length===0){G.push(pe),j.push(pe);break}const we=G[G.length-1];if(k.Range.containsRange(we.range,pe.range)&&!k.Range.equalsRange(we.range,pe.range)){we.children?.push(pe),G.push(pe);break}G.pop()}}return j}}class u{constructor(O,j,G){this._documents=O,this._commands=j,this._provider=G,this._cache=new f.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,j){const G=this._documents.getDocument(O),X=await this._provider.provideCodeLenses(G,j);if(!X||j.isCancellationRequested)return;const pe=this._cache.add(X),we=new S.DisposableStore;this._disposables.set(pe,we);const ce={cacheId:pe,lenses:[]};for(let Ie=0;Ie<X.length;Ie++)ce.lenses.push({cacheId:[pe,Ie],range:I.Range.from(X[Ie].range),command:this._commands.toInternal(X[Ie].command,we)});return ce}async resolveCodeLens(O,j){const G=O.cacheId&&this._cache.get(...O.cacheId);if(!G)return;let X;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?X=G:X=await this._provider.resolveCodeLens(G,j),X||(X=G),j.isCancellationRequested)return;const pe=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!pe)return O.command=this._commands.toInternal(X.command??u._badCmd,pe),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function r(ie){return Array.isArray(ie)?ie.map(I.DefinitionLink.from):ie?[I.DefinitionLink.from(ie)]:[]}class n{constructor(O,j){this._documents=O,this._provider=j}async provideDefinition(O,j,G){const X=this._documents.getDocument(O),pe=I.Position.to(j),we=await this._provider.provideDefinition(X,pe,G);return r(we)}}class o{constructor(O,j){this._documents=O,this._provider=j}async provideDeclaration(O,j,G){const X=this._documents.getDocument(O),pe=I.Position.to(j),we=await this._provider.provideDeclaration(X,pe,G);return r(we)}}class d{constructor(O,j){this._documents=O,this._provider=j}async provideImplementation(O,j,G){const X=this._documents.getDocument(O),pe=I.Position.to(j),we=await this._provider.provideImplementation(X,pe,G);return r(we)}}class s{constructor(O,j){this._documents=O,this._provider=j}async provideTypeDefinition(O,j,G){const X=this._documents.getDocument(O),pe=I.Position.to(j),we=await this._provider.provideTypeDefinition(X,pe,G);return r(we)}}class a{constructor(O,j){this._documents=O,this._provider=j}async provideHover(O,j,G){const X=this._documents.getDocument(O),pe=I.Position.to(j),we=await this._provider.provideHover(X,pe,G);if(!(!we||(0,L.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=X.getWordRangeAtPosition(pe)),we.range||(we.range=new P.Range(pe,pe)),I.Hover.from(we)}}class m{constructor(O,j){this._documents=O,this._provider=j}async provideEvaluatableExpression(O,j,G){const X=this._documents.getDocument(O),pe=I.Position.to(j),we=await this._provider.provideEvaluatableExpression(X,pe,G);if(we)return I.EvaluatableExpression.from(we)}}class _{constructor(O,j){this._documents=O,this._provider=j}async provideInlineValues(O,j,G,X){const pe=this._documents.getDocument(O),we=await this._provider.provideInlineValues(pe,I.Range.to(j),I.InlineValueContext.to(G),X);if(Array.isArray(we))return we.map(ce=>I.InlineValue.from(ce))}}class R{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentHighlights(O,j,G){const X=this._documents.getDocument(O),pe=I.Position.to(j),we=await this._provider.provideDocumentHighlights(X,pe,G);if(Array.isArray(we))return we.map(I.DocumentHighlight.from)}}class M{constructor(O,j){this._documents=O,this._provider=j}async provideLinkedEditingRanges(O,j,G){const X=this._documents.getDocument(O),pe=I.Position.to(j),we=await this._provider.provideLinkedEditingRanges(X,pe,G);if(we&&Array.isArray(we.ranges))return{ranges:(0,L.coalesce)(we.ranges.map(I.Range.from)),wordPattern:we.wordPattern}}}class U{constructor(O,j){this._documents=O,this._provider=j}async provideReferences(O,j,G,X){const pe=this._documents.getDocument(O),we=I.Position.to(j),ce=await this._provider.provideReferences(pe,we,G,X);if(Array.isArray(ce))return ce.map(I.location.from)}}class A{constructor(O,j,G,X,pe,we,ce){this._documents=O,this._commands=j,this._diagnostics=G,this._provider=X,this._logService=pe,this._extension=we,this._apiDeprecation=ce,this._cache=new f.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,j,G,X){const pe=this._documents.getDocument(O),we=E.Selection.isISelection(j)?I.Selection.to(j):I.Range.to(j),ce=[];for(const Ye of this._diagnostics.getDiagnostics(O))if(we.intersection(Ye.range)&&ce.push(Ye)>A._maxCodeActionsPerFile)break;const Ie={diagnostics:ce,only:G.only?new P.CodeActionKind(G.only):void 0,triggerKind:I.CodeActionTriggerKind.to(G.trigger)},ye=await this._provider.provideCodeActions(pe,we,Ie,X);if(!(0,L.isNonEmptyArray)(ye)||X.isCancellationRequested)return;const We=this._cache.add(ye),qe=new S.DisposableStore;this._disposables.set(We,qe);const Ze=[];for(let Ye=0;Ye<ye.length;Ye++){const Ne=ye[Ye];!Ne||(A._isCommand(Ne)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:Ne.title,command:this._commands.toInternal(Ne,qe)})):(Ie.only&&(Ne.kind?Ie.only.contains(Ne.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action is of kind '${Ne.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[We,Ye],title:Ne.title,command:Ne.command&&this._commands.toInternal(Ne.command,qe),diagnostics:Ne.diagnostics&&Ne.diagnostics.map(I.Diagnostic.from),edit:Ne.edit&&I.WorkspaceEdit.from(Ne.edit,void 0),kind:Ne.kind&&Ne.kind.value,isPreferred:Ne.isPreferred,disabled:Ne.disabled?.reason})))}return{cacheId:We,actions:Ze}}async resolveCodeAction(O,j){const[G,X]=O,pe=this._cache.get(G,X);if(!pe||A._isCommand(pe)||!this._provider.resolveCodeAction)return;const we=await this._provider.resolveCodeAction(pe,j)??pe;return we?.edit?I.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}A._maxCodeActionsPerFile=1e3;class z{constructor(O,j,G,X){this._proxy=O,this._documents=j,this._provider=G,this._handle=X}async prepareDocumentPaste(O,j,G,X){if(!this._provider.prepareDocumentPaste)return;const pe=this._documents.getDocument(O),we=j.map(Ie=>I.Range.to(Ie)),ce=I.DataTransfer.toDataTransfer(G,()=>{throw new h.NotImplementedError});return await this._provider.prepareDocumentPaste(pe,we,ce,X),I.DataTransfer.toDataTransferDTO(ce)}async providePasteEdits(O,j,G,X,pe){const we=this._documents.getDocument(j),ce=G.map(We=>I.Range.to(We)),Ie=I.DataTransfer.toDataTransfer(X,async We=>(await this._proxy.$resolvePasteFileData(this._handle,O,We)).buffer),ye=await this._provider.provideDocumentPasteEdits(we,ce,Ie,pe);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?I.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class ${constructor(O,j){this._documents=O,this._provider=j}async provideDocumentFormattingEdits(O,j,G){const X=this._documents.getDocument(O),pe=await this._provider.provideDocumentFormattingEdits(X,j,G);if(Array.isArray(pe))return pe.map(I.TextEdit.from)}}class N{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentRangeFormattingEdits(O,j,G,X){const pe=this._documents.getDocument(O),we=I.Range.to(j),ce=await this._provider.provideDocumentRangeFormattingEdits(pe,we,G,X);if(Array.isArray(ce))return ce.map(I.TextEdit.from)}}class V{constructor(O,j){this._documents=O,this._provider=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,j,G,X,pe){const we=this._documents.getDocument(O),ce=I.Position.to(j),Ie=await this._provider.provideOnTypeFormattingEdits(we,ce,G,X,pe);if(Array.isArray(Ie))return Ie.map(I.TextEdit.from)}}class B{constructor(O,j){this._provider=O,this._logService=j,this._cache=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,j){const G=await this._provider.provideWorkspaceSymbols(O,j);if(!(0,L.isNonEmptyArray)(G))return{symbols:[]};const X=this._cache.add(G),pe={cacheId:X,symbols:[]};for(let we=0;we<G.length;we++){const ce=G[we];if(!ce||!ce.name){this._logService.warn("INVALID SymbolInformation",ce);continue}pe.symbols.push({...I.WorkspaceSymbol.from(ce),cacheId:[X,we]})}return pe}async resolveWorkspaceSymbol(O,j){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const G=this._cache.get(...O.cacheId);if(G){const X=await this._provider.resolveWorkspaceSymbol(G,j);return X&&(0,t.mixin)(O,I.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class F{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,j,G){this._documents=O,this._provider=j,this._logService=G}async provideRenameEdits(O,j,G,X){const pe=this._documents.getDocument(O),we=I.Position.to(j);try{const ce=await this._provider.provideRenameEdits(pe,we,G,X);return ce?I.WorkspaceEdit.from(ce):void 0}catch(ce){const Ie=F._asMessage(ce);return Ie?{rejectReason:Ie,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(O,j,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(O),pe=I.Position.to(j);try{const we=await this._provider.prepareRename(X,pe,G);let ce,Ie;if(P.Range.isRange(we)?(ce=we,Ie=X.getText(we)):(0,C.isObject)(we)&&(ce=we.range,Ie=we.placeholder),!ce||!Ie)return;if(ce.start.line>pe.line||ce.end.line<pe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ce),text:Ie}}catch(we){const ce=F._asMessage(we);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(we)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class x{constructor(O,j){this.resultId=O,this.tokens=j}}class H{constructor(O,j){this._documents=O,this._provider=j,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,j,G){const X=this._documents.getDocument(O),pe=j!==0?this._previousResults.get(j):null;let we=typeof pe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,pe.resultId,G):await this._provider.provideDocumentSemanticTokens(X,G);return pe&&this._previousResults.delete(j),we?(we=H._fixProvidedSemanticTokens(we),this._send(H._convertToEdits(pe,we),we)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return H._isSemanticTokens(O)?H._isCorrectSemanticTokens(O)?O:new P.SemanticTokens(new Uint32Array(O.data),O.resultId):H._isSemanticTokensEdits(O)?H._isCorrectSemanticTokensEdits(O)?O:new P.SemanticTokensEdits(O.edits.map(j=>new P.SemanticTokensEdit(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const j of O.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,j){if(!H._isSemanticTokens(j)||!O||!O.tokens)return j;const G=O.tokens,X=G.length,pe=j.data,we=pe.length;let ce=0;const Ie=Math.min(X,we);for(;ce<Ie&&G[ce]===pe[ce];)ce++;if(ce===X&&ce===we)return new P.SemanticTokensEdits([],j.resultId);let ye=0;const We=Ie-ce;for(;ye<We&&G[X-ye-1]===pe[we-ye-1];)ye++;return new P.SemanticTokensEdits([{start:ce,deleteCount:X-ce-ye,data:pe.subarray(ce,we-ye)}],j.resultId)}_send(O,j){if(H._isSemanticTokens(O)){const G=this._nextResultId++;return this._previousResults.set(G,new x(O.resultId,O.data)),(0,p.encodeSemanticTokensDto)({id:G,type:"full",data:O.data})}if(H._isSemanticTokensEdits(O)){const G=this._nextResultId++;return H._isSemanticTokens(j)?this._previousResults.set(G,new x(j.resultId,j.data)):this._previousResults.set(G,new x(O.resultId)),(0,p.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(O.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=H;class Q{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentRangeSemanticTokens(O,j,G){const X=this._documents.getDocument(O),pe=await this._provider.provideDocumentRangeSemanticTokens(X,I.Range.to(j),G);return pe?this._send(pe):null}_send(O){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}e.DocumentRangeSemanticTokensAdapter=Q;class K{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,j,G,X,pe){this._documents=O,this._commands=j,this._provider=G,this._apiDeprecation=X,this._extension=pe,this._cache=new f.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(O,j,G,X){const pe=this._documents.getDocument(O),we=I.Position.to(j),ce=pe.getWordRangeAtPosition(we)||new P.Range(we,we),Ie=ce.with({end:we}),ye=new v.StopWatch(!0),We=await this._provider.provideCompletionItems(pe,we,X,I.CompletionContext.to(G));if(!We||X.isCancellationRequested)return;const qe=Array.isArray(We)?new P.CompletionList(We):We,Ze=K.supportsResolving(this._provider)?this._cache.add(qe.items):this._cache.add([]),Ye=new S.DisposableStore;this._disposables.set(Ze,Ye);const Ne=[],at={x:Ze,b:Ne,a:{replace:I.Range.from(ce),insert:I.Range.from(Ie)},c:qe.isIncomplete||void 0,d:ye.elapsed()};for(let re=0;re<qe.items.length;re++){const se=qe.items[re],Ee=this._convertCompletionItem(se,[Ze,re],Ie,ce);Ne.push(Ee)}return at}async resolveCompletionItem(O,j){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...O);if(!G)return;const X=await this._provider.resolveCompletionItem(G,j);if(!!X)return this._convertCompletionItem(X,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,j,G,X){const pe=this._disposables.get(j[0]);if(!pe)throw Error("DisposableStore is missing...");const we={x:j,a:O.label,b:O.kind!==void 0?I.CompletionItemKind.from(O.kind):void 0,n:O.tags&&O.tags.map(I.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:I.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters,l:O.additionalTextEdits&&O.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(O.command,pe)};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=O.textEdit.newText):typeof O.insertText=="string"?we.h=O.insertText:O.insertText instanceof P.SnippetString&&(we.h=O.insertText.value,we.i|=4);let ce;return O.textEdit?ce=O.textEdit.range:O.range&&(ce=O.range),P.Range.isRange(ce)?we.j=I.Range.from(ce):ce&&(!G?.isEqual(ce.inserting)||!X?.isEqual(ce.replacing))&&(we.j={insert:I.Range.from(ce.inserting),replace:I.Range.from(ce.replacing)}),we}}class de{async provideInlineCompletions(O,j,G,X){}disposeCompletions(O){}handleDidShowCompletionItem(O,j){}}class ee extends de{constructor(O,j,G,X){super(),this._extension=O,this._documents=j,this._provider=G,this._commands=X,this._references=new Y,this._isAdditionsProposedApiEnabled=(0,g.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[y.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,g.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,j,G,X){const pe=this._documents.getDocument(O),we=I.Position.to(j),ce=await this._provider.provideInlineCompletionItems(pe,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:I.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!ce||X.isCancellationRequested)return;const Ie=Array.isArray(ce)?ce:ce.items,ye=this._isAdditionsProposedApiEnabled?Array.isArray(ce)?[]:ce.commands||[]:[];let We;return{pid:this._references.createReferenceId({dispose(){We?.dispose()},items:Ie}),items:Ie.map((Ze,Ye)=>{let Ne;Ze.command&&(We||(We=new S.DisposableStore),Ne=this._commands.toInternal(Ze.command,We));const at=Ze.insertText;return{insertText:typeof at=="string"?at:{snippet:at.value},filterText:Ze.filterText,range:Ze.range?I.Range.from(Ze.range):void 0,command:Ne,idx:Ye,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>(We||(We=new S.DisposableStore),this._commands.toInternal(Ze,We)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,j){const G=this._references.get(O)?.items[j];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class he extends de{constructor(O,j,G,X){super(),this.extension=O,this._documents=j,this._provider=G,this._commands=X,this._references=new Y,this.isAdditionProposedApiEnabled=(0,g.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKindNew.Automatic,[y.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(O,j,G,X){const pe=this._documents.getDocument(O),we=I.Position.to(j),ce=await this._provider.provideInlineCompletionItems(pe,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:I.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!ce||X.isCancellationRequested)return;const Ie=Array.isArray(ce)?ce:ce.items,ye=Array.isArray(ce)?[]:ce.commands||[];let We;return{pid:this._references.createReferenceId({dispose(){We?.dispose()},items:Ie}),items:Ie.map((Ze,Ye)=>{let Ne;Ze.command&&(We||(We=new S.DisposableStore),Ne=this._commands.toInternal(Ze.command,We));const at=Ze.insertText;return{insertText:typeof at=="string"?at:{snippet:at.value},filterText:Ze.filterText,range:Ze.range?I.Range.from(Ze.range):void 0,command:Ne,idx:Ye,completeBracketPairs:this.isAdditionProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>(We||(We=new S.DisposableStore),this._commands.toInternal(Ze,We)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,j){const G=this._references.get(O)?.items[j];G&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class Y{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const j=this._idPool++;return this._references.set(j,O),j}disposeReferenceId(O){const j=this._references.get(O);return this._references.delete(O),j}get(O){return this._references.get(O)}}class me{constructor(O,j){this._documents=O,this._provider=j,this._cache=new f.Cache("SignatureHelp")}async provideSignatureHelp(O,j,G,X){const pe=this._documents.getDocument(O),we=I.Position.to(j),ce=this.reviveContext(G),Ie=await this._provider.provideSignatureHelp(pe,we,X,ce);if(Ie){const ye=this._cache.add([Ie]);return{...I.SignatureHelp.from(Ie),id:ye}}}reviveContext(O){let j;if(O.activeSignatureHelp){const G=I.SignatureHelp.to(O.activeSignatureHelp),X=this._cache.get(O.activeSignatureHelp.id,0);X?(j=X,j.activeSignature=G.activeSignature,j.activeParameter=G.activeParameter):j=G}return{...O,activeSignatureHelp:j}}releaseSignatureHelp(O){this._cache.delete(O)}}class be{constructor(O,j,G,X,pe){this._documents=O,this._commands=j,this._provider=G,this._logService=X,this._extension=pe,this._cache=new f.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,j,G){const X=this._documents.getDocument(O),pe=I.Range.to(j),we=await this._provider.provideInlayHints(X,pe,G);if(!Array.isArray(we)||we.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${j}`);return}if(G.isCancellationRequested)return;const ce=this._cache.add(we);this._disposables.set(ce,new S.DisposableStore);const Ie={hints:[],cacheId:ce};for(let ye=0;ye<we.length;ye++)this._isValidInlayHint(we[ye],pe)&&Ie.hints.push(this._convertInlayHint(we[ye],[ce,ye]));return this._logService.trace(`[InlayHints] ${Ie.hints.length} inlay hints from '${this._extension.identifier.value}' for ${j}`),Ie}async resolveInlayHint(O,j){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...O);if(!G)return;const X=await this._provider.resolveInlayHint(G,j);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,j){return O.label.length===0||Array.isArray(O.label)&&O.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(j&&!j.contains(O.position))}_convertInlayHint(O,j){const G=this._disposables.get(j[0]);if(!G)throw Error("DisposableStore is missing...");const X={label:"",cacheId:j,tooltip:I.MarkdownString.fromStrict(O.tooltip),position:I.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(I.TextEdit.from),kind:O.kind&&I.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?X.label=O.label:X.label=O.label.map(pe=>{const we={label:pe.value};return we.tooltip=I.MarkdownString.fromStrict(pe.tooltip),P.Location.isLocation(pe.location)&&(we.location=I.location.from(pe.location)),pe.command&&(we.command=this._commands.toInternal(pe.command,G)),we}),X}}class ke{constructor(O,j){this._documents=O,this._provider=j,this._cache=new f.Cache("DocumentLink")}async provideLinks(O,j){const G=this._documents.getDocument(O),X=await this._provider.provideDocumentLinks(G,j);if(!(!Array.isArray(X)||X.length===0)&&!j.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(ke._validateLink).map(I.DocumentLink.from)};{const pe=this._cache.add(X),we={links:[],cacheId:pe};for(let ce=0;ce<X.length;ce++){if(!ke._validateLink(X[ce]))continue;const Ie=I.DocumentLink.from(X[ce]);Ie.cacheId=[pe,ce],we.links.push(Ie)}return we}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,j){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...O);if(!G)return;const X=await this._provider.resolveDocumentLink(G,j);if(!(!X||!ke._validateLink(X)))return I.DocumentLink.from(X)}releaseLinks(O){this._cache.delete(O)}}class Re{constructor(O,j){this._documents=O,this._provider=j}async provideColors(O,j){const G=this._documents.getDocument(O),X=await this._provider.provideDocumentColors(G,j);return Array.isArray(X)?X.map(we=>({color:I.Color.from(we.color),range:I.Range.from(we.range)})):[]}async provideColorPresentations(O,j,G){const X=this._documents.getDocument(O),pe=I.Range.to(j.range),we=I.Color.to(j.color),ce=await this._provider.provideColorPresentations(we,{document:X,range:pe},G);if(!!Array.isArray(ce))return ce.map(I.ColorPresentation.from)}}class ze{constructor(O,j){this._documents=O,this._provider=j}async provideFoldingRanges(O,j,G){const X=this._documents.getDocument(O),pe=await this._provider.provideFoldingRanges(X,j,G);if(!!Array.isArray(pe))return pe.map(I.FoldingRange.from)}}class oe{constructor(O,j,G){this._documents=O,this._provider=j,this._logService=G}async provideSelectionRanges(O,j,G){const X=this._documents.getDocument(O),pe=j.map(I.Position.to),we=await this._provider.provideSelectionRanges(X,pe,G);if(!(0,L.isNonEmptyArray)(we))return[];if(we.length!==pe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Ie=0;Ie<pe.length;Ie++){const ye=[];ce.push(ye);let We=pe[Ie],qe=we[Ie];for(;;){if(!qe.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(ye.push(I.SelectionRange.from(qe)),!qe.parent)break;We=qe.range,qe=qe.parent}}return ce}}class le{constructor(O,j){this._documents=O,this._provider=j,this._idPool=new b.IdGenerator(""),this._cache=new Map}async prepareSession(O,j,G){const X=this._documents.getDocument(O),pe=I.Position.to(j),we=await this._provider.prepareCallHierarchy(X,pe,G);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ie=>this._cacheAndConvertItem(ce,Ie)):[this._cacheAndConvertItem(ce,we)]}async provideCallsTo(O,j,G){const X=this._itemFromCache(O,j);if(!X)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyIncomingCalls(X,G);if(!!pe)return pe.map(we=>({from:this._cacheAndConvertItem(O,we.from),fromRanges:we.fromRanges.map(ce=>I.Range.from(ce))}))}async provideCallsFrom(O,j,G){const X=this._itemFromCache(O,j);if(!X)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyOutgoingCalls(X,G);if(!!pe)return pe.map(we=>({to:this._cacheAndConvertItem(O,we.to),fromRanges:we.fromRanges.map(ce=>I.Range.from(ce))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,j){const G=this._cache.get(O),X=I.CallHierarchyItem.from(j,O,G.size.toString(36));return G.set(X._itemId,j),X}_itemFromCache(O,j){return this._cache.get(O)?.get(j)}}class ge{constructor(O,j){this._documents=O,this._provider=j,this._idPool=new b.IdGenerator(""),this._cache=new Map}async prepareSession(O,j,G){const X=this._documents.getDocument(O),pe=I.Position.to(j),we=await this._provider.prepareTypeHierarchy(X,pe,G);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ie=>this._cacheAndConvertItem(ce,Ie)):[this._cacheAndConvertItem(ce,we)]}async provideSupertypes(O,j,G){const X=this._itemFromCache(O,j);if(!X)throw new Error("missing type hierarchy item");const pe=await this._provider.provideTypeHierarchySupertypes(X,G);if(!!pe)return pe.map(we=>this._cacheAndConvertItem(O,we))}async provideSubtypes(O,j,G){const X=this._itemFromCache(O,j);if(!X)throw new Error("missing type hierarchy item");const pe=await this._provider.provideTypeHierarchySubtypes(X,G);if(!!pe)return pe.map(we=>this._cacheAndConvertItem(O,we))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,j){const G=this._cache.get(O),X=I.TypeHierarchyItem.from(j,O,G.size.toString(36));return G.set(X._itemId,j),X}_itemFromCache(O,j){return this._cache.get(O)?.get(j)}}class Z{constructor(O,j,G,X){this._proxy=O,this._documents=j,this._provider=G,this._handle=X}async provideDocumentOnDropEdits(O,j,G,X,pe){const we=this._documents.getDocument(j),ce=I.Position.to(G),Ie=I.DataTransfer.toDataTransfer(X,async We=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,We)).buffer),ye=await this._provider.provideDocumentDropEdits(we,ce,Ie,pe);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?I.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class ae{constructor(O,j){this.adapter=O,this.extension=j}}class ne{constructor(O,j,G,X,pe,we,ce){this._adapter=new Map,this._uriTransformer=j,this._proxy=O.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=G,this._commands=X,this._diagnostics=pe,this._logService=we,this._apiDeprecation=ce}_transformDocumentSelector(O){return I.DocumentSelector.from(O,this._uriTransformer)}_createDisposable(O){return new P.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return ne._handlePool++}async _withAdapter(O,j,G,X,pe,we=!1){const ce=this._adapter.get(O);if(!ce||!(ce.adapter instanceof j))return X;const Ie=Date.now();we||this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const ye=G(ce.adapter,ce.extension);return Promise.resolve(ye).catch(We=>{(0,h.isCancellationError)(We)||(this._logService.error(`[${ce.extension.identifier.value}] provider FAILED`),this._logService.error(We))}).finally(()=>{we||this._logService.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Ie}ms`)}),T.CancellationToken.isCancellationToken(pe)?(0,c.raceCancellationError)(ye,pe):ye}_addNewAdapter(O,j){const G=this._nextHandle();return this._adapter.set(G,new ae(O,j)),G}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,j,G,X){const pe=this._addNewAdapter(new i(this._documents,G),O),we=X&&X.label||ne._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(pe,this._transformDocumentSelector(j),we),this._createDisposable(pe)}$provideDocumentSymbols(O,j,G){return this._withAdapter(O,i,X=>X.provideDocumentSymbols(l.URI.revive(j),G),void 0,G)}registerCodeLensProvider(O,j,G){const X=this._nextHandle(),pe=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new u(this._documents,this._commands.converter,G),O)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(j),pe);let we=this._createDisposable(X);if(pe!==void 0){const ce=G.onDidChangeCodeLenses(Ie=>this._proxy.$emitCodeLensEvent(pe));we=P.Disposable.from(we,ce)}return we}$provideCodeLenses(O,j,G){return this._withAdapter(O,u,X=>X.provideCodeLenses(l.URI.revive(j),G),void 0,G)}$resolveCodeLens(O,j,G){return this._withAdapter(O,u,X=>X.resolveCodeLens(j,G),void 0,void 0)}$releaseCodeLenses(O,j){this._withAdapter(O,u,G=>Promise.resolve(G.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(O,j,G){const X=this._addNewAdapter(new n(this._documents,G),O);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDefinition(O,j,G,X){return this._withAdapter(O,n,pe=>pe.provideDefinition(l.URI.revive(j),G,X),[],X)}registerDeclarationProvider(O,j,G){const X=this._addNewAdapter(new o(this._documents,G),O);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDeclaration(O,j,G,X){return this._withAdapter(O,o,pe=>pe.provideDeclaration(l.URI.revive(j),G,X),[],X)}registerImplementationProvider(O,j,G){const X=this._addNewAdapter(new d(this._documents,G),O);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideImplementation(O,j,G,X){return this._withAdapter(O,d,pe=>pe.provideImplementation(l.URI.revive(j),G,X),[],X)}registerTypeDefinitionProvider(O,j,G){const X=this._addNewAdapter(new s(this._documents,G),O);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideTypeDefinition(O,j,G,X){return this._withAdapter(O,s,pe=>pe.provideTypeDefinition(l.URI.revive(j),G,X),[],X)}registerHoverProvider(O,j,G,X){const pe=this._addNewAdapter(new a(this._documents,G),O);return this._proxy.$registerHoverProvider(pe,this._transformDocumentSelector(j)),this._createDisposable(pe)}$provideHover(O,j,G,X){return this._withAdapter(O,a,pe=>pe.provideHover(l.URI.revive(j),G,X),void 0,X)}registerEvaluatableExpressionProvider(O,j,G,X){const pe=this._addNewAdapter(new m(this._documents,G),O);return this._proxy.$registerEvaluatableExpressionProvider(pe,this._transformDocumentSelector(j)),this._createDisposable(pe)}$provideEvaluatableExpression(O,j,G,X){return this._withAdapter(O,m,pe=>pe.provideEvaluatableExpression(l.URI.revive(j),G,X),void 0,X)}registerInlineValuesProvider(O,j,G,X){const pe=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new _(this._documents,G),O);this._proxy.$registerInlineValuesProvider(we,this._transformDocumentSelector(j),pe);let ce=this._createDisposable(we);if(pe!==void 0){const Ie=G.onDidChangeInlineValues(ye=>this._proxy.$emitInlineValuesEvent(pe));ce=P.Disposable.from(ce,Ie)}return ce}$provideInlineValues(O,j,G,X,pe){return this._withAdapter(O,_,we=>we.provideInlineValues(l.URI.revive(j),G,X,pe),void 0,pe)}registerDocumentHighlightProvider(O,j,G){const X=this._addNewAdapter(new R(this._documents,G),O);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDocumentHighlights(O,j,G,X){return this._withAdapter(O,R,pe=>pe.provideDocumentHighlights(l.URI.revive(j),G,X),void 0,X)}registerLinkedEditingRangeProvider(O,j,G){const X=this._addNewAdapter(new M(this._documents,G),O);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideLinkedEditingRanges(O,j,G,X){return this._withAdapter(O,M,async pe=>{const we=await pe.provideLinkedEditingRanges(l.URI.revive(j),G,X);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ne._serializeRegExp(we.wordPattern):void 0}},void 0,X)}registerReferenceProvider(O,j,G){const X=this._addNewAdapter(new U(this._documents,G),O);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideReferences(O,j,G,X,pe){return this._withAdapter(O,U,we=>we.provideReferences(l.URI.revive(j),G,X,pe),void 0,pe)}registerCodeActionProvider(O,j,G,X){const pe=new S.DisposableStore,we=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,G,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(j),{providedKinds:X?.providedCodeActionKinds?.map(ce=>ce.value),documentation:X?.documentation?.map(ce=>({kind:ce.kind.value,command:this._commands.converter.toInternal(ce.command,pe)}))},ne._extLabel(O),Boolean(G.resolveCodeAction)),pe.add(this._createDisposable(we)),pe}$provideCodeActions(O,j,G,X,pe){return this._withAdapter(O,A,we=>we.provideCodeActions(l.URI.revive(j),G,X,pe),void 0,pe)}$resolveCodeAction(O,j,G){return this._withAdapter(O,A,X=>X.resolveCodeAction(j,G),void 0,void 0)}$releaseCodeActions(O,j){this._withAdapter(O,A,G=>Promise.resolve(G.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(O,j,G){const X=this._addNewAdapter(new $(this._documents,G),O);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(j),O.identifier,O.displayName||O.name),this._createDisposable(X)}$provideDocumentFormattingEdits(O,j,G,X){return this._withAdapter(O,$,pe=>pe.provideDocumentFormattingEdits(l.URI.revive(j),G,X),void 0,X)}registerDocumentRangeFormattingEditProvider(O,j,G){const X=this._addNewAdapter(new N(this._documents,G),O);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(j),O.identifier,O.displayName||O.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(O,j,G,X,pe){return this._withAdapter(O,N,we=>we.provideDocumentRangeFormattingEdits(l.URI.revive(j),G,X,pe),void 0,pe)}registerOnTypeFormattingEditProvider(O,j,G,X){const pe=this._addNewAdapter(new V(this._documents,G),O);return this._proxy.$registerOnTypeFormattingSupport(pe,this._transformDocumentSelector(j),X,O.identifier),this._createDisposable(pe)}$provideOnTypeFormattingEdits(O,j,G,X,pe,we){return this._withAdapter(O,V,ce=>ce.provideOnTypeFormattingEdits(l.URI.revive(j),G,X,pe,we),void 0,we)}registerWorkspaceSymbolProvider(O,j){const G=this._addNewAdapter(new B(j,this._logService),O);return this._proxy.$registerNavigateTypeSupport(G,typeof j.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(O,j,G){return this._withAdapter(O,B,X=>X.provideWorkspaceSymbols(j,G),{symbols:[]},G)}$resolveWorkspaceSymbol(O,j,G){return this._withAdapter(O,B,X=>X.resolveWorkspaceSymbol(j,G),void 0,void 0)}$releaseWorkspaceSymbols(O,j){this._withAdapter(O,B,G=>G.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(O,j,G){const X=this._addNewAdapter(new F(this._documents,G,this._logService),O);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(j),F.supportsResolving(G)),this._createDisposable(X)}$provideRenameEdits(O,j,G,X,pe){return this._withAdapter(O,F,we=>we.provideRenameEdits(l.URI.revive(j),G,X,pe),void 0,pe)}$resolveRenameLocation(O,j,G,X){return this._withAdapter(O,F,pe=>pe.resolveRenameLocation(l.URI.revive(j),G,X),void 0,X)}registerDocumentSemanticTokensProvider(O,j,G,X){const pe=this._addNewAdapter(new H(this._documents,G),O),we=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(pe,this._transformDocumentSelector(j),X,we);let ce=this._createDisposable(pe);if(we){const Ie=G.onDidChangeSemanticTokens(ye=>this._proxy.$emitDocumentSemanticTokensEvent(we));ce=P.Disposable.from(ce,Ie)}return ce}$provideDocumentSemanticTokens(O,j,G,X){return this._withAdapter(O,H,pe=>pe.provideDocumentSemanticTokens(l.URI.revive(j),G,X),null,X)}$releaseDocumentSemanticTokens(O,j){this._withAdapter(O,H,G=>G.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,j,G,X){const pe=this._addNewAdapter(new Q(this._documents,G),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(pe,this._transformDocumentSelector(j),X),this._createDisposable(pe)}$provideDocumentRangeSemanticTokens(O,j,G,X){return this._withAdapter(O,Q,pe=>pe.provideDocumentRangeSemanticTokens(l.URI.revive(j),G,X),null,X)}registerCompletionItemProvider(O,j,G,X){const pe=this._addNewAdapter(new K(this._documents,this._commands.converter,G,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(pe,this._transformDocumentSelector(j),X,K.supportsResolving(G),`${O.identifier.value}(${X.join("")})`),this._createDisposable(pe)}$provideCompletionItems(O,j,G,X,pe){return this._withAdapter(O,K,we=>we.provideCompletionItems(l.URI.revive(j),G,X,pe),void 0,pe)}$resolveCompletionItem(O,j,G){return this._withAdapter(O,K,X=>X.resolveCompletionItem(j,G),void 0,G)}$releaseCompletionItems(O,j){this._withAdapter(O,K,G=>G.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(O,j,G){const X=new ee(O,this._documents,G,this._commands.converter),pe=this._addNewAdapter(X,O);return this._proxy.$registerInlineCompletionsSupport(pe,this._transformDocumentSelector(j),X.supportsHandleDidShowCompletionItem),this._createDisposable(pe)}registerInlineCompletionsProviderNew(O,j,G){const X=this._addNewAdapter(new he(O,this._documents,G,this._commands.converter),O);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector(j),!0),this._createDisposable(X)}$provideInlineCompletions(O,j,G,X,pe){return this._withAdapter(O,de,we=>we.provideInlineCompletions(l.URI.revive(j),G,X,pe),void 0,pe)}$handleInlineCompletionDidShow(O,j,G){this._withAdapter(O,de,async X=>{X.handleDidShowCompletionItem(j,G)},void 0,void 0)}$freeInlineCompletionsList(O,j){this._withAdapter(O,de,async G=>{G.disposeCompletions(j)},void 0,void 0)}registerSignatureHelpProvider(O,j,G,X){const pe=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,we=this._addNewAdapter(new me(this._documents,G),O);return this._proxy.$registerSignatureHelpProvider(we,this._transformDocumentSelector(j),pe),this._createDisposable(we)}$provideSignatureHelp(O,j,G,X,pe){return this._withAdapter(O,me,we=>we.provideSignatureHelp(l.URI.revive(j),G,X,pe),void 0,pe)}$releaseSignatureHelp(O,j){this._withAdapter(O,me,G=>G.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(O,j,G){const X=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,pe=this._addNewAdapter(new be(this._documents,this._commands.converter,G,this._logService,O),O);this._proxy.$registerInlayHintsProvider(pe,this._transformDocumentSelector(j),typeof G.resolveInlayHint=="function",X,ne._extLabel(O));let we=this._createDisposable(pe);if(X!==void 0){const ce=G.onDidChangeInlayHints(Ie=>this._proxy.$emitInlayHintsEvent(X));we=P.Disposable.from(we,ce)}return we}$provideInlayHints(O,j,G,X){return this._withAdapter(O,be,pe=>pe.provideInlayHints(l.URI.revive(j),G,X),void 0,X)}$resolveInlayHint(O,j,G){return this._withAdapter(O,be,X=>X.resolveInlayHint(j,G),void 0,G)}$releaseInlayHints(O,j){this._withAdapter(O,be,G=>G.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(O,j,G){const X=this._addNewAdapter(new ke(this._documents,G),O);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(j),typeof G.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(O,j,G){return this._withAdapter(O,ke,X=>X.provideLinks(l.URI.revive(j),G),void 0,G,j.scheme==="output")}$resolveDocumentLink(O,j,G){return this._withAdapter(O,ke,X=>X.resolveLink(j,G),void 0,void 0,!0)}$releaseDocumentLinks(O,j){this._withAdapter(O,ke,G=>G.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(O,j,G){const X=this._addNewAdapter(new Re(this._documents,G),O);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDocumentColors(O,j,G){return this._withAdapter(O,Re,X=>X.provideColors(l.URI.revive(j),G),[],G)}$provideColorPresentations(O,j,G,X){return this._withAdapter(O,Re,pe=>pe.provideColorPresentations(l.URI.revive(j),G,X),void 0,X)}registerFoldingRangeProvider(O,j,G){const X=this._nextHandle(),pe=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new ze(this._documents,G),O)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(j),pe);let we=this._createDisposable(X);if(pe!==void 0){const ce=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(pe));we=P.Disposable.from(we,ce)}return we}$provideFoldingRanges(O,j,G,X){return this._withAdapter(O,ze,pe=>pe.provideFoldingRanges(l.URI.revive(j),G,X),void 0,X)}registerSelectionRangeProvider(O,j,G){const X=this._addNewAdapter(new oe(this._documents,G,this._logService),O);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideSelectionRanges(O,j,G,X){return this._withAdapter(O,oe,pe=>pe.provideSelectionRanges(l.URI.revive(j),G,X),[],X)}registerCallHierarchyProvider(O,j,G){const X=this._addNewAdapter(new le(this._documents,G),O);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$prepareCallHierarchy(O,j,G,X){return this._withAdapter(O,le,pe=>Promise.resolve(pe.prepareSession(l.URI.revive(j),G,X)),void 0,X)}$provideCallHierarchyIncomingCalls(O,j,G,X){return this._withAdapter(O,le,pe=>pe.provideCallsTo(j,G,X),void 0,X)}$provideCallHierarchyOutgoingCalls(O,j,G,X){return this._withAdapter(O,le,pe=>pe.provideCallsFrom(j,G,X),void 0,X)}$releaseCallHierarchy(O,j){this._withAdapter(O,le,G=>Promise.resolve(G.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(O,j,G){const X=this._addNewAdapter(new ge(this._documents,G),O);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$prepareTypeHierarchy(O,j,G,X){return this._withAdapter(O,ge,pe=>Promise.resolve(pe.prepareSession(l.URI.revive(j),G,X)),void 0,X)}$provideTypeHierarchySupertypes(O,j,G,X){return this._withAdapter(O,ge,pe=>pe.provideSupertypes(j,G,X),void 0,X)}$provideTypeHierarchySubtypes(O,j,G,X){return this._withAdapter(O,ge,pe=>pe.provideSubtypes(j,G,X),void 0,X)}$releaseTypeHierarchy(O,j){this._withAdapter(O,ge,G=>Promise.resolve(G.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(O,j,G){const X=this._nextHandle();return this._adapter.set(X,new ae(new Z(this._proxy,this._documents,G,X),O)),this._proxy.$registerDocumentOnDropEditProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDocumentOnDropEdits(O,j,G,X,pe,we){return this._withAdapter(O,Z,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(j,l.URI.revive(G),X,pe,we)),void 0,void 0)}registerDocumentPasteEditProvider(O,j,G,X){const pe=this._nextHandle();return this._adapter.set(pe,new ae(new z(this._proxy,this._documents,G,pe),O)),this._proxy.$registerPasteEditProvider(pe,this._transformDocumentSelector(j),!!G.prepareDocumentPaste,X.pasteMimeTypes),this._createDisposable(pe)}$prepareDocumentPaste(O,j,G,X,pe){return this._withAdapter(O,z,we=>we.prepareDocumentPaste(l.URI.revive(j),G,X,pe),void 0,pe)}$providePasteEdits(O,j,G,X,pe,we){return this._withAdapter(O,z,ce=>ce.providePasteEdits(j,l.URI.revive(G),X,pe,we),void 0,we)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,w.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:ne._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:ne._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?ne._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?ne._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:ne._serializeRegExp(O.beforeText),afterText:O.afterText?ne._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?ne._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(ne._serializeOnEnterRule)}setLanguageConfiguration(O,j,G){const{wordPattern:X}=G;if(X&&(0,w.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(j,X):this._documents.setWordDefinitionFor(j,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const pe=this._nextHandle(),we={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ne._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?ne._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ne._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(pe,j,we),this._createDisposable(pe)}$setWordDefinitions(O){for(const j of O)this._documents.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.ExtHostLanguageFeatures=ne,ne._handlePool=0}),define(Ce[253],De([1,0,5,15,7,42,18,6]),function(J,e,l,t,I,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class w{constructor(L,C,E,T){this._documents=C,this._commands=E,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(l.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,C){await this._proxy.$changeLanguage(L,C);const E=this._documents.getDocumentData(L);if(!E)throw new Error(`document '${L.toString()}' NOT found`);return E.document}async tokenAtPosition(L,C){const E=L.version,T=t.Position.from(C),S=await this._proxy.$tokensAtPosition(L.uri,T),p={type:I.StandardTokenType.Other,range:L.getWordRangeAtPosition(C)??new I.Range(C.line,C.character,C.line,C.character)};if(!S)return p;const b={range:t.Range.to(S.range),type:t.TokenType.to(S.type)};return!b.range.contains(C)||E!==L.version?p:b}createLanguageStatusItem(L,C,E){const T=this._handlePool++,S=this._proxy,p=this._ids,b=`${L.identifier.value}/${C}`;if(p.has(b))throw new Error(`LanguageStatusItem with id '${C}' ALREADY exists`);p.add(b);const f={selector:E,id:C,name:L.displayName??L.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const h=new D.DisposableStore,c=()=>{v?.dispose(),v=(0,y.disposableTimeout)(()=>{h.clear(),this._proxy.$setLanguageStatus(T,{id:b,name:f.name??L.displayName??L.name,source:L.displayName??L.name,selector:t.DocumentSelector.from(f.selector,this._uriTransformer),label:f.text,detail:f.detail??"",severity:f.severity===I.LanguageStatusSeverity.Error?P.default.Error:f.severity===I.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:f.command&&this._commands.toInternal(f.command,h),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},g={dispose(){h.dispose(),v?.dispose(),S.$removeLanguageStatus(T),p.delete(b)},get id(){return f.id},get name(){return f.name},set name(i){f.name=i,c()},get selector(){return f.selector},set selector(i){f.selector=i,c()},get text(){return f.text},set text(i){f.text=i,c()},get detail(){return f.detail},set detail(i){f.detail=i,c()},get severity(){return f.severity},set severity(i){f.severity=i,c()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(i){f.accessibilityInformation=i,c()},get command(){return f.command},set command(i){f.command=i,c()},get busy(){return f.busy},set busy(i){f.busy=i,c()}};return c(),g}}e.ExtHostLanguages=w}),define(Ce[92],De([1,0,10,8,2,3,12,5,25,16]),function(J,e,l,t,I,P,y,D,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(E,T,S){this.logService=S,this.bundleCache=new Map,this._proxy=T.getProxy(D.MainContext.MainThreadLocalization),this.currentLanguage=E.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===l.LANGUAGE_DEFAULT}getMessage(E,T){const{message:S,args:p,comment:b}=T;if(this.isDefaultLanguage)return(0,t.format2)(S,p??{});let f=S;b&&b.length>0&&(f+=`/${Array.isArray(b)?b.join():b}`);const v=this.bundleCache.get(E)?.contents[f];return v||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,t.format2)(v??f,p??{})}getBundle(E){return this.bundleCache.get(E)?.contents}getBundleUri(E){return this.bundleCache.get(E)?.uri}async initializeLocalizedMessages(E){if(this.isDefaultLanguage||!E.l10n&&!E.isBuiltin||this.bundleCache.has(E.identifier.value))return;let T;const S=await this.getBundleLocation(E);if(!S){this.logService.error(`No bundle location found for extension ${E.identifier.value}`);return}try{const p=await this._proxy.$fetchBundleContents(S),b=JSON.parse(p);T=E.isBuiltin?b.contents?.bundle:b}catch(p){this.logService.error(`Failed to load translations for ${E.identifier.value} from ${S}: ${p.message}`);return}T&&this.bundleCache.set(E.identifier.value,{contents:T,uri:S})}async getBundleLocation(E){if(E.isBuiltin){const T=await this._proxy.$fetchBuiltInBundleUri(E.identifier.value);return I.URI.revive(T)}return E.l10n?I.URI.joinPath(E.extensionLocation,E.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};L=je([He(0,w.IExtHostInitDataService),He(1,k.IExtHostRpcService),He(2,y.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,P.createDecorator)("IExtHostLocalizationService")}),define(Ce[137],De([1,0,12,5,25,16,4]),function(J,e,l,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends l.AbstractLoggerService{constructor(L,C){const E=new y.Emitter;super(C.logLevel,E.event),this._proxy=L.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(E)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,C,E){return new w(this._proxy,L,C,E)}};D=je([He(0,P.IExtHostRpcService),He(1,I.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class w extends l.AbstractMessageLogger{constructor(L,C,E,T){super(T?.always),this.proxy=L,this.file=C,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(E),this.proxy.$createLogger(C,T).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,C){const E=[[L,C]];this.isLoggerCreated?this.doLog(E):this.buffer.push(...E)}doLog(L){this.proxy.$log(this.file,L)}}}),define(Ce[254],De([1,0,5,12,28]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(D){return D&&D.title}let y=class{constructor(w,k){this._logService=k,this._proxy=w.getProxy(l.MainContext.MainThreadMessageService)}showMessage(w,k,L,C,E){const T={source:{identifier:w.identifier,label:w.displayName||w.name}};let S;typeof C=="string"||P(C)?S=[C,...E]:(T.modal=C?.modal,T.useCustom=C?.useCustom,T.detail=C?.detail,S=E),T.useCustom&&(0,I.checkProposedApiEnabled)(w,"resolvers");const p=[];for(let b=0;b<S.length;b++){const f=S[b];if(typeof f=="string")p.push({title:f,handle:b,isCloseAffordance:!1});else if(typeof f=="object"){const{title:v,isCloseAffordance:h}=f;p.push({title:v,isCloseAffordance:!!h,handle:b})}else this._logService.warn("Invalid message item:",f)}return this._proxy.$showMessage(k,L,T,p).then(b=>{if(typeof b=="number")return S[b]})}};y=je([He(1,t.ILogService)],y),e.ExtHostMessageService=y}),define(Ce[255],De([1,0,23,4,6,26,8,13,2,87,5,39,15,7,56,230,133]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(h=>h.apiEditor)}constructor(h,c,g,i){this._textDocumentsAndEditors=g,this._textDocuments=i,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new k.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=h.getProxy(L.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=h.getProxy(L.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=h.getProxy(L.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===12){const r=u.notebookEditor?.notebookUri,n=u.cell.handle,d=this._documents.get(r)?.getCell(n);if(d)return d.apiCell}return u}}),f._registerApiCommands(c)}getEditorById(h){const c=this._editors.get(h);if(!c)throw new Error(`unknown text editor: ${h}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(h){for(const[c,g]of this._editors)if(g.apiEditor===h)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(h,c){const g=this._documents.get(h);if(!g&&!c)throw new Error(`NO notebook document for '${h}'`);return g}_getProviderData(h){const c=this._notebookContentProviders.get(h);if(!c)throw new Error(`NO provider for '${h}'`);return c}registerNotebookContentProvider(h,c,g,i,u){if((0,y.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);return this._notebookContentProviders.set(c,{extension:h,provider:g}),this._notebookProxy.$registerNotebookProvider({id:h.identifier,location:h.extensionLocation},c,E.NotebookDocumentContentOptions.from(i),f._convertNotebookRegistrationData(h,u)),new T.Disposable(()=>{this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(h,c){if(!c)return;const g=c.filenamePattern.map(i=>E.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(c.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:c.displayName,filenamePattern:g,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,c,g){const i=f._notebookStatusBarItemProviderHandlePool++,u=typeof g.onDidChangeCellStatusBarItems=="function"?f._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,u,c);let r;return u!==void 0&&(r=g.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(u))),new T.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,u),r?.dispose()})}async createNotebookDocument(h){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:h.viewType,content:h.content&&E.NotebookData.from(h.content)});return w.URI.revive(c)}async openNotebookDocument(h){const c=this._documents.get(h);if(c)return c.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(h),i=this._documents.get(w.URI.revive(g));return(0,D.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(h,c){w.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let g;typeof c=="object"?g={position:E.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(E.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:g={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(h.uri,h.notebookType,g),u=i&&this._editors.get(i)?.apiEditor;if(u)return u;throw i?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,c,g,i){const u=this._notebookStatusBarItemProviders.get(h),r=w.URI.revive(c),n=this._documents.get(r);if(!n||!u)return;const o=n.getCellFromIndex(g);if(!o)return;const d=await u.provideCellStatusBarItems(o.apiCell,i);if(!d)return;const s=new I.DisposableStore,a=this._statusBarCache.add([s]),_=(Array.isArray(d)?d:[d]).map(R=>E.NotebookStatusBarItem.from(R,this._commandsConverter,s));return{cacheId:a,items:_}}$releaseNotebookCellStatusBarItems(h){this._statusBarCache.delete(h)}registerNotebookSerializer(h,c,g,i,u){if((0,y.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,g),this._notebookProxy.$registerNotebookSerializer(r,{id:h.identifier,location:h.extensionLocation},c,E.NotebookDocumentContentOptions.from(i),f._convertNotebookRegistrationData(h,u)),(0,I.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(h,c,g){const i=this._notebookSerializer.get(h);if(!i)throw new Error("NO serializer found");const u=await i.deserializeNotebook(c.buffer,g);return new S.SerializableObjectWithBuffers(E.NotebookData.from(u))}async $notebookToData(h,c,g){const i=this._notebookSerializer.get(h);if(!i)throw new Error("NO serializer found");const u=await i.serializeNotebook(E.NotebookData.to(c.value),g);return l.VSBuffer.wrap(u)}async $openNotebook(h,c,g,i,u){const{provider:r}=this._getProviderData(h),n=await r.openNotebook(w.URI.revive(c),{backupId:g,untitledDocumentData:i?.buffer},u);return new S.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(E.NotebookCellData.from)})}_createExtHostEditor(h,c,g){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const i=new b.ExtHostNotebookEditor(c,this._notebookEditorsProxy,h,g.visibleRanges.map(E.NotebookRange.to),g.selections.map(E.NotebookRange.to),typeof g.viewColumn=="number"?E.ViewColumn.to(g.viewColumn):void 0);this._editors.set(c,i)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const g of h.value.removedDocuments){const i=w.URI.revive(g),u=this._documents.get(i);u&&(u.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:u.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(u.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===i.toString()&&this._editors.delete(r.id)}if(h.value.addedDocuments){const g=[];for(const i of h.value.addedDocuments){const u=w.URI.revive(i.uri);if(this._documents.has(u))throw new Error(`adding EXISTING notebook ${u} `);const r=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,u,i);g.push(...i.cells.map(n=>p.ExtHostCell.asModelAddData(r.apiNotebook,n))),this._documents.get(u)?.dispose(),this._documents.set(u,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(h.value.addedEditors)for(const g of h.value.addedEditors){if(this._editors.has(g.id))return;const i=w.URI.revive(g.documentUri),u=this._documents.get(i);u&&this._createExtHostEditor(u,g.id,g)}const c=[];if(h.value.removedEditors)for(const g of h.value.removedEditors){const i=this._editors.get(g);i&&(this._editors.delete(g),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),c.push(i))}if(h.value.visibleEditors){this._visibleNotebookEditors=h.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const g=new Set;this._visibleNotebookEditors.forEach(i=>g.add(i.id));for(const i of this._editors.values()){const u=g.has(i.id);i._acceptVisibility(u)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this._activeNotebookEditor=void 0:h.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(h){const c=C.ApiCommandArgument.String.with("notebookType","A notebook type"),g=new C.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[c,new C.ApiCommandArgument("data","Bytes to convert to data",u=>u instanceof Uint8Array,u=>l.VSBuffer.wrap(u))],new C.ApiCommandResult("Notebook Data",u=>E.NotebookData.to(u.value))),i=new C.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[c,new C.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",u=>!0,u=>new S.SerializableObjectWithBuffers(E.NotebookData.from(u)))],new C.ApiCommandResult("Bytes",u=>u.buffer));h.registerApiCommand(g),h.registerApiCommand(i)}}e.ExtHostNotebookController=f,f._notebookStatusBarItemProviderHandlePool=0}),define(Ce[256],De([1,0,17,18,21,4,6,26,2,27,12,5,39,15,7,88,218,28,56]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let h=class{constructor(n,o,d,s,a){this._initData=o,this._extHostNotebook=d,this._commands=s,this._logService=a,this._activeExecutions=new D.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=n.getProxy(C.MainContext.MainThreadNotebookKernels);const m=new E.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new E.ApiCommandArgument("options","Select kernel options",_=>!0,_=>{if(_&&"notebookEditor"in _&&"id"in _){const R=this._extHostNotebook.getIdByEditor(_.notebookEditor);return{id:_.id,extension:_.extension,notebookEditorId:R}}else if(_&&"notebookEditor"in _){const R=this._extHostNotebook.getIdByEditor(_.notebookEditor);if(R===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${_.notebookEditor.document.uri.toString()}`);return{notebookEditorId:R}}return _})],E.ApiCommandResult.Void);this._commands.registerApiCommand(m)}createNotebookController(n,o,d,s,a,m){for(const K of this._kernelData.values())if(K.controller.id===o&&k.ExtensionIdentifier.equals(n.identifier,K.extensionId))throw new Error(`notebook controller with id '${o}' ALREADY exist`);const _=this._handlePool++,R=this;this._logService.trace(`NotebookController[${_}], CREATED by ${n.identifier.value}, ${o}`);const M=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${n.identifier}'`);let U=!1;const A=new y.DisposableStore,z=new P.Emitter,$=new P.Emitter,N={id:u(n.identifier,o),notebookType:d,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:s||n.identifier.value,preloads:m?m.map(T.NotebookRendererScript.from):[]};let V=a??M,B;this._proxy.$addKernel(_,N).catch(K=>{console.log(K),U=!0});let F=0;const x=()=>{if(U)return;const K=++F;Promise.resolve().then(()=>{K===F&&this._proxy.$updateKernel(_,N)})},H=new D.ResourceMap,Q={get id(){return o},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return N.label},set label(K){N.label=K??n.displayName??n.name,x()},get detail(){return N.detail??""},set detail(K){N.detail=K,x()},get description(){return N.description??""},set description(K){N.description=K,x()},get kind(){return(0,f.checkProposedApiEnabled)(n,"notebookControllerKind"),N.kind??""},set kind(K){(0,f.checkProposedApiEnabled)(n,"notebookControllerKind"),N.kind=K,x()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(K){N.supportedLanguages=K,x()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(K){N.supportsExecutionOrder=K,x()},get rendererScripts(){return N.preloads?N.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(K){V=K??M},get interruptHandler(){return B},set interruptHandler(K){B=K,N.supportsInterrupt=Boolean(K),x()},createNotebookCellExecution(K){if(U)throw new Error("notebook controller is DISPOSED");if(!H.has(K.notebook.uri))throw R._logService.trace(`NotebookController[${_}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${K.notebook.uri.toString()}`);return R._createNotebookCellExecution(K,u(n.identifier,this.id))},dispose:()=>{U||(this._logService.trace(`NotebookController[${_}], DISPOSED`),U=!0,this._kernelData.delete(_),A.dispose(),z.dispose(),$.dispose(),this._proxy.$removeKernel(_))},updateNotebookAffinity(K,de){de===S.NotebookControllerAffinity2.Hidden&&(0,f.checkProposedApiEnabled)(n,"notebookControllerAffinityHidden"),R._proxy.$updateNotebookPriority(_,K.uri,de)},onDidReceiveMessage:$.event,postMessage(K,de){return(0,f.checkProposedApiEnabled)(n,"notebookMessaging"),R._proxy.$postMessage(_,de&&R._extHostNotebook.getIdByEditor(de),K)},asWebviewUri(K){return(0,f.checkProposedApiEnabled)(n,"notebookMessaging"),(0,p.asWebviewUri)(K,R._initData.remote)}};return this._kernelData.set(_,{extensionId:n.identifier,controller:Q,onDidReceiveMessage:$,onDidChangeSelection:z,associatedNotebooks:H}),Q}getIdByController(n){for(const[o,d]of this._kernelData)if(d.controller===n)return u(d.extensionId,n.id);return null}$acceptNotebookAssociation(n,o,d){const s=this._kernelData.get(n);if(s){const a=this._extHostNotebook.getNotebookDocument(w.URI.revive(o));d?s.associatedNotebooks.set(a.uri,!0):s.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,a.uri.toString(),d),s.onDidChangeSelection.fire({selected:d,notebook:a.apiNotebook})}}async $executeCells(n,o,d){const s=this._kernelData.get(n);if(!s)return;const a=this._extHostNotebook.getNotebookDocument(w.URI.revive(o)),m=[];for(const _ of d){const R=a.getCell(_);R&&m.push(R.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,a.uri.toString(),m.length),await s.controller.executeHandler.call(s.controller,m,a.apiNotebook,s.controller)}catch(_){this._logService.error(`NotebookController[${n}] execute cells FAILED`,_),console.error(_)}}async $cancelCells(n,o,d){const s=this._kernelData.get(n);if(!s)return;const a=this._extHostNotebook.getNotebookDocument(w.URI.revive(o));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,a.apiNotebook);else for(const m of d){const _=a.getCell(m);_&&this._activeExecutions.get(_.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,o,d){const s=this._kernelData.get(n);if(!s)return;const a=this._extHostNotebook.getEditorById(o);s.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:d}))}$cellExecutionChanged(n,o,d){const a=this._extHostNotebook.getNotebookDocument(w.URI.revive(n)).getCell(o);if(a){const m=d?T.NotebookCellExecutionState.to(d):S.NotebookCellExecutionState.Idle;m!==void 0&&this._onDidChangeCellExecutionState.fire({cell:a.apiCell,state:m})}}_createNotebookCellExecution(n,o){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const a=new g(o,s,this._proxy);this._activeExecutions.set(s.uri,a);const m=a.onDidChangeState(()=>{a.state===c.Resolved&&(a.dispose(),m.dispose(),this._activeExecutions.delete(s.uri))});return a.asApiObject()}};h=je([He(4,L.ILogService)],h),e.ExtHostNotebookKernels=h;var c;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(c||(c={}));class g extends y.Disposable{get state(){return this._state}constructor(n,o,d){super(),this._cell=o,this._proxy=d,this._handle=g.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new i(10,s=>this.update(s)),this._executionOrder=o.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,n,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const o=Array.isArray(n)?n:[n];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(o))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let o=this._cell;if(n&&(o=this._cell.notebook.getCellFromApiCell(n)),!o)throw new Error("INVALID cell");return o.handle}validateAndConvertOutputs(n){return n.map(o=>{const d=S.NotebookCellOutput.ensureUniqueMimeTypes(o.items,!0);return d===o.items?T.NotebookCellOutput.from(o):T.NotebookCellOutput.from({items:d,id:o.id,metadata:o.metadata})})}async updateOutputs(n,o,d){const s=this.cellIndexToHandle(o),a=this.validateAndConvertOutputs((0,l.asArray)(n));return this.updateSoon({editType:b.CellExecutionUpdateType.Output,cellHandle:s,append:d,outputs:a})}async updateOutputItems(n,o,d){return n=S.NotebookCellOutput.ensureUniqueMimeTypes((0,l.asArray)(n),!0),this.updateSoon({editType:b.CellExecutionUpdateType.OutputItems,items:n.map(T.NotebookCellOutputItem.from),outputId:o.id,append:d})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(d){n._executionOrder=d,n.update([{editType:b.CellExecutionUpdateType.ExecutionState,executionOrder:n._executionOrder}])},start(d){if(n._state===c.Resolved||n._state===c.Started)throw new Error("Cannot call start again");n._state=c.Started,n._onDidChangeState.fire(),n.update({editType:b.CellExecutionUpdateType.ExecutionState,runStartTime:d})},end(d,s){if(n._state===c.Resolved)throw new Error("Cannot call resolve twice");n._state=c.Resolved,n._onDidChangeState.fire(),n._collector.flush(),n._proxy.$completeExecution(n._handle,new v.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:d}))},clearOutput(d){return n.verifyStateForOutput(),n.updateOutputs([],d,!1)},appendOutput(d,s){return n.verifyStateForOutput(),n.updateOutputs(d,s,!0)},replaceOutput(d,s){return n.verifyStateForOutput(),n.updateOutputs(d,s,!1)},appendOutputItems(d,s){return n.verifyStateForOutput(),n.updateOutputItems(d,s,!0)},replaceOutputItems(d,s){return n.verifyStateForOutput(),n.updateOutputItems(d,s,!1)}})}}g.HANDLE=0;class i{constructor(n,o){this.delay=n,this.callback=o,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const o=this.batch;return this.batch=[],this.callback(o).finally(()=>n.complete())}}function u(r,n){return`${r.value}/${n}`}e.createKernelId=u}),define(Ce[257],De([1,0,4,5,133]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(D,w){this._extHostNotebook=w,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,w,k){const L=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(w)?.fire({editor:L.apiEditor,message:k})}createRendererMessaging(D,w){if(!D.contributes?.notebookRenderer?.some(L=>L.id===w))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${w})`);return{onDidReceiveMessage:(L,C,E)=>this.getOrCreateEmitterFor(w).event(L,C,E),postMessage:(L,C)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,C]=[C,L]);const E=C&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(C);return this.proxy.$postMessage(E?.id,w,L)}}}getOrCreateEmitterFor(D){let w=this._rendererMessageEmitters.get(D);return w||(w=new l.Emitter({onLastListenerRemove:()=>{w?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,w),w)}}e.ExtHostNotebookRenderers=P}),define(Ce[258],De([1,0,21,4,6,5,2,7,11,17,42,86]),function(J,e,l,t,I,P,y,D,w,k,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(T,S,p){const b=T.getProxy(P.MainContext.MainThreadQuickOpen);class f{constructor(o,d){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=d}showQuickPick(o,d,s=l.CancellationToken.None){this._onDidSelectItem=void 0;const a=Promise.resolve(o),m=++this._instances,_=b.$show(m,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},s),R={},M=_.then(()=>R);return Promise.race([M,a]).then(U=>{if(U!==R)return a.then(A=>{const z=[];for(let $=0;$<A.length;$++){const N=A[$];typeof N=="string"?z.push({label:N,handle:$}):N.kind===D.QuickPickItemKind.Separator?z.push({type:"separator",label:N.label}):z.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:$})}return d&&typeof d.onDidSelectItem=="function"&&(this._onDidSelectItem=$=>{d.onDidSelectItem(A[$])}),b.$setItems(m,z),_.then($=>{if(typeof $=="number")return A[$];if(Array.isArray($))return $.map(N=>A[N])})})}).then(void 0,U=>{if(!(0,w.isCancellationError)(U))return b.$setError(m,U),Promise.reject(U)})}$onItemSelected(o){this._onDidSelectItem?.(o)}showInput(o,d=l.CancellationToken.None){return this._validateInput=o?.validateInput,b.$input(o,typeof this._validateInput=="function",d).then(void 0,s=>{if(!(0,w.isCancellationError)(s))return Promise.reject(s)})}async $validateInput(o){if(!this._validateInput)return;const d=await this._validateInput(o);if(!d||typeof d=="string")return d;let s;switch(d.severity){case D.InputBoxValidationSeverity.Info:s=L.default.Info;break;case D.InputBoxValidationSeverity.Warning:s=L.default.Warning;break;case D.InputBoxValidationSeverity.Error:s=L.default.Error;break;default:s=d.message?L.default.Error:L.default.Ignore;break}return{content:d.message,severity:s}}async showWorkspaceFolderPick(o,d=l.CancellationToken.None){const s=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!s)return;const a=await this._workspace.getWorkspaceFolders2();if(!!a)return a.find(m=>m.uri.toString()===s.uri.toString())}createQuickPick(o){const d=new u(o,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}createInputBox(o){const d=new r(o,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(o,d){this._sessions.get(o)?._fireDidChangeValue(d)}$onDidAccept(o){this._sessions.get(o)?._fireDidAccept()}$onDidChangeActive(o,d){const s=this._sessions.get(o);s instanceof u&&s._fireDidChangeActive(d)}$onDidChangeSelection(o,d){const s=this._sessions.get(o);s instanceof u&&s._fireDidChangeSelection(d)}$onDidTriggerButton(o,d){this._sessions.get(o)?._fireDidTriggerButton(d)}$onDidTriggerItemButton(o,d,s){const a=this._sessions.get(o);a instanceof u&&a._fireDidTriggerItemButton(d,s)}$onDidHide(o){this._sessions.get(o)?._fireDidHide()}}class v{constructor(o,d){this._extensionId=o,this._onDidDispose=d,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new t.Emitter,this._onDidChangeValueEmitter=new t.Emitter,this._onDidTriggerButtonEmitter=new t.Emitter,this._onDidHideEmitter=new t.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((d,s)=>{const a=d===D.QuickInputButtons.Back?-1:s;this._handlesToButtons.set(a,d)}),this.update({buttons:o.map((d,s)=>({...i(d),tooltip:d.tooltip,handle:d===D.QuickInputButtons.Back?-1:s}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const d=this._handlesToButtons.get(o);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(o){if(!this._disposed){for(const d of Object.keys(o)){const s=o[d];this._pendingUpdate[d]=s===void 0?null:s}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function h(n){if(n instanceof D.ThemeIcon)return{id:n.id};const o=g(n),d=c(n);return{dark:typeof o=="string"?y.URI.file(o):o,light:typeof d=="string"?y.URI.file(d):d}}function c(n){return typeof n=="object"&&"light"in n?n.light:n}function g(n){return typeof n=="object"&&"dark"in n?n.dark:n}function i(n){const o=h(n.iconPath);let d,s;return"id"in o?s=C.ThemeIcon.asClassName(o):d=o,{iconPath:d,iconClass:s}}class u extends v{constructor(o,d){super(o.identifier,d),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new t.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new t.Emitter,this._onDidTriggerItemButtonEmitter=new t.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((s,a)=>{this._handlesToItems.set(a,s),this._itemsToHandles.set(s,a)});const d=[];for(let s=0;s<o.length;s++){const a=o[s];a.kind===D.QuickPickItemKind.Separator?d.push({type:"separator",label:a.label}):d.push({handle:s,label:a.label,description:a.description,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow,buttons:a.buttons?.map((m,_)=>({...i(m),tooltip:m.tooltip,handle:_}))})}this.update({items:d})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(o){const d=(0,k.coalesce)(o.map(s=>this._handlesToItems.get(s)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(o){const d=(0,k.coalesce)(o.map(s=>this._handlesToItems.get(s)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(o,d){const s=this._handlesToItems.get(o);if(!s||!s.buttons||!s.buttons.length)return;const a=s.buttons[d];a&&this._onDidTriggerItemButtonEmitter.fire({button:a,item:s})}}class r extends v{constructor(o,d){super(o.identifier,d),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,o?typeof o=="string"?this.update({validationMessage:o,severity:L.default.Error}):this.update({validationMessage:o.message,severity:o.severity??L.default.Error}):this.update({validationMessage:void 0,severity:L.default.Ignore})}}return new f(S,p)}e.createExtHostQuickOpen=E});var Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)},tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,l):I?I.value=l:e.set(J,l),l};define(Ce[259],De([1,0,2,4,59,6,18,5,17,106,12,27,86,15,28]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S){"use strict";var p,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(a){if(a)return typeof a.iconPath=="string"?l.URI.file(a.iconPath):l.URI.isUri(a.iconPath)||E.ThemeIcon.isThemeIcon(a.iconPath)?a.iconPath:void 0}function v(a,m){if(!a.iconPath&&!m.iconPath)return 0;if(a.iconPath){if(!m.iconPath)return 1}else return-1;const _=typeof a.iconPath=="string"?a.iconPath:l.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id,R=typeof m.iconPath=="string"?m.iconPath:l.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,k.comparePaths)(_,R)}function h(a,m){let _=0;if(a.strikeThrough!==m.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==m.faded)return a.faded?1:-1;if(a.tooltip!==m.tooltip)return(a.tooltip||"").localeCompare(m.tooltip||"");if(_=v(a,m),_!==0)return _;if(a.light&&m.light)_=v(a.light,m.light);else{if(a.light)return 1;if(m.light)return-1}if(_!==0)return _;if(a.dark&&m.dark)_=v(a.dark,m.dark);else{if(a.dark)return 1;if(m.dark)return-1}return _}function c(a,m){if(a.command!==m.command)return a.command<m.command?-1:1;if(a.title!==m.title)return a.title<m.title?-1:1;if(a.tooltip!==m.tooltip){if(a.tooltip!==void 0&&m.tooltip!==void 0)return a.tooltip<m.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(a.arguments===m.arguments)return 0;if(a.arguments)if(m.arguments){if(a.arguments.length!==m.arguments.length)return a.arguments.length-m.arguments.length}else return 1;else return-1;for(let _=0;_<a.arguments.length;_++){const R=a.arguments[_],M=m.arguments[_];if(R!==M)return R<M?-1:1}return 0}function g(a,m){let _=(0,k.comparePaths)(a.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(_!==0)return _;if(a.command&&m.command)_=c(a.command,m.command);else{if(a.command)return 1;if(m.command)return-1}if(_!==0)return _;if(a.decorations&&m.decorations)_=h(a.decorations,m.decorations);else{if(a.decorations)return 1;if(m.decorations)return-1}return _}function i(a,m){for(let _=0;_<a.length;_++)if(a[_]!==m[_])return!1;return!0}function u(a,m){return a.command===m.command&&a.title===m.title&&a.tooltip===m.tooltip&&(a.arguments&&m.arguments?i(a.arguments,m.arguments):a.arguments===m.arguments)}function r(a,m){return(0,w.equals)(a,m,u)}class n{get value(){return this._value}set value(m){m=m??"",Be(this,p,"f").$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){Be(this,p,"f").$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,S.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(m){if((0,S.checkProposedApiEnabled)(this._extension,"scmValidation"),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,Be(this,p,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get enabled(){return this._enabled}set enabled(m){m=!!m,this._enabled!==m&&(this._enabled=m,Be(this,p,"f").$setInputBoxEnablement(this._sourceControlHandle,m))}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,Be(this,p,"f").$setInputBoxVisibility(this._sourceControlHandle,m))}constructor(m,_,R){this._extension=m,this._sourceControlHandle=R,p.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,tt(this,p,_,"f")}showValidationMessage(m,_){(0,S.checkProposedApiEnabled)(this._extension,"scmValidation"),Be(this,p,"f").$showValidationMessage(this._sourceControlHandle,m,_)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=n,p=new WeakMap;class o{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}constructor(m,_,R,M,U){this._proxy=m,this._commands=_,this._sourceControlHandle=R,this._id=M,this._label=U,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=o._handlePool++}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,_){const R=this._resourceStatesCommandsMap.get(m);return R?(0,y.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],_)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(g),R=(0,w.sortedDiff)(this._resourceSnapshot,m,g).map(A=>{const z=A.toInsert.map($=>{const N=this._resourceHandlePool++;this._resourceStatesMap.set(N,$);const V=$.resourceUri;let B;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const me=new P.DisposableStore;B=this._commands.converter.toInternal($.command,me),this._resourceStatesDisposablesMap.set(N,me)}else this._resourceStatesCommandsMap.set(N,$.command);const F=f($.decorations),x=$.decorations&&f($.decorations.light)||F,H=$.decorations&&f($.decorations.dark)||F,Q=[x,H],K=$.decorations&&$.decorations.tooltip||"",de=$.decorations&&!!$.decorations.strikeThrough,ee=$.decorations&&!!$.decorations.faded,he=$.contextValue||"";return{rawResource:[N,V,Q,K,de,ee,he,B],handle:N}});return{start:A.start,deleteCount:A.deleteCount,toInsert:z}}),M=R.map(({start:A,deleteCount:z,toInsert:$})=>[A,z,$.map(N=>N.rawResource)]),U=R.reverse();for(const{start:A,deleteCount:z,toInsert:$}of U){const N=$.map(B=>B.handle),V=this._handlesSnapshot.splice(A,z,...N);for(const B of V)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=m,M}dispose(){this._disposed=!0,this._onDidDispose.fire()}}o._handlePool=0;class d{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,Be(this,b,"f").$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,Be(this,b,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,Be(this,b,"f").$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=m;const _=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);Be(this,b,"f").$updateSourceControl(this.handle,{acceptInputCommand:_})}get actionButton(){return(0,S.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(m){(0,S.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=m;const _=m!==void 0?{command:this._commands.converter.toInternal(m.command,this._actionButtonDisposables.value),secondaryCommands:m.secondaryCommands?.map(R=>R.map(M=>this._commands.converter.toInternal(M,this._actionButtonDisposables.value))),description:m.description,enabled:m.enabled}:void 0;Be(this,b,"f").$updateSourceControl(this.handle,{actionButton:_??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&r(this._statusBarCommands,m))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=m;const _=(m||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));Be(this,b,"f").$updateSourceControl(this.handle,{statusBarCommands:_})}get selected(){return this._selected}constructor(m,_,R,M,U,A){this._extension=m,this._commands=R,this._id=M,this._label=U,this._rootUri=A,b.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=d._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,b,_,"f"),this._inputBox=new n(m,Be(this,b,"f"),this.handle),Be(this,b,"f").$registerSourceControl(this.handle,M,U,A)}createResourceGroup(m,_){const R=new o(Be(this,b,"f"),this._commands,this.handle,m,_),M=t.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,M),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const m=[],_=[];for(const[R,M]of this.createdResourceGroups){M.dispose();const U=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});t.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),U.dispose(),this._groups.delete(R.handle),Be(this,b,"f").$unregisterGroup(this.handle,R.handle)}),m.push([R.handle,R.id,R.label,R.features]);const A=R._takeResourceStateSnapshot();A.length>0&&_.push([R.handle,A]),this._groups.set(R.handle,R)}Be(this,b,"f").$registerGroups(this.handle,m,_),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(_=>{const R=_._takeResourceStateSnapshot();R.length!==0&&m.push([_.handle,R])}),m.length>0&&Be(this,b,"f").$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),Be(this,b,"f").$unregisterSourceControl(this.handle)}}b=new WeakMap,d._handlePool=0,je([(0,I.debounce)(100)],d.prototype,"eventuallyAddResourceGroups",null),je([(0,I.debounce)(100)],d.prototype,"eventuallyUpdateResourceStates",null);let s=class Zn{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(m,_,R){this._commands=_,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=m.getProxy(D.MainContext.MainThreadSCM),this._telemetry=m.getProxy(D.MainContext.MainThreadTelemetry),_.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const U=this._sourceControls.get(M.sourceControlHandle);if(!U)return M;const A=U.getResourceGroup(M.groupHandle);return A?A.getResourceState(M.handle):M}else if(M&&M.$mid===4){const U=this._sourceControls.get(M.sourceControlHandle);return U?U.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const U=this._sourceControls.get(M.handle);return U||M}return M}})}createSourceControl(m,_,R,M){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,_,R,M),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const U=Zn._handlePool++,A=new d(m,this._proxy,this._commands,_,R,M);this._sourceControls.set(U,A);const z=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(m.identifier))||[];return z.push(A),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(m.identifier),z),A}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const _=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(m.identifier)),R=_&&_[_.length-1];return R&&R.inputBox}$provideOriginalResource(m,_,R){const M=l.URI.revive(_);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,M.toString());const U=this._sourceControls.get(m);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>U.quickDiffProvider.provideOriginalResource(M,R)).then(A=>A||null)}$onInputBoxValueChange(m,_){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const R=this._sourceControls.get(m);return R&&R.inputBox.$onInputBoxValueChange(_),Promise.resolve(void 0)}$executeResourceCommand(m,_,R,M){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,_,R);const U=this._sourceControls.get(m);if(!U)return Promise.resolve(void 0);const A=U.getResourceGroup(_);return A?A.$executeResourceCommand(R,M):Promise.resolve(void 0)}$validateInput(m,_,R){this.logService.trace("ExtHostSCM#$validateInput",m);const M=this._sourceControls.get(m);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>M.inputBox.validateInput(_,R)).then(U=>{if(!U)return Promise.resolve(void 0);const A=T.MarkdownString.fromStrict(U.message);return A?Promise.resolve([A,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};s._handlePool=0,s=je([He(2,L.ILogService)],s),e.ExtHostSCM=s}),define(Ce[93],De([1,0,5,4,3]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(D){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(l.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,w){return this._proxy.$getPassword(D,w)}store(D,w,k){return this._proxy.$setPassword(D,w,k)}delete(D,w){return this._proxy.$deletePassword(D,w)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,l):I?I.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[260],De([1,0,7,5,173,6,15,13]),function(J,e,l,t,I,P,y,D){"use strict";var w,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(S,p,b,f,v=l.StatusBarAlignment.Left,h){w.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,w,S,"f"),tt(this,k,p,"f"),this._entryId=L.ID_GEN++,this._extension=b,this._id=f,this._alignment=v,this._priority=this.validatePriority(h)}validatePriority(S){if(!!(0,D.isNumber)(S))return S===Number.POSITIVE_INFINITY?Number.MAX_VALUE:S===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:S}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(S){this._text=S,this.update()}set name(S){this._name=S,this.update()}set tooltip(S){this._tooltip=S,this.update()}set color(S){this._color=S,this.update()}set backgroundColor(S){S&&!L.ALLOWED_BACKGROUND_COLORS.has(S.id)&&(S=void 0),this._backgroundColor=S,this.update()}set command(S){this._command?.fromApi!==S&&(this._internalCommandRegistration.clear(),typeof S=="string"?this._command={fromApi:S,internal:Be(this,k,"f").toInternal({title:"",command:S},this._internalCommandRegistration)}:S?this._command={fromApi:S,internal:Be(this,k,"f").toInternal(S,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(S){this._accessibilityInformation=S,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,w,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let S;this._extension?this._id?S=`${this._extension.identifier.value}.${this._id}`:S=this._extension.identifier.value:S=this._id;let p;this._name?p=this._name:p=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let b=this._color;this._backgroundColor&&(b=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const f=y.MarkdownString.fromStrict(this._tooltip);Be(this,w,"f").$setEntry(this._entryId,S,p,this._text,f,this._command?.internal,b,this._backgroundColor,this._alignment===l.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,w=new WeakMap,k=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new l.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.ThemeColor("statusBarItem.warningForeground")]]);class C{constructor(S){this._messages=[],this._item=S.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(S){const p={message:S};return this._messages.unshift(p),this._update(),new l.Disposable(()=>{const b=this._messages.indexOf(p);b>=0&&(this._messages.splice(b,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class E{constructor(S,p){this._proxy=S.getProxy(t.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new C(this)}createStatusBarEntry(S,p,b,f){return new L(this._proxy,this._commands,S,p,b,f)}setStatusBarMessage(S,p){const b=this._statusMessage.setMessage(S);let f;return typeof p=="number"?f=setTimeout(()=>b.dispose(),p):typeof p<"u"&&p.then(()=>b.dispose(),()=>b.dispose()),new l.Disposable(()=>{b.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=E}),define(Ce[94],De([1,0,5,4,3]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(D){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(l.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,w){this._proxy.$registerExtensionStorageKeysToSync(D,w)}initializeExtensionStorage(D,w,k){return this._proxy.$initializeExtensionStorage(D,w).then(L=>L||k)}setValue(D,w,k){return this._proxy.$setValue(D,w,k)}$acceptValue(D,w,k){this._onDidChangeStorage.fire({shared:D,key:w,value:k})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(Ce[69],De([1,0,3,25,12,68,2]),function(J,e,l,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,l.createDecorator)("IExtensionStoragePaths");let D=class{constructor(k,L,C){this._logService=L,this._extHostFileSystem=C,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(E=>this._value=E)}async _getWorkspaceStorageURI(k){return y.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,L=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:y.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(C){this._logService.error("[ExtHostStorage]",C);return}}workspaceValue(k){if(this._value)return y.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return y.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};D=je([He(0,t.IExtHostInitDataService),He(1,I.ILogService),He(2,P.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(Ce[40],De([1,0,4,5,3,2,16,6,7,174,11,219,21,31,204,86,13,18,15]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class h{constructor(s,a,m,_){this._proxy=s,this._id=a,this._creationOptions=m,this._name=_,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(M=>this._pidPromiseComplete=M);const R=this;this.value={get name(){return R._name||""},get processId(){return R._pidPromise},get creationOptions(){return R._creationOptions},get exitStatus(){return R._exitStatus},get state(){return R._state},sendText(M,U=!0){R._checkDisposed(),R._proxy.$sendText(R._id,M,U)},show(M){R._checkDisposed(),R._proxy.$show(R._id,M)},hide(){R._checkDisposed(),R._proxy.$hide(R._id)},dispose(){R._disposed||(R._disposed=!0,R._proxy.$dispose(R._id))},get dimensions(){if(!(R._cols===void 0||R._rows===void 0))return{columns:R._cols,rows:R._rows}}}}async create(s,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:(0,b.withNullAsUndefined)(s.shellPath),shellArgs:(0,b.withNullAsUndefined)(s.shellArgs),cwd:(0,b.withNullAsUndefined)(s.cwd),env:(0,b.withNullAsUndefined)(s.env),icon:(0,b.withNullAsUndefined)(n(s.iconPath)),color:p.ThemeColor.isThemeColor(s.color)?s.color.id:void 0,initialText:(0,b.withNullAsUndefined)(s.message),strictEnv:(0,b.withNullAsUndefined)(s.strictEnv),hideFromUser:(0,b.withNullAsUndefined)(s.hideFromUser),isFeatureTerminal:(0,b.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,b.withNullAsUndefined)(a?.useShellEnvironment),location:a?.location||this._serializeParentTerminal(s.location,a?.resolvedExtHostIdentifier),isTransient:(0,b.withNullAsUndefined)(s.isTransient)})}async createExtensionTerminal(s,a,m,_){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:p.ThemeColor.isThemeColor(_)?_.id:void 0,location:this._serializeParentTerminal(s,a),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(s,a){return typeof s=="object"?"parentTerminal"in s&&s.parentTerminal&&a?{parentTerminal:a}:"viewColumn"in s?{viewColumn:v.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus}:void 0:s}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitStatus(s,a){this._exitStatus=Object.freeze({code:s,reason:a})}setDimensions(s,a){return s===this._cols&&a===this._rows||s===0||a===0?!1:(this._cols=s,this._rows=a,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=h;class c{get onProcessReady(){return this._onProcessReady.event}constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._onProcessData=new l.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new l.Emitter,this._onDidChangeProperty=new l.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new l.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(s){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${s}`)}updateProperty(s,a){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${s}, value: ${a}`)}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput?.(s)}resize(s,a){this._pty.setDimensions?.({columns:s,rows:a})}async processBinary(s){}acknowledgeDataEvent(s){}async setUnicodeVersion(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose?.((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions?.(a=>{a&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:a.columns,rows:a.rows}})}),this._pty.onDidChangeName?.(a=>{this._onDidChangeProperty.fire({type:"title",value:a})}),this._pty.open(s||void 0),s&&this._pty.setDimensions?.(s),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=c;let g=1,i=class extends D.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(s,a){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new l.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new l.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new l.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new l.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new l.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new l.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=a.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new S.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new l.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[m,_]of this._terminalProcesses)_.shutdown(!0)}})}getDefaultShell(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(s,a){const m=new h(this._proxy,(0,T.generateUuid)(),s,s.name),_=new c(s.pty);return m.createExtensionTerminal(s.location,this._serializeParentTerminal(s,a).resolvedExtHostIdentifier,n(s.iconPath),o(s.color)).then(R=>{const M=this._setupExtHostProcessListeners(R,_);this._terminalProcessDisposables[R]=M}),this._terminals.push(m),m.value}_serializeParentTerminal(s,a){if(a=a||{},s.location&&typeof s.location=="object"&&"parentTerminal"in s.location){const m=s.location.parentTerminal;if(m){const _=this._terminals.find(R=>R.value===m);_&&(a.resolvedExtHostIdentifier=_._id)}}else s.location&&typeof s.location!="object"?a.location=s.location:a.location&&typeof a.location=="object"&&"splitActiveTerminal"in a.location&&(a.location={splitActiveTerminal:!0});return a}attachPtyToTerminal(s,a){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const _=new c(a),R=this._setupExtHostProcessListeners(s,_);this._terminalProcessDisposables[s]=R}async $acceptActiveTerminalChanged(s){const a=this._activeTerminal;if(s===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(s);m&&(this._activeTerminal=m,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,a){const m=this._getTerminalById(s);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:a})}async $acceptTerminalDimensions(s,a,m){const _=this._getTerminalById(s);_&&_.setDimensions(a,m)&&this._onDidChangeTerminalDimensions.fire({terminal:_.value,dimensions:_.value.dimensions})}async $acceptTerminalMaximumDimensions(s,a,m){this._terminalProcesses.get(s)?.resize(a,m)}async $acceptTerminalTitleChange(s,a){const m=this._getTerminalById(s);m&&(m.name=a)}async $acceptTerminalClosed(s,a,m){const _=this._getTerminalObjectIndexById(this._terminals,s);if(_!==null){const R=this._terminals.splice(_,1)[0];R.setExitStatus(a,m),this._onDidCloseTerminal.fire(R.value)}}$acceptTerminalOpened(s,a,m,_){if(a){const U=this._getTerminalObjectIndexById(this._terminals,a);if(U!==null){this._terminals[U]._id=s,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const R={name:_.name,shellPath:_.executable,shellArgs:_.args,cwd:typeof _.cwd=="string"?_.cwd:P.URI.revive(_.cwd),env:_.env,hideFromUser:_.hideFromUser},M=new h(this._proxy,s,R,m);this._terminals.push(M),this._onDidOpenTerminal.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(s,a){this._getTerminalById(s)?._setProcessId(a)}async $startExtensionTerminal(s,a){const m=this._getTerminalById(s);if(!m)return{message:(0,k.localize)(0,null,s)};m.isOpen||await new Promise(R=>{const M=this.onDidOpenTerminal(async U=>{U===m.value&&(M.dispose(),R())})});const _=this._terminalProcesses.get(s);_?_.startSendingEvents(a):this._extensionTerminalAwaitingStart[s]={initialDimensions:a}}_setupExtHostProcessListeners(s,a){const m=new D.DisposableStore;m.add(a.onProcessReady(R=>this._proxy.$sendProcessReady(s,R.pid,R.cwd))),m.add(a.onDidChangeProperty(R=>this._proxy.$sendProcessProperty(s,R))),this._bufferer.startBuffering(s,a.onProcessData),m.add(a.onProcessExit(R=>this._onProcessExit(s,R))),this._terminalProcesses.set(s,a);const _=this._extensionTerminalAwaitingStart[s];return _&&a instanceof c&&(a.startSendingEvents(_.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),m}$acceptProcessAckDataEvent(s,a){this._terminalProcesses.get(s)?.acknowledgeDataEvent(a)}$acceptProcessInput(s,a){this._terminalProcesses.get(s)?.input(a)}$acceptTerminalInteraction(s){const a=this._getTerminalById(s);a?.setInteractedWith()&&this._onDidChangeTerminalState.fire(a.value)}$acceptProcessResize(s,a,m){try{this._terminalProcesses.get(s)?.resize(a,m)}catch(_){if(_.code!=="EPIPE"&&_.code!=="ERR_IPC_CHANNEL_CLOSED")throw _}}$acceptProcessShutdown(s,a){this._terminalProcesses.get(s)?.shutdown(a)}$acceptProcessRequestInitialCwd(s){this._terminalProcesses.get(s)?.getInitialCwd().then(a=>this._proxy.$sendProcessProperty(s,{type:"initialCwd",value:a}))}$acceptProcessRequestCwd(s){this._terminalProcesses.get(s)?.getCwd().then(a=>this._proxy.$sendProcessProperty(s,{type:"cwd",value:a}))}$acceptProcessRequestLatency(s){return Promise.resolve(s)}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new w.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,a,m){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,m),this._proxy.$registerProfileProvider(a,s.identifier.value),new w.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(s,a){const m=new E.CancellationTokenSource().token;let _=await this._profileProviders.get(s)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(_&&!("options"in _)&&(_={options:_}),!_||!("options"in _))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in _.options){this.createExtensionTerminal(_.options,a);return}this.createTerminalFromOptions(_.options,a)}}async $provideLinks(s,a){const m=this._getTerminalById(s);if(!m)return[];this._terminalLinkCache.delete(s),this._terminalLinkCancellationSource.get(s)?.dispose(!0);const R=new E.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,R);const M=[],U={terminal:m.value,line:a},A=[];for(const N of this._linkProviders)A.push(f.Promises.withAsyncBody(async V=>{R.token.onCancellationRequested(()=>V({provider:N,links:[]}));const B=await N.provideTerminalLinks(U,R.token)||[];R.token.isCancellationRequested||V({provider:N,links:B})}));const z=await Promise.all(A);if(R.token.isCancellationRequested)return[];const $=new Map;for(const N of z)N&&N.links.length>0&&M.push(...N.links.map(V=>{const B={id:g++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return $.set(B.id,{provider:N.provider,link:V}),B}));return this._terminalLinkCache.set(s,$),M}$activateLink(s,a){const m=this._terminalLinkCache.get(s)?.get(a);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(s,a){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const m=this._terminalProcessDisposables[s];m&&(m.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,a)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,a){const m=this._getTerminalObjectIndexById(s,a);return m!==null?s[m]:null}_getTerminalObjectIndexById(s,a){let m=null;return s.some((_,R)=>_._id===a?(m=R,!0):!1),m}getEnvironmentVariableCollection(s){let a=this._environmentVariableCollections.get(s.identifier.value);return a||(a=new u,this._setEnvironmentVariableCollection(s.identifier.value,a)),a}_syncEnvironmentVariableCollection(s,a){const m=(0,C.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(s,a.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(s){s.forEach(a=>{const m=a[0],_=new u(a[1]);this._setEnvironmentVariableCollection(m,_)})}$acceptDefaultProfile(s,a){const m=this._defaultProfile;this._defaultProfile=s,this._defaultAutomationProfile=a,m?.path!==s.path&&this._onDidChangeShell.fire(s.path)}_setEnvironmentVariableCollection(s,a){this._environmentVariableCollections.set(s,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,a)})}};i=je([He(1,y.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class u{get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new l.Emitter,this.map=new Map(s)}get size(){return this.map.size}replace(s,a){this._setIfDiffers(s,{value:a,type:w.EnvironmentVariableMutatorType.Replace})}append(s,a){this._setIfDiffers(s,{value:a,type:w.EnvironmentVariableMutatorType.Append})}prepend(s,a){this._setIfDiffers(s,{value:a,type:w.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,a){const m=this.map.get(s);(!m||m.value!==a.value||m.type!==a.type)&&(this.map.set(s,a),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,a){this.map.forEach((m,_)=>s.call(a,_,m,this))}[Symbol.iterator](){return this.map.entries()}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let r=class extends i{constructor(s){super(!1,s)}createTerminal(s,a,m){throw new L.NotSupportedError}createTerminalFromOptions(s,a){throw new L.NotSupportedError}};r=je([He(0,y.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function n(d){if(!(!d||typeof d=="string"))return"id"in d?{id:d.id,color:d.color}:d}function o(d){return p.ThemeColor.isThemeColor(d)?d:void 0}});var Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)},tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,l):I?I.value=l:e.set(J,l),l};define(Ce[261],De([1,0,17,23,21,4,60,79,6,24,13,31,5,16,134,15,7,55,90,66]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f,v,h){"use strict";var c,g;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let i=class{constructor(U,A,z){this.editors=z,this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=U.getProxy(E.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new r(this.proxy),A.registerArgumentProcessor({processArgument:$=>{if($?.$mid!==13)return $;const N=$,V=N.tests[N.tests.length-1].item.extId;return this.controllers.get(f.TestId.root(V))?.collection.tree.get(V)?.actual??(0,S.toItemFromContext)($)}})}createTestController(U,A,z){if(this.controllers.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const $=new w.DisposableStore,N=$.add(new S.ExtHostTestItemCollection(U,A,this.editors));N.root.label=A;const V=new Map,B=this.proxy,F={items:N.root.children,get label(){return A},set label(H){A=H,N.root.label=H,B.$updateController(U,{label:A})},get refreshHandler(){return z},set refreshHandler(H){z=H,B.$updateController(U,{canRefresh:!!H})},get id(){return U},createRunProfile:(H,Q,K,de,ee)=>{let he=(0,D.hash)(H);for(;V.has(he);)he++;return new _(this.proxy,V,U,he,H,Q,K,de,ee)},createTestItem(H,Q,K){return new S.TestItemImpl(U,H,Q,K)},createTestRun:(H,Q,K=!0)=>this.runTracker.createTestRun(U,N,H,Q,K),set resolveHandler(H){N.resolveHandler=H},get resolveHandler(){return N.resolveHandler},dispose:()=>{$.dispose()}};B.$registerTestController(U,A,!!z),$.add((0,w.toDisposable)(()=>B.$unregisterTestController(U)));const x={controller:F,collection:N,profiles:V};return this.controllers.set(U,x),$.add((0,w.toDisposable)(()=>this.controllers.delete(U))),$.add(N.onDidGenerateDiff(H=>B.$publishDiff(U,H.map(h.TestsDiffOp.serialize)))),F}createTestObserver(){return this.observer.checkout()}async runTests(U,A=I.CancellationToken.None){const z=n(U);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const $=this.controllers.get(z.controllerId);if(!$)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(N=>f.TestId.fromExtHostTestItem(N,$.collection.root.id).toString())??[$.collection.root.id],profileGroup:R[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:U.exclude?.map(N=>N.id)},A)}$syncTests(){for(const{collection:U}of this.controllers.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,A,z){return(0,l.mapFind)(this.runTracker.trackers,N=>N.id===U?N.getCoverage(A):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(U,A,z,$){return(0,l.mapFind)(this.runTracker.trackers,V=>V.id===U?V.getCoverage(A):void 0)?.resolveFileCoverage(z,$)??Promise.resolve([])}$configureRunProfile(U,A){this.controllers.get(U)?.profiles.get(A)?.configureHandler?.()}async $refreshTests(U,A){await this.controllers.get(U)?.controller.refreshHandler?.(A)}$publishTestResults(U){this.results=Object.freeze(U.map(A=>(0,k.deepFreeze)(p.TestResults.to(A))).concat(this.results).sort((A,z)=>z.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(U,A){const z=this.controllers.get(f.TestId.fromString(U).controllerId)?.collection;z&&(await z.expand(U,A<0?1/0:A),z.flushDiff())}$acceptDiff(U){this.observer.applyDiff(U.map(h.TestsDiffOp.deserialize))}async $runControllerTests(U,A){return Promise.all(U.map(z=>this.runControllerTestRequest(z,A)))}async runControllerTestRequest(U,A){const z=this.controllers.get(U.controllerId);if(!z)return{};const{collection:$,profiles:N}=z,V=N.get(U.profileId);if(!V)return{};const B=U.testIds.map(Q=>$.tree.get(Q)).filter(L.isDefined),F=U.excludeExtIds.map(Q=>z.collection.tree.get(Q)).filter(L.isDefined).filter(Q=>B.some(K=>K.fullId.compare(Q.fullId)===2));if(!B.length)return{};const x=new b.TestRunRequest(B.some(Q=>Q.actual instanceof S.TestItemRootImpl)?void 0:B.map(Q=>Q.actual),F.map(Q=>Q.actual),V),H=this.runTracker.prepareForMainThreadTestRun(x,o.fromInternal(U,z.collection),A);try{return await V.runHandler(x,A),{}}catch(Q){return{error:String(Q)}}finally{H.isRunning&&!A.isCancellationRequested&&await P.Event.toPromise(H.onEnd),H.dispose()}}$cancelExtensionTestRun(U){U===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(U)}};i=je([He(0,T.IExtHostRpcService)],i),e.ExtHostTesting=i;class u extends w.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(U,A,z){super(),this.dto=U,this.proxy=A,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(z)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:$}of this.tasks.values())$.end()}))}getCoverage(U){return this.tasks.get(U)?.coverage}createRun(U){const A=this.dto.id,z=this.dto.controllerId,$=(0,C.generateUuid)(),N=new d(this.proxy,A,$),V=H=>(Q,...K)=>{if(F){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Q)||(this.ensureTestIsKnown(Q),H(Q,...K))},B=(H,Q)=>{const K=Q instanceof Array?Q.map(p.TestMessage.from):[p.TestMessage.from(Q)];if(H.uri&&H.range){const de={range:p.Range.from(H.range),uri:H.uri};for(const ee of K)ee.location=ee.location||de}this.proxy.$appendTestMessagesInRun(A,$,f.TestId.fromExtHostTestItem(H,z).toString(),K)};let F=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:U,get coverageProvider(){return N.coverageProvider},set coverageProvider(H){N.coverageProvider=H},enqueued:V(H=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(H,z).toString(),1)}),skipped:V(H=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(H,z).toString(),5)}),started:V(H=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(H,z).toString(),2)}),errored:V((H,Q,K)=>{B(H,Q),this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(H,z).toString(),6,K)}),failed:V((H,Q,K)=>{B(H,Q),this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(H,z).toString(),4,K)}),passed:V((H,Q)=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(H,this.dto.controllerId).toString(),3,Q)}),appendOutput:(H,Q,K)=>{F||(K&&(this.dto.isIncluded(K)?this.ensureTestIsKnown(K):K=void 0),this.proxy.$appendOutputToRun(A,$,t.VSBuffer.fromString(H),Q&&p.location.from(Q),K&&f.TestId.fromExtHostTestItem(K,z).toString()))},end:()=>{F||(F=!0,this.proxy.$finishedTestRunTask(A,$),this.tasks.delete($),this.isRunning||this.dispose())}};return this.tasks.set($,{run:x,coverage:N}),this.proxy.$startedTestRunTask(A,{id:$,name:U,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(U){if(!(U instanceof S.TestItemImpl))throw new v.InvalidTestItemError(U.id);if(this.sharedTestIds.has(f.TestId.fromExtHostTestItem(U,this.dto.controllerId).toString()))return;const A=[],z=this.dto.colllection.root;for(;;){const $=p.TestItem.from(U);if(A.unshift($),this.sharedTestIds.has($.extId)||(this.sharedTestIds.add($.extId),U===z))break;U=U.parent||z}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,A)}}class r{get trackers(){return this.tracked.values()}constructor(U){this.proxy=U,this.tracked=new Map}prepareForMainThreadTestRun(U,A,z){return this.getTracker(U,A,z)}cancelRunById(U){for(const A of this.tracked.values())if(A.id===U){A.dispose();return}}cancelAllRuns(){for(const U of this.tracked.values())U.dispose()}createTestRun(U,A,z,$,N){const V=this.tracked.get(z);if(V)return V.createRun($);const B=o.fromPublic(U,A,z,N),F=n(z);this.proxy.$startedExtensionTestRun({controllerId:U,profile:F&&{group:R[F.kind],id:F.profileId},exclude:z.exclude?.map(H=>f.TestId.fromExtHostTestItem(H,A.root.id).toString())??[],id:B.id,include:z.include?.map(H=>f.TestId.fromExtHostTestItem(H,A.root.id).toString())??[A.root.id],persist:N});const x=this.getTracker(z,B);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(B.id)),x.createRun($)}getTracker(U,A,z){const $=new u(A,this.proxy,z);return this.tracked.set(U,$),$.onEnd(()=>this.tracked.delete(U)),$}}e.TestRunCoordinator=r;const n=M=>{if(!!M.profile){if(!(M.profile instanceof _))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return M.profile}};class o{static fromPublic(U,A,z,$){return new o(U,(0,C.generateUuid)(),z.include?.map(N=>f.TestId.fromExtHostTestItem(N,U).toString())??[U],z.exclude?.map(N=>f.TestId.fromExtHostTestItem(N,U).toString())??[],$,A)}static fromInternal(U,A){return new o(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,A)}constructor(U,A,z,$,N,V){this.controllerId=U,this.id=A,this.isPersisted=N,this.colllection=V,this.includePrefix=z.map(B=>B+"\0"),this.excludePrefix=$.map(B=>B+"\0")}isIncluded(U){const A=f.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const z of this.excludePrefix)if(A===z||A.startsWith(z))return!1;for(const z of this.includePrefix)if(A===z||A.startsWith(z))return!0;return!1}}e.TestRunDto=o;class d{set coverageProvider(U){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this._coverageProvider=U,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(U,A,z){this.proxy=U,this.runId=A,this.taskId=z}async provideFileCoverage(U){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(U))());try{return(await this.fileCoverage)?.map(p.TestCoverage.fromFile)??[]}catch(A){throw this.fileCoverage=void 0,A}}async resolveFileCoverage(U,A){const z=await this.fileCoverage;let $=z?.[U];return!this._coverageProvider||!z||!$?[]:($.detailedCoverage||($=z[U]=await this._coverageProvider.resolveFileCoverage?.($,A)??$),$.detailedCoverage?.map(p.TestCoverage.fromDetailed)??[])}}class s extends h.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(U){super(),this.emitter=U,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(U){this.added.add(U)}update(U){Object.assign(U.revived,p.TestItem.toPlain(U.item)),this.added.has(U)||this.updated.add(U)}remove(U){if(this.added.has(U)){this.added.delete(U);return}this.updated.delete(U);const A=f.TestId.parentId(U.item.extId);if(A&&this.alreadyRemoved.has(A.toString())){this.alreadyRemoved.add(U.item.extId);return}this.removed.add(U)}getChangeEvent(){const{added:U,updated:A,removed:z}=this;return{get added(){return[...U].map($=>$.revived)},get updated(){return[...A].map($=>$.revived)},get removed(){return[...z].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class a extends h.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(U){return this.items.get(U)}getMirroredTestDataByReference(U){return this.items.get(U.id)}createItem(U,A){return{...U,revived:p.TestItem.toPlain(U.item),depth:A?A.depth+1:0,children:new Set}}createChangeCollector(){return new s(this.changeEmitter)}}e.MirroredTestCollection=a;class m{constructor(U){this.proxy=U}checkout(){this.current||(this.current=this.createObserverData());const U=this.current;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(A=>A.revived)},dispose:(0,y.once)(()=>{--U.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(U){return this.current?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.current?.tests.apply(U)}createObserverData(){const U=new a;return this.proxy.$subscribeToDiffs(),{observers:0,tests:U}}}class _{get label(){return this._label}set label(U){U!==this._label&&(this._label=U,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get isDefault(){return this._isDefault}set isDefault(U){U!==this._isDefault&&(this._isDefault=U,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?p.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(U){U!==this._configureHandler&&(this._configureHandler=U,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,A,z,$,N,V,B,F=!1,x=void 0){this.controllerId=z,this.profileId=$,this._label=N,this.kind=V,this.runHandler=B,this._isDefault=F,this._tag=x,c.set(this,void 0),g.set(this,void 0),tt(this,c,U,"f"),tt(this,g,A,"f"),A.set($,this);const H=R[V];if(typeof H!="number")throw new Error(`Unknown TestRunProfile.group ${V}`);Be(this,c,"f").$publishTestRunProfile({profileId:$,controllerId:z,tag:x?p.TestTag.namespace(this.controllerId,x.id):null,label:N,group:H,isDefault:F,hasConfigurationHandler:!1})}dispose(){Be(this,g,"f")?.delete(this.profileId)&&(tt(this,g,void 0,"f"),Be(this,c,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=_,c=new WeakMap,g=new WeakMap;const R={[b.TestRunProfileKind.Coverage]:8,[b.TestRunProfileKind.Debug]:4,[b.TestRunProfileKind.Run]:2}}),define(Ce[262],De([1,0,17,4,5,135,15,7]),function(J,e,l,t,I,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class w{constructor(L,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new t.Emitter,this._onDidChangeTextEditorOptions=new t.Emitter,this._onDidChangeTextEditorVisibleRanges=new t.Emitter,this._onDidChangeTextEditorViewColumn=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(E=>this._onDidChangeVisibleTextEditors.fire(E)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(E=>this._onDidChangeActiveTextEditor.fire(E))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const C=this._extHostDocumentsAndEditors.allEditors();return L?C:C.map(E=>E.value)}async showTextDocument(L,C,E){let T;typeof C=="number"?T={position:y.ViewColumn.from(C),preserveFocus:E}:typeof C=="object"?T={position:y.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?y.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:T={preserveFocus:!1};const S=await this._proxy.$tryShowTextDocument(L.uri,T),p=S&&this._extHostDocumentsAndEditors.getEditor(S);if(p)return p.value;throw S?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,C){return new P.TextEditorDecorationType(this._proxy,L,C).value}$acceptEditorPropertiesChanged(L,C){const E=this._extHostDocumentsAndEditors.getEditor(L);if(!E)throw new Error("unknown text editor");if(C.options&&E._acceptOptions(C.options),C.selections){const T=C.selections.selections.map(y.Selection.to);E._acceptSelections(T)}if(C.visibleRanges){const T=l.coalesce(C.visibleRanges.map(y.Range.to));E._acceptVisibleRanges(T)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:E.value,options:{...C.options,lineNumbers:y.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const T=D.TextEditorSelectionChangeKind.fromValue(C.selections.source),S=C.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:E.value,selections:S,kind:T})}if(C.visibleRanges){const T=l.coalesce(C.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:E.value,visibleRanges:T})}}$acceptEditorPositionData(L){for(const C in L){const E=this._extHostDocumentsAndEditors.getEditor(C);if(!E)throw new Error("Unknown text editor");const T=y.ViewColumn.to(L[C]);E.value.viewColumn!==T&&(E._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:E.value,viewColumn:T}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=w}),define(Ce[263],De([1,0,2,3,5,6,7,15,13]),function(J,e,l,t,I,P,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class k{constructor(E,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=E.getProxy(I.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===11){const p=S.uri===void 0?void 0:l.URI.revive(S.uri);return this._itemsBySourceAndUriMap.get(S.source)?.get(L(p))?.get(S.handle)}return S}})}async $getTimeline(E,T,S,p){return this._providers.get(E)?.provideTimeline(l.URI.revive(T),S,p)}registerTimelineProvider(E,T,S,p){const b=new P.DisposableStore,f=this.convertTimelineItem(T.id,p,b).bind(this);let v;T.onDidChange&&(v=T.onDidChange(c=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:T.id}),this));const h=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:E,onDidChange:void 0,async provideTimeline(c,g,i){g?.resetCache&&(b.clear(),h.get(T.id)?.clear());const u=await T.provideTimeline(c,g,i);if(u==null)return;const r=f(c,g);return{...u,source:T.id,items:u.items.map(r)}},dispose(){for(const c of h.values())c.get(T.id)?.clear();v?.dispose(),b.dispose()}})}convertTimelineItem(E,T,S){return(p,b)=>{let f;if(b?.cacheResults){let v=this._itemsBySourceAndUriMap.get(E);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(E,v));const h=L(p);f=v.get(h),f===void 0&&(f=new Map,v.set(h,f))}return v=>{const{iconPath:h,...c}=v,g=`${E}|${v.id??v.timestamp}`;f?.set(g,v);let i,u,r;v.iconPath&&(h instanceof y.ThemeIcon?r={id:h.id,color:h.color}:l.URI.isUri(h)?(i=h,u=h):{light:i,dark:u}=h);let n;return y.MarkdownString.isMarkdownString(c.tooltip)?n=D.MarkdownString.from(c.tooltip):(0,w.isString)(c.tooltip)?n=c.tooltip:y.MarkdownString.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=D.MarkdownString.from(c.detail)):(0,w.isString)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=c.detail),{...c,id:c.id??void 0,handle:g,source:E,command:v.command?T.toInternal(v.command,S):void 0,icon:i,iconDark:u,themeIcon:r,tooltip:n,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(E){if(this._providers.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this._proxy.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this._providers.set(E.id,E),(0,P.toDisposable)(()=>{for(const S of this._itemsBySourceAndUriMap.values())S.get(E.id)?.clear();this._providers.delete(E.id),this._proxy.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=k;function L(C){return C?.toString()}}),define(Ce[264],De([1,0,6,14,2,5]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(w){this._openers=new Map,this._proxy=w.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(w,k,L,C){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const E=C.schemes.find(T=>!y.supportedSchemes.has(T));if(E)throw new Error(`Scheme '${E}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,L),this._proxy.$registerUriOpener(k,C.schemes,w,C.label),(0,l.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(w,k,L){const C=this._openers.get(w);if(!C)throw new Error(`Unknown opener with id: ${w}`);const E=I.URI.revive(k);return C.canOpenExternalUri(E,L)}async $openUri(w,k,L){const C=this._openers.get(w);if(!C)throw new Error(`Unknown opener id: '${w}'`);return C.openExternalUri(I.URI.revive(k.resolvedUri),{sourceUri:I.URI.revive(k.sourceUri)},L)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(Ce[265],De([1,0,5,2,6,11,27]),function(J,e,l,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(l.MainContext.MainThreadUrls)}registerUriHandler(k,L){if(this.handles.has(y.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const C=D.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(k)),this.handlers.set(C,L),this._proxy.$registerUriHandler(C,k),(0,I.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(k)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(k,L){const C=this.handlers.get(k);if(!C)return Promise.resolve(void 0);try{C.handleUri(t.URI.revive(L))}catch(E){(0,P.onUnexpectedError)(E)}return Promise.resolve(void 0)}async createAppUri(k){return t.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=D,D.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,l):I?I.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[70],De([1,0,4,14,2,188,210,88,5]),function(J,e,l,t,I,P,y,D,w){"use strict";var k,L,C,E,T,S,p,b,f,v,h,c,g;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class i{constructor(_,R,M,U,A,z,$){k.set(this,void 0),L.set(this,void 0),C.set(this,void 0),E.set(this,void 0),T.set(this,void 0),S.set(this,void 0),p.set(this,""),b.set(this,void 0),f.set(this,!1),v.set(this,!1),h.set(this,void 0),c.set(this,void 0),this._onMessageEmitter=new l.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,g.set(this,new l.Emitter),this._onDidDispose=Be(this,g,"f").event,tt(this,k,_,"f"),tt(this,L,R,"f"),tt(this,b,M,"f"),tt(this,E,U,"f"),tt(this,T,A,"f"),tt(this,S,z,"f"),tt(this,h,u(z),"f"),tt(this,c,r(z),"f"),tt(this,C,$,"f")}dispose(){tt(this,f,!0,"f"),Be(this,g,"f").fire(),Be(this,g,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(_){return tt(this,v,!0,"f"),(0,D.asWebviewUri)(_,Be(this,E,"f"))}get cspSource(){const _=Be(this,S,"f").extensionLocation;if(_.scheme===t.Schemas.https||_.scheme===t.Schemas.http){let R=_.toString();return R.endsWith("/")||(R+="/"),R+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,p,"f")}set html(_){this.assertNotDisposed(),Be(this,p,"f")!==_&&(tt(this,p,_,"f"),Be(this,c,"f")&&!Be(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(_)&&(tt(this,v,!0,"f"),Be(this,C,"f").report("Webview vscode-resource: uris",Be(this,S,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,L,"f").$setHtml(Be(this,k,"f"),this.rewriteOldResourceUrlsIfNeeded(_)))}get options(){return this.assertNotDisposed(),Be(this,b,"f")}set options(_){this.assertNotDisposed(),Be(this,L,"f").$setOptions(Be(this,k,"f"),d(Be(this,S,"f"),Be(this,T,"f"),_)),tt(this,b,_,"f")}async postMessage(_){if(Be(this,f,"f"))return!1;const R=(0,y.serializeWebviewMessage)(_,{serializeBuffersForPostMessage:Be(this,h,"f")});return Be(this,L,"f").$postMessage(Be(this,k,"f"),R.message,...R.buffers)}assertNotDisposed(){if(Be(this,f,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(_){if(!Be(this,c,"f"))return _;const R=Be(this,S,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,M=Be(this,S,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Be(this,S,"f").extensionLocation.authority:void 0;return _.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(U,A,z,$,N,V)=>{const B=I.URI.from({scheme:$||"file",path:decodeURIComponent(N)}),F=(0,D.asWebviewUri)(B,{isRemote:R,authority:M}).toString();return`${A}${F}${V}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(U,A,z,$,N,V)=>{const B=I.URI.from({scheme:$||"file",path:decodeURIComponent(N)}),F=(0,D.asWebviewUri)(B,{isRemote:R,authority:M}).toString();return`${A}${F}${V}`})}}e.ExtHostWebview=i,k=new WeakMap,L=new WeakMap,C=new WeakMap,E=new WeakMap,T=new WeakMap,S=new WeakMap,p=new WeakMap,b=new WeakMap,f=new WeakMap,v=new WeakMap,h=new WeakMap,c=new WeakMap,g=new WeakMap;function u(m){try{const _=(0,P.normalizeVersion)((0,P.parseVersion)(m.engines.vscode));return!!_&&_.majorBase>=1&&_.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=u;function r(m){try{const _=(0,P.normalizeVersion)((0,P.parseVersion)(m.engines.vscode));return _?_.majorBase<1||_.majorBase===1&&_.minorBase<60:!1}catch{return!1}}class n{constructor(_,R,M,U,A){this.remoteInfo=R,this.workspace=M,this._logService=U,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=_.getProxy(w.MainContext.MainThreadWebviews)}$onMessage(_,R,M){const U=this.getWebview(_);if(U){const{message:A}=(0,y.deserializeWebviewMessage)(R,M.value);U._onMessageEmitter.fire(A)}}$onMissingCsp(_,R){this._logService.warn(`${R} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(_,R,M){const U=new i(_,this._webviewProxy,s(R),this.remoteInfo,this.workspace,M,this._deprecationService);return this._webviews.set(_,U),U._onDidDispose(()=>{this._webviews.delete(_)}),U}deleteWebview(_){this._webviews.delete(_)}getWebview(_){return this._webviews.get(_)}}e.ExtHostWebviews=n;function o(m){return{id:m.identifier,location:m.extensionLocation}}e.toExtensionData=o;function d(m,_,R){return{enableCommandUris:R.enableCommandUris,enableScripts:R.enableScripts,enableForms:R.enableForms,portMapping:R.portMapping,localResourceRoots:R.localResourceRoots||a(m,_)}}e.serializeWebviewOptions=d;function s(m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots?.map(_=>I.URI.from(_))}}e.reviveOptions=s;function a(m,_){return[...(_?.getWorkspaceFolders()||[]).map(R=>R.uri),m.extensionLocation]}}),define(Ce[266],De([1,0,21,79,6,14,22,2,15,70,87,5,7]),function(J,e,l,t,I,P,y,D,w,k,L,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(u,r){this.document=u,this._storagePath=r,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(u){return this._edits.add([u])}async undo(u,r){await this.getEdit(u).undo(),r||this.disposeBackup()}async redo(u,r){await this.getEdit(u).redo(),r||this.disposeBackup()}disposeEdits(u){for(const r of u)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const u=g(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,u)}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(u){const r=this._edits.get(u,0);if(!r)throw new Error("No edit found");return r}}class S{constructor(){this._documents=new Map}get(u,r){return this._documents.get(this.key(u,r))}add(u,r,n){const o=this.key(u,r.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${u} resource:${r.uri}`);const d=new T(r,n);return this._documents.set(o,d),d}delete(u,r){const n=this.key(u,r.uri);this._documents.delete(n)}key(u,r){return`${u}@@@${r}`}}var p;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(p||(p={}));class b{constructor(){this._providers=new Map}addTextProvider(u,r,n){return this.add(0,u,r,n)}addCustomProvider(u,r,n){return this.add(1,u,r,n)}get(u){return this._providers.get(u)}add(u,r,n,o){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:u,extension:n,provider:o}),new E.Disposable(()=>this._providers.delete(r))}}class f{constructor(u,r,n,o,d){this._extHostDocuments=r,this._extensionStoragePaths=n,this._extHostWebview=o,this._extHostWebviewPanels=d,this._editorProviders=new b,this._documents=new S,this._proxy=u.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(u,r,n,o){const d=new I.DisposableStore;return h(n)?(d.add(this._editorProviders.addTextProvider(r,u,n)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(u),r,o.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(u))):(d.add(this._editorProviders.addCustomProvider(r,u,n)),v(n)&&d.add(n.onDidChangeCustomDocument(s=>{const a=this.getCustomDocumentEntry(r,s.document.uri);if(c(s)){const m=a.addEdit(s);this._proxy.$onDidEdit(s.document.uri,r,m,s.label)}else this._proxy.$onContentChange(s.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(u),r,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(u))),E.Disposable.from(d,new E.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(u,r,n,o,d){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provide type for '${r}'`);const a=D.URI.revive(u),m=await s.provider.openCustomDocument(a,{backupId:n,untitledDocumentData:o?.buffer},d);let _;return v(s.provider)&&this._extensionStoragePaths&&(_=this._extensionStoragePaths.workspaceValue(s.extension)??this._extensionStoragePaths.globalValue(s.extension)),this._documents.add(r,m,_),{editable:v(s.provider)}}async $disposeCustomDocument(u,r){const n=this._editorProviders.get(r);if(!n)throw new Error(`No provider found for '${r}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${r}'`);const o=D.URI.revive(u),{document:d}=this.getCustomDocumentEntry(r,o);this._documents.delete(r,d),d.dispose()}async $resolveWebviewEditor(u,r,n,o,d,s){const a=this._editorProviders.get(n);if(!a)throw new Error(`No provider found for '${n}'`);const m=w.ViewColumn.to(d),_=this._extHostWebview.createNewWebview(r,o.contentOptions,a.extension),R=this._extHostWebviewPanels.createNewWebviewPanel(r,n,o.title,m,o.options,_,!0),M=D.URI.revive(u);switch(a.type){case 1:{const{document:U}=this.getCustomDocumentEntry(n,M);return a.provider.resolveCustomEditor(U,R,s)}case 0:{const U=this._extHostDocuments.getDocument(M);return a.provider.resolveCustomTextEditor(U,R,s)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,r,n){this.getCustomDocumentEntry(r,u).disposeEdits(n)}async $onMoveCustomEditor(u,r,n){const o=this._editorProviders.get(n);if(!o)throw new Error(`No provider found for '${n}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const d=this._extHostWebviewPanels.getWebviewPanel(u);if(!d)throw new Error("No webview found");const s=D.URI.revive(r),a=this._extHostDocuments.getDocument(s);await o.provider.moveCustomTextEditor(a,d,l.CancellationToken.None)}async $undo(u,r,n,o){return this.getCustomDocumentEntry(r,u).undo(n,o)}async $redo(u,r,n,o){return this.getCustomDocumentEntry(r,u).redo(n,o)}async $revert(u,r,n){const o=this.getCustomDocumentEntry(r,u);await this.getCustomEditorProvider(r).revertCustomDocument(o.document,n),o.disposeBackup()}async $onSave(u,r,n){const o=this.getCustomDocumentEntry(r,u);await this.getCustomEditorProvider(r).saveCustomDocument(o.document,n),o.disposeBackup()}async $onSaveAs(u,r,n,o){const d=this.getCustomDocumentEntry(r,u);return this.getCustomEditorProvider(r).saveCustomDocumentAs(d.document,D.URI.revive(n),o)}async $backup(u,r,n){const o=this.getCustomDocumentEntry(r,u),s=await this.getCustomEditorProvider(r).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},n);return o.updateBackup(s),s.id}getCustomDocumentEntry(u,r){const n=this._documents.get(u,D.URI.revive(r));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(u){const n=this._editorProviders.get(u)?.provider;if(!n||!v(n))throw new Error("Custom document is not editable");return n}}e.ExtHostCustomEditors=f;function v(i){return!!i.onDidChangeCustomDocument}function h(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function g(i){const u=i.scheme===P.Schemas.file||i.scheme===P.Schemas.untitled?i.fsPath:i.toString();return(0,t.hash)(u)+""}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,l):I?I.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[267],De([1,0,4,6,2,31,15,70,5,7]),function(J,e,l,t,I,P,y,D,w,k){"use strict";var L,C,E,T,S,p,b,f,v,h,c,g,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends t.Disposable{constructor(d,s,a,m){super(),L.set(this,void 0),C.set(this,void 0),E.set(this,void 0),T.set(this,void 0),S.set(this,void 0),p.set(this,void 0),b.set(this,void 0),f.set(this,void 0),v.set(this,!0),h.set(this,void 0),c.set(this,!1),g.set(this,this._register(new l.Emitter)),this.onDidDispose=Be(this,g,"f").event,i.set(this,this._register(new l.Emitter)),this.onDidChangeViewState=Be(this,i,"f").event,tt(this,L,d,"f"),tt(this,C,s,"f"),tt(this,T,a,"f"),tt(this,E,m.viewType,"f"),tt(this,S,m.panelOptions,"f"),tt(this,f,m.viewColumn,"f"),tt(this,p,m.title,"f"),tt(this,h,m.active,"f")}dispose(){Be(this,c,"f")||(tt(this,c,!0,"f"),Be(this,g,"f").fire(),Be(this,C,"f").$disposeWebview(Be(this,L,"f")),Be(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,T,"f")}get viewType(){return this.assertNotDisposed(),Be(this,E,"f")}get title(){return this.assertNotDisposed(),Be(this,p,"f")}set title(d){this.assertNotDisposed(),Be(this,p,"f")!==d&&(tt(this,p,d,"f"),Be(this,C,"f").$setTitle(Be(this,L,"f"),d))}get iconPath(){return this.assertNotDisposed(),Be(this,b,"f")}set iconPath(d){this.assertNotDisposed(),Be(this,b,"f")!==d&&(tt(this,b,d,"f"),Be(this,C,"f").$setIconPath(Be(this,L,"f"),I.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Be(this,S,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,f,"f")=="number"&&Be(this,f,"f")<0))return Be(this,f,"f")}get active(){return this.assertNotDisposed(),Be(this,h,"f")}get visible(){return this.assertNotDisposed(),Be(this,v,"f")}_updateViewState(d){Be(this,c,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(tt(this,h,d.active,"f"),tt(this,v,d.visible,"f"),tt(this,f,d.viewColumn,"f"),Be(this,i,"f").fire({webviewPanel:this}))}reveal(d,s){this.assertNotDisposed(),Be(this,C,"f").$reveal(Be(this,L,"f"),{viewColumn:typeof d>"u"?void 0:y.ViewColumn.from(d),preserveFocus:!!s})}assertNotDisposed(){if(Be(this,c,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,C=new WeakMap,E=new WeakMap,T=new WeakMap,S=new WeakMap,p=new WeakMap,b=new WeakMap,f=new WeakMap,v=new WeakMap,h=new WeakMap,c=new WeakMap,g=new WeakMap,i=new WeakMap;class r{static newHandle(){return(0,P.generateUuid)()}constructor(d,s,a){this.webviews=s,this.workspace=a,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(w.MainContext.MainThreadWebviewPanels)}createWebviewPanel(d,s,a,m,_={}){const R=typeof m=="object"?m.viewColumn:m,M={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof m=="object"&&!!m.preserveFocus},U=(0,D.shouldSerializeBuffersForPostMessage)(d),A=r.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(d),A,s,{title:a,panelOptions:n(_),webviewOptions:(0,D.serializeWebviewOptions)(d,this.workspace,_),serializeBuffersForPostMessage:U},M);const z=this.webviews.createNewWebview(A,_,d);return this.createNewWebviewPanel(A,s,a,R,_,z,!0)}$onDidChangeWebviewPanelViewStates(d){const s=Object.keys(d);s.sort((a,m)=>{const _=d[a],R=d[m];return _.active?1:R.active?-1:+_.visible-+R.visible});for(const a of s){const m=this.getWebviewPanel(a);if(!m)continue;const _=d[a];m._updateViewState({active:_.active,visible:_.visible,viewColumn:y.ViewColumn.to(_.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,s,a){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:a,extension:d}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(d)}),new k.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(d,s,a,m){const _=this._serializers.get(s);if(!_)throw new Error(`No serializer found for '${s}'`);const{serializer:R,extension:M}=_,U=this.webviews.createNewWebview(d,a.webviewOptions,M),A=this.createNewWebviewPanel(d,s,a.title,m,a.panelOptions,U,a.active);await R.deserializeWebviewPanel(A,a.state)}createNewWebviewPanel(d,s,a,m,_,R,M){const U=new u(d,this._proxy,R,{viewType:s,title:a,viewColumn:m,panelOptions:_,active:M});return this._webviewPanels.set(d,U),U}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=r;function n(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,l):I?I.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[268],De([1,0,4,6,70,15,5,7]),function(J,e,l,t,I,P,y,D){"use strict";var w,k,L,C,E,T,S,p,b,f,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class h extends t.Disposable{constructor(i,u,r,n,o,d,s){super(),w.set(this,void 0),k.set(this,void 0),L.set(this,void 0),C.set(this,void 0),E.set(this,!1),T.set(this,void 0),S.set(this,void 0),p.set(this,void 0),b.set(this,void 0),f.set(this,this._register(new l.Emitter)),this.onDidChangeVisibility=Be(this,f,"f").event,v.set(this,this._register(new l.Emitter)),this.onDidDispose=Be(this,v,"f").event,tt(this,L,r,"f"),tt(this,S,n,"f"),tt(this,w,i,"f"),tt(this,k,u,"f"),tt(this,C,o,"f"),tt(this,T,s,"f")}dispose(){Be(this,E,"f")||(tt(this,E,!0,"f"),Be(this,v,"f").fire(),Be(this,C,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,S,"f")}set title(i){this.assertNotDisposed(),Be(this,S,"f")!==i&&(tt(this,S,i,"f"),Be(this,k,"f").$setWebviewViewTitle(Be(this,w,"f"),i))}get description(){return this.assertNotDisposed(),Be(this,p,"f")}set description(i){this.assertNotDisposed(),Be(this,p,"f")!==i&&(tt(this,p,i,"f"),Be(this,k,"f").$setWebviewViewDescription(Be(this,w,"f"),i))}get visible(){return Be(this,T,"f")}get webview(){return Be(this,C,"f")}get viewType(){return Be(this,L,"f")}_setVisible(i){i===Be(this,T,"f")||Be(this,E,"f")||(tt(this,T,i,"f"),Be(this,f,"f").fire())}get badge(){return this.assertNotDisposed(),Be(this,b,"f")}set badge(i){this.assertNotDisposed(),!(i?.value===Be(this,b,"f")?.value&&i?.tooltip===Be(this,b,"f")?.tooltip)&&(tt(this,b,P.ViewBadge.from(i),"f"),Be(this,k,"f").$setWebviewViewBadge(Be(this,w,"f"),i))}show(i){this.assertNotDisposed(),Be(this,k,"f").$show(Be(this,w,"f"),!!i)}assertNotDisposed(){if(Be(this,E,"f"))throw new Error("Webview is disposed")}}w=new WeakMap,k=new WeakMap,L=new WeakMap,C=new WeakMap,E=new WeakMap,T=new WeakMap,S=new WeakMap,p=new WeakMap,b=new WeakMap,f=new WeakMap,v=new WeakMap;class c{constructor(i,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=i.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,u,r,n){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:r,extension:i}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(i),u,{retainContextWhenHidden:n?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(i)}),new D.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(i,u,r,n,o){const d=this._viewProviders.get(u);if(!d)throw new Error(`No view provider found for '${u}'`);const{provider:s,extension:a}=d,m=this._extHostWebview.createNewWebview(i,{},a),_=new h(i,this._proxy,u,r,m,a,!0);this._webviewViews.set(i,_),await s.resolveWebviewView(_,{state:n},o)}async $onDidChangeWebviewViewVisibility(i,u){this.getWebviewView(i)._setVisible(u)}async $disposeWebviewView(i){const u=this.getWebviewView(i);this._webviewViews.delete(i),u.dispose(),this._extHostWebview.deleteWebview(i)}getWebviewView(i){const u=this._webviewViews.get(i);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=c}),define(Ce[138],De([1,0,4,5,2,14,8,3,16]),function(J,e,l,t,I,P,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class ei{get state(){return this._state}constructor(C){this._onDidChangeWindowState=new l.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ei.InitialState,this._proxy=C.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(E=>this.$onDidChangeWindowFocus(E))}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state={...this._state,focused:C},this._onDidChangeWindowState.fire(this._state))}openUri(C,E){let T;if(typeof C=="string"){T=C;try{C=I.URI.parse(C)}catch{return Promise.reject(`Invalid uri - '${C}'`)}}return(0,y.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,T,E)}async asExternalUri(C,E){if((0,y.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(C,E);return I.URI.from(T)}};k.InitialState={focused:!0},k=je([He(0,w.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(Ce[269],De([1,0,115,270,63,39,2,12,45]),function(J,e,l,t,I,P,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(E,T,S){this._commands=E,this.logService=T,this._ipcHandlePath=S,this._server=t.createServer((p,b)=>this.onRequest(p,b)),this.setup().catch(p=>(T.error(p),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",E=>this.logService.error(E))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(E,T){const S=(b,f)=>{T.writeHead(b,{"content-type":"application/json"}),T.end(JSON.stringify(f||null),v=>v&&this.logService.error(v))},p=[];E.setEncoding("utf8"),E.on("data",b=>p.push(b)),E.on("end",async()=>{try{const b=JSON.parse(p.join(""));let f;switch(b.type){case"open":f=await this.open(b);break;case"openExternal":f=await this.openExternal(b);break;case"status":f=await this.getStatus(b);break;case"extensionManagement":f=await this.manageExtensions(b);break;default:S(404,`Unknown message type: ${b.type}`);break}S(200,f)}catch(b){const f=b instanceof Error?b.message:JSON.stringify(b);S(500,f),this.logService.error("Error while processing pipe request",b)}})}async open(E){const{fileURIs:T,folderURIs:S,forceNewWindow:p,diffMode:b,mergeMode:f,addMode:v,forceReuseWindow:h,gotoLineMode:c,waitMarkerFilePath:g,remoteAuthority:i}=E,u=[];if(Array.isArray(S))for(const d of S)try{u.push({folderUri:y.URI.parse(d)})}catch{}if(Array.isArray(T))for(const d of T)try{(0,w.hasWorkspaceFileExtension)(d)?u.push({workspaceUri:y.URI.parse(d)}):u.push({fileUri:y.URI.parse(d)})}catch{}const r=g?y.URI.file(g):void 0,o={forceNewWindow:p,diffMode:b,mergeMode:f,addMode:v,gotoLineMode:c,forceReuseWindow:h,preferNewWindow:!h&&!r&&!v,waitMarkerFileURI:r,remoteAuthority:i};return this._commands.executeCommand("_remoteCLI.windowOpen",u,o),""}async openExternal(E){for(const T of E.uris){const S=y.URI.parse(T),p=S.scheme==="file"?S:T;await this._commands.executeCommand("_remoteCLI.openExternal",p)}}async manageExtensions(E){const T=p=>p?.map(b=>/\.vsix$/i.test(b)?y.URI.parse(b):b),S={list:E.list,install:T(E.install),uninstall:T(E.uninstall),force:E.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",S)}async getStatus(E){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=k;let L=class extends k{constructor(E,T){super(E,T,(0,l.createRandomIPCHandle)())}};L=je([He(0,P.IExtHostCommands),He(1,D.ILogService)],L),e.CLIServer=L}),define(Ce[271],De([1,0,243,25,16]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const P=1024*1024;let y=class extends l.AbstractExtHostConsoleForwarder{constructor(w,k){super(w,k),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(w,k,L){const C=w==="error"||w==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,C.write(`
START_NATIVE_LOG
`),k.apply(console,L),C.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(w,k){const L=process[w],C=L.write;let E="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(T,S,p)=>{if(!this._isMakingConsoleCall){E+=T.toString(S);const b=E.length>P?E.length:E.lastIndexOf(`
`);b!==-1&&(console[k](E.slice(0,b)),E=E.slice(b+1))}C.call(L,T,S,p)}})}};y=je([He(0,I.IExtHostRpcService),He(1,t.IExtHostInitDataService)],y),e.ExtHostConsoleForwarder=y}),define(Ce[272],De([1,0,9,82,31,39,6,5,2,16]),function(J,e,l,t,I,P,y,D,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends y.Disposable{constructor(E,T){super();const S=E.getProxy(D.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async p=>{const b=w.URI.file((0,l.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await S.$download(p,b),b})}};L=je([He(0,k.IExtHostRpcService),He(1,P.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(Ce[273],De([1,0,137,14,194,31]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class y extends l.ExtHostLoggerService{doCreateLogger(w,k,L){return w.scheme===t.Schemas.file?new I.SpdLogLogger(L?.name||(0,P.generateUuid)(),w.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,k):super.doCreateLogger(w,k,L)}}e.ExtHostLoggerService=y}),define(Ce[274],De([1,0,63,9,2,69,6,14,18,29]),function(J,e,l,t,I,P,y,D,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends P.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(i){const u=await super._getWorkspaceStorageURI(i);if(u.scheme!==D.Schemas.file)return u;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${u.fsPath}.`),u;const r=u.fsPath;let n=0;do{let o;n===0?o=r:o=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${n}`:`${r}-${n}`,await C(o);const d=t.join(o,"vscode.lock"),s=await p(this._logService,d,!1);if(s)return this._workspaceStorageLock=s,process.on("exit",()=>{s.dispose()}),I.URI.file(o);n++}while(n<10);return u}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function C(g){try{await k.Promises.stat(g);return}catch{}try{await k.Promises.mkdir(g,{recursive:!0})}catch{}}const E=1e3,T=10*60*1e3;class S extends y.Disposable{constructor(i,u){super(),this.logService=i,this.filename=u,this._timer=this._register(new w.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await b(i,u);(!r||r.pid!==process.pid)&&(i.info(`Lock '${u}': The lock was lost unexpectedly.`),this._timer.cancel());try{await k.Promises.utimes(u,new Date,new Date)}catch(n){i.error(n),i.info(`Lock '${u}': Could not update mtime.`)}},E)}dispose(){super.dispose();try{l.unlinkSync(this.filename)}catch{}}async setWillRelease(i){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const u={pid:process.pid,willReleaseAt:Date.now()+i};await k.Promises.writeFile(this.filename,JSON.stringify(u),{flag:"w"})}catch(u){this.logService.error(u)}}}async function p(g,i,u){try{const n={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(i,JSON.stringify(n),{flag:"wx"})}catch(n){g.error(n)}const r=await b(g,i);return!r||r.pid!==process.pid?u?(g.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),h(g,i)):(g.info(`Lock '${i}': Lock acquired.`),new S(g,i))}async function b(g,i){let u;try{u=await k.Promises.readFile(i)}catch(r){return g.error(r),null}try{return JSON.parse(String(u))}catch(r){return g.error(r),null}}async function f(g,i){let u;try{u=await k.Promises.stat(i)}catch(r){return g.error(r),0}return u.mtime.getTime()}function v(g){try{return process.kill(g,0),!0}catch{return!1}}async function h(g,i){const u=await b(g,i);if(!u)return g.info(`Lock '${i}': Could not read pid of lock holder.`),c(g,i);if(u.willReleaseAt){let s=u.willReleaseAt-Date.now();if(s<5e3){for(s>0?g.info(`Lock '${i}': The lockfile is scheduled to be released in ${s} ms.`):g.info(`Lock '${i}': The lockfile is scheduled to have been released.`);s>0;){if(await(0,w.timeout)(Math.min(100,s)),await f(g,i)===0)return c(g,i);s=u.willReleaseAt-Date.now()}return c(g,i)}}if(!v(u.pid))return g.info(`Lock '${i}': The pid ${u.pid} appears to be gone.`),c(g,i);const r=await f(g,i),n=Date.now()-r;if(n<=T)return g.info(`Lock '${i}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null;g.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,w.timeout)(2e3);const o=await f(g,i),d=Date.now()-o;return d<=T?(g.info(`Lock '${i}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(g.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),c(g,i))}async function c(g,i){g.info(`Lock '${i}': Deleting a stale lock.`);try{await k.Promises.unlink(i)}catch{}return p(g,i,!0)}}),define(Ce[275],De([1,0,31,16,40]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let P=class extends I.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,w,k){return this.createTerminalFromOptions({name:D,shellPath:w,shellArgs:k})}createTerminalFromOptions(D,w){const k=new I.ExtHostTerminal(this._proxy,(0,l.generateUuid)(),D,D.name);return this._terminals.push(k),k.create(D,this._serializeParentTerminal(D,w)),k.value}};P=je([He(0,t.IExtHostRpcService)],P),e.ExtHostTerminalService=P}),define(Ce[276],De([1,0,5,16,178,6,25,2,44,22,29,7,10,53,4,126,97,12]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class v extends p.DisposableTunnel{}function h(s){const a=s.trim().split(`
`),m=[];return a.forEach(R=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);M&&M.length>=3&&m.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),m.reduce((R,M)=>(R[M.socket]=M,R),{})}e.getSockets=h;function c(...s){const a=[].concat(...s.map(i));return[...new Map(a.filter(m=>m.st==="0A").map(m=>{const _=m.local_address.split(":");return{socket:parseInt(m.inode,10),ip:g(_[0]),port:parseInt(_[1],16)}}).map(m=>[m.ip+":"+m.port,m])).values()]}e.loadListeningPorts=c;function g(s){let a="";if(s.length===8)for(let m=s.length-2;m>=0;m-=2)a+=parseInt(s.substr(m,2),16),m!==0&&(a+=".");else for(let m=s.length-4;m>=0;m-=4)a+=parseInt(s.substr(m,4),16).toString(16),m!==0&&(a+=":");return a}e.parseIpAddress=g;function i(s){const a=s.trim().split(`
`),m=a.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return a.map(R=>R.trim().split(/\s+/).reduce((M,U,A)=>(M[m[A]||A]=U,M),{}))}e.loadConnectionTable=i;function u(s){return!!s.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||s.indexOf("out/server-main.js")!==-1||s.indexOf("_productName=VSCode")!==-1}function r(s){const a=s.trim().split(`
`),m=[];return a.forEach(_=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(_);R&&R.length>=4&&m.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),m}e.getRootProcesses=r;async function n(s,a,m){const _=m.reduce((M,U)=>(M[U.pid]=U,M),{}),R=[];return s.forEach(({socket:M,ip:U,port:A})=>{const z=a[M]?a[M].pid:void 0,$=z?_[z]?.cmd:void 0;z&&$&&!u($)&&R.push({host:U,port:A,detail:$,pid:z})}),R}e.findPorts=n;function o(s,a,m){const _=new Map,R=r(a);for(const M of s){const U=m.get(M.port);if(U){_.set(M.port,U);continue}const A=R.find(z=>z.cmd.includes(`${M.port}`));if(A){let z=A,$;do $=R.find(N=>N.ppid===z.pid),$&&(z=$);while($);_.set(M.port,{host:M.ip,port:M.port,pid:z.pid,detail:z.cmd,ppid:z.ppid})}else _.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return _}e.tryFindRootPorts=o;let d=class extends P.Disposable{constructor(a,m,_){super(),this.logService=_,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new S.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=a.getProxy(l.MainContext.MainThreadTunnelService),E.isLinux&&m.remote.isRemote&&m.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(a,m){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const _=await this._proxy.$openTunnel(m,a.displayName);if(_){const R=new v(_.remoteAddress,_.localAddress,()=>this._proxy.$closeTunnel(_.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(a){return Math.max(a*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(a,m){const _=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(_,{selector:a,provider:m}),this._proxy.$registerPortsAttributesProvider(a,_),new C.Disposable(()=>{this._portAttributesProviders.delete(_),this._proxy.$unregisterPortsAttributesProvider(_)})}async $providePortAttributes(a,m,_,R,M){const U=[];for(const z of a){const $=this._portAttributesProviders.get(z);if(!$)return[];U.push(...await Promise.all(m.map(async N=>$.provider.providePortAttributes(N,_,R,M))))}const A=U.filter(z=>!!z);return A.length>0?A.map(z=>({autoForwardAction:z.autoForwardAction,port:z.port})):[]}async $registerCandidateFinder(a){if(a&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=a;const m=new b.MovingAverage;let _;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),M=(await this.findCandidatePorts()).filter(A=>(0,p.isLocalhost)(A.host)||(0,p.isAllInterfaces)(A.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(A=>A.port).join(", ")}`);const U=new Date().getTime()-R;m.update(U),(!_||JSON.stringify(_)!==JSON.stringify(M))&&(_=M,await this._proxy.$onFoundNewCandidates(_)),await new Promise(A=>setTimeout(()=>A(),this.calculateDelay(m.value)))}}async setTunnelFactory(a){if(a){if(a.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this._showCandidatePort=a.showCandidatePort,this._proxy.$setCandidateFilter()),a.tunnelFactory){this._forwardPortProvider=a.tunnelFactory;let m=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&m.length===0&&(m=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const _=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:m}:void 0;this._proxy.$setTunnelProvider(_)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(a,m){if(this._extensionTunnels.has(a.host)){const _=this._extensionTunnels.get(a.host);_.has(a.port)&&(m&&_.get(a.port).disposeListener.dispose(),await _.get(a.port).tunnel.dispose(),_.delete(a.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(a,m){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const _=this._forwardPortProvider(a,m);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),_!==void 0){const R=await _;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(a.remoteAddress.host)||this._extensionTunnels.set(a.remoteAddress.host,new Map);const M=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:R,disposeListener:M}),T.TunnelDtoConverter.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(a){const m=await Promise.all(a.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),_=a.filter((R,M)=>m[M]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(R=>R.port).join(", ")} to ${_.map(R=>R.port).join(", ")}`),_}async findCandidatePorts(){let a="",m="";try{a=await L.Promises.readFile("/proc/net/tcp","utf8"),m=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const _=c(a,m),R=await new Promise(B=>{(0,w.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,x,H)=>{B(x)})}),M=h(R),U=await L.Promises.readdir("/proc"),A=[];for(const B of U)try{const F=Number(B),x=k.joinPath(D.URI.file("/proc"),B);if((await L.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(F)){const Q=await L.Promises.readlink(k.joinPath(x,"cwd").fsPath),K=await L.Promises.readFile(k.joinPath(x,"cmdline").fsPath,"utf8");A.push({pid:F,cwd:Q,cmd:K})}}catch{}const z=[],$=_.filter(B=>{const F=M[B.socket];return F||z.push(B),F}),N=n($,M,A);let V;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${z.length}`),z.length>0){const B=await new Promise(F=>{(0,w.exec)("ps -F -A -l | grep root",(x,H,Q)=>{F(H)})});this._foundRootPorts=o(z,B,this._foundRootPorts),V=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${V.join(", ")}`)}return N.then(B=>V?B.concat(V):B)}};d=je([He(0,t.IExtHostRpcService),He(1,y.IExtHostInitDataService),He(2,f.ILogService)],d),e.ExtHostTunnelService=d}),define(Ce[277],De([1,0,18,23,21,11,4,6,110,237,56]),function(J,e,l,t,I,P,y,D,w,k,L){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function E(_,R){try{return JSON.stringify(_,R)}catch{return"null"}}const T="$$ref$$",S={[T]:-1};class p{constructor(R,M){this.jsonString=R,this.referencedBuffers=M}}function b(_,R=null,M=!1){const U=[];return{jsonString:(M?E:JSON.stringify)(_,(z,$)=>{if(typeof $>"u")return S;if(typeof $=="object"){if($ instanceof t.VSBuffer){const N=U.push($)-1;return{[T]:N}}if(R)return R(z,$)}return $}),referencedBuffers:U}}e.stringifyJsonWithBufferRefs=b;function f(_,R,M){return JSON.parse(_,(U,A)=>{if(A){const z=A[T];if(typeof z=="number")return R[z];if(M&&A.$mid===1)return M.transformIncoming(A)}return A})}e.parseJsonAndRestoreBufferRefs=f;function v(_,R){return JSON.stringify(_,R)}function h(_){return _?(R,M)=>M&&M.$mid===1?_.transformOutgoing(M):M:null}var c;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(_){_[_.Responsive=0]="Responsive",_[_.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},u=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class n extends D.Disposable{constructor(R,M=null,U=null){super(),this[C]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=M,this._uriTransformer=U,this._uriReplacer=h(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,z=L.ProxyIdentifier.count;A<z;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new l.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,w.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:M,sid:U}=R;return this._proxies[M]||(this._proxies[M]=this._createProxy(M,U)),this._proxies[M]}_createProxy(R,M){const U={get:(A,z)=>(typeof z=="string"&&!A[z]&&z.charCodeAt(0)===36&&(A[z]=(...$)=>this._remoteCall(R,z,$)),z===r?M:A[z])};return new Proxy(Object.create(null),U)}set(R,M){return this._locals[R.nid]=M,M}assertRegistered(R){for(let M=0,U=R.length;M<U;M++){const A=R[M];if(!this._locals[A.nid])throw new Error(`Missing proxy instance ${A.sid}`)}}_receiveOneMessage(R){if(this._isDisposed)return;const M=R.byteLength,U=o.read(R,0),A=U.readUInt8(),z=U.readUInt32();switch(A){case 1:case 2:{let{rpcId:$,method:N,args:V}=s.deserializeRequestJSONArgs(U);this._uriTransformer&&(V=(0,w.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(M,z,$,N,V,A===2);break}case 3:case 4:{let{rpcId:$,method:N,args:V}=s.deserializeRequestMixedArgs(U);this._uriTransformer&&(V=(0,w.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(M,z,$,N,V,A===4);break}case 5:{this._logger?.logIncoming(M,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(M,z);break}case 7:{this._receiveReply(M,z,void 0);break}case 9:{let $=s.deserializeReplyOKJSON(U);this._uriTransformer&&($=(0,w.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(M,z,$);break}case 10:{const $=s.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(M,z,$);break}case 8:{const $=s.deserializeReplyOKVSBuffer(U);this._receiveReply(M,z,$);break}case 11:{let $=s.deserializeReplyErrError(U);this._uriTransformer&&($=(0,w.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(M,z,$);break}case 12:{this._receiveReplyErr(M,z,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,M,U,A,z,$){this._logger?.logIncoming(R,M,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(U)}.${A}(`,z);const N=String(M);let V,B;if($){const x=new I.CancellationTokenSource;z.push(x.token),V=this._invokeHandler(U,A,z),B=()=>x.cancel()}else V=this._invokeHandler(U,A,z),B=i;this._cancelInvokedHandlers[N]=B;const F=s.serializeAcknowledged(M);this._logger?.logOutgoing(F.byteLength,M,1,"ack"),this._protocol.send(F),V.then(x=>{delete this._cancelInvokedHandlers[N];const H=s.serializeReplyOK(M,x,this._uriReplacer);this._logger?.logOutgoing(H.byteLength,M,1,"reply:",x),this._protocol.send(H)},x=>{delete this._cancelInvokedHandlers[N];const H=s.serializeReplyErr(M,x);this._logger?.logOutgoing(H.byteLength,M,1,"replyErr:",x),this._protocol.send(H)})}_receiveCancel(R,M){this._logger?.logIncoming(R,M,1,"receiveCancel");const U=String(M);this._cancelInvokedHandlers[U]?.()}_receiveReply(R,M,U){this._logger?.logIncoming(R,M,0,"receiveReply:",U);const A=String(M);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const z=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],z.resolveOk(U)}_receiveReplyErr(R,M,U){this._logger?.logIncoming(R,M,0,"receiveReplyErr:",U);const A=String(M);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const z=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let $;U&&(U.$isError?($=new Error,$.name=U.name,$.message=U.message,$.stack=U.stack):$=U),z.resolveErr($)}_invokeHandler(R,M,U){try{return Promise.resolve(this._doInvokeHandler(R,M,U))}catch(A){return Promise.reject(A)}}_doInvokeHandler(R,M,U){const A=this._locals[R];if(!A)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(R));const z=A[M];if(typeof z!="function")throw new Error("Unknown method "+M+" on actor "+(0,L.getStringIdentifierForProxy)(R));return z.apply(A,U)}_remoteCall(R,M,U){if(this._isDisposed)return new k.CanceledLazyPromise;let A=null;if(U.length>0&&I.CancellationToken.isCancellationToken(U[U.length-1])&&(A=U.pop()),A&&A.isCancellationRequested)return Promise.reject(P.canceled());const z=s.serializeRequestArguments(U,this._uriReplacer),$=++this._lastMessageId,N=String($),V=new k.LazyPromise;A&&A.onCancellationRequested(()=>{const F=s.serializeCancel($);this._logger?.logOutgoing(F.byteLength,$,0,"cancel"),this._protocol.send(s.serializeCancel($))}),this._pendingRPCReplies[N]=V,this._onWillSendRequest($);const B=s.serializeRequest($,R,M,z,!!A);return this._logger?.logOutgoing(B.byteLength,$,0,`request: ${(0,L.getStringIdentifierForProxy)(R)}.${M}(`,U),this._protocol.send(B),V}}e.RPCProtocol=n,C=u,n.UNRESPONSIVE_TIME=3*1e3;class o{static alloc(R,M,U){const A=new o(t.VSBuffer.alloc(U+1+4),0);return A.writeUInt8(R),A.writeUInt32(M),A}static read(R,M){return new o(R,M)}get buffer(){return this._buff}constructor(R,M){this._buff=R,this._offset=M}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,U}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,U}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,M}static sizeMixedArray(R){let M=0;M+=1;for(let U=0,A=R.length;U<A;U++){const z=R[U];switch(M+=1,z.type){case 1:M+=this.sizeLongString(z.value);break;case 2:M+=this.sizeVSBuffer(z.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(z.value);for(let $=0;$<z.buffers.length;++$)M+=this.sizeVSBuffer(z.buffers[$]);break;case 4:break}}return M}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let M=0,U=R.length;M<U;M++){const A=R[M];switch(A.type){case 1:this.writeUInt8(1),this.writeLongString(A.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A.value);break;case 3:this.writeUInt8(3),this.writeUInt32(A.buffers.length),this.writeLongString(A.value);for(let z=0;z<A.buffers.length;++z)this.writeBuffer(A.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const M=new Array(R);for(let U=0;U<R;U++)switch(this.readUInt8()){case 1:M[U]=this.readLongString();break;case 2:M[U]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),$=this.readLongString(),N=[];for(let V=0;V<z;++V)N.push(this.readVSBuffer());M[U]=new L.SerializableObjectWithBuffers(f($,N,null));break}case 4:M[U]=void 0;break}return M}}o.sizeUInt32=4;var d;(function(_){_[_.Simple=0]="Simple",_[_.Mixed=1]="Mixed"})(d||(d={}));class s{static _useMixedArgSerialization(R){for(let M=0,U=R.length;M<U;M++)if(R[M]instanceof t.VSBuffer||R[M]instanceof L.SerializableObjectWithBuffers||typeof R[M]>"u")return!0;return!1}static serializeRequestArguments(R,M){if(this._useMixedArgSerialization(R)){const U=[];for(let A=0,z=R.length;A<z;A++){const $=R[A];if($ instanceof t.VSBuffer)U[A]={type:2,value:$};else if(typeof $>"u")U[A]={type:4};else if($ instanceof L.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:V}=b($.value,M);U[A]={type:3,value:t.VSBuffer.fromString(N),buffers:V}}else U[A]={type:1,value:t.VSBuffer.fromString(v($,M))}}return{type:1,args:U}}return{type:0,args:v(R,M)}}static serializeRequest(R,M,U,A,z){switch(A.type){case 0:return this._requestJSONArgs(R,M,U,A.args,z);case 1:return this._requestMixedArgs(R,M,U,A.args,z)}}static _requestJSONArgs(R,M,U,A,z){const $=t.VSBuffer.fromString(U),N=t.VSBuffer.fromString(A);let V=0;V+=o.sizeUInt8(),V+=o.sizeShortString($),V+=o.sizeLongString(N);const B=o.alloc(z?2:1,R,V);return B.writeUInt8(M),B.writeShortString($),B.writeLongString(N),B.buffer}static deserializeRequestJSONArgs(R){const M=R.readUInt8(),U=R.readShortString(),A=R.readLongString();return{rpcId:M,method:U,args:JSON.parse(A)}}static _requestMixedArgs(R,M,U,A,z){const $=t.VSBuffer.fromString(U);let N=0;N+=o.sizeUInt8(),N+=o.sizeShortString($),N+=o.sizeMixedArray(A);const V=o.alloc(z?4:3,R,N);return V.writeUInt8(M),V.writeShortString($),V.writeMixedArray(A),V.buffer}static deserializeRequestMixedArgs(R){const M=R.readUInt8(),U=R.readShortString(),A=R.readMixedArray(),z=new Array(A.length);for(let $=0,N=A.length;$<N;$++){const V=A[$];typeof V=="string"?z[$]=JSON.parse(V):z[$]=V}return{rpcId:M,method:U,args:z}}static serializeAcknowledged(R){return o.alloc(5,R,0).buffer}static serializeCancel(R){return o.alloc(6,R,0).buffer}static serializeReplyOK(R,M,U){if(typeof M>"u")return this._serializeReplyOKEmpty(R);if(M instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(R,M);if(M instanceof L.SerializableObjectWithBuffers){const{jsonString:A,referencedBuffers:z}=b(M.value,U,!0);return this._serializeReplyOKJSONWithBuffers(R,A,z)}else return this._serializeReplyOKJSON(R,E(M,U))}static _serializeReplyOKEmpty(R){return o.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,M){let U=0;U+=o.sizeVSBuffer(M);const A=o.alloc(8,R,U);return A.writeVSBuffer(M),A.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,M){const U=t.VSBuffer.fromString(M);let A=0;A+=o.sizeLongString(U);const z=o.alloc(9,R,A);return z.writeLongString(U),z.buffer}static _serializeReplyOKJSONWithBuffers(R,M,U){const A=t.VSBuffer.fromString(M);let z=0;z+=o.sizeUInt32,z+=o.sizeLongString(A);for(const N of U)z+=o.sizeVSBuffer(N);const $=o.alloc(10,R,z);$.writeUInt32(U.length),$.writeLongString(A);for(const N of U)$.writeBuffer(N);return $.buffer}static deserializeReplyOKJSON(R){const M=R.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(R,M){const U=R.readUInt32(),A=R.readLongString(),z=[];for(let $=0;$<U;++$)z.push(R.readVSBuffer());return new L.SerializableObjectWithBuffers(f(A,z,M))}static serializeReplyErr(R,M){const U=M?E(P.transformErrorForSerialization(M),null):void 0;if(typeof U!="string")return this._serializeReplyErrEmpty(R);const A=t.VSBuffer.fromString(U);let z=0;z+=o.sizeLongString(A);const $=o.alloc(11,R,z);return $.writeLongString(A),$.buffer}static deserializeReplyErrError(R){const M=R.readLongString();return JSON.parse(M)}static _serializeReplyErrEmpty(R){return o.alloc(12,R,0).buffer}}var a;(function(_){_[_.RequestJSONArgs=1]="RequestJSONArgs",_[_.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",_[_.RequestMixedArgs=3]="RequestMixedArgs",_[_.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",_[_.Acknowledged=5]="Acknowledged",_[_.Cancel=6]="Cancel",_[_.ReplyOKEmpty=7]="ReplyOKEmpty",_[_.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",_[_.ReplyOKJSON=9]="ReplyOKJSON",_[_.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",_[_.ReplyErrError=11]="ReplyErrError",_[_.ReplyErrEmpty=12]="ReplyErrEmpty"})(a||(a={}));var m;(function(_){_[_.String=1]="String",_[_.VSBuffer=2]="VSBuffer",_[_.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",_[_.Undefined=4]="Undefined"})(m||(m={}))}),define(Ce[278],De([1,0,4,43,52,3,38,11,18]),function(J,e,l,t,I,P,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.channels=new Map,this._onDidRegisterChannel=new l.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new l.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(S){this.channels.has(S.id)||(this.channels.set(S.id,S),this._onDidRegisterChannel.fire(S.id))}getChannels(){const S=[];return this.channels.forEach(p=>S.push(p)),S}getChannel(S){return this.channels.get(S)}removeChannel(S){this.channels.delete(S),this._onDidRemoveChannel.fire(S)}}t.Registry.add(e.Extensions.OutputChannels,new L);function C(T,S,p,b,f){return(0,w.createCancelablePromise)(async v=>{await(0,y.whenProviderRegistered)(p,b);const h=t.Registry.as(e.Extensions.OutputChannels);try{await E(p,1,b,f,v),h.registerChannel({id:T,label:S,file:p,log:!0})}catch(c){(0,D.isCancellationError)(c)||f.error("Error while registering log channel",p.toString(),(0,D.getErrorMessage)(c))}})}e.registerLogChannel=C;async function E(T,S,p,b,f){if(!await p.exists(T)){if(f.isCancellationRequested)throw new D.CancellationError;if(S>10)throw new Error("Timed out while waiting for file to be created");b.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,w.timeout)(1e3,f),await E(T,S+1,p,b,f)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new I.RawContextKey("activeOutputChannel","")}),define(Ce[139],De([1,0,5,3,16,12,278,68,25,46,152,23,13,38]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class S extends P.AbstractMessageLogger{get disposed(){return this._disposed}constructor(v,h,c,g,i){super(),this.id=v,this.name=h,this.logger=c,this.proxy=g,this.extension=i,this.offset=0,this._disposed=!1,this.visible=!1,this._register(c.onDidChangeLogLevel(u=>this.setLevel(u)))}appendLine(v){this.append(v+`
`)}append(v){this.info(v),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Append))}clear(){const v=this.offset;this.logger.flush(),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Clear,v)}replace(v){const h=this.offset;this.info(v),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Replace,h),this.visible&&this.logger.flush()}show(v,h){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof v=="boolean"?v:h))}hide(){this.proxy.$close(this.id)}log(v,h){this.offset+=C.VSBuffer.fromString(h).byteLength,(0,P.log)(this.logger,v,h)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class p extends S{appendLine(v){this.append(v)}}let b=class{constructor(v,h,c,g,i){this.initData=h,this.extHostFileSystem=c,this.extHostFileSystemInfo=g,this.loggerService=i,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=v.getProxy(l.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(h.logsLocation,`output_logging_${(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.visibleChannelId=v;for(const[h,c]of this.channels)c.visible=h===this.visibleChannelId}createOutputChannel(v,h,c){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const g=typeof h=="object"&&h.log,i=(0,E.isString)(h)?h:void 0;if((0,E.isString)(i)&&!i.trim())throw new Error("illegal argument `languageId`. must not be empty");const u=g?this.doCreateLogOutputChannel(v,c):this.doCreateOutputChannel(v,i,c);return u.then(r=>{this.channels.set(r.id,r),r.visible=r.id===this.visibleChannelId}),g?this.createExtHostLogOutputChannel(v,u):this.createExtHostOutputChannel(v,u)}async doCreateOutputChannel(v,h,c){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const g=await this.outputDirectoryPromise,i=this.extHostFileSystemInfo.extUri.joinPath(g,`${this.namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.loggerService.createLogger(i,{always:!0,donotRotate:!0,donotUseFormatters:!0}),r=await this.proxy.$register(v,i,!1,h,c.identifier.value);return new S(r,v,u,this.proxy,c)}async doCreateLogOutputChannel(v,h){const c=await this.createExtensionLogDirectory(h),g=this.extHostFileSystemInfo.extUri.joinPath(c,`${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),i=this.loggerService.createLogger(g,{name:v}),u=await this.proxy.$register(v,g,!0,void 0,h.identifier.value);return new p(u,v,i,this.proxy,h)}createExtensionLogDirectory(v){let h=this.extensionLogDirectoryPromise.get(v.identifier.value);if(!h){const c=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,v.identifier.value);this.extensionLogDirectoryPromise.set(v.identifier.value,h=(async()=>{try{await this.extHostFileSystem.value.createDirectory(c)}catch(g){if((0,T.toFileSystemProviderErrorCode)(g)!==T.FileSystemProviderErrorCode.FileExists)throw g}return c})())}return h}createExtHostOutputChannel(v,h){let c=!1;const g=()=>{if(c)throw new Error("Channel has been closed")};return{get name(){return v},append(i){g(),h.then(u=>u.append(i))},appendLine(i){g(),h.then(u=>u.appendLine(i))},clear(){g(),h.then(i=>i.clear())},replace(i){g(),h.then(u=>u.replace(i))},show(i,u){g(),h.then(r=>r.show(i,u))},hide(){g(),h.then(i=>i.hide())},dispose(){c=!0,h.then(i=>i.dispose())}}}createExtHostLogOutputChannel(v,h){let c=!1;const g=()=>{if(c)throw new Error("Channel has been closed")};return{...this.createExtHostOutputChannel(v,h),trace(i,...u){g(),h.then(r=>r.trace(i,...u))},debug(i,...u){g(),h.then(r=>r.debug(i,...u))},info(i,...u){g(),h.then(r=>r.info(i,...u))},warn(i,...u){g(),h.then(r=>r.warn(i,...u))},error(i,...u){g(),h.then(r=>r.error(i,...u))},dispose(){c=!0,h.then(i=>i.dispose())}}}};b=je([He(0,I.IExtHostRpcService),He(1,w.IExtHostInitDataService),He(2,D.IExtHostConsumerFileSystem),He(3,k.IExtHostFileSystemInfo),He(4,P.ILoggerService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(Ce[279],De([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,l.createDecorator)("remoteAgentService")}),define(Ce[280],De([1,0,32,14,9,10,22,2,3,206,45,223,279]),function(J,e,l,t,I,P,y,D,w,k,L,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,w.createDecorator)("pathService");let T=class ti{constructor(p,b,f,v){this.localUserHome=p,this.remoteAgentService=b,this.environmentService=f,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const h=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=h?.userHome??p})()}hasValidBasename(p,b,f){return typeof b=="string"||typeof b>"u"?this.resolveOS.then(v=>this.doHasValidBasename(p,v,b)):this.doHasValidBasename(p,b,f)}doHasValidBasename(p,b,f){return p.scheme===t.Schemas.file||p.scheme===t.Schemas.vscodeRemote?(0,l.isValidBasename)(f??(0,y.basename)(p),b===1):!0}get defaultUriScheme(){return ti.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(p,b){if(p.remoteAuthority)return t.Schemas.vscodeRemote;const f=(0,k.getVirtualWorkspaceScheme)(b.getWorkspace());if(f)return f;const v=b.getWorkspace().folders[0];if(v)return v.uri.scheme;const h=b.getWorkspace().configuration;return h?h.scheme:t.Schemas.file}userHome(p){return p?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(p=>p===1?I.win32:I.posix)}async fileURI(p){let b="";if(await this.resolveOS===1&&(p=p.replace(/\\/g,"/")),p[0]==="/"&&p[1]==="/"){const v=p.indexOf("/",2);v===-1?(b=p.substring(2),p="/"):(b=p.substring(2,v),p=p.substring(v)||"/")}return D.URI.from({scheme:t.Schemas.file,authority:b,path:p,query:"",fragment:""})}};T=je([He(1,E.IRemoteAgentService),He(2,C.IWorkbenchEnvironmentService),He(3,L.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(Ce[71],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class l{constructor(y,D){this.line=y,this.character=D}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,D){return new l(0,0)}with(y){return new l(0,0)}}e.Position=l;class t{constructor(y,D,w,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(y,D),this.end=new l(w,k)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new t(0,0,0,0)}with(y){return new t(0,0,0,0)}}e.Range=t;var I;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[30],De([1,0,17,37,24,32,8,3,9,11,71,18]),function(J,e,l,t,I,P,y,D,w,k,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const E="\u27EA ",T=" characters skipped \u27EB",S=(E.length+T.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var p;(function(K){K[K.file=0]="file",K[K.text=1]="text"})(p=e.SearchProviderType||(e.SearchProviderType={}));var b;(function(K){K[K.File=1]="File",K[K.Text=2]="Text"})(b=e.QueryType||(e.QueryType={}));function f(K){return!!K.preview}e.resultIsMatch=f;function v(K){return!!K.resource}e.isFileMatch=v;function h(K){return!!K.message}e.isProgressMessage=h;var c;(function(K){K[K.Normal=0]="Normal",K[K.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=g;class i{constructor(de,ee,he){this.ranges=ee;const Y=Array.isArray(ee)?ee:[ee];if(he&&he.matchLines===1&&u(Y)){de=(0,y.getNLines)(de,he.matchLines);let me="",be=0,ke=0;const Re=Math.floor(he.charsPerLine/5),ze=[];for(const oe of Y){const le=Math.max(oe.startColumn-Re,0),ge=oe.startColumn+he.charsPerLine;if(le>ke+Re+S){const Z=E+(le-ke)+T;me+=Z+de.slice(le,ge),be+=le-(ke+Z.length)}else me+=de.slice(ke,ge);ze.push(new n(0,oe.startColumn-be,oe.endColumn-be)),ke=ge}this.preview={text:me,matches:Array.isArray(this.ranges)?ze:ze[0]}}else{const me=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:de,matches:(0,l.mapArrayOrNot)(ee,be=>new r(be.startLineNumber-me,be.startColumn,be.endLineNumber-me,be.endColumn))}}}}e.TextSearchMatch=i;function u(K){const de=K[0].startLineNumber;for(const ee of K)if(ee.startLineNumber!==de||ee.endLineNumber!==de)return!1;return!0}class r{constructor(de,ee,he,Y){this.startLineNumber=de,this.startColumn=ee,this.endLineNumber=he,this.endColumn=Y}}e.SearchRange=r;class n extends r{constructor(de,ee,he){super(de,ee,de,he)}}e.OneLineRange=n;var o;(function(K){K.List="list",K.Tree="tree"})(o=e.ViewMode||(e.ViewMode={}));var d;(function(K){K.Default="default",K.FileNames="fileNames",K.Type="type",K.Modified="modified",K.CountDescending="countDescending",K.CountAscending="countAscending"})(d=e.SearchSortOrder||(e.SearchSortOrder={}));function s(K,de=!0){const ee=K&&K.files&&K.files.exclude,he=de&&K&&K.search&&K.search.exclude;if(!ee&&!he)return;if(!ee||!he)return ee||he;let Y=Object.create(null);return Y=I.mixin(Y,I.deepClone(ee)),Y=I.mixin(Y,I.deepClone(he),!0),Y}e.getExcludes=s;function a(K,de){return K.excludePattern&&t.match(K.excludePattern,de)?!1:K.includePattern||K.usingSearchPaths?K.includePattern&&t.match(K.includePattern,de)?!0:K.usingSearchPaths?!!K.folderQueries&&K.folderQueries.some(ee=>{const he=ee.folder.fsPath;if(P.isEqualOrParent(de,he)){const Y=w.relative(he,de);return!ee.includePattern||!!t.match(ee.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var m;(function(K){K[K.unknownEncoding=1]="unknownEncoding",K[K.regexParseError=2]="regexParseError",K[K.globParseError=3]="globParseError",K[K.invalidLiteral=4]="invalidLiteral",K[K.rgProcessError=5]="rgProcessError",K[K.other=6]="other",K[K.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(de,ee){super(de),this.code=ee}}e.SearchError=_;function R(K){const de=K.message;if((0,k.isCancellationError)(K))return new _(de,m.canceled);try{const ee=JSON.parse(de);return new _(ee.message,ee.code)}catch{return new _(de,m.other)}}e.deserializeSearchError=R;function M(K){const de={message:K.message,code:K.code};return new Error(JSON.stringify(de))}e.serializeSearchError=M;function U(K){return K.type==="error"?!0:K.type==="success"}e.isSerializedSearchComplete=U;function A(K){return K.type==="success"}e.isSerializedSearchSuccess=A;function z(K){return!!K.path}e.isSerializedFileMatch=z;function $(K,de){const ee=K.searchPath?K.searchPath:K.relativePath;return(0,y.fuzzyContains)(ee,de)}e.isFilePatternMatch=$;class N{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function V(K,de){const ee={...K||{},...de||{}};return Object.keys(ee).filter(he=>{const Y=ee[he];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=V;class B{constructor(de,ee){this._parsedIncludeExpression=null,this._excludeExpression={...de.excludePattern||{},...ee.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let he=de.includePattern;ee.includePattern&&(he?he={...he,...ee.includePattern}:he=ee.includePattern),he&&(this._parsedIncludeExpression=t.parse(he))}matchesExcludesSync(de,ee,he){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,ee,he))}includedInQuerySync(de,ee,he){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,ee,he)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(de,ee,he))}includedInQuery(de,ee,he){const Y=this._parsedExcludeExpression(de,ee,he),me=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(de,ee,he):!0;return(0,C.isThenable)(Y)?Y.then(be=>be?!1:me()):me()}hasSiblingExcludeClauses(){return F(this._excludeExpression)}}e.QueryGlobTester=B;function F(K){for(const de in K)if(typeof K[de]!="boolean")return!0;return!1}function x(K){if(!K)return;let de;return ee=>(de||(de=(K()||Promise.resolve([])).then(he=>he?Q(he):{})),de.then(he=>!!he[ee]))}e.hasSiblingPromiseFn=x;function H(K){if(!K)return;let de;return ee=>{if(!de){const he=K();de=he?Q(he):{}}return!!de[ee]}}e.hasSiblingFn=H;function Q(K){const de={};for(const ee of K)de[ee]=!0;return de}}),define(Ce[33],De([1,0,17,18,21,4,6,26,14,97,22,8,13,2,176,3,12,195,45,46,25,16,15,7,54,30,5]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f,v,h,c,g,i,u,r,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function d(A,z,$){return new L.ExtUri(N=>_(N,$)).isEqual(A,z)}function s(A,z,$){return d(A.uri,z.uri,$)?0:(0,C.compare)(A.uri.toString(),z.uri.toString())}function a(A,z,$){return A.index!==z.index?A.index<z.index?-1:1:d(A.uri,z.uri,$)?(0,C.compare)(A.name,z.name):(0,C.compare)(A.uri.toString(),z.uri.toString())}function m(A,z,$,N){const V=A.slice(0).sort((F,x)=>$(F,x,N)),B=z.slice(0).sort((F,x)=>$(F,x,N));return(0,l.delta)(V,B,(F,x)=>$(F,x,N))}function _(A,z){const $=z.getCapabilities(A.scheme);return!($&&$&1024)}class R extends v.Workspace{static toExtHostWorkspace(z,$,N,V){if(!z)return{workspace:null,added:[],removed:[]};const{id:B,name:F,folders:x,configuration:H,transient:Q,isUntitled:K}=z,de=[],ee=$;$?x.forEach((be,ke)=>{const Re=T.URI.revive(be.uri),ze=R._findFolder(N||$,Re,V);ze?(ze.name=be.name,ze.index=be.index,de.push(ze)):de.push({uri:Re,name:be.name,index:ke})}):de.push(...x.map(({uri:be,name:ke,index:Re})=>({uri:T.URI.revive(be),name:ke,index:Re}))),de.sort((be,ke)=>be.index<ke.index?-1:1);const he=new R(B,F,de,!!Q,H?T.URI.revive(H):null,!!K,be=>_(be,V)),{added:Y,removed:me}=m(ee?ee.workspaceFolders:[],he.workspaceFolders,s,V);return{workspace:he,added:Y,removed:me}}static _findFolder(z,$,N){for(let V=0;V<z.folders.length;V++){const B=z.workspaceFolders[V];if(d(B.uri,$,N))return B}}constructor(z,$,N,V,B,F,x){super(z,N.map(H=>new v.WorkspaceFolder(H)),V,B,x),this._name=$,this._isUntitled=F,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris(x),N.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(z,$){return $&&this._structure.get(z)&&(z=(0,L.dirname)(z)),this._structure.findSubstr(z)}resolveWorkspaceFolder(z){return this._structure.get(z)}}let M=class{constructor(z,$,N,V,B){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=V,this._extHostFileSystemInfo=N,this._uriTransformerService=B,this._requestIdProvider=new k.Counter,this._barrier=new t.Barrier,this._proxy=z.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=z.getProxy(o.MainContext.MainThreadMessageService);const F=$.workspace;this._confirmedWorkspace=F?new R(F.id,F.name,[],!!F.transient,F.configuration?T.URI.revive(F.configuration):null,!!F.isUntitled,x=>_(x,N)):void 0}$initializeWorkspace(z,$){this._trusted=$,this.$acceptWorkspaceData(z),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?T.URI.from({scheme:w.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(z,$,N,...V){const B=[];if(Array.isArray(V)&&V.forEach(K=>{T.URI.isUri(K.uri)&&!B.some(de=>d(de.uri,K.uri,this._extHostFileSystemInfo))&&B.push({uri:K.uri,name:K.name||(0,L.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[$,N].some(K=>typeof K!="number"||K<0)||N===0&&B.length===0)return!1;const F=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+N>F.length)return!1;const x=F.slice(0);x.splice($,N,...B.map(K=>({uri:K.uri,name:K.name||(0,L.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<x.length;K++){const de=x[K];if(x.some((ee,he)=>he!==K&&d(de.uri,ee.uri,this._extHostFileSystemInfo)))return!1}x.forEach((K,de)=>K.index=de);const{added:H,removed:Q}=m(F,x,a,this._extHostFileSystemInfo);if(H.length===0&&Q.length===0)return!1;if(this._proxy){const K=z.displayName||z.name;this._proxy.$updateWorkspaceFolders(K,$,N,B).then(void 0,de=>{this._unconfirmedWorkspace=void 0;const ee={source:{identifier:z.identifier,label:z.displayName||z.name}};this._messageService.$showMessage(f.Severity.Error,(0,S.localize)(0,null,K,de.toString()),ee,[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(z,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,$)}async getWorkspaceFolder2(z,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,$)}async resolveWorkspaceFolder(z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(z)}getPath(){if(!this._actualWorkspace)return;const{folders:z}=this._actualWorkspace;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,$){let N,V="";if(typeof z=="string"?(N=T.URI.file(z),V=z):typeof z<"u"&&(N=z,V=z.fsPath),!N)return V;const B=this.getWorkspaceFolder(N,!0);if(!B)return V;typeof $>"u"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let F=(0,L.relativePath)(B.uri,N);return $&&B.name&&(F=`${B.name}/${F}`),F}trySetWorkspaceFolders(z){this._actualWorkspace&&(this._unconfirmedWorkspace=R.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:z,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:$,added:N,removed:V}=R.toExtHostWorkspace(z,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:V}))}findFiles(z,$,N,V,B=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let F;if($===null?F=!1:$&&(typeof $=="string"?F=$:F=$.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:H}=U(i.GlobPattern.from(z));return this._proxy.$startFileSearch((0,E.withUndefinedAsNull)(x),(0,E.withUndefinedAsNull)(H),(0,E.withUndefinedAsNull)(F),(0,E.withUndefinedAsNull)(N),B).then(Q=>Array.isArray(Q)?Q.map(K=>T.URI.revive(K)):[])}async findTextInFiles(z,$,N,V,B=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const F=this._requestIdProvider.getNext(),x=typeof $.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:H,folder:Q}=U(i.GlobPattern.from($.include)),K=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,de={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof $.useParentIgnoreFiles=="boolean"?!$.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:x,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:H,excludePattern:K},ee=!1;if(this._activeSearchCallbacks[F]=he=>{if(ee)return;const Y=T.URI.revive(he.resource);he.results.forEach(me=>{(0,n.resultIsMatch)(me)?N({uri:Y,preview:{text:me.preview.text,matches:(0,l.mapArrayOrNot)(me.preview.matches,be=>new u.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,l.mapArrayOrNot)(me.ranges,be=>new u.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):N({uri:Y,text:me.text,lineNumber:me.lineNumber})})},B.isCancellationRequested)return{};try{const he=await this._proxy.$startTextSearch(z,(0,E.withUndefinedAsNull)(Q),de,F,B);return delete this._activeSearchCallbacks[F],he||{}}catch(he){throw delete this._activeSearchCallbacks[F],he}}$handleTextSearchResult(z,$){this._activeSearchCallbacks[$]?.(z)}saveAll(z){return this._proxy.$saveAll(z)}resolveProxy(z){return this._proxy.$resolveProxy(z)}get trusted(){return this._trusted}requestWorkspaceTrust(z){return this._proxy.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(z,$){if(this._editSessionIdentityProviders.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this._editSessionIdentityProviders.set(z,$);const N=this._uriTransformerService.transformOutgoingScheme(z),V=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(V,N),(0,y.toDisposable)(()=>{this._editSessionIdentityProviders.delete(z),this._proxy.$unregisterEditSessionIdentityProvider(V)})}async $getEditSessionIdentifier(z,$){this._logService.info("Getting edit session identifier for workspaceFolder",z);const N=await this.resolveWorkspaceFolder(T.URI.revive(z));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const V=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!V),!V)return;const B=await V.provideEditSessionIdentity(N,$);if(this._logService.info("Provider returned edit session identifier: ",B),!!B)return B}};M=je([He(0,g.IExtHostRpcService),He(1,c.IExtHostInitDataService),He(2,h.IExtHostFileSystemInfo),He(3,b.ILogService),He(4,r.IURITransformerService)],M),e.ExtHostWorkspace=M,e.IExtHostWorkspace=(0,p.createDecorator)("IExtHostWorkspace");function U(A){let z,$;return A&&(typeof A=="string"?z=A:(z=A.pattern,$=T.URI.revive(A.baseUri))),{includePattern:z,folder:$}}}),define(Ce[34],De([1,0,24,4,33,5,7,198,124,13,18,3,16,12,2]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function p(u,r){if(r){const n=r.split(".");let o=u;for(let d=0;o&&d<n.length;d++)o=o[n[d]];return o}}function b(u){return u instanceof S.URI}function f(u){return u&&u.uri instanceof S.URI&&u.languageId&&typeof u.languageId=="string"}function v(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function h(u){return u&&u.uri instanceof S.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function c(u){if(b(u))return{resource:u};if(f(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(v(u))return{overrideIdentifier:u.languageId};if(h(u))return{resource:u.uri};if(u===null)return{resource:null}}let g=class{constructor(r,n,o){this._proxy=r.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=o,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new i(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,n){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(r,n))}};g=je([He(0,E.IExtHostRpcService),He(1,I.IExtHostWorkspace),He(2,T.ILogService)],g),e.ExtHostConfiguration=g;class i{constructor(r,n,o,d){this._onDidChangeConfiguration=new t.Emitter,this._proxy=r,this._logService=d,this._extHostWorkspace=n,this._configuration=D.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,n){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,o))}getConfiguration(r,n,o){const d=c(n)||{},s=this._toReadonlyValue(r?p(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,d,o?.identifier);function a(_){if(_==null)return null;if(typeof _=="boolean")return _?2:5;switch(_){case y.ConfigurationTarget.Global:return 2;case y.ConfigurationTarget.Workspace:return 5;case y.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(_){return typeof p(s,_)<"u"},get:(_,R)=>{this._validateConfigurationAccess(r?`${r}.${_}`:_,d,o?.identifier);let M=p(s,_);if(typeof M>"u")M=R;else{let U;const A=(z,$)=>{let N;const V=()=>{U=U||(0,l.deepClone)(s),N=N||p(U,$)};return(0,k.isObject)(z)?new Proxy(z,{get:(B,F)=>{if(typeof F=="string"&&F.toLowerCase()==="tojson")return V(),()=>N;if(U)return N=N||p(U,$),N[F];const x=B[F];return typeof F=="string"?A(x,`${$}.${F}`):x},set:(B,F,x)=>(V(),N&&(N[F]=x),!0),deleteProperty:(B,F)=>(V(),N&&delete N[F],!0),defineProperty:(B,F,x)=>(V(),N&&Object.defineProperty(N,F,x),!0)}):z};M=A(M,_)}return M},update:(_,R,M,U)=>{_=r?`${r}.${_}`:_;const A=a(M);return R!==void 0?this._proxy.$updateConfigurationOption(A,_,R,d,U):this._proxy.$removeConfigurationOption(A,_,d,U)},inspect:_=>{_=r?`${r}.${_}`:_;const R=(0,l.deepClone)(this._configuration.inspect(_,d,this._extHostWorkspace.workspace));if(R)return{key:_,defaultValue:R.policy?.value??R.default?.value,globalValue:R.user?.value??R.application?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override??R.application?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof s=="object"&&(0,l.mixin)(m,s,!1),Object.freeze(m)}_toReadonlyValue(r){const n=o=>(0,k.isObject)(o)?new Proxy(o,{get:(d,s)=>n(d[s]),set:(d,s,a)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(d,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(d,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return n(r)}_validateConfigurationAccess(r,n,o){const d=w.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),s=o?`[${o.value}] `:"";if(d===4){typeof n?.resource>"u"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){n?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,n){const o=new D.ConfigurationChangeEvent(r,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,s)=>o.affectsConfiguration(d,c(s))})}_toMap(r){return r.reduce((n,o)=>(n.set(o[0],o[1]),n),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,l):I?I.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[72],De([1,0,2,18,4,5,7,33,57,34,21,40,16,25,3,14,10,12,67,236,11]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f,v,h,c){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function($){function N(B){if(B!=null)return B}$.from=N;function V(B){if(B!=null)return B}$.to=V})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function($){function N(B){if(B!=null)return B}$.from=N;function V(B){if(B!=null)return B}$.to=V})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function($){function N(B){if(B!=null)return B}$.from=N;function V(B){if(B!=null)return B}$.to=V})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function($){function N(F){if(F){const x=F;return x&&!!x.process}else return!1}$.is=N;function V(F){if(F==null)return;const x={process:F.process,args:F.args};return F.options&&(x.options=r.from(F.options)),x}$.from=V;function B(F){if(F!=null)return new y.ProcessExecution(F.process,F.args,F.options)}$.to=B})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function($){function N(B){if(B!=null)return B}$.from=N;function V(B){if(B!=null)return B}$.to=V})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function($){function N(F){if(F){const x=F;return x&&(!!x.commandLine||!!x.command)}else return!1}$.is=N;function V(F){if(F==null)return;const x={};return F.commandLine!==void 0?x.commandLine=F.commandLine:(x.command=F.command,x.args=F.args),F.options&&(x.options=o.from(F.options)),x}$.from=V;function B(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new y.ShellExecution(F.commandLine,F.options):new y.ShellExecution(F.command,F.args?F.args:[],F.options)}$.to=B})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function($){function N(F){if(F){const x=F;return x&&x.customExecution==="customExecution"}else return!1}$.is=N;function V(F){return{customExecution:"customExecution"}}$.from=V;function B(F,x){return x.get(F)}$.to=B})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var a;(function($){function N(V,B){let F;return V.scope!==void 0&&typeof V.scope!="number"?F=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===y.TaskScope.Workspace&&B&&B.workspaceFile?F=B.workspaceFile:F=h.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:F}}$.from=N})(a=e.TaskHandleDTO||(e.TaskHandleDTO={}));var m;(function($){function N(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}$.from=N})(m=e.TaskGroupDTO||(e.TaskGroupDTO={}));var _;(function($){function N(F,x){if(F==null)return[];const H=[];for(const Q of F){const K=V(Q,x);K&&H.push(K)}return H}$.fromMany=N;function V(F,x){if(F==null)return;let H;F.execution instanceof y.ProcessExecution?H=n.from(F.execution):F.execution instanceof y.ShellExecution?H=d.from(F.execution):F.execution&&F.execution instanceof y.CustomExecution&&(H=s.from(F.execution));const Q=i.from(F.definition);let K;return F.scope?typeof F.scope=="number"?K=F.scope:K=F.scope.uri:K=y.TaskScope.Workspace,!Q||!K?void 0:{_id:F._id,definition:Q,name:F.name,source:{extensionId:x.identifier.value,label:F.source,scope:K},execution:H,isBackground:F.isBackground,group:m.from(F.group),presentationOptions:u.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}$.from=V;async function B(F,x,H){if(F==null)return;let Q;n.is(F.execution)?Q=n.to(F.execution):d.is(F.execution)?Q=d.to(F.execution):s.is(F.execution)&&(Q=s.to(F._id,H));const K=i.to(F.definition);let de;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?de=F.source.scope:de=await x.resolveWorkspaceFolder(l.URI.revive(F.source.scope)):de=y.TaskScope.Workspace),!K||!de)return;const ee=new y.Task(K,de,F.name,F.source.label,Q,F.problemMatchers);return F.isBackground!==void 0&&(ee.isBackground=F.isBackground),F.group!==void 0&&(ee.group=y.TaskGroup.from(F.group._id),ee.group&&F.group.isDefault&&(ee.group=new y.TaskGroup(ee.group.id,ee.group.label),F.group.isDefault===!0&&(ee.group.isDefault=F.group.isDefault))),F.presentationOptions&&(ee.presentationOptions=u.to(F.presentationOptions)),F._id&&(ee._id=F._id),F.detail&&(ee.detail=F.detail),ee}$.to=B})(_=e.TaskDTO||(e.TaskDTO={}));var R;(function($){function N(B){return B}$.from=N;function V(B){if(!!B)return Object.assign(Object.create(null),B)}$.to=V})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class M{constructor(N,V,B){this._id=V,this._task=B,g.set(this,void 0),tt(this,g,N,"f")}get task(){return this._task}terminate(){Be(this,g,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}g=new WeakMap;var U;(function($){function N(V){return{id:V._id,task:void 0}}$.from=N})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let A=class{constructor(N,V,B,F,x,H,Q,K){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=N.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=F,this._configurationService=x,this._terminalService=H,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Q,this._deprecationService=K,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,V,B){if(!B)return new y.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:V,provider:B,extension:N}),this._proxy.$registerTaskProvider(F,V),new y.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(N,V){this._proxy.$registerTaskSystem(N,V)}fetchTasks(N){return this._proxy.$fetchTasks(R.from(N)).then(async V=>{const B=[];for(const F of V){const x=await _.to(F,this._workspaceProvider,this._providedCustomExecutions2);x&&B.push(x)}return B})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(V=>N.push(V)),N}terminateTask(N){if(!(N instanceof M))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,V,B){const F=this._providedCustomExecutions2.get(N.id);F&&(this._activeCustomExecutions2.set(N.id,F),this._terminalService.attachPtyToTerminal(V,await F.callback(B))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const V=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:V,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:N.exitCode})}$provideTasks(N,V){const B=this._handlers.get(N);if(!B)return Promise.reject(new Error("no handler found"));const F=[],x=(0,t.asPromise)(()=>B.provider.provideTasks(L.CancellationToken.None)).then(H=>this.provideTasksInternal(V,F,B,H));return new Promise(H=>{x.then(Q=>{Promise.all(F).then(()=>{H(Q)})})})}async $resolveTask(N,V){const B=this._handlers.get(N);if(!B)return Promise.reject(new Error("no handler found"));if(V.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${B.type}].`);const F=await _.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const x=await B.provider.resolveTask(F,L.CancellationToken.None);if(!x)return;this.checkDeprecation(x,B);const H=_.from(x,B.extension);if(!H)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(H.execution)&&await this.addCustomExecution(H,x,!0),await this.resolveTaskInternal(H)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,V,B){const F=await this._proxy.$createTaskId(N);!B&&!this._providedCustomExecutions2.has(F)&&(this._notProvidedCustomExecutions.add(F),this._activeCustomExecutions2.set(F,V.execution)),this._providedCustomExecutions2.set(F,V.execution)}async getTaskExecution(N,V){if(typeof N=="string"){const x=this._taskExecutionPromises.get(N);if(!x)throw new c.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return x}const B=this._taskExecutionPromises.get(N.id);if(B)return B;const F=new Promise((x,H)=>{function Q(K,de,ee){ee?x(new M(K,de.id,ee)):H("Unexpected: Task does not exist.")}V?Q(this,N,V):_.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(K=>Q(this,N,K))});return this._taskExecutionPromises.set(N.id,F),F.then(x=>(this._taskExecutions.set(N.id,x),x),x=>Promise.reject(x))}checkDeprecation(N,V){N._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));const B=this._notProvidedCustomExecutions.values();let F=B.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=B.next()}};A=je([He(0,E.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,D.IExtHostWorkspace),He(3,w.IExtHostDocumentsAndEditors),He(4,k.IExtHostConfiguration),He(5,C.IExtHostTerminalService),He(6,f.ILogService),He(7,v.IExtHostApiDeprecationService)],A),e.ExtHostTaskBase=A;let z=class extends A{constructor(N,V,B,F,x,H,Q,K){super(N,V,B,F,x,H,Q,K),this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(N,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const B=_.from(V,N);if(B===void 0)throw new Error("Task is not valid");if(s.is(B.execution))await this.addCustomExecution(B,V,!1);else throw new c.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),V);return this._proxy.$executeTask(B).catch(x=>{throw new Error(x)}),F}provideTasksInternal(N,V,B,F){const x=[];if(F)for(const H of F){this.checkDeprecation(H,B),(!H.definition||!N[H.definition.type])&&this._logService.warn(`The task [${H.source}, ${H.name}] uses an undefined task type. The task will be ignored in the future.`);const Q=_.from(H,B.extension);Q&&s.is(Q.execution)?(x.push(Q),V.push(this.addCustomExecution(Q,H,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:B.extension}}async resolveTaskInternal(N){if(s.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,V,B){}};z=je([He(0,E.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,D.IExtHostWorkspace),He(3,w.IExtHostDocumentsAndEditors),He(4,k.IExtHostConfiguration),He(5,C.IExtHostTerminalService),He(6,f.ILogService),He(7,v.IExtHostApiDeprecationService)],z),e.WorkerExtHostTask=z,e.IExtHostTask=(0,S.createDecorator)("IExtHostTask")}),define(Ce[281],De([1,0,9,21,50,37,22,51,30]),function(J,e,l,t,I,P,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(E,T,S){this.config=E,this.provider=T,this.sessionToken=S,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=E.filePattern,this.includePattern=E.includePattern&&P.parse(E.includePattern),this.maxResults=E.maxResults||void 0,this.exists=E.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=E.excludePattern&&P.parse(E.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(E=>E.cancel()),this.activeCancellationTokens=new Set}search(E){const T=this.config.folderQueries||[];return new Promise((S,p)=>{const b=f=>{this.resultCount++,E(f)};if(this.isCanceled)return S({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(f=>{const v=f.toString(),h=l.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,h)||this.matchFile(b,{base:f,basename:h})}),Promise.all(T.map(f=>this.searchInFolder(f,b))).then(f=>{S({limitHit:this.isLimitHit,stats:f[0]||void 0})},f=>{p(new Error((0,I.toErrorMessage)(f)))})})}async searchInFolder(E,T){const S=new t.CancellationTokenSource,p=this.getSearchOptionsForFolder(E),b=this.initDirectoryTree(),f=new w.QueryGlobTester(this.config,E),v=!f.hasSiblingExcludeClauses();let h;try{this.activeCancellationTokens.add(S),h=D.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},p,S.token),g=h.elapsed(),i=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(u=>{const r=l.posix.relative(E.folder.path,u.path);if(v){const n=l.basename(u.path);this.matchFile(T,{base:E.folder,relativePath:r,basename:n});return}this.addDirectoryEntries(b,E.folder,r,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(b,f,T),{providerTime:g,postProcessTime:i.elapsed()})}finally{S.dispose(),this.activeCancellationTokens.delete(S)}}getSearchOptionsForFolder(E){const T=(0,w.resolvePatternsForProvider)(this.config.includePattern,E.includePattern),S=(0,w.resolvePatternsForProvider)(this.config.excludePattern,E.excludePattern);return{folder:E.folder,excludes:S,includes:T,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}addDirectoryEntries({pathToEntries:E},T,S,p){if(S===this.filePattern){const f=l.basename(this.filePattern);this.matchFile(p,{base:T,relativePath:this.filePattern,basename:f})}function b(f){const v=l.basename(f),h=l.dirname(f);let c=E[h];c||(c=E[h]=[],b(h)),c.push({base:T,relativePath:f,basename:v})}b(S)}matchDirectoryTree({rootEntries:E,pathToEntries:T},S,p){const b=this,f=this.filePattern;function v(h){const c=(0,w.hasSiblingFn)(()=>h.map(g=>g.basename));for(let g=0,i=h.length;g<i;g++){const u=h[g],{relativePath:r,basename:n}=u;if(S.matchesExcludesSync(r,n,f!==n?c:void 0))continue;const o=T[r];if(o)v(o);else{if(r===f)continue;b.matchFile(p,u)}if(b.isLimitHit)break}}v(E)}matchFile(E,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||E(T))}}class L{constructor(){this.sessions=new Map}fileSearch(E,T,S,p){const b=this.getSessionTokenSource(E.cacheKey),f=new k(E,T,b&&b.token);let v=0;const h=c=>{v+=c.length,S(c.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(f,L.BATCH_SIZE,h,p).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:c.stats}}))}clearCache(E){this.getSessionTokenSource(E)?.cancel()}getSessionTokenSource(E){if(!!E)return this.sessions.has(E)||this.sessions.set(E,new t.CancellationTokenSource),this.sessions.get(E)}rawMatchToSearchItem(E){return E.relativePath?{resource:y.joinPath(E.base,E.relativePath)}:{resource:E.base}}doSearch(E,T,S,p){p.onCancellationRequested(()=>{E.cancel()});const b=v=>{v&&(f.push(v),T>0&&f.length>=T&&(S(f),f=[]))};let f=[];return E.search(b).then(v=>(f.length&&S(f),v),v=>(f.length&&S(f),Promise.reject(v)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(Ce[282],De([1,0,17,77,37,109,26,14,9,22,8,13,2,160,187,65,12,45,130,280,30]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(m,_,R,M,U){this.configurationService=m,this.workspaceContextService=_,this.editorGroupsService=R,this.logService=M,this.pathService=U}text(m,_,R={}){m=this.getContentPattern(m,R);const M=this.configurationService.getValue(),U=_&&_.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(_?.map(f.toWorkspaceFolder),R),type:2,contentPattern:m,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:M.search.usePCRE2||U||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}getContentPattern(m,_){const R=this.configurationService.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const M={...m,wordSeparators:R.editor.wordSeparators};return this.isCaseSensitive(m,_)&&(M.isCaseSensitive=!0),this.isMultiline(m)&&(M.isMultiline=!0),M}file(m,_={}){return{...this.commonQuery(m,_),type:1,filePattern:_.filePattern?_.filePattern.trim():_.filePattern,exists:_.exists,sortByScore:_.sortByScore,cacheKey:_.cacheKey}}handleIncludeExclude(m,_){return m?(m=Array.isArray(m)?m.map(o):o(m),_?this.parseSearchPaths(m):{pattern:u(...Array.isArray(m)?m:[m])}):{}}commonQuery(m=[],_={}){const R=this.handleIncludeExclude(_.includePattern,_.expandPatterns),M=this.handleIncludeExclude(_.excludePattern,_.expandPatterns),U=m.length>1,A=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,_,M)):m.map(N=>this.getFolderQueryForRoot(N,_,M,U))).filter(N=>!!N),z={_reason:_._reason,folderQueries:A,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:_.extraFileResources,excludePattern:M.pattern,includePattern:R.pattern,onlyOpenEditors:_.onlyOpenEditors,maxResults:_.maxResults};if(_.onlyOpenEditors){const N=l.coalesce(l.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(x=>x.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const V=N.filter(F=>(0,c.pathIncludedInQuery)(z,F.fsPath)),B=this.commonQueryFromFileList(V);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...z,...B}}const $=_.extraFileResources&&_.extraFileResources.filter(N=>(0,c.pathIncludedInQuery)(z,N.fsPath));return z.extraFileResources=$&&$.length?$:void 0,z}commonQueryFromFileList(m){const _=[],R=new y.ResourceMap,M={};let U=!1;return m.forEach(A=>{if(A.scheme===D.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(A)){const $=this.workspaceContextService.getWorkspaceFolder(A)?.uri??A.with({path:w.dirname(A.fsPath)});let N=R.get($);N||(U=!0,N={folder:$,includePattern:{}},_.push(N),R.set($,N));const V=w.relative($.fsPath,A.fsPath);(0,C.assertIsDefined)(N.includePattern)[V.replace(/\\/g,"/")]=!0}else A.fsPath&&(U=!0,M[A.fsPath]=!0)}),{folderQueries:_,includePattern:M,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}isCaseSensitive(m,_){if(_.isSmartCase){if(m.isRegExp){if(L.containsUppercaseCharacter(m.pattern,!0))return!0}else if(L.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}isMultiline(m){return m.isMultiline||m.isRegExp&&(0,T.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const _=B=>w.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),M=(Array.isArray(m)?m:r(m)).map(B=>{const F=this.pathService.resolvedUserHome;return F?(0,P.untildify)(B,F.scheme===D.Schemas.file?F.fsPath:F.path):B}),U=t.groupBy(M,B=>_(B)?"searchPaths":"exprSegments"),A=(U.exprSegments||[]).map(B=>L.rtrim(B,"/")).map(B=>L.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),n(B))),z={},$=this.expandSearchPathPatterns(U.searchPaths||[]);$&&$.length&&(z.searchPaths=$);const N=l.flatten(A),V=u(...N);return V&&(z.pattern=V),z}getExcludesForFolder(m,_){return _.disregardExcludeSettings?void 0:(0,c.getExcludes)(m,!_.disregardSearchExcludeSettings)}expandSearchPathPatterns(m){if(!m||!m.length)return[];const _=l.flatten(m.map(M=>{let{pathPortion:U,globPortion:A}=i(M);A&&(A=d(A));const z=this.expandOneSearchPath(U);return l.flatten(z.map($=>this.resolveOneSearchPathPattern($,A)))})),R=new Map;return _.forEach(M=>{const U=M.searchPath.toString(),A=R.get(U);A?M.pattern&&(A.pattern=A.pattern||{},A.pattern[M.pattern]=!0):R.set(U,{searchPath:M.searchPath,pattern:M.pattern?u(M.pattern):void 0})}),Array.from(R.values())}expandOneSearchPath(m){if(w.isAbsolute(m)){const _=this.workspaceContextService.getWorkspace().folders;return _[0]&&_[0].uri.scheme!==D.Schemas.file?[{searchPath:_[0].uri.with({path:m})}]:[{searchPath:E.URI.file(w.normalize(m))}]}if(this.workspaceContextService.getWorkbenchState()===2){const _=this.workspaceContextService.getWorkspace().folders[0].uri;if(m=o(m),m.startsWith("../")||m===".."){const M=w.posix.resolve(_.path,m);return[{searchPath:_.with({path:M})}]}const R=d(m);return[{searchPath:_,pattern:R}]}else{if(m==="./"||m===".\\")return[];{const _=m.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(U=>{const A=_.match(new RegExp(`^${L.escapeRegExpCharacters(U.name)}(?:/(.*)|$)`));return A?{match:A,folder:U}:null}).filter(C.isDefined);if(M.length)return M.map(U=>{const A=U.match[1];return{searchPath:U.folder.uri,pattern:A&&d(A)}});{const U=m.match(/\.[\/\\](.+)[\/\\]?/),A=U?U[1]:m,z=S.localize(0,null,A);throw new Error(z)}}}}resolveOneSearchPathPattern(m,_){const R=m.pattern&&_?`${m.pattern}/${_}`:m.pattern||_,M=[{searchPath:m.searchPath,pattern:R}];return R&&!R.endsWith("**")&&M.push({searchPath:m.searchPath,pattern:R+"/**"}),M}getFolderQueryForSearchPath(m,_,R){const M=this.getFolderQueryForRoot((0,f.toWorkspaceFolder)(m.searchPath),_,R,!1);return M?{...M,includePattern:m.pattern}:null}getFolderQueryForRoot(m,_,R,M){let U;const A=E.URI.isUri(m)?m:m.uri;if(R.searchPaths){const B=R.searchPaths.filter(F=>(0,k.isEqual)(F.searchPath,A))[0];if(B&&!B.pattern)return null;B&&(U=B.pattern)}const z=this.configurationService.getValue({resource:A}),N={...this.getExcludesForFolder(z,_)||{},...U||{}},V=E.URI.isUri(m)?(0,k.basename)(m):m.name;return{folder:A,folderName:M?V:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof _.disregardIgnoreFiles=="boolean"?_.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof _.disregardGlobalIgnoreFiles=="boolean"?_.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof _.disregardParentIgnoreFiles=="boolean"?_.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof _.ignoreSymlinks=="boolean"?_.ignoreSymlinks:!z.search.followSymlinks}}};g=je([He(0,p.IConfigurationService),He(1,f.IWorkspaceContextService),He(2,v.IEditorGroupsService),He(3,b.ILogService),He(4,h.IPathService)],g),e.QueryBuilder=g;function i(a){const m=a.match(/[\*\{\}\(\)\[\]\?]/);if(m){const _=m.index,R=a.substr(0,_).match(/[/|\\][^/\\]*$/);if(R){let M=a.substr(0,R.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:a.substr((R.index||0)+1)}}}return{pathPortion:a}}function u(...a){return a.length?a.reduce((m,_)=>(m[_]=!0,m),Object.create(null)):void 0}function r(a){return I.splitGlobAware(a,",").map(m=>m.trim()).filter(m=>!!m.length)}function n(a){return[`**/${a}/**`,`**/${a}`].map(_=>_.replace(/\*\*\/\*\*/g,"**"))}function o(a){return a.replace(/\\/g,"/")}function d(a){return o(a).replace(/^\.\//,"").replace(/\/+$/g,"")}function s(a,m){a=l.distinct(a,M=>M.toString());const _=[],R=m.getWorkspace();return a&&a.forEach(M=>{let U;if(m.getWorkbenchState()===2)U=(0,k.relativePath)(R.folders[0].uri,M),U&&U!=="."&&(U="./"+U);else{const A=m.getWorkspaceFolder(M);if(A){const z=A.name;if(R.folders.filter(N=>N.name===z).length===1){const N=(0,k.relativePath)(A.uri,M);N===""?U=`./${A.name}`:U=`./${A.name}/${N}`}else U=M.fsPath}}U&&_.push(U)}),_}e.resolveResourcesForSearchIncludes=s}),define(Ce[283],De([1,0,22,2,21,11,3,282,30,45]),function(J,e,l,t,I,P,y,D,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function C(p,b){const f=b.activationEvents;if(!f)return Promise.resolve(void 0);const v=[],h=[];for(const n of f)if(/^workspaceContains:/.test(n)){const o=n.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||p.forceUsingSearch?h.push(o):v.push(o)}if(v.length===0&&h.length===0)return Promise.resolve(void 0);let c;const g=new Promise((n,o)=>{c=n}),i=n=>c({activationEvent:n}),u=Promise.all(v.map(n=>E(p,n,i))).then(()=>{}),r=T(p,b.identifier,h,i);return Promise.all([u,r]).then(()=>{c(void 0)}),g}e.checkActivateWorkspaceContainsExtension=C;async function E(p,b,f){for(const v of p.folders)if(await p.exists(l.joinPath(t.URI.revive(v),b))){f(`workspaceContains:${b}`);return}}async function T(p,b,f,v){if(f.length===0)return Promise.resolve(void 0);const h=new I.CancellationTokenSource,c=p.checkExists(p.folders,f,h.token),g=setTimeout(async()=>{h.cancel(),p.logService.info(`Not activating extension '${b.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},L);let i=!1;try{i=await c}catch(u){P.isCancellationError(u)||P.onUnexpectedError(u)}h.dispose(),clearTimeout(g),i&&v(`workspaceContains:${f.join(",")}`)}function S(p,b,f,v){const h=p.get(y.IInstantiationService),c=p.get(w.ISearchService),i=h.createInstance(D.QueryBuilder).file(b.map(u=>(0,k.toWorkspaceFolder)(t.URI.revive(u))),{_reason:"checkExists",includePattern:f,exists:!0});return c.fileSearch(i,v).then(u=>!!u.limitHit,u=>P.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=S});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,l):I?I.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[41],De([1,0,171,9,73,22,18,6,26,2,12,5,34,226,94,33,28,224,11,27,23,207,7,125,3,25,69,16,84,53,40,4,283,93,209,14,92]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f,v,h,c,g,i,u,r,n,o,d,s,a,m,_,R,M,U,A,z){"use strict";var $,N,V;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let B=class Nn extends D.Disposable{constructor(ee,he,Y,me,be,ke,Re,ze,oe,le,ge){super(),this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=he,this._extHostContext=Y,this._initData=Re,this._extHostWorkspace=me,this._extHostConfiguration=be,this._logService=ke,this._extHostTunnelService=oe,this._extHostTerminalService=le,this._extHostLocalizationService=ge,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._globalRegistry=new f.ExtensionDescriptionRegistry(this._initData.allExtensions);const Z=(0,b.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new f.ExtensionDescriptionRegistry(H(this._globalRegistry,Z)),this._storage=new S.ExtHostStorage(this._extHostContext),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=ze,this._instaService=ee.createChild(new s.ServiceCollection([S.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState]));let ae=[],ne=[];this._initData.remote.isRemote&&(ae=this._initData.allExtensions.filter(O=>!O.main&&!O.browser).map(O=>O.identifier),ne=this._initData.allExtensions.filter(O=>!Z.has(h.ExtensionIdentifier.toKey(O.identifier.value))).filter(O=>(O.main||O.browser)&&O.api==="none").map(O=>O.identifier));const ie=(0,b.extensionIdentifiersArrayToSet)(ne);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,ae,ne,{onExtensionActivationError:(O,j,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(O,v.transformErrorForSerialization(j),G)},actualActivateExtension:async(O,j)=>{if(ie.has(h.ExtensionIdentifier.toKey(O)))return await this._mainThreadExtensionsProxy.$activateExtension(O,j),new T.HostExtension;const G=this._myRegistry.getExtensionDescription(O);return this._activateExtension(G,j)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ee){v.onUnexpectedError(ee)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ee=[];try{ee=this._myRegistry.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this._deactivate(be))}catch{}await Promise.all(ee)}terminate(ee,he=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ee}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(me=>{this._logService.error(me)}),this._extHostContext.dispose();const Y=this._deactivateAll();Promise.race([(0,y.timeout)(5e3),Y]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${he}`):this._logService.info(`Extension host exiting with code ${he}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(he)})}isActivated(ee){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ee):!1}async getExtension(ee){const he=await this._mainThreadExtensionsProxy.$getExtension(ee);let Y;if(he?.browserNlsBundleUris){Y={};for(const me of Object.keys(he.browserNlsBundleUris))Y[me]=k.URI.revive(he.browserNlsBundleUris[me])}return he&&{...he,identifier:new h.ExtensionIdentifier(he.identifier.value),extensionLocation:k.URI.revive(he.extensionLocation),browserNlsBundleUris:Y}}_activateByEvent(ee,he){return this._activator.activateByEvent(ee,he)}_activateById(ee,he){return this._activator.activateById(ee,he)}activateByIdWithErrors(ee,he){return this._activateById(ee,he).then(()=>{const Y=this._activator.getActivatedExtension(ee);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ee=>this._myRegistry)}getExtensionExports(ee){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ee).exports:null}async _realPathExtensionUri(ee){if(ee.scheme!==A.Schemas.file)return ee;const he=await this._hostUtils.realpath(ee.fsPath);return k.URI.file(he)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ee=>new K(ee))),this._extensionPathIndex}async _createExtensionPathIndex(ee){const he=w.TernarySearchTree.forUris(Y=>P.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(ee.map(async Y=>{if(this._getEntryPoint(Y)){const me=await this._realPathExtensionUri(Y.extensionLocation);he.set(me,Y)}})),he}_deactivate(ee){let he=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ee))return he;const Y=this._activator.getActivatedExtension(ee);if(!Y)return he;try{typeof Y.module.deactivate=="function"&&(he=Promise.resolve(Y.module.deactivate()).then(void 0,me=>(this._logService.error(me),Promise.resolve(void 0))))}catch(me){this._logService.error(`An error occurred when deactivating the extension '${ee.value}':`),this._logService.error(me)}try{(0,D.dispose)(Y.subscriptions)}catch(me){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ee.value}':`),this._logService.error(me)}return he}async _activateExtension(ee,he){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ee.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ee.identifier),this._doActivateExtension(ee,he).then(Y=>{const me=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ee.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,he),this._logExtensionActivationTimes(ee,he,"success",me),Y},Y=>{throw this._logExtensionActivationTimes(ee,he,"failure"),Y})}_logExtensionActivationTimes(ee,he,Y,me){const be=F(ee,he);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...be,...me||{},outcome:Y})}_doActivateExtension(ee,he){const Y=F(ee,he);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const me=this._getEntryPoint(ee);if(!me)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ee.identifier.value}, startup: ${he.startup}, activationEvent: '${he.activationEvent}'${ee.identifier.value!==he.extensionId.value?`, root cause: ${he.extensionId.value}`:""}`),this._logService.flush();const be=new T.ExtensionActivationTimesBuilder(he.startup);return Promise.all([this._loadCommonJSModule(ee,(0,P.joinPath)(ee.extensionLocation,me),be),this._loadExtensionContext(ee)]).then(ke=>(I.mark(`code/extHost/willActivateExtension/${ee.identifier.value}`),Nn._callActivate(this._logService,ee.identifier,ke[0],ke[1],be))).then(ke=>(I.mark(`code/extHost/didActivateExtension/${ee.identifier.value}`),ke))}_loadExtensionContext(ee){const he=new g.ExtensionGlobalMemento(ee,this._storage),Y=new g.ExtensionMemento(ee.identifier.value,!1,this._storage),me=new U.ExtensionSecrets(ee,this._secretState),be=ee.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ke=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ee.identifier.value}`),Promise.all([he.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let ze,oe;const le=(0,b.isProposedApiEnabled)(ee,"ipc")?this._initData.messagePorts?.get(h.ExtensionIdentifier.toKey(ee.identifier)):void 0;return Object.freeze({globalState:he,workspaceState:Y,secrets:me,subscriptions:[],get extensionUri(){return ee.extensionLocation},get extensionPath(){return ee.extensionLocation.fsPath},asAbsolutePath(ge){return t.join(ee.extensionLocation.fsPath,ge)},get storagePath(){return Re._storagePath.workspaceValue(ee)?.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(ee).fsPath},get logPath(){return t.join(Re._initData.logsLocation.fsPath,ee.identifier.value)},get logUri(){return k.URI.joinPath(Re._initData.logsLocation,ee.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(ee)},get globalStorageUri(){return Re._storagePath.globalValue(ee)},get extensionMode(){return be},get extension(){return ze===void 0&&(ze=new x(Re,ee.identifier,ee,ke,!1)),ze},get extensionRuntime(){return(0,b.checkProposedApiEnabled)(ee,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(ee)},get messagePassingProtocol(){if(!oe){if(!le)return;const ge=_.Event.buffer(_.Event.fromDOMEventEmitter(le,"message",Z=>Z.data));le.start(),oe={onDidReceiveMessage:ge,postMessage:le.postMessage.bind(le)}}return oe}})})}static _callActivate(ee,he,Y,me,be){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(ee,he,Y,me,be).then(ke=>new T.ActivatedExtension(!1,null,be.build(),Y,ke,me.subscriptions))}static _callActivateOptional(ee,he,Y,me,be){if(typeof Y.activate=="function")try{be.activateCallStart(),ee.trace(`ExtensionService#_callActivateOptional ${he.value}`);const ke=typeof global=="object"?global:self,Re=Y.activate.apply(ke,[me]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(Re).then(ze=>(be.activateResolveStop(),ze))}catch(ke){return Promise.reject(ke)}else return Promise.resolve(Y)}_activateOneStartupFinished(ee,he){this._activateById(ee.identifier,{startup:!1,extensionId:ee.identifier,activationEvent:he}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const ee of this._myRegistry.getAllExtensionDescriptions())if(ee.activationEvents)for(const he of ee.activationEvents)he==="onStartupFinished"&&this._activateOneStartupFinished(ee,he)}_handleEagerExtensions(){const ee=this._activateByEvent("*",!0).then(void 0,be=>{this._logService.error(be)});this._register(this._extHostWorkspace.onDidChangeWorkspace(be=>this._handleWorkspaceContainsEagerExtensions(be.added)));const he=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(he),me=Promise.all([ee,Y]).then(()=>{});return Promise.race([me,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),me}_handleWorkspaceContainsEagerExtensions(ee){return ee.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(he=>this._handleWorkspaceContainsEagerExtension(ee,he))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ee,he){if(this.isActivated(he.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,me={logService:this._logService,folders:ee.map(ke=>ke.uri),forceUsingSearch:Y,exists:ke=>this._hostUtils.exists(ke.fsPath),checkExists:(ke,Re,ze)=>this._mainThreadWorkspaceProxy.$checkExists(ke,Re,ze)},be=await(0,R.checkActivateWorkspaceContainsExtension)(me,he);if(!!be)return this._activateById(he.identifier,{startup:!0,extensionId:he.identifier,activationEvent:be.activationEvent}).then(void 0,ke=>this._logService.error(ke))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ee){throw console.error(ee),ee}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ee,extensionTestsLocationURI:he}=this._initData.environment;if(!ee||!he)throw new Error(l.localize(0,null));const Y=await this._loadCommonJSModule(null,he,new T.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(l.localize(1,null,he.toString()));return new Promise((me,be)=>{const ke=(oe,le)=>{oe?be(oe):me(typeof le=="number"&&le>0?1:0)},Re=(0,P.originalFSPath)(he),ze=Y.run(Re,ke);ze&&ze.then&&ze.then(()=>{me(0)}).catch(oe=>{be(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ee,he){return this._resolvers[ee]=he,(0,D.toDisposable)(()=>{delete this._resolvers[ee]})}async _activateAndGetResolver(ee){const he=ee.indexOf("+");if(he===-1)throw new Error("Not an authority that can be resolved!");const Y=ee.substr(0,he);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(ee,he){this._logService.info(`$resolveAuthority invoked for authority (${Q(ee)})`);const{authorityPrefix:Y,resolver:me}=await this._activateAndGetResolver(ee);if(!me)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(me)),I.mark(`code/extHost/willResolveAuthority/${Y}`);const be=await me.resolve(ee,{resolveAttempt:he});I.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const ke={authority:ee,host:be.host,port:be.port,connectionToken:be.connectionToken},Re={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ke,options:Re,tunnelInformation:{environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures}}}}catch(be){if(I.mark(`code/extHost/didResolveAuthorityError/${Y}`),be instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:be._code,message:be._message,detail:be._detail}};throw be}}async $getCanonicalURI(ee,he){this._logService.info(`$getCanonicalURI invoked for authority (${Q(ee)})`);const{resolver:Y}=await this._activateAndGetResolver(ee);if(!Y)return null;const me=k.URI.revive(he);if(typeof Y.getCanonicalURI>"u")return me;const be=await(0,y.asPromise)(()=>Y.getCanonicalURI(me));return be||me}static _applyExtensionsDelta(ee,he,Y){const me=new f.ExtensionDescriptionRegistry(ee.getAllExtensionDescriptions());me.deltaExtensions(Y.toAdd,Y.toRemove);const be=(0,b.extensionIdentifiersArrayToSet)(he.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of Y.myToRemove)be.delete(h.ExtensionIdentifier.toKey(Re));for(const Re of Y.myToAdd)be.add(h.ExtensionIdentifier.toKey(Re));const ke=H(me,be);return{globalRegistry:me,myExtensions:ke}}$startExtensionHost(ee){ee.toAdd.forEach(me=>me.extensionLocation=k.URI.revive(me.extensionLocation));const{globalRegistry:he,myExtensions:Y}=Nn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ee);return this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(Y),this._startExtensionHost()}$activateByEvent(ee,he){return he===1?this._activateByEvent(ee,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(ee,!1))}async $activate(ee,he){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ee)?(await this._activateById(ee,he),!0):!1}async $deltaExtensions(ee){ee.toAdd.forEach(ke=>ke.extensionLocation=k.URI.revive(ke.extensionLocation));const{globalRegistry:he,myExtensions:Y}=Nn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ee),me=await this._createExtensionPathIndex(Y);return(await this.getExtensionPathIndex()).setSearchTree(me),this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(Y),Promise.resolve(void 0)}async $test_latency(ee){return ee}async $test_up(ee){return ee.byteLength}async $test_down(ee){const he=c.VSBuffer.alloc(ee),Y=Math.random()%256;for(let me=0;me<ee;me++)he.writeUInt8(Y,me);return he}async $updateRemoteConnectionData(ee){this._remoteConnectionData=ee,this._onDidChangeRemoteConnectionData.fire()}};B=je([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,d.IExtHostRpcService),He(3,p.IExtHostWorkspace),He(4,E.IExtHostConfiguration),He(5,L.ILogService),He(6,n.IExtHostInitDataService),He(7,o.IExtensionStoragePaths),He(8,a.IExtHostTunnelService),He(9,m.IExtHostTerminalService),He(10,z.IExtHostLocalizationService)],B),e.AbstractExtHostExtensionService=B;function F(de,ee){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:ee.activationEvent,reasonId:ee.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class x{constructor(ee,he,Y,me,be){$.set(this,void 0),N.set(this,void 0),V.set(this,void 0),tt(this,$,ee,"f"),tt(this,N,he,"f"),tt(this,V,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=me,this.isFromDifferentExtensionHost=be}get isActive(){return Be(this,$,"f").isActivated(Be(this,V,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,$,"f").getExtensionExports(Be(this,V,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,$,"f").activateByIdWithErrors(Be(this,V,"f"),{startup:!1,extensionId:Be(this,N,"f"),activationEvent:"api"}),this.exports}}e.Extension=x,$=new WeakMap,N=new WeakMap,V=new WeakMap;function H(de,ee){return de.getAllExtensionDescriptions().filter(he=>ee.has(h.ExtensionIdentifier.toKey(he.identifier)))}function Q(de){const ee=de.indexOf("+");return ee===-1?de:de.substring(0,ee)}class K{constructor(ee){this._searchTree=ee}setSearchTree(ee){this._searchTree=ee}findSubstr(ee){return this._searchTree.findSubstr(ee)}forEach(ee){return this._searchTree.forEach(ee)}}e.ExtensionPaths=K}),define(Ce[284],De([1,0,73,2,5,34,28,27,16,25,3,41,36,12,8]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let p=class{constructor(g,i,u,r,n,o,d){this._apiFactory=g,this._extensionRegistry=i,this._instaService=u,this._extHostConfiguration=r,this._extHostExtensionService=n,this._initData=o,this._logService=d,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),l.mark("code/extHost/willWaitForConfig");const g=await this._extHostConfiguration.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const i=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,i,this._extensionRegistry,g,this._logService)),this.register(this._instaService.createInstance(v,i)),this.register(this._instaService.createInstance(b)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(h,i,this._initData.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const i of g.nodeModuleName)this._factories.set(i,g);else this._factories.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this._alternatives.push(i=>g.alternativeModuleName(i))}};p=je([He(2,L.IInstantiationService),He(3,P.IExtHostConfiguration),He(4,C.IExtHostExtensionService),He(5,k.IExtHostInitDataService),He(6,T.ILogService)],p),e.RequireInterceptor=p;let b=class Yn{constructor(g){if(g.environment.appRoot&&Yn.aliased.size){const i=(0,S.escapeRegExpCharacters)(this.forceForwardSlashes(g.environment.appRoot.fsPath)),u="[a-z0-9_.-]",r=`@${u}+\\/${u}+|${u}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${i}/${n}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(g){if(!this.re)return;const i=this.re.exec(this.forceForwardSlashes(g));if(!i)return;const[,u,r,n]=i,o=Yn.aliased.get(r);if(o!==void 0)return console.warn(`${r} as been renamed to ${o}, please update your imports`),u+o+n}forceForwardSlashes(g){return g.replace(/\\/g,"/")}};b.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),b=je([He(0,k.IExtHostInitDataService)],b);class f{constructor(g,i,u,r,n){this._apiFactory=g,this._extensionPaths=i,this._extensionRegistry=u,this._configProvider=r,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(g,i){const u=this._extensionPaths.findSubstr(i);if(u){let r=this._extApiImpl.get(D.ExtensionIdentifier.toKey(u.identifier));return r||(r=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(u.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((n,o)=>r+=`	${o} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(g,i,u){this._extensionPaths=g,this.nodeModuleName="keytar",this._mainThreadTelemetry=i.getProxy(I.MainContext.MainThreadTelemetry);const{environment:r}=u,n=i.getProxy(I.MainContext.MainThreadKeytar);if(r.appRoot){let o=r.appRoot.fsPath;E.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${o}/node_modules.asar/keytar`),this.alternativeNames.add(`${o}/node_modules/keytar`)}this._impl={getPassword:(o,d)=>n.$getPassword(o,d),setPassword:(o,d,s)=>n.$setPassword(o,d,s),deletePassword:(o,d)=>n.$deletePassword(o,d),findPassword:o=>n.$findPassword(o),findCredentials(o){return n.$findCredentials(o)}}}load(g,i){const u=this._extensionPaths.findSubstr(i);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(g){const i=g.length;if(i<=7||!this.alternativeNames)return;const u=i-7;if((g.charAt(u)==="/"||g.charAt(u)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.alternativeNames.has(g)))return"keytar"}};v=je([He(1,w.IExtHostRpcService),He(2,k.IExtHostInitDataService)],v);let h=class{constructor(g,i,u){this._extensionPaths=g,this._appUriScheme=i,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(I.MainContext.MainThreadTelemetry);const r=u.getProxy(I.MainContext.MainThreadWindow);this._impl=(n,o)=>{const d=t.URI.parse(n);return o?this.callOriginal(n,o):d.scheme==="http"||d.scheme==="https"?r.$openUri(d,n,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this._appUriScheme?r.$openUri(d,n,{}):this.callOriginal(n,o)}}load(g,i,u){const r=this._extensionPaths.findSubstr(i);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=u(g),this._impl}callOriginal(g,i){return this.sendNoForwardTelemetry(),this._original(g,i)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};h=je([He(2,w.IExtHostRpcService)],h)}),define(Ce[47],De([1,0,78,6,9,36,3,57,58,41,7,33,221,34]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,y.createDecorator)("IExtHostVariableResolverProvider");class S extends E.AbstractVariableResolverService{constructor(f,v,h,c,g,i,u){function r(){if(h){const n=h.activeEditor();if(n)return n.document.uri;const o=c.tabGroups.all.find(d=>d.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof L.TextDiffTabInput||o.input instanceof L.NotebookDiffEditorTabInput)return o.input.modified;if(o.input instanceof L.TextTabInput||o.input instanceof L.NotebookEditorTabInput||o.input instanceof L.CustomEditorTabInput)return o.input.uri}}}super({getFolderUri:n=>{const o=i.folders.filter(d=>d.name===n);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(n,o)=>g.getConfiguration(void 0,n).get(o),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const n=r();if(n)return I.normalize(n.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const n=r();if(n){const o=v.getWorkspaceFolder(n);if(o)return I.normalize(o.uri.fsPath)}}},getSelectedText:()=>{if(h){const n=h.activeEditor();if(n&&!n.selection.isEmpty)return n.document.getText(n.selection)}},getLineNumber:()=>{if(h){const n=h.activeEditor();if(n)return String(n.selection.end.line+1)}},getExtension:n=>f.getExtension(n)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(P.env))}}let p=class extends t.Disposable{constructor(f,v,h,c,g){super(),this.extensionService=f,this.workspaceService=v,this.editorService=h,this.configurationService=c,this.editorTabs=g,this._resolver=new l.Lazy(async()=>{const i=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async n=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new S(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,i,r,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};p=je([He(0,k.IExtHostExtensionService),He(1,C.IExtHostWorkspace),He(2,D.IExtHostDocumentsAndEditors),He(3,T.IExtHostConfiguration),He(4,w.IExtHostEditorTabs)],p),e.ExtHostVariableResolverProviderService=p}),define(Ce[74],De([1,0,18,4,13,2,3,5,58,41,16,7,33,128,214,34,47]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(r,n,o,d,s,a){this._workspaceService=n,this._extensionService=o,this._configurationService=d,this._editorTabs=s,this._variableResolver=a,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new t.Emitter,this._onDidTerminateDebugSession=new t.Emitter,this._onDidChangeActiveDebugSession=new t.Emitter,this._onDidReceiveDebugSessionCustomEvent=new t.Emitter,this._debugServiceProxy=r.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new t.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new h(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(m=>{m.onDidChange(_=>{this.registerAllDebugTypes(m)}),this.registerAllDebugTypes(m)})}asDebugSourceUri(r,n){const o=r;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let d=`debug:${encodeURIComponent(o.path||"")}`,s="?";return n&&(d+=`${s}session=${encodeURIComponent(n.id)}`,s="&"),d+=`${s}ref=${o.sourceReference}`,P.URI.parse(d)}else{if(o.path)return P.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const n=[];for(const o of r.getAllExtensionDescriptions())if(o.contributes){const d=o.contributes.debuggers;if(d&&d.length>0)for(const s of d)(0,S.isDebuggerMainContribution)(s)&&n.push(s.type)}this._debugServiceProxy.$registerDebugTypes(n)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(n=>r.push(n)),r}addBreakpoints(r){this.startBreakpoints();const n=r.filter(s=>{const a=s.id;return this._breakpoints.has(a)?!1:(this._breakpoints.set(a,s),!0)});this.fireBreakpointChanges(n,[],[]);const o=[],d=new Map;for(const s of n)if(s instanceof C.SourceBreakpoint){let a=d.get(s.location.uri.toString());a||(a={type:"sourceMulti",uri:s.location.uri,lines:[]},d.set(s.location.uri.toString(),a),o.push(a)),a.lines.push({id:s.id,enabled:s.enabled,condition:s.condition,hitCondition:s.hitCondition,logMessage:s.logMessage,line:s.location.range.start.line,character:s.location.range.start.character})}else s instanceof C.FunctionBreakpoint&&o.push({type:"function",id:s.id,enabled:s.enabled,hitCondition:s.hitCondition,logMessage:s.logMessage,condition:s.condition,functionName:s.functionName});return this._debugServiceProxy.$registerBreakpoints(o)}removeBreakpoints(r){this.startBreakpoints();const n=r.filter(a=>this._breakpoints.delete(a.id));this.fireBreakpointChanges([],n,[]);const o=n.filter(a=>a instanceof C.SourceBreakpoint).map(a=>a.id),d=n.filter(a=>a instanceof C.FunctionBreakpoint).map(a=>a.id),s=n.filter(a=>a instanceof C.DataBreakpoint).map(a=>a.id);return this._debugServiceProxy.$unregisterBreakpoints(o,d,s)}startDebugging(r,n,o){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,n,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,n,o){if(!n)return new C.Disposable(()=>{});const d=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:d,provider:n}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,o,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,d),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(s=>s.provider!==n),this._debugServiceProxy.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(r,n,o){if(!o)return new C.Disposable(()=>{});if(!this.definesDebugType(r,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.getAdapterDescriptorFactoryByType(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:n,handle:d,factory:o}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(n,d),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(s=>s.factory!==o),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(r,n){if(!n)return new C.Disposable(()=>{});const o=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:o,factory:n}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(d=>d.factory!==n)})}async $runInTerminal(r,n){return Promise.resolve(void 0)}async $substituteVariables(r,n){let o;const d=await this.getFolder(r);return d&&(o={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(o,n)}createDebugAdapter(r,n){if(r.type==="implementation")return new g(r.implementation)}createSignService(){}async $startDASession(r,n){const o=this,d=await this.getSession(n);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(d.type),d).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const a=this.convertToDto(s),m=this.createDebugAdapter(a,d);if(!m)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const _=m;return this._debugAdapters.set(r,_),this.getDebugAdapterTrackers(d).then(R=>(R&&this._debugAdaptersTrackers.set(r,R),_.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const U=M,A={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const z=await this._signService.sign(U.arguments.value);A.body={signature:z},_.sendResponse(A)}else throw new Error("no signer")}catch(z){A.success=!1,A.message=z.message,_.sendResponse(A)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(M),M=(0,S.convertToVSCPaths)(M,!0),o._debugServiceProxy.$acceptDAMessage(r,M)}),_.onError(M=>{R&&R.onError&&R.onError(M),this._debugServiceProxy.$acceptDAError(r,M.name,M.message,M.stack)}),_.onExit(M=>{R&&R.onExit&&R.onExit((0,I.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,I.withNullAsUndefined)(M),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),_.startSession()))})}$sendDAMessage(r,n){n=(0,S.convertToDAPaths)(n,!1);const o=this._debugAdaptersTrackers.get(r);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(n),this._debugAdapters.get(r)?.sendMessage(n)}$stopDASession(r){const n=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),n&&n.onWillStopSession&&n.onWillStopSession();const o=this._debugAdapters.get(r);return this._debugAdapters.delete(r),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const n=[],o=[],d=[];if(r.added)for(const s of r.added){const a=s.id;if(a&&!this._breakpoints.has(a)){let m;if(s.type==="function")m=new C.FunctionBreakpoint(s.functionName,s.enabled,s.condition,s.hitCondition,s.logMessage);else if(s.type==="data")m=new C.DataBreakpoint(s.label,s.dataId,s.canPersist,s.enabled,s.hitCondition,s.condition,s.logMessage);else{const _=P.URI.revive(s.uri);m=new C.SourceBreakpoint(new C.Location(_,new C.Position(s.line,s.character)),s.enabled,s.condition,s.hitCondition,s.logMessage)}m._id=a,this._breakpoints.set(a,m),n.push(m)}}if(r.removed)for(const s of r.removed){const a=this._breakpoints.get(s);a&&(this._breakpoints.delete(s),o.push(a))}if(r.changed){for(const s of r.changed)if(s.id){const a=this._breakpoints.get(s.id);if(a){if(a instanceof C.FunctionBreakpoint&&s.type==="function"){const m=a;m.enabled=s.enabled,m.condition=s.condition,m.hitCondition=s.hitCondition,m.logMessage=s.logMessage,m.functionName=s.functionName}else if(a instanceof C.SourceBreakpoint&&s.type==="source"){const m=a;m.enabled=s.enabled,m.condition=s.condition,m.hitCondition=s.hitCondition,m.logMessage=s.logMessage,m.location=new C.Location(P.URI.revive(s.uri),new C.Position(s.line,s.character))}d.push(a)}}}this.fireBreakpointChanges(n,o,d)}$provideDebugConfigurations(r,n,o){return(0,l.asPromise)(async()=>{const d=this.getConfigProviderByHandle(r);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const s=await this.getFolder(n);return d.provideDebugConfigurations(s,o)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(r,n,o,d){return(0,l.asPromise)(async()=>{const s=this.getConfigProviderByHandle(r);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const a=await this.getFolder(n);return s.resolveDebugConfiguration(a,o,d)})}$resolveDebugConfigurationWithSubstitutedVariables(r,n,o,d){return(0,l.asPromise)(async()=>{const s=this.getConfigProviderByHandle(r);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const a=await this.getFolder(n);return s.resolveDebugConfigurationWithSubstitutedVariables(a,o,d)})}async $provideDebugAdapter(r,n){const o=this.getAdapterDescriptorFactoryByHandle(r);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.getSession(n);return this.getAdapterDescriptor(o,d).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.convertToDto(s)})}async $acceptDebugSessionStarted(r){const n=await this.getSession(r);this._onDidStartDebugSession.fire(n)}async $acceptDebugSessionTerminated(r){const n=await this.getSession(r);n&&(this._onDidTerminateDebugSession.fire(n),this._debugSessions.delete(n.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,n){(await this.getSession(r))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(r,n){const d={session:await this.getSession(r),event:n.event,body:n.body};this._onDidReceiveDebugSessionCustomEvent.fire(d)}convertToDto(r){if(r instanceof C.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof C.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const n=this._adapterFactories.filter(o=>o.type===r);if(n.length>0)return n[0].factory}getAdapterDescriptorFactoryByHandle(r){const n=this._adapterFactories.filter(o=>o.handle===r);if(n.length>0)return n[0].factory}getConfigProviderByHandle(r){const n=this._configProviders.filter(o=>o.handle===r);if(n.length>0)return n[0].provider}definesDebugType(r,n){if(r.contributes){const o=r.contributes.debuggers;if(o&&o.length>0){for(const d of o)if(d.label&&d.type&&d.type===n)return!0}}return!1}getDebugAdapterTrackers(r){const o=r.configuration.type,d=this._trackerFactories.filter(s=>s.type===o||s.type==="*").map(s=>(0,l.asPromise)(()=>s.factory.createDebugAdapterTracker(r)).then(a=>a,a=>null));return Promise.race([Promise.all(d).then(s=>{const a=s.filter(m=>!!m);if(a.length>0)return new c(a)}),new Promise((s,a)=>{const m=setTimeout(()=>{clearTimeout(m),a(new Error("timeout"))},1e3)})]).catch(s=>{})}async getAdapterDescriptor(r,n){const o=n.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new C.DebugAdapterServer(o));if(r){const s=await this._extensionService.getExtensionRegistry();return(0,l.asPromise)(()=>r.createDebugAdapterDescriptor(n,this.daExecutableFromPackage(n,s))).then(a=>{if(a)return a})}const d=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(n,d))}daExecutableFromPackage(r,n){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,n,o){(r.length>0||n.length>0||o.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:n,changed:o}))}async getSession(r){if(r)if(typeof r=="string"){const n=this._debugSessions.get(r);if(n)return n}else{let n=this._debugSessions.get(r.id);if(!n){const o=await this.getFolder(r.folderUri),d=r.parent?this._debugSessions.get(r.parent):void 0;n=new v(this._debugServiceProxy,r.id,r.type,r.name,o,r.configuration,d),this._debugSessions.set(n.id,n),this._debugServiceProxy.$sessionCached(n.id)}return n}throw new Error("cannot find session")}getFolder(r){if(r){const n=P.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};f=je([He(0,L.IExtHostRpcService),He(1,E.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,p.IExtHostConfiguration),He(4,w.IExtHostEditorTabs),He(5,b.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class v{constructor(r,n,o,d,s,a,m){this._debugServiceProxy=r,this._id=n,this._type=o,this._name=d,this._workspaceFolder=s,this._configuration=a,this._parentSession=m}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,n){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,n)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=v;class h{constructor(r){this.value=Object.freeze({append(n){r.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.ExtHostDebugConsole=h;class c{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(n=>n.onError?n.onError(r):void 0)}onExit(r,n){this.trackers.forEach(o=>o.onExit?o.onExit(r,n):void 0)}}class g extends T.AbstractDebugAdapter{constructor(r){super(),this.implementation=r,r.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=class extends f{constructor(r,n,o,d,s,a){super(r,n,o,d,s,a)}};i=je([He(0,L.IExtHostRpcService),He(1,E.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,p.IExtHostConfiguration),He(4,w.IExtHostEditorTabs),He(5,b.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(Ce[285],De([1,0,11,73,2,5,277,12,83,84,25,193,16,54,41]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class p{constructor(f,v,h,c,g){this._hostUtils=h,this._rpcProtocol=new y.RPCProtocol(f,null,c),v=p._transform(v,this._rpcProtocol);const i=new k.ServiceCollection(...(0,w.getSingletonServiceDescriptors)());i.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...v,messagePorts:g}),i.set(E.IExtHostRpcService,new E.ExtHostRpcService(this._rpcProtocol)),i.set(T.IURITransformerService,new T.URITransformerService(c)),i.set(S.IHostUtils,h);const u=new C.InstantiationService(i,!0);this._logService=u.invokeFunction(d=>d.get(D.ILogService)),t.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=u.invokeFunction(d=>d.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const r=new WeakMap;this._extensionService.getExtensionPathIndex().then(d=>{Error.prepareStackTrace=(s,a)=>{let m="",_,R;for(const M of a)m+=`
	at ${M.toString()}`,R=M.getFileName(),!_&&R&&(_=d.findSubstr(I.URI.file(R)));return r.set(s,_),`${s.name||"Error"}: ${s.message||""}${m}`}});const n=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),o=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);l.setUnexpectedErrorHandler(d=>{const s=l.transformErrorForSerialization(d),a=r.get(d);a?n.$onExtensionRuntimeError(a.identifier,s):o.$onUnexpectedError(s)})}async asBrowserUri(f){const v=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return I.URI.revive(await v.$asBrowserUri(f))}terminate(f){this._extensionService.terminate(f)}static _transform(f,v){f.allExtensions.forEach(c=>{c.extensionLocation=I.URI.revive(v.transformIncomingURIs(c.extensionLocation));const g={};c.browserNlsBundleUris&&(Object.keys(c.browserNlsBundleUris).forEach(i=>g[i]=I.URI.revive(v.transformIncomingURIs(c.browserNlsBundleUris[i]))),c.browserNlsBundleUris=g)}),f.environment.appRoot=I.URI.revive(v.transformIncomingURIs(f.environment.appRoot));const h=f.environment.extensionDevelopmentLocationURI;return h&&(f.environment.extensionDevelopmentLocationURI=h.map(c=>I.URI.revive(v.transformIncomingURIs(c)))),f.environment.extensionTestsLocationURI=I.URI.revive(v.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=I.URI.revive(v.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=I.URI.revive(v.transformIncomingURIs(f.environment.workspaceStorageHome)),f.nlsBaseUrl=I.URI.revive(v.transformIncomingURIs(f.nlsBaseUrl)),f.logsLocation=I.URI.revive(v.transformIncomingURIs(f.logsLocation)),f.logFile=I.URI.revive(v.transformIncomingURIs(f.logFile)),f.workspace=v.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=p}),define(Ce[286],De([1,0,18,10,177,192,200,74,58,41,16,40,7,47,33,215,217,34]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let v=class extends D.ExtHostDebugServiceBase{constructor(u,r,n,o,d,s,a){super(u,r,n,o,s,a),this._terminalService=d,this._integratedTerminalInstances=new g}createDebugAdapter(u,r){switch(u.type){case"server":return new p.SocketDebugAdapter(u);case"pipeServer":return new p.NamedPipeDebugAdapter(u);case"executable":return new p.ExecutableDebugAdapter(u,r.type)}return super.createDebugAdapter(u,r)}daExecutableFromPackage(u,r){const n=p.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),u.type);if(n)return new E.DebugAdapterExecutable(n.command,n.args,n.options)}createSignService(){return new y.SignService}async $runInTerminal(u,r){if(u.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(z=>{this._integratedTerminalInstances.onTerminalClosed(z)}));const n=await this._configurationService.getConfigProvider(),o=this._terminalService.getDefaultShell(!0),d=this._terminalService.getDefaultShellArgs(!0),s=u.title||I.localize(0,null),a=JSON.stringify({shell:o,shellArgs:d});let m=await this._integratedTerminalInstances.checkout(a,s),_,R=!1;if(m)_=u.cwd;else{const z={shellPath:o,shellArgs:d,cwd:u.cwd,name:s,iconPath:new E.ThemeIcon("debug")};R=!0,m=this._terminalService.createTerminalFromOptions(z,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(m,a)}m.show(!0);const M=await m.processId;R?await new Promise(z=>setTimeout(z,1e3)):n.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(o.indexOf("powershell")>=0||o.indexOf("pwsh")>=0||o.indexOf("cmd.exe")>=0?m.sendText("cls"):o.indexOf("bash")>=0?m.sendText("clear"):t.isWindows?m.sendText("cls"):m.sendText("clear"));const U=(0,b.prepareCommand)(o,u.args,!!u.argsCanBeInterpretedByShell,_,u.env);m.sendText(U);const A=this.onDidTerminateDebugSession(z=>{z.id===r&&(this._integratedTerminalInstances.free(m),A.dispose())});return M}else if(u.kind==="external")return c(u,await this._configurationService.getConfigProvider());return super.$runInTerminal(u,r)}};v=je([He(0,L.IExtHostRpcService),He(1,S.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,f.IExtHostConfiguration),He(4,C.IExtHostTerminalService),He(5,w.IExtHostEditorTabs),He(6,T.IExtHostVariableResolverProvider)],v),e.ExtHostDebugService=v;let h;function c(i,u){if(!h)if(t.isWindows)h=new P.WindowsExternalTerminalService;else if(t.isMacintosh)h=new P.MacExternalTerminalService;else if(t.isLinux)h=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=u.getConfiguration("terminal");return h.runInTerminal(i.title,i.cwd,i.args,i.env||{},r.external||{})}e.runInExternalTerminal=c;class g{constructor(){this._terminalInstances=new Map}async checkout(u,r){const o=[...this._terminalInstances.entries()].map(([d,s])=>(0,l.createCancelablePromise)(async a=>{if(d.name!==r||s.lastUsedAt!==-1&&await(0,b.hasChildProcesses)(await d.processId))return null;const m=Date.now();return s.lastUsedAt+g.minUseDelay>m||a.isCancellationRequested||s.config!==u?null:(s.lastUsedAt=m,d)}));return await(0,l.firstParallel)(o,d=>!!d)}insert(u,r){this._terminalInstances.set(u,{lastUsedAt:Date.now(),config:r})}free(u){const r=this._terminalInstances.get(u);r&&(r.lastUsedAt=-1)}onTerminalClosed(u){this._terminalInstances.delete(u)}}g.minUseDelay=1e3}),define(Ce[287],De([1,0,9,2,112,33,57,34,45,40,16,25,72,14,12,67,22,82,47]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let h=class extends E.ExtHostTaskBase{constructor(g,i,u,r,n,o,d,s,a){super(g,i,u,r,n,o,d,s),this.workspaceService=u,this.variableResolver=a,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(g,i){const u=i;if(!i.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const r=E.TaskHandleDTO.from(u,this.workspaceService),n=await this._proxy.$getTaskExecution(r);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const o=await this.getTaskExecution(n,i);return this._proxy.$executeTask(r).catch(()=>{}),o}else{const r=E.TaskDTO.from(i,g);if(r===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(r.execution)&&await this.addCustomExecution(r,i,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(r),i);return this._proxy.$executeTask(r).catch(()=>{}),n}}provideTasksInternal(g,i,u,r){const n=[];if(r)for(const o of r){this.checkDeprecation(o,u),(!o.definition||!g[o.definition.type])&&this._logService.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const d=E.TaskDTO.from(o,u.extension);d&&(n.push(d),E.CustomExecutionDTO.is(d.execution)&&i.push(this.addCustomExecution(d,o,!0)))}return{tasks:n,extension:u.extension}}async resolveTaskInternal(g){return g}async getAFolder(g){let i=g&&g.length>0?g[0]:void 0;if(!i){const u=t.URI.file((0,f.homedir)());i=new w.WorkspaceFolder({uri:u,name:b.basename(u),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(g,i){const u=t.URI.revive(g),r={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(u),o=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.variableResolver.getResolver(),s=n?{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(o);for(const a of i.variables)r.variables[a]=await d.resolveAsync(s,a);if(i.process!==void 0){let a;if(i.process.path!==void 0){a=i.process.path.split(l.delimiter);for(let m=0;m<a.length;m++)a[m]=await d.resolveAsync(s,a[m])}r.process=await I.win32.findExecutable(await d.resolveAsync(s,i.process.name),i.process.cwd!==void 0?await d.resolveAsync(s,i.process.cwd):void 0,a)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(g,i,u){return I.win32.findExecutable(g,i,u)}};h=je([He(0,L.IExtHostRpcService),He(1,C.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,y.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,k.IExtHostTerminalService),He(6,S.ILogService),He(7,p.IExtHostApiDeprecationService),He(8,v.IExtHostVariableResolverProvider)],h),e.ExtHostTask=h}),define(Ce[288],De([1,0,82,47]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class I extends t.ExtHostVariableResolverProviderService{homeDir(){return(0,l.homedir)()}}e.NodeExtHostVariableResolverProviderService=I}),define(Ce[140],De([1,0,17,18,21,50,14,9,22,2,30]),function(J,e,l,t,I,P,y,D,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class C{constructor(v,h,c,g){this.query=v,this.provider=h,this.fileUtils=c,this.processType=g,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,h){const c=this.query.folderQueries||[],g=new I.CancellationTokenSource;return h.onCancellationRequested(()=>g.cancel()),new Promise((i,u)=>{this.collector=new T(v);let r=!1;const n=(o,d)=>{if(!r&&!this.isLimitHit){const s=this.resultSize(o);p(o)&&typeof this.query.maxResults=="number"&&this.resultCount+s>this.query.maxResults&&(this.isLimitHit=!0,r=!0,g.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const a=this.resultSize(o);this.resultCount+=a,(a>0||!p(o))&&this.collector.add(o,d)}};Promise.all(c.map((o,d)=>this.searchInFolder(o,s=>n(s,d),g.token))).then(o=>{g.dispose(),this.collector.flush();const d=o.some(s=>!!s&&!!s.limitHit);i({limitHit:this.isLimitHit||d,messages:(0,l.flatten)(o.map(s=>s?.message?Array.isArray(s.message)?s.message:[s.message]:[])),stats:{type:this.processType}})},o=>{g.dispose();const d=(0,P.toErrorMessage)(o);u(new Error(d))})})}resultSize(v){return p(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,h){const c=Array.isArray(v.ranges)?v.ranges:[v.ranges],g=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:c.slice(0,h),preview:{matches:g.slice(0,h),text:v.preview.text},uri:v.uri}}async searchInFolder(v,h,c){const g=new L.QueryGlobTester(this.query,v),i=[],u={report:o=>{if(!this.validateProviderResult(o))return;const d=v.folder.scheme===y.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(w.dirname(o.uri))):void 0,s=w.relativePath(v.folder,o.uri);if(s){const a=g.includedInQuery(s,D.basename(s),d);(0,t.isThenable)(a)?i.push(a.then(m=>{m&&h(o)})):a&&h(o)}}},r=this.getSearchOptionsForFolder(v),n=await this.provider.provideTextSearchResults(E(this.query.contentPattern),r,u,c);return i.length&&await Promise.all(i),n}validateProviderResult(v){if(p(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const h=(0,L.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),c=(0,L.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),g={folder:k.URI.from(v.folder),excludes:c,includes:h,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return g.usePCRE2=this.query.usePCRE2,g}}e.TextSearchManager=C;function E(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class T{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,h=>this.sendItems(h))}add(v,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!w.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(S(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=T;function S(f){return p(f)?{preview:{matches:(0,l.mapArrayOrNot)(f.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:f.preview.text},ranges:(0,l.mapArrayOrNot)(f.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function p(f){return!!f.preview}e.extensionResultIsMatch=p;class b{constructor(v,h){this.maxBatchSize=v,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,h){!v||this.addItemToBatch(v,h)}addItems(v,h){!v||this.addItemsToBatch(v,h)}addItemToBatch(v,h){this.batch.push(v),this.batchSize+=h,this.onUpdate()}addItemsToBatch(v,h){this.batch=this.batch.concat(v),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(Ce[75],De([1,0,6,5,3,281,16,54,12,2,140]),function(J,e,l,t,I,P,y,D,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let C=class{constructor(p,b,f){this.extHostRpc=p,this._uriTransformer=b,this._logService=f,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}registerTextSearchProvider(p,b){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const f=this._handlePool++;return this._textSearchProvider.set(f,b),this._proxy.$registerTextSearchProvider(f,this._transformScheme(p)),(0,l.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}registerFileSearchProvider(p,b){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const f=this._handlePool++;return this._fileSearchProvider.set(f,b),this._proxy.$registerFileSearchProvider(f,this._transformScheme(p)),(0,l.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(p,b,f,v){const h=E(f),c=this._fileSearchProvider.get(p);if(c)return this._fileSearchManager.fileSearch(h,c,g=>{this._proxy.$handleFileMatch(p,b,g.map(i=>i.resource))},v);throw new Error("unknown provider: "+p)}$clearCache(p){return this._fileSearchManager.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,b,f,v){const h=this._textSearchProvider.get(p);if(!h||!h.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const c=E(f);return this.createTextSearchManager(c,h).search(i=>this._proxy.$handleTextMatch(p,b,i),v)}$enableExtensionHostSearch(){}createTextSearchManager(p,b){return new L.TextSearchManager(p,b,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};C=je([He(0,y.IExtHostRpcService),He(1,D.IURITransformerService),He(2,w.ILogService)],C),e.ExtHostSearch=C;function E(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(T),extraFileResources:S.extraFileResources&&S.extraFileResources.map(p=>k.URI.revive(p))}}e.reviveQuery=E;function T(S){return{...S,folder:k.URI.revive(S.folder)}}}),define(Ce[289],De([1,0,83,139,33,136,34,39,57,40,72,74,75,94,53,67,138,68,46,93,131,58,137,12,227,47,92]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f,v,h,c,g,i,u,r,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,1),(0,l.registerSingleton)(u.ILoggerService,i.ExtHostLoggerService,1),(0,l.registerSingleton)(u.ILogService,r.ExtHostLogService,1),(0,l.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService,!1),(0,l.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands,!1),(0,l.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration,!1),(0,l.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem,!1),(0,l.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService,!1),(0,l.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations,!1),(0,l.registerSingleton)(w.IExtHostDocumentsAndEditors,w.ExtHostDocumentsAndEditors,!1),(0,l.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,!1),(0,l.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,l.registerSingleton)(E.IExtHostSearch,E.ExtHostSearch,!1),(0,l.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,!1),(0,l.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,!1),(0,l.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,!1),(0,l.registerSingleton)(S.IExtHostTunnelService,S.ExtHostTunnelService,!1),(0,l.registerSingleton)(b.IExtHostWindow,b.ExtHostWindow,!1),(0,l.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace,!1),(0,l.registerSingleton)(h.IExtHostSecretState,h.ExtHostSecretState,!1),(0,l.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry,!1),(0,l.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs,!1),(0,l.registerSingleton)(n.IExtHostVariableResolverProvider,n.ExtHostVariableResolverProviderService,!1)}),define(Ce[95],De([1,0,17,12,30,71]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=y;function D(C,E,T,S){const p=(0,l.mapArrayOrNot)(T,w),b=new I.TextSearchMatch(E,p,S),f=b.preview.matches;return{ranges:(0,l.mapArrayOrNot)(p,k),uri:C,preview:{text:b.preview.text,matches:(0,l.mapArrayOrNot)(f,k)}}}e.createTextSearchResult=D;function w(C){return new I.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function k(C){return new P.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let L=class{constructor(E,T){this.prefix=E,this.logService=T}appendLine(E){this.logService.debug(`${this.prefix}#search`,E)}};L=je([He(1,t.ILogService)],L),e.OutputChannel=L}),define(Ce[290],De([1,0,44,9,80,32,10,8,95,291]),function(J,e,l,t,I,P,y,D,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(h,c,g,i){const u=E(h,c,g,i),r=c.folder.fsPath;return{cmd:l.spawn(L,u.args,{cwd:r}),rgDiskPath:L,siblingClauses:u.siblingClauses,rgArgs:u,cwd:r}}e.spawnRipgrepCmd=C;function E(h,c,g,i){const u=["--files","--hidden","--case-sensitive"];S([c],g,!1).forEach(n=>{const o=(0,w.anchorGlob)(n);if(u.push("-g",o),y.isMacintosh){const d=(0,I.normalizeNFD)(o);d!==o&&u.push("-g",d)}});const r=T([c],i,void 0,!1);return r.globArgs.forEach(n=>{const o=`!${(0,w.anchorGlob)(n)}`;if(u.push("-g",o),y.isMacintosh){const d=(0,I.normalizeNFD)(o);d!==o&&u.push("-g",d)}}),c.disregardIgnoreFiles!==!1?u.push("--no-ignore"):c.disregardParentIgnoreFiles!==!1&&u.push("--no-ignore-parent"),c.ignoreSymlinks||u.push("--follow"),h.exists&&u.push("--quiet"),u.push("--no-config"),c.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:r.siblingClauses}}function T(h,c,g,i=!0){const u=[];let r={};return h.forEach(n=>{const o=Object.assign({},n.excludePattern||{},c||{}),d=p(o,i?n.folder.fsPath:void 0,g);u.push(...d.globArgs),d.siblingClauses&&(r=Object.assign(r,d.siblingClauses))}),{globArgs:u,siblingClauses:r}}e.foldersToRgExcludeGlobs=T;function S(h,c,g=!0){const i=[];return h.forEach(u=>{const r=Object.assign({},c||{},u.includePattern||{}),n=p(r,g?u.folder.fsPath:void 0);i.push(...n.globArgs)}),i}e.foldersToIncludeGlobs=S;function p(h,c,g){const i=[],u={};return Object.keys(h).forEach(r=>{if(g&&g.has(r)||!r)return;const n=h[r];r=f(c?b(c,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof n=="boolean"&&n?(r.startsWith("\\\\")&&(r+="**"),i.push(v(r))):n&&n.when&&(u[r]=n)}),{globArgs:i,siblingClauses:u}}function b(h,c){return t.isAbsolute(c)?c:t.join(h,c)}e.getAbsoluteGlob=b;function f(h){return h=D.rtrim(h,"\\"),D.rtrim(h,"/")}function v(h){return P.getRoot(h).toLowerCase()==="c:/"?h.replace(/^c:[/\\]/i,"/"):h}e.fixDriveC=v}),define(Ce[292],De([1,0,44,63,9,293,17,50,37,80,32,10,51,8,13,29,30,290,107]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const h=new Set;process.on("exit",()=>{h.forEach(r=>r())});class c{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&w.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,v.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&w.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(o=>{const d=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),s=o.folder.fsPath;n.folderQueries.map(a=>a.folder.fsPath).filter(a=>a!==s).forEach(a=>{(0,L.isEqualOrParent)(a,s)&&(d[I.relative(s,a)]=!0)}),this.folderExcludePatterns.set(s,new i(d,s))})}cancel(){this.isCanceled=!0,h.forEach(n=>n())}walk(n,o,d,s,a){if(this.fileWalkSW=E.StopWatch.create(!1),this.isCanceled)return a(null,this.isLimitHit);o.forEach(m=>{const _=I.basename(m.fsPath);this.globalExcludePattern&&this.globalExcludePattern(m.fsPath,_)||this.matchFile(d,{relativePath:m.fsPath,searchPath:void 0})}),this.cmdSW=E.StopWatch.create(!1),this.parallel(n,(m,_)=>{this.call(this.cmdTraversal,this,m,d,s,R=>{if(R){const M=(0,D.toErrorMessage)(R);console.error(M),this.errors.push(M),_(R,void 0)}else _(null,void 0)})},(m,_)=>{this.fileWalkSW.stop();const R=m?y.coalesce(m)[0]:null;a(R,this.isLimitHit)})}parallel(n,o,d){const s=new Array(n.length),a=new Array(n.length);let m=!1,_=0;if(n.length===0)return d(null,[]);n.forEach((R,M)=>{o(R,(U,A)=>{if(U?(m=!0,s[M]=null,a[M]=U):(s[M]=A,a[M]=null),++_===n.length)return d(m?a:null,s)})})}call(n,o,...d){try{n.apply(o,d)}catch(s){d[d.length-1](s)}}cmdTraversal(n,o,d,s){const a=n.folder.fsPath,m=C.isMacintosh,_=()=>z&&z.kill();h.add(_);let R=B=>{h.delete(_),R=()=>{},s(B)},M="";const U=this.initDirectoryTree(),A=(0,f.spawnRipgrepCmd)(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression),z=A.cmd,$=!Object.keys(A.siblingClauses).length,N=A.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let V=`${A.rgDiskPath} ${N}
 - cwd: ${A.cwd}`;A.rgArgs.siblingClauses&&(V+=`
 - Sibling clauses: ${JSON.stringify(A.rgArgs.siblingClauses)}`),d({message:V}),this.cmdResultCount=0,this.collectStdout(z,"utf8",d,(B,F,x)=>{if(B){R(B);return}if(this.isLimitHit){R();return}const Q=(M+(m?k.normalizeNFC(F||""):F)).split(`
`);if(x){const K=Q.length;Q[K-1]=Q[K-1].trim(),Q[K-1]||Q.pop()}else M=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=Q.length,$){for(const K of Q)if(this.matchFile(o,{base:a,relativePath:K,searchPath:this.getSearchPath(n,K)}),this.isLimitHit){_();break}(x||this.isLimitHit)&&R();return}this.addDirectoryEntries(n,U,a,Q,o),x&&(this.matchDirectoryTree(U,a,o),R())})}spawnFindCmd(n){const o=this.folderExcludePatterns.get(n.folder.fsPath),d=o.getBasenameTerms(),s=o.getPathTerms(),a=["-L","."];if(d.length||s.length){a.push("-not","(","(");for(const m of d)a.push("-name",m),a.push("-o");for(const m of s)a.push("-path",m),a.push("-o");a.pop(),a.push(")","-prune",")")}return a.push("-type","f"),l.spawn("find",a,{cwd:n.folder.fsPath})}readStdout(n,o,d){let s="";this.collectStdout(n,o,()=>{},(a,m,_)=>{if(a){d(a);return}s+=m,_&&d(null,s)})}collectStdout(n,o,d,s){let a=(R,M,U)=>{(R||U)&&(a=()=>{},this.cmdSW?.stop()),s(R,M,U)},m=!1;n.stdout?(this.forwardData(n.stdout,o,a),n.stdout.once("data",()=>m=!0)):d({message:"stdout is null"});let _;n.stderr?_=this.collectData(n.stderr):d({message:"stderr is null"}),n.on("error",R=>{a(R)}),n.on("close",R=>{let M;!m&&(M=this.decodeData(_,o))&&u(M)?a(new Error(`command failed with error code ${R}: ${this.decodeData(_,o)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),a(null,"",!0))})}forwardData(n,o,d){const s=new P.StringDecoder(o);return n.on("data",a=>{d(null,s.write(a))}),s}collectData(n){const o=[];return n.on("data",d=>{o.push(d)}),o}decodeData(n,o){const d=new P.StringDecoder(o);return n.map(s=>d.write(s)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:o},d,s,a){s.indexOf(this.filePattern)!==-1&&this.matchFile(a,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const m=_=>{const R=I.basename(_),M=I.dirname(_);let U=o[M];U||(U=o[M]=[],m(M)),U.push({base:d,relativePath:_,basename:R,searchPath:this.getSearchPath(n,_)})};s.forEach(m)}matchDirectoryTree({rootEntries:n,pathToEntries:o},d,s){const a=this,m=this.folderExcludePatterns.get(d),_=this.filePattern;function R(M){a.directoriesWalked++;const U=(0,b.hasSiblingFn)(()=>M.map(A=>A.basename));for(let A=0,z=M.length;A<z;A++){const $=M[A],{relativePath:N,basename:V}=$;if(m.test(N,V,_!==V?U:void 0))continue;const B=o[N];if(B)R(B);else{if(a.filesWalked++,N===_)continue;a.matchFile(s,$)}if(a.isLimitHit)break}}R(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,o,d,s,a){const m=n.folder,_=(0,b.hasSiblingFn)(()=>d);this.parallel(d,(R,M)=>{if(this.isCanceled||this.isLimitHit)return M(null);const U=o?[o,R].join(I.sep):R;if(this.folderExcludePatterns.get(n.folder.fsPath).test(U,R,this.config.filePattern!==R?_:void 0))return M(null);const A=[m.fsPath,U].join(I.sep);t.lstat(A,(z,$)=>{if(z||this.isCanceled||this.isLimitHit)return M(null);this.statLinkIfNeeded(A,$,(N,V)=>N||this.isCanceled||this.isLimitHit?M(null):V.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(A,$,(B,F)=>B||this.isCanceled||this.isLimitHit||(F=F||"",this.walkedPaths[F])?M(null):(this.walkedPaths[F]=!0,p.Promises.readdir(A).then(x=>{if(this.isCanceled||this.isLimitHit)return M(null);this.doWalk(n,U,x,s,H=>M(H||null))},x=>{M(null)})))):(this.filesWalked++,U===this.filePattern||this.maxFilesize&&S.isNumber(V.size)&&V.size>this.maxFilesize||this.matchFile(s,{base:m.fsPath,relativePath:U,searchPath:this.getSearchPath(n,U)}),M(null,void 0)))})},R=>{const M=R&&y.coalesce(R);return a(M&&M.length>0?M[0]:void 0)})}matchFile(n,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,I.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(o))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,b.isFilePatternMatch)(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,o,d){return o.isSymbolicLink()?t.stat(n,d):d(null,o)}realPathIfNeeded(n,o,d){return o.isSymbolicLink()?t.realpath(n,(s,a)=>s?d(s):d(null,a)):d(null,n)}getSearchPath(n,o){return n.folderName?I.join(n.folderName,o):o}}e.FileWalker=c;class g{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new c(n)}search(n,o,d){this.walker.walk(this.folderQueries,this.extraFiles,n,o,(s,a)=>{d(s,{limitHit:a,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class i{constructor(n,o){this.expression=n,this.root=o,this.init(n)}init(n){let o,d;Object.keys(n).filter(s=>n[s]).forEach(s=>{I.isAbsolute(s)?(o=o||w.getEmptyExpression(),o[s]=n[s]):(d=d||w.getEmptyExpression(),d[s]=n[s])}),this.absoluteParsedExpr=o&&w.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=d&&w.parse(d,{trimForExclusions:!0})}test(n,o,d){return this.relativeParsedExpr&&this.relativeParsedExpr(n,o,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,n),o,d)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...w.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...w.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...w.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...w.getPathTerms(this.relativeParsedExpr)),n}}function u(r){const n=r.trim().split(`
`),o=n[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return T.uppercaseFirstLetter(n[n.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=u}),define(Ce[294],De([1,0,98,23]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===r)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,y=512,D=512*8,w=512*128;var k;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(k=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(n,o){super(n),this.decodeStreamErrorKind=o}}e.DecodeStreamError=L;class C{static async create(n){let o;if(n!==e.UTF8)o=(await new Promise((s,a)=>{J(["@vscode/iconv-lite-umd"],s,a)})).getDecoder(p(n));else{const d=new TextDecoder;o={write(s){return d.decode(s,{stream:!0})},end(){return d.decode()}}}return new C(o)}constructor(n){this.iconvLiteDecoder=n}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function E(r,n){const o=n.minBytesRequiredForDetection??n.guessEncoding?D:y;return new Promise((d,s)=>{const a=(0,l.newWriteableStream)(A=>A.join("")),m=[];let _=0,R,M;const U=async()=>{try{const A=await u({buffer:t.VSBuffer.concat(m),bytesRead:_},n.guessEncoding);if(A.seemsBinary&&n.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);A.encoding=await n.overwriteEncoding(A.encoding),R=await C.create(A.encoding);const z=R.write(t.VSBuffer.concat(m).buffer);a.write(z),m.length=0,_=0,d({stream:a,detected:A})}catch(A){M?.dispose(),a.destroy(),s(A)}};M=(0,l.listenStream)(r,{onData:async A=>{R?a.write(R.write(A.buffer)):(m.push(A),_+=A.byteLength,_>=o&&(r.pause(),await U(),setTimeout(()=>r.resume())))},onError:A=>a.error(A),onEnd:async()=>{R||await U(),a.end(R?.end())}})})}e.toDecodeStream=E;async function T(r,n,o){const s=(await new Promise((_,R)=>{J(["@vscode/iconv-lite-umd"],_,R)})).getEncoder(p(n),o);let a=!1,m=!1;return{read(){if(m)return null;const _=r.read();if(typeof _!="string"){if(m=!0,!a&&o?.addBOM)switch(n){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=s.end();return R&&R.length>0?(a=!0,t.VSBuffer.wrap(R)):null}return a=!0,t.VSBuffer.wrap(s.write(_))}}}e.toEncodeReadable=T;async function S(r){return(await new Promise((o,d)=>{J(["@vscode/iconv-lite-umd"],o,d)})).encodingExists(p(r))}e.encodingExists=S;function p(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=p;function b(r,n){if(!r||n<e.UTF16be_BOM.length)return null;const o=r.readUInt8(0),d=r.readUInt8(1);if(o===e.UTF16be_BOM[0]&&d===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&d===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const s=r.readUInt8(2);return o===e.UTF8_BOM[0]&&d===e.UTF8_BOM[1]&&s===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=b;const f=["ascii","utf-16","utf-32"];async function v(r){const n=await new Promise((m,_)=>{J(["jschardet"],m,_)}),o=r.slice(0,w),d=g(o.buffer),s=n.detect(d);if(!s||!s.encoding)return null;const a=s.encoding.toLowerCase();return 0<=f.indexOf(a)?null:c(s.encoding)}const h={ibm866:"cp866",big5:"cp950"};function c(r){const n=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return h[n]||n}function g(r){let n="";for(let o=0;o<r.length;o++)n+=String.fromCharCode(r[o]);return n}function i(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const n=r.match(/windows(\d+)/);return n?"windows-"+n[1]:r}}}e.toCanonicalName=i;function u({buffer:r,bytesRead:n},o){let d=b(r,n),s=!1;if(d!==e.UTF16be&&d!==e.UTF16le&&r){let a=!0,m=!0,_=!1;for(let R=0;R<n&&R<P;R++){const M=R%2===1,U=r.readUInt8(R)===0;if(U&&(_=!0),a&&(M&&!U||!M&&U)&&(a=!1),m&&(M&&U||!M&&!U)&&(m=!1),U&&!a&&!m)break}_&&(a?d=e.UTF16le:m?d=e.UTF16be:s=!0)}return o&&!s&&!d&&r?v(r.slice(0,n)).then(a=>({seemsBinary:!1,encoding:a})):{seemsBinary:s,encoding:d}}e.detectEncodingFromBuffer=u,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ce[141],De([1,0,294,29,140]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends I.TextSearchManager{constructor(D,w,k=t,L="searchProcess"){super(D,w,{readdir:C=>k.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,l.toCanonicalName)(C)},L)}}e.NativeTextSearchManager=P}),define(Ce[295],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class l{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(I){if(I&&this._dragOperations.has(I)){const P=this._dragOperations.get(I);return this._dragOperations.delete(I),P}}addDragOperationTransfer(I,P){this._dragOperations.set(I,P)}getRenderedTreeElement(I){if(this._renderedElements.has(I))return this._renderedElements.get(I)}addRenderedTreeItemElement(I,P){this._renderedElements.set(I,P)}removeRenderedTreeItemElement(I){this._renderedElements.has(I)&&this._renderedElements.delete(I)}}e.TreeviewsService=l}),define(Ce[296],De([1,0,175,7,22,2,4,6,18,7,13,17,15,21,295,28]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function b(h,c){if((0,L.isString)(h))return{label:h};if(h&&typeof h=="object"&&typeof h.label=="string"){let g;return Array.isArray(h.highlights)&&(g=h.highlights.filter(i=>i.length===2&&typeof i[0]=="number"&&typeof i[1]=="number"),g=g.length?g:void 0),{label:h.label,highlights:g}}}class f{constructor(c,g,i){this._proxy=c,this.commands=g,this.logService=i,this.treeViews=new Map,this.treeDragAndDropService=new S.TreeviewsService;function u(r){return r&&r.$treeViewId&&(r.$treeItemHandle||r.$selectedTreeItems||r.$focusedTreeItem)}g.registerArgumentProcessor({processArgument:r=>u(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(n=>u(n)?this.convertArgument(n):n):r})}registerTreeDataProvider(c,g,i){const u=this.createTreeView(c,{treeDataProvider:g},i);return{dispose:()=>u.dispose()}}createTreeView(c,g,i){if(!g||!g.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=g.dragAndDropController?.dropMimeTypes??[],r=g.dragAndDropController?.dragMimeTypes??[],n=!!g.dragAndDropController?.handleDrag,o=!!g.dragAndDropController?.handleDrop,d=this.createExtHostTreeView(c,g,i),s=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!g.showCollapseAll,canSelectMany:!!g.canSelectMany,dropMimeTypes:u,dragMimeTypes:r,hasHandleDrag:n,hasHandleDrop:o});return{get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,p.checkProposedApiEnabled)(i,"treeItemCheckbox"),d.onDidChangeCheckboxState},get message(){return d.message},set message(a){d.message=a},get title(){return d.title},set title(a){d.title=a},get description(){return d.description},set description(a){d.description=a},get badge(){return d.badge},set badge(a){a!==void 0&&k.ViewBadge.isViewBadge(a)?d.badge={value:Math.floor(Math.abs(a.value)),tooltip:a.tooltip}:a===void 0&&(d.badge=void 0)},reveal:(a,m)=>d.reveal(a,m),dispose:async()=>{await s,this.treeViews.delete(c),d.dispose()}}}$getChildren(c,g){const i=this.treeViews.get(c);return i?i.getChildren(g):Promise.reject(new Error((0,l.localize)(0,null,c)))}async $handleDrop(c,g,i,u,r,n,o,d){const s=this.treeViews.get(c);if(!s)return Promise.reject(new Error((0,l.localize)(1,null,c)));const a=E.DataTransfer.toDataTransfer(i,async m=>(await this._proxy.$resolveDropFileData(c,g,m)).buffer);return o===c&&d&&await this.addAdditionalTransferItems(a,s,d,r,n),s.onDrop(a,u,r)}async addAdditionalTransferItems(c,g,i,u,r){const n=this.treeDragAndDropService.removeDragOperationTransfer(r);if(n)(await n)?.forEach((o,d)=>{o&&c.set(d,o)});else if(r&&g.handleDrag){const o=g.handleDrag(i,c,u);this.treeDragAndDropService.addDragOperationTransfer(r,o),await o}return c}async $handleDrag(c,g,i,u){const r=this.treeViews.get(c);if(!r)return Promise.reject(new Error((0,l.localize)(2,null,c)));const n=await this.addAdditionalTransferItems(new t.DataTransfer,r,g,u,i);if(!!n)return E.DataTransfer.toDataTransferDTO(n)}async $hasResolve(c){const g=this.treeViews.get(c);if(!g)throw new Error((0,l.localize)(3,null,c));return g.hasResolve}$resolve(c,g,i){const u=this.treeViews.get(c);if(!u)throw new Error((0,l.localize)(4,null,c));return u.resolveTreeItem(g,i)}$setExpanded(c,g,i){const u=this.treeViews.get(c);if(!u)throw new Error((0,l.localize)(5,null,c));u.setExpanded(g,i)}$setSelection(c,g){const i=this.treeViews.get(c);if(!i)throw new Error((0,l.localize)(6,null,c));i.setSelection(g)}$setFocus(c,g){const i=this.treeViews.get(c);if(!i)throw new Error((0,l.localize)(7,null,c));i.setFocus(g)}$setVisible(c,g){const i=this.treeViews.get(c);if(!i)throw new Error((0,l.localize)(8,null,c));i.setVisible(g)}$changeCheckboxState(c,g){const i=this.treeViews.get(c);if(!i)throw new Error((0,l.localize)(9,null,c));i.setCheckboxState(g)}createExtHostTreeView(c,g,i){const u=new v(c,g,this._proxy,this.commands.converter,this.logService,i);return this.treeViews.set(c,u),u}convertArgument(c){const g=this.treeViews.get(c.$treeViewId);return g&&"$treeItemHandle"in c?g.getExtensionElement(c.$treeItemHandle):g&&"$focusedTreeItem"in c&&c.$focusedTreeItem?g.focusedElement:null}}e.ExtHostTreeViews=f;class v extends D.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,L.isUndefinedOrNull)(c))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(c,g,i,u,r,n){if(super(),this.viewId=c,this.proxy=i,this.commands=u,this.logService=r,this.extension=n,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new y.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new T.CancellationTokenSource,n.contributes&&n.contributes.views)for(const s in n.contributes.views)for(const a of n.contributes.views[s])a.id===c&&(this._title=a.name);this.dataProvider=g.treeDataProvider,this.dndController=g.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let o,d;this._register(y.Event.debounce(this._onDidChangeData.event,(s,a)=>(s||(s={message:!1,elements:[]}),a.element!==!1&&(o||(o=new Promise(m=>d=m),this.refreshPromise=this.refreshPromise.then(()=>o)),Array.isArray(a.element)?s.elements.push(...a.element):s.elements.push(a.element)),a.message&&(s.message=!0),s),200,!0)(({message:s,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=d;return o=null,this.refresh(a).then(()=>m())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(c){const g=c?this.getExtensionElement(c):void 0;if(c&&!g)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let i=this.getChildrenNodes(c);return i||(i=await this.fetchChildrenNodes(g)),i?i.map(u=>u.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,g){g=g||{select:!0,focus:!1};const i=(0,L.isUndefinedOrNull)(g.select)?!0:g.select,u=(0,L.isUndefinedOrNull)(g.focus)?!1:g.focus,r=(0,L.isUndefinedOrNull)(g.expand)?!1:g.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(n=>this.resolveTreeNode(c,n[n.length-1]).then(o=>this.proxy.$reveal(this.viewId,{item:o.item,parentChain:n.map(d=>d.item)},{select:i,focus:u,expand:r})),n=>this.logService.error(n)):this.proxy.$reveal(this.viewId,void 0,{select:i,focus:u,expand:r})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}get badge(){return this._badge}set badge(c){this._badge?.value===c?.value&&this._badge?.tooltip===c?.tooltip||(this._badge=E.ViewBadge.from(c),this.proxy.$setBadge(this.viewId,c))}setExpanded(c,g){const i=this.getExtensionElement(c);i&&(g?this._onDidExpandElement.fire(Object.freeze({element:i})):this._onDidCollapseElement.fire(Object.freeze({element:i})))}setSelection(c){(0,C.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(c){this._focusedHandle=c}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(c){const g=(await Promise.all(c.map(async i=>{const u=this.getExtensionElement(i.treeItemHandle);return u?{extensionItem:u,treeItem:await this.dataProvider.getTreeItem(u),newState:i.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(i=>i!==void 0);g.forEach(i=>{i.treeItem.checkboxState=i.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:g.map(i=>[i.extensionItem,i.newState])})}async handleDrag(c,g,i){const u=[];for(const r of c){const n=this.getExtensionElement(r);n&&u.push(n)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,g,i),g}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(c,g,i){const u=g?this.getExtensionElement(g):void 0;if(!(!u&&g||!this.dndController?.handleDrop))return(0,w.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(u,c,i):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,g){if(!this.dataProvider.resolveTreeItem)return;const i=this.elements.get(c);if(i){const u=this.nodes.get(i);if(u){const r=await this.dataProvider.resolveTreeItem(u.extensionItem,i,g)??u.extensionItem;return this.validateTreeItem(r),u.item.tooltip=this.getTooltip(r.tooltip),u.item.command=this.getCommand(u.disposableStore,r.command),u.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(g=>g?this.resolveUnknownParentChain(g).then(i=>this.resolveTreeNode(g,i[i.length-1]).then(u=>(i.push(u),i))):Promise.resolve([]))}resolveParent(c){const g=this.nodes.get(c);return g?Promise.resolve(g.parent?this.elements.get(g.parent.item.handle):void 0):(0,w.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,g){const i=this.nodes.get(c);return i?Promise.resolve(i):(0,w.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(u=>this.createHandle(c,u,g,!0)).then(u=>this.getChildren(g?g.item.handle:void 0).then(()=>{const r=this.getExtensionElement(u);if(r){const n=this.nodes.get(r);if(n)return Promise.resolve(n)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(c){if(c){let g;if(typeof c=="string"){const i=this.getExtensionElement(c);g=i?this.nodes.get(i):void 0}else g=c;return g&&g.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const g=new T.CancellationTokenSource(this._refreshCancellationSource.token);try{const i=c?this.nodes.get(c):void 0,u=await this.dataProvider.getChildren(c);if(g.token.isCancellationRequested)return;const r=await Promise.all((0,C.coalesce)(u||[]).map(async n=>{const o=await this.dataProvider.getTreeItem(n);return o&&!g.token.isCancellationRequested?this.createAndRegisterTreeNode(n,o,i):null}));return g.token.isCancellationRequested?void 0:(0,C.coalesce)(r)}finally{g.dispose()}}refresh(c){if(c.some(i=>!i))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new T.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const i=this.getHandlesToRefresh(c);if(i.length)return this.refreshHandles(i)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const g=new Set,i=c.map(r=>this.nodes.get(r));for(const r of i)if(r&&!g.has(r.item.handle)){let n=r;for(;n&&n.parent&&i.findIndex(o=>n&&n.parent&&o&&o.item.handle===n.parent.item.handle)===-1;){const o=this.elements.get(n.parent.item.handle);n=o?this.nodes.get(o):void 0}n&&!n.parent&&g.add(r.item.handle)}const u=[];return g.forEach(r=>{const n=this.elements.get(r);if(n){const o=this.nodes.get(n);o&&(!o.parent||!g.has(o.parent.item.handle))&&u.push(r)}}),u}refreshHandles(c){const g={};return Promise.all(c.map(i=>this.refreshNode(i).then(u=>{u&&(g[i]=u.item)}))).then(()=>Object.keys(g).length?this.proxy.$refresh(this.viewId,g):void 0)}refreshNode(c){const g=this.getExtensionElement(c);if(g){const i=this.nodes.get(g);if(i)return this.clearChildren(g),(0,w.asPromise)(()=>this.dataProvider.getTreeItem(g)).then(u=>{if(u){const r=this.createTreeNode(g,u,i.parent);return this.updateNodeCache(g,r,i,i.parent),i.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,g,i){const u=this.createTreeNode(c,g,i);if(g.id&&this.elements.has(u.item.handle))throw new Error((0,l.localize)(10,null,g.id));return this.addNodeToCache(c,u),this.addNodeToParentCache(u,i),u}getTooltip(c){return k.MarkdownString.isMarkdownString(c)?E.MarkdownString.from(c):c}getCommand(c,g){return g?{...this.commands.toInternal(g,c),originalId:g.command}:void 0}getCheckbox(c){if(!c.checkboxState)return;let g,i;return typeof c.checkboxState=="number"?g=c.checkboxState:(g=c.checkboxState.state,i=c.checkboxState.tooltip),{isChecked:g===k.TreeItemCheckboxState.Checked,tooltip:i}}validateTreeItem(c){if(!k.TreeItem.isTreeItem(c,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(c,g,i){this.validateTreeItem(g);const u=new D.DisposableStore,r=this.createHandle(c,g,i),n=this.getLightIconPath(g);return{item:{handle:r,parentHandle:i?i.item.handle:void 0,label:b(g.label,this.extension),description:g.description,resourceUri:g.resourceUri,tooltip:this.getTooltip(g.tooltip),command:this.getCommand(u,g.command),contextValue:g.contextValue,icon:n,iconDark:this.getDarkIconPath(g)||n,themeIcon:this.getThemeIcon(g),collapsibleState:(0,L.isUndefinedOrNull)(g.collapsibleState)?k.TreeItemCollapsibleState.None:g.collapsibleState,accessibilityInformation:g.accessibilityInformation,checkbox:this.getCheckbox(g)},extensionItem:g,parent:i,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(c){return c.iconPath instanceof k.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:g,label:i,resourceUri:u},r,n){if(g)return`${v.ID_HANDLE_PREFIX}/${g}`;const o=b(i,this.extension),d=r?r.item.handle:v.LABEL_HANDLE_PREFIX;let s=o?o.label:u?(0,I.basename)(u):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const a=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,m=this.getChildrenNodes(r)||[];let _,R=0;do{if(_=`${d}/${R}:${s}`,n||!this.elements.has(_)||a===_)break;R++}while(R<=m.length);return _}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof k.ThemeIcon))return typeof c.iconPath=="string"||P.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof k.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return P.URI.isUri(c)?c:P.URI.file(c)}addNodeToCache(c,g){this.elements.set(g.item.handle,c),this.nodes.set(c,g)}updateNodeCache(c,g,i,u){this.elements.delete(g.item.handle),this.nodes.delete(c),g.item.handle!==i.item.handle&&this.elements.delete(i.item.handle),this.addNodeToCache(c,g);const r=this.getChildrenNodes(u)||[],n=r.filter(o=>o.item.handle===i.item.handle)[0];n&&r.splice(r.indexOf(n),1,g)}addNodeToParentCache(c,g){g?(g.children||(g.children=[]),g.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const g=this.nodes.get(c);if(g){if(g.children)for(const i of g.children){const u=this.elements.get(i.item.handle);u&&this.clear(u)}g.children=void 0}}else this.clearAll()}clear(c){const g=this.nodes.get(c);if(g){if(g.children)for(const i of g.children){const u=this.elements.get(i.item.handle);u&&this.clear(u)}this.nodes.delete(c),this.elements.delete(g.item.handle),g.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(Ce[297],De([1,0,21,11,4,42,2,117,102,148,158,38,5,91,241,240,39,242,34,244,245,246,229,247,57,41,248,249,252,253,254,139,232,258,259,260,94,40,262,296,15,7,265,70,138,33,212,251,85,136,72,74,75,12,54,16,25,255,228,53,67,238,263,69,68,268,266,267,239,46,261,264,93,58,131,256,71,257,14,121,231,208,250,6,28,213,92]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f,v,h,c,g,i,u,r,n,o,d,s,a,m,_,R,M,U,A,z,$,N,V,B,F,x,H,Q,K,de,ee,he,Y,me,be,ke,Re,ze,oe,le,ge,Z,ae,ne,ie,O,j,G,X,pe,we,ce,Ie,ye,We,qe,Ze,Ye,Ne,at,re,se,Ee,Ve,fe,Ae,Le,Me,Ke,Je){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function st(ot){const it=ot.get(le.IExtHostInitDataService),lt=ot.get(Ie.IExtHostFileSystemInfo),vt=ot.get(G.IExtHostConsumerFileSystem),wt=ot.get(n.IExtHostExtensionService),ft=ot.get(K.IExtHostWorkspace),St=ot.get(Ye.IExtHostTelemetry),Ft=ot.get(v.IExtHostConfiguration),Mt=ot.get(ze.IURITransformerService),Qe=ot.get(oe.IExtHostRpcService),zt=ot.get(z.IExtHostStorage),Ot=ot.get(j.IExtensionStoragePaths),Pt=ot.get(Re.ILoggerService),gt=ot.get(Re.ILogService),kt=ot.get(ae.IExtHostTunnelService),Pe=ot.get(ne.IExtHostApiDeprecationService),Oe=ot.get(Q.IExtHostWindow),_e=ot.get(qe.IExtHostSecretState),te=ot.get(Ze.IExtHostEditorTabs);Qe.set(E.ExtHostContext.ExtHostFileSystemInfo,lt),Qe.set(E.ExtHostContext.ExtHostLogLevelServiceShape,Pt),Qe.set(E.ExtHostContext.ExtHostWorkspace,ft),Qe.set(E.ExtHostContext.ExtHostConfiguration,Ft),Qe.set(E.ExtHostContext.ExtHostExtensionService,wt),Qe.set(E.ExtHostContext.ExtHostStorage,zt),Qe.set(E.ExtHostContext.ExtHostTunnelService,kt),Qe.set(E.ExtHostContext.ExtHostWindow,Oe),Qe.set(E.ExtHostContext.ExtHostSecretState,_e),Qe.set(E.ExtHostContext.ExtHostTelemetry,St),Qe.set(E.ExtHostContext.ExtHostEditorTabs,te);const Fe=Qe.set(E.ExtHostContext.ExtHostDecorations,ot.get(Y.IExtHostDecorations)),xe=Qe.set(E.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(r.IExtHostDocumentsAndEditors)),nt=Qe.set(E.ExtHostContext.ExtHostCommands,ot.get(b.IExtHostCommands)),Ge=Qe.set(E.ExtHostContext.ExtHostTerminalService,ot.get($.IExtHostTerminalService)),rt=Qe.set(E.ExtHostContext.ExtHostDebugService,ot.get(be.IExtHostDebugService)),pt=Qe.set(E.ExtHostContext.ExtHostSearch,ot.get(ke.IExtHostSearch)),Et=Qe.set(E.ExtHostContext.ExtHostTask,ot.get(me.IExtHostTask)),Tt=Qe.set(E.ExtHostContext.ExtHostOutputService,ot.get(_.IExtHostOutputService)),It=Qe.set(E.ExtHostContext.ExtHostLocalization,ot.get(Je.IExtHostLocalizationService)),_t=Qe.set(E.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(Qe)),bt=Qe.set(E.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(Qe,xe)),Ct=Qe.set(E.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(Qe,xe,gt)),en=Qe.set(E.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(gt,bt,Qe.getProxy(E.MainContext.MainThreadBulkEdits))),yt=Qe.set(E.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(Qe,nt,xe,bt)),qt=Qe.set(E.ExtHostContext.ExtHostNotebookDocuments,new fe.ExtHostNotebookDocuments(yt)),$t=Qe.set(E.ExtHostContext.ExtHostNotebookEditors,new Ve.ExtHostNotebookEditors(gt,yt)),tn=Qe.set(E.ExtHostContext.ExtHostNotebookKernels,new Ne.ExtHostNotebookKernels(Qe,it,yt,nt,gt)),un=Qe.set(E.ExtHostContext.ExtHostNotebookRenderers,new re.ExtHostNotebookRenderers(Qe,yt)),At=Qe.set(E.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Qe,xe)),nn=Qe.set(E.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(Qe.getProxy(E.MainContext.MainThreadTreeViews),nt,gt)),dn=Qe.set(E.ExtHostContext.ExtHostEditorInsets,new de.ExtHostEditorInsets(Qe.getProxy(E.MainContext.MainThreadEditorInsets),At,it.remote)),Ut=Qe.set(E.ExtHostContext.ExtHostDiagnostics,new h.ExtHostDiagnostics(Qe,gt,lt)),Jt=Qe.set(E.ExtHostContext.ExtHostLanguages,new a.ExtHostLanguages(Qe,bt,nt.converter,Mt)),dt=Qe.set(E.ExtHostContext.ExtHostLanguageFeatures,new s.ExtHostLanguageFeatures(Qe,Mt,bt,nt,Ut,gt,Pe)),hn=Qe.set(E.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(Qe,dt)),Nt=Qe.set(E.ExtHostContext.ExtHostFileSystemEventService,new d.ExtHostFileSystemEventService(Qe,gt,xe)),Gt=Qe.set(E.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(Qe,ft,nt)),rn=Qe.set(E.ExtHostContext.ExtHostSCM,new U.ExtHostSCM(Qe,nt,gt)),fn=Qe.set(E.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(Qe,nt,bt)),sn=Qe.set(E.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Qe.getProxy(E.MainContext.MainThreadProgress))),mn=Qe.set(E.ExtHostContext.ExtHosLabelService,new ee.ExtHostLabelService(Qe)),on=Qe.set(E.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Qe)),Zt=Qe.set(E.ExtHostContext.ExtHostAuthentication,new ie.ExtHostAuthentication(Qe)),gn=Qe.set(E.ExtHostContext.ExtHostTimeline,new O.ExtHostTimeline(Qe,nt)),pn=Qe.set(E.ExtHostContext.ExtHostWebviews,new H.ExtHostWebviews(Qe,it.remote,ft,gt,Pe)),vn=Qe.set(E.ExtHostContext.ExtHostWebviewPanels,new we.ExtHostWebviewPanels(Qe,pn,ft)),bn=Qe.set(E.ExtHostContext.ExtHostCustomEditors,new pe.ExtHostCustomEditors(Qe,bt,Ot,pn,vn)),wn=Qe.set(E.ExtHostContext.ExtHostWebviewViews,new X.ExtHostWebviewViews(Qe,pn)),Kt=Qe.set(E.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(Qe,nt,xe)),En=Qe.set(E.ExtHostContext.ExtHostUriOpeners,new We.ExtHostUriOpeners(Qe));Qe.set(E.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(Qe,yt,xe,nt,gt));const Fn=Object.values(E.ExtHostContext);Qe.assertRegistered(Fn);const Sn=new ce.ExtHostBulkEdits(Qe,xe),_n=new p.ExtHostClipboard(Qe),yn=new m.ExtHostMessageService(Qe,gt),Tn=new c.ExtHostDialogs(Qe),Pn=new A.ExtHostStatusBar(Qe,nt.converter);return S.ExtHostApiCommands.register(nt),function($e,xt,An){const mt=function(){let ve=!$e.isUnderDevelopment;function Se(){ve||(gt.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ve=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")Se();else{const Dt=ct;typeof Dt.scheme>"u"&&Se(),typeof Dt.exclusive=="boolean"&&(0,Me.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return ct}}(),Cn={getSession(ve,Se,Ue){return Zt.getSession($e,ve,Se,Ue)},async hasSession(ve,Se){return(0,Me.checkProposedApiEnabled)($e,"authSession"),!!await Zt.getSession($e,ve,Se,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(ve,Se,Ue,ct){return Zt.registerAuthenticationProvider(ve,Se,Ue,ct)}},Mn={registerCommand(ve,Se,Ue){return nt.registerCommand(!0,ve,Se,Ue,void 0,$e)},registerTextEditorCommand(ve,Se,Ue){return nt.registerCommand(!0,ve,(...ct)=>{const Dt=At.getActiveTextEditor();if(!Dt){gt.warn("Cannot execute "+ve+" because there is no active text editor.");return}return Dt.edit(Rt=>{Se.apply(Ue,[Dt,Rt,...ct])}).then(Rt=>{Rt||gt.warn("Edits from command "+ve+" were not applied.")},Rt=>{gt.warn("An error occurred while running command "+ve,Rt)})},void 0,void 0,$e)},registerDiffInformationCommand:(ve,Se,Ue)=>((0,Me.checkProposedApiEnabled)($e,"diffCommand"),nt.registerCommand(!0,ve,async(...ct)=>{const Dt=xe.activeEditor(!0);if(!Dt){gt.warn("Cannot execute "+ve+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Dt.id);Se.apply(Ue,[Rt,...ct])},void 0,void 0,$e)),executeCommand(ve,...Se){return nt.executeCommand(ve,...Se)},getCommands(ve=!1){return nt.getCommands(ve)}},Rn={get machineId(){return it.telemetryInfo.machineId},get sessionId(){return it.telemetryInfo.sessionId},get language(){return it.environment.appLanguage},get appName(){return it.environment.appName},get appRoot(){return it.environment.appRoot?.fsPath??""},get appHost(){return it.environment.appHost},get uriScheme(){return it.environment.appUriScheme},get clipboard(){return _n.value},get shell(){return Ge.getDefaultShell(!1)},get onDidChangeShell(){return(0,Me.checkProposedApiEnabled)($e,"envShellEvent"),Ge.onDidChangeShell},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return St.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Me.checkProposedApiEnabled)($e,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Me.checkProposedApiEnabled)($e,"telemetry"),St.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.isNewAppInstall)(it.telemetryInfo.firstSessionDate)},createTelemetryLogger(ve){return(0,Me.checkProposedApiEnabled)($e,"telemetry"),St.instantiateLogger($e,ve)},openExternal(ve,Se){return Oe.openUri(ve,{allowTunneling:!!it.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(ve){if(ve.scheme===it.environment.appUriScheme)return _t.createAppUri(ve);try{return await Oe.asExternalUri(ve,{allowTunneling:!!it.remote.authority})}catch(Se){if((0,Ee.matchesScheme)(ve,se.Schemas.http)||(0,Ee.matchesScheme)(ve,se.Schemas.https))return ve;throw Se}},get remoteName(){return(0,he.getRemoteName)(it.remote.authority)},get remoteAuthority(){return(0,Me.checkProposedApiEnabled)($e,"resolvers"),it.remote.authority},get uiKind(){return it.uiKind}};it.environment.extensionTestsLocationURI||Object.freeze(Rn);const Un={createTestController(ve,Se,Ue){return Kt.createTestController(ve,Se,Ue)},createTestObserver(){return(0,Me.checkProposedApiEnabled)($e,"testObserver"),Kt.createTestObserver()},runTests(ve){return(0,Me.checkProposedApiEnabled)($e,"testObserver"),Kt.runTests(ve)},get onDidChangeTestResults(){return(0,Me.checkProposedApiEnabled)($e,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,Me.checkProposedApiEnabled)($e,"testObserver"),Kt.results}},Xt=it.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,Bn={getExtension(ve,Se){(0,Me.isProposedApiEnabled)($e,"extensionsAny")||(Se=!1);const Ue=xt.mine.getExtensionDescription(ve);if(Ue)return new n.Extension(wt,$e.identifier,Ue,Xt,!1);if(Se){const ct=xt.all.getExtensionDescription(ve);if(ct)return new n.Extension(wt,$e.identifier,ct,Xt,!0)}},get all(){const ve=[];for(const Se of xt.mine.getAllExtensionDescriptions())ve.push(new n.Extension(wt,$e.identifier,Se,Xt,!1));return ve},get allAcrossExtensionHosts(){(0,Me.checkProposedApiEnabled)($e,"extensionsAny");const ve=new Me.ExtensionIdentifierSet(xt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Se=[];for(const Ue of xt.all.getAllExtensionDescriptions()){const ct=!ve.has(Ue.identifier);Se.push(new n.Extension(wt,$e.identifier,Ue,Xt,ct))}return Se},get onDidChange(){return(0,Me.isProposedApiEnabled)($e,"extensionsAny")?I.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},zn={createDiagnosticCollection(ve){return Ut.createDiagnosticCollection($e.identifier,ve)},get onDidChangeDiagnostics(){return Ut.onDidChangeDiagnostics},getDiagnostics:ve=>Ut.getDiagnostics(ve),getLanguages(){return Jt.getLanguages()},setTextDocumentLanguage(ve,Se){return Jt.changeLanguage(ve.uri,Se)},match(ve,Se){const Ue=bt.getDocumentData(Se.uri)?.notebook;return(0,L.score)(B.LanguageSelector.from(ve),Se.uri,Se.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(ve,Se,Ue){return dt.registerCodeActionProvider($e,mt(ve),Se,Ue)},registerDocumentPasteEditProvider(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)($e,"documentPaste"),dt.registerDocumentPasteEditProvider($e,mt(ve),Se,Ue)},registerCodeLensProvider(ve,Se){return dt.registerCodeLensProvider($e,mt(ve),Se)},registerDefinitionProvider(ve,Se){return dt.registerDefinitionProvider($e,mt(ve),Se)},registerDeclarationProvider(ve,Se){return dt.registerDeclarationProvider($e,mt(ve),Se)},registerImplementationProvider(ve,Se){return dt.registerImplementationProvider($e,mt(ve),Se)},registerTypeDefinitionProvider(ve,Se){return dt.registerTypeDefinitionProvider($e,mt(ve),Se)},registerHoverProvider(ve,Se){return dt.registerHoverProvider($e,mt(ve),Se,$e.identifier)},registerEvaluatableExpressionProvider(ve,Se){return dt.registerEvaluatableExpressionProvider($e,mt(ve),Se,$e.identifier)},registerInlineValuesProvider(ve,Se){return dt.registerInlineValuesProvider($e,mt(ve),Se,$e.identifier)},registerDocumentHighlightProvider(ve,Se){return dt.registerDocumentHighlightProvider($e,mt(ve),Se)},registerLinkedEditingRangeProvider(ve,Se){return dt.registerLinkedEditingRangeProvider($e,mt(ve),Se)},registerReferenceProvider(ve,Se){return dt.registerReferenceProvider($e,mt(ve),Se)},registerRenameProvider(ve,Se){return dt.registerRenameProvider($e,mt(ve),Se)},registerDocumentSymbolProvider(ve,Se,Ue){return dt.registerDocumentSymbolProvider($e,mt(ve),Se,Ue)},registerWorkspaceSymbolProvider(ve){return dt.registerWorkspaceSymbolProvider($e,ve)},registerDocumentFormattingEditProvider(ve,Se){return dt.registerDocumentFormattingEditProvider($e,mt(ve),Se)},registerDocumentRangeFormattingEditProvider(ve,Se){return dt.registerDocumentRangeFormattingEditProvider($e,mt(ve),Se)},registerOnTypeFormattingEditProvider(ve,Se,Ue,...ct){return dt.registerOnTypeFormattingEditProvider($e,mt(ve),Se,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(ve,Se,Ue){return dt.registerDocumentSemanticTokensProvider($e,mt(ve),Se,Ue)},registerDocumentRangeSemanticTokensProvider(ve,Se,Ue){return dt.registerDocumentRangeSemanticTokensProvider($e,mt(ve),Se,Ue)},registerSignatureHelpProvider(ve,Se,Ue,...ct){return typeof Ue=="object"?dt.registerSignatureHelpProvider($e,mt(ve),Se,Ue):dt.registerSignatureHelpProvider($e,mt(ve),Se,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(ve,Se,...Ue){return dt.registerCompletionItemProvider($e,mt(ve),Se,Ue)},registerInlineCompletionItemProvider(ve,Se){return Se.handleDidShowCompletionItem&&(0,Me.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider($e,mt(ve),Se)},registerInlineCompletionItemProviderNew(ve,Se){if((0,Me.checkProposedApiEnabled)($e,"inlineCompletionsNew"),Se.handleDidShowCompletionItem&&!(0,Me.isProposedApiEnabled)($e,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew($e,mt(ve),Se)},registerDocumentLinkProvider(ve,Se){return dt.registerDocumentLinkProvider($e,mt(ve),Se)},registerColorProvider(ve,Se){return dt.registerColorProvider($e,mt(ve),Se)},registerFoldingRangeProvider(ve,Se){return dt.registerFoldingRangeProvider($e,mt(ve),Se)},registerSelectionRangeProvider(ve,Se){return dt.registerSelectionRangeProvider($e,ve,Se)},registerCallHierarchyProvider(ve,Se){return dt.registerCallHierarchyProvider($e,ve,Se)},registerTypeHierarchyProvider(ve,Se){return dt.registerTypeHierarchyProvider($e,ve,Se)},setLanguageConfiguration:(ve,Se)=>dt.setLanguageConfiguration($e,ve,Se),getTokenInformationAtPosition(ve,Se){return(0,Me.checkProposedApiEnabled)($e,"tokenInformation"),Jt.tokenAtPosition(ve,Se)},registerInlayHintsProvider(ve,Se){return dt.registerInlayHintsProvider($e,ve,Se)},createLanguageStatusItem(ve,Se){return Jt.createLanguageStatusItem($e,ve,Se)},registerDocumentDropEditProvider(ve,Se){return dt.registerDocumentOnDropEditProvider($e,ve,Se)}},Wn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Ge.activeTerminal},get terminals(){return Ge.terminals},async showTextDocument(ve,Se,Ue){const ct=await(y.URI.isUri(ve)?Promise.resolve(Ln.openTextDocument(ve)):Promise.resolve(ve));return At.showTextDocument(ct,Se,Ue)},createTextEditorDecorationType(ve){return At.createTextEditorDecorationType($e,ve)},onDidChangeActiveTextEditor(ve,Se,Ue){return At.onDidChangeActiveTextEditor(ve,Se,Ue)},onDidChangeVisibleTextEditors(ve,Se,Ue){return At.onDidChangeVisibleTextEditors(ve,Se,Ue)},onDidChangeTextEditorSelection(ve,Se,Ue){return At.onDidChangeTextEditorSelection(ve,Se,Ue)},onDidChangeTextEditorOptions(ve,Se,Ue){return At.onDidChangeTextEditorOptions(ve,Se,Ue)},onDidChangeTextEditorVisibleRanges(ve,Se,Ue){return At.onDidChangeTextEditorVisibleRanges(ve,Se,Ue)},onDidChangeTextEditorViewColumn(ve,Se,Ue){return At.onDidChangeTextEditorViewColumn(ve,Se,Ue)},onDidCloseTerminal(ve,Se,Ue){return Ge.onDidCloseTerminal(ve,Se,Ue)},onDidOpenTerminal(ve,Se,Ue){return Ge.onDidOpenTerminal(ve,Se,Ue)},onDidChangeActiveTerminal(ve,Se,Ue){return Ge.onDidChangeActiveTerminal(ve,Se,Ue)},onDidChangeTerminalDimensions(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)($e,"terminalDimensions"),Ge.onDidChangeTerminalDimensions(ve,Se,Ue)},onDidChangeTerminalState(ve,Se,Ue){return Ge.onDidChangeTerminalState(ve,Se,Ue)},onDidWriteTerminalData(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),Ge.onDidWriteTerminalData(ve,Se,Ue)},get state(){return Oe.state},onDidChangeWindowState(ve,Se,Ue){return Oe.onDidChangeWindowState(ve,Se,Ue)},showInformationMessage(ve,...Se){return yn.showMessage($e,P.default.Info,ve,Se[0],Se.slice(1))},showWarningMessage(ve,...Se){return yn.showMessage($e,P.default.Warning,ve,Se[0],Se.slice(1))},showErrorMessage(ve,...Se){return yn.showMessage($e,P.default.Error,ve,Se[0],Se.slice(1))},showQuickPick(ve,Se,Ue){return Gt.showQuickPick(ve,Se,Ue)},showWorkspaceFolderPick(ve){return Gt.showWorkspaceFolderPick(ve)},showInputBox(ve,Se){return Gt.showInput(ve,Se)},showOpenDialog(ve){return Tn.showOpenDialog(ve)},showSaveDialog(ve){return Tn.showSaveDialog(ve)},createStatusBarItem(ve,Se,Ue){let ct,Dt,Rt;return typeof ve=="string"?(ct=ve,Dt=Se,Rt=Ue):(Dt=ve,Rt=Se),Pn.createStatusBarEntry($e,ct,Dt,Rt)},setStatusBarMessage(ve,Se){return Pn.setStatusBarMessage(ve,Se)},withScmProgress(ve){return Pe.report("window.withScmProgress",$e,"Use 'withProgress' instead."),sn.withProgress($e,{location:F.ProgressLocation.SourceControl},(Se,Ue)=>ve({report(ct){}}))},withProgress(ve,Se){return sn.withProgress($e,ve,Se)},createOutputChannel(ve,Se){return Tt.createOutputChannel(ve,Se,$e)},createWebviewPanel(ve,Se,Ue,ct){return vn.createWebviewPanel($e,ve,Se,Ue,ct)},createWebviewTextEditorInset(ve,Se,Ue,ct){return(0,Me.checkProposedApiEnabled)($e,"editorInsets"),dn.createWebviewEditorInset(ve,Se,Ue,ct,$e)},createTerminal(ve,Se,Ue){return typeof ve=="object"?"pty"in ve?Ge.createExtensionTerminal(ve):Ge.createTerminalFromOptions(ve):Ge.createTerminal(ve,Se,Ue)},registerTerminalLinkProvider(ve){return Ge.registerLinkProvider(ve)},registerTerminalProfileProvider(ve,Se){return Ge.registerProfileProvider($e,ve,Se)},registerTreeDataProvider(ve,Se){return nn.registerTreeDataProvider(ve,Se,$e)},createTreeView(ve,Se){return nn.createTreeView(ve,Se,$e)},registerWebviewPanelSerializer:(ve,Se)=>vn.registerWebviewPanelSerializer($e,ve,Se),registerCustomEditorProvider:(ve,Se,Ue={})=>bn.registerCustomEditorProvider($e,ve,Se,Ue),registerFileDecorationProvider(ve){return Fe.registerFileDecorationProvider(ve,$e.identifier)},registerUriHandler(ve){return _t.registerUriHandler($e.identifier,ve)},createQuickPick(){return Gt.createQuickPick($e)},createInputBox(){return Gt.createInputBox($e)},get activeColorTheme(){return on.activeColorTheme},onDidChangeActiveColorTheme(ve,Se,Ue){return on.onDidChangeActiveColorTheme(ve,Se,Ue)},registerWebviewViewProvider(ve,Se,Ue){return wn.registerWebviewViewProvider($e,ve,Se,Ue?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ve,Se,Ue){return yt.onDidChangeActiveNotebookEditor(ve,Se,Ue)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ve,Se,Ue){return $t.onDidChangeNotebookEditorSelection(ve,Se,Ue)},onDidChangeNotebookEditorVisibleRanges(ve,Se,Ue){return $t.onDidChangeNotebookEditorVisibleRanges(ve,Se,Ue)},showNotebookDocument(ve,Se){return y.URI.isUri(ve)&&Pe.report("window.showNotebookDocument(uri)",$e,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),yt.showNotebookDocument(ve,Se)},registerExternalUriOpener(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)($e,"externalUriOpener"),En.registerExternalUriOpener($e.identifier,ve,Se,Ue)},get tabGroups(){return te.tabGroups}},Ln={get rootPath(){return Pe.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ve){throw t.readonly()},getWorkspaceFolder(ve){return ft.getWorkspaceFolder(ve)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ve){throw t.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ve){throw t.readonly()},updateWorkspaceFolders:(ve,Se,...Ue)=>ft.updateWorkspaceFolders($e,ve,Se||0,...Ue),onDidChangeWorkspaceFolders:function(ve,Se,Ue){return ft.onDidChangeWorkspace(ve,Se,Ue)},asRelativePath:(ve,Se)=>ft.getRelativePath(ve,Se),findFiles:(ve,Se,Ue,ct)=>ft.findFiles(ve,Se,Ue,$e.identifier,ct),findTextInFiles:(ve,Se,Ue,ct)=>{(0,Me.checkProposedApiEnabled)($e,"findTextInFiles");let Dt,Rt;return typeof Se=="object"?(Dt=Se,Rt=Ue):(Dt={},Rt=Se,ct=Ue),ft.findTextInFiles(ve,Dt||{},Rt,$e.identifier,ct)},saveAll:ve=>ft.saveAll(ve),applyEdit(ve,Se){return Sn.applyWorkspaceEdit(ve,$e,Se)},createFileSystemWatcher:(ve,Se,Ue,ct)=>Nt.createFileSystemWatcher(ft,$e,ve,Se,Ue,ct),get textDocuments(){return bt.getAllDocumentData().map(ve=>ve.document)},set textDocuments(ve){throw t.readonly()},openTextDocument(ve){let Se;const Ue=ve;if(typeof ve=="string")Se=Promise.resolve(y.URI.file(ve));else if(y.URI.isUri(ve))Se=Promise.resolve(ve);else if(!Ue||typeof Ue=="object")Se=bt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(ct=>bt.ensureDocumentData(ct).then(Dt=>Dt.document))},onDidOpenTextDocument:(ve,Se,Ue)=>bt.onDidAddDocument(ve,Se,Ue),onDidCloseTextDocument:(ve,Se,Ue)=>bt.onDidRemoveDocument(ve,Se,Ue),onDidChangeTextDocument:(ve,Se,Ue)=>bt.onDidChangeDocument(ve,Se,Ue),onDidSaveTextDocument:(ve,Se,Ue)=>bt.onDidSaveDocument(ve,Se,Ue),onWillSaveTextDocument:(ve,Se,Ue)=>en.getOnWillSaveTextDocumentEvent($e)(ve,Se,Ue),get notebookDocuments(){return yt.notebookDocuments.map(ve=>ve.apiNotebook)},async openNotebookDocument(ve,Se){let Ue;if(y.URI.isUri(ve))Ue=ve,await yt.openNotebookDocument(ve);else if(typeof ve=="string")Ue=y.URI.revive(await yt.createNotebookDocument({viewType:ve,content:Se}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(ve,Se,Ue){return qt.onDidSaveNotebookDocument(ve,Se,Ue)},onDidChangeNotebookDocument(ve,Se,Ue){return qt.onDidChangeNotebookDocument(ve,Se,Ue)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(ve,Se,Ue,ct){return yt.registerNotebookSerializer($e,ve,Se,Ue,(0,Me.isProposedApiEnabled)($e,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(ve,Se,Ue,ct)=>((0,Me.checkProposedApiEnabled)($e,"notebookContentProvider"),Pe.report("workspace.registerNotebookContentProvider",$e,"The notebookContentProvider API is not on track for finalization and will be removed."),yt.registerNotebookContentProvider($e,ve,Se,Ue,(0,Me.isProposedApiEnabled)($e,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(ve,Se,Ue)=>An.onDidChangeConfiguration(ve,Se,Ue),getConfiguration(ve,Se){return Se=arguments.length===1?void 0:Se,An.getConfiguration(ve,Se,$e)},registerTextDocumentContentProvider(ve,Se){return Ct.registerTextDocumentContentProvider(ve,Se)},registerTaskProvider:(ve,Se)=>(Pe.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider($e,ve,Se)),registerFileSystemProvider(ve,Se,Ue){return(0,Le.combinedDisposable)(hn.registerFileSystemProvider($e,ve,Se,Ue),vt.addFileSystemProvider(ve,Se))},get fs(){return vt.value},registerFileSearchProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)($e,"fileSearchProvider"),pt.registerFileSearchProvider(ve,Se)),registerTextSearchProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)($e,"textSearchProvider"),pt.registerTextSearchProvider(ve,Se)),registerRemoteAuthorityResolver:(ve,Se)=>((0,Me.checkProposedApiEnabled)($e,"resolvers"),wt.registerRemoteAuthorityResolver(ve,Se)),registerResourceLabelFormatter:ve=>((0,Me.checkProposedApiEnabled)($e,"resolvers"),mn.$registerResourceLabelFormatter(ve)),onDidCreateFiles:(ve,Se,Ue)=>Nt.onDidCreateFile(ve,Se,Ue),onDidDeleteFiles:(ve,Se,Ue)=>Nt.onDidDeleteFile(ve,Se,Ue),onDidRenameFiles:(ve,Se,Ue)=>Nt.onDidRenameFile(ve,Se,Ue),onWillCreateFiles:(ve,Se,Ue)=>Nt.getOnWillCreateFileEvent($e)(ve,Se,Ue),onWillDeleteFiles:(ve,Se,Ue)=>Nt.getOnWillDeleteFileEvent($e)(ve,Se,Ue),onWillRenameFiles:(ve,Se,Ue)=>Nt.getOnWillRenameFileEvent($e)(ve,Se,Ue),openTunnel:ve=>((0,Me.checkProposedApiEnabled)($e,"tunnels"),kt.openTunnel($e,ve).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,Me.checkProposedApiEnabled)($e,"tunnels"),kt.getTunnels()},onDidChangeTunnels:(ve,Se,Ue)=>((0,Me.checkProposedApiEnabled)($e,"tunnels"),kt.onDidChangeTunnels(ve,Se,Ue)),registerPortAttributesProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)($e,"portsAttributes"),kt.registerPortsAttributesProvider(ve,Se)),registerTimelineProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)($e,"timeline"),gn.registerTimelineProvider(ve,Se,$e.identifier,nt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ve=>((0,Me.checkProposedApiEnabled)($e,"workspaceTrust"),ft.requestWorkspaceTrust(ve)),onDidGrantWorkspaceTrust:(ve,Se,Ue)=>ft.onDidGrantWorkspaceTrust(ve,Se,Ue),registerEditSessionIdentityProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ve,Se))},Dn={get inputBox(){return Pe.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),rn.getLastInputBox($e)},createSourceControl(ve,Se,Ue){return rn.createSourceControl($e,ve,Se,Ue)}},$n={createCommentController(ve,Se){return fn.createCommentController($e,ve,Se)}},Vt={get activeDebugSession(){return rt.activeDebugSession},get activeDebugConsole(){return rt.activeDebugConsole},get breakpoints(){return rt.breakpoints},onDidStartDebugSession(ve,Se,Ue){return rt.onDidStartDebugSession(ve,Se,Ue)},onDidTerminateDebugSession(ve,Se,Ue){return rt.onDidTerminateDebugSession(ve,Se,Ue)},onDidChangeActiveDebugSession(ve,Se,Ue){return rt.onDidChangeActiveDebugSession(ve,Se,Ue)},onDidReceiveDebugSessionCustomEvent(ve,Se,Ue){return rt.onDidReceiveDebugSessionCustomEvent(ve,Se,Ue)},onDidChangeBreakpoints(ve,Se,Ue){return rt.onDidChangeBreakpoints(ve,Se,Ue)},registerDebugConfigurationProvider(ve,Se,Ue){return rt.registerDebugConfigurationProvider(ve,Se,Ue||Ke.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ve,Se){return rt.registerDebugAdapterDescriptorFactory($e,ve,Se)},registerDebugAdapterTrackerFactory(ve,Se){return rt.registerDebugAdapterTrackerFactory(ve,Se)},startDebugging(ve,Se,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?rt.startDebugging(ve,Se,{parentSession:Ue}):rt.startDebugging(ve,Se,Ue||{})},stopDebugging(ve){return rt.stopDebugging(ve)},addBreakpoints(ve){return rt.addBreakpoints(ve)},removeBreakpoints(ve){return rt.removeBreakpoints(ve)},asDebugSourceUri(ve,Se){return rt.asDebugSourceUri(ve,Se)}},an={registerTaskProvider:(ve,Se)=>Et.registerTaskProvider($e,ve,Se),fetchTasks:ve=>Et.fetchTasks(ve),executeTask:ve=>Et.executeTask($e,ve),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(ve,Se,Ue)=>Et.onDidStartTask(ve,Se,Ue),onDidEndTask:(ve,Se,Ue)=>Et.onDidEndTask(ve,Se,Ue),onDidStartTaskProcess:(ve,Se,Ue)=>Et.onDidStartTaskProcess(ve,Se,Ue),onDidEndTaskProcess:(ve,Se,Ue)=>Et.onDidEndTaskProcess(ve,Se,Ue)},Hn={createNotebookController(ve,Se,Ue,ct,Dt){return tn.createNotebookController($e,ve,Se,Ue,ct,(0,Me.isProposedApiEnabled)($e,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ve,Se)=>yt.registerNotebookCellStatusBarItemProvider($e,ve,Se),createRendererMessaging(ve){return un.createRendererMessaging($e,ve)},onDidChangeNotebookCellExecutionState(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)($e,"notebookCellExecutionState"),tn.onDidChangeNotebookCellExecutionState(ve,Se,Ue)}},Bt={t(...ve){if(typeof ve[0]=="string"){const Se=ve.shift(),Ue=!ve||typeof ve[0]!="object"?ve:ve[0];return It.getMessage($e.identifier.value,{message:Se,args:Ue})}return It.getMessage($e.identifier.value,ve[0])},get bundle(){return It.getBundle($e.identifier.value)},get uri(){return It.getBundleUri($e.identifier.value)}};return{version:it.version,authentication:Cn,commands:Mn,comments:$n,debug:Vt,env:Rn,extensions:Bn,l10n:Bt,languages:zn,notebooks:Hn,scm:Dn,tasks:an,tests:Un,window:Wn,workspace:Ln,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:l.CancellationTokenSource,CandidatePortSource:E.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CommentThreadState:F.CommentThreadState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ke.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:F.InlineCompletionTriggerKindNew,EventEmitter:I.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:C.FileType,FilePermission:C.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionItemNew:F.InlineSuggestionNew,InlineCompletionList:F.InlineSuggestionList,InlineCompletionListNew:F.InlineSuggestionsNew,Hover:F.Hover,IndentAction:k.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalLocation:F.TerminalLocation,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,SnippetTextEdit:F.SnippetTextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItem2:F.TreeItem,TreeItemCheckboxState:F.TreeItemCheckboxState,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:T.UIKind,Uri:y.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,DocumentDropEdit:F.DocumentDropEdit,DocumentPasteEdit:F.DocumentPasteEdit,InlayHint:F.InlayHint,InlayHintLabelPart:F.InlayHintLabelPart,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,NotebookControllerAffinity2:F.NotebookControllerAffinity2,NotebookEdit:F.NotebookEdit,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestTag:F.TestTag,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:at.TextSearchCompleteMessageType,DataTransfer:F.DataTransfer,DataTransferItem:F.DataTransferItem,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity,QuickPickItemKind:F.QuickPickItemKind,InputBoxValidationSeverity:F.InputBoxValidationSeverity,TabInputText:F.TextTabInput,TabInputTextDiff:F.TextDiffTabInput,TabInputTextMerge:F.TextMergeTabInput,TabInputCustom:F.CustomEditorTabInput,TabInputNotebook:F.NotebookEditorTabInput,TabInputNotebookDiff:F.NotebookDiffEditorTabInput,TabInputWebview:F.WebviewEditorTabInput,TabInputTerminal:F.TerminalEditorTabInput,TabInputInteractiveWindow:F.InteractiveWindowInput,TerminalExitReason:F.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=st}),define(Ce[298],De([1,0,270,307,308,2,309]),function(J,e,l,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function D(C,E,T,S,p,b){const f=b.environment.useHostProxy,v=typeof f=="boolean"?f:!b.remote.isRemote,h=(0,y.createProxyResolver)({resolveProxy:g=>C.resolveProxy(g),getHttpProxySetting:()=>E.getConfiguration("http").get("proxy"),log:(g,i,...u)=>{switch(g){case y.LogLevel.Trace:S.trace(i,...u);break;case y.LogLevel.Debug:S.debug(i,...u);break;case y.LogLevel.Info:S.info(i,...u);break;case y.LogLevel.Warning:S.warn(i,...u);break;case y.LogLevel.Error:S.error(i,...u);break;case y.LogLevel.Critical:S.critical(i,...u);break;case y.LogLevel.Off:break;default:r(g,i,u);break}function r(n,o,...d){S.error("Unknown log level",n),S.error(o,...d)}},getLogLevel:()=>S.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:v,env:process.env}),c=w(E,h);return L(T,c)}e.connectProxyResolver=D;function w(C,E){const T={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(p=>{T.config=C.getConfiguration("http").get("proxySupport")||"off"});const S={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(p=>{S.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},l,(0,y.createHttpPatch)(l,E,{config:"off"},S,!0)),on:Object.assign({},l,(0,y.createHttpPatch)(l,E,{config:"on"},S,!0)),override:Object.assign({},l,(0,y.createHttpPatch)(l,E,{config:"override"},S,!0)),onRequest:Object.assign({},l,(0,y.createHttpPatch)(l,E,T,S,!0)),default:Object.assign(l,(0,y.createHttpPatch)(l,E,T,S,!1))},https:{off:Object.assign({},t,(0,y.createHttpPatch)(t,E,{config:"off"},S,!0)),on:Object.assign({},t,(0,y.createHttpPatch)(t,E,{config:"on"},S,!0)),override:Object.assign({},t,(0,y.createHttpPatch)(t,E,{config:"override"},S,!0)),onRequest:Object.assign({},t,(0,y.createHttpPatch)(t,E,T,S,!0)),default:Object.assign(t,(0,y.createHttpPatch)(t,E,T,S,!1))},tls:Object.assign(I,(0,y.createTlsPatch)(I))}}const k=new Map;function L(C,E){return C.getExtensionPathIndex().then(T=>{const S=J.__$__nodeRequire("module"),p=S._load;S._load=function(f,v,h){if(f==="tls")return E.tls;if(f!=="http"&&f!=="https")return p.apply(this,arguments);const c=E[f],g=T.findSubstr(P.URI.file(v.filename));let i=k.get(g);if(i||k.set(g,i={}),!i[f]){const u=c.default;i[f]={...u}}return i[f]}})}}),define(Ce[299],De([1,0,73,297,284,298,41,272,2,14,7,269,111,271]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class S extends I.RequireInterceptor{_installInterceptor(){const f=this,v=J.__$__nodeRequire("module"),h=v._load;v._load=function(u,r,n){return u=g(u),f._factories.has(u)?f._factories.get(u).load(u,w.URI.file((0,E.realpathSync)(r.filename)),o=>h.apply(this,[o,r,n])):h.apply(this,arguments)};const c=v._resolveLookupPaths;v._resolveLookupPaths=(i,u)=>c.call(this,g(i),u);const g=i=>{for(const u of f._alternatives){const r=u(i);if(r){i=r;break}}return i}}}class p extends y.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(T.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const c=this._instaService.createInstance(C.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}await this._instaService.createInstance(S,f,{mine:this._myRegistry,all:this._globalRegistry}).install(),l.mark("code/extHost/didInitAPI");const h=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,h,this,this._logService,this._mainThreadTelemetryProxy,this._initData),l.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(f){return f.main}async _loadCommonJSModule(f,v,h){if(v.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${v}', must be of file-scheme`);let c=null;h.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${v.toString(!0)}`),this._logService.flush();const g=f?.identifier.value;f&&await this._extHostLocalizationService.initializeLocalizedMessages(f);try{g&&l.mark(`code/extHost/willLoadExtensionCode/${g}`),c=J.__$__nodeRequire(v.fsPath)}finally{g&&l.mark(`code/extHost/didLoadExtensionCode/${g}`),h.codeLoadingStop()}return c}async $setRemoteEnvironment(f){if(!!this._initData.remote.isRemote)for(const v in f){const h=f[v];h===null?delete process.env[v]:process.env[v]=h}}}e.ExtHostExtensionService=p}),define(Ce[142],De([1,0,44,310,293,17,77,37,9,8,2,30,71,311,291,95]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const b=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(m){this.outputChannel=m}provideTextSearchResults(m,_,R,M){return this.outputChannel.appendLine(`provideTextSearchResults ${m.pattern}, ${JSON.stringify({..._,folder:_.folder.toString()})}`),new Promise((U,A)=>{M.onCancellationRequested(()=>H());const z=u(m,_),$=_.folder.fsPath,N=z.map(he=>he.match(/^-/)?he:`'${he}'`).join(" ");this.outputChannel.appendLine(`${b} ${N}
 - cwd: ${$}`);let V=l.spawn(b,z,{cwd:$});V.on("error",he=>{console.error(he),this.outputChannel.appendLine("Error: "+(he&&he.message)),A((0,C.serializeSearchError)(new C.SearchError(he&&he.message,C.SearchErrorCode.rgProcessError)))});let B=!1;const F=new c(_.maxResults,$,_.previewOptions);F.on("result",he=>{B=!0,K="",R.report(he)});let x=!1;const H=()=>{x=!0,V?.kill(),F?.cancel()};let Q=!1;F.on("hitLimit",()=>{Q=!0,H()});let K="";V.stdout.on("data",he=>{F.handleData(he),B||(K+=he)});let de=!1;V.stdout.once("data",()=>de=!0);let ee="";V.stderr.on("data",he=>{const Y=he.toString();this.outputChannel.appendLine(Y),ee.length+Y.length<1e6&&(ee+=Y)}),V.on("close",()=>{if(this.outputChannel.appendLine(de?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(B?"Got result from parser":"No result from parser"),K&&this.outputChannel.appendLine(`Got data without result: ${K}`),this.outputChannel.appendLine(""),x)U({limitHit:Q});else{F.flush(),V=null;let he;ee&&!de&&(he=v(ee))?A((0,C.serializeSearchError)(new C.SearchError(he.message,he.code))):U({limitHit:Q})}})})}}e.RipgrepTextSearchEngine=f;function v(a){const m=a.split(`
`),_=m[0].trim();if(m.some(M=>M.startsWith("regex parse error")))return new C.SearchError(h(m),C.SearchErrorCode.regexParseError);const R=_.match(/grep config error: unknown encoding: (.*)/);if(R)return new C.SearchError(`Unknown encoding: ${R[1]}`,C.SearchErrorCode.unknownEncoding);if(_.startsWith("error parsing glob"))return new C.SearchError(_.charAt(0).toUpperCase()+_.substr(1),C.SearchErrorCode.globParseError);if(_.startsWith("the literal"))return new C.SearchError(_.charAt(0).toUpperCase()+_.substr(1),C.SearchErrorCode.invalidLiteral);if(_.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(_,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=v;function h(a){const m=["Regex parse error"],_=a.filter(R=>R.startsWith("PCRE2:"));if(_.length>=1){const R=_[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const M=R.split(":")[1];m.push(":"+M)}}return m.join("")}e.buildRegexParseError=h;class c extends t.EventEmitter{constructor(m,_,R){super(),this.maxResults=m,this.rootFolder=_,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(m,_){return super.on(m,_),this}handleData(m){if(this.isDone)return;const _=typeof m=="string"?m:this.stringDecoder.write(m);this.handleDecodedData(_)}handleDecodedData(m){let _=m.indexOf(`
`);const R=this.remainder+m;if(_>=0)_+=this.remainder.length;else{this.remainder=R;return}let M=0;for(;_>=0;)this.handleLine(R.substring(M,_).trim()),M=_+1,_=R.indexOf(`
`,M);this.remainder=R.substring(M)}handleLine(m){if(this.isDone||!m)return;let _;try{_=JSON.parse(m)}catch{throw new Error(`malformed line from rg: ${m}`)}if(_.type==="match"){const R=g(_.data.path),M=L.URI.file(w.join(this.rootFolder,R)),U=this.createTextSearchMatch(_.data,M);this.onResult(U),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(_.type==="context"){const R=g(_.data.path),M=L.URI.file(w.join(this.rootFolder,R));this.createTextSearchContext(_.data,M).forEach(A=>this.onResult(A))}}createTextSearchMatch(m,_){const R=m.line_number-1,M=g(m.lines),U=Buffer.from(M);let A=0,z=0,$=R;m.submatches.length===0&&m.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const N=(0,P.coalesce)(m.submatches.map((V,B)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const F=g(V.match),x=U.slice(A,V.start).toString(),H=i(x),Q=H.numLines>0?H.lastLineLength:H.lastLineLength+z,K=i(F),de=H.numLines+$,ee=K.numLines+de,he=K.numLines>0?K.lastLineLength:K.lastLineLength+Q;return A=V.end,z=he,$=ee,new E.Range(de,Q,ee,he)}));return(0,p.createTextSearchResult)(_,M,N,this.previewOptions)}createTextSearchContext(m,_){const R=g(m.lines),M=m.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((U,A)=>({text:U,uri:_,lineNumber:M+A}))}onResult(m){this.emit("result",m)}}e.RipgrepParser=c;function g(a){return a.bytes?Buffer.from(a.bytes,"base64").toString():a.text}function i(a){const m=/\n/g;let _=0,R=-1,M;for(;M=m.exec(a);)_++,R=M.index;const U=R>=0?a.length-R-1:a.length;return{numLines:_,lastLineLength:U}}function u(a,m){const _=["--hidden"];_.push(a.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:M}=(0,y.groupBy)(m.includes,A=>A.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const A=new Set;M.forEach(z=>{A.add(z)}),_.push("-g","!*"),A.forEach(z=>{r(z).map(p.anchorGlob).forEach($=>{_.push("-g",$)})})}R&&R.length&&R.forEach(A=>{_.push("-g",A)}),m.excludes.map(p.anchorGlob).forEach(A=>_.push("-g",`!${A}`)),m.maxFileSize&&_.push("--max-filesize",m.maxFileSize+""),m.useIgnoreFiles?m.useParentIgnoreFiles||_.push("--no-ignore-parent"):_.push("--no-ignore"),m.followSymlinks&&_.push("--follow"),m.encoding&&m.encoding!=="utf8"&&_.push("--encoding",m.encoding),a.pattern==="--"&&(a.isRegExp=!0,a.pattern="\\-\\-"),a.isMultiline&&!a.isRegExp&&(a.pattern=(0,k.escapeRegExpCharacters)(a.pattern),a.isRegExp=!0),m.usePCRE2&&_.push("--pcre2"),_.push("--crlf"),a.isRegExp&&(a.pattern=n(a.pattern),_.push("--engine","auto"));let U;if(a.isWordMatch){const z=(0,k.createRegExp)(a.pattern,!!a.isRegExp,{wholeWord:a.isWordMatch}).source.replace(/\\\//g,"/");_.push("--regexp",z)}else if(a.isRegExp){let A=d(a.pattern);A=s(A),_.push("--regexp",A)}else U=a.pattern,_.push("--fixed-strings");return _.push("--no-config"),m.useGlobalIgnoreFiles||_.push("--no-ignore-global"),_.push("--json"),a.isMultiline&&_.push("--multiline"),m.beforeContext&&_.push("--before-context",m.beforeContext+""),m.afterContext&&_.push("--after-context",m.afterContext+""),_.push("--"),U&&_.push(U),_.push("."),_}function r(a){const m=(0,D.splitGlobAware)(a,"/");return m.map((_,R)=>m.slice(0,R+1).join("/"))}e.spreadGlobComponents=r;function n(a){const m=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;a.match(m);)a=a.replace(m,"$1\\x{$2}");const _=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;a.match(_);)a=a.replace(_,"$1\\x{$2}");return a}e.unicodeEscapesToPCRE2=n;const o=a=>a.type==="Assertion"&&a.kind==="lookbehind";function d(a){let m;try{m=new T.RegExpParser().parsePattern(a)}catch{return a}let _="",R=0;const M=(z,$,N)=>{_+=a.slice(R,z)+N,R=$},U=[];return new T.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const $=U[0];if(!$)M(z.start,z.end,"\\r?\\n");else if(!U.some(o))if($.type==="CharacterClass")if($.negate){const N=a.slice($.start+2,z.start)+a.slice(z.end,$.end-1);$.parent?.type==="Quantifier"?M($.start,$.end,N?`[^${N}]`:"."):M($.start,$.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=a.slice($.start+1,z.start)+a.slice(z.end,$.end-1);M($.start,$.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else $.type==="Quantifier"&&M(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){U.unshift(z)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(z){U.unshift(z)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(z){U.unshift(z)},onCharacterClassLeave(){U.shift()},onAssertionEnter(z){o(z)&&U.push(z)},onAssertionLeave(z){U[0]===z&&U.shift()}}).visit(m),_+=a.slice(R),_}e.fixRegexNewline=d;function s(a){return a.replace(/\n/g,"\\r?\\n")}e.fixNewline=s}),define(Ce[300],De([1,0,21,142,122,14]),function(J,e,l,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,L,C,E){const T=new t.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===P.Schemas.vscodeUserData){const S={...L,folder:L.folder.with({scheme:P.Schemas.file})},p=new I.Progress(b=>C.report({...b,uri:b.uri.with({scheme:L.folder.scheme})}));return this.withToken(E,b=>T.provideTextSearchResults(k,S,p,b))}else return this.withToken(E,S=>T.provideTextSearchResults(k,L,C,S))}async withToken(k,L){const C=D(k);this.inProgress.add(C);const E=await L(C.token);return this.inProgress.delete(C),E}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=y;function D(w){const k=new l.CancellationTokenSource;return w.onCancellationRequested(()=>k.cancel()),k}}),define(Ce[301],De([1,0,29,142,141]),function(J,e,l,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(w){this.query=w}search(w,k,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(T){L({message:T})}},E=new I.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(C),l);return new Promise((T,S)=>E.search(p=>{k(p.map(y))},w).then(p=>T({limitHit:p.limitHit,type:"success",stats:p.stats}),S))}}e.TextSearchEngineAdapter=P;function y(D){return{path:D.resource&&D.resource.fsPath,results:D.results,numMatches:(D.results||[]).reduce((w,k)=>{if(k.ranges){const L=k;return w+(Array.isArray(L.ranges)?L.ranges.length:1)}else return w+1},0)}}}),define(Ce[302],De([1,0,17,18,11,4,107,9,51,2,38,30,292,301]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class S{constructor(c="searchProcess"){this.processType=c,this.caches=Object.create(null)}fileSearch(c){let g;const i=f(c),u=new P.Emitter({onFirstListenerDidAdd:()=>{g=(0,t.createCancelablePromise)(r=>this.doFileSearchWithEngine(E.Engine,i,n=>u.fire(n),r)),g.then(r=>u.fire(r),r=>u.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return u.event}textSearch(c){let g;const i=f(c),u=new P.Emitter({onFirstListenerDidAdd:()=>{g=(0,t.createCancelablePromise)(r=>this.ripgrepTextSearch(i,n=>u.fire(n),r)),g.then(r=>u.fire(r),r=>u.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return u.event}ripgrepTextSearch(c,g,i){return c.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new T.TextSearchEngineAdapter(c).search(i,g,g)}doFileSearch(c,g,i){return this.doFileSearchWithEngine(E.Engine,c,g,i)}doFileSearchWithEngine(c,g,i,u,r=S.BATCH_SIZE){let n=0;const o=s=>{Array.isArray(s)?(n+=s.length,i(s.map(a=>this.rawMatchToSearchItem(a)))):s.relativePath?(n++,i(this.rawMatchToSearchItem(s))):i(s)};if(g.sortByScore){let s=this.trySortedSearchFromCache(g,o,u);if(!s){const a=g.maxResults?Object.assign({},g,{maxResults:null}):g,m=new c(a);s=this.doSortedSearch(m,g,i,o,u)}return new Promise((a,m)=>{s.then(([_,R])=>{const M=R.map(U=>this.rawMatchToSearchItem(U));this.sendProgress(M,i,r),a(_)},m)})}const d=new c(g);return this.doSearch(d,o,r,u).then(s=>({limitHit:s.limitHit,type:"success",stats:{detailStats:s.stats,type:this.processType,fromCache:!1,resultCount:n,sortingTime:void 0}}))}rawMatchToSearchItem(c){return{path:c.base?(0,D.join)(c.base,c.relativePath):c.relativePath}}doSortedSearch(c,g,i,u,r){const n=new P.Emitter;let o=(0,t.createCancelablePromise)(s=>{let a=[];const m=_=>{Array.isArray(_)?a=_:(u(_),n.fire(_))};return this.doSearch(c,m,-1,s).then(_=>[_,a])}),d;if(g.cacheKey){d=this.getOrCreateCache(g.cacheKey);const s={promise:o,event:n.event,resolved:!1};d.resultsToSearchCache[g.filePattern||""]=s,o.then(()=>{s.resolved=!0},a=>{delete d.resultsToSearchCache[g.filePattern||""]}),o=this.preventCancellation(o)}return o.then(([s,a])=>{const m=d?d.scorerCache:Object.create(null),_=(typeof g.maxResults!="number"||g.maxResults>0)&&w.StopWatch.create(!1);return this.sortResults(g,a,m,r).then(R=>{const M=_?_.elapsed():-1;return[{type:"success",stats:{detailStats:s.stats,sortingTime:M,fromCache:!1,type:this.processType,workspaceFolderCount:g.folderQueries.length,resultCount:R.length},messages:s.messages,limitHit:s.limitHit||typeof g.maxResults=="number"&&a.length>g.maxResults},R]})})}getOrCreateCache(c){const g=this.caches[c];return g||(this.caches[c]=new p)}trySortedSearchFromCache(c,g,i){const u=c.cacheKey&&this.caches[c.cacheKey];if(!u)return;const r=this.getResultsFromCache(u,c.filePattern||"",g,i);if(r)return r.then(([n,o,d])=>{const s=w.StopWatch.create(!1);return this.sortResults(c,o,u.scorerCache,i).then(a=>{const m=s.elapsed(),_={fromCache:!0,detailStats:d,type:this.processType,resultCount:o.length,sortingTime:m};return[{type:"success",limitHit:n.limitHit||typeof c.maxResults=="number"&&o.length>c.maxResults,stats:_},a]})})}sortResults(c,g,i,u){const r=(0,y.prepareQuery)(c.filePattern||""),n=(d,s)=>(0,y.compareItemsByFuzzyScore)(d,s,r,!0,b,i),o=typeof c.maxResults=="number"?c.maxResults:Number.MAX_VALUE;return l.topAsync(g,n,o,1e4,u)}sendProgress(c,g,i){if(i&&i>0)for(let u=0;u<c.length;u+=i)g(c.slice(u,u+i));else g(c)}getResultsFromCache(c,g,i,u){const r=w.StopWatch.create(!1),n=g.indexOf(D.sep)>=0;let o;for(const m in c.resultsToSearchCache)if(g.startsWith(m)){if(n&&m.indexOf(D.sep)<0&&m!=="")continue;const _=c.resultsToSearchCache[m];o={promise:this.preventCancellation(_.promise),event:_.event,resolved:_.resolved};break}if(!o)return null;const d=r.elapsed(),s=w.StopWatch.create(!1),a=o.event(i);return u&&u.onCancellationRequested(()=>{a.dispose()}),o.promise.then(([m,_])=>{if(u&&u.isCancellationRequested)throw(0,I.canceled)();const R=[],M=(0,y.prepareQuery)(g).normalizedLowercase;for(const U of _)!(0,C.isFilePatternMatch)(U,M)||R.push(U);return[m,R,{cacheWasResolved:o.resolved,cacheLookupTime:d,cacheFilterTime:s.elapsed(),cacheEntryCount:_.length}]})}doSearch(c,g,i,u){return new Promise((r,n)=>{let o=[];u?.onCancellationRequested(()=>c.cancel()),c.search(d=>{d&&(i?(o.push(d),i>0&&o.length>=i&&(g(o),o=[])):g(d))},d=>{g(d)},(d,s)=>{o.length&&g(o),d?n(d):r(s)})})}clearCache(c){return delete this.caches[c],Promise.resolve(void 0)}preventCancellation(c){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,i){return c.then(g,i)}catch(g){return this.then(void 0,g)}finally(g){return c.finally(g)}}}}e.SearchService=S,S.BATCH_SIZE=512;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(h){return(0,D.basename)(h.relativePath)}getItemDescription(h){return(0,D.dirname)(h.relativePath)}getItemPath(h){return h.relativePath}};function f(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(v),extraFileResources:h.extraFileResources&&h.extraFileResources.map(c=>k.URI.revive(c))}}function v(h){return{...h,folder:k.URI.revive(h.folder)}}}),define(Ce[303],De([1,0,6,14,2,29,12,25,16,75,54,30,302,300,95,141]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let b=class extends k.ExtHostSearch{constructor(v,h,c,g){super(v,c,g),this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const i=new S.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new T.RipgrepSearchProvider(i)),h.remote.isRemote&&h.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const v=new S.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new T.RipgrepSearchProvider(v)),this.registerInternalFileSearchProvider(t.Schemas.file,new E.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(v,h){const c=this._handlePool++;return this._internalFileSearchProvider=h,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(v)),(0,l.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(v,h,c,g){const i=(0,k.reviveQuery)(c);return v===this._internalFileSearchHandle?this.doInternalFileSearch(v,h,i,g):super.$provideFileSearchResults(v,h,c,g)}doInternalFileSearch(v,h,c,g){const i=u=>{if((0,C.isSerializedFileMatch)(u)&&(u=[u]),Array.isArray(u)){this._proxy.$handleFileMatch(v,h,u.map(r=>I.URI.file(r.path)));return}u.message&&this._logService.debug("ExtHostSearch",u.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,i,g)}$clearCache(v){return this._internalFileSearchProvider?.clearCache(v),super.$clearCache(v)}createTextSearchManager(v,h){return new p.NativeTextSearchManager(v,h,void 0,"textSearchProvider")}};b=je([He(0,w.IExtHostRpcService),He(1,D.IExtHostInitDataService),He(2,L.IURITransformerService),He(3,y.ILogService)],b),e.NativeExtHostSearch=b}),define(Ce[304],De([1,0,83,275,287,286,303,299,276,74,41,75,72,40,53,69,274,273,12,288,47]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(L.IExtHostExtensionService,D.ExtHostExtensionService,!1),(0,l.registerSingleton)(v.ILoggerService,f.ExtHostLoggerService,1),(0,l.registerSingleton)(p.IExtensionStoragePaths,b.ExtensionStoragePaths,!1),(0,l.registerSingleton)(k.IExtHostDebugService,P.ExtHostDebugService,!1),(0,l.registerSingleton)(C.IExtHostSearch,y.NativeExtHostSearch,!1),(0,l.registerSingleton)(E.IExtHostTask,I.ExtHostTask,!1),(0,l.registerSingleton)(T.IExtHostTerminalService,t.ExtHostTerminalService,!1),(0,l.registerSingleton)(S.IExtHostTunnelService,w.ExtHostTunnelService,!1),(0,l.registerSingleton)(c.IExtHostVariableResolverProvider,h.NodeExtHostVariableResolverProviderService,!1)}),define(Ce[312],De([1,0,216,313,73,11,114,115,196,91,285,23,29,111,18,117,211,225,289,304]),function(J,e,l,t,I,P,y,D,w,k,L,C,E,T,S,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let d=0;d<process.execArgv.length;d++)process.execArgv[d]==="--inspect-port=0"&&(process.execArgv.splice(d,1),d--)}();const v=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const o=J.__$__nodeRequire("module"),d=o._load;o._load=function(s){if(s==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return d.apply(this,arguments)}})();const h=process.exit.bind(process);function c(o){process.exit=function(d){if(o)h(d);else{const s=new Error("An extension called process.exit() and this was prevented.");console.warn(s.stack)}},process.crash=function(){const d=new Error("An extension called process.crash() and this was prevented.");console.warn(d.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let g=function(o){h()};function i(){const o=(0,f.readExtHostConnection)(process.env);if(o.type===3)return new Promise((d,s)=>{const a=m=>{const _=m[0],R=new y.BufferedEmitter;_.on("message",M=>R.fire(C.VSBuffer.wrap(M.data))),_.on("close",()=>{g("renderer closed the MessagePort")}),_.start(),d({onMessage:R.event,send:M=>_.postMessage(M.buffer)})};if(global.vscodePorts){const m=global.vscodePorts;delete global.vscodePorts,a(m)}else global.vscodePortsCallback=a});if(o.type===2)return new Promise((d,s)=>{let a=null;const m=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),_=108e5,R=3e5,M=new S.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (1)"),_),U=new S.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (2)"),R);process.on("message",(z,$)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){$.setNoDelay(!0);const N=C.VSBuffer.wrap(Buffer.from(z.initialDataChunk,"base64"));let V;if(z.skipWebSocketFrames)V=new D.NodeSocket($,"extHost-socket");else{const B=C.VSBuffer.wrap(Buffer.from(z.inflateBytes,"base64"));V=new D.WebSocketNodeSocket(new D.NodeSocket($,"extHost-socket"),z.permessageDeflate,B,!1)}a?(M.cancel(),U.cancel(),a.beginAcceptReconnection(V,N),a.endAcceptReconnection(),a.sendResume()):(clearTimeout(m),a=new y.PersistentProtocol(V,N),a.sendResume(),a.onDidDispose(()=>g("renderer disconnected")),d(a),a.onSocketClose(()=>{M.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(U.isScheduled())return;M.isScheduled()&&U.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(A)});{const d=o.pipeName;return new Promise((s,a)=>{const m=l.createConnection(d,()=>{m.removeListener("error",a);const _=new y.PersistentProtocol(new D.NodeSocket(m,"extHost-renderer"));_.sendResume(),s(_)});m.once("error",a),m.on("close",()=>{g("renderer closed the socket")})})}}async function u(){const o=await i();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,o.onMessage(d=>{(0,k.isMessageOfType)(d,2)?(this._terminating=!0,g("received terminate message from renderer")):this._onMessage.fire(d)})}send(d){this._terminating||o.send(d)}async drain(){if(o.drain)return o.drain()}}}function r(o){return new Promise(d=>{const s=o.onMessage(a=>{s.dispose();const m=JSON.parse(a.toString()),_=m.commit,R=w.default.commit;if(_&&R&&_!==R&&h(55),m.parentPid){let M=0;setInterval(function(){try{process.kill(m.parentPid,0),M=0}catch(A){A&&A.code==="EPERM"?(M++,M>=3&&g(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${A.message} (code: ${A.code}) (errno: ${A.errno})`)):g(`parent process ${m.parentPid} does not exist anymore: ${A.message} (code: ${A.code}) (errno: ${A.errno})`)}},1e3);let U;try{U=J.__$__nodeRequire("native-watchdog"),U.start(m.parentPid)}catch(A){(0,P.onUnexpectedError)(A)}}o.send((0,k.createMessageOfType)(0)),d({protocol:o,initData:m})});o.send((0,k.createMessageOfType)(1))})}async function n(){const o=[];process.on("unhandledRejection",(M,U)=>{o.push(U),setTimeout(()=>{const A=o.indexOf(U);A>=0&&U.catch(z=>{o.splice(A,1),(0,P.isCancellationError)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),M&&(0,P.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const U=o.indexOf(M);U>=0&&o.splice(U,1)}),process.on("uncaughtException",function(M){(0,P.onUnexpectedError)(M)}),I.mark("code/extHost/willConnectToRenderer");const d=await u();I.mark("code/extHost/didConnectToRenderer");const s=await r(d);I.mark("code/extHost/didWaitForInitData");const{initData:a}=s;c(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=v.useHostProxy!==void 0?v.useHostProxy!=="false":void 0,a.environment.skipWorkspaceStorageLock=(0,p.boolean)(v.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(U){h(U)}exists(U){return E.Promises.exists(U)}realpath(U){return(0,T.realpath)(U)}};let _=null;a.remote.authority&&v.transformURIs&&(_=(0,b.createURITransformer)(a.remote.authority));const R=new L.ExtensionHostMain(s.protocol,a,m,_);g=M=>R.terminate(M)}e.startExtensionHostProcess=n,n().catch(o=>console.log(o))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a8108049ab61b970f2ec1839dfb753054e07395e/core/vs/workbench/api/node/extensionHostProcess.js.map
