/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/base/common/assert","vs/base/common/process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/observableValue","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ie=function(ne){for(var e=[],r=0,C=ne.length;r<C;r++)e[r]=Ce[ne[r]];return e};define(Ce[75],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function r(y,A){const E=Object.create(null);for(const P of y){const R=A(P);let b=E[R];b||(b=E[R]=[]),b.push(P)}return E}e.groupBy=r;function C(y,A){const E=[],P=[];for(const R of y)A.has(R)||E.push(R);for(const R of A)y.has(R)||P.push(R);return{removed:E,added:P}}e.diffSets=C;function w(y,A){const E=[],P=[];for(const[R,b]of y)A.has(R)||E.push(b);for(const[R,b]of A)y.has(R)||P.push(b);return{removed:E,added:P}}e.diffMaps=w;class F{constructor(){this.map=new Map}add(A,E){let P=this.map.get(A);P||(P=new Set,this.map.set(A,P)),P.add(E)}delete(A,E){const P=this.map.get(A);!P||(P.delete(E),P.size===0&&this.map.delete(A))}forEach(A,E){const P=this.map.get(A);!P||P.forEach(E)}}e.SetMap=F}),define(Ce[57],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function r(y){return(A,E,P)=>{let R=null,b=null;if(typeof P.value=="function"?(R="value",b=P.value):typeof P.get=="function"&&(R="get",b=P.get),!b)throw new Error("not supported");P[R]=y(b,E)}}e.createDecorator=r;function C(y,A,E){let P=null,R=null;if(typeof E.value=="function"?(P="value",R=E.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(P="get",R=E.get),!R)throw new Error("not supported");const b=`$memoize$${A}`;E[P]=function(...g){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,g)}),this[b]}}e.memoize=C;function w(y,A,E){return r((P,R)=>{const b=`$debounce$${R}`,g=`$debounce$result$${R}`;return function(...I){this[g]||(this[g]=E?E():void 0),clearTimeout(this[b]),A&&(this[g]=A(this[g],...I),I=[this[g]]),this[b]=setTimeout(()=>{P.apply(this,I),this[g]=E?E():void 0},y)}})}e.debounce=w;function F(y,A,E){return r((P,R)=>{const b=`$throttle$timer$${R}`,g=`$throttle$result$${R}`,I=`$throttle$lastRun$${R}`,p=`$throttle$pending$${R}`;return function(...a){if(this[g]||(this[g]=E?E():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),A&&(this[g]=A(this[g],...a)),this[p])return;const l=this[I]+y;l<=Date.now()?(this[I]=Date.now(),P.apply(this,[this[g]]),this[g]=E?E():void 0):(this[p]=!0,this[b]=setTimeout(()=>{this[p]=!1,this[I]=Date.now(),P.apply(this,[this[g]]),this[g]=E?E():void 0},l-Date.now()))}})}e.throttle=F}),define(Ce[76],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(Ce[105],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r=e.ScanError||(e.ScanError={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var F;(function(t){t.DEFAULT={allowTrailingComma:!0}})(F=e.ParseOptions||(e.ParseOptions={}));function y(t,u=!1){let i=0;const n=t.length;let s="",h=0,o=16,f=0;function v(L){let O=0,H=0;for(;O<L;){const W=t.charCodeAt(i);if(W>=48&&W<=57)H=H*16+W-48;else if(W>=65&&W<=70)H=H*16+W-65+10;else if(W>=97&&W<=102)H=H*16+W-97+10;else break;i++,O++}return O<L&&(H=-1),H}function T(L){i=L,s="",h=0,o=16,f=0}function M(){const L=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&P(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&P(t.charCodeAt(i)))for(i++;i<t.length&&P(t.charCodeAt(i));)i++;else return f=3,t.substring(L,i);let O=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&P(t.charCodeAt(i))){for(i++;i<t.length&&P(t.charCodeAt(i));)i++;O=i}else f=3;return t.substring(L,O)}function j(){let L="",O=i;for(;;){if(i>=n){L+=t.substring(O,i),f=2;break}const H=t.charCodeAt(i);if(H===34){L+=t.substring(O,i),i++;break}if(H===92){if(L+=t.substring(O,i),i++,i>=n){f=2;break}switch(t.charCodeAt(i++)){case 34:L+='"';break;case 92:L+="\\";break;case 47:L+="/";break;case 98:L+="\b";break;case 102:L+="\f";break;case 110:L+=`
`;break;case 114:L+="\r";break;case 116:L+="	";break;case 117:{const z=v(4);z>=0?L+=String.fromCharCode(z):f=4;break}default:f=5}O=i;continue}if(H>=0&&H<=31)if(E(H)){L+=t.substring(O,i),f=2;break}else f=6;i++}return L}function U(){if(s="",f=0,h=i,i>=n)return h=n,o=17;let L=t.charCodeAt(i);if(A(L)){do i++,s+=String.fromCharCode(L),L=t.charCodeAt(i);while(A(L));return o=15}if(E(L))return i++,s+=String.fromCharCode(L),L===13&&t.charCodeAt(i)===10&&(i++,s+=`
`),o=14;switch(L){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,s=j(),o=10;case 47:{const O=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!E(t.charCodeAt(i));)i++;return s=t.substring(O,i),o=12}if(t.charCodeAt(i+1)===42){i+=2;const H=n-1;let W=!1;for(;i<H;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,W=!0;break}i++}return W||(i++,f=1),s=t.substring(O,i),o=13}return s+=String.fromCharCode(L),i++,o=16}case 45:if(s+=String.fromCharCode(L),i++,i===n||!P(t.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=M(),o=11;default:for(;i<n&&D(L);)i++,L=t.charCodeAt(i);if(h!==i){switch(s=t.substring(h,i),s){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return s+=String.fromCharCode(L),i++,o=16}}function D(L){if(A(L)||E(L))return!1;switch(L){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function $(){let L;do L=U();while(L>=12&&L<=15);return L}return{setPosition:T,getPosition:()=>i,scan:u?$:U,getToken:()=>o,getTokenValue:()=>s,getTokenOffset:()=>h,getTokenLength:()=>i-h,getTokenError:()=>f}}e.createScanner=y;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function b(t,u){const i=[],n=new Object;let s;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function f(v,T,M,j){h.value=v,h.offset=T,h.length=M,h.type=j,h.colonOffset=void 0,s=h}try{S(t,{onObjectBegin:(v,T)=>{if(u<=v)throw n;s=void 0,o=u>v,i.push("")},onObjectProperty:(v,T,M)=>{if(u<T||(f(v,T,M,"property"),i[i.length-1]=v,u<=T+M))throw n},onObjectEnd:(v,T)=>{if(u<=v)throw n;s=void 0,i.pop()},onArrayBegin:(v,T)=>{if(u<=v)throw n;s=void 0,i.push(0)},onArrayEnd:(v,T)=>{if(u<=v)throw n;s=void 0,i.pop()},onLiteralValue:(v,T,M)=>{if(u<T||(f(v,T,M,_(v)),u<=T+M))throw n},onSeparator:(v,T,M)=>{if(u<=T)throw n;if(v===":"&&s&&s.type==="property")s.colonOffset=T,o=!1,s=void 0;else if(v===","){const j=i[i.length-1];typeof j=="number"?i[i.length-1]=j+1:(o=!0,i[i.length-1]=""),s=void 0}}})}catch(v){if(v!==n)throw v}return{path:i,previousNode:s,isAtPropertyKey:o,matches:v=>{let T=0;for(let M=0;T<v.length&&M<i.length;M++)if(v[T]===i[M]||v[T]==="*")T++;else if(v[T]!=="**")return!1;return T===v.length}}}e.getLocation=b;function g(t,u=[],i=F.DEFAULT){let n=null,s=[];const h=[];function o(v){Array.isArray(s)?s.push(v):n!==null&&(s[n]=v)}return S(t,{onObjectBegin:()=>{const v={};o(v),h.push(s),s=v,n=null},onObjectProperty:v=>{n=v},onObjectEnd:()=>{s=h.pop()},onArrayBegin:()=>{const v=[];o(v),h.push(s),s=v,n=null},onArrayEnd:()=>{s=h.pop()},onLiteralValue:o,onError:(v,T,M)=>{u.push({error:v,offset:T,length:M})}},i),s[0]}e.parse=g;function I(t,u=[],i=F.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(v){n.type==="property"&&(n.length=v-n.offset,n=n.parent)}function h(v){return n.children.push(v),v}S(t,{onObjectBegin:v=>{n=h({type:"object",offset:v,length:-1,parent:n,children:[]})},onObjectProperty:(v,T,M)=>{n=h({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:v,offset:T,length:M,parent:n})},onObjectEnd:(v,T)=>{n.length=v+T-n.offset,n=n.parent,s(v+T)},onArrayBegin:(v,T)=>{n=h({type:"array",offset:v,length:-1,parent:n,children:[]})},onArrayEnd:(v,T)=>{n.length=v+T-n.offset,n=n.parent,s(v+T)},onLiteralValue:(v,T,M)=>{h({type:_(v),offset:T,length:M,parent:n,value:v}),s(T+M)},onSeparator:(v,T,M)=>{n.type==="property"&&(v===":"?n.colonOffset=T:v===","&&s(T))},onError:(v,T,M)=>{u.push({error:v,offset:T,length:M})}},i);const f=n.children[0];return f&&delete f.parent,f}e.parseTree=I;function p(t,u){if(!t)return;let i=t;for(const n of u)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const h of i.children)if(Array.isArray(h.children)&&h.children[0].value===n){i=h.children[1],s=!0;break}if(!s)return}else{const s=n;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=p;function a(t){if(!t.parent||!t.parent.children)return[];const u=a(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;u.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&u.push(i)}return u}e.getNodePath=a;function l(t){switch(t.type){case"array":return t.children.map(l);case"object":{const u=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(u[i.children[0].value]=l(n))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=l;function d(t,u,i=!1){return u>=t.offset&&u<t.offset+t.length||i&&u===t.offset+t.length}e.contains=d;function m(t,u,i=!1){if(d(t,u,i)){const n=t.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=u;s++){const h=m(n[s],u,i);if(h)return h}return t}}e.findNodeAtOffset=m;function S(t,u,i=F.DEFAULT){const n=y(t,!1);function s(le){return le?()=>le(n.getTokenOffset(),n.getTokenLength()):()=>!0}function h(le){return le?fe=>le(fe,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=s(u.onObjectBegin),f=h(u.onObjectProperty),v=s(u.onObjectEnd),T=s(u.onArrayBegin),M=s(u.onArrayEnd),j=h(u.onLiteralValue),U=h(u.onSeparator),D=s(u.onComment),$=h(u.onError),L=i&&i.disallowComments,O=i&&i.allowTrailingComma;function H(){for(;;){const le=n.scan();switch(n.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:L||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(le){case 12:case 13:L?W(10):D();break;case 16:W(1);break;case 15:case 14:break;default:return le}}}function W(le,fe=[],Q=[]){if($(le),fe.length+Q.length>0){let pe=n.getToken();for(;pe!==17;){if(fe.indexOf(pe)!==-1){H();break}else if(Q.indexOf(pe)!==-1)break;pe=H()}}}function z(le){const fe=n.getTokenValue();return le?j(fe):f(fe),H(),!0}function G(){switch(n.getToken()){case 11:{let le=0;try{le=JSON.parse(n.getTokenValue()),typeof le!="number"&&(W(2),le=0)}catch{W(2)}j(le);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return H(),!0}function te(){return n.getToken()!==10?(W(3,[],[2,5]),!1):(z(!1),n.getToken()===6?(U(":"),H(),be()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function he(){o(),H();let le=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(le||W(4,[],[]),U(","),H(),n.getToken()===2&&O)break}else le&&W(6,[],[]);te()||W(4,[],[2,5]),le=!0}return v(),n.getToken()!==2?W(7,[2],[]):H(),!0}function re(){T(),H();let le=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(le||W(4,[],[]),U(","),H(),n.getToken()===4&&O)break}else le&&W(6,[],[]);be()||W(4,[],[4,5]),le=!0}return M(),n.getToken()!==4?W(8,[4],[]):H(),!0}function be(){switch(n.getToken()){case 3:return re();case 1:return he();case 10:return z(!0);default:return G()}}return H(),n.getToken()===17?i.allowEmptyContent?!0:(W(4,[],[]),!1):be()?(n.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=S;function c(t,u){const i=y(t),n=[];let s,h=0,o;do switch(o=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:h!==o&&n.push(t.substring(h,o)),u!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,u)),h=i.getPosition();break}while(s!==17);return n.join("")}e.stripComments=c;function _(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=_}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[106],Ie([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(ke,ye){for(var De=0;De<ye.length;De++){var ae=ye[De];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(ke,ae.key,ae)}}function r(ke,ye,De){return ye&&e(ke.prototype,ye),De&&e(ke,De),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function C(ke,ye){if(!!ke){if(typeof ke=="string")return w(ke,ye);var De=Object.prototype.toString.call(ke).slice(8,-1);if(De==="Object"&&ke.constructor&&(De=ke.constructor.name),De==="Map"||De==="Set")return Array.from(ke);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return w(ke,ye)}}function w(ke,ye){(ye==null||ye>ke.length)&&(ye=ke.length);for(var De=0,ae=new Array(ye);De<ye;De++)ae[De]=ke[De];return ae}function F(ke,ye){var De=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(De)return(De=De.call(ke)).next.bind(De);if(Array.isArray(ke)||(De=C(ke))||ye&&ke&&typeof ke.length=="number"){De&&(ke=De);var ae=0;return function(){return ae>=ke.length?{done:!0}:{done:!1,value:ke[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=y();function A(ke){ne.defaults=ke}var E=/[&<>"']/,P=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,g={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},I=function(ye){return g[ye]};function p(ke,ye){if(ye){if(E.test(ke))return ke.replace(P,I)}else if(R.test(ke))return ke.replace(b,I);return ke}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(ke){return ke.replace(a,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var d=/(^|[^\[])\^/g;function m(ke,ye){ke=typeof ke=="string"?ke:ke.source,ye=ye||"";var De={replace:function(ue,ee){return ee=ee.source||ee,ee=ee.replace(d,"$1"),ke=ke.replace(ue,ee),De},getRegex:function(){return new RegExp(ke,ye)}};return De}var S=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function _(ke,ye,De){if(ke){var ae;try{ae=decodeURIComponent(l(De)).replace(S,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}ye&&!c.test(De)&&(De=s(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var t={},u=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(ke,ye){t[" "+ke]||(u.test(ke)?t[" "+ke]=ke+"/":t[" "+ke]=v(ke,"/",!0)),ke=t[" "+ke];var De=ke.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:ke.replace(i,"$1")+ye:ye.charAt(0)==="/"?De?ye:ke.replace(n,"$1")+ye:ke+ye}var h={exec:function(){}};function o(ke){for(var ye=1,De,ae;ye<arguments.length;ye++){De=arguments[ye];for(ae in De)Object.prototype.hasOwnProperty.call(De,ae)&&(ke[ae]=De[ae])}return ke}function f(ke,ye){var De=ke.replace(/\|/g,function(ee,Z,k){for(var B=!1,V=Z;--V>=0&&k[V]==="\\";)B=!B;return B?"|":" |"}),ae=De.split(/ \|/),ue=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>ye)ae.splice(ye);else for(;ae.length<ye;)ae.push("");for(;ue<ae.length;ue++)ae[ue]=ae[ue].trim().replace(/\\\|/g,"|");return ae}function v(ke,ye,De){var ae=ke.length;if(ae===0)return"";for(var ue=0;ue<ae;){var ee=ke.charAt(ae-ue-1);if(ee===ye&&!De)ue++;else if(ee!==ye&&De)ue++;else break}return ke.slice(0,ae-ue)}function T(ke,ye){if(ke.indexOf(ye[1])===-1)return-1;for(var De=ke.length,ae=0,ue=0;ue<De;ue++)if(ke[ue]==="\\")ue++;else if(ke[ue]===ye[0])ae++;else if(ke[ue]===ye[1]&&(ae--,ae<0))return ue;return-1}function M(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(ke,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=ke),ye>>=1,ke+=ke;return De+ke}function U(ke,ye,De,ae){var ue=ye.href,ee=ye.title?p(ye.title):null,Z=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){ae.state.inLink=!0;var k={type:"link",raw:De,href:ue,title:ee,text:Z,tokens:ae.inlineTokens(Z)};return ae.state.inLink=!1,k}return{type:"image",raw:De,href:ue,title:ee,text:p(Z)}}function D(ke,ye){var De=ke.match(/^(\s+)(?:```)/);if(De===null)return ye;var ae=De[1];return ye.split(`
`).map(function(ue){var ee=ue.match(/^\s+/);if(ee===null)return ue;var Z=ee[0];return Z.length>=ae.length?ue.slice(ae.length):ue}).join(`
`)}var $=function(){function ke(De){this.options=De||ne.defaults}var ye=ke.prototype;return ye.space=function(ae){var ue=this.rules.block.newline.exec(ae);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},ye.code=function(ae){var ue=this.rules.block.code.exec(ae);if(ue){var ee=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:v(ee,`
`)}}},ye.fences=function(ae){var ue=this.rules.block.fences.exec(ae);if(ue){var ee=ue[0],Z=D(ee,ue[3]||"");return{type:"code",raw:ee,lang:ue[2]?ue[2].trim():ue[2],text:Z}}},ye.heading=function(ae){var ue=this.rules.block.heading.exec(ae);if(ue){var ee=ue[2].trim();if(/#$/.test(ee)){var Z=v(ee,"#");(this.options.pedantic||!Z||/ $/.test(Z))&&(ee=Z.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:ee,tokens:this.lexer.inline(ee)}}},ye.hr=function(ae){var ue=this.rules.block.hr.exec(ae);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(ae){var ue=this.rules.block.blockquote.exec(ae);if(ue){var ee=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},ye.list=function(ae){var ue=this.rules.block.list.exec(ae);if(ue){var ee,Z,k,B,V,q,oe,ce,J,Ee,ve,Ne,ze=ue[1].trim(),Je=ze.length>1,Ge={type:"list",raw:"",ordered:Je,start:Je?+ze.slice(0,-1):"",loose:!1,items:[]};ze=Je?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=Je?ze:"[*+-]");for(var Pe=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Ne=!1,!(!(ue=Pe.exec(ae))||this.rules.block.hr.test(ae)));){if(ee=ue[0],ae=ae.substring(ee.length),ce=ue[2].split(`
`,1)[0],J=ae.split(`
`,1)[0],this.options.pedantic?(B=2,ve=ce.trimLeft()):(B=ue[2].search(/[^ ]/),B=B>4?1:B,ve=ce.slice(B),B+=ue[1].length),q=!1,!ce&&/^ *$/.test(J)&&(ee+=J+`
`,ae=ae.substring(J.length+1),Ne=!0),!Ne)for(var nt=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),X=new RegExp("^ {0,"+Math.min(3,B-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Y=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:```|~~~)"),me=new RegExp("^ {0,"+Math.min(3,B-1)+"}#");ae&&(Ee=ae.split(`
`,1)[0],ce=Ee,this.options.pedantic&&(ce=ce.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Y.test(ce)||me.test(ce)||nt.test(ce)||X.test(ae)));){if(ce.search(/[^ ]/)>=B||!ce.trim())ve+=`
`+ce.slice(B);else if(!q)ve+=`
`+ce;else break;!q&&!ce.trim()&&(q=!0),ee+=Ee+`
`,ae=ae.substring(Ee.length+1)}Ge.loose||(oe?Ge.loose=!0:/\n *\n *$/.test(ee)&&(oe=!0)),this.options.gfm&&(Z=/^\[[ xX]\] /.exec(ve),Z&&(k=Z[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:ee,task:!!Z,checked:k,loose:!1,text:ve}),Ge.raw+=ee}Ge.items[Ge.items.length-1].raw=ee.trimRight(),Ge.items[Ge.items.length-1].text=ve.trimRight(),Ge.raw=Ge.raw.trimRight();var Ue=Ge.items.length;for(V=0;V<Ue;V++){this.lexer.state.top=!1,Ge.items[V].tokens=this.lexer.blockTokens(Ge.items[V].text,[]);var Ve=Ge.items[V].tokens.filter(function(Ke){return Ke.type==="space"}),et=Ve.every(function(Ke){for(var je=Ke.raw.split(""),it=0,st=F(je),ct;!(ct=st()).done;){var at=ct.value;if(at===`
`&&(it+=1),it>1)return!0}return!1});!Ge.loose&&Ve.length&&et&&(Ge.loose=!0,Ge.items[V].loose=!0)}return Ge}},ye.html=function(ae){var ue=this.rules.block.html.exec(ae);if(ue){var ee={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var Z=this.options.sanitizer?this.options.sanitizer(ue[0]):p(ue[0]);ee.type="paragraph",ee.text=Z,ee.tokens=this.lexer.inline(Z)}return ee}},ye.def=function(ae){var ue=this.rules.block.def.exec(ae);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var ee=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(ae){var ue=this.rules.block.table.exec(ae);if(ue){var ee={type:"table",header:f(ue[1]).map(function(oe){return{text:oe}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=ue[0];var Z=ee.align.length,k,B,V,q;for(k=0;k<Z;k++)/^ *-+: *$/.test(ee.align[k])?ee.align[k]="right":/^ *:-+: *$/.test(ee.align[k])?ee.align[k]="center":/^ *:-+ *$/.test(ee.align[k])?ee.align[k]="left":ee.align[k]=null;for(Z=ee.rows.length,k=0;k<Z;k++)ee.rows[k]=f(ee.rows[k],ee.header.length).map(function(oe){return{text:oe}});for(Z=ee.header.length,B=0;B<Z;B++)ee.header[B].tokens=this.lexer.inline(ee.header[B].text);for(Z=ee.rows.length,B=0;B<Z;B++)for(q=ee.rows[B],V=0;V<q.length;V++)q[V].tokens=this.lexer.inline(q[V].text);return ee}}},ye.lheading=function(ae){var ue=this.rules.block.lheading.exec(ae);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},ye.paragraph=function(ae){var ue=this.rules.block.paragraph.exec(ae);if(ue){var ee=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:ee,tokens:this.lexer.inline(ee)}}},ye.text=function(ae){var ue=this.rules.block.text.exec(ae);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},ye.escape=function(ae){var ue=this.rules.inline.escape.exec(ae);if(ue)return{type:"escape",raw:ue[0],text:p(ue[1])}},ye.tag=function(ae){var ue=this.rules.inline.tag.exec(ae);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):p(ue[0]):ue[0]}},ye.link=function(ae){var ue=this.rules.inline.link.exec(ae);if(ue){var ee=ue[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var Z=v(ee.slice(0,-1),"\\");if((ee.length-Z.length)%2===0)return}else{var k=T(ue[2],"()");if(k>-1){var B=ue[0].indexOf("!")===0?5:4,V=B+ue[1].length+k;ue[2]=ue[2].substring(0,k),ue[0]=ue[0].substring(0,V).trim(),ue[3]=""}}var q=ue[2],oe="";if(this.options.pedantic){var ce=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);ce&&(q=ce[1],oe=ce[3])}else oe=ue[3]?ue[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(ee)?q=q.slice(1):q=q.slice(1,-1)),U(ue,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:oe&&oe.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ye.reflink=function(ae,ue){var ee;if((ee=this.rules.inline.reflink.exec(ae))||(ee=this.rules.inline.nolink.exec(ae))){var Z=(ee[2]||ee[1]).replace(/\s+/g," ");if(Z=ue[Z.toLowerCase()],!Z||!Z.href){var k=ee[0].charAt(0);return{type:"text",raw:k,text:k}}return U(ee,Z,ee[0],this.lexer)}},ye.emStrong=function(ae,ue,ee){ee===void 0&&(ee="");var Z=this.rules.inline.emStrong.lDelim.exec(ae);if(!!Z&&!(Z[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var k=Z[1]||Z[2]||"";if(!k||k&&(ee===""||this.rules.inline.punctuation.exec(ee))){var B=Z[0].length-1,V,q,oe=B,ce=0,J=Z[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(J.lastIndex=0,ue=ue.slice(-1*ae.length+B);(Z=J.exec(ue))!=null;)if(V=Z[1]||Z[2]||Z[3]||Z[4]||Z[5]||Z[6],!!V){if(q=V.length,Z[3]||Z[4]){oe+=q;continue}else if((Z[5]||Z[6])&&B%3&&!((B+q)%3)){ce+=q;continue}if(oe-=q,!(oe>0)){if(q=Math.min(q,q+oe+ce),Math.min(B,q)%2){var Ee=ae.slice(1,B+Z.index+q);return{type:"em",raw:ae.slice(0,B+Z.index+q+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}var ve=ae.slice(2,B+Z.index+q-1);return{type:"strong",raw:ae.slice(0,B+Z.index+q+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},ye.codespan=function(ae){var ue=this.rules.inline.code.exec(ae);if(ue){var ee=ue[2].replace(/\n/g," "),Z=/[^ ]/.test(ee),k=/^ /.test(ee)&&/ $/.test(ee);return Z&&k&&(ee=ee.substring(1,ee.length-1)),ee=p(ee,!0),{type:"codespan",raw:ue[0],text:ee}}},ye.br=function(ae){var ue=this.rules.inline.br.exec(ae);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(ae){var ue=this.rules.inline.del.exec(ae);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},ye.autolink=function(ae,ue){var ee=this.rules.inline.autolink.exec(ae);if(ee){var Z,k;return ee[2]==="@"?(Z=p(this.options.mangle?ue(ee[1]):ee[1]),k="mailto:"+Z):(Z=p(ee[1]),k=Z),{type:"link",raw:ee[0],text:Z,href:k,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.url=function(ae,ue){var ee;if(ee=this.rules.inline.url.exec(ae)){var Z,k;if(ee[2]==="@")Z=p(this.options.mangle?ue(ee[0]):ee[0]),k="mailto:"+Z;else{var B;do B=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(B!==ee[0]);Z=p(ee[0]),ee[1]==="www."?k="http://"+Z:k=Z}return{type:"link",raw:ee[0],text:Z,href:k,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.inlineText=function(ae,ue){var ee=this.rules.inline.text.exec(ae);if(ee){var Z;return this.lexer.state.inRawBlock?Z=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):p(ee[0]):ee[0]:Z=p(this.options.smartypants?ue(ee[0]):ee[0]),{type:"text",raw:ee[0],text:Z}}},ke}(),L={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};L._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,L._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,L.def=m(L.def).replace("label",L._label).replace("title",L._title).getRegex(),L.bullet=/(?:[*+-]|\d{1,9}[.)])/,L.listItemStart=m(/^( *)(bull) */).replace("bull",L.bullet).getRegex(),L.list=m(L.list).replace(/bull/g,L.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+L.def.source+")").getRegex(),L._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",L._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,L.html=m(L.html,"i").replace("comment",L._comment).replace("tag",L._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),L.paragraph=m(L._paragraph).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.blockquote=m(L.blockquote).replace("paragraph",L.paragraph).getRegex(),L.normal=o({},L),L.gfm=o({},L.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),L.gfm.table=m(L.gfm.table).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.gfm.paragraph=m(L._paragraph).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",L.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.pedantic=o({},L.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",L._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:m(L.normal._paragraph).replace("hr",L.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",L.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=m(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=m(L._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=m(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=m(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=m(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=m(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=m(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=m(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=m(O.reflink).replace("label",O._label).replace("ref",L._label).getRegex(),O.nolink=m(O.nolink).replace("ref",L._label).getRegex(),O.reflinkSearch=m(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=o({},O),O.pedantic=o({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=o({},O.normal,{escape:m(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=m(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=o({},O.gfm,{br:m(O.br).replace("{2,}","*").getRegex(),text:m(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function H(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(ke){var ye="",De,ae,ue=ke.length;for(De=0;De<ue;De++)ae=ke.charCodeAt(De),Math.random()>.5&&(ae="x"+ae.toString(16)),ye+="&#"+ae+";";return ye}var z=function(){function ke(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||ne.defaults,this.options.tokenizer=this.options.tokenizer||new $,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:L.normal,inline:O.normal};this.options.pedantic?(ae.block=L.pedantic,ae.inline=O.pedantic):this.options.gfm&&(ae.block=L.gfm,this.options.breaks?ae.inline=O.breaks:ae.inline=O.gfm),this.tokenizer.rules=ae}ke.lex=function(ae,ue){var ee=new ke(ue);return ee.lex(ae)},ke.lexInline=function(ae,ue){var ee=new ke(ue);return ee.inlineTokens(ae)};var ye=ke.prototype;return ye.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ye.blockTokens=function(ae,ue){var ee=this;ue===void 0&&(ue=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(oe,ce,J){return ce+"    ".repeat(J.length)});for(var Z,k,B,V;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(oe){return(Z=oe.call({lexer:ee},ae,ue))?(ae=ae.substring(Z.raw.length),ue.push(Z),!0):!1}))){if(Z=this.tokenizer.space(ae)){ae=ae.substring(Z.raw.length),Z.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(Z);continue}if(Z=this.tokenizer.code(ae)){ae=ae.substring(Z.raw.length),k=ue[ue.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+Z.raw,k.text+=`
`+Z.text,this.inlineQueue[this.inlineQueue.length-1].src=k.text):ue.push(Z);continue}if(Z=this.tokenizer.fences(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.heading(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.hr(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.blockquote(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.list(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.html(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.def(ae)){ae=ae.substring(Z.raw.length),k=ue[ue.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+Z.raw,k.text+=`
`+Z.raw,this.inlineQueue[this.inlineQueue.length-1].src=k.text):this.tokens.links[Z.tag]||(this.tokens.links[Z.tag]={href:Z.href,title:Z.title});continue}if(Z=this.tokenizer.table(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.lheading(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(B=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var oe=1/0,ce=ae.slice(1),J=void 0;ee.options.extensions.startBlock.forEach(function(Ee){J=Ee.call({lexer:this},ce),typeof J=="number"&&J>=0&&(oe=Math.min(oe,J))}),oe<1/0&&oe>=0&&(B=ae.substring(0,oe+1))}(),this.state.top&&(Z=this.tokenizer.paragraph(B))){k=ue[ue.length-1],V&&k.type==="paragraph"?(k.raw+=`
`+Z.raw,k.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):ue.push(Z),V=B.length!==ae.length,ae=ae.substring(Z.raw.length);continue}if(Z=this.tokenizer.text(ae)){ae=ae.substring(Z.raw.length),k=ue[ue.length-1],k&&k.type==="text"?(k.raw+=`
`+Z.raw,k.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):ue.push(Z);continue}if(ae){var q="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,ue},ye.inline=function(ae,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:ae,tokens:ue}),ue},ye.inlineTokens=function(ae,ue){var ee=this;ue===void 0&&(ue=[]);var Z,k,B,V=ae,q,oe,ce;if(this.tokens.links){var J=Object.keys(this.tokens.links);if(J.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(V))!=null;)J.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(V=V.slice(0,q.index)+"["+j("a",q[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(V))!=null;)V=V.slice(0,q.index)+"["+j("a",q[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(V))!=null;)V=V.slice(0,q.index)+"++"+V.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(oe||(ce=""),oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(Z=ve.call({lexer:ee},ae,ue))?(ae=ae.substring(Z.raw.length),ue.push(Z),!0):!1}))){if(Z=this.tokenizer.escape(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.tag(ae)){ae=ae.substring(Z.raw.length),k=ue[ue.length-1],k&&Z.type==="text"&&k.type==="text"?(k.raw+=Z.raw,k.text+=Z.text):ue.push(Z);continue}if(Z=this.tokenizer.link(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(Z.raw.length),k=ue[ue.length-1],k&&Z.type==="text"&&k.type==="text"?(k.raw+=Z.raw,k.text+=Z.text):ue.push(Z);continue}if(Z=this.tokenizer.emStrong(ae,V,ce)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.codespan(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.br(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.del(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.autolink(ae,W)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(!this.state.inLink&&(Z=this.tokenizer.url(ae,W))){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(B=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Ne=ae.slice(1),ze=void 0;ee.options.extensions.startInline.forEach(function(Je){ze=Je.call({lexer:this},Ne),typeof ze=="number"&&ze>=0&&(ve=Math.min(ve,ze))}),ve<1/0&&ve>=0&&(B=ae.substring(0,ve+1))}(),Z=this.tokenizer.inlineText(B,H)){ae=ae.substring(Z.raw.length),Z.raw.slice(-1)!=="_"&&(ce=Z.raw.slice(-1)),oe=!0,k=ue[ue.length-1],k&&k.type==="text"?(k.raw+=Z.raw,k.text+=Z.text):ue.push(Z);continue}if(ae){var Ee="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return ue},r(ke,null,[{key:"rules",get:function(){return{block:L,inline:O}}}]),ke}(),G=function(){function ke(De){this.options=De||ne.defaults}var ye=ke.prototype;return ye.code=function(ae,ue,ee){var Z=(ue||"").match(/\S*/)[0];if(this.options.highlight){var k=this.options.highlight(ae,Z);k!=null&&k!==ae&&(ee=!0,ae=k)}return ae=ae.replace(/\n$/,"")+`
`,Z?'<pre><code class="'+this.options.langPrefix+p(Z,!0)+'">'+(ee?ae:p(ae,!0))+`</code></pre>
`:"<pre><code>"+(ee?ae:p(ae,!0))+`</code></pre>
`},ye.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},ye.html=function(ae){return ae},ye.heading=function(ae,ue,ee,Z){if(this.options.headerIds){var k=this.options.headerPrefix+Z.slug(ee);return"<h"+ue+' id="'+k+'">'+ae+"</h"+ue+`>
`}return"<h"+ue+">"+ae+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ae,ue,ee){var Z=ue?"ol":"ul",k=ue&&ee!==1?' start="'+ee+'"':"";return"<"+Z+k+`>
`+ae+"</"+Z+`>
`},ye.listitem=function(ae){return"<li>"+ae+`</li>
`},ye.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ae){return"<p>"+ae+`</p>
`},ye.table=function(ae,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+ue+`</table>
`},ye.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},ye.tablecell=function(ae,ue){var ee=ue.header?"th":"td",Z=ue.align?"<"+ee+' align="'+ue.align+'">':"<"+ee+">";return Z+ae+("</"+ee+`>
`)},ye.strong=function(ae){return"<strong>"+ae+"</strong>"},ye.em=function(ae){return"<em>"+ae+"</em>"},ye.codespan=function(ae){return"<code>"+ae+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ae){return"<del>"+ae+"</del>"},ye.link=function(ae,ue,ee){if(ae=_(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var Z='<a href="'+p(ae)+'"';return ue&&(Z+=' title="'+ue+'"'),Z+=">"+ee+"</a>",Z},ye.image=function(ae,ue,ee){if(ae=_(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var Z='<img src="'+ae+'" alt="'+ee+'"';return ue&&(Z+=' title="'+ue+'"'),Z+=this.options.xhtml?"/>":">",Z},ye.text=function(ae){return ae},ke}(),te=function(){function ke(){}var ye=ke.prototype;return ye.strong=function(ae){return ae},ye.em=function(ae){return ae},ye.codespan=function(ae){return ae},ye.del=function(ae){return ae},ye.html=function(ae){return ae},ye.text=function(ae){return ae},ye.link=function(ae,ue,ee){return""+ee},ye.image=function(ae,ue,ee){return""+ee},ye.br=function(){return""},ke}(),he=function(){function ke(){this.seen={}}var ye=ke.prototype;return ye.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ae,ue){var ee=ae,Z=0;if(this.seen.hasOwnProperty(ee)){Z=this.seen[ae];do Z++,ee=ae+"-"+Z;while(this.seen.hasOwnProperty(ee))}return ue||(this.seen[ae]=Z,this.seen[ee]=0),ee},ye.slug=function(ae,ue){ue===void 0&&(ue={});var ee=this.serialize(ae);return this.getNextSafeSlug(ee,ue.dryrun)},ke}(),re=function(){function ke(De){this.options=De||ne.defaults,this.options.renderer=this.options.renderer||new G,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new te,this.slugger=new he}ke.parse=function(ae,ue){var ee=new ke(ue);return ee.parse(ae)},ke.parseInline=function(ae,ue){var ee=new ke(ue);return ee.parseInline(ae)};var ye=ke.prototype;return ye.parse=function(ae,ue){ue===void 0&&(ue=!0);var ee="",Z,k,B,V,q,oe,ce,J,Ee,ve,Ne,ze,Je,Ge,Pe,nt,X,Y,me,Ue=ae.length;for(Z=0;Z<Ue;Z++){if(ve=ae[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(me=this.options.extensions.renderers[ve.type].call({parser:this},ve),me!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){ee+=me||"";continue}switch(ve.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,l(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(J="",ce="",V=ve.header.length,k=0;k<V;k++)ce+=this.renderer.tablecell(this.parseInline(ve.header[k].tokens),{header:!0,align:ve.align[k]});for(J+=this.renderer.tablerow(ce),Ee="",V=ve.rows.length,k=0;k<V;k++){for(oe=ve.rows[k],ce="",q=oe.length,B=0;B<q;B++)ce+=this.renderer.tablecell(this.parseInline(oe[B].tokens),{header:!1,align:ve.align[B]});Ee+=this.renderer.tablerow(ce)}ee+=this.renderer.table(J,Ee);continue}case"blockquote":{Ee=this.parse(ve.tokens),ee+=this.renderer.blockquote(Ee);continue}case"list":{for(Ne=ve.ordered,ze=ve.start,Je=ve.loose,V=ve.items.length,Ee="",k=0;k<V;k++)Pe=ve.items[k],nt=Pe.checked,X=Pe.task,Ge="",Pe.task&&(Y=this.renderer.checkbox(nt),Je?Pe.tokens.length>0&&Pe.tokens[0].type==="paragraph"?(Pe.tokens[0].text=Y+" "+Pe.tokens[0].text,Pe.tokens[0].tokens&&Pe.tokens[0].tokens.length>0&&Pe.tokens[0].tokens[0].type==="text"&&(Pe.tokens[0].tokens[0].text=Y+" "+Pe.tokens[0].tokens[0].text)):Pe.tokens.unshift({type:"text",text:Y}):Ge+=Y),Ge+=this.parse(Pe.tokens,Je),Ee+=this.renderer.listitem(Ge,X,nt);ee+=this.renderer.list(Ee,Ne,ze);continue}case"html":{ee+=this.renderer.html(ve.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Ee=ve.tokens?this.parseInline(ve.tokens):ve.text;Z+1<Ue&&ae[Z+1].type==="text";)ve=ae[++Z],Ee+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);ee+=ue?this.renderer.paragraph(Ee):Ee;continue}default:{var Ve='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Ve);return}else throw new Error(Ve)}}}return ee},ye.parseInline=function(ae,ue){ue=ue||this.renderer;var ee="",Z,k,B,V=ae.length;for(Z=0;Z<V;Z++){if(k=ae[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[k.type]&&(B=this.options.extensions.renderers[k.type].call({parser:this},k),B!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(k.type))){ee+=B||"";continue}switch(k.type){case"escape":{ee+=ue.text(k.text);break}case"html":{ee+=ue.html(k.text);break}case"link":{ee+=ue.link(k.href,k.title,this.parseInline(k.tokens,ue));break}case"image":{ee+=ue.image(k.href,k.title,k.text);break}case"strong":{ee+=ue.strong(this.parseInline(k.tokens,ue));break}case"em":{ee+=ue.em(this.parseInline(k.tokens,ue));break}case"codespan":{ee+=ue.codespan(k.text);break}case"br":{ee+=ue.br();break}case"del":{ee+=ue.del(this.parseInline(k.tokens,ue));break}case"text":{ee+=ue.text(k.text);break}default:{var q='Token with "'+k.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return ee},ke}();function be(ke,ye,De){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=o({},be.defaults,ye||{}),M(ye),De){var ae=ye.highlight,ue;try{ue=z.lex(ke,ye)}catch(V){return De(V)}var ee=function(q){var oe;if(!q)try{ye.walkTokens&&be.walkTokens(ue,ye.walkTokens),oe=re.parse(ue,ye)}catch(ce){q=ce}return ye.highlight=ae,q?De(q):De(null,oe)};if(!ae||ae.length<3||(delete ye.highlight,!ue.length))return ee();var Z=0;be.walkTokens(ue,function(V){V.type==="code"&&(Z++,setTimeout(function(){ae(V.text,V.lang,function(q,oe){if(q)return ee(q);oe!=null&&oe!==V.text&&(V.text=oe,V.escaped=!0),Z--,Z===0&&ee()})},0))}),Z===0&&ee();return}function k(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+p(V.message+"",!0)+"</pre>";throw V}try{var B=z.lex(ke,ye);if(ye.walkTokens){if(ye.async)return Promise.all(be.walkTokens(B,ye.walkTokens)).then(function(){return re.parse(B,ye)}).catch(k);be.walkTokens(B,ye.walkTokens)}return re.parse(B,ye)}catch(V){k(V)}}be.options=be.setOptions=function(ke){return o(be.defaults,ke),A(be.defaults),be},be.getDefaults=y,be.defaults=ne.defaults,be.use=function(){for(var ke=arguments.length,ye=new Array(ke),De=0;De<ke;De++)ye[De]=arguments[De];var ae=o.apply(void 0,[{}].concat(ye)),ue=be.defaults.extensions||{renderers:{},childTokens:{}},ee;ye.forEach(function(Z){if(Z.extensions&&(ee=!0,Z.extensions.forEach(function(B){if(!B.name)throw new Error("extension name required");if(B.renderer){var V=ue.renderers?ue.renderers[B.name]:null;V?ue.renderers[B.name]=function(){for(var q=arguments.length,oe=new Array(q),ce=0;ce<q;ce++)oe[ce]=arguments[ce];var J=B.renderer.apply(this,oe);return J===!1&&(J=V.apply(this,oe)),J}:ue.renderers[B.name]=B.renderer}if(B.tokenizer){if(!B.level||B.level!=="block"&&B.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[B.level]?ue[B.level].unshift(B.tokenizer):ue[B.level]=[B.tokenizer],B.start&&(B.level==="block"?ue.startBlock?ue.startBlock.push(B.start):ue.startBlock=[B.start]:B.level==="inline"&&(ue.startInline?ue.startInline.push(B.start):ue.startInline=[B.start]))}B.childTokens&&(ue.childTokens[B.name]=B.childTokens)})),Z.renderer&&function(){var B=be.defaults.renderer||new G,V=function(ce){var J=B[ce];B[ce]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Ne=0;Ne<Ee;Ne++)ve[Ne]=arguments[Ne];var ze=Z.renderer[ce].apply(B,ve);return ze===!1&&(ze=J.apply(B,ve)),ze}};for(var q in Z.renderer)V(q);ae.renderer=B}(),Z.tokenizer&&function(){var B=be.defaults.tokenizer||new $,V=function(ce){var J=B[ce];B[ce]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Ne=0;Ne<Ee;Ne++)ve[Ne]=arguments[Ne];var ze=Z.tokenizer[ce].apply(B,ve);return ze===!1&&(ze=J.apply(B,ve)),ze}};for(var q in Z.tokenizer)V(q);ae.tokenizer=B}(),Z.walkTokens){var k=be.defaults.walkTokens;ae.walkTokens=function(B){var V=[];return V.push(Z.walkTokens.call(this,B)),k&&(V=V.concat(k.call(this,B))),V}}ee&&(ae.extensions=ue),be.setOptions(ae)})},be.walkTokens=function(ke,ye){for(var De=[],ae=function(){var k=ee.value;switch(De=De.concat(ye.call(be,k)),k.type){case"table":{for(var B=F(k.header),V;!(V=B()).done;){var q=V.value;De=De.concat(be.walkTokens(q.tokens,ye))}for(var oe=F(k.rows),ce;!(ce=oe()).done;)for(var J=ce.value,Ee=F(J),ve;!(ve=Ee()).done;){var Ne=ve.value;De=De.concat(be.walkTokens(Ne.tokens,ye))}break}case"list":{De=De.concat(be.walkTokens(k.items,ye));break}default:be.defaults.extensions&&be.defaults.extensions.childTokens&&be.defaults.extensions.childTokens[k.type]?be.defaults.extensions.childTokens[k.type].forEach(function(ze){De=De.concat(be.walkTokens(k[ze],ye))}):k.tokens&&(De=De.concat(be.walkTokens(k.tokens,ye)))}},ue=F(ke),ee;!(ee=ue()).done;)ae();return De},be.parseInline=function(ke,ye){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");ye=o({},be.defaults,ye||{}),M(ye);try{var De=z.lexInline(ke,ye);return ye.walkTokens&&be.walkTokens(De,ye.walkTokens),re.parseInline(De,ye)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+p(ae.message+"",!0)+"</pre>";throw ae}},be.Parser=re,be.parser=re.parse,be.Renderer=G,be.TextRenderer=te,be.Lexer=z,be.lexer=z.lex,be.Tokenizer=$,be.Slugger=he,be.parse=be;var le=be.options,fe=be.setOptions,Q=be.use,pe=be.walkTokens,Se=be.parseInline,Fe=be,Be=re.parse,Xe=z.lex;ne.Lexer=z,ne.Parser=re,ne.Renderer=G,ne.Slugger=he,ne.TextRenderer=te,ne.Tokenizer=$,ne.getDefaults=y,ne.lexer=Xe,ne.marked=be,ne.options=le,ne.parse=Fe,ne.parseInline=Se,ne.parser=Be,ne.setOptions=fe,ne.use=Q,ne.walkTokens=pe,Object.defineProperty(ne,"__esModule",{value:!0})}),define(Ce[107],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function r(A,E,P){return Math.min(Math.max(A,E),P)}e.clamp=r;function C(A,E){return(E+A%E)%E}e.rot=C;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class F{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=F;class y{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const P=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),function(){function ne(w){const F=[];typeof w=="number"&&F.push("code/timeOrigin",w);function y(E){F.push(E,Date.now())}function A(){const E=[];for(let P=0;P<F.length;P+=2)E.push({name:F[P],startTime:F[P+1]});return E}return{mark:y,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const y of performance.getEntriesByType("mark"))F.push({name:y.name,startTime:Math.round(w+y.startTime)});return F}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function r(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=r(C))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var C in r)(typeof exports=="object"?exports:ne)[C]=r[C]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function r(C){if(e[C])return e[C].exports;var w=e[C]={i:C,l:!1,exports:{}};return ne[C].call(w.exports,w,w.exports,r),w.l=!0,w.exports}return r.m=ne,r.c=e,r.d=function(C,w,F){r.o(C,w)||Object.defineProperty(C,w,{enumerable:!0,get:F})},r.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},r.t=function(C,w){if(1&w&&(C=r(C)),8&w||4&w&&typeof C=="object"&&C&&C.__esModule)return C;var F=Object.create(null);if(r.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:C}),2&w&&typeof C!="string")for(var y in C)r.d(F,y,function(A){return C[A]}.bind(null,y));return F},r.n=function(C){var w=C&&C.__esModule?function(){return C.default}:function(){return C};return r.d(w,"a",w),w},r.o=function(C,w){return Object.prototype.hasOwnProperty.call(C,w)},r.p="",r(r.s=0)}([function(ne,e,r){(function(C){var w;e=ne.exports=Q,w=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,y=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],E=e.src=[],P=0,R=P++;E[R]="0|[1-9]\\d*";var b=P++;E[b]="[0-9]+";var g=P++;E[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=P++;E[I]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var p=P++;E[p]="("+E[b]+")\\.("+E[b]+")\\.("+E[b]+")";var a=P++;E[a]="(?:"+E[R]+"|"+E[g]+")";var l=P++;E[l]="(?:"+E[b]+"|"+E[g]+")";var d=P++;E[d]="(?:-("+E[a]+"(?:\\."+E[a]+")*))";var m=P++;E[m]="(?:-?("+E[l]+"(?:\\."+E[l]+")*))";var S=P++;E[S]="[0-9A-Za-z-]+";var c=P++;E[c]="(?:\\+("+E[S]+"(?:\\."+E[S]+")*))";var _=P++,t="v?"+E[I]+E[d]+"?"+E[c]+"?";E[_]="^"+t+"$";var u="[v=\\s]*"+E[p]+E[m]+"?"+E[c]+"?",i=P++;E[i]="^"+u+"$";var n=P++;E[n]="((?:<|>)?=?)";var s=P++;E[s]=E[b]+"|x|X|\\*";var h=P++;E[h]=E[R]+"|x|X|\\*";var o=P++;E[o]="[v=\\s]*("+E[h]+")(?:\\.("+E[h]+")(?:\\.("+E[h]+")(?:"+E[d]+")?"+E[c]+"?)?)?";var f=P++;E[f]="[v=\\s]*("+E[s]+")(?:\\.("+E[s]+")(?:\\.("+E[s]+")(?:"+E[m]+")?"+E[c]+"?)?)?";var v=P++;E[v]="^"+E[n]+"\\s*"+E[o]+"$";var T=P++;E[T]="^"+E[n]+"\\s*"+E[f]+"$";var M=P++;E[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=P++;E[j]="(?:~>?)";var U=P++;E[U]="(\\s*)"+E[j]+"\\s+",A[U]=new RegExp(E[U],"g");var D=P++;E[D]="^"+E[j]+E[o]+"$";var $=P++;E[$]="^"+E[j]+E[f]+"$";var L=P++;E[L]="(?:\\^)";var O=P++;E[O]="(\\s*)"+E[L]+"\\s+",A[O]=new RegExp(E[O],"g");var H=P++;E[H]="^"+E[L]+E[o]+"$";var W=P++;E[W]="^"+E[L]+E[f]+"$";var z=P++;E[z]="^"+E[n]+"\\s*("+u+")$|^$";var G=P++;E[G]="^"+E[n]+"\\s*("+t+")$|^$";var te=P++;E[te]="(\\s*)"+E[n]+"\\s*("+u+"|"+E[o]+")",A[te]=new RegExp(E[te],"g");var he=P++;E[he]="^\\s*("+E[o]+")\\s+-\\s+("+E[o]+")\\s*$";var re=P++;E[re]="^\\s*("+E[f]+")\\s+-\\s+("+E[f]+")\\s*$";var be=P++;E[be]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)w(le,E[le]),A[le]||(A[le]=new RegExp(E[le]));function fe(J,Ee){if(J instanceof Q)return J;if(typeof J!="string"||J.length>F||!(Ee?A[i]:A[_]).test(J))return null;try{return new Q(J,Ee)}catch{return null}}function Q(J,Ee){if(J instanceof Q){if(J.loose===Ee)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof Q))return new Q(J,Ee);w("SemVer",J,Ee),this.loose=Ee;var ve=J.trim().match(Ee?A[i]:A[_]);if(!ve)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>y||this.major<0)throw new TypeError("Invalid major version");if(this.minor>y||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>y||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var ze=+Ne;if(ze>=0&&ze<y)return ze}return Ne}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=fe,e.valid=function(J,Ee){var ve=fe(J,Ee);return ve?ve.version:null},e.clean=function(J,Ee){var ve=fe(J.trim().replace(/^[=v]+/,""),Ee);return ve?ve.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(J){return w("SemVer.compare",this.version,this.loose,J),J instanceof Q||(J=new Q(J,this.loose)),this.compareMain(J)||this.comparePre(J)},Q.prototype.compareMain=function(J){return J instanceof Q||(J=new Q(J,this.loose)),Se(this.major,J.major)||Se(this.minor,J.minor)||Se(this.patch,J.patch)},Q.prototype.comparePre=function(J){if(J instanceof Q||(J=new Q(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var Ee=0;do{var ve=this.prerelease[Ee],Ne=J.prerelease[Ee];if(w("prerelease compare",Ee,ve,Ne),ve===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ve===void 0)return-1;if(ve!==Ne)return Se(ve,Ne)}while(++Ee)},Q.prototype.inc=function(J,Ee){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ee),this.inc("pre",Ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ee),this.inc("pre",Ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}Ee&&(this.prerelease[0]===Ee?isNaN(this.prerelease[1])&&(this.prerelease=[Ee,0]):this.prerelease=[Ee,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,Ee,ve,Ne){typeof ve=="string"&&(Ne=ve,ve=void 0);try{return new Q(J,ve).inc(Ee,Ne).version}catch{return null}},e.diff=function(J,Ee){if(ke(J,Ee))return null;var ve=fe(J),Ne=fe(Ee);if(ve.prerelease.length||Ne.prerelease.length){for(var ze in ve)if((ze==="major"||ze==="minor"||ze==="patch")&&ve[ze]!==Ne[ze])return"pre"+ze;return"prerelease"}for(var ze in ve)if((ze==="major"||ze==="minor"||ze==="patch")&&ve[ze]!==Ne[ze])return ze},e.compareIdentifiers=Se;var pe=/^[0-9]+$/;function Se(J,Ee){var ve=pe.test(J),Ne=pe.test(Ee);return ve&&Ne&&(J=+J,Ee=+Ee),ve&&!Ne?-1:Ne&&!ve?1:J<Ee?-1:J>Ee?1:0}function Fe(J,Ee,ve){return new Q(J,ve).compare(new Q(Ee,ve))}function Be(J,Ee,ve){return Fe(J,Ee,ve)>0}function Xe(J,Ee,ve){return Fe(J,Ee,ve)<0}function ke(J,Ee,ve){return Fe(J,Ee,ve)===0}function ye(J,Ee,ve){return Fe(J,Ee,ve)!==0}function De(J,Ee,ve){return Fe(J,Ee,ve)>=0}function ae(J,Ee,ve){return Fe(J,Ee,ve)<=0}function ue(J,Ee,ve,Ne){var ze;switch(Ee){case"===":typeof J=="object"&&(J=J.version),typeof ve=="object"&&(ve=ve.version),ze=J===ve;break;case"!==":typeof J=="object"&&(J=J.version),typeof ve=="object"&&(ve=ve.version),ze=J!==ve;break;case"":case"=":case"==":ze=ke(J,ve,Ne);break;case"!=":ze=ye(J,ve,Ne);break;case">":ze=Be(J,ve,Ne);break;case">=":ze=De(J,ve,Ne);break;case"<":ze=Xe(J,ve,Ne);break;case"<=":ze=ae(J,ve,Ne);break;default:throw new TypeError("Invalid operator: "+Ee)}return ze}function ee(J,Ee){if(J instanceof ee){if(J.loose===Ee)return J;J=J.value}if(!(this instanceof ee))return new ee(J,Ee);w("comparator",J,Ee),this.loose=Ee,this.parse(J),this.semver===Z?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}e.rcompareIdentifiers=function(J,Ee){return Se(Ee,J)},e.major=function(J,Ee){return new Q(J,Ee).major},e.minor=function(J,Ee){return new Q(J,Ee).minor},e.patch=function(J,Ee){return new Q(J,Ee).patch},e.compare=Fe,e.compareLoose=function(J,Ee){return Fe(J,Ee,!0)},e.rcompare=function(J,Ee,ve){return Fe(Ee,J,ve)},e.sort=function(J,Ee){return J.sort(function(ve,Ne){return e.compare(ve,Ne,Ee)})},e.rsort=function(J,Ee){return J.sort(function(ve,Ne){return e.rcompare(ve,Ne,Ee)})},e.gt=Be,e.lt=Xe,e.eq=ke,e.neq=ye,e.gte=De,e.lte=ae,e.cmp=ue,e.Comparator=ee;var Z={};function k(J,Ee){if(J instanceof k)return J.loose===Ee?J:new k(J.raw,Ee);if(J instanceof ee)return new k(J.value,Ee);if(!(this instanceof k))return new k(J,Ee);if(this.loose=Ee,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function B(J){return!J||J.toLowerCase()==="x"||J==="*"}function V(J,Ee,ve,Ne,ze,Je,Ge,Pe,nt,X,Y,me,Ue){return((Ee=B(ve)?"":B(Ne)?">="+ve+".0.0":B(ze)?">="+ve+"."+Ne+".0":">="+Ee)+" "+(Pe=B(nt)?"":B(X)?"<"+(+nt+1)+".0.0":B(Y)?"<"+nt+"."+(+X+1)+".0":me?"<="+nt+"."+X+"."+Y+"-"+me:"<="+Pe)).trim()}function q(J,Ee){for(var ve=0;ve<J.length;ve++)if(!J[ve].test(Ee))return!1;if(Ee.prerelease.length){for(ve=0;ve<J.length;ve++)if(w(J[ve].semver),J[ve].semver!==Z&&J[ve].semver.prerelease.length>0){var Ne=J[ve].semver;if(Ne.major===Ee.major&&Ne.minor===Ee.minor&&Ne.patch===Ee.patch)return!0}return!1}return!0}function oe(J,Ee,ve){try{Ee=new k(Ee,ve)}catch{return!1}return Ee.test(J)}function ce(J,Ee,ve,Ne){var ze,Je,Ge,Pe,nt;switch(J=new Q(J,Ne),Ee=new k(Ee,Ne),ve){case">":ze=Be,Je=ae,Ge=Xe,Pe=">",nt=">=";break;case"<":ze=Xe,Je=De,Ge=Be,Pe="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(oe(J,Ee,Ne))return!1;for(var X=0;X<Ee.set.length;++X){var Y=Ee.set[X],me=null,Ue=null;if(Y.forEach(function(Ve){Ve.semver===Z&&(Ve=new ee(">=0.0.0")),me=me||Ve,Ue=Ue||Ve,ze(Ve.semver,me.semver,Ne)?me=Ve:Ge(Ve.semver,Ue.semver,Ne)&&(Ue=Ve)}),me.operator===Pe||me.operator===nt||(!Ue.operator||Ue.operator===Pe)&&Je(J,Ue.semver)||Ue.operator===nt&&Ge(J,Ue.semver))return!1}return!0}ee.prototype.parse=function(J){var Ee=this.loose?A[z]:A[G],ve=J.match(Ee);if(!ve)throw new TypeError("Invalid comparator: "+J);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new Q(ve[2],this.loose):this.semver=Z},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(J){return w("Comparator.test",J,this.loose),this.semver===Z||(typeof J=="string"&&(J=new Q(J,this.loose)),ue(J,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(J,Ee){if(!(J instanceof ee))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new k(J.value,Ee),oe(this.value,ve,Ee);if(J.operator==="")return ve=new k(this.value,Ee),oe(J.semver,ve,Ee);var Ne=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Je=this.semver.version===J.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Pe=ue(this.semver,"<",J.semver,Ee)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),nt=ue(this.semver,">",J.semver,Ee)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Ne||ze||Je&&Ge||Pe||nt},e.Range=k,k.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},k.prototype.toString=function(){return this.range},k.prototype.parseRange=function(J){var Ee=this.loose;J=J.trim(),w("range",J,Ee);var ve=Ee?A[re]:A[he];J=J.replace(ve,V),w("hyphen replace",J),J=J.replace(A[te],"$1$2$3"),w("comparator trim",J,A[te]),J=(J=(J=J.replace(A[U],"$1~")).replace(A[O],"$1^")).split(/\s+/).join(" ");var Ne=Ee?A[z]:A[G],ze=J.split(" ").map(function(Je){return function(Ge,Pe){return w("comp",Ge),Ge=function(nt,X){return nt.trim().split(/\s+/).map(function(Y){return function(me,Ue){w("caret",me,Ue);var Ve=Ue?A[W]:A[H];return me.replace(Ve,function(et,Ke,je,it,st){var ct;return w("caret",me,et,Ke,je,it,st),B(Ke)?ct="":B(je)?ct=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":B(it)?ct=Ke==="0"?">="+Ke+"."+je+".0 <"+Ke+"."+(+je+1)+".0":">="+Ke+"."+je+".0 <"+(+Ke+1)+".0.0":st?(w("replaceCaret pr",st),st.charAt(0)!=="-"&&(st="-"+st),ct=Ke==="0"?je==="0"?">="+Ke+"."+je+"."+it+st+" <"+Ke+"."+je+"."+(+it+1):">="+Ke+"."+je+"."+it+st+" <"+Ke+"."+(+je+1)+".0":">="+Ke+"."+je+"."+it+st+" <"+(+Ke+1)+".0.0"):(w("no pr"),ct=Ke==="0"?je==="0"?">="+Ke+"."+je+"."+it+" <"+Ke+"."+je+"."+(+it+1):">="+Ke+"."+je+"."+it+" <"+Ke+"."+(+je+1)+".0":">="+Ke+"."+je+"."+it+" <"+(+Ke+1)+".0.0"),w("caret return",ct),ct})}(Y,X)}).join(" ")}(Ge,Pe),w("caret",Ge),Ge=function(nt,X){return nt.trim().split(/\s+/).map(function(Y){return function(me,Ue){var Ve=Ue?A[$]:A[D];return me.replace(Ve,function(et,Ke,je,it,st){var ct;return w("tilde",me,et,Ke,je,it,st),B(Ke)?ct="":B(je)?ct=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":B(it)?ct=">="+Ke+"."+je+".0 <"+Ke+"."+(+je+1)+".0":st?(w("replaceTilde pr",st),st.charAt(0)!=="-"&&(st="-"+st),ct=">="+Ke+"."+je+"."+it+st+" <"+Ke+"."+(+je+1)+".0"):ct=">="+Ke+"."+je+"."+it+" <"+Ke+"."+(+je+1)+".0",w("tilde return",ct),ct})}(Y,X)}).join(" ")}(Ge,Pe),w("tildes",Ge),Ge=function(nt,X){return w("replaceXRanges",nt,X),nt.split(/\s+/).map(function(Y){return function(me,Ue){me=me.trim();var Ve=Ue?A[T]:A[v];return me.replace(Ve,function(et,Ke,je,it,st,ct){w("xRange",me,et,Ke,je,it,st,ct);var at=B(je),rt=at||B(it),_t=rt||B(st);return Ke==="="&&_t&&(Ke=""),at?et=Ke===">"||Ke==="<"?"<0.0.0":"*":Ke&&_t?(rt&&(it=0),_t&&(st=0),Ke===">"?(Ke=">=",rt?(je=+je+1,it=0,st=0):_t&&(it=+it+1,st=0)):Ke==="<="&&(Ke="<",rt?je=+je+1:it=+it+1),et=Ke+je+"."+it+"."+st):rt?et=">="+je+".0.0 <"+(+je+1)+".0.0":_t&&(et=">="+je+"."+it+".0 <"+je+"."+(+it+1)+".0"),w("xRange return",et),et})}(Y,X)}).join(" ")}(Ge,Pe),w("xrange",Ge),Ge=function(nt,X){return w("replaceStars",nt,X),nt.trim().replace(A[be],"")}(Ge,Pe),w("stars",Ge),Ge}(Je,Ee)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(Je){return!!Je.match(Ne)})),ze=ze.map(function(Je){return new ee(Je,Ee)})},k.prototype.intersects=function(J,Ee){if(!(J instanceof k))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Ne){return J.set.some(function(ze){return ze.every(function(Je){return Ne.intersects(Je,Ee)})})})})},e.toComparators=function(J,Ee){return new k(J,Ee).set.map(function(ve){return ve.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},k.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new Q(J,this.loose));for(var Ee=0;Ee<this.set.length;Ee++)if(q(this.set[Ee],J))return!0;return!1},e.satisfies=oe,e.maxSatisfying=function(J,Ee,ve){var Ne=null,ze=null;try{var Je=new k(Ee,ve)}catch{return null}return J.forEach(function(Ge){Je.test(Ge)&&(Ne&&ze.compare(Ge)!==-1||(ze=new Q(Ne=Ge,ve)))}),Ne},e.minSatisfying=function(J,Ee,ve){var Ne=null,ze=null;try{var Je=new k(Ee,ve)}catch{return null}return J.forEach(function(Ge){Je.test(Ge)&&(Ne&&ze.compare(Ge)!==1||(ze=new Q(Ne=Ge,ve)))}),Ne},e.validRange=function(J,Ee){try{return new k(J,Ee).range||"*"}catch{return null}},e.ltr=function(J,Ee,ve){return ce(J,Ee,"<",ve)},e.gtr=function(J,Ee,ve){return ce(J,Ee,">",ve)},e.outside=ce,e.prerelease=function(J,Ee){var ve=fe(J,Ee);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(J,Ee,ve){return J=new k(J,ve),Ee=new k(Ee,ve),J.intersects(Ee)},e.coerce=function(J){if(J instanceof Q)return J;if(typeof J!="string")return null;var Ee=J.match(A[M]);return Ee==null?null:fe((Ee[1]||"0")+"."+(Ee[2]||"0")+"."+(Ee[3]||"0"))}}).call(this,r(1))},function(ne,e){var r,C,w=ne.exports={};function F(){throw new Error("setTimeout has not been defined")}function y(){throw new Error("clearTimeout has not been defined")}function A(l){if(r===setTimeout)return setTimeout(l,0);if((r===F||!r)&&setTimeout)return r=setTimeout,setTimeout(l,0);try{return r(l,0)}catch{try{return r.call(null,l,0)}catch{return r.call(this,l,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:F}catch{r=F}try{C=typeof clearTimeout=="function"?clearTimeout:y}catch{C=y}})();var E,P=[],R=!1,b=-1;function g(){R&&E&&(R=!1,E.length?P=E.concat(P):b=-1,P.length&&I())}function I(){if(!R){var l=A(g);R=!0;for(var d=P.length;d;){for(E=P,P=[];++b<d;)E&&E[b].run();b=-1,d=P.length}E=null,R=!1,function(m){if(C===clearTimeout)return clearTimeout(m);if((C===y||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(m);try{C(m)}catch{try{return C.call(null,m)}catch{return C.call(this,m)}}}(l)}}function p(l,d){this.fun=l,this.array=d}function a(){}w.nextTick=function(l){var d=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)d[m-1]=arguments[m];P.push(new p(l,d)),P.length!==1||R||A(I)},p.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=a,w.addListener=a,w.once=a,w.off=a,w.removeListener=a,w.removeAllListeners=a,w.emit=a,w.prependListener=a,w.prependOnceListener=a,w.listeners=function(l){return[]},w.binding=function(l){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(l){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(Ce[108],Ie([1,0,12,7]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function w(c){const _=c;return _?typeof _.read=="function":!1}e.isReadable=w;function F(c){const _=c;return _?[_.on,_.pause,_.resume,_.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=F;function y(c){const _=c;return _?F(_.stream)&&Array.isArray(_.buffer)&&typeof _.ended=="boolean":!1}e.isReadableBufferedStream=y;function A(c,_){return new E(c,_)}e.newWriteableStream=A;class E{constructor(_,t){this.reducer=_,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(_){if(!this.state.destroyed){if(this.state.flowing)this.emitData(_);else if(this.buffer.data.push(_),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(_){this.state.destroyed||(this.state.flowing?this.emitError(_):this.buffer.error.push(_))}end(_){this.state.destroyed||(typeof _<"u"&&this.write(_),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(_){this.listeners.data.slice(0).forEach(t=>t(_))}emitError(_){this.listeners.error.length===0?(0,r.onUnexpectedError)(_):this.listeners.error.slice(0).forEach(t=>t(_))}emitEnd(){this.listeners.end.slice(0).forEach(_=>_())}on(_,t){if(!this.state.destroyed)switch(_){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(_,t){if(this.state.destroyed)return;let u;switch(_){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const i=u.indexOf(t);i>=0&&u.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const _=this.reducer(this.buffer.data);this.emitData(_),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const _ of this.buffer.error)this.emitError(_);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(c,_){const t=[];let u;for(;(u=c.read())!==null;)t.push(u);return _(t)}e.consumeReadable=P;function R(c,_,t){const u=[];let i;for(;(i=c.read())!==null&&u.length<t;)u.push(i);return i===null&&u.length>0?_(u):{read:()=>{if(u.length>0)return u.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return c.read()}}}e.peekReadable=R;function b(c,_){return new Promise((t,u)=>{const i=[];g(c,{onData:n=>{_&&i.push(n)},onError:n=>{_?u(n):t(void 0)},onEnd:()=>{t(_?_(i):void 0)}})})}e.consumeStream=b;function g(c,_){let t=!1;return c.on("error",u=>{t||_.onError(u)}),c.on("end",()=>{t||_.onEnd()}),c.on("data",u=>{t||_.onData(u)}),(0,C.toDisposable)(()=>t=!0)}e.listenStream=g;function I(c,_){return new Promise((t,u)=>{const i=new C.DisposableStore,n=[],s=f=>{if(n.push(f),n.length>_)return i.dispose(),c.pause(),t({stream:c,buffer:n,ended:!1})},h=f=>u(f),o=()=>t({stream:c,buffer:n,ended:!0});i.add((0,C.toDisposable)(()=>c.removeListener("error",h))),c.on("error",h),i.add((0,C.toDisposable)(()=>c.removeListener("end",o))),c.on("end",o),i.add((0,C.toDisposable)(()=>c.removeListener("data",s))),c.on("data",s)})}e.peekStream=I;function p(c,_){const t=A(_);return t.end(c),t}e.toStream=p;function a(){const c=A(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=a;function l(c){let _=!1;return{read:()=>_?null:(_=!0,c)}}e.toReadable=l;function d(c,_,t){const u=A(t);return g(c,{onData:i=>u.write(_.data(i)),onError:i=>u.error(_.error?_.error(i):i),onEnd:()=>u.end()}),u}e.transform=d;function m(c,_,t){let u=!1;return{read:()=>{const i=_.read();return u?i:(u=!0,i!==null?t([c,i]):c)}}}e.prefixedReadable=m;function S(c,_,t){let u=!1;const i=A(t);return g(_,{onData:n=>u?i.write(n):(u=!0,i.write(t([c,n]))),onError:n=>i.error(n),onEnd:()=>{u||(u=!0,i.write(c)),i.end()}}),i}e.prefixedStream=S}),define(Ce[23],Ie([1,0,108]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer<"u";let w,F;class y{static alloc(f){return C?new y(Buffer.allocUnsafe(f)):new y(new Uint8Array(f))}static wrap(f){return C&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new y(f)}static fromString(f,v){return!(v?.dontUseNodeBuffer||!1)&&C?new y(Buffer.from(f)):(w||(w=new TextEncoder),new y(w.encode(f)))}static fromByteArray(f){const v=y.alloc(f.length);for(let T=0,M=f.length;T<M;T++)v.buffer[T]=f[T];return v}static concat(f,v){if(typeof v>"u"){v=0;for(let j=0,U=f.length;j<U;j++)v+=f[j].byteLength}const T=y.alloc(v);let M=0;for(let j=0,U=f.length;j<U;j++){const D=f[j];T.set(D,M),M+=D.byteLength}return T}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=y.alloc(this.byteLength);return f.set(this),f}toString(){return C?this.buffer.toString():(F||(F=new TextDecoder),F.decode(this.buffer))}slice(f,v){return new y(this.buffer.subarray(f,v))}set(f,v){if(f instanceof y)this.buffer.set(f.buffer,v);else if(f instanceof Uint8Array)this.buffer.set(f,v);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),v);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return P(this.buffer,f)}writeUInt32BE(f,v){R(this.buffer,f,v)}readUInt32LE(f){return b(this.buffer,f)}writeUInt32LE(f,v){g(this.buffer,f,v)}readUInt8(f){return I(this.buffer,f)}writeUInt8(f,v){p(this.buffer,f,v)}}e.VSBuffer=y;function A(o,f){return o[f+0]<<0>>>0|o[f+1]<<8>>>0}e.readUInt16LE=A;function E(o,f,v){o[v+0]=f&255,f=f>>>8,o[v+1]=f&255}e.writeUInt16LE=E;function P(o,f){return o[f]*2**24+o[f+1]*2**16+o[f+2]*2**8+o[f+3]}e.readUInt32BE=P;function R(o,f,v){o[v+3]=f,f=f>>>8,o[v+2]=f,f=f>>>8,o[v+1]=f,f=f>>>8,o[v]=f}e.writeUInt32BE=R;function b(o,f){return o[f+0]<<0>>>0|o[f+1]<<8>>>0|o[f+2]<<16>>>0|o[f+3]<<24>>>0}e.readUInt32LE=b;function g(o,f,v){o[v+0]=f&255,f=f>>>8,o[v+1]=f&255,f=f>>>8,o[v+2]=f&255,f=f>>>8,o[v+3]=f&255}e.writeUInt32LE=g;function I(o,f){return o[f]}e.readUInt8=I;function p(o,f,v){o[v]=f}e.writeUInt8=p;function a(o){return r.consumeReadable(o,f=>y.concat(f))}e.readableToBuffer=a;function l(o){return r.toReadable(o)}e.bufferToReadable=l;function d(o){return r.consumeStream(o,f=>y.concat(f))}e.streamToBuffer=d;async function m(o){return o.ended?y.concat(o.buffer):y.concat([...o.buffer,await d(o.stream)])}e.bufferedStreamToBuffer=m;function S(o){return r.toStream(o,f=>y.concat(f))}e.bufferToStream=S;function c(o){return r.transform(o,{data:f=>typeof f=="string"?y.fromString(f):y.wrap(f)},f=>y.concat(f))}e.streamToBufferReadableStream=c;function _(o){return r.newWriteableStream(f=>y.concat(f),o)}e.newWriteableBufferStream=_;function t(o,f){return r.prefixedReadable(o,f,v=>y.concat(v))}e.prefixedBufferReadable=t;function u(o,f){return r.prefixedStream(o,f,v=>y.concat(v))}e.prefixedBufferStream=u;function i(o){let f=0,v=0,T=0;const M=new Uint8Array(Math.floor(o.length/4*3)),j=D=>{switch(v){case 3:M[T++]=f|D,v=0;break;case 2:M[T++]=f|D>>>2,f=D<<6,v=3;break;case 1:M[T++]=f|D>>>4,f=D<<4,v=2;break;default:f=D<<2,v=1}};for(let D=0;D<o.length;D++){const $=o.charCodeAt(D);if($>=65&&$<=90)j($-65);else if($>=97&&$<=122)j($-97+26);else if($>=48&&$<=57)j($-48+52);else if($===43||$===45)j(62);else if($===47||$===95)j(63);else{if($===61)break;throw new SyntaxError(`Unexpected base64 character ${o[D]}`)}}const U=T;for(;v>0;)j(0);return y.wrap(M).slice(0,U)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:o},f=!0,v=!1){const T=v?s:n;let M="";const j=o.byteLength%3;let U=0;for(;U<o.byteLength-j;U+=3){const D=o[U+0],$=o[U+1],L=o[U+2];M+=T[D>>>2],M+=T[(D<<4|$>>>4)&63],M+=T[($<<2|L>>>6)&63],M+=T[L&63]}if(j===1){const D=o[U+0];M+=T[D>>>2],M+=T[D<<4&63],f&&(M+="==")}else if(j===2){const D=o[U+0],$=o[U+1];M+=T[D>>>2],M+=T[(D<<4|$>>>4)&63],M+=T[$<<2&63],f&&(M+="=")}return M}e.encodeBase64=h}),define(Ce[38],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(w){return r.test(w)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let w;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?w=crypto.getRandomValues.bind(crypto):w=function(A){for(let E=0;E<A.length;E++)A[E]=Math.floor(Math.random()*256);return A};const F=new Uint8Array(16),y=[];for(let A=0;A<256;A++)y.push(A.toString(16).padStart(2,"0"));return function(){w(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let E=0,P="";return P+=y[F[E++]],P+=y[F[E++]],P+=y[F[E++]],P+=y[F[E++]],P+="-",P+=y[F[E++]],P+=y[F[E++]],P+="-",P+=y[F[E++]],P+=y[F[E++]],P+="-",P+=y[F[E++]],P+=y[F[E++]],P+="-",P+=y[F[E++]],P+=y[F[E++]],P+=y[F[E++]],P+=y[F[E++]],P+=y[F[E++]],P+=y[F[E++]],P}}()}),define(Ce[109],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[110],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var r;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(r=e.IndentAction||(e.IndentAction={}));class C{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let E=0,P=A.notIn.length;E<P;E++)switch(A.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,E){if(A.getTokenCount()===0)return!0;const P=A.findTokenIndexAtOffset(E-2),R=A.getStandardTokenType(P);return this.isOK(R)}_findNeutralCharacterInRange(A,E){for(let P=A;P<=E;P++){const R=String.fromCharCode(P);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=C;class w{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of A)F(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),F(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),F(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),F(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&F(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=w;function F(y,A,E){y.has(A)?y.get(A).push(E):y.set(A,[E])}}),define(Ce[111],Ie([16,17]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(Ce[112],Ie([1,0,111]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,w=C*60,F=w*24,y=F*7,A=F*30,E=F*365;function P(b,g,I){typeof b!="number"&&(b=b.getTime());const p=Math.round((new Date().getTime()-b)/1e3);if(p<-30)return(0,r.localize)(0,null,P(new Date().getTime()+p*1e3,!1));if(p<30)return(0,r.localize)(1,null);let a;return p<C?(a=p,g?a===1?I?(0,r.localize)(2,null,a):(0,r.localize)(3,null,a):I?(0,r.localize)(4,null,a):(0,r.localize)(5,null,a):a===1?I?(0,r.localize)(6,null,a):(0,r.localize)(7,null,a):I?(0,r.localize)(8,null,a):(0,r.localize)(9,null,a)):p<w?(a=Math.floor(p/C),g?a===1?I?(0,r.localize)(10,null,a):(0,r.localize)(11,null,a):I?(0,r.localize)(12,null,a):(0,r.localize)(13,null,a):a===1?I?(0,r.localize)(14,null,a):(0,r.localize)(15,null,a):I?(0,r.localize)(16,null,a):(0,r.localize)(17,null,a)):p<F?(a=Math.floor(p/w),g?a===1?I?(0,r.localize)(18,null,a):(0,r.localize)(19,null,a):I?(0,r.localize)(20,null,a):(0,r.localize)(21,null,a):a===1?I?(0,r.localize)(22,null,a):(0,r.localize)(23,null,a):I?(0,r.localize)(24,null,a):(0,r.localize)(25,null,a)):p<y?(a=Math.floor(p/F),g?a===1?(0,r.localize)(26,null,a):(0,r.localize)(27,null,a):a===1?(0,r.localize)(28,null,a):(0,r.localize)(29,null,a)):p<A?(a=Math.floor(p/y),g?a===1?I?(0,r.localize)(30,null,a):(0,r.localize)(31,null,a):I?(0,r.localize)(32,null,a):(0,r.localize)(33,null,a):a===1?I?(0,r.localize)(34,null,a):(0,r.localize)(35,null,a):I?(0,r.localize)(36,null,a):(0,r.localize)(37,null,a)):p<E?(a=Math.floor(p/A),g?a===1?I?(0,r.localize)(38,null,a):(0,r.localize)(39,null,a):I?(0,r.localize)(40,null,a):(0,r.localize)(41,null,a):a===1?I?(0,r.localize)(42,null,a):(0,r.localize)(43,null,a):I?(0,r.localize)(44,null,a):(0,r.localize)(45,null,a)):(a=Math.floor(p/E),g?a===1?I?(0,r.localize)(46,null,a):(0,r.localize)(47,null,a):I?(0,r.localize)(48,null,a):(0,r.localize)(49,null,a):a===1?I?(0,r.localize)(50,null,a):(0,r.localize)(51,null,a):I?(0,r.localize)(52,null,a):(0,r.localize)(53,null,a))}e.fromNow=P;function R(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Ce[113],Ie([16,17]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(Ce[44],Ie([1,0,18,10,113]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function F(b,g){return g&&(b.stack||b.stacktrace)?w.localize(0,null,A(b),y(b.stack)||y(b.stacktrace)):A(b)}function y(b){return Array.isArray(b)?b.join(`
`):b}function A(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?w.localize(1,null,b.message):b.message||w.localize(2,null)}function E(b=null,g=!1){if(!b)return w.localize(3,null);if(Array.isArray(b)){const I=r.coalesce(b),p=E(I[0],g);return I.length>1?w.localize(4,null,p,I.length):p}if(C.isString(b))return b;if(b.detail){const I=b.detail;if(I.error)return F(I.error,g);if(I.exception)return F(I.exception,g)}return b.stack?F(b,g):b.message?b.message:w.localize(5,null)}e.toErrorMessage=E;function P(b){const g=b;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=P;function R(b,g){let I;return typeof b=="string"?I=new Error(b):I=b,I.actions=g,I}e.createErrorWithActions=R}),define(Ce[77],Ie([1,0,19]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(R){const b=(0,r.extname)(R),g=C[b.toLowerCase()];return g!==void 0?g:y(R)}e.getMediaOrTextMime=F;function y(R){const b=(0,r.extname)(R);return w[b.toLowerCase()]}e.getMediaMime=y;function A(R){for(const b in w)if(w[b]===R)return b}e.getExtensionForMimeType=A;const E=/^(.+)\/(.+?)(;.+)?$/;function P(R,b){const g=E.exec(R);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:b?void 0:R}e.normalizeMimeType=P}),define(Ce[114],Ie([1,0,4,7]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const w=y=>({onDidChange:r.Event.None,value:y});e.staticObservableValue=w;class F extends C.Disposable{get value(){return this._value}set value(A){A!==this._value&&(this._value=A,this.changeEmitter.fire(A))}constructor(A){super(),this._value=A,this.changeEmitter=this._register(new r.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=F}),define(Ce[39],Ie([1,0,19,20,9,10]),function(ne,e,r,C,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(s){return s===47||s===92}e.isPathSeparator=y;function A(s){return s.replace(/[\\/]/g,r.posix.sep)}e.toSlashes=A;function E(s){return s.indexOf("/")===-1&&(s=A(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=E;function P(s,h=r.posix.sep){if(!s)return"";const o=s.length,f=s.charCodeAt(0);if(y(f)){if(y(s.charCodeAt(1))&&!y(s.charCodeAt(2))){let T=3;const M=T;for(;T<o&&!y(s.charCodeAt(T));T++);if(M!==T&&!y(s.charCodeAt(T+1))){for(T+=1;T<o;T++)if(y(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,h)}}return h}else if(d(f)&&s.charCodeAt(1)===58)return y(s.charCodeAt(2))?s.slice(0,2)+h:s.slice(0,2);let v=s.indexOf("://");if(v!==-1){for(v+=3;v<o;v++)if(y(s.charCodeAt(v)))return s.slice(0,v+1)}return""}e.getRoot=P;function R(s){if(!C.isWindows||!s||s.length<5)return!1;let h=s.charCodeAt(0);if(h!==92||(h=s.charCodeAt(1),h!==92))return!1;let o=2;const f=o;for(;o<s.length&&(h=s.charCodeAt(o),h!==92);o++);return!(f===o||(h=s.charCodeAt(o+1),isNaN(h)||h===92))}e.isUNC=R;const b=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(s,h=C.isWindows){const o=h?b:g;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||h&&I.test(s)||s==="."||s===".."||h&&s[s.length-1]==="."||h&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=p;function a(s,h,o){const f=s===h;return!o||f?f:!s||!h?!1:(0,w.equalsIgnoreCase)(s,h)}e.isEqual=a;function l(s,h,o,f=r.sep){if(s===h)return!0;if(!s||!h||h.length>s.length)return!1;if(o){if(!(0,w.startsWithIgnoreCase)(s,h))return!1;if(h.length===s.length)return!0;let T=h.length;return h.charAt(h.length-1)===f&&T--,s.charAt(T)===f}return h.charAt(h.length-1)!==f&&(h+=f),s.indexOf(h)===0}e.isEqualOrParent=l;function d(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=d;function m(s,h){return C.isWindows&&s.endsWith(":")&&(s+=r.sep),(0,r.isAbsolute)(s)||(s=(0,r.join)(h,s)),s=(0,r.normalize)(s),C.isWindows?(s=(0,w.rtrim)(s,r.sep),s.endsWith(":")&&(s+=r.sep)):(s=(0,w.rtrim)(s,r.sep),s||(s=r.sep)),s}e.sanitizeFilePath=m;function S(s){const h=(0,r.normalize)(s);return C.isWindows?s.length>3?!1:c(h)&&(s.length===2||h.charCodeAt(2)===92):h===r.posix.sep}e.isRootOrDriveLetter=S;function c(s,h=C.isWindows){return h?d(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function _(s){return c(s)?s[0]:void 0}e.getDriveLetter=_;function t(s,h,o){return h.length>s.length?-1:s===h?0:(o&&(s=s.toLowerCase(),h=h.toLowerCase()),s.indexOf(h))}e.indexOfPath=t;function u(s){const h=s.split(":");let o,f,v;for(const T of h){const M=Number(T);(0,F.isNumber)(M)?f===void 0?f=M:v===void 0&&(v=M):o=o?[o,T].join(":"):T}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:f!==void 0?f:void 0,column:v!==void 0?v:f!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,h,o=8){let f="";for(let T=0;T<o;T++)f+=i.charAt(Math.floor(Math.random()*i.length));let v;return h?v=`${h}-${f}`:v=f,s?(0,r.join)(s,v):v}e.randomPath=n}),define(Ce[25],Ie([1,0,18,9]),function(ne,e,r,C){"use strict";var w,F,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(i,n,s){let h=i.get(n);return h===void 0&&(h=s,i.set(n,h)),h}e.getOrSet=A;function E(i){const n=[];return i.forEach((s,h)=>{n.push(`${h} => ${s}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=E;function P(i){const n=[];return i.forEach(s=>{n.push(s)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=P;class R{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),h=this._value.charCodeAt(this._pos);return s-h}value(){return this._value[this._pos]}}e.StringIterator=R;class b{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,C.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class g{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let s=n.length-1;s>=0;s--,this._valueLen--){const h=this._value.charCodeAt(s);if(!(h===47||this._splitOnBackslash&&h===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,C.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var I;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(I||(I={}));class p{constructor(n,s){this._ignorePathCasing=n,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,C.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,C.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,C.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,C.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var l;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(l||(l={}));class d{static forUris(n=()=>!1,s=()=>!1){return new d(new p(n,s))}static forPaths(n=!1){return new d(new g(void 0,!n))}static forStrings(){return new d(new R)}static forConfigKeys(){return new d(new b)}constructor(n){this._iter=n}clear(){this._root=void 0}fill(n,s){if(s){const h=s.slice(0);(0,r.shuffle)(h);for(const o of h)this.set(o,n)}else{const h=n.slice(0);(0,r.shuffle)(h);for(const o of h)this.set(o[0],o[1])}}set(n,s){const h=this._iter.reset(n);let o;this._root||(this._root=new a,this._root.segment=h.value());const f=[];for(o=this._root;;){const T=h.cmp(o.segment);if(T>0)o.left||(o.left=new a,o.left.segment=h.value()),f.push([-1,o]),o=o.left;else if(T<0)o.right||(o.right=new a,o.right.segment=h.value()),f.push([1,o]),o=o.right;else if(h.hasNext())h.next(),o.mid||(o.mid=new a,o.mid.segment=h.value()),f.push([0,o]),o=o.mid;else break}const v=o.value;o.value=s,o.key=n;for(let T=f.length-1;T>=0;T--){const M=f[T][1];M.updateHeight();const j=M.balanceFactor();if(j<-1||j>1){const U=f[T][0],D=f[T+1][0];if(U===1&&D===1)f[T][1]=M.rotateLeft();else if(U===-1&&D===-1)f[T][1]=M.rotateRight();else if(U===1&&D===-1)M.right=f[T+1][1]=f[T+1][1].rotateRight(),f[T][1]=M.rotateLeft();else if(U===-1&&D===1)M.left=f[T+1][1]=f[T+1][1].rotateLeft(),f[T][1]=M.rotateRight();else throw new Error;if(T>0)switch(f[T-1][0]){case-1:f[T-1][1].left=f[T][1];break;case 1:f[T-1][1].right=f[T][1];break;case 0:f[T-1][1].mid=f[T][1];break}else this._root=f[0][1]}}return v}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let h=this._root;for(;h;){const o=s.cmp(h.segment);if(o>0)h=h.left;else if(o<0)h=h.right;else if(s.hasNext())s.next(),h=h.mid;else break}return h}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const h=this._iter.reset(n),o=[];let f=this._root;for(;f;){const v=h.cmp(f.segment);if(v>0)o.push([-1,f]),f=f.left;else if(v<0)o.push([1,f]),f=f.right;else if(h.hasNext())h.next(),o.push([0,f]),f=f.mid;else break}if(!!f){if(s?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const v=this._min(f.right);if(v.key){const{key:T,value:M,segment:j}=v;this._delete(v.key,!1),f.key=T,f.value=M,f.segment=j}}else{const v=f.left??f.right;if(o.length>0){const[T,M]=o[o.length-1];switch(T){case-1:M.left=v;break;case 0:M.mid=v;break;case 1:M.right=v;break}}else this._root=v}for(let v=o.length-1;v>=0;v--){const T=o[v][1];T.updateHeight();const M=T.balanceFactor();if(M>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),o[v][1]=T.rotateLeft()):M<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),o[v][1]=T.rotateRight()),v>0)switch(o[v-1][0]){case-1:o[v-1][1].left=o[v][1];break;case 1:o[v-1][1].right=o[v][1];break;case 0:o[v-1][1].mid=o[v][1];break}else this._root=o[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const s=this._iter.reset(n);let h=this._root,o;for(;h;){const f=s.cmp(h.segment);if(f>0)h=h.left;else if(f<0)h=h.right;else if(s.hasNext())s.next(),o=h.value||o,h=h.mid;else break}return h&&h.value||o}findSuperstr(n){const s=this._iter.reset(n);let h=this._root;for(;h;){const o=s.cmp(h.segment);if(o>0)h=h.left;else if(o<0)h=h.right;else if(s.hasNext())s.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(n){for(const[s,h]of this)n(h,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const s=[];return this._dfsEntries(n,s),s[Symbol.iterator]()}_dfsEntries(n,s){!n||(n.left&&this._dfsEntries(n.left,s),n.value&&s.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,s),n.right&&this._dfsEntries(n.right,s))}_isBalanced(){const n=s=>{if(!s)return!0;const h=s.balanceFactor();return h<-1||h>1?!1:n(s.left)&&n(s.right)};return n(this._root)}}e.TernarySearchTree=d;class m{constructor(n,s){this.uri=n,this.value=s}}class S{constructor(n,s){this[w]="ResourceMap",n instanceof S?(this.map=new Map(n.map),this.toKey=s??S.defaultToKey):(this.map=new Map,this.toKey=n??S.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),new m(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[h,o]of this.map)n(o.value,o.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=S,S.defaultToKey=i=>i.toString();class c{constructor(n,s){this[F]="ResourceSet",!n||typeof n=="function"?this._map=new S(n):(this._map=new S(s),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,s){this._map.forEach((h,o)=>n.call(s,o,o,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=c;var _;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(_=e.Touch||(e.Touch={}));class t{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const h=this._map.get(n);if(!!h)return s!==0&&this.touch(h,s),h.value}set(n,s,h=0){let o=this._map.get(n);if(o)o.value=s,h!==0&&this.touch(o,h);else{switch(o={key:n,value:s,next:void 0,previous:void 0},h){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const h=this._state;let o=this._head;for(;o;){if(s?n.bind(s)(o.value,o.key,this):n(o.value,o.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,s=this._state;let h=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(h){const f={value:h.key,done:!1};return h=h.next,f}else return{value:void 0,done:!0}}};return o}values(){const n=this,s=this._state;let h=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(h){const f={value:h.value,done:!1};return h=h.next,f}else return{value:void 0,done:!0}}};return o}entries(){const n=this,s=this._state;let h=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(h){const f={value:[h.key,h.value],done:!1};return h=h.next,f}else return{value:void 0,done:!0}}};return o}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,h=this.size;for(;s&&h>n;)this._map.delete(s.key),s=s.next,h--;this._head=s,this._size=h,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,h=n.previous;if(!s||!h)throw new Error("Invalid list");s.previous=h,h.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const h=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(h.previous=o,o.next=h),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const h=n.next,o=n.previous;n===this._head?(h.previous=void 0,this._head=h):(h.previous=o,o.next=h),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,h)=>{n.push([h,s])}),n}fromJSON(n){this.clear();for(const[s,h]of n)this.set(s,h)}}e.LinkedMap=t;class u extends t{constructor(n,s=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u}),define(Ce[115],Ie([1,0,25,9]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...ee){return function(Z,k){for(let B=0,V=ee.length;B<V;B++){const q=ee[B](Z,k);if(q)return q}return null}}e.or=w,e.matchesStrictPrefix=F.bind(void 0,!1),e.matchesPrefix=F.bind(void 0,!0);function F(ee,Z,k){if(!k||k.length<Z.length)return null;let B;return ee?B=C.startsWithIgnoreCase(k,Z):B=k.indexOf(Z)===0,B?Z.length>0?[{start:0,end:Z.length}]:[]:null}function y(ee,Z){const k=Z.toLowerCase().indexOf(ee.toLowerCase());return k===-1?null:[{start:k,end:k+ee.length}]}e.matchesContiguousSubString=y;function A(ee,Z){return E(ee.toLowerCase(),Z.toLowerCase(),0,0)}e.matchesSubString=A;function E(ee,Z,k,B){if(k===ee.length)return[];if(B===Z.length)return null;if(ee[k]===Z[B]){let V=null;return(V=E(ee,Z,k+1,B+1))?d({start:B,end:B+1},V):null}return E(ee,Z,k,B+1)}function P(ee){return 97<=ee&&ee<=122}function R(ee){return 65<=ee&&ee<=90}e.isUpper=R;function b(ee){return 48<=ee&&ee<=57}function g(ee){return ee===32||ee===9||ee===10||ee===13}const I=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>I.add(ee.charCodeAt(0)));function p(ee){return g(ee)||I.has(ee)}function a(ee,Z){return ee===Z||p(ee)&&p(Z)}function l(ee){return P(ee)||R(ee)||b(ee)}function d(ee,Z){return Z.length===0?Z=[ee]:ee.end===Z[0].start?Z[0].start=ee.start:Z.unshift(ee),Z}function m(ee,Z){for(let k=Z;k<ee.length;k++){const B=ee.charCodeAt(k);if(R(B)||b(B)||k>0&&!l(ee.charCodeAt(k-1)))return k}return ee.length}function S(ee,Z,k,B){if(k===ee.length)return[];if(B===Z.length)return null;if(ee[k]!==Z[B].toLowerCase())return null;{let V=null,q=B+1;for(V=S(ee,Z,k+1,B+1);!V&&(q=m(Z,q))<Z.length;)V=S(ee,Z,k+1,q),q++;return V===null?null:d({start:B,end:B+1},V)}}function c(ee){let Z=0,k=0,B=0,V=0,q=0;for(let ve=0;ve<ee.length;ve++)q=ee.charCodeAt(ve),R(q)&&Z++,P(q)&&k++,l(q)&&B++,b(q)&&V++;const oe=Z/ee.length,ce=k/ee.length,J=B/ee.length,Ee=V/ee.length;return{upperPercent:oe,lowerPercent:ce,alphaPercent:J,numericPercent:Ee}}function _(ee){const{upperPercent:Z,lowerPercent:k}=ee;return k===0&&Z>.6}function t(ee){const{upperPercent:Z,lowerPercent:k,alphaPercent:B,numericPercent:V}=ee;return k>.2&&Z<.8&&B>.6&&V<.2}function u(ee){let Z=0,k=0,B=0,V=0;for(let q=0;q<ee.length;q++)B=ee.charCodeAt(q),R(B)&&Z++,P(B)&&k++,g(B)&&V++;return(Z===0||k===0)&&V===0?ee.length<=30:Z<=5}function i(ee,Z){if(!Z||(Z=Z.trim(),Z.length===0)||!u(ee)||Z.length>60)return null;const k=c(Z);if(!t(k)){if(!_(k))return null;Z=Z.toLowerCase()}let B=null,V=0;for(ee=ee.toLowerCase();V<Z.length&&(B=S(ee,Z,0,V))===null;)V=m(Z,V+1);return B}e.matchesCamelCase=i;function n(ee,Z,k=!1){if(!Z||Z.length===0)return null;let B=null,V=0;for(ee=ee.toLowerCase(),Z=Z.toLowerCase();V<Z.length&&(B=s(ee,Z,0,V,k))===null;)V=h(Z,V+1);return B}e.matchesWords=n;function s(ee,Z,k,B,V){if(k===ee.length)return[];if(B===Z.length)return null;if(a(ee.charCodeAt(k),Z.charCodeAt(B))){let q=null,oe=B+1;if(q=s(ee,Z,k+1,B+1,V),!V)for(;!q&&(oe=h(Z,oe))<Z.length;)q=s(ee,Z,k+1,oe,V),oe++;return q?ee.charCodeAt(k)!==Z.charCodeAt(B)?q:d({start:B,end:B+1},q):null}else return null}function h(ee,Z){for(let k=Z;k<ee.length;k++)if(p(ee.charCodeAt(k))||k>0&&p(ee.charCodeAt(k-1)))return k;return ee.length}const o=w(e.matchesPrefix,i,y),f=w(e.matchesPrefix,i,A),v=new r.LRUCache(1e4);function T(ee,Z,k=!1){if(typeof ee!="string"||typeof Z!="string")return null;let B=v.get(ee);B||(B=new RegExp(C.convertSimple2RegExpPattern(ee),"i"),v.set(ee,B));const V=B.exec(Z);return V?[{start:V.index,end:V.index+V[0].length}]:k?f(ee,Z):o(ee,Z)}e.matchesFuzzy=T;function M(ee,Z){const k=Be(ee,ee.toLowerCase(),0,Z,Z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return k?U(k):null}e.matchesFuzzy2=M;function j(ee,Z,k,B,V,q){const oe=Math.min(13,ee.length);for(;k<oe;k++){const ce=Be(ee,Z,k,B,V,q,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(ce)return ce}return[0,q]}e.anyScore=j;function U(ee){if(typeof ee>"u")return[];const Z=[],k=ee[1];for(let B=ee.length-1;B>1;B--){const V=ee[B]+k,q=Z[Z.length-1];q&&q.end===V?q.end=V+1:Z.push({start:V,end:V+1})}return Z}e.createMatches=U;const D=128;function $(){const ee=[],Z=[];for(let k=0;k<=D;k++)Z[k]=0;for(let k=0;k<=D;k++)ee.push(Z.slice(0));return ee}function L(ee){const Z=[];for(let k=0;k<=ee;k++)Z[k]=0;return Z}const O=L(2*D),H=L(2*D),W=$(),z=$(),G=$(),te=!1;function he(ee,Z,k,B,V){function q(ce,J,Ee=" "){for(;ce.length<J;)ce=Ee+ce;return ce}let oe=` |   |${B.split("").map(ce=>q(ce,3)).join("|")}
`;for(let ce=0;ce<=k;ce++)ce===0?oe+=" |":oe+=`${Z[ce-1]}|`,oe+=ee[ce].slice(0,V+1).map(J=>q(J.toString(),3)).join("|")+`
`;return oe}function re(ee,Z,k,B){ee=ee.substr(Z),k=k.substr(B),console.log(he(z,ee,ee.length,k,k.length)),console.log(he(G,ee,ee.length,k,k.length)),console.log(he(W,ee,ee.length,k,k.length))}function be(ee,Z){if(Z<0||Z>=ee.length)return!1;const k=ee.codePointAt(Z);switch(k){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(k)}}function le(ee,Z){if(Z<0||Z>=ee.length)return!1;switch(ee.charCodeAt(Z)){case 32:case 9:return!0;default:return!1}}function fe(ee,Z,k){return Z[ee]!==k[ee]}function Q(ee,Z,k,B,V,q,oe=!1){for(;Z<k&&V<q;)ee[Z]===B[V]&&(oe&&(O[Z]=V),Z+=1),V+=1;return Z===k}e.isPatternInWord=Q;var pe;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var Se;(function(ee){ee.Default=[-100,0];function Z(k){return!k||k.length===2&&k[0]===-100&&k[1]===0}ee.isDefault=Z})(Se=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(Z,k){this.firstMatchCanBeWeak=Z,this.boostFullMatch=k}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Be(ee,Z,k,B,V,q,oe=Fe.default){const ce=ee.length>D?D:ee.length,J=B.length>D?D:B.length;if(k>=ce||q>=J||ce-k>J-q||!Q(Z,k,ce,V,q,J,!0))return;Xe(ce,J,k,q,Z,V);let Ee=1,ve=1,Ne=k,ze=q;const Je=[!1];for(Ee=1,Ne=k;Ne<ce;Ee++,Ne++){const Y=O[Ne],me=H[Ne],Ue=Ne+1<ce?H[Ne+1]:J;for(ve=Y-q+1,ze=Y;ze<Ue;ve++,ze++){let Ve=Number.MIN_SAFE_INTEGER,et=!1;ze<=me&&(Ve=ke(ee,Z,Ne,k,B,V,ze,J,q,W[Ee-1][ve-1]===0,Je));let Ke=0;Ve!==Number.MAX_SAFE_INTEGER&&(et=!0,Ke=Ve+z[Ee-1][ve-1]);const je=ze>Y,it=je?z[Ee][ve-1]+(W[Ee][ve-1]>0?-5:0):0,st=ze>Y+1&&W[Ee][ve-1]>0,ct=st?z[Ee][ve-2]+(W[Ee][ve-2]>0?-5:0):0;if(st&&(!je||ct>=it)&&(!et||ct>=Ke))z[Ee][ve]=ct,G[Ee][ve]=3,W[Ee][ve]=0;else if(je&&(!et||it>=Ke))z[Ee][ve]=it,G[Ee][ve]=2,W[Ee][ve]=0;else if(et)z[Ee][ve]=Ke,G[Ee][ve]=1,W[Ee][ve]=W[Ee-1][ve-1]+1;else throw new Error("not possible")}}if(te&&re(ee,k,B,q),!Je[0]&&!oe.firstMatchCanBeWeak)return;Ee--,ve--;const Ge=[z[Ee][ve],q];let Pe=0,nt=0;for(;Ee>=1;){let Y=ve;do{const me=G[Ee][Y];if(me===3)Y=Y-2;else if(me===2)Y=Y-1;else break}while(Y>=1);Pe>1&&Z[k+Ee-1]===V[q+ve-1]&&!fe(Y+q-1,B,V)&&Pe+1>W[Ee][Y]&&(Y=ve),Y===ve?Pe++:Pe=1,nt||(nt=Y),Ee--,ve=Y-1,Ge.push(ve)}J===ce&&oe.boostFullMatch&&(Ge[0]+=2);const X=nt-ce;return Ge[0]-=X,Ge}e.fuzzyScore=Be;function Xe(ee,Z,k,B,V,q){let oe=ee-1,ce=Z-1;for(;oe>=k&&ce>=B;)V[oe]===q[ce]&&(H[oe]=ce,oe--),ce--}function ke(ee,Z,k,B,V,q,oe,ce,J,Ee,ve){if(Z[k]!==q[oe])return Number.MIN_SAFE_INTEGER;let Ne=1,ze=!1;return oe===k-B?Ne=ee[k]===V[oe]?7:5:fe(oe,V,q)&&(oe===0||!fe(oe-1,V,q))?(Ne=ee[k]===V[oe]?7:5,ze=!0):be(q,oe)&&(oe===0||!be(q,oe-1))?Ne=5:(be(q,oe-1)||le(q,oe-1))&&(Ne=5,ze=!0),Ne>1&&k===B&&(ve[0]=!0),ze||(ze=fe(oe,V,q)||be(q,oe-1)||le(q,oe-1)),k===B?oe>J&&(Ne-=ze?3:5):Ee?Ne+=ze?2:0:Ne+=ze?0:1,oe+1===ce&&(Ne-=ze?3:5),Ne}function ye(ee,Z,k,B,V,q,oe){return ae(ee,Z,k,B,V,q,!0,oe)}e.fuzzyScoreGracefulAggressive=ye;function De(ee,Z,k,B,V,q,oe){return ae(ee,Z,k,B,V,q,!1,oe)}e.fuzzyScoreGraceful=De;function ae(ee,Z,k,B,V,q,oe,ce){let J=Be(ee,Z,k,B,V,q,ce);if(J&&!oe)return J;if(ee.length>=3){const Ee=Math.min(7,ee.length-1);for(let ve=k+1;ve<Ee;ve++){const Ne=ue(ee,ve);if(Ne){const ze=Be(Ne,Ne.toLowerCase(),k,B,V,q,ce);ze&&(ze[0]-=3,(!J||ze[0]>J[0])&&(J=ze))}}}return J}function ue(ee,Z){if(Z+1>=ee.length)return;const k=ee[Z],B=ee[Z+1];if(k!==B)return ee.slice(0,Z)+B+k+ee.slice(Z+2)}}),define(Ce[116],Ie([1,0,117,115,9]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const F=new RegExp(`\\$\\(${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(r.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${F.source}`,"g");function E(l){return l.replace(A,(d,m)=>m?d:`\\${d}`)}e.escapeIcons=E;const P=new RegExp(`\\\\${F.source}`,"g");function R(l){return l.replace(P,d=>`\\${d}`)}e.markdownEscapeEscapedIcons=R;const b=new RegExp(`(\\s)?(\\\\)?${F.source}(\\s)?`,"g");function g(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(b,(d,m,S,c)=>S?d:m||c||"")}e.stripIcons=g;function I(l){const d=l.indexOf(e.iconStartMarker);return d===-1?{text:l}:p(l,d)}e.parseLabelWithIcons=I;function p(l,d){const m=[];let S="";function c(o){if(o){S+=o;for(const f of o)m.push(u)}}let _=-1,t="",u=0,i,n,s=d;const h=l.length;for(c(l.substr(0,d));s<h;)i=l[s],n=l[s+1],i===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(_=s,c(t),t=e.iconStartMarker,s++):i===")"&&_!==-1?(u+=s-_+1,_=-1,t=""):_!==-1?y.test(i)?t+=i:(c(t),_=-1,t=""):c(i),s++;return c(t),{text:S,iconOffsets:m}}function a(l,d,m=!1){const{text:S,iconOffsets:c}=d;if(!c||c.length===0)return(0,C.matchesFuzzy)(l,S,m);const _=(0,w.ltrim)(S," "),t=S.length-_.length,u=(0,C.matchesFuzzy)(l,_,m);if(u)for(const i of u){const n=c[i.start+t]+t;i.start+=n,i.end+=n}return u}e.matchesFuzzyIconAware=a}),define(Ce[29],Ie([1,0,9]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(C||(C={})),function(w){const F="error",y="warning",A="warn",E="info",P="ignore";function R(g){return g?r.equalsIgnoreCase(F,g)?w.Error:r.equalsIgnoreCase(y,g)||r.equalsIgnoreCase(A,g)?w.Warning:r.equalsIgnoreCase(E,g)?w.Info:w.Ignore:w.Ignore}w.fromValue=R;function b(g){switch(g){case w.Error:return F;case w.Warning:return y;case w.Info:return E;default:return P}}w.toString=b}(C||(C={})),e.default=C}),define(Ce[78],Ie([1,0,23,9,2]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function F(P){return JSON.stringify(P,A)}e.stringify=F;function y(P){let R=JSON.parse(P);return R=E(R),R}e.parse=y;function A(P,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,C.regExpFlags)(R)}:R}function E(P,R=0){if(!P||R>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return w.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof r.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let b=0;b<P.length;++b)P[b]=E(P[b],R+1);else for(const b in P)Object.hasOwnProperty.call(P,b)&&(P[b]=E(P[b],R+1))}return P}e.revive=E}),define(Ce[13],Ie([1,0,20,2]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var w;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(w=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class F{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${w.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${w.vscodeRemoteResource}`}set(P,R,b){this._hosts[P]=R,this._ports[P]=b}setConnectionToken(P,R){this._connectionTokens[P]=R}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)return this._delegate(P);const R=P.authority;let b=this._hosts[R];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const g=this._ports[R],I=this._connectionTokens[R];let p=`path=${encodeURIComponent(P.path)}`;return typeof I=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),C.URI.from({scheme:r.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${b}:${g}`,path:this._remoteResourcesPath,query:p})}}e.RemoteAuthorities=new F;class y{asBrowserUri(P,R){const b=this.toUri(P,R);return b.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===w.file&&(r.isNative||r.isWebWorker&&r.globals.origin===`${w.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?b.with({scheme:w.vscodeFileResource,authority:b.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(P,R){const b=this.toUri(P,R);return b.scheme===w.vscodeFileResource?b.with({scheme:w.file,authority:b.authority!==y.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(P,R){return C.URI.isUri(P)?P:C.URI.parse(R.toUrl(P))}}y.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new y;var A;(function(E){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(P.get("3"));const R="vscode-coi";function b(I){let p;typeof I=="string"?p=new URL(I).searchParams:I instanceof URL?p=I.searchParams:C.URI.isUri(I)&&(p=new URL(I.toString(!0)).searchParams);const a=p?.get(R);if(!!a)return P.get(a)}E.getHeadersFromQuery=b;function g(I,p,a){if(!globalThis.crossOriginIsolated)return;const l=p&&a?"3":a?"2":"1";I instanceof URLSearchParams?I.set(R,l):I[R]=l}E.addSearchParam=g})(A=e.COI||(e.COI={}))}),define(Ce[22],Ie([1,0,39,13,19,20,9,2]),function(ne,e,r,C,w,F,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(I){return(0,A.uriToFsPath)(I,!0)}e.originalFSPath=E;class P{constructor(p){this._ignorePathCasing=p}compare(p,a,l=!1){return p===a?0:(0,y.compare)(this.getComparisonKey(p,l),this.getComparisonKey(a,l))}isEqual(p,a,l=!1){return p===a?!0:!p||!a?!1:this.getComparisonKey(p,l)===this.getComparisonKey(a,l)}getComparisonKey(p,a=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,a,l=!1){if(p.scheme===a.scheme){if(p.scheme===C.Schemas.file)return r.isEqualOrParent(E(p),E(a),this._ignorePathCasing(p))&&p.query===a.query&&(l||p.fragment===a.fragment);if((0,e.isEqualAuthority)(p.authority,a.authority))return r.isEqualOrParent(p.path,a.path,this._ignorePathCasing(p),"/")&&p.query===a.query&&(l||p.fragment===a.fragment)}return!1}joinPath(p,...a){return A.URI.joinPath(p,...a)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return w.posix.basename(p.path)}extname(p){return w.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let a;return p.scheme===C.Schemas.file?a=A.URI.file(w.dirname(E(p))).path:(a=w.posix.dirname(p.path),p.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),a="/")),p.with({path:a})}normalizePath(p){if(!p.path.length)return p;let a;return p.scheme===C.Schemas.file?a=A.URI.file(w.normalize(E(p))).path:a=w.posix.normalize(p.path),p.with({path:a})}relativePath(p,a){if(p.scheme!==a.scheme||!(0,e.isEqualAuthority)(p.authority,a.authority))return;if(p.scheme===C.Schemas.file){const m=w.relative(E(p),E(a));return F.isWindows?r.toSlashes(m):m}let l=p.path||"/";const d=a.path||"/";if(this._ignorePathCasing(p)){let m=0;for(const S=Math.min(l.length,d.length);m<S&&!(l.charCodeAt(m)!==d.charCodeAt(m)&&l.charAt(m).toLowerCase()!==d.charAt(m).toLowerCase());m++);l=d.substr(0,m)+l.substr(m)}return w.posix.relative(l,d)}resolvePath(p,a){if(p.scheme===C.Schemas.file){const l=A.URI.file(w.resolve(E(p),a));return p.with({authority:l.authority,path:l.path})}return a=r.toPosixPath(a),p.with({path:w.posix.resolve(p.path,a)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,a){return p===a||p!==void 0&&a!==void 0&&(0,y.equalsIgnoreCase)(p,a)}hasTrailingPathSeparator(p,a=w.sep){if(p.scheme===C.Schemas.file){const l=E(p);return l.length>r.getRoot(l).length&&l[l.length-1]===a}else{const l=p.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,a=w.sep){return(0,e.hasTrailingPathSeparator)(p,a)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,a=w.sep){let l=!1;if(p.scheme===C.Schemas.file){const d=E(p);l=d!==void 0&&d.length===r.getRoot(d).length&&d[d.length-1]===a}else{a="/";const d=p.path;l=d.length===1&&d.charCodeAt(d.length-1)===47}return!l&&!(0,e.hasTrailingPathSeparator)(p,a)?p.with({path:p.path+"/"}):p}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(I=>I.scheme===C.Schemas.file?!F.isLinux:!0),e.extUriIgnorePathCase=new P(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(I,p){const a=[];for(let l=0;l<I.length;l++){const d=p(I[l]);I.some((m,S)=>S===l?!1:(0,e.isEqualOrParent)(d,p(m)))||a.push(I[l])}return a}e.distinctParents=R;var b;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function p(a){const l=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(S=>{const[c,_]=S.split(":");c&&_&&l.set(c,_)});const m=a.path.substring(0,a.path.indexOf(";"));return m&&l.set(I.META_DATA_MIME,m),l}I.parseMetaData=p})(b=e.DataUri||(e.DataUri={}));function g(I,p,a){if(p){let l=I.path;return l&&l[0]!==w.posix.sep&&(l=w.posix.sep+l),I.with({scheme:a,authority:p,path:l})}return I.with({scheme:a})}e.toLocalResource=g}),define(Ce[15],Ie([1,0,21,12,4,7,22,20]),function(ne,e,r,C,w,F,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=E;function P(fe){const Q=new r.CancellationTokenSource,pe=fe(Q.token),Se=new Promise((Fe,Be)=>{const Xe=Q.token.onCancellationRequested(()=>{Xe.dispose(),Q.dispose(),Be(new C.CancellationError)});Promise.resolve(pe).then(ke=>{Xe.dispose(),Q.dispose(),Fe(ke)},ke=>{Xe.dispose(),Q.dispose(),Be(ke)})});return new class{cancel(){Q.cancel()}then(Fe,Be){return Se.then(Fe,Be)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Se.finally(Fe)}}}e.createCancelablePromise=P;function R(fe,Q,pe){return new Promise((Se,Fe)=>{const Be=Q.onCancellationRequested(()=>{Be.dispose(),Se(pe)});fe.then(Se,Fe).finally(()=>Be.dispose())})}e.raceCancellation=R;function b(fe,Q){return new Promise((pe,Se)=>{const Fe=Q.onCancellationRequested(()=>{Fe.dispose(),Se(new C.CancellationError)});fe.then(pe,Se).finally(()=>Fe.dispose())})}e.raceCancellationError=b;async function g(fe){let Q=-1;const pe=fe.map((Fe,Be)=>Fe.then(Xe=>(Q=Be,Xe))),Se=await Promise.race(pe);return fe.forEach((Fe,Be)=>{Be!==Q&&Fe.cancel()}),Se}e.raceCancellablePromises=g;function I(fe,Q,pe){let Se;const Fe=setTimeout(()=>{Se?.(void 0),pe?.()},Q);return Promise.race([fe.finally(()=>clearTimeout(Fe)),new Promise(Be=>Se=Be)])}e.raceTimeout=I;function p(fe){return new Promise((Q,pe)=>{const Se=fe();E(Se)?Se.then(Q,pe):Q(Se)})}e.asPromise=p;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const pe=()=>{this.queuedPromise=null;const Se=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Se};this.queuedPromise=new Promise(Se=>{this.activePromise.then(pe,pe).then(Se)})}return new Promise((pe,Se)=>{this.queuedPromise.then(pe,Se)})}return this.activePromise=Q(),new Promise((pe,Se)=>{this.activePromise.then(Fe=>{this.activePromise=null,pe(Fe)},Fe=>{this.activePromise=null,Se(Fe)})})}}e.Throttler=a;class l{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=l;class d{constructor(){this.promiseMap=new Map}queue(Q,pe){const Fe=(this.promiseMap.get(Q)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.promiseMap.get(Q)===Fe&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,Fe),Fe}}e.SequencerByKey=d;const m=(fe,Q)=>{let pe=!0;const Se=setTimeout(()=>{pe=!1,Q()},fe);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(Se),pe=!1}}},S=fe=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,fe())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(Q){this.defaultDelay=Q,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,pe=this.defaultDelay){this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,Be)=>{this.doResolve=Fe,this.doReject=Be}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Se=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=pe===e.MicrotaskDelay?S(Se):m(pe,Se),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new C.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class _{constructor(Q){this.delayer=new c(Q),this.throttler=new a}trigger(Q,pe){return this.delayer.trigger(()=>this.throttler.queue(Q),pe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class t{constructor(){this._isOpen=!1,this._promise=new Promise((Q,pe)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=t;class u extends t{constructor(Q){super(),this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function i(fe,Q){return Q?new Promise((pe,Se)=>{const Fe=setTimeout(()=>{Be.dispose(),pe()},fe),Be=Q.onCancellationRequested(()=>{clearTimeout(Fe),Be.dispose(),Se(new C.CancellationError)})}):P(pe=>i(fe,pe))}e.timeout=i;function n(fe,Q=0){const pe=setTimeout(fe,Q);return(0,F.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=n;function s(fe){const Q=[];let pe=0;const Se=fe.length;function Fe(){return pe<Se?fe[pe++]():null}function Be(Xe){Xe!=null&&Q.push(Xe);const ke=Fe();return ke?ke.then(Be):Promise.resolve(Q)}return Promise.resolve(null).then(Be)}e.sequence=s;function h(fe,Q=Se=>!!Se,pe=null){let Se=0;const Fe=fe.length,Be=()=>{if(Se>=Fe)return Promise.resolve(pe);const Xe=fe[Se++];return Promise.resolve(Xe()).then(ye=>Q(ye)?Promise.resolve(ye):Be())};return Be()}e.first=h;function o(fe,Q=Se=>!!Se,pe=null){if(fe.length===0)return Promise.resolve(pe);let Se=fe.length;const Fe=()=>{Se=-1;for(const Be of fe)Be.cancel?.()};return new Promise((Be,Xe)=>{for(const ke of fe)ke.then(ye=>{--Se>=0&&Q(ye)?(Fe(),Be(ye)):Se===0&&Be(pe)}).catch(ye=>{--Se>=0&&(Fe(),Xe(ye))})})}e.firstParallel=o;class f{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new w.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Q){return this._size++,new Promise((pe,Se)=>{this.outstandingPromises.push({factory:Q,c:pe,e:Se}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const pe=Q.factory();pe.then(Q.c,Q.e),pe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=f;class v extends f{constructor(){super(1)}}e.Queue=v;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Q=new G;return this.drainers.add(Q),Q.p}isDrained(){for(const[,Q]of this.queues)if(Q.size>0)return!1;return!0}queueFor(Q,pe=y.extUri){const Se=pe.getComparisonKey(Q);let Fe=this.queues.get(Se);return Fe||(Fe=new v,w.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Se),this.onDidQueueDrain()}),this.queues.set(Se,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Q of this.drainers)Q.complete();this.drainers.clear()}dispose(){for(const[,Q]of this.queues)Q.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class M{constructor(Q,pe){this._token=-1,typeof Q=="function"&&typeof pe=="number"&&this.setIfNotSet(Q,pe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,pe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},pe)}setIfNotSet(Q,pe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},pe))}}e.TimeoutTimer=M;class j{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,pe){this.cancel(),this._token=setInterval(()=>{Q()},pe)}}e.IntervalTimer=j;class U{constructor(Q,pe){this.timeoutToken=-1,this.runner=Q,this.timeout=pe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class D{constructor(Q,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.runner=Q,this.timeout=pe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Q=this.timeout){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=D;class $ extends U{constructor(Q,pe){super(Q,pe),this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner?.(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=$;class L extends F.Disposable{constructor(Q,pe){super(),this.options=Q,this.handler=pe,this.pendingWork=[],this.throttler=this._register(new F.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Q){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Q.length>this.options.maxBufferedWork)return!1}else if(this.pending+Q.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=L,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,A.setTimeout0)(()=>{if(Q)return;const pe=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.runWhenIdle=(fe,Q)=>{const pe=requestIdleCallback(fe,typeof Q=="number"?{timeout:Q}:void 0);let Se=!1;return{dispose(){Se||(Se=!0,cancelIdleCallback(pe))}}}}();class O{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(pe){this._error=pe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function H(fe,Q,pe){let Se;for(let Fe=0;Fe<pe;Fe++)try{return await fe()}catch(Be){Se=Be,await i(Q)}throw Se}e.retry=H;class W{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Q,pe,Se){return this._pending={taskId:Q,cancel:()=>Se?.(),promise:pe},pe.then(()=>this.donePending(Q),()=>this.donePending(Q)),pe}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let pe,Se;const Fe=new Promise((Be,Xe)=>{pe=Be,Se=Xe});this._next={run:Q,promise:Fe,promiseResolve:pe,promiseReject:Se}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=W;class z{constructor(Q,pe=()=>Date.now()){this.interval=Q,this.nowFn=pe,this.lastIncrementTime=0,this.value=0}increment(){const Q=this.nowFn();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class G{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,pe)=>{this.completeCallback=Q,this.errorCallback=pe})}complete(Q){return new Promise(pe=>{this.completeCallback(Q),this.resolved=!0,pe()})}error(Q){return new Promise(pe=>{this.errorCallback(Q),this.rejected=!0,pe()})}cancel(){new Promise(Q=>{this.errorCallback(new C.CancellationError),this.rejected=!0,Q()})}}e.DeferredPromise=G;var te;(function(fe){async function Q(Se){let Fe;const Be=await Promise.all(Se.map(Xe=>Xe.then(ke=>ke,ke=>{Fe||(Fe=ke)})));if(typeof Fe<"u")throw Fe;return Be}fe.settled=Q;function pe(Se){return new Promise(async(Fe,Be)=>{try{await Se(Fe,Be)}catch(Xe){Be(Xe)}})}fe.withAsyncBody=pe})(te=e.Promises||(e.Promises={}));var he;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(he||(he={}));class re{static fromArray(Q){return new re(pe=>{pe.emitMany(Q)})}static fromPromise(Q){return new re(async pe=>{pe.emitMany(await Q)})}static fromPromises(Q){return new re(async pe=>{await Promise.all(Q.map(async Se=>pe.emitOne(await Se)))})}static merge(Q){return new re(async pe=>{await Promise.all(Q.map(async Se=>{for await(const Fe of Se)pe.emitOne(Fe)}))})}constructor(Q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const pe={emitOne:Se=>this.emitOne(Se),emitMany:Se=>this.emitMany(Se),reject:Se=>this.reject(Se)};try{await Promise.resolve(Q(pe)),this.resolve()}catch(Se){this.reject(Se)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Q<this._results.length)return{done:!1,value:this._results[Q++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Q,pe){return new re(async Se=>{for await(const Fe of Q)Se.emitOne(pe(Fe))})}map(Q){return re.map(this,Q)}static filter(Q,pe){return new re(async Se=>{for await(const Fe of Q)pe(Fe)&&Se.emitOne(Fe)})}filter(Q){return re.filter(this,Q)}static coalesce(Q){return re.filter(Q,pe=>!!pe)}coalesce(){return re.coalesce(this)}static async toPromise(Q){const pe=[];for await(const Se of Q)pe.push(Se);return pe}toPromise(){return re.toPromise(this)}emitOne(Q){this._state===0&&(this._results.push(Q),this._onStateChanged.fire())}emitMany(Q){this._state===0&&(this._results=this._results.concat(Q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Q){this._state===0&&(this._state=2,this._error=Q,this._onStateChanged.fire())}}e.AsyncIterableObject=re,re.EMPTY=re.fromArray([]);class be extends re{constructor(Q,pe){super(pe),this._source=Q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=be;function le(fe){const Q=new r.CancellationTokenSource,pe=fe(Q.token);return new be(Q,async Se=>{const Fe=Q.token.onCancellationRequested(()=>{Fe.dispose(),Q.dispose(),Se.reject(new C.CancellationError)});try{for await(const Be of pe){if(Q.token.isCancellationRequested)return;Se.emitOne(Be)}Fe.dispose(),Q.dispose()}catch(Be){Fe.dispose(),Q.dispose(),Se.reject(Be)}})}e.createCancelableAsyncIterable=le}),define(Ce[118],Ie([1,0,15,19]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new r.IdleValue(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),F=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(v,T,M=!1){const j=v||"",U=T||"",D=w.value.collator.compare(j,U);return w.value.collatorIsNumeric&&D===0&&j!==U?j<U?-1:1:D}e.compareFileNames=A;function E(v,T){const M=F.value.collator;return v=v||"",T=T||"",_(M,v,T)}e.compareFileNamesDefault=E;function P(v,T){const M=F.value.collator;return v=v||"",T=T||"",n(v,T)||_(M,v,T)}e.compareFileNamesUpper=P;function R(v,T){const M=F.value.collator;return v=v||"",T=T||"",i(v,T)||_(M,v,T)}e.compareFileNamesLower=R;function b(v,T){return v=v||"",T=T||"",v===T?0:v<T?-1:1}e.compareFileNamesUnicode=b;function g(v,T,M=!1){M||(v=v&&v.toLowerCase(),T=T&&T.toLowerCase());const[j,U]=S(v),[D,$]=S(T);return j!==D?j<D?-1:1:U===$?0:U<$?-1:1}e.noIntlCompareFileNames=g;function I(v,T){const[M,j]=S(v),[U,D]=S(T);let $=w.value.collator.compare(j,D);if($===0){if(w.value.collatorIsNumeric&&j!==D)return j<D?-1:1;if($=w.value.collator.compare(M,U),w.value.collatorIsNumeric&&$===0&&M!==U)return M<U?-1:1}return $}e.compareFileExtensions=I;function p(v,T){v=v||"",T=T||"";const M=c(v),j=c(T),U=F.value.collator,D=y.value.collator;return _(D,M,j)||_(U,v,T)}e.compareFileExtensionsDefault=p;function a(v,T){v=v||"",T=T||"";const M=c(v),j=c(T),U=F.value.collator,D=y.value.collator;return _(D,M,j)||n(v,T)||_(U,v,T)}e.compareFileExtensionsUpper=a;function l(v,T){v=v||"",T=T||"";const M=c(v),j=c(T),U=F.value.collator,D=y.value.collator;return _(D,M,j)||i(v,T)||_(U,v,T)}e.compareFileExtensionsLower=l;function d(v,T){v=v||"",T=T||"";const M=c(v).toLowerCase(),j=c(T).toLowerCase();return M!==j?M<j?-1:1:v!==T?v<T?-1:1:0}e.compareFileExtensionsUnicode=d;const m=/^(.*?)(\.([^.]*))?$/;function S(v,T=!1){const M=v?m.exec(v):[];let j=[M&&M[1]||"",M&&M[3]||""];return T&&(!j[0]&&j[1]||j[0]&&j[0].charAt(0)===".")&&(j=[j[0]+"."+j[1],""]),j}function c(v){const T=v?m.exec(v):[];return T&&T[1]&&T[1].charAt(0)!=="."&&T[3]||""}function _(v,T,M){const j=v.compare(T,M);return j!==0?j:T.length!==M.length?T.length<M.length?-1:1:0}function t(v){const T=v.charAt(0);return T.toLocaleUpperCase()!==T}function u(v){const T=v.charAt(0);return T.toLocaleLowerCase()!==T}function i(v,T){return t(v)&&u(T)?-1:u(v)&&t(T)?1:0}function n(v,T){return u(v)&&t(T)?-1:t(v)&&u(T)?1:0}function s(v,T,M=!1){return M||(v=v&&v.toLowerCase(),T=T&&T.toLowerCase()),v===T?0:v<T?-1:1}function h(v,T,M=!1){const j=v.split(C.sep),U=T.split(C.sep),D=j.length-1,$=U.length-1;let L,O;for(let H=0;;H++){if(L=D===H,O=$===H,L&&O)return A(j[H],U[H],M);if(L)return-1;if(O)return 1;const W=s(j[H],U[H],M);if(W!==0)return W}}e.comparePaths=h;function o(v,T,M){const j=v.toLowerCase(),U=T.toLowerCase(),D=f(v,T,M);if(D)return D;const $=j.endsWith(M),L=U.endsWith(M);if($!==L)return $?-1:1;const O=A(j,U);return O!==0?O:j.localeCompare(U)}e.compareAnything=o;function f(v,T,M){const j=v.toLowerCase(),U=T.toLowerCase(),D=j.startsWith(M),$=U.startsWith(M);if(D!==$)return D?-1:1;if(D&&$){if(j.length<U.length)return-1;if(j.length>U.length)return 1}return 0}e.compareByPrefix=f}),define(Ce[34],Ie([1,0,18,15,39,25,19,20,9]),function(ne,e,r,C,w,F,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",b="[^/\\\\]",g=/\//g;function I(G,te){switch(G){case 0:return"";case 1:return`${b}*?`;default:return`(?:${R}|${b}+${R}${te?`|${R}${b}+`:""})*?`}}function p(G,te){if(!G)return[];const he=[];let re=!1,be=!1,le="";for(const fe of G){switch(fe){case te:if(!re&&!be){he.push(le),le="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":be=!0;break;case"]":be=!1;break}le+=fe}return le&&he.push(le),he}e.splitGlobAware=p;function a(G){if(!G)return"";let te="";const he=p(G,e.GLOB_SPLIT);if(he.every(re=>re===e.GLOBSTAR))te=".*";else{let re=!1;he.forEach((be,le)=>{if(be===e.GLOBSTAR){if(re)return;te+=I(2,le===he.length-1)}else{let fe=!1,Q="",pe=!1,Se="";for(const Fe of be){if(Fe!=="}"&&fe){Q+=Fe;continue}if(pe&&(Fe!=="]"||!Se)){let Be;Fe==="-"?Be=Fe:(Fe==="^"||Fe==="!")&&!Se?Be="^":Fe===e.GLOB_SPLIT?Be="":Be=(0,E.escapeRegExpCharacters)(Fe),Se+=Be;continue}switch(Fe){case"{":fe=!0;continue;case"[":pe=!0;continue;case"}":{te+=`(?:${p(Q,",").map(ke=>a(ke)).join("|")})`,fe=!1,Q="";break}case"]":{te+="["+Se+"]",pe=!1,Se="";break}case"?":te+=b;continue;case"*":te+=I(1);continue;default:te+=(0,E.escapeRegExpCharacters)(Fe)}}le<he.length-1&&(he[le+1]!==e.GLOBSTAR||le+2<he.length)&&(te+=R)}re=be===e.GLOBSTAR})}return te}const l=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,_=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new F.LRUCache(1e4),u=function(){return!1},i=function(){return null};function n(G,te){if(!G)return i;let he;typeof G!="string"?he=G.pattern:he=G,he=he.trim();const re=`${he}_${!!te.trimForExclusions}`;let be=t.get(re);if(be)return s(be,G);let le;return l.test(he)?be=o(he.substr(4),he):(le=d.exec(h(he,te)))?be=f(le[1],he):(te.trimForExclusions?S:m).test(he)?be=v(he,te):(le=c.exec(h(he,te)))?be=T(le[1].substr(1),he,!0):(le=_.exec(h(he,te)))?be=T(le[1],he,!1):be=M(he),t.set(re,be),s(be,G)}function s(G,te){if(typeof te=="string")return G;const he=function(re,be){return(0,w.isEqualOrParent)(re,te.base,!A.isLinux)?G(re.substr(te.base.length+1),be):null};return he.allBasenames=G.allBasenames,he.allPaths=G.allPaths,he.basenames=G.basenames,he.patterns=G.patterns,he}function h(G,te){return te.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function o(G,te){return function(he,re){return typeof he=="string"&&he.endsWith(G)?te:null}}function f(G,te){const he=`/${G}`,re=`\\${G}`,be=function(fe,Q){return typeof fe!="string"?null:Q?Q===G?te:null:fe===G||fe.endsWith(he)||fe.endsWith(re)?te:null},le=[G];return be.basenames=le,be.patterns=[te],be.allBasenames=le,be}function v(G,te){const he=W(G.slice(1,-1).split(",").map(Q=>n(Q,te)).filter(Q=>Q!==i),G),re=he.length;if(!re)return i;if(re===1)return he[0];const be=function(Q,pe){for(let Se=0,Fe=he.length;Se<Fe;Se++)if(he[Se](Q,pe))return G;return null},le=he.find(Q=>!!Q.allBasenames);le&&(be.allBasenames=le.allBasenames);const fe=he.reduce((Q,pe)=>pe.allPaths?Q.concat(pe.allPaths):Q,[]);return fe.length&&(be.allPaths=fe),be}function T(G,te,he){const re=y.sep===y.posix.sep,be=re?G:G.replace(g,y.sep),le=y.sep+be,fe=y.posix.sep+G;let Q;return he?Q=function(pe,Se){return typeof pe=="string"&&(pe===be||pe.endsWith(le)||!re&&(pe===G||pe.endsWith(fe)))?te:null}:Q=function(pe,Se){return typeof pe=="string"&&(pe===be||!re&&pe===G)?te:null},Q.allPaths=[(he?"*/":"./")+G],Q}function M(G){try{const te=new RegExp(`^${a(G)}$`);return function(he){return te.lastIndex=0,typeof he=="string"&&te.test(he)?G:null}}catch{return i}}function j(G,te,he){return!G||typeof te!="string"?!1:U(G)(te,void 0,he)}e.match=j;function U(G,te={}){if(!G)return u;if(typeof G=="string"||D(G)){const he=n(G,te);if(he===i)return u;const re=function(be,le){return!!he(be,le)};return he.allBasenames&&(re.allBasenames=he.allBasenames),he.allPaths&&(re.allPaths=he.allPaths),re}return O(G,te)}e.parse=U;function D(G){const te=G;return te?typeof te.base=="string"&&typeof te.pattern=="string":!1}e.isRelativePattern=D;function $(G){return G.allBasenames||[]}e.getBasenameTerms=$;function L(G){return G.allPaths||[]}e.getPathTerms=L;function O(G,te){const he=W(Object.getOwnPropertyNames(G).map(Q=>H(Q,G[Q],te)).filter(Q=>Q!==i)),re=he.length;if(!re)return i;if(!he.some(Q=>!!Q.requiresSiblings)){if(re===1)return he[0];const Q=function(Fe,Be){let Xe;for(let ke=0,ye=he.length;ke<ye;ke++){const De=he[ke](Fe,Be);if(typeof De=="string")return De;(0,C.isThenable)(De)&&(Xe||(Xe=[]),Xe.push(De))}return Xe?(async()=>{for(const ke of Xe){const ye=await ke;if(typeof ye=="string")return ye}return null})():null},pe=he.find(Fe=>!!Fe.allBasenames);pe&&(Q.allBasenames=pe.allBasenames);const Se=he.reduce((Fe,Be)=>Be.allPaths?Fe.concat(Be.allPaths):Fe,[]);return Se.length&&(Q.allPaths=Se),Q}const be=function(Q,pe,Se){let Fe,Be;for(let Xe=0,ke=he.length;Xe<ke;Xe++){const ye=he[Xe];ye.requiresSiblings&&Se&&(pe||(pe=(0,y.basename)(Q)),Fe||(Fe=pe.substr(0,pe.length-(0,y.extname)(Q).length)));const De=ye(Q,pe,Fe,Se);if(typeof De=="string")return De;(0,C.isThenable)(De)&&(Be||(Be=[]),Be.push(De))}return Be?(async()=>{for(const Xe of Be){const ke=await Xe;if(typeof ke=="string")return ke}return null})():null},le=he.find(Q=>!!Q.allBasenames);le&&(be.allBasenames=le.allBasenames);const fe=he.reduce((Q,pe)=>pe.allPaths?Q.concat(pe.allPaths):Q,[]);return fe.length&&(be.allPaths=fe),be}function H(G,te,he){if(te===!1)return i;const re=n(G,he);if(re===i)return i;if(typeof te=="boolean")return re;if(te){const be=te.when;if(typeof be=="string"){const le=(fe,Q,pe,Se)=>{if(!Se||!re(fe,Q))return null;const Fe=be.replace("$(basename)",pe),Be=Se(Fe);return(0,C.isThenable)(Be)?Be.then(Xe=>Xe?G:null):Be?G:null};return le.requiresSiblings=!0,le}}return re}function W(G,te){const he=G.filter(Q=>!!Q.basenames);if(he.length<2)return G;const re=he.reduce((Q,pe)=>{const Se=pe.basenames;return Se?Q.concat(Se):Q},[]);let be;if(te){be=[];for(let Q=0,pe=re.length;Q<pe;Q++)be.push(te)}else be=he.reduce((Q,pe)=>{const Se=pe.patterns;return Se?Q.concat(Se):Q},[]);const le=function(Q,pe){if(typeof Q!="string")return null;if(!pe){let Fe;for(Fe=Q.length;Fe>0;Fe--){const Be=Q.charCodeAt(Fe-1);if(Be===47||Be===92)break}pe=Q.substr(Fe)}const Se=re.indexOf(pe);return Se!==-1?be[Se]:null};le.basenames=re,le.patterns=be,le.allBasenames=re;const fe=G.filter(Q=>!Q.basenames);return fe.push(le),fe}function z(G,te){return(0,r.equals)(G,te,(he,re)=>typeof he=="string"&&typeof re=="string"?he===re:typeof he!="string"&&typeof re!="string"?he.base===re.base&&he.pattern===re.pattern:!1)}e.patternsEquals=z}),define(Ce[79],Ie([1,0,12,116,22,9,2]),function(ne,e,r,C,w,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(d="",m=!1){if(this.value=d,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(d,m=0){return this.value+=g(this.supportThemeIcons?(0,C.escapeIcons)(d):d).replace(/([ \t]+)/g,(S,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,m){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=m,this.value+="\n```\n",this}appendLink(d,m,S){return this.value+="[",this.value+=this._escape(m,"]"),this.value+="](",this.value+=this._escape(String(d),")"),S&&(this.value+=` "${this._escape(this._escape(S,'"'),")")}"`),this.value+=")",this}_escape(d,m){const S=new RegExp((0,F.escapeRegExpCharacters)(m),"g");return d.replace(S,(c,_)=>d.charAt(_-1)!=="\\"?`\\${c}`:c)}}e.MarkdownString=E;function P(l){return R(l)?!l.value:Array.isArray(l)?l.every(P):!0}e.isEmptyMarkdownString=P;function R(l){return l instanceof E?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function b(l,d){return l===d?!0:!l||!d?!1:l.value===d.value&&l.isTrusted===d.isTrusted&&l.supportThemeIcons===d.supportThemeIcons&&l.supportHtml===d.supportHtml&&(l.baseUri===d.baseUri||!!l.baseUri&&!!d.baseUri&&(0,w.isEqual)(y.URI.from(l.baseUri),y.URI.from(d.baseUri)))}e.markdownStringEqual=b;function g(l){return l.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=g;function I(l){return l.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=I;function p(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=p;function a(l){const d=[],m=l.split("|").map(c=>c.trim());l=m[0];const S=m[1];if(S){const c=/height=(\d+)/.exec(S),_=/width=(\d+)/.exec(S),t=c?c[1]:"",u=_?_[1]:"",i=isFinite(parseInt(u)),n=isFinite(parseInt(t));i&&d.push(`width="${u}"`),n&&d.push(`height="${t}"`)}return{href:l,dimensions:d}}e.parseHrefAndDimensions=a}),define(Ce[80],Ie([1,0,18,39,19,20,22,9]),function(ne,e,r,C,w,F,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(i,n){const{os:s,tildify:h,relative:o}=n;if(o){const T=P(i,o,s);if(typeof T=="string")return T}let f=i.fsPath;if(s===1&&!F.isWindows?f=f.replace(/\//g,"\\"):s!==1&&F.isWindows&&(f=f.replace(/\\/g,"/")),s!==1&&h?.userHome){const T=h.userHome.fsPath;let M;i.scheme!==h.userHome.scheme&&i.path.startsWith(w.posix.sep)?M=h.userHome.with({path:i.path}).fsPath:M=i.fsPath,f=g(M,T,s)}return(s===1?w.win32:w.posix).normalize(R(f,s===1))}e.getPathLabel=E;function P(i,n,s){const h=s===1?w.win32:w.posix,o=s===3?y.extUri:y.extUriIgnorePathCase,f=n.getWorkspace(),v=(0,r.firstOrDefault)(f.folders);if(!v)return;i.scheme!==v.uri.scheme&&i.path.startsWith(w.posix.sep)&&(i=v.uri.with({path:i.path}));const T=n.getWorkspaceFolder(i);if(!T)return;let M;if(o.isEqual(T.uri,i)?M="":M=o.relativePath(T.uri,i)??"",M&&(M=h.normalize(M)),f.folders.length>1&&!n.noPrefix){const j=T.name?T.name:o.basenameOrAuthority(T.uri);M=M?`${j} \u2022 ${M}`:j}return M}function R(i,n=F.isWindows){return(0,C.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=R;let b=Object.create(null);function g(i,n,s=F.OS){if(s===1||!i||!n)return i;let h=b.original===n?b.normalized:void 0;h||(h=n,F.isWindows&&(h=(0,C.toSlashes)(h)),h=`${(0,A.rtrim)(h,w.posix.sep)}${w.posix.sep}`,b={original:n,normalized:h});let o=i;return F.isWindows&&(o=(0,C.toSlashes)(o)),(s===3?o.startsWith(h):(0,A.startsWithIgnoreCase)(o,h))?`~/${o.substr(h.length)}`:i}e.tildify=g;function I(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=I;const p="\u2026",a="\\\\",l="~";function d(i,n=w.sep){const s=new Array(i.length);let h=!1;for(let o=0;o<i.length;o++){const f=i[o];if(f===""){s[o]=`.${n}`;continue}if(!f){s[o]=f;continue}h=!0;let v="",T=f;T.indexOf(a)===0?(v=T.substr(0,T.indexOf(a)+a.length),T=T.substr(T.indexOf(a)+a.length)):T.indexOf(n)===0?(v=T.substr(0,T.indexOf(n)+n.length),T=T.substr(T.indexOf(n)+n.length)):T.indexOf(l)===0&&(v=T.substr(0,T.indexOf(l)+l.length),T=T.substr(T.indexOf(l)+l.length));const M=T.split(n);for(let j=1;h&&j<=M.length;j++)for(let U=M.length-j;h&&U>=0;U--){h=!1;let D=M.slice(U,U+j).join(n);for(let $=0;!h&&$<i.length;$++)if($!==o&&i[$]&&i[$].indexOf(D)>-1){const L=U+j===M.length,O=U>0&&i[$].indexOf(n)>-1?n+D:D,H=i[$].endsWith(O);h=!L||H}if(!h){let $="";(M[0].endsWith(":")||v!=="")&&(U===1&&(U=0,j++,D=M[0]+n+D),U>0&&($=M[0]+n),$=v+$),U>0&&($=$+p+n),$=$+D,U+j<M.length&&($=$+n+p),s[o]=$}}h&&(s[o]=f)}return s}e.shorten=d;var m;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function S(i,n=Object.create(null)){const s=[];let h=!1,o="";for(const f of i)if(f==="$"||h&&f==="{")o&&s.push({value:o,type:m.TEXT}),o="",h=!0;else if(f==="}"&&h){const v=n[o];if(typeof v=="string")v.length&&s.push({value:v,type:m.VARIABLE});else if(v){const T=s[s.length-1];(!T||T.type!==m.SEPARATOR)&&s.push({value:v.label,type:m.SEPARATOR})}o="",h=!1}else o+=f;return o&&!h&&s.push({value:o,type:m.TEXT}),s.filter((f,v)=>{if(f.type===m.SEPARATOR){const T=s[v-1],M=s[v+1];return[T,M].every(j=>j&&(j.type===m.VARIABLE||j.type===m.TEXT)&&j.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=S;function c(i,n){return F.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):i.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function _(i,n){return F.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):F.isWindows?i.replace(/&&|&/g,s=>s==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=_;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function u(i){const n=i.indexOf("/")!==-1?w.posix:w.win32,s=n.basename(i),h=n.dirname(i);return s.length?{name:s,parentPath:h}:{name:h,parentPath:""}}e.splitName=u}),define(Ce[119],Ie([1,0,2]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(R){return R.toJSON()}class w{constructor(b){this._uriTransformer=b}transformIncoming(b){const g=this._uriTransformer.transformIncoming(b);return g===b?b:C(r.URI.from(g))}transformOutgoing(b){const g=this._uriTransformer.transformOutgoing(b);return g===b?b:C(r.URI.from(g))}transformOutgoingURI(b){const g=this._uriTransformer.transformOutgoing(b);return g===b?b:r.URI.from(g)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function F(R,b,g){if(!R||g>200)return null;if(typeof R=="object"){if(R instanceof r.URI)return b.transformOutgoing(R);for(const I in R)if(Object.hasOwnProperty.call(R,I)){const p=F(R[I],b,g+1);p!==null&&(R[I]=p)}}return null}function y(R,b){const g=F(R,b,0);return g===null?R:g}e.transformOutgoingURIs=y;function A(R,b,g,I){if(!R||I>200)return null;if(typeof R=="object"){if(R.$mid===1)return g?r.URI.revive(b.transformIncoming(R)):b.transformIncoming(R);for(const p in R)if(Object.hasOwnProperty.call(R,p)){const a=A(R[p],b,g,I+1);a!==null&&(R[p]=a)}}return null}function E(R,b){const g=A(R,b,!1,0);return g===null?R:g}e.transformIncomingURIs=E;function P(R,b){const g=A(R,b,!0,0);return g===null?R:g}e.transformAndReviveIncomingURIs=P}),define(Ce[120],Ie([1,0,34,19]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(F,y,A,E,P,R){if(Array.isArray(F)){let b=0;for(const g of F){const I=w(g,y,A,E,P,R);if(I===10)return I;I>b&&(b=I)}return b}else{if(typeof F=="string")return E?F==="*"?5:F===A?10:0:0;if(F){const{language:b,pattern:g,scheme:I,hasAccessToAllModels:p,notebookType:a}=F;if(!E&&!p)return 0;a&&P&&(y=P);let l=0;if(I)if(I===y.scheme)l=10;else if(I==="*")l=5;else return 0;if(b)if(b===A)l=10;else if(b==="*")l=Math.max(l,5);else return 0;if(a)if(a===R)l=10;else if(a==="*"&&R!==void 0)l=Math.max(l,5);else return 0;if(g){let d;if(typeof g=="string"?d=g:d={...g,base:(0,C.normalize)(g.base)},d===y.fsPath||(0,r.match)(d,y.fsPath))l=10;else return 0}return l}else return 0}}e.score=w}),define(Ce[81],Ie([1,0,23,20]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(w||(w={}));function F(b){for(let g=0,I=b.length;g<I;g+=4){const p=b[g+0],a=b[g+1],l=b[g+2],d=b[g+3];b[g+0]=d,b[g+1]=l,b[g+2]=a,b[g+3]=p}}function y(b){const g=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return C.isLittleEndian()||F(g),r.VSBuffer.wrap(g)}function A(b){const g=b.buffer;if(C.isLittleEndian()||F(g),g.byteOffset%4===0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const I=new Uint8Array(g.byteLength);return I.set(g),new Uint32Array(I.buffer,I.byteOffset,I.length/4)}}function E(b){const g=new Uint32Array(P(b));let I=0;if(g[I++]=b.id,b.type==="full")g[I++]=1,g[I++]=b.data.length,g.set(b.data,I),I+=b.data.length;else{g[I++]=2,g[I++]=b.deltas.length;for(const p of b.deltas)g[I++]=p.start,g[I++]=p.deleteCount,p.data?(g[I++]=p.data.length,g.set(p.data,I),I+=p.data.length):g[I++]=0}return y(g)}e.encodeSemanticTokensDto=E;function P(b){let g=0;if(g+=1+1,b.type==="full")g+=1+b.data.length;else{g+=1,g+=(1+1+1)*b.deltas.length;for(const I of b.deltas)I.data&&(g+=I.data.length)}return g}function R(b){const g=A(b);let I=0;const p=g[I++];if(g[I++]===1){const m=g[I++],S=g.subarray(I,I+m);return I+=m,{id:p,type:"full",data:S}}const l=g[I++],d=[];for(let m=0;m<l;m++){const S=g[I++],c=g[I++],_=g[I++];let t;_>0&&(t=g.subarray(I,I+_),I+=_),d[m]={start:S,deleteCount:c,data:t}}return{id:p,type:"delta",deltas:d}}e.decodeSemanticTokensDto=R}),define(Ce[121],Ie([16,17]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(Ce[122],Ie([1,0,121,20,123,18,24,109]),function(ne,e,r,C,w,F,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=P;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class b{constructor(Y,me,Ue,Ve){this.id=Y,this.name=me,this.defaultValue=Ue,this.schema=Ve}applyUpdate(Y,me){return I(Y,me)}compute(Y,me,Ue){return Ue}}class g{constructor(Y,me){this.newValue=Y,this.didChange=me}}e.ApplyUpdateResult=g;function I(X,Y){if(typeof X!="object"||typeof Y!="object"||!X||!Y)return new g(Y,X!==Y);if(Array.isArray(X)||Array.isArray(Y)){const Ue=Array.isArray(X)&&Array.isArray(Y)&&F.equals(X,Y);return new g(Y,!Ue)}let me=!1;for(const Ue in Y)if(Y.hasOwnProperty(Ue)){const Ve=I(X[Ue],Y[Ue]);Ve.didChange&&(X[Ue]=Ve.newValue,me=!0)}return new g(X,me)}class p{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,me){return I(Y,me)}validate(Y){return this.defaultValue}}class a{constructor(Y,me,Ue,Ve){this.id=Y,this.name=me,this.defaultValue=Ue,this.schema=Ve}applyUpdate(Y,me){return I(Y,me)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,me,Ue){return Ue}}function l(X,Y){return typeof X>"u"?Y:X==="false"?!1:Boolean(X)}e.boolean=l;class d extends a{constructor(Y,me,Ue,Ve=void 0){typeof Ve<"u"&&(Ve.type="boolean",Ve.default=Ue),super(Y,me,Ue,Ve)}validate(Y){return l(Y,this.defaultValue)}}function m(X,Y,me,Ue){if(typeof X>"u")return Y;let Ve=parseInt(X,10);return isNaN(Ve)?Y:(Ve=Math.max(me,Ve),Ve=Math.min(Ue,Ve),Ve|0)}e.clampedInt=m;class S extends a{static clampedInt(Y,me,Ue,Ve){return m(Y,me,Ue,Ve)}constructor(Y,me,Ue,Ve,et,Ke=void 0){typeof Ke<"u"&&(Ke.type="integer",Ke.default=Ue,Ke.minimum=Ve,Ke.maximum=et),super(Y,me,Ue,Ke),this.minimum=Ve,this.maximum=et}validate(Y){return S.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class c extends a{static clamp(Y,me,Ue){return Y<me?me:Y>Ue?Ue:Y}static float(Y,me){if(typeof Y=="number")return Y;if(typeof Y>"u")return me;const Ue=parseFloat(Y);return isNaN(Ue)?me:Ue}constructor(Y,me,Ue,Ve,et){typeof et<"u"&&(et.type="number",et.default=Ue),super(Y,me,Ue,et),this.validationFn=Ve}validate(Y){return this.validationFn(c.float(Y,this.defaultValue))}}class _ extends a{static string(Y,me){return typeof Y!="string"?me:Y}constructor(Y,me,Ue,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.default=Ue),super(Y,me,Ue,Ve)}validate(Y){return _.string(Y,this.defaultValue)}}function t(X,Y,me){return typeof X!="string"||me.indexOf(X)===-1?Y:X}e.stringSet=t;class u extends a{constructor(Y,me,Ue,Ve,et=void 0){typeof et<"u"&&(et.type="string",et.enum=Ve,et.default=Ue),super(Y,me,Ue,et),this._allowedValues=Ve}validate(Y){return t(Y,this.defaultValue,this._allowedValues)}}class i extends b{constructor(Y,me,Ue,Ve,et,Ke,je=void 0){typeof je<"u"&&(je.type="string",je.enum=et,je.default=Ve),super(Y,me,Ue,je),this._allowedValues=et,this._convert=Ke}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function n(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends b{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[r.localize(0,null),r.localize(1,null),r.localize(2,null)],default:"auto",tags:["accessibility"],description:r.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,me,Ue){return Ue===0?Y.accessibilitySupport:Ue}}class h extends b{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:r.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:r.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertSpace:l(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function f(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function T(X){switch(X){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=T;function M(X){switch(X){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class j extends p{constructor(){super(130)}compute(Y,me,Ue){const Ve=["monaco-editor"];return me.get(34)&&Ve.push(me.get(34)),Y.extraEditorClassName&&Ve.push(Y.extraEditorClassName),me.get(67)==="default"?Ve.push("mouse-default"):me.get(67)==="copy"&&Ve.push("mouse-copy"),me.get(101)&&Ve.push("showUnused"),me.get(128)&&Ve.push("showDeprecated"),Ve.join(" ")}}class U extends d{constructor(){super(33,"emptySelectionClipboard",!0,{description:r.localize(6,null)})}compute(Y,me,Ue){return Ue&&Y.emptySelectionClipboard}}class D extends b{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:r.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[r.localize(8,null),r.localize(9,null),r.localize(10,null)],description:r.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[r.localize(12,null),r.localize(13,null),r.localize(14,null)],description:r.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:r.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:r.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:r.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{cursorMoveOnType:l(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":t(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":t(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(me.loop,this.defaultValue.loop)}}}class $ extends b{constructor(){super(46,"fontLigatures",$.OFF,{anyOf:[{type:"boolean",description:r.localize(19,null)},{type:"string",description:r.localize(20,null)}],description:r.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?$.OFF:Y==="true"?$.ON:Y:Boolean(Y)?$.ON:$.OFF}}e.EditorFontLigatures=$,$.OFF='"liga" off, "calt" off',$.ON='"liga" on, "calt" on';class L extends p{constructor(){super(45)}compute(Y,me,Ue){return Y.fontInfo}}class O extends a{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:r.localize(22,null)})}validate(Y){const me=c.float(Y,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(me,6,100)}compute(Y,me,Ue){return Y.fontInfo.fontSize}}class H extends b{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.MINIMUM_VALUE,maximum:H.MAXIMUM_VALUE,errorMessage:r.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:r.localize(24,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(S.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,H.MINIMUM_VALUE,H.MAXIMUM_VALUE))}}H.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],H.MINIMUM_VALUE=1,H.MAXIMUM_VALUE=1e3;class W extends b{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[r.localize(25,null),r.localize(26,null),r.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:r.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:r.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:r.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:r.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:r.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:r.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Ue,description:r.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Ue,description:r.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Ue,description:r.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Ue,description:r.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Ue,description:r.localize(38,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{multiple:t(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??t(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??t(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??t(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??t(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??t(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends b{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:r.localize(39,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:r.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:r.localize(41,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:r.localize(42,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:l(me.enabled,this.defaultValue.enabled),delay:S.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:l(me.sticky,this.defaultValue.sticky),above:l(me.above,this.defaultValue.above)}}}var G;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(G=e.RenderMinimap||(e.RenderMinimap={}));class te extends p{constructor(){super(133)}compute(Y,me,Ue){return te.computeLayout(me,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const me=Y.height/Y.lineHeight,Ue=Y.scrollBeyondLastLine?me-1:0,Ve=(Y.viewLineCount+Ue)/(Y.pixelRatio*Y.height),et=Math.floor(Y.viewLineCount/Ve);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Ue,desiredRatio:Ve,minimapLineCount:et}}static _computeMinimapLayout(Y,me){const Ue=Y.outerWidth,Ve=Y.outerHeight,et=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const Ke=me.stableMinimapLayoutInput,je=Ke&&Y.outerHeight===Ke.outerHeight&&Y.lineHeight===Ke.lineHeight&&Y.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&Y.pixelRatio===Ke.pixelRatio&&Y.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&Y.minimap.enabled===Ke.minimap.enabled&&Y.minimap.side===Ke.minimap.side&&Y.minimap.size===Ke.minimap.size&&Y.minimap.showSlider===Ke.minimap.showSlider&&Y.minimap.renderCharacters===Ke.minimap.renderCharacters&&Y.minimap.maxColumn===Ke.minimap.maxColumn&&Y.minimap.scale===Ke.minimap.scale&&Y.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&Y.isViewportWrapping===Ke.isViewportWrapping,it=Y.lineHeight,st=Y.typicalHalfwidthCharacterWidth,ct=Y.scrollBeyondLastLine,at=Y.minimap.renderCharacters;let rt=et>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const _t=Y.minimap.maxColumn,Rt=Y.minimap.size,Ot=Y.minimap.side,ft=Y.verticalScrollbarWidth,Dt=Y.viewLineCount,Mt=Y.remainingWidth,Lt=Y.isViewportWrapping,qe=at?2:3;let zt=Math.floor(et*Ve);const Ft=zt/et;let Tt=!1,mt=!1,Ct=qe*rt,_e=rt/et,Te=1;if(Rt==="fill"||Rt==="fit"){const{typicalViewportLineCount:tt,extraLinesBeyondLastLine:gt,desiredRatio:vt,minimapLineCount:It}=te.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:ct,height:Ve,lineHeight:it,pixelRatio:et});if(Dt/It>1)Tt=!0,mt=!0,rt=1,Ct=1,_e=rt/et;else{let Et=!1,pt=rt+1;if(Rt==="fit"){const wt=Math.ceil((Dt+gt)*Ct);Lt&&je&&Mt<=me.stableFitRemainingWidth?(Et=!0,pt=me.stableFitMaxMinimapScale):Et=wt>zt}if(Rt==="fill"||Et){Tt=!0;const wt=rt;Ct=Math.min(it*et,Math.max(1,Math.floor(1/vt))),Lt&&je&&Mt<=me.stableFitRemainingWidth&&(pt=me.stableFitMaxMinimapScale),rt=Math.min(pt,Math.max(1,Math.floor(Ct/qe))),rt>wt&&(Te=Math.min(2,rt/wt)),_e=rt/et/Te,zt=Math.ceil(Math.max(tt,Dt+gt)*Ct),Lt?(me.stableMinimapLayoutInput=Y,me.stableFitRemainingWidth=Mt,me.stableFitMaxMinimapScale=rt):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const ge=Math.floor(_t*_e),K=Math.min(ge,Math.max(0,Math.floor((Mt-ft-2)*_e/(st+_e)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(et*K);const Le=Ae/et;Ae=Math.floor(Ae*Te);const Ze=at?1:2,We=Ot==="left"?0:Ue-K-ft;return{renderMinimap:Ze,minimapLeft:We,minimapWidth:K,minimapHeightIsEditorHeight:Tt,minimapIsSampling:mt,minimapScale:rt,minimapLineHeight:Ct,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:zt,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Ft}}static computeLayout(Y,me){const Ue=me.outerWidth|0,Ve=me.outerHeight|0,et=me.lineHeight|0,Ke=me.lineNumbersDigitCount|0,je=me.typicalHalfwidthCharacterWidth,it=me.maxDigitWidth,st=me.pixelRatio,ct=me.viewLineCount,at=Y.get(125),rt=at==="inherit"?Y.get(124):at,_t=rt==="inherit"?Y.get(120):rt,Rt=Y.get(123),Ot=Y.get(2),ft=me.isDominatedByLongLines,Dt=Y.get(51),Mt=Y.get(61).renderType!==0,Lt=Y.get(62),qe=Y.get(95),zt=Y.get(66),Ft=Y.get(93),Tt=Ft.verticalScrollbarSize,mt=Ft.verticalHasArrows,Ct=Ft.arrowSize,_e=Ft.horizontalScrollbarSize,Te=Y.get(59),ge=Y.get(38),K=Y.get(100)!=="never";let Ae;if(typeof Te=="string"&&/^\d+(\.\d+)?ch$/.test(Te)){const xt=parseFloat(Te.substr(0,Te.length-2));Ae=S.clampedInt(xt*je,0,0,1e3)}else Ae=S.clampedInt(Te,0,0,1e3);ge&&K&&(Ae+=16);let Le=0;if(Mt){const xt=Math.max(Ke,Lt);Le=Math.round(xt*it)}let Ze=0;Dt&&(Ze=et);let We=0,tt=We+Ze,gt=tt+Le,vt=gt+Ae;const It=Ue-Ze-Le-Ae;let yt=!1,Et=!1,pt=-1;Ot!==2&&(rt==="inherit"&&ft?(yt=!0,Et=!0):_t==="on"||_t==="bounded"?Et=!0:_t==="wordWrapColumn"&&(pt=Rt));const wt=te._computeMinimapLayout({outerWidth:Ue,outerHeight:Ve,lineHeight:et,typicalHalfwidthCharacterWidth:je,pixelRatio:st,scrollBeyondLastLine:qe,minimap:zt,verticalScrollbarWidth:Tt,viewLineCount:ct,remainingWidth:It,isViewportWrapping:Et},me.memory||new R);wt.renderMinimap!==0&&wt.minimapLeft===0&&(We+=wt.minimapWidth,tt+=wt.minimapWidth,gt+=wt.minimapWidth,vt+=wt.minimapWidth);const ei=It-wt.minimapWidth,bt=Math.max(1,Math.floor((ei-Tt-2)/je)),qt=mt?Ct:0;return Et&&(pt=Math.max(1,bt),_t==="bounded"&&(pt=Math.min(pt,Rt))),{width:Ue,height:Ve,glyphMarginLeft:We,glyphMarginWidth:Ze,lineNumbersLeft:tt,lineNumbersWidth:Le,decorationsLeft:gt,decorationsWidth:Ae,contentLeft:vt,contentWidth:ei,minimap:wt,viewportColumn:bt,isWordWrapMinified:yt,isViewportWrapping:Et,wrappingColumn:pt,verticalScrollbarWidth:Tt,horizontalScrollbarHeight:_e,overviewRuler:{top:qt,width:Tt,height:Ve-2*qt,right:0}}}}e.EditorLayoutInfoComputer=te;class he extends b{constructor(){const Y={enabled:!0};super(58,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:r.localize(43,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:l(Y.enabled,this.defaultValue.enabled)}}}class re extends b{constructor(){const Y={enabled:!1,maxLineCount:5};super(105,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:r.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:r.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:l(me.enabled,this.defaultValue.enabled),maxLineCount:S.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class be extends b{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:r.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[r.localize(47,null),r.localize(48,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(49,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:r.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:r.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:r.localize(53,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:t(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:S.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(me.fontFamily,this.defaultValue.fontFamily),padding:l(me.padding,this.defaultValue.padding)}}}class le extends c{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>c.clamp(Y,0,150),{markdownDescription:r.localize(54,null)})}compute(Y,me,Ue){return Y.fontInfo.lineHeight}}class fe extends b{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:r.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:r.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[r.localize(57,null),r.localize(58,null),r.localize(59,null)],default:Y.size,description:r.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:r.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:r.localize(62,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:r.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:r.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:r.localize(65,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:l(me.enabled,this.defaultValue.enabled),autohide:l(me.autohide,this.defaultValue.autohide),size:t(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(me.side,this.defaultValue.side,["right","left"]),showSlider:t(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(me.renderCharacters,this.defaultValue.renderCharacters),scale:S.clampedInt(me.scale,1,1,3),maxColumn:S.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Q(X){return X==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class pe extends b{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(67,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{top:S.clampedInt(me.top,0,0,1e3),bottom:S.clampedInt(me.bottom,0,0,1e3)}}}class Se extends b{constructor(){const Y={enabled:!0,cycle:!1};super(77,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:r.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:r.localize(69,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:l(me.enabled,this.defaultValue.enabled),cycle:l(me.cycle,this.defaultValue.cycle)}}}class Fe extends p{constructor(){super(131)}compute(Y,me,Ue){return Y.pixelRatio}}class Be extends b{constructor(){const Y={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[r.localize(70,null),r.localize(71,null),r.localize(72,null)]}];super(80,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Y.strings,description:r.localize(73,null)},comments:{anyOf:me,default:Y.comments,description:r.localize(74,null)},other:{anyOf:me,default:Y.other,description:r.localize(75,null)}},default:Y,markdownDescription:r.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const st=Y?"on":"off";return{comments:st,strings:st,other:st}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:me,comments:Ue,strings:Ve}=Y,et=["on","inline","off"];let Ke,je,it;return typeof me=="boolean"?Ke=me?"on":"off":Ke=t(me,this.defaultValue.other,et),typeof Ue=="boolean"?je=Ue?"on":"off":je=t(Ue,this.defaultValue.comments,et),typeof Ve=="boolean"?it=Ve?"on":"off":it=t(Ve,this.defaultValue.strings,et),{other:Ke,comments:je,strings:it}}}var Xe;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Xe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ke extends b{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[r.localize(77,null),r.localize(78,null),r.localize(79,null),r.localize(80,null)],default:"on",description:r.localize(81,null)})}validate(Y){let me=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(me=4,Ue=Y):Y==="interval"?me=3:Y==="relative"?me=2:Y==="on"?me=1:me=0),{renderType:me,renderFn:Ue}}}function ye(X){const Y=X.get(88);return Y==="editable"?X.get(82):Y!=="on"}e.filterValidationDecorations=ye;class De extends b{constructor(){const Y=[],me={type:"number",description:r.localize(82,null)};super(92,"rulers",Y,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:r.localize(83,null),format:"color-hex"}}}]},default:Y,description:r.localize(84,null)})}validate(Y){if(Array.isArray(Y)){const me=[];for(const Ue of Y)if(typeof Ue=="number")me.push({column:S.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Ve=Ue;me.push({column:S.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return me.sort((Ue,Ve)=>Ue.column-Ve.column),me}return this.defaultValue}}function ae(X,Y){if(typeof X!="string")return Y;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class ue extends b{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(85,null),r.localize(86,null),r.localize(87,null)],default:"auto",description:r.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(89,null),r.localize(90,null),r.localize(91,null)],default:"auto",description:r.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:r.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:r.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:r.localize(95,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y,Ue=S.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=S.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:S.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(me.vertical,this.defaultValue.vertical),horizontal:ae(me.horizontal,this.defaultValue.horizontal),useShadows:l(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:S.clampedInt(me.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:S.clampedInt(me.verticalSliderSize,Ve,0,1e3),scrollByPage:l(me.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ee extends b{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:r.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:r.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:r.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:r.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:r.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:r.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:r.localize(102,null)}})}applyUpdate(Y,me){let Ue=!1;me.allowedCharacters&&Y&&(y.equals(Y.allowedCharacters,me.allowedCharacters)||(Y={...Y,allowedCharacters:me.allowedCharacters},Ue=!0)),me.allowedLocales&&Y&&(y.equals(Y.allowedLocales,me.allowedLocales)||(Y={...Y,allowedLocales:me.allowedLocales},Ue=!0));const Ve=super.applyUpdate(Y,me);return Ue?new g(Ve.newValue,!0):Ve}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{nonBasicASCII:V(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:l(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:l(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:V(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:V(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Y.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Y,me){if(typeof Y!="object"||!Y)return me;const Ue={};for(const[Ve,et]of Object.entries(Y))et===!0&&(Ue[Ve]=!0);return Ue}}class Z extends b{constructor(){const Y={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:r.localize(103,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:l(me.enabled,this.defaultValue.enabled),mode:t(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class k extends b{constructor(){const Y={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:r.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:r.localize(105,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:l(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:l(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class B extends b{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(106,null),r.localize(107,null),r.localize(108,null)],default:Y.bracketPairs,description:r.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(110,null),r.localize(111,null),r.localize(112,null)],default:Y.bracketPairsHorizontal,description:r.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:r.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:r.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[r.localize(116,null),r.localize(117,null),r.localize(118,null)],default:Y.highlightActiveIndentation,description:r.localize(119,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{bracketPairs:V(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:V(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:l(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:l(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:V(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function V(X,Y,me){const Ue=me.indexOf(X);return Ue===-1?Y:me[Ue]}class q extends b{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[r.localize(120,null),r.localize(121,null)],default:Y.insertMode,description:r.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:r.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:r.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:r.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:r.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:r.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:r.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:r.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:r.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:r.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:r.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:r.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:r.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:r.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:r.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:r.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:r.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:r.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:r.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:r.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:r.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:r.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:r.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:r.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:r.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:r.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:r.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:r.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:r.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:r.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:r.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:r.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:r.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:r.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:r.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:r.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:r.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:r.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:r.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:r.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:r.localize(162,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertMode:t(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(me.showIcons,this.defaultValue.showIcons),showStatusBar:l(me.showStatusBar,this.defaultValue.showStatusBar),preview:l(me.preview,this.defaultValue.preview),previewMode:t(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(me.showMethods,this.defaultValue.showMethods),showFunctions:l(me.showFunctions,this.defaultValue.showFunctions),showConstructors:l(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:l(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:l(me.showFields,this.defaultValue.showFields),showVariables:l(me.showVariables,this.defaultValue.showVariables),showClasses:l(me.showClasses,this.defaultValue.showClasses),showStructs:l(me.showStructs,this.defaultValue.showStructs),showInterfaces:l(me.showInterfaces,this.defaultValue.showInterfaces),showModules:l(me.showModules,this.defaultValue.showModules),showProperties:l(me.showProperties,this.defaultValue.showProperties),showEvents:l(me.showEvents,this.defaultValue.showEvents),showOperators:l(me.showOperators,this.defaultValue.showOperators),showUnits:l(me.showUnits,this.defaultValue.showUnits),showValues:l(me.showValues,this.defaultValue.showValues),showConstants:l(me.showConstants,this.defaultValue.showConstants),showEnums:l(me.showEnums,this.defaultValue.showEnums),showEnumMembers:l(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(me.showKeywords,this.defaultValue.showKeywords),showWords:l(me.showWords,this.defaultValue.showWords),showColors:l(me.showColors,this.defaultValue.showColors),showFiles:l(me.showFiles,this.defaultValue.showFiles),showReferences:l(me.showReferences,this.defaultValue.showReferences),showFolders:l(me.showFolders,this.defaultValue.showFolders),showTypeParameters:l(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(me.showSnippets,this.defaultValue.showSnippets),showUsers:l(me.showUsers,this.defaultValue.showUsers),showIssues:l(me.showIssues,this.defaultValue.showIssues)}}}class oe extends b{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:r.localize(163,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ce extends p{constructor(){super(132)}compute(Y,me,Ue){return me.get(82)?!0:Y.tabFocusMode}}var J;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(J=e.WrappingIndent||(e.WrappingIndent={}));function Ee(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ve extends p{constructor(){super(134)}compute(Y,me,Ue){const Ve=me.get(133);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}class Ne extends b{constructor(){const Y={enabled:!0};super(32,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:r.localize(164,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:l(Y.enabled,this.defaultValue.enabled)}}}const ze="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?Je:C.isLinux?Ge:ze,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Pe(X){return e.editorOptionsRegistry[X.id]=X,X}var nt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.guides=13]="guides",X[X.codeLens=14]="codeLens",X[X.codeLensFontFamily=15]="codeLensFontFamily",X[X.codeLensFontSize=16]="codeLensFontSize",X[X.colorDecorators=17]="colorDecorators",X[X.columnSelection=18]="columnSelection",X[X.comments=19]="comments",X[X.contextmenu=20]="contextmenu",X[X.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",X[X.cursorBlinking=22]="cursorBlinking",X[X.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",X[X.cursorStyle=24]="cursorStyle",X[X.cursorSurroundingLines=25]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",X[X.cursorWidth=27]="cursorWidth",X[X.disableLayerHinting=28]="disableLayerHinting",X[X.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",X[X.domReadOnly=30]="domReadOnly",X[X.dragAndDrop=31]="dragAndDrop",X[X.dropIntoEditor=32]="dropIntoEditor",X[X.emptySelectionClipboard=33]="emptySelectionClipboard",X[X.extraEditorClassName=34]="extraEditorClassName",X[X.fastScrollSensitivity=35]="fastScrollSensitivity",X[X.find=36]="find",X[X.fixedOverflowWidgets=37]="fixedOverflowWidgets",X[X.folding=38]="folding",X[X.foldingStrategy=39]="foldingStrategy",X[X.foldingHighlight=40]="foldingHighlight",X[X.foldingImportsByDefault=41]="foldingImportsByDefault",X[X.foldingMaximumRegions=42]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=44]="fontFamily",X[X.fontInfo=45]="fontInfo",X[X.fontLigatures=46]="fontLigatures",X[X.fontSize=47]="fontSize",X[X.fontWeight=48]="fontWeight",X[X.formatOnPaste=49]="formatOnPaste",X[X.formatOnType=50]="formatOnType",X[X.glyphMargin=51]="glyphMargin",X[X.gotoLocation=52]="gotoLocation",X[X.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",X[X.hover=54]="hover",X[X.inDiffEditor=55]="inDiffEditor",X[X.inlineSuggest=56]="inlineSuggest",X[X.letterSpacing=57]="letterSpacing",X[X.lightbulb=58]="lightbulb",X[X.lineDecorationsWidth=59]="lineDecorationsWidth",X[X.lineHeight=60]="lineHeight",X[X.lineNumbers=61]="lineNumbers",X[X.lineNumbersMinChars=62]="lineNumbersMinChars",X[X.linkedEditing=63]="linkedEditing",X[X.links=64]="links",X[X.matchBrackets=65]="matchBrackets",X[X.minimap=66]="minimap",X[X.mouseStyle=67]="mouseStyle",X[X.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=69]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",X[X.multiCursorModifier=71]="multiCursorModifier",X[X.multiCursorPaste=72]="multiCursorPaste",X[X.occurrencesHighlight=73]="occurrencesHighlight",X[X.overviewRulerBorder=74]="overviewRulerBorder",X[X.overviewRulerLanes=75]="overviewRulerLanes",X[X.padding=76]="padding",X[X.parameterHints=77]="parameterHints",X[X.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",X[X.quickSuggestions=80]="quickSuggestions",X[X.quickSuggestionsDelay=81]="quickSuggestionsDelay",X[X.readOnly=82]="readOnly",X[X.renameOnType=83]="renameOnType",X[X.renderControlCharacters=84]="renderControlCharacters",X[X.renderFinalNewline=85]="renderFinalNewline",X[X.renderLineHighlight=86]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=88]="renderValidationDecorations",X[X.renderWhitespace=89]="renderWhitespace",X[X.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",X[X.roundedSelection=91]="roundedSelection",X[X.rulers=92]="rulers",X[X.scrollbar=93]="scrollbar",X[X.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=95]="scrollBeyondLastLine",X[X.scrollPredominantAxis=96]="scrollPredominantAxis",X[X.selectionClipboard=97]="selectionClipboard",X[X.selectionHighlight=98]="selectionHighlight",X[X.selectOnLineNumbers=99]="selectOnLineNumbers",X[X.showFoldingControls=100]="showFoldingControls",X[X.showUnused=101]="showUnused",X[X.snippetSuggestions=102]="snippetSuggestions",X[X.smartSelect=103]="smartSelect",X[X.smoothScrolling=104]="smoothScrolling",X[X.stickyScroll=105]="stickyScroll",X[X.stickyTabStops=106]="stickyTabStops",X[X.stopRenderingLineAfter=107]="stopRenderingLineAfter",X[X.suggest=108]="suggest",X[X.suggestFontSize=109]="suggestFontSize",X[X.suggestLineHeight=110]="suggestLineHeight",X[X.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",X[X.suggestSelection=112]="suggestSelection",X[X.tabCompletion=113]="tabCompletion",X[X.tabIndex=114]="tabIndex",X[X.unicodeHighlighting=115]="unicodeHighlighting",X[X.unusualLineTerminators=116]="unusualLineTerminators",X[X.useShadowDOM=117]="useShadowDOM",X[X.useTabStops=118]="useTabStops",X[X.wordSeparators=119]="wordSeparators",X[X.wordWrap=120]="wordWrap",X[X.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=123]="wordWrapColumn",X[X.wordWrapOverride1=124]="wordWrapOverride1",X[X.wordWrapOverride2=125]="wordWrapOverride2",X[X.wrappingIndent=126]="wrappingIndent",X[X.wrappingStrategy=127]="wrappingStrategy",X[X.showDeprecated=128]="showDeprecated",X[X.inlayHints=129]="inlayHints",X[X.editorClassName=130]="editorClassName",X[X.pixelRatio=131]="pixelRatio",X[X.tabFocusMode=132]="tabFocusMode",X[X.layoutInfo=133]="layoutInfo",X[X.wrappingInfo=134]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Pe(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:r.localize(165,null)})),acceptSuggestionOnEnter:Pe(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",r.localize(166,null),""],markdownDescription:r.localize(167,null)})),accessibilitySupport:Pe(new s),accessibilityPageSize:Pe(new S(3,"accessibilityPageSize",10,1,1073741824,{description:r.localize(168,null),tags:["accessibility"]})),ariaLabel:Pe(new _(4,"ariaLabel",r.localize(169,null))),autoClosingBrackets:Pe(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(170,null),r.localize(171,null),""],description:r.localize(172,null)})),autoClosingDelete:Pe(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",r.localize(173,null),""],description:r.localize(174,null)})),autoClosingOvertype:Pe(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",r.localize(175,null),""],description:r.localize(176,null)})),autoClosingQuotes:Pe(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(177,null),r.localize(178,null),""],description:r.localize(179,null)})),autoIndent:Pe(new i(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],n,{enumDescriptions:[r.localize(180,null),r.localize(181,null),r.localize(182,null),r.localize(183,null),r.localize(184,null)],description:r.localize(185,null)})),automaticLayout:Pe(new d(10,"automaticLayout",!1)),autoSurround:Pe(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[r.localize(186,null),r.localize(187,null),r.localize(188,null),""],description:r.localize(189,null)})),bracketPairColorization:Pe(new k),bracketPairGuides:Pe(new B),stickyTabStops:Pe(new d(106,"stickyTabStops",!1,{description:r.localize(190,null)})),codeLens:Pe(new d(14,"codeLens",!0,{description:r.localize(191,null)})),codeLensFontFamily:Pe(new _(15,"codeLensFontFamily","",{description:r.localize(192,null)})),codeLensFontSize:Pe(new S(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:r.localize(193,null)})),colorDecorators:Pe(new d(17,"colorDecorators",!0,{description:r.localize(194,null)})),columnSelection:Pe(new d(18,"columnSelection",!1,{description:r.localize(195,null)})),comments:Pe(new h),contextmenu:Pe(new d(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Pe(new d(21,"copyWithSyntaxHighlighting",!0,{description:r.localize(196,null)})),cursorBlinking:Pe(new i(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:r.localize(197,null)})),cursorSmoothCaretAnimation:Pe(new d(23,"cursorSmoothCaretAnimation",!1,{description:r.localize(198,null)})),cursorStyle:Pe(new i(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:r.localize(199,null)})),cursorSurroundingLines:Pe(new S(25,"cursorSurroundingLines",0,0,1073741824,{description:r.localize(200,null)})),cursorSurroundingLinesStyle:Pe(new u(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[r.localize(201,null),r.localize(202,null)],description:r.localize(203,null)})),cursorWidth:Pe(new S(27,"cursorWidth",0,0,1073741824,{markdownDescription:r.localize(204,null)})),disableLayerHinting:Pe(new d(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Pe(new d(29,"disableMonospaceOptimizations",!1)),domReadOnly:Pe(new d(30,"domReadOnly",!1)),dragAndDrop:Pe(new d(31,"dragAndDrop",!0,{description:r.localize(205,null)})),emptySelectionClipboard:Pe(new U),dropIntoEditor:Pe(new Ne),stickyScroll:Pe(new re),extraEditorClassName:Pe(new _(34,"extraEditorClassName","")),fastScrollSensitivity:Pe(new c(35,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:r.localize(206,null)})),find:Pe(new D),fixedOverflowWidgets:Pe(new d(37,"fixedOverflowWidgets",!1)),folding:Pe(new d(38,"folding",!0,{description:r.localize(207,null)})),foldingStrategy:Pe(new u(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[r.localize(208,null),r.localize(209,null)],description:r.localize(210,null)})),foldingHighlight:Pe(new d(40,"foldingHighlight",!0,{description:r.localize(211,null)})),foldingImportsByDefault:Pe(new d(41,"foldingImportsByDefault",!1,{description:r.localize(212,null)})),foldingMaximumRegions:Pe(new S(42,"foldingMaximumRegions",5e3,10,65e3,{description:r.localize(213,null)})),unfoldOnClickAfterEndOfLine:Pe(new d(43,"unfoldOnClickAfterEndOfLine",!1,{description:r.localize(214,null)})),fontFamily:Pe(new _(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:r.localize(215,null)})),fontInfo:Pe(new L),fontLigatures2:Pe(new $),fontSize:Pe(new O),fontWeight:Pe(new H),formatOnPaste:Pe(new d(49,"formatOnPaste",!1,{description:r.localize(216,null)})),formatOnType:Pe(new d(50,"formatOnType",!1,{description:r.localize(217,null)})),glyphMargin:Pe(new d(51,"glyphMargin",!0,{description:r.localize(218,null)})),gotoLocation:Pe(new W),hideCursorInOverviewRuler:Pe(new d(53,"hideCursorInOverviewRuler",!1,{description:r.localize(219,null)})),hover:Pe(new z),inDiffEditor:Pe(new d(55,"inDiffEditor",!1)),letterSpacing:Pe(new c(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>c.clamp(X,-5,20),{description:r.localize(220,null)})),lightbulb:Pe(new he),lineDecorationsWidth:Pe(new a(59,"lineDecorationsWidth",10)),lineHeight:Pe(new le),lineNumbers:Pe(new ke),lineNumbersMinChars:Pe(new S(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Pe(new d(63,"linkedEditing",!1,{description:r.localize(221,null)})),links:Pe(new d(64,"links",!0,{description:r.localize(222,null)})),matchBrackets:Pe(new u(65,"matchBrackets","always",["always","near","never"],{description:r.localize(223,null)})),minimap:Pe(new fe),mouseStyle:Pe(new u(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Pe(new c(68,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:r.localize(224,null)})),mouseWheelZoom:Pe(new d(69,"mouseWheelZoom",!1,{markdownDescription:r.localize(225,null)})),multiCursorMergeOverlapping:Pe(new d(70,"multiCursorMergeOverlapping",!0,{description:r.localize(226,null)})),multiCursorModifier:Pe(new i(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Q,{markdownEnumDescriptions:[r.localize(227,null),r.localize(228,null)],markdownDescription:r.localize(229,null)})),multiCursorPaste:Pe(new u(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[r.localize(230,null),r.localize(231,null)],markdownDescription:r.localize(232,null)})),occurrencesHighlight:Pe(new d(73,"occurrencesHighlight",!0,{description:r.localize(233,null)})),overviewRulerBorder:Pe(new d(74,"overviewRulerBorder",!0,{description:r.localize(234,null)})),overviewRulerLanes:Pe(new S(75,"overviewRulerLanes",3,0,3)),padding:Pe(new pe),parameterHints:Pe(new Se),peekWidgetDefaultFocus:Pe(new u(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[r.localize(235,null),r.localize(236,null)],description:r.localize(237,null)})),definitionLinkOpensInPeek:Pe(new d(79,"definitionLinkOpensInPeek",!1,{description:r.localize(238,null)})),quickSuggestions:Pe(new Be),quickSuggestionsDelay:Pe(new S(81,"quickSuggestionsDelay",10,0,1073741824,{description:r.localize(239,null)})),readOnly:Pe(new d(82,"readOnly",!1)),renameOnType:Pe(new d(83,"renameOnType",!1,{description:r.localize(240,null),markdownDeprecationMessage:r.localize(241,null)})),renderControlCharacters:Pe(new d(84,"renderControlCharacters",!0,{description:r.localize(242,null),restricted:!0})),renderFinalNewline:Pe(new d(85,"renderFinalNewline",!0,{description:r.localize(243,null)})),renderLineHighlight:Pe(new u(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",r.localize(244,null)],description:r.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Pe(new d(87,"renderLineHighlightOnlyWhenFocus",!1,{description:r.localize(246,null)})),renderValidationDecorations:Pe(new u(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Pe(new u(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",r.localize(247,null),r.localize(248,null),r.localize(249,null),""],description:r.localize(250,null)})),revealHorizontalRightPadding:Pe(new S(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Pe(new d(91,"roundedSelection",!0,{description:r.localize(251,null)})),rulers:Pe(new De),scrollbar:Pe(new ue),scrollBeyondLastColumn:Pe(new S(94,"scrollBeyondLastColumn",4,0,1073741824,{description:r.localize(252,null)})),scrollBeyondLastLine:Pe(new d(95,"scrollBeyondLastLine",!0,{description:r.localize(253,null)})),scrollPredominantAxis:Pe(new d(96,"scrollPredominantAxis",!0,{description:r.localize(254,null)})),selectionClipboard:Pe(new d(97,"selectionClipboard",!0,{description:r.localize(255,null),included:C.isLinux})),selectionHighlight:Pe(new d(98,"selectionHighlight",!0,{description:r.localize(256,null)})),selectOnLineNumbers:Pe(new d(99,"selectOnLineNumbers",!0)),showFoldingControls:Pe(new u(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[r.localize(257,null),r.localize(258,null),r.localize(259,null)],description:r.localize(260,null)})),showUnused:Pe(new d(101,"showUnused",!0,{description:r.localize(261,null)})),showDeprecated:Pe(new d(128,"showDeprecated",!0,{description:r.localize(262,null)})),inlayHints:Pe(new be),snippetSuggestions:Pe(new u(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[r.localize(263,null),r.localize(264,null),r.localize(265,null),r.localize(266,null)],description:r.localize(267,null)})),smartSelect:Pe(new oe),smoothScrolling:Pe(new d(104,"smoothScrolling",!1,{description:r.localize(268,null)})),stopRenderingLineAfter:Pe(new S(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Pe(new q),inlineSuggest:Pe(new Z),suggestFontSize:Pe(new S(109,"suggestFontSize",0,0,1e3,{markdownDescription:r.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Pe(new S(110,"suggestLineHeight",0,0,1e3,{markdownDescription:r.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Pe(new d(111,"suggestOnTriggerCharacters",!0,{description:r.localize(271,null)})),suggestSelection:Pe(new u(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[r.localize(272,null),r.localize(273,null),r.localize(274,null)],description:r.localize(275,null)})),tabCompletion:Pe(new u(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[r.localize(276,null),r.localize(277,null),r.localize(278,null)],description:r.localize(279,null)})),tabIndex:Pe(new S(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Pe(new ee),unusualLineTerminators:Pe(new u(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[r.localize(280,null),r.localize(281,null),r.localize(282,null)],description:r.localize(283,null)})),useShadowDOM:Pe(new d(117,"useShadowDOM",!0)),useTabStops:Pe(new d(118,"useTabStops",!0,{description:r.localize(284,null)})),wordSeparators:Pe(new _(119,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:r.localize(285,null)})),wordWrap:Pe(new u(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[r.localize(286,null),r.localize(287,null),r.localize(288,null),r.localize(289,null)],description:r.localize(290,null)})),wordWrapBreakAfterCharacters:Pe(new _(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Pe(new _(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Pe(new S(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:r.localize(291,null)})),wordWrapOverride1:Pe(new u(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Pe(new u(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Pe(new i(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ee,{enumDescriptions:[r.localize(292,null),r.localize(293,null),r.localize(294,null),r.localize(295,null)],description:r.localize(296,null)})),wrappingStrategy:Pe(new u(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[r.localize(297,null),r.localize(298,null)],description:r.localize(299,null)})),editorClassName:Pe(new j),pixelRatio:Pe(new Fe),tabFocusMode:Pe(new ce),layoutInfo:Pe(new te),wrappingInfo:Pe(new ve)}}),define(Ce[124],Ie([16,17]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[125],Ie([16,17]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[126],Ie([16,17]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[127],Ie([16,17]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(Ce[128],Ie([16,17]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(Ce[129],Ie([16,17]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(Ce[130],Ie([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[131],Ie([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[132],Ie([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[133],Ie([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[134],Ie([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[135],Ie([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[136],Ie([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[137],Ie([16,17]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(Ce[138],Ie([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[139],Ie([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[140],Ie([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[141],Ie([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[142],Ie([16,17]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[143],Ie([16,17]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[144],Ie([16,17]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[145],Ie([1,0,22,29,126,244]),function(ne,e,r,C,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function E(d){return d=d.trim(),d==="*"||y.test(d)}e.isValidVersionStr=E;function P(d){if(!E(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=d.match(y);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=P;function R(d){if(!d)return null;const m=d.majorBase,S=d.majorMustEqual,c=d.minorBase;let _=d.minorMustEqual;const t=d.patchBase;let u=d.patchMustEqual;d.hasCaret&&(m===0||(_=!1),u=!1);let i=0;if(d.preRelease){const n=A.exec(d.preRelease);if(n){const[,s,h,o]=n;i=Date.UTC(Number(s),Number(h)-1,Number(o))}}return{majorBase:m,majorMustEqual:S,minorBase:c,minorMustEqual:_,patchBase:t,patchMustEqual:u,isMinimum:d.hasGreaterEquals,notBefore:i}}e.normalizeVersion=R;function b(d,m,S){let c;typeof d=="string"?c=R(P(d)):c=d;let _;m instanceof Date?_=m.getTime():typeof m=="string"&&(_=new Date(m).getTime());let t;if(typeof S=="string"?t=R(P(S)):t=S,!c||!t)return!1;const u=c.majorBase,i=c.minorBase,n=c.patchBase;let s=t.majorBase,h=t.minorBase,o=t.patchBase;const f=t.notBefore;let v=t.majorMustEqual,T=t.minorMustEqual,M=t.patchMustEqual;return t.isMinimum?u>s?!0:u<s?!1:i>h?!0:i<h||_&&_<f?!1:n>=o:(u===1&&s===0&&(!v||!T||!M)&&(s=1,h=0,o=0,v=!0,T=!1,M=!1),u<s?!1:u>s?!v:i<h?!1:i>h?!T:n<o?!1:n>o?!M:!(_&&_<f))}e.isValidVersion=b;function g(d,m,S,c,_){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([C.default.Error,w.localize(0,null)]),t;if(typeof c.name!="string")return t.push([C.default.Error,w.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([C.default.Error,w.localize(2,null,"version")]),t;if(!c.engines)return t.push([C.default.Error,w.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([C.default.Error,w.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!l(c.extensionDependencies))return t.push([C.default.Error,w.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!l(c.activationEvents))return t.push([C.default.Error,w.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([C.default.Error,w.localize(7,null,"activationEvents","main")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([C.default.Warning,w.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([C.default.Error,w.localize(9,null,"main")]),t;{const n=(0,r.joinPath)(S,c.main);(0,r.isEqualOrParent)(n,S)||t.push([C.default.Warning,w.localize(10,null,n.path,S.path)])}if(typeof c.activationEvents>"u")return t.push([C.default.Error,w.localize(11,null,"activationEvents","main")]),t}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([C.default.Error,w.localize(12,null,"browser")]),t;{const n=(0,r.joinPath)(S,c.browser);(0,r.isEqualOrParent)(n,S)||t.push([C.default.Warning,w.localize(13,null,n.path,S.path)])}if(typeof c.activationEvents>"u")return t.push([C.default.Error,w.localize(14,null,"activationEvents","browser")]),t}if(!F.valid(c.version))return t.push([C.default.Error,w.localize(15,null)]),t;const u=[];if(!I(d,m,c,_,u))for(const n of u)t.push([C.default.Error,n]);return t}e.validateExtensionManifest=g;function I(d,m,S,c,_){return c||typeof S.main>"u"&&typeof S.browser>"u"?!0:a(d,m,S.engines.vscode,_)}e.isValidExtensionVersion=I;function p(d,m,S){return d==="*"||a(m,S,d)}e.isEngineValid=p;function a(d,m,S,c=[]){const _=R(P(S));if(!_)return c.push(w.localize(16,null,S)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return c.push(w.localize(17,null,S)),!1}else if(!_.majorMustEqual)return c.push(w.localize(18,null,S)),!1;return b(d,m,_)?!0:(c.push(w.localize(19,null,d,S)),!1)}function l(d){if(!Array.isArray(d))return!1;for(let m=0,S=d.length;m<S;m++)if(typeof d[m]!="string")return!1;return!0}}),define(Ce[82],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(w,F=[],y=!1){this.ctor=w,this.staticArguments=F,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=r}),define(Ce[58],Ie([1,0,82]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const C=[];var w;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(w=e.InstantiationType||(e.InstantiationType={}));function F(A,E,P){E instanceof r.SyncDescriptor||(E=new r.SyncDescriptor(E,[],Boolean(P))),C.push([A,E])}e.registerSingleton=F;function y(){return C}e.getSingletonServiceDescriptors=y}),define(Ce[146],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(F,y){this.key=F,this.data=y,this.incoming=new Map,this.outgoing=new Map}}e.Node=r;class C{constructor(F){this._hashFn=F,this._nodes=new Map}roots(){const F=[];for(const y of this._nodes.values())y.outgoing.size===0&&F.push(y);return F}insertEdge(F,y){const A=this.lookupOrInsertNode(F),E=this.lookupOrInsertNode(y);A.outgoing.set(E.key,E),E.incoming.set(A.key,A)}removeNode(F){const y=this._hashFn(F);this._nodes.delete(y);for(const A of this._nodes.values())A.outgoing.delete(y),A.incoming.delete(y)}lookupOrInsertNode(F){const y=this._hashFn(F);let A=this._nodes.get(y);return A||(A=new r(y,F),this._nodes.set(y,A)),A}lookup(F){return this._nodes.get(this._hashFn(F))}isEmpty(){return this._nodes.size===0}toString(){const F=[];for(const[y,A]of this._nodes)F.push(`${y}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,y]of this._nodes){const A=new Set([F]),E=this._findCycle(y,A);if(E)return E}}_findCycle(F,y){for(const[A,E]of F.outgoing){if(y.has(A))return[...y,A].join(" -> ");y.add(A);const P=this._findCycle(E,y);if(P)return P;y.delete(A)}}}e.Graph=C}),define(Ce[3],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var r;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function A(E){return E[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=A})(r=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function C(y,A,E){A[r.DI_TARGET]===A?A[r.DI_DEPENDENCIES].push({id:y,index:E}):(A[r.DI_DEPENDENCIES]=[{id:y,index:E}],A[r.DI_TARGET]=A)}function w(y){if(r.serviceIds.has(y))return r.serviceIds.get(y);const A=function(E,P,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(A,E,R)};return A.toString=()=>y,r.serviceIds.set(y,A),A}e.createDecorator=w;function F(y){return y}e.refineServiceDecorator=F}),define(Ce[45],Ie([1,0,10,2,3]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function F(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof C.URI)}e.isConfigurationOverrides=F;function y(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=y;var A;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function P(d,m){const S=Object.create(null);for(const c in d)R(S,c,d[c],m);return S}e.toValuesTree=P;function R(d,m,S,c){const _=m.split("."),t=_.pop();let u=d;for(let i=0;i<_.length;i++){const n=_[i];let s=u[n];switch(typeof s){case"undefined":s=u[n]=Object.create(null);break;case"object":break;default:c(`Ignoring ${m} as ${_.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}u=s}if(typeof u=="object"&&u!==null)try{u[t]=S}catch{c(`Ignoring ${m} as ${_.join(".")} is ${JSON.stringify(u)}`)}else c(`Ignoring ${m} as ${_.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=R;function b(d,m){const S=m.split(".");g(d,S)}e.removeFromValueTree=b;function g(d,m){const S=m.shift();if(m.length===0){delete d[S];return}if(Object.keys(d).indexOf(S)!==-1){const c=d[S];typeof c=="object"&&!Array.isArray(c)&&(g(c,m),Object.keys(c).length===0&&delete d[S])}}function I(d,m,S){function c(u,i){let n=u;for(const s of i){if(typeof n!="object"||n===null)return;n=n[s]}return n}const _=m.split("."),t=c(d,_);return typeof t>"u"?S:t}e.getConfigurationValue=I;function p(d,m,S){Object.keys(m).forEach(c=>{c!=="__proto__"&&(c in d?r.isObject(d[c])&&r.isObject(m[c])?p(d[c],m[c],S):S&&(d[c]=m[c]):d[c]=m[c])})}e.merge=p;function a(d,m,S){const c=d.inspect(m),_=d.inspect(S);return typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:typeof _.userValue<"u"||typeof _.workspaceValue<"u"||typeof _.workspaceFolderValue<"u"?_.value:c.defaultValue}e.getMigratedSettingValue=a;function l(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=l}),define(Ce[40],Ie([1,0,20,9,3]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",r.isMacintosh),F.set("isLinux",r.isLinux),F.set("isWindows",r.isWindows),F.set("isWeb",r.isWeb),F.set("isMacNative",r.isMacintosh&&!r.isWeb),F.set("isEdge",r.isEdge),F.set("isFirefox",r.isFirefox),F.set("isChrome",r.isChrome),F.set("isSafari",r.isSafari);const y=Object.prototype.hasOwnProperty;var A;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return b.INSTANCE}static true(){return g.INSTANCE}static has(D){return I.create(D)}static equals(D,$){return p.create(D,$)}static notEquals(D,$){return d.create(D,$)}static regex(D,$){return i.create(D,$)}static in(D,$){return a.create(D,$)}static notIn(D,$){return l.create(D,$)}static not(D){return m.create(D)}static and(...D){return h.create(D,null)}static or(...D){return o.create(D,null,!0)}static greater(D,$){return c.create(D,$)}static greaterEquals(D,$){return _.create(D,$)}static smaller(D,$){return t.create(D,$)}static smallerEquals(D,$){return u.create(D,$)}static deserialize(D,$=!1){if(!!D)return this._deserializeOrExpression(D,$)}static _deserializeOrExpression(D,$){const L=D.split("||");return o.create(L.map(O=>this._deserializeAndExpression(O,$)),null,!0)}static _deserializeAndExpression(D,$){const L=D.split("&&");return h.create(L.map(O=>this._deserializeOne(O,$)),null)}static _deserializeOne(D,$){if(D=D.trim(),D.indexOf("!=")>=0){const L=D.split("!=");return d.create(L[0].trim(),this._deserializeValue(L[1],$))}if(D.indexOf("==")>=0){const L=D.split("==");return p.create(L[0].trim(),this._deserializeValue(L[1],$))}if(D.indexOf("=~")>=0){const L=D.split("=~");return i.create(L[0].trim(),this._deserializeRegexValue(L[1],$))}if(D.indexOf(" not in ")>=0){const L=D.split(" not in ");return l.create(L[0].trim(),this._deserializeValue(L[1],$))}if(D.indexOf(" in ")>=0){const L=D.split(" in ");return a.create(L[0].trim(),this._deserializeValue(L[1],$))}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const L=D.split(">=");return _.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const L=D.split(">");return c.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const L=D.split("<=");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const L=D.split("<");return t.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(D)?m.create(D.substr(1).trim()):I.create(D)}static _deserializeValue(D,$){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;const L=/^'([^']*)'$/.exec(D);return L?L[1].trim():D}static _deserializeRegexValue(D,$){if((0,C.isFalsyOrWhitespace)(D)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const L=D.indexOf("/"),O=D.lastIndexOf("/");if(L===O||L<0){if($)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}const H=D.slice(L+1,O),W=D[O+1]==="i"?"i":"";try{return new RegExp(H,W)}catch(z){if($)throw new Error(`bad regexp-value '${D}', parse error: ${z}`);return console.warn(`bad regexp-value '${D}', parse error: ${z}`),null}}}e.ContextKeyExpr=E;function P(U,D){const $=U?U.substituteConstants():void 0,L=D?D.substituteConstants():void 0;return!$&&!L?!0:!$||!L?!1:$.equals(L)}e.expressionsAreEqualWithConstantSubstitution=P;function R(U,D){return U.cmp(D)}class b{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class g{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class I{static create(D,$=null){const L=F.get(D);return typeof L=="boolean"?L?g.INSTANCE:b.INSTANCE:new I(D,$)}constructor(D,$){this.key=D,this.negated=$,this.type=2}cmp(D){return D.type!==this.type?this.type-D.type:v(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=F.get(this.key);return typeof D=="boolean"?D?g.INSTANCE:b.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=I;class p{static create(D,$,L=null){if(typeof $=="boolean")return $?I.create(D,L):m.create(D,L);const O=F.get(D);return typeof O=="boolean"?$===(O?"true":"false")?g.INSTANCE:b.INSTANCE:new p(D,$,L)}constructor(D,$,L){this.key=D,this.value=$,this.negated=L,this.type=4}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=F.get(this.key);if(typeof D=="boolean"){const $=D?"true":"false";return this.value===$?g.INSTANCE:b.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class a{static create(D,$){return new a(D,$)}constructor(D,$){this.key=D,this.valueKey=$,this.type=10,this.negated=null}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const $=D.getValue(this.valueKey),L=D.getValue(this.key);return Array.isArray($)?$.includes(L):typeof L=="string"&&typeof $=="object"&&$!==null?y.call($,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=l.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=a;class l{static create(D,$){return new l(D,$)}constructor(D,$){this.key=D,this.valueKey=$,this.type=11,this._negated=a.create(D,$)}cmp(D){return D.type!==this.type?this.type-D.type:this._negated.cmp(D._negated)}equals(D){return D.type===this.type?this._negated.equals(D._negated):!1}substituteConstants(){return this}evaluate(D){return!this._negated.evaluate(D)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(D){return D.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=l;class d{static create(D,$,L=null){if(typeof $=="boolean")return $?m.create(D,L):I.create(D,L);const O=F.get(D);return typeof O=="boolean"?$===(O?"true":"false")?b.INSTANCE:g.INSTANCE:new d(D,$,L)}constructor(D,$,L){this.key=D,this.value=$,this.negated=L,this.type=5}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=F.get(this.key);if(typeof D=="boolean"){const $=D?"true":"false";return this.value===$?b.INSTANCE:g.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=d;class m{static create(D,$=null){const L=F.get(D);return typeof L=="boolean"?L?b.INSTANCE:g.INSTANCE:new m(D,$)}constructor(D,$){this.key=D,this.negated=$,this.type=3}cmp(D){return D.type!==this.type?this.type-D.type:v(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=F.get(this.key);return typeof D=="boolean"?D?b.INSTANCE:g.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function S(U,D){if(typeof U=="string"){const $=parseFloat(U);isNaN($)||(U=$)}return typeof U=="string"||typeof U=="number"?D(U):b.INSTANCE}class c{static create(D,$,L=null){return S($,O=>new c(D,O,L))}constructor(D,$,L){this.key=D,this.value=$,this.negated=L,this.type=12}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class _{static create(D,$,L=null){return S($,O=>new _(D,O,L))}constructor(D,$,L){this.key=D,this.value=$,this.negated=L,this.type=13}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=_;class t{static create(D,$,L=null){return S($,O=>new t(D,O,L))}constructor(D,$,L){this.key=D,this.value=$,this.negated=L,this.type=14}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class u{static create(D,$,L=null){return S($,O=>new u(D,O,L))}constructor(D,$,L){this.key=D,this.value=$,this.negated=L,this.type=15}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class i{static create(D,$){return new i(D,$)}constructor(D,$){this.key=D,this.regexp=$,this.type=7,this.negated=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const $=this.regexp?this.regexp.source:"",L=D.regexp?D.regexp.source:"";return $<L?-1:$>L?1:0}equals(D){if(D.type===this.type){const $=this.regexp?this.regexp.source:"",L=D.regexp?D.regexp.source:"";return this.key===D.key&&$===L}return!1}substituteConstants(){return this}evaluate(D){const $=D.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class n{static create(D){return new n(D)}constructor(D){this._actual=D,this.type=8}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new n(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function s(U){let D=null;for(let $=0,L=U.length;$<L;$++){const O=U[$].substituteConstants();if(U[$]!==O&&D===null){D=[];for(let H=0;H<$;H++)D[H]=U[H]}D!==null&&(D[$]=O)}return D===null?U:D}class h{static create(D,$){return h._normalizeArr(D,$)}constructor(D,$){this.expr=D,this.negated=$,this.type=6}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let $=0,L=this.expr.length;$<L;$++){const O=R(this.expr[$],D.expr[$]);if(O!==0)return O}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let $=0,L=this.expr.length;$<L;$++)if(!this.expr[$].equals(D.expr[$]))return!1;return!0}return!1}substituteConstants(){const D=s(this.expr);return D===this.expr?this:h.create(D,this.negated)}evaluate(D){for(let $=0,L=this.expr.length;$<L;$++)if(!this.expr[$].evaluate(D))return!1;return!0}static _normalizeArr(D,$){const L=[];let O=!1;for(const H of D)if(!!H){if(H.type===1){O=!0;continue}if(H.type===0)return b.INSTANCE;if(H.type===6){L.push(...H.expr);continue}L.push(H)}if(L.length===0&&O)return g.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(R);for(let H=1;H<L.length;H++)L[H-1].equals(L[H])&&(L.splice(H,1),H--);if(L.length===1)return L[0];for(;L.length>1;){const H=L[L.length-1];if(H.type!==9)break;L.pop();const W=L.pop(),z=L.length===0,G=o.create(H.expr.map(te=>h.create([te,W],null)),null,z);G&&(L.push(G),L.sort(R))}return L.length===1?L[0]:new h(L,$)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const $ of this.expr)D.push(...$.keys());return D}map(D){return new h(this.expr.map($=>$.map(D)),null)}negate(){if(!this.negated){const D=[];for(const $ of this.expr)D.push($.negate());this.negated=o.create(D,this,!0)}return this.negated}}class o{static create(D,$,L){return o._normalizeArr(D,$,L)}constructor(D,$){this.expr=D,this.negated=$,this.type=9}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let $=0,L=this.expr.length;$<L;$++){const O=R(this.expr[$],D.expr[$]);if(O!==0)return O}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let $=0,L=this.expr.length;$<L;$++)if(!this.expr[$].equals(D.expr[$]))return!1;return!0}return!1}substituteConstants(){const D=s(this.expr);return D===this.expr?this:o.create(D,this.negated,!1)}evaluate(D){for(let $=0,L=this.expr.length;$<L;$++)if(this.expr[$].evaluate(D))return!0;return!1}static _normalizeArr(D,$,L){let O=[],H=!1;if(D){for(let W=0,z=D.length;W<z;W++){const G=D[W];if(!!G){if(G.type===0){H=!0;continue}if(G.type===1)return g.INSTANCE;if(G.type===9){O=O.concat(G.expr);continue}O.push(G)}}if(O.length===0&&H)return b.INSTANCE;O.sort(R)}if(O.length!==0){if(O.length===1)return O[0];for(let W=1;W<O.length;W++)O[W-1].equals(O[W])&&(O.splice(W,1),W--);if(O.length===1)return O[0];if(L){for(let W=0;W<O.length;W++)for(let z=W+1;z<O.length;z++)M(O[W],O[z])&&(O.splice(z,1),z--);if(O.length===1)return O[0]}return new o(O,$)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const $ of this.expr)D.push(...$.keys());return D}map(D){return new o(this.expr.map($=>$.map(D)),null)}negate(){if(!this.negated){const D=[];for(const $ of this.expr)D.push($.negate());for(;D.length>1;){const $=D.shift(),L=D.shift(),O=[];for(const W of j($))for(const z of j(L))O.push(h.create([W,z],null));const H=D.length===0;D.unshift(o.create(O,null,H))}this.negated=D[0]}return this.negated}}class f extends I{static all(){return f._info.values()}constructor(D,$,L){super(D,null),this._defaultValue=$,typeof L=="object"?f._info.push({...L,key:D}):L!==!0&&f._info.push({key:D,description:L,type:$!=null?typeof $:void 0})}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return p.create(this.key,D)}notEqualsTo(D){return d.create(this.key,D)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(U,D){return U<D?-1:U>D?1:0}function T(U,D,$,L){return U<$?-1:U>$?1:D<L?-1:D>L?1:0}function M(U,D){if(D.type===6&&U.type!==9&&U.type!==6){for(const O of D.expr)if(U.equals(O))return!0}const $=U.negate(),L=j($).concat(j(D));L.sort(R);for(let O=0;O<L.length;O++){const W=L[O].negate();for(let z=O+1;z<L.length;z++){const G=L[z];if(W.equals(G))return!0}}return!1}e.implies=M;function j(U){return U.type===9?U.expr:[U]}}),define(Ce[147],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[83],Ie([1,0,125,3]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function w(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=w;function F(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=F;function y(d,m){switch(d){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function A(d,m){return m==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function E(d,m,S){return A(m,S)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===S?!0:P(S).includes(d)}e.isTargetPlatformCompatible=E;function P(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function R(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=R;var b;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var g;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var I;(function(d){d.Install="install",d.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var p;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var a;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(a=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class l extends Error{constructor(m,S){super(m),this.code=S,this.name=S}}e.ExtensionManagementError=l,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,r.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,r.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ce[35],Ie([1,0,25,19,9,10,2,127,3]),function(ne,e,r,C,w,F,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function P(W){return W.create===!0}e.isFileOpenForWriteOptions=P;var R;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var b;(function(W){W[W.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var g;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function I(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=I;function p(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=p;function a(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=a;function l(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function d(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=d;function m(W){return I(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var S;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(z,G){super(z),this.code=G}}e.FileSystemProviderError=c;function _(W,z){const G=new c(W.toString(),z);return u(G,z),G}e.createFileSystemProviderError=_;function t(W){return W||_((0,A.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=t;function u(W,z){return W.name=z?`${z} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=u;function i(W){if(!W)return S.Unknown;if(W instanceof c)return W.code;const z=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!z)return S.Unknown;switch(z[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=i;function n(W){if(W instanceof T)return W.fileOperationResult;switch(i(W)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class h{constructor(z,G,te){this.resource=z,this.operation=G,this.target=te}isOperation(z){return this.operation===z}}e.FileOperationEvent=h;var o;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class f{constructor(z,G){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=z;const te=new Map;for(const he of z){const re=te.get(he.type);switch(re?re.push([he.resource,he]):te.set(he.type,[[he.resource,he]]),he.type){case 1:this.rawAdded.push(he.resource);break;case 0:this.rawUpdated.push(he.resource);break;case 2:this.rawDeleted.push(he.resource);break}}for(const[he,re]of te)switch(he){case 1:this.added=r.TernarySearchTree.forUris(()=>G),this.added.fill(re);break;case 0:this.updated=r.TernarySearchTree.forUris(()=>G),this.updated.fill(re);break;case 2:this.deleted=r.TernarySearchTree.forUris(()=>G),this.deleted.fill(re);break}}contains(z,...G){return this.doContains(z,{includeChildren:!1},...G)}affects(z,...G){return this.doContains(z,{includeChildren:!0},...G)}doContains(z,G,...te){if(!z)return!1;const he=te.length>0;return!!((!he||te.includes(1))&&(this.added?.get(z)||G.includeChildren&&this.added?.findSuperstr(z))||(!he||te.includes(0))&&(this.updated?.get(z)||G.includeChildren&&this.updated?.findSuperstr(z))||(!he||te.includes(2))&&(this.deleted?.findSubstr(z)||G.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=f;function v(W,z,G){return!W||!z||W===z||z.length>W.length?!1:(z.charAt(z.length-1)!==C.sep&&(z+=C.sep),G?(0,w.startsWithIgnoreCase)(W,z):W.indexOf(z)===0)}e.isParent=v;class T extends Error{constructor(z,G,te){super(z),this.fileOperationResult=G,this.options=te}}e.FileOperationError=T;class M extends T{constructor(z,G,te){super(z,2,te),this.stat=G}}e.NotModifiedSinceFileOperationError=M;var j;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(j=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=D;async function $(W,z){if(!z.hasProvider(y.URI.from({scheme:W.scheme})))return new Promise(G=>{const te=z.onDidChangeFileSystemProviderRegistrations(he=>{he.scheme===W.scheme&&he.added&&(te.dispose(),G())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(z){return(0,F.isNumber)(z)||(z=0),z<L.KB?(0,A.localize)(1,null,z.toFixed(0)):z<L.MB?(0,A.localize)(2,null,(z/L.KB).toFixed(2)):z<L.GB?(0,A.localize)(3,null,(z/L.MB).toFixed(2)):z<L.TB?(0,A.localize)(4,null,(z/L.GB).toFixed(2)):(0,A.localize)(5,null,(z/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var O;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(O=e.Arch||(e.Arch={}));function H(W){return{maxFileSize:W===0?300*L.MB:16*L.GB,maxHeapSize:W===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=H}),define(Ce[59],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(...w){this._entries=new Map;for(const[F,y]of w)this.set(F,y)}set(w,F){const y=this._entries.get(w);return this._entries.set(w,F),y}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=r}),define(Ce[148],Ie([1,0,15,12,7,82,146,3,59,149]),function(ne,e,r,C,w,F,y,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class b extends Error{constructor(l){super("cyclic dependency between services"),this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class g{constructor(l=new E.ServiceCollection,d=!1,m,S=R){this._services=l,this._strict=d,this._parent=m,this._enableTracing=S,this._activeInstantiations=new Set,this._services.set(A.IInstantiationService,this),this._globalGraph=S?m?._globalGraph??new y.Graph(c=>c):void 0}createChild(l){return new g(l,this._strict,this,this._enableTracing)}invokeFunction(l,...d){const m=p.traceInvocation(this._enableTracing,l);let S=!1;try{return l({get:_=>{if(S)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(_,m);if(!t)throw new Error(`[invokeFunction] unknown service '${_}'`);return t}},...d)}finally{S=!0,m.stop()}}createInstance(l,...d){let m,S;return l instanceof F.SyncDescriptor?(m=p.traceCreation(this._enableTracing,l.ctor),S=this._createInstance(l.ctor,l.staticArguments.concat(d),m)):(m=p.traceCreation(this._enableTracing,l),S=this._createInstance(l,d,m)),m.stop(),S}_createInstance(l,d=[],m){const S=A._util.getServiceDependencies(l).sort((t,u)=>t.index-u.index),c=[];for(const t of S){const u=this._getOrCreateServiceInstance(t.id,m);u||this._throwIfStrict(`[createInstance] ${l.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(u)}const _=S.length>0?S[0].index:d.length;if(d.length!==_){console.trace(`[createInstance] First service dependency of ${l.name} at position ${_+1} conflicts with ${d.length} static arguments`);const t=_-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,_)}return Reflect.construct(l,d.concat(c))}_setServiceInstance(l,d){if(this._services.get(l)instanceof F.SyncDescriptor)this._services.set(l,d);else if(this._parent)this._parent._setServiceInstance(l,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){const d=this._services.get(l);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):d}_getOrCreateServiceInstance(l,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(l));const m=this._getServiceInstanceOrDescriptor(l);return m instanceof F.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,m,d.branch(l,!0)):(d.branch(l,!1),m)}_safeCreateAndCacheServiceInstance(l,d,m){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,d,m)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,d,m){const S=new y.Graph(t=>t.id.toString());let c=0;const _=[{id:l,desc:d,_trace:m}];for(;_.length;){const t=_.pop();if(S.lookupOrInsertNode(t),c++>1e3)throw new b(S);for(const u of A._util.getServiceDependencies(t.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(u.id);if(i||this._throwIfStrict(`[createInstance] ${l} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(u.id)),i instanceof F.SyncDescriptor){const n={id:u.id,desc:i,_trace:t._trace.branch(u.id,!0)};S.insertEdge(t,n),_.push(n)}}}for(;;){const t=S.roots();if(t.length===0){if(!S.isEmpty())throw new b(S);break}for(const{data:u}of t){if(this._getServiceInstanceOrDescriptor(u.id)instanceof F.SyncDescriptor){const n=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,n)}S.removeNode(u)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,d,m=[],S,c){if(this._services.get(l)instanceof F.SyncDescriptor)return this._createServiceInstance(l,d,m,S,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,d,m,S,c);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(l,d,m=[],S,c){if(S){const _=new g(void 0,this._strict,this,this._enableTracing);_._globalGraphImplicitDependency=String(l);const t=new Map,u=new r.IdleValue(()=>{const i=_._createInstance(d,m,c);for(const[n,s]of t){const h=i[n];if(typeof h=="function")for(const o of s)h.apply(i,o)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!u.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let o=t.get(n);return o||(o=new P.LinkedList,t.set(n,o)),(v,T,M)=>{const j=o.push([v,T,M]);return(0,w.toDisposable)(j)}}if(n in i)return i[n];const s=u.value;let h=s[n];return typeof h!="function"||(h=h.bind(s),i[n]=h),h},set(i,n,s){return u.value[n]=s,!0}})}else return this._createInstance(d,m,c)}_throwIfStrict(l,d){if(d&&console.warn(l),this._strict)throw new Error(l)}}e.InstantiationService=g;var I;(function(a){a[a.Creation=0]="Creation",a[a.Invocation=1]="Invocation",a[a.Branch=2]="Branch"})(I||(I={}));class p{static traceInvocation(l,d){return l?new p(1,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(l,d){return l?new p(0,d.name):p._None}constructor(l,d){this.type=l,this.name=d,this._start=Date.now(),this._dep=[]}branch(l,d){const m=new p(2,l.toString());return this._dep.push([l,d,m]),m}stop(){const l=Date.now()-this._start;p._totals+=l;let d=!1;function m(c,_){const t=[],u=new Array(c+1).join("	");for(const[i,n,s]of _._dep)if(n&&s){d=!0,t.push(`${u}CREATES -> ${i}`);const h=m(c+1,s);h&&t.push(h)}else t.push(`${u}uses -> ${i}`);return t.join(`
`)}const S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(l>2||d)&&p.all.add(S.join(`
`))}}e.Trace=p,p.all=new Set,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(Ce[11],Ie([1,0,44,4,7,20,3]),function(ne,e,r,C,w,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function A(){return new Date().toISOString()}var E;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function P(u,i,n){switch(i){case E.Trace:u.trace(n);break;case E.Debug:u.debug(n);break;case E.Info:u.info(n);break;case E.Warning:u.warn(n);break;case E.Error:u.error(n);break;case E.Critical:u.critical(n);break;default:throw new Error("Invalid log level")}}e.log=P;function R(u){let i="";for(let n=0;n<u.length;n++){let s=u[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}i+=(n>0?" ":"")+s}return i}e.format=R;class b extends w.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class g extends b{constructor(i){super(),this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(E.Trace)&&this.log(E.Trace,R([i,...n]))}debug(i,...n){this.checkLogLevel(E.Debug)&&this.log(E.Debug,R([i,...n]))}info(i,...n){this.checkLogLevel(E.Info)&&this.log(E.Info,R([i,...n]))}warn(i,...n){this.checkLogLevel(E.Warning)&&this.log(E.Warning,R([i,...n]))}error(i,...n){if(this.checkLogLevel(E.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(E.Error,R(s))}else this.log(E.Error,R([i,...n]))}critical(i,...n){this.checkLogLevel(E.Critical)&&this.log(E.Critical,R([i,...n]))}flush(){}}e.AbstractMessageLogger=g;class I extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i),this.useColors=!F.isWindows}trace(i,...n){this.getLevel()<=E.Trace&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.log(`[main ${A()}]`,i,...n))}debug(i,...n){this.getLevel()<=E.Debug&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.log(`[main ${A()}]`,i,...n))}info(i,...n){this.getLevel()<=E.Info&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.log(`[main ${A()}]`,i,...n))}warn(i,...n){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${A()}]\x1B[0m`,i,...n):console.warn(`[main ${A()}]`,i,...n))}error(i,...n){this.getLevel()<=E.Error&&(this.useColors?console.error(`\x1B[91m[main ${A()}]\x1B[0m`,i,...n):console.error(`[main ${A()}]`,i,...n))}critical(i,...n){this.getLevel()<=E.Critical&&(this.useColors?console.error(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.error(`[main ${A()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class p extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i)}trace(i,...n){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=p;class a extends b{constructor(i,n=e.DEFAULT_LOG_LEVEL){super(),this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,r.toErrorMessage)(i,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=a;class l extends b{constructor(i){super(),this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const s of this.logServices)s.trace(i,...n)}debug(i,...n){for(const s of this.logServices)s.debug(i,...n)}info(i,...n){for(const s of this.logServices)s.info(i,...n)}warn(i,...n){for(const s of this.logServices)s.warn(i,...n)}error(i,...n){for(const s of this.logServices)s.error(i,...n)}critical(i,...n){for(const s of this.logServices)s.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=l;class d extends w.Disposable{constructor(i){super(),this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=d;class m extends w.Disposable{constructor(i,n){super(),this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(h=>h.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,n?.always?E.Trace:this.logLevel,n),this.loggers.set(i.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=m;class S{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(i){}getLevel(){return E.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=S;function c(u){if(u.verbose)return E.Trace;if(typeof u.logLevel=="string"){const i=_(u.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function _(u){switch(u){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=_;function t(u){switch(u){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=t}),define(Ce[84],Ie([1,0,29,128,3]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(F=e.MarkerTag||(e.MarkerTag={}));var y;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function P(p,a){return a-p}E.compare=P;const R=Object.create(null);R[E.Error]=(0,C.localize)(0,null),R[E.Warning]=(0,C.localize)(1,null),R[E.Info]=(0,C.localize)(2,null);function b(p){return R[p]||""}E.toString=b;function g(p){switch(p){case r.default.Error:return E.Error;case r.default.Warning:return E.Warning;case r.default.Info:return E.Info;case r.default.Ignore:return E.Hint}}E.fromSeverity=g;function I(p){switch(p){case E.Error:return r.default.Error;case E.Warning:return r.default.Warning;case E.Info:return r.default.Info;case E.Hint:return r.default.Ignore}}E.toSeverity=I}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(E){const P="";function R(g){return b(g,!0)}E.makeKey=R;function b(g,I){const p=[P];return g.source?p.push(g.source.replace("\xA6","\\\xA6")):p.push(P),g.code?typeof g.code=="string"?p.push(g.code.replace("\xA6","\\\xA6")):p.push(g.code.value.replace("\xA6","\\\xA6")):p.push(P),g.severity!==void 0&&g.severity!==null?p.push(y.toString(g.severity)):p.push(P),g.message&&I?p.push(g.message.replace("\xA6","\\\xA6")):p.push(P),g.startLineNumber!==void 0&&g.startLineNumber!==null?p.push(g.startLineNumber.toString()):p.push(P),g.startColumn!==void 0&&g.startColumn!==null?p.push(g.startColumn.toString()):p.push(P),g.endLineNumber!==void 0&&g.endLineNumber!==null?p.push(g.endLineNumber.toString()):p.push(P),g.endColumn!==void 0&&g.endColumn!==null?p.push(g.endColumn.toString()):p.push(P),p.push(P),p.join("\xA6")}E.makeKeyOptionalMessage=b})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(Ce[150],Ie([1,0,4,29,3]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=C.default,e.INotificationService=(0,w.createDecorator)("notificationService");var F;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(F=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new E,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=A;class E{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=E}),define(Ce[85],Ie([1,0,7,9,2,3]),function(ne,e,r,C,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,F.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return r.Disposable.None},registerValidator(){return r.Disposable.None},registerExternalUriResolver(){return r.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return r.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function y(R,b){return w.URI.isUri(R)?(0,C.equalsIgnoreCase)(R.scheme,b):(0,C.startsWithIgnoreCase)(R,b+":")}e.matchesScheme=y;function A(R,...b){return b.some(g=>y(R,g))}e.matchesSomeScheme=A;function E(R,b){return R.with({fragment:`${b.startLineNumber},${b.startColumn}${b.endLineNumber?`-${b.endLineNumber}${b.endColumn?`,${b.endColumn}`:""}`:""}`})}e.withSelection=E;function P(R){let b;const g=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(R.fragment);return g&&(b={startLineNumber:parseInt(g[1]),startColumn:g[2]?parseInt(g[2]):1,endLineNumber:g[4]?parseInt(g[4]):void 0,endColumn:g[4]?g[5]?parseInt(g[5]):1:void 0},R=R.with({fragment:""})),{selection:b,uri:R}}e.extractSelection=P}),define(Ce[151],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,r.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__decorate||function(ne,e,r,C){var w=arguments.length,F=w<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,r):C,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(ne,e,r,C);else for(var A=ne.length-1;A>=0;A--)(y=ne[A])&&(F=(w<3?y(F):w>3?y(e,r,F):y(e,r))||F);return w>3&&F&&Object.defineProperty(e,r,F),F},xe=this&&this.__param||function(ne,e){return function(r,C){e(r,C,ne)}};define(Ce[152],Ie([1,0,15,21,7,3]),function(ne,e,r,C,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,F.createDecorator)("progressService");var y;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this._value}constructor(b){this.callback=b}report(b){this._value=b,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let E=class extends w.Disposable{constructor(b,g){super(),this.deferred=new r.DeferredPromise,g.withProgress(b,I=>(this.reporter=I,this.lastStep&&I.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};E=$e([xe(1,e.IProgressService)],E),e.UnmanagedProgress=E;class P extends w.Disposable{constructor(b){super(),this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(b){this.stop();const g=++this.currentOperationId,I=new C.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{g===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>I.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:g,token:I.token,stop:()=>this.doStop(g),isCurrent:()=>this.currentOperationId===g}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,F.createDecorator)("editorProgressService")}),define(Ce[30],Ie([1,0,46,10]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(y,A){r.ok(C.isString(y)),r.ok(C.isObject(A)),r.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,A)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new w}),define(Ce[86],Ie([1,0,4,30]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class F{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,P){this.schemasById[w(E)]=P,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new F;C.Registry.add(e.Extensions.JSONContribution,y)}),define(Ce[87],Ie([1,0,18,4,10,124,45,86,30]),function(ne,e,r,C,w,F,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(_){_.Multiline="multilineText",_.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=E.Registry.as(A.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const i=this.doRegisterConfigurations(t,u);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const u=this.doDeregisterConfigurations(t);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:t,remove:u}){const i=[];i.push(...this.doDeregisterConfigurations(u)),i.push(...this.doRegisterConfigurations(t,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,r.distinct)(i)})}registerDefaultConfigurations(t){const u=[],i=[];for(const{overrides:n,source:s}of t)for(const h in n)if(u.push(h),e.OVERRIDE_PROPERTY_REGEX.test(h)){const o=this.configurationDefaultsOverrides.get(h),f=o?.valuesSources??new Map;if(s)for(const j of Object.keys(n[h]))f.set(j,s);const v={...o?.value||{},...n[h]};this.configurationDefaultsOverrides.set(h,{source:s,value:v,valuesSources:f});const T=(0,y.getLanguageTagSettingPlainKey)(h),M={type:"object",default:v,description:F.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:w.isString(s)?void 0:s,defaultValueSource:s};i.push(...a(h)),this.configurationProperties[h]=M,this.defaultLanguageConfigurationOverridesNode.properties[h]=M}else{this.configurationDefaultsOverrides.set(h,{value:n[h],source:s});const o=this.configurationProperties[h];o&&(this.updatePropertyDefaultValue(h,o),this.updateSchema(h,o))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const u=[];for(const{overrides:i,source:n}of t)for(const s in i){const h=this.configurationDefaultsOverrides.get(s),o=w.isString(n)?n:n?.id,f=w.isString(h?.source)?h?.source:h?.source?.id;if(o===f)if(u.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const v=this.configurationProperties[s];v&&(this.updatePropertyDefaultValue(s,v),this.updateSchema(s,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const u of t)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,u){const i=[];return t.forEach(n=>{i.push(...this.validateAndRegisterProperties(n,u,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),i}doDeregisterConfigurations(t){const u=[],i=n=>{if(n.properties)for(const s in n.properties){u.push(s);const h=this.configurationProperties[s];h?.policy?.name&&this.policyConfigurations.delete(h.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,n.properties[s])}n.allOf?.forEach(s=>i(s))};for(const n of t){i(n);const s=this.configurationContributors.indexOf(n);s!==-1&&this.configurationContributors.splice(s,1)}return u}validateAndRegisterProperties(t,u=!0,i,n,s=3){s=w.isUndefinedOrNull(t.scope)?s:t.scope;const h=[],o=t.properties;if(o)for(const v in o){const T=o[v];if(u&&S(v,T)){delete o[v];continue}if(T.source=i,T.defaultDefaultValue=o[v].default,this.updatePropertyDefaultValue(v,T),e.OVERRIDE_PROPERTY_REGEX.test(v)?T.scope=void 0:(T.scope=w.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=w.isUndefinedOrNull(T.restricted)?!!n?.includes(v):T.restricted),o[v].hasOwnProperty("included")&&!o[v].included){this.excludedConfigurationProperties[v]=o[v],delete o[v];continue}else this.configurationProperties[v]=o[v],o[v].policy?.name&&this.policyConfigurations.set(o[v].policy.name,v);!o[v].deprecationMessage&&o[v].markdownDeprecationMessage&&(o[v].deprecationMessage=o[v].markdownDeprecationMessage),h.push(v)}const f=t.allOf;if(f)for(const v of f)h.push(...this.validateAndRegisterProperties(v,u,i,n,s));return h}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const u=i=>{const n=i.properties;if(n)for(const h in n)this.updateSchema(h,n[h]);i.allOf?.forEach(u)};u(t)}updateSchema(t,u){switch(e.allSettings.properties[t]=u,u.scope){case 1:e.applicationSettings.properties[t]=u;break;case 2:e.machineSettings.properties[t]=u;break;case 6:e.machineOverridableSettings.properties[t]=u;break;case 3:e.windowSettings.properties[t]=u;break;case 4:e.resourceSettings.properties[t]=u;break;case 5:e.resourceSettings.properties[t]=u,this.resourceLanguageSettingsSchema.properties[t]=u;break}}removeFromSchema(t,u){switch(delete e.allSettings.properties[t],u.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const u=`[${t}]`,i={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,i),e.allSettings.properties[u]=i,e.applicationSettings.properties[u]=i,e.machineSettings.properties[u]=i,e.machineOverridableSettings.properties[u]=i,e.windowSettings.properties[u]=i,e.resourceSettings.properties[u]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,u){const i=this.configurationDefaultsOverrides.get(t);let n=i?.value,s=i?.source;w.isUndefined(n)&&(n=u.defaultDefaultValue,s=void 0),w.isUndefined(n)&&(n=d(u.type)),u.default=n,u.defaultValueSource=s}}const I="\\[([^\\]]+)\\]",p=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(_){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(_)){let u=p.exec(_);for(;u?.length;){const i=u[1].trim();i&&t.push(i),u=p.exec(_)}}return(0,r.distinct)(t)}e.overrideIdentifiersFromKey=a;function l(_){return _.reduce((t,u)=>`${t}[${u}]`,"")}e.keyFromOverrideIdentifiers=l;function d(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const m=new g;E.Registry.add(e.Extensions.Configuration,m);function S(_,t){return _.trim()?e.OVERRIDE_PROPERTY_REGEX.test(_)?F.localize(7,null,_):m.getConfigurationProperties()[_]!==void 0?F.localize(8,null,_):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?F.localize(9,null,_,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:F.localize(6,null)}e.validateProperty=S;function c(){const _=[],t=m.getConfigurationProperties();for(const u of Object.keys(t))_.push([u,t[u].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=c}),define(Ce[153],Ie([1,0,18,4,105,7,25,24,10,2,45,87,30]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class I{constructor(t={},u=[],i=[],n){this._contents=t,this._keys=u,this._overrides=i,this.raw=n,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(u=>{if(u instanceof I)return u;const i=new p("");return i.parseRaw(u),i.configurationModel});this._rawConfiguration=t.reduce((u,i)=>i===u?i:u.merge(i),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(t){return t?(0,R.getConfigurationValue)(this.contents,t):this.contents}inspect(t,u){const i=this.rawConfiguration.getValue(t),n=u?this.rawConfiguration.getOverrideValue(t,u):void 0,s=u?this.rawConfiguration.override(u).getValue(t):i;return{value:i,override:n,merged:s}}getOverrideValue(t,u){const i=this.getContentsForOverrideIdentifer(u);return i?t?(0,R.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){const u=[];for(const i of this.overrides)i.identifiers.includes(t)&&u.push(...i.keys);return r.distinct(u)}getAllOverrideIdentifiers(){const t=[];for(const u of this.overrides)t.push(...u.identifiers);return r.distinct(t)}override(t){let u=this.overrideConfigurations.get(t);return u||(u=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,u)),u}merge(...t){const u=A.deepClone(this.contents),i=A.deepClone(this.overrides),n=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const h of t)if(s.push(...h.raw?.length?h.raw:[h]),!h.isEmpty()){this.mergeContents(u,h.contents);for(const o of h.overrides){const[f]=i.filter(v=>r.equals(v.identifiers,o.identifiers));f?(this.mergeContents(f.contents,o.contents),f.keys.push(...o.keys),f.keys=r.distinct(f.keys)):i.push(A.deepClone(o))}for(const o of h.keys)n.indexOf(o)===-1&&n.push(o)}return new I(u,n,i,s.every(h=>h instanceof I)?void 0:s)}freeze(){return this.frozen=!0,this}clone(){return new I(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}createOverrideConfigurationModel(t){const u=this.getContentsForOverrideIdentifer(t);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const i={};for(const n of r.distinct([...Object.keys(this.contents),...Object.keys(u)])){let s=this.contents[n];const h=u[n];h&&(typeof s=="object"&&typeof h=="object"?(s=A.deepClone(s),this.mergeContents(s,h)):s=h),i[n]=s}return new I(i,this.keys,this.overrides)}mergeContents(t,u){for(const i of Object.keys(u)){if(i in t&&E.isObject(t[i])&&E.isObject(u[i])){this.mergeContents(t[i],u[i]);continue}t[i]=A.deepClone(u[i])}}checkAndFreeze(t){return this.frozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){let u=null,i=null;const n=s=>{s&&(i?this.mergeContents(i,s):i=A.deepClone(s))};for(const s of this.overrides)r.equals(s.identifiers,[t])?u=s.contents:s.identifiers.includes(t)&&n(s.contents);return n(u),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,u){this.addKey(t),(0,R.addToValueTree)(this.contents,t,u,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,R.removeFromValueTree)(this.contents,t)}addKey(t){let u=this.keys.length;for(let i=0;i<u;i++)t.indexOf(this.keys[i])===0&&(u=i);this.keys.splice(u,1,t)}removeKey(t){const u=this.keys.indexOf(t);return u!==-1?(this.keys.splice(u,1),!0):!1}}e.ConfigurationModel=I;class p{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,u){if(!E.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,u)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,u){this._raw=t;const{contents:i,keys:n,overrides:s,restricted:h,hasExcludedProperties:o}=this.doParseRaw(t,u);this._configurationModel=new I(i,n,s,o?[t]:void 0),this._restrictedConfigurations=h||[]}doParseContent(t){let u={},i=null,n=[];const s=[],h=[];function o(v){Array.isArray(n)?n.push(v):i!==null&&(n[i]=v)}const f={onObjectBegin:()=>{const v={};o(v),s.push(n),n=v,i=null},onObjectProperty:v=>{i=v},onObjectEnd:()=>{n=s.pop()},onArrayBegin:()=>{const v=[];o(v),s.push(n),n=v,i=null},onArrayEnd:()=>{n=s.pop()},onLiteralValue:o,onError:(v,T,M)=>{h.push({error:v,offset:T,length:M})}};if(t)try{w.visit(t,f),u=n[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return u}doParseRaw(t,u){const i=g.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,i,!0,u);t=n.raw;const s=(0,R.toValuesTree)(t,f=>console.error(`Conflict in settings file ${this._name}: ${f}`)),h=Object.keys(t),o=this.toOverrides(t,f=>console.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:s,keys:h,overrides:o,restricted:n.restricted,hasExcludedProperties:n.hasExcludedProperties}}filter(t,u,i,n){let s=!1;if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:s};const h={},o=[];for(const f in t)if(b.OVERRIDE_PROPERTY_REGEX.test(f)&&i){const v=this.filter(t[f],u,!1,n);h[f]=v.raw,s=s||v.hasExcludedProperties,o.push(...v.restricted)}else{const v=u[f],T=v?typeof v.scope<"u"?v.scope:3:void 0;v?.restricted&&o.push(f),(T===void 0||n.scopes===void 0||n.scopes.includes(T))&&!(n.skipRestricted&&v?.restricted)?h[f]=t[f]:s=!0}return{raw:h,restricted:o,hasExcludedProperties:s}}toOverrides(t,u){const i=[];for(const n of Object.keys(t))if(b.OVERRIDE_PROPERTY_REGEX.test(n)){const s={};for(const h in t[n])s[h]=t[n][h];i.push({identifiers:(0,b.overrideIdentifiersFromKey)(n),keys:Object.keys(s),contents:(0,R.toValuesTree)(s,u)})}return i}}e.ConfigurationModelParser=p;class a extends F.Disposable{constructor(t,u,i,n){super(),this.userSettingsResource=t,this.scopes=u,this.fileService=n,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(C.Event.any(C.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),C.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&i.isEqual(s.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=a;class l{constructor(t,u,i,n,s=new I,h=new I,o=new y.ResourceMap,f=new I,v=new y.ResourceMap,T=!0){this._defaultConfiguration=t,this._policyConfiguration=u,this._applicationConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=h,this._folderConfigurations=o,this._memoryConfiguration=f,this._memoryConfigurationByResource=v,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(t,u,i){return this.getConsolidatedConfigurationModel(t,u,i).getValue(t)}updateValue(t,u,i={}){let n;i.resource?(n=this._memoryConfigurationByResource.get(i.resource),n||(n=new I,this._memoryConfigurationByResource.set(i.resource,n))):n=this._memoryConfiguration,u===void 0?n.removeValue(t):n.setValue(t,u),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,u,i){const n=this.getConsolidatedConfigurationModel(t,u,i),s=this.getFolderConfigurationModelForResource(u.resource,i),h=u.resource?this._memoryConfigurationByResource.get(u.resource)||this._memoryConfiguration:this._memoryConfiguration,o=this._defaultConfiguration.inspect(t,u.overrideIdentifier),f=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(t),v=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(t),T=this.userConfiguration.freeze().inspect(t,u.overrideIdentifier),M=this.localUserConfiguration.freeze().inspect(t,u.overrideIdentifier),j=this.remoteUserConfiguration.freeze().inspect(t,u.overrideIdentifier),U=i?this._workspaceConfiguration.freeze().inspect(t,u.overrideIdentifier):void 0,D=s?s.freeze().inspect(t,u.overrideIdentifier):void 0,$=h.inspect(t,u.overrideIdentifier),L=n.getValue(t),O=r.distinct(n.overrides.map(H=>H.identifiers).flat()).filter(H=>n.getOverrideValue(t,H)!==void 0);return{defaultValue:o?o.merged:void 0,policyValue:f?f.merged:void 0,applicationValue:v?v.merged:void 0,userValue:T?T.merged:void 0,userLocalValue:M?M.merged:void 0,userRemoteValue:j?j.merged:void 0,workspaceValue:U?U.merged:void 0,workspaceFolderValue:D?D.merged:void 0,memoryValue:$?$.merged:void 0,value:L,default:o.value!==void 0||o.override!==void 0?{value:o.value,override:o.override}:void 0,policy:f?.value!==void 0?{value:f.value}:void 0,application:v?.value!==void 0||v?.override!==void 0?{value:v.value,override:v.override}:void 0,user:T.value!==void 0||T.override!==void 0?{value:T.value,override:T.override}:void 0,userLocal:M.value!==void 0||M.override!==void 0?{value:M.value,override:M.override}:void 0,userRemote:j.value!==void 0||j.override!==void 0?{value:j.value,override:j.override}:void 0,workspace:U?.value!==void 0||U?.override!==void 0?{value:U.value,override:U.override}:void 0,workspaceFolder:D?.value!==void 0||D?.override!==void 0?{value:D.value,override:D.override}:void 0,memory:$.value!==void 0||$.override!==void 0?{value:$.value,override:$.override}:void 0,overrideIdentifiers:O.length?O:void 0}}keys(t){const u=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:u?u.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,u){this._folderConfigurations.set(t,u),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,u){const i=[];if(!u){const{added:n,updated:s,removed:h}=S(this._defaultConfiguration,t);u=[...n,...s,...h]}for(const n of u)for(const s of(0,b.overrideIdentifiersFromKey)(n)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(s),o=t.getKeysForOverrideIdentifier(s),f=[...o.filter(v=>h.indexOf(v)===-1),...h.filter(v=>o.indexOf(v)===-1),...h.filter(v=>!A.equals(this._defaultConfiguration.override(s).getValue(v),t.override(s).getValue(v)))];i.push([s,f])}return this.updateDefaultConfiguration(t),{keys:u,overrides:i}}compareAndUpdatePolicyConfiguration(t){const{added:u,updated:i,removed:n}=S(this._policyConfiguration,t),s=[...u,...i,...n];return s.length&&this.updatePolicyConfiguration(t),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:u,updated:i,removed:n,overrides:s}=S(this.applicationConfiguration,t),h=[...u,...i,...n];return h.length&&this.updateApplicationConfiguration(t),{keys:h,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:u,updated:i,removed:n,overrides:s}=S(this.localUserConfiguration,t),h=[...u,...i,...n];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:u,updated:i,removed:n,overrides:s}=S(this.remoteUserConfiguration,t),h=[...u,...i,...n];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:u,updated:i,removed:n,overrides:s}=S(this.workspaceConfiguration,t),h=[...u,...i,...n];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:s}}compareAndUpdateFolderConfiguration(t,u){const i=this.folderConfigurations.get(t),{added:n,updated:s,removed:h,overrides:o}=S(i,u),f=[...n,...s,...h];return(f.length||!i)&&this.updateFolderConfiguration(t,u),{keys:f,overrides:o}}compareAndDeleteFolderConfiguration(t){const u=this.folderConfigurations.get(t);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:n,removed:s,overrides:h}=S(u,void 0);return{keys:[...i,...n,...s],overrides:h}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,u,i){let n=this.getConsolidatedConfigurationModelForResource(u,i);return u.overrideIdentifier&&(n=n.override(u.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:t},u){let i=this.getWorkspaceConsolidatedConfiguration();if(u&&t){const n=u.getFolder(t);n&&(i=this.getFolderConsolidatedConfiguration(n.uri)||i);const s=this._memoryConfigurationByResource.get(t);s&&(i=i.merge(s))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let u=this._foldersConsolidatedConfigurations.get(t);if(!u){const i=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(u=i.merge(n),this._freeze&&(u=u.freeze()),this._foldersConsolidatedConfigurations.set(t,u)):u=i}return u}getFolderConfigurationModelForResource(t,u){if(u&&t){const i=u.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,u)=>{const{contents:i,overrides:n,keys:s}=this._folderConfigurations.get(u);return t.push([u,{contents:i,overrides:n,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(u=>t.add(u)),this.userConfiguration.freeze().keys.forEach(u=>t.add(u)),this._workspaceConfiguration.freeze().keys.forEach(u=>t.add(u)),this._folderConfigurations.forEach(u=>u.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>t.add(u)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>t.add(u)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>t.add(u)),this._folderConfigurations.forEach(u=>u.freeze().getAllOverrideIdentifiers().forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const u=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>u.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>u.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>u.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(n=>u.add(n))),[...u.values()]}static parse(t){const u=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.policy),n=this.parseConfigurationModel(t.application),s=this.parseConfigurationModel(t.user),h=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((f,v)=>(f.set(P.URI.revive(v[0]),this.parseConfigurationModel(v[1])),f),new y.ResourceMap);return new l(u,i,n,s,new I,h,o,new I,new y.ResourceMap,!1)}static parseConfigurationModel(t){return new I(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=l;function d(..._){if(_.length===0)return{keys:[],overrides:[]};if(_.length===1)return _[0];const t=new Set,u=new Map;for(const n of _)n.keys.forEach(s=>t.add(s)),n.overrides.forEach(([s,h])=>{const o=(0,y.getOrSet)(u,s,new Set);h.forEach(f=>o.add(f))});const i=[];return u.forEach((n,s)=>i.push([s,[...n.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=d;class m{constructor(t,u,i,n){this.change=t,this.previous=u,this.currentConfiguraiton=i,this.currentWorkspace=n,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(o=>s.add(o)),t.overrides.forEach(([,o])=>o.forEach(f=>s.add(f))),this.affectedKeys=[...s.values()];const h=new I;this.affectedKeys.forEach(o=>h.setValue(o,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=l.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,u){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(u){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,u,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,u,this.currentWorkspace);return!A.equals(i,n)}return!0}return!1}doesAffectedKeysTreeContains(t,u){let i=(0,R.toValuesTree)({[u]:!0},()=>{}),n;for(;typeof i=="object"&&(n=Object.keys(i)[0]);){if(t=t[n],!t)return!1;i=i[n]}return!0}}e.ConfigurationChangeEvent=m;function S(_,t){const{added:u,removed:i,updated:n}=c(t,_),s=[],h=_?.getAllOverrideIdentifiers()||[],o=t?.getAllOverrideIdentifiers()||[];if(t){const f=o.filter(v=>!h.includes(v));for(const v of f)s.push([v,t.getKeysForOverrideIdentifier(v)])}if(_){const f=h.filter(v=>!o.includes(v));for(const v of f)s.push([v,_.getKeysForOverrideIdentifier(v)])}if(t&&_){for(const f of h)if(o.includes(f)){const v=c({contents:_.getOverrideValue(void 0,f)||{},keys:_.getKeysForOverrideIdentifier(f)},{contents:t.getOverrideValue(void 0,f)||{},keys:t.getKeysForOverrideIdentifier(f)});s.push([f,[...v.added,...v.removed,...v.updated]])}}return{added:u,removed:i,updated:n,overrides:s}}function c(_,t){const u=_?t?_.keys.filter(s=>t.keys.indexOf(s)===-1):[..._.keys]:[],i=t?_?t.keys.filter(s=>_.keys.indexOf(s)===-1):[...t.keys]:[],n=[];if(_&&t){for(const s of t.keys)if(_.keys.indexOf(s)!==-1){const h=(0,R.getConfigurationValue)(t.contents,s),o=(0,R.getConfigurationValue)(_.contents,s);A.equals(h,o)||n.push(s)}}return{added:u,removed:i,updated:n}}}),define(Ce[88],Ie([1,0,12,3]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,C.createDecorator)("remoteAuthorityResolverService");var w;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(w=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class F extends r.ErrorNoTelemetry{static isTemporarilyNotAvailable(A){return A instanceof F&&A._code===w.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof F&&A._code===w.NoResolverFound}static isHandled(A){return A instanceof F&&A.isHandled}constructor(A,E=w.Unknown,P){super(A),this._message=A,this._code=E,this._detail=P,this.isHandled=E===w.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,F.prototype)}}e.RemoteAuthorityResolverError=F}),define(Ce[60],Ie([1,0,13]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(P){return P.scheme===r.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=C;function w(P){if(!P)return;const R=P.indexOf("+");return R<0?P:P.substr(0,R)}e.getRemoteName=w;function F(P){return`/${P.quality??"oss"}-${P.commit??"dev"}`}e.getRemoteServerRootPath=F;function y(P){const{host:R,port:b}=E(P);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:b}}e.parseAuthorityWithPort=y;function A(P,R){let{host:b,port:g}=E(P);return typeof g>"u"&&(g=R),{host:b,port:g}}e.parseAuthorityWithOptionalPort=A;function E(P){const R=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const b=P.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const g=P.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:P,port:void 0}}}),define(Ce[27],Ie([1,0,9,3,60]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function F(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=F;function y(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var E;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,l){if(typeof a>"u"||a===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof a=="string"||typeof l=="string"){const d=typeof a=="string"?a:a.value,m=typeof l=="string"?l:l.value;return r.equalsIgnoreCase(d,m)}return a._lower===l._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.ExtensionIdentifier=P;function R(p){return b(p)}e.isApplicationScopedExtension=R;function b(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function g(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=g;function I(p,a){if(a){const l=`onResolveRemoteAuthority:${(0,w.getRemoteName)(a)}`;return p.activationEvents?.indexOf(l)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[154],Ie([1,0,9,83,27,20,2,12,47]),function(ne,e,r,C,w,F,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(u,i){return u.uuid&&i.uuid?u.uuid===i.uuid:u.id===i.id?!0:(0,r.compareIgnoreCase)(u.id,i.id)===0}e.areSameExtensions=P;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const n=i.manifest?i.manifest.version:i.version,s=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,n,s)}static parse(i){const n=R.exec(i);return n&&n[1]&&n[2]?new b({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,s="undefined"){this.version=n,this.targetPlatform=s,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=b;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(u){const i=g.exec(u);return i&&i[1]?[a(i[1]),i[2]]:[a(u),void 0]}e.getIdAndVersion=I;function p(u,i){return`${u}.${i}`}e.getExtensionId=p;function a(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=a;function l(u,i){return a(p(u,i))}e.getGalleryExtensionId=l;function d(u,i){const n=[],s=h=>{for(const o of n)if(o.some(f=>P(i(f),i(h))))return o;return null};for(const h of u){const o=s(h);o?o.push(h):n.push([h])}return n}e.groupByExtension=d;function m(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=m;function S(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new w.ExtensionIdentifier("pprice.better-merge");function c(u,i){const n=[],s=i.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const h=s.shift();if(h&&n.every(o=>!P(o.identifier,{id:h}))){const o=u.filter(f=>P(f.identifier,{id:h}));o.length===1&&(n.push(o[0]),s.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=c;async function _(u,i){if(!F.isLinux)return!1;let n;try{n=(await u.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await u.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){i.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(h))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=_;async function t(u,i){const n=await _(u,i),s=(0,C.getTargetPlatform)(n?"alpine":F.platform,E.arch);return i.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=t}),define(Ce[155],Ie([1,0,20,47,2,38]),function(ne,e,r,C,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function y(P){if(r.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}async function A(P,R,b,g,I,p,a,l,d,m){const S=Object.create(null);S["common.machineId"]=a,S.sessionID=(0,F.generateUuid)()+Date.now(),S.commitHash=I,S.version=p,S["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),S["common.platform"]=(0,r.PlatformToString)(r.platform),S["common.nodePlatform"]=C.platform,S["common.nodeArch"]=g,S["common.product"]=m||"desktop",l&&(S["common.msftInternal"]=l);let c=0;const _=Date.now();Object.defineProperties(S,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-_,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),r.isLinuxSnap&&(S["common.snap"]="true");const t=y(b);t&&(S["common.platformDetail"]=t);try{const u=await P.readFile(w.URI.file(d));S["common.source"]=u.value.toString().slice(0,30)}catch{}return S}e.resolveCommonProperties=A;function E(P){const R=C.env.USERDNSDOMAIN;if(!R)return!1;const b=R.toLowerCase();return P.some(g=>b===g)}e.verifyMicrosoftInternalDomain=E}),define(Ce[156],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,r.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,r.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(C=e.TelemetryLevel||(e.TelemetryLevel={}));var w;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(w=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ce[157],Ie([1,0,24,114,10,45,155,156]),function(ne,e,r,C,w,F,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,C.staticObservableValue)(0)}publicLog(n,s){return Promise.resolve(void 0)}publicLog2(n,s){return this.publicLog(n,s)}publicLogError(n,s){return Promise.resolve(void 0)}publicLogError2(n,s){return this.publicLogError(n,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class P{async publicLog(n,s,h){}async publicLogError(n,s,h){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function R(i,n){return n.onDidChangeConfiguration(s=>{s.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,F.ConfigurationTargetToString)(s.source),configurationKeys:d(s.sourceConfig)})})}e.configurationTelemetry=R;function b(i,n){return!(n.disableTelemetry||!i.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=b;function g(i){const n=i.getValue(A.TELEMETRY_SETTING_ID),s=i.getValue("telemetry.enableCrashReporter");if(i.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=g;function I(i){const n={},s={},h={};l(i,h);for(let o in h){o=o.length>150?o.substr(o.length-149):o;const f=h[o];typeof f=="number"?s[o]=f:typeof f=="boolean"?s[o]=f?1:0:typeof f=="string"?(f.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${f.length}`),n[o]=f.substring(0,8191)):typeof f<"u"&&f!==null&&(n[o]=f)}return{properties:n,measurements:s}}e.validateTelemetryData=I;const p=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function a(i){if(!i)return"none";for(const n of p)if(i.startsWith(`${n}+`))return n;return"other"}e.cleanRemoteAuthority=a;function l(i,n,s=0,h){if(!!i)for(const o of Object.getOwnPropertyNames(i)){const f=i[o],v=h?h+o:o;Array.isArray(f)?n[v]=(0,r.safeStringify)(f):f instanceof Date?n[v]=f.toISOString():(0,w.isObject)(f)?s<2?l(f,n,s+1,v+"."):n[v]=(0,r.safeStringify)(f):n[v]=f}}function d(i){if(!i)return[];const n=[];return m(n,"",i),n}function m(i,n,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(h=>m(i,n?`${n}.${h}`:h,s[h])):i.push(n)}function S(i,n){const s=i.msftInternalDomains||[],h=n.getValue("telemetry.internalTesting");return(0,y.verifyMicrosoftInternalDomain)(s)||h}e.isInternalTelemetry=S;function c(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=c;function _(i,n){let s=i;const h=[];for(const T of n)for(;;){const M=T.exec(i);if(!M)break;h.push([M.index,T.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(s="";;){const T=f.exec(i);if(!T)break;!o.test(T[0])&&h.every(([M,j])=>T.index<M||T.index>=j)&&(s+=i.substring(v,T.index)+"<REDACTED: user-file-path>",v=f.lastIndex)}return v<i.length&&(s+=i.substr(v)),s}function t(i){if(!i)return i;const n=i.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of s)if(h.regex.test(n))return`<REDACTED: ${h.label}>`;return i}function u(i,n){return(0,r.cloneAndChange)(i,s=>{if(typeof s=="string"){let h=s;h=_(h,n);for(const o of n)h=h.replace(o,"");return h=t(h),h}})}e.cleanData=u}),define(Ce[158],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,F,y=5){const A=F(E=>{const P=typeof E=="string"?E:E.data;let R=this._terminalBufferMap.get(w);if(R){R.data.push(P);return}const b=setTimeout(()=>this.flushBuffer(w),y);R={data:[P],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(w),A.dispose()}},this._terminalBufferMap.set(w,R)});return A}stopBuffering(w){this._terminalBufferMap.get(w)?.dispose()}flushBuffer(w){const F=this._terminalBufferMap.get(w);F&&(this._terminalBufferMap.delete(w),this._callback(w,F.data.join("")))}}e.TerminalDataBufferer=r}),define(Ce[159],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var r;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST_DARK="hcDark",F.HIGH_CONTRAST_LIGHT="hcLight"})(r=e.ColorScheme||(e.ColorScheme={}));function C(F){return F===r.HIGH_CONTRAST_DARK||F===r.HIGH_CONTRAST_LIGHT}e.isHighContrast=C;function w(F){return F===r.DARK||F===r.HIGH_CONTRAST_DARK}e.isDark=w}),define(Ce[61],Ie([1,0,117,4,7,3,30,159]),function(ne,e,r,C,w,F,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,F.createDecorator)("themeService");var E;(function(l){function d(m){return m&&typeof m=="object"&&typeof m.id=="string"}l.isThemeColor=d})(E=e.ThemeColor||(e.ThemeColor={}));function P(l){return{id:l}}e.themeColorFromId=P;var R;(function(l){function d(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||E.isThemeColor(n.color))}l.isThemeIcon=d;const m=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function S(n){const s=m.exec(n);if(!s)return;const[,h]=s;return{id:h}}l.fromString=S;function c(n){return{id:n}}l.fromId=c;function _(n,s){let h=n.id;const o=h.lastIndexOf("~");return o!==-1&&(h=h.substring(0,o)),s&&(h=`${h}~${s}`),{id:h}}l.modify=_;function t(n){const s=n.id.lastIndexOf("~");if(s!==-1)return n.id.substring(s+1)}l.getModifier=t;function u(n,s){return n.id===s.id&&n.color?.id===s.color?.id}l.isEqual=u;function i(n,s){return{id:n.id,color:s?P(s):void 0}}l.asThemeIcon=i,l.asClassNameArray=r.CSSIcon.asClassNameArray,l.asClassName=r.CSSIcon.asClassName,l.asCSSSelector=r.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function b(l){switch(l){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new C.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,w.toDisposable)(()=>{const m=this.themingParticipants.indexOf(d);this.themingParticipants.splice(m,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const I=new g;y.Registry.add(e.Extensions.ThemingContribution,I);function p(l){return I.onColorThemeChange(l)}e.registerThemingParticipant=p;class a extends w.Disposable{constructor(d){super(),this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(m=>this.onThemeChange(m)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,m){let S=this.theme.getColor(d);return S&&m&&(S=m(S,this.theme)),S?S.toString():null}}e.Themable=a}),define(Ce[160],Ie([1,0,4,20,3,11]),function(ne,e,r,C,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var y;(function(a){a.Http="http",a.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=b;function g(a,l){return l?l!==1&&a<1024:!C.isWindows&&a<1024}e.isPortPrivileged=g;class I{constructor(l,d,m){this.remoteAddress=l,this.localAddress=d,this._dispose=m,this._onDispose=new r.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=I;let p=class{constructor(l){this.logService=l,this._onTunnelOpened=new r.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new r.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new r.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(l){return this._tunnelProvider=l,l?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this._canElevate=l.elevation,this._privacyOptions=l.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const l=[],d=Array.from(this._tunnels.values());for(const m of d){const S=Array.from(m.values());for(const c of S){const _=await c.value;_&&l.push(_)}}return l}async dispose(){for(const l of this._tunnels.values()){for(const{value:d}of l.values())await d.then(m=>m?.dispose());l.clear()}this._tunnels.clear()}setEnvironmentTunnel(l,d,m,S,c){this.addTunnelToMap(l,d,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:d,localAddress:m,privacy:S,protocol:c,dispose:()=>Promise.resolve()}))}openTunnel(l,d,m,S,c=!1,_,t){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${m} on local port ${S}.`),!l)return;if(d||(d="localhost"),this._tunnelProvider&&this._factoryInProgress.has(m)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(l,d,m,S,c,_,t);return u?u.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(i);return(i.tunnelRemoteHost!==d||i.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const d=this._tunnels.get(l.tunnelRemoteHost);if(d){const m=d.get(l.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(l.tunnelRemoteHost,l.tunnelRemotePort,m))}}}}async tryDisposeTunnel(l,d,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${d}.`);const S=m.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(l)&&this._tunnels.get(l).delete(d),S}}async closeTunnel(l,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${d} `);const m=this._tunnels.get(l);if(m&&m.has(d)){const S=m.get(d);S.refcount=0,await this.tryDisposeTunnel(l,d,S)}}addTunnelToMap(l,d,m){this._tunnels.has(l)||this._tunnels.set(l,new Map),this._tunnels.get(l).set(d,{refcount:1,value:m})}async removeEmptyTunnelFromMap(l,d){const m=this._tunnels.get(l);m&&(await m.get(d)||m.delete(d),m.size===0&&this._tunnels.delete(l))}getTunnelFromMap(l,d){const m=[l];R(l)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):b(l)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const S=m.map(c=>this._tunnels.get(c));for(const c of S){const _=c?.get(d);if(_)return _}}canTunnel(l){return!!P(l)}doIsPortPrivileged(l,d,m,S){if(d)return!1;if(m){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(S);if(c?.length===4){const _=parseInt(c[1]),t=parseInt(c[2]);if(_>10||_===10&&t>=14)return!1}}return l<1024}createWithProvider(l,d,m,S,c,_,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${m} on local port ${S}.`);const u=m;this._factoryInProgress.add(u);const i=S===void 0?m:S,n={elevationRequired:c?this.isPortPrivileged(i):!1},s={remoteAddress:{host:d,port:m},localAddressPort:S,privacy:_,public:_?_!==A.Private:void 0,protocol:t},h=l.forwardPort(s,n);return h?(this.addTunnelToMap(d,m,h),h.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),h}};p=$e([xe(0,F.ILogService)],p),e.AbstractTunnelService=p}),define(Ce[161],Ie([1,0,13]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function C(E){return E.scheme!==r.Schemas.file&&E.scheme!==r.Schemas.vscodeRemote}e.isVirtualResource=C;function w(E){if(E.folders.length)return E.folders.every(P=>C(P.uri))?E.folders[0].uri:void 0;if(E.configuration&&C(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=w;function F(E){return w(E)?.scheme}e.getVirtualWorkspaceScheme=F;function y(E){return w(E)?.authority}e.getVirtualWorkspaceAuthority=y;function A(E){return w(E)!==void 0}e.isVirtualWorkspace=A}),define(Ce[48],Ie([1,0,129,19,25,22,2,3,13]),function(ne,e,r,C,w,F,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function P(u){const i=u;return typeof i?.id=="string"&&y.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function R(u,i){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,C.basename)(u)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=u;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=R;function b(u){const i=u;return typeof i?.id=="string"&&y.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=b;function g(u){const i=u;if(i?.uri)return{id:i.id,uri:y.URI.revive(i.uri)};const n=u;if(n?.configPath)return{id:n.id,configPath:y.URI.revive(n.configPath)};if(u?.id)return{id:u.id}}e.reviveIdentifier=g;var I;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function p(u){const i=u;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=p;function a(u){const i=u;return!!(i&&typeof i=="object"&&y.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=a;class l{constructor(i,n,s,h,o){this._id=i,this._transient=s,this._configuration=h,this._ignorePathCasing=o,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class d{constructor(i,n){this.raw=n,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,F.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function m(u){return new d({uri:u,index:0,name:(0,F.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=m,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,r.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(u,i){return F.extUriBiasedIgnorePathCase.isEqualOrParent(u,i.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function c(u){let i;return y.URI.isUri(u)?i=u:i=u.configuration,i?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=c;function _(u,i){return!S(u,i)&&!c(u)}e.isSavedWorkspace=_;function t(u){return(typeof u=="string"?(0,C.extname)(u):(0,F.extname)(u))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(Ce[62],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const F=this._idPool++;return this._data.set(F,w),this.logDebugInfo(),F}get(w,F){return this._data.has(w)?this._data.get(w)[F]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!r.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=r,r.enableDebugLogging=!1}),define(Ce[36],Ie([1,0,13,22,3]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class F{constructor(){this._systemSchemes=new Set(Object.keys(r.Schemas)),this._providerInfo=new Map,this.extUri=new C.ExtUri(A=>{const E=this._providerInfo.get(A.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(A,E){E===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,E)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=F,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[26],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(Ce[162],Ie([1,0,15]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class C{constructor(y,A,E){this._deferredPromises=new Map,this._id=y,this._shared=A,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new r.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of P.values())R.complete()}catch(R){for(const b of P.values())b.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(y,A){let E=this._value[y];return typeof E>"u"&&(E=A),E}update(y,A){this._value[y]=A;const E=this._deferredPromises.get(y);if(E!==void 0)return E.p;const P=new r.DeferredPromise;return this._deferredPromises.set(y,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=C;class w extends C{setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}constructor(y,A){super(y.identifier.value,!0,A),this._extension=y}}e.ExtensionGlobalMemento=w}),define(Ce[163],Ie([1,0,4,2]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class w{constructor(y){this._notebooksAndEditors=y,this._onDidSaveNotebookDocument=new r.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new r.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(y,A,E,P){const b=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(y)).acceptModelChanged(A.value,E,P);this._onDidChangeNotebookDocument.fire(b)}$acceptDirtyStateChanged(y,A){this._notebooksAndEditors.getNotebookDocument(C.URI.revive(y)).acceptDirty(A)}$acceptModelSaved(y){const A=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(y));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=w}),define(Ce[14],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class C{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.ExtHostRpcService=C});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(ne,r):w?w.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!C:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ne):C?C.value:e.get(ne)};define(Ce[164],Ie([1,0,27,4]),function(ne,e,r,C){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class F{constructor(A,E){w.set(this,void 0),this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._id=r.ExtensionIdentifier.toKey(A.identifier),Ye(this,w,E,"f"),Oe(this,w,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(A){return Oe(this,w,"f").get(this._id,A)}store(A,E){return Oe(this,w,"f").store(this._id,A,E)}delete(A){return Oe(this,w,"f").delete(this._id,A)}}e.ExtensionSecrets=F,w=new WeakMap}),define(Ce[63],Ie([1,0,3,160,4,14]),function(ne,e,r,C,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(E){function P(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:b.protocol}}E.fromApiTunnel=P;function R(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==C.TunnelPrivacyId.ConstantPrivate&&b.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}E.fromServiceTunnel=R})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,r.createDecorator)("IExtHostTunnelService");let A=class{constructor(P){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,R){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,R){return{dispose:()=>{}}}async $providePortAttributes(P,R,b,g,I){return[]}async $forwardPort(P,R){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=$e([xe(0,F.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(Ce[49],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class C{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=C}),define(Ce[165],Ie([1,0,23]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(E){let P=this.buffers.indexOf(E);return P<0&&(P=this.buffers.length,this.buffers.push(E)),P}}function w(A,E){if(E.serializeBuffersForPostMessage){const P=new C,R=(I,p)=>{if(p instanceof ArrayBuffer){const a=P.add(p);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(p)){const a=F(p);if(a){const l=P.add(p.buffer);return{$$vscode_array_buffer_reference$$:!0,index:l,view:{type:a,byteLength:p.byteLength,byteOffset:p.byteOffset}}}}return p},b=JSON.stringify(A,R),g=P.buffers.map(I=>{const p=new Uint8Array(I);return r.VSBuffer.wrap(p)});return{message:b,buffers:g}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=w;function F(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(A,E){const P=E.map(g=>{const I=new ArrayBuffer(g.byteLength);return new Uint8Array(I).set(g.buffer),I}),R=E.length?(g,I)=>{if(I&&typeof I=="object"&&I.$$vscode_array_buffer_reference$$){const p=I,{index:a}=p,l=P[a];if(p.view)switch(p.view.type){case 1:return new Int8Array(l,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(l,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(l,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(l,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(l,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(l,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(l,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(l,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(l,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(l,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(l,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return l}return I}:void 0;return{message:JSON.parse(A,R),arrayBuffers:P}}e.deserializeWebviewMessage=y}),define(Ce[89],Ie([1,0,137,10,2,7,3,30,35,13]),function(ne,e,r,C,w,F,y,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var b;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(b=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function g(G){const te=G;return!!te&&typeof te.getSelection=="function"&&!!te.onDidChangeSelection}e.isEditorPaneWithSelection=g;function I(G,te,he){for(const re of he.visibleEditorPanes)if(re.group.id===te&&G.matches(re.input))return re.getViewState()}e.findViewStateForEditor=I;function p(G){if(s(G))return!1;const te=G;return w.URI.isUri(te?.resource)}e.isResourceEditorInput=p;function a(G){if(s(G))return!1;const te=G;return te?.original!==void 0&&te.modified!==void 0}e.isResourceDiffEditorInput=a;function l(G){if(s(G)||a(G))return!1;const te=G;return te?.primary!==void 0&&te.secondary!==void 0}e.isResourceSideBySideEditorInput=l;function d(G){if(s(G))return!1;const te=G;return te?te.resource===void 0||te.resource.scheme===P.Schemas.untitled||te.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=d;const m=/Untitled-\d+/;function S(G){return G.scheme===P.Schemas.untitled&&G.path.length>1&&!m.test(G.path)}e.isUntitledWithAssociatedResource=S;function c(G){if(s(G))return!1;const te=G;return w.URI.isUri(te?.base?.resource)&&w.URI.isUri(te?.input1?.resource)&&w.URI.isUri(te?.input2?.resource)&&w.URI.isUri(te?.result?.resource)}e.isResourceMergeEditorInput=c;var _;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(_=e.Verbosity||(e.Verbosity={}));var t;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(t=e.SaveReason||(e.SaveReason={}));class u{constructor(){this.mapIdToSaveSource=new Map}registerSource(te,he){let re=this.mapIdToSaveSource.get(te);return re||(re={source:te,label:he},this.mapIdToSaveSource.set(te,re)),re.source}getSourceLabel(te){return this.mapIdToSaveSource.get(te)?.label??te}}e.SaveSourceRegistry=new u;var i;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors"})(i=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends F.Disposable{}e.AbstractEditorInput=n;function s(G){return G instanceof n}e.isEditorInput=s;function h(G){const te=G;return w.URI.isUri(te?.preferredResource)}function o(G){const te=G;return s(te?.primary)&&s(te?.secondary)}e.isSideBySideEditorInput=o;function f(G){const te=G;return s(te?.modified)&&s(te?.original)}e.isDiffEditorInput=f;function v(G){return s(G?.editor)}e.isEditorInputWithOptions=v;function T(G){const te=G;return v(G)&&te?.group!==void 0}e.isEditorInputWithOptionsAndGroup=T;function M(G){const te=G;return typeof te?.groupId=="number"&&s(te.editor)}e.isEditorIdentifier=M;var j;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})(j=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var D;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(D=e.SideBySideEditor||(e.SideBySideEditor={}));class ${getOriginalUri(te,he){if(!te)return;if(c(te))return e.EditorResourceAccessor.getOriginalUri(te.result,he);if(he?.supportSideBySide){const{primary:be,secondary:le}=this.getSideEditors(te);if(be&&le){if(he?.supportSideBySide===D.BOTH)return{primary:this.getOriginalUri(be,{filterByScheme:he.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===D.ANY)return this.getOriginalUri(be,{filterByScheme:he.filterByScheme})??this.getOriginalUri(le,{filterByScheme:he.filterByScheme});te=he.supportSideBySide===D.PRIMARY?be:le}}if(a(te)||l(te)||c(te))return;const re=h(te)?te.preferredResource:te.resource;return!re||!he||!he.filterByScheme?re:this.filterUri(re,he.filterByScheme)}getSideEditors(te){return o(te)||l(te)?{primary:te.primary,secondary:te.secondary}:f(te)||a(te)?{primary:te.modified,secondary:te.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(te,he){if(!te)return;if(c(te))return e.EditorResourceAccessor.getCanonicalUri(te.result,he);if(he?.supportSideBySide){const{primary:be,secondary:le}=this.getSideEditors(te);if(be&&le){if(he?.supportSideBySide===D.BOTH)return{primary:this.getCanonicalUri(be,{filterByScheme:he.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===D.ANY)return this.getCanonicalUri(be,{filterByScheme:he.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:he.filterByScheme});te=he.supportSideBySide===D.PRIMARY?be:le}}if(a(te)||l(te)||c(te))return;const re=te.resource;return!re||!he||!he.filterByScheme?re:this.filterUri(re,he.filterByScheme)}filterUri(te,he){if(Array.isArray(he)){if(he.some(re=>te.scheme===re))return te}else if(he===te.scheme)return te}}e.EditorResourceAccessor=new $;var L;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(L=e.CloseDirection||(e.CloseDirection={}));class O{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(te){const he=this.instantiationService=te.get(y.IInstantiationService);for(const[re,be]of this.editorSerializerConstructors)this.createEditorSerializer(re,be,he);this.editorSerializerConstructors.clear()}createEditorSerializer(te,he,re){const be=re.createInstance(he);this.editorSerializerInstances.set(te,be)}registerFileEditorFactory(te){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=te}getFileEditorFactory(){return(0,C.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(te,he){if(this.editorSerializerConstructors.has(te)||this.editorSerializerInstances.has(te))throw new Error(`A editor serializer with type ID '${te}' was already registered.`);return this.instantiationService?this.createEditorSerializer(te,he,this.instantiationService):this.editorSerializerConstructors.set(te,he),(0,F.toDisposable)(()=>{this.editorSerializerConstructors.delete(te),this.editorSerializerInstances.delete(te)})}getEditorSerializer(te){return this.editorSerializerInstances.get(typeof te=="string"?te:te.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new O);async function H(G,te){return!G||!G.length?[]:await Promise.all(G.map(async he=>{const re=w.URI.revive(he.fileUri);if(!re||!await te.canHandleResource(re))return;let le=he.exists,fe=he.type;if(typeof le!="boolean"||typeof fe!="number")try{fe=(await te.stat(re)).isDirectory?E.FileType.Directory:E.FileType.Unknown,le=!0}catch{le=!1}if(!le&&he.openOnlyIfExists||fe===E.FileType.Directory)return;const Q={...he.options,pinned:!0};return le?{resource:re,options:Q}:{resource:re,options:Q,forceUntitled:!0}}))}e.pathsToEditors=H;var W;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(W=e.EditorsOrder||(e.EditorsOrder={}));function z(G){const te=G;if(!te)return!1;const he=te;if(he.modified)return z(he.modified);const re=te;return!!(re.contributionsState&&re.viewState&&Array.isArray(re.cursorState))}e.isTextEditorViewState=z}),define(Ce[64],Ie([1,0,13,2]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function w(A,E){return A.scheme===r.Schemas.http||A.scheme===r.Schemas.https?A:(E&&E.authority&&E.isRemote&&A.scheme===r.Schemas.file&&(A=C.URI.from({scheme:r.Schemas.vscodeRemote,authority:E.authority,path:A.path})),C.URI.from({scheme:r.Schemas.https,authority:`${A.scheme}+${F(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=w;function F(A){return A.replace(/./g,E=>{const P=E.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?E:"-"+P.toString(16).padStart(4,"0")})}function y(A){return A.replace(/-([0-9a-f]{4})/g,(E,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=y}),define(Ce[166],Ie([1,0,4,7,64]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class F{constructor(A,E,P){this._proxy=A,this._editors=E,this._remoteInfo=P,this._handlePool=0,this._disposables=new C.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const R=E.getVisibleTextEditors();for(const b of this._insets.values())R.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,E,P,R,b){let g;for(const S of this._editors.getVisibleTextEditors(!0))if(S.value===A){g=S;break}if(!g)throw new Error("not a visible editor");const I=this,p=this._handlePool++,a=new r.Emitter,l=new r.Emitter,d=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(S){return(0,w.asWebviewUri)(S,I._remoteInfo)}get cspSource(){return w.webviewGenericCspSource}set options(S){this._options=S,I._proxy.$setOptions(p,S)}get options(){return this._options}set html(S){this._html=S,I._proxy.$setHtml(p,S)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(S){return I._proxy.$postMessage(p,S)}},m=new class{constructor(){this.editor=A,this.line=E,this.height=P,this.webview=d,this.onDidDispose=l.event}dispose(){I._insets.has(p)&&(I._insets.delete(p),I._proxy.$disposeEditorInset(p),l.fire(),l.dispose(),a.dispose())}};return this._proxy.$createEditorInset(p,g.id,g.value.document.uri,E+1,P,R||{},b.identifier,b.extensionLocation),this._insets.set(p,{editor:A,inset:m,onDidReceiveMessage:a}),m}$onDidDispose(A){const E=this._insets.get(A);E&&E.inset.dispose()}$onDidReceiveMessage(A,E){this._insets.get(A)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=F}),define(Ce[167],Ie([1,0,4,15,138]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class F{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new r.Emitter,this._onExit=new r.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,E,P,R){const b={command:A};if(E&&Object.keys(E).length>0&&(b.arguments=E),this.internalSend("request",b),typeof R=="number"){const g=setTimeout(()=>{clearTimeout(g);const I=this.pendingRequests.get(b.seq);if(I){this.pendingRequests.delete(b.seq);const p={type:"response",seq:0,request_seq:b.seq,success:!1,command:A,message:(0,w.localize)(0,null,R,A)};I(p)}},R)}return P&&this.pendingRequests.set(b.seq,P),b.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,E){return A.type!=="event"||E.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,C.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const E=A,P=this.pendingRequests.get(E.request_seq);P&&(this.pendingRequests.delete(E.request_seq),P(E));break}}}}internalSend(A,E){E.type=A,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((E,P)=>A.set(P,E)),await(0,C.timeout)(500),A.forEach((E,P)=>{E({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=F}),define(Ce[168],Ie([1,0,139,40,3]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:r.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:r.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:r.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:r.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:r.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:r.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:r.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:r.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:r.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:r.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:r.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:r.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:r.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:r.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new C.RawContextKey("breakpointAccessType",void 0,{type:"string",description:r.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:r.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:r.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:r.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:r.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:r.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:r.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:r.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:r.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:r.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:r.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(50,null)});const F=g=>r.localize(51,null,g);e.debuggerDisabledMessage=F,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(52,null)};var y;(function(g){g[g.Inactive=0]="Inactive",g[g.Initializing=1]="Initializing",g[g.Stopped=2]="Stopped",g[g.Running=3]="Running"})(y=e.State||(e.State={}));function A(g){switch(g){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var E;(function(g){g[g.Valid=0]="Valid",g[g.Unreadable=1]="Unreadable",g[g.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var P;(function(g){g[g.Initial=1]="Initial",g[g.Dynamic=2]="Dynamic"})(P=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(g){g.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,w.createDecorator)(e.DEBUG_SERVICE_ID);var b;(function(g){g[g.CONDITION=0]="CONDITION",g[g.HIT_COUNT=1]="HIT_COUNT",g[g.LOG_MESSAGE=2]="LOG_MESSAGE"})(b=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[169],Ie([1,0,9,2,19,24,13]),function(ne,e,r,C,w,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function E(i,n,s){return i.replace(A,function(h,o){return n&&o.length>0&&o[0]!=="_"?h:s&&s.hasOwnProperty(o)?s[o]:h})}e.formatPII=E;function P(i){const n={};for(const s of Object.keys(i))s.startsWith("!")||(n[s]=i[s]);return n}e.filterExceptionsFromTelemetry=P;function R(i){return i.configuration.request==="attach"&&!b(i)&&(!i.parentSession||R(i.parentSession))}e.isSessionAttach=R;function b(i){let n=i.configuration.type;if(!!n)return n==="vslsShare"&&(n=i.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(n,"extensionhost")||(0,r.equalsIgnoreCase)(n,"pwa-extensionhost")?i:i.parentSession?b(i.parentSession):void 0}e.getExtensionHostDebugSession=b;function g(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=g;function I(i,n,s){let h,o=0;const f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let v=null;for(;v=f.exec(i);){const T=v.index+1,M=T+v[0].length;if(T<=n&&M>=s){h=v[0],o=T;break}}if(h){const T=/\w+/g;let M=null;for(;(M=T.exec(h))&&!(M.index+1+o+M[0].length>=s););M&&(h=h.substring(0,T.lastIndex))}return h?{start:o,end:o+h.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=I;const p=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(i){return!!(i&&i.match(p))}e.isUri=a;function l(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(a(i.path))return C.URI.parse(i.path);if((0,w.isAbsolute)(i.path))return C.URI.file(i.path)}return i.path}function d(i){if(typeof i.path=="object"){const n=C.URI.revive(i.path);if(n)return n.scheme===y.Schemas.file?n.fsPath:n.toString()}return i.path}function m(i,n){const s=n?l:d,h=(0,F.deepClone)(i);return c(h,(o,f)=>{o&&f&&(f.path=s(f))}),h}e.convertToDAPaths=m;function S(i,n){const s=n?l:d,h=(0,F.deepClone)(i);return c(h,(o,f)=>{!o&&f&&(f.path=s(f))}),h}e.convertToVSCPaths=S;function c(i,n){switch(i.type){case"event":{const s=i;switch(s.event){case"output":n(!1,s.body.source);break;case"loadedSource":n(!1,s.body.source);break;case"breakpoint":n(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=i;switch(s.command){case"setBreakpoints":n(!0,s.arguments.source);break;case"breakpointLocations":n(!0,s.arguments.source);break;case"source":n(!0,s.arguments.source);break;case"gotoTargets":n(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(h=>n(!1,h));break;default:break}break}case"response":{const s=i;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(h=>n(!1,h.source));break;case"loadedSources":s.body.sources.forEach(h=>n(!1,h));break;case"scopes":s.body.scopes.forEach(h=>n(!1,h.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(h=>n(!1,h.source));break;case"setBreakpoints":s.body.breakpoints.forEach(h=>n(!1,h.source));break;case"disassemble":s.body?.instructions.forEach(o=>n(!1,o.location));break;default:break}break}}}function _(i){return i.filter(n=>!n.presentation?.hidden).sort((n,s)=>n.presentation?s.presentation?n.presentation.group?s.presentation.group?n.presentation.group!==s.presentation.group?n.presentation.group.localeCompare(s.presentation.group):t(n.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(n.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=_;function t(i,n){return typeof i!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:i-n}async function u(i,n){const s=i.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(s!=="none"&&(await n.saveAll(),s==="allEditorsInActiveGroup")){const h=n.activeEditorPane;h&&h.input.resource?.scheme===y.Schemas.untitled&&await n.save({editor:h.input,groupId:h.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(Ce[65],Ie([1,0,23,34,170,77,13,19,20,40]),function(ne,e,r,C,w,F,y,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.latex,F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.latex,F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var b;(function(H){H[H.Running=1]="Running",H[H.Idle=2]="Idle"})(b=e.NotebookRunState||(e.NotebookRunState={}));var g;(function(H){H[H.Unconfirmed=1]="Unconfirmed",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(g=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(H){H[H.WithHardKernelDependency=0]="WithHardKernelDependency",H[H.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",H[H.Pure=2]="Pure",H[H.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var p;(function(H){H.Always="always",H.Never="never",H.Optional="optional"})(p=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(H){H[H.ModelChange=1]="ModelChange",H[H.Move=2]="Move",H[H.ChangeCellLanguage=5]="ChangeCellLanguage",H[H.Initialize=6]="Initialize",H[H.ChangeCellMetadata=7]="ChangeCellMetadata",H[H.Output=8]="Output",H[H.OutputItem=9]="OutputItem",H[H.ChangeCellContent=10]="ChangeCellContent",H[H.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",H[H.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",H[H.ChangeCellMime=13]="ChangeCellMime",H[H.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var l;(function(H){H[H.Handle=0]="Handle",H[H.Index=1]="Index"})(l=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(H){H[H.Replace=1]="Replace",H[H.Output=2]="Output",H[H.Metadata=3]="Metadata",H[H.CellLanguage=4]="CellLanguage",H[H.DocumentMetadata=5]="DocumentMetadata",H[H.Move=6]="Move",H[H.OutputItems=7]="OutputItems",H[H.PartialMetadata=8]="PartialMetadata",H[H.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var m;(function(H){H.scheme=y.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],z=new RegExp(`^[${W.join("")}]+`),G=7;function te(Q,pe){const Se=pe.toString(G),Be=`${Se.length<W.length?W[Se.length-1]:"z"}${Se}s${(0,r.encodeBase64)(r.VSBuffer.fromString(Q.scheme),!0,!0)}`;return Q.with({scheme:H.scheme,fragment:Be})}H.generate=te;function he(Q){if(Q.scheme!==H.scheme)return;const pe=Q.fragment.indexOf("s");if(pe<0)return;const Se=parseInt(Q.fragment.substring(0,pe).replace(z,""),G),Fe=(0,r.decodeBase64)(Q.fragment.substring(pe+1)).toString();if(!isNaN(Se))return{handle:Se,notebook:Q.with({scheme:Fe,fragment:null})}}H.parse=he;function re(Q,pe){return Q.with({scheme:y.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${Q.scheme!==y.Schemas.file?Q.scheme:""}`})}H.generateCellOutputUri=re;function be(Q){if(Q.scheme!==y.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Q.fragment);if(!pe)return;const Se=pe[1]&&pe[1]!==""?pe[1]:void 0,Fe=pe[2];return{outputId:Se,notebook:Q.with({scheme:Fe||y.Schemas.file,fragment:null})}}H.parseCellOutputUri=be;function le(Q,pe,Se){return H.generate(Q,pe).with({scheme:Se})}H.generateCellPropertyUri=le;function fe(Q,pe){if(Q.scheme===pe)return H.parse(Q.with({scheme:H.scheme}))}H.parseCellPropertyUri=fe})(m=e.CellUri||(e.CellUri={}));const S=H=>E.isWindows?H.replace(/\//g,"\\"):H;class c{constructor(W=[],z=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=z,this.order=[...new Set(W)].map(G=>({pattern:G,matches:C.parse(S(G))}))}sort(W){const z=new Map(w.Iterable.map(W,te=>[te,S(te)]));let G=[];for(const{matches:te}of this.order)for(const[he,re]of z)if(te(re)){G.push(he),z.delete(he);break}return z.size&&(G=G.concat([...z.keys()].sort((te,he)=>this.defaultOrder.indexOf(te)-this.defaultOrder.indexOf(he)))),G}prioritize(W,z){const G=this.findIndex(W);if(G===-1){this.order.unshift({pattern:W,matches:C.parse(S(W))});return}const te=new Set(z.map(re=>this.findIndex(re,G)));te.delete(-1);const he=Array.from(te).sort();this.order.splice(G+1,0,...he.map(re=>this.order[re]));for(let re=he.length-1;re>=0;re--)this.order.splice(he[re],1)}toArray(){return this.order.map(W=>W.pattern)}findIndex(W,z=this.order.length){const G=S(W);for(let te=0;te<z;te++)if(this.order[te].matches(G))return te;return-1}}e.MimeTypeDisplayOrder=c;function _(H,W,z,G=(te,he)=>te===he){const te=[];function he(le,fe,Q){if(fe===0&&Q.length===0)return;const pe=te[te.length-1];pe&&pe.start+pe.deleteCount===le?(pe.deleteCount+=fe,pe.toInsert.push(...Q)):te.push({start:le,deleteCount:fe,toInsert:Q})}let re=0,be=0;for(;;){if(re===H.length){he(re,0,W.slice(be));break}if(be===W.length){he(re,H.length-re,[]);break}const le=H[re],fe=W[be];if(G(le,fe)){re+=1,be+=1;continue}z(fe)?(he(re,1,[]),re+=1):(he(re,0,[fe]),be+=1)}return te}e.diff=_,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(H){H.default="default",H.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(H){const W=H;return!!((typeof W.include=="string"||C.isRelativePattern(W.include))&&(typeof W.exclude=="string"||C.isRelativePattern(W.exclude)))}e.isDocumentExcludePattern=u;function i(H,W,z){if(Array.isArray(H.viewType)&&H.viewType.indexOf(W)>=0||H.viewType===W)return!0;if(H.filenamePattern){const G=u(H.filenamePattern)?H.filenamePattern.include:H.filenamePattern,te=u(H.filenamePattern)?H.filenamePattern.exclude:void 0;if(C.match(G,(0,A.basename)(z.fsPath).toLowerCase()))return!(te&&C.match(te,(0,A.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var n;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(n=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(W){return`${s._prefix}${W}`}static parse(W){if(W.startsWith(s._prefix))return W.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/";function h(H){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(H)}e.isTextStreamMime=h;const o=new TextDecoder;function f(H){const W=[];let z=!1;for(const G of H)(W.length===0||z)&&(W.push(G),z=!0);return j(W),O(r.VSBuffer.concat(W.map(G=>r.VSBuffer.wrap(G))))}e.compressOutputItemStreams=f;const v=`${String.fromCharCode(27)}[A`,T=v.split("").map(H=>H.charCodeAt(0)),M=10;function j(H){H.forEach((W,z)=>{if(z===0||W.length<v.length)return;const G=H[z-1],te=W.subarray(0,v.length);if(te[0]===T[0]&&te[1]===T[1]&&te[2]===T[2]){const he=G.lastIndexOf(M);if(he===-1)return;H[z-1]=G.subarray(0,he),H[z]=W.subarray(v.length)}})}function U(H){let W=H;do H=W,W=H.replace(/[^\n]\x08/gm,"");while(W.length<H.length);return H}function D(H){for(H=H.replace(/\r+\n/gm,`
`);H.search(/\r[^$]/g)>-1;){const W=H.match(/^(.*)\r+/m)[1];let z=H.match(/\r+(.*)$/m)[1];z=z+W.slice(z.length,W.length),H=H.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,z)}return H}const $="\b".charCodeAt(0),L="\r".charCodeAt(0);function O(H){return!H.buffer.includes($)&&!H.buffer.includes(L)?H:r.VSBuffer.fromString(D(U(o.decode(H.buffer))))}}),define(Ce[171],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var C;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState"})(C=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(Ce[172],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function r(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=r;function C(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=C;function w(y){return Array.from(y.entries()).map(A=>[A[0],r(A[1].map)])}e.serializeEnvironmentVariableCollections=w;function F(y){return new Map(y.map(A=>[A[0],{map:C(A[1])}]))}e.deserializeEnvironmentVariableCollections=F}),define(Ce[41],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(F){F.Delimiter="\0"})(r=e.TestIdPathParts||(e.TestIdPathParts={}));var C;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(C=e.TestPosition||(e.TestPosition={}));class w{static fromExtHostTestItem(y,A,E=y.parent){if(y._isRoot)return new w([A]);const P=[y.id];for(let R=E;R&&R.id!==A;R=R.parent)P.push(R.id);return P.push(A),new w(P.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const A=y.indexOf("\0");return A===-1?y:y.slice(0,A)}static fromString(y){return new w(y.split("\0"))}static join(y,A){return new w([...y.path,A])}static joinToString(y,A){return y.toString()+"\0"+A}static parentId(y){const A=y.lastIndexOf("\0");return A===-1?void 0:y.slice(0,A)}static compare(y,A){return y===A?0:A.startsWith(y+"\0")?2:y.startsWith(A+"\0")?3:1}constructor(y,A=y.length){if(this.path=y,this.viewEnd=A,y.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let y=1;y<=this.viewEnd;y++)yield new w(this.path,y)}*idsToRoot(){for(let y=this.viewEnd;y>0;y--)yield new w(this.path,y)}compare(y){if(typeof y=="string")return w.compare(this.toString(),y);for(let A=0;A<y.viewEnd&&A<this.viewEnd;A++)if(y.path[A]!==this.path[A])return 1;return y.viewEnd>this.viewEnd?2:y.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let y=1;y<this.viewEnd;y++)this.stringifed+="\0",this.stringifed+=this.path[y]}return this.stringifed}}e.TestId=w}),define(Ce[50],Ie([1,0,2,51,41]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var F;(function(o){o[o.Unset=0]="Unset",o[o.Queued=1]="Queued",o[o.Running=2]="Running",o[o.Passed=3]="Passed",o[o.Failed=4]="Failed",o[o.Skipped=5]="Skipped",o[o.Errored=6]="Errored"})(F=e.TestResultState||(e.TestResultState={}));var y;(function(o){o[o.Run=2]="Run",o[o.Debug=4]="Debug",o[o.Coverage=8]="Coverage",o[o.HasNonDefaultProfile=16]="HasNonDefaultProfile",o[o.HasConfigurable=32]="HasConfigurable"})(y=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var A;(function(o){o.serialize=f=>({range:f.range.toJSON(),uri:f.uri.toJSON()}),o.deserialize=f=>({range:C.Range.lift(f.range),uri:r.URI.revive(f.uri)})})(A=e.IRichLocation||(e.IRichLocation={}));var E;(function(o){o[o.Error=0]="Error",o[o.Output=1]="Output"})(E=e.TestMessageType||(e.TestMessageType={}));var P;(function(o){o.serialize=f=>({message:f.message,type:0,expected:f.expected,actual:f.actual,location:f.location&&A.serialize(f.location)}),o.deserialize=f=>({message:f.message,type:0,expected:f.expected,actual:f.actual,location:f.location&&A.deserialize(f.location)})})(P=e.ITestErrorMessage||(e.ITestErrorMessage={}));const R=(o,f)=>`${f?"s":"e"}${o}`;e.getMarkId=R;var b;(function(o){o.serialize=f=>({message:f.message,type:1,offset:f.offset,length:f.length,location:f.location&&A.serialize(f.location)}),o.deserialize=f=>({message:f.message,type:1,offset:f.offset,length:f.length,location:f.location&&A.deserialize(f.location)})})(b=e.ITestOutputMessage||(e.ITestOutputMessage={}));var g;(function(o){o.serialize=f=>f.type===0?P.serialize(f):b.serialize(f),o.deserialize=f=>f.type===0?P.deserialize(f):b.deserialize(f)})(g=e.ITestMessage||(e.ITestMessage={}));var I;(function(o){o.serializeWithoutMessages=f=>({state:f.state,duration:f.duration,messages:[]}),o.serialize=f=>({state:f.state,duration:f.duration,messages:f.messages.map(g.serialize)}),o.deserialize=f=>({state:f.state,duration:f.duration,messages:f.messages.map(g.deserialize)})})(I=e.ITestTaskState||(e.ITestTaskState={}));const p="\0",a=(o,f)=>o+p+f;e.namespaceTestTag=a;const l=o=>{const f=o.indexOf(p);return{ctrlId:o.slice(0,f),tagId:o.slice(f+1)}};e.denamespaceTestTag=l;var d;(function(o){o.serialize=f=>({extId:f.extId,label:f.label,tags:f.tags,busy:f.busy,children:void 0,uri:f.uri?.toJSON(),range:f.range?.toJSON()||null,description:f.description,error:f.error,sortText:f.sortText}),o.deserialize=f=>({extId:f.extId,label:f.label,tags:f.tags,busy:f.busy,children:void 0,uri:f.uri?r.URI.revive(f.uri):void 0,range:f.range?C.Range.lift(f.range):null,description:f.description,error:f.error,sortText:f.sortText})})(d=e.ITestItem||(e.ITestItem={}));var m;(function(o){o[o.NotExpandable=0]="NotExpandable",o[o.Expandable=1]="Expandable",o[o.BusyExpanding=2]="BusyExpanding",o[o.Expanded=3]="Expanded"})(m=e.TestItemExpandState||(e.TestItemExpandState={}));var S;(function(o){o.serialize=f=>({expand:f.expand,item:d.serialize(f.item)}),o.deserialize=f=>({controllerId:w.TestId.root(f.item.extId),expand:f.expand,item:d.deserialize(f.item)})})(S=e.InternalTestItem||(e.InternalTestItem={}));var c;(function(o){o.serialize=f=>{let v;return f.item&&(v={},f.item.label!==void 0&&(v.label=f.item.label),f.item.tags!==void 0&&(v.tags=f.item.tags),f.item.busy!==void 0&&(v.busy=f.item.busy),f.item.uri!==void 0&&(v.uri=f.item.uri?.toJSON()),f.item.range!==void 0&&(v.range=f.item.range?.toJSON()),f.item.description!==void 0&&(v.description=f.item.description),f.item.error!==void 0&&(v.error=f.item.error),f.item.sortText!==void 0&&(v.sortText=f.item.sortText)),{extId:f.extId,expand:f.expand,item:v}},o.deserialize=f=>{let v;return f.item&&(v={},f.item.label!==void 0&&(v.label=f.item.label),f.item.tags!==void 0&&(v.tags=f.item.tags),f.item.busy!==void 0&&(v.busy=f.item.busy),f.item.range!==void 0&&(v.range=f.item.range?C.Range.lift(f.item.range):null),f.item.description!==void 0&&(v.description=f.item.description),f.item.error!==void 0&&(v.error=f.item.error),f.item.sortText!==void 0&&(v.sortText=f.item.sortText)),{extId:f.extId,expand:f.expand,item:v}}})(c=e.ITestItemUpdate||(e.ITestItemUpdate={}));const _=(o,f)=>{f.expand!==void 0&&(o.expand=f.expand),f.item!==void 0&&(o.item=o.item?Object.assign(o.item,f.item):f.item)};e.applyTestItemUpdate=_;var t;(function(o){o.serializeWithoutMessages=f=>({...S.serialize(f),ownComputedState:f.ownComputedState,computedState:f.computedState,tasks:f.tasks.map(I.serializeWithoutMessages),retired:f.retired}),o.serialize=f=>({...S.serialize(f),ownComputedState:f.ownComputedState,computedState:f.computedState,tasks:f.tasks.map(I.serialize),retired:f.retired}),o.deserialize=f=>({...S.deserialize(f),ownComputedState:f.ownComputedState,computedState:f.computedState,tasks:f.tasks.map(I.deserialize),retired:!0})})(t=e.TestResultItem||(e.TestResultItem={}));var u;(function(o){o[o.Function=0]="Function",o[o.Statement=1]="Statement"})(u=e.DetailType||(e.DetailType={}));var i;(function(o){o[o.Add=0]="Add",o[o.Update=1]="Update",o[o.DocumentSynced=2]="DocumentSynced",o[o.Remove=3]="Remove",o[o.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",o[o.Retire=5]="Retire",o[o.AddTag=6]="AddTag",o[o.RemoveTag=7]="RemoveTag"})(i=e.TestDiffOpType||(e.TestDiffOpType={}));var n;(function(o){o.deserialize=f=>f.op===0?{op:f.op,item:S.deserialize(f.item)}:f.op===1?{op:f.op,item:c.deserialize(f.item)}:f.op===2?{op:f.op,uri:r.URI.revive(f.uri),docv:f.docv}:f,o.serialize=f=>f.op===0?{op:f.op,item:S.serialize(f.item)}:f.op===1?{op:f.op,item:c.serialize(f.item)}:f})(n=e.TestsDiffOp||(e.TestsDiffOp={}));class s{add(f){}update(f){}remove(f,v){}complete(){}}e.IncrementalChangeCollector=s;class h{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(f){const v=this.createChangeCollector();for(const T of f)switch(T.op){case 0:{const M=S.deserialize(T.item),j=w.TestId.parentId(M.item.extId)?.toString();if(j){if(this.items.has(j)){const U=this.items.get(j);U.children.add(M.item.extId);const D=this.createItem(M,U);this.items.set(M.item.extId,D),v.add(D)}}else{const U=this.createItem(M);this.roots.add(U),this.items.set(M.item.extId,U),v.add(U)}M.expand===2&&this.busyControllerCount++;break}case 1:{const M=c.deserialize(T.item),j=this.items.get(M.extId);if(!j)break;M.expand!==void 0&&(j.expand===2&&this.busyControllerCount--,M.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(j,M),v.update(j);break}case 3:{const M=this.items.get(T.itemId);if(!M)break;const j=w.TestId.parentId(M.item.extId)?.toString();j?this.items.get(j).children.delete(M.item.extId):this.roots.delete(M);const U=[[T.itemId]];for(;U.length;)for(const D of U.pop()){const $=this.items.get(D);$&&(U.push($.children),this.items.delete(D),v.remove($,$!==M),$.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(T.itemId);break;case 4:this.updatePendingRoots(T.amount);break;case 6:this._tags.set(T.tag.id,T.tag);break;case 7:this._tags.delete(T.id);break}v.complete()}retireTest(f){}updatePendingRoots(f){this.pendingRootCount+=f}createChangeCollector(){return new s}}e.AbstractIncrementalTestCollection=h}),define(Ce[66],Ie([1,0,15,4,7,46,50,41]),function(ne,e,r,C,w,F,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const P=(d,m)=>d===m,R={range:(d,m)=>d===m?!0:!d||!m?!1:d.equalsRange(m),busy:P,label:P,description:P,error:P,tags:(d,m)=>!(d.length!==m.length||d.some(S=>!m.includes(S)))},b=(d,m)=>{let S;for(const[c,_]of Object.entries(R))_(d[c],m[c])||(S?S[c]=m[c]:S={[c]:m[c]});return S};class g extends w.Disposable{get root(){return this.options.root}constructor(m){super(),this.options=m,this.debounceSendDiff=this._register(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new C.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(m){this._resolveHandler=m;for(const S of this.tree.values())this.updateExpandability(S)}collectDiff(){const m=this.diff;return this.diff=[],m}pushDiff(m){switch(m.op){case 2:{for(const S of this.diff)if(S.op===2&&S.uri===m.uri){S.docv=m.docv;return}break}case 1:{const S=this.diff[this.diff.length-1];if(S){if(S.op===1&&S.item.extId===m.item.extId){(0,y.applyTestItemUpdate)(S.item,m.item);return}if(S.op===0&&S.item.item.extId===m.item.extId){(0,y.applyTestItemUpdate)(S.item,m.item);return}}break}}this.diff.push(m),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(m,S){const c=this.tree.get(m);if(!!c){if((c.expandLevels===void 0||S>c.expandLevels)&&(c.expandLevels=S),c.expand===1){const _=this.resolveChildren(c);return _.isOpen()?this.expandChildren(c,S-1):_.wait().then(()=>this.expandChildren(c,S-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,S-1)):this.expandChildren(c,S-1)}}dispose(){for(const m of this.tree.values())this.options.getApiFor(m.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(m,S){switch(S.op){case 3:this.removeItem(A.TestId.joinToString(m.fullId,S.id));break;case 0:this.upsertItem(S.item,m);break;case 5:for(const c of S.ops)this.onTestItemEvent(m,c);break;case 1:this.diffTagRefs(S.new,S.old,m.fullId.toString());break;case 2:this.updateExpandability(m);break;case 4:this.pushDiff({op:1,item:{extId:m.fullId.toString(),item:S.update}});break;case 6:this.documentSynced(m.actual.uri);break;default:(0,F.assertNever)(S)}}documentSynced(m){m&&this.pushDiff({op:2,uri:m,docv:this.options.getDocumentVersion(m)})}upsertItem(m,S){const c=A.TestId.fromExtHostTestItem(m,this.root.id,S?.actual),_=this.options.getApiFor(m);_.parent&&_.parent!==S?.actual&&this.options.getChildren(_.parent).delete(m.id);let t=this.tree.get(c.toString());if(!t){t={fullId:c,actual:m,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},m.tags.forEach(this.incrementTagRefs,this),this.tree.set(t.fullId.toString(),t),this.setItemParent(m,S),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:t.expand,item:this.options.toITestItem(m)}}),this.connectItemAndChildren(m,t,S);return}if(t.actual===m){this.connectItem(m,t,S);return}const u=this.options.getChildren(t.actual),i=t.actual,n=b(this.options.toITestItem(i),this.options.toITestItem(m));this.options.getApiFor(i).listener=void 0,t.actual=m,t.expand=0,n&&(n.hasOwnProperty("tags")&&(this.diffTagRefs(m.tags,i.tags,c.toString()),delete n.tags),this.onTestItemEvent(t,{op:4,update:n})),this.connectItemAndChildren(m,t,S);for(const[s,h]of u)this.options.getChildren(m).get(h.id)||this.removeItem(A.TestId.joinToString(c,h.id));this.documentSynced(t.actual.uri)}diffTagRefs(m,S,c){const _=new Set(S.map(t=>t.id));for(const t of m)_.delete(t.id)||this.incrementTagRefs(t);this.pushDiff({op:1,item:{extId:c,item:{tags:m.map(t=>(0,y.namespaceTestTag)(this.options.controllerId,t.id))}}}),_.forEach(this.decrementTagRefs,this)}incrementTagRefs(m){const S=this.tags.get(m.id);S?S.refCount++:(this.tags.set(m.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,y.namespaceTestTag)(this.options.controllerId,m.id)}}))}decrementTagRefs(m){const S=this.tags.get(m);S&&!--S.refCount&&(this.tags.delete(m),this.pushDiff({op:7,id:(0,y.namespaceTestTag)(this.options.controllerId,m)}))}setItemParent(m,S){this.options.getApiFor(m).parent=S&&S.actual!==this.root?S.actual:void 0}connectItem(m,S,c){this.setItemParent(m,c);const _=this.options.getApiFor(m);_.parent=c?.actual,_.listener=t=>this.onTestItemEvent(S,t),this.updateExpandability(S)}connectItemAndChildren(m,S,c){this.connectItem(m,S,c);for(const[_,t]of this.options.getChildren(m))this.upsertItem(t,S)}updateExpandability(m){let S;this._resolveHandler?m.resolveBarrier?S=m.resolveBarrier.isOpen()?3:2:S=m.actual.canResolveChildren?1:0:S=0,S!==m.expand&&(m.expand=S,this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:S}}),S===1&&m.expandLevels!==void 0&&this.resolveChildren(m))}expandChildren(m,S){if(S<0)return;const c=[];for(const[_,t]of this.options.getChildren(m.actual)){const u=this.expand(A.TestId.joinToString(m.fullId,t.id),S);(0,r.isThenable)(u)&&c.push(u)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(m){if(m.resolveBarrier)return m.resolveBarrier;if(!this._resolveHandler){const t=new r.Barrier;return t.open(),t}m.expand=2,this.pushExpandStateUpdate(m);const S=m.resolveBarrier=new r.Barrier,c=t=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,t)};let _;try{_=this._resolveHandler(m.actual===this.root?void 0:m.actual)}catch(t){c(t)}return(0,r.isThenable)(_)?_.catch(c).then(()=>{S.open(),this.updateExpandability(m)}):(S.open(),this.updateExpandability(m)),m.resolveBarrier}pushExpandStateUpdate(m){this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:m.expand}})}removeItem(m){const S=this.tree.get(m);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:m});const c=[S];for(;c.length;){const _=c.pop();if(!!_){this.options.getApiFor(_.actual).listener=void 0;for(const t of _.actual.tags)this.decrementTagRefs(t.id);this.tree.delete(_.fullId.toString());for(const[t,u]of this.options.getChildren(_.actual))c.push(this.tree.get(A.TestId.joinToString(_.fullId,u.id)))}}}flushDiff(){const m=this.collectDiff();m.length&&this.diffOpEmitter.fire(m)}}e.TestItemCollection=g;class I extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.DuplicateTestItemError=I;class p extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class a extends Error{constructor(m,S,c){super(`TestItem with ID "${m}" is from controller "${S}" and cannot be added as a child of an item from controller "${c}".`)}}e.MixedTestItemController=a;const l=(d,m,S)=>{let c=new Map;return{get size(){return c.size},forEach(_,t){for(const u of c.values())_.call(t,u,this)},[Symbol.iterator](){return c.entries()},replace(_){const t=new Map,u=new Set(c.keys()),i={op:5,ops:[]};for(const n of _){if(!(n instanceof S))throw new p(n.id);const s=m(n).controllerId;if(s!==d.controllerId)throw new a(n.id,s,d.controllerId);if(t.has(n.id))throw new I(n.id);t.set(n.id,n),u.delete(n.id),i.ops.push({op:0,item:n})}for(const n of u.keys())i.ops.push({op:3,id:n});d.listener?.(i),c=t},add(_){if(!(_ instanceof S))throw new p(_.id);c.set(_.id,_),d.listener?.({op:0,item:_})},delete(_){c.delete(_)&&d.listener?.({op:3,id:_})},get(_){return c.get(_)},toJSON(){return Array.from(c.values())}}};e.createTestItemChildren=l}),define(Ce[90],Ie([1,0,66]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const C=new WeakMap,w=(y,A)=>{const E={controllerId:A};return C.set(y,E),E};e.createPrivateApiFor=w;const F=y=>{const A=C.get(y);if(!A)throw new r.InvalidTestItemError(y?.id||"<unknown>");return A};e.getPrivateApiFor=F}),define(Ce[173],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,r.createDecorator)("configurationResolverService");var C;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator"})(C=e.VariableKind||(e.VariableKind={}));class w extends Error{constructor(y,A){super(A),this.variable=y}}e.VariableError=w}),define(Ce[174],Ie([1,0,19,47,10,24,20,80,142,173,9]),function(ne,e,r,C,w,F,y,A,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class b{constructor(I,p,a,l){this._contributedVariables=new Map,this._context=I,this._labelService=p,this._userHomePromise=a,l&&(this._envVariablesPromise=l.then(d=>this.prepareEnv(d)))}prepareEnv(I){if(y.isWindows){const p=Object.create(null);return Object.keys(I).forEach(a=>{p[a.toLowerCase()]=I[a]}),p}return I}resolveWithEnvironment(I,p,a){return this.recursiveResolve({env:this.prepareEnv(I),userHome:void 0},p?p.uri:void 0,a)}async resolveAsync(I,p){const a={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(a,I?I.uri:void 0,p)}async resolveAnyBase(I,p,a,l){const d=F.deepClone(p);y.isWindows&&d.windows?Object.keys(d.windows).forEach(S=>d[S]=d.windows[S]):y.isMacintosh&&d.osx?Object.keys(d.osx).forEach(S=>d[S]=d.osx[S]):y.isLinux&&d.linux&&Object.keys(d.linux).forEach(S=>d[S]=d.linux[S]),delete d.windows,delete d.osx,delete d.linux;const m={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(m,I?I.uri:void 0,d,a,l)}async resolveAnyAsync(I,p,a){return this.resolveAnyBase(I,p,a)}async resolveAnyMap(I,p,a){const l=new Map;return{newConfig:await this.resolveAnyBase(I,p,a,l),resolvedVariables:l}}resolveWithInteractionReplace(I,p,a,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,p,a,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,p){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,p)}async recursiveResolve(I,p,a,l,d){if(w.isString(a))return this.resolveString(I,p,a,l,d);if(Array.isArray(a))return Promise.all(a.map(m=>this.recursiveResolve(I,p,m,l,d)));if(w.isObject(a)){const m=Object.create(null),S=await Promise.all(Object.keys(a).map(async c=>[await this.resolveString(I,p,c,l,d),await this.recursiveResolve(I,p,a[c],l,d)]));for(const[c,_]of S)m[c]=_;return m}return a}resolveString(I,p,a,l,d){return(0,R.replaceAsync)(a,b.VARIABLE_REGEXP,async(m,S)=>{if(S.includes(b.VARIABLE_LHS))return m;let c=await this.evaluateSingleVariable(I,m,S,p,l);return d?.set(S,c),c!==m&&w.isString(c)&&c.match(b.VARIABLE_REGEXP)&&(c=await this.resolveString(I,p,c,l,d)),c})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}async evaluateSingleVariable(I,p,a,l,d){let m;const S=a.split(":");S.length>1&&(a=S[0],m=S[1]);const c=u=>{const i=this._context.getFilePath();if(i)return i;throw new P.VariableError(u,(0,E.localize)(0,null,p))},_=u=>{const i=c(u);if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new P.VariableError(u,(0,E.localize)(1,null,p,r.basename(i)))},t=u=>{if(m){const i=this._context.getFolderUri(m);if(i)return i;throw new P.VariableError(u,(0,E.localize)(2,null,p,m))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new P.VariableError(u,(0,E.localize)(3,null,p)):new P.VariableError(u,(0,E.localize)(4,null,p))};switch(a){case"env":if(m){if(I.env){const u=I.env[y.isWindows?m.toLowerCase():m];if(w.isString(u))return u}return""}throw new P.VariableError(P.VariableKind.Env,(0,E.localize)(5,null,p));case"config":if(m){const u=this._context.getConfigurationValue(l,m);if(w.isUndefinedOrNull(u))throw new P.VariableError(P.VariableKind.Config,(0,E.localize)(6,null,p,m));if(w.isObject(u))throw new P.VariableError(P.VariableKind.Config,(0,E.localize)(7,null,p,m));return u}throw new P.VariableError(P.VariableKind.Config,(0,E.localize)(8,null,p));case"command":return this.resolveFromMap(P.VariableKind.Command,p,m,d,"command");case"input":return this.resolveFromMap(P.VariableKind.Input,p,m,d,"input");case"extensionInstallFolder":if(m){const u=await this._context.getExtension(m);if(!u)throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,p,m));return this.fsPath(u.extensionLocation)}throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,p));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(t(P.VariableKind.WorkspaceFolder)));case"cwd":return l||m?(0,A.normalizeDriveLetter)(this.fsPath(t(P.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return r.basename(this.fsPath(t(P.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(I.userHome)return I.userHome;throw new P.VariableError(P.VariableKind.UserHome,(0,E.localize)(11,null,p))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new P.VariableError(P.VariableKind.LineNumber,(0,E.localize)(12,null,p))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new P.VariableError(P.VariableKind.SelectedText,(0,E.localize)(13,null,p))}case"file":return c(P.VariableKind.File);case"fileWorkspaceFolder":return _(P.VariableKind.FileWorkspaceFolder);case"relativeFile":return l||m?r.relative(this.fsPath(t(P.VariableKind.RelativeFile)),c(P.VariableKind.RelativeFile)):c(P.VariableKind.RelativeFile);case"relativeFileDirname":{const u=r.dirname(c(P.VariableKind.RelativeFileDirname));if(l||m){const i=r.relative(this.fsPath(t(P.VariableKind.RelativeFileDirname)),u);return i.length===0?".":i}return u}case"fileDirname":return r.dirname(c(P.VariableKind.FileDirname));case"fileExtname":return r.extname(c(P.VariableKind.FileExtname));case"fileBasename":return r.basename(c(P.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=r.basename(c(P.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-r.extname(u).length)}case"fileDirnameBasename":return r.basename(r.dirname(c(P.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||p}case"execInstallFolder":{const u=this._context.getAppRoot();return u||p}case"pathSeparator":return r.sep;default:try{const u=m?`${a}:${m}`:a;return this.resolveFromMap(P.VariableKind.Unknown,p,u,d,void 0)}catch{return p}}}}resolveFromMap(I,p,a,l,d){if(a&&l){const m=d===void 0?l[a]:l[d+":"+a];if(typeof m=="string")return m;throw new P.VariableError(I,(0,E.localize)(14,null,p))}return p}}e.AbstractVariableResolverService=b,b.VARIABLE_LHS="${",b.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[91],Ie([1,0,3,89]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var w;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var F;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(F=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var A;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function P(p){const a=p;return(0,C.isEditorInput)(a?.editor)&&(0,C.isEditorInput)(a?.replacement)}e.isEditorReplacement=P;var R;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var b;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(b=e.OpenEditorContext||(e.OpenEditorContext={}));function g(p){const a=p;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.isEditorGroup=g;function I(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(Ce[175],Ie([1,0,3,91]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(F){const y=F;return typeof F=="number"||(0,C.isEditorGroup)(y)}e.isPreferredGroup=w}),define(Ce[176],Ie([1,0,3,147]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(C.IEnvironmentService)}),define(Ce[177],Ie([1,0,27,4,19]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class F{constructor(b){this.removedDueToLooping=b}}e.DeltaExtensionsResult=F;class y{constructor(b){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=b,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const b of this._extensionDescriptions){if(this._extensionsMap.has(r.ExtensionIdentifier.toKey(b.identifier))){console.error("Extension `"+b.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(r.ExtensionIdentifier.toKey(b.identifier),b),this._extensionsArr.push(b),Array.isArray(b.activationEvents))for(let g of b.activationEvents)g==="onUri"&&(g=`onUri:${r.ExtensionIdentifier.toKey(b.identifier)}`),this._activationMap.has(g)||this._activationMap.set(g,[]),this._activationMap.get(g).push(b)}}set(b){this._extensionDescriptions=b,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(b,g){this._extensionDescriptions=P(this._extensionDescriptions,g),this._extensionDescriptions=this._extensionDescriptions.concat(b);const I=y._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=P(this._extensionDescriptions,I.map(p=>p.identifier)),this._initialize(),this._onDidChange.fire(void 0),new F(I)}static _findLoopingExtensions(b){const g=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,m){this.addNode(d),this.addNode(m),this._arcs.has(d)?this._arcs.get(d).push(m):this._arcs.set(d,[m])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,m){const S=g.getArcs(d);for(let c=0;c<S.length;c++)if(!m.has(S[c]))return!1;return!0}getNodes(){return this._nodesArr}},I=new Map;for(const d of b){const m=r.ExtensionIdentifier.toKey(d.identifier);if(I.set(m,d),d.extensionDependencies)for(const S of d.extensionDependencies){const c=r.ExtensionIdentifier.toKey(S);g.addArc(m,c)}}const p=new Set;g.getNodes().filter(d=>g.getArcs(d).length===0).forEach(d=>p.add(d));const a=g.getNodes().filter(d=>!p.has(d));let l;do{l=!1;for(let d=0;d<a.length;d++){const m=a[d];g.hasOnlyGoodArcs(m,p)&&(a.splice(d,1),d--,p.add(m),l=!0)}}while(l);return a.map(d=>I.get(d))}containsActivationEvent(b){return this._activationMap.has(b)}containsExtension(b){return this._extensionsMap.has(r.ExtensionIdentifier.toKey(b))}getExtensionDescriptionsForActivationEvent(b){const g=this._activationMap.get(b);return g?g.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(b){const g=this._extensionsMap.get(r.ExtensionIdentifier.toKey(b));return g||void 0}getExtensionDescriptionByUUID(b){for(const g of this._extensionsArr)if(g.uuid===b)return g}getExtensionDescriptionByIdOrUUID(b,g){return this.getExtensionDescription(b)??(g?this.getExtensionDescriptionByUUID(g):void 0)}}e.ExtensionDescriptionRegistry=y;var A;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(A||(A={}));function E(R,b){const g=R.isBuiltin?0:R.isUnderDevelopment?2:1,I=b.isBuiltin?0:b.isUnderDevelopment?2:1;if(g!==I)return g-I;const p=w.posix.basename(R.extensionLocation.path),a=w.posix.basename(b.extensionLocation.path);return p<a?-1:p>a?1:0}function P(R,b){const g=new Set;return b.forEach(I=>g.add(r.ExtensionIdentifier.toKey(I))),R.filter(I=>!g.has(r.ExtensionIdentifier.toKey(I.identifier)))}}),define(Ce[67],Ie([1,0,23]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(P){P[P.Desktop=1]="Desktop",P[P.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var w;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(w=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var F;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(F=e.MessageType||(e.MessageType={}));function y(P){const R=r.VSBuffer.alloc(1);switch(P){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=y;function A(P,R){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=A;var E;(function(P){P.Start="START_NATIVE_LOG",P.End="END_NATIVE_LOG"})(E=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[92],Ie([1,0,3,4,11,26,67,60,157,24,2]),function(ne,e,r,C,w,F,y,A,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let b=class{constructor(a,l){this.initData=a,this._onDidChangeTelemetryEnabled=new C.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new C.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryLoggers=new Map,console.log(this.initData.environment.extensionTelemetryLogResource),this._outputLogger=l.createLogger(R.URI.revive(this.initData.environment.extensionTelemetryLogResource)),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(a,l){const d=this.getTelemetryDetails(),m=new g(l,a,this._outputLogger,this.getBuiltInCommonProperties(a),{isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled});return this._telemetryLoggers.set(a.identifier.value,m),m.apiTelemetryLogger}$initializeTelemetryLevel(a,l){this._level=a,this._productConfig=l||{usage:!0,error:!0}}getBuiltInCommonProperties(a){const l={};switch(l["common.extname"]=a.name,l["common.extversion"]=a.version,l["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,l["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,l["common.vscodeversion"]=this.initData.version,l["common.isnewappinstall"]=I(this.initData.telemetryInfo.firstSessionDate),l["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case y.UIKind.Web:l["common.uikind"]="web";break;case y.UIKind.Desktop:l["common.uikind"]="desktop";break;default:l["common.uikind"]="unknown"}return l["common.remotename"]=(0,A.getRemoteName)((0,E.cleanRemoteAuthority)(this.initData.remote.authority)),l}$onDidChangeTelemetryLevel(a){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=a;const l=this.getTelemetryDetails();this._telemetryLoggers.forEach(d=>{d.updateTelemetryEnablements(l.isUsageEnabled,l.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}};b=$e([xe(0,F.IExtHostInitDataService),xe(1,w.ILoggerService)],b),e.ExtHostTelemetry=b;class g{constructor(a,l,d,m,S){this._extension=l,this._logger=d,this._commonProperties=m,this._onDidChangeEnableStates=new C.Emitter,this._appender=a,this._telemetryEnablements={isUsageEnabled:S.isUsageEnabled,isErrorsEnabled:S.isErrorsEnabled}}updateTelemetryEnablements(a,l){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:a,isErrorsEnabled:l},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(a){return this._appender.ignoreBuiltInCommonProperties||(a=(0,P.mixin)(a,this._commonProperties)),this._appender.additionalCommonProperties&&(a=(0,P.mixin)(a,this._appender.additionalCommonProperties)),a=(0,E.cleanData)(a,[]),a}logEvent(a,l){a=this._extension.identifier.value+"/"+a,l=this.mixInCommonPropsAndCleanData(l||{}),this._appender.logEvent(a,l),this._logger.trace(a,l)}logUsage(a,l){!this._telemetryEnablements.isUsageEnabled||this.logEvent(a,l)}logError(a,l){!this._telemetryEnablements.isErrorsEnabled||(typeof a=="string"?this.logEvent(a,l):this._appender.logException(a,l))}get apiTelemetryLogger(){if(!this._apiObject){const a=this,l={logUsage:a.logUsage,get isUsageEnabled(){return a._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return a._telemetryEnablements.isErrorsEnabled},logError:a.logError,dispose:a.dispose,onDidChangeEnableStates:a._onDidChangeEnableStates.event};this._apiObject=Object.freeze(l)}return this._apiObject}dispose(){this._appender?.flush&&this._appender.flush()}}e.ExtHostTelemetryLogger=g;function I(p){const a=Date.now()-new Date(p).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.isNewAppInstall=I,e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(Ce[28],Ie([1,0,4,2,3,27,154]),function(ne,e,r,C,w,F,y){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new F.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");class E{constructor(h){this.affinity=h,this.kind=1}equals(h){return this.kind===h.kind&&this.affinity===h.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class P{constructor(){this.kind=2,this.affinity=0}equals(h){return this.kind===h.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=P;class R{constructor(){this.kind=3,this.affinity=0}equals(h){return this.kind===h.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class b{constructor(h){this.dependency=h}}e.MissingExtensionDependency=b;var g;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(g=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=I;class p{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(h,o){const f=[],v=[],T=[],M=[],j=d(this._allExtensions),U=d(h),D=(H,W)=>H.extensionLocation.toString()===W.extensionLocation.toString()||H.isBuiltin===W.isBuiltin||H.isUserBuiltin===W.isUserBuiltin||H.isUnderDevelopment===W.isUnderDevelopment;for(const H of this._allExtensions){const W=U.get(F.ExtensionIdentifier.toKey(H.identifier));if(!W){f.push(H.identifier),j.delete(F.ExtensionIdentifier.toKey(H.identifier));continue}if(!D(H,W)){f.push(H.identifier),j.delete(F.ExtensionIdentifier.toKey(H.identifier));continue}}for(const H of h){const W=j.get(F.ExtensionIdentifier.toKey(H.identifier));if(!W){v.push(H);continue}if(!D(W,H)){f.push(W.identifier),j.delete(F.ExtensionIdentifier.toKey(W.identifier));continue}}const $=l(this._myExtensions),L=l(o);for(const H of this._myExtensions)L.has(F.ExtensionIdentifier.toKey(H))||T.push(H);for(const H of o)$.has(F.ExtensionIdentifier.toKey(H))||M.push(H);const O={toRemove:f,toAdd:v,myToRemove:T,myToAdd:M};return this.delta(O),O}delta(h){const{toRemove:o,toAdd:f,myToRemove:v,myToAdd:T}=h,M=l(o),j=l(v);for(let U=0;U<this._allExtensions.length;U++)M.has(F.ExtensionIdentifier.toKey(this._allExtensions[U].identifier))&&(this._allExtensions.splice(U,1),U--);for(let U=0;U<this._myExtensions.length;U++)j.has(F.ExtensionIdentifier.toKey(this._myExtensions[U]))&&(this._myExtensions.splice(U,1),U--);for(const U of f)this._allExtensions.push(U);for(const U of T)this._myExtensions.push(U)}containsExtension(h){for(const o of this._myExtensions)if(F.ExtensionIdentifier.equals(o,h))return!0;return!1}}e.ExtensionHostExtensions=p;class a{constructor(h){if(this[A]="ExtensionIdentifierSet",this._map=new Map,this._toKey=F.ExtensionIdentifier.toKey,h)for(const o of h)this.add(o)}get size(){return this._map.size}add(h){return this._map.set(this._toKey(h),h),this}clear(){this._map.clear()}delete(h){return this._map.delete(this._toKey(h))}has(h){return this._map.has(this._toKey(h))}forEach(h,o){this._map.forEach(f=>h.call(o,f,f,this))}*entries(){for(const[h,o]of this._map)yield[o,o]}keys(){return this._map.values()}values(){return this._map.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=a;function l(s){const h=new Set;for(const o of s)h.add(F.ExtensionIdentifier.toKey(o));return h}e.extensionIdentifiersArrayToSet=l;function d(s){const h=new Map;for(const o of s)h.set(F.ExtensionIdentifier.toKey(o.identifier),o);return h}function m(s,h){return s.enabledApiProposals?s.enabledApiProposals.includes(h):!1}e.isProposedApiEnabled=m;function S(s,h){if(!m(s,h))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=S;class c{constructor(h,o,f,v){this.codeLoadingTime=h,this.activateCallTime=o,this.activateResolvedTime=f,this.activationReason=v}}e.ActivationTimes=c;class _{constructor(h,o){this.description=h,this.value=o}}e.ExtensionPointContribution=_,e.ExtensionHostLogFileName="exthost";var t;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function u(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function i(s,h){return{identifier:new F.ExtensionIdentifier((0,y.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!h,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=i;class n{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(h,o){return Promise.resolve(0)}getInspectPorts(h,o){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(h,o){return Promise.resolve()}}e.NullExtensionService=n}),define(Ce[178],Ie([1,0,12,27,28,11,15]),function(ne,e,r,C,w,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class A{constructor(l,d,m,S){this.startup=l,this.codeLoadingTime=d,this.activateCallTime=m,this.activateResolvedTime=S}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class E{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,d){return l===-1||d===-1?-1:d-l}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class P{constructor(l,d,m,S,c,_){this.activationFailed=l,this.activationFailedError=d,this.activationTimes=m,this.module=S,this.exports=c,this.subscriptions=_}}e.ActivatedExtension=P;class R extends P{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class b extends P{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=b;class g extends P{constructor(l){super(!0,l,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=g;let I=class{constructor(l,d,m,S,c){this._logService=c,this._registry=l,this._resolvedExtensionsSet=new Set,d.forEach(_=>this._resolvedExtensionsSet.add(C.ExtensionIdentifier.toKey(_))),this._externalExtensionsMap=new Map,m.forEach(_=>this._externalExtensionsMap.set(C.ExtensionIdentifier.toKey(_),_)),this._host=S,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[l,d]of this._operations)d.dispose()}isActivated(l){const d=this._operations.get(C.ExtensionIdentifier.toKey(l));return Boolean(d&&d.value)}getActivatedExtension(l){const d=this._operations.get(C.ExtensionIdentifier.toKey(l));if(!d||!d.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return d.value}async activateByEvent(l,d){if(this._alreadyActivatedEvents[l])return;const m=this._registry.getExtensionDescriptionsForActivationEvent(l);await this._activateExtensions(m.map(S=>({id:S.identifier,reason:{startup:d,extensionId:S.identifier,activationEvent:l}}))),this._alreadyActivatedEvents[l]=!0}activateById(l,d){const m=this._registry.getExtensionDescription(l);if(!m)throw new Error(`Extension '${l}' is not known`);return this._activateExtensions([{id:m.identifier,reason:d}])}async _activateExtensions(l){const d=l.filter(m=>!this.isActivated(m.id)).map(m=>this._handleActivationRequest(m));await Promise.all(d.map(m=>m.wait()))}_handleActivationRequest(l){if(this._operations.has(C.ExtensionIdentifier.toKey(l.id)))return this._operations.get(C.ExtensionIdentifier.toKey(l.id));if(this._externalExtensionsMap.has(C.ExtensionIdentifier.toKey(l.id)))return this._createAndSaveOperation(l,null,[],null);const d=this._registry.getExtensionDescription(l.id);if(!d){const c=new Error(`Cannot activate unknown extension '${l.id.value}'`),_=this._createAndSaveOperation(l,null,[],new g(c));return this._host.onExtensionActivationError(l.id,c,new w.MissingExtensionDependency(l.id.value)),_}const m=[],S=typeof d.extensionDependencies>"u"?[]:d.extensionDependencies;for(const c of S){if(this._resolvedExtensionsSet.has(C.ExtensionIdentifier.toKey(c)))continue;const _=this._operations.get(C.ExtensionIdentifier.toKey(c));if(_){m.push(_);continue}if(this._externalExtensionsMap.has(C.ExtensionIdentifier.toKey(c))){m.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(C.ExtensionIdentifier.toKey(c)),reason:l.reason}));continue}const t=this._registry.getExtensionDescription(c);if(t){if(!t.main&&!t.browser)continue;m.push(this._handleActivationRequest({id:t.identifier,reason:l.reason}));continue}const u=d.displayName||d.identifier.value,i=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${c}'`),n=this._createAndSaveOperation(l,d.displayName,[],new g(i));return this._host.onExtensionActivationError(d.identifier,i,new w.MissingExtensionDependency(c)),n}return this._createAndSaveOperation(l,d.displayName,m,null)}_createAndSaveOperation(l,d,m,S){const c=new p(l.id,d,l.reason,m,S,this._host,this._logService);return this._operations.set(C.ExtensionIdentifier.toKey(l.id),c),c}};I=$e([xe(4,F.ILogService)],I),e.ExtensionsActivator=I;let p=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(l,d,m,S,c,_,t){this._id=l,this._displayName=d,this._reason=m,this._deps=S,this._value=c,this._host=_,this._logService=t,this._barrier=new y.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let l=0;l<this._deps.length;l++){const d=this._deps[l];if(d.value&&!d.value.activationFailed){this._deps.splice(l,1),l--;continue}if(d.value&&d.value.activationFailed){const m=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${d.friendlyName}' failed to activate`);m.detail=d.value.activationFailedError,this._value=new g(m),this._host.onExtensionActivationError(this._id,m,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(l=>l.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(l){const d=new Error;if(l&&l.name&&(d.name=l.name),l&&l.message?d.message=`Activating extension '${this._id.value}' failed: ${l.message}.`:d.message=`Activating extension '${this._id.value}' failed: ${l}.`,l&&l.stack&&(d.stack=l.stack),this._value=new g(d),this._isDisposed&&r.isCancellationError(l))return;this._host.onExtensionActivationError(this._id,d,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(l)}}};p=$e([xe(6,F.ILogService)],p)}),define(Ce[179],Ie([1,0,11,26,28]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends r.LogService{constructor(A,E){super(A.createLogger(E.logFile,{name:w.ExtensionHostLogFileName}))}};F=$e([xe(0,r.ILoggerService),xe(1,C.IExtHostInitDataService)],F),e.ExtHostLogService=F});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(ne,r):w?w.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!C:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ne):C?C.value:e.get(ne)};define(Ce[6],Ie([1,0,18,12,79,25,77,9,10,2,38,35,88,65,28]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p){"use strict";var a,l,d,m,S,c,_,t,u,i,n,s,h,o,f,v,T,M,j,U,D,$,L;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function O(x){return Object.assign(x,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct(x,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(x,[]);{const[ie,...we]=arguments;return Reflect.construct(x,we,ie.constructor)}}})}let H=c=class{static from(...N){let ie=N;return new c(function(){if(ie){for(const we of ie)we&&typeof we.dispose=="function"&&we.dispose();ie=void 0}})}constructor(N){a.set(this,void 0),Ye(this,a,N,"f")}dispose(){typeof Oe(this,a,"f")=="function"&&(Oe(this,a,"f").call(this),Ye(this,a,void 0,"f"))}};a=new WeakMap,H=c=$e([O],H),e.Disposable=H;let W=_=class{static Min(...N){if(N.length===0)throw new TypeError;let ie=N[0];for(let we=1;we<N.length;we++){const He=N[we];He.isBefore(ie)&&(ie=He)}return ie}static Max(...N){if(N.length===0)throw new TypeError;let ie=N[0];for(let we=1;we<N.length;we++){const He=N[we];He.isAfter(ie)&&(ie=He)}return ie}static isPosition(N){if(!N)return!1;if(N instanceof _)return!0;const{line:ie,character:we}=N;return typeof ie=="number"&&typeof we=="number"}static of(N){if(N instanceof _)return N;if(this.isPosition(N))return new _(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(N,ie){if(N<0)throw(0,C.illegalArgument)("line must be non-negative");if(ie<0)throw(0,C.illegalArgument)("character must be non-negative");this._line=N,this._character=ie}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,ie=0){if(N===null||ie===null)throw(0,C.illegalArgument)();let we;return typeof N>"u"?we=0:typeof N=="number"?we=N:(we=typeof N.lineDelta=="number"?N.lineDelta:0,ie=typeof N.characterDelta=="number"?N.characterDelta:0),we===0&&ie===0?this:new _(this.line+we,this.character+ie)}with(N,ie=this.character){if(N===null||ie===null)throw(0,C.illegalArgument)();let we;return typeof N>"u"?we=this.line:typeof N=="number"?we=N:(we=typeof N.line=="number"?N.line:this.line,ie=typeof N.character=="number"?N.character:this.character),we===this.line&&ie===this.character?this:new _(we,ie)}toJSON(){return{line:this.line,character:this.character}}};W=_=$e([O],W),e.Position=W;let z=t=class{static isRange(N){return N instanceof t?!0:N?W.isPosition(N.start)&&W.isPosition(N.end):!1}static of(N){if(N instanceof t)return N;if(this.isRange(N))return new t(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(N,ie,we,He){let Qe,lt;if(typeof N=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new W(N,ie),lt=new W(we,He)):W.isPosition(N)&&W.isPosition(ie)&&(Qe=W.of(N),lt=W.of(ie)),!Qe||!lt)throw new Error("Invalid arguments");Qe.isBefore(lt)?(this._start=Qe,this._end=lt):(this._start=lt,this._end=Qe)}contains(N){return t.isRange(N)?this.contains(N.start)&&this.contains(N.end):W.isPosition(N)?!(W.of(N).isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const ie=W.Max(N.start,this._start),we=W.Min(N.end,this._end);if(!ie.isAfter(we))return new t(ie,we)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ie=W.Min(N.start,this._start),we=W.Max(N.end,this.end);return new t(ie,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,ie=this.end){if(N===null||ie===null)throw(0,C.illegalArgument)();let we;return N?W.isPosition(N)?we=N:(we=N.start||this.start,ie=N.end||this.end):we=this.start,we.isEqual(this._start)&&ie.isEqual(this.end)?this:new t(we,ie)}toJSON(){return[this.start,this.end]}};z=t=$e([O],z),e.Range=z;let G=u=class extends z{static isSelection(N){return N instanceof u?!0:N?z.isRange(N)&&W.isPosition(N.anchor)&&W.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(N,ie,we,He){let Qe,lt;if(typeof N=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new W(N,ie),lt=new W(we,He)):W.isPosition(N)&&W.isPosition(ie)&&(Qe=W.of(N),lt=W.of(ie)),!Qe||!lt)throw new Error("Invalid arguments");super(Qe,lt),this._anchor=Qe,this._active=lt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=u=$e([O],G),e.Selection=G;class te{constructor(N,ie,we){if(typeof N!="string"||N.length===0)throw(0,C.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,C.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw(0,C.illegalArgument)("connectionToken");this.host=N,this.port=Math.round(ie),this.connectionToken=we}}e.ResolvedAuthority=te;class he extends Error{static NotAvailable(N,ie){return new he(N,g.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(N){return new he(N,g.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,ie=g.RemoteAuthorityResolverErrorCode.Unknown,we){super(N),this._message=N,this._code=ie,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,he.prototype)}}e.RemoteAuthorityResolverError=he;var re;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(re=e.EndOfLine||(e.EndOfLine={}));var be;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(be=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let le=i=class{static isTextEdit(N){return N instanceof i?!0:N?z.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ie){return new i(N,ie)}static insert(N,ie){return i.replace(new z(N,N),ie)}static delete(N){return i.replace(N,"")}static setEndOfLine(N){const ie=new i(new z(new W(0,0),new W(0,0)),"");return ie.newEol=N,ie}get range(){return this._range}set range(N){if(N&&!z.isRange(N))throw(0,C.illegalArgument)("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw(0,C.illegalArgument)("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw(0,C.illegalArgument)("newEol");this._newEol=N}constructor(N,ie){this._range=N,this._newText=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};le=i=$e([O],le),e.TextEdit=le;let fe=n=class{static isNotebookCellEdit(N){return N instanceof n?!0:N?Vt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ie){return new n(N,ie)}static insertCells(N,ie){return new n(new Vt(N,N),ie)}static deleteCells(N){return new n(N,[])}static updateCellMetadata(N,ie){const we=new n(new Vt(N,N),[]);return we.newCellMetadata=ie,we}static updateNotebookMetadata(N){const ie=new n(new Vt(0,0),[]);return ie.newNotebookMetadata=N,ie}constructor(N,ie){this.range=N,this.newCells=ie}};fe=n=$e([O],fe),e.NotebookEdit=fe;class Q{static isSnippetTextEdit(N){return N instanceof Q?!0:N?z.isRange(N.range)&&Fe.isSnippetString(N.snippet):!1}static replace(N,ie){return new Q(N,ie)}static insert(N,ie){return Q.replace(new z(N,N),ie)}constructor(N,ie){this.range=N,this.snippet=ie}}e.SnippetTextEdit=Q;var pe;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(pe=e.FileEditType||(e.FileEditType={}));let Se=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(N,ie,we,He){this._edits.push({_type:1,from:N,to:ie,options:we,metadata:He})}createFile(N,ie,we){this._edits.push({_type:1,from:void 0,to:N,options:ie,metadata:we})}deleteFile(N,ie,we){this._edits.push({_type:1,from:N,to:void 0,options:ie,metadata:we})}replaceNotebookMetadata(N,ie,we){this._edits.push({_type:3,metadata:we,uri:N,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(N,ie,we,He){const Qe=ie.start,lt=ie.end;(Qe!==lt||we.length>0)&&this._edits.push({_type:5,uri:N,index:Qe,count:lt-Qe,cells:we,metadata:He})}replaceNotebookCellMetadata(N,ie,we,He){this._edits.push({_type:3,metadata:He,uri:N,edit:{editType:8,index:ie,metadata:we}})}replace(N,ie,we,He){this._edits.push({_type:2,uri:N,edit:new le(ie,we),metadata:He})}insert(N,ie,we,He){this.replace(N,new z(ie,ie),we,He)}delete(N,ie,we){this.replace(N,ie,"",we)}has(N){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===N.toString())}set(N,ie){if(ie)for(const we of ie){if(!we)continue;let He,Qe;Array.isArray(we)?(He=we[0],Qe=we[1]):He=we,fe.isNotebookCellEdit(He)?He.newCellMetadata?this.replaceNotebookCellMetadata(N,He.range.start,He.newCellMetadata,Qe):He.newNotebookMetadata?this.replaceNotebookMetadata(N,He.newNotebookMetadata,Qe):this.replaceNotebookCells(N,He.range,He.newCells,Qe):Q.isSnippetTextEdit(He)?this._edits.push({_type:6,uri:N,range:He.range,edit:He.snippet,metadata:Qe}):this._edits.push({_type:2,uri:N,edit:He,metadata:Qe})}else{for(let we=0;we<this._edits.length;we++){const He=this._edits[we];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===N.toString()&&(this._edits[we]=void 0);break}}(0,r.coalesceInPlace)(this._edits)}}get(N){const ie=[];for(const we of this._edits)we._type===2&&we.uri.toString()===N.toString()&&ie.push(we.edit);return ie}entries(){const N=new F.ResourceMap;for(const ie of this._edits)if(ie._type===2){let we=N.get(ie.uri);we||(we=[ie.uri,[]],N.set(ie.uri,we)),we[1].push(ie.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Se=$e([O],Se),e.WorkspaceEdit=Se;let Fe=s=class{static isSnippetString(N){return N instanceof s?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this._tabstop=1,this.value=N||""}appendText(N){return this.value+=s._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ie=this._tabstop++){if(typeof N=="function"){const we=new s;we._tabstop=this._tabstop,N(we),this._tabstop=we._tabstop,N=we.value}else N=s._escape(N);return this.value+="${",this.value+=ie,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ie=this._tabstop++){const we=N.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(N,ie){if(typeof ie=="function"){const we=new s;we._tabstop=this._tabstop,ie(we),this._tabstop=we._tabstop,ie=we.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};Fe=s=$e([O],Fe),e.SnippetString=Fe;var Be;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(Be=e.DiagnosticTag||(e.DiagnosticTag={}));var Xe;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(Xe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=h=class{static isLocation(N){return N instanceof h?!0:N?z.isRange(N.range)&&P.URI.isUri(N.uri):!1}constructor(N,ie){if(this.uri=N,ie)if(z.isRange(ie))this.range=z.of(ie);else if(W.isPosition(ie))this.range=new z(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=h=$e([O],ke),e.Location=ke;let ye=class{static is(N){return N?typeof N.message=="string"&&N.location&&z.isRange(N.location.range)&&P.URI.isUri(N.location.uri):!1}constructor(N,ie){this.location=N,this.message=ie}static isEqual(N,ie){return N===ie?!0:!N||!ie?!1:N.message===ie.message&&N.location.range.isEqual(ie.location.range)&&N.location.uri.toString()===ie.location.uri.toString()}};ye=$e([O],ye),e.DiagnosticRelatedInformation=ye;let De=class{constructor(N,ie,we=Xe.Error){if(!z.isRange(N))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=N,this.message=ie,this.severity=we}toJSON(){return{severity:Xe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ie){return N===ie?!0:!N||!ie?!1:N.message===ie.message&&N.severity===ie.severity&&N.code===ie.code&&N.severity===ie.severity&&N.source===ie.source&&N.range.isEqual(ie.range)&&(0,r.equals)(N.tags,ie.tags)&&(0,r.equals)(N.relatedInformation,ie.relatedInformation,ye.isEqual)}};De=$e([O],De),e.Diagnostic=De;let ae=class{constructor(N,ie){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ie}};ae=$e([O],ae),e.Hover=ae;var ue;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(ue=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ee=class{constructor(N,ie=ue.Text){this.range=N,this.kind=ie}toJSON(){return{range:this.range,kind:ue[this.kind]}}};ee=$e([O],ee),e.DocumentHighlight=ee;var Z;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Z=e.SymbolKind||(e.SymbolKind={}));var k;(function(x){x[x.Deprecated=1]="Deprecated"})(k=e.SymbolTag||(e.SymbolTag={}));let B=o=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,ie,we,He,Qe){this.name=N,this.kind=ie,this.containerName=Qe,typeof we=="string"&&(this.containerName=we),He instanceof ke?this.location=He:we instanceof z&&(this.location=new ke(He,we)),o.validate(this)}toJSON(){return{name:this.name,kind:Z[this.kind],location:this.location,containerName:this.containerName}}};B=o=$e([O],B),e.SymbolInformation=B;let V=f=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(f.validate)}constructor(N,ie,we,He,Qe){this.name=N,this.detail=ie,this.kind=we,this.range=He,this.selectionRange=Qe,this.children=[],f.validate(this)}};V=f=$e([O],V),e.DocumentSymbol=V;var q;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(q=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let oe=class{constructor(N,ie){this.title=N,this.kind=ie}};oe=$e([O],oe),e.CodeAction=oe;let ce=v=class{constructor(N){this.value=N}append(N){return new v(this.value?this.value+v.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+v.sep)}};ce.sep=".",ce=v=$e([O],ce),e.CodeActionKind=ce,ce.Empty=new ce(""),ce.QuickFix=ce.Empty.append("quickfix"),ce.Refactor=ce.Empty.append("refactor"),ce.RefactorExtract=ce.Refactor.append("extract"),ce.RefactorInline=ce.Refactor.append("inline"),ce.RefactorMove=ce.Refactor.append("move"),ce.RefactorRewrite=ce.Refactor.append("rewrite"),ce.Source=ce.Empty.append("source"),ce.SourceOrganizeImports=ce.Source.append("organizeImports"),ce.SourceFixAll=ce.Source.append("fixAll");let J=class{constructor(N,ie){if(this.range=N,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};J=$e([O],J),e.SelectionRange=J;class Ee{constructor(N,ie,we,He,Qe,lt){this.kind=N,this.name=ie,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=lt}}e.CallHierarchyItem=Ee;class ve{constructor(N,ie){this.fromRanges=ie,this.from=N}}e.CallHierarchyIncomingCall=ve;class Ne{constructor(N,ie){this.fromRanges=ie,this.to=N}}e.CallHierarchyOutgoingCall=Ne;var ze;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor(N,ie){this.range=N,this.command=ie}get isResolved(){return!!this.command}};Je=$e([O],Je),e.CodeLens=Je;let Ge=T=class{static isMarkdownString(N){return N instanceof T?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,ie=!1){l.set(this,void 0),Ye(this,l,new w.MarkdownString(N,{supportThemeIcons:ie}),"f")}get value(){return Oe(this,l,"f").value}set value(N){Oe(this,l,"f").value=N}get isTrusted(){return Oe(this,l,"f").isTrusted}set isTrusted(N){Oe(this,l,"f").isTrusted=N}get supportThemeIcons(){return Oe(this,l,"f").supportThemeIcons}set supportThemeIcons(N){Oe(this,l,"f").supportThemeIcons=N}get supportHtml(){return Oe(this,l,"f").supportHtml}set supportHtml(N){Oe(this,l,"f").supportHtml=N}get baseUri(){return Oe(this,l,"f").baseUri}set baseUri(N){Oe(this,l,"f").baseUri=N}appendText(N){return Oe(this,l,"f").appendText(N),this}appendMarkdown(N){return Oe(this,l,"f").appendMarkdown(N),this}appendCodeblock(N,ie){return Oe(this,l,"f").appendCodeblock(ie??"",N),this}};l=new WeakMap,Ge=T=$e([O],Ge),e.MarkdownString=Ge;let Pe=class{constructor(N,ie){this.label=N,this.documentation=ie}};Pe=$e([O],Pe),e.ParameterInformation=Pe;let nt=class{constructor(N,ie){this.label=N,this.documentation=ie,this.parameters=[]}};nt=$e([O],nt),e.SignatureInformation=nt;let X=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};X=$e([O],X),e.SignatureHelp=X;var Y;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(Y=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var me;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(me=e.InlayHintKind||(e.InlayHintKind={}));let Ue=class{constructor(N){this.value=N}};Ue=$e([O],Ue),e.InlayHintLabelPart=Ue;let Ve=class{constructor(N,ie,we){this.position=N,this.label=ie,this.kind=we}};Ve=$e([O],Ve),e.InlayHint=Ve;var et;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(et=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var je;(function(x){x[x.Deprecated=1]="Deprecated"})(je=e.CompletionItemTag||(e.CompletionItemTag={}));let it=class{constructor(N,ie){this.label=N,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};it=$e([O],it),e.CompletionItem=it;let st=class{constructor(N=[],ie=!1){this.items=N,this.isIncomplete=ie}};st=$e([O],st),e.CompletionList=st;let ct=class{constructor(N,ie,we){this.insertText=N,this.range=ie,this.command=we}};ct=$e([O],ct),e.InlineSuggestion=ct;let at=class{constructor(N){this.commands=void 0,this.items=N}};at=$e([O],at),e.InlineSuggestionList=at;let rt=class{constructor(N,ie,we){this.insertText=N,this.range=ie,this.command=we}};rt=$e([O],rt),e.InlineSuggestionNew=rt;let _t=class{constructor(N,ie){this.items=N,this.commands=ie}};_t=$e([O],_t),e.InlineSuggestionsNew=_t;var Rt;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Rt=e.ViewColumn||(e.ViewColumn={}));var Ot;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Ot=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Dt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Dt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Mt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Mt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Lt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(Lt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var qe;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(qe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var zt;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(zt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function N(ie){switch(ie){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=N}(Lt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(N,ie){if(ie&&!P.URI.isUri(ie))throw(0,C.illegalArgument)("target");if(!z.isRange(N)||N.isEmpty)throw(0,C.illegalArgument)("range");this.range=N,this.target=ie}};Ft=$e([O],Ft),e.DocumentLink=Ft;let Tt=class{constructor(N,ie,we,He){this.red=N,this.green=ie,this.blue=we,this.alpha=He}};Tt=$e([O],Tt),e.Color=Tt;let mt=class{constructor(N,ie){if(ie&&!(ie instanceof Tt))throw(0,C.illegalArgument)("color");if(!z.isRange(N)||N.isEmpty)throw(0,C.illegalArgument)("range");this.range=N,this.color=ie}};mt=$e([O],mt),e.ColorInformation=mt;let Ct=class{constructor(N){if(!N||typeof N!="string")throw(0,C.illegalArgument)("label");this.label=N}};Ct=$e([O],Ct),e.ColorPresentation=Ct;var _e;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(_e=e.ColorFormat||(e.ColorFormat={}));var Te;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Te=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ge;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(ge=e.TerminalExitReason||(e.TerminalExitReason={}));class K{constructor(N,ie,we){if(this.startIndex=N,this.length=ie,this.tooltip=we,typeof N!="number"||N<0)throw(0,C.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,C.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,C.illegalArgument)("tooltip")}}e.TerminalLink=K;var Ae;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(Ae=e.TerminalLocation||(e.TerminalLocation={}));class Le{constructor(N){if(this.options=N,typeof N!="object")throw(0,C.illegalArgument)("options")}}e.TerminalProfile=Le;var Ze;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(Ze=e.TaskRevealKind||(e.TaskRevealKind={}));var We;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(We=e.TaskPanelKind||(e.TaskPanelKind={}));let tt=M=class{static from(N){switch(N){case"clean":return M.Clean;case"build":return M.Build;case"rebuild":return M.Rebuild;case"test":return M.Test;default:return}}constructor(N,ie){if(this.label=ie,typeof N!="string"||typeof ie!="string")throw(0,C.illegalArgument)("name");this._id=N}get id(){return this._id}};tt.Clean=new M("clean","Clean"),tt.Build=new M("build","Build"),tt.Rebuild=new M("rebuild","Rebuild"),tt.Test=new M("test","Test"),tt=M=$e([O],tt),e.TaskGroup=tt;function gt(x){let N="";for(let ie=0;ie<x.length;ie++)N+=x[ie].replace(/,/g,",,")+",";return N}let vt=class{constructor(N,ie,we){if(typeof N!="string")throw(0,C.illegalArgument)("process");this._args=[],this._process=N,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=we):this._options=ie)}get process(){return this._process}set process(N){if(typeof N!="string")throw(0,C.illegalArgument)("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(const ie of this._args)N.push(ie);return gt(N)}};vt=$e([O],vt),e.ProcessExecution=vt;let It=class{constructor(N,ie,we){if(this._args=[],Array.isArray(ie)){if(!N)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,C.illegalArgument)("command");this._command=N,this._args=ie,this._options=we}else{if(typeof N!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=N,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,C.illegalArgument)("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ie of this._args)N.push(typeof ie=="string"?ie:ie.value);return gt(N)}};It=$e([O],It),e.ShellExecution=It;var yt;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(yt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class pt{constructor(N){this._callback=N}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=pt;let wt=j=class{constructor(N,ie,we,He,Qe,lt){this.__deprecated=!1,this._definition=this.definition=N;let dt;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=we,this.execution=He,dt=Qe,this.__deprecated=!0):ie===Et.Global||ie===Et.Workspace?(this.target=ie,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,dt=lt):(this.target=ie,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,dt=lt),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof vt?this._definition={type:j.ProcessType,id:this._execution.computeId()}:this._execution instanceof It?this._definition={type:j.ShellType,id:this._execution.computeId()}:this._execution instanceof pt?this._definition={type:j.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:j.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(N){if(N==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw(0,C.illegalArgument)("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const ie=this._definition.type;(j.EmptyType===ie||j.ProcessType===ie||j.ShellType===ie||j.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};wt.ExtensionCallbackType="customExecution",wt.ProcessType="process",wt.ShellType="shell",wt.EmptyType="$empty",wt=j=$e([O],wt),e.Task=wt;var ei;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(ei=e.ProgressLocation||(e.ProgressLocation={}));var bt;(function(x){function N(ie){const we=ie;return(0,E.isNumber)(we.value)?we.tooltip&&!(0,E.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}x.isViewBadge=N})(bt=e.ViewBadge||(e.ViewBadge={}));let qt=U=class{static isTreeItem(N,ie){if(N instanceof U)return!0;const we=N;if(we.label!==void 0&&!(0,E.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,E.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,E.isString)(we.iconPath)&&!P.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,E.isString)(we.iconPath.id))){const He=we.iconPath;if(!He||!(0,E.isString)(He.light)&&!P.URI.isUri(He.light)&&!(0,E.isString)(He.dark)&&!P.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,E.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!P.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,E.isString)(we.tooltip)&&!(we.tooltip instanceof Ge))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<xt.None&&we.collapsibleState>xt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,E.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,p.checkProposedApiEnabled)(ie,"treeItemCheckbox");const He=(0,E.isNumber)(we.checkboxState)?we.checkboxState:(0,E.isObject)(we.checkboxState)&&(0,E.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,Qe=!(0,E.isNumber)(we.checkboxState)&&(0,E.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(He===void 0||He!==ti.Checked&&He!==ti.Unchecked||Qe!==void 0&&!(0,E.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(N,ie=xt.None){this.collapsibleState=ie,P.URI.isUri(N)?this.resourceUri=N:this.label=N}};qt=U=$e([O],qt),e.TreeItem=qt;var xt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(xt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var ti;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(ti=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ci=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N,ie){this.value=N,this.id=ie??(0,R.generateUuid)()}};ci=$e([O],ci),e.DataTransferItem=ci;let kt=class{constructor(N){d.set(this,new Map);for(const[ie,we]of N??[]){const He=Oe(this,d,"f").get(ie);He?He.push(we):Oe(this,d,"f").set(ie,[we])}}get(N){return Oe(this,d,"f").get(N)?.[0]}set(N,ie){Oe(this,d,"f").set(N,[ie])}forEach(N,ie){for(const[we,He]of Oe(this,d,"f"))for(const Qe of He)N.call(ie,Qe,we,this)}*[(d=new WeakMap,Symbol.iterator)](){for(const[N,ie]of Oe(this,d,"f"))for(const we of ie)yield[N,we]}};kt=$e([O],kt),e.DataTransfer=kt;let ii=class{constructor(N){this.insertText=N}};ii=$e([O],ii),e.DocumentDropEdit=ii;let ui=class{constructor(N){this.insertText=N}};ui=$e([O],ui),e.DocumentPasteEdit=ui;let Ut=class{constructor(N,ie){this.id=N,this.color=ie}};Ut=$e([O],Ut),e.ThemeIcon=Ut,Ut.File=new Ut("file"),Ut.Folder=new Ut("folder");let Jt=class{constructor(N){this.id=N}};Jt=$e([O],Jt),e.ThemeColor=Jt;var ut;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let di=class{get base(){return this._base}set base(N){this._base=N,this._baseUri=P.URI.file(N)}get baseUri(){return this._baseUri}set baseUri(N){this._baseUri=N,this._base=N.fsPath}constructor(N,ie){if(typeof N!="string"&&(!N||!P.URI.isUri(N)&&!P.URI.isUri(N.uri)))throw(0,C.illegalArgument)("base");if(typeof ie!="string")throw(0,C.illegalArgument)("pattern");typeof N=="string"?this.baseUri=P.URI.file(N):P.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};di=$e([O],di),e.RelativePattern=di;let Nt=class{constructor(N,ie,we,He){this.enabled=typeof N=="boolean"?N:!0,typeof ie=="string"&&(this.condition=ie),typeof we=="string"&&(this.hitCondition=we),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Nt=$e([O],Nt),e.Breakpoint=Nt;let Kt=class extends Nt{constructor(N,ie,we,He,Qe){if(super(ie,we,He,Qe),N===null)throw(0,C.illegalArgument)("location");this.location=N}};Kt=$e([O],Kt),e.SourceBreakpoint=Kt;let ni=class extends Nt{constructor(N,ie,we,He,Qe){super(ie,we,He,Qe),this.functionName=N}};ni=$e([O],ni),e.FunctionBreakpoint=ni;let hi=class extends Nt{constructor(N,ie,we,He,Qe,lt,dt){if(super(He,Qe,lt,dt),!ie)throw(0,C.illegalArgument)("dataId");this.label=N,this.dataId=ie,this.canPersist=we}};hi=$e([O],hi),e.DataBreakpoint=hi;let ri=class{constructor(N,ie,we){this.command=N,this.args=ie||[],this.options=we}};ri=$e([O],ri),e.DebugAdapterExecutable=ri;let fi=class{constructor(N,ie){this.port=N,this.host=ie}};fi=$e([O],fi),e.DebugAdapterServer=fi;let si=class{constructor(N){this.path=N}};si=$e([O],si),e.DebugAdapterNamedPipeServer=si;let Zt=class{constructor(N){this.implementation=N}};Zt=$e([O],Zt),e.DebugAdapterInlineImplementation=Zt;let mi=class{constructor(N,ie){this.range=N,this.expression=ie}};mi=$e([O],mi),e.EvaluatableExpression=mi;var gi;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(gi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var pi;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(pi=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let vi=class{constructor(N,ie){this.range=N,this.text=ie}};vi=$e([O],vi),e.InlineValueText=vi;let Ei=class{constructor(N,ie,we=!0){this.range=N,this.variableName=ie,this.caseSensitiveLookup=we}};Ei=$e([O],Ei),e.InlineValueVariableLookup=Ei;let Gt=class{constructor(N,ie){this.range=N,this.expression=ie}};Gt=$e([O],Gt),e.InlineValueEvaluatableExpression=Gt;let bi=class{constructor(N,ie){this.frameId=N,this.stoppedLocation=ie}};bi=$e([O],bi),e.InlineValueContext=bi;var Ni;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Ni=e.FileChangeType||(e.FileChangeType={}));let wi=D=class extends Error{static FileExists(N){return new D(N,b.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(N){return new D(N,b.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(N){return new D(N,b.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(N){return new D(N,b.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(N){return new D(N,b.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(N){return new D(N,b.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}constructor(N,ie=b.FileSystemProviderErrorCode.Unknown,we){super(P.URI.isUri(N)?N.toString(!0):N),this.code=we?.name??"Unknown",(0,b.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};wi=D=$e([O],wi),e.FileSystemError=wi;let Si=class{constructor(N,ie,we){this.start=N,this.end=ie,this.kind=we}};Si=$e([O],Si),e.FoldingRange=Si;var _i;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(_i=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ti;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Ti=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ki;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(ki=e.CommentMode||(e.CommentMode={}));var Me;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Me=e.CommentThreadState||(e.CommentThreadState={}));class Ht{constructor(N,ie=[]){this.tokenTypes=N,this.tokenModifiers=ie}}e.SemanticTokensLegend=Ht;function Pi(x){return typeof x>"u"||(0,E.isStringArray)(x)}class ht{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let ie=0,we=N.tokenTypes.length;ie<we;ie++)this._tokenTypeStrToInt.set(N.tokenTypes[ie],ie);for(let ie=0,we=N.tokenModifiers.length;ie<we;ie++)this._tokenModifierStrToInt.set(N.tokenModifiers[ie],ie)}}push(N,ie,we,He,Qe){if(typeof N=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof He=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this._pushEncoded(N,ie,we,He,Qe);if(z.isRange(N)&&typeof ie=="string"&&Pi(we))return this._push(N,ie,we);throw(0,C.illegalArgument)()}_push(N,ie,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const He=N.start.line,Qe=N.start.character,lt=N.end.character-N.start.character,dt=this._tokenTypeStrToInt.get(ie);let At=0;if(we)for(const $t of we){if(!this._tokenModifierStrToInt.has($t))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get($t);At|=1<<Wt>>>0}this._pushEncoded(He,Qe,lt,dt,At)}_pushEncoded(N,ie,we,He,Qe){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const At=this._data.length/5|0;let $t=0,Wt=0;for(let jt=0;jt<At;jt++){let Qt=this._data[5*jt],Ci=this._data[5*jt+1];Qt===0?(Qt=$t,Ci+=Wt):Qt+=$t,this._data[5*jt]=Qt,this._data[5*jt+1]=Ci,$t=Qt,Wt=Ci}}let lt=N,dt=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=we,this._data[this._dataLen++]=He,this._data[this._dataLen++]=Qe,this._prevLine=N,this._prevChar=ie}static _sortAndDeltaEncode(N){const ie=[],we=N.length/5|0;for(let dt=0;dt<we;dt++)ie[dt]=dt;ie.sort((dt,At)=>{const $t=N[5*dt],Wt=N[5*At];if($t===Wt){const jt=N[5*dt+1],Qt=N[5*At+1];return jt-Qt}return $t-Wt});const He=new Uint32Array(N.length);let Qe=0,lt=0;for(let dt=0;dt<we;dt++){const At=5*ie[dt],$t=N[At+0],Wt=N[At+1],jt=N[At+2],Qt=N[At+3],Ci=N[At+4],Yi=$t-Qe,Cn=Yi===0?Wt-lt:Wt,Ii=5*dt;He[Ii+0]=Yi,He[Ii+1]=Cn,He[Ii+2]=jt,He[Ii+3]=Qt,He[Ii+4]=Ci,Qe=$t,lt=Wt}return He}build(N){return this._dataIsSortedAndDeltaEncoded?new yi(new Uint32Array(this._data),N):new yi(ht._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=ht;class yi{constructor(N,ie){this.resultId=ie,this.data=N}}e.SemanticTokens=yi;class Mi{constructor(N,ie,we){this.start=N,this.deleteCount=ie,this.data=we}}e.SemanticTokensEdit=Mi;class Ai{constructor(N,ie){this.resultId=ie,this.edits=N}}e.SemanticTokensEdits=Ai;var Li;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Li=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new Ut("arrow-left")},Xt=$e([O],Xt),e.QuickInputButtons=Xt;var Ui;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(Ui=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Bi;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Bi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var zi;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(zi=e.ExtensionKind||(e.ExtensionKind={}));class Ri{static validate(N){if(N.badge){let ie=(0,A.nextCharLength)(N.badge,0);if(ie<N.badge.length&&(ie+=(0,A.nextCharLength)(N.badge,ie)),N.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,ie,we){this.badge=N,this.tooltip=ie,this.color=we}}e.FileDecoration=Ri;let Di=class{constructor(N){this.kind=N}};Di=$e([O],Di),e.ColorTheme=Di;var $i;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})($i=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{static isNotebookRange(N){return N instanceof Vt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(N,ie){if(N<0)throw(0,C.illegalArgument)("start must be positive");if(ie<0)throw(0,C.illegalArgument)("end must be positive");N<=ie?(this._start=N,this._end=ie):(this._start=ie,this._end=N)}with(N){let ie=this._start,we=this._end;return N.start!==void 0&&(ie=N.start),N.end!==void 0&&(we=N.end),ie===this._start&&we===this._end?this:new Vt(ie,we)}}e.NotebookRange=Vt;class oi{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ie=>oi.isNotebookCellData(ie))}static isNotebookCellData(N){return!0}constructor(N,ie,we,He,Qe,lt,dt){this.kind=N,this.value=ie,this.languageId=we,this.mime=He,this.outputs=Qe??[],this.metadata=lt,this.executionSummary=dt,oi.validate(this)}}e.NotebookCellData=oi;class xi{constructor(N){this.cells=N}}e.NotebookData=xi;class Bt{static isNotebookCellOutputItem(N){return N instanceof Bt?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ie={name:N.name,message:N.message,stack:N.stack};return Bt.json(ie,"application/vnd.code.notebook.error")}static stdout(N){return Bt.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Bt.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ie="application/octet-stream"){return new Bt(N,ie)}static text(N,ie=y.Mimes.text){const we=Oe(Bt,m,"f",S).encode(String(N));return new Bt(we,ie)}static json(N,ie="text/x-json"){const we=JSON.stringify(N,void 0,"	");return Bt.text(we,ie)}constructor(N,ie){this.data=N,this.mime=ie;const we=(0,y.normalizeMimeType)(ie,!0);if(!we)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.NotebookCellOutputItem=Bt,m=Bt,S={value:new TextEncoder};class se{static isNotebookCellOutput(N){return N instanceof se?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ie=!1){const we=new Set,He=new Set;for(let Qe=0;Qe<N.length;Qe++){const lt=N[Qe],dt=(0,y.normalizeMimeType)(lt.mime);if(!we.has(dt)||(0,I.isTextStreamMime)(dt)){we.add(dt);continue}He.add(Qe),ie&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return He.size===0?N:N.filter((Qe,lt)=>!He.has(lt))}constructor(N,ie,we){this.items=se.ensureUniqueMimeTypes(N,!0),typeof ie=="string"?(this.id=ie,this.metadata=we):(this.id=(0,R.generateUuid)(),this.metadata=ie??we)}}e.NotebookCellOutput=se;var de;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(de=e.NotebookCellKind||(e.NotebookCellKind={}));var Re;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Re=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ot;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(ot=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var St;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(St=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Pt{constructor(N,ie){this.text=N,this.alignment=ie}}e.NotebookCellStatusBarItem=Pt;var tn;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(tn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var nn;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(nn=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class rn{constructor(N,ie=[]){this.uri=N,this.provides=(0,r.asArray)(ie)}}e.NotebookRendererScript=rn;let Wi=class{constructor(N,ie){this.label=N,this.timestamp=ie}};Wi=$e([O],Wi),e.TimelineItem=Wi;var sn;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(sn=e.ExtensionMode||(e.ExtensionMode={}));var on;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(on=e.ExtensionRuntime||(e.ExtensionRuntime={}));var an;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(an=e.StandardTokenType||(e.StandardTokenType={}));class ln{constructor(N,ie){this.ranges=N,this.wordPattern=ie}}e.LinkedEditingRanges=ln;class cn{constructor(N,ie){this._port=N,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=cn;var un;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(un=e.TestResultState||(e.TestResultState={}));var dn;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(dn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Hi=class{constructor(N=void 0,ie=void 0,we=void 0){this.include=N,this.exclude=ie,this.profile=we}};Hi=$e([O],Hi),e.TestRunRequest=Hi;let Vi=$=class{static diff(N,ie,we){const He=new $(N);return He.expectedOutput=ie,He.actualOutput=we,He}constructor(N){this.message=N}};Vi=$=$e([O],Vi),e.TestMessage=Vi;let ji=class{constructor(N){this.id=N}};ji=$e([O],ji),e.TestTag=ji;let ai=class{constructor(N,ie){this.covered=N,this.total=ie}};ai=$e([O],ai),e.CoveredCount=ai;let qi=L=class{static fromDetails(N,ie){const we=new ai(0,0),He=new ai(0,0),Qe=new ai(0,0);for(const dt of ie)if("branches"in dt){we.total+=1,we.covered+=dt.executionCount>0?1:0;for(const At of dt.branches)He.total+=1,He.covered+=At.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=dt.executionCount>0?1:0;const lt=new L(N,we,He.total>0?He:void 0,Qe.total>0?Qe:void 0);return lt.detailedCoverage=ie,lt}constructor(N,ie,we,He){this.uri=N,this.statementCoverage=ie,this.branchCoverage=we,this.functionCoverage=He}};qi=L=$e([O],qi),e.FileCoverage=qi;let Ki=class{constructor(N,ie,we=[]){this.executionCount=N,this.location=ie,this.branches=we}};Ki=$e([O],Ki),e.StatementCoverage=Ki;let Gi=class{constructor(N,ie){this.executionCount=N,this.location=ie}};Gi=$e([O],Gi),e.BranchCoverage=Gi;let Xi=class{constructor(N,ie){this.executionCount=N,this.location=ie}};Xi=$e([O],Xi),e.FunctionCoverage=Xi;var hn;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fn;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(fn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mn;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(mn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gn{constructor(N,ie,we,He,Qe,lt){this.kind=N,this.name=ie,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=lt}}e.TypeHierarchyItem=gn;class pn{constructor(N){this.uri=N}}e.TextTabInput=pn;class vn{constructor(N,ie){this.original=N,this.modified=ie}}e.TextDiffTabInput=vn;class En{constructor(N,ie,we,He){this.base=N,this.input1=ie,this.input2=we,this.result=He}}e.TextMergeTabInput=En;class bn{constructor(N,ie){this.uri=N,this.viewType=ie}}e.CustomEditorTabInput=bn;class wn{constructor(N){this.viewType=N}}e.WebviewEditorTabInput=wn;class Sn{constructor(N,ie){this.uri=N,this.notebookType=ie}}e.NotebookEditorTabInput=Sn;class _n{constructor(N,ie,we){this.original=N,this.modified=ie,this.notebookType=we}}e.NotebookDiffEditorTabInput=_n;class yn{constructor(){}}e.TerminalEditorTabInput=yn;class Dn{constructor(N,ie){this.uri=N,this.inputBoxUri=ie}}e.InteractiveWindowInput=Dn}),define(Ce[93],Ie([1,0,46,13,9,245,123,6,18]),function(ne,e,r,C,w,F,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function R(p,a){a?P.set(p,a):P.delete(p)}e.setWordDefinitionFor=R;function b(p){return P.get(p)}e.getWordDefinitionFor=b;class g extends F.MirrorTextModel{constructor(a,l,d,m,S,c,_,t){super(l,d,m,S),this._proxy=a,this._languageId=c,this._isDirty=_,this.notebook=t,this._isDisposed=!1}dispose(){(0,r.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,E.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===C.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},save(){return a._save()},getText(l){return l?a._getTextInRange(l):a.getText()},get eol(){return a._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(l){return a._lineAt(l)},offsetAt(l){return a._offsetAt(l)},positionAt(l){return a._positionAt(l)},validateRange(l){return a._validateRange(l)},validatePosition(l){return a._validatePosition(l)},getWordRangeAtPosition(l,d){return a._getWordRangeAtPosition(l,d)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,r.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,r.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const l=this._validateRange(a);if(l.isEmpty)return"";if(l.isSingleLine)return this._lines[l.start.line].substring(l.start.character,l.end.character);const d=this._eol,m=l.start.line,S=l.end.line,c=[];c.push(this._lines[m].substring(l.start.character));for(let _=m+1;_<S;_++)c.push(this._lines[_]);return c.push(this._lines[S].substring(0,l.end.character)),c.join(d)}_lineAt(a){let l;if(a instanceof A.Position?l=a.line:typeof a=="number"&&(l=a),typeof l!="number"||l<0||l>=this._lines.length||Math.floor(l)!==l)throw new Error("Illegal value for `line`");return new I(l,this._lines[l],l===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const l=this._lineStarts.getIndexOf(a),d=this._lines[l.index].length;return new A.Position(l.index,Math.min(l.remainder,d))}_validateRange(a){if(!(a instanceof A.Range))throw new Error("Invalid argument");const l=this._validatePosition(a.start),d=this._validatePosition(a.end);return l===a.start&&d===a.end?a:new A.Range(l.line,l.character,d.line,d.character)}_validatePosition(a){if(!(a instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:l,character:d}=a,m=!1;if(l<0)l=0,d=0,m=!0;else if(l>=this._lines.length)l=this._lines.length-1,d=this._lines[l].length,m=!0;else{const S=this._lines[l].length;d<0?(d=0,m=!0):d>S&&(d=S,m=!0)}return m?new A.Position(l,d):a}_getWordRangeAtPosition(a,l){const d=this._validatePosition(a);if(!l)l=b(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(l))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${l.source}' because it matches the empty string.`);const m=(0,y.getWordAtText)(d.character+1,(0,y.ensureValidWordDefinition)(l),this._lines[d.line],0);if(m)return new A.Range(d.line,m.startColumn-1,d.line,m.endColumn-1)}}e.ExtHostDocumentData=g;class I{constructor(a,l,d){this._line=a,this._text=l,this._isLastLine=d}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=I}),define(Ce[180],Ie([1,0,6,14,4]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let F=class{constructor(A){this._actual=new r.ColorTheme(r.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let E;switch(A){case"light":E=r.ColorThemeKind.Light;break;case"hcDark":E=r.ColorThemeKind.HighContrast;break;case"hcLight":E=r.ColorThemeKind.HighContrastLight;break;default:E=r.ColorThemeKind.Dark}this._actual=new r.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};F=$e([xe(0,C.IExtHostRpcService)],F),e.ExtHostTheming=F}),define(Ce[8],Ie([1,0,18,23,79,25,106,78,24,10,2,51,68,84,90,89,65,41,50,175,6,181]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a,l,d,m,S,c,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var t;(function(_e){function Te(K){const{selectionStartLineNumber:Ae,selectionStartColumn:Le,positionLineNumber:Ze,positionColumn:We}=K,tt=new c.Position(Ae-1,Le-1),gt=new c.Position(Ze-1,We-1);return new c.Selection(tt,gt)}_e.to=Te;function ge(K){const{anchor:Ae,active:Le}=K;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}_e.from=ge})(t=e.Selection||(e.Selection={}));var u;(function(_e){function Te(K){if(!K)return;const{start:Ae,end:Le}=K;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}_e.from=Te;function ge(K){if(!K)return;const{startLineNumber:Ae,startColumn:Le,endLineNumber:Ze,endColumn:We}=K;return new c.Range(Ae-1,Le-1,Ze-1,We-1)}_e.to=ge})(u=e.Range||(e.Range={}));var i;(function(_e){function Te(ge){switch(ge){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}_e.to=Te})(i=e.TokenType||(e.TokenType={}));var n;(function(_e){function Te(K){return new c.Position(K.lineNumber-1,K.column-1)}_e.to=Te;function ge(K){return{lineNumber:K.line+1,column:K.character+1}}_e.from=ge})(n=e.Position||(e.Position={}));var s;(function(_e){function Te(Ae,Le){return(0,r.coalesce)((0,r.asArray)(Ae).map(Ze=>ge(Ze,Le)))}_e.from=Te;function ge(Ae,Le){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:K(Ae.scheme,Le),pattern:me.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function K(Ae,Le){return Le&&typeof Ae=="string"?Le.transformOutgoingScheme(Ae):Ae}})(s=e.DocumentSelector||(e.DocumentSelector={}));var h;(function(_e){function Te(K){switch(K){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}_e.from=Te;function ge(K){switch(K){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}_e.to=ge})(h=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(_e){function Te(K){let Ae;return K.code&&((0,P.isString)(K.code)||(0,P.isNumber)(K.code)?Ae=String(K.code):Ae={value:String(K.code.value),target:K.code.target}),{...u.from(K.range),message:K.message,source:K.source,code:Ae,severity:v.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(f.from),tags:Array.isArray(K.tags)?(0,r.coalesce)(K.tags.map(h.from)):void 0}}_e.from=Te;function ge(K){const Ae=new c.Diagnostic(u.to(K),K.message,v.to(K.severity));return Ae.source=K.source,Ae.code=(0,P.isString)(K.code)?K.code:K.code?.value,Ae.relatedInformation=K.relatedInformation&&K.relatedInformation.map(f.to),Ae.tags=K.tags&&(0,r.coalesce)(K.tags.map(h.to)),Ae}_e.to=ge})(o=e.Diagnostic||(e.Diagnostic={}));var f;(function(_e){function Te(K){return{...u.from(K.location.range),message:K.message,resource:K.location.uri}}_e.from=Te;function ge(K){return new c.DiagnosticRelatedInformation(new c.Location(K.resource,u.to(K)),K.message)}_e.to=ge})(f=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var v;(function(_e){function Te(K){switch(K){case c.DiagnosticSeverity.Error:return I.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return I.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return I.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return I.MarkerSeverity.Hint}return I.MarkerSeverity.Error}_e.from=Te;function ge(K){switch(K){case I.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case I.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case I.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case I.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}_e.to=ge})(v=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var T;(function(_e){function Te(K){return typeof K=="number"&&K>=c.ViewColumn.One?K-1:K===c.ViewColumn.Beside?S.SIDE_GROUP:S.ACTIVE_GROUP}_e.from=Te;function ge(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=ge})(T=e.ViewColumn||(e.ViewColumn={}));function M(_e){return typeof _e.range<"u"}function j(_e){return _e.length===0?!0:!!M(_e[0])}e.isDecorationOptionsArr=j;var U;(function(_e){function Te(We){return We.map(_e.from)}_e.fromMany=Te;function ge(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function K(We){let tt;if(ge(We)){const{language:yt,value:Et}=We;tt={value:"```"+yt+`
`+Et+"\n```\n"}}else c.MarkdownString.isMarkdownString(We)?tt={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?tt={value:We}:tt={value:""};const gt=Object.create(null);tt.uris=gt;const vt=yt=>{try{let Et=R.URI.parse(yt,!0);Et=Et.with({query:Ae(Et.query,gt)}),gt[yt]=Et}catch{}return""},It=new y.marked.Renderer;return It.link=vt,It.image=yt=>typeof yt=="string"?vt(w.parseHrefAndDimensions(yt).href):"",(0,y.marked)(tt.value,{renderer:It}),tt}_e.from=K;function Ae(We,tt){if(!We)return We;let gt;try{gt=(0,A.parse)(We)}catch{}if(!gt)return We;let vt=!1;return gt=(0,E.cloneAndChange)(gt,It=>{if(R.URI.isUri(It)){const yt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[yt]=It,vt=!0,yt}else return}),vt?JSON.stringify(gt):We}function Le(We){const tt=new c.MarkdownString(We.value,We.supportThemeIcons);return tt.isTrusted=We.isTrusted,tt.supportHtml=We.supportHtml,tt.baseUri=We.baseUri?R.URI.from(We.baseUri):void 0,tt}_e.to=Le;function Ze(We){if(!!We)return typeof We=="string"?We:_e.from(We)}_e.fromStrict=Ze})(U=e.MarkdownString||(e.MarkdownString={}));function D(_e){return j(_e)?_e.map(Te=>({range:u.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?U.fromMany(Te.hoverMessage):Te.hoverMessage?U.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):_e.map(Te=>({range:u.from(Te)}))}e.fromRangeOrRangeWithMessage=D;function $(_e){return typeof _e>"u"?_e:typeof _e=="string"?R.URI.file(_e):_e}e.pathOrURIToURI=$;var L;(function(_e){function Te(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?$(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}_e.from=Te})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(_e){function Te(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?$(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?L.from(ge.before):void 0,after:ge.after?L.from(ge.after):void 0}}_e.from=Te})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var H;(function(_e){function Te(ge){if(typeof ge>"u")return ge;switch(ge){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=Te})(H=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(_e){function Te(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?H.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?O.from(ge.light):void 0,dark:ge.dark?O.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?$(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?L.from(ge.before):void 0,after:ge.after?L.from(ge.after):void 0}}_e.from=Te})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(_e){function Te(K){return{text:K.newText,eol:K.newEol&&Ge.from(K.newEol),range:u.from(K.range)}}_e.from=Te;function ge(K){const Ae=new c.TextEdit(u.to(K.range),K.text);return Ae.newEol=typeof K.eol>"u"?void 0:Ge.to(K.eol),Ae}_e.to=ge})(z=e.TextEdit||(e.TextEdit={}));var G;(function(_e){function Te(K,Ae){const Le={edits:[]};if(K instanceof c.WorkspaceEdit){const Ze=new F.ResourceSet;for(const We of K._allEntries())We._type===1&&R.URI.isUri(We.to)&&We.from===void 0&&Ze.add(We.to);for(const We of K._allEntries())We._type===1?Le.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contentsBase64:We.options?.contents&&(0,C.encodeBase64)(C.VSBuffer.wrap(We.options.contents))},metadata:We.metadata}):We._type===2?Le.edits.push({resource:We.uri,textEdit:z.from(We.edit),versionId:Ze.has(We.uri)?void 0:Ae?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Le.edits.push({resource:We.uri,textEdit:{range:u.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ze.has(We.uri)?void 0:Ae?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Le.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Le.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(st.from)}})}return Le}_e.from=Te;function ge(K){const Ae=new c.WorkspaceEdit;for(const Le of K.edits)Le.textEdit?Ae.replace(R.URI.revive(Le.resource),u.to(Le.textEdit.range),Le.textEdit.text):Ae.renameFile(R.URI.revive(Le.oldResource),R.URI.revive(Le.newResource),Le.options);return Ae}_e.to=ge})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var te;(function(_e){const Te=Object.create(null);Te[c.SymbolKind.File]=0,Te[c.SymbolKind.Module]=1,Te[c.SymbolKind.Namespace]=2,Te[c.SymbolKind.Package]=3,Te[c.SymbolKind.Class]=4,Te[c.SymbolKind.Method]=5,Te[c.SymbolKind.Property]=6,Te[c.SymbolKind.Field]=7,Te[c.SymbolKind.Constructor]=8,Te[c.SymbolKind.Enum]=9,Te[c.SymbolKind.Interface]=10,Te[c.SymbolKind.Function]=11,Te[c.SymbolKind.Variable]=12,Te[c.SymbolKind.Constant]=13,Te[c.SymbolKind.String]=14,Te[c.SymbolKind.Number]=15,Te[c.SymbolKind.Boolean]=16,Te[c.SymbolKind.Array]=17,Te[c.SymbolKind.Object]=18,Te[c.SymbolKind.Key]=19,Te[c.SymbolKind.Null]=20,Te[c.SymbolKind.EnumMember]=21,Te[c.SymbolKind.Struct]=22,Te[c.SymbolKind.Event]=23,Te[c.SymbolKind.Operator]=24,Te[c.SymbolKind.TypeParameter]=25;function ge(Ae){return typeof Te[Ae]=="number"?Te[Ae]:6}_e.from=ge;function K(Ae){for(const Le in Te)if(Te[Le]===Ae)return Number(Le);return c.SymbolKind.Property}_e.to=K})(te=e.SymbolKind||(e.SymbolKind={}));var he;(function(_e){function Te(K){switch(K){case c.SymbolTag.Deprecated:return 1}}_e.from=Te;function ge(K){switch(K){case 1:return c.SymbolTag.Deprecated}}_e.to=ge})(he=e.SymbolTag||(e.SymbolTag={}));var re;(function(_e){function Te(K){return{name:K.name,kind:te.from(K.kind),tags:K.tags&&K.tags.map(he.from),containerName:K.containerName,location:pe.from(K.location)}}_e.from=Te;function ge(K){const Ae=new c.SymbolInformation(K.name,te.to(K.kind),K.containerName,pe.to(K.location));return Ae.tags=K.tags&&K.tags.map(he.to),Ae}_e.to=ge})(re=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var be;(function(_e){function Te(K){const Ae={name:K.name||"!!MISSING: name!!",detail:K.detail,range:u.from(K.range),selectionRange:u.from(K.selectionRange),kind:te.from(K.kind),tags:K.tags?.map(he.from)??[]};return K.children&&(Ae.children=K.children.map(Te)),Ae}_e.from=Te;function ge(K){const Ae=new c.DocumentSymbol(K.name,K.detail,te.to(K.kind),u.to(K.range),u.to(K.selectionRange));return(0,r.isNonEmptyArray)(K.tags)&&(Ae.tags=K.tags.map(he.to)),K.children&&(Ae.children=K.children.map(ge)),Ae}_e.to=ge})(be=e.DocumentSymbol||(e.DocumentSymbol={}));var le;(function(_e){function Te(K){const Ae=new c.CallHierarchyItem(te.to(K.kind),K.name,K.detail||"",R.URI.revive(K.uri),u.to(K.range),u.to(K.selectionRange));return Ae._sessionId=K._sessionId,Ae._itemId=K._itemId,Ae}_e.to=Te;function ge(K,Ae,Le){if(Ae=Ae??K._sessionId,Le=Le??K._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,name:K.name,detail:K.detail,kind:te.from(K.kind),uri:K.uri,range:u.from(K.range),selectionRange:u.from(K.selectionRange),tags:K.tags?.map(he.from)}}_e.from=ge})(le=e.CallHierarchyItem||(e.CallHierarchyItem={}));var fe;(function(_e){function Te(ge){return new c.CallHierarchyIncomingCall(le.to(ge.from),ge.fromRanges.map(K=>u.to(K)))}_e.to=Te})(fe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Q;(function(_e){function Te(ge){return new c.CallHierarchyOutgoingCall(le.to(ge.to),ge.fromRanges.map(K=>u.to(K)))}_e.to=Te})(Q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var pe;(function(_e){function Te(K){return{range:K.range&&u.from(K.range),uri:K.uri}}_e.from=Te;function ge(K){return new c.Location(R.URI.revive(K.uri),u.to(K.range))}_e.to=ge})(pe=e.location||(e.location={}));var Se;(function(_e){function Te(K){const Ae=K,Le=K;return{originSelectionRange:Ae.originSelectionRange?u.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Le.uri,range:u.from(Ae.targetRange?Ae.targetRange:Le.range),targetSelectionRange:Ae.targetSelectionRange?u.from(Ae.targetSelectionRange):void 0}}_e.from=Te;function ge(K){return{targetUri:R.URI.revive(K.uri),targetRange:u.to(K.range),targetSelectionRange:K.targetSelectionRange?u.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?u.to(K.originSelectionRange):void 0}}_e.to=ge})(Se=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(_e){function Te(K){return{range:u.from(K.range),contents:U.fromMany(K.contents)}}_e.from=Te;function ge(K){return new c.Hover(K.contents.map(U.to),u.to(K.range))}_e.to=ge})(Fe=e.Hover||(e.Hover={}));var Be;(function(_e){function Te(K){return{range:u.from(K.range),expression:K.expression}}_e.from=Te;function ge(K){return new c.EvaluatableExpression(u.to(K.range),K.expression)}_e.to=ge})(Be=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Xe;(function(_e){function Te(K){if(K instanceof c.InlineValueText)return{type:"text",range:u.from(K.range),text:K.text};if(K instanceof c.InlineValueVariableLookup)return{type:"variable",range:u.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=Te;function ge(K){switch(K.type){case"text":return{range:u.to(K.range),text:K.text};case"variable":return{range:u.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:u.to(K.range),expression:K.expression}}}_e.to=ge})(Xe=e.InlineValue||(e.InlineValue={}));var ke;(function(_e){function Te(K){return{frameId:K.frameId,stoppedLocation:u.from(K.stoppedLocation)}}_e.from=Te;function ge(K){return new c.InlineValueContext(K.frameId,u.to(K.stoppedLocation))}_e.to=ge})(ke=e.InlineValueContext||(e.InlineValueContext={}));var ye;(function(_e){function Te(K){return{range:u.from(K.range),kind:K.kind}}_e.from=Te;function ge(K){return new c.DocumentHighlight(u.to(K.range),K.kind)}_e.to=ge})(ye=e.DocumentHighlight||(e.DocumentHighlight={}));var De;(function(_e){function Te(ge){switch(ge){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}_e.to=Te})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(_e){function Te(ge){return{triggerKind:De.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}_e.to=Te})(ae=e.CompletionContext||(e.CompletionContext={}));var ue;(function(_e){function Te(K){switch(K){case c.CompletionItemTag.Deprecated:return 1}}_e.from=Te;function ge(K){switch(K){case 1:return c.CompletionItemTag.Deprecated}}_e.to=ge})(ue=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(_e){const Te=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function ge(Le){return Te.get(Le)??9}_e.from=ge;const K=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Ae(Le){return K.get(Le)??c.CompletionItemKind.Property}_e.to=Ae})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var Z;(function(_e){function Te(ge,K){const Ae=new c.CompletionItem(ge.label);return Ae.insertText=ge.insertText,Ae.kind=ee.to(ge.kind),Ae.tags=ge.tags?.map(ue.to),Ae.detail=ge.detail,Ae.documentation=w.isMarkdownString(ge.documentation)?U.to(ge.documentation):ge.documentation,Ae.sortText=ge.sortText,Ae.filterText=ge.filterText,Ae.preselect=ge.preselect,Ae.commitCharacters=ge.commitCharacters,b.Range.isIRange(ge.range)?Ae.range=u.to(ge.range):typeof ge.range=="object"&&(Ae.range={inserting:u.to(ge.range.insert),replacing:u.to(ge.range.replace)}),Ae.keepWhitespace=typeof ge.insertTextRules>"u"?!1:Boolean(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Ae.insertText=new c.SnippetString(ge.insertText):(Ae.insertText=ge.insertText,Ae.textEdit=Ae.range instanceof c.Range?new c.TextEdit(Ae.range,Ae.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ge.additionalTextEdits.map(Le=>z.to(Le))),Ae.command=K&&ge.command?K.fromInternal(ge.command):void 0,Ae}_e.to=Te})(Z=e.CompletionItem||(e.CompletionItem={}));var k;(function(_e){function Te(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:U.fromStrict(K.documentation)}}_e.from=Te;function ge(K){return{label:K.label,documentation:w.isMarkdownString(K.documentation)?U.to(K.documentation):K.documentation}}_e.to=ge})(k=e.ParameterInformation||(e.ParameterInformation={}));var B;(function(_e){function Te(K){return{label:K.label,documentation:U.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(k.from):[],activeParameter:K.activeParameter}}_e.from=Te;function ge(K){return{label:K.label,documentation:w.isMarkdownString(K.documentation)?U.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(k.to):[],activeParameter:K.activeParameter}}_e.to=ge})(B=e.SignatureInformation||(e.SignatureInformation={}));var V;(function(_e){function Te(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(B.from):[]}}_e.from=Te;function ge(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(B.to):[]}}_e.to=ge})(V=e.SignatureHelp||(e.SignatureHelp={}));var q;(function(_e){function Te(ge,K){const Ae=new c.InlayHint(n.to(K.position),typeof K.label=="string"?K.label:K.label.map(oe.to.bind(void 0,ge)),K.kind&&ce.to(K.kind));return Ae.textEdits=K.textEdits&&K.textEdits.map(z.to),Ae.tooltip=w.isMarkdownString(K.tooltip)?U.to(K.tooltip):K.tooltip,Ae.paddingLeft=K.paddingLeft,Ae.paddingRight=K.paddingRight,Ae}_e.to=Te})(q=e.InlayHint||(e.InlayHint={}));var oe;(function(_e){function Te(ge,K){const Ae=new c.InlayHintLabelPart(K.label);return Ae.tooltip=w.isMarkdownString(K.tooltip)?U.to(K.tooltip):K.tooltip,g.Command.is(K.command)&&(Ae.command=ge.fromInternal(K.command)),K.location&&(Ae.location=pe.to(K.location)),Ae}_e.to=Te})(oe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ce;(function(_e){function Te(K){return K}_e.from=Te;function ge(K){return K}_e.to=ge})(ce=e.InlayHintKind||(e.InlayHintKind={}));var J;(function(_e){function Te(K){return{range:u.from(K.range),url:K.target,tooltip:K.tooltip}}_e.from=Te;function ge(K){let Ae;if(K.url)try{Ae=typeof K.url=="string"?R.URI.parse(K.url,!0):R.URI.revive(K.url)}catch{}return new c.DocumentLink(u.to(K.range),Ae)}_e.to=ge})(J=e.DocumentLink||(e.DocumentLink={}));var Ee;(function(_e){function Te(K){const Ae=new c.ColorPresentation(K.label);return K.textEdit&&(Ae.textEdit=z.to(K.textEdit)),K.additionalTextEdits&&(Ae.additionalTextEdits=K.additionalTextEdits.map(Le=>z.to(Le))),Ae}_e.to=Te;function ge(K){return{label:K.label,textEdit:K.textEdit?z.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Ae=>z.from(Ae)):void 0}}_e.from=ge})(Ee=e.ColorPresentation||(e.ColorPresentation={}));var ve;(function(_e){function Te(K){return new c.Color(K[0],K[1],K[2],K[3])}_e.to=Te;function ge(K){return[K.red,K.green,K.blue,K.alpha]}_e.from=ge})(ve=e.Color||(e.Color={}));var Ne;(function(_e){function Te(K){return{range:u.from(K.range)}}_e.from=Te;function ge(K){return new c.SelectionRange(u.to(K.range))}_e.to=ge})(Ne=e.SelectionRange||(e.SelectionRange={}));var ze;(function(_e){function Te(ge){switch(ge){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}_e.to=Te})(ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(_e){function Te(K){switch(K){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=Te;function ge(K){switch(K){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}_e.to=ge})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(_e){function Te(K){if(K===c.EndOfLine.CRLF)return 1;if(K===c.EndOfLine.LF)return 0}_e.from=Te;function ge(K){if(K===1)return c.EndOfLine.CRLF;if(K===0)return c.EndOfLine.LF}_e.to=ge})(Ge=e.EndOfLine||(e.EndOfLine={}));var Pe;(function(_e){function Te(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=Te})(Pe=e.ProgressLocation||(e.ProgressLocation={}));var nt;(function(_e){function Te(ge){const K={start:ge.start+1,end:ge.end+1};return ge.kind&&(K.kind=X.from(ge.kind)),K}_e.from=Te})(nt=e.FoldingRange||(e.FoldingRange={}));var X;(function(_e){function Te(ge){if(ge)switch(ge){case c.FoldingRangeKind.Comment:return g.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return g.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return g.FoldingRangeKind.Region}}_e.from=Te})(X=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(_e){function Te(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?u.from(ge.selection):void 0,override:typeof ge.override=="boolean"?a.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}_e.from=Te})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var me;(function(_e){function Te(Le){return Le instanceof c.RelativePattern?Le.toJSON():typeof Le=="string"?Le:ge(Le)||K(Le)?new c.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}_e.from=Te;function ge(Le){const Ze=Le;return Ze?R.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function K(Le){const Ze=Le;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Ae(Le){return typeof Le=="string"?Le:new c.RelativePattern(R.URI.revive(Le.baseUri),Le.pattern)}_e.to=Ae})(me=e.GlobPattern||(e.GlobPattern={}));var Ue;(function(_e){function Te(ge){if(ge){if(Array.isArray(ge))return ge.map(Te);if(typeof ge=="string")return ge;{const K=ge;return{language:K.language,scheme:K.scheme,pattern:me.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}_e.from=Te})(Ue=e.LanguageSelector||(e.LanguageSelector={}));var Ve;(function(_e){function Te(K){return{start:K.start,end:K.end}}_e.from=Te;function ge(K){return new c.NotebookRange(K.start,K.end)}_e.to=ge})(Ve=e.NotebookRange||(e.NotebookRange={}));var et;(function(_e){function Te(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}_e.to=Te;function ge(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}_e.from=ge})(et=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ke;(function(_e){function Te(ge){if(ge===l.NotebookCellExecutionState.Unconfirmed)return c.NotebookCellExecutionState.Pending;if(ge===l.NotebookCellExecutionState.Pending)return;if(ge===l.NotebookCellExecutionState.Executing)return c.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}_e.to=Te})(Ke=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var je;(function(_e){function Te(K){switch(K){case c.NotebookCellKind.Markup:return l.CellKind.Markup;case c.NotebookCellKind.Code:default:return l.CellKind.Code}}_e.from=Te;function ge(K){switch(K){case l.CellKind.Markup:return c.NotebookCellKind.Markup;case l.CellKind.Code:default:return c.NotebookCellKind.Code}}_e.to=ge})(je=e.NotebookCellKind||(e.NotebookCellKind={}));var it;(function(_e){function Te(K){const Ae={metadata:K.metadata??Object.create(null),cells:[]};for(const Le of K.cells)c.NotebookCellData.validate(Le),Ae.cells.push(st.from(Le));return Ae}_e.from=Te;function ge(K){const Ae=new c.NotebookData(K.cells.map(st.to));return(0,P.isEmptyObject)(K.metadata)||(Ae.metadata=K.metadata),Ae}_e.to=ge})(it=e.NotebookData||(e.NotebookData={}));var st;(function(_e){function Te(K){return{cellKind:je.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:et.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(at.from):[]}}_e.from=Te;function ge(K){return new c.NotebookCellData(je.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(at.to):void 0,K.metadata,K.internalMetadata?et.to(K.internalMetadata):void 0)}_e.to=ge})(st=e.NotebookCellData||(e.NotebookCellData={}));var ct;(function(_e){function Te(K){return{mime:K.mime,valueBytes:C.VSBuffer.wrap(K.data)}}_e.from=Te;function ge(K){return new c.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}_e.to=ge})(ct=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var at;(function(_e){function Te(K){return{outputId:K.id,items:K.items.map(ct.from),metadata:K.metadata}}_e.from=Te;function ge(K){const Ae=K.items.map(ct.to);return new c.NotebookCellOutput(Ae,K.outputId,K.metadata)}_e.to=ge})(at=e.NotebookCellOutput||(e.NotebookCellOutput={}));var rt;(function(_e){function Te(Ae){return K(Ae)?{include:(0,P.withNullAsUndefined)(me.from(Ae.include)),exclude:(0,P.withNullAsUndefined)(me.from(Ae.exclude))}:(0,P.withNullAsUndefined)(me.from(Ae))}_e.from=Te;function ge(Ae){return K(Ae)?{include:me.to(Ae.include),exclude:me.to(Ae.exclude)}:me.to(Ae)}_e.to=ge;function K(Ae){const Le=Ae;return Le?!(0,P.isUndefinedOrNull)(Le.include)&&!(0,P.isUndefinedOrNull)(Le.exclude):!1}})(rt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var _t;(function(_e){function Te(ge,K,Ae){const Le=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Le,Ae),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}_e.from=Te})(_t=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Rt;(function(_e){function Te(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}_e.from=Te})(Rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ot;(function(_e){function Te(K){return{uri:K.uri,provides:K.provides}}_e.from=Te;function ge(K){return new c.NotebookRendererScript(R.URI.revive(K.uri),K.provides)}_e.to=ge})(Ot=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(_e){function Te(K){return{message:U.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:u.from(K.location.range),uri:K.location.uri}}}_e.from=Te;function ge(K){const Ae=new c.TestMessage(typeof K.message=="string"?K.message:U.to(K.message));return Ae.actualOutput=K.actual,Ae.expectedOutput=K.expected,Ae.location=K.location?pe.to(K.location):void 0,Ae}_e.to=ge})(ft=e.TestMessage||(e.TestMessage={}));var Dt;(function(_e){_e.namespace=m.namespaceTestTag,_e.denamespace=m.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var Mt;(function(_e){function Te(K){const Ae=(0,p.getPrivateApiFor)(K).controllerId;return{extId:d.TestId.fromExtHostTestItem(K,Ae).toString(),label:K.label,uri:R.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Le=>Dt.namespace(Ae,Le.id)),range:b.Range.lift(u.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&U.fromStrict(K.error)||null}}_e.from=Te;function ge(K){return{parent:void 0,error:void 0,id:d.TestId.fromString(K.extId).localId,label:K.label,uri:R.URI.revive(K.uri),tags:(K.tags||[]).map(Ae=>{const{tagId:Le}=Dt.denamespace(Ae);return new c.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}_e.toPlain=ge})(Mt=e.TestItem||(e.TestItem={})),function(_e){function Te(K){return{id:K.id}}_e.from=Te;function ge(K){return new c.TestTag(K.id)}_e.to=ge}(Dt=e.TestTag||(e.TestTag={}));var Lt;(function(_e){const Te=(K,Ae)=>{const Le=[];for(const[We,tt]of Ae)d.TestId.compare(tt.item.extId,We)===2&&(Ae.delete(We),Le.push(tt));const Ze={...Mt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(tt=>tt.type===0).map(ft.to)})),children:Le.map(We=>Te(We,Ae))};for(const We of Ze.children)We.parent=Ze;return Ze};function ge(K){const Ae=[],Le=new Map;for(const Ze of K.items){Le.set(Ze.item.extId,Ze);const We=d.TestId.root(Ze.item.extId);K.request.targets.some(tt=>tt.controllerId===We&&tt.testIds.includes(Ze.item.extId))&&Ae.push(Ze)}return{completedAt:K.completedAt,results:Ae.map(Ze=>Te(Ze,Le))}}_e.to=ge})(Lt=e.TestResults||(e.TestResults={}));var qe;(function(_e){function Te(Le){return{covered:Le.covered,total:Le.covered}}function ge(Le){return"line"in Le?n.from(Le):u.from(Le)}function K(Le){return"branches"in Le?{count:Le.executionCount,location:ge(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ge(Ze.location)})):void 0}:{type:0,count:Le.executionCount,location:ge(Le.location)}}_e.fromDetailed=K;function Ae(Le){return{uri:Le.uri,statement:Te(Le.statementCoverage),branch:Le.branchCoverage&&Te(Le.branchCoverage),function:Le.functionCoverage&&Te(Le.functionCoverage),details:Le.detailedCoverage?.map(K)}}_e.fromFile=Ae})(qe=e.TestCoverage||(e.TestCoverage={}));var zt;(function(_e){function Te(ge){switch(ge){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}_e.to=Te})(zt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(_e){function Te(K){const Ae=new c.TypeHierarchyItem(te.to(K.kind),K.name,K.detail||"",R.URI.revive(K.uri),u.to(K.range),u.to(K.selectionRange));return Ae._sessionId=K._sessionId,Ae._itemId=K._itemId,Ae}_e.to=Te;function ge(K,Ae,Le){if(Ae=Ae??K._sessionId,Le=Le??K._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,kind:te.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:u.from(K.range),selectionRange:u.from(K.selectionRange),tags:K.tags?.map(he.from)}}_e.from=ge})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Tt;(function(_e){function Te(ge){if(!!ge)return{value:ge.value,tooltip:ge.tooltip}}_e.from=Te})(Tt=e.ViewBadge||(e.ViewBadge={}));var mt;(function(_e){function Te(ge,K){const Ae=ge.fileData;return Ae?new class extends c.DataTransferItem{asFile(){return{name:Ae.name,uri:R.URI.revive(Ae.uri),data:(0,_.once)(()=>K())}}}("",ge.id):new c.DataTransferItem(ge.asString)}_e.toDataTransferItem=Te})(mt=e.DataTransferItem||(e.DataTransferItem={}));var Ct;(function(_e){function Te(K,Ae){const Le=K.items.map(([Ze,We])=>[Ze,mt.toDataTransferItem(We,()=>Ae(We.id))]);return new c.DataTransfer(Le)}_e.toDataTransfer=Te;async function ge(K){const Ae={items:[]},Le=[];return K.forEach((Ze,We)=>{Le.push((async()=>{const tt=await Ze.asString(),gt=Ze.asFile();Ae.items.push([We,{id:Ze.id,asString:tt,fileData:gt?{name:gt.name,uri:gt.uri}:void 0}])})())}),await Promise.all(Le),Ae}_e.toDataTransferDTO=ge})(Ct=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[182],Ie([1,0,2,12,6,8,149]),function(ne,e,r,C,w,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(P,R,b,g={timeout:1500,errors:3}){this._logService=P,this._documents=R,this._mainThreadBulkEdits=b,this._thresholds=g,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(R,b,g)=>{const p={dispose:this._callbacks.push([R,b,P])};return Array.isArray(g)&&g.push(p),p}}async $participateInSave(P,R){const b=r.URI.revive(P);let g=!1;const I=setTimeout(()=>g=!0,this._thresholds.timeout),p=[];try{for(const a of[...this._callbacks]){if(g)break;const l=this._documents.getDocument(b),d=await this._deliverEventAsyncAndBlameBadListeners(a,{document:l,reason:F.TextDocumentSaveReason.to(R)});p.push(d)}}finally{clearTimeout(I)}return p}_deliverEventAsyncAndBlameBadListeners([P,R,b],g){const I=this._badListeners.get(P);return typeof I=="number"&&I>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,P,R,g).then(()=>!0,p=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const a=this._badListeners.get(P);this._badListeners.set(P,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,R,b,g){const I=[],p=Date.now(),{document:a,reason:l}=g,{version:d}=a,m=Object.freeze({document:a,reason:l,waitUntil(S){if(Object.isFrozen(I))throw(0,C.illegalState)("waitUntil can not be called async");I.push(Promise.resolve(S))}});try{R.apply(b,[m])}catch(S){return Promise.reject(S)}return Object.freeze(I),new Promise((S,c)=>{const _=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(I).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(_),S(t)}).catch(t=>{clearTimeout(_),c(t)})}).then(S=>{const c={edits:[]};for(const _ of S)if(Array.isArray(_)&&_.every(t=>t instanceof w.TextEdit))for(const{newText:t,newEol:u,range:i}of _)c.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:i&&F.Range.from(i),text:t,eol:u&&F.EndOfLine.from(u)}});if(c.edits.length!==0)return d===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ce[183],Ie([1,0,13,2,8,6,65]),function(ne,e,r,C,w,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(b,g,I,p){this.start=b,this.deletedCount=g,this.deletedItems=I,this.items=p}asApiEvent(){return{range:new F.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(b=>b.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(b,g){return{EOL:g.eol,lines:g.source,languageId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:b}}constructor(b,g,I){this.notebook=b,this._extHostDocument=g,this._cellData=I,this.handle=I.handle,this.uri=C.URI.revive(I.uri),this.cellKind=I.cellKind,this._outputs=I.outputs.map(w.NotebookCellOutput.to),this._internalMetadata=I.internalMetadata??{},this._metadata=Object.freeze(I.metadata??{}),this._previousResult=Object.freeze(w.NotebookCellExecutionSummary.to(I.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const b=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const I={get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:w.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get mime(){return b._mime},set mime(p){b._mime=p},get outputs(){return b._outputs.slice(0)},get metadata(){return b._metadata},get executionSummary(){return b._previousResult}};this._apiCell=Object.freeze(I)}return this._apiCell}setOutputs(b){this._outputs=b.map(w.NotebookCellOutput.to)}setOutputItems(b,g,I){const p=I.map(w.NotebookCellOutputItem.to),a=this._outputs.find(l=>l.id===b);if(a&&(g||(a.items.length=0),a.items.push(...p),a.items.length>1&&a.items.every(l=>y.isTextStreamMime(l.mime)))){const l=new Map,d=[];a.items.forEach(m=>{let S;l.has(m.mime)?S=l.get(m.mime):(S=[],l.set(m.mime,S),d.push(m.mime)),S.push(m.data)}),a.items.length=0,d.forEach(m=>{const S=y.compressOutputItemStreams(l.get(m));a.items.push({mime:m,data:S.buffer})})}}setMetadata(b){this._metadata=Object.freeze(b)}setInternalMetadata(b){this._internalMetadata=b,this._previousResult=Object.freeze(w.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.ExtHostCell=E;class P{constructor(b,g,I,p,a){this._proxy=b,this._textDocumentsAndEditors=g,this._textDocuments=I,this.uri=p,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=a.viewType,this._metadata=Object.freeze(a.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,a.cells]],!0,void 0),this._versionId=a.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const b=this,g={get uri(){return b.uri},get version(){return b._versionId},get notebookType(){return b._notebookType},get isDirty(){return b._isDirty},get isUntitled(){return b.uri.scheme===r.Schemas.untitled},get isClosed(){return b._disposed},get metadata(){return b._metadata},get cellCount(){return b._cells.length},cellAt(I){return I=b._validateIndex(I),b._cells[I].apiCell},getCells(I){return(I?b._getCells(I):b._cells).map(a=>a.apiCell)},save(){return b._save()}};this._notebook=Object.freeze(g)}return this._notebook}acceptDocumentPropertiesChanged(b){b.metadata&&(this._metadata=Object.freeze({...this._metadata,...b.metadata}))}acceptDirty(b){this._isDirty=b}acceptModelChanged(b,g,I){this._versionId=b.versionId,this._isDirty=g,this.acceptDocumentPropertiesChanged({metadata:I});const p={notebook:this.apiNotebook,metadata:I,cellChanges:[],contentChanges:[]},a=[];for(const d of b.rawEvents)d.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1,p.contentChanges):d.kind===y.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx,p.contentChanges):d.kind===y.NotebookCellsChangeType.Output?(this._setCellOutputs(d.index,d.outputs),a.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===y.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems),a.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===y.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(d.index,d.language),a.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document})):d.kind===y.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document}):d.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===y.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(d.index,d.metadata),a.push({cell:this._cells[d.index].apiCell,metadata:this._cells[d.index].apiCell.metadata})):d.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(d.index,d.internalMetadata),a.push({cell:this._cells[d.index].apiCell,executionSummary:this._cells[d.index].apiCell.executionSummary}));const l=new Map;for(let d=0;d<a.length;d++){const m=a[d],S=l.get(m.cell);if(S===void 0){const c=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...m});l.set(m.cell,c-1)}else p.cellChanges[S]={...p.cellChanges[S],...m}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}_validateIndex(b){return b=b|0,b<0?0:b>=this._cells.length?this._cells.length-1:b}_validateRange(b){let g=b.start|0,I=b.end|0;return g<0&&(g=0),I>this._cells.length&&(I=this._cells.length),b.with({start:g,end:I})}_getCells(b){b=this._validateRange(b);const g=[];for(let I=b.start;I<b.end;I++)g.push(this._cells[I]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(b,g,I){if(this._disposed)return;const p=[],a=[],l=[];if(b.reverse().forEach(d=>{const S=d[2].map(t=>{const u=new E(this,this._textDocumentsAndEditors,t);return g||a.push(E.asModelAddData(this.apiNotebook,t)),u}),c=new A(d[0],d[1],[],S),_=this._cells.splice(d[0],d[1],...S);for(const t of _)l.push(t.uri),c.deletedItems.push(t.apiCell);p.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:l}),I)for(const d of p)I.push(d.asApiEvent())}_moveCell(b,g,I){const p=this._cells.splice(b,1);this._cells.splice(g,0,...p);const a=[new A(b,1,p.map(l=>l.apiCell),[]),new A(g,0,[],p)];for(const l of a)I.push(l.asApiEvent())}_setCellOutputs(b,g){this._cells[b].setOutputs(g)}_setCellOutputItems(b,g,I,p){this._cells[b].setOutputItems(g,I,p)}_changeCellLanguage(b,g){const I=this._cells[b];I.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelLanguageChanged(I.uri,g)}_changeCellMime(b,g){const I=this._cells[b];I.apiCell.mime=g}_changeCellMetadata(b,g){this._cells[b].setMetadata(g)}_changeCellInternalMetadata(b,g){this._cells[b].setInternalMetadata(g)}getCellFromApiCell(b){return this._cells.find(g=>g.apiCell===b)}getCellFromIndex(b){return this._cells[b]}getCell(b){return this._cells.find(g=>g.handle===b)}getCellIndex(b){return this._cells.indexOf(b)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(Ce[94],Ie([1,0,12,8,6]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class F{constructor(A,E,P,R,b,g){this.id=A,this._proxy=E,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=b,this._visibleRanges=R,this._viewColumn=g}get apiEditor(){if(!this._editor){const A=this;this._editor={get document(){return A.notebookData.apiNotebook},get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(E){this.selections=[E]},get selections(){return A._selections},set selections(E){if(!Array.isArray(E)||!E.every(w.NotebookRange.isNotebookRange))throw(0,r.illegalArgument)("selections");A._selections=E,A._trySetSelections(E)},get visibleRanges(){return A._visibleRanges},revealRange(E,P){A._proxy.$tryRevealRange(A.id,C.NotebookRange.from(E),P??w.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(C.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(Ce[184],Ie([1,0,4,11,8]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let F=class{constructor(A,E){this._logService=A,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new r.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new r.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,E);const P=this._notebooksAndEditors.getEditorById(A);E.visibleRanges&&P._acceptVisibleRanges(E.visibleRanges.ranges.map(w.NotebookRange.to)),E.selections&&P._acceptSelections(E.selections.selections.map(w.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const E in A)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(w.ViewColumn.to(A[E]))}};F=$e([xe(0,C.ILogService)],F),e.ExtHostNotebookEditors=F}),define(Ce[185],Ie([1,0,8,152,132,21,57,12]),function(ne,e,r,C,w,F,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(g){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=g}async withProgress(g,I,p){const a=this._handles++,{title:l,location:d,cancellable:m}=I,S={label:(0,w.localize)(0,null,g.displayName||g.name),id:g.identifier.value};return this._proxy.$startProgress(a,{location:r.ProgressLocation.from(d),title:l,source:S,cancellable:m},g.isUnderDevelopment?void 0:g.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(a,p,!!m)}_withProgress(g,I,p){let a;p&&(a=new F.CancellationTokenSource,this._mapHandleToCancellationSource.set(g,a));const l=m=>{this._proxy.$progressEnd(m),this._mapHandleToCancellationSource.delete(m),a?.dispose()};let d;try{d=I(new R(this._proxy,g),p&&a?a.token:F.CancellationToken.None)}catch(m){throw l(g),m}return d.then(m=>l(g),m=>l(g)),d}$acceptProgressCanceled(g){const I=this._mapHandleToCancellationSource.get(g);I&&(I.cancel(),this._mapHandleToCancellationSource.delete(g))}}e.ExtHostProgress=E;function P(b,g){return b.message=g.message,typeof g.increment=="number"&&(typeof b.increment=="number"?b.increment+=g.increment:b.increment=g.increment),b}class R extends C.Progress{constructor(g,I){super(p=>this.throttledReport(p)),this._proxy=g,this._handle=I}throttledReport(g){this._proxy.$progressReport(this._handle,g)}}$e([(0,y.throttle)(100,(b,g)=>P(b,g),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ce[95],Ie([1,0,51,90,41,66,50,8,2]),function(ne,e,r,C,w,F,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const P=(S,c,_,t)=>{let u=c;return{enumerable:!0,configurable:!1,get(){return u},set(i){if(!_(u,i)){const n=u;u=i,S.listener?.(t(i,n))}}}},R=(S,c)=>S===c,b={range:(S,c)=>S===c?!0:!S||!c?!1:S.isEqual(c),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(S,c)=>!(S.length!==c.length||S.some(_=>!c.find(t=>_.id===t.id)))},g=S=>c=>({op:4,update:S(c)}),I=(S,c)=>({range:(()=>{let _;const t=g(u=>({range:r.Range.lift(A.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return _},set(u){S.listener?.({op:6}),b.range(_,u)||(_=u,S.listener?.(t(u)))}}})(),label:P(S,c,b.label,g(_=>({label:_}))),description:P(S,void 0,b.description,g(_=>({description:_}))),sortText:P(S,void 0,b.sortText,g(_=>({sortText:_}))),canResolveChildren:P(S,!1,b.canResolveChildren,_=>({op:2,state:_})),busy:P(S,!1,b.busy,g(_=>({busy:_}))),error:P(S,void 0,b.error,g(_=>({error:A.MarkdownString.fromStrict(_)||null}))),tags:P(S,[],b.tags,(_,t)=>({op:1,new:_.map(A.TestTag.from),old:t.map(A.TestTag.from)}))}),p=S=>{const c=w.TestId.fromString(S.extId),_=new l(c.controllerId,c.localId,S.label,E.URI.revive(S.uri)||void 0);return _.range=A.Range.to(S.range||void 0),_.description=S.description||void 0,_.sortText=S.sortText||void 0,_.tags=S.tags.map(t=>A.TestTag.to({id:(0,y.denamespaceTestTag)(t).tagId})),_},a=S=>{let c;for(const _ of S.tests){const t=p(_.item);(0,C.getPrivateApiFor)(t).parent=c,c=t}return c};e.toItemFromContext=a;class l{constructor(c,_,t,u){if(_.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(_)} symbol`);const i=(0,C.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:_,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof d?void 0:i.parent}},children:{value:(0,F.createTestItemChildren)(i,C.getPrivateApiFor,l),enumerable:!0,writable:!1},...I(i,t)})}}e.TestItemImpl=l;class d extends l{constructor(c,_){super(c,c,_,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class m extends F.TestItemCollection{constructor(c,_,t){super({controllerId:c,getDocumentVersion:u=>u&&t.getDocument(u)?.version,getApiFor:C.getPrivateApiFor,getChildren:u=>u.children,root:new d(c,_),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=m}),define(Ce[96],Ie([1,0,46,12,76,8,6]),function(ne,e,r,C,w,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(g,I,p){const a=A._Keys.nextId();g.$registerTextEditorDecorationType(I.identifier,a,F.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:a,dispose(){g.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=A,A._Keys=new w.IdGenerator("TextEditorDecorationType");class E{constructor(g,I){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=g,this._documentVersionId=g.version,this._undoStopBefore=I.undoStopBefore,this._undoStopAfter=I.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(g,I){this._throwIfFinalized();let p=null;if(g instanceof y.Position)p=new y.Range(g,g);else if(g instanceof y.Range)p=g;else throw new Error("Unrecognized location");this._pushEdit(p,I,!1)}insert(g,I){this._throwIfFinalized(),this._pushEdit(new y.Range(g,g),I,!0)}delete(g){this._throwIfFinalized();let I=null;if(g instanceof y.Range)I=g;else throw new Error("Unrecognized location");this._pushEdit(I,null,!0)}_pushEdit(g,I,p){const a=this._document.validateRange(g);this._collectedEdits.push({range:a,text:I,forceMoveMarkers:p})}setEndOfLine(g){if(this._throwIfFinalized(),g!==y.EndOfLine.LF&&g!==y.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this._setEndOfLine=g}}e.TextEditorEdit=E;class P{constructor(g,I,p,a){this._proxy=g,this._id=I,this._accept(p),this._logService=a;const l=this;this.value={get tabSize(){return l._tabSize},set tabSize(d){l._setTabSize(d)},get insertSpaces(){return l._insertSpaces},set insertSpaces(d){l._setInsertSpaces(d)},get cursorStyle(){return l._cursorStyle},set cursorStyle(d){l._setCursorStyle(d)},get lineNumbers(){return l._lineNumbers},set lineNumbers(d){l._setLineNumbers(d)}}}_accept(g){this._tabSize=g.tabSize,this._insertSpaces=g.insertSpaces,this._cursorStyle=g.cursorStyle,this._lineNumbers=F.TextEditorLineNumbersStyle.to(g.lineNumbers)}_validateTabSize(g){if(g==="auto")return"auto";if(typeof g=="number"){const I=Math.floor(g);return I>0?I:null}if(typeof g=="string"){const I=parseInt(g,10);return isNaN(I)?null:I>0?I:null}return null}_setTabSize(g){const I=this._validateTabSize(g);if(I!==null){if(typeof I=="number"){if(this._tabSize===I)return;this._tabSize=I}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:I}))}}_validateInsertSpaces(g){return g==="auto"?"auto":g==="false"?!1:Boolean(g)}_setInsertSpaces(g){const I=this._validateInsertSpaces(g);if(typeof I=="boolean"){if(this._insertSpaces===I)return;this._insertSpaces=I}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:I}))}_setCursorStyle(g){this._cursorStyle!==g&&(this._cursorStyle=g,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:g})))}_setLineNumbers(g){this._lineNumbers!==g&&(this._lineNumbers=g,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:F.TextEditorLineNumbersStyle.from(g)})))}assign(g){const I={};let p=!1;if(typeof g.tabSize<"u"){const a=this._validateTabSize(g.tabSize);a==="auto"?(p=!0,I.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,p=!0,I.tabSize=a)}if(typeof g.insertSpaces<"u"){const a=this._validateInsertSpaces(g.insertSpaces);a==="auto"?(p=!0,I.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,p=!0,I.insertSpaces=a)}typeof g.cursorStyle<"u"&&this._cursorStyle!==g.cursorStyle&&(this._cursorStyle=g.cursorStyle,p=!0,I.cursorStyle=g.cursorStyle),typeof g.lineNumbers<"u"&&this._lineNumbers!==g.lineNumbers&&(this._lineNumbers=g.lineNumbers,p=!0,I.lineNumbers=F.TextEditorLineNumbersStyle.from(g.lineNumbers)),p&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,I))}_warnOnError(g,I){I.catch(p=>{this._logService.warn(`ExtHostTextEditorOptions '${g}' failed:'`),this._logService.warn(p)})}}e.ExtHostTextEditorOptions=P;class R{constructor(g,I,p,a,l,d,m,S){this.id=g,this._proxy=I,this._logService=p,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._options=new P(this._proxy,this.id,d,p),this._visibleRanges=m,this._viewColumn=S;const c=this;this.value=Object.freeze({get document(){return a.getValue()},set document(_){throw(0,C.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(_){if(!(_ instanceof y.Selection))throw(0,C.illegalArgument)("selection");c._selections=[_],c._trySetSelection()},get selections(){return c._selections},set selections(_){if(!Array.isArray(_)||_.some(t=>!(t instanceof y.Selection)))throw(0,C.illegalArgument)("selections");c._selections=_,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(_){throw(0,C.readonly)("visibleRanges")},get options(){return c._options.value},set options(_){c._disposed||c._options.assign(_)},get viewColumn(){return c._viewColumn},set viewColumn(_){throw(0,C.readonly)("viewColumn")},edit(_,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new E(a.getValue(),t);return _(u),c._applyEdit(u)},insertSnippet(_,t,u={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!t||Array.isArray(t)&&t.length===0)i=c._selections.map(n=>F.Range.from(n));else if(t instanceof y.Position){const{lineNumber:n,column:s}=F.Position.from(t);i=[{startLineNumber:n,startColumn:s,endLineNumber:n,endColumn:s}]}else if(t instanceof y.Range)i=[F.Range.from(t)];else{i=[];for(const n of t)if(n instanceof y.Range)i.push(F.Range.from(n));else{const{lineNumber:s,column:h}=F.Position.from(n);i.push({startLineNumber:s,startColumn:h,endLineNumber:s,endColumn:h})}}return I.$tryInsertSnippet(g,a.getValue().version,_.value,i,u)},setDecorations(_,t){const u=t.length===0;u&&!c._hasDecorationsForKey.has(_.key)||(u?c._hasDecorationsForKey.delete(_.key):c._hasDecorationsForKey.add(_.key),c._runOnProxy(()=>{if(F.isDecorationOptionsArr(t))return I.$trySetDecorations(g,_.key,F.fromRangeOrRangeWithMessage(t));{const i=new Array(4*t.length);for(let n=0,s=t.length;n<s;n++){const h=t[n];i[4*n]=h.start.line+1,i[4*n+1]=h.start.character+1,i[4*n+2]=h.end.line+1,i[4*n+3]=h.end.character+1}return I.$trySetDecorationsFast(g,_.key,i)}}))},revealRange(_,t){c._runOnProxy(()=>I.$tryRevealRange(g,F.Range.from(_),t||y.TextEditorRevealType.Default))},show(_){I.$tryShowEditor(g,F.ViewColumn.from(_))},hide(){I.$tryHideEditor(g)}})}dispose(){(0,r.ok)(!this._disposed),this._disposed=!0}_acceptOptions(g){(0,r.ok)(!this._disposed),this._options._accept(g)}_acceptVisibleRanges(g){(0,r.ok)(!this._disposed),this._visibleRanges=g}_acceptViewColumn(g){(0,r.ok)(!this._disposed),this._viewColumn=g}_acceptSelections(g){(0,r.ok)(!this._disposed),this._selections=g}async _trySetSelection(){const g=this._selections.map(F.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,g)),this.value}_applyEdit(g){const I=g.finalize();if(I.edits.length===0&&!I.setEndOfLine)return Promise.resolve(!0);const p=I.edits.map(l=>l.range);p.sort((l,d)=>l.end.line===d.end.line?l.end.character===d.end.character?l.start.line===d.start.line?l.start.character-d.start.character:l.start.line-d.start.line:l.end.character-d.end.character:l.end.line-d.end.line);for(let l=0,d=p.length-1;l<d;l++){const m=p[l].end;if(p[l+1].start.isBefore(m))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=I.edits.map(l=>({range:F.Range.from(l.range),text:l.text,forceMoveMarkers:l.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,I.documentVersionId,a,{setEndOfLine:typeof I.setEndOfLine=="number"?F.EndOfLine.from(I.setEndOfLine):void 0,undoStopBefore:I.undoStopBefore,undoStopAfter:I.undoStopAfter})}_runOnProxy(g){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,I=>(I instanceof Error&&I.name==="DISPOSED"||this._logService.warn(I),null))}}e.ExtHostTextEditor=R}),define(Ce[186],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[187],Ie([1,0,143,12,29,83,86,30,27,186,151]),function(ne,e,r,C,w,F,y,A,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const b=A.Registry.as(y.Extensions.JSONContribution);class g{constructor(c,_,t){this._messageHandler=c,this._extension=_,this._extensionPointId=t}_msg(c,_){this._messageHandler({type:c,message:_,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(c){this._msg(w.default.Error,c)}warn(c){this._msg(w.default.Warning,c)}info(c){this._msg(w.default.Info,c)}}e.ExtensionMessageCollector=g;class I{static _toSet(c){const _=new Set;for(let t=0,u=c.length;t<u;t++)_.add(E.ExtensionIdentifier.toKey(c[t].description.identifier));return _}static compute(c,_){if(!c||!c.length)return new I(_,[]);if(!_||!_.length)return new I([],c);const t=this._toSet(c),u=this._toSet(_),i=_.filter(s=>!t.has(E.ExtensionIdentifier.toKey(s.description.identifier))),n=c.filter(s=>!u.has(E.ExtensionIdentifier.toKey(s.description.identifier)));return new I(i,n)}constructor(c,_){this.added=c,this.removed=_}}e.ExtensionPointUserDelta=I;class p{constructor(c,_){this.name=c,this.defaultExtensionKind=_,this._handler=null,this._users=null,this._delta=null}setHandler(c){if(this._handler!==null)throw new Error("Handler already set!");this._handler=c,this._handle()}acceptUsers(c){this._delta=I.compute(this._users,c),this._users=c,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(c){(0,C.onUnexpectedError)(c)}}}e.ExtensionPoint=p;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}},activationEvents:{description:r.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:r.localize(31,null)},{label:"onUri",body:"onUri",description:r.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(36,null)},{label:"onRenderer",description:r.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(39,null)},{label:"*",description:r.localize(40,null),body:"*"}]}},badges:{type:"array",description:r.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(42,null)},href:{type:"string",description:r.localize(43,null)},description:{type:"string",description:r.localize(44,null)}}}},markdown:{type:"string",description:r.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:r.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:r.localize(49,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(50,null)},{body:["workspace"],description:r.localize(51,null)},{body:["ui","workspace"],description:r.localize(52,null)},{body:["workspace","ui"],description:r.localize(53,null)},{body:[],description:r.localize(54,null)}]},capabilities:{description:r.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(58,null),r.localize(59,null),r.localize(60,null)]},description:{type:"string",markdownDescription:r.localize(61,null)}}},untrustedWorkspaces:{description:r.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(64,null),r.localize(65,null),r.localize(66,null)]},restrictedConfigurations:{description:r.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(68,null)}}}}},sponsor:{description:r.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(71,null),type:"string"},"vscode:uninstall":{description:r.localize(72,null),type:"string"}}},icon:{type:"string",description:r.localize(73,null)},l10n:{type:"string",description:r.localize(74,null)}}};class d{constructor(){this._extensionPoints=new Map}registerExtensionPoint(c){if(this._extensionPoints.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const _=new p(c.extensionPoint,c.defaultExtensionKind);return this._extensionPoints.set(c.extensionPoint,_),e.schema.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,b.registerSchema(l,e.schema),_}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=d;const m={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(m.ExtensionsRegistry,new d),e.ExtensionsRegistry=A.Registry.as(m.ExtensionsRegistry),b.registerSchema(l,e.schema),b.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:r.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}}]}}}})}),define(Ce[188],Ie([1,0,140,10,24,187,40,4]),function(ne,e,r,C,w,F,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var P;(function(g){function I(p,a,l){if(!p)return;const d=C.isString(p.type)?p.type:void 0;if(!d||d.length===0){l.error(r.localize(3,null));return}const m=[];if(Array.isArray(p.required))for(const S of p.required)C.isString(S)&&m.push(S);return{extensionId:a.value,taskType:d,required:m,properties:p.properties?w.deepClone(p.properties):{},when:p.when?y.ContextKeyExpr.deserialize(p.when):void 0}}g.from=I})(P||(P={}));const R=F.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:r.localize(4,null),type:"array",items:E}});class b{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((I,p)=>{R.setHandler((a,l)=>{this._schema=void 0;try{for(const d of l.removed){const m=d.value;for(const S of m)this.taskTypes&&S.type&&this.taskTypes[S.type]&&delete this.taskTypes[S.type]}for(const d of l.added){const m=d.value;for(const S of m){const c=P.from(S,d.description.identifier,d.collector);c&&(this.taskTypes[c.taskType]=c)}}(l.removed.length>0||l.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}I(void 0)})})}onReady(){return this.readyPromise}get(I){return this.taskTypes[I]}all(){return Object.keys(this.taskTypes).map(I=>this.taskTypes[I])}getJsonSchema(){if(this._schema===void 0){const I=[];for(const p of this.all()){const a={type:"object",additionalProperties:!1};p.required.length>0&&(a.required=p.required.slice(0)),p.properties!==void 0?a.properties=w.deepClone(p.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[p.taskType]},I.push(a)}this._schema={oneOf:I}}return this._schema}}e.TaskDefinitionRegistryImpl=b,e.TaskDefinitionRegistry=new b}),define(Ce[189],Ie([1,0,141,10,22,24,40,188]),function(ne,e,r,C,w,F,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new y.RawContextKey("taskRunning",!1,r.localize(0,null)),e.TASKS_CATEGORY={value:r.localize(1,null),original:"Tasks"};var E;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function H(W){if(!W)return O.Strong;switch(W.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=H}(E=e.ShellQuoting||(e.ShellQuoting={}));var P;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(P=e.CommandOptions||(e.CommandOptions={}));var R;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(O){function H(W){switch(W.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=H}(R=e.RevealKind||(e.RevealKind={}));var b;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(b=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function H(W){switch(W.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=H}(b=e.RevealProblemKind||(e.RevealProblemKind={}));var g;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(g=e.PanelKind||(e.PanelKind={})),function(O){function H(W){switch(W.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=H}(g=e.PanelKind||(e.PanelKind={}));var I;(function(O){O.defaults={echo:!0,reveal:R.Always,revealProblems:b.Never,focus:!1,panel:g.Shared,showReuseMessage:!0,clear:!1}})(I=e.PresentationOptions||(e.PresentationOptions={}));var p;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(p=e.RuntimeType||(e.RuntimeType={})),function(O){function H(z){switch(z.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=H;function W(z){switch(z){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=W}(p=e.RuntimeType||(e.RuntimeType={}));var a;(function(O){function H(W){return C.isString(W)?W:W.value}O.value=H})(a=e.CommandString||(e.CommandString={}));var l;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function H(z){return z===O.Clean._id||z===O.Build._id||z===O.Rebuild._id||z===O.Test._id}O.is=H;function W(z){if(z!==void 0)return C.isString(z)?H(z)?{_id:z,isDefault:!1}:void 0:z}O.from=W})(l=e.TaskGroup||(e.TaskGroup={}));var d;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(d=e.TaskScope||(e.TaskScope={}));var m;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function H(W){switch(W){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=H})(m=e.TaskSourceKind||(e.TaskSourceKind={}));var S;(function(O){O.parallel="parallel",O.sequence="sequence"})(S=e.DependsOrder||(e.DependsOrder={}));var c;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(c=e.RunOnOptions||(e.RunOnOptions={}));var _;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(_=e.RunOptions||(e.RunOptions={}));class t{constructor(H,W,z,G,te,he){this._label="",this._id=H,W&&(this._label=W),z&&(this.type=z),this.runOptions=G,this.configurationProperties=te,this._source=he}getDefinition(H){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const H={folder:this.getFolderId(),id:this._id};return JSON.stringify(H)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(H,W=!1){if(H===void 0)return!1;if(C.isString(H))return H===this._label||H===this.configurationProperties.identifier||W&&H===this._id;const z=this.getDefinition(!0);return z!==void 0&&z._key===H._key}getQualifiedLabel(){const H=this.getWorkspaceFolder();return H?`${this._label} (${H.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(H){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),H&&(this._taskLoadMessages=this._taskLoadMessages.concat(H))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class u extends t{constructor(H,W,z,G,te,he,re,be){super(H,z,void 0,re,be,W),this.command={},this._source=W,this.hasDefinedMatchers=he,te&&(this.command=te)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(H=!1){if(H&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case p.Shell:W="shell";break;case p.Process:W="process";break;case p.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(H){return H instanceof u}getMapKey(){const H=this._source.config.workspaceFolder;return H?`${H.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===m.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const H=this.getFolderId();if(!H)return;let W=this.configurationProperties.identifier;this._source.kind!==m.Workspace&&(W+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:H,id:W};return JSON.stringify(z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?w.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(H){return new u(H._id,H._source,H._label,H.type,H.command,H.hasDefinedMatchers,H.runOptions,H.configurationProperties)}}e.CustomTask=u;class i extends t{constructor(H,W,z,G,te,he,re){super(H,z,G,he,re,W),this._source=W,this.configures=te}static is(H){return H instanceof i}fromObject(H){return H}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?w.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===m.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const H=this.getFolderId();if(!H)return;let W=this.configurationProperties.identifier;this._source.kind!==m.Workspace&&(W+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:H,id:W};return JSON.stringify(z)}}e.ConfiguringTask=i;class n extends t{constructor(H,W,z,G,te,he,re,be,le){super(H,z,G,be,le,W),this.defines=te,this.hasDefinedMatchers=re,this.command=he,this.icon=le.icon,this.hide=le.hide}clone(){return new n(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(H){return H instanceof n}getMapKey(){const H=this._source.workspaceFolder;return H?`${this._source.scope.toString()}|${H.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const H={type:"contributed",scope:this._source.scope,id:this._id};return H.folder=this.getFolderId(),JSON.stringify(H)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(H){return new n(H._id,H._source,H._label,H.type,H.defines,H.command,H.hasDefinedMatchers,H.runOptions,H.configurationProperties)}}e.ContributedTask=n;class s extends t{constructor(H,W,z,G,te,he){super(H,z,G,te,he,W),this._source=W}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(H){return H instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(H){return new s(H._id,H._source,H._label,H.type,H.runOptions,H.configurationProperties)}}e.InMemoryTask=s;var h;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(h=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(h=e.ExecutionEngine||(e.ExecutionEngine={}));var o;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(o=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class f{constructor(H){this._order=new Map;for(let W=0;W<H.length;W++)this._order.set(H[W].uri.toString(),W)}compare(H,W){const z=H.getWorkspaceFolder(),G=W.getWorkspaceFolder();if(z&&G){let te=this._order.get(z.uri.toString());te=te===void 0?0:te+1;let he=this._order.get(G.uri.toString());return he=he===void 0?0:he+1,te===he?H._label.localeCompare(W._label):te-he}else return!z&&G?-1:z&&!G?1:0}}e.TaskSorter=f;var v;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(v=e.TaskEventKind||(e.TaskEventKind={}));var T;(function(O){O.SingleRun="singleRun",O.Background="background"})(T=e.TaskRunType||(e.TaskRunType={}));var M;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(M=e.TaskRunSource||(e.TaskRunSource={}));var j;(function(O){function H(W,z,G,te,he){if(z){const re={kind:W,taskId:z._id,taskName:z.configurationProperties.name,runType:z.configurationProperties.isBackground?"background":"singleRun",group:z.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:z};return W==="start"?(re.terminalId=G,re.resolvedVariables=te):W==="processStarted"?re.processId=G:W==="processEnded"&&(re.exitCode=G),Object.freeze(re)}else return Object.freeze({kind:"changed"})}O.create=H})(j=e.TaskEvent||(e.TaskEvent={}));var U;(function(O){function H(z){const G=Object.keys(z).sort();let te="";for(const he of G){let re=z[he];re instanceof Object?re=H(re):typeof re=="string"&&(re=re.replace(/,/g,",,")),te+=he+","+re+","}return te}function W(z){const te={_key:H(z),type:z.taskType};return Object.assign(te,z),te}O.create=W})(U=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var D;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(D=e.TaskSettingId||(e.TaskSettingId={}));var $;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})($=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var L;(function(O){function H(W,z){const G=A.TaskDefinitionRegistry.get(W.type);if(G===void 0){const be=F.deepClone(W);return delete be._key,U.create(be)}const te=Object.create(null);te.type=G.taskType;const he=new Set;G.required.forEach(be=>he.add(be));const re=G.properties;for(const be of Object.keys(re)){const le=W[be];if(le!=null)te[be]=le;else if(he.has(be)){const fe=re[be];if(fe.default!==void 0)te[be]=F.deepClone(fe.default);else switch(fe.type){case"boolean":te[be]=!1;break;case"number":case"integer":te[be]=0;break;case"string":te[be]="";break;default:z.error(r.localize(2,null,JSON.stringify(W,void 0,0),be));return}}}return U.create(te)}O.createTaskIdentifier=H})(L=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[190],Ie([1,0,12]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class C{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,A)=>{this._actualOk=y,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,r.onUnexpectedError)(y))}then(y,A){return this._ensureActual().then(y,A)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=C;class w extends C{constructor(){super(),this._hasErr=!0,this._err=new r.CancellationError}}e.CanceledLazyPromise=w}),define(Ce[42],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class r{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++r.count}}e.ProxyIdentifier=r,r.count=0;const C=[];function w(A){const E=new r(A);return C[E.nid]=E,E}e.createProxyIdentifier=w;function F(A){return C[A].sid}e.getStringIdentifierForProxy=F;class y{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=y}),define(Ce[5],Ie([1,0,42]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var w;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput"})(w=e.TabInputKind||(e.TabInputKind={}));var F;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(F=e.TabModelOperationKind||(e.TabModelOperationKind={}));var y;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var E;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(E=e.CellOutputKind||(e.CellOutputKind={}));var P;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(P=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class b{static mixin(l){return l._id=b._n++,l}}e.IdObject=b,b._n=0;var g;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(g=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var I;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(I=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,r.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,r.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,r.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,r.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,r.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,r.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,r.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,r.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,r.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,r.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,r.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,r.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,r.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,r.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,r.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,r.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,r.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,r.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,r.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,r.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,r.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,r.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,r.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,r.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,r.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,r.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,r.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,r.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,r.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,r.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,r.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,r.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,r.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,r.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,r.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,r.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,r.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,r.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,r.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,r.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,r.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,r.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,r.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,r.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,r.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,r.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,r.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,r.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,r.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,r.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,r.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,r.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,r.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,r.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,r.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,r.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,r.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,r.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,r.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,r.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,r.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,r.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,r.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,r.createProxyIdentifier)("ExtHostLocalization")}}),define(Ce[69],Ie([1,0,3,11,5,14]),function(ne,e,r,C,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(E,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(w.MainContext.MainThreadTelemetry)}report(E,P,R){const b=this.getUsageKey(E,P);this._reportedUsages.has(b)||(this._reportedUsages.add(b),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:E}))}getUsageKey(E,P){return`${E}-${P.identifier.value}`}};y=$e([xe(0,F.IExtHostRpcService),xe(1,C.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(A,E,P){}})}),define(Ce[191],Ie([1,0,4,5,6,27]),function(ne,e,r,C,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new r.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,P,R,b={}){const g=F.ExtensionIdentifier.toKey(E.identifier),I=this._inFlightRequests.get(g)||[],p=[...R].sort().join(" ");let a=I.find(l=>l.providerId===P&&l.scopes===p);if(a)return a.result;{const l=this._getSession(E,g,P,R,b);a={providerId:P,scopes:p,result:l},I.push(a),this._inFlightRequests.set(g,I);try{await l}finally{const d=I.findIndex(m=>m.providerId===P&&m.scopes===p);d>-1&&(I.splice(d),this._inFlightRequests.set(g,I))}return l}}async _getSession(E,P,R,b,g={}){await this._proxy.$ensureProvider(R);const I=E.displayName||E.name;return this._proxy.$getSession(R,b,P,I,g)}async removeSession(E,P){const R=this._authenticationProviders.get(E);return R?R.provider.removeSession(P):this._proxy.$removeSession(E,P)}registerAuthenticationProvider(E,P,R,b){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:P,provider:R,options:b??{supportsMultipleAccounts:!1}}),this._providers.find(I=>I.id===E)||this._providers.push({id:E,label:P});const g=R.onDidChangeSessions(I=>{this._proxy.$sendDidChangeSessions(E,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,P,b?.supportsMultipleAccounts??!1),new w.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(E);const I=this._providers.findIndex(p=>p.id===E);I>-1&&this._providers.splice(I),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,P){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,P){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,P){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,P){return this._onDidChangeSessions.fire({provider:{id:E,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(Ce[192],Ie([1,0,5,14,8]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let F=class{constructor(A,E){this._proxy=A.getProxy(r.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:P=>E.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,E,P){const R=w.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(R,void 0,P?.isRefactoring??!1)}};F=$e([xe(0,C.IExtHostRpcService)],F),e.ExtHostBulkEdits=F}),define(Ce[193],Ie([1,0,5]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(F){const y=F.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(A){return y.$writeText(A)}})}}e.ExtHostClipboard=C});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(ne,r):w?w.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!C:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ne):C?C.value:e.get(ne)};define(Ce[37],Ie([1,0,10,6,8,24,5,18,11,78,51,246,2,7,3,14,95,23,42,44]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a,l,d,m,S){"use strict";var c,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let t=class{constructor(o,f){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,_.set(this,void 0),Ye(this,c,o.getProxy(y.MainContext.MainThreadCommands),"f"),this._logService=f,Ye(this,_,o.getProxy(y.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,v=>{const T=this._apiCommands.get(v);return T?.result===n.Void?T:void 0},f),this._argumentProcessors=[{processArgument(v){return(0,P.revive)(v)}},{processArgument(v){return(0,F.cloneAndChange)(v,function(T){if(R.Range.isIRange(T))return w.Range.to(T);if(b.Position.isIPosition(T))return w.Position.to(T);if(R.Range.isIRange(T.range)&&g.URI.isUri(T.uri))return w.location.to(T);if(T instanceof d.VSBuffer)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const f=this.registerCommand(!1,o.id,async(...v)=>{const T=o.args.map((j,U)=>{if(!j.validate(v[U]))throw new Error(`Invalid argument '${j.name}' when running '${o.id}', received: ${v[U]}`);return j.convert(v[U])}),M=await this.executeCommand(o.internalId,...T);return o.result.convert(M,v,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new C.Disposable(()=>{f.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,f,v,T,M,j){if(this._logService.trace("ExtHostCommands#registerCommand",f),!f.trim().length)throw new Error("invalid id");if(this._commands.has(f))throw new Error(`command '${f}' already exists`);return this._commands.set(f,{callback:v,thisArg:T,description:M,extension:j}),o&&Oe(this,c,"f").$registerCommand(f),new C.Disposable(()=>{this._commands.delete(f)&&o&&Oe(this,c,"f").$unregisterCommand(f)})}executeCommand(o,...f){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,f,!0)}async _doExecuteCommand(o,f,v){if(this._commands.has(o))return Oe(this,c,"f").$fireCommandActivationEvent(o),this._executeContributedCommand(o,f,!1);{let T=!1;const M=(0,F.cloneAndChange)(f,function(j){if(j instanceof C.Position)return w.Position.from(j);if(j instanceof C.Range)return w.Range.from(j);if(j instanceof C.Location)return w.location.from(j);if(C.NotebookRange.isNotebookRange(j))return w.NotebookRange.from(j);if(j instanceof ArrayBuffer)return T=!0,d.VSBuffer.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return T=!0,d.VSBuffer.wrap(j);if(j instanceof d.VSBuffer)return T=!0,j;if(!Array.isArray(j))return j});try{const j=await Oe(this,c,"f").$executeCommand(o,T?new m.SerializableObjectWithBuffers(M):M,v);return(0,P.revive)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this._doExecuteCommand(o,f,!1);throw j}}}async _executeContributedCommand(o,f,v){const T=this._commands.get(o);if(!T)throw new Error("Unknown command");this._reportTelemetry(T,o);const{callback:M,thisArg:j,description:U}=T;if(U)for(let D=0;D<U.args.length;D++)try{(0,r.validateConstraint)(f[D],U.args[D].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${U.args[D].name}' - ${U.args[D].description}`)}try{return await M.apply(j,f)}catch(D){if(o===this.converter.delegatingCommandId){const $=this.converter.getActualCommand(...f);$&&(o=$.command)}throw this._logService.error(D,o,T.extension?.identifier),v?new class extends Error{constructor(){super((0,S.toErrorMessage)(D)),this.id=o,this.source=T.extension?.displayName??T.extension?.name}}:D}}_reportTelemetry(o,f){!o.extension||o.extension.isBuiltin||Oe(this,_,"f").$publicLog2("Extension:ActionExecuted",{extensionId:o.extension.identifier.value,id:f})}$executeContributedCommand(o,...f){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(f=f.map(v=>this._argumentProcessors.reduce((T,M)=>M.processArgument(T),v)),this._executeContributedCommand(o,f,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),Oe(this,c,"f").$getCommands().then(f=>(o&&(f=f.filter(v=>v[0]!=="_")),f))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(const[f,v]of this._commands){const{description:T}=v;T&&(o[f]=T)}return Promise.resolve(o)}};c=new WeakMap,_=new WeakMap,t=$e([xe(0,a.IExtHostRpcService),xe(1,E.ILogService)],t),e.ExtHostCommands=t,e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class u{constructor(o,f,v){this._commands=o,this._lookupApiCommand=f,this._logService=v,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,f){if(!o)return;const v={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return v;const T=this._lookupApiCommand(o.command);if(T)v.id=T.internalId,v.arguments=T.args.map((M,j)=>M.convert(o.arguments&&o.arguments[j]));else if((0,A.isNonEmptyArray)(o.arguments)){const M=++this._cachIdPool;this._cache.set(M,o),f.add((0,I.toDisposable)(()=>{this._cache.delete(M),this._logService.trace("CommandsConverter#DISPOSE",M)})),v.$ident=M,v.id=this.delegatingCommandId,v.arguments=[M],this._logService.trace("CommandsConverter#CREATE",o.command,M)}return v}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const f=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],f?f.command:"MISSING"),f?this._commands.executeCommand(f.command,...f.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=u;class i{constructor(o,f,v,T){this.name=o,this.description=f,this.validate=v,this.convert=T}optional(){return new i(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,f){return new i(o??this.name,f??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",h=>g.URI.isUri(h),h=>h),i.Position=new i("position","A position in a text document",h=>C.Position.isPosition(h),w.Position.from),i.Range=new i("range","A range in a text document",h=>C.Range.isRange(h),w.Range.from),i.Selection=new i("selection","A selection in a text document",h=>C.Selection.isSelection(h),w.Selection.from),i.Number=new i("number","",h=>typeof h=="number",h=>h),i.String=new i("string","",h=>typeof h=="string",h=>h),i.CallHierarchyItem=new i("item","A call hierarchy item",h=>h instanceof C.CallHierarchyItem,w.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",h=>h instanceof C.TypeHierarchyItem,w.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",h=>h instanceof l.TestItemImpl,w.TestItem.from);class n{constructor(o,f){this.description=o,this.convert=f}}e.ApiCommandResult=n,n.Void=new n("no result",h=>h);class s{constructor(o,f,v,T,M){this.id=o,this.internalId=f,this.description=v,this.args=T,this.result=M}}e.ApiCommand=s}),define(Ce[194],Ie([1,0,2,8,6,68,37,18,81,85,13]),function(ne,e,r,C,w,F,y,A,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const b=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",I(C.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,l)=>{if((0,A.isFalsyOrEmpty)(a))return;class d extends w.SymbolInformation{static to(S){const c=new d(S.name,C.SymbolKind.to(S.kind),S.containerName||"",new w.Location(l[0],C.Range.to(S.range)));return c.detail=S.detail,c.range=c.location.range,c.selectionRange=C.Range.to(S.selectionRange),c.children=S.children?S.children.map(d.to):[],c}}return a.map(d.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(C.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(C.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(C.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",I(C.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",I(C.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(l=>w.Position.isPosition(l)),a=>a.map(C.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(l=>{let d;for(const m of l.reverse())d=new w.SelectionRange(C.Range.to(m),d);return d}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(C.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(C.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(C.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(C.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:C.Range.to(a.range),placeholder:a.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return C.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(C.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new w.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const l=(0,E.decodeSemanticTokensDto)(a);if(l.type==="full")return new w.SemanticTokens(l.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new w.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const l=(0,E.decodeSemanticTokensDto)(a);if(l.type==="full")return new w.SemanticTokens(l.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,l,d)=>{if(!a)return new w.CompletionList([]);const m=a.suggestions.map(S=>C.CompletionItem.to(S,d));return new w.CompletionList(m,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return C.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,l,d)=>I(m=>new w.CodeLens(C.Range.to(m.range),m.command&&d.fromInternal(m.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>w.Range.isRange(a),a=>w.Selection.isSelection(a)?C.Selection.from(a):C.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,l,d)=>I(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(m.command)}else{const S=new w.CodeAction(m.title,m.kind?new w.CodeActionKind(m.kind):void 0);return m.edit&&(S.edit=C.WorkspaceEdit.to(m.edit)),m.command&&(S.command=d.fromInternal(m.command)),S.isPreferred=m.isPreferred,S}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(l=>new w.ColorInformation(C.Range.to(l.range),C.Color.to(l.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof w.Color,C.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:C.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(C.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(a,l,d)=>a.map(C.InlayHint.to.bind(void 0,d)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",I(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(l=>C.NotebookExclusiveDocumentPattern.to(l))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(C.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",a=>r.URI.isUri(a)||typeof a=="string"&&(0,P.matchesSomeScheme)(a,R.Schemas.http,R.Schemas.https),a=>a),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[C.ViewColumn.from(a),void 0]:[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[C.ViewColumn.from(a),void 0]:[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(C.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(C.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(C.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void),new y.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[y.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],y.ApiCommandResult.Void)];class g{static register(l){b.forEach(l.registerApiCommand,l)}}e.ExtHostApiCommands=g;function I(a){return l=>{if(Array.isArray(l))return l.map(a)}}function p(a){if(!Array.isArray(a))return;const l=[];for(const d of a)F.isLocationLink(d)?l.push(C.DefinitionLink.to(d)):l.push(C.location.to(d));return l}}),define(Ce[195],Ie([1,0,15,57,4,7,2,68,27,8,6,28,5]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function I(p,a,l){const d=p.getProxy(g.MainContext.MainThreadComments);class m{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const o=this._commentControllers.get(h.handle);return o?o.value:h}else if(h&&h.$mid===7){const o=this._commentControllers.get(h.commentControlHandle);if(!o)return h;const f=o.getCommentThread(h.commentThreadHandle);return f?f.value:h}else if(h&&h.$mid===8){const o=this._commentControllers.get(h.thread.commentControlHandle);if(!o)return h;const f=o.getCommentThread(h.thread.commentThreadHandle);return f?{thread:f.value,text:h.text}:h}else if(h&&h.$mid===9){const o=this._commentControllers.get(h.thread.commentControlHandle);if(!o)return h;const f=o.getCommentThread(h.thread.commentThreadHandle);if(!f)return h;const v=h.commentUniqueId,T=f.getCommentByUniqueId(v);return T||h}else if(h&&h.$mid===10){const o=this._commentControllers.get(h.thread.commentControlHandle);if(!o)return h;const f=o.getCommentThread(h.thread.commentThreadHandle);if(!f)return h;const v=h.text,T=h.commentUniqueId,M=f.getCommentByUniqueId(T);return M?(typeof M.body=="string"?M.body=v:M.body.value=v,M):h}return h}})}createCommentController(h,o,f){const v=m.handlePool++,T=new c(h,v,o,f);this._commentControllers.set(T.handle,T);const M=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(h.identifier))||[];return M.push(T),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(h.identifier),M),T.value}$createCommentThreadTemplate(h,o,f){const v=this._commentControllers.get(h);!v||v.$createCommentThreadTemplate(o,f)}async $updateCommentThreadTemplate(h,o,f){const v=this._commentControllers.get(h);!v||v.$updateCommentThreadTemplate(o,f)}$deleteCommentThread(h,o){this._commentControllers.get(h)?.$deleteCommentThread(o)}$provideCommentingRanges(h,o,f){const v=this._commentControllers.get(h);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const T=l.getDocument(y.URI.revive(o));return(0,r.asPromise)(()=>v.commentingRangeProvider.provideCommentingRanges(T,f)).then(M=>M?M.map(j=>P.Range.from(j)):void 0)}$toggleReaction(h,o,f,v,T){const M=this._commentControllers.get(h);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const j=M.getCommentThread(o);if(j){const U=j.getCommentByUniqueId(v.uniqueIdInThread);if(M!==void 0&&U&&M.reactionHandler)return M.reactionHandler(U,u(T))}return Promise.resolve(void 0)})}dispose(){}}m.handlePool=0;class S{set threadId(h){this._id=h}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(h){h.isEqual(this._range)||(this._range=h,this.modifications.range=h,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(h){this._canReply!==h&&(this._canReply=h,this.modifications.canReply=h,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(h){this._label=h,this.modifications.label=h,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(h){this._contextValue=h,this.modifications.contextValue=h,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(h){this._comments=h,this.modifications.comments=h,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(h){this._collapseState=h,this.modifications.collapsibleState=h,this._onDidUpdateCommentThread.fire()}get state(){return(0,b.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(h){(0,b.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=h,this.modifications.state=h,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(h,o,f,v,T,M,j,U){this._commentControllerHandle=o,this._id=f,this._uri=v,this._range=T,this._comments=M,this.extensionDescription=j,this._isTemplate=U,this.handle=S._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new F.MutableDisposable,this._acceptInputDisposables.value=new F.DisposableStore,this._id===void 0&&(this._id=`${h}.${this.handle}`),d.$createCommentThread(o,this.handle,this._id,this._uri,P.Range.from(this._range),j.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=M,this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(o,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range($){D.range=$},get comments(){return D.comments},set comments($){D.comments=$},get collapsibleState(){return D.collapsibleState},set collapsibleState($){D.collapsibleState=$},get canReply(){return D.canReply},set canReply($){D.canReply=$},get contextValue(){return D.contextValue},set contextValue($){D.contextValue=$},get label(){return D.label},set label($){D.label=$},get state(){return D.state},set state($){D.state=$},dispose:()=>{D.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new F.DisposableStore);const h=f=>Object.prototype.hasOwnProperty.call(this.modifications,f),o={};h("range")&&(o.range=P.Range.from(this._range)),h("label")&&(o.label=this.label),h("contextValue")&&(o.contextValue=this.contextValue??null),h("comments")&&(o.comments=this._comments.map(f=>_(this,f,this._commentsMap))),h("collapsibleState")&&(o.collapseState=i(this._collapseState)),h("canReply")&&(o.canReply=this.canReply),h("state")&&(o.state=n(this._state)),h("isTemplate")&&(o.isTemplate=this._isTemplate),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(h){for(const o of this._commentsMap){const f=o[0],v=o[1];if(h===v)return f}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(h=>h.dispose())}}S._handlePool=0,$e([(0,C.debounce)(100)],S.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(h){this._commentingRangeProvider=h,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(h){this._reactionHandler=h,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this._options}set options(h){this._options=h,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(h,o,f,v){this._extension=h,this._handle=o,this._id=f,this._label=v,this._threads=new Map,d.$registerCommentController(this.handle,f,v);const T=this;this.value=Object.freeze({id:T.id,label:T.label,get options(){return T.options},set options(M){T.options=M},get commentingRangeProvider(){return T.commentingRangeProvider},set commentingRangeProvider(M){T.commentingRangeProvider=M},get reactionHandler(){return T.reactionHandler},set reactionHandler(M){T.reactionHandler=M},createCommentThread(M,j,U){return T.createCommentThread(M,j,U).value},dispose:()=>{T.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(h,o,f,v){if(typeof h=="string"){const T=new S(this.id,this.handle,h,o,f,v,this._extension,!1);return this._threads.set(T.handle,T),T}else{const T=new S(this.id,this.handle,void 0,h,o,f,this._extension,!1);return this._threads.set(T.handle,T),T}}$createCommentThreadTemplate(h,o){const f=new S(this.id,this.handle,void 0,y.URI.revive(h),P.Range.to(o),[],this._extension,!0);return f.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(h,o){const f=this._threads.get(h);f&&(f.range=P.Range.to(o))}$deleteCommentThread(h){this._threads.get(h)?.dispose(),this._threads.delete(h)}getCommentThread(h){return this._threads.get(h)}dispose(){this._threads.forEach(h=>{h.dispose()}),this._localDisposables.forEach(h=>h.dispose())}}function _(s,h,o){let f=o.get(h);f||(f=++s.commentHandle,o.set(h,f));const v=h.author&&h.author.iconPath?h.author.iconPath.toString():void 0;return{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:f,body:typeof h.body=="string"?h.body:P.MarkdownString.from(h.body),userName:h.author.name,userIconPath:v,label:h.label,commentReactions:h.reactions?h.reactions.map(T=>t(T)):void 0,timestamp:h.timestamp?.toJSON()}}function t(s){return{label:s.label,iconPath:s.iconPath?P.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function u(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?y.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function i(s){if(s!==void 0)switch(s){case R.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function n(s){if(s!==void 0)switch(s){case R.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new m}e.createExtHostComments=I}),define(Ce[196],Ie([1,0,24,5,26,14]),function(ne,e,r,C,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let y=class{constructor(R,b){this._mainThreadConsole=R.getProxy(C.MainContext.MainThreadConsole),this._includeStack=b.consoleForward.includeStack,this._logNative=b.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,b){const g=this,I=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){g._handleConsoleCall(R,b,I,arguments)}})}_handleConsoleCall(R,b,g,I){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:b,arguments:E(I,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,g,I)}};y=$e([xe(0,F.IExtHostRpcService),xe(1,w.IExtHostInitDataService)],y),e.AbstractExtHostConsoleForwarder=y;const A=1e5;function E(P,R){const b=[];if(P.length)for(let g=0;g<P.length;g++){let I=P[g];if(typeof I>"u")I="undefined";else if(I instanceof Error){const p=I;p.stack?I=p.stack:I=p.toString()}b.push(I)}if(R){const g=new Error().stack;g&&b.push({__$stack:g.split(`
`).slice(3).join(`
`)})}try{const g=(0,r.safeStringify)(b);return g.length>A?"Output omitted for a large object that exceeds the limits":g}catch(g){return`Output omitted for an object that cannot be inspected ('${g.toString()}')`}}}),define(Ce[97],Ie([1,0,2,5,6,3,14,11,18,9,19]),function(ne,e,r,C,w,F,y,A,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class Oi{constructor(I,p){this._logService=p,this._provider=new Map,this._proxy=I.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(I,p){const a=Oi._handlePool++;this._provider.set(a,{provider:I,extensionId:p}),this._proxy.$registerDecorationProvider(a,p.value);const l=I.onDidChangeFileDecorations&&I.onDidChangeFileDecorations(d=>{if(!d){this._proxy.$onDidChange(a,null);return}const m=(0,E.asArray)(d);if(m.length<=Oi._maxEventSize){this._proxy.$onDidChange(a,m);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",p.value,m.length);const S=m.map(t=>({uri:t,rank:(0,P.count)(t.path,"/")})),c=(0,E.groupBy)(S,(t,u)=>t.rank-u.rank||(0,P.compare)(t.uri.path,u.uri.path)),_=[];e:for(const t of c){let u;for(const i of t){const n=(0,R.dirname)(i.uri.path);if(u!==n&&(u=n,_.push(i.uri)>=Oi._maxEventSize))break e}}this._proxy.$onDidChange(a,_)});return new w.Disposable(()=>{l?.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(I,p,a){if(!this._provider.has(I))return Object.create(null);const l=Object.create(null),{provider:d,extensionId:m}=this._provider.get(I);return await Promise.all(p.map(async S=>{try{const{uri:c,id:_}=S,t=await Promise.resolve(d.provideFileDecoration(r.URI.revive(c),a));if(!t)return;try{w.FileDecoration.validate(t),l[_]=[t.propagate,t.tooltip,t.badge,t.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${m.value}': ${u}`)}}catch(c){this._logService.error(c)}})),l}};b._handlePool=0,b._maxEventSize=250,b=$e([xe(0,y.IExtHostRpcService),xe(1,A.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,F.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(ne,r):w?w.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!C:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ne):C?C.value:e.get(ne)};define(Ce[197],Ie([1,0,130,84,2,5,6,8,4,11,25,36]),function(ne,e,r,C,w,F,y,A,E,P,R,b){"use strict";var g,I,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class a{constructor(m,S,c,_,t,u){this._name=m,this._owner=S,this._maxDiagnosticsPerFile=c,g.set(this,void 0),I.set(this,void 0),p.set(this,void 0),this._isDisposed=!1,Ye(this,p,new R.ResourceMap(i=>_.getComparisonKey(i)),"f"),Ye(this,g,t,"f"),Ye(this,I,u,"f")}dispose(){this._isDisposed||(Oe(this,I,"f").fire([...Oe(this,p,"f").keys()]),Oe(this,g,"f")?.$clear(this._owner),Oe(this,p,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(m,S){if(!m){this.clear();return}this._checkDisposed();let c=[];if(w.URI.isUri(m)){if(!S){this.delete(m);return}Oe(this,p,"f").set(m,S.slice()),c=[m]}else if(Array.isArray(m)){c=[];let t;m=[...m].sort(a._compareIndexedTuplesByUri);for(const u of m){const[i,n]=u;if((!t||i.toString()!==t.toString())&&(t&&Oe(this,p,"f").get(t).length===0&&Oe(this,p,"f").delete(t),t=i,c.push(i),Oe(this,p,"f").set(i,[])),n)Oe(this,p,"f").get(i)?.push(...n);else{const s=Oe(this,p,"f").get(i);s&&(s.length=0)}}}if(Oe(this,I,"f").fire(c),!Oe(this,g,"f"))return;const _=[];for(const t of c){let u=[];const i=Oe(this,p,"f").get(t);if(i)if(i.length>this._maxDiagnosticsPerFile){u=[];const n=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const h of i)if(h.severity===n[s]&&u.push(A.Diagnostic.from(h))===this._maxDiagnosticsPerFile)break e;u.push({severity:C.MarkerSeverity.Info,message:(0,r.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=i.map(n=>A.Diagnostic.from(n));_.push([t,u])}Oe(this,g,"f").$changeMany(this._owner,_)}delete(m){this._checkDisposed(),Oe(this,I,"f").fire([m]),Oe(this,p,"f").delete(m),Oe(this,g,"f")?.$changeMany(this._owner,[[m,void 0]])}clear(){this._checkDisposed(),Oe(this,I,"f").fire([...Oe(this,p,"f").keys()]),Oe(this,p,"f").clear(),Oe(this,g,"f")?.$clear(this._owner)}forEach(m,S){this._checkDisposed();for(const[c,_]of this)m.call(S,c,_,this)}*[(g=new WeakMap,I=new WeakMap,p=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const m of Oe(this,p,"f").keys())yield[m,this.get(m)]}get(m){this._checkDisposed();const S=Oe(this,p,"f").get(m);return Array.isArray(S)?Object.freeze(S.slice(0)):[]}has(m){return this._checkDisposed(),Array.isArray(Oe(this,p,"f").get(m))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(m,S){return m[0].toString()<S[0].toString()?-1:m[0].toString()>S[0].toString()?1:0}}e.DiagnosticCollection=a;let l=class li{static _mapper(m){const S=new R.ResourceMap;for(const c of m)S.set(c,c);return{uris:Object.freeze(Array.from(S.values()))}}constructor(m,S,c){this._logService=S,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,li._mapper),this._proxy=m.getProxy(F.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(m,S){const{_collections:c,_proxy:_,_onDidChangeDiagnostics:t,_logService:u,_fileSystemInfoService:i}=this,n=new class{$changeMany(o,f){_.$changeMany(o,f),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,o,f.length===0?"CLEARING":f)}$clear(o){_.$clear(o),u.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,o)}dispose(){_.dispose()}};let s;if(!S)S="_generated_diagnostic_collection_name_#"+li._idPool++,s=S;else if(!c.has(S))s=S;else{this._logService.warn(`DiagnosticCollection with name '${S}' does already exist.`);do s=S+li._idPool++;while(c.has(s))}return new class extends a{constructor(){super(S,s,li._maxDiagnosticsPerFile,i.extUri,n,t),c.set(s,this)}dispose(){super.dispose(),c.delete(s)}}}getDiagnostics(m){if(m)return this._getDiagnostics(m);{const S=new Map,c=[];for(const _ of this._collections.values())_.forEach((t,u)=>{let i=S.get(t.toString());typeof i>"u"&&(i=c.length,S.set(t.toString(),i),c.push([t,[]])),c[i][1]=c[i][1].concat(...u)});return c}}_getDiagnostics(m){let S=[];for(const c of this._collections.values())c.has(m)&&(S=S.concat(c.get(m)));return S}$acceptMarkersChange(m){if(!this._mirrorCollection){const S="_generated_mirror",c=new a(S,S,li._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(S,c),this._mirrorCollection=c}for(const[S,c]of m)this._mirrorCollection.set(w.URI.revive(S),c.map(A.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=$e([xe(1,P.ILogService),xe(2,b.IExtHostFileSystemInfo)],l),e.ExtHostDiagnostics=l}),define(Ce[198],Ie([1,0,2,5]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(y){this._proxy=y.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(A=>A?A.map(E=>r.URI.revive(E)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(A=>A?r.URI.revive(A):void 0)}}e.ExtHostDialogs=w}),define(Ce[199],Ie([1,0,12,2,6,5,13,21,9]),function(ne,e,r,C,w,F,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(b,g,I){this._documentsAndEditors=g,this._logService=I,this._documentContentProviders=new Map,this._proxy=b.getProxy(F.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,g){if(Object.keys(y.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const I=P._handlePool++;this._documentContentProviders.set(I,g),this._proxy.$registerTextContentProvider(I,b);let p;return typeof g.onDidChange=="function"&&(p=g.onDidChange(a=>{if(a.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(I,a).then(l=>{if(!l&&typeof l!="string")return;const d=this._documentsAndEditors.getDocument(a);if(!d)return;const m=(0,E.splitLines)(l);if(!d.equalLines(m))return this._proxy.$onVirtualDocumentChange(a,l)},r.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(I)&&this._proxy.$unregisterTextContentProvider(I),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(b,g){const I=this._documentContentProviders.get(b);return I?Promise.resolve(I.provideTextDocumentContent(C.URI.revive(g),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(Ce[200],Ie([1,0,4,7,2,5,93,8,10,24,6]),function(ne,e,r,C,w,F,y,A,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(I,p){this._onDidAddDocument=new r.Emitter,this._onDidRemoveDocument=new r.Emitter,this._onDidChangeDocument=new r.Emitter,this._onDidSaveDocument=new r.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new C.DisposableStore,this._documentLoader=new Map,this._proxy=I.getProxy(F.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const l of a)this._onDidRemoveDocument.fire(l.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const l of a)this._onDidAddDocument.fire(l.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(I){if(!I)return;const p=this._documentsAndEditors.getDocument(I);if(p)return p}getDocument(I){const p=this.getDocumentData(I);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${I}'`);return p.document}ensureDocumentData(I){const p=this._documentsAndEditors.getDocument(I);if(p)return Promise.resolve(p);let a=this._documentLoader.get(I.toString());return a||(a=this._proxy.$tryOpenDocument(I).then(l=>{this._documentLoader.delete(I.toString());const d=w.URI.revive(l);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(d))},l=>(this._documentLoader.delete(I.toString()),Promise.reject(l))),this._documentLoader.set(I.toString(),a)),a}createDocumentData(I){return this._proxy.$tryCreateDocument(I).then(p=>w.URI.revive(p))}$acceptModelLanguageChanged(I,p){const a=w.URI.revive(I),l=this._documentsAndEditors.getDocument(a);if(!l)throw new Error("unknown document");this._onDidRemoveDocument.fire(l.document),l._acceptLanguageId(p),this._onDidAddDocument.fire(l.document)}$acceptModelSaved(I){const p=w.URI.revive(I),a=this._documentsAndEditors.getDocument(p);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(I,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(I,p){const a=w.URI.revive(I),l=this._documentsAndEditors.getDocument(a);if(!l)throw new Error("unknown document");l._acceptIsDirty(p),this._onDidChangeDocument.fire({document:l.document,contentChanges:[],reason:void 0})}$acceptModelChanged(I,p,a){const l=w.URI.revive(I),d=this._documentsAndEditors.getDocument(l);if(!d)throw new Error("unknown document");d._acceptIsDirty(a),d.onEvents(p);let m;p.isUndoing?m=R.TextDocumentChangeReason.Undo:p.isRedoing&&(m=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:d.document,contentChanges:p.changes.map(S=>({range:A.Range.to(S.range),rangeOffset:S.rangeOffset,rangeLength:S.rangeLength,text:S.text})),reason:m}))}setWordDefinitionFor(I,p){(0,y.setWordDefinitionFor)(I,p)}}e.ExtHostDocuments=b}),define(Ce[52],Ie([1,0,46,4,7,2,3,5,93,14,96,8,11,25,13,170,201]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let m=class{constructor(c,_){this._extHostRpc=c,this._logService=_,this._activeEditorId=null,this._editors=new Map,this._documents=new I.ResourceMap,this._onDidAddDocuments=new C.Emitter,this._onDidRemoveDocuments=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const _=[],t=[],u=[];if(c.removedDocuments)for(const i of c.removedDocuments){const n=F.URI.revive(i),s=this._documents.get(n);s?.unref()&&(this._documents.delete(n),_.push(s.value))}if(c.addedDocuments)for(const i of c.addedDocuments){const n=F.URI.revive(i.uri);let s=this._documents.get(n);if(s&&n.scheme!==p.Schemas.vscodeNotebookCell&&n.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);s||(s=new d(new E.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),n,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this._documents.set(n,s),t.push(s.value)),s.ref()}if(c.removedEditors)for(const i of c.removedEditors){const n=this._editors.get(i);this._editors.delete(i),n&&u.push(n)}if(c.addedEditors)for(const i of c.addedEditors){const n=F.URI.revive(i.documentUri);r.ok(this._documents.has(n),`document '${n}' does not exist`),r.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const s=this._documents.get(n).value,h=new R.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new l.Lazy(()=>s.document),i.selections.map(b.Selection.to),i.options,i.visibleRanges.map(o=>b.Range.to(o)),typeof i.editorPosition=="number"?b.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,h)}c.newActiveEditor!==void 0&&(r.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,w.dispose)(_),(0,w.dispose)(u),c.removedDocuments&&this._onDidRemoveDocuments.fire(_),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return a.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const _=this._editors.get(this._activeEditorId);return c?_:_?.value}allEditors(){return[...this._editors.values()]}};m=$e([xe(0,P.IExtHostRpcService),xe(1,g.ILogService)],m),e.ExtHostDocumentsAndEditors=m,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[53],Ie([1,0,8,5,2,4,3,6,14,10,75]),function(ne,e,r,C,w,F,y,A,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");class b{constructor(l,d,m){this._activeTabIdGetter=m,this._parentGroup=d,this.acceptDtoUpdate(l)}get apiObject(){if(!this._apiObject){const l=this,d={get isActive(){return l._dto.id===l._activeTabIdGetter()},get label(){return l._dto.label},get input(){return l._input},get isDirty(){return l._dto.isDirty},get isPinned(){return l._dto.isPinned},get isPreview(){return l._dto.isPreview},get group(){return l._parentGroup.apiObject}};this._apiObject=Object.freeze(d)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(l){this._dto=l,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(w.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(w.URI.revive(this._dto.input.original),w.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(w.URI.revive(this._dto.input.base),w.URI.revive(this._dto.input.input1),w.URI.revive(this._dto.input.input2),w.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(w.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(w.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(w.URI.revive(this._dto.input.original),w.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(w.URI.revive(this._dto.input.uri),w.URI.revive(this._dto.input.inputBoxUri));default:return}}}class g{constructor(l,d){this._tabs=[],this._activeTabId="",this._dto=l,this._activeGroupIdGetter=d;for(const m of l.tabs)m.isActive&&(this._activeTabId=m.id),this._tabs.push(new b(m,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const l=this,d={get isActive(){return l._dto.groupId===l._activeGroupIdGetter()},get viewColumn(){return r.ViewColumn.to(l._dto.viewColumn)},get activeTab(){return l._tabs.find(m=>m.tabId===l._activeTabId)?.apiObject},get tabs(){return Object.freeze(l._tabs.map(m=>m.apiObject))}};this._apiObject=Object.freeze(d)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(l){this._dto=l}acceptTabOperation(l){if(l.kind===0){const m=new b(l.tabDto,this,()=>this.activeTabId());return this._tabs.splice(l.index,0,m),l.tabDto.isActive&&(this._activeTabId=m.tabId),m}else if(l.kind===1){const m=this._tabs.splice(l.index,1)[0];if(!m)throw new Error(`Tab close updated received for index ${l.index} which does not exist`);return m.tabId===this._activeTabId&&(this._activeTabId=""),m}else if(l.kind===3){if(l.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const m=this._tabs.splice(l.oldIndex,1)[0];if(!m)throw new Error(`Tab move updated received for index ${l.oldIndex} which does not exist`);return this._tabs.splice(l.index,0,m),m}const d=this._tabs.find(m=>m.tabId===l.tabDto.id);if(!d)throw new Error("INVALID tab");return l.tabDto.isActive?this._activeTabId=l.tabDto.id:this._activeTabId===l.tabDto.id&&!l.tabDto.isActive&&(this._activeTabId=""),d.acceptDtoUpdate(l.tabDto),d}activeTabId(){return this._activeTabId}}let I=class{constructor(l){this._onDidChangeTabs=new F.Emitter,this._onDidChangeTabGroups=new F.Emitter,this._extHostTabGroups=[],this._proxy=l.getProxy(C.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const l=this,d={onDidChangeTabGroups:l._onDidChangeTabGroups.event,onDidChangeTabs:l._onDidChangeTabs.event,get all(){return Object.freeze(l._extHostTabGroups.map(m=>m.apiObject))},get activeTabGroup(){const m=l._activeGroupId;return(0,P.assertIsDefined)(l._extHostTabGroups.find(c=>c.groupId===m)?.apiObject)},close:async(m,S)=>{const c=Array.isArray(m)?m:[m];return c.length?p(c[0])?this._closeGroups(c,S):this._closeTabs(c,S):!0}};this._apiObject=Object.freeze(d)}return this._apiObject}$acceptEditorTabModel(l){const d=new Set(this._extHostTabGroups.map(i=>i.groupId)),m=new Set(l.map(i=>i.groupId)),S=(0,R.diffSets)(d,m),c=this._extHostTabGroups.filter(i=>S.removed.includes(i.groupId)).map(i=>i.apiObject),_=[],t=[];this._extHostTabGroups=l.map(i=>{const n=new g(i,()=>this._activeGroupId);return S.added.includes(n.groupId)?_.push(n.apiObject):t.push(n.apiObject),n});const u=(0,P.assertIsDefined)(l.find(i=>i.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:_,closed:c,changed:t}))}$acceptTabGroupUpdate(l){const d=this._extHostTabGroups.find(m=>m.groupId===l.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(l),l.isActive&&(this._activeGroupId=l.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(l){const d=this._extHostTabGroups.find(S=>S.groupId===l.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const m=d.acceptTabOperation(l);switch(l.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[m.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[m.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[m.apiObject]}));return}}_findExtHostTabFromApi(l){for(const d of this._extHostTabGroups)for(const m of d.tabs)if(m.apiObject===l)return m}_findExtHostTabGroupFromApi(l){return this._extHostTabGroups.find(d=>d.apiObject===l)}async _closeTabs(l,d){const m=[];for(const S of l){const c=this._findExtHostTabFromApi(S);if(!c)throw new Error("Tab close: Invalid tab not found!");m.push(c.tabId)}return this._proxy.$closeTab(m,d)}async _closeGroups(l,d){const m=[];for(const S of l){const c=this._findExtHostTabGroupFromApi(S);if(!c)throw new Error("Group close: Invalid group not found!");m.push(c.groupId)}return this._proxy.$closeGroup(m,d)}};I=$e([xe(0,E.IExtHostRpcService)],I),e.ExtHostEditorTabs=I;function p(a){return a.tabs!==void 0}}),define(Ce[202],Ie([1,0,2,5,7,6,8,247,9,23,28]),function(ne,e,r,C,w,F,y,A,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class b{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const a=this._schemes.indexOf(p);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),a=[];let l,d,m=14,S=14;for(const c of p){let _=l?(0,E.commonPrefixLength)(l,c):0;for(_===0?d=1:d=S;_<c.length;_++)_+1===c.length?(m=S,S=9):S+=1,a.push([d,c.toUpperCase().charCodeAt(_),S]),a.push([d,c.toLowerCase().charCodeAt(_),S]),d=S;l=c,S=m}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new A.StateMachine(a)}}provideDocumentLinks(p){this._initStateMachine();const a=[],l=A.LinkComputer.computeLinks({getLineContent(d){return p.lineAt(d-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const d of l){const m=y.DocumentLink.to(d);m.target&&a.push(m)}return a}}class g{constructor(p,a){this._extHostLanguageFeatures=a,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(p,a,l,d={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(p,"*",this._linkProvider));const m=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(m,l);let S=2;d.isCaseSensitive&&(S+=1024),d.isReadonly&&(S+=2048),typeof l.copy=="function"&&(S+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&((0,R.checkProposedApiEnabled)(p,"fsChunks"),S+=4),this._proxy.$registerFileSystemProvider(m,a,S).catch(_=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${a}`),console.error(_)});const c=l.onDidChangeFile(_=>{const t=[];for(const u of _){const{uri:i,type:n}=u;if(i.scheme!==a)continue;let s;switch(n){case F.FileChangeType.Changed:s=0;break;case F.FileChangeType.Created:s=1;break;case F.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:i,type:s})}this._proxy.$onFileSystemChange(m,t)});return(0,w.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(m),this._proxy.$unregisterProvider(m)})}static _asIStat(p){const{type:a,ctime:l,mtime:d,size:m,permissions:S}=p;return{type:a,ctime:l,mtime:d,size:m,permissions:S}}$stat(p,a){return Promise.resolve(this._getFsProvider(p).stat(r.URI.revive(a))).then(l=>g._asIStat(l))}$readdir(p,a){return Promise.resolve(this._getFsProvider(p).readDirectory(r.URI.revive(a)))}$readFile(p,a){return Promise.resolve(this._getFsProvider(p).readFile(r.URI.revive(a))).then(l=>P.VSBuffer.wrap(l))}$writeFile(p,a,l,d){return Promise.resolve(this._getFsProvider(p).writeFile(r.URI.revive(a),l.buffer,d))}$delete(p,a,l){return Promise.resolve(this._getFsProvider(p).delete(r.URI.revive(a),l))}$rename(p,a,l,d){return Promise.resolve(this._getFsProvider(p).rename(r.URI.revive(a),r.URI.revive(l),d))}$copy(p,a,l,d){const m=this._getFsProvider(p);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(r.URI.revive(a),r.URI.revive(l),d))}$mkdir(p,a){return Promise.resolve(this._getFsProvider(p).createDirectory(r.URI.revive(a)))}$watch(p,a,l,d){const m=this._getFsProvider(p).watch(r.URI.revive(l),d);this._watches.set(a,m)}$unwatch(p,a){const l=this._watches.get(a);l&&(l.dispose(),this._watches.delete(a))}$open(p,a,l){const d=this._getFsProvider(p);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(r.URI.revive(a),l))}$close(p,a){const l=this._getFsProvider(p);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(a))}$read(p,a,l,d){const m=this._getFsProvider(p);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const S=P.VSBuffer.alloc(d);return Promise.resolve(m.read(a,l,S.buffer,0,d)).then(c=>S.slice(0,c))}$write(p,a,l,d){const m=this._getFsProvider(p);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(a,l,d.buffer,0,d.byteLength))}_getFsProvider(p){const a=this._fsProvider.get(p);if(!a){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return a}}e.ExtHostFileSystem=g}),define(Ce[54],Ie([1,0,5,35,6,23,3,14,36,7]),function(ne,e,r,C,w,F,y,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Yt{constructor(g,I){this._fileSystemProvider=new Map,this._proxy=g.getProxy(r.MainContext.MainThreadFileSystem);const p=this;this.value=Object.freeze({async stat(a){try{const l=p._fileSystemProvider.get(a.scheme);if(!l)return await p._proxy.$stat(a);await p._proxy.$ensureActivation(a.scheme);const d=await l.stat(a);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions}}catch(l){Yt._handleError(l)}},async readDirectory(a){try{const l=p._fileSystemProvider.get(a.scheme);return l?(await p._proxy.$ensureActivation(a.scheme),(await l.readDirectory(a)).slice()):await p._proxy.$readdir(a)}catch(l){return Yt._handleError(l)}},async createDirectory(a){try{return await p._proxy.$mkdir(a)}catch(l){return Yt._handleError(l)}},async readFile(a){try{const l=p._fileSystemProvider.get(a.scheme);return l?(await p._proxy.$ensureActivation(a.scheme),(await l.readFile(a)).slice()):(await p._proxy.$readFile(a)).buffer}catch(l){return Yt._handleError(l)}},async writeFile(a,l){try{return await p._proxy.$writeFile(a,F.VSBuffer.wrap(l))}catch(d){return Yt._handleError(d)}},async delete(a,l){try{const d=p._fileSystemProvider.get(a.scheme);return d?(await p._proxy.$ensureActivation(a.scheme),await d.delete(a,{recursive:!1,...l})):await p._proxy.$delete(a,{recursive:!1,useTrash:!1,...l})}catch(d){return Yt._handleError(d)}},async rename(a,l,d){try{return await p._proxy.$rename(a,l,{overwrite:!1,...d})}catch(m){return Yt._handleError(m)}},async copy(a,l,d){try{return await p._proxy.$copy(a,l,{overwrite:!1,...d})}catch(m){return Yt._handleError(m)}},isWritableFileSystem(a){const l=I.getCapabilities(a);if(typeof l=="number")return!(l&2048)}})}static _handleError(g){if(g instanceof w.FileSystemError)throw g;if(!(g instanceof Error))throw new w.FileSystemError(String(g));if(g.name==="ENOPRO")throw w.FileSystemError.Unavailable(g.message);switch(g.name){case C.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(g.message);case C.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(g.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(g.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(g.message);case C.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(g.message);case C.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(g.message);default:throw new w.FileSystemError(g.message,g.name)}}addFileSystemProvider(g,I){return this._fileSystemProvider.set(g,I),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(g))}};R=$e([xe(0,A.IExtHostRpcService),xe(1,E.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[203],Ie([1,0,4,34,2,5,8,6]),function(ne,e,r,C,w,F,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(b,g,I,p,a,l,d,m){this._onDidCreate=new r.Emitter,this._onDidChange=new r.Emitter,this._onDidDelete=new r.Emitter;const S=this.ensureWatching(b,I,a);this._config=0,l&&(this._config+=1),d&&(this._config+=2),m&&(this._config+=4);const c=(0,C.parse)(a),_=typeof a=="string",t=p(u=>{if(!l)for(const i of u.created){const n=w.URI.revive(i);c(n.fsPath)&&(!_||g.getWorkspaceFolder(n))&&this._onDidCreate.fire(n)}if(!d)for(const i of u.changed){const n=w.URI.revive(i);c(n.fsPath)&&(!_||g.getWorkspaceFolder(n))&&this._onDidChange.fire(n)}if(!m)for(const i of u.deleted){const n=w.URI.revive(i);c(n.fsPath)&&(!_||g.getWorkspaceFolder(n))&&this._onDidDelete.fire(n)}});this._disposable=A.Disposable.from(S,this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(b,g,I){const p=A.Disposable.from();if(typeof I=="string")return p;const a=b.getProxy(F.MainContext.MainThreadFileSystem);let l=!1;(I.pattern.includes(C.GLOBSTAR)||I.pattern.includes(C.GLOB_SPLIT))&&(l=!0);const d=Math.random();return a.$watch(g.identifier.value,d,I.baseUri,{recursive:l,excludes:[]}),A.Disposable.from({dispose:()=>a.$unwatch(d)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(b,g,I){this._mainContext=b,this._logService=g,this._extHostDocumentsAndEditors=I,this._onFileSystemEvent=new r.Emitter,this._onDidRenameFile=new r.Emitter,this._onDidCreateFile=new r.Emitter,this._onDidDeleteFile=new r.Emitter,this._onWillRenameFile=new r.AsyncEmitter,this._onWillCreateFile=new r.AsyncEmitter,this._onWillDeleteFile=new r.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(b,g,I,p,a,l){return new E(this._mainContext,b,g,this._onFileSystemEvent.event,y.GlobPattern.from(I),p,a,l)}$onFileEvent(b){this._onFileSystemEvent.fire(b)}$onDidRunFileOperation(b,g){switch(b){case 2:this._onDidRenameFile.fire(Object.freeze({files:g.map(I=>({oldUri:w.URI.revive(I.source),newUri:w.URI.revive(I.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:g.map(I=>w.URI.revive(I.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:g.map(I=>w.URI.revive(I.target))}));break;default:}}getOnWillRenameFileEvent(b){return this._createWillExecuteEvent(b,this._onWillRenameFile)}getOnWillCreateFileEvent(b){return this._createWillExecuteEvent(b,this._onWillCreateFile)}getOnWillDeleteFileEvent(b){return this._createWillExecuteEvent(b,this._onWillDeleteFile)}_createWillExecuteEvent(b,g){return(I,p,a)=>{const l=function(m){I.call(p,m)};return l.extension=b,g.event(l,void 0,a)}}async $onWillRunFileOperation(b,g,I,p){switch(b){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:g.map(a=>({oldUri:w.URI.revive(a.source),newUri:w.URI.revive(a.target)}))},I,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:g.map(a=>w.URI.revive(a.target))},I,p);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:g.map(a=>w.URI.revive(a.target))},I,p)}}async _fireWillEvent(b,g,I,p){const a=new Set,l=[];if(await b.fireAsync(g,p,async(m,S)=>{const c=Date.now(),_=await Promise.resolve(m);_ instanceof A.WorkspaceEdit&&(l.push([S.extension,_]),a.add(S.extension.displayName??S.extension.identifier.value)),Date.now()-c>I&&this._logService.warn("SLOW file-participant",S.extension.identifier)}),p.isCancellationRequested||l.length===0)return;const d={edits:[]};for(const[,m]of l){const{edits:S}=y.WorkspaceEdit.from(m,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});d.edits=d.edits.concat(S)}return{edit:d,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=P}),define(Ce[204],Ie([1,0,2,37]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(y,A,E,P,R){this._extHostNotebooks=A,this._textDocumentsAndEditors=E,this._commands=P;const b=new C.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.ApiCommandArgument("showOptions","Show Options",g=>!0,g=>g),new C.ApiCommandArgument("resource","Interactive resource Uri",g=>!0,g=>g),new C.ApiCommandArgument("controllerId","Notebook controller Id",g=>!0,g=>g),new C.ApiCommandArgument("title","Interactive editor title",g=>!0,g=>g)],new C.ApiCommandResult("Notebook and input URI",g=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",g.notebookEditorId),g.notebookEditorId!==void 0){const I=this._extHostNotebooks.getEditorById(g.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",I.id),{notebookUri:r.URI.revive(g.notebookUri),inputUri:r.URI.revive(g.inputUri),notebookEditor:I.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",g.notebookUri,g.inputUri),{notebookUri:r.URI.revive(g.notebookUri),inputUri:r.URI.revive(g.inputUri)}}));this._commands.registerApiCommand(b)}$willAddInteractiveDocument(y,A,E,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:E,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(r.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=w}),define(Ce[205],Ie([1,0,7,5]),function(ne,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(y){this._handlePool=0,this._proxy=y.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,y),(0,r.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=w}),define(Ce[206],Ie([1,0,2,24,8,6,68,5,9,51,18,10,248,21,7,81,76,62,207,12,15,28]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a,l,d,m,S,c,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class t{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentSymbols(k,B){const V=this._documents.getDocument(k),q=await this._provider.provideDocumentSymbols(V,B);if(!(0,R.isFalsyOrEmpty)(q))return q[0]instanceof F.DocumentSymbol?q.map(w.DocumentSymbol.from):t._asDocumentSymbolTree(q)}static _asDocumentSymbolTree(k){k=k.slice(0).sort((q,oe)=>{let ce=q.location.range.start.compareTo(oe.location.range.start);return ce===0&&(ce=oe.location.range.end.compareTo(q.location.range.end)),ce});const B=[],V=[];for(const q of k){const oe={name:q.name||"!!MISSING: name!!",kind:w.SymbolKind.from(q.kind),tags:q.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:w.Range.from(q.location.range),selectionRange:w.Range.from(q.location.range),children:[]};for(;;){if(V.length===0){V.push(oe),B.push(oe);break}const ce=V[V.length-1];if(P.Range.containsRange(ce.range,oe.range)&&!P.Range.equalsRange(ce.range,oe.range)){ce.children?.push(oe),V.push(oe);break}V.pop()}}return B}}class u{constructor(k,B,V){this._documents=k,this._commands=B,this._provider=V,this._cache=new d.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(k,B){const V=this._documents.getDocument(k),q=await this._provider.provideCodeLenses(V,B);if(!q||B.isCancellationRequested)return;const oe=this._cache.add(q),ce=new p.DisposableStore;this._disposables.set(oe,ce);const J={cacheId:oe,lenses:[]};for(let Ee=0;Ee<q.length;Ee++)J.lenses.push({cacheId:[oe,Ee],range:w.Range.from(q[Ee].range),command:this._commands.toInternal(q[Ee].command,ce)});return J}async resolveCodeLens(k,B){const V=k.cacheId&&this._cache.get(...k.cacheId);if(!V)return;let q;if(typeof this._provider.resolveCodeLens!="function"||V.isResolved?q=V:q=await this._provider.resolveCodeLens(V,B),q||(q=V),B.isCancellationRequested)return;const oe=k.cacheId&&this._disposables.get(k.cacheId[0]);if(!!oe)return k.command=this._commands.toInternal(q.command??u._badCmd,oe),k}releaseCodeLenses(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function i(Z){return Array.isArray(Z)?Z.map(w.DefinitionLink.from):Z?[w.DefinitionLink.from(Z)]:[]}class n{constructor(k,B){this._documents=k,this._provider=B}async provideDefinition(k,B,V){const q=this._documents.getDocument(k),oe=w.Position.to(B),ce=await this._provider.provideDefinition(q,oe,V);return i(ce)}}class s{constructor(k,B){this._documents=k,this._provider=B}async provideDeclaration(k,B,V){const q=this._documents.getDocument(k),oe=w.Position.to(B),ce=await this._provider.provideDeclaration(q,oe,V);return i(ce)}}class h{constructor(k,B){this._documents=k,this._provider=B}async provideImplementation(k,B,V){const q=this._documents.getDocument(k),oe=w.Position.to(B),ce=await this._provider.provideImplementation(q,oe,V);return i(ce)}}class o{constructor(k,B){this._documents=k,this._provider=B}async provideTypeDefinition(k,B,V){const q=this._documents.getDocument(k),oe=w.Position.to(B),ce=await this._provider.provideTypeDefinition(q,oe,V);return i(ce)}}class f{constructor(k,B){this._documents=k,this._provider=B}async provideHover(k,B,V){const q=this._documents.getDocument(k),oe=w.Position.to(B),ce=await this._provider.provideHover(q,oe,V);if(!(!ce||(0,R.isFalsyOrEmpty)(ce.contents)))return ce.range||(ce.range=q.getWordRangeAtPosition(oe)),ce.range||(ce.range=new F.Range(oe,oe)),w.Hover.from(ce)}}class v{constructor(k,B){this._documents=k,this._provider=B}async provideEvaluatableExpression(k,B,V){const q=this._documents.getDocument(k),oe=w.Position.to(B),ce=await this._provider.provideEvaluatableExpression(q,oe,V);if(ce)return w.EvaluatableExpression.from(ce)}}class T{constructor(k,B){this._documents=k,this._provider=B}async provideInlineValues(k,B,V,q){const oe=this._documents.getDocument(k),ce=await this._provider.provideInlineValues(oe,w.Range.to(B),w.InlineValueContext.to(V),q);if(Array.isArray(ce))return ce.map(J=>w.InlineValue.from(J))}}class M{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentHighlights(k,B,V){const q=this._documents.getDocument(k),oe=w.Position.to(B),ce=await this._provider.provideDocumentHighlights(q,oe,V);if(Array.isArray(ce))return ce.map(w.DocumentHighlight.from)}}class j{constructor(k,B){this._documents=k,this._provider=B}async provideLinkedEditingRanges(k,B,V){const q=this._documents.getDocument(k),oe=w.Position.to(B),ce=await this._provider.provideLinkedEditingRanges(q,oe,V);if(ce&&Array.isArray(ce.ranges))return{ranges:(0,R.coalesce)(ce.ranges.map(w.Range.from)),wordPattern:ce.wordPattern}}}class U{constructor(k,B){this._documents=k,this._provider=B}async provideReferences(k,B,V,q){const oe=this._documents.getDocument(k),ce=w.Position.to(B),J=await this._provider.provideReferences(oe,ce,V,q);if(Array.isArray(J))return J.map(w.location.from)}}class D{constructor(k,B,V,q,oe,ce,J){this._documents=k,this._commands=B,this._diagnostics=V,this._provider=q,this._logService=oe,this._extension=ce,this._apiDeprecation=J,this._cache=new d.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(k,B,V,q){const oe=this._documents.getDocument(k),ce=g.Selection.isISelection(B)?w.Selection.to(B):w.Range.to(B),J=[];for(const Ge of this._diagnostics.getDiagnostics(k))if(ce.intersection(Ge.range)&&J.push(Ge)>D._maxCodeActionsPerFile)break;const Ee={diagnostics:J,only:V.only?new F.CodeActionKind(V.only):void 0,triggerKind:w.CodeActionTriggerKind.to(V.trigger)},ve=await this._provider.provideCodeActions(oe,ce,Ee,q);if(!(0,R.isNonEmptyArray)(ve)||q.isCancellationRequested)return;const Ne=this._cache.add(ve),ze=new p.DisposableStore;this._disposables.set(Ne,ze);const Je=[];for(let Ge=0;Ge<ve.length;Ge++){const Pe=ve[Ge];!Pe||(D._isCommand(Pe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Je.push({_isSynthetic:!0,title:Pe.title,command:this._commands.toInternal(Pe,ze)})):(Ee.only&&(Pe.kind?Ee.only.contains(Pe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action is of kind '${Pe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Je.push({cacheId:[Ne,Ge],title:Pe.title,command:Pe.command&&this._commands.toInternal(Pe.command,ze),diagnostics:Pe.diagnostics&&Pe.diagnostics.map(w.Diagnostic.from),edit:Pe.edit&&w.WorkspaceEdit.from(Pe.edit,void 0),kind:Pe.kind&&Pe.kind.value,isPreferred:Pe.isPreferred,disabled:Pe.disabled?.reason})))}return{cacheId:Ne,actions:Je}}async resolveCodeAction(k,B){const[V,q]=k,oe=this._cache.get(V,q);if(!oe||D._isCommand(oe)||!this._provider.resolveCodeAction)return;const ce=await this._provider.resolveCodeAction(oe,B)??oe;return ce?.edit?w.WorkspaceEdit.from(ce.edit,void 0):void 0}releaseCodeActions(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}static _isCommand(k){return typeof k.command=="string"&&typeof k.title=="string"}}D._maxCodeActionsPerFile=1e3;class ${constructor(k,B,V,q){this._proxy=k,this._documents=B,this._provider=V,this._handle=q}async prepareDocumentPaste(k,B,V,q){if(!this._provider.prepareDocumentPaste)return;const oe=this._documents.getDocument(k),ce=B.map(Ee=>w.Range.to(Ee)),J=w.DataTransfer.toDataTransfer(V,()=>{throw new S.NotImplementedError});return await this._provider.prepareDocumentPaste(oe,ce,J,q),w.DataTransfer.toDataTransferDTO(J)}async providePasteEdits(k,B,V,q,oe){const ce=this._documents.getDocument(B),J=V.map(Ne=>w.Range.to(Ne)),Ee=w.DataTransfer.toDataTransfer(q,async Ne=>(await this._proxy.$resolvePasteFileData(this._handle,k,Ne)).buffer),ve=await this._provider.provideDocumentPasteEdits(ce,J,Ee,oe);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?w.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class L{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentFormattingEdits(k,B,V){const q=this._documents.getDocument(k),oe=await this._provider.provideDocumentFormattingEdits(q,B,V);if(Array.isArray(oe))return oe.map(w.TextEdit.from)}}class O{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentRangeFormattingEdits(k,B,V,q){const oe=this._documents.getDocument(k),ce=w.Range.to(B),J=await this._provider.provideDocumentRangeFormattingEdits(oe,ce,V,q);if(Array.isArray(J))return J.map(w.TextEdit.from)}}class H{constructor(k,B){this._documents=k,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(k,B,V,q,oe){const ce=this._documents.getDocument(k),J=w.Position.to(B),Ee=await this._provider.provideOnTypeFormattingEdits(ce,J,V,q,oe);if(Array.isArray(Ee))return Ee.map(w.TextEdit.from)}}class W{constructor(k,B){this._provider=k,this._logService=B,this._cache=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(k,B){const V=await this._provider.provideWorkspaceSymbols(k,B);if(!(0,R.isNonEmptyArray)(V))return{symbols:[]};const q=this._cache.add(V),oe={cacheId:q,symbols:[]};for(let ce=0;ce<V.length;ce++){const J=V[ce];if(!J||!J.name){this._logService.warn("INVALID SymbolInformation",J);continue}oe.symbols.push({...w.WorkspaceSymbol.from(J),cacheId:[q,ce]})}return oe}async resolveWorkspaceSymbol(k,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!k.cacheId)return k;const V=this._cache.get(...k.cacheId);if(V){const q=await this._provider.resolveWorkspaceSymbol(V,B);return q&&(0,C.mixin)(k,w.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(k){this._cache.delete(k)}}class z{static supportsResolving(k){return typeof k.prepareRename=="function"}constructor(k,B,V){this._documents=k,this._provider=B,this._logService=V}async provideRenameEdits(k,B,V,q){const oe=this._documents.getDocument(k),ce=w.Position.to(B);try{const J=await this._provider.provideRenameEdits(oe,ce,V,q);return J?w.WorkspaceEdit.from(J):void 0}catch(J){const Ee=z._asMessage(J);return Ee?{rejectReason:Ee,edits:void 0}:Promise.reject(J)}}async resolveRenameLocation(k,B,V){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const q=this._documents.getDocument(k),oe=w.Position.to(B);try{const ce=await this._provider.prepareRename(q,oe,V);let J,Ee;if(F.Range.isRange(ce)?(J=ce,Ee=q.getText(ce)):(0,b.isObject)(ce)&&(J=ce.range,Ee=ce.placeholder),!J||!Ee)return;if(J.start.line>oe.line||J.end.line<oe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(J),text:Ee}}catch(ce){const J=z._asMessage(ce);return J?{rejectReason:J,range:void 0,text:void 0}:Promise.reject(ce)}}static _asMessage(k){return typeof k=="string"?k:k instanceof Error&&typeof k.message=="string"?k.message:void 0}}class G{constructor(k,B){this.resultId=k,this.tokens=B}}class te{constructor(k,B){this._documents=k,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(k,B,V){const q=this._documents.getDocument(k),oe=B!==0?this._previousResults.get(B):null;let ce=typeof oe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(q,oe.resultId,V):await this._provider.provideDocumentSemanticTokens(q,V);return oe&&this._previousResults.delete(B),ce?(ce=te._fixProvidedSemanticTokens(ce),this._send(te._convertToEdits(oe,ce),ce)):null}async releaseDocumentSemanticColoring(k){this._previousResults.delete(k)}static _fixProvidedSemanticTokens(k){return te._isSemanticTokens(k)?te._isCorrectSemanticTokens(k)?k:new F.SemanticTokens(new Uint32Array(k.data),k.resultId):te._isSemanticTokensEdits(k)?te._isCorrectSemanticTokensEdits(k)?k:new F.SemanticTokensEdits(k.edits.map(B=>new F.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),k.resultId):k}static _isSemanticTokens(k){return k&&!!k.data}static _isCorrectSemanticTokens(k){return k.data instanceof Uint32Array}static _isSemanticTokensEdits(k){return k&&Array.isArray(k.edits)}static _isCorrectSemanticTokensEdits(k){for(const B of k.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(k,B){if(!te._isSemanticTokens(B)||!k||!k.tokens)return B;const V=k.tokens,q=V.length,oe=B.data,ce=oe.length;let J=0;const Ee=Math.min(q,ce);for(;J<Ee&&V[J]===oe[J];)J++;if(J===q&&J===ce)return new F.SemanticTokensEdits([],B.resultId);let ve=0;const Ne=Ee-J;for(;ve<Ne&&V[q-ve-1]===oe[ce-ve-1];)ve++;return new F.SemanticTokensEdits([{start:J,deleteCount:q-J-ve,data:oe.subarray(J,ce-ve)}],B.resultId)}_send(k,B){if(te._isSemanticTokens(k)){const V=this._nextResultId++;return this._previousResults.set(V,new G(k.resultId,k.data)),(0,a.encodeSemanticTokensDto)({id:V,type:"full",data:k.data})}if(te._isSemanticTokensEdits(k)){const V=this._nextResultId++;return te._isSemanticTokens(B)?this._previousResults.set(V,new G(B.resultId,B.data)):this._previousResults.set(V,new G(k.resultId)),(0,a.encodeSemanticTokensDto)({id:V,type:"delta",deltas:(k.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}e.DocumentSemanticTokensAdapter=te;class he{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentRangeSemanticTokens(k,B,V){const q=this._documents.getDocument(k),oe=await this._provider.provideDocumentRangeSemanticTokens(q,w.Range.to(B),V);return oe?this._send(oe):null}_send(k){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:k.data})}}e.DocumentRangeSemanticTokensAdapter=he;class re{static supportsResolving(k){return typeof k.resolveCompletionItem=="function"}constructor(k,B,V,q,oe){this._documents=k,this._commands=B,this._provider=V,this._apiDeprecation=q,this._extension=oe,this._cache=new d.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(k,B,V,q){const oe=this._documents.getDocument(k),ce=w.Position.to(B),J=oe.getWordRangeAtPosition(ce)||new F.Range(ce,ce),Ee=J.with({end:ce}),ve=new m.StopWatch(!0),Ne=await this._provider.provideCompletionItems(oe,ce,q,w.CompletionContext.to(V));if(!Ne||q.isCancellationRequested)return;const ze=Array.isArray(Ne)?new F.CompletionList(Ne):Ne,Je=re.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),Ge=new p.DisposableStore;this._disposables.set(Je,Ge);const Pe=[],nt={x:Je,b:Pe,a:{replace:w.Range.from(J),insert:w.Range.from(Ee)},c:ze.isIncomplete||void 0,d:ve.elapsed()};for(let X=0;X<ze.items.length;X++){const Y=ze.items[X],me=this._convertCompletionItem(Y,[Je,X],Ee,J);Pe.push(me)}return nt}async resolveCompletionItem(k,B){if(typeof this._provider.resolveCompletionItem!="function")return;const V=this._cache.get(...k);if(!V)return;const q=await this._provider.resolveCompletionItem(V,B);if(!!q)return this._convertCompletionItem(q,k)}releaseCompletionItems(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}_convertCompletionItem(k,B,V,q){const oe=this._disposables.get(B[0]);if(!oe)throw Error("DisposableStore is missing...");const ce={x:B,a:k.label,b:k.kind!==void 0?w.CompletionItemKind.from(k.kind):void 0,n:k.tags&&k.tags.map(w.CompletionItemTag.from),c:k.detail,d:typeof k.documentation>"u"?void 0:w.MarkdownString.fromStrict(k.documentation),e:k.sortText!==k.label?k.sortText:void 0,f:k.filterText!==k.label?k.filterText:void 0,g:k.preselect||void 0,i:k.keepWhitespace?1:0,k:k.commitCharacters,l:k.additionalTextEdits&&k.additionalTextEdits.map(w.TextEdit.from),m:this._commands.toInternal(k.command,oe)};k.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=k.textEdit.newText):typeof k.insertText=="string"?ce.h=k.insertText:k.insertText instanceof F.SnippetString&&(ce.h=k.insertText.value,ce.i|=4);let J;return k.textEdit?J=k.textEdit.range:k.range&&(J=k.range),F.Range.isRange(J)?ce.j=w.Range.from(J):J&&(!V?.isEqual(J.inserting)||!q?.isEqual(J.replacing))&&(ce.j={insert:w.Range.from(J.inserting),replace:w.Range.from(J.replacing)}),ce}}class be{async provideInlineCompletions(k,B,V,q){}disposeCompletions(k){}handleDidShowCompletionItem(k,B){}}class le extends be{constructor(k,B,V,q){super(),this._extension=k,this._documents=B,this._provider=V,this._commands=q,this._references=new Q,this._isAdditionsProposedApiEnabled=(0,_.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[y.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,_.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(k,B,V,q){const oe=this._documents.getDocument(k),ce=w.Position.to(B),J=await this._provider.provideInlineCompletionItems(oe,ce,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:w.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[V.triggerKind]},q);if(!J||q.isCancellationRequested)return;const Ee=Array.isArray(J)?J:J.items,ve=this._isAdditionsProposedApiEnabled?Array.isArray(J)?[]:J.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:Ee}),items:Ee.map((Je,Ge)=>{let Pe;Je.command&&(Ne||(Ne=new p.DisposableStore),Pe=this._commands.toInternal(Je.command,Ne));const nt=Je.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Je.filterText,range:Je.range?w.Range.from(Je.range):void 0,command:Pe,idx:Ge,completeBracketPairs:this._isAdditionsProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:ve.map(Je=>(Ne||(Ne=new p.DisposableStore),this._commands.toInternal(Je,Ne)))}}disposeCompletions(k){this._references.disposeReferenceId(k)?.dispose()}handleDidShowCompletionItem(k,B){const V=this._references.get(k)?.items[B];V&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(V)}}class fe extends be{constructor(k,B,V,q){super(),this.extension=k,this._documents=B,this._provider=V,this._commands=q,this._references=new Q,this.isAdditionProposedApiEnabled=(0,_.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKindNew.Automatic,[y.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(k,B,V,q){const oe=this._documents.getDocument(k),ce=w.Position.to(B),J=await this._provider.provideInlineCompletionItems(oe,ce,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:w.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[V.triggerKind]},q);if(!J||q.isCancellationRequested)return;const Ee=Array.isArray(J)?J:J.items,ve=Array.isArray(J)?[]:J.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:Ee}),items:Ee.map((Je,Ge)=>{let Pe;Je.command&&(Ne||(Ne=new p.DisposableStore),Pe=this._commands.toInternal(Je.command,Ne));const nt=Je.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Je.filterText,range:Je.range?w.Range.from(Je.range):void 0,command:Pe,idx:Ge,completeBracketPairs:this.isAdditionProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:ve.map(Je=>(Ne||(Ne=new p.DisposableStore),this._commands.toInternal(Je,Ne)))}}disposeCompletions(k){this._references.disposeReferenceId(k)?.dispose()}handleDidShowCompletionItem(k,B){const V=this._references.get(k)?.items[B];V&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(V)}}class Q{constructor(){this._references=new Map,this._idPool=1}createReferenceId(k){const B=this._idPool++;return this._references.set(B,k),B}disposeReferenceId(k){const B=this._references.get(k);return this._references.delete(k),B}get(k){return this._references.get(k)}}class pe{constructor(k,B){this._documents=k,this._provider=B,this._cache=new d.Cache("SignatureHelp")}async provideSignatureHelp(k,B,V,q){const oe=this._documents.getDocument(k),ce=w.Position.to(B),J=this.reviveContext(V),Ee=await this._provider.provideSignatureHelp(oe,ce,q,J);if(Ee){const ve=this._cache.add([Ee]);return{...w.SignatureHelp.from(Ee),id:ve}}}reviveContext(k){let B;if(k.activeSignatureHelp){const V=w.SignatureHelp.to(k.activeSignatureHelp),q=this._cache.get(k.activeSignatureHelp.id,0);q?(B=q,B.activeSignature=V.activeSignature,B.activeParameter=V.activeParameter):B=V}return{...k,activeSignatureHelp:B}}releaseSignatureHelp(k){this._cache.delete(k)}}class Se{constructor(k,B,V,q,oe){this._documents=k,this._commands=B,this._provider=V,this._logService=q,this._extension=oe,this._cache=new d.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(k,B,V){const q=this._documents.getDocument(k),oe=w.Range.to(B),ce=await this._provider.provideInlayHints(q,oe,V);if(!Array.isArray(ce)||ce.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(V.isCancellationRequested)return;const J=this._cache.add(ce);this._disposables.set(J,new p.DisposableStore);const Ee={hints:[],cacheId:J};for(let ve=0;ve<ce.length;ve++)this._isValidInlayHint(ce[ve],oe)&&Ee.hints.push(this._convertInlayHint(ce[ve],[J,ve]));return this._logService.trace(`[InlayHints] ${Ee.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),Ee}async resolveInlayHint(k,B){if(typeof this._provider.resolveInlayHint!="function")return;const V=this._cache.get(...k);if(!V)return;const q=await this._provider.resolveInlayHint(V,B);if(!!q&&!!this._isValidInlayHint(q))return this._convertInlayHint(q,k)}releaseHints(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}_isValidInlayHint(k,B){return k.label.length===0||Array.isArray(k.label)&&k.label.every(V=>V.value.length===0)?(console.log("INVALID inlay hint, empty label",k),!1):!(B&&!B.contains(k.position))}_convertInlayHint(k,B){const V=this._disposables.get(B[0]);if(!V)throw Error("DisposableStore is missing...");const q={label:"",cacheId:B,tooltip:w.MarkdownString.fromStrict(k.tooltip),position:w.Position.from(k.position),textEdits:k.textEdits&&k.textEdits.map(w.TextEdit.from),kind:k.kind&&w.InlayHintKind.from(k.kind),paddingLeft:k.paddingLeft,paddingRight:k.paddingRight};return typeof k.label=="string"?q.label=k.label:q.label=k.label.map(oe=>{const ce={label:oe.value};return ce.tooltip=w.MarkdownString.fromStrict(oe.tooltip),F.Location.isLocation(oe.location)&&(ce.location=w.location.from(oe.location)),oe.command&&(ce.command=this._commands.toInternal(oe.command,V)),ce}),q}}class Fe{constructor(k,B){this._documents=k,this._provider=B,this._cache=new d.Cache("DocumentLink")}async provideLinks(k,B){const V=this._documents.getDocument(k),q=await this._provider.provideDocumentLinks(V,B);if(!(!Array.isArray(q)||q.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:q.filter(Fe._validateLink).map(w.DocumentLink.from)};{const oe=this._cache.add(q),ce={links:[],cacheId:oe};for(let J=0;J<q.length;J++){if(!Fe._validateLink(q[J]))continue;const Ee=w.DocumentLink.from(q[J]);Ee.cacheId=[oe,J],ce.links.push(Ee)}return ce}}}static _validateLink(k){return k.target&&k.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(k,B){if(typeof this._provider.resolveDocumentLink!="function")return;const V=this._cache.get(...k);if(!V)return;const q=await this._provider.resolveDocumentLink(V,B);if(!(!q||!Fe._validateLink(q)))return w.DocumentLink.from(q)}releaseLinks(k){this._cache.delete(k)}}class Be{constructor(k,B){this._documents=k,this._provider=B}async provideColors(k,B){const V=this._documents.getDocument(k),q=await this._provider.provideDocumentColors(V,B);return Array.isArray(q)?q.map(ce=>({color:w.Color.from(ce.color),range:w.Range.from(ce.range)})):[]}async provideColorPresentations(k,B,V){const q=this._documents.getDocument(k),oe=w.Range.to(B.range),ce=w.Color.to(B.color),J=await this._provider.provideColorPresentations(ce,{document:q,range:oe},V);if(!!Array.isArray(J))return J.map(w.ColorPresentation.from)}}class Xe{constructor(k,B){this._documents=k,this._provider=B}async provideFoldingRanges(k,B,V){const q=this._documents.getDocument(k),oe=await this._provider.provideFoldingRanges(q,B,V);if(!!Array.isArray(oe))return oe.map(w.FoldingRange.from)}}class ke{constructor(k,B,V){this._documents=k,this._provider=B,this._logService=V}async provideSelectionRanges(k,B,V){const q=this._documents.getDocument(k),oe=B.map(w.Position.to),ce=await this._provider.provideSelectionRanges(q,oe,V);if(!(0,R.isNonEmptyArray)(ce))return[];if(ce.length!==oe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const J=[];for(let Ee=0;Ee<oe.length;Ee++){const ve=[];J.push(ve);let Ne=oe[Ee],ze=ce[Ee];for(;;){if(!ze.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(w.SelectionRange.from(ze)),!ze.parent)break;Ne=ze.range,ze=ze.parent}}return J}}class ye{constructor(k,B){this._documents=k,this._provider=B,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(k,B,V){const q=this._documents.getDocument(k),oe=w.Position.to(B),ce=await this._provider.prepareCallHierarchy(q,oe,V);if(!ce)return;const J=this._idPool.nextId();return this._cache.set(J,new Map),Array.isArray(ce)?ce.map(Ee=>this._cacheAndConvertItem(J,Ee)):[this._cacheAndConvertItem(J,ce)]}async provideCallsTo(k,B,V){const q=this._itemFromCache(k,B);if(!q)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyIncomingCalls(q,V);if(!!oe)return oe.map(ce=>({from:this._cacheAndConvertItem(k,ce.from),fromRanges:ce.fromRanges.map(J=>w.Range.from(J))}))}async provideCallsFrom(k,B,V){const q=this._itemFromCache(k,B);if(!q)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyOutgoingCalls(q,V);if(!!oe)return oe.map(ce=>({to:this._cacheAndConvertItem(k,ce.to),fromRanges:ce.fromRanges.map(J=>w.Range.from(J))}))}releaseSession(k){this._cache.delete(k)}_cacheAndConvertItem(k,B){const V=this._cache.get(k),q=w.CallHierarchyItem.from(B,k,V.size.toString(36));return V.set(q._itemId,B),q}_itemFromCache(k,B){return this._cache.get(k)?.get(B)}}class De{constructor(k,B){this._documents=k,this._provider=B,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(k,B,V){const q=this._documents.getDocument(k),oe=w.Position.to(B),ce=await this._provider.prepareTypeHierarchy(q,oe,V);if(!ce)return;const J=this._idPool.nextId();return this._cache.set(J,new Map),Array.isArray(ce)?ce.map(Ee=>this._cacheAndConvertItem(J,Ee)):[this._cacheAndConvertItem(J,ce)]}async provideSupertypes(k,B,V){const q=this._itemFromCache(k,B);if(!q)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySupertypes(q,V);if(!!oe)return oe.map(ce=>this._cacheAndConvertItem(k,ce))}async provideSubtypes(k,B,V){const q=this._itemFromCache(k,B);if(!q)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySubtypes(q,V);if(!!oe)return oe.map(ce=>this._cacheAndConvertItem(k,ce))}releaseSession(k){this._cache.delete(k)}_cacheAndConvertItem(k,B){const V=this._cache.get(k),q=w.TypeHierarchyItem.from(B,k,V.size.toString(36));return V.set(q._itemId,B),q}_itemFromCache(k,B){return this._cache.get(k)?.get(B)}}class ae{constructor(k,B,V,q){this._proxy=k,this._documents=B,this._provider=V,this._handle=q}async provideDocumentOnDropEdits(k,B,V,q,oe){const ce=this._documents.getDocument(B),J=w.Position.to(V),Ee=w.DataTransfer.toDataTransfer(q,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,k,Ne)).buffer),ve=await this._provider.provideDocumentDropEdits(ce,J,Ee,oe);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?w.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class ue{constructor(k,B){this.adapter=k,this.extension=B}}class ee{constructor(k,B,V,q,oe,ce,J){this._adapter=new Map,this._uriTransformer=B,this._proxy=k.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=V,this._commands=q,this._diagnostics=oe,this._logService=ce,this._apiDeprecation=J}_transformDocumentSelector(k){return w.DocumentSelector.from(k,this._uriTransformer)}_createDisposable(k){return new F.Disposable(()=>{this._adapter.delete(k),this._proxy.$unregister(k)})}_nextHandle(){return ee._handlePool++}async _withAdapter(k,B,V,q,oe,ce=!1){const J=this._adapter.get(k);if(!J||!(J.adapter instanceof B))return q;const Ee=Date.now();ce||this._logService.trace(`[${J.extension.identifier.value}] INVOKE provider '${V.toString().replace(/[\r\n]/g,"")}'`);const ve=V(J.adapter,J.extension);return Promise.resolve(ve).catch(Ne=>{(0,S.isCancellationError)(Ne)||(this._logService.error(`[${J.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{ce||this._logService.trace(`[${J.extension.identifier.value}] provider DONE after ${Date.now()-Ee}ms`)}),I.CancellationToken.isCancellationToken(oe)?(0,c.raceCancellationError)(ve,oe):ve}_addNewAdapter(k,B){const V=this._nextHandle();return this._adapter.set(V,new ue(k,B)),V}static _extLabel(k){return k.displayName||k.name}registerDocumentSymbolProvider(k,B,V,q){const oe=this._addNewAdapter(new t(this._documents,V),k),ce=q&&q.label||ee._extLabel(k);return this._proxy.$registerDocumentSymbolProvider(oe,this._transformDocumentSelector(B),ce),this._createDisposable(oe)}$provideDocumentSymbols(k,B,V){return this._withAdapter(k,t,q=>q.provideDocumentSymbols(r.URI.revive(B),V),void 0,V)}registerCodeLensProvider(k,B,V){const q=this._nextHandle(),oe=typeof V.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(q,new ue(new u(this._documents,this._commands.converter,V),k)),this._proxy.$registerCodeLensSupport(q,this._transformDocumentSelector(B),oe);let ce=this._createDisposable(q);if(oe!==void 0){const J=V.onDidChangeCodeLenses(Ee=>this._proxy.$emitCodeLensEvent(oe));ce=F.Disposable.from(ce,J)}return ce}$provideCodeLenses(k,B,V){return this._withAdapter(k,u,q=>q.provideCodeLenses(r.URI.revive(B),V),void 0,V)}$resolveCodeLens(k,B,V){return this._withAdapter(k,u,q=>q.resolveCodeLens(B,V),void 0,void 0)}$releaseCodeLenses(k,B){this._withAdapter(k,u,V=>Promise.resolve(V.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(k,B,V){const q=this._addNewAdapter(new n(this._documents,V),k);return this._proxy.$registerDefinitionSupport(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideDefinition(k,B,V,q){return this._withAdapter(k,n,oe=>oe.provideDefinition(r.URI.revive(B),V,q),[],q)}registerDeclarationProvider(k,B,V){const q=this._addNewAdapter(new s(this._documents,V),k);return this._proxy.$registerDeclarationSupport(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideDeclaration(k,B,V,q){return this._withAdapter(k,s,oe=>oe.provideDeclaration(r.URI.revive(B),V,q),[],q)}registerImplementationProvider(k,B,V){const q=this._addNewAdapter(new h(this._documents,V),k);return this._proxy.$registerImplementationSupport(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideImplementation(k,B,V,q){return this._withAdapter(k,h,oe=>oe.provideImplementation(r.URI.revive(B),V,q),[],q)}registerTypeDefinitionProvider(k,B,V){const q=this._addNewAdapter(new o(this._documents,V),k);return this._proxy.$registerTypeDefinitionSupport(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideTypeDefinition(k,B,V,q){return this._withAdapter(k,o,oe=>oe.provideTypeDefinition(r.URI.revive(B),V,q),[],q)}registerHoverProvider(k,B,V,q){const oe=this._addNewAdapter(new f(this._documents,V),k);return this._proxy.$registerHoverProvider(oe,this._transformDocumentSelector(B)),this._createDisposable(oe)}$provideHover(k,B,V,q){return this._withAdapter(k,f,oe=>oe.provideHover(r.URI.revive(B),V,q),void 0,q)}registerEvaluatableExpressionProvider(k,B,V,q){const oe=this._addNewAdapter(new v(this._documents,V),k);return this._proxy.$registerEvaluatableExpressionProvider(oe,this._transformDocumentSelector(B)),this._createDisposable(oe)}$provideEvaluatableExpression(k,B,V,q){return this._withAdapter(k,v,oe=>oe.provideEvaluatableExpression(r.URI.revive(B),V,q),void 0,q)}registerInlineValuesProvider(k,B,V,q){const oe=typeof V.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new T(this._documents,V),k);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(B),oe);let J=this._createDisposable(ce);if(oe!==void 0){const Ee=V.onDidChangeInlineValues(ve=>this._proxy.$emitInlineValuesEvent(oe));J=F.Disposable.from(J,Ee)}return J}$provideInlineValues(k,B,V,q,oe){return this._withAdapter(k,T,ce=>ce.provideInlineValues(r.URI.revive(B),V,q,oe),void 0,oe)}registerDocumentHighlightProvider(k,B,V){const q=this._addNewAdapter(new M(this._documents,V),k);return this._proxy.$registerDocumentHighlightProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideDocumentHighlights(k,B,V,q){return this._withAdapter(k,M,oe=>oe.provideDocumentHighlights(r.URI.revive(B),V,q),void 0,q)}registerLinkedEditingRangeProvider(k,B,V){const q=this._addNewAdapter(new j(this._documents,V),k);return this._proxy.$registerLinkedEditingRangeProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideLinkedEditingRanges(k,B,V,q){return this._withAdapter(k,j,async oe=>{const ce=await oe.provideLinkedEditingRanges(r.URI.revive(B),V,q);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?ee._serializeRegExp(ce.wordPattern):void 0}},void 0,q)}registerReferenceProvider(k,B,V){const q=this._addNewAdapter(new U(this._documents,V),k);return this._proxy.$registerReferenceSupport(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideReferences(k,B,V,q,oe){return this._withAdapter(k,U,ce=>ce.provideReferences(r.URI.revive(B),V,q,oe),void 0,oe)}registerCodeActionProvider(k,B,V,q){const oe=new p.DisposableStore,ce=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,V,this._logService,k,this._apiDeprecation),k);return this._proxy.$registerQuickFixSupport(ce,this._transformDocumentSelector(B),{providedKinds:q?.providedCodeActionKinds?.map(J=>J.value),documentation:q?.documentation?.map(J=>({kind:J.kind.value,command:this._commands.converter.toInternal(J.command,oe)}))},ee._extLabel(k),Boolean(V.resolveCodeAction)),oe.add(this._createDisposable(ce)),oe}$provideCodeActions(k,B,V,q,oe){return this._withAdapter(k,D,ce=>ce.provideCodeActions(r.URI.revive(B),V,q,oe),void 0,oe)}$resolveCodeAction(k,B,V){return this._withAdapter(k,D,q=>q.resolveCodeAction(B,V),void 0,void 0)}$releaseCodeActions(k,B){this._withAdapter(k,D,V=>Promise.resolve(V.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(k,B,V){const q=this._addNewAdapter(new L(this._documents,V),k);return this._proxy.$registerDocumentFormattingSupport(q,this._transformDocumentSelector(B),k.identifier,k.displayName||k.name),this._createDisposable(q)}$provideDocumentFormattingEdits(k,B,V,q){return this._withAdapter(k,L,oe=>oe.provideDocumentFormattingEdits(r.URI.revive(B),V,q),void 0,q)}registerDocumentRangeFormattingEditProvider(k,B,V){const q=this._addNewAdapter(new O(this._documents,V),k);return this._proxy.$registerRangeFormattingSupport(q,this._transformDocumentSelector(B),k.identifier,k.displayName||k.name),this._createDisposable(q)}$provideDocumentRangeFormattingEdits(k,B,V,q,oe){return this._withAdapter(k,O,ce=>ce.provideDocumentRangeFormattingEdits(r.URI.revive(B),V,q,oe),void 0,oe)}registerOnTypeFormattingEditProvider(k,B,V,q){const oe=this._addNewAdapter(new H(this._documents,V),k);return this._proxy.$registerOnTypeFormattingSupport(oe,this._transformDocumentSelector(B),q,k.identifier),this._createDisposable(oe)}$provideOnTypeFormattingEdits(k,B,V,q,oe,ce){return this._withAdapter(k,H,J=>J.provideOnTypeFormattingEdits(r.URI.revive(B),V,q,oe,ce),void 0,ce)}registerWorkspaceSymbolProvider(k,B){const V=this._addNewAdapter(new W(B,this._logService),k);return this._proxy.$registerNavigateTypeSupport(V,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(V)}$provideWorkspaceSymbols(k,B,V){return this._withAdapter(k,W,q=>q.provideWorkspaceSymbols(B,V),{symbols:[]},V)}$resolveWorkspaceSymbol(k,B,V){return this._withAdapter(k,W,q=>q.resolveWorkspaceSymbol(B,V),void 0,void 0)}$releaseWorkspaceSymbols(k,B){this._withAdapter(k,W,V=>V.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(k,B,V){const q=this._addNewAdapter(new z(this._documents,V,this._logService),k);return this._proxy.$registerRenameSupport(q,this._transformDocumentSelector(B),z.supportsResolving(V)),this._createDisposable(q)}$provideRenameEdits(k,B,V,q,oe){return this._withAdapter(k,z,ce=>ce.provideRenameEdits(r.URI.revive(B),V,q,oe),void 0,oe)}$resolveRenameLocation(k,B,V,q){return this._withAdapter(k,z,oe=>oe.resolveRenameLocation(r.URI.revive(B),V,q),void 0,q)}registerDocumentSemanticTokensProvider(k,B,V,q){const oe=this._addNewAdapter(new te(this._documents,V),k),ce=typeof V.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(oe,this._transformDocumentSelector(B),q,ce);let J=this._createDisposable(oe);if(ce){const Ee=V.onDidChangeSemanticTokens(ve=>this._proxy.$emitDocumentSemanticTokensEvent(ce));J=F.Disposable.from(J,Ee)}return J}$provideDocumentSemanticTokens(k,B,V,q){return this._withAdapter(k,te,oe=>oe.provideDocumentSemanticTokens(r.URI.revive(B),V,q),null,q)}$releaseDocumentSemanticTokens(k,B){this._withAdapter(k,te,V=>V.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(k,B,V,q){const oe=this._addNewAdapter(new he(this._documents,V),k);return this._proxy.$registerDocumentRangeSemanticTokensProvider(oe,this._transformDocumentSelector(B),q),this._createDisposable(oe)}$provideDocumentRangeSemanticTokens(k,B,V,q){return this._withAdapter(k,he,oe=>oe.provideDocumentRangeSemanticTokens(r.URI.revive(B),V,q),null,q)}registerCompletionItemProvider(k,B,V,q){const oe=this._addNewAdapter(new re(this._documents,this._commands.converter,V,this._apiDeprecation,k),k);return this._proxy.$registerCompletionsProvider(oe,this._transformDocumentSelector(B),q,re.supportsResolving(V),`${k.identifier.value}(${q.join("")})`),this._createDisposable(oe)}$provideCompletionItems(k,B,V,q,oe){return this._withAdapter(k,re,ce=>ce.provideCompletionItems(r.URI.revive(B),V,q,oe),void 0,oe)}$resolveCompletionItem(k,B,V){return this._withAdapter(k,re,q=>q.resolveCompletionItem(B,V),void 0,V)}$releaseCompletionItems(k,B){this._withAdapter(k,re,V=>V.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(k,B,V){const q=new le(k,this._documents,V,this._commands.converter),oe=this._addNewAdapter(q,k);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(B),q.supportsHandleDidShowCompletionItem),this._createDisposable(oe)}registerInlineCompletionsProviderNew(k,B,V){const q=this._addNewAdapter(new fe(k,this._documents,V,this._commands.converter),k);return this._proxy.$registerInlineCompletionsSupport(q,this._transformDocumentSelector(B),!0),this._createDisposable(q)}$provideInlineCompletions(k,B,V,q,oe){return this._withAdapter(k,be,ce=>ce.provideInlineCompletions(r.URI.revive(B),V,q,oe),void 0,oe)}$handleInlineCompletionDidShow(k,B,V){this._withAdapter(k,be,async q=>{q.handleDidShowCompletionItem(B,V)},void 0,void 0)}$freeInlineCompletionsList(k,B){this._withAdapter(k,be,async V=>{V.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(k,B,V,q){const oe=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,ce=this._addNewAdapter(new pe(this._documents,V),k);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(B),oe),this._createDisposable(ce)}$provideSignatureHelp(k,B,V,q,oe){return this._withAdapter(k,pe,ce=>ce.provideSignatureHelp(r.URI.revive(B),V,q,oe),void 0,oe)}$releaseSignatureHelp(k,B){this._withAdapter(k,pe,V=>V.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(k,B,V){const q=typeof V.onDidChangeInlayHints=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new Se(this._documents,this._commands.converter,V,this._logService,k),k);this._proxy.$registerInlayHintsProvider(oe,this._transformDocumentSelector(B),typeof V.resolveInlayHint=="function",q,ee._extLabel(k));let ce=this._createDisposable(oe);if(q!==void 0){const J=V.onDidChangeInlayHints(Ee=>this._proxy.$emitInlayHintsEvent(q));ce=F.Disposable.from(ce,J)}return ce}$provideInlayHints(k,B,V,q){return this._withAdapter(k,Se,oe=>oe.provideInlayHints(r.URI.revive(B),V,q),void 0,q)}$resolveInlayHint(k,B,V){return this._withAdapter(k,Se,q=>q.resolveInlayHint(B,V),void 0,V)}$releaseInlayHints(k,B){this._withAdapter(k,Se,V=>V.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(k,B,V){const q=this._addNewAdapter(new Fe(this._documents,V),k);return this._proxy.$registerDocumentLinkProvider(q,this._transformDocumentSelector(B),typeof V.resolveDocumentLink=="function"),this._createDisposable(q)}$provideDocumentLinks(k,B,V){return this._withAdapter(k,Fe,q=>q.provideLinks(r.URI.revive(B),V),void 0,V,B.scheme==="output")}$resolveDocumentLink(k,B,V){return this._withAdapter(k,Fe,q=>q.resolveLink(B,V),void 0,void 0,!0)}$releaseDocumentLinks(k,B){this._withAdapter(k,Fe,V=>V.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(k,B,V){const q=this._addNewAdapter(new Be(this._documents,V),k);return this._proxy.$registerDocumentColorProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideDocumentColors(k,B,V){return this._withAdapter(k,Be,q=>q.provideColors(r.URI.revive(B),V),[],V)}$provideColorPresentations(k,B,V,q){return this._withAdapter(k,Be,oe=>oe.provideColorPresentations(r.URI.revive(B),V,q),void 0,q)}registerFoldingRangeProvider(k,B,V){const q=this._nextHandle(),oe=typeof V.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(q,new ue(new Xe(this._documents,V),k)),this._proxy.$registerFoldingRangeProvider(q,this._transformDocumentSelector(B),oe);let ce=this._createDisposable(q);if(oe!==void 0){const J=V.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(oe));ce=F.Disposable.from(ce,J)}return ce}$provideFoldingRanges(k,B,V,q){return this._withAdapter(k,Xe,oe=>oe.provideFoldingRanges(r.URI.revive(B),V,q),void 0,q)}registerSelectionRangeProvider(k,B,V){const q=this._addNewAdapter(new ke(this._documents,V,this._logService),k);return this._proxy.$registerSelectionRangeProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideSelectionRanges(k,B,V,q){return this._withAdapter(k,ke,oe=>oe.provideSelectionRanges(r.URI.revive(B),V,q),[],q)}registerCallHierarchyProvider(k,B,V){const q=this._addNewAdapter(new ye(this._documents,V),k);return this._proxy.$registerCallHierarchyProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$prepareCallHierarchy(k,B,V,q){return this._withAdapter(k,ye,oe=>Promise.resolve(oe.prepareSession(r.URI.revive(B),V,q)),void 0,q)}$provideCallHierarchyIncomingCalls(k,B,V,q){return this._withAdapter(k,ye,oe=>oe.provideCallsTo(B,V,q),void 0,q)}$provideCallHierarchyOutgoingCalls(k,B,V,q){return this._withAdapter(k,ye,oe=>oe.provideCallsFrom(B,V,q),void 0,q)}$releaseCallHierarchy(k,B){this._withAdapter(k,ye,V=>Promise.resolve(V.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(k,B,V){const q=this._addNewAdapter(new De(this._documents,V),k);return this._proxy.$registerTypeHierarchyProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$prepareTypeHierarchy(k,B,V,q){return this._withAdapter(k,De,oe=>Promise.resolve(oe.prepareSession(r.URI.revive(B),V,q)),void 0,q)}$provideTypeHierarchySupertypes(k,B,V,q){return this._withAdapter(k,De,oe=>oe.provideSupertypes(B,V,q),void 0,q)}$provideTypeHierarchySubtypes(k,B,V,q){return this._withAdapter(k,De,oe=>oe.provideSubtypes(B,V,q),void 0,q)}$releaseTypeHierarchy(k,B){this._withAdapter(k,De,V=>Promise.resolve(V.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(k,B,V){const q=this._nextHandle();return this._adapter.set(q,new ue(new ae(this._proxy,this._documents,V,q),k)),this._proxy.$registerDocumentOnDropEditProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideDocumentOnDropEdits(k,B,V,q,oe,ce){return this._withAdapter(k,ae,J=>Promise.resolve(J.provideDocumentOnDropEdits(B,r.URI.revive(V),q,oe,ce)),void 0,void 0)}registerDocumentPasteEditProvider(k,B,V,q){const oe=this._nextHandle();return this._adapter.set(oe,new ue(new $(this._proxy,this._documents,V,oe),k)),this._proxy.$registerPasteEditProvider(oe,this._transformDocumentSelector(B),!!V.prepareDocumentPaste,q.pasteMimeTypes),this._createDisposable(oe)}$prepareDocumentPaste(k,B,V,q,oe){return this._withAdapter(k,$,ce=>ce.prepareDocumentPaste(r.URI.revive(B),V,q,oe),void 0,oe)}$providePasteEdits(k,B,V,q,oe,ce){return this._withAdapter(k,$,J=>J.providePasteEdits(B,r.URI.revive(V),q,oe,ce),void 0,ce)}static _serializeRegExp(k){return{pattern:k.source,flags:(0,E.regExpFlags)(k)}}static _serializeIndentationRule(k){return{decreaseIndentPattern:ee._serializeRegExp(k.decreaseIndentPattern),increaseIndentPattern:ee._serializeRegExp(k.increaseIndentPattern),indentNextLinePattern:k.indentNextLinePattern?ee._serializeRegExp(k.indentNextLinePattern):void 0,unIndentedLinePattern:k.unIndentedLinePattern?ee._serializeRegExp(k.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(k){return{beforeText:ee._serializeRegExp(k.beforeText),afterText:k.afterText?ee._serializeRegExp(k.afterText):void 0,previousLineText:k.previousLineText?ee._serializeRegExp(k.previousLineText):void 0,action:k.action}}static _serializeOnEnterRules(k){return k.map(ee._serializeOnEnterRule)}setLanguageConfiguration(k,B,V){const{wordPattern:q}=V;if(q&&(0,E.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this._documents.setWordDefinitionFor(B,q):this._documents.setWordDefinitionFor(B,void 0),V.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",k,"Do not use."),V.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",k,"Do not use.");const oe=this._nextHandle(),ce={comments:V.comments,brackets:V.brackets,wordPattern:V.wordPattern?ee._serializeRegExp(V.wordPattern):void 0,indentationRules:V.indentationRules?ee._serializeIndentationRule(V.indentationRules):void 0,onEnterRules:V.onEnterRules?ee._serializeOnEnterRules(V.onEnterRules):void 0,__electricCharacterSupport:V.__electricCharacterSupport,__characterPairSupport:V.__characterPairSupport};return this._proxy.$setLanguageConfiguration(oe,B,ce),this._createDisposable(oe)}$setWordDefinitions(k){for(const B of k)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=ee,ee._handlePool=0}),define(Ce[208],Ie([1,0,5,8,6,29,15,7]),function(ne,e,r,C,w,F,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(R,b,g,I){this._documents=b,this._commands=g,this._uriTransformer=I,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,b){await this._proxy.$changeLanguage(R,b);const g=this._documents.getDocumentData(R);if(!g)throw new Error(`document '${R.toString()}' NOT found`);return g.document}async tokenAtPosition(R,b){const g=R.version,I=C.Position.from(b),p=await this._proxy.$tokensAtPosition(R.uri,I),a={type:w.StandardTokenType.Other,range:R.getWordRangeAtPosition(b)??new w.Range(b.line,b.character,b.line,b.character)};if(!p)return a;const l={range:C.Range.to(p.range),type:C.TokenType.to(p.type)};return!l.range.contains(b)||g!==R.version?a:l}createLanguageStatusItem(R,b,g){const I=this._handlePool++,p=this._proxy,a=this._ids,l=`${R.identifier.value}/${b}`;if(a.has(l))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);a.add(l);const d={selector:g,id:b,name:R.displayName??R.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let m;const S=new A.DisposableStore,c=()=>{m?.dispose(),m=(0,y.disposableTimeout)(()=>{S.clear(),this._proxy.$setLanguageStatus(I,{id:l,name:d.name??R.displayName??R.name,source:R.displayName??R.name,selector:C.DocumentSelector.from(d.selector,this._uriTransformer),label:d.text,detail:d.detail??"",severity:d.severity===w.LanguageStatusSeverity.Error?F.default.Error:d.severity===w.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:d.command&&this._commands.toInternal(d.command,S),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},_={dispose(){S.dispose(),m?.dispose(),p.$removeLanguageStatus(I),a.delete(l)},get id(){return d.id},get name(){return d.name},set name(t){d.name=t,c()},get selector(){return d.selector},set selector(t){d.selector=t,c()},get text(){return d.text},set text(t){d.text=t,c()},get detail(){return d.detail},set detail(t){d.detail=t,c()},get severity(){return d.severity},set severity(t){d.severity=t,c()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(t){d.accessibilityInformation=t,c()},get command(){return d.command},set command(t){d.command=t,c()},get busy(){return d.busy},set busy(t){d.busy=t,c()}};return c(),_}}e.ExtHostLanguages=E}),define(Ce[70],Ie([1,0,20,9,2,3,11,5,26,14]),function(ne,e,r,C,w,F,y,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(g,I,p){this.logService=p,this.bundleCache=new Map,this._proxy=I.getProxy(A.MainContext.MainThreadLocalization),this.currentLanguage=g.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===r.LANGUAGE_DEFAULT}getMessage(g,I){const{message:p,args:a,comment:l}=I;if(this.isDefaultLanguage)return(0,C.format2)(p,a??{});let d=p;l&&l.length>0&&(d+=`/${Array.isArray(l)?l.join():l}`);const m=this.bundleCache.get(g)?.contents[d];return m||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,C.format2)(m??d,a??{})}getBundle(g){return this.bundleCache.get(g)?.contents}getBundleUri(g){return this.bundleCache.get(g)?.uri}async initializeLocalizedMessages(g){if(this.isDefaultLanguage||!g.l10n&&!g.isBuiltin||this.bundleCache.has(g.identifier.value))return;let I;const p=await this.getBundleLocation(g);if(!p){this.logService.error(`No bundle location found for extension ${g.identifier.value}`);return}try{const a=await this._proxy.$fetchBundleContents(p),l=JSON.parse(a);I=g.isBuiltin?l.contents?.bundle:l}catch(a){this.logService.error(`Failed to load translations for ${g.identifier.value} from ${p}: ${a.message}`);return}I&&this.bundleCache.set(g.identifier.value,{contents:I,uri:p})}async getBundleLocation(g){if(g.isBuiltin){const I=await this._proxy.$fetchBuiltInBundleUri(g.identifier.value);return w.URI.revive(I)}return g.l10n?w.URI.joinPath(g.extensionLocation,g.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};R=$e([xe(0,E.IExtHostInitDataService),xe(1,P.IExtHostRpcService),xe(2,y.ILogService)],R),e.ExtHostLocalizationService=R,e.IExtHostLocalizationService=(0,F.createDecorator)("IExtHostLocalizationService")}),define(Ce[209],Ie([1,0,11,5,26,14,4]),function(ne,e,r,C,w,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends r.AbstractLoggerService{constructor(R,b){const g=new y.Emitter;super(b.logLevel,g.event),this._proxy=R.getProxy(C.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(g)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,b,g){return new E(this._proxy,R,b,g)}};A=$e([xe(0,F.IExtHostRpcService),xe(1,w.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class E extends r.AbstractMessageLogger{constructor(R,b,g,I){super(I?.always),this.proxy=R,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(g),this.proxy.$createLogger(b,I).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,b){const g=[[R,b]];this.isLoggerCreated?this.doLog(g):this.buffer.push(...g)}doLog(R){this.proxy.$log(this.file,R)}}}),define(Ce[210],Ie([1,0,5,11,28]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function F(A){return A&&A.title}let y=class{constructor(E,P){this._logService=P,this._proxy=E.getProxy(r.MainContext.MainThreadMessageService)}showMessage(E,P,R,b,g){const I={source:{identifier:E.identifier,label:E.displayName||E.name}};let p;typeof b=="string"||F(b)?p=[b,...g]:(I.modal=b?.modal,I.useCustom=b?.useCustom,I.detail=b?.detail,p=g),I.useCustom&&(0,w.checkProposedApiEnabled)(E,"resolvers");const a=[];for(let l=0;l<p.length;l++){const d=p[l];if(typeof d=="string")a.push({title:d,handle:l,isCloseAffordance:!1});else if(typeof d=="object"){const{title:m,isCloseAffordance:S}=d;a.push({title:m,isCloseAffordance:!!S,handle:l})}else this._logService.warn("Invalid message item:",d)}return this._proxy.$showMessage(P,R,I,a).then(l=>{if(typeof l=="number")return p[l]})}};y=$e([xe(1,C.ILogService)],y),e.ExtHostMessageService=y}),define(Ce[211],Ie([1,0,23,4,7,25,9,10,2,62,5,37,8,6,42,183,94]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class d{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(S=>S.apiEditor)}constructor(S,c,_,t){this._textDocumentsAndEditors=_,this._textDocuments=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new C.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new C.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new C.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=S.getProxy(R.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=S.getProxy(R.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=S.getProxy(R.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===12){const i=u.notebookEditor?.notebookUri,n=u.cell.handle,h=this._documents.get(i)?.getCell(n);if(h)return h.apiCell}return u}}),d._registerApiCommands(c)}getEditorById(S){const c=this._editors.get(S);if(!c)throw new Error(`unknown text editor: ${S}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(S){for(const[c,_]of this._editors)if(_.apiEditor===S)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(S,c){const _=this._documents.get(S);if(!_&&!c)throw new Error(`NO notebook document for '${S}'`);return _}_getProviderData(S){const c=this._notebookContentProviders.get(S);if(!c)throw new Error(`NO provider for '${S}'`);return c}registerNotebookContentProvider(S,c,_,t,u){if((0,y.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);return this._notebookContentProviders.set(c,{extension:S,provider:_}),this._notebookProxy.$registerNotebookProvider({id:S.identifier,location:S.extensionLocation},c,g.NotebookDocumentContentOptions.from(t),d._convertNotebookRegistrationData(S,u)),new I.Disposable(()=>{this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(S,c){if(!c)return;const _=c.filenamePattern.map(t=>g.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(c.filenamePattern&&!_){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:c.displayName,filenamePattern:_,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(S,c,_){const t=d._notebookStatusBarItemProviderHandlePool++,u=typeof _.onDidChangeCellStatusBarItems=="function"?d._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,_),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,u,c);let i;return u!==void 0&&(i=_.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(u))),new I.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,u),i?.dispose()})}async createNotebookDocument(S){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:S.viewType,content:S.content&&g.NotebookData.from(S.content)});return E.URI.revive(c)}async openNotebookDocument(S){const c=this._documents.get(S);if(c)return c.apiNotebook;const _=await this._notebookDocumentsProxy.$tryOpenNotebook(S),t=this._documents.get(E.URI.revive(_));return(0,A.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(S,c){E.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let _;typeof c=="object"?_={position:g.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(g.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:_={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(S.uri,S.notebookType,_),u=t&&this._editors.get(t)?.apiEditor;if(u)return u;throw t?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,c,_,t){const u=this._notebookStatusBarItemProviders.get(S),i=E.URI.revive(c),n=this._documents.get(i);if(!n||!u)return;const s=n.getCellFromIndex(_);if(!s)return;const h=await u.provideCellStatusBarItems(s.apiCell,t);if(!h)return;const o=new w.DisposableStore,f=this._statusBarCache.add([o]),T=(Array.isArray(h)?h:[h]).map(M=>g.NotebookStatusBarItem.from(M,this._commandsConverter,o));return{cacheId:f,items:T}}$releaseNotebookCellStatusBarItems(S){this._statusBarCache.delete(S)}registerNotebookSerializer(S,c,_,t,u){if((0,y.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,_),this._notebookProxy.$registerNotebookSerializer(i,{id:S.identifier,location:S.extensionLocation},c,g.NotebookDocumentContentOptions.from(t),d._convertNotebookRegistrationData(S,u)),(0,w.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(S,c,_){const t=this._notebookSerializer.get(S);if(!t)throw new Error("NO serializer found");const u=await t.deserializeNotebook(c.buffer,_);return new p.SerializableObjectWithBuffers(g.NotebookData.from(u))}async $notebookToData(S,c,_){const t=this._notebookSerializer.get(S);if(!t)throw new Error("NO serializer found");const u=await t.serializeNotebook(g.NotebookData.to(c.value),_);return r.VSBuffer.wrap(u)}async $openNotebook(S,c,_,t,u){const{provider:i}=this._getProviderData(S),n=await i.openNotebook(E.URI.revive(c),{backupId:_,untitledDocumentData:t?.buffer},u);return new p.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(g.NotebookCellData.from)})}_createExtHostEditor(S,c,_){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const t=new l.ExtHostNotebookEditor(c,this._notebookEditorsProxy,S,_.visibleRanges.map(g.NotebookRange.to),_.selections.map(g.NotebookRange.to),typeof _.viewColumn=="number"?g.ViewColumn.to(_.viewColumn):void 0);this._editors.set(c,t)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const _ of S.value.removedDocuments){const t=E.URI.revive(_),u=this._documents.get(t);u&&(u.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:u.apiNotebook.getCells().map(i=>i.document.uri)}),this._onDidCloseNotebookDocument.fire(u.apiNotebook));for(const i of this._editors.values())i.notebookData.uri.toString()===t.toString()&&this._editors.delete(i.id)}if(S.value.addedDocuments){const _=[];for(const t of S.value.addedDocuments){const u=E.URI.revive(t.uri);if(this._documents.has(u))throw new Error(`adding EXISTING notebook ${u} `);const i=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,u,t);_.push(...t.cells.map(n=>a.ExtHostCell.asModelAddData(i.apiNotebook,n))),this._documents.get(u)?.dispose(),this._documents.set(u,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:_}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(S.value.addedEditors)for(const _ of S.value.addedEditors){if(this._editors.has(_.id))return;const t=E.URI.revive(_.documentUri),u=this._documents.get(t);u&&this._createExtHostEditor(u,_.id,_)}const c=[];if(S.value.removedEditors)for(const _ of S.value.removedEditors){const t=this._editors.get(_);t&&(this._editors.delete(_),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),c.push(t))}if(S.value.visibleEditors){this._visibleNotebookEditors=S.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const _=new Set;this._visibleNotebookEditors.forEach(t=>_.add(t.id));for(const t of this._editors.values()){const u=_.has(t.id);t._acceptVisibility(u)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this._activeNotebookEditor=void 0:S.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(S){const c=b.ApiCommandArgument.String.with("notebookType","A notebook type"),_=new b.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[c,new b.ApiCommandArgument("data","Bytes to convert to data",u=>u instanceof Uint8Array,u=>r.VSBuffer.wrap(u))],new b.ApiCommandResult("Notebook Data",u=>g.NotebookData.to(u.value))),t=new b.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[c,new b.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",u=>!0,u=>new p.SerializableObjectWithBuffers(g.NotebookData.from(u)))],new b.ApiCommandResult("Bytes",u=>u.buffer));S.registerApiCommand(_),S.registerApiCommand(t)}}e.ExtHostNotebookController=d,d._notebookStatusBarItemProviderHandlePool=0}),define(Ce[212],Ie([1,0,18,15,21,4,7,25,2,27,11,5,37,8,6,64,171,28,42]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a,l,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let S=class{constructor(n,s,h,o,f){this._initData=s,this._extHostNotebook=h,this._commands=o,this._logService=f,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=n.getProxy(b.MainContext.MainThreadNotebookKernels);const v=new g.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new g.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const M=this._extHostNotebook.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:M}}else if(T&&"notebookEditor"in T){const M=this._extHostNotebook.getIdByEditor(T.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.document.uri.toString()}`);return{notebookEditorId:M}}return T})],g.ApiCommandResult.Void);this._commands.registerApiCommand(v)}createNotebookController(n,s,h,o,f,v){for(const re of this._kernelData.values())if(re.controller.id===s&&P.ExtensionIdentifier.equals(n.identifier,re.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const T=this._handlePool++,M=this;this._logService.trace(`NotebookController[${T}], CREATED by ${n.identifier.value}, ${s}`);const j=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${n.identifier}'`);let U=!1;const D=new y.DisposableStore,$=new F.Emitter,L=new F.Emitter,O={id:u(n.identifier,s),notebookType:h,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:o||n.identifier.value,preloads:v?v.map(I.NotebookRendererScript.from):[]};let H=f??j,W;this._proxy.$addKernel(T,O).catch(re=>{console.log(re),U=!0});let z=0;const G=()=>{if(U)return;const re=++z;Promise.resolve().then(()=>{re===z&&this._proxy.$updateKernel(T,O)})},te=new A.ResourceMap,he={get id(){return s},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:$.event,get label(){return O.label},set label(re){O.label=re??n.displayName??n.name,G()},get detail(){return O.detail??""},set detail(re){O.detail=re,G()},get description(){return O.description??""},set description(re){O.description=re,G()},get kind(){return(0,d.checkProposedApiEnabled)(n,"notebookControllerKind"),O.kind??""},set kind(re){(0,d.checkProposedApiEnabled)(n,"notebookControllerKind"),O.kind=re,G()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(re){O.supportedLanguages=re,G()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(re){O.supportsExecutionOrder=re,G()},get rendererScripts(){return O.preloads?O.preloads.map(I.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(re){H=re??j},get interruptHandler(){return W},set interruptHandler(re){W=re,O.supportsInterrupt=Boolean(re),G()},createNotebookCellExecution(re){if(U)throw new Error("notebook controller is DISPOSED");if(!te.has(re.notebook.uri))throw M._logService.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(te.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return M._createNotebookCellExecution(re,u(n.identifier,this.id))},dispose:()=>{U||(this._logService.trace(`NotebookController[${T}], DISPOSED`),U=!0,this._kernelData.delete(T),D.dispose(),$.dispose(),L.dispose(),this._proxy.$removeKernel(T))},updateNotebookAffinity(re,be){be===p.NotebookControllerAffinity2.Hidden&&(0,d.checkProposedApiEnabled)(n,"notebookControllerAffinityHidden"),M._proxy.$updateNotebookPriority(T,re.uri,be)},onDidReceiveMessage:L.event,postMessage(re,be){return(0,d.checkProposedApiEnabled)(n,"notebookMessaging"),M._proxy.$postMessage(T,be&&M._extHostNotebook.getIdByEditor(be),re)},asWebviewUri(re){return(0,d.checkProposedApiEnabled)(n,"notebookMessaging"),(0,a.asWebviewUri)(re,M._initData.remote)}};return this._kernelData.set(T,{extensionId:n.identifier,controller:he,onDidReceiveMessage:L,onDidChangeSelection:$,associatedNotebooks:te}),he}getIdByController(n){for(const[s,h]of this._kernelData)if(h.controller===n)return u(h.extensionId,n.id);return null}$acceptNotebookAssociation(n,s,h){const o=this._kernelData.get(n);if(o){const f=this._extHostNotebook.getNotebookDocument(E.URI.revive(s));h?o.associatedNotebooks.set(f.uri,!0):o.associatedNotebooks.delete(f.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,f.uri.toString(),h),o.onDidChangeSelection.fire({selected:h,notebook:f.apiNotebook})}}async $executeCells(n,s,h){const o=this._kernelData.get(n);if(!o)return;const f=this._extHostNotebook.getNotebookDocument(E.URI.revive(s)),v=[];for(const T of h){const M=f.getCell(T);M&&v.push(M.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,f.uri.toString(),v.length),await o.controller.executeHandler.call(o.controller,v,f.apiNotebook,o.controller)}catch(T){this._logService.error(`NotebookController[${n}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(n,s,h){const o=this._kernelData.get(n);if(!o)return;const f=this._extHostNotebook.getNotebookDocument(E.URI.revive(s));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,f.apiNotebook);else for(const v of h){const T=f.getCell(v);T&&this._activeExecutions.get(T.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,s,h){const o=this._kernelData.get(n);if(!o)return;const f=this._extHostNotebook.getEditorById(s);o.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:h}))}$cellExecutionChanged(n,s,h){const f=this._extHostNotebook.getNotebookDocument(E.URI.revive(n)).getCell(s);if(f){const v=h?I.NotebookCellExecutionState.to(h):p.NotebookCellExecutionState.Idle;v!==void 0&&this._onDidChangeCellExecutionState.fire({cell:f.apiCell,state:v})}}_createNotebookCellExecution(n,s){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const f=new _(s,o,this._proxy);this._activeExecutions.set(o.uri,f);const v=f.onDidChangeState(()=>{f.state===c.Resolved&&(f.dispose(),v.dispose(),this._activeExecutions.delete(o.uri))});return f.asApiObject()}};S=$e([xe(4,R.ILogService)],S),e.ExtHostNotebookKernels=S;var c;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(c||(c={}));class _ extends y.Disposable{get state(){return this._state}constructor(n,s,h){super(),this._cell=s,this._proxy=h,this._handle=_.HANDLE++,this._onDidChangeState=new F.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new t(10,o=>this.update(o)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,n,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const s=Array.isArray(n)?n:[n];return this._proxy.$updateExecution(this._handle,new m.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let s=this._cell;if(n&&(s=this._cell.notebook.getCellFromApiCell(n)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(n){return n.map(s=>{const h=p.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return h===s.items?I.NotebookCellOutput.from(s):I.NotebookCellOutput.from({items:h,id:s.id,metadata:s.metadata})})}async updateOutputs(n,s,h){const o=this.cellIndexToHandle(s),f=this.validateAndConvertOutputs((0,r.asArray)(n));return this.updateSoon({editType:l.CellExecutionUpdateType.Output,cellHandle:o,append:h,outputs:f})}async updateOutputItems(n,s,h){return n=p.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(n),!0),this.updateSoon({editType:l.CellExecutionUpdateType.OutputItems,items:n.map(I.NotebookCellOutputItem.from),outputId:s.id,append:h})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(h){n._executionOrder=h,n.update([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:n._executionOrder}])},start(h){if(n._state===c.Resolved||n._state===c.Started)throw new Error("Cannot call start again");n._state=c.Started,n._onDidChangeState.fire(),n.update({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:h})},end(h,o){if(n._state===c.Resolved)throw new Error("Cannot call resolve twice");n._state=c.Resolved,n._onDidChangeState.fire(),n._collector.flush(),n._proxy.$completeExecution(n._handle,new m.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:h}))},clearOutput(h){return n.verifyStateForOutput(),n.updateOutputs([],h,!1)},appendOutput(h,o){return n.verifyStateForOutput(),n.updateOutputs(h,o,!0)},replaceOutput(h,o){return n.verifyStateForOutput(),n.updateOutputs(h,o,!1)},appendOutputItems(h,o){return n.verifyStateForOutput(),n.updateOutputItems(h,o,!0)},replaceOutputItems(h,o){return n.verifyStateForOutput(),n.updateOutputItems(h,o,!1)}})}}_.HANDLE=0;class t{constructor(n,s){this.delay=n,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new C.DeferredPromise,this.startedTimer=Date.now(),(0,C.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>n.complete())}}function u(i,n){return`${i.value}/${n}`}e.createKernelId=u}),define(Ce[213],Ie([1,0,4,5,94]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class F{constructor(A,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(C.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,E,P){const R=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(E)?.fire({editor:R.apiEditor,message:P})}createRendererMessaging(A,E){if(!A.contributes?.notebookRenderer?.some(R=>R.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(R,b,g)=>this.getOrCreateEmitterFor(E).event(R,b,g),postMessage:(R,b)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,b]=[b,R]);const g=b&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(b);return this.proxy.$postMessage(g?.id,E,R)}}}getOrCreateEmitterFor(A){let E=this._rendererMessageEmitters.get(A);return E||(E=new r.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,E),E)}}e.ExtHostNotebookRenderers=F}),define(Ce[214],Ie([1,0,21,4,7,5,2,6,12,18,29,61]),function(ne,e,r,C,w,F,y,A,E,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(I,p,a){const l=I.getProxy(F.MainContext.MainThreadQuickOpen);class d{constructor(s,h){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=h}showQuickPick(s,h,o=r.CancellationToken.None){this._onDidSelectItem=void 0;const f=Promise.resolve(s),v=++this._instances,T=l.$show(v,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},o),M={},j=T.then(()=>M);return Promise.race([j,f]).then(U=>{if(U!==M)return f.then(D=>{const $=[];for(let L=0;L<D.length;L++){const O=D[L];typeof O=="string"?$.push({label:O,handle:L}):O.kind===A.QuickPickItemKind.Separator?$.push({type:"separator",label:O.label}):$.push({label:O.label,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,handle:L})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=L=>{h.onDidSelectItem(D[L])}),l.$setItems(v,$),T.then(L=>{if(typeof L=="number")return D[L];if(Array.isArray(L))return L.map(O=>D[O])})})}).then(void 0,U=>{if(!(0,E.isCancellationError)(U))return l.$setError(v,U),Promise.reject(U)})}$onItemSelected(s){this._onDidSelectItem?.(s)}showInput(s,h=r.CancellationToken.None){return this._validateInput=s?.validateInput,l.$input(s,typeof this._validateInput=="function",h).then(void 0,o=>{if(!(0,E.isCancellationError)(o))return Promise.reject(o)})}async $validateInput(s){if(!this._validateInput)return;const h=await this._validateInput(s);if(!h||typeof h=="string")return h;let o;switch(h.severity){case A.InputBoxValidationSeverity.Info:o=R.default.Info;break;case A.InputBoxValidationSeverity.Warning:o=R.default.Warning;break;case A.InputBoxValidationSeverity.Error:o=R.default.Error;break;default:o=h.message?R.default.Error:R.default.Ignore;break}return{content:h.message,severity:o}}async showWorkspaceFolderPick(s,h=r.CancellationToken.None){const o=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!o)return;const f=await this._workspace.getWorkspaceFolders2();if(!!f)return f.find(v=>v.uri.toString()===o.uri.toString())}createQuickPick(s){const h=new u(s,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(s){const h=new i(s,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(s,h){this._sessions.get(s)?._fireDidChangeValue(h)}$onDidAccept(s){this._sessions.get(s)?._fireDidAccept()}$onDidChangeActive(s,h){const o=this._sessions.get(s);o instanceof u&&o._fireDidChangeActive(h)}$onDidChangeSelection(s,h){const o=this._sessions.get(s);o instanceof u&&o._fireDidChangeSelection(h)}$onDidTriggerButton(s,h){this._sessions.get(s)?._fireDidTriggerButton(h)}$onDidTriggerItemButton(s,h,o){const f=this._sessions.get(s);f instanceof u&&f._fireDidTriggerItemButton(h,o)}$onDidHide(s){this._sessions.get(s)?._fireDidHide()}}class m{constructor(s,h){this._extensionId=s,this._onDidDispose=h,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((h,o)=>{const f=h===A.QuickInputButtons.Back?-1:o;this._handlesToButtons.set(f,h)}),this.update({buttons:s.map((h,o)=>({...t(h),tooltip:h.tooltip,handle:h===A.QuickInputButtons.Back?-1:o}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const h=this._handlesToButtons.get(s);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,w.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),l.$dispose(this._id))}update(s){if(!this._disposed){for(const h of Object.keys(s)){const o=s[h];this._pendingUpdate[h]=o===void 0?null:o}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){l.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}m._nextId=1;function S(n){if(n instanceof A.ThemeIcon)return{id:n.id};const s=_(n),h=c(n);return{dark:typeof s=="string"?y.URI.file(s):s,light:typeof h=="string"?y.URI.file(h):h}}function c(n){return typeof n=="object"&&"light"in n?n.light:n}function _(n){return typeof n=="object"&&"dark"in n?n.dark:n}function t(n){const s=S(n.iconPath);let h,o;return"id"in s?o=b.ThemeIcon.asClassName(s):h=s,{iconPath:h,iconClass:o}}class u extends m{constructor(s,h){super(s.identifier,h),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this._onDidTriggerItemButtonEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((o,f)=>{this._handlesToItems.set(f,o),this._itemsToHandles.set(o,f)});const h=[];for(let o=0;o<s.length;o++){const f=s[o];f.kind===A.QuickPickItemKind.Separator?h.push({type:"separator",label:f.label}):h.push({handle:o,label:f.label,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,buttons:f.buttons?.map((v,T)=>({...t(v),tooltip:v.tooltip,handle:T}))})}this.update({items:h})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(s){const h=(0,P.coalesce)(s.map(o=>this._handlesToItems.get(o)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(s){const h=(0,P.coalesce)(s.map(o=>this._handlesToItems.get(o)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(s,h){const o=this._handlesToItems.get(s);if(!o||!o.buttons||!o.buttons.length)return;const f=o.buttons[h];f&&this._onDidTriggerItemButtonEmitter.fire({button:f,item:o})}}class i extends m{constructor(s,h){super(s.identifier,h),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,s?typeof s=="string"?this.update({validationMessage:s,severity:R.default.Error}):this.update({validationMessage:s.message,severity:s.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new d(p,a)}e.createExtHostQuickOpen=g});var Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!C:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ne):C?C.value:e.get(ne)},Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(ne,r):w?w.value=r:e.set(ne,r),r};define(Ce[215],Ie([1,0,2,4,57,7,15,5,18,118,11,27,61,8,28]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p){"use strict";var a,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(f){if(f)return typeof f.iconPath=="string"?r.URI.file(f.iconPath):r.URI.isUri(f.iconPath)||g.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function m(f,v){if(!f.iconPath&&!v.iconPath)return 0;if(f.iconPath){if(!v.iconPath)return 1}else return-1;const T=typeof f.iconPath=="string"?f.iconPath:r.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,M=typeof v.iconPath=="string"?v.iconPath:r.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,P.comparePaths)(T,M)}function S(f,v){let T=0;if(f.strikeThrough!==v.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==v.faded)return f.faded?1:-1;if(f.tooltip!==v.tooltip)return(f.tooltip||"").localeCompare(v.tooltip||"");if(T=m(f,v),T!==0)return T;if(f.light&&v.light)T=m(f.light,v.light);else{if(f.light)return 1;if(v.light)return-1}if(T!==0)return T;if(f.dark&&v.dark)T=m(f.dark,v.dark);else{if(f.dark)return 1;if(v.dark)return-1}return T}function c(f,v){if(f.command!==v.command)return f.command<v.command?-1:1;if(f.title!==v.title)return f.title<v.title?-1:1;if(f.tooltip!==v.tooltip){if(f.tooltip!==void 0&&v.tooltip!==void 0)return f.tooltip<v.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(f.arguments===v.arguments)return 0;if(f.arguments)if(v.arguments){if(f.arguments.length!==v.arguments.length)return f.arguments.length-v.arguments.length}else return 1;else return-1;for(let T=0;T<f.arguments.length;T++){const M=f.arguments[T],j=v.arguments[T];if(M!==j)return M<j?-1:1}return 0}function _(f,v){let T=(0,P.comparePaths)(f.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(T!==0)return T;if(f.command&&v.command)T=c(f.command,v.command);else{if(f.command)return 1;if(v.command)return-1}if(T!==0)return T;if(f.decorations&&v.decorations)T=S(f.decorations,v.decorations);else{if(f.decorations)return 1;if(v.decorations)return-1}return T}function t(f,v){for(let T=0;T<f.length;T++)if(f[T]!==v[T])return!1;return!0}function u(f,v){return f.command===v.command&&f.title===v.title&&f.tooltip===v.tooltip&&(f.arguments&&v.arguments?t(f.arguments,v.arguments):f.arguments===v.arguments)}function i(f,v){return(0,E.equals)(f,v,u)}class n{get value(){return this._value}set value(v){v=v??"",Oe(this,a,"f").$setInputBoxValue(this._sourceControlHandle,v),this.updateValue(v)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(v){Oe(this,a,"f").$setInputBoxPlaceholder(this._sourceControlHandle,v),this._placeholder=v}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(v){if((0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=v,Oe(this,a,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!v)}get enabled(){return this._enabled}set enabled(v){v=!!v,this._enabled!==v&&(this._enabled=v,Oe(this,a,"f").$setInputBoxEnablement(this._sourceControlHandle,v))}get visible(){return this._visible}set visible(v){v=!!v,this._visible!==v&&(this._visible=v,Oe(this,a,"f").$setInputBoxVisibility(this._sourceControlHandle,v))}constructor(v,T,M){this._extension=v,this._sourceControlHandle=M,a.set(this,void 0),this._value="",this._onDidChange=new C.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Ye(this,a,T,"f")}showValidationMessage(v,T){(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,a,"f").$showValidationMessage(this._sourceControlHandle,v,T)}$onInputBoxValueChange(v){this.updateValue(v)}updateValue(v){this._value=v,this._onDidChange.fire(v)}}e.ExtHostSCMInputBox=n,a=new WeakMap;class s{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(v){this._label=v,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,v)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(v){this._hideWhenEmpty=v,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(v){this._resourceStates=[...v],this._onDidUpdateResourceStates.fire()}constructor(v,T,M,j,U){this._proxy=v,this._commands=T,this._sourceControlHandle=M,this._id=j,this._label=U,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new C.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new C.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}getResourceState(v){return this._resourceStatesMap.get(v)}$executeResourceCommand(v,T){const M=this._resourceStatesCommandsMap.get(v);return M?(0,y.asPromise)(()=>this._commands.executeCommand(M.command,...M.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this._resourceStates].sort(_),M=(0,E.sortedDiff)(this._resourceSnapshot,v,_).map(D=>{const $=D.toInsert.map(L=>{const O=this._resourceHandlePool++;this._resourceStatesMap.set(O,L);const H=L.resourceUri;let W;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const pe=new F.DisposableStore;W=this._commands.converter.toInternal(L.command,pe),this._resourceStatesDisposablesMap.set(O,pe)}else this._resourceStatesCommandsMap.set(O,L.command);const z=d(L.decorations),G=L.decorations&&d(L.decorations.light)||z,te=L.decorations&&d(L.decorations.dark)||z,he=[G,te],re=L.decorations&&L.decorations.tooltip||"",be=L.decorations&&!!L.decorations.strikeThrough,le=L.decorations&&!!L.decorations.faded,fe=L.contextValue||"";return{rawResource:[O,H,he,re,be,le,fe,W],handle:O}});return{start:D.start,deleteCount:D.deleteCount,toInsert:$}}),j=M.map(({start:D,deleteCount:$,toInsert:L})=>[D,$,L.map(O=>O.rawResource)]),U=M.reverse();for(const{start:D,deleteCount:$,toInsert:L}of U){const O=L.map(W=>W.handle),H=this._handlesSnapshot.splice(D,$,...O);for(const W of H)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),this._resourceStatesDisposablesMap.get(W)?.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=v,j}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class h{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(v){this._count!==v&&(this._count=v,Oe(this,l,"f").$updateSourceControl(this.handle,{count:v}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(v){this._quickDiffProvider=v,Oe(this,l,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!v})}get commitTemplate(){return this._commitTemplate}set commitTemplate(v){v!==this._commitTemplate&&(this._commitTemplate=v,Oe(this,l,"f").$updateSourceControl(this.handle,{commitTemplate:v}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(v){this._acceptInputDisposables.value=new F.DisposableStore,this._acceptInputCommand=v;const T=this._commands.converter.toInternal(v,this._acceptInputDisposables.value);Oe(this,l,"f").$updateSourceControl(this.handle,{acceptInputCommand:T})}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(v){(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new F.DisposableStore,this._actionButton=v;const T=v!==void 0?{command:this._commands.converter.toInternal(v.command,this._actionButtonDisposables.value),secondaryCommands:v.secondaryCommands?.map(M=>M.map(j=>this._commands.converter.toInternal(j,this._actionButtonDisposables.value))),description:v.description,enabled:v.enabled}:void 0;Oe(this,l,"f").$updateSourceControl(this.handle,{actionButton:T??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(v){if(this._statusBarCommands&&v&&i(this._statusBarCommands,v))return;this._statusBarDisposables.value=new F.DisposableStore,this._statusBarCommands=v;const T=(v||[]).map(M=>this._commands.converter.toInternal(M,this._statusBarDisposables.value));Oe(this,l,"f").$updateSourceControl(this.handle,{statusBarCommands:T})}get selected(){return this._selected}constructor(v,T,M,j,U,D){this._extension=v,this._commands=M,this._id=j,this._label=U,this._rootUri=D,l.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new F.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new F.MutableDisposable,this._statusBarDisposables=new F.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new C.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=h._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ye(this,l,T,"f"),this._inputBox=new n(v,Oe(this,l,"f"),this.handle),Oe(this,l,"f").$registerSourceControl(this.handle,j,U,D)}createResourceGroup(v,T){const M=new s(Oe(this,l,"f"),this._commands,this.handle,v,T),j=C.Event.once(M.onDidDispose)(()=>this.createdResourceGroups.delete(M));return this.createdResourceGroups.set(M,j),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const v=[],T=[];for(const[M,j]of this.createdResourceGroups){j.dispose();const U=M.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(M),this.eventuallyUpdateResourceStates()});C.Event.once(M.onDidDispose)(()=>{this.updatedResourceGroups.delete(M),U.dispose(),this._groups.delete(M.handle),Oe(this,l,"f").$unregisterGroup(this.handle,M.handle)}),v.push([M.handle,M.id,M.label,M.features]);const D=M._takeResourceStateSnapshot();D.length>0&&T.push([M.handle,D]),this._groups.set(M.handle,M)}Oe(this,l,"f").$registerGroups(this.handle,v,T),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const v=[];this.updatedResourceGroups.forEach(T=>{const M=T._takeResourceStateSnapshot();M.length!==0&&v.push([T.handle,M])}),v.length>0&&Oe(this,l,"f").$spliceResourceStates(this.handle,v),this.updatedResourceGroups.clear()}getResourceGroup(v){return this._groups.get(v)}setSelectionState(v){this._selected=v,this._onDidChangeSelection.fire(v)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(v=>v.dispose()),Oe(this,l,"f").$unregisterSourceControl(this.handle)}}l=new WeakMap,h._handlePool=0,$e([(0,w.debounce)(100)],h.prototype,"eventuallyAddResourceGroups",null),$e([(0,w.debounce)(100)],h.prototype,"eventuallyUpdateResourceStates",null);let o=class Ji{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(v,T,M){this._commands=T,this.logService=M,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new C.Emitter,this._proxy=v.getProxy(A.MainContext.MainThreadSCM),this._telemetry=v.getProxy(A.MainContext.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const U=this._sourceControls.get(j.sourceControlHandle);if(!U)return j;const D=U.getResourceGroup(j.groupHandle);return D?D.getResourceState(j.handle):j}else if(j&&j.$mid===4){const U=this._sourceControls.get(j.sourceControlHandle);return U?U.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const U=this._sourceControls.get(j.handle);return U||j}return j}})}createSourceControl(v,T,M,j){this.logService.trace("ExtHostSCM#createSourceControl",v.identifier.value,T,M,j),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const U=Ji._handlePool++,D=new h(v,this._proxy,this._commands,T,M,j);this._sourceControls.set(U,D);const $=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(v.identifier))||[];return $.push(D),this._sourceControlsByExtension.set(b.ExtensionIdentifier.toKey(v.identifier),$),D}getLastInputBox(v){this.logService.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const T=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(v.identifier)),M=T&&T[T.length-1];return M&&M.inputBox}$provideOriginalResource(v,T,M){const j=r.URI.revive(T);this.logService.trace("ExtHostSCM#$provideOriginalResource",v,j.toString());const U=this._sourceControls.get(v);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>U.quickDiffProvider.provideOriginalResource(j,M)).then(D=>D||null)}$onInputBoxValueChange(v,T){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",v);const M=this._sourceControls.get(v);return M&&M.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(v,T,M,j){this.logService.trace("ExtHostSCM#$executeResourceCommand",v,T,M);const U=this._sourceControls.get(v);if(!U)return Promise.resolve(void 0);const D=U.getResourceGroup(T);return D?D.$executeResourceCommand(M,j):Promise.resolve(void 0)}$validateInput(v,T,M){this.logService.trace("ExtHostSCM#$validateInput",v);const j=this._sourceControls.get(v);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>j.inputBox.validateInput(T,M)).then(U=>{if(!U)return Promise.resolve(void 0);const D=I.MarkdownString.fromStrict(U.message);return D?Promise.resolve([D,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this._sourceControls.get(v)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=v,Promise.resolve(void 0)}};o._handlePool=0,o=$e([xe(2,R.ILogService)],o),e.ExtHostSCM=o}),define(Ce[71],Ie([1,0,5,4,3]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class F{constructor(A){this._onDidChangePassword=new C.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,E){return this._proxy.$getPassword(A,E)}store(A,E,P){return this._proxy.$setPassword(A,E,P)}delete(A,E){return this._proxy.$deletePassword(A,E)}}e.ExtHostSecretState=F,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(ne,r):w?w.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!C:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ne):C?C.value:e.get(ne)};define(Ce[216],Ie([1,0,6,5,133,7,8,10]),function(ne,e,r,C,w,F,y,A){"use strict";var E,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(p,a,l,d,m=r.StatusBarAlignment.Left,S){E.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new F.DisposableStore,Ye(this,E,p,"f"),Ye(this,P,a,"f"),this._entryId=R.ID_GEN++,this._extension=l,this._id=d,this._alignment=m,this._priority=this.validatePriority(S)}validatePriority(p){if(!!(0,A.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!R.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._internalCommandRegistration.clear(),typeof p=="string"?this._command={fromApi:p,internal:Oe(this,P,"f").toInternal({title:"",command:p},this._internalCommandRegistration)}:p?this._command={fromApi:p,internal:Oe(this,P,"f").toInternal(p,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let a;this._name?a=this._name:a=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let l=this._color;this._backgroundColor&&(l=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const d=y.MarkdownString.fromStrict(this._tooltip);Oe(this,E,"f").$setEntry(this._entryId,p,a,this._text,d,this._command?.internal,l,this._backgroundColor,this._alignment===r.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,E=new WeakMap,P=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const a={message:p};return this._messages.unshift(a),this._update(),new r.Disposable(()=>{const l=this._messages.indexOf(a);l>=0&&(this._messages.splice(l,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class g{constructor(p,a){this._proxy=p.getProxy(C.MainContext.MainThreadStatusBar),this._commands=a,this._statusMessage=new b(this)}createStatusBarEntry(p,a,l,d){return new R(this._proxy,this._commands,p,a,l,d)}setStatusBarMessage(p,a){const l=this._statusMessage.setMessage(p);let d;return typeof a=="number"?d=setTimeout(()=>l.dispose(),a):typeof a<"u"&&a.then(()=>l.dispose(),()=>l.dispose()),new r.Disposable(()=>{l.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=g}),define(Ce[72],Ie([1,0,5,4,3]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class F{constructor(A){this._onDidChangeStorage=new C.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,E){this._proxy.$registerExtensionStorageKeysToSync(A,E)}initializeExtensionStorage(A,E,P){return this._proxy.$initializeExtensionStorage(A,E).then(R=>R||P)}setValue(A,E,P){return this._proxy.$setValue(A,E,P)}$acceptValue(A,E,P){this._onDidChangeStorage.fire({shared:A,key:E,value:P})}}e.ExtHostStorage=F,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(Ce[73],Ie([1,0,3,26,11,54,2]),function(ne,e,r,C,w,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let A=class{constructor(P,R,b){this._logService=R,this._extHostFileSystem=b,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getWorkspaceStorageURI(P){return y.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,R=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:y.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(P){if(this._value)return y.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return y.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=$e([xe(0,C.IExtHostInitDataService),xe(1,w.ILogService),xe(2,F.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ce[55],Ie([1,0,4,5,3,2,14,7,6,134,12,172,21,38,158,61,10,15,8]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a,l,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class S{constructor(o,f,v,T){this._proxy=o,this._id=f,this._creationOptions=v,this._name=T,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(j=>this._pidPromiseComplete=j);const M=this;this.value={get name(){return M._name||""},get processId(){return M._pidPromise},get creationOptions(){return M._creationOptions},get exitStatus(){return M._exitStatus},get state(){return M._state},sendText(j,U=!0){M._checkDisposed(),M._proxy.$sendText(M._id,j,U)},show(j){M._checkDisposed(),M._proxy.$show(M._id,j)},hide(){M._checkDisposed(),M._proxy.$hide(M._id)},dispose(){M._disposed||(M._disposed=!0,M._proxy.$dispose(M._id))},get dimensions(){if(!(M._cols===void 0||M._rows===void 0))return{columns:M._cols,rows:M._rows}}}}async create(o,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,l.withNullAsUndefined)(o.shellPath),shellArgs:(0,l.withNullAsUndefined)(o.shellArgs),cwd:(0,l.withNullAsUndefined)(o.cwd),env:(0,l.withNullAsUndefined)(o.env),icon:(0,l.withNullAsUndefined)(n(o.iconPath)),color:a.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,l.withNullAsUndefined)(o.message),strictEnv:(0,l.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,l.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,l.withNullAsUndefined)(f?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,l.withNullAsUndefined)(f?.useShellEnvironment),location:f?.location||this._serializeParentTerminal(o.location,f?.resolvedExtHostIdentifier),isTransient:(0,l.withNullAsUndefined)(o.isTransient)})}async createExtensionTerminal(o,f,v,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:v,color:a.ThemeColor.isThemeColor(T)?T.id:void 0,location:this._serializeParentTerminal(o,f),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,f){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in o?{viewColumn:m.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitStatus(o,f){this._exitStatus=Object.freeze({code:o,reason:f})}setDimensions(o,f){return o===this._cols&&f===this._rows||o===0||f===0?!1:(this._cols=o,this._rows=f,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(f=>{f!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=S;class c{get onProcessReady(){return this._onProcessReady.event}constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._onProcessData=new r.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new r.Emitter,this._onDidChangeProperty=new r.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new r.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${f}`)}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput?.(o)}resize(o,f){this._pty.setDimensions?.({columns:o,rows:f})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(f=>this._onProcessData.fire(f)),this._pty.onDidClose?.((f=void 0)=>{this._onProcessExit.fire(f===void 0?void 0:f)}),this._pty.onDidOverrideDimensions?.(f=>{f&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:f.columns,rows:f.rows}})}),this._pty.onDidChangeName?.(f=>{this._onDidChangeProperty.fire({type:"title",value:f})}),this._pty.open(o||void 0),o&&this._pty.setDimensions?.(o),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=c;let _=1,t=class extends A.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(o,f){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new r.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new r.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new r.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new r.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new r.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new r.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=f.getProxy(C.MainContext.MainThreadTerminalService),this._bufferer=new p.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new r.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[v,T]of this._terminalProcesses)T.shutdown(!0)}})}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,f){const v=new S(this._proxy,(0,I.generateUuid)(),o,o.name),T=new c(o.pty);return v.createExtensionTerminal(o.location,this._serializeParentTerminal(o,f).resolvedExtHostIdentifier,n(o.iconPath),s(o.color)).then(M=>{const j=this._setupExtHostProcessListeners(M,T);this._terminalProcessDisposables[M]=j}),this._terminals.push(v),v.value}_serializeParentTerminal(o,f){if(f=f||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const v=o.location.parentTerminal;if(v){const T=this._terminals.find(M=>M.value===v);T&&(f.resolvedExtHostIdentifier=T._id)}}else o.location&&typeof o.location!="object"?f.location=o.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal(o,f){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const T=new c(f),M=this._setupExtHostProcessListeners(o,T);this._terminalProcessDisposables[o]=M}async $acceptActiveTerminalChanged(o){const f=this._activeTerminal;if(o===null){this._activeTerminal=void 0,f!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const v=this._getTerminalById(o);v&&(this._activeTerminal=v,f!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,f){const v=this._getTerminalById(o);v&&this._onDidWriteTerminalData.fire({terminal:v.value,data:f})}async $acceptTerminalDimensions(o,f,v){const T=this._getTerminalById(o);T&&T.setDimensions(f,v)&&this._onDidChangeTerminalDimensions.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptTerminalMaximumDimensions(o,f,v){this._terminalProcesses.get(o)?.resize(f,v)}async $acceptTerminalTitleChange(o,f){const v=this._getTerminalById(o);v&&(v.name=f)}async $acceptTerminalClosed(o,f,v){const T=this._getTerminalObjectIndexById(this._terminals,o);if(T!==null){const M=this._terminals.splice(T,1)[0];M.setExitStatus(f,v),this._onDidCloseTerminal.fire(M.value)}}$acceptTerminalOpened(o,f,v,T){if(f){const U=this._getTerminalObjectIndexById(this._terminals,f);if(U!==null){this._terminals[U]._id=o,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const M={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:F.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},j=new S(this._proxy,o,M,v);this._terminals.push(j),this._onDidOpenTerminal.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(o,f){this._getTerminalById(o)?._setProcessId(f)}async $startExtensionTerminal(o,f){const v=this._getTerminalById(o);if(!v)return{message:(0,P.localize)(0,null,o)};v.isOpen||await new Promise(M=>{const j=this.onDidOpenTerminal(async U=>{U===v.value&&(j.dispose(),M())})});const T=this._terminalProcesses.get(o);T?T.startSendingEvents(f):this._extensionTerminalAwaitingStart[o]={initialDimensions:f}}_setupExtHostProcessListeners(o,f){const v=new A.DisposableStore;v.add(f.onProcessReady(M=>this._proxy.$sendProcessReady(o,M.pid,M.cwd))),v.add(f.onDidChangeProperty(M=>this._proxy.$sendProcessProperty(o,M))),this._bufferer.startBuffering(o,f.onProcessData),v.add(f.onProcessExit(M=>this._onProcessExit(o,M))),this._terminalProcesses.set(o,f);const T=this._extensionTerminalAwaitingStart[o];return T&&f instanceof c&&(f.startSendingEvents(T.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),v}$acceptProcessAckDataEvent(o,f){this._terminalProcesses.get(o)?.acknowledgeDataEvent(f)}$acceptProcessInput(o,f){this._terminalProcesses.get(o)?.input(f)}$acceptTerminalInteraction(o){const f=this._getTerminalById(o);f?.setInteractedWith()&&this._onDidChangeTerminalState.fire(f.value)}$acceptProcessResize(o,f,v){try{this._terminalProcesses.get(o)?.resize(f,v)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(o,f){this._terminalProcesses.get(o)?.shutdown(f)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(f=>this._proxy.$sendProcessProperty(o,{type:"initialCwd",value:f}))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(f=>this._proxy.$sendProcessProperty(o,{type:"cwd",value:f}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,f,v){if(this._profileProviders.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this._profileProviders.set(f,v),this._proxy.$registerProfileProvider(f,o.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(f),this._proxy.$unregisterProfileProvider(f)})}async $createContributedProfileTerminal(o,f){const v=new g.CancellationTokenSource().token;let T=await this._profileProviders.get(o)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,f);return}this.createTerminalFromOptions(T.options,f)}}async $provideLinks(o,f){const v=this._getTerminalById(o);if(!v)return[];this._terminalLinkCache.delete(o),this._terminalLinkCancellationSource.get(o)?.dispose(!0);const M=new g.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,M);const j=[],U={terminal:v.value,line:f},D=[];for(const O of this._linkProviders)D.push(d.Promises.withAsyncBody(async H=>{M.token.onCancellationRequested(()=>H({provider:O,links:[]}));const W=await O.provideTerminalLinks(U,M.token)||[];M.token.isCancellationRequested||H({provider:O,links:W})}));const $=await Promise.all(D);if(M.token.isCancellationRequested)return[];const L=new Map;for(const O of $)O&&O.links.length>0&&j.push(...O.links.map(H=>{const W={id:_++,startIndex:H.startIndex,length:H.length,label:H.tooltip};return L.set(W.id,{provider:O.provider,link:H}),W}));return this._terminalLinkCache.set(o,L),j}$activateLink(o,f){const v=this._terminalLinkCache.get(o)?.get(f);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(o,f){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const v=this._terminalProcessDisposables[o];v&&(v.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,f)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,f){const v=this._getTerminalObjectIndexById(o,f);return v!==null?o[v]:null}_getTerminalObjectIndexById(o,f){let v=null;return o.some((T,M)=>T._id===f?(v=M,!0):!1),v}getEnvironmentVariableCollection(o){let f=this._environmentVariableCollections.get(o.identifier.value);return f||(f=new u,this._setEnvironmentVariableCollection(o.identifier.value,f)),f}_syncEnvironmentVariableCollection(o,f){const v=(0,b.serializeEnvironmentVariableCollection)(f.map);this._proxy.$setEnvironmentVariableCollection(o,f.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(o){o.forEach(f=>{const v=f[0],T=new u(f[1]);this._setEnvironmentVariableCollection(v,T)})}$acceptDefaultProfile(o,f){const v=this._defaultProfile;this._defaultProfile=o,this._defaultAutomationProfile=f,v?.path!==o.path&&this._onDidChangeShell.fire(o.path)}_setEnvironmentVariableCollection(o,f){this._environmentVariableCollections.set(o,f),f.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,f)})}};t=$e([xe(1,y.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class u{get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(o){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new r.Emitter,this.map=new Map(o)}get size(){return this.map.size}replace(o,f){this._setIfDiffers(o,{value:f,type:E.EnvironmentVariableMutatorType.Replace})}append(o,f){this._setIfDiffers(o,{value:f,type:E.EnvironmentVariableMutatorType.Append})}prepend(o,f){this._setIfDiffers(o,{value:f,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(o,f){const v=this.map.get(o);(!v||v.value!==f.value||v.type!==f.type)&&(this.map.set(o,f),this._onDidChangeCollection.fire())}get(o){return this.map.get(o)}forEach(o,f){this.map.forEach((v,T)=>o.call(f,T,v,this))}[Symbol.iterator](){return this.map.entries()}delete(o){this.map.delete(o),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let i=class extends t{constructor(o){super(!1,o)}createTerminal(o,f,v){throw new R.NotSupportedError}createTerminalFromOptions(o,f){throw new R.NotSupportedError}};i=$e([xe(0,y.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function n(h){if(!(!h||typeof h=="string"))return"id"in h?{id:h.id,color:h.color}:h}function s(h){return a.ThemeColor.isThemeColor(h)?h:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!C:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ne):C?C.value:e.get(ne)},Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(ne,r):w?w.value=r:e.set(ne,r),r};define(Ce[217],Ie([1,0,18,23,21,4,181,218,7,24,10,38,5,14,95,8,6,41,66,50]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a,l,d,m,S){"use strict";var c,_;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let t=class{constructor(U,D,$){this.editors=$,this.resultsChangedEmitter=new F.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=U.getProxy(g.MainContext.MainThreadTesting),this.observer=new v(this.proxy),this.runTracker=new i(this.proxy),D.registerArgumentProcessor({processArgument:L=>{if(L?.$mid!==13)return L;const O=L,H=O.tests[O.tests.length-1].item.extId;return this.controllers.get(d.TestId.root(H))?.collection.tree.get(H)?.actual??(0,p.toItemFromContext)(L)}})}createTestController(U,D,$){if(this.controllers.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const L=new E.DisposableStore,O=L.add(new p.ExtHostTestItemCollection(U,D,this.editors));O.root.label=D;const H=new Map,W=this.proxy,z={items:O.root.children,get label(){return D},set label(te){D=te,O.root.label=te,W.$updateController(U,{label:D})},get refreshHandler(){return $},set refreshHandler(te){$=te,W.$updateController(U,{canRefresh:!!te})},get id(){return U},createRunProfile:(te,he,re,be,le)=>{let fe=(0,A.hash)(te);for(;H.has(fe);)fe++;return new T(this.proxy,H,U,fe,te,he,re,be,le)},createTestItem(te,he,re){return new p.TestItemImpl(U,te,he,re)},createTestRun:(te,he,re=!0)=>this.runTracker.createTestRun(U,O,te,he,re),set resolveHandler(te){O.resolveHandler=te},get resolveHandler(){return O.resolveHandler},dispose:()=>{L.dispose()}};W.$registerTestController(U,D,!!$),L.add((0,E.toDisposable)(()=>W.$unregisterTestController(U)));const G={controller:z,collection:O,profiles:H};return this.controllers.set(U,G),L.add((0,E.toDisposable)(()=>this.controllers.delete(U))),L.add(O.onDidGenerateDiff(te=>W.$publishDiff(U,te.map(S.TestsDiffOp.serialize)))),z}createTestObserver(){return this.observer.checkout()}async runTests(U,D=w.CancellationToken.None){const $=n(U);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const L=this.controllers.get($.controllerId);if(!L)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(O=>d.TestId.fromExtHostTestItem(O,L.collection.root.id).toString())??[L.collection.root.id],profileGroup:M[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:U.exclude?.map(O=>O.id)},D)}$syncTests(){for(const{collection:U}of this.controllers.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,D,$){return(0,r.mapFind)(this.runTracker.trackers,O=>O.id===U?O.getCoverage(D):void 0)?.provideFileCoverage($)??Promise.resolve([])}$resolveFileCoverage(U,D,$,L){return(0,r.mapFind)(this.runTracker.trackers,H=>H.id===U?H.getCoverage(D):void 0)?.resolveFileCoverage($,L)??Promise.resolve([])}$configureRunProfile(U,D){this.controllers.get(U)?.profiles.get(D)?.configureHandler?.()}async $refreshTests(U,D){await this.controllers.get(U)?.controller.refreshHandler?.(D)}$publishTestResults(U){this.results=Object.freeze(U.map(D=>(0,P.deepFreeze)(a.TestResults.to(D))).concat(this.results).sort((D,$)=>$.completedAt-D.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(U,D){const $=this.controllers.get(d.TestId.fromString(U).controllerId)?.collection;$&&(await $.expand(U,D<0?1/0:D),$.flushDiff())}$acceptDiff(U){this.observer.applyDiff(U.map(S.TestsDiffOp.deserialize))}async $runControllerTests(U,D){return Promise.all(U.map($=>this.runControllerTestRequest($,D)))}async runControllerTestRequest(U,D){const $=this.controllers.get(U.controllerId);if(!$)return{};const{collection:L,profiles:O}=$,H=O.get(U.profileId);if(!H)return{};const W=U.testIds.map(he=>L.tree.get(he)).filter(R.isDefined),z=U.excludeExtIds.map(he=>$.collection.tree.get(he)).filter(R.isDefined).filter(he=>W.some(re=>re.fullId.compare(he.fullId)===2));if(!W.length)return{};const G=new l.TestRunRequest(W.some(he=>he.actual instanceof p.TestItemRootImpl)?void 0:W.map(he=>he.actual),z.map(he=>he.actual),H),te=this.runTracker.prepareForMainThreadTestRun(G,s.fromInternal(U,$.collection),D);try{return await H.runHandler(G,D),{}}catch(he){return{error:String(he)}}finally{te.isRunning&&!D.isCancellationRequested&&await F.Event.toPromise(te.onEnd),te.dispose()}}$cancelExtensionTestRun(U){U===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(U)}};t=$e([xe(0,I.IExtHostRpcService)],t),e.ExtHostTesting=t;class u extends E.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(U,D,$){super(),this.dto=U,this.proxy=D,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new F.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource($)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:L}of this.tasks.values())L.end()}))}getCoverage(U){return this.tasks.get(U)?.coverage}createRun(U){const D=this.dto.id,$=this.dto.controllerId,L=(0,b.generateUuid)(),O=new h(this.proxy,D,L),H=te=>(he,...re)=>{if(z){console.warn(`Setting the state of test "${he.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(he)||(this.ensureTestIsKnown(he),te(he,...re))},W=(te,he)=>{const re=he instanceof Array?he.map(a.TestMessage.from):[a.TestMessage.from(he)];if(te.uri&&te.range){const be={range:a.Range.from(te.range),uri:te.uri};for(const le of re)le.location=le.location||be}this.proxy.$appendTestMessagesInRun(D,L,d.TestId.fromExtHostTestItem(te,$).toString(),re)};let z=!1;const G={isPersisted:this.dto.isPersisted,token:this.cts.token,name:U,get coverageProvider(){return O.coverageProvider},set coverageProvider(te){O.coverageProvider=te},enqueued:H(te=>{this.proxy.$updateTestStateInRun(D,L,d.TestId.fromExtHostTestItem(te,$).toString(),1)}),skipped:H(te=>{this.proxy.$updateTestStateInRun(D,L,d.TestId.fromExtHostTestItem(te,$).toString(),5)}),started:H(te=>{this.proxy.$updateTestStateInRun(D,L,d.TestId.fromExtHostTestItem(te,$).toString(),2)}),errored:H((te,he,re)=>{W(te,he),this.proxy.$updateTestStateInRun(D,L,d.TestId.fromExtHostTestItem(te,$).toString(),6,re)}),failed:H((te,he,re)=>{W(te,he),this.proxy.$updateTestStateInRun(D,L,d.TestId.fromExtHostTestItem(te,$).toString(),4,re)}),passed:H((te,he)=>{this.proxy.$updateTestStateInRun(D,L,d.TestId.fromExtHostTestItem(te,this.dto.controllerId).toString(),3,he)}),appendOutput:(te,he,re)=>{z||(re&&(this.dto.isIncluded(re)?this.ensureTestIsKnown(re):re=void 0),this.proxy.$appendOutputToRun(D,L,C.VSBuffer.fromString(te),he&&a.location.from(he),re&&d.TestId.fromExtHostTestItem(re,$).toString()))},end:()=>{z||(z=!0,this.proxy.$finishedTestRunTask(D,L),this.tasks.delete(L),this.isRunning||this.dispose())}};return this.tasks.set(L,{run:G,coverage:O}),this.proxy.$startedTestRunTask(D,{id:L,name:U,running:!0}),G}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(U){if(!(U instanceof p.TestItemImpl))throw new m.InvalidTestItemError(U.id);if(this.sharedTestIds.has(d.TestId.fromExtHostTestItem(U,this.dto.controllerId).toString()))return;const D=[],$=this.dto.colllection.root;for(;;){const L=a.TestItem.from(U);if(D.unshift(L),this.sharedTestIds.has(L.extId)||(this.sharedTestIds.add(L.extId),U===$))break;U=U.parent||$}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,D)}}class i{get trackers(){return this.tracked.values()}constructor(U){this.proxy=U,this.tracked=new Map}prepareForMainThreadTestRun(U,D,$){return this.getTracker(U,D,$)}cancelRunById(U){for(const D of this.tracked.values())if(D.id===U){D.dispose();return}}cancelAllRuns(){for(const U of this.tracked.values())U.dispose()}createTestRun(U,D,$,L,O){const H=this.tracked.get($);if(H)return H.createRun(L);const W=s.fromPublic(U,D,$,O),z=n($);this.proxy.$startedExtensionTestRun({controllerId:U,profile:z&&{group:M[z.kind],id:z.profileId},exclude:$.exclude?.map(te=>d.TestId.fromExtHostTestItem(te,D.root.id).toString())??[],id:W.id,include:$.include?.map(te=>d.TestId.fromExtHostTestItem(te,D.root.id).toString())??[D.root.id],persist:O});const G=this.getTracker($,W);return G.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),G.createRun(L)}getTracker(U,D,$){const L=new u(D,this.proxy,$);return this.tracked.set(U,L),L.onEnd(()=>this.tracked.delete(U)),L}}e.TestRunCoordinator=i;const n=j=>{if(!!j.profile){if(!(j.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class s{static fromPublic(U,D,$,L){return new s(U,(0,b.generateUuid)(),$.include?.map(O=>d.TestId.fromExtHostTestItem(O,U).toString())??[U],$.exclude?.map(O=>d.TestId.fromExtHostTestItem(O,U).toString())??[],L,D)}static fromInternal(U,D){return new s(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,D)}constructor(U,D,$,L,O,H){this.controllerId=U,this.id=D,this.isPersisted=O,this.colllection=H,this.includePrefix=$.map(W=>W+"\0"),this.excludePrefix=L.map(W=>W+"\0")}isIncluded(U){const D=d.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const $ of this.excludePrefix)if(D===$||D.startsWith($))return!1;for(const $ of this.includePrefix)if(D===$||D.startsWith($))return!0;return!1}}e.TestRunDto=s;class h{set coverageProvider(U){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this._coverageProvider=U,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(U,D,$){this.proxy=U,this.runId=D,this.taskId=$}async provideFileCoverage(U){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(U))());try{return(await this.fileCoverage)?.map(a.TestCoverage.fromFile)??[]}catch(D){throw this.fileCoverage=void 0,D}}async resolveFileCoverage(U,D){const $=await this.fileCoverage;let L=$?.[U];return!this._coverageProvider||!$||!L?[]:(L.detailedCoverage||(L=$[U]=await this._coverageProvider.resolveFileCoverage?.(L,D)??L),L.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class o extends S.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(U){super(),this.emitter=U,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(U){this.added.add(U)}update(U){Object.assign(U.revived,a.TestItem.toPlain(U.item)),this.added.has(U)||this.updated.add(U)}remove(U){if(this.added.has(U)){this.added.delete(U);return}this.updated.delete(U);const D=d.TestId.parentId(U.item.extId);if(D&&this.alreadyRemoved.has(D.toString())){this.alreadyRemoved.add(U.item.extId);return}this.removed.add(U)}getChangeEvent(){const{added:U,updated:D,removed:$}=this;return{get added(){return[...U].map(L=>L.revived)},get updated(){return[...D].map(L=>L.revived)},get removed(){return[...$].map(L=>L.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class f extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new F.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(U){return this.items.get(U)}getMirroredTestDataByReference(U){return this.items.get(U.id)}createItem(U,D){return{...U,revived:a.TestItem.toPlain(U.item),depth:D?D.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=f;class v{constructor(U){this.proxy=U}checkout(){this.current||(this.current=this.createObserverData());const U=this.current;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(D=>D.revived)},dispose:(0,y.once)(()=>{--U.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(U){return this.current?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.current?.tests.apply(U)}createObserverData(){const U=new f;return this.proxy.$subscribeToDiffs(),{observers:0,tests:U}}}class T{get label(){return this._label}set label(U){U!==this._label&&(this._label=U,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get isDefault(){return this._isDefault}set isDefault(U){U!==this._isDefault&&(this._isDefault=U,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?a.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(U){U!==this._configureHandler&&(this._configureHandler=U,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,D,$,L,O,H,W,z=!1,G=void 0){this.controllerId=$,this.profileId=L,this._label=O,this.kind=H,this.runHandler=W,this._isDefault=z,this._tag=G,c.set(this,void 0),_.set(this,void 0),Ye(this,c,U,"f"),Ye(this,_,D,"f"),D.set(L,this);const te=M[H];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${H}`);Oe(this,c,"f").$publishTestRunProfile({profileId:L,controllerId:$,tag:G?a.TestTag.namespace(this.controllerId,G.id):null,label:O,group:te,isDefault:z,hasConfigurationHandler:!1})}dispose(){Oe(this,_,"f")?.delete(this.profileId)&&(Ye(this,_,void 0,"f"),Oe(this,c,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=T,c=new WeakMap,_=new WeakMap;const M={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(Ce[219],Ie([1,0,18,4,5,96,8,6]),function(ne,e,r,C,w,F,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(R,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new C.Emitter,this._onDidChangeTextEditorOptions=new C.Emitter,this._onDidChangeTextEditorVisibleRanges=new C.Emitter,this._onDidChangeTextEditorViewColumn=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(g=>this._onDidChangeVisibleTextEditors.fire(g)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(g=>this._onDidChangeActiveTextEditor.fire(g))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const b=this._extHostDocumentsAndEditors.allEditors();return R?b:b.map(g=>g.value)}async showTextDocument(R,b,g){let I;typeof b=="number"?I={position:y.ViewColumn.from(b),preserveFocus:g}:typeof b=="object"?I={position:y.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?y.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:I={preserveFocus:!1};const p=await this._proxy.$tryShowTextDocument(R.uri,I),a=p&&this._extHostDocumentsAndEditors.getEditor(p);if(a)return a.value;throw p?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,b){return new F.TextEditorDecorationType(this._proxy,R,b).value}$acceptEditorPropertiesChanged(R,b){const g=this._extHostDocumentsAndEditors.getEditor(R);if(!g)throw new Error("unknown text editor");if(b.options&&g._acceptOptions(b.options),b.selections){const I=b.selections.selections.map(y.Selection.to);g._acceptSelections(I)}if(b.visibleRanges){const I=r.coalesce(b.visibleRanges.map(y.Range.to));g._acceptVisibleRanges(I)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:g.value,options:{...b.options,lineNumbers:y.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const I=A.TextEditorSelectionChangeKind.fromValue(b.selections.source),p=b.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:g.value,selections:p,kind:I})}if(b.visibleRanges){const I=r.coalesce(b.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:g.value,visibleRanges:I})}}$acceptEditorPositionData(R){for(const b in R){const g=this._extHostDocumentsAndEditors.getEditor(b);if(!g)throw new Error("Unknown text editor");const I=y.ViewColumn.to(R[b]);g.value.viewColumn!==I&&(g._acceptViewColumn(I),this._onDidChangeTextEditorViewColumn.fire({textEditor:g.value,viewColumn:I}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=E}),define(Ce[220],Ie([1,0,2,3,5,7,6,8,10]),function(ne,e,r,C,w,F,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class P{constructor(g,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=g.getProxy(w.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:p=>{if(p&&p.$mid===11){const a=p.uri===void 0?void 0:r.URI.revive(p.uri);return this._itemsBySourceAndUriMap.get(p.source)?.get(R(a))?.get(p.handle)}return p}})}async $getTimeline(g,I,p,a){return this._providers.get(g)?.provideTimeline(r.URI.revive(I),p,a)}registerTimelineProvider(g,I,p,a){const l=new F.DisposableStore,d=this.convertTimelineItem(I.id,a,l).bind(this);let m;I.onDidChange&&(m=I.onDidChange(c=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:I.id}),this));const S=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:g,onDidChange:void 0,async provideTimeline(c,_,t){_?.resetCache&&(l.clear(),S.get(I.id)?.clear());const u=await I.provideTimeline(c,_,t);if(u==null)return;const i=d(c,_);return{...u,source:I.id,items:u.items.map(i)}},dispose(){for(const c of S.values())c.get(I.id)?.clear();m?.dispose(),l.dispose()}})}convertTimelineItem(g,I,p){return(a,l)=>{let d;if(l?.cacheResults){let m=this._itemsBySourceAndUriMap.get(g);m===void 0&&(m=new Map,this._itemsBySourceAndUriMap.set(g,m));const S=R(a);d=m.get(S),d===void 0&&(d=new Map,m.set(S,d))}return m=>{const{iconPath:S,...c}=m,_=`${g}|${m.id??m.timestamp}`;d?.set(_,m);let t,u,i;m.iconPath&&(S instanceof y.ThemeIcon?i={id:S.id,color:S.color}:r.URI.isUri(S)?(t=S,u=S):{light:t,dark:u}=S);let n;return y.MarkdownString.isMarkdownString(c.tooltip)?n=A.MarkdownString.from(c.tooltip):(0,E.isString)(c.tooltip)?n=c.tooltip:y.MarkdownString.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=A.MarkdownString.from(c.detail)):(0,E.isString)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=c.detail),{...c,id:c.id??void 0,handle:_,source:g,command:m.command?I.toInternal(m.command,p):void 0,icon:t,iconDark:u,themeIcon:i,tooltip:n,accessibilityInformation:m.accessibilityInformation}}}}registerTimelineProviderCore(g){if(this._providers.get(g.id))throw new Error(`Timeline Provider ${g.id} already exists.`);return this._proxy.$registerTimelineProvider({id:g.id,label:g.label,scheme:g.scheme}),this._providers.set(g.id,g),(0,F.toDisposable)(()=>{for(const p of this._itemsBySourceAndUriMap.values())p.get(g.id)?.clear();this._providers.delete(g.id),this._proxy.$unregisterTimelineProvider(g.id),g.dispose()})}}e.ExtHostTimeline=P;function R(b){return b?.toString()}}),define(Ce[221],Ie([1,0,7,13,2,5]),function(ne,e,r,C,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(E){this._openers=new Map,this._proxy=E.getProxy(F.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,P,R,b){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const g=b.schemes.find(I=>!y.supportedSchemes.has(I));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,R),this._proxy.$registerUriOpener(P,b.schemes,E,b.label),(0,r.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(E,P,R){const b=this._openers.get(E);if(!b)throw new Error(`Unknown opener with id: ${E}`);const g=w.URI.revive(P);return b.canOpenExternalUri(g,R)}async $openUri(E,P,R){const b=this._openers.get(E);if(!b)throw new Error(`Unknown opener id: '${E}'`);return b.openExternalUri(w.URI.revive(P.resolvedUri),{sourceUri:w.URI.revive(P.sourceUri)},R)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([C.Schemas.http,C.Schemas.https])}),define(Ce[222],Ie([1,0,5,2,7,12,27]),function(ne,e,r,C,w,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(P,R){if(this.handles.has(y.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const b=A.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(P)),this.handlers.set(b,R),this._proxy.$registerUriHandler(b,P),(0,w.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(P)),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(P,R){const b=this.handlers.get(P);if(!b)return Promise.resolve(void 0);try{b.handleUri(C.URI.revive(R))}catch(g){(0,F.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(P){return C.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=A,A.HandlePool=0});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(ne,r):w?w.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!C:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ne):C?C.value:e.get(ne)};define(Ce[56],Ie([1,0,4,13,2,145,165,64,5]),function(ne,e,r,C,w,F,y,A,E){"use strict";var P,R,b,g,I,p,a,l,d,m,S,c,_;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class t{constructor(T,M,j,U,D,$,L){P.set(this,void 0),R.set(this,void 0),b.set(this,void 0),g.set(this,void 0),I.set(this,void 0),p.set(this,void 0),a.set(this,""),l.set(this,void 0),d.set(this,!1),m.set(this,!1),S.set(this,void 0),c.set(this,void 0),this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,_.set(this,new r.Emitter),this._onDidDispose=Oe(this,_,"f").event,Ye(this,P,T,"f"),Ye(this,R,M,"f"),Ye(this,l,j,"f"),Ye(this,g,U,"f"),Ye(this,I,D,"f"),Ye(this,p,$,"f"),Ye(this,S,u($),"f"),Ye(this,c,i($),"f"),Ye(this,b,L,"f")}dispose(){Ye(this,d,!0,"f"),Oe(this,_,"f").fire(),Oe(this,_,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(T){return Ye(this,m,!0,"f"),(0,A.asWebviewUri)(T,Oe(this,g,"f"))}get cspSource(){const T=Oe(this,p,"f").extensionLocation;if(T.scheme===C.Schemas.https||T.scheme===C.Schemas.http){let M=T.toString();return M.endsWith("/")||(M+="/"),M+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,a,"f")}set html(T){this.assertNotDisposed(),Oe(this,a,"f")!==T&&(Ye(this,a,T,"f"),Oe(this,c,"f")&&!Oe(this,m,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(T)&&(Ye(this,m,!0,"f"),Oe(this,b,"f").report("Webview vscode-resource: uris",Oe(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,R,"f").$setHtml(Oe(this,P,"f"),this.rewriteOldResourceUrlsIfNeeded(T)))}get options(){return this.assertNotDisposed(),Oe(this,l,"f")}set options(T){this.assertNotDisposed(),Oe(this,R,"f").$setOptions(Oe(this,P,"f"),h(Oe(this,p,"f"),Oe(this,I,"f"),T)),Ye(this,l,T,"f")}async postMessage(T){if(Oe(this,d,"f"))return!1;const M=(0,y.serializeWebviewMessage)(T,{serializeBuffersForPostMessage:Oe(this,S,"f")});return Oe(this,R,"f").$postMessage(Oe(this,P,"f"),M.message,...M.buffers)}assertNotDisposed(){if(Oe(this,d,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(T){if(!Oe(this,c,"f"))return T;const M=Oe(this,p,"f").extensionLocation?.scheme===C.Schemas.vscodeRemote,j=Oe(this,p,"f").extensionLocation.scheme===C.Schemas.vscodeRemote?Oe(this,p,"f").extensionLocation.authority:void 0;return T.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(U,D,$,L,O,H)=>{const W=w.URI.from({scheme:L||"file",path:decodeURIComponent(O)}),z=(0,A.asWebviewUri)(W,{isRemote:M,authority:j}).toString();return`${D}${z}${H}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(U,D,$,L,O,H)=>{const W=w.URI.from({scheme:L||"file",path:decodeURIComponent(O)}),z=(0,A.asWebviewUri)(W,{isRemote:M,authority:j}).toString();return`${D}${z}${H}`})}}e.ExtHostWebview=t,P=new WeakMap,R=new WeakMap,b=new WeakMap,g=new WeakMap,I=new WeakMap,p=new WeakMap,a=new WeakMap,l=new WeakMap,d=new WeakMap,m=new WeakMap,S=new WeakMap,c=new WeakMap,_=new WeakMap;function u(v){try{const T=(0,F.normalizeVersion)((0,F.parseVersion)(v.engines.vscode));return!!T&&T.majorBase>=1&&T.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=u;function i(v){try{const T=(0,F.normalizeVersion)((0,F.parseVersion)(v.engines.vscode));return T?T.majorBase<1||T.majorBase===1&&T.minorBase<60:!1}catch{return!1}}class n{constructor(T,M,j,U,D){this.remoteInfo=M,this.workspace=j,this._logService=U,this._deprecationService=D,this._webviews=new Map,this._webviewProxy=T.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(T,M,j){const U=this.getWebview(T);if(U){const{message:D}=(0,y.deserializeWebviewMessage)(M,j.value);U._onMessageEmitter.fire(D)}}$onMissingCsp(T,M){this._logService.warn(`${M} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(T,M,j){const U=new t(T,this._webviewProxy,o(M),this.remoteInfo,this.workspace,j,this._deprecationService);return this._webviews.set(T,U),U._onDidDispose(()=>{this._webviews.delete(T)}),U}deleteWebview(T){this._webviews.delete(T)}getWebview(T){return this._webviews.get(T)}}e.ExtHostWebviews=n;function s(v){return{id:v.identifier,location:v.extensionLocation}}e.toExtensionData=s;function h(v,T,M){return{enableCommandUris:M.enableCommandUris,enableScripts:M.enableScripts,enableForms:M.enableForms,portMapping:M.portMapping,localResourceRoots:M.localResourceRoots||f(v,T)}}e.serializeWebviewOptions=h;function o(v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots?.map(T=>w.URI.from(T))}}e.reviveOptions=o;function f(v,T){return[...(T?.getWorkspaceFolders()||[]).map(M=>M.uri),v.extensionLocation]}}),define(Ce[223],Ie([1,0,21,218,7,13,22,2,8,56,62,5,6]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class I{constructor(u,i){this.document=u,this._storagePath=i,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(u){return this._edits.add([u])}async undo(u,i){await this.getEdit(u).undo(),i||this.disposeBackup()}async redo(u,i){await this.getEdit(u).redo(),i||this.disposeBackup()}disposeEdits(u){for(const i of u)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const u=_(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,u)}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(u){const i=this._edits.get(u,0);if(!i)throw new Error("No edit found");return i}}class p{constructor(){this._documents=new Map}get(u,i){return this._documents.get(this.key(u,i))}add(u,i,n){const s=this.key(u,i.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${u} resource:${i.uri}`);const h=new I(i,n);return this._documents.set(s,h),h}delete(u,i){const n=this.key(u,i.uri);this._documents.delete(n)}key(u,i){return`${u}@@@${i}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class l{constructor(){this._providers=new Map}addTextProvider(u,i,n){return this.add(0,u,i,n)}addCustomProvider(u,i,n){return this.add(1,u,i,n)}get(u){return this._providers.get(u)}add(u,i,n,s){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:u,extension:n,provider:s}),new g.Disposable(()=>this._providers.delete(i))}}class d{constructor(u,i,n,s,h){this._extHostDocuments=i,this._extensionStoragePaths=n,this._extHostWebview=s,this._extHostWebviewPanels=h,this._editorProviders=new l,this._documents=new p,this._proxy=u.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(u,i,n,s){const h=new w.DisposableStore;return S(n)?(h.add(this._editorProviders.addTextProvider(i,u,n)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(u),i,s.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(u))):(h.add(this._editorProviders.addCustomProvider(i,u,n)),m(n)&&h.add(n.onDidChangeCustomDocument(o=>{const f=this.getCustomDocumentEntry(i,o.document.uri);if(c(o)){const v=f.addEdit(o);this._proxy.$onDidEdit(o.document.uri,i,v,o.label)}else this._proxy.$onContentChange(o.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(u),i,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(u))),g.Disposable.from(h,new g.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(u,i,n,s,h){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(o.type!==1)throw new Error(`Invalid provide type for '${i}'`);const f=A.URI.revive(u),v=await o.provider.openCustomDocument(f,{backupId:n,untitledDocumentData:s?.buffer},h);let T;return m(o.provider)&&this._extensionStoragePaths&&(T=this._extensionStoragePaths.workspaceValue(o.extension)??this._extensionStoragePaths.globalValue(o.extension)),this._documents.add(i,v,T),{editable:m(o.provider)}}async $disposeCustomDocument(u,i){const n=this._editorProviders.get(i);if(!n)throw new Error(`No provider found for '${i}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${i}'`);const s=A.URI.revive(u),{document:h}=this.getCustomDocumentEntry(i,s);this._documents.delete(i,h),h.dispose()}async $resolveWebviewEditor(u,i,n,s,h,o){const f=this._editorProviders.get(n);if(!f)throw new Error(`No provider found for '${n}'`);const v=E.ViewColumn.to(h),T=this._extHostWebview.createNewWebview(i,s.contentOptions,f.extension),M=this._extHostWebviewPanels.createNewWebviewPanel(i,n,s.title,v,s.options,T,!0),j=A.URI.revive(u);switch(f.type){case 1:{const{document:U}=this.getCustomDocumentEntry(n,j);return f.provider.resolveCustomEditor(U,M,o)}case 0:{const U=this._extHostDocuments.getDocument(j);return f.provider.resolveCustomTextEditor(U,M,o)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,i,n){this.getCustomDocumentEntry(i,u).disposeEdits(n)}async $onMoveCustomEditor(u,i,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const h=this._extHostWebviewPanels.getWebviewPanel(u);if(!h)throw new Error("No webview found");const o=A.URI.revive(i),f=this._extHostDocuments.getDocument(o);await s.provider.moveCustomTextEditor(f,h,r.CancellationToken.None)}async $undo(u,i,n,s){return this.getCustomDocumentEntry(i,u).undo(n,s)}async $redo(u,i,n,s){return this.getCustomDocumentEntry(i,u).redo(n,s)}async $revert(u,i,n){const s=this.getCustomDocumentEntry(i,u);await this.getCustomEditorProvider(i).revertCustomDocument(s.document,n),s.disposeBackup()}async $onSave(u,i,n){const s=this.getCustomDocumentEntry(i,u);await this.getCustomEditorProvider(i).saveCustomDocument(s.document,n),s.disposeBackup()}async $onSaveAs(u,i,n,s){const h=this.getCustomDocumentEntry(i,u);return this.getCustomEditorProvider(i).saveCustomDocumentAs(h.document,A.URI.revive(n),s)}async $backup(u,i,n){const s=this.getCustomDocumentEntry(i,u),o=await this.getCustomEditorProvider(i).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},n);return s.updateBackup(o),o.id}getCustomDocumentEntry(u,i){const n=this._documents.get(u,A.URI.revive(i));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(u){const n=this._editorProviders.get(u)?.provider;if(!n||!m(n))throw new Error("Custom document is not editable");return n}}e.ExtHostCustomEditors=d;function m(t){return!!t.onDidChangeCustomDocument}function S(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function _(t){const u=t.scheme===F.Schemas.file||t.scheme===F.Schemas.untitled?t.fsPath:t.toString();return(0,C.hash)(u)+""}});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(ne,r):w?w.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!C:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ne):C?C.value:e.get(ne)};define(Ce[224],Ie([1,0,4,7,2,38,8,56,5,6]),function(ne,e,r,C,w,F,y,A,E,P){"use strict";var R,b,g,I,p,a,l,d,m,S,c,_,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends C.Disposable{constructor(h,o,f,v){super(),R.set(this,void 0),b.set(this,void 0),g.set(this,void 0),I.set(this,void 0),p.set(this,void 0),a.set(this,void 0),l.set(this,void 0),d.set(this,void 0),m.set(this,!0),S.set(this,void 0),c.set(this,!1),_.set(this,this._register(new r.Emitter)),this.onDidDispose=Oe(this,_,"f").event,t.set(this,this._register(new r.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,Ye(this,R,h,"f"),Ye(this,b,o,"f"),Ye(this,I,f,"f"),Ye(this,g,v.viewType,"f"),Ye(this,p,v.panelOptions,"f"),Ye(this,d,v.viewColumn,"f"),Ye(this,a,v.title,"f"),Ye(this,S,v.active,"f")}dispose(){Oe(this,c,"f")||(Ye(this,c,!0,"f"),Oe(this,_,"f").fire(),Oe(this,b,"f").$disposeWebview(Oe(this,R,"f")),Oe(this,I,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,I,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,g,"f")}get title(){return this.assertNotDisposed(),Oe(this,a,"f")}set title(h){this.assertNotDisposed(),Oe(this,a,"f")!==h&&(Ye(this,a,h,"f"),Oe(this,b,"f").$setTitle(Oe(this,R,"f"),h))}get iconPath(){return this.assertNotDisposed(),Oe(this,l,"f")}set iconPath(h){this.assertNotDisposed(),Oe(this,l,"f")!==h&&(Ye(this,l,h,"f"),Oe(this,b,"f").$setIconPath(Oe(this,R,"f"),w.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return Oe(this,p,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,d,"f")=="number"&&Oe(this,d,"f")<0))return Oe(this,d,"f")}get active(){return this.assertNotDisposed(),Oe(this,S,"f")}get visible(){return this.assertNotDisposed(),Oe(this,m,"f")}_updateViewState(h){Oe(this,c,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(Ye(this,S,h.active,"f"),Ye(this,m,h.visible,"f"),Ye(this,d,h.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(h,o){this.assertNotDisposed(),Oe(this,b,"f").$reveal(Oe(this,R,"f"),{viewColumn:typeof h>"u"?void 0:y.ViewColumn.from(h),preserveFocus:!!o})}assertNotDisposed(){if(Oe(this,c,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,b=new WeakMap,g=new WeakMap,I=new WeakMap,p=new WeakMap,a=new WeakMap,l=new WeakMap,d=new WeakMap,m=new WeakMap,S=new WeakMap,c=new WeakMap,_=new WeakMap,t=new WeakMap;class i{static newHandle(){return(0,F.generateUuid)()}constructor(h,o,f){this.webviews=o,this.workspace=f,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(E.MainContext.MainThreadWebviewPanels)}createWebviewPanel(h,o,f,v,T={}){const M=typeof v=="object"?v.viewColumn:v,j={viewColumn:y.ViewColumn.from(M),preserveFocus:typeof v=="object"&&!!v.preserveFocus},U=(0,A.shouldSerializeBuffersForPostMessage)(h),D=i.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(h),D,o,{title:f,panelOptions:n(T),webviewOptions:(0,A.serializeWebviewOptions)(h,this.workspace,T),serializeBuffersForPostMessage:U},j);const $=this.webviews.createNewWebview(D,T,h);return this.createNewWebviewPanel(D,o,f,M,T,$,!0)}$onDidChangeWebviewPanelViewStates(h){const o=Object.keys(h);o.sort((f,v)=>{const T=h[f],M=h[v];return T.active?1:M.active?-1:+T.visible-+M.visible});for(const f of o){const v=this.getWebviewPanel(f);if(!v)continue;const T=h[f];v._updateViewState({active:T.active,visible:T.visible,viewColumn:y.ViewColumn.to(T.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,o,f){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:f,extension:h}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(h)}),new P.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(h,o,f,v){const T=this._serializers.get(o);if(!T)throw new Error(`No serializer found for '${o}'`);const{serializer:M,extension:j}=T,U=this.webviews.createNewWebview(h,f.webviewOptions,j),D=this.createNewWebviewPanel(h,o,f.title,v,f.panelOptions,U,f.active);await M.deserializeWebviewPanel(D,f.state)}createNewWebviewPanel(h,o,f,v,T,M,j){const U=new u(h,this._proxy,M,{viewType:o,title:f,viewColumn:v,panelOptions:T,active:j});return this._webviewPanels.set(h,U),U}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=i;function n(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(ne,r):w?w.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!C:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ne):C?C.value:e.get(ne)};define(Ce[225],Ie([1,0,4,7,56,8,5,6]),function(ne,e,r,C,w,F,y,A){"use strict";var E,P,R,b,g,I,p,a,l,d,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends C.Disposable{constructor(t,u,i,n,s,h,o){super(),E.set(this,void 0),P.set(this,void 0),R.set(this,void 0),b.set(this,void 0),g.set(this,!1),I.set(this,void 0),p.set(this,void 0),a.set(this,void 0),l.set(this,void 0),d.set(this,this._register(new r.Emitter)),this.onDidChangeVisibility=Oe(this,d,"f").event,m.set(this,this._register(new r.Emitter)),this.onDidDispose=Oe(this,m,"f").event,Ye(this,R,i,"f"),Ye(this,p,n,"f"),Ye(this,E,t,"f"),Ye(this,P,u,"f"),Ye(this,b,s,"f"),Ye(this,I,o,"f")}dispose(){Oe(this,g,"f")||(Ye(this,g,!0,"f"),Oe(this,m,"f").fire(),Oe(this,b,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,p,"f")}set title(t){this.assertNotDisposed(),Oe(this,p,"f")!==t&&(Ye(this,p,t,"f"),Oe(this,P,"f").$setWebviewViewTitle(Oe(this,E,"f"),t))}get description(){return this.assertNotDisposed(),Oe(this,a,"f")}set description(t){this.assertNotDisposed(),Oe(this,a,"f")!==t&&(Ye(this,a,t,"f"),Oe(this,P,"f").$setWebviewViewDescription(Oe(this,E,"f"),t))}get visible(){return Oe(this,I,"f")}get webview(){return Oe(this,b,"f")}get viewType(){return Oe(this,R,"f")}_setVisible(t){t===Oe(this,I,"f")||Oe(this,g,"f")||(Ye(this,I,t,"f"),Oe(this,d,"f").fire())}get badge(){return this.assertNotDisposed(),Oe(this,l,"f")}set badge(t){this.assertNotDisposed(),!(t?.value===Oe(this,l,"f")?.value&&t?.tooltip===Oe(this,l,"f")?.tooltip)&&(Ye(this,l,F.ViewBadge.from(t),"f"),Oe(this,P,"f").$setWebviewViewBadge(Oe(this,E,"f"),t))}show(t){this.assertNotDisposed(),Oe(this,P,"f").$show(Oe(this,E,"f"),!!t)}assertNotDisposed(){if(Oe(this,g,"f"))throw new Error("Webview is disposed")}}E=new WeakMap,P=new WeakMap,R=new WeakMap,b=new WeakMap,g=new WeakMap,I=new WeakMap,p=new WeakMap,a=new WeakMap,l=new WeakMap,d=new WeakMap,m=new WeakMap;class c{constructor(t,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,u,i,n){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:i,extension:t}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(t),u,{retainContextWhenHidden:n?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,w.shouldSerializeBuffersForPostMessage)(t)}),new A.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(t,u,i,n,s){const h=this._viewProviders.get(u);if(!h)throw new Error(`No view provider found for '${u}'`);const{provider:o,extension:f}=h,v=this._extHostWebview.createNewWebview(t,{},f),T=new S(t,this._proxy,u,i,v,f,!0);this._webviewViews.set(t,T),await o.resolveWebviewView(T,{state:n},s)}async $onDidChangeWebviewViewVisibility(t,u){this.getWebviewView(t)._setVisible(u)}async $disposeWebviewView(t){const u=this.getWebviewView(t);this._webviewViews.delete(t),u.dispose(),this._extHostWebview.deleteWebview(t)}getWebviewView(t){const u=this._webviewViews.get(t);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=c}),define(Ce[98],Ie([1,0,4,5,2,13,9,3,14]),function(ne,e,r,C,w,F,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Zi{get state(){return this._state}constructor(b){this._onDidChangeWindowState=new r.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Zi.InitialState,this._proxy=b.getProxy(C.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(g=>this.$onDidChangeWindowFocus(g))}$onDidChangeWindowFocus(b){b!==this._state.focused&&(this._state={...this._state,focused:b},this._onDidChangeWindowState.fire(this._state))}openUri(b,g){let I;if(typeof b=="string"){I=b;try{b=w.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,y.isFalsyOrWhitespace)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this._proxy.$openUri(b,I,g)}async asExternalUri(b,g){if((0,y.isFalsyOrWhitespace)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const I=await this._proxy.$asExternalUri(b,g);return w.URI.from(I)}};P.InitialState={focused:!0},P=$e([xe(0,E.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ce[226],Ie([1,0,196,26,14]),function(ne,e,r,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let F=class extends r.AbstractExtHostConsoleForwarder{constructor(A,E){super(A,E)}_nativeConsoleLogMessage(A,E,P){E.apply(console,P)}};F=$e([xe(0,w.IExtHostRpcService),xe(1,C.IExtHostInitDataService)],F),e.ExtHostConsoleForwarder=F}),define(Ce[227],Ie([1,0,15,23,21,12,4,7,119,190,42]),function(ne,e,r,C,w,F,y,A,E,P,R){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function g(T,M){try{return JSON.stringify(T,M)}catch{return"null"}}const I="$$ref$$",p={[I]:-1};class a{constructor(M,j){this.jsonString=M,this.referencedBuffers=j}}function l(T,M=null,j=!1){const U=[];return{jsonString:(j?g:JSON.stringify)(T,($,L)=>{if(typeof L>"u")return p;if(typeof L=="object"){if(L instanceof C.VSBuffer){const O=U.push(L)-1;return{[I]:O}}if(M)return M($,L)}return L}),referencedBuffers:U}}e.stringifyJsonWithBufferRefs=l;function d(T,M,j){return JSON.parse(T,(U,D)=>{if(D){const $=D[I];if(typeof $=="number")return M[$];if(j&&D.$mid===1)return j.transformIncoming(D)}return D})}e.parseJsonAndRestoreBufferRefs=d;function m(T,M){return JSON.stringify(T,M)}function S(T){return T?(M,j)=>j&&j.$mid===1?T.transformOutgoing(j):j:null}var c;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(T){T[T.Responsive=0]="Responsive",T[T.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},u=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class n extends A.Disposable{constructor(M,j=null,U=null){super(),this[b]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=M,this._logger=j,this._uriTransformer=U,this._uriReplacer=S(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,$=R.ProxyIdentifier.count;D<$;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new r.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(M=>{this._pendingRPCReplies[M].resolveErr(F.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(M){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(M){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(M){this._responsiveState!==M&&(this._responsiveState=M,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(M){return this._uriTransformer?(0,E.transformIncomingURIs)(M,this._uriTransformer):M}getProxy(M){const{nid:j,sid:U}=M;return this._proxies[j]||(this._proxies[j]=this._createProxy(j,U)),this._proxies[j]}_createProxy(M,j){const U={get:(D,$)=>(typeof $=="string"&&!D[$]&&$.charCodeAt(0)===36&&(D[$]=(...L)=>this._remoteCall(M,$,L)),$===i?j:D[$])};return new Proxy(Object.create(null),U)}set(M,j){return this._locals[M.nid]=j,j}assertRegistered(M){for(let j=0,U=M.length;j<U;j++){const D=M[j];if(!this._locals[D.nid])throw new Error(`Missing proxy instance ${D.sid}`)}}_receiveOneMessage(M){if(this._isDisposed)return;const j=M.byteLength,U=s.read(M,0),D=U.readUInt8(),$=U.readUInt32();switch(D){case 1:case 2:{let{rpcId:L,method:O,args:H}=o.deserializeRequestJSONArgs(U);this._uriTransformer&&(H=(0,E.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(j,$,L,O,H,D===2);break}case 3:case 4:{let{rpcId:L,method:O,args:H}=o.deserializeRequestMixedArgs(U);this._uriTransformer&&(H=(0,E.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(j,$,L,O,H,D===4);break}case 5:{this._logger?.logIncoming(j,$,0,"ack"),this._onDidReceiveAcknowledge($);break}case 6:{this._receiveCancel(j,$);break}case 7:{this._receiveReply(j,$,void 0);break}case 9:{let L=o.deserializeReplyOKJSON(U);this._uriTransformer&&(L=(0,E.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReply(j,$,L);break}case 10:{const L=o.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(j,$,L);break}case 8:{const L=o.deserializeReplyOKVSBuffer(U);this._receiveReply(j,$,L);break}case 11:{let L=o.deserializeReplyErrError(U);this._uriTransformer&&(L=(0,E.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReplyErr(j,$,L);break}case 12:{this._receiveReplyErr(j,$,void 0);break}default:console.error("received unexpected message"),console.error(M)}}_receiveRequest(M,j,U,D,$,L){this._logger?.logIncoming(M,j,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(U)}.${D}(`,$);const O=String(j);let H,W;if(L){const G=new w.CancellationTokenSource;$.push(G.token),H=this._invokeHandler(U,D,$),W=()=>G.cancel()}else H=this._invokeHandler(U,D,$),W=t;this._cancelInvokedHandlers[O]=W;const z=o.serializeAcknowledged(j);this._logger?.logOutgoing(z.byteLength,j,1,"ack"),this._protocol.send(z),H.then(G=>{delete this._cancelInvokedHandlers[O];const te=o.serializeReplyOK(j,G,this._uriReplacer);this._logger?.logOutgoing(te.byteLength,j,1,"reply:",G),this._protocol.send(te)},G=>{delete this._cancelInvokedHandlers[O];const te=o.serializeReplyErr(j,G);this._logger?.logOutgoing(te.byteLength,j,1,"replyErr:",G),this._protocol.send(te)})}_receiveCancel(M,j){this._logger?.logIncoming(M,j,1,"receiveCancel");const U=String(j);this._cancelInvokedHandlers[U]?.()}_receiveReply(M,j,U){this._logger?.logIncoming(M,j,0,"receiveReply:",U);const D=String(j);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const $=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],$.resolveOk(U)}_receiveReplyErr(M,j,U){this._logger?.logIncoming(M,j,0,"receiveReplyErr:",U);const D=String(j);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const $=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let L;U&&(U.$isError?(L=new Error,L.name=U.name,L.message=U.message,L.stack=U.stack):L=U),$.resolveErr(L)}_invokeHandler(M,j,U){try{return Promise.resolve(this._doInvokeHandler(M,j,U))}catch(D){return Promise.reject(D)}}_doInvokeHandler(M,j,U){const D=this._locals[M];if(!D)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(M));const $=D[j];if(typeof $!="function")throw new Error("Unknown method "+j+" on actor "+(0,R.getStringIdentifierForProxy)(M));return $.apply(D,U)}_remoteCall(M,j,U){if(this._isDisposed)return new P.CanceledLazyPromise;let D=null;if(U.length>0&&w.CancellationToken.isCancellationToken(U[U.length-1])&&(D=U.pop()),D&&D.isCancellationRequested)return Promise.reject(F.canceled());const $=o.serializeRequestArguments(U,this._uriReplacer),L=++this._lastMessageId,O=String(L),H=new P.LazyPromise;D&&D.onCancellationRequested(()=>{const z=o.serializeCancel(L);this._logger?.logOutgoing(z.byteLength,L,0,"cancel"),this._protocol.send(o.serializeCancel(L))}),this._pendingRPCReplies[O]=H,this._onWillSendRequest(L);const W=o.serializeRequest(L,M,j,$,!!D);return this._logger?.logOutgoing(W.byteLength,L,0,`request: ${(0,R.getStringIdentifierForProxy)(M)}.${j}(`,U),this._protocol.send(W),H}}e.RPCProtocol=n,b=u,n.UNRESPONSIVE_TIME=3*1e3;class s{static alloc(M,j,U){const D=new s(C.VSBuffer.alloc(U+1+4),0);return D.writeUInt8(M),D.writeUInt32(j),D}static read(M,j){return new s(M,j)}get buffer(){return this._buff}constructor(M,j){this._buff=M,this._offset=j}static sizeUInt8(){return 1}writeUInt8(M){this._buff.writeUInt8(M,this._offset),this._offset+=1}readUInt8(){const M=this._buff.readUInt8(this._offset);return this._offset+=1,M}writeUInt32(M){this._buff.writeUInt32BE(M,this._offset),this._offset+=4}readUInt32(){const M=this._buff.readUInt32BE(this._offset);return this._offset+=4,M}static sizeShortString(M){return 1+M.byteLength}writeShortString(M){this._buff.writeUInt8(M.byteLength,this._offset),this._offset+=1,this._buff.set(M,this._offset),this._offset+=M.byteLength}readShortString(){const M=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+M).toString();return this._offset+=M,U}static sizeLongString(M){return 4+M.byteLength}writeLongString(M){this._buff.writeUInt32BE(M.byteLength,this._offset),this._offset+=4,this._buff.set(M,this._offset),this._offset+=M.byteLength}readLongString(){const M=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+M).toString();return this._offset+=M,U}writeBuffer(M){this._buff.writeUInt32BE(M.byteLength,this._offset),this._offset+=4,this._buff.set(M,this._offset),this._offset+=M.byteLength}static sizeVSBuffer(M){return 4+M.byteLength}writeVSBuffer(M){this._buff.writeUInt32BE(M.byteLength,this._offset),this._offset+=4,this._buff.set(M,this._offset),this._offset+=M.byteLength}readVSBuffer(){const M=this._buff.readUInt32BE(this._offset);this._offset+=4;const j=this._buff.slice(this._offset,this._offset+M);return this._offset+=M,j}static sizeMixedArray(M){let j=0;j+=1;for(let U=0,D=M.length;U<D;U++){const $=M[U];switch(j+=1,$.type){case 1:j+=this.sizeLongString($.value);break;case 2:j+=this.sizeVSBuffer($.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString($.value);for(let L=0;L<$.buffers.length;++L)j+=this.sizeVSBuffer($.buffers[L]);break;case 4:break}}return j}writeMixedArray(M){this._buff.writeUInt8(M.length,this._offset),this._offset+=1;for(let j=0,U=M.length;j<U;j++){const D=M[j];switch(D.type){case 1:this.writeUInt8(1),this.writeLongString(D.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(D.value);break;case 3:this.writeUInt8(3),this.writeUInt32(D.buffers.length),this.writeLongString(D.value);for(let $=0;$<D.buffers.length;++$)this.writeBuffer(D.buffers[$]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const M=this._buff.readUInt8(this._offset);this._offset+=1;const j=new Array(M);for(let U=0;U<M;U++)switch(this.readUInt8()){case 1:j[U]=this.readLongString();break;case 2:j[U]=this.readVSBuffer();break;case 3:{const $=this.readUInt32(),L=this.readLongString(),O=[];for(let H=0;H<$;++H)O.push(this.readVSBuffer());j[U]=new R.SerializableObjectWithBuffers(d(L,O,null));break}case 4:j[U]=void 0;break}return j}}s.sizeUInt32=4;var h;(function(T){T[T.Simple=0]="Simple",T[T.Mixed=1]="Mixed"})(h||(h={}));class o{static _useMixedArgSerialization(M){for(let j=0,U=M.length;j<U;j++)if(M[j]instanceof C.VSBuffer||M[j]instanceof R.SerializableObjectWithBuffers||typeof M[j]>"u")return!0;return!1}static serializeRequestArguments(M,j){if(this._useMixedArgSerialization(M)){const U=[];for(let D=0,$=M.length;D<$;D++){const L=M[D];if(L instanceof C.VSBuffer)U[D]={type:2,value:L};else if(typeof L>"u")U[D]={type:4};else if(L instanceof R.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:H}=l(L.value,j);U[D]={type:3,value:C.VSBuffer.fromString(O),buffers:H}}else U[D]={type:1,value:C.VSBuffer.fromString(m(L,j))}}return{type:1,args:U}}return{type:0,args:m(M,j)}}static serializeRequest(M,j,U,D,$){switch(D.type){case 0:return this._requestJSONArgs(M,j,U,D.args,$);case 1:return this._requestMixedArgs(M,j,U,D.args,$)}}static _requestJSONArgs(M,j,U,D,$){const L=C.VSBuffer.fromString(U),O=C.VSBuffer.fromString(D);let H=0;H+=s.sizeUInt8(),H+=s.sizeShortString(L),H+=s.sizeLongString(O);const W=s.alloc($?2:1,M,H);return W.writeUInt8(j),W.writeShortString(L),W.writeLongString(O),W.buffer}static deserializeRequestJSONArgs(M){const j=M.readUInt8(),U=M.readShortString(),D=M.readLongString();return{rpcId:j,method:U,args:JSON.parse(D)}}static _requestMixedArgs(M,j,U,D,$){const L=C.VSBuffer.fromString(U);let O=0;O+=s.sizeUInt8(),O+=s.sizeShortString(L),O+=s.sizeMixedArray(D);const H=s.alloc($?4:3,M,O);return H.writeUInt8(j),H.writeShortString(L),H.writeMixedArray(D),H.buffer}static deserializeRequestMixedArgs(M){const j=M.readUInt8(),U=M.readShortString(),D=M.readMixedArray(),$=new Array(D.length);for(let L=0,O=D.length;L<O;L++){const H=D[L];typeof H=="string"?$[L]=JSON.parse(H):$[L]=H}return{rpcId:j,method:U,args:$}}static serializeAcknowledged(M){return s.alloc(5,M,0).buffer}static serializeCancel(M){return s.alloc(6,M,0).buffer}static serializeReplyOK(M,j,U){if(typeof j>"u")return this._serializeReplyOKEmpty(M);if(j instanceof C.VSBuffer)return this._serializeReplyOKVSBuffer(M,j);if(j instanceof R.SerializableObjectWithBuffers){const{jsonString:D,referencedBuffers:$}=l(j.value,U,!0);return this._serializeReplyOKJSONWithBuffers(M,D,$)}else return this._serializeReplyOKJSON(M,g(j,U))}static _serializeReplyOKEmpty(M){return s.alloc(7,M,0).buffer}static _serializeReplyOKVSBuffer(M,j){let U=0;U+=s.sizeVSBuffer(j);const D=s.alloc(8,M,U);return D.writeVSBuffer(j),D.buffer}static deserializeReplyOKVSBuffer(M){return M.readVSBuffer()}static _serializeReplyOKJSON(M,j){const U=C.VSBuffer.fromString(j);let D=0;D+=s.sizeLongString(U);const $=s.alloc(9,M,D);return $.writeLongString(U),$.buffer}static _serializeReplyOKJSONWithBuffers(M,j,U){const D=C.VSBuffer.fromString(j);let $=0;$+=s.sizeUInt32,$+=s.sizeLongString(D);for(const O of U)$+=s.sizeVSBuffer(O);const L=s.alloc(10,M,$);L.writeUInt32(U.length),L.writeLongString(D);for(const O of U)L.writeBuffer(O);return L.buffer}static deserializeReplyOKJSON(M){const j=M.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(M,j){const U=M.readUInt32(),D=M.readLongString(),$=[];for(let L=0;L<U;++L)$.push(M.readVSBuffer());return new R.SerializableObjectWithBuffers(d(D,$,j))}static serializeReplyErr(M,j){const U=j?g(F.transformErrorForSerialization(j),null):void 0;if(typeof U!="string")return this._serializeReplyErrEmpty(M);const D=C.VSBuffer.fromString(U);let $=0;$+=s.sizeLongString(D);const L=s.alloc(11,M,$);return L.writeLongString(D),L.buffer}static deserializeReplyErrError(M){const j=M.readLongString();return JSON.parse(j)}static _serializeReplyErrEmpty(M){return s.alloc(12,M,0).buffer}}var f;(function(T){T[T.RequestJSONArgs=1]="RequestJSONArgs",T[T.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",T[T.RequestMixedArgs=3]="RequestMixedArgs",T[T.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",T[T.Acknowledged=5]="Acknowledged",T[T.Cancel=6]="Cancel",T[T.ReplyOKEmpty=7]="ReplyOKEmpty",T[T.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",T[T.ReplyOKJSON=9]="ReplyOKJSON",T[T.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",T[T.ReplyErrError=11]="ReplyErrError",T[T.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var v;(function(T){T[T.String=1]="String",T[T.VSBuffer=2]="VSBuffer",T[T.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",T[T.Undefined=4]="Undefined"})(v||(v={}))}),define(Ce[228],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const r=function(F){const y=A=>{self.removeEventListener("message",y);const E=A.data;Object.defineProperties(self,{postMessage:{value(P,R){E.postMessage(P,R)}},onmessage:{get(){return E.onmessage},set(P){E.onmessage=P}}}),E.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),E.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};self.addEventListener("message",y)}.toString();class C extends EventTarget{constructor(F,y,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${r})('${y}'))`,P=new Blob([E],{type:"application/javascript"}),R=URL.createObjectURL(P),b=new MessageChannel,g=R,I={type:"_newWorker",id:g,port:b.port2,url:R,options:A};F(I,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{F({type:"_terminateWorker",id:g}),URL.revokeObjectURL(R),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(p){b.port1.onmessage=p}},onmessageerror:{get(){return b.port1.onmessageerror},set(p){b.port1.onmessageerror=p}}}),b.port1.addEventListener("messageerror",p=>{const a=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(a)}),b.port1.addEventListener("message",p=>{const a=new MessageEvent("message",{data:p.data});this.dispatchEvent(a)}),b.port1.start()}}e.NestedWorker=C}),define(Ce[229],Ie([1,0,4,30,40,3,35,12,15]),function(ne,e,r,C,w,F,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new w.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new w.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new w.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,F.createDecorator)(e.OUTPUT_SERVICE_ID);var P;(function(I){I[I.Append=1]="Append",I[I.Replace=2]="Replace",I[I.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new r.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new r.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(p){this.channels.has(p.id)||(this.channels.set(p.id,p),this._onDidRegisterChannel.fire(p.id))}getChannels(){const p=[];return this.channels.forEach(a=>p.push(a)),p}getChannel(p){return this.channels.get(p)}removeChannel(p){this.channels.delete(p),this._onDidRemoveChannel.fire(p)}}C.Registry.add(e.Extensions.OutputChannels,new R);function b(I,p,a,l,d){return(0,E.createCancelablePromise)(async m=>{await(0,y.whenProviderRegistered)(a,l);const S=C.Registry.as(e.Extensions.OutputChannels);try{await g(a,1,l,d,m),S.registerChannel({id:I,label:p,file:a,log:!0})}catch(c){(0,A.isCancellationError)(c)||d.error("Error while registering log channel",a.toString(),(0,A.getErrorMessage)(c))}})}e.registerLogChannel=b;async function g(I,p,a,l,d){if(!await a.exists(I)){if(d.isCancellationRequested)throw new A.CancellationError;if(p>10)throw new Error("Timed out while waiting for file to be created");l.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",I.toString()),await(0,E.timeout)(1e3,d),await g(I,p+1,a,l,d)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new w.RawContextKey("activeOutputChannel","")}),define(Ce[99],Ie([1,0,5,3,14,11,229,54,26,36,112,23,10,35]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class p extends F.AbstractMessageLogger{get disposed(){return this._disposed}constructor(m,S,c,_,t){super(),this.id=m,this.name=S,this.logger=c,this.proxy=_,this.extension=t,this.offset=0,this._disposed=!1,this.visible=!1,this._register(c.onDidChangeLogLevel(u=>this.setLevel(u)))}appendLine(m){this.append(m+`
`)}append(m){this.info(m),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Append))}clear(){const m=this.offset;this.logger.flush(),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Clear,m)}replace(m){const S=this.offset;this.info(m),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Replace,S),this.visible&&this.logger.flush()}show(m,S){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof m=="boolean"?m:S))}hide(){this.proxy.$close(this.id)}log(m,S){this.offset+=b.VSBuffer.fromString(S).byteLength,(0,F.log)(this.logger,m,S)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class a extends p{appendLine(m){this.append(m)}}let l=class{constructor(m,S,c,_,t){this.initData=S,this.extHostFileSystem=c,this.extHostFileSystemInfo=_,this.loggerService=t,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=m.getProxy(r.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(S.logsLocation,`output_logging_${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(m){this.visibleChannelId=m;for(const[S,c]of this.channels)c.visible=S===this.visibleChannelId}createOutputChannel(m,S,c){if(m=m.trim(),!m)throw new Error("illegal argument `name`. must not be falsy");const _=typeof S=="object"&&S.log,t=(0,g.isString)(S)?S:void 0;if((0,g.isString)(t)&&!t.trim())throw new Error("illegal argument `languageId`. must not be empty");const u=_?this.doCreateLogOutputChannel(m,c):this.doCreateOutputChannel(m,t,c);return u.then(i=>{this.channels.set(i.id,i),i.visible=i.id===this.visibleChannelId}),_?this.createExtHostLogOutputChannel(m,u):this.createExtHostOutputChannel(m,u)}async doCreateOutputChannel(m,S,c){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const _=await this.outputDirectoryPromise,t=this.extHostFileSystemInfo.extUri.joinPath(_,`${this.namePool++}-${m.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.loggerService.createLogger(t,{always:!0,donotRotate:!0,donotUseFormatters:!0}),i=await this.proxy.$register(m,t,!1,S,c.identifier.value);return new p(i,m,u,this.proxy,c)}async doCreateLogOutputChannel(m,S){const c=await this.createExtensionLogDirectory(S),_=this.extHostFileSystemInfo.extUri.joinPath(c,`${m.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),t=this.loggerService.createLogger(_,{name:m}),u=await this.proxy.$register(m,_,!0,void 0,S.identifier.value);return new a(u,m,t,this.proxy,S)}createExtensionLogDirectory(m){let S=this.extensionLogDirectoryPromise.get(m.identifier.value);if(!S){const c=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,m.identifier.value);this.extensionLogDirectoryPromise.set(m.identifier.value,S=(async()=>{try{await this.extHostFileSystem.value.createDirectory(c)}catch(_){if((0,I.toFileSystemProviderErrorCode)(_)!==I.FileSystemProviderErrorCode.FileExists)throw _}return c})())}return S}createExtHostOutputChannel(m,S){let c=!1;const _=()=>{if(c)throw new Error("Channel has been closed")};return{get name(){return m},append(t){_(),S.then(u=>u.append(t))},appendLine(t){_(),S.then(u=>u.appendLine(t))},clear(){_(),S.then(t=>t.clear())},replace(t){_(),S.then(u=>u.replace(t))},show(t,u){_(),S.then(i=>i.show(t,u))},hide(){_(),S.then(t=>t.hide())},dispose(){c=!0,S.then(t=>t.dispose())}}}createExtHostLogOutputChannel(m,S){let c=!1;const _=()=>{if(c)throw new Error("Channel has been closed")};return{...this.createExtHostOutputChannel(m,S),trace(t,...u){_(),S.then(i=>i.trace(t,...u))},debug(t,...u){_(),S.then(i=>i.debug(t,...u))},info(t,...u){_(),S.then(i=>i.info(t,...u))},warn(t,...u){_(),S.then(i=>i.warn(t,...u))},error(t,...u){_(),S.then(i=>i.error(t,...u))},dispose(){c=!0,S.then(t=>t.dispose())}}}};l=$e([xe(0,w.IExtHostRpcService),xe(1,E.IExtHostInitDataService),xe(2,A.IExtHostConsumerFileSystem),xe(3,P.IExtHostFileSystemInfo),xe(4,F.ILoggerService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(Ce[230],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService")}),define(Ce[231],Ie([1,0,39,13,19,20,22,2,3,161,48,176,230]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let I=class en{constructor(a,l,d,m){this.localUserHome=a,this.remoteAgentService=l,this.environmentService=d,this.contextService=m,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||F.OS)(),this.resolveUserHome=(async()=>{const S=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=S?.userHome??a})()}hasValidBasename(a,l,d){return typeof l=="string"||typeof l>"u"?this.resolveOS.then(m=>this.doHasValidBasename(a,m,l)):this.doHasValidBasename(a,l,d)}doHasValidBasename(a,l,d){return a.scheme===C.Schemas.file||a.scheme===C.Schemas.vscodeRemote?(0,r.isValidBasename)(d??(0,y.basename)(a),l===1):!0}get defaultUriScheme(){return en.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(a,l){if(a.remoteAuthority)return C.Schemas.vscodeRemote;const d=(0,P.getVirtualWorkspaceScheme)(l.getWorkspace());if(d)return d;const m=l.getWorkspace().folders[0];if(m)return m.uri.scheme;const S=l.getWorkspace().configuration;return S?S.scheme:C.Schemas.file}userHome(a){return a?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(a=>a===1?w.win32:w.posix)}async fileURI(a){let l="";if(await this.resolveOS===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const m=a.indexOf("/",2);m===-1?(l=a.substring(2),a="/"):(l=a.substring(2,m),a=a.substring(m)||"/")}return A.URI.from({scheme:C.Schemas.file,authority:l,path:a,query:"",fragment:""})}};I=$e([xe(1,g.IRemoteAgentService),xe(2,b.IWorkbenchEnvironmentService),xe(3,R.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(Ce[100],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(y,A){this.line=y,this.character=A}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,A){return new r(0,0)}with(y){return new r(0,0)}}e.Position=r;class C{constructor(y,A,E,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(y,A),this.end=new r(E,P)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new C(0,0,0,0)}with(y){return new C(0,0,0,0)}}e.Range=C;var w;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[43],Ie([1,0,18,34,24,39,9,3,19,12,100,15]),function(ne,e,r,C,w,F,y,A,E,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const g="\u27EA ",I=" characters skipped \u27EB",p=(g.length+I.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var a;(function(re){re[re.file=0]="file",re[re.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var l;(function(re){re[re.File=1]="File",re[re.Text=2]="Text"})(l=e.QueryType||(e.QueryType={}));function d(re){return!!re.preview}e.resultIsMatch=d;function m(re){return!!re.resource}e.isFileMatch=m;function S(re){return!!re.message}e.isProgressMessage=S;var c;(function(re){re[re.Normal=0]="Normal",re[re.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class _{constructor(be){this.resource=be,this.results=[]}}e.FileMatch=_;class t{constructor(be,le,fe){this.ranges=le;const Q=Array.isArray(le)?le:[le];if(fe&&fe.matchLines===1&&u(Q)){be=(0,y.getNLines)(be,fe.matchLines);let pe="",Se=0,Fe=0;const Be=Math.floor(fe.charsPerLine/5),Xe=[];for(const ke of Q){const ye=Math.max(ke.startColumn-Be,0),De=ke.startColumn+fe.charsPerLine;if(ye>Fe+Be+p){const ae=g+(ye-Fe)+I;pe+=ae+be.slice(ye,De),Se+=ye-(Fe+ae.length)}else pe+=be.slice(Fe,De);Xe.push(new n(0,ke.startColumn-Se,ke.endColumn-Se)),Fe=De}this.preview={text:pe,matches:Array.isArray(this.ranges)?Xe:Xe[0]}}else{const pe=Array.isArray(le)?le[0].startLineNumber:le.startLineNumber;this.preview={text:be,matches:(0,r.mapArrayOrNot)(le,Se=>new i(Se.startLineNumber-pe,Se.startColumn,Se.endLineNumber-pe,Se.endColumn))}}}}e.TextSearchMatch=t;function u(re){const be=re[0].startLineNumber;for(const le of re)if(le.startLineNumber!==be||le.endLineNumber!==be)return!1;return!0}class i{constructor(be,le,fe,Q){this.startLineNumber=be,this.startColumn=le,this.endLineNumber=fe,this.endColumn=Q}}e.SearchRange=i;class n extends i{constructor(be,le,fe){super(be,le,be,fe)}}e.OneLineRange=n;var s;(function(re){re.List="list",re.Tree="tree"})(s=e.ViewMode||(e.ViewMode={}));var h;(function(re){re.Default="default",re.FileNames="fileNames",re.Type="type",re.Modified="modified",re.CountDescending="countDescending",re.CountAscending="countAscending"})(h=e.SearchSortOrder||(e.SearchSortOrder={}));function o(re,be=!0){const le=re&&re.files&&re.files.exclude,fe=be&&re&&re.search&&re.search.exclude;if(!le&&!fe)return;if(!le||!fe)return le||fe;let Q=Object.create(null);return Q=w.mixin(Q,w.deepClone(le)),Q=w.mixin(Q,w.deepClone(fe),!0),Q}e.getExcludes=o;function f(re,be){return re.excludePattern&&C.match(re.excludePattern,be)?!1:re.includePattern||re.usingSearchPaths?re.includePattern&&C.match(re.includePattern,be)?!0:re.usingSearchPaths?!!re.folderQueries&&re.folderQueries.some(le=>{const fe=le.folder.fsPath;if(F.isEqualOrParent(be,fe)){const Q=E.relative(fe,be);return!le.includePattern||!!C.match(le.includePattern,Q)}else return!1}):!1:!0}e.pathIncludedInQuery=f;var v;(function(re){re[re.unknownEncoding=1]="unknownEncoding",re[re.regexParseError=2]="regexParseError",re[re.globParseError=3]="globParseError",re[re.invalidLiteral=4]="invalidLiteral",re[re.rgProcessError=5]="rgProcessError",re[re.other=6]="other",re[re.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class T extends Error{constructor(be,le){super(be),this.code=le}}e.SearchError=T;function M(re){const be=re.message;if((0,P.isCancellationError)(re))return new T(be,v.canceled);try{const le=JSON.parse(be);return new T(le.message,le.code)}catch{return new T(be,v.other)}}e.deserializeSearchError=M;function j(re){const be={message:re.message,code:re.code};return new Error(JSON.stringify(be))}e.serializeSearchError=j;function U(re){return re.type==="error"?!0:re.type==="success"}e.isSerializedSearchComplete=U;function D(re){return re.type==="success"}e.isSerializedSearchSuccess=D;function $(re){return!!re.path}e.isSerializedFileMatch=$;function L(re,be){const le=re.searchPath?re.searchPath:re.relativePath;return(0,y.fuzzyContains)(le,be)}e.isFilePatternMatch=L;class O{constructor(be){this.path=be,this.results=[]}addMatch(be){this.results.push(be)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function H(re,be){const le={...re||{},...be||{}};return Object.keys(le).filter(fe=>{const Q=le[fe];return typeof Q=="boolean"&&Q})}e.resolvePatternsForProvider=H;class W{constructor(be,le){this._parsedIncludeExpression=null,this._excludeExpression={...be.excludePattern||{},...le.excludePattern||{}},this._parsedExcludeExpression=C.parse(this._excludeExpression);let fe=be.includePattern;le.includePattern&&(fe?fe={...fe,...le.includePattern}:fe=le.includePattern),fe&&(this._parsedIncludeExpression=C.parse(fe))}matchesExcludesSync(be,le,fe){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(be,le,fe))}includedInQuerySync(be,le,fe){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(be,le,fe)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(be,le,fe))}includedInQuery(be,le,fe){const Q=this._parsedExcludeExpression(be,le,fe),pe=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(be,le,fe):!0;return(0,b.isThenable)(Q)?Q.then(Se=>Se?!1:pe()):pe()}hasSiblingExcludeClauses(){return z(this._excludeExpression)}}e.QueryGlobTester=W;function z(re){for(const be in re)if(typeof re[be]!="boolean")return!0;return!1}function G(re){if(!re)return;let be;return le=>(be||(be=(re()||Promise.resolve([])).then(fe=>fe?he(fe):{})),be.then(fe=>!!fe[le]))}e.hasSiblingPromiseFn=G;function te(re){if(!re)return;let be;return le=>{if(!be){const fe=re();be=fe?he(fe):{}}return!!be[le]}}e.hasSiblingFn=te;function he(re){const be={};for(const le of re)be[le]=!0;return be}}),define(Ce[31],Ie([1,0,18,15,21,4,7,25,13,107,22,9,10,2,136,3,11,150,48,36,26,14,8,6,49,43,5]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a,l,d,m,S,c,_,t,u,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function h(D,$,L){return new R.ExtUri(O=>T(O,L)).isEqual(D,$)}function o(D,$,L){return h(D.uri,$.uri,L)?0:(0,b.compare)(D.uri.toString(),$.uri.toString())}function f(D,$,L){return D.index!==$.index?D.index<$.index?-1:1:h(D.uri,$.uri,L)?(0,b.compare)(D.name,$.name):(0,b.compare)(D.uri.toString(),$.uri.toString())}function v(D,$,L,O){const H=D.slice(0).sort((z,G)=>L(z,G,O)),W=$.slice(0).sort((z,G)=>L(z,G,O));return(0,r.delta)(H,W,(z,G)=>L(z,G,O))}function T(D,$){const L=$.getCapabilities(D.scheme);return!(L&&L&1024)}class M extends m.Workspace{static toExtHostWorkspace($,L,O,H){if(!$)return{workspace:null,added:[],removed:[]};const{id:W,name:z,folders:G,configuration:te,transient:he,isUntitled:re}=$,be=[],le=L;L?G.forEach((Se,Fe)=>{const Be=I.URI.revive(Se.uri),Xe=M._findFolder(O||L,Be,H);Xe?(Xe.name=Se.name,Xe.index=Se.index,be.push(Xe)):be.push({uri:Be,name:Se.name,index:Fe})}):be.push(...G.map(({uri:Se,name:Fe,index:Be})=>({uri:I.URI.revive(Se),name:Fe,index:Be}))),be.sort((Se,Fe)=>Se.index<Fe.index?-1:1);const fe=new M(W,z,be,!!he,te?I.URI.revive(te):null,!!re,Se=>T(Se,H)),{added:Q,removed:pe}=v(le?le.workspaceFolders:[],fe.workspaceFolders,o,H);return{workspace:fe,added:Q,removed:pe}}static _findFolder($,L,O){for(let H=0;H<$.folders.length;H++){const W=$.workspaceFolders[H];if(h(W.uri,L,O))return W}}constructor($,L,O,H,W,z,G){super($,O.map(te=>new m.WorkspaceFolder(te)),H,W,G),this._name=L,this._isUntitled=z,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(G),O.forEach(te=>{this._workspaceFolders.push(te),this._structure.set(te.uri,te)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder($,L){return L&&this._structure.get($)&&($=(0,R.dirname)($)),this._structure.findSubstr($)}resolveWorkspaceFolder($){return this._structure.get($)}}let j=class{constructor($,L,O,H,W){this._onDidChangeWorkspace=new F.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new F.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=H,this._extHostFileSystemInfo=O,this._uriTransformerService=W,this._requestIdProvider=new P.Counter,this._barrier=new C.Barrier,this._proxy=$.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=$.getProxy(s.MainContext.MainThreadMessageService);const z=L.workspace;this._confirmedWorkspace=z?new M(z.id,z.name,[],!!z.transient,z.configuration?I.URI.revive(z.configuration):null,!!z.isUntitled,G=>T(G,O)):void 0}$initializeWorkspace($,L){this._trusted=L,this.$acceptWorkspaceData($),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?I.URI.from({scheme:E.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders($,L,O,...H){const W=[];if(Array.isArray(H)&&H.forEach(re=>{I.URI.isUri(re.uri)&&!W.some(be=>h(be.uri,re.uri,this._extHostFileSystemInfo))&&W.push({uri:re.uri,name:re.name||(0,R.basenameOrAuthority)(re.uri)})}),this._unconfirmedWorkspace||[L,O].some(re=>typeof re!="number"||re<0)||O===0&&W.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(L+O>z.length)return!1;const G=z.slice(0);G.splice(L,O,...W.map(re=>({uri:re.uri,name:re.name||(0,R.basenameOrAuthority)(re.uri),index:void 0})));for(let re=0;re<G.length;re++){const be=G[re];if(G.some((le,fe)=>fe!==re&&h(be.uri,le.uri,this._extHostFileSystemInfo)))return!1}G.forEach((re,be)=>re.index=be);const{added:te,removed:he}=v(z,G,f,this._extHostFileSystemInfo);if(te.length===0&&he.length===0)return!1;if(this._proxy){const re=$.displayName||$.name;this._proxy.$updateWorkspaceFolders(re,L,O,W).then(void 0,be=>{this._unconfirmedWorkspace=void 0;const le={source:{identifier:$.identifier,label:$.displayName||$.name}};this._messageService.$showMessage(d.Severity.Error,(0,p.localize)(0,null,re,be.toString()),le,[])})}return this.trySetWorkspaceFolders(G),!0}getWorkspaceFolder($,L){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,L)}async getWorkspaceFolder2($,L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,L)}async resolveWorkspaceFolder($){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder($)}getPath(){if(!this._actualWorkspace)return;const{folders:$}=this._actualWorkspace;if($.length!==0)return $[0].uri.fsPath}getRelativePath($,L){let O,H="";if(typeof $=="string"?(O=I.URI.file($),H=$):typeof $<"u"&&(O=$,H=$.fsPath),!O)return H;const W=this.getWorkspaceFolder(O,!0);if(!W)return H;typeof L>"u"&&this._actualWorkspace&&(L=this._actualWorkspace.folders.length>1);let z=(0,R.relativePath)(W.uri,O);return L&&W.name&&(z=`${W.name}/${z}`),z}trySetWorkspaceFolders($){this._actualWorkspace&&(this._unconfirmedWorkspace=M.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:$,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData($){const{workspace:L,added:O,removed:H}=M.toExtHostWorkspace($,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=L||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:H}))}findFiles($,L,O,H,W=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${H.value}, entryPoint: findFiles`);let z;if(L===null?z=!1:L&&(typeof L=="string"?z=L:z=L.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:G,folder:te}=U(t.GlobPattern.from($));return this._proxy.$startFileSearch((0,g.withUndefinedAsNull)(G),(0,g.withUndefinedAsNull)(te),(0,g.withUndefinedAsNull)(z),(0,g.withUndefinedAsNull)(O),W).then(he=>Array.isArray(he)?he.map(re=>I.URI.revive(re)):[])}async findTextInFiles($,L,O,H,W=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${H.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),G=typeof L.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:te,folder:he}=U(t.GlobPattern.from(L.include)),re=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,be={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:G,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:te,excludePattern:re},le=!1;if(this._activeSearchCallbacks[z]=fe=>{if(le)return;const Q=I.URI.revive(fe.resource);fe.results.forEach(pe=>{(0,n.resultIsMatch)(pe)?O({uri:Q,preview:{text:pe.preview.text,matches:(0,r.mapArrayOrNot)(pe.preview.matches,Se=>new u.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))},ranges:(0,r.mapArrayOrNot)(pe.ranges,Se=>new u.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))}):O({uri:Q,text:pe.text,lineNumber:pe.lineNumber})})},W.isCancellationRequested)return{};try{const fe=await this._proxy.$startTextSearch($,(0,g.withUndefinedAsNull)(he),be,z,W);return delete this._activeSearchCallbacks[z],fe||{}}catch(fe){throw delete this._activeSearchCallbacks[z],fe}}$handleTextSearchResult($,L){this._activeSearchCallbacks[L]?.($)}saveAll($){return this._proxy.$saveAll($)}resolveProxy($){return this._proxy.$resolveProxy($)}get trusted(){return this._trusted}requestWorkspaceTrust($){return this._proxy.$requestWorkspaceTrust($)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider($,L){if(this._editSessionIdentityProviders.has($))throw new Error(`A provider has already been registered for scheme ${$}`);this._editSessionIdentityProviders.set($,L);const O=this._uriTransformerService.transformOutgoingScheme($),H=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(H,O),(0,y.toDisposable)(()=>{this._editSessionIdentityProviders.delete($),this._proxy.$unregisterEditSessionIdentityProvider(H)})}async $getEditSessionIdentifier($,L){this._logService.info("Getting edit session identifier for workspaceFolder",$);const O=await this.resolveWorkspaceFolder(I.URI.revive($));if(!O){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const H=this._editSessionIdentityProviders.get(O.uri.scheme);if(this._logService.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!H),!H)return;const W=await H.provideEditSessionIdentity(O,L);if(this._logService.info("Provider returned edit session identifier: ",W),!!W)return W}};j=$e([xe(0,_.IExtHostRpcService),xe(1,c.IExtHostInitDataService),xe(2,S.IExtHostFileSystemInfo),xe(3,l.ILogService),xe(4,i.IURITransformerService)],j),e.ExtHostWorkspace=j,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function U(D){let $,L;return D&&(typeof D=="string"?$=D:($=D.pattern,L=I.URI.revive(D.baseUri))),{includePattern:$,folder:L}}}),define(Ce[32],Ie([1,0,24,4,31,5,6,153,87,10,15,3,14,11,2]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(u,i){if(i){const n=i.split(".");let s=u;for(let h=0;s&&h<n.length;h++)s=s[n[h]];return s}}function l(u){return u instanceof p.URI}function d(u){return u&&u.uri instanceof p.URI&&u.languageId&&typeof u.languageId=="string"}function m(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function S(u){return u&&u.uri instanceof p.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function c(u){if(l(u))return{resource:u};if(d(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(m(u))return{overrideIdentifier:u.languageId};if(S(u))return{resource:u.uri};if(u===null)return{resource:null}}let _=class{constructor(i,n,s){this._proxy=i.getProxy(F.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=s,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new t(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,n){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(i,n))}};_=$e([xe(0,g.IExtHostRpcService),xe(1,w.IExtHostWorkspace),xe(2,I.ILogService)],_),e.ExtHostConfiguration=_;class t{constructor(i,n,s,h){this._onDidChangeConfiguration=new C.Emitter,this._proxy=i,this._logService=h,this._extHostWorkspace=n,this._configuration=A.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,n){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,s))}getConfiguration(i,n,s){const h=c(n)||{},o=this._toReadonlyValue(i?a(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,h,s?.identifier);function f(T){if(T==null)return null;if(typeof T=="boolean")return T?2:5;switch(T){case y.ConfigurationTarget.Global:return 2;case y.ConfigurationTarget.Workspace:return 5;case y.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(T){return typeof a(o,T)<"u"},get:(T,M)=>{this._validateConfigurationAccess(i?`${i}.${T}`:T,h,s?.identifier);let j=a(o,T);if(typeof j>"u")j=M;else{let U;const D=($,L)=>{let O;const H=()=>{U=U||(0,r.deepClone)(o),O=O||a(U,L)};return(0,P.isObject)($)?new Proxy($,{get:(W,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return H(),()=>O;if(U)return O=O||a(U,L),O[z];const G=W[z];return typeof z=="string"?D(G,`${L}.${z}`):G},set:(W,z,G)=>(H(),O&&(O[z]=G),!0),deleteProperty:(W,z)=>(H(),O&&delete O[z],!0),defineProperty:(W,z,G)=>(H(),O&&Object.defineProperty(O,z,G),!0)}):$};j=D(j,T)}return j},update:(T,M,j,U)=>{T=i?`${i}.${T}`:T;const D=f(j);return M!==void 0?this._proxy.$updateConfigurationOption(D,T,M,h,U):this._proxy.$removeConfigurationOption(D,T,h,U)},inspect:T=>{T=i?`${i}.${T}`:T;const M=(0,r.deepClone)(this._configuration.inspect(T,h,this._extHostWorkspace.workspace));if(M)return{key:T,defaultValue:M.policy?.value??M.default?.value,globalValue:M.user?.value??M.application?.value,workspaceValue:M.workspace?.value,workspaceFolderValue:M.workspaceFolder?.value,defaultLanguageValue:M.default?.override,globalLanguageValue:M.user?.override??M.application?.override,workspaceLanguageValue:M.workspace?.override,workspaceFolderLanguageValue:M.workspaceFolder?.override,languageIds:M.overrideIdentifiers}}};return typeof o=="object"&&(0,r.mixin)(v,o,!1),Object.freeze(v)}_toReadonlyValue(i){const n=s=>(0,P.isObject)(s)?new Proxy(s,{get:(h,o)=>n(h[o]),set:(h,o,f)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(h,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(h,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return n(i)}_validateConfigurationAccess(i,n,s){const h=E.OVERRIDE_PROPERTY_REGEX.test(i)?4:this._configurationScopes.get(i),o=s?`[${s.value}] `:"";if(h===4){typeof n?.resource>"u"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){n?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,n){const s=new A.ConfigurationChangeEvent(i,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,o)=>s.affectsConfiguration(h,c(o))})}_toMap(i){return i.reduce((n,s)=>(n.set(s[0],s[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(ne,r):w?w.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!C:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ne):C?C.value:e.get(ne)};define(Ce[101],Ie([1,0,2,15,4,5,6,31,52,32,21,55,14,26,3,13,20,11,69,189,12]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a,l,d,m,S,c){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(L){function O(W){if(W!=null)return W}L.from=O;function H(W){if(W!=null)return W}L.to=H})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(L){function O(W){if(W!=null)return W}L.from=O;function H(W){if(W!=null)return W}L.to=H})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(L){function O(W){if(W!=null)return W}L.from=O;function H(W){if(W!=null)return W}L.to=H})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(L){function O(z){if(z){const G=z;return G&&!!G.process}else return!1}L.is=O;function H(z){if(z==null)return;const G={process:z.process,args:z.args};return z.options&&(G.options=i.from(z.options)),G}L.from=H;function W(z){if(z!=null)return new y.ProcessExecution(z.process,z.args,z.options)}L.to=W})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(L){function O(W){if(W!=null)return W}L.from=O;function H(W){if(W!=null)return W}L.to=H})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(L){function O(z){if(z){const G=z;return G&&(!!G.commandLine||!!G.command)}else return!1}L.is=O;function H(z){if(z==null)return;const G={};return z.commandLine!==void 0?G.commandLine=z.commandLine:(G.command=z.command,G.args=z.args),z.options&&(G.options=s.from(z.options)),G}L.from=H;function W(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new y.ShellExecution(z.commandLine,z.options):new y.ShellExecution(z.command,z.args?z.args:[],z.options)}L.to=W})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(L){function O(z){if(z){const G=z;return G&&G.customExecution==="customExecution"}else return!1}L.is=O;function H(z){return{customExecution:"customExecution"}}L.from=H;function W(z,G){return G.get(z)}L.to=W})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var f;(function(L){function O(H,W){let z;return H.scope!==void 0&&typeof H.scope!="number"?z=H.scope.uri:H.scope!==void 0&&typeof H.scope=="number"&&(H.scope===y.TaskScope.Workspace&&W&&W.workspaceFile?z=W.workspaceFile:z=S.USER_TASKS_GROUP_KEY),{id:H._id,workspaceFolder:z}}L.from=O})(f=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(L){function O(H){if(H!=null)return{_id:H.id,isDefault:H.isDefault}}L.from=O})(v=e.TaskGroupDTO||(e.TaskGroupDTO={}));var T;(function(L){function O(z,G){if(z==null)return[];const te=[];for(const he of z){const re=H(he,G);re&&te.push(re)}return te}L.fromMany=O;function H(z,G){if(z==null)return;let te;z.execution instanceof y.ProcessExecution?te=n.from(z.execution):z.execution instanceof y.ShellExecution?te=h.from(z.execution):z.execution&&z.execution instanceof y.CustomExecution&&(te=o.from(z.execution));const he=t.from(z.definition);let re;return z.scope?typeof z.scope=="number"?re=z.scope:re=z.scope.uri:re=y.TaskScope.Workspace,!he||!re?void 0:{_id:z._id,definition:he,name:z.name,source:{extensionId:G.identifier.value,label:z.source,scope:re},execution:te,isBackground:z.isBackground,group:v.from(z.group),presentationOptions:u.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}L.from=H;async function W(z,G,te){if(z==null)return;let he;n.is(z.execution)?he=n.to(z.execution):h.is(z.execution)?he=h.to(z.execution):o.is(z.execution)&&(he=o.to(z._id,te));const re=t.to(z.definition);let be;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?be=z.source.scope:be=await G.resolveWorkspaceFolder(r.URI.revive(z.source.scope)):be=y.TaskScope.Workspace),!re||!be)return;const le=new y.Task(re,be,z.name,z.source.label,he,z.problemMatchers);return z.isBackground!==void 0&&(le.isBackground=z.isBackground),z.group!==void 0&&(le.group=y.TaskGroup.from(z.group._id),le.group&&z.group.isDefault&&(le.group=new y.TaskGroup(le.group.id,le.group.label),z.group.isDefault===!0&&(le.group.isDefault=z.group.isDefault))),z.presentationOptions&&(le.presentationOptions=u.to(z.presentationOptions)),z._id&&(le._id=z._id),z.detail&&(le.detail=z.detail),le}L.to=W})(T=e.TaskDTO||(e.TaskDTO={}));var M;(function(L){function O(W){return W}L.from=O;function H(W){if(!!W)return Object.assign(Object.create(null),W)}L.to=H})(M=e.TaskFilterDTO||(e.TaskFilterDTO={}));class j{constructor(O,H,W){this._id=H,this._task=W,_.set(this,void 0),Ye(this,_,O,"f")}get task(){return this._task}terminate(){Oe(this,_,"f").terminateTask(this)}fireDidStartProcess(O){}fireDidEndProcess(O){}}_=new WeakMap;var U;(function(L){function O(H){return{id:H._id,task:void 0}}L.from=O})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let D=class{constructor(O,H,W,z,G,te,he,re){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=O.getProxy(F.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=z,this._configurationService=G,this._terminalService=te,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=he,this._deprecationService=re,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(O,H,W){if(!W)return new y.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:H,provider:W,extension:O}),this._proxy.$registerTaskProvider(z,H),new y.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem(O,H){this._proxy.$registerTaskSystem(O,H)}fetchTasks(O){return this._proxy.$fetchTasks(M.from(O)).then(async H=>{const W=[];for(const z of H){const G=await T.to(z,this._workspaceProvider,this._providedCustomExecutions2);G&&W.push(G)}return W})}get taskExecutions(){const O=[];return this._taskExecutions.forEach(H=>O.push(H)),O}terminateTask(O){if(!(O instanceof j))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(O._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(O,H,W){const z=this._providedCustomExecutions2.get(O.id);z&&(this._activeCustomExecutions2.set(O.id,z),this._terminalService.attachPtyToTerminal(H,await z.callback(W))),this._lastStartedTask=O.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(O)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(O){const H=await this.getTaskExecution(O);this._taskExecutionPromises.delete(O.id),this._taskExecutions.delete(O.id),this.customExecutionComplete(O),this._onDidTerminateTask.fire({execution:H})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(O){const H=await this.getTaskExecution(O.id);this._onDidTaskProcessStarted.fire({execution:H,processId:O.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(O){const H=await this.getTaskExecution(O.id);this._onDidTaskProcessEnded.fire({execution:H,exitCode:O.exitCode})}$provideTasks(O,H){const W=this._handlers.get(O);if(!W)return Promise.reject(new Error("no handler found"));const z=[],G=(0,C.asPromise)(()=>W.provider.provideTasks(R.CancellationToken.None)).then(te=>this.provideTasksInternal(H,z,W,te));return new Promise(te=>{G.then(he=>{Promise.all(z).then(()=>{te(he)})})})}async $resolveTask(O,H){const W=this._handlers.get(O);if(!W)return Promise.reject(new Error("no handler found"));if(H.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${H.definition.type}] cannot be resolved by provider of type [${W.type}].`);const z=await T.to(H,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const G=await W.provider.resolveTask(z,R.CancellationToken.None);if(!G)return;this.checkDeprecation(G,W);const te=T.from(G,W.extension);if(!te)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(te.execution)&&await this.addCustomExecution(te,G,!0),await this.resolveTaskInternal(te)}nextHandle(){return this._handleCounter++}async addCustomExecution(O,H,W){const z=await this._proxy.$createTaskId(O);!W&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,H.execution)),this._providedCustomExecutions2.set(z,H.execution)}async getTaskExecution(O,H){if(typeof O=="string"){const G=this._taskExecutionPromises.get(O);if(!G)throw new c.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return G}const W=this._taskExecutionPromises.get(O.id);if(W)return W;const z=new Promise((G,te)=>{function he(re,be,le){le?G(new j(re,be.id,le)):te("Unexpected: Task does not exist.")}H?he(this,O,H):T.to(O.task,this._workspaceProvider,this._providedCustomExecutions2).then(re=>he(this,O,re))});return this._taskExecutionPromises.set(O.id,z),z.then(G=>(this._taskExecutions.set(O.id,G),G),G=>Promise.reject(G))}checkDeprecation(O,H){O._deprecated&&this._deprecationService.report("Task.constructor",H.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(O){this._activeCustomExecutions2.get(O.id)&&this._activeCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.has(O.id)&&this._lastStartedTask!==O.id&&(this._providedCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.delete(O.id));const W=this._notProvidedCustomExecutions.values();let z=W.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=W.next()}};D=$e([xe(0,g.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,A.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,P.IExtHostConfiguration),xe(5,b.IExtHostTerminalService),xe(6,d.ILogService),xe(7,m.IExtHostApiDeprecationService)],D),e.ExtHostTaskBase=D;let $=class extends D{constructor(O,H,W,z,G,te,he,re){super(O,H,W,z,G,te,he,re),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:l.PlatformToString(0)})}async executeTask(O,H){if(!H.execution)throw new Error("Tasks to execute must include an execution");const W=T.from(H,O);if(W===void 0)throw new Error("Task is not valid");if(o.is(W.execution))await this.addCustomExecution(W,H,!1);else throw new c.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),H);return this._proxy.$executeTask(W).catch(G=>{throw new Error(G)}),z}provideTasksInternal(O,H,W,z){const G=[];if(z)for(const te of z){this.checkDeprecation(te,W),(!te.definition||!O[te.definition.type])&&this._logService.warn(`The task [${te.source}, ${te.name}] uses an undefined task type. The task will be ignored in the future.`);const he=T.from(te,W.extension);he&&o.is(he.execution)?(G.push(he),H.push(this.addCustomExecution(he,te,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:W.extension}}async resolveTaskInternal(O){if(o.is(O.execution))return O;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(O,H){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(O,H,W){}};$=$e([xe(0,g.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,A.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,P.IExtHostConfiguration),xe(5,b.IExtHostTerminalService),xe(6,d.ILogService),xe(7,m.IExtHostApiDeprecationService)],$),e.WorkerExtHostTask=$,e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(Ce[232],Ie([1,0,19,21,44,34,22,207,43]),function(ne,e,r,C,w,F,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(g,I,p){this.config=g,this.provider=I,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&F.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&F.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const I=this.config.folderQueries||[];return new Promise((p,a)=>{const l=d=>{this.resultCount++,g(d)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(d=>{const m=d.toString(),S=r.basename(m);this.globalExcludePattern&&this.globalExcludePattern(m,S)||this.matchFile(l,{base:d,basename:S})}),Promise.all(I.map(d=>this.searchInFolder(d,l))).then(d=>{p({limitHit:this.isLimitHit,stats:d[0]||void 0})},d=>{a(new Error((0,w.toErrorMessage)(d)))})})}async searchInFolder(g,I){const p=new C.CancellationTokenSource,a=this.getSearchOptionsForFolder(g),l=this.initDirectoryTree(),d=new E.QueryGlobTester(this.config,g),m=!d.hasSiblingExcludeClauses();let S;try{this.activeCancellationTokens.add(p),S=A.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,p.token),_=S.elapsed(),t=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(u=>{const i=r.posix.relative(g.folder.path,u.path);if(m){const n=r.basename(u.path);this.matchFile(I,{base:g.folder,relativePath:i,basename:n});return}this.addDirectoryEntries(l,g.folder,i,I)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(l,d,I),{providerTime:_,postProcessTime:t.elapsed()})}finally{p.dispose(),this.activeCancellationTokens.delete(p)}}getSearchOptionsForFolder(g){const I=(0,E.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),p=(0,E.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:p,includes:I,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},I,p,a){if(p===this.filePattern){const d=r.basename(this.filePattern);this.matchFile(a,{base:I,relativePath:this.filePattern,basename:d})}function l(d){const m=r.basename(d),S=r.dirname(d);let c=g[S];c||(c=g[S]=[],l(S)),c.push({base:I,relativePath:d,basename:m})}l(p)}matchDirectoryTree({rootEntries:g,pathToEntries:I},p,a){const l=this,d=this.filePattern;function m(S){const c=(0,E.hasSiblingFn)(()=>S.map(_=>_.basename));for(let _=0,t=S.length;_<t;_++){const u=S[_],{relativePath:i,basename:n}=u;if(p.matchesExcludesSync(i,n,d!==n?c:void 0))continue;const s=I[i];if(s)m(s);else{if(i===d)continue;l.matchFile(a,u)}if(l.isLimitHit)break}}m(g)}matchFile(g,I){(!this.includePattern||I.relativePath&&this.includePattern(I.relativePath,I.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(I))}}class R{constructor(){this.sessions=new Map}fileSearch(g,I,p,a){const l=this.getSessionTokenSource(g.cacheKey),d=new P(g,I,l&&l.token);let m=0;const S=c=>{m+=c.length,p(c.map(_=>this.rawMatchToSearchItem(_)))};return this.doSearch(d,R.BATCH_SIZE,S,a).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:m,detailStats:c.stats}}))}clearCache(g){this.getSessionTokenSource(g)?.cancel()}getSessionTokenSource(g){if(!!g)return this.sessions.has(g)||this.sessions.set(g,new C.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:y.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,I,p,a){a.onCancellationRequested(()=>{g.cancel()});const l=m=>{m&&(d.push(m),I>0&&d.length>=I&&(p(d),d=[]))};let d=[];return g.search(l).then(m=>(d.length&&p(d),m),m=>(d.length&&p(d),Promise.reject(m)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(Ce[233],Ie([1,0,18,75,34,80,25,13,19,22,9,10,2,249,144,45,11,48,91,231,43]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a,l,d,m,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let _=class{constructor(v,T,M,j,U){this.configurationService=v,this.workspaceContextService=T,this.editorGroupsService=M,this.logService=j,this.pathService=U}text(v,T,M={}){v=this.getContentPattern(v,M);const j=this.configurationService.getValue(),U=T&&T.some($=>!this.configurationService.getValue({resource:$}).search.useRipgrep);return{...this.commonQuery(T?.map(d.toWorkspaceFolder),M),type:2,contentPattern:v,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:j.search.usePCRE2||U||!1,beforeContext:M.beforeContext,afterContext:M.afterContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}getContentPattern(v,T){const M=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const j={...v,wordSeparators:M.editor.wordSeparators};return this.isCaseSensitive(v,T)&&(j.isCaseSensitive=!0),this.isMultiline(v)&&(j.isMultiline=!0),j}file(v,T={}){return{...this.commonQuery(v,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(v,T){return v?(v=Array.isArray(v)?v.map(s):s(v),T?this.parseSearchPaths(v):{pattern:u(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],T={}){const M=this.handleIncludeExclude(T.includePattern,T.expandPatterns),j=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),U=v.length>1,D=(M.searchPaths&&M.searchPaths.length?M.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,T,j)):v.map(O=>this.getFolderQueryForRoot(O,T,j,U))).filter(O=>!!O),$={_reason:T._reason,folderQueries:D,usingSearchPaths:!!(M.searchPaths&&M.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:j.pattern,includePattern:M.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const O=r.coalesce(r.flatten(this.editorGroupsService.groups.map(z=>z.editors.map(G=>G.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const H=O.filter(z=>(0,c.pathIncludedInQuery)($,z.fsPath)),W=this.commonQueryFromFileList(H);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...$,...W}}const L=T.extraFileResources&&T.extraFileResources.filter(O=>(0,c.pathIncludedInQuery)($,O.fsPath));return $.extraFileResources=L&&L.length?L:void 0,$}commonQueryFromFileList(v){const T=[],M=new y.ResourceMap,j={};let U=!1;return v.forEach(D=>{if(D.scheme===A.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(D)){const L=this.workspaceContextService.getWorkspaceFolder(D)?.uri??D.with({path:E.dirname(D.fsPath)});let O=M.get(L);O||(U=!0,O={folder:L,includePattern:{}},T.push(O),M.set(L,O));const H=E.relative(L.fsPath,D.fsPath);(0,b.assertIsDefined)(O.includePattern)[H.replace(/\\/g,"/")]=!0}else D.fsPath&&(U=!0,j[D.fsPath]=!0)}),{folderQueries:T,includePattern:j,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}isCaseSensitive(v,T){if(T.isSmartCase){if(v.isRegExp){if(R.containsUppercaseCharacter(v.pattern,!0))return!0}else if(R.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,I.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const T=W=>E.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),j=(Array.isArray(v)?v:i(v)).map(W=>{const z=this.pathService.resolvedUserHome;return z?(0,F.untildify)(W,z.scheme===A.Schemas.file?z.fsPath:z.path):W}),U=C.groupBy(j,W=>T(W)?"searchPaths":"exprSegments"),D=(U.exprSegments||[]).map(W=>R.rtrim(W,"/")).map(W=>R.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),n(W))),$={},L=this.expandSearchPathPatterns(U.searchPaths||[]);L&&L.length&&($.searchPaths=L);const O=r.flatten(D),H=u(...O);return H&&($.pattern=H),$}getExcludesForFolder(v,T){return T.disregardExcludeSettings?void 0:(0,c.getExcludes)(v,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const T=r.flatten(v.map(j=>{let{pathPortion:U,globPortion:D}=t(j);D&&(D=h(D));const $=this.expandOneSearchPath(U);return r.flatten($.map(L=>this.resolveOneSearchPathPattern(L,D)))})),M=new Map;return T.forEach(j=>{const U=j.searchPath.toString(),D=M.get(U);D?j.pattern&&(D.pattern=D.pattern||{},D.pattern[j.pattern]=!0):M.set(U,{searchPath:j.searchPath,pattern:j.pattern?u(j.pattern):void 0})}),Array.from(M.values())}expandOneSearchPath(v){if(E.isAbsolute(v)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==A.Schemas.file?[{searchPath:T[0].uri.with({path:v})}]:[{searchPath:g.URI.file(E.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=s(v),v.startsWith("../")||v===".."){const j=E.posix.resolve(T.path,v);return[{searchPath:T.with({path:j})}]}const M=h(v);return[{searchPath:T,pattern:M}]}else{if(v==="./"||v===".\\")return[];{const T=v.replace(/^\.[\/\\]/,""),j=this.workspaceContextService.getWorkspace().folders.map(U=>{const D=T.match(new RegExp(`^${R.escapeRegExpCharacters(U.name)}(?:/(.*)|$)`));return D?{match:D,folder:U}:null}).filter(b.isDefined);if(j.length)return j.map(U=>{const D=U.match[1];return{searchPath:U.folder.uri,pattern:D&&h(D)}});{const U=v.match(/\.[\/\\](.+)[\/\\]?/),D=U?U[1]:v,$=p.localize(0,null,D);throw new Error($)}}}}resolveOneSearchPathPattern(v,T){const M=v.pattern&&T?`${v.pattern}/${T}`:v.pattern||T,j=[{searchPath:v.searchPath,pattern:M}];return M&&!M.endsWith("**")&&j.push({searchPath:v.searchPath,pattern:M+"/**"}),j}getFolderQueryForSearchPath(v,T,M){const j=this.getFolderQueryForRoot((0,d.toWorkspaceFolder)(v.searchPath),T,M,!1);return j?{...j,includePattern:v.pattern}:null}getFolderQueryForRoot(v,T,M,j){let U;const D=g.URI.isUri(v)?v:v.uri;if(M.searchPaths){const W=M.searchPaths.filter(z=>(0,P.isEqual)(z.searchPath,D))[0];if(W&&!W.pattern)return null;W&&(U=W.pattern)}const $=this.configurationService.getValue({resource:D}),O={...this.getExcludesForFolder($,T)||{},...U||{}},H=g.URI.isUri(v)?(0,P.basename)(v):v.name;return{folder:D,folderName:j?H:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:$.files&&$.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!$.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!$.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof T.disregardParentIgnoreFiles=="boolean"?T.disregardParentIgnoreFiles:!$.search.useParentIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!$.search.followSymlinks}}};_=$e([xe(0,a.IConfigurationService),xe(1,d.IWorkspaceContextService),xe(2,m.IEditorGroupsService),xe(3,l.ILogService),xe(4,S.IPathService)],_),e.QueryBuilder=_;function t(f){const v=f.match(/[\*\{\}\(\)\[\]\?]/);if(v){const T=v.index,M=f.substr(0,T).match(/[/|\\][^/\\]*$/);if(M){let j=f.substr(0,M.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:f.substr((M.index||0)+1)}}}return{pathPortion:f}}function u(...f){return f.length?f.reduce((v,T)=>(v[T]=!0,v),Object.create(null)):void 0}function i(f){return w.splitGlobAware(f,",").map(v=>v.trim()).filter(v=>!!v.length)}function n(f){return[`**/${f}/**`,`**/${f}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function s(f){return f.replace(/\\/g,"/")}function h(f){return s(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(f,v){f=r.distinct(f,j=>j.toString());const T=[],M=v.getWorkspace();return f&&f.forEach(j=>{let U;if(v.getWorkbenchState()===2)U=(0,P.relativePath)(M.folders[0].uri,j),U&&U!=="."&&(U="./"+U);else{const D=v.getWorkspaceFolder(j);if(D){const $=D.name;if(M.folders.filter(O=>O.name===$).length===1){const O=(0,P.relativePath)(D.uri,j);O===""?U=`./${D.name}`:U=`./${D.name}/${O}`}else U=j.fsPath}}U&&T.push(U)}),T}e.resolveResourcesForSearchIncludes=o}),define(Ce[234],Ie([1,0,22,2,21,12,3,233,43,48]),function(ne,e,r,C,w,F,y,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function b(a,l){const d=l.activationEvents;if(!d)return Promise.resolve(void 0);const m=[],S=[];for(const n of d)if(/^workspaceContains:/.test(n)){const s=n.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||a.forceUsingSearch?S.push(s):m.push(s)}if(m.length===0&&S.length===0)return Promise.resolve(void 0);let c;const _=new Promise((n,s)=>{c=n}),t=n=>c({activationEvent:n}),u=Promise.all(m.map(n=>g(a,n,t))).then(()=>{}),i=I(a,l.identifier,S,t);return Promise.all([u,i]).then(()=>{c(void 0)}),_}e.checkActivateWorkspaceContainsExtension=b;async function g(a,l,d){for(const m of a.folders)if(await a.exists(r.joinPath(C.URI.revive(m),l))){d(`workspaceContains:${l}`);return}}async function I(a,l,d,m){if(d.length===0)return Promise.resolve(void 0);const S=new w.CancellationTokenSource,c=a.checkExists(a.folders,d,S.token),_=setTimeout(async()=>{S.cancel(),a.logService.info(`Not activating extension '${l.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},R);let t=!1;try{t=await c}catch(u){F.isCancellationError(u)||F.onUnexpectedError(u)}S.dispose(),clearTimeout(_),t&&m(`workspaceContains:${d.join(",")}`)}function p(a,l,d,m){const S=a.get(y.IInstantiationService),c=a.get(E.ISearchService),t=S.createInstance(A.QueryBuilder).file(l.map(u=>(0,P.toWorkspaceFolder)(C.URI.revive(u))),{_reason:"checkExists",includePattern:d,exists:!0});return c.fileSearch(t,m).then(u=>!!u.limitHit,u=>F.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=p});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!w:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(ne,r):w?w.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!C:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ne):C?C.value:e.get(ne)};define(Ce[33],Ie([1,0,131,19,74,22,15,7,25,2,11,5,32,178,72,31,28,177,12,27,23,162,6,88,3,26,73,14,59,63,55,4,234,71,164,13,70]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a,l,d,m,S,c,_,t,u,i,n,s,h,o,f,v,T,M,j,U,D,$){"use strict";var L,O,H;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let W=class Fi extends A.Disposable{constructor(le,fe,Q,pe,Se,Fe,Be,Xe,ke,ye,De){super(),this._onDidChangeRemoteConnectionData=this._register(new T.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=fe,this._extHostContext=Q,this._initData=Be,this._extHostWorkspace=pe,this._extHostConfiguration=Se,this._logService=Fe,this._extHostTunnelService=ke,this._extHostTerminalService=ye,this._extHostLocalizationService=De,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._globalRegistry=new d.ExtensionDescriptionRegistry(this._initData.allExtensions);const ae=(0,l.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new d.ExtensionDescriptionRegistry(te(this._globalRegistry,ae)),this._storage=new p.ExtHostStorage(this._extHostContext),this._secretState=new j.ExtHostSecretState(this._extHostContext),this._storagePath=Xe,this._instaService=le.createChild(new o.ServiceCollection([p.IExtHostStorage,this._storage],[j.IExtHostSecretState,this._secretState]));let ue=[],ee=[];this._initData.remote.isRemote&&(ue=this._initData.allExtensions.filter(k=>!k.main&&!k.browser).map(k=>k.identifier),ee=this._initData.allExtensions.filter(k=>!ae.has(S.ExtensionIdentifier.toKey(k.identifier.value))).filter(k=>(k.main||k.browser)&&k.api==="none").map(k=>k.identifier));const Z=(0,l.extensionIdentifiersArrayToSet)(ee);this._activator=this._register(new I.ExtensionsActivator(this._myRegistry,ue,ee,{onExtensionActivationError:(k,B,V)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(k,m.transformErrorForSerialization(B),V)},actualActivateExtension:async(k,B)=>{if(Z.has(S.ExtensionIdentifier.toKey(k)))return await this._mainThreadExtensionsProxy.$activateExtension(k,B),new I.HostExtension;const V=this._myRegistry.getExtensionDescription(k);return this._activateExtension(V,B)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(le){m.onUnexpectedError(le)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let le=[];try{le=this._myRegistry.getAllExtensionDescriptions().map(Se=>Se.identifier).filter(Se=>this.isActivated(Se)).map(Se=>this._deactivate(Se))}catch{}await Promise.all(le)}terminate(le,fe=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${le}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),m.setUnexpectedErrorHandler(pe=>{this._logService.error(pe)}),this._extHostContext.dispose();const Q=this._deactivateAll();Promise.race([(0,y.timeout)(5e3),Q]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${fe}`):this._logService.info(`Extension host exiting with code ${fe}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(fe)})}isActivated(le){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(le):!1}async getExtension(le){const fe=await this._mainThreadExtensionsProxy.$getExtension(le);let Q;if(fe?.browserNlsBundleUris){Q={};for(const pe of Object.keys(fe.browserNlsBundleUris))Q[pe]=P.URI.revive(fe.browserNlsBundleUris[pe])}return fe&&{...fe,identifier:new S.ExtensionIdentifier(fe.identifier.value),extensionLocation:P.URI.revive(fe.extensionLocation),browserNlsBundleUris:Q}}_activateByEvent(le,fe){return this._activator.activateByEvent(le,fe)}_activateById(le,fe){return this._activator.activateById(le,fe)}activateByIdWithErrors(le,fe){return this._activateById(le,fe).then(()=>{const Q=this._activator.getActivatedExtension(le);if(Q.activationFailed)return Promise.reject(Q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(le=>this._myRegistry)}getExtensionExports(le){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(le).exports:null}async _realPathExtensionUri(le){if(le.scheme!==D.Schemas.file)return le;const fe=await this._hostUtils.realpath(le.fsPath);return P.URI.file(fe)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(le=>new re(le))),this._extensionPathIndex}async _createExtensionPathIndex(le){const fe=E.TernarySearchTree.forUris(Q=>F.extUriBiasedIgnorePathCase.ignorePathCasing(Q));return await Promise.all(le.map(async Q=>{if(this._getEntryPoint(Q)){const pe=await this._realPathExtensionUri(Q.extensionLocation);fe.set(pe,Q)}})),fe}_deactivate(le){let fe=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(le))return fe;const Q=this._activator.getActivatedExtension(le);if(!Q)return fe;try{typeof Q.module.deactivate=="function"&&(fe=Promise.resolve(Q.module.deactivate()).then(void 0,pe=>(this._logService.error(pe),Promise.resolve(void 0))))}catch(pe){this._logService.error(`An error occurred when deactivating the extension '${le.value}':`),this._logService.error(pe)}try{(0,A.dispose)(Q.subscriptions)}catch(pe){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${le.value}':`),this._logService.error(pe)}return fe}async _activateExtension(le,fe){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(le.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(le.identifier),this._doActivateExtension(le,fe).then(Q=>{const pe=Q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(le.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,fe),this._logExtensionActivationTimes(le,fe,"success",pe),Q},Q=>{throw this._logExtensionActivationTimes(le,fe,"failure"),Q})}_logExtensionActivationTimes(le,fe,Q,pe){const Se=z(le,fe);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Se,...pe||{},outcome:Q})}_doActivateExtension(le,fe){const Q=z(le,fe);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Q);const pe=this._getEntryPoint(le);if(!pe)return Promise.resolve(new I.EmptyExtension(I.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${le.identifier.value}, startup: ${fe.startup}, activationEvent: '${fe.activationEvent}'${le.identifier.value!==fe.extensionId.value?`, root cause: ${fe.extensionId.value}`:""}`),this._logService.flush();const Se=new I.ExtensionActivationTimesBuilder(fe.startup);return Promise.all([this._loadCommonJSModule(le,(0,F.joinPath)(le.extensionLocation,pe),Se),this._loadExtensionContext(le)]).then(Fe=>(w.mark(`code/extHost/willActivateExtension/${le.identifier.value}`),Fi._callActivate(this._logService,le.identifier,Fe[0],Fe[1],Se))).then(Fe=>(w.mark(`code/extHost/didActivateExtension/${le.identifier.value}`),Fe))}_loadExtensionContext(le){const fe=new _.ExtensionGlobalMemento(le,this._storage),Q=new _.ExtensionMemento(le.identifier.value,!1,this._storage),pe=new U.ExtensionSecrets(le,this._secretState),Se=le.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Fe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${le.identifier.value}`),Promise.all([fe.whenReady,Q.whenReady,this._storagePath.whenReady]).then(()=>{const Be=this;let Xe,ke;const ye=(0,l.isProposedApiEnabled)(le,"ipc")?this._initData.messagePorts?.get(S.ExtensionIdentifier.toKey(le.identifier)):void 0;return Object.freeze({globalState:fe,workspaceState:Q,secrets:pe,subscriptions:[],get extensionUri(){return le.extensionLocation},get extensionPath(){return le.extensionLocation.fsPath},asAbsolutePath(De){return C.join(le.extensionLocation.fsPath,De)},get storagePath(){return Be._storagePath.workspaceValue(le)?.fsPath},get globalStoragePath(){return Be._storagePath.globalValue(le).fsPath},get logPath(){return C.join(Be._initData.logsLocation.fsPath,le.identifier.value)},get logUri(){return P.URI.joinPath(Be._initData.logsLocation,le.identifier.value)},get storageUri(){return Be._storagePath.workspaceValue(le)},get globalStorageUri(){return Be._storagePath.globalValue(le)},get extensionMode(){return Se},get extension(){return Xe===void 0&&(Xe=new G(Be,le.identifier,le,Fe,!1)),Xe},get extensionRuntime(){return(0,l.checkProposedApiEnabled)(le,"extensionRuntime"),Be.extensionRuntime},get environmentVariableCollection(){return Be._extHostTerminalService.getEnvironmentVariableCollection(le)},get messagePassingProtocol(){if(!ke){if(!ye)return;const De=T.Event.buffer(T.Event.fromDOMEventEmitter(ye,"message",ae=>ae.data));ye.start(),ke={onDidReceiveMessage:De,postMessage:ye.postMessage.bind(ye)}}return ke}})})}static _callActivate(le,fe,Q,pe,Se){return Q=Q||{activate:void 0,deactivate:void 0},this._callActivateOptional(le,fe,Q,pe,Se).then(Fe=>new I.ActivatedExtension(!1,null,Se.build(),Q,Fe,pe.subscriptions))}static _callActivateOptional(le,fe,Q,pe,Se){if(typeof Q.activate=="function")try{Se.activateCallStart(),le.trace(`ExtensionService#_callActivateOptional ${fe.value}`);const Fe=typeof global=="object"?global:self,Be=Q.activate.apply(Fe,[pe]);return Se.activateCallStop(),Se.activateResolveStart(),Promise.resolve(Be).then(Xe=>(Se.activateResolveStop(),Xe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(Q)}_activateOneStartupFinished(le,fe){this._activateById(le.identifier,{startup:!1,extensionId:le.identifier,activationEvent:fe}).then(void 0,Q=>{this._logService.error(Q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const le of this._myRegistry.getAllExtensionDescriptions())if(le.activationEvents)for(const fe of le.activationEvents)fe==="onStartupFinished"&&this._activateOneStartupFinished(le,fe)}_handleEagerExtensions(){const le=this._activateByEvent("*",!0).then(void 0,Se=>{this._logService.error(Se)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Se=>this._handleWorkspaceContainsEagerExtensions(Se.added)));const fe=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Q=this._handleWorkspaceContainsEagerExtensions(fe),pe=Promise.all([le,Q]).then(()=>{});return Promise.race([pe,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),pe}_handleWorkspaceContainsEagerExtensions(le){return le.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(fe=>this._handleWorkspaceContainsEagerExtension(le,fe))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(le,fe){if(this.isActivated(fe.identifier))return;const Q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,pe={logService:this._logService,folders:le.map(Fe=>Fe.uri),forceUsingSearch:Q,exists:Fe=>this._hostUtils.exists(Fe.fsPath),checkExists:(Fe,Be,Xe)=>this._mainThreadWorkspaceProxy.$checkExists(Fe,Be,Xe)},Se=await(0,M.checkActivateWorkspaceContainsExtension)(pe,fe);if(!!Se)return this._activateById(fe.identifier,{startup:!0,extensionId:fe.identifier,activationEvent:Se.activationEvent}).then(void 0,Fe=>this._logService.error(Fe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(le){throw console.error(le),le}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:le,extensionTestsLocationURI:fe}=this._initData.environment;if(!le||!fe)throw new Error(r.localize(0,null));const Q=await this._loadCommonJSModule(null,fe,new I.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(r.localize(1,null,fe.toString()));return new Promise((pe,Se)=>{const Fe=(ke,ye)=>{ke?Se(ke):pe(typeof ye=="number"&&ye>0?1:0)},Be=(0,F.originalFSPath)(fe),Xe=Q.run(Be,Fe);Xe&&Xe.then&&Xe.then(()=>{pe(0)}).catch(ke=>{Se(ke instanceof Error&&ke.stack?ke.stack:String(ke))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(le,fe){return this._resolvers[le]=fe,(0,A.toDisposable)(()=>{delete this._resolvers[le]})}async _activateAndGetResolver(le){const fe=le.indexOf("+");if(fe===-1)throw new Error("Not an authority that can be resolved!");const Q=le.substr(0,fe);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Q}`,!1),{authorityPrefix:Q,resolver:this._resolvers[Q]}}async $resolveAuthority(le,fe){this._logService.info(`$resolveAuthority invoked for authority (${he(le)})`);const{authorityPrefix:Q,resolver:pe}=await this._activateAndGetResolver(le);if(!pe)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Q}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(pe)),w.mark(`code/extHost/willResolveAuthority/${Q}`);const Se=await pe.resolve(le,{resolveAttempt:fe});w.mark(`code/extHost/didResolveAuthorityOK/${Q}`);const Fe={authority:le,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},Be={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Fe,options:Be,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(w.mark(`code/extHost/didResolveAuthorityError/${Q}`),Se instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(le,fe){this._logService.info(`$getCanonicalURI invoked for authority (${he(le)})`);const{resolver:Q}=await this._activateAndGetResolver(le);if(!Q)return null;const pe=P.URI.revive(fe);if(typeof Q.getCanonicalURI>"u")return pe;const Se=await(0,y.asPromise)(()=>Q.getCanonicalURI(pe));return Se||pe}static _applyExtensionsDelta(le,fe,Q){const pe=new d.ExtensionDescriptionRegistry(le.getAllExtensionDescriptions());pe.deltaExtensions(Q.toAdd,Q.toRemove);const Se=(0,l.extensionIdentifiersArrayToSet)(fe.getAllExtensionDescriptions().map(Be=>Be.identifier));for(const Be of Q.myToRemove)Se.delete(S.ExtensionIdentifier.toKey(Be));for(const Be of Q.myToAdd)Se.add(S.ExtensionIdentifier.toKey(Be));const Fe=te(pe,Se);return{globalRegistry:pe,myExtensions:Fe}}$startExtensionHost(le){le.toAdd.forEach(pe=>pe.extensionLocation=P.URI.revive(pe.extensionLocation));const{globalRegistry:fe,myExtensions:Q}=Fi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,le);return this._globalRegistry.set(fe.getAllExtensionDescriptions()),this._myRegistry.set(Q),this._startExtensionHost()}$activateByEvent(le,fe){return fe===1?this._activateByEvent(le,!1):this._readyToRunExtensions.wait().then(Q=>this._activateByEvent(le,!1))}async $activate(le,fe){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(le)?(await this._activateById(le,fe),!0):!1}async $deltaExtensions(le){le.toAdd.forEach(Fe=>Fe.extensionLocation=P.URI.revive(Fe.extensionLocation));const{globalRegistry:fe,myExtensions:Q}=Fi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,le),pe=await this._createExtensionPathIndex(Q);return(await this.getExtensionPathIndex()).setSearchTree(pe),this._globalRegistry.set(fe.getAllExtensionDescriptions()),this._myRegistry.set(Q),Promise.resolve(void 0)}async $test_latency(le){return le}async $test_up(le){return le.byteLength}async $test_down(le){const fe=c.VSBuffer.alloc(le),Q=Math.random()%256;for(let pe=0;pe<le;pe++)fe.writeUInt8(Q,pe);return fe}async $updateRemoteConnectionData(le){this._remoteConnectionData=le,this._onDidChangeRemoteConnectionData.fire()}};W=$e([xe(0,i.IInstantiationService),xe(1,e.IHostUtils),xe(2,h.IExtHostRpcService),xe(3,a.IExtHostWorkspace),xe(4,g.IExtHostConfiguration),xe(5,R.ILogService),xe(6,n.IExtHostInitDataService),xe(7,s.IExtensionStoragePaths),xe(8,f.IExtHostTunnelService),xe(9,v.IExtHostTerminalService),xe(10,$.IExtHostLocalizationService)],W),e.AbstractExtHostExtensionService=W;function z(be,le){return{id:be.identifier.value,name:be.name,extensionVersion:be.version,publisherDisplayName:be.publisher,activationEvents:be.activationEvents?be.activationEvents.join(","):null,isBuiltin:be.isBuiltin,reason:le.activationEvent,reasonId:le.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class G{constructor(le,fe,Q,pe,Se){L.set(this,void 0),O.set(this,void 0),H.set(this,void 0),Ye(this,L,le,"f"),Ye(this,O,fe,"f"),Ye(this,H,Q.identifier,"f"),this.id=Q.identifier.value,this.extensionUri=Q.extensionLocation,this.extensionPath=C.normalize((0,F.originalFSPath)(Q.extensionLocation)),this.packageJSON=Q,this.extensionKind=pe,this.isFromDifferentExtensionHost=Se}get isActive(){return Oe(this,L,"f").isActivated(Oe(this,H,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,L,"f").getExtensionExports(Oe(this,H,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,L,"f").activateByIdWithErrors(Oe(this,H,"f"),{startup:!1,extensionId:Oe(this,O,"f"),activationEvent:"api"}),this.exports}}e.Extension=G,L=new WeakMap,O=new WeakMap,H=new WeakMap;function te(be,le){return be.getAllExtensionDescriptions().filter(fe=>le.has(S.ExtensionIdentifier.toKey(fe.identifier)))}function he(be){const le=be.indexOf("+");return le===-1?be:be.substring(0,le)}class re{constructor(le){this._searchTree=le}setSearchTree(le){this._searchTree=le}findSubstr(le){return this._searchTree.findSubstr(le)}forEach(le){return this._searchTree.forEach(le)}}e.ExtensionPaths=re}),define(Ce[235],Ie([1,0,74,2,5,32,28,27,14,26,3,33,47,11,9]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(_,t,u,i,n,s,h){this._apiFactory=_,this._extensionRegistry=t,this._instaService=u,this._extHostConfiguration=i,this._extHostExtensionService=n,this._initData=s,this._logService=h,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),r.mark("code/extHost/willWaitForConfig");const _=await this._extHostConfiguration.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,t,this._extensionRegistry,_,this._logService)),this.register(this._instaService.createInstance(m,t)),this.register(this._instaService.createInstance(l)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(S,t,this._initData.environment.appUriScheme))}register(_){if("nodeModuleName"in _)if(Array.isArray(_.nodeModuleName))for(const t of _.nodeModuleName)this._factories.set(t,_);else this._factories.set(_.nodeModuleName,_);typeof _.alternativeModuleName=="function"&&this._alternatives.push(t=>_.alternativeModuleName(t))}};a=$e([xe(2,R.IInstantiationService),xe(3,F.IExtHostConfiguration),xe(4,b.IExtHostExtensionService),xe(5,P.IExtHostInitDataService),xe(6,I.ILogService)],a),e.RequireInterceptor=a;let l=class Qi{constructor(_){if(_.environment.appRoot&&Qi.aliased.size){const t=(0,p.escapeRegExpCharacters)(this.forceForwardSlashes(_.environment.appRoot.fsPath)),u="[a-z0-9_.-]",i=`@${u}+\\/${u}+|${u}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${n}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(_){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(_));if(!t)return;const[,u,i,n]=t,s=Qi.aliased.get(i);if(s!==void 0)return console.warn(`${i} as been renamed to ${s}, please update your imports`),u+s+n}forceForwardSlashes(_){return _.replace(/\\/g,"/")}};l.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),l=$e([xe(0,P.IExtHostInitDataService)],l);class d{constructor(_,t,u,i,n){this._apiFactory=_,this._extensionPaths=t,this._extensionRegistry=u,this._configProvider=i,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(_,t){const u=this._extensionPaths.findSubstr(t);if(u){let i=this._extApiImpl.get(A.ExtensionIdentifier.toKey(u.identifier));return i||(i=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(u.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((n,s)=>i+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let m=class{constructor(_,t,u){this._extensionPaths=_,this.nodeModuleName="keytar",this._mainThreadTelemetry=t.getProxy(w.MainContext.MainThreadTelemetry);const{environment:i}=u,n=t.getProxy(w.MainContext.MainThreadKeytar);if(i.appRoot){let s=i.appRoot.fsPath;g.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,h)=>n.$getPassword(s,h),setPassword:(s,h,o)=>n.$setPassword(s,h,o),deletePassword:(s,h)=>n.$deletePassword(s,h),findPassword:s=>n.$findPassword(s),findCredentials(s){return n.$findCredentials(s)}}}load(_,t){const u=this._extensionPaths.findSubstr(t);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(_){const t=_.length;if(t<=7||!this.alternativeNames)return;const u=t-7;if((_.charAt(u)==="/"||_.charAt(u)==="\\")&&_.endsWith("keytar")&&(_=_.replace(/\\/g,"/"),this.alternativeNames.has(_)))return"keytar"}};m=$e([xe(1,E.IExtHostRpcService),xe(2,P.IExtHostInitDataService)],m);let S=class{constructor(_,t,u){this._extensionPaths=_,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(w.MainContext.MainThreadTelemetry);const i=u.getProxy(w.MainContext.MainThreadWindow);this._impl=(n,s)=>{const h=C.URI.parse(n);return s?this.callOriginal(n,s):h.scheme==="http"||h.scheme==="https"?i.$openUri(h,n,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this._appUriScheme?i.$openUri(h,n,{}):this.callOriginal(n,s)}}load(_,t,u){const i=this._extensionPaths.findSubstr(t);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=u(_),this._impl}callOriginal(_,t){return this.sendNoForwardTelemetry(),this._original(_,t)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};S=$e([xe(2,E.IExtHostRpcService)],S)}),define(Ce[102],Ie([1,0,201,7,19,47,3,52,53,33,6,31,174,32]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,y.createDecorator)("IExtHostVariableResolverProvider");class p extends g.AbstractVariableResolverService{constructor(d,m,S,c,_,t,u){function i(){if(S){const n=S.activeEditor();if(n)return n.document.uri;const s=c.tabGroups.all.find(h=>h.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof R.TextDiffTabInput||s.input instanceof R.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof R.TextTabInput||s.input instanceof R.NotebookEditorTabInput||s.input instanceof R.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:n=>{const s=t.folders.filter(h=>h.name===n);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(n,s)=>_.getConfiguration(void 0,n).get(s),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const n=i();if(n)return w.normalize(n.fsPath)},getWorkspaceFolderPathForFile:()=>{if(m){const n=i();if(n){const s=m.getWorkspaceFolder(n);if(s)return w.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(S){const n=S.activeEditor();if(n&&!n.selection.isEmpty)return n.document.getText(n.selection)}},getLineNumber:()=>{if(S){const n=S.activeEditor();if(n)return String(n.selection.end.line+1)}},getExtension:n=>d.getExtension(n)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(F.env))}}let a=class extends C.Disposable{constructor(d,m,S,c,_){super(),this.extensionService=d,this.workspaceService=m,this.editorService=S,this.configurationService=c,this.editorTabs=_,this._resolver=new r.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),i={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async n=>{i.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new p(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,i,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};a=$e([xe(0,P.IExtHostExtensionService),xe(1,b.IExtHostWorkspace),xe(2,A.IExtHostDocumentsAndEditors),xe(3,I.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs)],a),e.ExtHostVariableResolverProviderService=a}),define(Ce[103],Ie([1,0,15,4,10,2,3,5,53,33,14,6,31,167,169,32,102]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(i,n,s,h,o,f){this._workspaceService=n,this._extensionService=s,this._configurationService=h,this._editorTabs=o,this._variableResolver=f,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=i.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new S(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(v=>{v.onDidChange(T=>{this.registerAllDebugTypes(v)}),this.registerAllDebugTypes(v)})}asDebugSourceUri(i,n){const s=i;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let h=`debug:${encodeURIComponent(s.path||"")}`,o="?";return n&&(h+=`${o}session=${encodeURIComponent(n.id)}`,o="&"),h+=`${o}ref=${s.sourceReference}`,F.URI.parse(h)}else{if(s.path)return F.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(i){const n=[];for(const s of i.getAllExtensionDescriptions())if(s.contributes){const h=s.contributes.debuggers;if(h&&h.length>0)for(const o of h)(0,p.isDebuggerMainContribution)(o)&&n.push(o.type)}this._debugServiceProxy.$registerDebugTypes(n)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const i=[];return this._breakpoints.forEach(n=>i.push(n)),i}addBreakpoints(i){this.startBreakpoints();const n=i.filter(o=>{const f=o.id;return this._breakpoints.has(f)?!1:(this._breakpoints.set(f,o),!0)});this.fireBreakpointChanges(n,[],[]);const s=[],h=new Map;for(const o of n)if(o instanceof b.SourceBreakpoint){let f=h.get(o.location.uri.toString());f||(f={type:"sourceMulti",uri:o.location.uri,lines:[]},h.set(o.location.uri.toString(),f),s.push(f)),f.lines.push({id:o.id,enabled:o.enabled,condition:o.condition,hitCondition:o.hitCondition,logMessage:o.logMessage,line:o.location.range.start.line,character:o.location.range.start.character})}else o instanceof b.FunctionBreakpoint&&s.push({type:"function",id:o.id,enabled:o.enabled,hitCondition:o.hitCondition,logMessage:o.logMessage,condition:o.condition,functionName:o.functionName});return this._debugServiceProxy.$registerBreakpoints(s)}removeBreakpoints(i){this.startBreakpoints();const n=i.filter(f=>this._breakpoints.delete(f.id));this.fireBreakpointChanges([],n,[]);const s=n.filter(f=>f instanceof b.SourceBreakpoint).map(f=>f.id),h=n.filter(f=>f instanceof b.FunctionBreakpoint).map(f=>f.id),o=n.filter(f=>f instanceof b.DataBreakpoint).map(f=>f.id);return this._debugServiceProxy.$unregisterBreakpoints(s,h,o)}startDebugging(i,n,s){return this._debugServiceProxy.$startDebugging(i?i.uri:void 0,n,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===b.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,suppressSaveBeforeStart:s.suppressSaveBeforeStart,suppressDebugStatusbar:s.suppressDebugStatusbar??s.debugUI?.simple,suppressDebugToolbar:s.suppressDebugToolbar??s.debugUI?.simple,suppressDebugView:s.suppressDebugView??s.debugUI?.simple})}stopDebugging(i){return this._debugServiceProxy.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,n,s){if(!n)return new b.Disposable(()=>{});const h=this._configProviderHandleCounter++;return this._configProviders.push({type:i,handle:h,provider:n}),this._debugServiceProxy.$registerDebugConfigurationProvider(i,s,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,h),new b.Disposable(()=>{this._configProviders=this._configProviders.filter(o=>o.provider!==n),this._debugServiceProxy.$unregisterDebugConfigurationProvider(h)})}registerDebugAdapterDescriptorFactory(i,n,s){if(!s)return new b.Disposable(()=>{});if(!this.definesDebugType(i,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.getAdapterDescriptorFactoryByType(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const h=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:n,handle:h,factory:s}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(n,h),new b.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(o=>o.factory!==s),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(h)})}registerDebugAdapterTrackerFactory(i,n){if(!n)return new b.Disposable(()=>{});const s=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:i,handle:s,factory:n}),new b.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(h=>h.factory!==n)})}async $runInTerminal(i,n){return Promise.resolve(void 0)}async $substituteVariables(i,n){let s;const h=await this.getFolder(i);return h&&(s={uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(s,n)}createDebugAdapter(i,n){if(i.type==="implementation")return new _(i.implementation)}createSignService(){}async $startDASession(i,n){const s=this,h=await this.getSession(n);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(h.type),h).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}' (extension might have failed to activate)`);const f=this.convertToDto(o),v=this.createDebugAdapter(f,h);if(!v)throw new Error(`Couldn't create a debug adapter for type '${h.type}'.`);const T=v;return this._debugAdapters.set(i,T),this.getDebugAdapterTrackers(h).then(M=>(M&&this._debugAdaptersTrackers.set(i,M),T.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const U=j,D={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(U.arguments.value);D.body={signature:$},T.sendResponse(D)}else throw new Error("no signer")}catch($){D.success=!1,D.message=$.message,T.sendResponse(D)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(j),j=(0,p.convertToVSCPaths)(j,!0),s._debugServiceProxy.$acceptDAMessage(i,j)}),T.onError(j=>{M&&M.onError&&M.onError(j),this._debugServiceProxy.$acceptDAError(i,j.name,j.message,j.stack)}),T.onExit(j=>{M&&M.onExit&&M.onExit((0,w.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(i,(0,w.withNullAsUndefined)(j),void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),T.startSession()))})}$sendDAMessage(i,n){n=(0,p.convertToDAPaths)(n,!1);const s=this._debugAdaptersTrackers.get(i);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(n),this._debugAdapters.get(i)?.sendMessage(n)}$stopDASession(i){const n=this._debugAdaptersTrackers.get(i);this._debugAdaptersTrackers.delete(i),n&&n.onWillStopSession&&n.onWillStopSession();const s=this._debugAdapters.get(i);return this._debugAdapters.delete(i),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const n=[],s=[],h=[];if(i.added)for(const o of i.added){const f=o.id;if(f&&!this._breakpoints.has(f)){let v;if(o.type==="function")v=new b.FunctionBreakpoint(o.functionName,o.enabled,o.condition,o.hitCondition,o.logMessage);else if(o.type==="data")v=new b.DataBreakpoint(o.label,o.dataId,o.canPersist,o.enabled,o.hitCondition,o.condition,o.logMessage);else{const T=F.URI.revive(o.uri);v=new b.SourceBreakpoint(new b.Location(T,new b.Position(o.line,o.character)),o.enabled,o.condition,o.hitCondition,o.logMessage)}v._id=f,this._breakpoints.set(f,v),n.push(v)}}if(i.removed)for(const o of i.removed){const f=this._breakpoints.get(o);f&&(this._breakpoints.delete(o),s.push(f))}if(i.changed){for(const o of i.changed)if(o.id){const f=this._breakpoints.get(o.id);if(f){if(f instanceof b.FunctionBreakpoint&&o.type==="function"){const v=f;v.enabled=o.enabled,v.condition=o.condition,v.hitCondition=o.hitCondition,v.logMessage=o.logMessage,v.functionName=o.functionName}else if(f instanceof b.SourceBreakpoint&&o.type==="source"){const v=f;v.enabled=o.enabled,v.condition=o.condition,v.hitCondition=o.hitCondition,v.logMessage=o.logMessage,v.location=new b.Location(F.URI.revive(o.uri),new b.Position(o.line,o.character))}h.push(f)}}}this.fireBreakpointChanges(n,s,h)}$provideDebugConfigurations(i,n,s){return(0,r.asPromise)(async()=>{const h=this.getConfigProviderByHandle(i);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const o=await this.getFolder(n);return h.provideDebugConfigurations(o,s)}).then(h=>{if(!h)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return h})}$resolveDebugConfiguration(i,n,s,h){return(0,r.asPromise)(async()=>{const o=this.getConfigProviderByHandle(i);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const f=await this.getFolder(n);return o.resolveDebugConfiguration(f,s,h)})}$resolveDebugConfigurationWithSubstitutedVariables(i,n,s,h){return(0,r.asPromise)(async()=>{const o=this.getConfigProviderByHandle(i);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const f=await this.getFolder(n);return o.resolveDebugConfigurationWithSubstitutedVariables(f,s,h)})}async $provideDebugAdapter(i,n){const s=this.getAdapterDescriptorFactoryByHandle(i);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const h=await this.getSession(n);return this.getAdapterDescriptor(s,h).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}'`);return this.convertToDto(o)})}async $acceptDebugSessionStarted(i){const n=await this.getSession(i);this._onDidStartDebugSession.fire(n)}async $acceptDebugSessionTerminated(i){const n=await this.getSession(i);n&&(this._onDidTerminateDebugSession.fire(n),this._debugSessions.delete(n.id))}async $acceptDebugSessionActiveChanged(i){this._activeDebugSession=i?await this.getSession(i):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(i,n){(await this.getSession(i))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(i,n){const h={session:await this.getSession(i),event:n.event,body:n.body};this._onDidReceiveDebugSessionCustomEvent.fire(h)}convertToDto(i){if(i instanceof b.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof b.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof b.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof b.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(i){const n=this._adapterFactories.filter(s=>s.type===i);if(n.length>0)return n[0].factory}getAdapterDescriptorFactoryByHandle(i){const n=this._adapterFactories.filter(s=>s.handle===i);if(n.length>0)return n[0].factory}getConfigProviderByHandle(i){const n=this._configProviders.filter(s=>s.handle===i);if(n.length>0)return n[0].provider}definesDebugType(i,n){if(i.contributes){const s=i.contributes.debuggers;if(s&&s.length>0){for(const h of s)if(h.label&&h.type&&h.type===n)return!0}}return!1}getDebugAdapterTrackers(i){const s=i.configuration.type,h=this._trackerFactories.filter(o=>o.type===s||o.type==="*").map(o=>(0,r.asPromise)(()=>o.factory.createDebugAdapterTracker(i)).then(f=>f,f=>null));return Promise.race([Promise.all(h).then(o=>{const f=o.filter(v=>!!v);if(f.length>0)return new c(f)}),new Promise((o,f)=>{const v=setTimeout(()=>{clearTimeout(v),f(new Error("timeout"))},1e3)})]).catch(o=>{})}async getAdapterDescriptor(i,n){const s=n.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new b.DebugAdapterServer(s));if(i){const o=await this._extensionService.getExtensionRegistry();return(0,r.asPromise)(()=>i.createDebugAdapterDescriptor(n,this.daExecutableFromPackage(n,o))).then(f=>{if(f)return f})}const h=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(n,h))}daExecutableFromPackage(i,n){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(i,n,s){(i.length>0||n.length>0||s.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:i,removed:n,changed:s}))}async getSession(i){if(i)if(typeof i=="string"){const n=this._debugSessions.get(i);if(n)return n}else{let n=this._debugSessions.get(i.id);if(!n){const s=await this.getFolder(i.folderUri),h=i.parent?this._debugSessions.get(i.parent):void 0;n=new m(this._debugServiceProxy,i.id,i.type,i.name,s,i.configuration,h),this._debugSessions.set(n.id,n),this._debugServiceProxy.$sessionCached(n.id)}return n}throw new Error("cannot find session")}getFolder(i){if(i){const n=F.URI.revive(i);return this._workspaceService.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};d=$e([xe(0,R.IExtHostRpcService),xe(1,g.IExtHostWorkspace),xe(2,P.IExtHostExtensionService),xe(3,a.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,l.IExtHostVariableResolverProvider)],d),e.ExtHostDebugServiceBase=d;class m{constructor(i,n,s,h,o,f,v){this._debugServiceProxy=i,this._id=n,this._type=s,this._name=h,this._workspaceFolder=o,this._configuration=f,this._parentSession=v}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(i){this._name=i,this._debugServiceProxy.$setDebugSessionName(this._id,i)}get parentSession(){return this._parentSession}_acceptNameChanged(i){this._name=i}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(i,n){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,i,n)}getDebugProtocolBreakpoint(i){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,i.id)}}e.ExtHostDebugSession=m;class S{constructor(i){this.value=Object.freeze({append(n){i.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.ExtHostDebugConsole=S;class c{constructor(i){this.trackers=i}onWillStartSession(){this.trackers.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.trackers.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.trackers.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(i):void 0)}onWillStopSession(){this.trackers.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.trackers.forEach(n=>n.onError?n.onError(i):void 0)}onExit(i,n){this.trackers.forEach(s=>s.onExit?s.onExit(i,n):void 0)}}class _ extends I.AbstractDebugAdapter{constructor(i){super(),this.implementation=i,i.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.implementation.handleMessage(i)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let t=class extends d{constructor(i,n,s,h,o,f){super(i,n,s,h,o,f)}};t=$e([xe(0,R.IExtHostRpcService),xe(1,g.IExtHostWorkspace),xe(2,P.IExtHostExtensionService),xe(3,a.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,l.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ce[236],Ie([1,0,12,74,2,5,227,11,58,59,26,148,14,49,33]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class a{constructor(d,m,S,c,_){this._hostUtils=S,this._rpcProtocol=new y.RPCProtocol(d,null,c),m=a._transform(m,this._rpcProtocol);const t=new P.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());t.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...m,messagePorts:_}),t.set(g.IExtHostRpcService,new g.ExtHostRpcService(this._rpcProtocol)),t.set(I.IURITransformerService,new I.URITransformerService(c)),t.set(p.IHostUtils,S);const u=new b.InstantiationService(t,!0);this._logService=u.invokeFunction(h=>h.get(A.ILogService)),C.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",m),this._extensionService=u.invokeFunction(h=>h.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const i=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(o,f)=>{let v="",T,M;for(const j of f)v+=`
	at ${j.toString()}`,M=j.getFileName(),!T&&M&&(T=h.findSubstr(w.URI.file(M)));return i.set(o,T),`${o.name||"Error"}: ${o.message||""}${v}`}});const n=this._rpcProtocol.getProxy(F.MainContext.MainThreadExtensionService),s=this._rpcProtocol.getProxy(F.MainContext.MainThreadErrors);r.setUnexpectedErrorHandler(h=>{const o=r.transformErrorForSerialization(h),f=i.get(h);f?n.$onExtensionRuntimeError(f.identifier,o):s.$onUnexpectedError(o)})}async asBrowserUri(d){const m=this._rpcProtocol.getProxy(F.MainContext.MainThreadExtensionService);return w.URI.revive(await m.$asBrowserUri(d))}terminate(d){this._extensionService.terminate(d)}static _transform(d,m){d.allExtensions.forEach(c=>{c.extensionLocation=w.URI.revive(m.transformIncomingURIs(c.extensionLocation));const _={};c.browserNlsBundleUris&&(Object.keys(c.browserNlsBundleUris).forEach(t=>_[t]=w.URI.revive(m.transformIncomingURIs(c.browserNlsBundleUris[t]))),c.browserNlsBundleUris=_)}),d.environment.appRoot=w.URI.revive(m.transformIncomingURIs(d.environment.appRoot));const S=d.environment.extensionDevelopmentLocationURI;return S&&(d.environment.extensionDevelopmentLocationURI=S.map(c=>w.URI.revive(m.transformIncomingURIs(c)))),d.environment.extensionTestsLocationURI=w.URI.revive(m.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=w.URI.revive(m.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=w.URI.revive(m.transformIncomingURIs(d.environment.workspaceStorageHome)),d.nlsBaseUrl=w.URI.revive(m.transformIncomingURIs(d.nlsBaseUrl)),d.logsLocation=w.URI.revive(m.transformIncomingURIs(d.logsLocation)),d.logFile=w.URI.revive(m.transformIncomingURIs(d.logFile)),d.workspace=m.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=a}),define(Ce[237],Ie([1,0,18,15,21,44,13,19,22,2,43]),function(ne,e,r,C,w,F,y,A,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(m,S,c,_){this.query=m,this.provider=S,this.fileUtils=c,this.processType=_,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(m,S){const c=this.query.folderQueries||[],_=new w.CancellationTokenSource;return S.onCancellationRequested(()=>_.cancel()),new Promise((t,u)=>{this.collector=new I(m);let i=!1;const n=(s,h)=>{if(!i&&!this.isLimitHit){const o=this.resultSize(s);a(s)&&typeof this.query.maxResults=="number"&&this.resultCount+o>this.query.maxResults&&(this.isLimitHit=!0,i=!0,_.cancel(),s=this.trimResultToSize(s,this.query.maxResults-this.resultCount));const f=this.resultSize(s);this.resultCount+=f,(f>0||!a(s))&&this.collector.add(s,h)}};Promise.all(c.map((s,h)=>this.searchInFolder(s,o=>n(o,h),_.token))).then(s=>{_.dispose(),this.collector.flush();const h=s.some(o=>!!o&&!!o.limitHit);t({limitHit:this.isLimitHit||h,messages:(0,r.flatten)(s.map(o=>o?.message?Array.isArray(o.message)?o.message:[o.message]:[])),stats:{type:this.processType}})},s=>{_.dispose();const h=(0,F.toErrorMessage)(s);u(new Error(h))})})}resultSize(m){return a(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}trimResultToSize(m,S){const c=Array.isArray(m.ranges)?m.ranges:[m.ranges],_=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:c.slice(0,S),preview:{matches:_.slice(0,S),text:m.preview.text},uri:m.uri}}async searchInFolder(m,S,c){const _=new R.QueryGlobTester(this.query,m),t=[],u={report:s=>{if(!this.validateProviderResult(s))return;const h=m.folder.scheme===y.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(s.uri))):void 0,o=E.relativePath(m.folder,s.uri);if(o){const f=_.includedInQuery(o,A.basename(o),h);(0,C.isThenable)(f)?t.push(f.then(v=>{v&&S(s)})):f&&S(s)}}},i=this.getSearchOptionsForFolder(m),n=await this.provider.provideTextSearchResults(g(this.query.contentPattern),i,u,c);return t.length&&await Promise.all(t),n}validateProviderResult(m){if(a(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(m){const S=(0,R.resolvePatternsForProvider)(this.query.includePattern,m.includePattern),c=(0,R.resolvePatternsForProvider)(this.query.excludePattern,m.excludePattern),_={folder:P.URI.from(m.folder),excludes:c,includes:S,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.fileUtils.toCanonicalName(m.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return _.usePCRE2=this.query.usePCRE2,_}}e.TextSearchManager=b;function g(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class I{constructor(m){this._onResult=m,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new l(512,S=>this.sendItems(S))}add(m,S){this._currentFileMatch&&(this._currentFolderIdx!==S||!E.isEqual(this._currentUri,m.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=S,this._currentFileMatch={resource:m.uri,results:[]}),this._currentFileMatch.results.push(p(m))}pushToCollector(){const m=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,m)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(m){this._onResult(m)}}e.TextSearchResultsCollector=I;function p(d){return a(d)?{preview:{matches:(0,r.mapArrayOrNot)(d.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:d.preview.text},ranges:(0,r.mapArrayOrNot)(d.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function a(d){return!!d.preview}e.extensionResultIsMatch=a;class l{constructor(m,S){this.maxBatchSize=m,this.cb=S,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(m,S){!m||this.addItemToBatch(m,S)}addItems(m,S){!m||this.addItemsToBatch(m,S)}addItemToBatch(m,S){this.batch.push(m),this.batchSize+=S,this.onUpdate()}addItemsToBatch(m,S){this.batch=this.batch.concat(m),this.batchSize+=S,this.onUpdate()}onUpdate(){this.totalNumberCompleted<l.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},l.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=l,l.TIMEOUT=4e3,l.START_BATCH_AFTER_COUNT=50}),define(Ce[104],Ie([1,0,7,5,3,232,14,49,11,2,237]),function(ne,e,r,C,w,F,y,A,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let b=class{constructor(a,l,d){this.extHostRpc=a,this._uriTransformer=l,this._logService=d,this._proxy=this.extHostRpc.getProxy(C.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new F.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,l){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const d=this._handlePool++;return this._textSearchProvider.set(d,l),this._proxy.$registerTextSearchProvider(d,this._transformScheme(a)),(0,r.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}registerFileSearchProvider(a,l){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const d=this._handlePool++;return this._fileSearchProvider.set(d,l),this._proxy.$registerFileSearchProvider(d,this._transformScheme(a)),(0,r.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(a,l,d,m){const S=g(d),c=this._fileSearchProvider.get(a);if(c)return this._fileSearchManager.fileSearch(S,c,_=>{this._proxy.$handleFileMatch(a,l,_.map(t=>t.resource))},m);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,l,d,m){const S=this._textSearchProvider.get(a);if(!S||!S.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const c=g(d);return this.createTextSearchManager(c,S).search(t=>this._proxy.$handleTextMatch(a,l,t),m)}$enableExtensionHostSearch(){}createTextSearchManager(a,l){return new R.TextSearchManager(a,l,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}};b=$e([xe(0,y.IExtHostRpcService),xe(1,A.IURITransformerService),xe(2,E.ILogService)],b),e.ExtHostSearch=b;function g(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(I),extraFileResources:p.extraFileResources&&p.extraFileResources.map(a=>P.URI.revive(a))}}e.reviveQuery=g;function I(p){return{...p,folder:P.URI.revive(p.folder)}}}),define(Ce[238],Ie([1,0,58,99,31,97,32,37,52,55,101,103,104,72,63,69,98,54,36,71,92,53,209,11,179,102,70]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a,l,d,m,S,c,_,t,u,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(s.IExtHostLocalizationService,s.ExtHostLocalizationService,1),(0,r.registerSingleton)(u.ILoggerService,t.ExtHostLoggerService,1),(0,r.registerSingleton)(u.ILogService,i.ExtHostLogService,1),(0,r.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService,!1),(0,r.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,!1),(0,r.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration,!1),(0,r.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,!1),(0,r.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService,!1),(0,r.registerSingleton)(F.IExtHostDecorations,F.ExtHostDecorations,!1),(0,r.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors,!1),(0,r.registerSingleton)(m.IExtHostFileSystemInfo,m.ExtHostFileSystemInfo,!1),(0,r.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService,1),(0,r.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch,!1),(0,r.registerSingleton)(I.IExtHostStorage,I.ExtHostStorage,!1),(0,r.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,!1),(0,r.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService,!1),(0,r.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService,!1),(0,r.registerSingleton)(l.IExtHostWindow,l.ExtHostWindow,!1),(0,r.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace,!1),(0,r.registerSingleton)(S.IExtHostSecretState,S.ExtHostSecretState,!1),(0,r.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry,!1),(0,r.registerSingleton)(_.IExtHostEditorTabs,_.ExtHostEditorTabs,!1),(0,r.registerSingleton)(n.IExtHostVariableResolverProvider,n.ExtHostVariableResolverProviderService,!1)}),define(Ce[239],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class r{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(w){if(w&&this._dragOperations.has(w)){const F=this._dragOperations.get(w);return this._dragOperations.delete(w),F}}addDragOperationTransfer(w,F){this._dragOperations.set(w,F)}getRenderedTreeElement(w){if(this._renderedElements.has(w))return this._renderedElements.get(w)}addRenderedTreeItemElement(w,F){this._renderedElements.set(w,F)}removeRenderedTreeItemElement(w){this._renderedElements.has(w)&&this._renderedElements.delete(w)}}e.TreeviewsService=r}),define(Ce[240],Ie([1,0,135,6,22,2,4,7,15,6,10,18,8,21,239,28]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(S,c){if((0,R.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let _;return Array.isArray(S.highlights)&&(_=S.highlights.filter(t=>t.length===2&&typeof t[0]=="number"&&typeof t[1]=="number"),_=_.length?_:void 0),{label:S.label,highlights:_}}}class d{constructor(c,_,t){this._proxy=c,this.commands=_,this.logService=t,this.treeViews=new Map,this.treeDragAndDropService=new p.TreeviewsService;function u(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}_.registerArgumentProcessor({processArgument:i=>u(i)?this.convertArgument(i):Array.isArray(i)&&i.length>0?i.map(n=>u(n)?this.convertArgument(n):n):i})}registerTreeDataProvider(c,_,t){const u=this.createTreeView(c,{treeDataProvider:_},t);return{dispose:()=>u.dispose()}}createTreeView(c,_,t){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=_.dragAndDropController?.dropMimeTypes??[],i=_.dragAndDropController?.dragMimeTypes??[],n=!!_.dragAndDropController?.handleDrag,s=!!_.dragAndDropController?.handleDrop,h=this.createExtHostTreeView(c,_,t),o=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany,dropMimeTypes:u,dragMimeTypes:i,hasHandleDrag:n,hasHandleDrop:s});return{get onDidCollapseElement(){return h.onDidCollapseElement},get onDidExpandElement(){return h.onDidExpandElement},get selection(){return h.selectedElements},get onDidChangeSelection(){return h.onDidChangeSelection},get visible(){return h.visible},get onDidChangeVisibility(){return h.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,a.checkProposedApiEnabled)(t,"treeItemCheckbox"),h.onDidChangeCheckboxState},get message(){return h.message},set message(f){h.message=f},get title(){return h.title},set title(f){h.title=f},get description(){return h.description},set description(f){h.description=f},get badge(){return h.badge},set badge(f){f!==void 0&&P.ViewBadge.isViewBadge(f)?h.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(h.badge=void 0)},reveal:(f,v)=>h.reveal(f,v),dispose:async()=>{await o,this.treeViews.delete(c),h.dispose()}}}$getChildren(c,_){const t=this.treeViews.get(c);return t?t.getChildren(_):Promise.reject(new Error((0,r.localize)(0,null,c)))}async $handleDrop(c,_,t,u,i,n,s,h){const o=this.treeViews.get(c);if(!o)return Promise.reject(new Error((0,r.localize)(1,null,c)));const f=g.DataTransfer.toDataTransfer(t,async v=>(await this._proxy.$resolveDropFileData(c,_,v)).buffer);return s===c&&h&&await this.addAdditionalTransferItems(f,o,h,i,n),o.onDrop(f,u,i)}async addAdditionalTransferItems(c,_,t,u,i){const n=this.treeDragAndDropService.removeDragOperationTransfer(i);if(n)(await n)?.forEach((s,h)=>{s&&c.set(h,s)});else if(i&&_.handleDrag){const s=_.handleDrag(t,c,u);this.treeDragAndDropService.addDragOperationTransfer(i,s),await s}return c}async $handleDrag(c,_,t,u){const i=this.treeViews.get(c);if(!i)return Promise.reject(new Error((0,r.localize)(2,null,c)));const n=await this.addAdditionalTransferItems(new C.DataTransfer,i,_,u,t);if(!!n)return g.DataTransfer.toDataTransferDTO(n)}async $hasResolve(c){const _=this.treeViews.get(c);if(!_)throw new Error((0,r.localize)(3,null,c));return _.hasResolve}$resolve(c,_,t){const u=this.treeViews.get(c);if(!u)throw new Error((0,r.localize)(4,null,c));return u.resolveTreeItem(_,t)}$setExpanded(c,_,t){const u=this.treeViews.get(c);if(!u)throw new Error((0,r.localize)(5,null,c));u.setExpanded(_,t)}$setSelection(c,_){const t=this.treeViews.get(c);if(!t)throw new Error((0,r.localize)(6,null,c));t.setSelection(_)}$setFocus(c,_){const t=this.treeViews.get(c);if(!t)throw new Error((0,r.localize)(7,null,c));t.setFocus(_)}$setVisible(c,_){const t=this.treeViews.get(c);if(!t)throw new Error((0,r.localize)(8,null,c));t.setVisible(_)}$changeCheckboxState(c,_){const t=this.treeViews.get(c);if(!t)throw new Error((0,r.localize)(9,null,c));t.setCheckboxState(_)}createExtHostTreeView(c,_,t){const u=new m(c,_,this._proxy,this.commands.converter,this.logService,t);return this.treeViews.set(c,u),u}convertArgument(c){const _=this.treeViews.get(c.$treeViewId);return _&&"$treeItemHandle"in c?_.getExtensionElement(c.$treeItemHandle):_&&"$focusedTreeItem"in c&&c.$focusedTreeItem?_.focusedElement:null}}e.ExtHostTreeViews=d;class m extends A.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,R.isUndefinedOrNull)(c))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(c,_,t,u,i,n){if(super(),this.viewId=c,this.proxy=t,this.commands=u,this.logService=i,this.extension=n,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new y.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new I.CancellationTokenSource,n.contributes&&n.contributes.views)for(const o in n.contributes.views)for(const f of n.contributes.views[o])f.id===c&&(this._title=f.name);this.dataProvider=_.treeDataProvider,this.dndController=_.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let s,h;this._register(y.Event.debounce(this._onDidChangeData.event,(o,f)=>(o||(o={message:!1,elements:[]}),f.element!==!1&&(s||(s=new Promise(v=>h=v),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(f.element)?o.elements.push(...f.element):o.elements.push(f.element)),f.message&&(o.message=!0),o),200,!0)(({message:o,elements:f})=>{f.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=h;return s=null,this.refresh(f).then(()=>v())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(c){const _=c?this.getExtensionElement(c):void 0;if(c&&!_)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let t=this.getChildrenNodes(c);return t||(t=await this.fetchChildrenNodes(_)),t?t.map(u=>u.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,_){_=_||{select:!0,focus:!1};const t=(0,R.isUndefinedOrNull)(_.select)?!0:_.select,u=(0,R.isUndefinedOrNull)(_.focus)?!1:_.focus,i=(0,R.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(n=>this.resolveTreeNode(c,n[n.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:n.map(h=>h.item)},{select:t,focus:u,expand:i})),n=>this.logService.error(n)):this.proxy.$reveal(this.viewId,void 0,{select:t,focus:u,expand:i})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}get badge(){return this._badge}set badge(c){this._badge?.value===c?.value&&this._badge?.tooltip===c?.tooltip||(this._badge=g.ViewBadge.from(c),this.proxy.$setBadge(this.viewId,c))}setExpanded(c,_){const t=this.getExtensionElement(c);t&&(_?this._onDidExpandElement.fire(Object.freeze({element:t})):this._onDidCollapseElement.fire(Object.freeze({element:t})))}setSelection(c){(0,b.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(c){this._focusedHandle=c}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(c){const _=(await Promise.all(c.map(async t=>{const u=this.getExtensionElement(t.treeItemHandle);return u?{extensionItem:u,treeItem:await this.dataProvider.getTreeItem(u),newState:t.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(t=>t!==void 0);_.forEach(t=>{t.treeItem.checkboxState=t.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:_.map(t=>[t.extensionItem,t.newState])})}async handleDrag(c,_,t){const u=[];for(const i of c){const n=this.getExtensionElement(i);n&&u.push(n)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,_,t),_}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(c,_,t){const u=_?this.getExtensionElement(_):void 0;if(!(!u&&_||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(u,c,t):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,_){if(!this.dataProvider.resolveTreeItem)return;const t=this.elements.get(c);if(t){const u=this.nodes.get(t);if(u){const i=await this.dataProvider.resolveTreeItem(u.extensionItem,t,_)??u.extensionItem;return this.validateTreeItem(i),u.item.tooltip=this.getTooltip(i.tooltip),u.item.command=this.getCommand(u.disposableStore,i.command),u.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(_=>_?this.resolveUnknownParentChain(_).then(t=>this.resolveTreeNode(_,t[t.length-1]).then(u=>(t.push(u),t))):Promise.resolve([]))}resolveParent(c){const _=this.nodes.get(c);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,_){const t=this.nodes.get(c);return t?Promise.resolve(t):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(u=>this.createHandle(c,u,_,!0)).then(u=>this.getChildren(_?_.item.handle:void 0).then(()=>{const i=this.getExtensionElement(u);if(i){const n=this.nodes.get(i);if(n)return Promise.resolve(n)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(c){if(c){let _;if(typeof c=="string"){const t=this.getExtensionElement(c);_=t?this.nodes.get(t):void 0}else _=c;return _&&_.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const _=new I.CancellationTokenSource(this._refreshCancellationSource.token);try{const t=c?this.nodes.get(c):void 0,u=await this.dataProvider.getChildren(c);if(_.token.isCancellationRequested)return;const i=await Promise.all((0,b.coalesce)(u||[]).map(async n=>{const s=await this.dataProvider.getTreeItem(n);return s&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(n,s,t):null}));return _.token.isCancellationRequested?void 0:(0,b.coalesce)(i)}finally{_.dispose()}}refresh(c){if(c.some(t=>!t))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new I.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const t=this.getHandlesToRefresh(c);if(t.length)return this.refreshHandles(t)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const _=new Set,t=c.map(i=>this.nodes.get(i));for(const i of t)if(i&&!_.has(i.item.handle)){let n=i;for(;n&&n.parent&&t.findIndex(s=>n&&n.parent&&s&&s.item.handle===n.parent.item.handle)===-1;){const s=this.elements.get(n.parent.item.handle);n=s?this.nodes.get(s):void 0}n&&!n.parent&&_.add(i.item.handle)}const u=[];return _.forEach(i=>{const n=this.elements.get(i);if(n){const s=this.nodes.get(n);s&&(!s.parent||!_.has(s.parent.item.handle))&&u.push(i)}}),u}refreshHandles(c){const _={};return Promise.all(c.map(t=>this.refreshNode(t).then(u=>{u&&(_[t]=u.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(c){const _=this.getExtensionElement(c);if(_){const t=this.nodes.get(_);if(t)return this.clearChildren(_),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(u=>{if(u){const i=this.createTreeNode(_,u,t.parent);return this.updateNodeCache(_,i,t,t.parent),t.dispose(),i}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,_,t){const u=this.createTreeNode(c,_,t);if(_.id&&this.elements.has(u.item.handle))throw new Error((0,r.localize)(10,null,_.id));return this.addNodeToCache(c,u),this.addNodeToParentCache(u,t),u}getTooltip(c){return P.MarkdownString.isMarkdownString(c)?g.MarkdownString.from(c):c}getCommand(c,_){return _?{...this.commands.toInternal(_,c),originalId:_.command}:void 0}getCheckbox(c){if(!c.checkboxState)return;let _,t;return typeof c.checkboxState=="number"?_=c.checkboxState:(_=c.checkboxState.state,t=c.checkboxState.tooltip),{isChecked:_===P.TreeItemCheckboxState.Checked,tooltip:t}}validateTreeItem(c){if(!P.TreeItem.isTreeItem(c,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(c,_,t){this.validateTreeItem(_);const u=new A.DisposableStore,i=this.createHandle(c,_,t),n=this.getLightIconPath(_);return{item:{handle:i,parentHandle:t?t.item.handle:void 0,label:l(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(u,_.command),contextValue:_.contextValue,icon:n,iconDark:this.getDarkIconPath(_)||n,themeIcon:this.getThemeIcon(_),collapsibleState:(0,R.isUndefinedOrNull)(_.collapsibleState)?P.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation,checkbox:this.getCheckbox(_)},extensionItem:_,parent:t,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(c){return c.iconPath instanceof P.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:_,label:t,resourceUri:u},i,n){if(_)return`${m.ID_HANDLE_PREFIX}/${_}`;const s=l(t,this.extension),h=i?i.item.handle:m.LABEL_HANDLE_PREFIX;let o=s?s.label:u?(0,w.basename)(u):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const f=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,v=this.getChildrenNodes(i)||[];let T,M=0;do{if(T=`${h}/${M}:${o}`,n||!this.elements.has(T)||f===T)break;M++}while(M<=v.length);return T}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof P.ThemeIcon))return typeof c.iconPath=="string"||F.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof P.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return F.URI.isUri(c)?c:F.URI.file(c)}addNodeToCache(c,_){this.elements.set(_.item.handle,c),this.nodes.set(c,_)}updateNodeCache(c,_,t,u){this.elements.delete(_.item.handle),this.nodes.delete(c),_.item.handle!==t.item.handle&&this.elements.delete(t.item.handle),this.addNodeToCache(c,_);const i=this.getChildrenNodes(u)||[],n=i.filter(s=>s.item.handle===t.item.handle)[0];n&&i.splice(i.indexOf(n),1,_)}addNodeToParentCache(c,_){_?(_.children||(_.children=[]),_.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const _=this.nodes.get(c);if(_){if(_.children)for(const t of _.children){const u=this.elements.get(t.item.handle);u&&this.clear(u)}_.children=void 0}}else this.clearAll()}clear(c){const _=this.nodes.get(c);if(_){if(_.children)for(const t of _.children){const u=this.elements.get(t.item.handle);u&&this.clear(u)}this.nodes.delete(c),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}m.LABEL_HANDLE_PREFIX="0",m.ID_HANDLE_PREFIX="1"}),define(Ce[241],Ie([1,0,21,12,4,29,2,122,250,110,120,35,5,67,194,193,37,195,32,197,198,199,182,200,52,33,202,203,206,208,210,99,185,214,215,216,72,55,219,240,8,6,222,56,98,31,166,205,60,97,101,103,104,11,49,14,26,211,180,63,69,191,220,73,54,225,223,224,192,36,217,221,71,53,92,212,100,213,13,85,184,163,204,7,28,168,70]),function(ne,e,r,C,w,F,y,A,E,P,R,b,g,I,p,a,l,d,m,S,c,_,t,u,i,n,s,h,o,f,v,T,M,j,U,D,$,L,O,H,W,z,G,te,he,re,be,le,fe,Q,pe,Se,Fe,Be,Xe,ke,ye,De,ae,ue,ee,Z,k,B,V,q,oe,ce,J,Ee,ve,Ne,ze,Je,Ge,Pe,nt,X,Y,me,Ue,Ve,et,Ke,je,it,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ct(at){const rt=at.get(ye.IExtHostInitDataService),_t=at.get(Ee.IExtHostFileSystemInfo),Rt=at.get(V.IExtHostConsumerFileSystem),Ot=at.get(n.IExtHostExtensionService),ft=at.get(re.IExtHostWorkspace),Dt=at.get(Ge.IExtHostTelemetry),Mt=at.get(m.IExtHostConfiguration),Lt=at.get(Xe.IURITransformerService),qe=at.get(ke.IExtHostRpcService),zt=at.get($.IExtHostStorage),Ft=at.get(B.IExtensionStoragePaths),Tt=at.get(Be.ILoggerService),mt=at.get(Be.ILogService),Ct=at.get(ue.IExtHostTunnelService),_e=at.get(ee.IExtHostApiDeprecationService),Te=at.get(he.IExtHostWindow),ge=at.get(ze.IExtHostSecretState),K=at.get(Je.IExtHostEditorTabs);qe.set(g.ExtHostContext.ExtHostFileSystemInfo,_t),qe.set(g.ExtHostContext.ExtHostLogLevelServiceShape,Tt),qe.set(g.ExtHostContext.ExtHostWorkspace,ft),qe.set(g.ExtHostContext.ExtHostConfiguration,Mt),qe.set(g.ExtHostContext.ExtHostExtensionService,Ot),qe.set(g.ExtHostContext.ExtHostStorage,zt),qe.set(g.ExtHostContext.ExtHostTunnelService,Ct),qe.set(g.ExtHostContext.ExtHostWindow,Te),qe.set(g.ExtHostContext.ExtHostSecretState,ge),qe.set(g.ExtHostContext.ExtHostTelemetry,Dt),qe.set(g.ExtHostContext.ExtHostEditorTabs,K);const Ae=qe.set(g.ExtHostContext.ExtHostDecorations,at.get(Q.IExtHostDecorations)),Le=qe.set(g.ExtHostContext.ExtHostDocumentsAndEditors,at.get(i.IExtHostDocumentsAndEditors)),Ze=qe.set(g.ExtHostContext.ExtHostCommands,at.get(l.IExtHostCommands)),We=qe.set(g.ExtHostContext.ExtHostTerminalService,at.get(L.IExtHostTerminalService)),tt=qe.set(g.ExtHostContext.ExtHostDebugService,at.get(Se.IExtHostDebugService)),gt=qe.set(g.ExtHostContext.ExtHostSearch,at.get(Fe.IExtHostSearch)),vt=qe.set(g.ExtHostContext.ExtHostTask,at.get(pe.IExtHostTask)),It=qe.set(g.ExtHostContext.ExtHostOutputService,at.get(T.IExtHostOutputService)),yt=qe.set(g.ExtHostContext.ExtHostLocalization,at.get(st.IExtHostLocalizationService)),Et=qe.set(g.ExtHostContext.ExtHostUrls,new G.ExtHostUrls(qe)),pt=qe.set(g.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(qe,Le)),wt=qe.set(g.ExtHostContext.ExtHostDocumentContentProviders,new _.ExtHostDocumentContentProvider(qe,Le,mt)),ei=qe.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(mt,pt,qe.getProxy(g.MainContext.MainThreadBulkEdits))),bt=qe.set(g.ExtHostContext.ExtHostNotebook,new De.ExtHostNotebookController(qe,Ze,Le,pt)),qt=qe.set(g.ExtHostContext.ExtHostNotebookDocuments,new Ve.ExtHostNotebookDocuments(bt)),xt=qe.set(g.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(mt,bt)),ti=qe.set(g.ExtHostContext.ExtHostNotebookKernels,new Pe.ExtHostNotebookKernels(qe,rt,bt,Ze,mt)),ci=qe.set(g.ExtHostContext.ExtHostNotebookRenderers,new X.ExtHostNotebookRenderers(qe,bt)),kt=qe.set(g.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(qe,Le)),ii=qe.set(g.ExtHostContext.ExtHostTreeViews,new H.ExtHostTreeViews(qe.getProxy(g.MainContext.MainThreadTreeViews),Ze,mt)),ui=qe.set(g.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets(qe.getProxy(g.MainContext.MainThreadEditorInsets),kt,rt.remote)),Ut=qe.set(g.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(qe,mt,_t)),Jt=qe.set(g.ExtHostContext.ExtHostLanguages,new f.ExtHostLanguages(qe,pt,Ze.converter,Lt)),ut=qe.set(g.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(qe,Lt,pt,Ze,Ut,mt,_e)),di=qe.set(g.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(qe,ut)),Nt=qe.set(g.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(qe,mt,Le)),Kt=qe.set(g.ExtHostContext.ExtHostQuickOpen,(0,j.createExtHostQuickOpen)(qe,ft,Ze)),ni=qe.set(g.ExtHostContext.ExtHostSCM,new U.ExtHostSCM(qe,Ze,mt)),hi=qe.set(g.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(qe,Ze,pt)),ri=qe.set(g.ExtHostContext.ExtHostProgress,new M.ExtHostProgress(qe.getProxy(g.MainContext.MainThreadProgress))),fi=qe.set(g.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(qe)),si=qe.set(g.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(qe)),Zt=qe.set(g.ExtHostContext.ExtHostAuthentication,new Z.ExtHostAuthentication(qe)),mi=qe.set(g.ExtHostContext.ExtHostTimeline,new k.ExtHostTimeline(qe,Ze)),gi=qe.set(g.ExtHostContext.ExtHostWebviews,new te.ExtHostWebviews(qe,rt.remote,ft,mt,_e)),pi=qe.set(g.ExtHostContext.ExtHostWebviewPanels,new ce.ExtHostWebviewPanels(qe,gi,ft)),vi=qe.set(g.ExtHostContext.ExtHostCustomEditors,new oe.ExtHostCustomEditors(qe,pt,Ft,gi,pi)),Ei=qe.set(g.ExtHostContext.ExtHostWebviewViews,new q.ExtHostWebviewViews(qe,gi)),Gt=qe.set(g.ExtHostContext.ExtHostTesting,new ve.ExtHostTesting(qe,Ze,Le)),bi=qe.set(g.ExtHostContext.ExtHostUriOpeners,new Ne.ExtHostUriOpeners(qe));qe.set(g.ExtHostContext.ExtHostInteractive,new et.ExtHostInteractive(qe,bt,Le,Ze,mt));const Ni=Object.values(g.ExtHostContext);qe.assertRegistered(Ni);const wi=new J.ExtHostBulkEdits(qe,Le),Si=new a.ExtHostClipboard(qe),_i=new v.ExtHostMessageService(qe,mt),Ti=new c.ExtHostDialogs(qe),ki=new D.ExtHostStatusBar(qe,Ze.converter);return p.ExtHostApiCommands.register(Ze),function(Me,Ht,Pi){const ht=function(){let se=!Me.isUnderDevelopment;function de(){se||(mt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Re(ot){if(Array.isArray(ot))ot.forEach(Re);else if(typeof ot=="string")de();else{const St=ot;typeof St.scheme>"u"&&de(),typeof St.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return ot}}(),yi={getSession(se,de,Re){return Zt.getSession(Me,se,de,Re)},async hasSession(se,de){return(0,je.checkProposedApiEnabled)(Me,"authSession"),!!await Zt.getSession(Me,se,de,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(se,de,Re,ot){return Zt.registerAuthenticationProvider(se,de,Re,ot)}},Mi={registerCommand(se,de,Re){return Ze.registerCommand(!0,se,de,Re,void 0,Me)},registerTextEditorCommand(se,de,Re){return Ze.registerCommand(!0,se,(...ot)=>{const St=kt.getActiveTextEditor();if(!St){mt.warn("Cannot execute "+se+" because there is no active text editor.");return}return St.edit(Pt=>{de.apply(Re,[St,Pt,...ot])}).then(Pt=>{Pt||mt.warn("Edits from command "+se+" were not applied.")},Pt=>{mt.warn("An error occurred while running command "+se,Pt)})},void 0,void 0,Me)},registerDiffInformationCommand:(se,de,Re)=>((0,je.checkProposedApiEnabled)(Me,"diffCommand"),Ze.registerCommand(!0,se,async(...ot)=>{const St=Le.activeEditor(!0);if(!St){mt.warn("Cannot execute "+se+" because there is no active text editor.");return}const Pt=await kt.getDiffInformation(St.id);de.apply(Re,[Pt,...ot])},void 0,void 0,Me)),executeCommand(se,...de){return Ze.executeCommand(se,...de)},getCommands(se=!1){return Ze.getCommands(se)}},Ai={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return Si.value},get shell(){return We.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)(Me,"envShellEvent"),We.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Me,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Me,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ge.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(se){return(0,je.checkProposedApiEnabled)(Me,"telemetry"),Dt.instantiateLogger(Me,se)},openExternal(se,de){return Te.openUri(se,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===rt.environment.appUriScheme)return Et.createAppUri(se);try{return await Te.asExternalUri(se,{allowTunneling:!!rt.remote.authority})}catch(de){if((0,me.matchesScheme)(se,Y.Schemas.http)||(0,me.matchesScheme)(se,Y.Schemas.https))return se;throw de}},get remoteName(){return(0,fe.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Me,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind}};rt.environment.extensionTestsLocationURI||Object.freeze(Ai);const Li={createTestController(se,de,Re){return Gt.createTestController(se,de,Re)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Me,"testObserver"),Gt.createTestObserver()},runTests(se){return(0,je.checkProposedApiEnabled)(Me,"testObserver"),Gt.runTests(se)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Me,"testObserver"),Gt.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Me,"testObserver"),Gt.results}},Xt=rt.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,Ui={getExtension(se,de){(0,je.isProposedApiEnabled)(Me,"extensionsAny")||(de=!1);const Re=Ht.mine.getExtensionDescription(se);if(Re)return new n.Extension(Ot,Me.identifier,Re,Xt,!1);if(de){const ot=Ht.all.getExtensionDescription(se);if(ot)return new n.Extension(Ot,Me.identifier,ot,Xt,!0)}},get all(){const se=[];for(const de of Ht.mine.getAllExtensionDescriptions())se.push(new n.Extension(Ot,Me.identifier,de,Xt,!1));return se},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)(Me,"extensionsAny");const se=new je.ExtensionIdentifierSet(Ht.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),de=[];for(const Re of Ht.all.getAllExtensionDescriptions()){const ot=!se.has(Re.identifier);de.push(new n.Extension(Ot,Me.identifier,Re,Xt,ot))}return de},get onDidChange(){return(0,je.isProposedApiEnabled)(Me,"extensionsAny")?w.Event.any(Ht.mine.onDidChange,Ht.all.onDidChange):Ht.mine.onDidChange}},Bi={createDiagnosticCollection(se){return Ut.createDiagnosticCollection(Me.identifier,se)},get onDidChangeDiagnostics(){return Ut.onDidChangeDiagnostics},getDiagnostics:se=>Ut.getDiagnostics(se),getLanguages(){return Jt.getLanguages()},setTextDocumentLanguage(se,de){return Jt.changeLanguage(se.uri,de)},match(se,de){const Re=pt.getDocumentData(de.uri)?.notebook;return(0,R.score)(W.LanguageSelector.from(se),de.uri,de.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(se,de,Re){return ut.registerCodeActionProvider(Me,ht(se),de,Re)},registerDocumentPasteEditProvider(se,de,Re){return(0,je.checkProposedApiEnabled)(Me,"documentPaste"),ut.registerDocumentPasteEditProvider(Me,ht(se),de,Re)},registerCodeLensProvider(se,de){return ut.registerCodeLensProvider(Me,ht(se),de)},registerDefinitionProvider(se,de){return ut.registerDefinitionProvider(Me,ht(se),de)},registerDeclarationProvider(se,de){return ut.registerDeclarationProvider(Me,ht(se),de)},registerImplementationProvider(se,de){return ut.registerImplementationProvider(Me,ht(se),de)},registerTypeDefinitionProvider(se,de){return ut.registerTypeDefinitionProvider(Me,ht(se),de)},registerHoverProvider(se,de){return ut.registerHoverProvider(Me,ht(se),de,Me.identifier)},registerEvaluatableExpressionProvider(se,de){return ut.registerEvaluatableExpressionProvider(Me,ht(se),de,Me.identifier)},registerInlineValuesProvider(se,de){return ut.registerInlineValuesProvider(Me,ht(se),de,Me.identifier)},registerDocumentHighlightProvider(se,de){return ut.registerDocumentHighlightProvider(Me,ht(se),de)},registerLinkedEditingRangeProvider(se,de){return ut.registerLinkedEditingRangeProvider(Me,ht(se),de)},registerReferenceProvider(se,de){return ut.registerReferenceProvider(Me,ht(se),de)},registerRenameProvider(se,de){return ut.registerRenameProvider(Me,ht(se),de)},registerDocumentSymbolProvider(se,de,Re){return ut.registerDocumentSymbolProvider(Me,ht(se),de,Re)},registerWorkspaceSymbolProvider(se){return ut.registerWorkspaceSymbolProvider(Me,se)},registerDocumentFormattingEditProvider(se,de){return ut.registerDocumentFormattingEditProvider(Me,ht(se),de)},registerDocumentRangeFormattingEditProvider(se,de){return ut.registerDocumentRangeFormattingEditProvider(Me,ht(se),de)},registerOnTypeFormattingEditProvider(se,de,Re,...ot){return ut.registerOnTypeFormattingEditProvider(Me,ht(se),de,[Re].concat(ot))},registerDocumentSemanticTokensProvider(se,de,Re){return ut.registerDocumentSemanticTokensProvider(Me,ht(se),de,Re)},registerDocumentRangeSemanticTokensProvider(se,de,Re){return ut.registerDocumentRangeSemanticTokensProvider(Me,ht(se),de,Re)},registerSignatureHelpProvider(se,de,Re,...ot){return typeof Re=="object"?ut.registerSignatureHelpProvider(Me,ht(se),de,Re):ut.registerSignatureHelpProvider(Me,ht(se),de,typeof Re>"u"?[]:[Re,...ot])},registerCompletionItemProvider(se,de,...Re){return ut.registerCompletionItemProvider(Me,ht(se),de,Re)},registerInlineCompletionItemProvider(se,de){return de.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Me,ht(se),de)},registerInlineCompletionItemProviderNew(se,de){if((0,je.checkProposedApiEnabled)(Me,"inlineCompletionsNew"),de.handleDidShowCompletionItem&&!(0,je.isProposedApiEnabled)(Me,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return ut.registerInlineCompletionsProviderNew(Me,ht(se),de)},registerDocumentLinkProvider(se,de){return ut.registerDocumentLinkProvider(Me,ht(se),de)},registerColorProvider(se,de){return ut.registerColorProvider(Me,ht(se),de)},registerFoldingRangeProvider(se,de){return ut.registerFoldingRangeProvider(Me,ht(se),de)},registerSelectionRangeProvider(se,de){return ut.registerSelectionRangeProvider(Me,se,de)},registerCallHierarchyProvider(se,de){return ut.registerCallHierarchyProvider(Me,se,de)},registerTypeHierarchyProvider(se,de){return ut.registerTypeHierarchyProvider(Me,se,de)},setLanguageConfiguration:(se,de)=>ut.setLanguageConfiguration(Me,se,de),getTokenInformationAtPosition(se,de){return(0,je.checkProposedApiEnabled)(Me,"tokenInformation"),Jt.tokenAtPosition(se,de)},registerInlayHintsProvider(se,de){return ut.registerInlayHintsProvider(Me,se,de)},createLanguageStatusItem(se,de){return Jt.createLanguageStatusItem(Me,se,de)},registerDocumentDropEditProvider(se,de){return ut.registerDocumentOnDropEditProvider(Me,se,de)}},zi={get activeTextEditor(){return kt.getActiveTextEditor()},get visibleTextEditors(){return kt.getVisibleTextEditors()},get activeTerminal(){return We.activeTerminal},get terminals(){return We.terminals},async showTextDocument(se,de,Re){const ot=await(y.URI.isUri(se)?Promise.resolve(Ri.openTextDocument(se)):Promise.resolve(se));return kt.showTextDocument(ot,de,Re)},createTextEditorDecorationType(se){return kt.createTextEditorDecorationType(Me,se)},onDidChangeActiveTextEditor(se,de,Re){return kt.onDidChangeActiveTextEditor(se,de,Re)},onDidChangeVisibleTextEditors(se,de,Re){return kt.onDidChangeVisibleTextEditors(se,de,Re)},onDidChangeTextEditorSelection(se,de,Re){return kt.onDidChangeTextEditorSelection(se,de,Re)},onDidChangeTextEditorOptions(se,de,Re){return kt.onDidChangeTextEditorOptions(se,de,Re)},onDidChangeTextEditorVisibleRanges(se,de,Re){return kt.onDidChangeTextEditorVisibleRanges(se,de,Re)},onDidChangeTextEditorViewColumn(se,de,Re){return kt.onDidChangeTextEditorViewColumn(se,de,Re)},onDidCloseTerminal(se,de,Re){return We.onDidCloseTerminal(se,de,Re)},onDidOpenTerminal(se,de,Re){return We.onDidOpenTerminal(se,de,Re)},onDidChangeActiveTerminal(se,de,Re){return We.onDidChangeActiveTerminal(se,de,Re)},onDidChangeTerminalDimensions(se,de,Re){return(0,je.checkProposedApiEnabled)(Me,"terminalDimensions"),We.onDidChangeTerminalDimensions(se,de,Re)},onDidChangeTerminalState(se,de,Re){return We.onDidChangeTerminalState(se,de,Re)},onDidWriteTerminalData(se,de,Re){return(0,je.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),We.onDidWriteTerminalData(se,de,Re)},get state(){return Te.state},onDidChangeWindowState(se,de,Re){return Te.onDidChangeWindowState(se,de,Re)},showInformationMessage(se,...de){return _i.showMessage(Me,F.default.Info,se,de[0],de.slice(1))},showWarningMessage(se,...de){return _i.showMessage(Me,F.default.Warning,se,de[0],de.slice(1))},showErrorMessage(se,...de){return _i.showMessage(Me,F.default.Error,se,de[0],de.slice(1))},showQuickPick(se,de,Re){return Kt.showQuickPick(se,de,Re)},showWorkspaceFolderPick(se){return Kt.showWorkspaceFolderPick(se)},showInputBox(se,de){return Kt.showInput(se,de)},showOpenDialog(se){return Ti.showOpenDialog(se)},showSaveDialog(se){return Ti.showSaveDialog(se)},createStatusBarItem(se,de,Re){let ot,St,Pt;return typeof se=="string"?(ot=se,St=de,Pt=Re):(St=se,Pt=de),ki.createStatusBarEntry(Me,ot,St,Pt)},setStatusBarMessage(se,de){return ki.setStatusBarMessage(se,de)},withScmProgress(se){return _e.report("window.withScmProgress",Me,"Use 'withProgress' instead."),ri.withProgress(Me,{location:z.ProgressLocation.SourceControl},(de,Re)=>se({report(ot){}}))},withProgress(se,de){return ri.withProgress(Me,se,de)},createOutputChannel(se,de){return It.createOutputChannel(se,de,Me)},createWebviewPanel(se,de,Re,ot){return pi.createWebviewPanel(Me,se,de,Re,ot)},createWebviewTextEditorInset(se,de,Re,ot){return(0,je.checkProposedApiEnabled)(Me,"editorInsets"),ui.createWebviewEditorInset(se,de,Re,ot,Me)},createTerminal(se,de,Re){return typeof se=="object"?"pty"in se?We.createExtensionTerminal(se):We.createTerminalFromOptions(se):We.createTerminal(se,de,Re)},registerTerminalLinkProvider(se){return We.registerLinkProvider(se)},registerTerminalProfileProvider(se,de){return We.registerProfileProvider(Me,se,de)},registerTreeDataProvider(se,de){return ii.registerTreeDataProvider(se,de,Me)},createTreeView(se,de){return ii.createTreeView(se,de,Me)},registerWebviewPanelSerializer:(se,de)=>pi.registerWebviewPanelSerializer(Me,se,de),registerCustomEditorProvider:(se,de,Re={})=>vi.registerCustomEditorProvider(Me,se,de,Re),registerFileDecorationProvider(se){return Ae.registerFileDecorationProvider(se,Me.identifier)},registerUriHandler(se){return Et.registerUriHandler(Me.identifier,se)},createQuickPick(){return Kt.createQuickPick(Me)},createInputBox(){return Kt.createInputBox(Me)},get activeColorTheme(){return si.activeColorTheme},onDidChangeActiveColorTheme(se,de,Re){return si.onDidChangeActiveColorTheme(se,de,Re)},registerWebviewViewProvider(se,de,Re){return Ei.registerWebviewViewProvider(Me,se,de,Re?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,de,Re){return bt.onDidChangeActiveNotebookEditor(se,de,Re)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,de,Re){return xt.onDidChangeNotebookEditorSelection(se,de,Re)},onDidChangeNotebookEditorVisibleRanges(se,de,Re){return xt.onDidChangeNotebookEditorVisibleRanges(se,de,Re)},showNotebookDocument(se,de){return y.URI.isUri(se)&&_e.report("window.showNotebookDocument(uri)",Me,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),bt.showNotebookDocument(se,de)},registerExternalUriOpener(se,de,Re){return(0,je.checkProposedApiEnabled)(Me,"externalUriOpener"),bi.registerExternalUriOpener(Me.identifier,se,de,Re)},get tabGroups(){return K.tabGroups}},Ri={get rootPath(){return _e.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(se){throw C.readonly()},getWorkspaceFolder(se){return ft.getWorkspaceFolder(se)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(se){throw C.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(se){throw C.readonly()},updateWorkspaceFolders:(se,de,...Re)=>ft.updateWorkspaceFolders(Me,se,de||0,...Re),onDidChangeWorkspaceFolders:function(se,de,Re){return ft.onDidChangeWorkspace(se,de,Re)},asRelativePath:(se,de)=>ft.getRelativePath(se,de),findFiles:(se,de,Re,ot)=>ft.findFiles(se,de,Re,Me.identifier,ot),findTextInFiles:(se,de,Re,ot)=>{(0,je.checkProposedApiEnabled)(Me,"findTextInFiles");let St,Pt;return typeof de=="object"?(St=de,Pt=Re):(St={},Pt=de,ot=Re),ft.findTextInFiles(se,St||{},Pt,Me.identifier,ot)},saveAll:se=>ft.saveAll(se),applyEdit(se,de){return wi.applyWorkspaceEdit(se,Me,de)},createFileSystemWatcher:(se,de,Re,ot)=>Nt.createFileSystemWatcher(ft,Me,se,de,Re,ot),get textDocuments(){return pt.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw C.readonly()},openTextDocument(se){let de;const Re=se;if(typeof se=="string")de=Promise.resolve(y.URI.file(se));else if(y.URI.isUri(se))de=Promise.resolve(se);else if(!Re||typeof Re=="object")de=pt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(ot=>pt.ensureDocumentData(ot).then(St=>St.document))},onDidOpenTextDocument:(se,de,Re)=>pt.onDidAddDocument(se,de,Re),onDidCloseTextDocument:(se,de,Re)=>pt.onDidRemoveDocument(se,de,Re),onDidChangeTextDocument:(se,de,Re)=>pt.onDidChangeDocument(se,de,Re),onDidSaveTextDocument:(se,de,Re)=>pt.onDidSaveDocument(se,de,Re),onWillSaveTextDocument:(se,de,Re)=>ei.getOnWillSaveTextDocumentEvent(Me)(se,de,Re),get notebookDocuments(){return bt.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,de){let Re;if(y.URI.isUri(se))Re=se,await bt.openNotebookDocument(se);else if(typeof se=="string")Re=y.URI.revive(await bt.createNotebookDocument({viewType:se,content:de}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(se,de,Re){return qt.onDidSaveNotebookDocument(se,de,Re)},onDidChangeNotebookDocument(se,de,Re){return qt.onDidChangeNotebookDocument(se,de,Re)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(se,de,Re,ot){return bt.registerNotebookSerializer(Me,se,de,Re,(0,je.isProposedApiEnabled)(Me,"notebookLiveShare")?ot:void 0)},registerNotebookContentProvider:(se,de,Re,ot)=>((0,je.checkProposedApiEnabled)(Me,"notebookContentProvider"),_e.report("workspace.registerNotebookContentProvider",Me,"The notebookContentProvider API is not on track for finalization and will be removed."),bt.registerNotebookContentProvider(Me,se,de,Re,(0,je.isProposedApiEnabled)(Me,"notebookLiveShare")?ot:void 0)),onDidChangeConfiguration:(se,de,Re)=>Pi.onDidChangeConfiguration(se,de,Re),getConfiguration(se,de){return de=arguments.length===1?void 0:de,Pi.getConfiguration(se,de,Me)},registerTextDocumentContentProvider(se,de){return wt.registerTextDocumentContentProvider(se,de)},registerTaskProvider:(se,de)=>(_e.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Me,se,de)),registerFileSystemProvider(se,de,Re){return(0,Ke.combinedDisposable)(di.registerFileSystemProvider(Me,se,de,Re),Rt.addFileSystemProvider(se,de))},get fs(){return Rt.value},registerFileSearchProvider:(se,de)=>((0,je.checkProposedApiEnabled)(Me,"fileSearchProvider"),gt.registerFileSearchProvider(se,de)),registerTextSearchProvider:(se,de)=>((0,je.checkProposedApiEnabled)(Me,"textSearchProvider"),gt.registerTextSearchProvider(se,de)),registerRemoteAuthorityResolver:(se,de)=>((0,je.checkProposedApiEnabled)(Me,"resolvers"),Ot.registerRemoteAuthorityResolver(se,de)),registerResourceLabelFormatter:se=>((0,je.checkProposedApiEnabled)(Me,"resolvers"),fi.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,de,Re)=>Nt.onDidCreateFile(se,de,Re),onDidDeleteFiles:(se,de,Re)=>Nt.onDidDeleteFile(se,de,Re),onDidRenameFiles:(se,de,Re)=>Nt.onDidRenameFile(se,de,Re),onWillCreateFiles:(se,de,Re)=>Nt.getOnWillCreateFileEvent(Me)(se,de,Re),onWillDeleteFiles:(se,de,Re)=>Nt.getOnWillDeleteFileEvent(Me)(se,de,Re),onWillRenameFiles:(se,de,Re)=>Nt.getOnWillRenameFileEvent(Me)(se,de,Re),openTunnel:se=>((0,je.checkProposedApiEnabled)(Me,"tunnels"),Ct.openTunnel(Me,se).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,je.checkProposedApiEnabled)(Me,"tunnels"),Ct.getTunnels()},onDidChangeTunnels:(se,de,Re)=>((0,je.checkProposedApiEnabled)(Me,"tunnels"),Ct.onDidChangeTunnels(se,de,Re)),registerPortAttributesProvider:(se,de)=>((0,je.checkProposedApiEnabled)(Me,"portsAttributes"),Ct.registerPortsAttributesProvider(se,de)),registerTimelineProvider:(se,de)=>((0,je.checkProposedApiEnabled)(Me,"timeline"),mi.registerTimelineProvider(se,de,Me.identifier,Ze.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:se=>((0,je.checkProposedApiEnabled)(Me,"workspaceTrust"),ft.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,de,Re)=>ft.onDidGrantWorkspaceTrust(se,de,Re),registerEditSessionIdentityProvider:(se,de)=>((0,je.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(se,de))},Di={get inputBox(){return _e.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Me)},createSourceControl(se,de,Re){return ni.createSourceControl(Me,se,de,Re)}},$i={createCommentController(se,de){return hi.createCommentController(Me,se,de)}},Vt={get activeDebugSession(){return tt.activeDebugSession},get activeDebugConsole(){return tt.activeDebugConsole},get breakpoints(){return tt.breakpoints},onDidStartDebugSession(se,de,Re){return tt.onDidStartDebugSession(se,de,Re)},onDidTerminateDebugSession(se,de,Re){return tt.onDidTerminateDebugSession(se,de,Re)},onDidChangeActiveDebugSession(se,de,Re){return tt.onDidChangeActiveDebugSession(se,de,Re)},onDidReceiveDebugSessionCustomEvent(se,de,Re){return tt.onDidReceiveDebugSessionCustomEvent(se,de,Re)},onDidChangeBreakpoints(se,de,Re){return tt.onDidChangeBreakpoints(se,de,Re)},registerDebugConfigurationProvider(se,de,Re){return tt.registerDebugConfigurationProvider(se,de,Re||it.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,de){return tt.registerDebugAdapterDescriptorFactory(Me,se,de)},registerDebugAdapterTrackerFactory(se,de){return tt.registerDebugAdapterTrackerFactory(se,de)},startDebugging(se,de,Re){return!Re||typeof Re=="object"&&"configuration"in Re?tt.startDebugging(se,de,{parentSession:Re}):tt.startDebugging(se,de,Re||{})},stopDebugging(se){return tt.stopDebugging(se)},addBreakpoints(se){return tt.addBreakpoints(se)},removeBreakpoints(se){return tt.removeBreakpoints(se)},asDebugSourceUri(se,de){return tt.asDebugSourceUri(se,de)}},oi={registerTaskProvider:(se,de)=>vt.registerTaskProvider(Me,se,de),fetchTasks:se=>vt.fetchTasks(se),executeTask:se=>vt.executeTask(Me,se),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(se,de,Re)=>vt.onDidStartTask(se,de,Re),onDidEndTask:(se,de,Re)=>vt.onDidEndTask(se,de,Re),onDidStartTaskProcess:(se,de,Re)=>vt.onDidStartTaskProcess(se,de,Re),onDidEndTaskProcess:(se,de,Re)=>vt.onDidEndTaskProcess(se,de,Re)},xi={createNotebookController(se,de,Re,ot,St){return ti.createNotebookController(Me,se,de,Re,ot,(0,je.isProposedApiEnabled)(Me,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(se,de)=>bt.registerNotebookCellStatusBarItemProvider(Me,se,de),createRendererMessaging(se){return ci.createRendererMessaging(Me,se)},onDidChangeNotebookCellExecutionState(se,de,Re){return(0,je.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(se,de,Re)}},Bt={t(...se){if(typeof se[0]=="string"){const de=se.shift(),Re=!se||typeof se[0]!="object"?se:se[0];return yt.getMessage(Me.identifier.value,{message:de,args:Re})}return yt.getMessage(Me.identifier.value,se[0])},get bundle(){return yt.getBundle(Me.identifier.value)},get uri(){return yt.getBundleUri(Me.identifier.value)}};return{version:rt.version,authentication:yi,commands:Mi,comments:$i,debug:Vt,env:Ai,extensions:Ui,l10n:Bt,languages:Bi,notebooks:xi,scm:Di,tasks:oi,tests:Li,window:zi,workspace:Ri,Breakpoint:z.Breakpoint,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:it.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:z.InlineCompletionTriggerKindNew,EventEmitter:w.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionItemNew:z.InlineSuggestionNew,InlineCompletionList:z.InlineSuggestionList,InlineCompletionListNew:z.InlineSuggestionsNew,Hover:z.Hover,IndentAction:P.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,SnippetTextEdit:z.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItem2:z.TreeItem,TreeItemCheckboxState:z.TreeItemCheckboxState,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:I.UIKind,Uri:y.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,DocumentDropEdit:z.DocumentDropEdit,DocumentPasteEdit:z.DocumentPasteEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,NotebookControllerAffinity2:z.NotebookControllerAffinity2,NotebookEdit:z.NotebookEdit,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:nt.TextSearchCompleteMessageType,DataTransfer:z.DataTransfer,DataTransferItem:z.DataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind,InputBoxValidationSeverity:z.InputBoxValidationSeverity,TabInputText:z.TextTabInput,TabInputTextDiff:z.TextDiffTabInput,TabInputTextMerge:z.TextMergeTabInput,TabInputCustom:z.CustomEditorTabInput,TabInputNotebook:z.NotebookEditorTabInput,TabInputNotebookDiff:z.NotebookDiffEditorTabInput,TabInputWebview:z.WebviewEditorTabInput,TabInputTerminal:z.TerminalEditorTabInput,TabInputInteractiveWindow:z.InteractiveWindowInput,TerminalExitReason:z.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=ct}),define(Ce[242],Ie([1,0,241,33,2,235,6,15,226]),function(ne,e,r,C,w,F,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class P extends F.RequireInterceptor{_installInterceptor(){}getModule(I,p){for(const a of this._alternatives){const l=a(I);if(l){I=l;break}}if(this._factories.has(I))return this._factories.get(I).load(I,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=y.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(E.ExtHostConsoleForwarder);const I=this._instaService.invokeFunction(r.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(P,I,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(I){return I.browser}async _loadCommonJSModule(I,p,a){p=p.with({path:b(p.path,".js")});const l=I?.identifier.value;l&&performance.mark(`code/extHost/willFetchExtensionCode/${l}`);const d=w.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(p)),m=await fetch(d.toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l}`),m.status!==200)throw new Error(m.statusText);const S=await m.text(),c=`${p.toString(!0)}#vscode-extension`,_=`${S}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",_)}catch(s){throw console.error(l?`Loading code for extension ${l} failed: ${s.message}`:`Loading code failed: ${s.message}`),console.error(`${p.toString(!0)}${typeof s.line=="number"?` line ${s.line}`:""}${typeof s.column=="number"?` column ${s.column}`:""}`),console.error(s),s}I&&await this._extHostLocalizationService.initializeLocalizedMessages(I);const u={},i={exports:u},n=s=>{const h=this._fakeModules.getModule(s,p);if(h===void 0)throw new Error(`Cannot load module '${s}'`);return h};try{return a.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l}`),t(i,u,n),i.exports!==u?i.exports:u}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l}`),a.codeLoadingStop()}}async $setRemoteEnvironment(I){}async _waitForDebuggerAttachment(I=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+I;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=R;function b(g,I){return g.endsWith(I)?g:g+I}}),define(Ce[243],Ie([1,0,58,33,73,242]),function(ne,e,r,C,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(C.IExtHostExtensionService,F.ExtHostExtensionService,!1),(0,r.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths,!1)}),define(Ce[251],Ie([1,0,23,4,67,236,228,19,74,13,2,238,243]),function(ne,e,r,C,w,F,y,A,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const g=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function I(t){return/^(file|vscode-remote):/i.test(t)}const p=fetch.bind(self);function a(t){self.fetch=async function(u,i){return u instanceof Request||I(String(u))&&(u=(await t(R.URI.parse(String(u)))).toString(!0)),p(u,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,i,n,s,h){(async()=>(I(i.toString())&&(i=(await t(R.URI.parse(i.toString()))).toString(!0)),super.open(u,i,n??!0,s,h)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(u,i){if(/^file:/i.test(u.toString()))u=P.FileAccess.asBrowserUri(R.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const s=`(${function(v){function T(U){return typeof U=="string"||U instanceof URL?String(U).replace(/^file:\/\//i,"vscode-file://vscode-app"):U}const M=fetch.bind(self);self.fetch=function(U,D){return U instanceof Request?M(U,D):M(T(U),D)},self.XMLHttpRequest=class extends XMLHttpRequest{open(U,D,$,L,O){return super.open(U,T(D),$??!0,L,O)}};const j=importScripts.bind(self);self.importScripts=(...U)=>{j(...U.map(T))},j(v)}.toString()}('${u}'))`;i=i||{},i.name=i.name||A.basename(u.toString());const h=new Blob([s],{type:"application/javascript"}),o=URL.createObjectURL(h);return new t(o,i)}}else self.Worker=class extends y.NestedWorker{constructor(t,u){super(g,t,{name:A.basename(t.toString()),...u})}};const l=new class{constructor(){this.pid=void 0}exit(t){b()}async exists(t){return!0}async realpath(t){return t}};class d{constructor(){const u=new MessageChannel,i=new C.Emitter;let n=!1;g(u.port2,[u.port2]),u.port1.onmessage=s=>{const{data:h}=s;if(!(h instanceof ArrayBuffer)){console.warn("UNKNOWN data received",h);return}const o=r.VSBuffer.wrap(new Uint8Array(h,0,h.byteLength));if((0,w.isMessageOfType)(o,2)){n=!0,S("received terminate message from renderer");return}i.fire(o)},this.protocol={onMessage:i.event,send:s=>{if(!n){const h=s.buffer.buffer.slice(s.buffer.byteOffset,s.buffer.byteOffset+s.buffer.byteLength);u.port1.postMessage(h,[h])}}}}}function m(t){return new Promise(u=>{const i=t.onMessage(n=>{i.dispose();const s=JSON.parse(n.toString());t.send((0,w.createMessageOfType)(0)),u({protocol:t,initData:s})});t.send((0,w.createMessageOfType)(1))})}let S=t=>b();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function _(){E.mark("code/extHost/willConnectToRenderer");const t=new d;return{onmessage(u){!c(u)||m(t.protocol).then(i=>{E.mark("code/extHost/didWaitForInitData");const n=new F.ExtensionHostMain(i.protocol,i.initData,l,null,u.data);a(s=>n.asBrowserUri(s)),S=s=>n.terminate(s)})}}}e.create=_})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a8108049ab61b970f2ec1839dfb753054e07395e/core/vs/workbench/api/worker/extensionHostWorker.js.map
